/*
This file contains FreeType, compiled to JavaScript. Licensing info:
====================================================================

Copyright 2006, 2007, 2008, 2009, 2010 by
David Turner, Robert Wilhelm, and Werner Lemberg.

This  file is  part of  the FreeType  project, and  may only  be used,
modified,  and distributed  under the  terms of  the  FreeType project
license,  LICENSE.TXT.  By  continuing to  use, modify,  or distribute
this file you  indicate that you have read  the license and understand
and accept it fully.

LICENSE.TXT:

The  FreeType 2  font  engine is  copyrighted  work and  cannot be  used
legally  without a  software license.   In  order to  make this  project
usable  to a vast  majority of  developers, we  distribute it  under two
mutually exclusive open-source licenses.

This means  that *you* must choose  *one* of the  two licenses described
below, then obey  all its terms and conditions when  using FreeType 2 in
any of your projects or products.

  - The FreeType License, found in  the file `FTL.TXT', which is similar
    to the original BSD license *with* an advertising clause that forces
    you  to  explicitly cite  the  FreeType  project  in your  product's
    documentation.  All  details are in the license  file.  This license
    is  suited  to products  which  don't  use  the GNU  General  Public
    License.

  - The GNU  General Public License  version 2, found in  `GPL.TXT' (any
    later version can be used  also), for programs which already use the
    GPL.  Note  that the  FTL is  incompatible with the  GPL due  to its
    advertisement clause.

The contributed BDF and PCF drivers come with a license similar  to that
of the X Window System.  It is compatible to the above two licenses (see
file src/bdf/README and src/pcf/README).

The gzip module uses the zlib license (see src/gzip/zlib.h) which too is
compatible to the above two licenses.
*/

/*
This file also contains the Liberation Sans Bold font (see 'font.ttf'):
=======================================================================

LICENSE AGREEMENT AND LIMITED PRODUCT WARRANTY
LIBERATION FONT SOFTWARE

This agreement governs the use of the Software and any updates to the Software, regardless of the delivery mechanism. Subject to the following terms, Red Hat, Inc. ("Red Hat") grants to the user ("Client") a license to this work pursuant to the GNU General Public License v.2 with the exceptions set forth below and such other terms as are set forth in this End User License Agreement.

 1. The Software and License Exception. LIBERATION font software  (the "Software") consists of TrueType-OpenType formatted font software for rendering LIBERATION typefaces in sans-serif, serif, and monospaced character styles. You are licensed to use, modify, copy, and distribute the Software pursuant to the GNU General Public License v.2 with the following exceptions:  

  (a) As a special exception, if you create a document which uses this font, and embed this font or unaltered portions of this font into the document, this font does not by itself cause the resulting document to be covered by the GNU General Public License. This exception does not however invalidate any other reasons why the document might be covered by the GNU General Public License. If you modify this font, you may extend this exception to your version of the font, but you are not obligated to do so. If you do not wish to do so, delete this exception statement from your version.

  (b) As a further exception, any distribution of the object code of the Software in a physical product must provide you the right to access and modify the source code for the Software and to reinstall that modified version of the Software in object code form on the same physical product on which you received it.

 2. Intellectual Property Rights. The Software and each of its components, including the source code, documentation, appearance, structure and organization are owned by Red Hat and others and are protected under copyright and other laws. Title to the Software and any component, or to any copy, modification, or merged portion shall remain with the aforementioned, subject to the applicable license. The "LIBERATION" trademark is a trademark of Red Hat, Inc. in the U.S. and other countries. This agreement does not permit Client to distribute modified versions of the Software using Red Hat's trademarks. If Client makes a redistribution of a modified version of the Software, then Client must modify the files names to remove any reference to the Red Hat trademarks and must not use the Red Hat trademarks in any way to reference or promote the modified Software. 

 3. Limited Warranty. To the maximum extent permitted under applicable law, the Software is provided and licensed "as is" without warranty of any kind, expressed or implied, including the implied warranties of merchantability, non-infringement or fitness for a particular purpose. Red Hat does not warrant that the functions contained in the Software will meet Client's requirements or that the operation of the Software will be entirely error free or appear precisely as described in the accompanying documentation. 

 4. Limitation of Remedies and Liability. To the maximum extent permitted by applicable law, Red Hat or any Red Hat authorized dealer will not be liable to Client for any incidental or consequential damages, including lost profits or lost savings arising out of the use or inability to use the Software, even if Red Hat or such dealer has been advised of the possibility of such damages. 

 5. General. If any provision of this agreement is held to be unenforceable, that shall not affect the enforceability of the remaining provisions. This agreement shall be governed by the laws of the State of North Carolina and of the United States, without regard to any conflict of laws provisions, except that the United Nations Convention on the International Sale of Goods shall not apply.
Copyright © 2007 Red Hat, Inc. All rights reserved. LIBERATION is a trademark of Red Hat, Inc.
*/

this.Module={};var args=arguments;
Runtime={stackAlloc:function(e){var g=STACKTOP;Runtime.memset(STACKTOP,0,e);STACKTOP+=e;STACKTOP=Math.ceil(STACKTOP/4)*4;return g},staticAlloc:function(e){var g=STATICTOP;STATICTOP+=e;STATICTOP=Math.ceil(STATICTOP/4)*4;return g},alignMemory:function(e,g){return Math.ceil(e/(g?g:4))*(g?g:4)},memset:function(e,g,d){for(var b=0;b<d;b++)HEAP[e+b]=g},getFunctionIndex:function(e,g){var d=FUNCTION_TABLE.length;FUNCTION_TABLE[d]=e;FUNCTION_TABLE[d+1]=null;Module[g]=e;return d},isNumberType:function(e){return e in
Runtime.INT_TYPES||e in Runtime.FLOAT_TYPES},isPointerType:function(e){return pointingLevels(e)>0},isStructType:function(e){if(isPointerType(e))return false;if(RegExp(/^\[\d+\ x\ (.*)\]/g).test(e))return true;return!Runtime.isNumberType(e)&&e[0]=="%"},INT_TYPES:{i1:0,i8:0,i16:0,i32:0,i64:0},FLOAT_TYPES:{"float":0,"double":0},getNativeFieldSize:function(e,g){var d={i1:1,i8:1,i16:2,i32:4,i64:8,"float":4,"double":8}[e];d||(d=4);g||(d=Math.max(d,4));return d},dedup:function(e,g){var d={};return g?e.filter(function(b){if(d[b[g]])return false;
return d[b[g]]=true}):e.filter(function(b){if(d[b])return false;return d[b]=true})},set:function(){if(typeof arguments[0]==="object")arguments=arguments[0];for(var e={},g=0;g<arguments.length;g++)e[arguments[g]]=0;return e},calculateStructAlignment:function(e,g){e.flatSize=0;e.alignSize=0;var d=[],b=-1;e.flatIndexes=e.fields.map(function(a){var c,f;if(Runtime.isNumberType(a)||Runtime.isPointerType(a))f=c=Runtime.getNativeFieldSize(a,true);else if(Runtime.isStructType(a)){c=g[a].flatSize;f=g[a].alignSize}else{dprint("Unclear type in struct: "+
a+", in "+e.name_);assert(0)}f=Math.min(f,4);e.alignSize=Math.max(e.alignSize,f);a=Runtime.alignMemory(e.flatSize,f);e.flatSize=a+c;b>=0&&d.push(a-b);return b=a});e.flatSize=Runtime.alignMemory(e.flatSize,e.alignSize);if(d.length==0)e.flatFactor=e.flatSize;else if(Runtime.dedup(d).length==1)e.flatFactor=d[0];e.needsFlattening=e.flatFactor!=1;return e.flatIndexes},__dummy__:0};function __globalConstructor__(){}var FUNCTION_TABLE=[],__THREW__=false,__ATEXIT__=[],ABORT=false,undef=0;
function abort(e){print(e+":\n"+Error().stack);ABORT=true;throw"Assertion: "+e;}function assert(e,g){e||abort("Assertion failed: "+g)}var ALLOC_NORMAL=0,ALLOC_STACK=1,ALLOC_STATIC=2;
function Pointer_make(e,g,d){g=g?g:0;assert(g===0);if(e===HEAP)return g;g=e.length;var b;for(b=0;b<g;b++)if(e[b]===undefined)throw"Invalid element in slab at "+Error().stack;d=[_malloc,Runtime.stackAlloc,Runtime.staticAlloc][d?d:ALLOC_STATIC](Math.max(g,1));for(b=0;b<g;b++){var a=e[b];if(typeof a==="function")a=Runtime.getFunctionIndex(a);HEAP[d+b]=a}return d}Module.Pointer_make=Pointer_make;
function Pointer_stringify(e){for(var g="",d=0,b;;){b=String.fromCharCode(HEAP[e+d]);if(b=="\u0000")break;g+=b;d+=1}return g}var PAGE_SIZE=4096;function alignMemoryPage(e){return Math.ceil(e/PAGE_SIZE)*PAGE_SIZE}var HEAP,IHEAP,FHEAP,STACK_ROOT,STACKTOP,STACK_MAX,STATICTOP,_malloc,_calloc,_free,__Znwj,__Znaj,__Znam,__Znwm,__ZdlPv,__ZdaPv,HAS_TYPED_ARRAYS=false,TOTAL_MEMORY=52428800;
function __initializeRuntime__(){Module._malloc=_malloc=__Znwj=__Znaj=__Znam=__Znwm=Module._malloc?Module._malloc:Runtime.staticAlloc;Module._calloc=_calloc=Module._calloc?Module._calloc:function(d,b){var a=_malloc(d*b);Runtime.memset(a,0,d*b);return a};Module._free=_free=__ZdlPv=__ZdaPv=Module._free?Module._free:function(){};var e=TOTAL_MEMORY/32;IHEAP=FHEAP=HEAP=Array(e);for(var g=0;g<e;g++)IHEAP[g]=FHEAP[g]=0;e=intArrayFromString("(null)").concat(0);for(g=0;g<e.length;g++)HEAP[g]=e[g];Module.HEAP=
HEAP;Module.IHEAP=IHEAP;Module.FHEAP=FHEAP;STACK_ROOT=STACKTOP=alignMemoryPage(10);this.TOTAL_STACK||(TOTAL_STACK=1048576);STACK_MAX=STACK_ROOT+TOTAL_STACK;STATICTOP=alignMemoryPage(STACK_MAX)}function __shutdownRuntime__(){for(;__ATEXIT__.length>0;){var e=__ATEXIT__.pop();if(typeof e==="number")e=FUNCTION_TABLE[e];e()}}function Array_copy(e,g){return IHEAP.slice(e,e+g)}function String_len(e){for(var g=0;HEAP[e+g];)g++;return g}
function String_copy(e,g){return Array_copy(e,String_len(e)).concat(g?[0]:[])}PRINTBUFFER="";function __print__(e){if(e===null){print(PRINTBUFFER);PRINTBUFFER=""}else for(PRINTBUFFER+=e;(e=PRINTBUFFER.indexOf("\n"))!=-1;){print(PRINTBUFFER.substr(0,e));PRINTBUFFER=PRINTBUFFER.substr(e+1)}}function jrint(e,g){if(g)e+=" : ";else{g=e;e=""}print(e+JSON.stringify(g))}function intArrayFromString(e){for(var g=[],d=0;d<e.length;){g.push(e.charCodeAt(d));d+=1}g.push(0);return g}Module.intArrayFromString=intArrayFromString;
function intArrayToString(e){for(var g="",d=0;d<e.length;d++)g+=String.fromCharCode(e[d]);return g}function unSign(e,g){if(e>=0)return e;return g<=32?2*Math.abs(1<<g-1)+e:Math.pow(2,g)+e}function reSign(e,g){if(e<=0)return e;var d=g<=32?Math.abs(1<<g-1):Math.pow(2,g-1);if(e>=d)e=-2*d+e;return e}
var $0___SIZE=4,$1___SIZE=8,$2___SIZE=1428,$2___FLATTENER=[0,4,8,12,16,20,24,28,32,36,40,44,48,52,56,60,64,68,72,76,852,980,1E3,1024,1040,1232,1236,1240,1244,1248,1252,1256,1412,1416,1420,1424],$3___SIZE=20,$struct__0TEncoding___SIZE=12,$struct_AFM_FontInfoRec____SIZE=44,$struct_AFM_FontInfoRec____FLATTENER=[0,4,20,24,28,32,36,40],$struct_AFM_KernPairRec____SIZE=16,$struct_AFM_ParserRec____SIZE=20,$struct_AFM_Parser_FuncsRec___SIZE=12,$struct_AFM_StreamRec____SIZE=16,$struct_AFM_TrackKernRec____SIZE=
20,$struct_AFM_ValueRec____SIZE=8,$struct_AF_AxisHintsRec___SIZE=28,$struct_AF_EdgeRec____SIZE=48,$struct_AF_EdgeRec____FLATTENER=[0,4,8,12,13,16,20,24,28,32,36,40,44],$struct_AF_FaceGlobalsRec____SIZE=28,$struct_AF_GlyphHintsRec____SIZE=124,$struct_AF_GlyphHintsRec____FLATTENER=[0,4,8,12,16,20,24,28,32,36,40,44,48,104,108,112,116,120],$struct_AF_LatinAxisRec___SIZE=396,$struct_AF_LatinAxisRec___FLATTENER=[0,4,8,12,204,208,212,213,216,220,388,392],$struct_AF_LatinBlueRec___SIZE=28,$struct_AF_LatinMetricsRec____SIZE=
832,$struct_AF_LatinMetricsRec____FLATTENER=[0,36,40],$struct_AF_LoaderRec____SIZE=184,$struct_AF_LoaderRec____FLATTENER=[0,4,8,12,136,140,144,160,168,176],$struct_AF_PointRec____SIZE=40,$struct_AF_PointRec____FLATTENER=[0,2,3,4,8,12,14,16,20,24,28,32,36],$struct_AF_ScalerRec___SIZE=28,$struct_AF_ScriptClassRec____SIZE=32,$struct_AF_ScriptMetricsRec____SIZE=36,$struct_AF_ScriptMetricsRec____FLATTENER=[0,4,32],$struct_AF_Script_UniRangeRec___SIZE=8,$struct_AF_SegmentRec____SIZE=52,$struct_AF_SegmentRec____FLATTENER=
[0,1,2,4,6,8,12,16,20,24,28,32,36,40,44,48],$struct_BDF_CMapRec____SIZE=24,$struct_BDF_CMapRec____FLATTENER=[0,16,20],$struct_BDF_FaceRec____SIZE=168,$struct_BDF_FaceRec____FLATTENER=[0,132,136,140,144,148,152,164],$struct_BDF_encoding_el___SIZE=8,$struct_CFF_Builder___SIZE=76,$struct_CFF_Builder___FLATTENER=[0,4,8,12,16,20,24,28,32,40,48,64,65,66,67,68,72],$struct_CFF_CMapStdRec____SIZE=20,$struct_CFF_CharsetRec___SIZE=24,$struct_CFF_Decoder___SIZE=928,$struct_CFF_Decoder___FLATTENER=[0,76,80,276,
280,676,680,684,688,744,748,752,753,756,760,888,892,896,900,904,908,912,916,920,924],$struct_CFF_Decoder_Zone___SIZE=12,$struct_CFF_EncodingRec___SIZE=1036,$struct_CFF_EncodingRec___FLATTENER=[0,4,8,12,524],$struct_CFF_FDSelectRec___SIZE=28,$struct_CFF_Field_Handler___SIZE=28,$struct_CFF_FontRecDictRec___SIZE=172,$struct_CFF_FontRecDictRec___FLATTENER=[0,4,8,12,16,20,24,28,32,36,40,44,48,64,68,76,80,96,100,104,108,112,116,120,124,128,132,136,140,144,148,152,156,160,164,168],$struct_CFF_FontRec____SIZE=
2072,$struct_CFF_FontRec____FLATTENER=[0,4,8,12,16,17,18,19,20,52,84,116,1152,1176,1208,1240,1272,1304,1308,1312,1316,1320,1324,1892,1896,2024,2052,2056,2060,2064,2068],$struct_CFF_GlyphSlotRec____SIZE=172,$struct_CFF_GlyphSlotRec____FLATTENER=[0,160,161,164,168],$struct_CFF_IndexRec___SIZE=32,$struct_CFF_InternalRec____SIZE=132,$struct_CFF_ParserRec____SIZE=416,$struct_CFF_ParserRec____FLATTENER=[0,4,8,12,16,404,408,412],$struct_CFF_PrivateRec___SIZE=360,$struct_CFF_PrivateRec___FLATTENER=[0,1,2,
3,4,60,100,156,196,200,204,208,212,216,217,220,272,324,328,332,336,340,344,348,352,356],$struct_CFF_SizeRec____SIZE=48,$struct_CFF_SubFontRec___SIZE=568,$struct_CFF_SubFontRec___FLATTENER=[0,172,532,564],$struct_CID_FaceDictRec____SIZE=252,$struct_CID_FaceDictRec____FLATTENER=[0,196,200,204,208,212,213,216,232,240,244,248],$struct_CID_FaceInfoRec____SIZE=172,$struct_CID_FaceInfoRec____FLATTENER=[0,4,8,12,16,20,24,56,72,76,80,144,148,152,156,160,164,168],$struct_CID_FaceRec____SIZE=332,$struct_CID_FaceRec____FLATTENER=
[0,132,136,140,312,316,320,324,328],$struct_CID_Loader___SIZE=104,$struct_CID_Parser___SIZE=100,$struct_CID_Parser___FLATTENER=[0,72,76,80,84,88,92,96],$struct_CID_SizeRec____SIZE=48,$struct_CID_SubrsRec____SIZE=8,$struct_FNT_CMapRec____SIZE=24,$struct_FNT_CMapRec____FLATTENER=[0,16,20],$struct_FNT_FaceRec____SIZE=152,$struct_FNT_FaceRec____FLATTENER=[0,132,136,140],$struct_FNT_FontRec____SIZE=172,$struct_FNT_FontRec____FLATTENER=[0,4,160,164,168],$struct_FTC_BasicAttrRec___SIZE=28,$struct_FTC_BasicFamilyRec____SIZE=
48,$struct_FTC_BasicQueryRec____SIZE=36,$struct_FTC_CMapCacheRec____SIZE=0,$struct_FTC_CMapCacheRec____FLATTENER=[],$struct_FTC_CMapNodeRec____SIZE=288,$struct_FTC_CMapNodeRec____FLATTENER=[0,20,24,28,32],$struct_FTC_CMapQueryRec____SIZE=12,$struct_FTC_CacheClassRec___SIZE=32,$struct_FTC_CacheRec____SIZE=64,$struct_FTC_CacheRec____FLATTENER=[0,4,8,12,16,48,52,56,60],$struct_FTC_FaceNodeRec____SIZE=16,$struct_FTC_FaceNodeRec____FLATTENER=[0,8,12],$struct_FTC_FamilyRec____SIZE=20,$struct_FTC_FamilyRec____FLATTENER=
[0,8,12,16],$struct_FTC_FontRec___SIZE=8,$struct_FTC_FontRec___FLATTENER=[0,4,6],$struct_FTC_GCacheClassRec___SIZE=36,$struct_FTC_GCacheRec____SIZE=104,$struct_FTC_GNodeRec____SIZE=28,$struct_FTC_GNodeRec____FLATTENER=[0,20,24],$struct_FTC_GQueryRec____SIZE=8,$struct_FTC_IFamilyClassRec___SIZE=24,$struct_FTC_INodeRec____SIZE=32,$struct_FTC_ImageCacheRec____SIZE=0,$struct_FTC_ImageCacheRec____FLATTENER=[],$struct_FTC_ImageTypeRec____SIZE=16,$struct_FTC_ManagerRec____SIZE=180,$struct_FTC_ManagerRec____FLATTENER=
[0,4,8,12,16,20,24,88,92,132,172,176],$struct_FTC_MruListClassRec___SIZE=20,$struct_FTC_MruListRec____SIZE=40,$struct_FTC_MruListRec____FLATTENER=[0,4,8,12,16,36],$struct_FTC_MruNodeRec____SIZE=8,$struct_FTC_NodeRec____SIZE=20,$struct_FTC_NodeRec____FLATTENER=[0,8,12,16,18],$struct_FTC_OldCMapDescRec____SIZE=16,$struct_FTC_OldImageDescRec____SIZE=12,$struct_FTC_SBitCacheRec____SIZE=0,$struct_FTC_SBitCacheRec____FLATTENER=[],$struct_FTC_SBitRec____SIZE=16,$struct_FTC_SBitRec____FLATTENER=[0,1,2,3,
4,5,6,8,9,12],$struct_FTC_SFamilyClassRec___SIZE=28,$struct_FTC_SFamilyClassRec___FLATTENER=[0,20,24],$struct_FTC_SNodeRec____SIZE=288,$struct_FTC_SNodeRec____FLATTENER=[0,28,32],$struct_FTC_ScalerRec____SIZE=24,$struct_FTC_SizeNodeRec____SIZE=36,$struct_FTC_SizeNodeRec____FLATTENER=[0,8,12],$struct_FT_AutoHinterRec____SIZE=0,$struct_FT_AutoHinterRec____FLATTENER=[],$struct_FT_AutoHinter_ServiceRec___SIZE=16,$struct_FT_AutofitterRec____SIZE=204,$struct_FT_Bitmap___SIZE=24,$struct_FT_Bitmap___FLATTENER=
[0,4,8,12,16,18,19,20],$struct_FT_BitmapGlyphRec____SIZE=52,$struct_FT_BitmapGlyphRec____FLATTENER=[0,20,24,28],$struct_FT_Bitmap_Size___SIZE=16,$struct_FT_Bitmap_Size___FLATTENER=[0,2,4,8,12],$struct_FT_CMapRec___SIZE=16,$struct_FT_CMap_ClassRec____SIZE=40,$struct_FT_CharMapRec___SIZE=12,$struct_FT_CharMapRec___FLATTENER=[0,4,8,10],$struct_FT_Data___SIZE=8,$struct_FT_DriverRec____SIZE=40,$struct_FT_DriverRec____FLATTENER=[0,20,24,32,36],$struct_FT_Driver_ClassRec____SIZE=104,$struct_FT_Driver_ClassRec____FLATTENER=
[0,36,40,44,48,52,56,60,64,68,72,76,80,84,88,92,96,100],$struct_FT_FaceRec___SIZE=132,$struct_FT_FaceRec___FLATTENER=[0,4,8,12,16,20,24,28,32,36,40,44,52,68,70,72,74,76,78,80,82,84,88,92,96,100,104,108,116,124,128],$struct_FT_Face_InternalRec____SIZE=64,$struct_FT_Face_InternalRec____FLATTENER=[0,2,4,20,28,32,52,56,60],$struct_FT_Frame_Field___SIZE=4,$struct_FT_GZipFileRec____SIZE=8276,$struct_FT_GZipFileRec____FLATTENER=[0,4,8,12,68,72,4168,8264,8268,8272],$struct_FT_Generic___SIZE=8,$struct_FT_GlyphLoadRec___SIZE=
36,$struct_FT_GlyphLoadRec___FLATTENER=[0,20,24,28,32],$struct_FT_GlyphLoaderRec____SIZE=96,$struct_FT_GlyphLoaderRec____FLATTENER=[0,4,8,12,16,20,56,92],$struct_FT_GlyphRec____SIZE=20,$struct_FT_GlyphSlotRec____SIZE=160,$struct_FT_GlyphSlotRec____FLATTENER=[0,4,8,12,16,24,56,60,64,72,76,100,104,108,128,132,136,140,144,148,152,156],$struct_FT_Glyph_Class___SIZE=32,$struct_FT_Glyph_Metrics___SIZE=32,$struct_FT_IncrementalRec____SIZE=0,$struct_FT_IncrementalRec____FLATTENER=[],$struct_FT_Incremental_FuncsRec___SIZE=
12,$struct_FT_Incremental_InterfaceRec___SIZE=8,$struct_FT_LZWFileRec____SIZE=4292,$struct_FT_LZWFileRec____FLATTENER=[0,4,8,12,184,4280,4284,4288],$struct_FT_LibraryRec____SIZE=200,$struct_FT_LibraryRec____FLATTENER=[0,4,12,16,20,24,28,156,164,168,172,176,180,196],$struct_FT_ListNodeRec____SIZE=12,$struct_FT_ListRec___SIZE=8,$struct_FT_LzwStateRec___SIZE=172,$struct_FT_LzwStateRec___FLATTENER=[0,4,8,24,28,32,36,40,44,48,52,56,60,64,68,72,76,80,84,88,92,96,100,164,168],$struct_FT_MM_Var___SIZE=20,
$struct_FT_MemoryRec____SIZE=16,$struct_FT_ModuleRec___SIZE=20,$struct_FT_Module_Class___SIZE=36,$struct_FT_Multi_Master___SIZE=56,$struct_FT_Open_Args___SIZE=32,$struct_FT_Outline___SIZE=20,$struct_FT_Outline___FLATTENER=[0,2,4,8,12,16],$struct_FT_OutlineGlyphRec____SIZE=40,$struct_FT_Outline_Funcs___SIZE=24,$struct_FT_Parameter___SIZE=8,$struct_FT_RFork_Ref___SIZE=8,$struct_FT_RasterRec____SIZE=0,$struct_FT_RasterRec____FLATTENER=[],$struct_FT_Raster_Funcs___SIZE=24,$struct_FT_Raster_Params___SIZE=
48,$struct_FT_RendererRec____SIZE=72,$struct_FT_RendererRec____FLATTENER=[0,20,24,28,60,64,68],$struct_FT_Renderer_Class___SIZE=60,$struct_FT_Renderer_Class___FLATTENER=[0,36,40,44,48,52,56],$struct_FT_ServiceCacheRec___SIZE=20,$struct_FT_ServiceDescRec___SIZE=8,$struct_FT_Service_BDFRec___SIZE=8,$struct_FT_Service_CIDRec___SIZE=12,$struct_FT_Service_CKERNvalidateRec____SIZE=4,$struct_FT_Service_GXvalidateRec____SIZE=4,$struct_FT_Service_GlyphDictRec___SIZE=8,$struct_FT_Service_KerningRec___SIZE=
4,$struct_FT_Service_MultiMastersRec___SIZE=20,$struct_FT_Service_OTvalidateRec____SIZE=4,$struct_FT_Service_PfrMetricsRec___SIZE=12,$struct_FT_Service_PsCMapsRec___SIZE=32,$struct_FT_Service_PsFontNameRec___SIZE=4,$struct_FT_Service_PsInfoRec___SIZE=16,$struct_FT_Service_SFNT_TableRec___SIZE=12,$struct_FT_Service_TTCMapsRec___SIZE=4,$struct_FT_Service_TTGlyfRec___SIZE=4,$struct_FT_Service_TrueTypeEngineRec___SIZE=4,$struct_FT_Service_WinFntRec___SIZE=4,$struct_FT_SfntName___SIZE=16,$struct_FT_SfntName___FLATTENER=
[0,2,4,6,8,12],$struct_FT_SizeRec____SIZE=44,$struct_FT_SizeRec____FLATTENER=[0,4,12,40],$struct_FT_Size_InternalRec____SIZE=0,$struct_FT_Size_InternalRec____FLATTENER=[],$struct_FT_Size_Metrics___SIZE=28,$struct_FT_Size_Metrics___FLATTENER=[0,2,4,8,12,16,20,24],$struct_FT_Slot_InternalRec____SIZE=40,$struct_FT_Slot_InternalRec____FLATTENER=[0,4,8,12,28,36],$struct_FT_Span___SIZE=6,$struct_FT_StreamRec____SIZE=40,$struct_FT_StrokeBorderRec____SIZE=32,$struct_FT_StrokerRec____SIZE=120,$struct_FT_StrokerRec____FLATTENER=
[0,4,8,16,17,20,24,32,36,40,44,48,52,116],$struct_FT_SubGlyphRec____SIZE=32,$struct_FT_UnitVector___SIZE=4,$struct_FT_ValidatorRec____SIZE=172,$struct_FT_Var_Named_Style___SIZE=8,$struct_FT_WinFNT_HeaderRec___SIZE=156,$struct_FT_WinFNT_HeaderRec___FLATTENER=[0,4,8,68,70,72,74,76,78,80,82,83,84,86,88,90,92,94,96,98,100,101,102,103,104,108,112,116,120,124,128,132,134,136,138,140],$struct_GX_AVarSegmentRec____SIZE=8,$struct_GX_BlendRec____SIZE=40,$struct_GX_FVar_Axis___SIZE=20,$struct_GX_FVar_Axis___FLATTENER=
[0,4,8,12,16,18],$struct_GX_FVar_Head___SIZE=16,$struct_GX_FVar_Head___FLATTENER=[0,4,6,8,10,12,14],$struct_GX_GVar_Head___SIZE=20,$struct_GX_GVar_Head___FLATTENER=[0,4,6,8,12,14,16],$struct_IUP_WorkerRec____SIZE=16,$struct_PCF_AccelRec___SIZE=84,$struct_PCF_AccelRec___FLATTENER=[0,1,2,3,4,5,6,8,12,16,20,36,52,68],$struct_PCF_Compressed_MetricRec___SIZE=5,$struct_PCF_FaceRec____SIZE=328,$struct_PCF_FaceRec____FLATTENER=[0,132,172,176,180,184,196,280,284,288,292,296,300,304,308,312,316],$struct_PCF_MetricRec___SIZE=
16,$struct_PCF_ParsePropertyRec____SIZE=12,$struct_PCF_PropertyRec____SIZE=12,$struct_PCF_TocRec___SIZE=12,$struct_PFR_BitWriter____SIZE=20,$struct_PFR_CMapRec____SIZE=24,$struct_PFR_CMapRec____FLATTENER=[0,16,20],$struct_PFR_DimensionRec___SIZE=12,$struct_PFR_ExtraItemRec____SIZE=8,$struct_PFR_FaceRec____SIZE=440,$struct_PFR_FaceRec____FLATTENER=[0,132,240,288],$struct_PFR_GlyphRec____SIZE=36,$struct_PFR_HeaderRec____SIZE=108,$struct_PFR_KernItemRec____SIZE=24,$struct_PFR_KernItemRec____FLATTENER=
[0,4,5,6,8,12,16,20],$struct_PFR_LogFontRec____SIZE=48,$struct_PFR_LogFontRec____FLATTENER=[0,4,8,24,28,32,36,40,44],$struct_PFR_PhyFontRec____SIZE=152,$struct_PFR_PhyFontRec____FLATTENER=[0,4,8,12,16,20,36,40,44,48,52,56,68,80,84,88,92,96,100,104,108,112,116,120,124,128,132,136,140,144,148],$struct_PFR_SizeRec____SIZE=44,$struct_PFR_SlotRec____SIZE=196,$struct_PFR_StrikeRec___SIZE=36,$struct_PFR_SubGlyphRec___SIZE=24,$struct_PSAux_Interface___SIZE=28,$struct_PSH_Blue_TableRec___SIZE=516,$struct_PSH_BluesRec___SIZE=
2084,$struct_PSH_BluesRec___FLATTENER=[0,516,1032,1548,2064,2068,2072,2076,2080],$struct_PSH_ContourRec____SIZE=8,$struct_PSH_DimensionRec___SIZE=204,$struct_PSH_DimensionRec___FLATTENER=[0,196,200],$struct_PSH_GlobalsRec____SIZE=2496,$struct_PSH_GlobalsRec____FLATTENER=[0,4,412],$struct_PSH_Globals_FuncsRec___SIZE=12,$struct_PSH_GlyphRec____SIZE=128,$struct_PSH_GlyphRec____FLATTENER=[0,4,8,12,16,20,24,28,108,112,116,120,121,122,123,124],$struct_PSH_HintRec____SIZE=28,$struct_PSH_Hint_TableRec____SIZE=
40,$struct_PSH_PointRec____SIZE=48,$struct_PSH_PointRec____FLATTENER=[0,4,8,12,16,20,21,24,28,32,36,40,44],$struct_PSH_WidthsRec___SIZE=196,$struct_PSHinter_Interface___SIZE=12,$struct_PS_BlendRec____SIZE=420,$struct_PS_BlendRec____FLATTENER=[0,4,8,24,88,136,140,144,212,280,284,352,416],$struct_PS_DesignMapRec___SIZE=12,$struct_PS_DimensionRec____SIZE=36,$struct_PS_FontExtraRec___SIZE=2,$struct_PS_FontInfoRec___SIZE=32,$struct_PS_FontInfoRec___FLATTENER=[0,4,8,12,16,20,24,26,28],$struct_PS_Hint_TableRec____SIZE=
12,$struct_PS_Hinter_Module_Rec____SIZE=176,$struct_PS_Hinter_Module_Rec____FLATTENER=[0,20,108,120,148],$struct_PS_HintsRec____SIZE=88,$struct_PS_MaskRec____SIZE=16,$struct_PS_Mask_TableRec____SIZE=12,$struct_PS_ParserRec___SIZE=72,$struct_PS_Parser_FuncsRec___SIZE=52,$struct_PS_PrivateRec___SIZE=196,$struct_PS_PrivateRec___FLATTENER=[0,4,8,9,10,11,12,40,60,88,108,112,116,120,122,124,125,126,127,128,154,180,184,188,192],$struct_PS_TableRec___SIZE=52,$struct_PS_Table_FuncsRec___SIZE=16,$struct_PS_UnicodesRec___SIZE=
24,$struct_PS_UnicodesRec___FLATTENER=[0,16,20],$struct_SFNT_HeaderRec____SIZE=16,$struct_SFNT_HeaderRec____FLATTENER=[0,4,6,8,10,12],$struct_SFNT_Interface___SIZE=160,$struct_T1_BuilderRec___SIZE=112,$struct_T1_BuilderRec___FLATTENER=[0,4,8,12,16,20,24,28,32,40,48,64,68,69,70,72,76,80],$struct_T1_Builder_FuncsRec___SIZE=32,$struct_T1_CMapCustomRec____SIZE=28,$struct_T1_CMapCustomRec____FLATTENER=[0,16,20,24],$struct_T1_CMapStdRec____SIZE=32,$struct_T1_CMapStdRec____FLATTENER=[0,16,20,24,28],$struct_T1_CMap_ClassesRec___SIZE=
16,$struct_T1_DecoderRec____SIZE=1500,$struct_T1_DecoderRec____FLATTENER=[0,112,1136,1140,1344,1348,1352,1356,1360,1364,1368,1372,1376,1392,1400,1404,1408,1464,1468,1472,1476,1488,1492,1496],$struct_T1_Decoder_FuncsRec___SIZE=12,$struct_T1_DriverRec____SIZE=0,$struct_T1_DriverRec____FLATTENER=[],$struct_T1_EncodingRec___SIZE=20,$struct_T1_FaceRec____SIZE=556,$struct_T1_FaceRec____FLATTENER=[0,132,484,488,492,496,520,528,532,536,540,544,548,552],$struct_T1_FieldRec____SIZE=36,$struct_T1_FontRec___SIZE=
352,$struct_T1_FontRec___FLATTENER=[0,32,36,232,236,240,260,264,268,272,276,280,284,288,292,296,300,301,304,320,328,344,348],$struct_T1_GlyphSlotRec____SIZE=180,$struct_T1_GlyphSlotRec____FLATTENER=[0,160,161,164,168,172,176],$struct_T1_HintsRec____SIZE=0,$struct_T1_HintsRec____FLATTENER=[],$struct_T1_Hints_FuncsRec___SIZE=28,$struct_T1_Loader____SIZE=376,$struct_T1_Loader____FLATTENER=[0,96,100,152,156,208,260,312,316,368,372],$struct_T1_ParserRec____SIZE=96,$struct_T1_ParserRec____FLATTENER=[0,
72,76,80,84,88,92,93,94],$struct_T1_TokenRec____SIZE=12,$struct_T2_HintsRec____SIZE=0,$struct_T2_HintsRec____FLATTENER=[],$struct_T2_Hints_FuncsRec___SIZE=28,$struct_T42_DriverRec____SIZE=48,$struct_T42_DriverRec____FLATTENER=[0,40,44],$struct_T42_FaceRec____SIZE=560,$struct_T42_FaceRec____FLATTENER=[0,132,484,488,492,496,500,504,528,536],$struct_T42_GlyphSlotRec____SIZE=164,$struct_T42_LoaderRec___SIZE=304,$struct_T42_LoaderRec___FLATTENER=[0,88,92,144,148,200,252],$struct_T42_ParserRec___SIZE=88,
$struct_T42_ParserRec___FLATTENER=[0,72,76,80,84],$struct_T42_SizeRec____SIZE=48,$struct_TBBox_Rec___SIZE=24,$struct_TCell____SIZE=16,$struct_TProfile___SIZE=32,$struct_TRaster____SIZE=24,$struct_TRaster____FLATTENER=[0,4,8,12,16,22],$struct_TTC_HeaderRec___SIZE=16,$struct_TT_BDFRec___SIZE=24,$struct_TT_CMap12Rec____SIZE=44,$struct_TT_CMap12Rec____FLATTENER=[0,24,28,32,36,40],$struct_TT_CMap14Rec____SIZE=40,$struct_TT_CMap14Rec____FLATTENER=[0,24,28,32,36],$struct_TT_CMap4Rec____SIZE=56,$struct_TT_CMap4Rec____FLATTENER=
[0,24,28,32,36,40,44,48,52],$struct_TT_CMapRec____SIZE=24,$struct_TT_CMapRec____FLATTENER=[0,16,20],$struct_TT_CMap_ClassRec___SIZE=52,$struct_TT_CMap_ClassRec___FLATTENER=[0,40,44,48],$struct_TT_DefRecord____SIZE=16,$struct_TT_DriverRec____SIZE=84,$struct_TT_DriverRec____FLATTENER=[0,40,44,80],$struct_TT_ExecContextRec____SIZE=608,$struct_TT_ExecContextRec____FLATTENER=[0,4,8,12,16,20,24,28,32,36,72,108,144,180,216,244,284,352,356,360,364,368,372,376,380,384,388,392,396,400,404,408,412,416,420,424,
428,432,436,440,442,444,468,472,476,480,484,488,492,560,561,564,568,572,576,580,584,588,592,596,600,604],$struct_TT_FaceRec____SIZE=824,$struct_TT_FaceRec____FLATTENER=[0,132,148,152,156,160,216,260,292,296,300,344,348,368,468,500,504,508,512,516,520,524,528,532,536,540,548,556,612,616,620,624,628,644,648,652,656,660,664,668,672,676,680,684,688,692,700,704,708,712,716,720,724,728,732,736,740,744,748,752,756,760,764,768,772,776,780,784,788,792,816,820],$struct_TT_GaspRec___SIZE=8,$struct_TT_GlyphZoneRec___SIZE=
36,$struct_TT_GlyphZoneRec___FLATTENER=[0,4,6,8,10,12,16,20,24,28,32],$struct_TT_GraphicsState___SIZE=68,$struct_TT_GraphicsState___FLATTENER=[0,2,4,6,10,14,20,24,28,32,36,40,44,48,50,52,53,56,60,62,64],$struct_TT_HdmxEntryRec____SIZE=8,$struct_TT_HdmxEntryRec____FLATTENER=[0,1,4],$struct_TT_HdmxRec___SIZE=8,$struct_TT_Header___SIZE=56,$struct_TT_Header___FLATTENER=[0,4,8,12,16,18,20,28,36,38,40,42,44,46,48,50,52],$struct_TT_HoriHeader___SIZE=44,$struct_TT_HoriHeader___FLATTENER=[0,4,6,8,10,12,14,
16,18,20,22,24,32,34,36,40],$struct_TT_Kern0_PairRec____SIZE=6,$struct_TT_LoaderRec____SIZE=208,$struct_TT_LoaderRec____FLATTENER=[0,4,8,12,16,20,24,28,32,36,52,56,60,64,65,68,76,84,88,124,160,164,168,172,176,180,184,192,200,204],$struct_TT_MaxProfile___SIZE=32,$struct_TT_MaxProfile___FLATTENER=[0,4,6,8,10,12,14,16,18,20,22,24,26,28,30],$struct_TT_NameEntryRec___SIZE=20,$struct_TT_NameEntryRec___FLATTENER=[0,2,4,6,8,12,16],$struct_TT_NameTableRec___SIZE=20,$struct_TT_OS2___SIZE=100,$struct_TT_OS2___FLATTENER=
[0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,44,48,52,56,60,64,66,68,70,72,74,76,78,80,84,88,90,92,94,96],$struct_TT_PCLT___SIZE=56,$struct_TT_PCLT___FLATTENER=[0,4,8,10,12,14,16,18,20,36,44,50,51,52,53],$struct_TT_Post_20Rec___SIZE=12,$struct_TT_Post_20Rec___FLATTENER=[0,2,4,8],$struct_TT_Post_25Rec___SIZE=8,$struct_TT_Post_NamesRec___SIZE=16,$struct_TT_Postscript___SIZE=32,$struct_TT_Postscript___FLATTENER=[0,4,8,10,12,16,20,24,28],$struct_TT_SBit_ComponentRec____SIZE=4,$struct_TT_SBit_ComponentRec____FLATTENER=
[0,2,3],$struct_TT_SBit_LineMetricsRec___SIZE=12,$struct_TT_SBit_MetricsRec___SIZE=8,$struct_TT_SBit_RangeRec____SIZE=40,$struct_TT_SBit_RangeRec____FLATTENER=[0,2,4,6,8,12,16,24,28,32,36],$struct_TT_SBit_ScaleRec____SIZE=28,$struct_TT_SBit_ScaleRec____FLATTENER=[0,12,24,25,26,27],$struct_TT_SBit_StrikeRec____SIZE=48,$struct_TT_SBit_StrikeRec____FLATTENER=[0,4,8,12,16,28,40,42,44,45,46,47],$struct_TT_SizeRec____SIZE=304,$struct_TT_SizeRec____FLATTENER=[0,44,72,112,116,120,124,128,132,136,140,144,
148,172,240,244,248,252,256,292,296,300,301],$struct_TT_Size_Metrics___SIZE=40,$struct_TT_Size_Metrics___FLATTENER=[0,4,8,12,16,20,36,37,38],$struct_TT_ValidatorRec____SIZE=176,$struct_TWorker____SIZE=1028,$struct_TWorker____FLATTENER=[0,4,8,12,16,20,24,28,32,36,40,44,48,52,56,60,64,68,72,76,80,84,86,87,88,92,96,100,104,128,148,152,156,158,160,164,168,172,176,180,181,184,960,1024],$struct_WinPE32_HeaderRec___SIZE=20,$struct_WinPE32_HeaderRec___FLATTENER=[0,4,6,8,10,12,16],$struct_WinPE32_SectionRec___SIZE=
20,$struct_WinPE32_SectionRec___FLATTENER=[0,8,12,16],$struct_WinPE_RsrcDirRec___SIZE=16,$struct_WinPE_RsrcDirRec___FLATTENER=[0,4,8,10,12,14],$struct__IO_FILE___SIZE=148,$struct__IO_FILE___FLATTENER=[0,4,8,12,16,20,24,28,32,36,40,44,48,52,56,60,64,68,70,71,72,76,84,88,92,96,100,104,108],$struct__IO_marker___SIZE=12,$struct___jmp_buf_tag___SIZE=156,$struct___jmp_buf_tag___FLATTENER=[0,24,28],$struct___sigset_t___SIZE=128,$struct__bdf_list_t___SIZE=16,$struct__bdf_parse_t___SIZE=8252,$struct__bdf_parse_t___FLATTENER=
[0,4,8,12,14,16,18,20,22,24,28,32,36,40,8232,8248],$struct_bdf_bbx_t___SIZE=12,$struct_bdf_font_t___SIZE=16548,$struct_bdf_font_t___FLATTENER=[0,4,16,20,24,28,32,36,40,44,48,52,56,60,64,68,72,76,80,84,88,92,128,132,8324,16516,16518,16520,16524,16528,16532],$struct_bdf_glyph_t___SIZE=36,$struct_bdf_glyph_t___FLATTENER=[0,4,8,10,12,24,28,32],$struct_bdf_glyphlist_t___SIZE=36,$struct_bdf_glyphlist_t___FLATTENER=[0,2,4,8,12,16,20,24],$struct_bdf_property_t___SIZE=16,$struct_hashtable___SIZE=16,$struct_raccess_guess_rec___SIZE=
8,$struct_stat___SIZE=88,$struct_stat___FLATTENER=[0,8,12,16,20,24,28,32,40,44,48,52,56,60,64,68,72,76,80,84],$struct_z_stream___SIZE=56,$union_anon___SIZE=12,_WIDTH,_HEIGHT,_image,__str,_stderr,__str1,__str2,__str3,__str4,_ft_default_modules,__str5,__str16,__str27,__str38,__str49,__str510,__str6,__str7,__str8,__str9,__str10,__str11,_raccess_guess_table,__str12,__str13,__str14,__str15,__str1611,__str17,__str18,_ft_trig_arctan_table,_bbox_interface,__str19,__str20,__str21,_ft_bitmap_glyph_class,_ft_outline_glyph_class,
__str22,__str123,__str24,__str25,__str127,__str28,__str30,__str31,_tt_service_gx_multi_masters,_tt_service_truetype_engine,_tt_service_truetype_glyf,_tt_services,__str133,__str537,_tt_driver_class,_tt_default_graphics_state,_trick_names_6890,_sfnt_id_6968,_Pop_Push_Count,_opcode_length,_gvar_fields_11813,_fvar_fields_12035,_fvaraxis_fields_12036,__str740,__str841,__str942,__str1043,__str44,__str145,__str246,__str650,__str751,__str852,__str953,__str1054,__str1155,_t1_keywords,__str1256,__str1357,__str1458,
__str1559,__str1660,__str1761,__str1862,__str1963,__str2064,__str2165,__str2266,__str23,__str2467,__str2568,__str2669,__str2712,__str2870,__str2971,__str3072,__str3173,__str3274,__str33,__str34,__str35,__str36,__str37,__str3813,__str39,__str40,__str41,__str42,__str43,__str4475,__str45,__str46,__str47,__str48,__str4914,__str50,__str51,__str52,__str53,__str54,__str55,__str56,__str57,__str58,__str59,__str60,__str61,__str62,__str63,__str64,_t1_service_glyph_dict,_t1_service_ps_name,_t1_service_multi_masters,
_t1_service_ps_info,_t1_service_kerning,_t1_services,__str68,_t1_driver_class,_cff_service_glyph_dict,_cff_service_ps_info,_cff_service_ps_name,_cff_cmap_encoding_class_rec,_cff_cmap_unicode_class_rec,_cff_service_get_cmap_info,_cff_service_cid_info,_cff_services,__str481,_cff_driver_class,_power_tens,_cff_field_handlers,_cff_isoadobe_charset,_cff_expert_charset,_cff_expertsubset_charset,_cff_standard_encoding,_cff_expert_encoding,_cff_header_fields_6394,_cff_argument_counts,__str93,__str194,__str295,
__str396,_cid_field_records,__str497,__str598,__str699,__str7100,__str8101,__str9102,__str10103,__str11104,__str12105,__str13106,__str14107,__str27120,__str28121,__str29122,__str30123,__str31124,__str51144,__str54147,_cid_service_ps_name,_cid_service_ps_info,_cid_service_cid_info,_cid_services,__str61154,_t1cid_driver_class,__str65159,_pfr_header_fields,_pfr_phy_font_extra_items,_pfr_cmap_class_rec,_pfr_metrics_service_rec,_pfr_services,__str2166,_pfr_driver_class,__str3168,_t42_keywords,__str23192,
__str24193,__str29198,_t42_service_glyph_dict,_t42_service_ps_font_name,_t42_service_ps_info,_t42_services,__str34203,_t42_driver_class,_winmz_header_fields,_winne_header_fields,_winpe32_header_fields,_winpe32_section_fields,_winpe_rsrc_dir_fields,_winpe_rsrc_dir_entry_fields,_winpe_rsrc_data_entry_fields,_winfnt_header_fields,_fnt_cmap_class_rec,__str1207,__str3209,_winfnt_service_rec,_winfnt_services,__str5211,_winfnt_driver_class,_pcf_metric_header,_pcf_metric_msb_header,_pcf_compressed_metric_header,
_pcf_property_header,_pcf_property_msb_header,_pcf_accel_header,_pcf_accel_msb_header,__str214,__str1215,__str3217,__str5219,__str6220,__str8222,__str9223,__str10224,__str11225,__str12226,__str13227,__str14228,__str15229,_pcf_cmap_class,__str16230,__str17231,__str18232,_pcf_service_bdf,_pcf_services,__str21235,_pcf_driver_class,__str22237,__bdf_opts,__bdf_properties,__str2240,__str3241,__str4242,__str5243,__str8246,__str9247,__str10248,__str11249,__str12250,__str13251,__str14252,__str16254,__str17255,
__str18256,__str19257,__str20258,__str21259,__str22260,__str23261,__str24262,__str25263,__str26264,__str27265,__str30268,__str31269,__str32270,__str33271,__str34272,__str35273,__str36274,__str37275,__str38276,__str39277,__str40278,__str41279,__str42280,__str43281,__str44282,__str45283,__str46284,__str47285,__str48286,__str49287,__str50288,__str51289,__str52290,__str53291,__str54292,__str55293,__str56294,__str57295,__str58296,__str59297,__str60298,__str61299,__str66304,__str67305,__str68306,__str69307,
__str70308,__str71309,__str72310,__str73,__str74,__str75,__str76,__str77311,__str78,__str80,__str81,__str82,_empty,_a2i,_odigits,_ddigits,_hdigits,__str83,_nibble_mask,__str84,__str85,__str86,__str87,__str88,__str89,__str90,__str91,__str92,__str93312,__str94,__str95,__str96,__str97,__str98,__str99,__str100,_bdf_cmap_class,_bdf_service_bdf,_bdf_services,__str110,_bdf_driver_class,_table_dir_entry_fields_3826,_offset_table_fields_3900,_header_fields_3996,_maxp_fields_4025,_maxp_fields_extra_4026,_name_table_fields_4061,
_name_record_fields_4062,_os2_fields_4158,_os2_fields_extra_4159,_os2_fields_extra2_4160,_post_fields_4185,_pclt_fields_4199,_metrics_header_fields_4401,_tt_cmap0_class_rec,_tt_cmap2_class_rec,_tt_cmap4_class_rec,_tt_cmap6_class_rec,_tt_cmap8_class_rec,_tt_cmap10_class_rec,_tt_cmap12_class_rec,_tt_cmap13_class_rec,_tt_cmap14_class_rec,_tt_cmap_classes,_tt_encodings_9541,_ttc_header_fields_9565,_sfnt_service_sfnt_table,_sfnt_service_glyph_dict,_sfnt_service_ps_name,_tt_service_get_cmap_info,_sfnt_service_bdf,
_sfnt_services,_sfnt_interface,_sfnt_module_class,_sbit_metrics_fields,_strike_start_fields_10745,_sbit_line_metrics_fields_10744,_strike_end_fields_10746,_sbit_small_metrics_fields_11020,_af_script_classes,_af_dummy_script_class,_af_latin_script_class,_af_cjk_script_class,_af_indic_script_class,_af_latin_blue_chars,_latin_encodings_4600,_af_latin_uniranges,_af_cjk_uniranges,_af_indic_uniranges,_af_autofitter_service,_autofit_module_class,__str325,_pshinter_interface,_pshinter_module_class,_ft_standard_raster,
_ft_raster1_renderer_class,_ft_raster5_renderer_class,__str329,__str1330,_func_interface,_ft_grays_raster,_ft_smooth_renderer_class,__str332,_ft_smooth_lcd_renderer_class,__str1334,_ft_smooth_lcdv_renderer_class,__str2336,_ftc_size_list_class,_ftc_face_list_class,_ftc_cmap_cache_class,_ftc_basic_image_family_class,_ftc_basic_image_cache_class,_ftc_basic_sbit_family_class,_ftc_basic_sbit_cache_class,__str337,_ps_table_funcs,_ps_parser_funcs,_t1_builder_funcs,_t1_decoder_funcs,_afm_parser_funcs,_t1_cmap_classes,
_t1_cmap_standard_class_rec,_t1_cmap_expert_class_rec,_t1_cmap_custom_class_rec,_t1_cmap_unicode_class_rec,_psaux_interface,_psaux_module_class,_t1_args_count,_afm_key_table,__str2343,__str3344,__str4345,__str5346,__str9350,__str10351,__str11352,__str12353,__str13354,__str14355,__str15356,__str16357,__str17358,__str18359,__str19360,__str20361,__str21362,__str22363,__str23364,__str24365,__str25366,__str26367,__str31372,__str32373,__str33374,__str34375,__str36377,__str37378,__str38379,__str39380,__str40381,
__str41382,__str42383,__str43384,__str45386,__str46387,__str47388,__str48389,__str49390,__str50391,__str51392,__str52393,__str53394,__str54395,__str55396,__str58399,__str61402,__str62403,__str63404,__str64405,__str65406,__str66407,__str67408,__str68409,__str69410,__str70411,__str71412,__str72413,__str75416,__str76417,_ft_char_table,_ft_standard_glyph_names,_ft_mac_names,_ft_sid_names,_t1_expert_encoding,_ft_adobe_glyph_list,_ft_extra_glyph_unicodes,_ft_extra_glyph_names,_ft_extra_glyph_name_offsets,
_pscmaps_interface,_pscmaps_services,_psnames_module_class,__str1421;_putchar=function(e){__print__(String.fromCharCode(e))};_printf=function(){__print__(Pointer_stringify(__formatString.apply(null,arguments)))};
__formatString=function(){function e(l){return String.fromCharCode(l)in Runtime.set("f","e","g")}function g(l){var m;if(d){e(l);m=HEAP[a];a+=l==="l".charCodeAt(0)?8:4}else{m=c[a];a++}return m}var d=false,b=arguments[0],a=1;if(b<0){d=true;b=-b;slab=null;a=arguments[1]}else var c=arguments;for(var f=[],h,i,k;;){h=HEAP[b];if(h===0)break;i=HEAP[b+1];if(h=="%".charCodeAt(0)){h=-1;if(i==".".charCodeAt(0)){b++;for(h=0;;){i=HEAP[b+1];if(!(i>="0".charCodeAt(0)&&i<="9".charCodeAt(0)))break;h*=10;h+=i-"0".charCodeAt(0);
b++}i=HEAP[b+1]}if(i=="l".charCodeAt(0)){b++;i=HEAP[b+1]}if(e(i))i="f".charCodeAt(0);if(["d","i","u","p","f"].indexOf(String.fromCharCode(i))!=-1){var j;k=g(i);j=String(+k);j=i=="u".charCodeAt(0)?String(unSign(k,32)):i=="p".charCodeAt(0)?"0x"+k.toString(16):String(+k);if(h>=0)if(e(i)){k=j.indexOf(".");if(k==-1&&i=="f".charCodeAt(0)){k=j.length;j+="."}j+="00000000000";j=j.substr(0,k+1+h)}else for(;j.length<h;)j="0"+j;j.split("").forEach(function(l){f.push(l.charCodeAt(0))})}else if(i=="s".charCodeAt(0))f=
f.concat(String_copy(g(i)));else if(i=="c".charCodeAt(0))f=f.concat(g(i));else f.push(i);b+=2}else{f.push(h);b+=1}}return Pointer_make(f.concat(0),0,ALLOC_STACK)};
_STDIO={streams:{},filenames:{},counter:1,SEEK_SET:0,SEEK_CUR:1,SEEK_END:2,init:function(){_stdin=Pointer_make([0],null,ALLOC_STATIC);IHEAP[_stdin]=this.prepare("<<stdin>>");_stdout=Pointer_make([0],null,ALLOC_STATIC);IHEAP[_stdout]=this.prepare("<<stdout>>",null,true);_stderr=Pointer_make([0],null,ALLOC_STATIC);IHEAP[_stderr]=this.prepare("<<stderr>>",null,true)},prepare:function(e,g,d){var b=this.counter++;this.streams[b]={filename:e,data:g?g:[],position:0,eof:0,error:0,print:d};return this.filenames[e]=
b},open:function(e){e=_STDIO.filenames[e];if(!e)return-1;var g=_STDIO.streams[e];g.position=g.error=g.eof=0;return e},read:function(e,g,d){e=_STDIO.streams[e];if(!e)return-1;for(var b=0;b<d;b++){if(e.position>=e.data.length){e.eof=1;return 0}HEAP[g]=e.data[e.position];e.position++;g++}return d}};_fprintf=function(){var e=Array.prototype.slice.call(arguments,1);__print__(Pointer_stringify(__formatString.apply(null,e)))};
_exit=function(e){__shutdownRuntime__();ABORT=true;throw"exit("+e+") called, at "+Error().stack;};_strlen=function(e){return String_len(e)};_atoi=function(e){return Math.floor(Number(Pointer_stringify(e)))};_cos=Math.cos;_sin=Math.sin;_realloc=function(e,g){if(!g){e&&_free(e);return 0}var d=_malloc(g);if(e){_memcpy(d,e,g);_free(e)}return d};_memcpy=function(e,g,d){for(var b=0;b<d;b++){IHEAP[e+b]=IHEAP[g+b];FHEAP[e+b]=FHEAP[g+b]}};_munmap=function(e){_free(e)};
_open=function(e,g,d){e=Pointer_stringify(e);if(g===0)return _STDIO.open(e);else if(g===1)return _STDIO.prepare(e);else assert(false,"open with odd params: "+[g,d])};_fcntl=function(){};_fstat=function(e,g){var d=_STDIO.streams[e];if(!d)return-1;HEAP[g+$struct_stat___FLATTENER[9]]=d.data.length;return 0};_mmap=function(e,g,d,b,a,c){e=_STDIO.streams[a];if(!e)return-1;return Pointer_make(e.data.slice(c,c+g),null,ALLOC_NORMAL)};_read=function(e,g,d){return _STDIO.read(e,g,d)};
___errno_location=function(){var e=arguments.callee;if(!e.ret)e.ret=Pointer_make([0],0,ALLOC_STATIC);return e.ret};_close=function(){return 0};_llvm_memcpy_p0i8_p0i8_i32=function(e,g,d){for(var b=0;b<d;b++){IHEAP[e+b]=IHEAP[g+b];FHEAP[e+b]=FHEAP[g+b]}};_llvm_memmove_p0i8_p0i8_i32=function(e,g,d){if(d!==0){var b=_malloc(d);_memcpy(b,g,d);_memcpy(e,b,d);_free(b)}};
_strcmp=function(e,g){for(var d=0;;){var b=HEAP[e+d],a=HEAP[g+d];if(b==a&&b==0)return 0;if(b==0)return-1;if(a==0)return 1;if(b==a)d++;else return b>a?1:-1}};_llvm_memset_p0i8_i32=Runtime.memset;_memcmp=function(e,g,d){for(var b=0;b<d;b++){var a=HEAP[e+b],c=HEAP[g+b];if(a!=c)return a>c?1:-1}return 0};
_qsort=function(e,g,d,b){b=FUNCTION_TABLE[b];for(var a=[],c=0;c<g;c++)a.push(c);a.sort(function(h,i){return b(e+h*d,e+i*d)});var f=_malloc(g*d);_memcpy(f,e,g*d);for(c=0;c<g;c++)a[c]!=c&&_memcpy(e+c*d,f+a[c]*d,d);_free(f)};_strrchr=function(e,g){var d=e+Pointer_stringify(e).length;do{if(HEAP[d]==g)return d;d--}while(d>=e);return 0};_strncpy=function(e,g,d){for(var b=false,a,c=0;c<d;c++){a=b?0:HEAP[g+c];HEAP[e+c]=a;b=b||HEAP[g+c]==0}};
_strcat=function(e,g){var d=Pointer_stringify(e).length,b=0;do{HEAP[e+d+b]=HEAP[g+b];b++}while(HEAP[g+b-1]!=0);return e};_strstr=function(e,g){var d=Pointer_stringify(e),b=Pointer_stringify(g);d=d.search(b);return d>=0?e+d:0};_strncmp=function(e,g,d){for(var b=0;b<d;){var a=HEAP[e+b],c=HEAP[g+b];if(a==c&&a==0)break;if(a==0)return-1;if(c==0)return 1;if(a==c)b++;else return a>c?1:-1}return 0};
_sprintf=function(){var e=arguments[0],g=Array.prototype.slice.call(arguments,1);_strcpy(e,__formatString.apply(null,g))};_strcpy=function(e,g){var d=0;do{HEAP[e+d]=HEAP[g+d];d++}while(HEAP[g+d-1]!=0)};__setjmp=function(){print("WARNING: setjmp() not really implemented, will fail if longjmp() is actually called");return 0};_memchr=function(e,g,d){g=unSign(g);for(var b=0;b<d;b++){if(HEAP[e]==g)return e;e++}return 0};_llvm_memset_p0i8_i64=Runtime.memset;
function __Z11draw_bitmapP10FT_Bitmap_ii(e,g,d){var b,a=null,c,f;c=g+HEAP[e+4];f=d+HEAP[e];if(reSign(g,32)<reSign(c,32)){var h=e+12;e=e+4;var i=reSign(d,32)<reSign(f,32),k=d+1;f=(reSign(f,32)>reSign(k,32)?f:k)-d;a=0;a:for(;;){k=a==0?0:p;var j=a==0?g:n,l=0+k;if(i){a=1;b=2}else{a=1;b=3}for(;;)if(b==2){o=a==5?o:0;a=d+o;b=reSign(j,32)<reSign(0,32);var m=reSign(a,32)<reSign(0,32);b=b|m;m=HEAP[_WIDTH];m=reSign(j,32)>=reSign(m,32);b=b|m;m=HEAP[_HEIGHT];m=reSign(a,32)>=reSign(m,32);b|m||(HEAP[HEAP[_image]+
(a*HEAP[_WIDTH]+j)]=HEAP[HEAP[h]+l+HEAP[e]*o]|HEAP[HEAP[_image]+(a*HEAP[_WIDTH]+j)]);var o=o+1;if(o!=f){a=5;b=2}else{a=5;b=3}}else if(b==3){var n=j+1;j=reSign(n,32)<reSign(c,32);var p=k+1;if(j){a=3;continue a}else break a}}}}__Z11draw_bitmapP10FT_Bitmap_ii.__index__=Runtime.getFunctionIndex(__Z11draw_bitmapP10FT_Bitmap_ii,"__Z11draw_bitmapP10FT_Bitmap_ii");
function __Z10show_imagev(){var e,g=null,d;d=0;var b=HEAP[_HEIGHT];if(reSign(0,32)<reSign(b,32)){d=d;g=0;a:for(;;){b=g==0?0:l;var a=g==0?d:j,c=0+b,f=1+b;e=HEAP[_WIDTH];if(reSign(0,32)<reSign(e,32)){g=1;e=2}else{g=1;e=3}b:for(;;)if(e==2){h=g==5?h:a;k=g==5?k:0;e=k+1;g=h+1;var h=HEAP[HEAP[_image]+(k+c*HEAP[_WIDTH])]!=0?g:h,i=HEAP[HEAP[_image]+(k+c*HEAP[_WIDTH])]!=0;c:do if(i){if(reSign(HEAP[HEAP[_image]+(k+c*HEAP[_WIDTH])],8)>=reSign(0,8)){g=4;break c}g=6}else g=2;while(0);_putchar(g==6?42:g==4?43:32);
var k=k+1;g=HEAP[_WIDTH];if(reSign(e,32)<reSign(g,32)){g=5;e=2;continue b}g=8;e=3}else if(e==3){var j=g==8?h:a;_putchar(10);l=HEAP[_HEIGHT];f=reSign(f,32)<reSign(l,32);var l=b+1;if(f){g=3;continue a}else break a}}d=j}_printf(__str,d)}__Z10show_imagev.__index__=Runtime.getFunctionIndex(__Z10show_imagev,"__Z10show_imagev");
function _main(e,g){var d=STACKTOP;STACKTOP+=64;Runtime.memset(d,0,64);var b,a=null,c,f;c=d+32;var h=d+36,i=d+40,k=d+56,j,l,m,o,n;if(e!=6){_fprintf(HEAP[_stderr],__str1,HEAP[g]);_exit(1);throw"Reached an unreachable! Original .ll line: 1105";}else{l=HEAP[g+8];n=_strlen(l);o=_atoi(HEAP[g+12]);HEAP[_WIDTH]=o;o=_atoi(HEAP[g+16]);HEAP[_HEIGHT]=o;o=_atoi(HEAP[g+20]);m=reSign(o,32)/360*3.14159*2;o=HEAP[_HEIGHT];a=_malloc(HEAP[_HEIGHT]*HEAP[_WIDTH]);HEAP[_image]=a;a=HEAP[_WIDTH];if(reSign(0,32)<reSign(a,
32)){a=0;a:for(;;){var p=a==0?0:f,r=0+p,q=1+p;a=HEAP[_HEIGHT];if(reSign(0,32)<reSign(a,32)){a=1;b=2}else{a=1;b=3}for(;;)if(b==2){j=a==2?j:0;a=j+1;HEAP[HEAP[_image]+r+HEAP[_WIDTH]*j]=0;j=j+1;b=HEAP[_HEIGHT];if(reSign(a,32)<reSign(b,32))b=a=2;else{a=2;b=3}}else if(b==3){f=HEAP[_WIDTH];a=reSign(q,32)<reSign(f,32);f=p+1;if(a){a=3;continue a}else break a}}}j=f=_FT_Init_FreeType(c);f!=0&&_printf(__str2,j);a=HEAP[g+4];f=HEAP[c];p=a==0;a:do{if(p){j=6;b=7}else{HEAP[d]=4;HEAP[d+12]=a;HEAP[d+16]=0;j=f=_FT_Open_Face(f,
d,0,h);b=f!=0?7:8}break a}while(0);b==7&&_printf(__str3,j);j=f=_FT_Set_Char_Size(HEAP[h],3200,0,100,0);f!=0&&_printf(__str4,j);a=HEAP[HEAP[h]+84];j=_cos(m)*65536;HEAP[i]=Math.floor(j);j=_sin(m)*-65536;HEAP[i+4]=Math.floor(j);j=_sin(m)*65536;HEAP[i+8]=Math.floor(j);m=_cos(m)*65536;HEAP[i+12]=Math.floor(m);HEAP[k]=1E3;HEAP[k+4]=0;if(reSign(0,32)<reSign(n,32)){m=a+104;j=a+100;f=a+76;p=a+64;q=k+4;b=a+64+4;r=k+4;n=(reSign(n,32)>reSign(1,32)?n:1)-0;for(a=11;;){s=a==11?0:s;a=l+(0+s);_FT_Set_Transform(HEAP[h],
i,k);a=reSign(HEAP[a],8);if(_FT_Load_Char(HEAP[h],a,4)==0){__Z11draw_bitmapP10FT_Bitmap_ii(f,HEAP[j],o-HEAP[m]);HEAP[k]=HEAP[p]+HEAP[k];HEAP[r]=HEAP[b]+HEAP[q]}var s=s+1;if(s!=n)a=14;else break}}__Z10show_imagev();_FT_Done_Face(HEAP[h]);h=HEAP[c];if(h!=0){c=HEAP[h];_FT_Done_Library(h);FUNCTION_TABLE[HEAP[c+8]](c,c)}STACKTOP=d;return 0}}_main.__index__=Runtime.getFunctionIndex(_main,"_main");function _ft_alloc(e,g){return _malloc(g)}_ft_alloc.__index__=Runtime.getFunctionIndex(_ft_alloc,"_ft_alloc");
function _ft_realloc(e,g,d,b){return _realloc(b,d)}_ft_realloc.__index__=Runtime.getFunctionIndex(_ft_realloc,"_ft_realloc");function _ft_free(e,g){_free(g)}_ft_free.__index__=Runtime.getFunctionIndex(_ft_free,"_ft_free");function _ft_close_stream_by_munmap(e){_munmap(HEAP[e+12],HEAP[e+4]);HEAP[e+12]=0;HEAP[e+4]=0;HEAP[e]=0}_ft_close_stream_by_munmap.__index__=Runtime.getFunctionIndex(_ft_close_stream_by_munmap,"_ft_close_stream_by_munmap");
function _ft_close_stream_by_free(e){_free(HEAP[e+12]);HEAP[e+12]=0;HEAP[e+4]=0;HEAP[e]=0}_ft_close_stream_by_free.__index__=Runtime.getFunctionIndex(_ft_close_stream_by_free,"_ft_close_stream_by_free");
function _FT_Stream_Open(e,g){var d=STACKTOP;STACKTOP+=88;Runtime.memset(d,0,88);var b,a=null,c,f,h=e==0;a:do if(h)f=40;else{f=_open(g,0);if(reSign(f,32)<reSign(0,32))f=1;else{_fcntl(f,2,1);b=_fstat(f,d);b=reSign(b,32)<reSign(0,32);b:do if(!b){if(HEAP[d+44]==0)break b;HEAP[e+4]=HEAP[d+44];HEAP[e+8]=0;b=_mmap(0,HEAP[e+4],1,2,f,0);HEAP[e]=b;c=HEAP[e]==4294967295;c:do if(c)b=3;else{if(HEAP[e]==0){b=3;break c}HEAP[e+24]=_ft_close_stream_by_munmap.__index__;b=5;break c}while(0);if(b==3){c=HEAP[e+4];c=
c=_malloc(c);HEAP[e]=c;if(HEAP[e]==0)break b;c=f;for(a=6;;){b=a==13?k:0;a=_read(c,HEAP[e]+b,HEAP[e+4]-b);if(reSign(a,32)<=reSign(0,32)){if(a!=-1){b=10;break}a=___errno_location();if(HEAP[a]==4)a=9;else{b=10;break}}else{var i=a+b;a=12}var k=a==12?i:b;if(k!=HEAP[e+4]){a=13;b=7}else{b=14;break}}if(b==10){b=HEAP[e];_free(b);break b}else if(b==14)HEAP[e+24]=_ft_close_stream_by_free.__index__}_close(f);HEAP[e+12]=HEAP[e];HEAP[e+16]=g;f=HEAP[e+20]=0;break a}while(0);_close(f);HEAP[e]=0;HEAP[e+4]=0;HEAP[e+
8]=0;f=81}}while(0);h=f;STACKTOP=d;return h}_FT_Stream_Open.__index__=Runtime.getFunctionIndex(_FT_Stream_Open,"_FT_Stream_Open");function _FT_New_Memory(){var e;e=_malloc(16);if(e!=0){HEAP[e]=0;HEAP[e+4]=_ft_alloc.__index__;HEAP[e+12]=_ft_realloc.__index__;HEAP[e+8]=_ft_free.__index__}return e}_FT_New_Memory.__index__=Runtime.getFunctionIndex(_FT_New_Memory,"_FT_New_Memory");function _FT_Done_Memory(e){FUNCTION_TABLE[HEAP[e+8]](e,e)}
_FT_Done_Memory.__index__=Runtime.getFunctionIndex(_FT_Done_Memory,"_FT_Done_Memory");function _ft_debug_init(){}_ft_debug_init.__index__=Runtime.getFunctionIndex(_ft_debug_init,"_ft_debug_init");function _FT_Trace_Get_Count(){return 0}_FT_Trace_Get_Count.__index__=Runtime.getFunctionIndex(_FT_Trace_Get_Count,"_FT_Trace_Get_Count");function _FT_Trace_Get_Name(){return 0}_FT_Trace_Get_Name.__index__=Runtime.getFunctionIndex(_FT_Trace_Get_Name,"_FT_Trace_Get_Name");
function _FT_Add_Default_Modules(e){var g=null,d;d=_ft_default_modules;if(HEAP[d]!=0)for(g=0;;){b=g==0?0:b;g=d+4*(b+1);_FT_Add_Module(e,HEAP[d+4*b]);var b=b+1;if(HEAP[g]!=0)g=1;else break}}_FT_Add_Default_Modules.__index__=Runtime.getFunctionIndex(_FT_Add_Default_Modules,"_FT_Add_Default_Modules");
function _FT_Init_FreeType(e){var g,d=null,b,a,c,f;c=_malloc(16);b=c!=0;a:do{if(b){HEAP[c]=0;HEAP[c+4]=_ft_alloc.__index__;HEAP[c+12]=_ft_realloc.__index__;HEAP[c+8]=_ft_free.__index__;g=c=c;if(c==0){g=0;break a}f=_FT_New_Library(g,e);c=f!=0;b:do if(c){b=g;FUNCTION_TABLE[HEAP[b+8]](b,b)}else{b=HEAP[e];a=_ft_default_modules;if(HEAP[a]==0)break b;b=b;a=a;for(d=4;;){h=d==4?0:h;d=a+4*(h+1);_FT_Add_Module(b,HEAP[a+4*h]);var h=h+1;if(HEAP[d]!=0)d=6;else break}}while(0);f=f;g=8}else g=0;break a}while(0);
if(g==0)f=7;return f}_FT_Init_FreeType.__index__=Runtime.getFunctionIndex(_FT_Init_FreeType,"_FT_Init_FreeType");function _FT_Done_FreeType(e){var g;if(e!=0){g=HEAP[e];_FT_Done_Library(e);FUNCTION_TABLE[HEAP[g+8]](g,g)}return 0}_FT_Done_FreeType.__index__=Runtime.getFunctionIndex(_FT_Done_FreeType,"_FT_Done_FreeType");
function __ft_face_scale_advances(e,g,d,b){var a=null;if((b&1&255)!=0)g=0;else if(HEAP[e+88]==0)g=36;else{a=HEAP[e+88]+12;b=(b&16)!=0?HEAP[a+8]:HEAP[a+4];if(unSign(0,32)<unSign(d,32)){d=(unSign(d,32)>unSign(1,32)?d:1)-0;for(a=2;;){c=a==2?0:c;e=0+c;a=g+4*e;e=_FT_MulDiv(HEAP[g+4*e],b,64);HEAP[a]=e;var c=c+1;if(c!=d)a=3;else break}}g=0}return g}__ft_face_scale_advances.__index__=Runtime.getFunctionIndex(__ft_face_scale_advances,"__ft_face_scale_advances");
function _FT_Get_Advance(e,g,d,b){var a,c=e==0;a:do if(c)a=35;else{a=g;if(unSign(HEAP[e+16],32)<=unSign(a,32))a=16;else{a=HEAP[HEAP[HEAP[e+96]+20]+92];var f=a!=0;b:do if(f){if((d&3)==0)if((reSign(d,32)>>reSign(16,32)&15)!=1)break b;a=f=FUNCTION_TABLE[a](e,g,1,d,b);if(f==0)a=__ft_face_scale_advances(e,b,1,d);else{if(a==7)break b;a=a}break a}while(0);a=_FT_Get_Advances(e,g,1,d,b)}}while(0);return a}_FT_Get_Advance.__index__=Runtime.getFunctionIndex(_FT_Get_Advance,"_FT_Get_Advance");
function _FT_Get_Advances(e,g,d,b,a){var c,f=null,h,i,k;b=b;i=e==0;a:do if(i)h=35;else{k=HEAP[e+16];h=d+g;var j=k;j=unSign(g,32)>=unSign(j,32);b:do if(!j){j=g;if(unSign(h,32)<unSign(j,32))break b;k=k;if(unSign(h,32)>unSign(k,32))break b;if(d==0)h=0;else{i=HEAP[HEAP[HEAP[e+96]+20]+92];h=i!=0;c:do if(h){if((b&3)==0)if((reSign(b,32)>>reSign(16,32)&15)!=1){c=6;break c}i=h=FUNCTION_TABLE[i](e,g,d,b,a);if(h==0){c=7;break c}if(i==7){c=6;break c}h=i;break a}else c=6;while(0);c:do if(c==6){i=0;if((b&536870912)!=
0)h=7;else{b|=256;h=d;k=e;j=b;var l=e+84,m=a,o=i;g=0+g;if((b&16)!=0){f=10;c=11}else{f=10;c=12}for(;;)if(c==11){q=f==15?q:0;var n=f==15?0:o;f=0+q;c=g+q;var p=m+4*f;if(!(unSign(f,32)<unSign(h,32))){f=11;c=14;break}var r=_FT_Load_Glyph(k,c,j);if(r!=0){f=13;c=16;break}HEAP[p]=HEAP[HEAP[l]+64+4];var q=q+1;f=15;c=11}else if(c==12){t=f==18?t:0;var s=f==18?0:o;f=0+t;c=g+t;p=m+4*f;if(!(unSign(f,32)<unSign(h,32))){f=12;c=14;break}var u=_FT_Load_Glyph(k,c,j);if(u!=0){f=17;c=16;break}HEAP[p]=HEAP[HEAP[l]+64];
var t=t+1;f=18;c=12}if(c==14){i=n=f==11?n:s;if(n==0)break c}else if(c==16)i=f==13?r:u;h=i}break a}while(0);h=__ft_face_scale_advances(e,a,d,b)}break a}while(0);h=16}while(0);return h}_FT_Get_Advances.__index__=Runtime.getFunctionIndex(_FT_Get_Advances,"_FT_Get_Advances");function _FT_RoundFix(e){return reSign(e,32)>=reSign(0,32)?e+32768&-65536:0-(32768-e&-65536)}_FT_RoundFix.__index__=Runtime.getFunctionIndex(_FT_RoundFix,"_FT_RoundFix");
function _FT_CeilFix(e){return reSign(e,32)>=reSign(0,32)?e+65535&-65536:0-(65535-e&-65536)}_FT_CeilFix.__index__=Runtime.getFunctionIndex(_FT_CeilFix,"_FT_CeilFix");function _FT_FloorFix(e){return reSign(e,32)>=reSign(0,32)?e&-65536:0-(0-e&-65536)}_FT_FloorFix.__index__=Runtime.getFunctionIndex(_FT_FloorFix,"_FT_FloorFix");
function _FT_Sqrt32(e){var g=null,d;d=d=0;for(g=-1;;){c=g==0?c:e;h=g==0?h:1073741824;f=g==0?f:d;var b=h+f;g=unSign(b,32)<=unSign(c,32);var a=c-b;b=h+b;var c=g?a:c,f=unSign(g?b:f,32)>>>unSign(1,32),h=unSign(h,32)>>>unSign(2,32);if(h!=0)g=0;else break}return d=f}_FT_Sqrt32.__index__=Runtime.getFunctionIndex(_FT_Sqrt32,"_FT_Sqrt32");
function _ft_multo64(e,g,d){var b,a,c;b=e&65535;e=unSign(e,32)>>>unSign(16,32);a=g&65535;c=unSign(g,32)>>>unSign(16,32);g=a*b;b=c*b;a=e*a;e=c*e;b=a+b;a=unSign(b,32)<unSign(a,32);e+=a?65536:0;e=(unSign(b,32)>>>unSign(16,32))+e;b<<=16;g=b+g;b=b;b=unSign(g,32)<unSign(b,32);e=unSign(b,1)+e;HEAP[d]=g;HEAP[d+4]=e}_ft_multo64.__index__=Runtime.getFunctionIndex(_ft_multo64,"_ft_multo64");
function _ft_div64by32(e,g,d){var b=null,a;a=0;if(unSign(e,32)>=unSign(d,32))e=2147483647;else{a=a;for(b=1;;){j=b==2?j:0;k=b==2?k:g;i=(b==2?i:e)<<1;h=(b==2?h:a)<<1;b=unSign(k,32)>>>unSign(31,32)|i;i=unSign(b,32)>=unSign(d,32);var c=b-d,f=h|1,h=i?f:h,i=i?c:b,k=k<<1,j=j+1;if(j!=32)b=2;else break}e=a=h}return e}_ft_div64by32.__index__=Runtime.getFunctionIndex(_ft_div64by32,"_ft_div64by32");
function _FT_MulDiv(e,g,d){var b=STACKTOP;STACKTOP+=16;Runtime.memset(b,0,16);var a,c=null,f,h,i,k;f=b+8;e=e;g=g;d=d;c=e==0;a:do if(c)a=0;else{if(g==d){a=0;break a}e=k=e;c=0-e;e=reSign(e,32)>=reSign(0,32)?e:c;k=g^k;g=g;c=0-g;g=reSign(g,32)>=reSign(0,32)?g:c;k=d^k;d=d;c=0-d;var j=reSign(d,32)>=reSign(0,32)?d:c;d=j;var l=reSign(e,32)>reSign(46340,32);b:do if(l){c=1;a=4}else{c=reSign(g,32)>reSign(46340,32);h=d;if(c){c=3;a=4;break b}c=reSign(h,32)>reSign(176095,32);i=d;a=reSign(i,32)<=reSign(0,32);if(c|
a){c=5;a=4;break b}else c=5;e=g*e;e=(reSign(d,32)>>reSign(1,32))+e;a=d;e=Math.floor(reSign(e,32)/reSign(a,32));a=7;break b}while(0);if(a==4)if(reSign(c==5?i:c==1?j:h,32)>reSign(0,32)){_ft_multo64(e,g,b);HEAP[f+4]=0;h=reSign(d,32)>>reSign(1,32);HEAP[f]=h;e=b;g=f;f=b;h=HEAP[g]+HEAP[e];i=HEAP[e+4];g=HEAP[g+4];c=h;e=unSign(HEAP[e],32)>unSign(c,32);e=unSign(e,1);i=g+i+e;HEAP[f]=h;HEAP[f+4]=i;e=_ft_div64by32(HEAP[b+4],HEAP[b],d)}else e=2147483647;d=reSign(k,32)<reSign(0,32);k=e;k=d=d?0-k:k;a=10;break a}while(0);
if(a==0)k=e;d=k;STACKTOP=b;return d}_FT_MulDiv.__index__=Runtime.getFunctionIndex(_FT_MulDiv,"_FT_MulDiv");
function _FT_MulDiv_No_Round(e,g,d){var b=STACKTOP;STACKTOP+=8;Runtime.memset(b,0,8);var a,c=null,f,h;e=e;g=g;d=d;c=e==0;a:do if(c)a=0;else{if(g==d){a=0;break a}e=h=e;c=0-e;e=reSign(e,32)>=reSign(0,32)?e:c;h=g^h;g=g;c=0-g;g=reSign(g,32)>=reSign(0,32)?g:c;h=d^h;d=d;c=0-d;var i=reSign(d,32)>=reSign(0,32)?d:c;d=i;var k=reSign(e,32)>reSign(46340,32);b:do if(k){c=1;a=4}else{c=reSign(g,32)>reSign(46340,32);f=d;if(c){c=3;a=4;break b}else c=3;if(reSign(f,32)<=reSign(0,32)){a=6;break b}a=d;e=Math.floor(reSign(g*
e,32)/reSign(a,32));a=8;break b}while(0);b:do if(a==4){if(!(reSign(c==1?i:f,32)>reSign(0,32))){a=6;break b}_ft_multo64(e,g,b);e=_ft_div64by32(HEAP[b+4],HEAP[b],d);a=8;break b}while(0);if(a==6)e=2147483647;f=reSign(h,32)<reSign(0,32);g=e;h=f=f?0-g:g;a=12;break a}while(0);if(a==0)h=e;e=h;STACKTOP=b;return e}_FT_MulDiv_No_Round.__index__=Runtime.getFunctionIndex(_FT_MulDiv_No_Round,"_FT_MulDiv_No_Round");
function _FT_MulFix(e,g){var d,b,a,c,f;b=e;a=g;f=b==0;a:do if(f)d=0;else{if(a==65536){d=0;break a}b=c=b;d=0-b;b=reSign(b,32)>=reSign(0,32)?b:d;c=a^c;d=a;a=0-d;a=reSign(d,32)>=reSign(0,32)?d:a;f=b;a=a;var h=unSign(f,32)>unSign(2048,32);b:do if(h)d=3;else{if(unSign(a,32)>unSign(1048576,32)){d=3;break b}f=unSign(a*f+32768,32)>>>unSign(16,32);d=5;break b}while(0);if(d==3){d=f&65535;f=(unSign(f,32)>>>unSign(16,32))*a;h=(unSign(a,32)>>>unSign(16,32))*d;d=unSign((a&65535)*d+32768,32)>>>unSign(16,32);f=h+
f+d}c=reSign(c,32)<reSign(0,32);d=f;c=c=c?0-d:d;d=8;break a}while(0);if(d==0)c=b;return c}_FT_MulFix.__index__=Runtime.getFunctionIndex(_FT_MulFix,"_FT_MulFix");
function _FT_DivFix(e,g){var d=STACKTOP;STACKTOP+=16;Runtime.memset(d,0,16);var b,a,c,f;a=d+8;b=e;c=g;b=f=b;var h=0-b;b=reSign(b,32)>=reSign(0,32)?b:h;f=c^f;c=c;h=0-c;c=reSign(c,32)>=reSign(0,32)?c:h;if(c==0)c=2147483647;else{h=reSign(b,32)>>reSign(16,32)==0;var i=b;if(h){a=i*65536;a=(reSign(c,32)>>reSign(1,32))+a;c=c;c=Math.floor(unSign(a,32)/unSign(c,32))}else{h=reSign(i,32)>>reSign(16,32);HEAP[d+4]=h;HEAP[d]=b<<16;HEAP[a+4]=0;b=reSign(c,32)>>reSign(1,32);HEAP[a]=b;b=HEAP[a]+HEAP[d];h=HEAP[d+4];
a=HEAP[a+4];i=unSign(HEAP[d],32)>unSign(b,32);i=unSign(i,1);a=a+h+i;HEAP[d]=b;HEAP[d+4]=a;c=_ft_div64by32(HEAP[d+4],HEAP[d],c)}}f=reSign(f,32)<reSign(0,32);c=c;f=f?0-c:c;STACKTOP=d;return f}_FT_DivFix.__index__=Runtime.getFunctionIndex(_FT_DivFix,"_FT_DivFix");
function _FT_Matrix_Multiply(e,g){var d,b,a,c,f=e==0;a:do if(!f){if(g==0)break a;d=_FT_MulFix(HEAP[e],HEAP[g]);d=_FT_MulFix(HEAP[e+4],HEAP[g+8])+d;b=_FT_MulFix(HEAP[e],HEAP[g+4]);b=_FT_MulFix(HEAP[e+4],HEAP[g+12])+b;a=_FT_MulFix(HEAP[e+8],HEAP[g]);a=_FT_MulFix(HEAP[e+12],HEAP[g+8])+a;c=_FT_MulFix(HEAP[e+8],HEAP[g+4]);c=_FT_MulFix(HEAP[e+12],HEAP[g+12])+c;HEAP[g]=d;HEAP[g+4]=b;HEAP[g+8]=a;HEAP[g+12]=c}while(0)}_FT_Matrix_Multiply.__index__=Runtime.getFunctionIndex(_FT_Matrix_Multiply,"_FT_Matrix_Multiply");
function _FT_Matrix_Invert(e){var g,d,b;if(e==0)e=6;else{g=_FT_MulFix(HEAP[e],HEAP[e+12]);d=_FT_MulFix(HEAP[e+4],HEAP[e+8]);g=g-d;if(g==0)e=6;else{d=0-_FT_DivFix(HEAP[e+4],g);HEAP[e+4]=d;d=0-_FT_DivFix(HEAP[e+8],g);HEAP[e+8]=d;d=HEAP[e];b=HEAP[e+12];b=_FT_DivFix(b,g);HEAP[e]=b;g=_FT_DivFix(d,g);HEAP[e+12]=g;e=0}}return e}_FT_Matrix_Invert.__index__=Runtime.getFunctionIndex(_FT_Matrix_Invert,"_FT_Matrix_Invert");
function _FT_Matrix_Multiply_Scaled(e,g,d){var b,a,c,f;d=d*65536;var h=e==0;a:do if(!h){if(g==0)break a;b=_FT_MulDiv(HEAP[e],HEAP[g],d);b=_FT_MulDiv(HEAP[e+4],HEAP[g+8],d)+b;a=_FT_MulDiv(HEAP[e],HEAP[g+4],d);a=_FT_MulDiv(HEAP[e+4],HEAP[g+12],d)+a;c=_FT_MulDiv(HEAP[e+8],HEAP[g],d);c=_FT_MulDiv(HEAP[e+12],HEAP[g+8],d)+c;f=_FT_MulDiv(HEAP[e+8],HEAP[g+4],d);f=_FT_MulDiv(HEAP[e+12],HEAP[g+12],d)+f;HEAP[g]=b;HEAP[g+4]=a;HEAP[g+8]=c;HEAP[g+12]=f}while(0)}
_FT_Matrix_Multiply_Scaled.__index__=Runtime.getFunctionIndex(_FT_Matrix_Multiply_Scaled,"_FT_Matrix_Multiply_Scaled");function _FT_Vector_Transform_Scaled(e,g,d){var b,a;d=d*65536;var c=e==0;a:do if(!c){if(g==0)break a;b=_FT_MulDiv(HEAP[e],HEAP[g],d);b=_FT_MulDiv(HEAP[e+4],HEAP[g+4],d)+b;a=_FT_MulDiv(HEAP[e],HEAP[g+8],d);a=_FT_MulDiv(HEAP[e+4],HEAP[g+12],d)+a;HEAP[e]=b;HEAP[e+4]=a}while(0)}_FT_Vector_Transform_Scaled.__index__=Runtime.getFunctionIndex(_FT_Vector_Transform_Scaled,"_FT_Vector_Transform_Scaled");
function _FT_SqrtFixed(e){var g=null,d;d=0;if(reSign(e,32)>reSign(0,32)){d=d;for(g=0;;){i=g==1?i:0;f=g==1?f:d;b=g==1?b:e;h=(g==1?h:0)<<2;h=unSign(b,32)>>>unSign(30,32)|h;var b=b<<2;f=f<<1;var a=f*2+1;g=unSign(h,32)>=unSign(a,32);a=h-a;var c=f+1,f=g?c:f,h=g?a:h,i=i+1;if(i!=24)g=1;else break}d=f}return d}_FT_SqrtFixed.__index__=Runtime.getFunctionIndex(_FT_SqrtFixed,"_FT_SqrtFixed");
function _ft_corner_orientation(e,g,d,b){var a=STACKTOP;STACKTOP+=16;Runtime.memset(a,0,16);var c;c=a+8;if(g==0)c=reSign(e,32)>=reSign(0,32)?b:0-b;else if(e==0)c=reSign(g,32)>=reSign(0,32)?0-d:d;else if(b==0)c=reSign(d,32)>=reSign(0,32)?g:0-g;else if(d==0)c=reSign(b,32)>=reSign(0,32)?0-e:e;else{_ft_multo64(e,b,a);_ft_multo64(g,d,c);e=HEAP[c+4];if(unSign(HEAP[a+4],32)>unSign(e,32))c=1;else{e=HEAP[c+4];if(unSign(HEAP[a+4],32)<unSign(e,32))c=-1;else{e=HEAP[c];if(unSign(HEAP[a],32)>unSign(e,32))c=1;else{c=
HEAP[c];c=unSign(HEAP[a],32)<unSign(c,32)?-1:0}}}}c=c;STACKTOP=a;return c}_ft_corner_orientation.__index__=Runtime.getFunctionIndex(_ft_corner_orientation,"_ft_corner_orientation");
function _ft_corner_is_flat(e,g,d,b){var a=null,c,f,h;c=e;f=g;if(reSign(c,32)<reSign(0,32)){c=0-c;h=f;a=0}else a=-1;if(reSign(a==0?h:g,32)<reSign(0,32))f=0-f;a=f+c;c=d;if(reSign(d,32)<reSign(0,32))c=0-c;f=b;if(reSign(b,32)<reSign(0,32))f=0-f;h=f+c;c=f=e+d;if(reSign(f,32)<reSign(0,32))c=0-c;f=g=g+b;if(reSign(g,32)<reSign(0,32))f=0-f;c=f+c;g=h+a+(0-c);c=reSign(c,32)>>reSign(4,32);c=reSign(g,32)<reSign(c,32);return unSign(c,1)}
_ft_corner_is_flat.__index__=Runtime.getFunctionIndex(_ft_corner_is_flat,"_ft_corner_is_flat");function _FT_GlyphLoader_New(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b;b=_ft_mem_alloc(e,96,d);if(HEAP[d]==0){HEAP[b]=e;HEAP[g]=b}b=HEAP[d];STACKTOP=d;return b}_FT_GlyphLoader_New.__index__=Runtime.getFunctionIndex(_FT_GlyphLoader_New,"_FT_GlyphLoader_New");function _FT_GlyphLoader_Rewind(e){var g;g=e+20;e=e+56;HEAP[g+2]=0;HEAP[g]=0;HEAP[g+28]=0;_llvm_memcpy_p0i8_p0i8_i32(e,g,36,4,0)}
_FT_GlyphLoader_Rewind.__index__=Runtime.getFunctionIndex(_FT_GlyphLoader_Rewind,"_FT_GlyphLoader_Rewind");
function _FT_GlyphLoader_Reset(e){var g,d;g=HEAP[e];d=HEAP[e+20+4];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+20+4]=0;d=HEAP[e+20+8];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+20+8]=0;d=HEAP[e+20+12];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+20+12]=0;d=HEAP[e+20+20];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+20+20]=0;d=HEAP[e+20+32];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+20+32]=0;HEAP[e+20+24]=0;HEAP[e+4]=0;HEAP[e+8]=0;HEAP[e+12]=0;g=e+20;e=e+56;HEAP[g+2]=0;HEAP[g]=0;HEAP[g+28]=0;_llvm_memcpy_p0i8_p0i8_i32(e,
g,36,4,0)}_FT_GlyphLoader_Reset.__index__=Runtime.getFunctionIndex(_FT_GlyphLoader_Reset,"_FT_GlyphLoader_Reset");function _FT_GlyphLoader_Done(e){var g,d,b=e!=0;a:do if(b){g=HEAP[e];_FT_GlyphLoader_Reset(e);d=e;g=g;d=d;if(d==0)break a;FUNCTION_TABLE[HEAP[g+8]](g,d)}while(0)}_FT_GlyphLoader_Done.__index__=Runtime.getFunctionIndex(_FT_GlyphLoader_Done,"_FT_GlyphLoader_Done");
function _FT_GlyphLoader_Adjust_Points(e){var g,d;g=e+20;d=e+56;var b=HEAP[g+4],a=reSign(HEAP[g+2],16);HEAP[d+4]=b+8*a;b=HEAP[g+8];a=reSign(HEAP[g+2],16);HEAP[d+8]=b+a;b=HEAP[g+12];a=reSign(HEAP[g],16);HEAP[d+12]=b+2*a;if(HEAP[e+16]!=0){d=HEAP[e+20+20];b=reSign(HEAP[g+2],16);HEAP[e+56+20]=d+8*b;d=HEAP[e+20+24];g=reSign(HEAP[g+2],16);HEAP[e+56+24]=d+8*g}}_FT_GlyphLoader_Adjust_Points.__index__=Runtime.getFunctionIndex(_FT_GlyphLoader_Adjust_Points,"_FT_GlyphLoader_Adjust_Points");
function _FT_GlyphLoader_CreateExtra(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d=_ft_mem_realloc(HEAP[e],8,0,HEAP[e+4]*2,0,g);HEAP[e+20+20]=d;if(HEAP[g]==0){HEAP[e+16]=1;HEAP[e+20+24]=HEAP[e+20+20]+8*HEAP[e+4];_FT_GlyphLoader_Adjust_Points(e)}e=HEAP[g];STACKTOP=g;return e}_FT_GlyphLoader_CreateExtra.__index__=Runtime.getFunctionIndex(_FT_GlyphLoader_CreateExtra,"_FT_GlyphLoader_CreateExtra");
function _FT_GlyphLoader_CheckPoints(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c,f,h,i,k,j;f=HEAP[e];HEAP[b]=0;h=e+20;i=e+56;k=0;j=reSign(HEAP[h+2],16);a=reSign(HEAP[i+2],16);j=g+j+a;a=g=HEAP[e+4];var l=unSign(j,32)>unSign(a,32);a:do if(l){j=j+7&-8;if(unSign(j,32)>unSign(32767,32)){c=10;a=0}else{a=_ft_mem_realloc(f,8,g,j,HEAP[h+4],b);HEAP[h+4]=a;if(HEAP[b]!=0){a=1;break a}a=_ft_mem_realloc(f,1,g,j,HEAP[h+8],b);HEAP[h+8]=a;if(HEAP[b]!=0){a=1;break a}if(HEAP[e+16]!=0){a=_ft_mem_realloc(f,
8,g*2,j*2,HEAP[e+20+20],b);HEAP[e+20+20]=a;if(HEAP[b]!=0){a=1;break a}_llvm_memmove_p0i8_p0i8_i32(HEAP[e+20+20]+8*j,HEAP[e+20+20]+8*g,g*8,1,0);HEAP[e+20+24]=HEAP[e+20+20]+8*j}k=1;HEAP[e+4]=j;a=6}break a}else a=6;while(0);a:do if(a==6){g=HEAP[e+8];j=reSign(HEAP[h],16);i=reSign(HEAP[i],16);j=d+j+i;d=g;if(unSign(j,32)>unSign(d,32)){j=j+3&-4;if(unSign(j,32)>unSign(32767,32)){c=10;a=0;break a}else{f=_ft_mem_realloc(f,2,g,j,HEAP[h+12],b);HEAP[h+12]=f;if(HEAP[b]!=0){a=1;break a}k=1;HEAP[e+8]=j}}if(k==0){a=
1;break a}_FT_GlyphLoader_Adjust_Points(e);a=1;break a}while(0);if(a==1)c=HEAP[b];e=c;STACKTOP=b;return e}_FT_GlyphLoader_CheckPoints.__index__=Runtime.getFunctionIndex(_FT_GlyphLoader_CheckPoints,"_FT_GlyphLoader_CheckPoints");
function _FT_GlyphLoader_CheckSubGlyphs(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a,c,f,h,i;c=HEAP[e];HEAP[d]=0;i=e+20;f=HEAP[e+56+28]+HEAP[i+28]+g;h=HEAP[e+12];var k=unSign(f,32)>unSign(h,32);a:do if(k){f=f+1&-2;a=_ft_mem_realloc(c,32,h,f,HEAP[i+32],d);HEAP[i+32]=a;if(HEAP[d]!=0)break a;HEAP[e+12]=f;b=e;a=b+20;b=b+56;HEAP[b+32]=HEAP[a+32]+32*HEAP[a+28]}while(0);c=HEAP[d];STACKTOP=d;return c}
_FT_GlyphLoader_CheckSubGlyphs.__index__=Runtime.getFunctionIndex(_FT_GlyphLoader_CheckSubGlyphs,"_FT_GlyphLoader_CheckSubGlyphs");function _FT_GlyphLoader_Prepare(e){var g;g=e+56;HEAP[g+2]=0;HEAP[g]=0;HEAP[g+28]=0;_FT_GlyphLoader_Adjust_Points(e);g=e+20;HEAP[e+56+32]=HEAP[g+32]+32*HEAP[g+28]}_FT_GlyphLoader_Prepare.__index__=Runtime.getFunctionIndex(_FT_GlyphLoader_Prepare,"_FT_GlyphLoader_Prepare");
function _FT_GlyphLoader_Add(e){var g=null,d,b,a,c;if(e!=0){d=e+20;b=e+56;a=reSign(HEAP[b],16);c=reSign(HEAP[d+2],16);HEAP[d+2]=HEAP[b+2]+HEAP[d+2];HEAP[d]=HEAP[b]+HEAP[d];HEAP[d+28]=HEAP[b+28]+HEAP[d+28];if(unSign(0,32)<unSign(a,32)){d=b+12;b=b+12;c=c&65535;a=(unSign(a,32)>unSign(1,32)?a:1)-0;for(g=0;;){f=g==0?0:f;g=0+f;HEAP[HEAP[d]+2*g]=c+HEAP[HEAP[b]+2*g];var f=f+1;if(f!=a)g=1;else break}}d=e+56;HEAP[d+2]=0;HEAP[d]=0;HEAP[d+28]=0;_FT_GlyphLoader_Adjust_Points(e);d=e+20;e=e+56;HEAP[e+32]=HEAP[d+
32]+32*HEAP[d+28]}}_FT_GlyphLoader_Add.__index__=Runtime.getFunctionIndex(_FT_GlyphLoader_Add,"_FT_GlyphLoader_Add");
function _FT_GlyphLoader_CopyPoints(e,g){var d,b,a,c,f;b=reSign(HEAP[g+20+2],16);a=reSign(HEAP[g+20],16);d=_FT_GlyphLoader_CheckPoints(e,b,a);if(d==0){c=e+20;f=g+20;_llvm_memcpy_p0i8_p0i8_i32(HEAP[c+4],HEAP[f+4],b*8,1,0);_llvm_memcpy_p0i8_p0i8_i32(HEAP[c+8],HEAP[f+8],b,1,0);_llvm_memcpy_p0i8_p0i8_i32(HEAP[c+12],HEAP[f+12],a*2,1,0);f=HEAP[e+16]!=0;a:do if(f){if(HEAP[g+16]==0)break a;_llvm_memcpy_p0i8_p0i8_i32(HEAP[e+20+20],HEAP[g+20+20],b*8,1,0);_llvm_memcpy_p0i8_p0i8_i32(HEAP[e+20+24],HEAP[g+20+24],
b*8,1,0)}while(0);HEAP[c+2]=b&65535;HEAP[c]=a&65535;_FT_GlyphLoader_Adjust_Points(e)}return d}_FT_GlyphLoader_CopyPoints.__index__=Runtime.getFunctionIndex(_FT_GlyphLoader_CopyPoints,"_FT_GlyphLoader_CopyPoints");
function _ft_service_list_lookup(e,g){var d,b=null,a,c;a=0;c=e;var f=c!=0;a:do if(f){if(g==0)break a;var h=g,i=c;for(b=0;;){d=b==0?0:j;var k=i+8*d;b=k;if(HEAP[b]==0){d=7;break}if(_strcmp(HEAP[b],h)==0){d=3;break}var j=d+1;b=4;d=2}if(d==7)c=k;else if(d==3){c=k;a=HEAP[k+4]}}while(0);return a}_ft_service_list_lookup.__index__=Runtime.getFunctionIndex(_ft_service_list_lookup,"_ft_service_list_lookup");function _ft_validator_init(e,g,d,b){HEAP[e]=g;HEAP[e+4]=d;HEAP[e+8]=b;HEAP[e+12]=0}
_ft_validator_init.__index__=Runtime.getFunctionIndex(_ft_validator_init,"_ft_validator_init");function _ft_validator_run(){return-1}_ft_validator_run.__index__=Runtime.getFunctionIndex(_ft_validator_run,"_ft_validator_run");function _ft_validator_error(e,g){var d;d=e+16;HEAP[e+12]=g;_longjmp(d,1);throw"Reached an unreachable! Original .ll line: 5389";}_ft_validator_error.__index__=Runtime.getFunctionIndex(_ft_validator_error,"_ft_validator_error");
function _FT_Stream_New(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c,f;HEAP[d]=0;if(e==0)d=33;else if(g==0)d=6;else{e=HEAP[e];c=_ft_mem_alloc(e,40,b);if(HEAP[b]==0){HEAP[c+28]=e;f=(HEAP[g]&1&255)!=0;a:do{if(f){a=HEAP[g+8];f=HEAP[g+4];g=c;f=f;a=a;HEAP[g]=f;HEAP[g+4]=a;HEAP[g+8]=0;HEAP[g+32]=0;HEAP[g+20]=0;HEAP[g+24]=0;a=1}else{a=g;if((HEAP[g]&4)!=0){a=_FT_Stream_Open(c,HEAP[a+12]);HEAP[b]=a;HEAP[c+16]=HEAP[g+12];a=1}else{a=(HEAP[a]&2)==0;b:do if(!a){if(HEAP[g+16]==0)break b;a=c;
c=e;a=a;a!=0&&FUNCTION_TABLE[HEAP[c+8]](c,a);c=HEAP[g+16];a=1;break a}while(0);HEAP[b]=6;a=5}}break a}while(0);a:do if(a==1){if(HEAP[b]!=0){a=5;break a}HEAP[c+28]=e;a=9;break a}while(0);if(a==5){g=c;g!=0&&FUNCTION_TABLE[HEAP[e+8]](e,g);c=0}HEAP[d]=c}d=HEAP[b]}d=d;STACKTOP=b;return d}_FT_Stream_New.__index__=Runtime.getFunctionIndex(_FT_Stream_New,"_FT_Stream_New");
function _FT_Stream_Free(e,g){var d,b,a=e!=0;a:do if(a){d=HEAP[e+28];b=e;var c=b!=0;b:do if(c){if(HEAP[b+24]==0)break b;FUNCTION_TABLE[HEAP[b+24]](b)}while(0);if(g!=0)break a;b=e;d=d;b=b;if(b==0)break a;FUNCTION_TABLE[HEAP[d+8]](d,b)}while(0)}_FT_Stream_Free.__index__=Runtime.getFunctionIndex(_FT_Stream_Free,"_FT_Stream_Free");
function _ft_glyphslot_free_bitmap(e){var g,d;g=HEAP[e+156]==0;a:do if(!g){if(unSign((HEAP[HEAP[e+156]+4]&1&255)!=0^1,1)!=0)break a;g=HEAP[HEAP[e+4]+100];d=HEAP[e+76+12];g=g;d=d;d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+76+12]=0;HEAP[HEAP[e+156]+4]&=-2;return}while(0);HEAP[e+76+12]=0}_ft_glyphslot_free_bitmap.__index__=Runtime.getFunctionIndex(_ft_glyphslot_free_bitmap,"_ft_glyphslot_free_bitmap");function _ft_glyphslot_set_bitmap(e,g){_ft_glyphslot_free_bitmap(e);HEAP[e+76+12]=g}
_ft_glyphslot_set_bitmap.__index__=Runtime.getFunctionIndex(_ft_glyphslot_set_bitmap,"_ft_glyphslot_set_bitmap");function _ft_glyphslot_alloc_bitmap(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a;a=HEAP[HEAP[e+4]+100];if((HEAP[HEAP[e+156]+4]&1&255)!=0){b=HEAP[e+76+12];b!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[e+76+12]=0}else HEAP[HEAP[e+156]+4]|=1;b=_ft_mem_alloc(a,g,d);HEAP[e+76+12]=b;b=HEAP[d];STACKTOP=d;return b}
_ft_glyphslot_alloc_bitmap.__index__=Runtime.getFunctionIndex(_ft_glyphslot_alloc_bitmap,"_ft_glyphslot_alloc_bitmap");
function _ft_glyphslot_done(e){var g,d,b,a,c;b=HEAP[HEAP[e+4]+96];a=HEAP[b+20];c=HEAP[b+8];HEAP[a+68]!=0&&FUNCTION_TABLE[HEAP[a+68]](e);_ft_glyphslot_free_bitmap(e);if(HEAP[e+156]!=0){if((HEAP[HEAP[b]]&512)==0){b=HEAP[HEAP[e+156]];a=b!=0;a:do if(a){g=HEAP[b];_FT_GlyphLoader_Reset(b);d=b;g=g;d=d;if(d==0)break a;FUNCTION_TABLE[HEAP[g+8]](g,d)}while(0);HEAP[HEAP[e+156]]=0}b=HEAP[e+156];b!=0&&FUNCTION_TABLE[HEAP[c+8]](c,b);HEAP[e+156]=0}}
_ft_glyphslot_done.__index__=Runtime.getFunctionIndex(_ft_glyphslot_done,"_ft_glyphslot_done");
function _FT_New_GlyphSlot(e,g){var d=STACKTOP;STACKTOP+=12;Runtime.memset(d,0,12);var b,a=null,c,f,h,i,k=d+4,j,l,m=d+8,o;o=e==0;a:do if(o)b=0;else{if(HEAP[e+96]==0){b=0;break a}l=HEAP[e+96];o=HEAP[l+20];l=HEAP[l+8];c=_ft_mem_alloc(l,HEAP[o+44],m);o=HEAP[m]==0;b:do if(o){HEAP[c+4]=e;f=c;a=HEAP[HEAP[f+4]+96];i=HEAP[a+20];b=HEAP[a+8];HEAP[k]=0;HEAP[f]=HEAP[a+4];j=_ft_mem_alloc(b,40,k);var n=HEAP[k],p=n!=0;c:do if(p)HEAP[m]=n;else{HEAP[f+156]=j;if((HEAP[HEAP[a]]&512)==0){a=j;h=b;b=a;a=_ft_mem_alloc(h,
96,d);if(HEAP[d]==0){HEAP[a]=h;HEAP[b]=a}h=h=h=HEAP[d];HEAP[k]=h;a=5}else{var r=HEAP[k];a=7}j=(a==7?r:h)==0;d:do if(j){if(HEAP[i+64]==0){b=9;break d}var q=FUNCTION_TABLE[HEAP[i+64]](f);HEAP[k]=q;a=8;b=10;break d}else b=9;while(0);if(b==9){var s=HEAP[k];a=9}f=a==9?s:q;HEAP[m]=f;if(f!=0)break c;HEAP[c+8]=HEAP[e+84];HEAP[e+84]=c;if(g==0)break b;HEAP[g]=c;break b}while(0);_ft_glyphslot_done(c);i=c;c=l;f=i;i!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);c=0}else{if(g==0)break b;HEAP[g]=0}while(0);l=HEAP[m];b=19;
break a}while(0);if(b==0)l=6;k=l;STACKTOP=d;return k}_FT_New_GlyphSlot.__index__=Runtime.getFunctionIndex(_FT_New_GlyphSlot,"_FT_New_GlyphSlot");
function _FT_Done_GlyphSlot(e){var g,d=null,b,a,c,f=e!=0;a:do if(f){b=HEAP[HEAP[e+4]+96];b=HEAP[b+8];c=0;d=a=HEAP[HEAP[e+4]+84];var h=e,i=d;for(d=0;;){var k=d==3?j:i;if((d==3?j:a)==0){g=8;break}if(k==h){g=2;break}c=k;var j=HEAP[k+8];d=3;g=1}if(g!=8)if(g==2){d=k;if(c==0)HEAP[HEAP[e+4]+84]=HEAP[d+8];else HEAP[c+8]=HEAP[d+8];_ft_glyphslot_done(e);c=e;b=b;a=c;if(c==0)break a;FUNCTION_TABLE[HEAP[b+8]](b,a)}}while(0)}_FT_Done_GlyphSlot.__index__=Runtime.getFunctionIndex(_FT_Done_GlyphSlot,"_FT_Done_GlyphSlot");
function _FT_Set_Transform(e,g,d){var b=STACKTOP;STACKTOP+=8;Runtime.memset(b,0,8);var a;g=g;d=d;a=e==0;a:do if(!a){e=HEAP[e+128];HEAP[e+28]=0;a=e+4;if(g==0){HEAP[a]=65536;HEAP[e+4+4]=0;HEAP[e+4+8]=0;HEAP[e+4+12]=65536;g=e+4}else{var c=g;HEAP[a]=HEAP[c];HEAP[a+4]=HEAP[c+4];HEAP[a+8]=HEAP[c+8];HEAP[a+12]=HEAP[c+12]}c=(HEAP[g+8]|HEAP[g+4])!=0;b:do if(c)a=1;else{if(HEAP[g]!=65536){a=1;break b}a=HEAP[g+12]!=65536?1:3;break b}while(0);if(a==1)HEAP[e+28]|=1;if(d==0){HEAP[e+20]=0;HEAP[e+20+4]=0;d=e+20}else{g=
d;HEAP[b]=HEAP[g];HEAP[b+4]=HEAP[g+4];g=e+20;HEAP[g]=HEAP[b];HEAP[g+4]=HEAP[b+4]}if((HEAP[d+4]|HEAP[d])==0)break a;HEAP[e+28]|=2;STACKTOP=b;return}while(0);STACKTOP=b}_FT_Set_Transform.__index__=Runtime.getFunctionIndex(_FT_Set_Transform,"_FT_Set_Transform");
function _FT_Load_Glyph(e,g,d){var b,a=null,c,f,h,i,k,j,l,m,o;d=d;l=0;m=e==0;a:do if(m)b=0;else{if(HEAP[e+88]==0){b=0;break a}if(HEAP[e+84]==0){b=0;break a}m=o=HEAP[e+84];_ft_glyphslot_free_bitmap(m);_llvm_memset_p0i8_i32(m+24,0,32,1,0);_llvm_memset_p0i8_i32(m+108,0,20,1,0);HEAP[m+76+4]=0;HEAP[m+76]=0;HEAP[m+76+8]=0;HEAP[m+76+18]=0;HEAP[m+100]=0;HEAP[m+104]=0;HEAP[m+128]=0;HEAP[m+132]=0;HEAP[m+136]=0;HEAP[m+140]=0;HEAP[m+152]=0;HEAP[m+72]=0;HEAP[m+56]=0;HEAP[m+60]=0;HEAP[m+144]=0;HEAP[m+148]=0;h=
HEAP[e+96];m=HEAP[h+4];m=HEAP[m+168];if((d&1024)!=0)d|=2049;if((d&1&255)!=0){d|=10;d&=-5}i=m!=0;b:do if(i){if((d&2)!=0){b=7;break b}if((d&32768)!=0){b=7;break b}if((HEAP[HEAP[h]]&256)==0){b=7;break b}if((HEAP[HEAP[h]]&512)!=0){b=7;break b}if((HEAP[e+8]&8192)!=0){b=7;break b}i=HEAP[HEAP[e+128]+4+8]!=0;c:do if(i)b=13;else{b=HEAP[HEAP[e+128]+4]!=0?12:13;break c}while(0);if(b==13){if(HEAP[HEAP[e+128]+4]!=0){b=7;break b}if(HEAP[HEAP[e+128]+4+8]==0){b=7;break b}}b=(d&32)!=0;c:do if(!b){if((HEAP[HEAP[h]]&
1024)==0)break c;b=reSign(d,32)>>reSign(16,32)&15;if(b!=1)if(HEAP[HEAP[e+128]+56]==0){b=7;break b}l=1;b=18;break b}while(0);l=1;b=18;break b}else b=7;while(0);b:do if(b==7){if(l!=0){b=18;break b}c=FUNCTION_TABLE[HEAP[HEAP[h+20]+80]](o,HEAP[e+88],g,d);if(c!=0){b=26;break b}if(HEAP[o+72]!=1869968492){b=24;break b}c=_FT_Outline_Check(o+108);if(c!=0){b=26;break b}if((d&2)!=0){b=24;break b}l=unSign(d&255,8)&16&255;b=o;l=l;i=b=b+24;if(l!=0){HEAP[b+8]=HEAP[i+8]&-64;HEAP[b+12]=HEAP[b+12]+63&-64;l=HEAP[b+
20]+63+HEAP[b]&-64;i=HEAP[b+24]+63+HEAP[b+4]&-64;HEAP[b+20]&=-64;HEAP[b+24]&=-64;HEAP[b]=l-HEAP[b+20];HEAP[b+4]=i-HEAP[b+24]}else{HEAP[b+20]=HEAP[i+20]&-64;HEAP[b+24]&=-64;l=HEAP[b+8]+63+HEAP[b]&-64;i=HEAP[b+12]-HEAP[b+4]&-64;HEAP[b+8]&=-64;HEAP[b+12]=HEAP[b+12]+63&-64;HEAP[b]=l-HEAP[b+8];HEAP[b+4]=HEAP[b+12]-i}HEAP[b+16]=HEAP[b+16]+32&-64;HEAP[b+28]=HEAP[b+28]+32&-64;b=24;break b}while(0);b:do if(b==18){b=(HEAP[e+8]&2)!=0;c:do if(b){if((d&8)!=0)break c;c=FUNCTION_TABLE[HEAP[HEAP[h+20]+80]](o,HEAP[e+
88],g,d|16384);if(c!=0)break c;if(HEAP[o+72]==1651078259){b=24;break b}}while(0);b=HEAP[e+128];h=HEAP[b+28];HEAP[b+28]=0;c=HEAP[HEAP[m]+20];c=FUNCTION_TABLE[HEAP[c+12]](m,o,HEAP[e+88],g,d);HEAP[b+28]=h;b=24;break b}while(0);b:do if(b==24){g=o;if((d&16)!=0){HEAP[g+64]=0;HEAP[o+64+4]=HEAP[o+24+28]}else{HEAP[o+64]=HEAP[g+24+16];HEAP[o+64+4]=0}g=(d&8192)==0;c:do if(g){if((HEAP[e+8]&1&255)==0)break c;m=HEAP[e+88]+12;b=_FT_MulDiv(HEAP[o+56],HEAP[m+4],64);HEAP[o+56]=b;m=_FT_MulDiv(HEAP[o+60],HEAP[m+8],64);
HEAP[o+60]=m}while(0);m=(d&2048)==0;c:do if(m){g=HEAP[e+128];if(HEAP[g+28]==0)break c;h=o;b=HEAP[h+4];l=HEAP[HEAP[b+96]+4];i=HEAP[l+164];var n=i==0;d:do if(n)b=38;else{if(HEAP[i+24]!=HEAP[h+72]){b=38;break d}var p=i;a=39;b=41;break d}while(0);if(b==38){var r=_FT_Lookup_Renderer(l,HEAP[h+72],0);a=38}b=h=a==39?p:r;l=h!=0;d:do if(l)c=FUNCTION_TABLE[HEAP[HEAP[b+20]+44]](b,o,g+4,g+20);else{if(HEAP[o+72]!=1869968492)break d;i=g+4;h=o+108;i=i;n=h==0;e:do if(!n){if(i==0)break e;k=HEAP[h+4];var q=reSign(HEAP[h+
2],16);j=k+8*q;if(!(k<j))break e;q=i;j=j;k=k;for(a=47;;){s=a==47?0:s;a=k+8*(s+1);_FT_Vector_Transform(k+8*s,q);var s=s+1;if(a<j)a=48;else{a=48;break}}}while(0);_FT_Outline_Translate(o+108,HEAP[g+20],HEAP[g+20+4])}while(0);_FT_Vector_Transform(o+64,g+4)}while(0);if(c!=0)break b;if(HEAP[o+72]==1651078259)break b;if(HEAP[o+72]==1668246896)break b;if((d&4)==0)break b;c=reSign(d,32)>>reSign(16,32)&15;g=c==0;c:do if(g){if((d&4096)==0)break c;c=2}while(0);m=o;g=c;c=m;g=g;m=m==0;c:do if(m)b=59;else{if(HEAP[c+
4]==0){b=59;break c}f=HEAP[HEAP[HEAP[c+4]+96]+4];f=_FT_Render_Glyph_Internal(f,c,g);b=62;break c}while(0);if(b==59)f=6;c=c=f}while(0);o=c;b=64;break a}while(0);if(b==0)o=35;return o}_FT_Load_Glyph.__index__=Runtime.getFunctionIndex(_FT_Load_Glyph,"_FT_Load_Glyph");function _FT_Load_Char(e,g,d){var b,a;if(e==0)e=35;else{a=g;if(HEAP[e+92]!=0){b=0;a=e!=0;a:do if(a){if(HEAP[e+92]==0)break a;b=HEAP[e+92];b=FUNCTION_TABLE[HEAP[HEAP[b+12]+12]](b,g)}while(0);a=g=b}e=_FT_Load_Glyph(e,a,d)}return e}
_FT_Load_Char.__index__=Runtime.getFunctionIndex(_FT_Load_Char,"_FT_Load_Char");function _destroy_size(e,g,d){HEAP[g+4+4]!=0&&FUNCTION_TABLE[HEAP[g+4+4]](g);HEAP[HEAP[d+20]+60]!=0&&FUNCTION_TABLE[HEAP[HEAP[d+20]+60]](g);d=HEAP[g+40];d!=0&&FUNCTION_TABLE[HEAP[e+8]](e,d);HEAP[g+40]=0;g!=0&&FUNCTION_TABLE[HEAP[e+8]](e,g)}_destroy_size.__index__=Runtime.getFunctionIndex(_destroy_size,"_destroy_size");
function _destroy_charmaps(e,g){var d=null;if(e!=0){var b=reSign(HEAP[e+36],32)>reSign(0,32),a=HEAP[e+40];if(b){b=e+40;var c=e+36,f=e+40;for(d=0;;){l=d==0?0:l;var h=0+l,i=1+l;d=HEAP[(d==0?a:j)+4*h];var k=HEAP[d+12];j=HEAP[HEAP[d]+100];HEAP[k+8]!=0&&FUNCTION_TABLE[HEAP[k+8]](d);d=d;d!=0&&FUNCTION_TABLE[HEAP[j+8]](j,d);HEAP[HEAP[b]+4*h]=0;h=reSign(HEAP[c],32)>reSign(i,32);var j=HEAP[f],l=l+1;if(h)d=4;else break}d=5}else d=9;a=d==5?j:a;a!=0&&FUNCTION_TABLE[HEAP[g+8]](g,a);HEAP[e+40]=0;HEAP[e+36]=0}}
_destroy_charmaps.__index__=Runtime.getFunctionIndex(_destroy_charmaps,"_destroy_charmaps");
function _destroy_face(e,g,d){var b,a=null,c;c=HEAP[d+20];HEAP[g+116+4]!=0&&FUNCTION_TABLE[HEAP[g+116+4]](HEAP[g+116]);if(HEAP[g+84]!=0){a=1;b=2}else{a=1;b=3}for(;;)if(b==2){_FT_Done_GlyphSlot(HEAP[(a==2?f:g)+84]);var f=g;if(HEAP[g+84]!=0)b=a=2;else{a=2;b=3}}else if(b==3){_FT_List_Finalize((a==1?g:f)+108,_destroy_size.__index__,e,d);HEAP[g+88]=0;b=HEAP[g+44+4]!=0?4:5;break}b==4&&FUNCTION_TABLE[HEAP[g+44+4]](g);_destroy_charmaps(g,e);HEAP[c+52]!=0&&FUNCTION_TABLE[HEAP[c+52]](g);d=unSign((HEAP[g+8]&
1024)!=0,1);_FT_Stream_Free(HEAP[g+104],d);HEAP[g+104]=0;if(HEAP[g+128]!=0){d=HEAP[g+128];d!=0&&FUNCTION_TABLE[HEAP[e+8]](e,d);HEAP[g+128]=0}g!=0&&FUNCTION_TABLE[HEAP[e+8]](e,g)}_destroy_face.__index__=Runtime.getFunctionIndex(_destroy_face,"_destroy_face");
function _find_unicode_charmap(e){var g,d=null,b,a,c;a=HEAP[e+40];if(a==0)b=38;else{c=c=a+4*HEAP[e+36];d=1;a:for(;;){d=d==3?i:0;var f=c+4*(d*-1+-1);if(!(f>=a)){g=11;break a}i=HEAP[HEAP[f]+4]==1970170211;b:do if(i){var h=HEAP[HEAP[f]+8]!=3;c:do if(h)g=5;else{g=HEAP[HEAP[f]+10]==10?4:5;break c}while(0);if(g==5){if(HEAP[HEAP[f]+8]!=0)break b;if(HEAP[HEAP[f]+10]!=4)break b}if(!(reSign(f-a,32)>reSign(63,32))){g=9;break a}}while(0);var i=d+1;d=3;g=2}if(g==11){f=c=a+4*HEAP[e+36];for(d=11;;){g=d==13?j:0;
var k=f+4*(g*-1+-1);if(!(k>=a)){g=17;break}if(HEAP[HEAP[k]+4]==1970170211)if(!(reSign(k-a,32)>reSign(63,32))){g=15;break}var j=g+1;d=13;g=12}if(g==17)b=38;else if(g==15){c=k;HEAP[e+92]=HEAP[c];b=0}}else if(g==9){c=f;HEAP[e+92]=HEAP[c];b=0}}return b}_find_unicode_charmap.__index__=Runtime.getFunctionIndex(_find_unicode_charmap,"_find_unicode_charmap");
function _find_variant_selector_charmap(e){var g,d=null,b,a,c;a=HEAP[e+40];if(a==0)b=0;else{e=a+4*HEAP[e+36];c=c=a;d=1;a:for(;;){g=d==4?h:0;var f=c+4*g;if(!(f<e)){g=9;break a}h=HEAP[HEAP[f]+8]==0;b:do if(h){if(HEAP[HEAP[f]+10]!=5)break b;if(_FT_Get_CMap_Format(HEAP[f])!=14)break b;if(!(reSign(f-a,32)>reSign(63,32))){g=7;break a}}while(0);var h=g+1;d=4;g=2}if(g==9)b=0;else if(g==7){c=f;b=HEAP[c]}}return b}
_find_variant_selector_charmap.__index__=Runtime.getFunctionIndex(_find_variant_selector_charmap,"_find_variant_selector_charmap");
function _open_face(e,g,d,b,a,c){var f=STACKTOP;STACKTOP+=4;Runtime.memset(f,0,4);var h,i=null,k,j,l,m;m=0;j=HEAP[e+20];k=HEAP[e+8];l=_ft_mem_alloc(k,HEAP[j+36],f);i=HEAP[f]!=0;a:do if(i)h=0;else{m=_ft_mem_alloc(k,64,f);if(HEAP[f]!=0){h=0;break a}HEAP[l+128]=m;HEAP[l+96]=e;HEAP[l+100]=k;HEAP[l+104]=g;HEAP[HEAP[l+128]+52]=0;h=b;e=l+128;var o=a,n=l+128,p=a;i=1;b:for(;;){i=i==4?s:0;s=0+i;var r=o+8*s,q=p+8*s+4;if(reSign(s,32)>=reSign(h,32))break b;if(HEAP[HEAP[e]+52]!=0)break b;if(HEAP[r]==1768842098)HEAP[HEAP[n]+
52]=HEAP[q];var s=i+1;i=4}if(HEAP[j+48]!=0){var u=FUNCTION_TABLE[HEAP[j+48]](g,l,d,b,a);HEAP[f]=u;i=8}else{var t=HEAP[f];i=10}g=(i==10?t:u)!=0;b:do if(g)h=13;else{g=_find_unicode_charmap(l);if(g!=0&g!=38){var v=g;HEAP[f]=v;i=11;h=12}else{HEAP[c]=l;h=13}break b}while(0);if(h==13){var w=HEAP[f];i=13}h=(i==13?w:v)!=0?0:15;break a}while(0);if(h==0){_destroy_charmaps(l,k);HEAP[j+52]!=0&&FUNCTION_TABLE[HEAP[j+52]](l);j=m;j!=0&&FUNCTION_TABLE[HEAP[k+8]](k,j);l!=0&&FUNCTION_TABLE[HEAP[k+8]](k,l);HEAP[c]=
0}c=HEAP[f];STACKTOP=f;return c}_open_face.__index__=Runtime.getFunctionIndex(_open_face,"_open_face");function _FT_New_Face(e,g,d,b){var a=STACKTOP;STACKTOP+=32;Runtime.memset(a,0,32);if(g==0)e=6;else{HEAP[a]=4;HEAP[a+12]=g;HEAP[a+16]=0;e=_FT_Open_Face(e,a,d,b)}e=e;STACKTOP=a;return e}_FT_New_Face.__index__=Runtime.getFunctionIndex(_FT_New_Face,"_FT_New_Face");
function _FT_New_Memory_Face(e,g,d,b,a){var c=STACKTOP;STACKTOP+=32;Runtime.memset(c,0,32);if(g==0)e=6;else{HEAP[c]=1;HEAP[c+4]=g;HEAP[c+8]=d;HEAP[c+16]=0;e=_FT_Open_Face(e,c,b,a)}e=e;STACKTOP=c;return e}_FT_New_Memory_Face.__index__=Runtime.getFunctionIndex(_FT_New_Memory_Face,"_FT_New_Memory_Face");function _memory_stream_close(e){var g,d=HEAP[e];g=HEAP[e+28];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e]=0;HEAP[e+4]=0;HEAP[e]=0;HEAP[e+24]=0}
_memory_stream_close.__index__=Runtime.getFunctionIndex(_memory_stream_close,"_memory_stream_close");
function _open_face_from_buffer(e,g,d,b,a,c){var f=STACKTOP;STACKTOP+=40;Runtime.memset(f,0,40);var h,i=null,k,j,l,m,o=f+4,n=f+36,p;HEAP[n]=0;p=HEAP[e];j=_memory_stream_close.__index__;k=e==0;a:do{if(k){i=0;h=1}else if(g==0){i=2;h=1}else{HEAP[n]=0;l=HEAP[e];l=_ft_mem_alloc(l,40,f);h=HEAP[f];if(h!=0){l=h;h=3}else{h=g;k=d;d=l;h=h;k=k;HEAP[d]=h;HEAP[d+4]=k;HEAP[d+8]=0;HEAP[d+32]=0;HEAP[d+20]=0;HEAP[d+24]=0;HEAP[l+24]=j;HEAP[n]=l;l=j=HEAP[f];if(j!=0){h=3;break a}HEAP[o]=2;HEAP[o+16]=HEAP[n];if(a!=0){HEAP[o]|=
8;a=_FT_Get_Module(e,a);HEAP[o+20]=a}l=e=_FT_Open_Face(e,o,b,c);if(e==0)HEAP[HEAP[c]+8]&=-1025;else{c=HEAP[n];e=c!=0;b:do if(e){if(HEAP[c+24]==0)break b;FUNCTION_TABLE[HEAP[c+24]](c)}while(0);b=HEAP[n];c=p;e=b;b!=0&&FUNCTION_TABLE[HEAP[c+8]](c,e);HEAP[n]=0}m=l;h=13}}break a}while(0);a:do if(h==1){l=i==0?33:6;h=3;break a}while(0);if(h==3){g!=0&&FUNCTION_TABLE[HEAP[p+8]](p,g);m=l}g=m;STACKTOP=f;return g}_open_face_from_buffer.__index__=Runtime.getFunctionIndex(_open_face_from_buffer,"_open_face_from_buffer");
function _open_face_PS_from_sfnt_stream(e,g,d,b,a,c){b=STACKTOP;STACKTOP+=17;Runtime.memset(b,0,17);var f,h=null,i,k,j,l,m,o;a=b+4;var n,p=b+8,r=b+12,q,s=b+16,u;n=HEAP[e];q=HEAP[g+8];HEAP[p]=0;HEAP[r]=0;HEAP[s]=0;l=_FT_Stream_ReadLong(g,b);var t=HEAP[b]!=0;a:do{if(t){u=HEAP[b];h=0;f=1}else{l=l!=1954115633;b:do if(l)h=2;else{h=_FT_Stream_ReadShort(g,b);if(HEAP[b]!=0){k=HEAP[b];h=4}else{l=g;t=reSign(6,32)<reSign(0,32);c:do if(t)HEAP[b]=85;else{l=_FT_Stream_Seek(l,6+HEAP[l+8]);HEAP[b]=l;if(l!=0)break c;
HEAP[s]=0;l=unSign(h,16);var v=t=g,w=g,x=p,y=g,A=r,z=p,C=p,B=r,D=r,E=s,F=reSign(d,32)<reSign(0,32),G=d,H=p,J=p,L=r,N=r,I=s,P=reSign(d,32)<reSign(0,32),K=reSign(d,32)>=reSign(0,32),O=v+8;h=7;d:for(;;){T=h==22?T:0;R=h==22?R:-1;f=0+T;if(!(reSign(l,32)>reSign(f,32))){f=25;break d}f=_FT_Stream_ReadLong(t,b);if(HEAP[b]!=0){h=9;f=10;break d}h=_FT_Stream_Seek(v,HEAP[O]+4);HEAP[b]=h;if(h!=0){h=11;f=10;break d}h=_FT_Stream_ReadLong(w,b);HEAP[x]=h;if(HEAP[b]!=0){h=12;f=10;break d}h=_FT_Stream_ReadLong(y,b);
HEAP[A]=h;if(HEAP[b]!=0){h=13;f=10;break d}else h=13;f=f==1128875040?15:f==1415139377?19:21;e:do if(f==21){if(K){h=21;f=17}else{h=21;f=22}break e}else if(f==15){j=R+1;HEAP[C]=HEAP[z]+22;HEAP[D]=HEAP[B]-22;HEAP[E]=1;if(F){h=15;f=16;break d}else{h=15;f=17;break e}}else if(f==19){var M=R+1;HEAP[J]=HEAP[H]+24;HEAP[N]=HEAP[L]-24;HEAP[I]=0;if(P){h=19;f=20;break d}else{h=19;f=17;break e}}while(0);if(f==17){var Q=h==19?M:h==15?j:R;if(Q==G){h=17;f=23;break d}else h=17}var R=h==17?Q:R,T=T+1;h=22;f=8}if(f==
25){h=25;break b}else if(f==10){var V=HEAP[b];h=10;f=1;break a}HEAP[a]=0;f=27;break a}while(0);var U=HEAP[b];h=6}f=1;break a}while(0);var S=h==2?2:142;HEAP[a]=S;h=26;f=28}break a}while(0);a:do if(f==1){var X=h==0?u:h==4?k:h==6?U:V;HEAP[a]=X;if(X!=0){h=1;f=28}else{h=1;f=27}break a}while(0);a:do if(f==27)if(_FT_Stream_Seek(g,HEAP[p]+q)!=0){var Y=HEAP[a];h=35}else{u=_ft_mem_alloc(n,HEAP[r],a);var W=HEAP[a];if(W!=0){h=29;break a}j=HEAP[r];k=u;i=g;k=k;j=j;i=i=_FT_Stream_ReadAt(i,HEAP[i+8],k,j);HEAP[a]=
i;i=HEAP[a];if(i!=0){h=30;break a}o=HEAP[s]!=0?__str5:__str16;k=d;k=reSign(k,32)<=reSign(0,32)?k:0;o=_open_face_from_buffer(e,u,HEAP[r],k,o,c);HEAP[a]=o;h=33}while(0);e=(h==35?Y:h==26?S:h==33?o:h==30?i:h==29?W:X)==2;a:do if(e){g=_FT_Stream_Seek(g,q);if(g==0){f=37;break a}m=g;f=38;break a}else f=37;while(0);if(f==37)m=HEAP[a];m=m;STACKTOP=b;return m}_open_face_PS_from_sfnt_stream.__index__=Runtime.getFunctionIndex(_open_face_PS_from_sfnt_stream,"_open_face_PS_from_sfnt_stream");
function _IsMacResource(e,g,d,b,a){var c=STACKTOP;STACKTOP+=24;Runtime.memset(c,0,24);var f=null,h,i,k,j,l,m,o,n,p,r,q,s,u,t,v,w,x,y,A,z,C=c+4,B,D;i=c+8;m=c+12;var E=c+16;k=c+20;D=HEAP[e];d=_FT_Raccess_Get_HeaderInfo(e,g,d,i,m);if(d==0){d=_FT_Raccess_Get_DataOffsets(e,g,HEAP[i],HEAP[m],1347375956,E,k);if(d==0){x=HEAP[k];C=HEAP[E];b=b;HEAP[c]=1;k=HEAP[e];d=b;d=d==-1?57:d==0?1:58;a:do if(d==58){h=HEAP[c];d=2;break a}else if(d==57){b=0;d=1;break a}while(0);a:do if(d==1){j=m=0;h=x;i=C;var F=g,G=g,H=j;
m=m;f=1;b:for(;;){d=f==7?s:0;var J=f==7?q:m,L=H+d,N=i+4*L;if(!(reSign(L,32)<reSign(h,32))){d=8;break b}L=_FT_Stream_Seek(F,HEAP[N]);HEAP[c]=L;if(HEAP[c]!=0){d=5;break b}L=_FT_Stream_ReadLong(G,c);if(HEAP[c]!=0){d=5;break b}q=L+6+J;s=d+1;f=7;d=3}b:do if(d==8){m=J;h=_ft_mem_alloc(k,m+2,c);if(HEAP[c]!=0){d=9;break b}HEAP[h]=-128;HEAP[h+1]=1;HEAP[h+2]=0;HEAP[h+3]=0;HEAP[h+4]=0;HEAP[h+5]=0;i=6;o=2;j=l=0;F=x;G=C;N=L=H=g;var I=m,P=m,K=g,O=m+2,M=m+2;j=j;l=l;o=o;f=10;c:for(;;){d=f==30?r:0;u=f==30?z:o;var Q=
f==30?n:1;v=f==30?p:l;f=j+d;var R=G+4*f;if(!(reSign(f,32)<reSign(F,32))){d=22;break c}f=_FT_Stream_Seek(H,HEAP[R]);HEAP[c]=f;if(HEAP[c]!=0){d=13;break c}R=_FT_Stream_ReadLong(L,c);if(HEAP[c]!=0){d=15;break c}f=_FT_Stream_ReadShort(N,c);f=unSign(f,16);if(HEAP[c]!=0){d=15;break c}if(reSign(f,32)>>reSign(8,32)==0)f=17;else{var T=R-2;R=reSign(R,32)>reSign(2,32)?T:0;if(reSign(f,32)>>reSign(8,32)==Q){w=R+v;f=18}else{if(reSign(u+3,32)>reSign(O,32)){d=13;break c}HEAP[h+u]=v&255;T=u+1;var V=reSign(v,32)>>
reSign(8,32)&255;HEAP[h+T]=V;T=u+2;V=reSign(v,32)>>reSign(16,32)&255;HEAP[h+T]=V;T=u+3;V=reSign(v,32)>>reSign(24,32)&255;HEAP[h+T]=V;if(reSign(f,32)>>reSign(8,32)==5){d=22;break c}if(reSign(i+6,32)>reSign(M,32)){d=13;break c}HEAP[h+i]=-128;i+=1;A=reSign(f,32)>>reSign(8,32);HEAP[h+i]=A&255;i+=1;t=i;HEAP[h+i]=0;i+=1;HEAP[h+i]=0;i+=1;HEAP[h+i]=0;i+=1;HEAP[h+i]=0;i+=1;f=24}y=f==24?t:u;var U=f==24?A:Q;B=f==24?R:w;HEAP[c]=1;if(reSign(i,32)>reSign(I,32)){d=13;break c}if(reSign(R+i,32)>reSign(P,32)){d=13;
break c}f=_FT_Stream_ReadAt(K,HEAP[K+8],h+i,R);HEAP[c]=f;if(HEAP[c]!=0){d=13;break c}i=R+i;f=28}z=f==28?y:u;n=f==28?U:Q;p=f==28?B:v;r=d+1;f=30;d=11}c:do if(d==22){o=u;l=v;d=m+2;if(reSign(i+2,32)>reSign(d,32)){d=31;break c}HEAP[h+i]=-128;i+=1;HEAP[h+i]=3;i+=1;d=m+2;if(reSign(o+3,32)>reSign(d,32)){d=31;break c}HEAP[h+o]=l&255;g=o+1;J=reSign(l,32)>>reSign(8,32)&255;HEAP[h+g]=J;g=o+2;J=reSign(l,32)>>reSign(16,32)&255;HEAP[h+g]=J;g=o+3;J=reSign(l,32)>>reSign(24,32)&255;HEAP[h+g]=J;h=_open_face_from_buffer(e,
h,i,b,__str16,a);break a}else if(d!=13)if(d==15){d=9;break b}while(0);m=h;h=k;i=m;m!=0&&FUNCTION_TABLE[HEAP[h+8]](h,i)}while(0);h=HEAP[c]}while(0);d=e=h;e=HEAP[E];e!=0&&FUNCTION_TABLE[HEAP[D+8]](D,e);HEAP[E]=0;if(d==0)HEAP[HEAP[a]]=1}else{d=_FT_Raccess_Get_DataOffsets(e,g,HEAP[i],HEAP[m],1936092788,E,k);J=d==0;a:do if(J){q=HEAP[k];q=reSign(b,32)%reSign(q,32);v=HEAP[k];u=HEAP[E];s=g;A=q;w=a;q=e;s=s;u=u;t=v;v=A;w=w;A=HEAP[q];if(v==-1)v=0;t=t;t=reSign(v,32)>=reSign(t,32);b:do if(t)y=1;else{y=HEAP[u+
4*v];U=_FT_Stream_Seek(s,y);HEAP[C]=U;U=HEAP[C]!=0;c:do if(!U){B=_FT_Stream_ReadLong(s,C);if(HEAP[C]!=0)break c;if(B==-1){y=1;break b}else{z=_open_face_PS_from_sfnt_stream(q,s,v,0,0,w);HEAP[C]=z;if(HEAP[C]==0)break c;if(_FT_Stream_Seek(s,y+4)!=0)break c;z=_ft_mem_alloc(A,B,C);if(HEAP[C]!=0){y=HEAP[C];break b}else{r=B;p=z;n=s;p=p;r=r;n=n=_FT_Stream_ReadAt(n,HEAP[n+8],p,r);HEAP[C]=n;if(HEAP[C]!=0)break c;n=reSign(B,32)<=reSign(4,32);d:do if(n)d=48;else{if(_memcmp(z,__str27,4)!=0){d=48;break d}x=__str38;
d=50;break d}while(0);if(d==48)x=__str49;B=_open_face_from_buffer(q,z,B,0,x,w);HEAP[C]=B}}}while(0);y=HEAP[C]}while(0);d=q=y;u=HEAP[E];q=D;s=u;u!=0&&FUNCTION_TABLE[HEAP[q+8]](q,s);HEAP[E]=0;if(d!=0)break a;HEAP[HEAP[a]]=HEAP[k]}while(0)}}a=d;STACKTOP=c;return a}_IsMacResource.__index__=Runtime.getFunctionIndex(_IsMacResource,"_IsMacResource");
function _IsMacBinary(e,g,d,b){var a=STACKTOP;STACKTOP+=128;Runtime.memset(a,0,128);var c,f,h;h=g==0;a:do if(h)c=85;else{c=_FT_Stream_Seek(g,0);f=c!=0;b:do if(!f){f=a;c=g;f=f;c=c=c=_FT_Stream_ReadAt(c,HEAP[c+8],f,128);if(c!=0)break b;h=HEAP[a]!=0;c:do if(!h){if(HEAP[a+74]!=0)break c;if(HEAP[a+82]!=0)break c;if(HEAP[a+1]==0)break c;if(unSign(HEAP[a+1],8)>unSign(33,8))break c;if(HEAP[a+63]!=0)break c;h=unSign(HEAP[a+1],8)+2;if(HEAP[a+h]!=0)break c;h=unSign(HEAP[a+83],8)<<24;c=unSign(HEAP[a+84],8)<<
16;f=unSign(HEAP[a+85],8)<<8;var i=unSign(HEAP[a+86],8);h=c|h|i|f;h=(h+127&-128)+128;c=_IsMacResource(e,g,h,d,b);break a}while(0);c=2;break a}while(0);c=c}while(0);e=c;STACKTOP=a;return e}_IsMacBinary.__index__=Runtime.getFunctionIndex(_IsMacBinary,"_IsMacBinary");
function _FT_Open_Face(e,g,d,b){var a=STACKTOP;STACKTOP+=160;Runtime.memset(a,0,160);var c,f=null,h,i,k,j,l,m,o,n=a+36,p=a+72,r=a+108,q=a+140,s,u,t,v,w=a+144,x=a+148,y=a+152;s=a+156;HEAP[x]=0;HEAP[y]=0;j=b!=0;a:do if(j)c=1;else{c=reSign(d,32)>=reSign(0,32)?0:1;break a}while(0);a:do if(c==1){if(g==0){c=0;break a}i=(HEAP[g]&2)==0;b:do if(i)c=4;else{if(HEAP[g+16]==0){c=4;break b}v=1;c=6;break b}while(0);if(c==4)v=0;v=v&255;c=_FT_Stream_New(e,g,x);HEAP[w]=c;i=c!=0;b:do if(i)c=29;else{i=HEAP[e];j=(HEAP[g]&
8)==0;c:do if(j)c=8;else{if(HEAP[g+20]==0){c=8;break c}c=HEAP[g+20];if((HEAP[HEAP[c]]&1&255)!=0){o=j=0;if((HEAP[g]&16)!=0){j=HEAP[g+24];o=HEAP[g+28]}c=_open_face(c,HEAP[x],d,j,o,y);HEAP[w]=c;if(c==0){c=11;break c}}else HEAP[w]=32;c=unSign(v,8);_FT_Stream_Free(HEAP[x],c);c=13;break b}while(0);if(c==8){f=e+28;j=j=f+4*HEAP[e+24];o=g;m=g+24;var A=g+28,z=d,C=e,B=d,D=b,E=f;f=8;c:for(;;){c=f==27?k:0;var F=E+4*c;if(!(F<j)){f=14;c=21;break c}if((HEAP[HEAP[HEAP[F]]]&1&255)!=0){var G=HEAP[F];if((HEAP[o]&16)!=
0){u=HEAP[m];t=HEAP[A];f=15}else f=99;k=f==15?t:0;var H=f==15?u:0;G=_open_face(G,HEAP[x],z,H,k,y);HEAP[w]=G;if(G==0){c=17;break c}F=_strcmp(HEAP[HEAP[HEAP[F]]+8],__str49)==0;d:do if(F){if((HEAP[w]&255)!=142)break d;if(_FT_Stream_Seek(HEAP[x],0)!=0){f=19;c=21;break c}else f=19;G=_open_face_PS_from_sfnt_stream(C,HEAP[x],B,H,k,D);HEAP[w]=G;if(HEAP[w]==0){c=23;break c}}while(0);if((HEAP[w]&255)!=2){f=20;c=21;break c}}k=c+1;f=27;c=14}if(c==21){c=29;break b}else if(c!=17)if(c==23){y=unSign(v,8);_FT_Stream_Free(HEAP[x],
y);i=HEAP[w];c=25;break a}}if(v!=0)HEAP[HEAP[y]+8]|=1024;c=_ft_mem_alloc(i,12,w);if(HEAP[w]!=0){c=13;break b}HEAP[c+8]=HEAP[y];u=c;c=HEAP[HEAP[y]+96]+24;u=u;t=HEAP[c+4];HEAP[u+4]=0;HEAP[u]=t;if(t!=0)HEAP[t+4]=u;else HEAP[c]=u;HEAP[c+4]=u;if(reSign(d,32)>=reSign(0,32)){c=_FT_New_GlyphSlot(HEAP[y],0);HEAP[w]=c;if(HEAP[w]!=0){c=13;break b}c=_FT_New_Size(HEAP[y],s);HEAP[w]=c;if(HEAP[w]!=0){c=13;break b}HEAP[HEAP[y]+88]=HEAP[s]}c=(HEAP[HEAP[y]+8]&1&255)!=0;c:do if(c){if(reSign(HEAP[HEAP[y]+74],16)<reSign(0,
16))HEAP[HEAP[y]+74]=0-HEAP[HEAP[y]+74];if((HEAP[HEAP[y]+8]&32)!=0)break c;HEAP[HEAP[y]+78]=HEAP[HEAP[y]+74]}while(0);c=(HEAP[HEAP[y]+8]&2)!=0;c:do if(c){if(!(reSign(HEAP[HEAP[y]+28],32)>reSign(0,32)))break c;for(f=78;;){f=f==78?0:h;h=0+f;s=1+f;u=HEAP[HEAP[y]+32];if(reSign(HEAP[u+16*h],16)<reSign(0,16))HEAP[u+16*h]=0-HEAP[u+16*h];if(reSign(HEAP[u+16*h+8],32)<reSign(0,32)){t=reSign(0-(HEAP[u+16*h+8]&65535),16);HEAP[u+16*h+8]=t}if(reSign(HEAP[u+16*h+12],32)<reSign(0,32))HEAP[u+16*h+12]=0-HEAP[u+16*
h+12];s=reSign(HEAP[HEAP[y]+28],32)>reSign(s,32);h=f+1;if(s)f=84;else{f=84;break}}}while(0);c=HEAP[HEAP[y]+128];HEAP[c+4]=65536;HEAP[c+4+4]=0;HEAP[c+4+8]=0;HEAP[c+4+12]=65536;HEAP[c+20]=0;HEAP[c+20+4]=0;HEAP[c+60]=1;c=HEAP[y];if(b!=0)HEAP[b]=c;else _FT_Done_Face(c);c=87;break b}while(0);b:do if(c==29){h=(HEAP[w]&255)!=81;c:do if(h){if((HEAP[w]&255)==2){c=31;break c}c=(HEAP[w]&255)!=85?32:31;break c}else c=31;while(0);c:do if(c==31){s=HEAP[x];u=d;t=b;c=g;h=e;s=s;u=u;t=t;i=c;k=_IsMacBinary(h,s,u,t);
if((k&255)==2)k=_IsMacResource(h,s,0,u,t);j=(k&255)==2;d:do if(j)c=35;else{var J=k;if((J&255)==85){f=34;c=35}else{f=34;c=36}break d}while(0);if(c==35)if((HEAP[i]&4)!=0){l=s;s=u;u=t;t=i;f=h;h=l;i=s;k=u;j=t;l=HEAP[f];m=2;HEAP[q]=0;_FT_Raccess_Guess(f,h,HEAP[j+12],a,n,p);o=0;h=r;s=r+12;t=u=f;i=i;k=k;j=j+12;o=o;m=m;A=o+1;f=37;d:for(;;){z=f==42?Q:0;var L=f==42?O:m;C=f==42?M:0;c=o+z;H=_raccess_guess_table+c*8+4;B=p+c*4;D=a+c*4;E=n+c*4;F=A+z;if(reSign(f==42?F:0,32)<=reSign(8,32))f=38;else{f=38;c=50;break d}F=
unSign(c,32)>unSign(8,32);e:do{if(F)c=39;else{f=HEAP[H];if(f==3){f=89;c=90}else if(f==4){f=89;c=90}else{f=89;c=39}}break e}while(0);if(c==39)f=39;c=(f==39?0:f==89?1:1)&255;H=c!=0&C!=0;e:do if(H)f=90;else{if(HEAP[B]!=0){f=41;break e}HEAP[h]=4;if(HEAP[D]!=0){var N=HEAP[D];f=44}else{var I=HEAP[j];f=46}HEAP[s]=f==46?I:N;var P=_FT_Stream_New(u,r,q);if(c!=0&P==81){f=47;break e}if(P!=0){f=48;break e}var K=_IsMacResource(t,HEAP[q],HEAP[E],i,k);_FT_Stream_Free(HEAP[q],0);if(K==0){f=49;c=50;break d}if(c==0){f=
51;break e}f=52}while(0);var O=f==52?K:f==51?K:f==48?P:f==41?L:f==90?L:81,M=f==52?1:f==51?C:f==48?C:f==41?C:f==90?C:1,Q=z+1;f=42;c=38}m=f==38?L:0;o=0;l=l;h=o;s=9-h;for(f=50;;){R=f==50?0:R;f=a+(h+R)*4;if(HEAP[f]!=0){c=HEAP[f];c!=0&&FUNCTION_TABLE[HEAP[l+8]](l,c);HEAP[f]=0}var R=R+1;if(R!=s){f=59;c=55}else{c=60;break}}if(m!=0)m=2;l=f=f=m;f=62}else{var T=k;f=64}h=f==64?T:f==34?J:l;HEAP[w]=h;if(h==0){y=unSign(v,8);_FT_Stream_Free(HEAP[x],y);i=HEAP[w];c=25;break a}else{if((HEAP[w]&255)!=2)break c;HEAP[w]=
2}}while(0);e=unSign(v,8);_FT_Stream_Free(HEAP[x],e);c=13;break b}while(0);c==13&&_FT_Done_Face(HEAP[y]);i=HEAP[w];c=25;break a}while(0);if(c==0)i=6;w=i;STACKTOP=a;return w}_FT_Open_Face.__index__=Runtime.getFunctionIndex(_FT_Open_Face,"_FT_Open_Face");function _FT_Attach_File(e,g){var d=STACKTOP;STACKTOP+=32;Runtime.memset(d,0,32);var b;if(g==0)b=6;else{HEAP[d+16]=0;HEAP[d]=4;HEAP[d+12]=g;b=_FT_Attach_Stream(e,d)}b=b;STACKTOP=d;return b}
_FT_Attach_File.__index__=Runtime.getFunctionIndex(_FT_Attach_File,"_FT_Attach_File");
function _FT_Attach_Stream(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a,c;if(e==0)c=35;else{b=HEAP[e+96];if(b==0)c=34;else{c=_FT_Stream_New(HEAP[b+4],g,d);if(c==0){c=7;b=HEAP[b+20];if(HEAP[b+88]!=0)c=FUNCTION_TABLE[HEAP[b+88]](e,HEAP[d]);var f=HEAP[g+16]==0;a:do if(f)b=2;else{if((HEAP[g]&2)==0){b=2;break a}a=1;b=4;break a}while(0);if(b==2)a=0;a=unSign(a&255,8);_FT_Stream_Free(HEAP[d],a)}c=c}}c=c;STACKTOP=d;return c}
_FT_Attach_Stream.__index__=Runtime.getFunctionIndex(_FT_Attach_Stream,"_FT_Attach_Stream");function _FT_Reference_Face(e){HEAP[HEAP[e+128]+60]+=1;return 0}_FT_Reference_Face.__index__=Runtime.getFunctionIndex(_FT_Reference_Face,"_FT_Reference_Face");
function _FT_Done_Face(e){var g,d=null,b,a,c,f,h;b=35;var i=e!=0;a:do if(i){if(HEAP[e+96]==0)break a;HEAP[HEAP[e+128]+60]-=1;if(HEAP[HEAP[e+128]+60]!=0)b=0;else{f=HEAP[e+96];h=HEAP[f+8];c=e;a=f+24;c=c;d=a=HEAP[a];c=c;var k=d;for(d=3;;){var j=d==6?l:k;if((d==6?l:a)==0){g=8;break}if(HEAP[j+8]==c){g=5;break}var l=HEAP[j+4];d=6;g=4}if(g!=8)if(g==5){c=a=j;b=f+24;d=c;c=HEAP[d];d=HEAP[d+4];if(c!=0)HEAP[c+4]=d;else HEAP[b]=d;if(d!=0)HEAP[d]=c;else HEAP[b+4]=c;c=a;b=h;a=c;c!=0&&FUNCTION_TABLE[HEAP[b+8]](b,
a);_destroy_face(h,e,f);b=0}}}while(0);return b}_FT_Done_Face.__index__=Runtime.getFunctionIndex(_FT_Done_Face,"_FT_Done_Face");
function _FT_New_Size(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b;b=null;var a,c,f,h,i,k;k=0;if(e==0)f=35;else if(g==0)f=36;else if(HEAP[e+96]==0)f=34;else{HEAP[g]=0;f=HEAP[e+96];h=HEAP[f+20];f=HEAP[e+100];i=_ft_mem_alloc(f,HEAP[h+40],d);var j=HEAP[d]!=0;a:do if(j)b=1;else{k=_ft_mem_alloc(f,12,d);if(HEAP[d]!=0){b=1;break a}HEAP[i]=e;HEAP[i+40]=0;if(HEAP[h+56]!=0){a=FUNCTION_TABLE[HEAP[h+56]](i);HEAP[d]=a;b=3}else{c=HEAP[d];b=5}if((b==5?c:a)==0){HEAP[g]=i;HEAP[k+8]=i;c=k;a=e+108;c=
c;b=HEAP[a+4];HEAP[c+4]=0;HEAP[c]=b;if(b!=0)HEAP[b+4]=c;else HEAP[a]=c;HEAP[a+4]=c}b=HEAP[d]!=0?1:8;break a}while(0);if(b==1){k=k;k!=0&&FUNCTION_TABLE[HEAP[f+8]](f,k);i!=0&&FUNCTION_TABLE[HEAP[f+8]](f,i)}f=HEAP[d]}f=f;STACKTOP=d;return f}_FT_New_Size.__index__=Runtime.getFunctionIndex(_FT_New_Size,"_FT_New_Size");
function _FT_Done_Size(e){var g,d=null,b,a,c,f,h,i;if(e==0)e=36;else{i=HEAP[e];if(i==0)e=35;else{f=HEAP[i+96];if(f==0)e=34;else{h=HEAP[f+8];c=0;d=i+108;var k=HEAP[d];d=1;a:for(;;){b=d==4?a:k;if((d==4?a:k)==0){g=6;break a}if(HEAP[b+8]==e){g=3;break a}a=HEAP[b+4];d=4;g=2}if(g==6)c=36;else if(g==3){d=b;g=i+108;b=HEAP[d];a=HEAP[d+4];if(b!=0)HEAP[b+4]=a;else HEAP[g]=a;if(a!=0)HEAP[a]=b;else HEAP[g+4]=b;d!=0&&FUNCTION_TABLE[HEAP[h+8]](h,d);g=HEAP[i+88]==e;a:do if(g){HEAP[i+88]=0;if(HEAP[i+108]==0)break a;
HEAP[i+88]=HEAP[HEAP[i+108]+8]}while(0);_destroy_size(h,e,f)}e=c}}}return e}_FT_Done_Size.__index__=Runtime.getFunctionIndex(_FT_Done_Size,"_FT_Done_Size");
function _FT_Match_Size(e,g,d,b){var a,c=null,f,h,i,k=(HEAP[e+8]&2)==0;a:do if(k)f=35;else if(HEAP[g]!=0)f=7;else{f=HEAP[g+4];h=f=HEAP[g+12]!=0?Math.floor(reSign(HEAP[g+12]*f+36,32)/reSign(72,32)):f;f=HEAP[g+8];i=f=HEAP[g+16]!=0?Math.floor(reSign(HEAP[g+16]*f+36,32)/reSign(72,32)):f;f=HEAP[g+4]==0;b:do if(f)a=3;else{if(HEAP[g+8]!=0){a=3;break b}i=h;a=5;break b}while(0);b:do if(a==3){if(HEAP[g+4]!=0)break b;if(HEAP[g+8]==0)break b;h=i}while(0);h=h+32&-64;i=i+32&-64;a=0;f=HEAP[e+28];var j=e+32;i=i;
h=h;var l=a;if(d!=0){c=5;a=9}else{c=5;a=10}for(;;)if(a==9){a=c==13?o:0;var m=l+a;if(reSign(f,32)>reSign(m,32))c=9;else{c=9;a=12;break}if((HEAP[HEAP[j]+16*m+12]+32&-64)==i){a=14;break}var o=a+1;c=13;a=9}else if(a==10){a=c==20?p:0;var n=l+a;if(!(reSign(f,32)>reSign(n,32))){c=10;a=12;break}c=HEAP[j];if((HEAP[c+16*n+12]+32&-64)==i)if((HEAP[c+16*n+8]+32&-64)==h){c=16;a=17;break}var p=a+1;c=20;a=10}if(a==12){f=23;break a}else if(a==14)c=14;a=c==14?m:n;if(b!=0)HEAP[b]=a;f=0}while(0);return f}
_FT_Match_Size.__index__=Runtime.getFunctionIndex(_FT_Match_Size,"_FT_Match_Size");
function _ft_synthesize_vertical_metrics(e,g){var d,b;d=g;b=HEAP[e+4];var a=reSign(HEAP[e+12],32)<reSign(0,32),c=HEAP[e+12];a:do if(a){var f=b;if(!(reSign(c,32)>reSign(f,32)))break a;b=HEAP[e+12]}else{if(!(reSign(c,32)>reSign(0,32)))break a;b-=HEAP[e+12]}while(0);if(d==0)d=Math.floor(reSign(b*12,32)/reSign(10,32));a=HEAP[e+8];c=Math.floor(reSign(HEAP[e+16],32)/reSign(2,32));HEAP[e+20]=a-c;b=Math.floor(reSign(d-b,32)/reSign(2,32));HEAP[e+24]=b;HEAP[e+28]=d}
_ft_synthesize_vertical_metrics.__index__=Runtime.getFunctionIndex(_ft_synthesize_vertical_metrics,"_ft_synthesize_vertical_metrics");function _ft_recompute_scaled_metrics(e,g){var d=HEAP[g+8],b=reSign(HEAP[e+70],16);d=_FT_MulFix(b,d)+63&-64;HEAP[g+12]=d;d=HEAP[g+8];b=reSign(HEAP[e+72],16);d=_FT_MulFix(b,d)&-64;HEAP[g+16]=d;d=HEAP[g+8];b=reSign(HEAP[e+74],16);d=_FT_MulFix(b,d)+32&-64;HEAP[g+20]=d;d=HEAP[g+4];b=reSign(HEAP[e+76],16);d=_FT_MulFix(b,d)+32&-64;HEAP[g+24]=d}
_ft_recompute_scaled_metrics.__index__=Runtime.getFunctionIndex(_ft_recompute_scaled_metrics,"_ft_recompute_scaled_metrics");
function _FT_Select_Metrics(e,g){var d,b;d=HEAP[e+88]+12;b=HEAP[e+32]+16*g;var a=reSign(HEAP[b+8]+32,32)>>reSign(6,32)&65535;HEAP[d]=a;a=reSign(HEAP[b+12]+32,32)>>reSign(6,32)&65535;HEAP[d+2]=a;if((HEAP[e+8]&1&255)!=0){a=unSign(HEAP[e+68],16);a=_FT_DivFix(HEAP[b+8],a);HEAP[d+4]=a;a=unSign(HEAP[e+68],16);b=_FT_DivFix(HEAP[b+12],a);HEAP[d+8]=b;_ft_recompute_scaled_metrics(e,d)}else{HEAP[d+4]=65536;HEAP[d+8]=65536;HEAP[d+12]=HEAP[b+12];HEAP[d+16]=0;a=reSign(HEAP[b],16)<<6;HEAP[d+20]=a;HEAP[d+24]=HEAP[b+
8]}}_FT_Select_Metrics.__index__=Runtime.getFunctionIndex(_FT_Select_Metrics,"_FT_Select_Metrics");
function _FT_Request_Metrics(e,g){var d,b=null,a,c,f,h,i;f=HEAP[e+88]+12;if((HEAP[e+8]&1&255)!=0){a=c=i=h=0;d=HEAP[g];d=d==0?0:d==1?2:d==2?13:d==3?14:d==4?15:3;a:do if(d==0){var k=i=unSign(HEAP[e+68],16);h=k;b=0;d=1;break a}else if(d==2){b=reSign(HEAP[e+70],16);h=reSign(HEAP[e+72],16);var j=i=b-h;h=j;b=2;d=1;break a}else if(d==13){h=HEAP[e+52+8]-HEAP[e+52];i=HEAP[e+52+12]-HEAP[e+52+4];d=3;break a}else if(d==14){h=reSign(HEAP[e+76],16);i=reSign(HEAP[e+70],16);d=reSign(HEAP[e+72],16);i=i-d;d=3;break a}else if(d==
15){HEAP[f+4]=HEAP[g+4];HEAP[f+8]=HEAP[g+8];d=HEAP[f+8];if(HEAP[f+4]==0)HEAP[f+4]=d;else{if(d!=0){d=4;break a}HEAP[f+8]=HEAP[f+4]}d=4;break a}while(0);a:do if(d==3){var l=h;b=3;d=1;break a}while(0);a:do if(d==1){if(reSign(b==3?l:b==2?j:k,32)<reSign(0,32))h=0-h;if(reSign(i,32)<reSign(0,32))i=0-i;c=HEAP[g+4];c=c=HEAP[g+12]!=0?Math.floor(reSign(HEAP[g+12]*c+36,32)/reSign(72,32)):c;a=HEAP[g+8];a=a=HEAP[g+16]!=0?Math.floor(reSign(HEAP[g+16]*a+36,32)/reSign(72,32)):a;if(HEAP[g+4]!=0){var m=_FT_DivFix(c,
h);HEAP[f+4]=m;if(HEAP[g+8]!=0){m=_FT_DivFix(a,i);HEAP[f+8]=m;if(HEAP[g]!=3)break a;m=HEAP[f+4];m=reSign(HEAP[f+8],32)>reSign(m,32);var o=f;if(m)HEAP[f+8]=HEAP[o+4];else HEAP[f+4]=HEAP[o+8]}else{HEAP[f+8]=HEAP[f+4];a=_FT_MulDiv(c,i,h)}}else{c=_FT_DivFix(a,i);HEAP[f+8]=c;HEAP[f+4]=HEAP[f+8];c=_FT_MulDiv(a,h,i)}}while(0);if(HEAP[g]!=0){k=HEAP[f+4];l=unSign(HEAP[e+68],16);c=_FT_MulFix(l,k);k=HEAP[f+8];l=unSign(HEAP[e+68],16);a=_FT_MulFix(l,k)}k=reSign(c+32,32)>>reSign(6,32)&65535;HEAP[f]=k;k=reSign(a+
32,32)>>reSign(6,32)&65535;HEAP[f+2]=k;_ft_recompute_scaled_metrics(e,f)}else{_llvm_memset_p0i8_i32(f,0,28,1,0);HEAP[f+4]=65536;HEAP[f+8]=65536}}_FT_Request_Metrics.__index__=Runtime.getFunctionIndex(_FT_Request_Metrics,"_FT_Request_Metrics");
function _FT_Select_Size(e,g){var d,b,a=e==0;a:do if(a)d=0;else{if((HEAP[e+8]&2)==0){d=0;break a}d=reSign(g,32)<reSign(0,32);b:do if(!d){d=g;if(reSign(HEAP[e+28],32)<=reSign(d,32))break b;d=HEAP[HEAP[e+96]+20];if(HEAP[d+100]!=0)b=FUNCTION_TABLE[HEAP[d+100]](HEAP[e+88],g);else{_FT_Select_Metrics(e,g);b=0}d=5;break a}while(0);b=6;d=5;break a}while(0);if(d==0)b=35;return b}_FT_Select_Size.__index__=Runtime.getFunctionIndex(_FT_Select_Size,"_FT_Select_Size");
function _FT_Request_Size(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a;a=e==0;a:do if(a)b=35;else{b=g==0;b:do if(!b){if(reSign(HEAP[g+4],32)<reSign(0,32))break b;if(reSign(HEAP[g+8],32)<reSign(0,32))break b;if(unSign(HEAP[g],32)>unSign(4,32))break b;a=HEAP[HEAP[e+96]+20];if(HEAP[a+96]!=0)b=FUNCTION_TABLE[HEAP[a+96]](HEAP[e+88],g);else{a=(HEAP[e+8]&1)==0;c:do if(a){if((HEAP[e+8]&2)==0)break c;a=_FT_Match_Size(e,g,0,d);b=a!=0?a:_FT_Select_Size(e,HEAP[d]);break a}while(0);_FT_Request_Metrics(e,
g);b=0}break a}while(0);b=6}while(0);a=b;STACKTOP=d;return a}_FT_Request_Size.__index__=Runtime.getFunctionIndex(_FT_Request_Size,"_FT_Request_Size");
function _FT_Set_Char_Size(e,g,d,b,a){var c=STACKTOP;STACKTOP+=20;Runtime.memset(c,0,20);g=g;d=d;b=b;a=a;var f=g==0,h=d;a:do if(f)g=h;else{if(h!=0)break a;d=g}while(0);f=b==0;h=a;a:do if(f)b=h;else{if(h!=0)break a;a=b}while(0);if(reSign(g,32)<=reSign(63,32))g=64;if(reSign(d,32)<=reSign(63,32))d=64;if(b==0)b=a=72;HEAP[c]=0;HEAP[c+4]=g;HEAP[c+8]=d;HEAP[c+12]=b;HEAP[c+16]=a;e=_FT_Request_Size(e,c);STACKTOP=c;return e}_FT_Set_Char_Size.__index__=Runtime.getFunctionIndex(_FT_Set_Char_Size,"_FT_Set_Char_Size");
function _FT_Set_Pixel_Sizes(e,g,d){var b=STACKTOP;STACKTOP+=20;Runtime.memset(b,0,20);var a=null;g=g;d=d;var c=g==0,f=d;a:do if(c){g=f;a=0}else{var h=g;if(f!=0){a=2;break a}d=h;a=3}while(0);if((a==3?h:a==0?f:h)==0)g=1;if(d==0)d=1;if(unSign(g,32)>unSign(65534,32))g=65535;if(unSign(d,32)>unSign(65534,32))d=65535;HEAP[b]=0;HEAP[b+4]=g<<6;HEAP[b+8]=d<<6;HEAP[b+12]=0;HEAP[b+16]=0;e=_FT_Request_Size(e,b);STACKTOP=b;return e}_FT_Set_Pixel_Sizes.__index__=Runtime.getFunctionIndex(_FT_Set_Pixel_Sizes,"_FT_Set_Pixel_Sizes");
function _FT_Get_Kerning(e,g,d,b,a){var c,f;c=0;if(e==0)e=35;else if(a==0)e=6;else{f=HEAP[e+96];HEAP[a]=0;HEAP[a+4]=0;var h=HEAP[HEAP[f+20]+84]!=0;a:do if(h){c=FUNCTION_TABLE[HEAP[HEAP[f+20]+84]](e,g,d,a);if(c!=0)break a;if(b==2)break a;var i=_FT_MulFix(HEAP[a],HEAP[HEAP[e+88]+12+4]);HEAP[a]=i;i=_FT_MulFix(HEAP[a+4],HEAP[HEAP[e+88]+12+8]);HEAP[a+4]=i;if(b==1)break a;if(unSign(HEAP[HEAP[e+88]+12],16)<=unSign(24,16)){i=unSign(HEAP[HEAP[e+88]+12],16);i=_FT_MulDiv(HEAP[a],i,25);HEAP[a]=i}if(unSign(HEAP[HEAP[e+
88]+12+2],16)<=unSign(24,16)){i=unSign(HEAP[HEAP[e+88]+12+2],16);i=_FT_MulDiv(HEAP[a+4],i,25);HEAP[a+4]=i}HEAP[a]=HEAP[a]+32&-64;HEAP[a+4]=HEAP[a+4]+32&-64}while(0);e=c}return e}_FT_Get_Kerning.__index__=Runtime.getFunctionIndex(_FT_Get_Kerning,"_FT_Get_Kerning");
function _FT_Get_Track_Kerning(e,g,d,b){var a,c;if(e==0)e=35;else if(b==0)e=6;else{a=HEAP[e+96];c=0;if(HEAP[HEAP[a]+32]!=0)c=FUNCTION_TABLE[HEAP[HEAP[a]+32]](a,__str510);a=c;if(a==0)e=7;else e=e=FUNCTION_TABLE[HEAP[a]](e,g,d,b)}return e}_FT_Get_Track_Kerning.__index__=Runtime.getFunctionIndex(_FT_Get_Track_Kerning,"_FT_Get_Track_Kerning");
function _FT_Select_Charmap(e,g){var d,b=null,a,c,f;if(e==0)a=35;else if(g==0)a=6;else if(g==1970170211)a=_find_unicode_charmap(e);else{c=HEAP[e+40];if(c==0)a=38;else{f=c+4*HEAP[e+36];var h=e+40;c=c;for(b=1;;){d=b==5?k:0;var i=c+4*d;if(!(i<f)){d=7;break}if(HEAP[HEAP[i]+4]==g)if(!(reSign(i-HEAP[h],32)>reSign(63,32))){d=4;break}var k=d+1;b=5;d=2}if(d==7)a=6;else if(d==4){c=i;HEAP[e+92]=HEAP[c];a=0}}}return a}_FT_Select_Charmap.__index__=Runtime.getFunctionIndex(_FT_Select_Charmap,"_FT_Select_Charmap");
function _FT_Set_Charmap(e,g){var d,b=null,a,c,f;if(e==0)a=35;else{c=HEAP[e+40];if(c==0)a=38;else if(_FT_Get_CMap_Format(g)==14)a=6;else{f=c+4*HEAP[e+36];var h=e+40;c=c;for(b=1;;){d=b==5?k:0;var i=c+4*d;if(!(i<f)){d=7;break}if(HEAP[i]==g)if(!(reSign(i-HEAP[h],32)>reSign(63,32))){d=4;break}var k=d+1;b=5;d=2}if(d==7)a=6;else if(d==4){c=i;HEAP[e+92]=HEAP[c];a=0}}}return a}_FT_Set_Charmap.__index__=Runtime.getFunctionIndex(_FT_Set_Charmap,"_FT_Set_Charmap");
function _FT_Get_Charmap_Index(e){var g,d=null,b;d=e==0;a:do if(d)g=0;else{if(HEAP[e]==0){g=0;break a}d=0;b=HEAP[HEAP[e]+36];e=g=e;var a=d;for(d=1;;){f=d==5?f:0;var c=a+f;if(!(reSign(b,32)>reSign(c,32)))break;if(HEAP[HEAP[HEAP[g]+40]+4*c]==e)break;var f=f+1;d=5}d=c;c=reSign(c,32)>reSign(15,32);f=d;b=c?0-f:f;g=7;break a}while(0);if(g==0)b=-1;return b}_FT_Get_Charmap_Index.__index__=Runtime.getFunctionIndex(_FT_Get_Charmap_Index,"_FT_Get_Charmap_Index");
function _FT_CMap_Done(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d,b=null,a,c,f,h,i=e!=0;a:do if(i){a=HEAP[e];f=HEAP[a+100];b=0;h=HEAP[a+36];var k=a+40,j=e,l=b;b=0;b:for(;;){b=b==3?o:0;var m=l+b;if(!(reSign(h,32)>reSign(m,32))){d=16;break b}if(HEAP[HEAP[k]+4*m]==j){d=2;break b}var o=b+1;b=3;d=1}if(d==16){STACKTOP=g;return}else if(d==2){b=m;h=HEAP[HEAP[a+40]+4*(HEAP[a+36]-1)];f=_ft_mem_realloc(f,4,HEAP[a+36],HEAP[a+36]-1,HEAP[a+40],g);HEAP[a+40]=f;if(HEAP[g]!=0)break a;f=b=b+1;i=reSign(HEAP[a+
36],32)>reSign(f,32);f=HEAP[a+36]-1;if(i){i=a+40;h=h;k=a+36;j=a+36;m=a+40;o=b;d=o+-1;l=o+1;for(b=6;;){r=b==6?0:r;var n=o+r,p=l+r;HEAP[HEAP[i]+4*(d+r)]=(b==6?f:c)==n?h:HEAP[HEAP[m]+4*n];b=reSign(HEAP[k],32)>reSign(p,32);c=HEAP[j]-1;var r=r+1;if(b)b=9;else break}b=10}else b=5;HEAP[a+36]=b==10?c:f;if(HEAP[a+92]==e)HEAP[a+92]=0;e=e;a=HEAP[e+12];c=HEAP[e];c=HEAP[c+100];HEAP[a+8]!=0&&FUNCTION_TABLE[HEAP[a+8]](e);e=e;a=c;c=e;if(e==0)break a;FUNCTION_TABLE[HEAP[a+8]](a,c);STACKTOP=g;return}}while(0);STACKTOP=
g}_FT_CMap_Done.__index__=Runtime.getFunctionIndex(_FT_CMap_Done,"_FT_CMap_Done");
function _FT_CMap_New(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c,f,h,i,k;HEAP[a]=0;k=e==0;a:do if(k)c=0;else{if(d==0){c=0;break a}if(HEAP[d]==0){c=0;break a}i=HEAP[d];k=HEAP[i+100];h=_ft_mem_alloc(k,HEAP[e],a);var j=HEAP[a]==0;b:do if(j){c=h;f=d;HEAP[c]=HEAP[f];HEAP[c+4]=HEAP[f+4];HEAP[c+8]=HEAP[f+8];HEAP[c+10]=HEAP[f+10];HEAP[h+12]=e;f=HEAP[e+4]!=0;c:do if(f){c=FUNCTION_TABLE[HEAP[e+4]](h,g);HEAP[a]=c;c=HEAP[a]!=0?4:5;break c}else c=5;while(0);c:do if(c==5){c=_ft_mem_realloc(k,
4,HEAP[i+36],HEAP[i+36]+1,HEAP[i+40],a);HEAP[i+40]=c;if(HEAP[a]!=0)break c;e=HEAP[i+36];HEAP[HEAP[i+40]+4*e]=h;HEAP[i+36]=e+1;break b}while(0);h=h;c=HEAP[h+12];f=HEAP[h];f=HEAP[f+100];HEAP[c+8]!=0&&FUNCTION_TABLE[HEAP[c+8]](h);h=h;c=f;f=h;h!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);h=0}while(0);if(b!=0)HEAP[b]=h;i=HEAP[a];c=9;break a}while(0);if(c==0)i=6;b=i;STACKTOP=a;return b}_FT_CMap_New.__index__=Runtime.getFunctionIndex(_FT_CMap_New,"_FT_CMap_New");
function _FT_Get_Char_Index(e,g){var d;d=0;var b=e!=0;a:do if(b){if(HEAP[e+92]==0)break a;d=HEAP[e+92];d=FUNCTION_TABLE[HEAP[HEAP[d+12]+12]](d,g)}while(0);return d}_FT_Get_Char_Index.__index__=Runtime.getFunctionIndex(_FT_Get_Char_Index,"_FT_Get_Char_Index");
function _FT_Get_First_Char(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b=null,a,c,f,h;h=0;HEAP[d]=0;if(e!=0){var i=HEAP[e+92]!=0;a:do if(i){if(HEAP[e+16]==0)break a;a=e;c=0;var k=a!=0;b:do if(k){if(HEAP[a+92]!=0){f=HEAP[a+92];c=f=FUNCTION_TABLE[HEAP[HEAP[f+12]+12]](f,0);b=3}else{var j=c;b=5}b=b==5?j:f;HEAP[d]=b;if(b==0)break b;b=HEAP[d];if(!(unSign(HEAP[e+16],32)<=unSign(b,32)))break a}else HEAP[d]=0;while(0);h=_FT_Get_Next_Char(e,0,d)}while(0);a=g;b=1}else b=-1;if((b==1?a:g)!=0)HEAP[g]=
HEAP[d];h=h;STACKTOP=d;return h}_FT_Get_First_Char.__index__=Runtime.getFunctionIndex(_FT_Get_First_Char,"_FT_Get_First_Char");
function _FT_Get_Next_Char(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a=null,c,f;f=c=0;if(e!=0){a=HEAP[e+92]!=0;a:do if(a){if(HEAP[e+16]==0)break a;HEAP[b]=g;c=HEAP[e+92];f=c+12;c=c;for(var h=e+16;;){var i=FUNCTION_TABLE[HEAP[HEAP[f]+16]](c,b);if(!(unSign(HEAP[h],32)<=unSign(i,32)))break}f=i;c=c=f!=0?HEAP[b]:0}while(0);h=d;a=1}else a=-1;if((a==1?h:d)!=0)HEAP[d]=f;e=c;STACKTOP=b;return e}_FT_Get_Next_Char.__index__=Runtime.getFunctionIndex(_FT_Get_Next_Char,"_FT_Get_Next_Char");
function _FT_Face_GetCharVariantIndex(e,g,d){var b,a,c;b=0;var f=e!=0;a:do if(f){if(HEAP[e+92]==0)break a;if(HEAP[HEAP[e+92]+4]!=1970170211)break a;a=_find_variant_selector_charmap(e);c=HEAP[e+92];if(a==0)break a;b=a;b=FUNCTION_TABLE[HEAP[HEAP[b+12]+20]](b,c,g,d)}while(0);return b}_FT_Face_GetCharVariantIndex.__index__=Runtime.getFunctionIndex(_FT_Face_GetCharVariantIndex,"_FT_Face_GetCharVariantIndex");
function _FT_Face_GetCharVariantIsDefault(e,g,d){var b,a;b=-1;var c=e!=0;a:do if(c){a=_find_variant_selector_charmap(e);if(a==0)break a;b=a;b=FUNCTION_TABLE[HEAP[HEAP[b+12]+24]](b,g,d);b=unSign(b,8)}while(0);return b}_FT_Face_GetCharVariantIsDefault.__index__=Runtime.getFunctionIndex(_FT_Face_GetCharVariantIsDefault,"_FT_Face_GetCharVariantIsDefault");
function _FT_Face_GetVariantSelectors(e){var g,d;g=0;var b=e!=0;a:do if(b){d=_find_variant_selector_charmap(e);if(d==0)break a;g=d;d=HEAP[e+100];g=FUNCTION_TABLE[HEAP[HEAP[g+12]+28]](g,d)}while(0);return g}_FT_Face_GetVariantSelectors.__index__=Runtime.getFunctionIndex(_FT_Face_GetVariantSelectors,"_FT_Face_GetVariantSelectors");
function _FT_Face_GetVariantsOfChar(e,g){var d,b;d=0;var a=e!=0;a:do if(a){b=_find_variant_selector_charmap(e);if(b==0)break a;d=b;b=HEAP[e+100];d=FUNCTION_TABLE[HEAP[HEAP[d+12]+32]](d,b,g)}while(0);return d}_FT_Face_GetVariantsOfChar.__index__=Runtime.getFunctionIndex(_FT_Face_GetVariantsOfChar,"_FT_Face_GetVariantsOfChar");
function _FT_Face_GetCharsOfVariant(e,g){var d,b;d=0;var a=e!=0;a:do if(a){b=_find_variant_selector_charmap(e);if(b==0)break a;d=b;b=HEAP[e+100];d=FUNCTION_TABLE[HEAP[HEAP[d+12]+36]](d,b,g)}while(0);return d}_FT_Face_GetCharsOfVariant.__index__=Runtime.getFunctionIndex(_FT_Face_GetCharsOfVariant,"_FT_Face_GetCharsOfVariant");
function _FT_Get_Name_Index(e,g){var d=null,b,a,c;a=0;var f=e!=0;a:do if(f){if((HEAP[e+8]&512)==0)break a;d=HEAP[HEAP[e+128]+32+8];c=d==4294967294;b:do if(c)d=0;else{if(d!=0)break b;d=HEAP[e+96];if(HEAP[HEAP[d]+32]!=0){var h=FUNCTION_TABLE[HEAP[HEAP[d]+32]](d,__str6);d=5}else{var i=0;d=7}d=b=d==7?i:h;var k=HEAP[e+128];b=b!=0?d:4294967294;HEAP[k+32+8]=b}while(0);c=d=d;if(d==0)break a;if(HEAP[c+4]==0)break a;a=FUNCTION_TABLE[HEAP[c+4]](e,g)}while(0);return a}
_FT_Get_Name_Index.__index__=Runtime.getFunctionIndex(_FT_Get_Name_Index,"_FT_Get_Name_Index");
function _FT_Get_Glyph_Name(e,g,d,b){var a=null,c,f,h;f=6;var i=d!=0;a:do if(i){if(b==0)break a;HEAP[d]=0}while(0);i=e!=0;a:do if(i){h=HEAP[e+16];if(!(reSign(g,32)<=reSign(h,32)))break a;if((HEAP[e+8]&512)==0)break a;a=HEAP[HEAP[e+128]+32+8];h=a==4294967294;b:do if(h)a=0;else{if(a!=0)break b;a=HEAP[e+96];if(HEAP[HEAP[a]+32]!=0){var k=FUNCTION_TABLE[HEAP[HEAP[a]+32]](a,__str6);a=9}else{var j=0;a=11}a=c=a==11?j:k;var l=HEAP[e+128];c=c!=0?a:4294967294;HEAP[l+32+8]=c}while(0);h=a=a;if(a==0)break a;if(HEAP[h]==
0)break a;f=FUNCTION_TABLE[HEAP[h]](e,g,d,b)}while(0);return f}_FT_Get_Glyph_Name.__index__=Runtime.getFunctionIndex(_FT_Get_Glyph_Name,"_FT_Get_Glyph_Name");
function _FT_Get_Postscript_Name(e){var g=null,d,b,a;b=0;var c=e==0;a:do if(!c){if(b!=0)break a;g=HEAP[HEAP[e+128]+32];a=g==4294967294;b:do if(a)g=0;else{if(g!=0)break b;g=HEAP[e+96];if(HEAP[HEAP[g]+32]!=0){var f=FUNCTION_TABLE[HEAP[HEAP[g]+32]](g,__str7);g=5}else{var h=0;g=7}g=d=g==7?h:f;var i=HEAP[e+128];d=d!=0?g:4294967294;HEAP[i+32]=d}while(0);a=g=g;if(g==0)break a;if(HEAP[a]==0)break a;b=FUNCTION_TABLE[HEAP[a]](e)}while(0);return b}
_FT_Get_Postscript_Name.__index__=Runtime.getFunctionIndex(_FT_Get_Postscript_Name,"_FT_Get_Postscript_Name");function _FT_Get_Sfnt_Table(e,g){var d,b,a;d=0;var c=e!=0;a:do if(c){if((HEAP[e+8]&8)==0)break a;b=HEAP[e+96];a=0;if(HEAP[HEAP[b]+32]!=0)a=FUNCTION_TABLE[HEAP[HEAP[b]+32]](b,__str8);b=a;if(b==0)break a;d=FUNCTION_TABLE[HEAP[b+4]](e,g)}while(0);return d}_FT_Get_Sfnt_Table.__index__=Runtime.getFunctionIndex(_FT_Get_Sfnt_Table,"_FT_Get_Sfnt_Table");
function _FT_Load_Sfnt_Table(e,g,d,b,a){var c,f,h=e==0;a:do if(h)c=0;else{if((HEAP[e+8]&8)==0){c=0;break a}c=HEAP[e+96];f=0;if(HEAP[HEAP[c]+32]!=0)f=FUNCTION_TABLE[HEAP[HEAP[c]+32]](c,__str8);c=f;f=c==0?7:FUNCTION_TABLE[HEAP[c]](e,g,d,b,a);c=4;break a}while(0);if(c==0)f=35;return f}_FT_Load_Sfnt_Table.__index__=Runtime.getFunctionIndex(_FT_Load_Sfnt_Table,"_FT_Load_Sfnt_Table");
function _FT_Sfnt_Table_Info(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c,f,h=e==0;a:do if(h)c=0;else{if((HEAP[e+8]&8)==0){c=0;break a}c=HEAP[e+96];f=0;if(HEAP[HEAP[c]+32]!=0)f=FUNCTION_TABLE[HEAP[HEAP[c]+32]](c,__str8);c=f;f=c==0?7:FUNCTION_TABLE[HEAP[c+8]](e,g,d,a,b);c=4;break a}while(0);if(c==0)f=35;e=f;STACKTOP=a;return e}_FT_Sfnt_Table_Info.__index__=Runtime.getFunctionIndex(_FT_Sfnt_Table_Info,"_FT_Sfnt_Table_Info");
function _FT_Get_CMap_Language_ID(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);var d,b,a=e==0;a:do if(a)d=0;else{if(HEAP[e]==0){d=0;break a}d=HEAP[e];d=HEAP[d+96];b=0;if(HEAP[HEAP[d]+32]!=0)b=FUNCTION_TABLE[HEAP[HEAP[d]+32]](d,__str9);d=b;b=d==0?0:FUNCTION_TABLE[HEAP[d]](e,g)!=0?0:HEAP[g];d=4;break a}while(0);if(d==0)b=0;e=b;STACKTOP=g;return e}_FT_Get_CMap_Language_ID.__index__=Runtime.getFunctionIndex(_FT_Get_CMap_Language_ID,"_FT_Get_CMap_Language_ID");
function _FT_Get_CMap_Format(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);var d,b,a=e==0;a:do if(a)d=0;else{if(HEAP[e]==0){d=0;break a}d=HEAP[e];d=HEAP[d+96];b=0;if(HEAP[HEAP[d]+32]!=0)b=FUNCTION_TABLE[HEAP[HEAP[d]+32]](d,__str9);d=b;b=d==0?-1:FUNCTION_TABLE[HEAP[d]](e,g)!=0?-1:HEAP[g+4];d=4;break a}while(0);if(d==0)b=-1;e=b;STACKTOP=g;return e}_FT_Get_CMap_Format.__index__=Runtime.getFunctionIndex(_FT_Get_CMap_Format,"_FT_Get_CMap_Format");
function _FT_Activate_Size(e){var g,d=e==0;a:do{if(!d){g=HEAP[e];var b=g==0;b:do if(!b){if(HEAP[g+96]==0)break b;HEAP[g+88]=e;g=0;break a}while(0)}g=6}while(0);return g}_FT_Activate_Size.__index__=Runtime.getFunctionIndex(_FT_Activate_Size,"_FT_Activate_Size");
function _FT_Lookup_Renderer(e,g,d){var b,a=null,c;c=0;if(e!=0){var f=HEAP[e+156];e=f;if(d!=0){if(HEAP[d]!=0)e=HEAP[HEAP[d]+4];HEAP[d]=0;var h=e;a=1}else a=11;h=a==11?f:h;e=e;for(a=3;;){var i=a==6?j:e;if((a==6?j:h)==0){b=10;break}var k=HEAP[i+8];if(HEAP[k+24]==g){b=5;break}var j=HEAP[i+4];a=6;b=4}if(b!=10)if(b==5){g=k;e=i;if(d!=0)HEAP[d]=e;c=g}}return c}_FT_Lookup_Renderer.__index__=Runtime.getFunctionIndex(_FT_Lookup_Renderer,"_FT_Lookup_Renderer");
function _FT_Get_Renderer(e,g){return _FT_Lookup_Renderer(e,g,0)}_FT_Get_Renderer.__index__=Runtime.getFunctionIndex(_FT_Get_Renderer,"_FT_Get_Renderer");
function _FT_Set_Renderer(e,g,d,b){var a,c=null,f,h,i,k;k=d;d=0;if(e==0)e=33;else if(g==0)e=6;else{c=e+156;h=HEAP[c];c=1;a:for(;;){var j=c==4?f:h;if((c==4?f:h)==0){a=6;break a}if(HEAP[j+8]==g){a=3;break a}f=HEAP[j+4];c=4;a=2}a:do if(a==6)d=6;else if(a==3){f=c=j;c=e+156;f=f;h=HEAP[f];i=HEAP[f+4];if(h!=0){HEAP[h+4]=i;if(i!=0)HEAP[i]=h;else HEAP[c+4]=h;HEAP[f]=0;HEAP[f+4]=HEAP[c];HEAP[HEAP[c]]=f;HEAP[c]=f}if(HEAP[g+24]==1869968492)HEAP[e+164]=g;if(k==0)break a;c=HEAP[HEAP[g+20]+52];f=k;h=b+4;i=b;var l=
c,m=g;k=k;d=d;var o=k+-1;for(c=11;;){a=c==16?s:0;var n=c==16?0:d,p=a*-1,r=k+p;p=o+p;if((c==16?p:f)==0){c=13;a=15;break}var q=FUNCTION_TABLE[l](m,HEAP[i],HEAP[h]);if(q!=0){c=14;a=15;break}var s=a+1;c=16;a=13}d=c==14?q:n;k=r}while(0);e=d}return e}_FT_Set_Renderer.__index__=Runtime.getFunctionIndex(_FT_Set_Renderer,"_FT_Set_Renderer");
function _FT_Render_Glyph_Internal(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c=null,f,h,i;f=0;var k=HEAP[g+72]==1651078259;a:do if(!k){i=HEAP[b]=0;if(HEAP[g+72]==1869968492){h=HEAP[e+164];HEAP[b]=HEAP[e+156]}else h=_FT_Lookup_Renderer(e,HEAP[g+72],b);f=7;var j=h,l=g,m=d,o=g+72,n=e,p=h,r=f;for(c=1;;){var q=c==6?u:r,s=c==6?t:p;if((c==6?t:j)==0){a=8;break}var u=FUNCTION_TABLE[HEAP[s+68]](s,l,m,0);if(u==0){a=3;break}if((u&255)!=19){a=5;break}var t=_FT_Lookup_Renderer(n,HEAP[o],b);
i=1;c=6;a=2}if(a==8){f=q;h=s;if(f!=0)break a}else if(a==3){f=0;h=s}else if(a==5){f=u;break a}if(i==0)break a;if(h==0)break a;_FT_Set_Renderer(e,h,0,0)}while(0);e=f;STACKTOP=b;return e}_FT_Render_Glyph_Internal.__index__=Runtime.getFunctionIndex(_FT_Render_Glyph_Internal,"_FT_Render_Glyph_Internal");function _FT_Render_Glyph(e,g){var d,b,a=e==0;a:do if(a)d=0;else{if(HEAP[e+4]==0){d=0;break a}d=HEAP[HEAP[HEAP[e+4]+96]+4];b=_FT_Render_Glyph_Internal(d,e,g);d=3;break a}while(0);if(d==0)b=6;return b}
_FT_Render_Glyph.__index__=Runtime.getFunctionIndex(_FT_Render_Glyph,"_FT_Render_Glyph");
function _FT_Add_Module(e,g){var d=STACKTOP;STACKTOP+=12;Runtime.memset(d,0,12);var b,a=null,c,f,h,i,k,j=d+4,l,m,o=d+8,n=e==0;a:do if(n)m=33;else if(g==0)m=6;else if(reSign(HEAP[g+16],32)>reSign(131076,32))m=4;else{m=e+24;var p=e;f=g+8;a=1;b:for(;;){b=a==4?r:0;a=0+b;h=p+28+a*4;if(!(unSign(HEAP[m],32)>unSign(a,32))){b=8;break b}c=HEAP[h];if(_strcmp(HEAP[HEAP[c]+8],HEAP[f])==0){b=3;break b}var r=b+1;a=4;b=2}if(b!=8)if(b==3){m=HEAP[HEAP[c]+12];if(reSign(HEAP[g+12],32)<=reSign(m,32)){m=5;break a}else _FT_Remove_Module(e,
c)}m=HEAP[e];HEAP[o]=0;p=unSign(HEAP[e+24],32)>unSign(31,32);b:do if(p)HEAP[o]=48;else{c=_ft_mem_alloc(m,HEAP[g+4],o);if(HEAP[o]!=0){b=10;break b}HEAP[c+4]=e;HEAP[c+8]=m;HEAP[c]=g;f=(HEAP[HEAP[c]]&2)!=0;c:do if(f){i=c;h=HEAP[i+4];f=HEAP[h];a=_ft_mem_alloc(f,12,j);b=HEAP[j];if(b!=0){HEAP[o]=b;b=12}else{k=i;l=HEAP[i];HEAP[k+20]=l;HEAP[k+24]=HEAP[l+36];var q=HEAP[l+36]==1869968492;d:do if(q){if(HEAP[HEAP[l+56]+4]==0){b=14;break d}b=FUNCTION_TABLE[HEAP[HEAP[l+56]+4]](f,k+60);HEAP[j]=b;if(HEAP[j]!=0){b=
15;break d}HEAP[k+64]=HEAP[HEAP[l+56]+16];HEAP[k+68]=HEAP[l+40];b=14;break d}else b=14;while(0);d:do if(b==14){HEAP[a+8]=i;i=a;b=h+156;i=i;k=HEAP[b+4];HEAP[i+4]=0;HEAP[i]=k;if(k!=0)HEAP[k+4]=i;else HEAP[b]=i;HEAP[b+4]=i;b=h;h=_FT_Lookup_Renderer(b,1869968492,0);HEAP[b+164]=h;b=HEAP[j];if(b!=0)break d;HEAP[o]=b;b=19;break c}while(0);b=a;f=f;a=b;b!=0&&FUNCTION_TABLE[HEAP[f+8]](f,a);b=HEAP[j];HEAP[o]=b;b=b!=0?12:19}break c}else b=19;while(0);c:do if(b==19){if((HEAP[HEAP[c]]&4)!=0)HEAP[e+168]=c;b=(HEAP[HEAP[c]]&
1&255)!=0;d:do if(b){f=c;HEAP[f+20]=HEAP[c];if((HEAP[HEAP[f]]&512)!=0)break d;a=f+36;f=m;a=a;h=_ft_mem_alloc(f,96,d);i=HEAP[d];if(i==0){HEAP[h]=f;HEAP[a]=h;f=HEAP[d];HEAP[o]=f;if(f!=0){b=12;break c}}else{HEAP[o]=i;b=12;break c}}while(0);if(HEAP[g+24]!=0){b=FUNCTION_TABLE[HEAP[g+24]](c);HEAP[o]=b;if(HEAP[o]!=0){b=12;break c}}m=HEAP[e+24];HEAP[e+28+m*4]=c;HEAP[e+24]=m+1;b=10;break b}while(0);f=(HEAP[HEAP[c]]&1&255)!=0;c:do if(f){a=c;if((HEAP[HEAP[a]]&512)!=0){b=27;break c}h=HEAP[a+36];if(h==0){b=27;
break c}a=HEAP[h];_FT_GlyphLoader_Reset(h);h=h;a=a;h=h;if(h==0){b=27;break c}FUNCTION_TABLE[HEAP[a+8]](a,h)}while(0);a=(HEAP[HEAP[c]]&2)!=0;c:do if(a){f=c;if(HEAP[HEAP[f+20]+36]!=1869968492){b=32;break c}if(HEAP[f+60]==0){b=32;break c}FUNCTION_TABLE[HEAP[HEAP[HEAP[f+20]+56]+20]](HEAP[f+60])}while(0);a=c;c=m;f=a;a!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);c=0}while(0);m=HEAP[o]}while(0);j=m;STACKTOP=d;return j}_FT_Add_Module.__index__=Runtime.getFunctionIndex(_FT_Add_Module,"_FT_Add_Module");
function _FT_Get_Module(e,g){var d,b=null,a,c;c=0;var f=e==0;a:do if(f)d=0;else{if(g==0){d=0;break a}b=e+28;a=a=b+4*HEAP[e+24];f=g;var h=b;for(b=1;;){d=b==5?k:0;var i=h+4*d;if(!(i<a)){d=8;break}if(_strcmp(HEAP[HEAP[HEAP[i]]+8],f)==0){d=4;break}var k=d+1;b=5;d=3}if(d!=8)if(d==4)c=HEAP[i];a=c;d=9;break a}while(0);if(d==0)a=c;return a}_FT_Get_Module.__index__=Runtime.getFunctionIndex(_FT_Get_Module,"_FT_Get_Module");
function _FT_Get_Module_Interface(e,g){var d;d=_FT_Get_Module(e,g);return d!=0?HEAP[HEAP[d]+20]:0}_FT_Get_Module_Interface.__index__=Runtime.getFunctionIndex(_FT_Get_Module_Interface,"_FT_Get_Module_Interface");
function _ft_module_get_service(e,g){var d=null,b,a;b=0;var c=e!=0;a:do if(c){if(HEAP[HEAP[e]+32]!=0){var f=FUNCTION_TABLE[HEAP[HEAP[e]+32]](e,g);b=f;d=0}else{var h=b;d=2}if((d==2?h:f)!=0)break a;a=HEAP[e+4];d=a+28;a=a=d+4*HEAP[a+24];var i=e,k=g,j=d;b=b;d=3;b:for(;;){var l=d==8?q:0,m=d==8?r:b,o=j+4*l;if(!(o<a)){d=5;break b}var n=HEAP[o]!=i;c:do if(n){if(HEAP[HEAP[HEAP[o]]+32]==0){d=6;break c}var p=FUNCTION_TABLE[HEAP[HEAP[HEAP[o]]+32]](HEAP[o],k);if(p!=0){d=7;break b}else d=7}else d=11;while(0);var r=
d==7?0:d==6?m:m,q=l+1;d=8}b=d==7?p:m}while(0);return b}_ft_module_get_service.__index__=Runtime.getFunctionIndex(_ft_module_get_service,"_ft_module_get_service");
function _FT_Remove_Module(e,g){var d,b=null,a,c,f,h,i,k,j,l,m;m=e==0;a:do if(m)c=33;else{if(g!=0){b=e+28;h=c=b+4*HEAP[e+24];k=g;var o=b;b=1;b:for(;;){d=b==4?j:0;f=o+4*d;if(!(f<h)){d=35;break b}if(HEAP[f]==k){d=3;break b}j=d+1;b=4;d=2}if(d!=35)if(d==3){b=f;HEAP[e+24]-=1;c+=-4;if(b<c){m=c;f=b;for(b=5;;){l=b==5?0:l;j=f+4*(l+1);HEAP[f+4*l]=HEAP[j];l=l+1;if(j<m)b=6;else break}}HEAP[c]=0;l=g;c=HEAP[l+8];m=HEAP[l];f=HEAP[l+4];HEAP[l+12+4]!=0&&FUNCTION_TABLE[HEAP[l+12+4]](l);j=f!=0;b:do if(j){if(HEAP[f+
168]!=l)break b;HEAP[f+168]=0}while(0);f=(HEAP[HEAP[l]]&2)!=0;b:do if(f){h=l;j=HEAP[h+4];d=HEAP[j];b=h;k=j+156;b=b;i=k=HEAP[k];o=b;i=i;b=13;c:for(;;){var n=b==16?a:i;if((b==16?a:k)==0)break b;if(HEAP[n+8]==o)break c;a=HEAP[n+4];b=16}b=n;h=h;k=HEAP[HEAP[h+20]+36]==1869968492;c:do if(k){if(HEAP[h+60]==0)break c;FUNCTION_TABLE[HEAP[HEAP[HEAP[h+20]+56]+20]](HEAP[h+60])}while(0);k=b;h=j+156;i=k;k=o=HEAP[i];i=HEAP[i+4];if(o!=0)HEAP[k+4]=i;else HEAP[h]=i;if(i!=0)HEAP[i]=k;else HEAP[h+4]=k;b=b;d=d;h=b;b!=
0&&FUNCTION_TABLE[HEAP[d+8]](d,h);j=j;d=_FT_Lookup_Renderer(j,1869968492,0);HEAP[j+164]=d}while(0);n=(HEAP[HEAP[l]]&1&255)!=0;b:do if(n){a=l;_FT_List_Finalize(a+24,_destroy_face.__index__,HEAP[a+8],a);if((HEAP[HEAP[a]]&512)!=0)break b;f=HEAP[a+36];if(f==0)break b;a=HEAP[f];_FT_GlyphLoader_Reset(f);f=f;a=a;f=f;if(f==0)break b;FUNCTION_TABLE[HEAP[a+8]](a,f)}while(0);HEAP[m+28]!=0&&FUNCTION_TABLE[HEAP[m+28]](l);n=l;a=c;c=n;n!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);c=0;break a}}c=34}while(0);return c}
_FT_Remove_Module.__index__=Runtime.getFunctionIndex(_FT_Remove_Module,"_FT_Remove_Module");function _FT_Reference_Library(e){HEAP[e+196]+=1;return 0}_FT_Reference_Library.__index__=Runtime.getFunctionIndex(_FT_Reference_Library,"_FT_Reference_Library");
function _FT_New_Library(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b;if(e==0)b=6;else{b=_ft_mem_alloc(e,200,d);if(HEAP[d]!=0)b=HEAP[d];else{HEAP[b]=e;HEAP[b+176]=16384;var a=_ft_mem_alloc(e,16384,d);HEAP[b+172]=a;if(HEAP[d]!=0){b!=0&&FUNCTION_TABLE[HEAP[e+8]](e,b);b=HEAP[d]}else{HEAP[b+12]=2;HEAP[b+16]=4;HEAP[b+20]=4;HEAP[b+196]=1;HEAP[g]=b;b=0}}}b=b;STACKTOP=d;return b}_FT_New_Library.__index__=Runtime.getFunctionIndex(_FT_New_Library,"_FT_New_Library");
function _FT_Library_Version(e,g,d,b){var a,c,f;f=c=a=0;if(e!=0){a=HEAP[e+12];c=HEAP[e+16];f=HEAP[e+20]}if(g!=0)HEAP[g]=a;if(d!=0)HEAP[d]=c;if(b!=0)HEAP[b]=f}_FT_Library_Version.__index__=Runtime.getFunctionIndex(_FT_Library_Version,"_FT_Library_Version");
function _FT_Done_Library(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);var d,b=null,a,c,f;if(e==0)e=33;else{HEAP[e+196]-=1;if(HEAP[e+196]==0){f=HEAP[e];HEAP[e+4+4]!=0&&FUNCTION_TABLE[HEAP[e+4+4]](e);HEAP[g]=__str10;HEAP[g+4]=0;b=2;a:for(;;){o=b==2?0:o;var h=g+(0+o)*4;if(unSign(HEAP[e+24],32)>unSign(0,32)){var i=HEAP[h]!=0;b=4;b:for(;;){var k=b==4?0:d;b=k+1;var j=HEAP[e+28+k*4],l=HEAP[HEAP[j]+8];c:do if(i){d=_strcmp(l,HEAP[h])!=0?7:8;break c}else d=8;while(0);c:do if(d==8){if((HEAP[HEAP[j]]&
1)==0)break c;var m=j+24;if(HEAP[m]==0)break c;for(m=l=m;;){_FT_Done_Face(HEAP[HEAP[l]+8]);if(HEAP[m]!=0)d=11;else break c}}while(0);d=k+1;if(unSign(HEAP[e+24],32)>unSign(b,32))b=7;else break b}}var o=o+1;if(o!=2)b=14;else break a}if(HEAP[e+24]!=0){b=15;d=16}else{b=15;d=17}for(;;)if(d==16){_FT_Remove_Module(e,HEAP[e+28+(HEAP[(b==16?n:e)+24]-1)*4]);var n=e;if(HEAP[e+24]!=0)d=b=16;else{b=16;d=17}}else if(d==17){n=HEAP[(b==15?e:n)+172];a=f;c=n;d=n!=0?18:19;break}d==18&&FUNCTION_TABLE[HEAP[a+8]](a,c);
HEAP[e+172]=0;HEAP[e+176]=0;e!=0&&FUNCTION_TABLE[HEAP[f+8]](f,e)}e=0}e=e;STACKTOP=g;return e}_FT_Done_Library.__index__=Runtime.getFunctionIndex(_FT_Done_Library,"_FT_Done_Library");function _FT_Set_Debug_Hook(e,g,d){var b=e!=0;a:do if(b){if(d==0)break a;if(!(unSign(g,32)<=unSign(3,32)))break a;HEAP[e+180+g*4]=d}while(0)}_FT_Set_Debug_Hook.__index__=Runtime.getFunctionIndex(_FT_Set_Debug_Hook,"_FT_Set_Debug_Hook");
function _FT_Get_TrueType_Engine_Type(e){var g,d;g=0;var b=e!=0;a:do if(b){d=_FT_Get_Module(e,__str49);if(d==0)break a;d=_ft_module_get_service(d,__str11);if(d==0)break a;g=HEAP[d]}while(0);return g}_FT_Get_TrueType_Engine_Type.__index__=Runtime.getFunctionIndex(_FT_Get_TrueType_Engine_Type,"_FT_Get_TrueType_Engine_Type");
function _ft_stub_set_char_sizes(e,g,d,b,a){var c=STACKTOP;STACKTOP+=20;Runtime.memset(c,0,20);var f=null,h;b=b;a=a;h=HEAP[HEAP[e]+96];if(HEAP[HEAP[h+20]+96]!=0){HEAP[c]=0;HEAP[c+4]=g;HEAP[c+8]=d;d=b;g=a;if(d==0){b=g;f=0}else f=5;f=f==5?d:g;if(g==0)a=f;if(f==0)b=a=72;HEAP[c+12]=b;HEAP[c+16]=a;e=FUNCTION_TABLE[HEAP[HEAP[h+20]+96]](e,c)}else e=0;e=e;STACKTOP=c;return e}_ft_stub_set_char_sizes.__index__=Runtime.getFunctionIndex(_ft_stub_set_char_sizes,"_ft_stub_set_char_sizes");
function _ft_stub_set_pixel_sizes(e,g,d){var b=STACKTOP;STACKTOP+=20;Runtime.memset(b,0,20);var a;a=HEAP[HEAP[e]+96];if(HEAP[HEAP[a+20]+96]!=0){HEAP[b]=0;HEAP[b+4]=g<<6;HEAP[b+8]=d<<6;HEAP[b+12]=0;HEAP[b+16]=0;e=FUNCTION_TABLE[HEAP[HEAP[a+20]+96]](e,b)}else e=0;e=e;STACKTOP=b;return e}_ft_stub_set_pixel_sizes.__index__=Runtime.getFunctionIndex(_ft_stub_set_pixel_sizes,"_ft_stub_set_pixel_sizes");
function _FT_Get_SubGlyph_Info(e,g,d,b,a,c,f){var h,i=e!=0;a:do if(i){if(HEAP[e+132]==0)break a;if(HEAP[e+72]!=1668246896)break a;h=g;if(!(unSign(HEAP[e+128],32)>unSign(h,32)))break a;h=HEAP[e+132]+32*g;HEAP[d]=HEAP[h];var k=unSign(HEAP[h+4],16);HEAP[b]=k;HEAP[a]=HEAP[h+8];HEAP[c]=HEAP[h+12];k=f;h=h+16;HEAP[k]=HEAP[h];HEAP[k+4]=HEAP[h+4];HEAP[k+8]=HEAP[h+8];HEAP[k+12]=HEAP[h+12]}while(0);return 6}_FT_Get_SubGlyph_Info.__index__=Runtime.getFunctionIndex(_FT_Get_SubGlyph_Info,"_FT_Get_SubGlyph_Info");
function _FT_Outline_Decompose(e,g,d){var b=STACKTOP;STACKTOP+=88;Runtime.memset(b,0,88);var a,c=null,f=b+8,h,i=b+16,k=b+24,j=b+32,l,m,o,n,p,r,q,s,u,t=b+40,v=b+48,w=b+56,x=b+64,y=b+72,A=b+80,z=e==0;a:do if(z)a=0;else{if(g==0){a=0;break a}q=HEAP[g+16];s=HEAP[g+20];p=o=0;var C=f,B=f+4,D=j,E=f,F=j+4,G=f+4,H=j,J=j,L=j+4,N=j+4,I=b,P=b+4,K=i,O=b,M=i+4,Q=b+4,R=i,T=i,V=i+4,U=i+4,S=k,X=j,Y=k+4,W=j+4,da=j,ba=i,aa=j+4,ca=i+4,$=i,la=j,ga=j+4,ea=i+4,Z=j+4,ha=i,ia=j,ja=i+4,fa=j+4,ka=x,na=x+4,sa=y,wa=y+4,Aa=A,Da=
A+4,pa=k,ta=k+4,ma=v,ya=v+4,qa=k,ua=v,Ba=w,Na=k+4,Ea=v+4,ra=w+4,za=k,Ha=v,Ca=k+4,va=v+4,Pa=t,Ja=t+4;b:for(;;){m=reSign(HEAP[e],16);u=p;if(!(reSign(m,32)>reSign(u,32))){a=26;break b}u=reSign(HEAP[HEAP[e+12]+2*p],16);if(reSign(u,32)<reSign(0,32)){a=4;break b}m=HEAP[e+4]+8*u;l=HEAP[e+4]+8*o;HEAP[C]=HEAP[l];HEAP[B]=HEAP[l+4];HEAP[D]=HEAP[E];HEAP[F]=HEAP[G];HEAP[J]=(HEAP[H]<<q)-s;HEAP[N]=(HEAP[L]<<q)-s;l=HEAP[e+4]+8*u;HEAP[I]=HEAP[l];HEAP[P]=HEAP[l+4];HEAP[K]=HEAP[O];HEAP[M]=HEAP[Q];HEAP[T]=(HEAP[R]<<
q)-s;HEAP[U]=(HEAP[V]<<q)-s;HEAP[S]=HEAP[X];HEAP[Y]=HEAP[W];l=HEAP[e+4]+8*o;o=HEAP[e+8]+o;r=reSign(HEAP[o],8)&3;if(r==2){a=4;break b}if(r==0){if((reSign(HEAP[HEAP[e+8]+u],8)&3)==1){HEAP[da]=HEAP[ba];HEAP[aa]=HEAP[ca];m+=-8}else{n=Math.floor(reSign(HEAP[$]+HEAP[da],32)/reSign(2,32));HEAP[la]=n;n=Math.floor(reSign(HEAP[ea]+HEAP[ga],32)/reSign(2,32));HEAP[Z]=n;HEAP[ha]=HEAP[ia];HEAP[ja]=HEAP[fa]}l+=-8;o+=-1}n=r=FUNCTION_TABLE[HEAP[g]](j,d);if(r!=0){a=9;break b}c:for(;;){if(!(l<m)){a=23;break c}l+=8;
o+=1;a=r=reSign(HEAP[o],8)&3;a=a==0?11:a==1?28:29;if(a==29){if(l+8>m){a=4;break b}if((reSign(HEAP[o+1],8)&3)!=2){a=4;break b}l+=16;o+=2;HEAP[ka]=(HEAP[l+-16]<<q)-s;HEAP[na]=(HEAP[l+-16+4]<<q)-s;HEAP[sa]=(HEAP[l+-8]<<q)-s;HEAP[wa]=(HEAP[l+-8+4]<<q)-s;if(!(l<=m)){a=21;break c}HEAP[Aa]=(HEAP[l]<<q)-s;HEAP[Da]=(HEAP[l+4]<<q)-s;n=FUNCTION_TABLE[HEAP[g+12]](x,y,A,d);if(n!=0){a=9;break b}else a=10}else if(a==11){HEAP[pa]=(HEAP[l]<<q)-s;HEAP[ta]=(HEAP[l+4]<<q)-s;a=m;r=q;var La=s,xa=q,oa=s,Fa=g+8,Ma=d,Ka=
n;o=o;for(c=11;;){var Ra=c==16?ab:0,Qa=c==16?0:Ka,Va=o+(Ra+1);if(!(l<a)){a=14;break c}l+=8;var Ta=reSign(HEAP[Va],8)&3;HEAP[ma]=(HEAP[l]<<r)-La;HEAP[ya]=(HEAP[l+4]<<xa)-oa;if(Ta==1)break;else if(Ta!=0){a=32;break b}var Ua=Math.floor(reSign(HEAP[ua]+HEAP[qa],32)/reSign(2,32));HEAP[Ba]=Ua;Ua=Math.floor(reSign(HEAP[Ea]+HEAP[Na],32)/reSign(2,32));HEAP[ra]=Ua;Ua=FUNCTION_TABLE[HEAP[Fa]](k,w,Ma);if(Ua!=0){a=15;break b}HEAP[za]=HEAP[Ha];HEAP[Ca]=HEAP[va];var ab=Ra+1;c=16}o=Va;n=FUNCTION_TABLE[HEAP[g+8]](k,
v,d);if(n!=0){a=9;break b}else a=10}else if(a==28){HEAP[Pa]=(HEAP[l]<<q)-s;HEAP[Ja]=(HEAP[l+4]<<q)-s;n=FUNCTION_TABLE[HEAP[g+4]](t,d);if(n!=0){a=9;break b}else a=10}}if(a==23){var Sa=FUNCTION_TABLE[HEAP[g+4]](j,d);n=Sa;c=23}else if(a==21){var $a=FUNCTION_TABLE[HEAP[g+12]](x,y,j,d);n=$a;c=21}else if(a==14){var Wa=FUNCTION_TABLE[HEAP[g+8]](k,j,d);n=Wa;c=14}if((c==23?Sa:c==21?$a:Wa)!=0){a=9;break b}o=u+1;p+=1;a=3}b:do if(a==26){h=0;a=27;break a}else if(a==32){n=Qa;a=4;break b}else if(a==15){n=Ua;a=9;
break b}while(0);if(a==4){h=20;a=27;break a}else if(a==9){h=n;a=27;break a}}while(0);if(a==0)h=6;e=h;STACKTOP=b;return e}_FT_Outline_Decompose.__index__=Runtime.getFunctionIndex(_FT_Outline_Decompose,"_FT_Outline_Decompose");
function _FT_Outline_New_Internal(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c,f,h=b==0;a:do if(h)c=0;else{if(e==0){c=0;break a}c=b;HEAP[c]=0;HEAP[c+2]=0;HEAP[c+4]=0;HEAP[c+8]=0;HEAP[c+12]=0;HEAP[c+16]=0;c=_ft_mem_realloc(e,8,0,g,0,a);HEAP[b+4]=c;c=HEAP[a]!=0;b:do if(!c){c=_ft_mem_realloc(e,1,0,g,0,a);HEAP[b+8]=c;if(HEAP[a]!=0)break b;c=_ft_mem_realloc(e,2,0,d,0,a);HEAP[b+12]=c;if(HEAP[a]!=0)break b;HEAP[b+2]=g&65535;HEAP[b]=d&65535;HEAP[b+16]|=1;f=0;c=6;break a}while(0);HEAP[b+
16]|=1;_FT_Outline_Done_Internal(e,b);f=HEAP[a];c=6;break a}while(0);if(c==0)f=6;e=f;STACKTOP=a;return e}_FT_Outline_New_Internal.__index__=Runtime.getFunctionIndex(_FT_Outline_New_Internal,"_FT_Outline_New_Internal");function _FT_Outline_New(e,g,d,b){return e==0?33:_FT_Outline_New_Internal(HEAP[e],g,d,b)}_FT_Outline_New.__index__=Runtime.getFunctionIndex(_FT_Outline_New,"_FT_Outline_New");
function _FT_Outline_Check(e){var g,d=null,b,a,c,f,h,i=e!=0;a:do if(i){a=reSign(HEAP[e+2],16);c=reSign(HEAP[e],16);var k=a;if(k==0)if(c==0){g=b=0;break a}else{var j=a;d=1}else d=13;if(reSign(d==1?j:k,32)<=reSign(0,32)){g=3;break a}if(reSign(c,32)<=reSign(0,32)){g=3;break a}f=h=-1;c=c;k=e+12;var l=a;h=h;f=f;for(d=5;;){g=d==8?p:0;var m=d==8?n:f,o=d==8?n:h;d=0+g;if(!(reSign(d,32)<reSign(c,32))){g=10;break}var n=reSign(HEAP[HEAP[k]+2*d],16);d=reSign(n,32)<=reSign(m,32);m=reSign(n,32)>=reSign(l,32);if(d|
m){g=7;break}var p=g+1;d=8;g=6}if(g==10){h=o;if(a-1!=h){g=3;break a}g=b=0;break a}else if(g==7){g=3;break a}}else g=3;while(0);if(g==3)b=6;return b}_FT_Outline_Check.__index__=Runtime.getFunctionIndex(_FT_Outline_Check,"_FT_Outline_Check");
function _FT_Outline_Copy(e,g){var d,b,a=e==0;a:do if(a)d=0;else{if(g==0){d=0;break a}if(HEAP[e+2]!=HEAP[g+2]){d=0;break a}if(HEAP[e]!=HEAP[g]){d=0;break a}if(e!=g){d=reSign(HEAP[e+2],16)*8;_llvm_memcpy_p0i8_p0i8_i32(HEAP[g+4],HEAP[e+4],d,1,0);d=reSign(HEAP[e+2],16);_llvm_memcpy_p0i8_p0i8_i32(HEAP[g+8],HEAP[e+8],d,1,0);d=reSign(HEAP[e],16)*2;_llvm_memcpy_p0i8_p0i8_i32(HEAP[g+12],HEAP[e+12],d,1,0);d=HEAP[g+16]&1;HEAP[g+16]=HEAP[e+16];HEAP[g+16]&=-2;HEAP[g+16]=d|HEAP[g+16]}b=0;d=5;break a}while(0);
if(d==0)b=6;return b}_FT_Outline_Copy.__index__=Runtime.getFunctionIndex(_FT_Outline_Copy,"_FT_Outline_Copy");
function _FT_Outline_Done_Internal(e,g){var d,b,a=e==0;a:do if(a)d=0;else{if(g==0){d=0;break a}if((HEAP[g+16]&1&255)!=0){b=HEAP[g+4];d=e;b=b;b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+4]=0;a=HEAP[g+8];d=e;b=a;a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+8]=0;a=HEAP[g+12];d=e;b=a;a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+12]=0}d=g;HEAP[d]=0;HEAP[d+2]=0;HEAP[d+4]=0;HEAP[d+8]=0;HEAP[d+12]=0;b=HEAP[d+16]=0;d=6;break a}while(0);if(d==0)b=6;return b}
_FT_Outline_Done_Internal.__index__=Runtime.getFunctionIndex(_FT_Outline_Done_Internal,"_FT_Outline_Done_Internal");function _FT_Outline_Done(e,g){return e==0?33:_FT_Outline_Done_Internal(HEAP[e],g)}_FT_Outline_Done.__index__=Runtime.getFunctionIndex(_FT_Outline_Done,"_FT_Outline_Done");
function _FT_Outline_Get_CBox(e,g){var d=null,b,a,c,f,h,i,k=e!=0;a:do if(k){if(g==0)break a;var j=HEAP[e+2]==0;b:do if(j)f=c=a=b=0;else{h=HEAP[e+4];i=reSign(HEAP[e+2],16);i=h+8*i;b=c=HEAP[h];a=f=HEAP[h+4];h+=8;if(!(h<i))break b;i=i;h=h;b=b;f=f;a=a;c=c;for(d=3;;){q=d==3?0:q;n=d==3?c:n;p=d==3?a:p;r=d==3?f:r;o=d==3?b:o;var l=h+8*q+4;d=h+8*(q+1);var m=HEAP[h+8*q],o=reSign(m,32)<reSign(o,32)?m:o,n=reSign(m,32)>reSign(n,32)?m:n;l=HEAP[l];var p=reSign(l,32)<reSign(p,32)?l:p,r=reSign(l,32)>reSign(r,32)?l:
r,q=q+1;if(d<i)d=5;else break}c=n;a=p;f=r;b=o}while(0);HEAP[g]=b;HEAP[g+8]=c;HEAP[g+4]=a;HEAP[g+12]=f}while(0)}_FT_Outline_Get_CBox.__index__=Runtime.getFunctionIndex(_FT_Outline_Get_CBox,"_FT_Outline_Get_CBox");
function _FT_Outline_Translate(e,g,d){var b=null,a,c=e==0;a:do if(!c){a=HEAP[e+4];var f=unSign(0,16),h=reSign(HEAP[e+2],16);if(!(reSign(f,32)<reSign(h,32)))break a;f=g;h=d;var i=e+2;a=a;var k=unSign(1,16);for(b=0;;){m=b==0?0:m;b=k+m&65535;var j=a+8*m+4,l=a+8*m;HEAP[l]=f+HEAP[l];HEAP[j]=h+HEAP[j];b=unSign(b,16);j=reSign(HEAP[i],16);b=reSign(b,32)<reSign(j,32);var m=m+1;if(b)b=2;else break}}while(0)}_FT_Outline_Translate.__index__=Runtime.getFunctionIndex(_FT_Outline_Translate,"_FT_Outline_Translate");
function _FT_Outline_Reverse(e){var g=STACKTOP;STACKTOP+=24;Runtime.memset(g,0,24);var d=null,b=g+8,a,c,f,h,i,k=g+16;if(e!=0){a=c=0;var j=unSign(a,16),l=reSign(HEAP[e],16);j=reSign(j,32)<reSign(l,32);a:do if(j){l=b;var m=b+4,o=k,n=k+4,p=g,r=g+4;d=0;for(;;){f=HEAP[(d==0?e:f)+12];h=unSign(a,16);f=reSign(HEAP[f+2*h],16);h=HEAP[e+4]+8*c;i=HEAP[e+4]+8*f;if(h<i){h=h;i=i;for(d=2;;){z=d==2?0:z;var q=z*-1;d=i+8*(q+-1);var s=i+8*q,u=i+8*q+4,t=h+8*(z+1),v=h+8*z,w=h+8*z+4;q=HEAP[v];var x=HEAP[w],y=HEAP[s],A=
HEAP[u];HEAP[v]=y;HEAP[w]=A;HEAP[s]=q;HEAP[u]=x;var z=z+1;if(t<d)d=3;else break}HEAP[r]=A;HEAP[p]=y;HEAP[n]=x;HEAP[o]=q;HEAP[m]=x;HEAP[l]=q}c=HEAP[e+8]+c;h=HEAP[e+8]+f;if(c<h){c=c;h=h;for(d=6;;){C=d==6?0:C;d=C*-1;i=h+(d+-1);s=h+d;d=c+(C+1);t=c+C;u=HEAP[t];HEAP[t]=HEAP[s];HEAP[s]=u;var C=C+1;if(d<i)d=7;else break}}c=f+1;a+=1;f=unSign(a,16);h=reSign(HEAP[e],16);h=reSign(f,32)<reSign(h,32);f=e;if(h)d=10;else{d=10;break a}}}else d=12;while(0);HEAP[e+16]=HEAP[(d==12?e:f)+16]^4}STACKTOP=g}
_FT_Outline_Reverse.__index__=Runtime.getFunctionIndex(_FT_Outline_Reverse,"_FT_Outline_Reverse");
function _FT_Outline_Render(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c=null,f,h;h=0;c=e==0;a:do if(c)f=33;else{f=g==0;b:do if(!f){if(d==0){a=1;break b}f=HEAP[e+164];HEAP[b]=HEAP[e+156];HEAP[d+4]=g;g=19;var i=f;d=d;var k=e,j=f,l=g;c=2;c:for(;;){var m=c==7?n:l,o=c==7?p:j;if((c==7?p:i)==0){a=9;break c}var n=FUNCTION_TABLE[HEAP[o+64]](HEAP[o+60],d);if(n==0){a=4;break c}if((n&255)!=19){a=6;break c}var p=_FT_Lookup_Renderer(k,1869968492,b);h=1;c=7;a=3}c:do if(a==9){g=m;f=o;a=g==0?11:
10;break c}else if(a==4){g=0;f=o;a=11;break c}else if(a==6){g=n;f=o;a=10;break c}while(0);c:do if(a==11){if(h==0)break c;if(f==0)break c;_FT_Set_Renderer(e,f,0,0)}while(0);f=g;break a}while(0);f=6}while(0);e=f;STACKTOP=b;return e}_FT_Outline_Render.__index__=Runtime.getFunctionIndex(_FT_Outline_Render,"_FT_Outline_Render");
function _FT_Outline_Get_Bitmap(e,g,d){var b=STACKTOP;STACKTOP+=48;Runtime.memset(b,0,48);var a;if(d==0)e=6;else{HEAP[b]=d;HEAP[b+8]=0;var c=HEAP[d+18]==2;a:do if(c)a=1;else{if(HEAP[d+18]==5){a=1;break a}a=HEAP[d+18]==6?1:3;break a}while(0);if(a==1)HEAP[b+8]|=1;e=_FT_Outline_Render(e,g,b)}e=e;STACKTOP=b;return e}_FT_Outline_Get_Bitmap.__index__=Runtime.getFunctionIndex(_FT_Outline_Get_Bitmap,"_FT_Outline_Get_Bitmap");
function _FT_Vector_Transform(e,g){var d,b,a=e==0;a:do if(!a){if(g==0)break a;d=_FT_MulFix(HEAP[e],HEAP[g]);d=_FT_MulFix(HEAP[e+4],HEAP[g+4])+d;b=_FT_MulFix(HEAP[e],HEAP[g+8]);b=_FT_MulFix(HEAP[e+4],HEAP[g+12])+b;HEAP[e]=d;HEAP[e+4]=b}while(0)}_FT_Vector_Transform.__index__=Runtime.getFunctionIndex(_FT_Vector_Transform,"_FT_Vector_Transform");
function _FT_Outline_Transform(e,g){var d=null,b,a,c=e==0;a:do if(!c){if(g==0)break a;b=HEAP[e+4];var f=reSign(HEAP[e+2],16);a=b+8*f;if(!(b<a))break a;f=g;a=a;b=b;for(d=2;;){h=d==2?0:h;d=b+8*(h+1);_FT_Vector_Transform(b+8*h,f);var h=h+1;if(d<a)d=3;else break}}while(0)}_FT_Outline_Transform.__index__=Runtime.getFunctionIndex(_FT_Outline_Transform,"_FT_Outline_Transform");
function _FT_Outline_Embolden(e,g){var d=STACKTOP;STACKTOP+=96;Runtime.memset(d,0,96);var b=null,a=d+8,c=d+16,f,h=d+24,i=d+32,k=d+40,j,l=d+48,m=d+56,o=d+64,n=d+72,p,r=d+80,q=d+88;f=g;if(e==0)a=6;else{f=Math.floor(reSign(f,32)/reSign(2,32));if(f==0)a=0;else{j=_FT_Outline_Get_Orientation(e);if(j==2)a=HEAP[e]!=0?6:0;else{p=j==0?-5898240:5898240;j=HEAP[e+4];var s=reSign(HEAP[e],16);if(reSign(s,32)>reSign(0,32)){s=e+12;var u=k+4,t=i+4,v=h+4,w=h+4,x=r+4,y=q+4,A=d+4,z=f;p=0-p;var C=e+4,B=f,D=e+4,E=n+4;f=
f;var F=r+4,G=l+4,H=o+4,J=r+4,L=r+4,N=a+4,I=a+4,P=c+4,K=c+4,O=m+4,M=HEAP[h];b=2;a:for(;;){Da=b==2?0:Da;var Q=b==2?0:Aa;wa=b==2?M:wa;var R=1+Da,T=HEAP[HEAP[s]+2*(0+Da)];Aa=reSign(T,16);var V=j+8*Q,U=HEAP[V];V=HEAP[V+4];var S=j+8*Aa,X=HEAP[S];S=HEAP[S+4];if(reSign(Q,32)<=reSign(Aa,32)){T=reSign(T,16)+1-Q;var Y=Q+1;for(b=4;;){sa=b==4?0:sa;ga=b==4?wa:ga;var W=b==4?S:ba,da=b==4?X:aa,ba=b==4?V:ea,aa=b==4?U:Z,ca=Q+sa;Z=Y+sa;ea=j+8*Z+4;Z=j+8*Z;if(reSign(ca,32)<reSign(Aa,32)){var $=HEAP[Z];HEAP[v]=HEAP[ea];
var la=HEAP[w];b=6}else b=5;var ga=b==6?$:ga,ea=b==6?la:V,Z=b==6?$:U;HEAP[r]=aa-da;b=ba-W;HEAP[x]=b;W=Z-aa;da=ea-ba;var ha=HEAP[r];if(ha==0&b==0)b=31;else{HEAP[c]=ha;HEAP[P]=b;_ft_trig_prenorm(c);_ft_trig_pseudo_polarize(c);var ia=HEAP[K];b=8}ha=b==8?ia:0;if(W==0&da==0)b=32;else{HEAP[a]=W;HEAP[N]=da;_ft_trig_prenorm(a);_ft_trig_pseudo_polarize(a);var ja=HEAP[I];b=10}b=reSign((b==10?ja:0)-ha,32)%reSign(23592960,32);var fa=b+23592960;b=reSign(b,32)<reSign(0,32)?fa:b;fa=b-23592960;b=reSign(b,32)>reSign(11796480,
32)?fa:b;fa=Math.floor(reSign(b,32)/reSign(2,32));HEAP[d]=72899491;HEAP[A]=0;_ft_trig_pseudo_rotate(d,fa);fa=Math.floor(reSign(HEAP[d],32)/reSign(4096,32));var ka=reSign(fa,32)>reSign(16383,32),na=reSign(fa,32)<=reSign(-16384,32);if(ka|na){fa=_FT_DivFix(z,fa);b=Math.floor(reSign(b,32)/reSign(2,32));b=ha+b+p;HEAP[r]=fa;HEAP[r+4]=0;_FT_Vector_Rotate(r,b)}else{HEAP[J]=0;HEAP[r]=HEAP[L]}HEAP[HEAP[C]+8*ca]=B+aa+HEAP[r];HEAP[HEAP[D]+8*ca+4]=f+ba+HEAP[F];var sa=sa+1;if(sa!=T)b=15;else break}HEAP[q]=W;HEAP[y]=
da;HEAP[H]=ea;HEAP[o]=Z;b=16}else b=3;var wa=b==16?ga:wa;Q=b==16?ba:S;T=b==16?aa:X;Y=b==16?ea:V;ca=b==16?Z:U;var Aa=Aa+1;b=reSign(HEAP[e],16);R=reSign(b,32)>reSign(R,32);var Da=Da+1;if(R)b=18;else break a}HEAP[t]=S;HEAP[i]=X;HEAP[u]=V;HEAP[k]=U;HEAP[O]=V;HEAP[m]=U;HEAP[h]=wa;HEAP[G]=Q;HEAP[l]=T;HEAP[E]=Y;HEAP[n]=ca}a=0}}}a=a;STACKTOP=d;return a}_FT_Outline_Embolden.__index__=Runtime.getFunctionIndex(_FT_Outline_Embolden,"_FT_Outline_Embolden");
function _FT_Outline_Get_Orientation(e){var g=STACKTOP;STACKTOP+=24;Runtime.memset(g,0,24);var d,b=null,a,c,f,h,i,k,j,l=g+12;c=b=32768;f=-32768;i=h=0;HEAP[l]=2;HEAP[l+4]=2;HEAP[l+8]=2;var m=e==0;a:do if(m)d=0;else{if(reSign(HEAP[e+2],16)<=reSign(0,16)){d=0;break a}d=HEAP[e+4];k=HEAP[e+12];a=HEAP[e+12];m=reSign(HEAP[e],16);if(a+2*m>k){a=e+4;m=e+12;e=e;k=k;var o=d,n=b;b=3;b:for(;;){F=b==3?0:F;var p=b==3?n:j;E=b==3?o:E;var r=k+2*(F+1);d=HEAP[a];b=reSign(HEAP[k+2*F],16);var q=d+8*b,s=E+16>q;c:do if(s)b=
4;else{j=E;if(j<=q){b=5;d=6}else{b=5;d=7}for(;;)if(d==6){d=b==16?w:-32768;y=b==16?y:32768;z=b==16?z:-32768;t=b==16?t:32768;if(reSign(HEAP[j],32)<reSign(t,32)){var u=HEAP[j];b=8}else b=6;var t=b==8?u:t;if(reSign(HEAP[j],32)>reSign(d,32)){var v=HEAP[j];b=10}else b=52;var w=b==10?v:d;if(reSign(HEAP[j+4],32)<reSign(y,32)){var x=HEAP[j+4];b=12}else b=53;var y=b==12?x:y;if(reSign(HEAP[j+4],32)>reSign(z,32)){var A=HEAP[j+4];b=14}else b=54;var z=b==14?A:z;j+=8;if(j<=q){b=16;d=6}else{b=16;d=7}}else if(d==
7){d=b==5?-32768:w;var C=b==5?32768:y,B=b==5?-32768:z,D=b==5?32768:t;if(reSign(D,32)<reSign(p,32)&D!=d&C!=B)break;else{b=7;break c}}c=C;f=B;h=E;i=q;b=17}while(0);j=b==17?D:b==7?p:p;var E=q+8;d=HEAP[m];b=reSign(HEAP[e],16);var F=F+1;if(d+2*b>r)b=18;else break b}b=j}if(b!=32768){d=reSign(c*3+f,32)>>reSign(2,32);HEAP[g]=d;d=reSign(f+c,32)>>reSign(1,32);HEAP[g+4]=d;d=reSign(f*3+c,32)>>reSign(2,32);HEAP[g+8]=d;c=i;h=h;i=i;b=46;b:for(;;){X=b==46?0:X;d=0+X;u=g+d*4;f=l+d*4;c:for(;;){j=h;b=23;d:for(;;){var G=
b==29?M:0,H=b==29?Q:0,J=b==29?R:0,L=b==29?T:0;v=b==29?V:32768;x=b==29?U:-32768;A=b==29?S:c;if(!(j<=i))break c;if(HEAP[j+4]==HEAP[u])break d;if(HEAP[A+4]==HEAP[u])break d;M=HEAP[u];M=reSign(HEAP[j+4],32)>=reSign(M,32);e:do if(M)d=30;else{M=HEAP[u];if(reSign(HEAP[A+4],32)<reSign(M,32)){b=28;d=29}else{b=28;d=30}break e}while(0);e:do if(d==30){M=HEAP[u];if(!(reSign(HEAP[j+4],32)<=reSign(M,32))){M=HEAP[u];if(reSign(HEAP[A+4],32)>reSign(M,32)){b=31;break e}}var N=_FT_MulDiv(HEAP[j]-HEAP[A],HEAP[u]-HEAP[A+
4],HEAP[j+4]-HEAP[A+4]);N=HEAP[A]+N;var I=reSign(N,32)<reSign(v,32),P=j;P=I?P:J;var K=I?A:L;I=I?N:v;if(!(reSign(N,32)>reSign(x,32))){b=33;break e}var O=j;b=34}while(0);var M=b==34?O:b==33?G:b==31?G:G,Q=b==34?A:b==33?H:b==31?H:H,R=b==34?P:b==33?P:b==31?J:J,T=b==34?K:b==33?K:b==31?L:L,V=b==34?I:b==33?I:b==31?v:v,U=b==34?N:b==33?x:b==31?x:x,S=j;j+=8;b=29}HEAP[u]+=1}d=L!=0&H!=0;c:do if(d){b=HEAP[J+4];b=reSign(HEAP[L+4],32)>=reSign(b,32);d:do if(!b){b=HEAP[G+4];if(reSign(HEAP[H+4],32)<=reSign(b,32))break d;
HEAP[f]=0;break c}while(0);b=HEAP[J+4];b=reSign(HEAP[L+4],32)<=reSign(b,32);d:do if(!b){b=HEAP[G+4];if(reSign(HEAP[H+4],32)>=reSign(b,32))break d;HEAP[f]=1;break c}while(0);HEAP[f]=2}while(0);var X=X+1;if(X!=3)b=40;else break b}G=HEAP[l]!=2;b:do if(G){if(HEAP[l]!=HEAP[l+4])if(HEAP[l]!=HEAP[l+8])break b;a=HEAP[l];d=22;break a}while(0);G=HEAP[l+4]!=2;b:do if(G){if(HEAP[l+4]!=HEAP[l+8])break b;a=HEAP[l+4];d=22;break a}while(0)}a=0;d=22;break a}while(0);if(d==0)a=0;l=a;STACKTOP=g;return l}
_FT_Outline_Get_Orientation.__index__=Runtime.getFunctionIndex(_FT_Outline_Get_Orientation,"_FT_Outline_Get_Orientation");
function _FT_Raccess_Get_HeaderInfo(e,g,d,b,a){e=STACKTOP;STACKTOP+=36;Runtime.memset(e,0,36);var c=null,f,h,i;f=e+4;var k=e+20;h=_FT_Stream_Seek(g,d);HEAP[e]=h;c=HEAP[e]!=0;a:do if(c)h=HEAP[e];else{i=f;h=g;i=i;h=h=_FT_Stream_ReadAt(h,HEAP[h+8],i,16);HEAP[e]=h;if(HEAP[e]!=0)h=HEAP[e];else{h=unSign(HEAP[f],8)<<24;i=unSign(HEAP[f+1],8)<<16;var j=unSign(HEAP[f+2],8)<<8,l=unSign(HEAP[f+3],8);HEAP[a]=(i|h|l|j)+d;h=unSign(HEAP[f+4],8)<<24;i=unSign(HEAP[f+5],8)<<16;j=unSign(HEAP[f+6],8)<<8;l=unSign(HEAP[f+
7],8);h=(i|h|l|j)+d;i=unSign(HEAP[f+8],8)<<24;j=unSign(HEAP[f+9],8)<<16;l=unSign(HEAP[f+10],8)<<8;var m=unSign(HEAP[f+11],8);i=j|i|m|l;i=i+HEAP[a]!=h;b:do if(!i){if(h==d)break b;d=_FT_Stream_Seek(g,h);HEAP[e]=d;if(HEAP[e]!=0)h=HEAP[e];else{HEAP[k+15]=HEAP[f+15]+1;a=k;d=g;a=a;d=d=_FT_Stream_ReadAt(d,HEAP[d+8],a,16);HEAP[e]=d;if(HEAP[e]!=0)h=HEAP[e];else{d=a=1;c=4;c:for(;;){o=c==4?0:o;i=0+o;c=k+i;i=f+i;if(HEAP[c]!=0)a=0;if(HEAP[c]!=HEAP[i])d=0;var o=o+1;if(o!=16)c=8;else break c}f=a==0;c:do if(f){if(d!=
0)break c;h=2;break a}while(0);f=g;f=f=_FT_Stream_Seek(f,8+HEAP[f+8]);HEAP[e]=f;f=_FT_Stream_ReadShort(g,e);f=unSign(f,16);if(HEAP[e]!=0)h=HEAP[e];else if(f==-1)h=2;else{g=_FT_Stream_Seek(g,f+h);HEAP[e]=g;if(HEAP[e]!=0)h=HEAP[e];else{HEAP[b]=f+h;h=0}}}}break a}while(0);h=2}}while(0);b=h;STACKTOP=e;return b}_FT_Raccess_Get_HeaderInfo.__index__=Runtime.getFunctionIndex(_FT_Raccess_Get_HeaderInfo,"_FT_Raccess_Get_HeaderInfo");
function _ft_raccess_sort_ref_by_id(e,g){var d;d=HEAP[g];if(unSign(HEAP[e],16)<unSign(d,16))d=-1;else{d=HEAP[g];d=unSign(HEAP[e],16)>unSign(d,16)?1:0}return d}_ft_raccess_sort_ref_by_id.__index__=Runtime.getFunctionIndex(_ft_raccess_sort_ref_by_id,"_ft_raccess_sort_ref_by_id");
function _FT_Raccess_Get_DataOffsets(e,g,d,b,a,c,f){var h=STACKTOP;STACKTOP+=4;Runtime.memset(h,0,4);var i,k=null,j,l,m;e=HEAP[e];k=_FT_Stream_Seek(g,d);HEAP[h]=k;if(HEAP[h]!=0)j=HEAP[h];else{k=_FT_Stream_ReadShort(g,h);k=unSign(k,16);if(HEAP[h]!=0)j=HEAP[h];else{k+=1;var o=k;k=1;a:for(;;){i=k==8?n:0;if(!(reSign(0+i,32)<reSign(o,32))){i=27;break a}k=_FT_Stream_ReadLong(g,h);if(HEAP[h]!=0){i=3;break a}l=_FT_Stream_ReadShort(g,h);l=unSign(l,16);if(HEAP[h]!=0){i=3;break a}m=_FT_Stream_ReadShort(g,h);
m=unSign(m,16);if(HEAP[h]!=0){i=3;break a}if(k==a){i=7;break a}var n=i+1;k=8;i=2}if(i==27)j=1;else if(i==3)j=HEAP[h];else if(i==7){HEAP[f]=l+1;m=d+m;d=_FT_Stream_Seek(g,m);HEAP[h]=d;if(HEAP[h]==0){d=_ft_mem_realloc(e,8,0,HEAP[f],0,h);if(HEAP[h]==0){a=k=0;k=9;a:for(;;){i=k==16?p:0;j=a+i;k=d+8*j;p=d+8*j+4;if(!(reSign(HEAP[f],32)>reSign(j,32))){i=17;break a}j=_FT_Stream_ReadShort(g,h);HEAP[k]=j;if(HEAP[h]!=0){i=12;break a}k=_FT_Stream_Seek(g,2+HEAP[g+8]);HEAP[h]=k;if(k!=0){i=12;break a}k=_FT_Stream_ReadLong(g,
h);if(HEAP[h]!=0){i=12;break a}j=_FT_Stream_Seek(g,4+HEAP[g+8]);HEAP[h]=j;if(j!=0){i=12;break a}HEAP[p]=k&16777215;var p=i+1;k=16;i=10}a:do if(i==17){_qsort(d,HEAP[f],8,_ft_raccess_sort_ref_by_id.__index__);g=_ft_mem_realloc(e,4,0,HEAP[f],0,h);if(HEAP[h]!=0)break a;p=k=0;if(reSign(HEAP[f],32)>reSign(p,32)){p=d;a=b;j=g;l=f;m=k;o=m+1;for(k=20;;){r=k==20?0:r;i=o+r;k=m+r;HEAP[j+4*k]=a+HEAP[p+8*k+4];i=reSign(HEAP[l],32)>reSign(i,32);var r=r+1;if(i)i=k=21;else{i=22;break}}}HEAP[c]=g;HEAP[h]=0}while(0);
d!=0&&FUNCTION_TABLE[HEAP[e+8]](e,d)}}j=HEAP[h]}}}b=j;STACKTOP=h;return b}_FT_Raccess_Get_DataOffsets.__index__=Runtime.getFunctionIndex(_FT_Raccess_Get_DataOffsets,"_FT_Raccess_Get_DataOffsets");
function _FT_Raccess_Guess(e,g,d,b,a,c){var f,h=null;if(g!=0){h=0;f=1}else{h=0;f=2}for(;;)if(f==1){o=h==3?o:0;var i=0+o;f=c+4*i;h=b+4*i;var k=a+4*i,j=_raccess_guess_table+i*8,l=c+4*i,m=c+4*i;HEAP[b+4*i]=0;i=_FT_Stream_Seek(g,0);HEAP[l]=i;if(HEAP[m]==0){h=FUNCTION_TABLE[HEAP[j]](e,g,d,h,k);HEAP[f]=h}var o=o+1;if(o!=9){h=3;f=1}else break}else if(f==2){n=h==7?n:0;h=0+n;k=c+4*h;j=c+4*h;l=_raccess_guess_table+h*8;m=a+4*h;i=b+4*h;f=c+4*h;HEAP[b+4*h]=0;HEAP[k]=0;if(HEAP[j]==0){h=FUNCTION_TABLE[HEAP[l]](e,
g,d,i,m);HEAP[f]=h}var n=n+1;if(n!=9){h=7;f=2}else break}}_FT_Raccess_Guess.__index__=Runtime.getFunctionIndex(_FT_Raccess_Guess,"_FT_Raccess_Guess");function _raccess_guess_apple_double(e,g,d,b,a){HEAP[b]=0;return g==0?81:_raccess_guess_apple_generic(e,g,d,333319,a)}_raccess_guess_apple_double.__index__=Runtime.getFunctionIndex(_raccess_guess_apple_double,"_raccess_guess_apple_double");
function _raccess_guess_apple_single(e,g,d,b,a){HEAP[b]=0;return g==0?81:_raccess_guess_apple_generic(e,g,d,333312,a)}_raccess_guess_apple_single.__index__=Runtime.getFunctionIndex(_raccess_guess_apple_single,"_raccess_guess_apple_single");function _raccess_guess_darwin_ufs_export(e,g,d,b,a){g=HEAP[e];d=_raccess_make_file_name(g,d,__str12);if(d==0)b=64;else{e=_raccess_guess_linux_double_from_file_name(e,d,a);if(e==0)HEAP[b]=d;else d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);b=e}return b}
_raccess_guess_darwin_ufs_export.__index__=Runtime.getFunctionIndex(_raccess_guess_darwin_ufs_export,"_raccess_guess_darwin_ufs_export");function _raccess_guess_darwin_hfsplus(e,g,d,b,a){g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var c;c=_strlen(d);e=_ft_mem_alloc(HEAP[e],c+6,g);if(HEAP[g]!=0)d=HEAP[g];else{_llvm_memcpy_p0i8_p0i8_i32(e,d,c,1,0);_llvm_memcpy_p0i8_p0i8_i32(e+c,__str13,6,1,0);HEAP[b]=e;d=HEAP[a]=0}d=d;STACKTOP=g;return d}
_raccess_guess_darwin_hfsplus.__index__=Runtime.getFunctionIndex(_raccess_guess_darwin_hfsplus,"_raccess_guess_darwin_hfsplus");function _raccess_guess_darwin_newvfs(e,g,d,b,a){g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var c;c=_strlen(d);e=_ft_mem_alloc(HEAP[e],c+18,g);if(HEAP[g]!=0)d=HEAP[g];else{_llvm_memcpy_p0i8_p0i8_i32(e,d,c,1,0);_llvm_memcpy_p0i8_p0i8_i32(e+c,__str14,18,1,0);HEAP[b]=e;d=HEAP[a]=0}d=d;STACKTOP=g;return d}
_raccess_guess_darwin_newvfs.__index__=Runtime.getFunctionIndex(_raccess_guess_darwin_newvfs,"_raccess_guess_darwin_newvfs");function _raccess_guess_vfat(e,g,d,b,a){e=_raccess_make_file_name(HEAP[e],d,__str15);if(e==0)b=64;else{HEAP[b]=e;b=HEAP[a]=0}return b}_raccess_guess_vfat.__index__=Runtime.getFunctionIndex(_raccess_guess_vfat,"_raccess_guess_vfat");function _raccess_guess_linux_cap(e,g,d,b,a){e=_raccess_make_file_name(HEAP[e],d,__str1611);if(e==0)b=64;else{HEAP[b]=e;b=HEAP[a]=0}return b}
_raccess_guess_linux_cap.__index__=Runtime.getFunctionIndex(_raccess_guess_linux_cap,"_raccess_guess_linux_cap");function _raccess_guess_linux_double(e,g,d,b,a){g=HEAP[e];d=_raccess_make_file_name(g,d,__str17);if(d==0)b=64;else{e=_raccess_guess_linux_double_from_file_name(e,d,a);if(e==0)HEAP[b]=d;else d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);b=e}return b}_raccess_guess_linux_double.__index__=Runtime.getFunctionIndex(_raccess_guess_linux_double,"_raccess_guess_linux_double");
function _raccess_guess_linux_netatalk(e,g,d,b,a){g=HEAP[e];d=_raccess_make_file_name(g,d,__str18);if(d==0)b=64;else{e=_raccess_guess_linux_double_from_file_name(e,d,a);if(e==0)HEAP[b]=d;else d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);b=e}return b}_raccess_guess_linux_netatalk.__index__=Runtime.getFunctionIndex(_raccess_guess_linux_netatalk,"_raccess_guess_linux_netatalk");
function _raccess_guess_apple_generic(e,g,d,b,a){e=STACKTOP;STACKTOP+=4;Runtime.memset(e,0,4);var c,f=null,h,i,k;d=_FT_Stream_ReadLong(g,e);var j=HEAP[e]!=0;a:do if(j)h=HEAP[e];else if(d!=b)h=2;else{_FT_Stream_ReadLong(g,e);if(HEAP[e]==0){h=g;var l=reSign(16,32)<reSign(0,32);b:do if(l)HEAP[e]=85;else{i=_FT_Stream_Seek(h,16+HEAP[h+8]);HEAP[e]=i;if(i!=0){c=2;break b}i=_FT_Stream_ReadShort(g,e);if(HEAP[e]!=0){h=HEAP[e];break a}else if(i==0){h=2;break a}else{i=unSign(i,16);var m=g,o=g,n=g;f=5;c:for(;;){c=
f==10?r:0;f=0+c;if(!(reSign(i,32)>reSign(f,32))){c=17;break c}f=_FT_Stream_ReadLong(m,e);if(HEAP[e]!=0){c=7;break c}f=f==2;d:do if(f){k=_FT_Stream_ReadLong(o,e);if(HEAP[e]!=0)break d;_FT_Stream_ReadLong(n,e);if(HEAP[e]==0){c=13;break c}}else{var p=_FT_Stream_Seek(o,8+HEAP[o+8]);HEAP[e]=p;if(p!=0){c=15;break c}}while(0);var r=c+1;f=10;c=6}if(c==17){h=2;break a}else if(c==7){h=HEAP[e];break a}else if(c==13){HEAP[a]=k;h=0;break a}else if(c==15){h=HEAP[e];break a}}}while(0)}h=HEAP[e]}while(0);g=h;STACKTOP=
e;return g}_raccess_guess_apple_generic.__index__=Runtime.getFunctionIndex(_raccess_guess_apple_generic,"_raccess_guess_apple_generic");function _raccess_guess_linux_double_from_file_name(e,g,d){var b=STACKTOP;STACKTOP+=40;Runtime.memset(b,0,40);var a,c=b+32,f=b+36;HEAP[f]=0;HEAP[b]=4;HEAP[b+12]=g;a=_FT_Stream_New(e,b,c);if(a==0){a=HEAP[c];HEAP[f]=0;a=e=a==0?81:_raccess_guess_apple_generic(e,a,g,333319,d);_FT_Stream_Free(HEAP[c],0)}c=a;STACKTOP=b;return c}
_raccess_guess_linux_double_from_file_name.__index__=Runtime.getFunctionIndex(_raccess_guess_linux_double_from_file_name,"_raccess_guess_linux_double_from_file_name");function _raccess_make_file_name(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;HEAP[b]=0;a=_strlen(g);a=_strlen(d)+a;e=_ft_mem_alloc(e,a+1,b);if(HEAP[b]!=0)d=0;else{a=_strrchr(g,47);if(a!=0){_strncpy(e,g,a+1+(0-g));HEAP[e+(a+1+(0-g))]=0;g=a+1}else{g=g;HEAP[e]=0}_strcat(e,d);_strcat(e,g);d=e}d=d;STACKTOP=b;return d}
_raccess_make_file_name.__index__=Runtime.getFunctionIndex(_raccess_make_file_name,"_raccess_make_file_name");function _FT_Get_Sfnt_Name_Count(e){var g,d,b=e==0;a:do if(b)g=0;else{if((HEAP[e+8]&8)==0){g=0;break a}d=unSign(HEAP[e+344],16);g=2;break a}while(0);if(g==0)d=0;return d}_FT_Get_Sfnt_Name_Count.__index__=Runtime.getFunctionIndex(_FT_Get_Sfnt_Name_Count,"_FT_Get_Sfnt_Name_Count");
function _FT_Get_Sfnt_Name(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c,f,h,i,k,j;HEAP[b]=6;var l=d!=0;a:do if(l){if(e==0)break a;if((HEAP[e+8]&8)==0)break a;k=e;var m=unSign(HEAP[k+344],16);a=g;if(!(unSign(m,32)>unSign(a,32)))break a;k=HEAP[k+348+12]+20*g;m=HEAP[k+8]!=0;b:do if(m){if(HEAP[k+16]!=0)break b;a=HEAP[e+100];j=HEAP[e+104];c=unSign(HEAP[k+8],16);c=_ft_mem_realloc(a,1,0,c,0,b);HEAP[k+16]=c;c=HEAP[b]!=0;c:do if(!c){f=_FT_Stream_Seek(j,HEAP[k+12]);HEAP[b]=f;if(HEAP[b]!=
0)break c;i=unSign(HEAP[k+8],16);h=HEAP[k+16];f=j;h=h;i=i;f=f=_FT_Stream_ReadAt(f,HEAP[f+8],h,i);HEAP[b]=f;if(HEAP[b]==0)break b}while(0);j=HEAP[k+16];a=a;c=j;j!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[k+16]=0;HEAP[k+8]=0}while(0);HEAP[d]=HEAP[k];HEAP[d+2]=HEAP[k+2];HEAP[d+4]=HEAP[k+4];HEAP[d+6]=HEAP[k+6];HEAP[d+8]=HEAP[k+16];k=unSign(HEAP[k+8],16);HEAP[d+12]=k;HEAP[b]=0}while(0);e=HEAP[b];STACKTOP=b;return e}_FT_Get_Sfnt_Name.__index__=Runtime.getFunctionIndex(_FT_Get_Sfnt_Name,"_FT_Get_Sfnt_Name");
function _FT_Stream_OpenMemory(e,g,d){HEAP[e]=g;HEAP[e+4]=d;HEAP[e+8]=0;HEAP[e+32]=0;HEAP[e+20]=0;HEAP[e+24]=0}_FT_Stream_OpenMemory.__index__=Runtime.getFunctionIndex(_FT_Stream_OpenMemory,"_FT_Stream_OpenMemory");function _FT_Stream_Close(e){var g=e!=0;a:do if(g){if(HEAP[e+24]==0)break a;FUNCTION_TABLE[HEAP[e+24]](e)}while(0)}_FT_Stream_Close.__index__=Runtime.getFunctionIndex(_FT_Stream_Close,"_FT_Stream_Close");
function _FT_Stream_Seek(e,g){var d,b;b=0;var a=HEAP[e+20]!=0;a:do{if(a){if(FUNCTION_TABLE[HEAP[e+20]](e,g,0,0)==0){d=1;break a}}else{d=g;if(!(unSign(HEAP[e+4],32)<unSign(d,32))){d=1;break a}}b=85;d=2;break a}while(0);a:do if(d==1){if(b!=0)break a;HEAP[e+8]=g}while(0);return b}_FT_Stream_Seek.__index__=Runtime.getFunctionIndex(_FT_Stream_Seek,"_FT_Stream_Seek");function _FT_Stream_Skip(e,g){return reSign(g,32)<reSign(0,32)?85:_FT_Stream_Seek(e,g+HEAP[e+8])}
_FT_Stream_Skip.__index__=Runtime.getFunctionIndex(_FT_Stream_Skip,"_FT_Stream_Skip");function _FT_Stream_Pos(e){return HEAP[e+8]}_FT_Stream_Pos.__index__=Runtime.getFunctionIndex(_FT_Stream_Pos,"_FT_Stream_Pos");function _FT_Stream_Read(e,g,d){return _FT_Stream_ReadAt(e,HEAP[e+8],g,d)}_FT_Stream_Read.__index__=Runtime.getFunctionIndex(_FT_Stream_Read,"_FT_Stream_Read");
function _FT_Stream_ReadAt(e,g,d,b){var a,c;a=0;if(unSign(HEAP[e+4],32)<=unSign(g,32))e=85;else{if(HEAP[e+20]!=0)c=FUNCTION_TABLE[HEAP[e+20]](e,g,d,b);else{c=HEAP[e+4]-g;if(unSign(c,32)>unSign(b,32))c=b;_llvm_memcpy_p0i8_p0i8_i32(d,HEAP[e]+g,c,1,0)}HEAP[e+8]=c+g;if(unSign(c,32)<unSign(b,32))a=85;e=a}return e}_FT_Stream_ReadAt.__index__=Runtime.getFunctionIndex(_FT_Stream_ReadAt,"_FT_Stream_ReadAt");
function _FT_Stream_TryRead(e,g,d){var b;b=0;var a=HEAP[e+4];if(!(unSign(HEAP[e+8],32)>=unSign(a,32))){if(HEAP[e+20]!=0)b=FUNCTION_TABLE[HEAP[e+20]](e,HEAP[e+8],g,d);else{b=HEAP[e+4]-HEAP[e+8];if(unSign(b,32)>unSign(d,32))b=d;_llvm_memcpy_p0i8_p0i8_i32(g,HEAP[e]+HEAP[e+8],b,1,0)}HEAP[e+8]=b+HEAP[e+8]}return b}_FT_Stream_TryRead.__index__=Runtime.getFunctionIndex(_FT_Stream_TryRead,"_FT_Stream_TryRead");
function _FT_Stream_ExtractFrame(e,g,d){g=_FT_Stream_EnterFrame(e,g);if(g==0){HEAP[d]=HEAP[e+32];HEAP[e+32]=0;HEAP[e+36]=0}return g}_FT_Stream_ExtractFrame.__index__=Runtime.getFunctionIndex(_FT_Stream_ExtractFrame,"_FT_Stream_ExtractFrame");function _FT_Stream_ReleaseFrame(e,g){var d,b,a=e!=0;a:do if(a){if(HEAP[e+20]==0)break a;d=HEAP[e+28];b=HEAP[g];d=d;b=b;b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g]=0}while(0);HEAP[g]=0}
_FT_Stream_ReleaseFrame.__index__=Runtime.getFunctionIndex(_FT_Stream_ReleaseFrame,"_FT_Stream_ReleaseFrame");
function _FT_Stream_EnterFrame(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a,c,f,h,i;HEAP[d]=0;var k=HEAP[e+20]!=0;a:do if(k){b=HEAP[e+28];c=g;if(unSign(HEAP[e+4],32)<unSign(c,32))HEAP[d]=85;else{a=g;c=b;a=a;f=d;i=h=0;var j=reSign(a,32)>reSign(0,32);b:do if(j){i=FUNCTION_TABLE[HEAP[c+4]](c,a);if(i!=0)break b;h=64}else{if(!(reSign(a,32)<reSign(0,32)))break b;h=6}while(0);HEAP[f]=h;c=c=i;HEAP[e]=c;if(HEAP[d]!=0)break a;c=FUNCTION_TABLE[HEAP[e+20]](e,HEAP[e+8],HEAP[e],g);a=g;if(unSign(c,
32)<unSign(a,32)){a=HEAP[e];b=b;a=a;a!=0&&FUNCTION_TABLE[HEAP[b+8]](b,a);HEAP[e]=0;HEAP[d]=85}HEAP[e+32]=HEAP[e];HEAP[e+36]=HEAP[e+32]+g;HEAP[e+8]=c+HEAP[e+8]}}else{b=HEAP[e+4];b=unSign(HEAP[e+8],32)>=unSign(b,32);b:do if(!b){b=g;if(unSign(HEAP[e+4]-HEAP[e+8],32)<unSign(b,32))break b;HEAP[e+32]=HEAP[e]+HEAP[e+8];HEAP[e+36]=HEAP[e+32]+g;HEAP[e+8]=g+HEAP[e+8];break a}while(0);HEAP[d]=85}while(0);k=HEAP[d];STACKTOP=d;return k}
_FT_Stream_EnterFrame.__index__=Runtime.getFunctionIndex(_FT_Stream_EnterFrame,"_FT_Stream_EnterFrame");function _FT_Stream_ExitFrame(e){var g,d;if(HEAP[e+20]!=0){d=HEAP[e+28];g=HEAP[e];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e]=0}HEAP[e+32]=0;HEAP[e+36]=0}_FT_Stream_ExitFrame.__index__=Runtime.getFunctionIndex(_FT_Stream_ExitFrame,"_FT_Stream_ExitFrame");function _FT_Stream_GetChar(e){var g;g=0;if(HEAP[e+32]<HEAP[e+36]){var d=HEAP[e+32];g=HEAP[d];HEAP[e+32]=d+1}return reSign(g,8)&255}
_FT_Stream_GetChar.__index__=Runtime.getFunctionIndex(_FT_Stream_GetChar,"_FT_Stream_GetChar");function _FT_Stream_GetShort(e){var g,d;d=0;g=HEAP[e+32];if(g+1<HEAP[e+36]){g+=2;d=reSign(HEAP[g+-2],8)<<8&65535;var b=unSign(HEAP[g+-2+1],8);d=d|b}HEAP[e+32]=g;return reSign(d,16)&65535}_FT_Stream_GetShort.__index__=Runtime.getFunctionIndex(_FT_Stream_GetShort,"_FT_Stream_GetShort");
function _FT_Stream_GetShortLE(e){var g,d;d=0;g=HEAP[e+32];if(g+1<HEAP[e+36]){g+=2;d=reSign(HEAP[g+-2+1],8)<<8&65535;var b=unSign(HEAP[g+-2],8);d=d|b}HEAP[e+32]=g;return reSign(d,16)&65535}_FT_Stream_GetShortLE.__index__=Runtime.getFunctionIndex(_FT_Stream_GetShortLE,"_FT_Stream_GetShortLE");function _FT_Stream_GetOffset(e){var g,d;d=0;g=HEAP[e+32];if(g+2<HEAP[e+36]){g+=3;d=reSign(HEAP[g+-3],8)<<16;var b=unSign(HEAP[g+-3+1],8)<<8,a=unSign(HEAP[g+-3+2],8);d=b|d|a}HEAP[e+32]=g;return d}
_FT_Stream_GetOffset.__index__=Runtime.getFunctionIndex(_FT_Stream_GetOffset,"_FT_Stream_GetOffset");function _FT_Stream_GetLong(e){var g,d;d=0;g=HEAP[e+32];if(g+3<HEAP[e+36]){g+=4;d=reSign(HEAP[g+-4],8)<<24;var b=unSign(HEAP[g+-4+1],8)<<16,a=unSign(HEAP[g+-4+2],8)<<8,c=unSign(HEAP[g+-4+3],8);d=b|d|a|c}HEAP[e+32]=g;return d}_FT_Stream_GetLong.__index__=Runtime.getFunctionIndex(_FT_Stream_GetLong,"_FT_Stream_GetLong");
function _FT_Stream_GetLongLE(e){var g,d;d=0;g=HEAP[e+32];if(g+3<HEAP[e+36]){g+=4;d=reSign(HEAP[g+-4+3],8)<<24;var b=unSign(HEAP[g+-4+2],8)<<16,a=unSign(HEAP[g+-4+1],8)<<8,c=unSign(HEAP[g+-4],8);d=b|d|a|c}HEAP[e+32]=g;return d}_FT_Stream_GetLongLE.__index__=Runtime.getFunctionIndex(_FT_Stream_GetLongLE,"_FT_Stream_GetLongLE");
function _FT_Stream_ReadChar(e,g){var d=STACKTOP;STACKTOP+=1;Runtime.memset(d,0,1);var b,a;HEAP[d]=0;HEAP[g]=0;var c=HEAP[e+20]!=0;a:do{if(c)b=FUNCTION_TABLE[HEAP[e+20]](e,HEAP[e+8],d,1)!=1?0:1;else{b=HEAP[e+4];if(!(unSign(HEAP[e+8],32)<unSign(b,32))){b=0;break a}HEAP[d]=HEAP[HEAP[e]+HEAP[e+8]];b=1}break a}while(0);if(b==0){HEAP[g]=85;a=0}else if(b==1){HEAP[e+8]+=1;a=reSign(HEAP[d],8)}a=a&255;STACKTOP=d;return a}_FT_Stream_ReadChar.__index__=Runtime.getFunctionIndex(_FT_Stream_ReadChar,"_FT_Stream_ReadChar");
function _FT_Stream_ReadShort(e,g){var d=STACKTOP;STACKTOP+=2;Runtime.memset(d,0,2);var b;b=null;var a,c;c=0;HEAP[g]=0;b=HEAP[e+4];var f=unSign(HEAP[e+8]+1,32)<unSign(b,32);a:do if(f){b=e;if(HEAP[e+20]!=0){if(FUNCTION_TABLE[HEAP[b+20]](e,HEAP[e+8],d,2)!=2){b=0;break a}var h=d;a=h;b=1}else{var i=HEAP[b]+HEAP[e+8];a=i;b=3}if((b==3?i:h)!=0){a+=2;c=reSign(HEAP[a+-2],8)<<8&65535;h=unSign(HEAP[a+-2+1],8);c=c|h}HEAP[e+8]+=2;a=reSign(c,16);b=5;break a}else b=0;while(0);if(b==0){HEAP[g]=85;a=0}c=a&65535;STACKTOP=
d;return c}_FT_Stream_ReadShort.__index__=Runtime.getFunctionIndex(_FT_Stream_ReadShort,"_FT_Stream_ReadShort");
function _FT_Stream_ReadShortLE(e,g){var d=STACKTOP;STACKTOP+=2;Runtime.memset(d,0,2);var b;b=null;var a,c;c=0;HEAP[g]=0;b=HEAP[e+4];var f=unSign(HEAP[e+8]+1,32)<unSign(b,32);a:do if(f){b=e;if(HEAP[e+20]!=0){if(FUNCTION_TABLE[HEAP[b+20]](e,HEAP[e+8],d,2)!=2){b=0;break a}var h=d;a=h;b=1}else{var i=HEAP[b]+HEAP[e+8];a=i;b=3}if((b==3?i:h)!=0){a+=2;c=reSign(HEAP[a+-2+1],8)<<8&65535;h=unSign(HEAP[a+-2],8);c=c|h}HEAP[e+8]+=2;a=reSign(c,16);b=5;break a}else b=0;while(0);if(b==0){HEAP[g]=85;a=0}c=a&65535;
STACKTOP=d;return c}_FT_Stream_ReadShortLE.__index__=Runtime.getFunctionIndex(_FT_Stream_ReadShortLE,"_FT_Stream_ReadShortLE");
function _FT_Stream_ReadOffset(e,g){var d=STACKTOP;STACKTOP+=3;Runtime.memset(d,0,3);var b;b=null;var a,c;c=0;HEAP[g]=0;b=HEAP[e+4];var f=unSign(HEAP[e+8]+2,32)<unSign(b,32);a:do if(f){b=e;if(HEAP[e+20]!=0){if(FUNCTION_TABLE[HEAP[b+20]](e,HEAP[e+8],d,3)!=3){b=0;break a}var h=d;a=h;b=1}else{var i=HEAP[b]+HEAP[e+8];a=i;b=3}if((b==3?i:h)!=0){a+=3;c=reSign(HEAP[a+-3],8)<<16;h=unSign(HEAP[a+-3+1],8)<<8;i=unSign(HEAP[a+-3+2],8);c=h|c|i}HEAP[e+8]+=3;a=c;b=5;break a}else b=0;while(0);if(b==0){HEAP[g]=85;
a=0}c=a;STACKTOP=d;return c}_FT_Stream_ReadOffset.__index__=Runtime.getFunctionIndex(_FT_Stream_ReadOffset,"_FT_Stream_ReadOffset");
function _FT_Stream_ReadLong(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b;b=null;var a,c;c=0;HEAP[g]=0;b=HEAP[e+4];var f=unSign(HEAP[e+8]+3,32)<unSign(b,32);a:do if(f){b=e;if(HEAP[e+20]!=0){if(FUNCTION_TABLE[HEAP[b+20]](e,HEAP[e+8],d,4)!=4){b=0;break a}var h=d;a=h;b=1}else{var i=HEAP[b]+HEAP[e+8];a=i;b=3}if((b==3?i:h)!=0){a+=4;c=reSign(HEAP[a+-4],8)<<24;h=unSign(HEAP[a+-4+1],8)<<16;i=unSign(HEAP[a+-4+2],8)<<8;a=unSign(HEAP[a+-4+3],8);c=h|c|i|a}HEAP[e+8]+=4;a=c;b=5;break a}else b=0;
while(0);if(b==0){HEAP[g]=85;a=0}c=a;STACKTOP=d;return c}_FT_Stream_ReadLong.__index__=Runtime.getFunctionIndex(_FT_Stream_ReadLong,"_FT_Stream_ReadLong");
function _FT_Stream_ReadLongLE(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b;b=null;var a,c;c=0;HEAP[g]=0;b=HEAP[e+4];var f=unSign(HEAP[e+8]+3,32)<unSign(b,32);a:do if(f){b=e;if(HEAP[e+20]!=0){if(FUNCTION_TABLE[HEAP[b+20]](e,HEAP[e+8],d,4)!=4){b=0;break a}var h=d;a=h;b=1}else{var i=HEAP[b]+HEAP[e+8];a=i;b=3}if((b==3?i:h)!=0){a+=4;c=reSign(HEAP[a+-4+3],8)<<24;h=unSign(HEAP[a+-4+2],8)<<16;i=unSign(HEAP[a+-4+1],8)<<8;a=unSign(HEAP[a+-4],8);c=h|c|i|a}HEAP[e+8]+=4;a=c;b=5;break a}else b=
0;while(0);if(b==0){HEAP[g]=85;a=0}c=a;STACKTOP=d;return c}_FT_Stream_ReadLongLE.__index__=Runtime.getFunctionIndex(_FT_Stream_ReadLongLE,"_FT_Stream_ReadLongLE");
function _FT_Stream_ReadFields(e,g,d){var b,a=null,c,f,h,i;c=0;i=g==0;a:do if(i)b=0;else{if(e==0){b=0;break a}i=HEAP[e+32];h=0;var k=e,j=e+32,l=d,m=e+36;d=d;g=g;var o=h;for(a=1;;){f=a==1?o:a==23?f:a==11?f:0;var n=a==1?g:a==23?z:a==11?y:r;b=unSign(HEAP[n],8);if(b==4)b=28;else if(b==8)b=12;else if(b==9)b=12;else if(b==12)b=14;else if(b==13)b=14;else if(b==14)b=15;else if(b==15)b=15;else if(b==16)b=16;else if(b==17)b=16;else if(b==18)b=17;else if(b==19)b=17;else if(b==20)b=18;else if(b==21)b=18;else if(b==
22)b=19;else if(b==23)b=19;else if(b==24)b=29;else if(b==25)b=29;else{b=30;break}if(b==28){var p=unSign(HEAP[n+2],16);p=_FT_Stream_EnterFrame(k,p);if(p!=0){b=4;break}c=1;i=HEAP[j];var r=n+4;a=5}else{if(b==12){var q=unSign(HEAP[i],8);i+=1;a=12}else if(b==14){i+=2;var s=unSign(HEAP[i+-2],8)<<8&65535;z=unSign(HEAP[i+-2+1],8);s=unSign(s|z,16);a=14}else if(b==15){i+=2;var u=unSign(HEAP[i+-2+1],8)<<8&65535;z=unSign(HEAP[i+-2],8);u=unSign(u|z,16);a=15}else if(b==16){i+=4;var t=unSign(HEAP[i+-4],8)<<24;z=
unSign(HEAP[i+-4+1],8)<<16;b=unSign(HEAP[i+-4+2],8)<<8;a=unSign(HEAP[i+-4+3],8);t=z|t|b|a;a=16}else if(b==17){i+=4;var v=unSign(HEAP[i+-4+3],8)<<24;z=unSign(HEAP[i+-4+2],8)<<16;b=unSign(HEAP[i+-4+1],8)<<8;a=unSign(HEAP[i+-4],8);v=z|v|b|a;a=17}else if(b==18){i+=3;var w=unSign(HEAP[i+-3],8)<<16;z=unSign(HEAP[i+-3+1],8)<<8;b=unSign(HEAP[i+-3+2],8);w=z|w|b;a=18}else if(b==19){i+=3;var x=unSign(HEAP[i+-3+2],8)<<16;z=unSign(HEAP[i+-3+1],8)<<8;b=unSign(HEAP[i+-3],8);x=z|x|b;a=19}else if(b==29){y=unSign(HEAP[n+
1],8);if(i+y>HEAP[m]){b=6;break}if(HEAP[n]==24){b=unSign(HEAP[n+2],16);_llvm_memcpy_p0i8_p0i8_i32(d+b,i,y,1,0)}i+=y;var y=n+4;a=11;b=3;continue}z=a==19?8:a==18?8:a==17?0:a==16?0:a==15?16:a==14?16:24;b=a==19?x:a==18?w:a==17?v:a==16?t:a==15?u:a==14?s:q;if((unSign(HEAP[n],8)&1&255)!=0){var A=reSign(b<<z,32)>>reSign(z,32);a=20}else a=36;z=a==20?A:b;b=unSign(HEAP[n+2],16);a=l+b;b=unSign(HEAP[n+1],8);b=b==1?31:b==2?32:b==4?33:34;if(b==34)HEAP[a]=z;else if(b==31)HEAP[a]=z&255;else if(b==32)HEAP[a]=z&65535;
else if(b==33)HEAP[a]=z;var z=n+4;a=23}b=3}if(b==30){h=f;HEAP[e+32]=i}else if(b==4)h=p;else if(b==6)h=85;if(c!=0){e=e;if(HEAP[e+20]!=0){c=HEAP[e+28];f=HEAP[e];c=c;f=f;f!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[e]=0}HEAP[e+32]=0;HEAP[e+36]=0}h=h;b=27;break a}while(0);if(b==0)h=6;return h}_FT_Stream_ReadFields.__index__=Runtime.getFunctionIndex(_FT_Stream_ReadFields,"_FT_Stream_ReadFields");
function _ft_trig_downscale(e){var g,d,b,a;g=e=g=e;d=0-g;g=reSign(g,32)>=reSign(0,32)?g:d;d=unSign(g,32)>>>unSign(16,32);b=g&65535;g=d*17797;d=d*47593+b*17797;b=unSign(b*47593,32)>>>unSign(16,32);a=d;a=unSign(a,32)>=unSign(b,32)?a:b;d=b+d;g=(unSign(d,32)>>>unSign(16,32))+g;if(unSign(d,32)<unSign(a,32))g+=65536;g=g;e=reSign(e,32)<reSign(0,32);g=g;return e?0-g:g}_ft_trig_downscale.__index__=Runtime.getFunctionIndex(_ft_trig_downscale,"_ft_trig_downscale");
function _ft_trig_prenorm(e){var g=null,d,b,a,c;d=HEAP[e];b=HEAP[e+4];c=0-d;c=reSign(d,32)>=reSign(0,32)?d:c;a=0-b;a=(reSign(b,32)>=reSign(0,32)?b:a)|c;c=0;var f=a;if(reSign(f,32)>reSign(65535,32)){var h=reSign(a,32)>>reSign(16,32);a=h;c+=16;g=0}else g=-1;g=reSign(g==0?h:f,32)>reSign(255,32);h=a;if(g){var i=reSign(h,32)>>reSign(8,32);a=i;c+=8;g=2}else g=12;g=reSign(g==2?i:h,32)>reSign(15,32);i=a;if(g){var k=reSign(i,32)>>reSign(4,32);a=k;c+=4;g=4}else g=13;i=reSign(g==4?k:i,32)>reSign(3,32);k=a;if(i){var j=
reSign(k,32)>>reSign(2,32);a=j;c+=2;g=6}else g=14;if(reSign(g==6?j:k,32)>reSign(1,32)){reSign(a,32);reSign(1,32);var l=c+1;c=l;g=8}else{var m=c;g=10}j=reSign(g==10?m:l,32)<=reSign(27,32);c=c;if(j){c=27-c;HEAP[e]=d<<c;HEAP[e+4]=b<<c}else{j=c=c-27;d=reSign(d,32)>>reSign(j,32);HEAP[e]=d;d=c;b=reSign(b,32)>>reSign(d,32);HEAP[e+4]=b;c=0-c}return c}_ft_trig_prenorm.__index__=Runtime.getFunctionIndex(_ft_trig_prenorm,"_ft_trig_prenorm");
function _ft_trig_pseudo_rotate(e,g){var d=null,b,a,c,f;b=g;a=HEAP[e];c=HEAP[e+4];var h=b;if(reSign(h,32)<=reSign(-5898240,32)){a=a;c=c;d=b;b=d+11796480;var i=(reSign(b,32)>reSign(-5898239,32)?b:-5898239)+-1-d;i=Math.floor(unSign(i,32)/unSign(11796480,32))*11796480;i=d+i;for(d=0;;){l=d==0?0:l;var k=0-(d==0?a:k),j=0-(d==0?c:j);d=reSign(b+l*11796480,32)<=reSign(-5898240,32);var l=l+1;if(d)d=1;else break}b=i=i+11796480;c=j;a=k;d=2}else d=-1;if(reSign(d==2?i:h,32)>reSign(5898240,32)){h=a;c=c;b=b+-11796480;
for(d=4;;){n=d==4?0:n;f=b+n*-11796480;var m=0-(d==4?h:m),o=0-(d==4?c:o);d=reSign(f,32)>reSign(5898240,32);var n=n+1;if(d)d=5;else break}b=f;c=o;a=m;d=6}else{var p=b;d=8}f=d==8?p:f;d=_ft_trig_arctan_table;f=reSign(f,32)<reSign(0,32);m=c<<1;o=a;if(f){f=m+o;c-=a<<1;a=f;b+=HEAP[d]}else{f=o-m;c=a*2+c;a=f;b-=HEAP[d]}d+=4;f=b;m=c;o=a;p=d;n=(reSign(1,32)>reSign(23,32)?1:23)-0;for(d=10;;){B=d==15?B:0;y=d==15?y:p;A=d==15?A:o;z=d==15?z:m;C=d==15?C:f;d=0+B;b=reSign(C,32)<reSign(0,32);c=reSign(z,32)>>reSign(d,
32);if(b){var r=c+A,q=reSign(A,32)>>reSign(d,32);q=z-q;var s=C+HEAP[y],u=y+4;d=12}else{var t=A-c,v=(reSign(A,32)>>reSign(d,32))+z,w=C-HEAP[y],x=y+4;d=14}var y=d==14?x:u,A=d==14?t:r,z=d==14?v:q,C=d==14?w:s,B=B+1;if(B!=n)d=15;else break}a=A;c=z;HEAP[e]=a;HEAP[e+4]=c}_ft_trig_pseudo_rotate.__index__=Runtime.getFunctionIndex(_ft_trig_pseudo_rotate,"_ft_trig_pseudo_rotate");
function _ft_trig_pseudo_polarize(e){var g=null,d,b,a,c;b=HEAP[e];a=c=HEAP[e+4];d=0;if(reSign(b,32)<reSign(0,32)){b=0-b;var f=0-a;a=f;d=11796480;g=0}else g=-1;if(reSign(g==0?f:c,32)>reSign(0,32))d=0-d;c=_ft_trig_arctan_table;g=reSign(a,32)<reSign(0,32);f=b<<1;var h=a;if(g){g=f+h;b-=a<<1;a=g;d-=HEAP[c]}else{g=h-f;b=a*2+b;a=g;d+=HEAP[c]}c+=4;a=a;b=b;c=c;d=d;f=(reSign(1,32)>reSign(23,32)?1:23)-0;for(g=4;;){v=g==9?v:0;q=g==9?q:d;s=g==9?s:c;u=g==9?u:b;t=g==9?t:a;g=0+v;h=reSign(t,32)<reSign(0,32);var i=
reSign(u,32)>>reSign(g,32);if(h){var k=i+t,j=reSign(t,32)>>reSign(g,32);j=u-j;var l=q-HEAP[s],m=s+4;g=6}else{var o=t-i,n=(reSign(t,32)>>reSign(g,32))+u,p=q+HEAP[s],r=s+4;g=8}var q=g==8?p:l,s=g==8?r:m,u=g==8?n:j,t=g==8?o:k,v=v+1;if(v!=f)g=9;else break}d=q;b=u;k=reSign(d,32)>=reSign(0,32);o=d;d=k?o+16&-32:0-(16-o&-32);HEAP[e]=b;HEAP[e+4]=d}_ft_trig_pseudo_polarize.__index__=Runtime.getFunctionIndex(_ft_trig_pseudo_polarize,"_ft_trig_pseudo_polarize");
function _FT_Cos(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);HEAP[g]=72899491;HEAP[g+4]=0;_ft_trig_pseudo_rotate(g,e);e=Math.floor(reSign(HEAP[g],32)/reSign(4096,32));STACKTOP=g;return e}_FT_Cos.__index__=Runtime.getFunctionIndex(_FT_Cos,"_FT_Cos");function _FT_Sin(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);e=5898240-e;HEAP[g]=72899491;HEAP[g+4]=0;_ft_trig_pseudo_rotate(g,e);e=Math.floor(reSign(HEAP[g],32)/reSign(4096,32));STACKTOP=g;return e}
_FT_Sin.__index__=Runtime.getFunctionIndex(_FT_Sin,"_FT_Sin");function _FT_Tan(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);HEAP[g]=72899491;HEAP[g+4]=0;_ft_trig_pseudo_rotate(g,e);e=_FT_DivFix(HEAP[g+4],HEAP[g]);STACKTOP=g;return e}_FT_Tan.__index__=Runtime.getFunctionIndex(_FT_Tan,"_FT_Tan");
function _FT_Atan2(e,g){var d=STACKTOP;STACKTOP+=8;Runtime.memset(d,0,8);var b,a,c=e==0;a:do if(c){if(g!=0){b=1;break a}a=0;b=2;break a}else b=1;while(0);if(b==1){HEAP[d]=e;HEAP[d+4]=g;_ft_trig_prenorm(d);_ft_trig_pseudo_polarize(d);a=HEAP[d+4]}b=a;STACKTOP=d;return b}_FT_Atan2.__index__=Runtime.getFunctionIndex(_FT_Atan2,"_FT_Atan2");
function _FT_Vector_Unit(e,g){HEAP[e]=72899491;HEAP[e+4]=0;_ft_trig_pseudo_rotate(e,g);var d=reSign(HEAP[e],32)>>reSign(12,32);HEAP[e]=d;d=reSign(HEAP[e+4],32)>>reSign(12,32);HEAP[e+4]=d}_FT_Vector_Unit.__index__=Runtime.getFunctionIndex(_FT_Vector_Unit,"_FT_Vector_Unit");
function _FT_Vector_Rotate(e,g){var d=STACKTOP;STACKTOP+=8;Runtime.memset(d,0,8);var b,a;HEAP[d]=HEAP[e];HEAP[d+4]=HEAP[e+4];b=g!=0;a:do if(b){if(HEAP[d]==0)if(HEAP[d+4]==0)break a;b=_ft_trig_prenorm(d);_ft_trig_pseudo_rotate(d,g);a=_ft_trig_downscale(HEAP[d]);HEAP[d]=a;a=_ft_trig_downscale(HEAP[d+4]);HEAP[d+4]=a;a=reSign(b,32)>reSign(0,32);var c=b;if(a){a=1<<c-1;c=HEAP[d];var f=a,h=reSign(HEAP[d],32)>>reSign(31,32),i=b;c=reSign(f+c+h,32)>>reSign(i,32);HEAP[e]=c;c=HEAP[d+4];a=a;f=reSign(HEAP[d+4],
32)>>reSign(31,32);b=b;b=reSign(a+c+f,32)>>reSign(b,32);HEAP[e+4]=b}else{b=0-c;HEAP[e]=HEAP[d]<<b;HEAP[e+4]=HEAP[d+4]<<b}STACKTOP=d;return}while(0);STACKTOP=d}_FT_Vector_Rotate.__index__=Runtime.getFunctionIndex(_FT_Vector_Rotate,"_FT_Vector_Rotate");
function _FT_Vector_Length(e){var g=STACKTOP;STACKTOP+=16;Runtime.memset(g,0,16);var d;d=g+8;HEAP[g]=HEAP[e];HEAP[g+4]=HEAP[e+4];HEAP[d]=HEAP[g];HEAP[d+4]=HEAP[g+4];e=HEAP[d+4];if(HEAP[d]==0){d=0-e;d=reSign(e,32)>=reSign(0,32)?e:d}else if(e==0){d=HEAP[d];e=0-d;d=reSign(d,32)>=reSign(0,32)?d:e}else{e=_ft_trig_prenorm(d);_ft_trig_pseudo_polarize(d);var b=_ft_trig_downscale(HEAP[d]);HEAP[d]=b;b=reSign(e,32)>reSign(0,32);d=HEAP[d];d=b?reSign((1<<e-1)+d,32)>>reSign(e,32):d<<0-e}d=d;STACKTOP=g;return d}
_FT_Vector_Length.__index__=Runtime.getFunctionIndex(_FT_Vector_Length,"_FT_Vector_Length");
function _FT_Vector_Polarize(e,g,d){var b=STACKTOP;STACKTOP+=16;Runtime.memset(b,0,16);var a=b+8;HEAP[b]=HEAP[e];HEAP[b+4]=HEAP[e+4];HEAP[a]=HEAP[b];HEAP[a+4]=HEAP[b+4];e=HEAP[a]==0;a:do if(e){if(HEAP[a+4]!=0)break a;STACKTOP=b;return}while(0);e=_ft_trig_prenorm(a);_ft_trig_pseudo_polarize(a);var c=_ft_trig_downscale(HEAP[a]);HEAP[a]=c;c=reSign(e,32)>=reSign(0,32);var f=HEAP[a];e=c?reSign(f,32)>>reSign(e,32):f<<0-e;HEAP[g]=e;HEAP[d]=HEAP[a+4];STACKTOP=b}
_FT_Vector_Polarize.__index__=Runtime.getFunctionIndex(_FT_Vector_Polarize,"_FT_Vector_Polarize");function _FT_Vector_From_Polar(e,g,d){HEAP[e]=g;HEAP[e+4]=0;_FT_Vector_Rotate(e,d)}_FT_Vector_From_Polar.__index__=Runtime.getFunctionIndex(_FT_Vector_From_Polar,"_FT_Vector_From_Polar");
function _FT_Angle_Diff(e,g){var d=null,b;b=g-e;var a=b=reSign(b,32)%reSign(23592960,32);if(reSign(a,32)<reSign(0,32)){var c=b+23592960;b=c;d=0}else d=-1;if(reSign(d==0?c:a,32)>reSign(11796480,32))b-=23592960;return b}_FT_Angle_Diff.__index__=Runtime.getFunctionIndex(_FT_Angle_Diff,"_FT_Angle_Diff");
function _ft_mem_alloc(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c;c=a=0;var f=reSign(g,32)>reSign(0,32);a:do if(f){c=FUNCTION_TABLE[HEAP[e+4]](e,g);if(c!=0)break a;a=64}else{if(!(reSign(g,32)<reSign(0,32)))break a;a=6}while(0);HEAP[b]=a;e=c;a=HEAP[b]==0;a:do if(a){if(!(reSign(g,32)>reSign(0,32)))break a;_llvm_memset_p0i8_i32(e,0,g,1,0)}while(0);HEAP[d]=HEAP[b];STACKTOP=b;return e}_ft_mem_alloc.__index__=Runtime.getFunctionIndex(_ft_mem_alloc,"_ft_mem_alloc");
function _ft_mem_qalloc(e,g,d){var b,a;a=b=0;var c=reSign(g,32)>reSign(0,32);a:do if(c){a=FUNCTION_TABLE[HEAP[e+4]](e,g);if(a!=0)break a;b=64}else{if(!(reSign(g,32)<reSign(0,32)))break a;b=6}while(0);HEAP[d]=b;return a}_ft_mem_qalloc.__index__=Runtime.getFunctionIndex(_ft_mem_qalloc,"_ft_mem_qalloc");
function _ft_mem_realloc(e,g,d,b,a,c){var f=STACKTOP;STACKTOP+=4;Runtime.memset(f,0,4);a=a;HEAP[f]=0;a=_ft_mem_qrealloc(e,g,d,b,a,f);e=HEAP[f]==0;a:do if(e){var h=d;if(!(reSign(b,32)>reSign(h,32)))break a;_llvm_memset_p0i8_i32(a+g*d,0,(b-d)*g,1,0)}while(0);HEAP[c]=HEAP[f];g=a;STACKTOP=f;return g}_ft_mem_realloc.__index__=Runtime.getFunctionIndex(_ft_mem_realloc,"_ft_mem_realloc");
function _ft_mem_qrealloc(e,g,d,b,a,c){var f=STACKTOP;STACKTOP+=4;Runtime.memset(f,0,4);var h;a=a;HEAP[f]=0;var i=reSign(d,32)<reSign(0,32);a:do if(i)h=0;else{if(reSign(b,32)<reSign(0,32)){h=0;break a}if(reSign(g,32)<reSign(0,32)){h=0;break a}h=b==0;b:do if(!h){if(g==0)break b;h=g;h=Math.floor(reSign(2147483647,32)/reSign(h,32));i=b;if(reSign(h,32)<reSign(i,32))HEAP[f]=10;else if(d==0)a=_ft_mem_alloc(e,g*b,f);else{d=g*d;g=g*b;e=FUNCTION_TABLE[HEAP[e+12]](e,d,g,a);if(e==0)HEAP[f]=64;else a=e}h=7;break a}while(0);
a=a;e=e;g=a;a!=0&&FUNCTION_TABLE[HEAP[e+8]](e,g);a=0;h=7;break a}while(0);if(h==0)HEAP[f]=6;HEAP[c]=HEAP[f];c=a;STACKTOP=f;return c}_ft_mem_qrealloc.__index__=Runtime.getFunctionIndex(_ft_mem_qrealloc,"_ft_mem_qrealloc");function _ft_mem_free(e,g){g!=0&&FUNCTION_TABLE[HEAP[e+8]](e,g)}_ft_mem_free.__index__=Runtime.getFunctionIndex(_ft_mem_free,"_ft_mem_free");
function _ft_mem_dup(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c,f;f=c=0;var h=reSign(d,32)>reSign(0,32);a:do if(h){f=FUNCTION_TABLE[HEAP[e+4]](e,d);if(f!=0)break a;c=64}else{if(!(reSign(d,32)<reSign(0,32)))break a;c=6}while(0);HEAP[a]=c;e=f;c=HEAP[a]==0;a:do if(c){if(g==0)break a;_llvm_memcpy_p0i8_p0i8_i32(e,g,d,1,0)}while(0);HEAP[b]=HEAP[a];STACKTOP=a;return e}_ft_mem_dup.__index__=Runtime.getFunctionIndex(_ft_mem_dup,"_ft_mem_dup");
function _ft_mem_strdup(e,g,d){var b=g!=0?_strlen(g)+1:0;return _ft_mem_dup(e,g,b,d)}_ft_mem_strdup.__index__=Runtime.getFunctionIndex(_ft_mem_strdup,"_ft_mem_strdup");function _ft_mem_strcpyn(e,g,d){var b=null;b=e;g=g=g;e=b;var a=d+-1;for(b=-1;;){i=b==1?i:0;var c=a+i*-1,f=e+i,h=g+i;if(unSign(b==1?c:d,32)<=unSign(1,32))break;if(HEAP[h]==0)break;HEAP[f]=HEAP[h];var i=i+1;b=1}b=f;g=h;HEAP[b]=0;return unSign(HEAP[g]!=0,1)}_ft_mem_strcpyn.__index__=Runtime.getFunctionIndex(_ft_mem_strcpyn,"_ft_mem_strcpyn");
function _FT_List_Find(e,g){var d,b=null,a,c=HEAP[e];for(b=-1;;){var f=b==2?h:c;if((b==2?h:c)==0){d=5;break}if(HEAP[f+8]==g){d=1;break}var h=HEAP[f+4];b=2;d=0}if(d==1)a=f;else if(d==5)a=0;return a}_FT_List_Find.__index__=Runtime.getFunctionIndex(_FT_List_Find,"_FT_List_Find");function _FT_List_Add(e,g){var d;d=HEAP[e+4];HEAP[g+4]=0;HEAP[g]=d;if(d!=0)HEAP[d+4]=g;else HEAP[e]=g;HEAP[e+4]=g}_FT_List_Add.__index__=Runtime.getFunctionIndex(_FT_List_Add,"_FT_List_Add");
function _FT_List_Insert(e,g){var d;d=HEAP[e];HEAP[g+4]=d;HEAP[g]=0;if(d==0)HEAP[e+4]=g;else HEAP[d]=g;HEAP[e]=g}_FT_List_Insert.__index__=Runtime.getFunctionIndex(_FT_List_Insert,"_FT_List_Insert");function _FT_List_Remove(e,g){var d,b;d=HEAP[g];b=HEAP[g+4];if(d!=0)HEAP[d+4]=b;else HEAP[e]=b;if(b!=0)HEAP[b]=d;else HEAP[e+4]=d}_FT_List_Remove.__index__=Runtime.getFunctionIndex(_FT_List_Remove,"_FT_List_Remove");
function _FT_List_Up(e,g){var d,b;d=HEAP[g];b=HEAP[g+4];if(d!=0){HEAP[d+4]=b;if(b!=0)HEAP[b]=d;else HEAP[e+4]=d;HEAP[g]=0;HEAP[g+4]=HEAP[e];HEAP[HEAP[e]]=g;HEAP[e]=g}}_FT_List_Up.__index__=Runtime.getFunctionIndex(_FT_List_Up,"_FT_List_Up");function _FT_List_Iterate(e,g,d){var b=null;e=HEAP[e];var a=b=0;for(b=-1;;){var c=b==-1?a:0,f=b==-1?e:h;if((b==-1?e:h)==0){b=0;break}var h=HEAP[f+4],i=FUNCTION_TABLE[g](f,d);if(i!=0){b=1;break}else b=1}return b=b==0?c:i}
_FT_List_Iterate.__index__=Runtime.getFunctionIndex(_FT_List_Iterate,"_FT_List_Iterate");function _FT_List_Finalize(e,g,d,b){var a=null,c=HEAP[e];if(c!=0){var f=g!=0;a:do if(f){var h=d+8;for(a=0;;){a=a==0?c:i;var i=HEAP[a+4];FUNCTION_TABLE[g](d,HEAP[a+8],b);a=a;a!=0&&FUNCTION_TABLE[HEAP[h]](d,a);if(i!=0)a=3;else break a}}else for(a=9;;){h=a==6?k:c;var k=HEAP[h+4];h=h;h!=0&&FUNCTION_TABLE[HEAP[d+8]](d,h);if(k!=0)a=6;else break a}while(0)}HEAP[e]=0;HEAP[e+4]=0}
_FT_List_Finalize.__index__=Runtime.getFunctionIndex(_FT_List_Finalize,"_FT_List_Finalize");function _ft_highpow2(e){var g=null;g=e;e=g-1&g;if(e!=0){for(g=0;;){var d=g==0?e:b,b=d-1&d;if(b==0)break;else g=1}g=d}return g}_ft_highpow2.__index__=Runtime.getFunctionIndex(_ft_highpow2,"_ft_highpow2");function _FT_Alloc(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);e=_ft_mem_alloc(e,g,b);HEAP[d]=e;d=HEAP[b];STACKTOP=b;return d}_FT_Alloc.__index__=Runtime.getFunctionIndex(_FT_Alloc,"_FT_Alloc");
function _FT_QAlloc(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c;c=a=0;var f=reSign(g,32)>reSign(0,32);a:do if(f){c=FUNCTION_TABLE[HEAP[e+4]](e,g);if(c!=0)break a;a=64}else{if(!(reSign(g,32)<reSign(0,32)))break a;a=6}while(0);HEAP[b]=a;HEAP[d]=c;e=HEAP[b];STACKTOP=b;return e}_FT_QAlloc.__index__=Runtime.getFunctionIndex(_FT_QAlloc,"_FT_QAlloc");
function _FT_Realloc(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);e=_ft_mem_realloc(e,1,g,d,HEAP[b],a);HEAP[b]=e;b=HEAP[a];STACKTOP=a;return b}_FT_Realloc.__index__=Runtime.getFunctionIndex(_FT_Realloc,"_FT_Realloc");function _FT_QRealloc(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);e=_ft_mem_qrealloc(e,1,g,d,HEAP[b],a);HEAP[b]=e;b=HEAP[a];STACKTOP=a;return b}_FT_QRealloc.__index__=Runtime.getFunctionIndex(_FT_QRealloc,"_FT_QRealloc");
function _FT_Free(e,g){var d;if(HEAP[g]!=0){d=HEAP[g];d!=0&&FUNCTION_TABLE[HEAP[e+8]](e,d);HEAP[g]=0}}_FT_Free.__index__=Runtime.getFunctionIndex(_FT_Free,"_FT_Free");function _BBox_Move_To(e,g){var d=STACKTOP;STACKTOP+=8;Runtime.memset(d,0,8);HEAP[d]=HEAP[e];HEAP[d+4]=HEAP[e+4];HEAP[g]=HEAP[d];HEAP[g+4]=HEAP[d+4];STACKTOP=d;return 0}_BBox_Move_To.__index__=Runtime.getFunctionIndex(_BBox_Move_To,"_BBox_Move_To");
function _BBox_Conic_Check(e,g,d,b,a){var c;e=e;g=g;c=d=d;var f=reSign(e,32)<=reSign(c,32);a:do if(f){c=g==e?0:1;break a}else c=1;while(0);a:do if(c==1){f=d;var h=reSign(e,32)<reSign(f,32);f=g;b:do if(h){var i=e;if(!(reSign(f,32)>=reSign(i,32))){c=3;break b}i=d;if(reSign(g,32)<=reSign(i,32))break a}else{c=d;if(!(reSign(f,32)>=reSign(c,32))){c=3;break b}c=e;if(!(reSign(g,32)<=reSign(c,32))){c=3;break b}g=e;e=d;d=g;break a}while(0);d=_FT_MulDiv(g-e,g-e,e+(0-g*2)+d);e=d=e-d}while(0);g=e;if(reSign(HEAP[b],
32)>reSign(g,32))HEAP[b]=e;b=d;if(reSign(HEAP[a],32)<reSign(b,32))HEAP[a]=d}_BBox_Conic_Check.__index__=Runtime.getFunctionIndex(_BBox_Conic_Check,"_BBox_Conic_Check");
function _BBox_Conic_To(e,g,d){var b=STACKTOP;STACKTOP+=8;Runtime.memset(b,0,8);var a;a=HEAP[d+8];var c=reSign(HEAP[e],32)<reSign(a,32);a:do if(c)a=0;else{a=HEAP[d+8+8];a=reSign(HEAP[e],32)>reSign(a,32)?0:1;break a}while(0);a==0&&_BBox_Conic_Check(HEAP[d],HEAP[e],HEAP[g],d+8,d+8+8);a=HEAP[d+8+4];c=reSign(HEAP[e+4],32)<reSign(a,32);a:do if(c)a=3;else{a=HEAP[d+8+12];a=reSign(HEAP[e+4],32)>reSign(a,32)?3:4;break a}while(0);a==3&&_BBox_Conic_Check(HEAP[d+4],HEAP[e+4],HEAP[g+4],d+8+4,d+8+12);HEAP[b]=HEAP[g];
HEAP[b+4]=HEAP[g+4];HEAP[d]=HEAP[b];HEAP[d+4]=HEAP[b+4];STACKTOP=b;return 0}_BBox_Conic_To.__index__=Runtime.getFunctionIndex(_BBox_Conic_To,"_BBox_Conic_To");function _test_cubic_extrema(e,g,d,b,a,c,f){var h,i;d=d+(0-g*2)+e;g=g-e;b=reSign(a,32)>reSign(0,32);h=reSign(a,32)<=reSign(65535,32);b=b&h;a:do if(b){i=_FT_MulFix(a,a);h=_FT_MulFix(g,a*2);var k=e;i=_FT_MulFix(d,i);k=h=k+h+i;if(reSign(HEAP[c],32)>reSign(k,32))HEAP[c]=h;k=h;if(!(reSign(HEAP[f],32)<reSign(k,32)))break a;HEAP[f]=h}while(0)}
_test_cubic_extrema.__index__=Runtime.getFunctionIndex(_test_cubic_extrema,"_test_cubic_extrema");
function _BBox_Cubic_Check(e,g,d,b,a,c){var f,h=null,i,k,j,l,m;f=reSign(HEAP[a],32)>reSign(e,32);a:do if(f)HEAP[a]=e;else{i=e;if(!(reSign(HEAP[c],32)<reSign(i,32)))break a;HEAP[c]=e}while(0);f=reSign(HEAP[a],32)>reSign(b,32);a:do if(f)HEAP[a]=b;else{i=b;if(!(reSign(HEAP[c],32)<reSign(i,32)))break a;HEAP[c]=b}while(0);i=reSign(e,32)<=reSign(b,32);a:do{if(i){if(!(reSign(e,32)<=reSign(g,32))){f=7;break a}f=b;if(!(reSign(g,32)<=reSign(f,32))){f=7;break a}f=d;if(!(reSign(e,32)<=reSign(f,32))){f=7;break a}f=
b;f=reSign(d,32)<=reSign(f,32)?10:7}else{if(!(reSign(e,32)>=reSign(g,32))){f=7;break a}f=b;if(!(reSign(g,32)>=reSign(f,32))){f=7;break a}f=d;if(!(reSign(e,32)>=reSign(f,32))){f=7;break a}f=b;f=reSign(d,32)>=reSign(f,32)?10:7}break a}while(0);a:do if(f==7){i=0-e+b+(g-d)*3;k=d+(0-g*2)+e;j=g-e;h=0;l=i;m=0-l;l=reSign(l,32)>=reSign(0,32)?l:m;m=k;var o=0-m;m=reSign(m,32)>=reSign(0,32)?m:o;l=m|l;m=j;o=0-m;m=reSign(m,32)>=reSign(0,32)?m:o;l=m=m|l;if(m==0)break a;if(unSign(l,32)>unSign(8388607,32)){var n=
l;l=h+1;for(h=15;;){q=h==15?0:q;var p=l+q,r=unSign(h==15?n:r,32)>>>unSign(1,32);h=unSign(r,32)>unSign(8388607,32);var q=q+1;if(h)h=16;else break}n=h=p;i=reSign(i,32)>>reSign(n,32);n=h;k=n=reSign(k,32)>>reSign(n,32);h=h;j=reSign(j,32)>>reSign(h,32);h=17}else if(unSign(l,32)<=unSign(4194303,32)){var s=l;l=h+1;for(h=19;;){v=h==19?0:v;var u=l+v,t=(h==19?s:t)<<1;h=unSign(t,32)<=unSign(4194303,32);var v=v+1;if(h)h=20;else break}h=u;i<<=h;k=s=k<<h;j<<=h;h=21}else{var w=k;h=22}h=h==22?w:h==21?s:n;if(i==0){if(h==
0)break a;i=0-_FT_DivFix(j,k);h=Math.floor(reSign(i,32)/reSign(2,32))}else{h=_FT_MulFix(h,k);j=_FT_MulFix(i,j);j=h-j;if(reSign(j,32)<reSign(0,32))break a;if(j==0)h=0-_FT_DivFix(k,i);else{j=_FT_SqrtFixed(j);h=0-_FT_DivFix(k-j,i);_test_cubic_extrema(e,g,d,b,h,a,c);h=0-_FT_DivFix(j+k,i)}}_test_cubic_extrema(e,g,d,b,h,a,c)}while(0)}_BBox_Cubic_Check.__index__=Runtime.getFunctionIndex(_BBox_Cubic_Check,"_BBox_Cubic_Check");
function _BBox_Cubic_To(e,g,d,b){var a=STACKTOP;STACKTOP+=8;Runtime.memset(a,0,8);var c;c=HEAP[b+8];var f=reSign(HEAP[e],32)<reSign(c,32);a:do if(f)c=0;else{c=HEAP[b+8+8];if(reSign(HEAP[e],32)>reSign(c,32)){c=0;break a}c=HEAP[b+8];if(reSign(HEAP[g],32)<reSign(c,32)){c=0;break a}c=HEAP[b+8+8];c=reSign(HEAP[g],32)>reSign(c,32)?0:3;break a}while(0);c==0&&_BBox_Cubic_Check(HEAP[b],HEAP[e],HEAP[g],HEAP[d],b+8,b+8+8);c=HEAP[b+8+4];f=reSign(HEAP[e+4],32)<reSign(c,32);a:do if(f)c=5;else{c=HEAP[b+8+12];if(reSign(HEAP[e+
4],32)>reSign(c,32)){c=5;break a}c=HEAP[b+8+4];if(reSign(HEAP[g+4],32)<reSign(c,32)){c=5;break a}c=HEAP[b+8+12];c=reSign(HEAP[g+4],32)>reSign(c,32)?5:8;break a}while(0);c==5&&_BBox_Cubic_Check(HEAP[b+4],HEAP[e+4],HEAP[g+4],HEAP[d+4],b+8+4,b+8+12);HEAP[a]=HEAP[d];HEAP[a+4]=HEAP[d+4];HEAP[b]=HEAP[a];HEAP[b+4]=HEAP[a+4];STACKTOP=a;return 0}_BBox_Cubic_To.__index__=Runtime.getFunctionIndex(_BBox_Cubic_To,"_BBox_Cubic_To");
function _FT_Outline_Get_BBox(e,g){var d=STACKTOP;STACKTOP+=56;Runtime.memset(d,0,56);var b,a=null,c,f=d+16,h,i=d+32,k=g==0;a:do if(k)c=6;else if(e==0)c=20;else{c=HEAP[e+2]==0;b:do if(!c){if(reSign(HEAP[e],16)<=reSign(0,16))break b;h=HEAP[e+4];HEAP[d+8]=HEAP[h];HEAP[d]=HEAP[d+8];HEAP[f+8]=HEAP[d];HEAP[f]=HEAP[f+8];HEAP[d+12]=HEAP[h+4];HEAP[d+4]=HEAP[d+12];HEAP[f+12]=HEAP[d+4];HEAP[f+4]=HEAP[f+12];h+=8;k=unSign(1,16);c=reSign(HEAP[e+2],16);if(reSign(k,32)<reSign(c,32)){k=d;c=d+8;var j=d+4,l=d+12,m=
e+8,o=f,n=f,p=f+8,r=f+8,q=f+4,s=f+4,u=f+12,t=f+12,v=e+2;h=h;var w=HEAP[k],x=HEAP[l],y=HEAP[j],A=HEAP[c],z=unSign(1,16),C=unSign(2,16);a=3;c:for(;;){L=a==3?0:L;F=a==3?A:F;G=a==3?y:G;H=a==3?x:H;b=a==3?w:b;var B=z+L&65535;a=C+L&65535;var D=HEAP[h+8*L],E=HEAP[h+8*L+4];b=reSign(b,32)>reSign(D,32)?D:b;var F=reSign(F,32)<reSign(D,32)?D:F,G=reSign(G,32)>reSign(E,32)?E:G,H=reSign(H,32)<reSign(E,32)?E:H,J=HEAP[m];B=unSign(B,16);B=(reSign(HEAP[J+B],8)&3)==1;d:do if(B){if(reSign(HEAP[o],32)>reSign(D,32))HEAP[n]=
D;if(reSign(HEAP[p],32)<reSign(D,32))HEAP[r]=D;if(reSign(HEAP[q],32)>reSign(E,32))HEAP[s]=E;if(!(reSign(HEAP[u],32)<reSign(E,32)))break d;HEAP[t]=E}while(0);a=unSign(a,16);D=reSign(HEAP[v],16);a=reSign(a,32)<reSign(D,32);var L=L+1;if(a)a=9;else break c}HEAP[c]=F;HEAP[j]=G;HEAP[l]=H;HEAP[k]=b}b=HEAP[f];F=reSign(HEAP[d],32)<reSign(b,32);c:do if(F)b=13;else{b=HEAP[f+8];if(reSign(HEAP[d+8],32)>reSign(b,32)){b=13;break c}b=HEAP[f+4];if(reSign(HEAP[d+4],32)<reSign(b,32)){b=13;break c}b=HEAP[f+12];if(reSign(HEAP[d+
12],32)>reSign(b,32)){b=13;break c}b=g;HEAP[b]=HEAP[f];HEAP[b+4]=HEAP[f+4];HEAP[b+8]=HEAP[f+8];HEAP[b+12]=HEAP[f+12];b=19;break c}while(0);if(b==13){b=i+8;HEAP[b]=HEAP[f];HEAP[b+4]=HEAP[f+4];HEAP[b+8]=HEAP[f+8];HEAP[b+12]=HEAP[f+12];f=b=_FT_Outline_Decompose(e,_bbox_interface,i);if(b!=0){c=f;break a}else{f=g;i=i+8;HEAP[f]=HEAP[i];HEAP[f+4]=HEAP[i+4];HEAP[f+8]=HEAP[i+8];HEAP[f+12]=HEAP[i+12]}}c=0;break a}while(0);HEAP[g+8]=0;HEAP[g]=HEAP[g+8];HEAP[g+12]=0;HEAP[g+4]=HEAP[g+12];c=0}while(0);i=c;STACKTOP=
d;return i}_FT_Outline_Get_BBox.__index__=Runtime.getFunctionIndex(_FT_Outline_Get_BBox,"_FT_Outline_Get_BBox");
function _FT_Get_BDF_Charset_ID(e,g,d){var b=STACKTOP;STACKTOP+=8;Runtime.memset(b,0,8);var a,c=b+4,f,h;HEAP[b]=0;HEAP[c]=0;a=6;var i=e!=0;a:do if(i){f=HEAP[e+96];h=0;if(HEAP[HEAP[f]+32]!=0)h=FUNCTION_TABLE[HEAP[HEAP[f]+32]](f,__str19);f=h=h;if(h==0)break a;if(HEAP[f]==0)break a;a=FUNCTION_TABLE[HEAP[f]](e,b,c)}while(0);if(g!=0)HEAP[g]=HEAP[b];if(d!=0)HEAP[d]=HEAP[c];e=a;STACKTOP=b;return e}_FT_Get_BDF_Charset_ID.__index__=Runtime.getFunctionIndex(_FT_Get_BDF_Charset_ID,"_FT_Get_BDF_Charset_ID");
function _FT_Get_BDF_Property(e,g,d){var b,a,c;b=6;HEAP[d]=0;var f=e!=0;a:do if(f){a=HEAP[e+96];c=0;if(HEAP[HEAP[a]+32]!=0)c=FUNCTION_TABLE[HEAP[HEAP[a]+32]](a,__str19);a=c=c;if(c==0)break a;if(HEAP[a+4]==0)break a;b=FUNCTION_TABLE[HEAP[a+4]](e,g,d)}while(0);return b}_FT_Get_BDF_Property.__index__=Runtime.getFunctionIndex(_FT_Get_BDF_Property,"_FT_Get_BDF_Property");function _FT_Bitmap_New(e){HEAP[e]=0;HEAP[e+4]=0;HEAP[e+8]=0;HEAP[e+12]=0;var g=e+20;_llvm_memset_p0i8_i64(e+16,0,4,4,0);HEAP[g]=0}
_FT_Bitmap_New.__index__=Runtime.getFunctionIndex(_FT_Bitmap_New,"_FT_Bitmap_New");
function _FT_Bitmap_Copy(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a=null,c,f,h;a=HEAP[e];HEAP[b]=0;e=HEAP[g+8];if(g==d)g=0;else if(HEAP[g+12]==0){HEAP[d]=HEAP[g];HEAP[d+4]=HEAP[g+4];HEAP[d+8]=HEAP[g+8];HEAP[d+12]=HEAP[g+12];HEAP[d+16]=HEAP[g+16];HEAP[d+18]=HEAP[g+18];HEAP[d+19]=HEAP[g+19];HEAP[d+20]=HEAP[g+20];g=0}else{if(reSign(e,32)<reSign(0,32))e=0-e;e=e*HEAP[g];if(HEAP[d+12]!=0){f=HEAP[d+8];if(reSign(f,32)<reSign(0,32))f=0-f;f=f*HEAP[d];if(f!=e){var i=_ft_mem_qrealloc(a,1,f,
e,HEAP[d+12],b);HEAP[d+12]=i;i=HEAP[b];a=3}else{h=HEAP[b];a=9}}else{f=c=0;var k=reSign(e,32)>reSign(0,32);a:do if(k){f=FUNCTION_TABLE[HEAP[a+4]](a,e);if(f!=0)break a;c=64}else{if(!(reSign(e,32)<reSign(0,32)))break a;c=6}while(0);HEAP[b]=c;a=f;HEAP[d+12]=a;c=HEAP[b];a=6}if((a==9?h:a==3?i:c)==0){h=HEAP[d+12];HEAP[d]=HEAP[g];HEAP[d+4]=HEAP[g+4];HEAP[d+8]=HEAP[g+8];HEAP[d+12]=HEAP[g+12];HEAP[d+16]=HEAP[g+16];HEAP[d+18]=HEAP[g+18];HEAP[d+19]=HEAP[g+19];HEAP[d+20]=HEAP[g+20];HEAP[d+12]=h;_llvm_memcpy_p0i8_p0i8_i32(HEAP[d+
12],HEAP[g+12],e,1,0)}g=HEAP[b]}g=g;STACKTOP=b;return g}_FT_Bitmap_Copy.__index__=Runtime.getFunctionIndex(_FT_Bitmap_Copy,"_FT_Bitmap_Copy");
function _FT_Bitmap_Embolden(e,g,d,b){var a=STACKTOP;STACKTOP+=28;Runtime.memset(a,0,28);var c,f=null,h,i,k,j,l,m,o,n,p,r,q,s,u,t,v;i=a+4;j=e==0;a:do if(j)f=33;else{f=g==0;b:do if(!f){if(HEAP[g+12]==0)break b;d=reSign(d+32&-64,32)>>reSign(6,32);b=reSign(b+32&-64,32)>>reSign(6,32);j=d;if(j!=0)f=2;else if(b!=0){k=d;f=4}else{f=0;break a}k=reSign(f==4?k:j,32)<reSign(0,32);c:do if(!k){if(reSign(b,32)<reSign(0,32))break c;k=reSign(HEAP[g+18],8);c=k==1?70:k==3?71:k==4?71:k==5?72:k==6?73:11;d:do if(c==70){if(!(reSign(d,
32)>reSign(8,32)))break d;d=8}else if(c==71){k=d+HEAP[g+4];k=HEAP[g+18]==3?Math.floor(reSign(k+3,32)/reSign(4,32)):Math.floor(reSign(k+1,32)/reSign(2,32));j=j=i;HEAP[j]=0;HEAP[j+4]=0;HEAP[j+8]=0;HEAP[j+12]=0;f=j+20;_llvm_memset_p0i8_i64(j+16,0,4,4,0);HEAP[f]=0;r=k=_FT_Bitmap_Convert(e,g,i,k);if(k!=0){f=r;break a}else{_FT_Bitmap_Done(e,g);k=g;HEAP[k]=HEAP[i];HEAP[k+4]=HEAP[i+4];HEAP[k+8]=HEAP[i+8];HEAP[k+12]=HEAP[i+12];HEAP[k+16]=HEAP[i+16];HEAP[k+18]=HEAP[i+18];HEAP[k+19]=HEAP[i+19];HEAP[k+20]=HEAP[i+
20]}}else if(c==72)d*=3;else if(c==73)b*=3;while(0);k=b;j=d;f=g;i=HEAP[e];e=f;f=j;k=k;o=HEAP[e+4];n=HEAP[e];j=c=HEAP[e+8];if(reSign(c,32)<reSign(0,32))j=0-j;c=reSign(HEAP[e+18],8);c=c==1?74:c==2?75:c==3?76:c==4?77:c==5?75:c==6?75:78;d:do if(c==78){r=18;c=14;break d}else if(c==74){m=1;l=unSign(o+7+f,32)>>>unSign(3,32);c=13;break d}else if(c==75){m=8;l=f+o;c=13;break d}else if(c==76){m=2;l=unSign(o+3+f,32)>>>unSign(2,32);c=13;break d}else if(c==77){m=4;l=unSign(o+1+f,32)>>>unSign(1,32);c=13;break d}while(0);
d:do if(c==13){r=k==0;e:do if(r){c=j;if(!(reSign(l,32)<=reSign(c,32))){c=16;break e}r=j*8;c=(f+o)*m;f=r;r=reSign(c,32)<reSign(f,32);f:do if(r){f=HEAP[e+12];u=reSign(c,32)>>reSign(3,32);q=f+u;s=HEAP[e+12]+j;u=f=c&7;u=unSign(65280,32)>>>unSign(u,32);var w=n;t=w;if(!(reSign(w,32)>reSign(0,32)))break f;f=reSign(f,32)>reSign(0,32);var x=u&255;w=u=j;q=q;t=t;s=s;reSign(0-t,32);reSign(-1,32);var y=0-t;y=reSign(y,32)>reSign(-1,32)?y:-1;t=t+y;if(f){t=t+1;for(f=19;;){f=f==23?z:0;z=u*f;y=q+(z+1);var A=s+w*f;
HEAP[q+z]&=x;y<A&&_llvm_memset_p0i8_i32(y,0,A-y,1,0);var z=f+1;if(z!=t)f=23;else break}}else{x=t+1;for(f=21;;){f=f==28?p:0;p=s+w*f;t=q+u*f;t<p&&_llvm_memset_p0i8_i32(t,0,p-t,1,0);p=f+1;if(p!=x)f=28;else break}}}while(0);c=31;break e}else c=16;while(0);e:do if(c==16){p=_ft_mem_qrealloc(i,k+HEAP[e],0,l,0,a);if(HEAP[a]!=0){r=l=HEAP[a];if(l!=0)break d;else break e}else{z=reSign(HEAP[e+8],32)>reSign(0,32);m=unSign(m*o+7,32)>>>unSign(3,32);f:do if(z){o=m;n=f=0;if(!(reSign(HEAP[e],32)>reSign(n,32)))break f;
o=o;n=e+12;c=j;r=l;u=p;w=e;f=f;q=f+1;s=f*c;x=r*(f+k);for(f=32;;){C=f==32?0:C;f=q+C;_llvm_memcpy_p0i8_p0i8_i32(u+(x+r*C),HEAP[n]+(s+c*C),o,1,0);f=reSign(HEAP[w],32)>reSign(f,32);var C=C+1;if(f)f=34;else break}}else{o=m;n=f=0;if(!(reSign(HEAP[e],32)>reSign(n,32)))break f;o=o;n=e+12;c=j;r=l;u=p;w=e;f=f;q=f+1;s=f*c;x=f*r;for(f=37;;){h=f==37?0:h;f=q+h;_llvm_memcpy_p0i8_p0i8_i32(u+(x+r*h),HEAP[n]+(s+c*h),o,1,0);f=reSign(HEAP[w],32)>reSign(f,32);h=h+1;if(f)f=38;else break}}while(0);C=HEAP[e+12];h=i;i=C;
C!=0&&FUNCTION_TABLE[HEAP[h+8]](h,i);HEAP[e+12]=0;HEAP[e+12]=p;if(reSign(HEAP[e+8],32)<reSign(0,32))l=0-l;HEAP[e+8]=l;break e}}while(0);i=l=HEAP[g+8];if(reSign(l,32)>reSign(0,32))j=HEAP[g+12]+b*i;else{i=0-i;j=HEAP[g+12]+(HEAP[g]-1)*i}if(reSign(HEAP[g],32)>reSign(0,32)){l=i-1;C=reSign(l,32)>=reSign(0,32);h=d;e=b;f=k=i;i=b;k=reSign(0,32)<reSign(k,32);j=j;m=reSign(f,32)>reSign(1,32)?f:1;f=45;e:for(;;){J=f==45?0:J;z=f==45?j:v;p=1+J;v=l;c=C?47:48;f:for(;;)if(c==47){o=unSign(HEAP[z+v],8);f=47;g:for(;;){n=
f==51?B:0;c=n+1;u=n*-1;r=u+7;u=u+-1;w=z+u;if(!(reSign(c,32)<=reSign(h,32))){c=54;break g}q=HEAP[g+18]==1;s=v;h:do if(q){x=HEAP[z+s];x=reSign(o,32)>>reSign(c,32)&255|x;HEAP[z+v]=x;if(!(reSign(v,32)>reSign(0,32)))break h;x=HEAP[z+v];x=unSign(HEAP[z+(v-1)],8)<<r&255|x;HEAP[z+v]=x}else{if(!(reSign(s+u,32)>=reSign(0,32))){c=54;break g}x=unSign(HEAP[z+v],8);x=unSign(HEAP[w+v],8)+x;t=reSign(HEAP[g+16],16)-1;if(reSign(x,32)>reSign(t,32)){c=55;break g}HEAP[z+v]=HEAP[w+v]+HEAP[z+v];x=unSign(HEAP[z+v],8);t=
reSign(HEAP[g+16],16)-1;if(x==t){c=54;break g}}while(0);var B=n+1;f=51;c=49}if(c==55)HEAP[z+v]=(HEAP[g+16]&255)-1;v=o=v-1;if(reSign(o,32)>=reSign(0,32)){c=47;continue f}c=48}else if(c==48){v=1;f=reSign(v,32)<=reSign(e,32);var D=HEAP[g+8];if(f){f=48;c=60}else{f=48;c=61}break f}if(c==60){if(k){f=60;c=62}else{f=60;c=63}f:for(;;)if(c==62){G=(f==65?G:D)*-1*v;for(f=62;;){F=f==62?0:F;var E=z+(G+F);HEAP[E]=HEAP[z+F]|HEAP[E];var F=F+1;if(F!=m)f=64;else break}v+=1;E=reSign(v,32)<=reSign(i,32);var G=HEAP[g+
8];if(E){f=65;c=62}else{f=65;break f}}else if(c==63){v+=1;E=reSign(v,32)<=reSign(i,32);var H=HEAP[g+8];if(E)c=f=63;else{f=63;break f}}E=f==65?G:H;f=66}v=z+(f==66?E:D);f=reSign(HEAP[g],32)>reSign(p,32);var J=J+1;if(f)f=61;else break e}}HEAP[g+4]=d+HEAP[g+4];HEAP[g]=b+HEAP[g];f=0;break a}while(0);f=r;break a}while(0);f=6;break a}while(0);f=6}while(0);g=f;STACKTOP=a;return g}_FT_Bitmap_Embolden.__index__=Runtime.getFunctionIndex(_FT_Bitmap_Embolden,"_FT_Bitmap_Embolden");
function _FT_Bitmap_Convert(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c,f=null,h,i,k,j,l,m;HEAP[a]=0;var o=e==0;a:do if(o)h=33;else{h=HEAP[e];i=reSign(HEAP[g+18],8);c=i==1?41:i==2?41:i==3?41:i==4?41:i==5?41:i==6?41:42;b:do if(c==42)HEAP[a]=6;else if(c==41){i=k=HEAP[d+8]*HEAP[d];if(reSign(k,32)<reSign(0,32))i=0-i;HEAP[d+18]=2;HEAP[d]=HEAP[g];HEAP[d+4]=HEAP[g+4];f=0;k=reSign(b,32)>reSign(0,32);c:do if(k){f=b;f=reSign(HEAP[g+4],32)%reSign(f,32);if(f==0)break c;f=b-f}while(0);HEAP[d+
8]=f+HEAP[g+4];k=i;if(!(reSign(HEAP[d+8]*HEAP[d],32)>reSign(k,32)))break b;h=_ft_mem_qrealloc(h,1,i,HEAP[d+8]*HEAP[d],HEAP[d+12],a);HEAP[d+12]=h;if(HEAP[a]==0)break b;h=HEAP[a];break a}while(0);h=reSign(HEAP[g+18],8);c=h==1?43:h==2?44:h==3?45:h==4?46:h==5?44:h==6?44:11;b:do if(c==43){h=HEAP[g+12];i=HEAP[d+12];HEAP[d+16]=2;k=f=HEAP[g];if(!(reSign(f,32)>reSign(0,32)))break b;for(;;){c=h;j=i;f=m=reSign(HEAP[g+4],32)>>reSign(3,32);if(reSign(m,32)>reSign(0,32)){c=c;m=j;f=f;l=f*-1;var n=reSign(l,32)>reSign(-1,
32)?l:-1;j=f+n;l=c+1+j;j=j*8;n=f+1+n;for(f=12;;){y=f==12?0:y;var p=y*8;f=m+(p+7);var r=m+(p+6),q=m+(p+5),s=m+(p+4),u=m+(p+3),t=m+(p+2),v=m+(p+1),w=m+p;p=unSign(HEAP[c+y],8);var x=reSign(p&128,32)>>reSign(7,32)&255;HEAP[w]=x;w=reSign(p&64,32)>>reSign(6,32)&255;HEAP[v]=w;v=reSign(p&32,32)>>reSign(5,32)&255;HEAP[t]=v;t=reSign(p&16,32)>>reSign(4,32)&255;HEAP[u]=t;u=reSign(p&8,32)>>reSign(3,32)&255;HEAP[s]=u;s=reSign(p&4,32)>>reSign(2,32)&255;HEAP[q]=s;q=reSign(p&2,32)>>reSign(1,32)&255;HEAP[r]=q;HEAP[f]=
p&255&1;var y=y+1;if(y!=n)f=13;else break}j=m+8+j;c=l}f=m=HEAP[g+4]&7;m=reSign(m,32)>reSign(0,32);d:do if(m){l=unSign(HEAP[c],8);if(!(reSign(f,32)>reSign(0,32)))break d;l=l;j=j;f=f;n=f*-1;q=reSign(n,32)>reSign(-1,32)?n:-1;n=-1-q;r=f+q;q=f+1+q;for(f=16;;){z=f==16?0:z;A=f==16?l:A;f=j+z;p=reSign(A&128,32)>>reSign(7,32)&255;HEAP[f]=p;var A=A<<1,z=z+1;if(z!=q)f=18;else break}l=j+1+r;f=n;j=l}while(0);h+=HEAP[g+8];i+=HEAP[d+8];k=f=k-1;if(reSign(f,32)>reSign(0,32))c=10;else break b}}else if(c==44){h=HEAP[g+
4];l=HEAP[g+12];m=HEAP[d+12];i=HEAP[g+8];k=HEAP[d+8];HEAP[d+16]=256;f=j=HEAP[g];if(!(reSign(j,32)>reSign(0,32)))break b;h=h;i=i;k=k;m=m;l=l;f=f;j=0-f;j=reSign(j,32)>reSign(-1,32)?j:-1;j=f+j+1;for(f=21;;){C=f==21?0:C;_llvm_memcpy_p0i8_p0i8_i32(m+k*C,l+i*C,h,1,0);var C=C+1;if(C!=j)c=f=22;else{c=23;break}}}else if(c==45){h=HEAP[g+12];i=HEAP[d+12];HEAP[d+16]=4;k=f=HEAP[g];if(!(reSign(f,32)>reSign(0,32)))break b;for(;;){c=h;j=i;f=m=reSign(HEAP[g+4],32)>>reSign(2,32);if(reSign(m,32)>reSign(0,32)){c=c;m=
j;f=f;l=f*-1;r=reSign(l,32)>reSign(-1,32)?l:-1;j=f+r;l=j*4;n=c+1;r=f+1+r;for(f=26;;){B=f==26?0:B;s=B*4;f=m+(s+3);q=m+(s+2);p=m+(s+1);u=m+s;s=unSign(HEAP[c+B],8);t=reSign(s&192,32)>>reSign(6,32)&255;HEAP[u]=t;u=reSign(s&48,32)>>reSign(4,32)&255;HEAP[p]=u;p=reSign(s&12,32)>>reSign(2,32)&255;HEAP[q]=p;HEAP[f]=s&255&3;var B=B+1;if(B!=r)f=27;else break}f=n+j;j=m+4+l;c=f}f=m=HEAP[g+4]&3;m=reSign(m,32)>reSign(0,32);d:do if(m){l=unSign(HEAP[c],8);if(!(reSign(f,32)>reSign(0,32)))break d;l=l;j=j;f=f;n=f*-1;
q=reSign(n,32)>reSign(-1,32)?n:-1;n=-1-q;r=f+q;q=f+1+q;for(f=30;;){E=f==30?0:E;D=f==30?l:D;f=j+E;p=reSign(D&192,32)>>reSign(6,32)&255;HEAP[f]=p;var D=D<<2,E=E+1;if(E!=q)f=32;else break}l=j+1+r;f=n;j=l}while(0);h+=HEAP[g+8];i+=HEAP[d+8];k=f=k-1;if(reSign(f,32)>reSign(0,32))c=25;else break b}}else if(c==46){h=HEAP[g+12];i=HEAP[d+12];HEAP[d+16]=16;k=f=HEAP[g];if(!(reSign(f,32)>reSign(0,32)))break b;for(;;){c=h;f=i;l=m=reSign(HEAP[g+4],32)>>reSign(1,32);if(reSign(m,32)>reSign(0,32)){c=c;m=f;f=l;l=f*-1;
r=reSign(l,32)>reSign(-1,32)?l:-1;j=f+r;l=j*2;n=c+1;r=f+1+r;for(f=36;;){F=f==36?0:F;q=F*2;f=m+(q+1);q=m+q;p=unSign(HEAP[c+F],8);s=reSign(p&240,32)>>reSign(4,32)&255;HEAP[q]=s;HEAP[f]=p&255&15;var F=F+1;if(F!=r)f=37;else break}c=n+j;f=m+2+l;c=c}if((HEAP[g+4]&1&255)!=0){c=unSign(HEAP[c],8)&240;c=reSign(c,32)>>reSign(4,32)&255;HEAP[f]=c}h+=HEAP[g+8];i+=HEAP[d+8];k=f=k-1;if(reSign(f,32)>reSign(0,32))c=35;else break b}}while(0);h=HEAP[a]}while(0);e=h;STACKTOP=a;return e}
_FT_Bitmap_Convert.__index__=Runtime.getFunctionIndex(_FT_Bitmap_Convert,"_FT_Bitmap_Convert");
function _FT_GlyphSlot_Own_Bitmap(e){var g=STACKTOP;STACKTOP+=24;Runtime.memset(g,0,24);var d,b,a=e!=0;a:do if(a){if(HEAP[e+72]!=1651078259){d=1;break a}if((HEAP[HEAP[e+156]+4]&1)!=0){d=1;break a}d=d=g;HEAP[d]=0;HEAP[d+4]=0;HEAP[d+8]=0;HEAP[d+12]=0;a=d+20;_llvm_memset_p0i8_i64(d+16,0,4,4,0);HEAP[a]=0;d=_FT_Bitmap_Copy(HEAP[e],e+76,g);if(d!=0){b=d;d=3}else{d=e+76;HEAP[d]=HEAP[g];HEAP[d+4]=HEAP[g+4];HEAP[d+8]=HEAP[g+8];HEAP[d+12]=HEAP[g+12];HEAP[d+16]=HEAP[g+16];HEAP[d+18]=HEAP[g+18];HEAP[d+19]=HEAP[g+
19];HEAP[d+20]=HEAP[g+20];HEAP[HEAP[e+156]+4]|=1;d=1}break a}else d=1;while(0);if(d==1)b=0;e=b;STACKTOP=g;return e}_FT_GlyphSlot_Own_Bitmap.__index__=Runtime.getFunctionIndex(_FT_GlyphSlot_Own_Bitmap,"_FT_GlyphSlot_Own_Bitmap");function _FT_Bitmap_Done(e,g){var d,b;if(e==0)d=33;else if(g==0)d=6;else{b=HEAP[e];d=HEAP[g+12];d!=0&&FUNCTION_TABLE[HEAP[b+8]](b,d);HEAP[g+12]=0;HEAP[g]=0;HEAP[g+4]=0;HEAP[g+8]=0;HEAP[g+12]=0;d=g+20;_llvm_memset_p0i8_i64(g+16,0,4,4,0);d=HEAP[d]=0}return d}
_FT_Bitmap_Done.__index__=Runtime.getFunctionIndex(_FT_Bitmap_Done,"_FT_Bitmap_Done");
function _FT_Get_CID_Registry_Ordering_Supplement(e,g,d,b){var a=STACKTOP;STACKTOP+=12;Runtime.memset(a,0,12);var c,f=a+4,h=a+8,i,k;HEAP[a]=0;HEAP[f]=0;HEAP[h]=0;c=6;var j=e!=0;a:do if(j){i=HEAP[e+96];k=0;if(HEAP[HEAP[i]+32]!=0)k=FUNCTION_TABLE[HEAP[HEAP[i]+32]](i,__str20);i=k=k;if(k==0)break a;if(HEAP[i]==0)break a;c=FUNCTION_TABLE[HEAP[i]](e,a,f,h)}while(0);if(g!=0)HEAP[g]=HEAP[a];if(d!=0)HEAP[d]=HEAP[f];if(b!=0)HEAP[b]=HEAP[h];e=c;STACKTOP=a;return e}
_FT_Get_CID_Registry_Ordering_Supplement.__index__=Runtime.getFunctionIndex(_FT_Get_CID_Registry_Ordering_Supplement,"_FT_Get_CID_Registry_Ordering_Supplement");
function _FT_Get_CID_Is_Internally_CID_Keyed(e,g){var d=STACKTOP;STACKTOP+=1;Runtime.memset(d,0,1);var b=null,a,c;a=6;HEAP[d]=0;if(e!=0){b=HEAP[e+96];c=0;if(HEAP[HEAP[b]+32]!=0)c=FUNCTION_TABLE[HEAP[HEAP[b]+32]](b,__str20);b=c;c=b!=0;a:do if(c){if(HEAP[b+4]==0)break a;a=FUNCTION_TABLE[HEAP[b+4]](e,d)}while(0);c=g;b=2}else b=-1;if((b==2?c:g)!=0)HEAP[g]=HEAP[d];a=a;STACKTOP=d;return a}_FT_Get_CID_Is_Internally_CID_Keyed.__index__=Runtime.getFunctionIndex(_FT_Get_CID_Is_Internally_CID_Keyed,"_FT_Get_CID_Is_Internally_CID_Keyed");
function _FT_Get_CID_From_Glyph_Index(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a=null,c,f;c=6;HEAP[b]=0;if(e!=0){a=HEAP[e+96];f=0;if(HEAP[HEAP[a]+32]!=0)f=FUNCTION_TABLE[HEAP[HEAP[a]+32]](a,__str20);a=f;f=a!=0;a:do if(f){if(HEAP[a+8]==0)break a;c=FUNCTION_TABLE[HEAP[a+8]](e,g,b)}while(0);f=d;a=2}else a=-1;if((a==2?f:d)!=0)HEAP[d]=HEAP[b];e=c;STACKTOP=b;return e}_FT_Get_CID_From_Glyph_Index.__index__=Runtime.getFunctionIndex(_FT_Get_CID_From_Glyph_Index,"_FT_Get_CID_From_Glyph_Index");
function _FT_Get_FSType_Flags(e){var g=STACKTOP;STACKTOP+=2;Runtime.memset(g,0,2);var d,b,a;a=e!=0;a:do if(a){d=HEAP[e+96];a=0;if(HEAP[HEAP[d]+32]!=0)a=FUNCTION_TABLE[HEAP[HEAP[d]+32]](d,__str21);d=a=a;if(a==0){d=2;break a}if(HEAP[d+4]==0){d=2;break a}if(FUNCTION_TABLE[HEAP[d+4]](e,g)!=0){d=2;break a}if(HEAP[g]==0){d=2;break a}b=unSign(HEAP[g],16);d=6;break a}else d=2;while(0);a:do if(d==2){b=a=_FT_Get_Sfnt_Table(e,2);a=a!=0;b:do if(a){if(HEAP[b]==-1){d=8;break b}b=unSign(HEAP[b+8],16);break a}while(0);
b=0}while(0);e=b&65535;STACKTOP=g;return e}_FT_Get_FSType_Flags.__index__=Runtime.getFunctionIndex(_FT_Get_FSType_Flags,"_FT_Get_FSType_Flags");
function _FT_Get_Gasp(e,g){var d,b=null,a,c,f,h;a=-1;var i=e!=0;a:do if(i){if((HEAP[e+8]&8)==0)break a;c=e;if(HEAP[c+548+2]==0)break a;f=HEAP[c+548+4];var k=unSign(HEAP[c+548+2],16);h=f+4*k;k=g;h=h;f=f;for(b=2;;){d=b==4?m:0;var j=f+4*d;b=f+4*(d+1);var l=unSign(HEAP[j],16);if(!(unSign(l,32)<unSign(k,32))){d=6;break}var m=d+1;if(b>=h){d=5;break}else{b=4;d=3}}if(d==6){a=unSign(HEAP[j+2],16);if(HEAP[c+548]!=0)break a;a&=3}}while(0);return a}
_FT_Get_Gasp.__index__=Runtime.getFunctionIndex(_FT_Get_Gasp,"_FT_Get_Gasp");
function _ft_bitmap_glyph_init(e,g){var d,b;d=0;b=HEAP[e];if(HEAP[g+72]!=1651078259)d=18;else{HEAP[e+20]=HEAP[g+100];HEAP[e+24]=HEAP[g+104];var a=e+28;if((HEAP[HEAP[g+156]+4]&1&255)!=0){b=g+76;HEAP[a]=HEAP[b];HEAP[a+4]=HEAP[b+4];HEAP[a+8]=HEAP[b+8];HEAP[a+12]=HEAP[b+12];HEAP[a+16]=HEAP[b+16];HEAP[a+18]=HEAP[b+18];HEAP[a+19]=HEAP[b+19];HEAP[a+20]=HEAP[b+20];HEAP[HEAP[g+156]+4]&=-2}else{HEAP[a]=0;HEAP[a+4]=0;HEAP[a+8]=0;HEAP[a+12]=0;d=a+20;_llvm_memset_p0i8_i64(a+16,0,4,4,0);HEAP[d]=0;d=_FT_Bitmap_Copy(b,
g+76,e+28)}}return d}_ft_bitmap_glyph_init.__index__=Runtime.getFunctionIndex(_ft_bitmap_glyph_init,"_ft_bitmap_glyph_init");function _ft_bitmap_glyph_copy(e,g){var d;d=HEAP[e];HEAP[g+20]=HEAP[e+20];HEAP[g+24]=HEAP[e+24];return _FT_Bitmap_Copy(d,e+28,g+28)}_ft_bitmap_glyph_copy.__index__=Runtime.getFunctionIndex(_ft_bitmap_glyph_copy,"_ft_bitmap_glyph_copy");function _ft_bitmap_glyph_done(e){_FT_Bitmap_Done(HEAP[e],e+28)}
_ft_bitmap_glyph_done.__index__=Runtime.getFunctionIndex(_ft_bitmap_glyph_done,"_ft_bitmap_glyph_done");function _ft_bitmap_glyph_bbox(e,g){HEAP[g]=HEAP[e+20]<<6;HEAP[g+8]=HEAP[e+28+4]*64+HEAP[g];HEAP[g+12]=HEAP[e+24]<<6;HEAP[g+4]=HEAP[g+12]-(HEAP[e+28]<<6)}_ft_bitmap_glyph_bbox.__index__=Runtime.getFunctionIndex(_ft_bitmap_glyph_bbox,"_ft_bitmap_glyph_bbox");
function _ft_outline_glyph_init(e,g){var d,b,a,c,f,h,i;f=HEAP[e];h=g+108;i=e+20;var k=HEAP[g+72]!=1869968492;a:do if(k)d=18;else{c=e+20;a=reSign(HEAP[h],16);b=reSign(HEAP[h+2],16);d=f;b=b;a=a;c=c;if(d==0)d=33;else{d=b=_FT_Outline_New_Internal(HEAP[d],b,a,c);if(b!=0)break a;_FT_Outline_Copy(h,i)}}while(0);return d}_ft_outline_glyph_init.__index__=Runtime.getFunctionIndex(_ft_outline_glyph_init,"_ft_outline_glyph_init");
function _ft_outline_glyph_done(e){var g=e+20;e=HEAP[e];e!=0&&_FT_Outline_Done_Internal(HEAP[e],g)}_ft_outline_glyph_done.__index__=Runtime.getFunctionIndex(_ft_outline_glyph_done,"_ft_outline_glyph_done");function _ft_outline_glyph_copy(e,g){var d,b;b=HEAP[e];var a=g+20,c=reSign(HEAP[e+20],16),f=reSign(HEAP[e+20+2],16),h=b==0;a:do if(h)d=33;else{var i=_FT_Outline_New_Internal(HEAP[b],f,c,a);d=i;if(i!=0)break a;_FT_Outline_Copy(e+20,g+20)}while(0);return d}
_ft_outline_glyph_copy.__index__=Runtime.getFunctionIndex(_ft_outline_glyph_copy,"_ft_outline_glyph_copy");function _ft_outline_glyph_transform(e,g,d){var b=null,a,c,f,h=g!=0;a:do if(h){c=g;a=e+20;c=c;if(a==0)break a;if(c==0)break a;f=HEAP[a+4];a=reSign(HEAP[a+2],16);a=f+8*a;if(!(f<a))break a;c=c;a=a;f=f;for(b=3;;){i=b==3?0:i;b=f+8*(i+1);_FT_Vector_Transform(f+8*i,c);var i=i+1;if(b<a)b=4;else break}}while(0);d!=0&&_FT_Outline_Translate(e+20,HEAP[d],HEAP[d+4])}
_ft_outline_glyph_transform.__index__=Runtime.getFunctionIndex(_ft_outline_glyph_transform,"_ft_outline_glyph_transform");function _ft_outline_glyph_bbox(e,g){_FT_Outline_Get_CBox(e+20,g)}_ft_outline_glyph_bbox.__index__=Runtime.getFunctionIndex(_ft_outline_glyph_bbox,"_ft_outline_glyph_bbox");
function _ft_outline_glyph_prepare(e,g){HEAP[g+72]=1869968492;var d=g+108,b=e+20;HEAP[d]=HEAP[b];HEAP[d+2]=HEAP[b+2];HEAP[d+4]=HEAP[b+4];HEAP[d+8]=HEAP[b+8];HEAP[d+12]=HEAP[b+12];HEAP[d+16]=HEAP[b+16];HEAP[g+108+16]&=-2;return 0}_ft_outline_glyph_prepare.__index__=Runtime.getFunctionIndex(_ft_outline_glyph_prepare,"_ft_outline_glyph_prepare");
function _ft_new_glyph(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;a=HEAP[e];HEAP[d]=0;a=_ft_mem_alloc(a,HEAP[g],b);if(HEAP[b]==0){HEAP[a]=e;HEAP[a+4]=g;HEAP[a+8]=HEAP[g+4];HEAP[d]=a}e=HEAP[b];STACKTOP=b;return e}_ft_new_glyph.__index__=Runtime.getFunctionIndex(_ft_new_glyph,"_ft_new_glyph");
function _FT_Glyph_Copy(e,g){var d=STACKTOP;STACKTOP+=12;Runtime.memset(d,0,12);var b=null,a=d+8,c;b=g==0;a:do{if(!b){HEAP[g]=0;c=e==0;b:do if(!c){if(HEAP[e+4]==0)break b;b=HEAP[e+4];c=_ft_new_glyph(HEAP[e],b,a);if(c!=0)break a;var f=HEAP[a],h=e+12;HEAP[d]=HEAP[h];HEAP[d+4]=HEAP[h+4];f=f+12;HEAP[f]=HEAP[d];HEAP[f+4]=HEAP[d+4];HEAP[HEAP[a]+8]=HEAP[e+8];if(HEAP[b+16]!=0){var i=FUNCTION_TABLE[HEAP[b+16]](e,HEAP[a]);c=i;b=5}else{var k=c;b=7}a=HEAP[a];if((b==7?k:i)!=0)_FT_Done_Glyph(a);else HEAP[g]=a;
break a}while(0)}c=6}while(0);i=c;STACKTOP=d;return i}_FT_Glyph_Copy.__index__=Runtime.getFunctionIndex(_FT_Glyph_Copy,"_FT_Glyph_Copy");
function _FT_Get_Glyph(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b;b=null;var a,c,f;f=0;if(e==0)a=37;else{a=HEAP[e];if(g==0)a=6;else{var h=HEAP[e+72]==1651078259;a:do{if(h){f=_ft_bitmap_glyph_class;b=1}else if(HEAP[e+72]==1869968492){f=_ft_outline_glyph_class;b=1}else{b=_FT_Lookup_Renderer(a,HEAP[e+72],0);if(b!=0){var i=b+28;f=i;b=2}else{var k=f;b=4}if((b==4?k:i)!=0){b=1;break a}c=18;b=6}break a}while(0);a:do if(b==1){c=i=_ft_new_glyph(a,f,d);if(i!=0)break a;HEAP[HEAP[d]+12]=HEAP[e+
64]<<10;HEAP[HEAP[d]+12+4]=HEAP[e+64+4]<<10;c=FUNCTION_TABLE[HEAP[f+8]](HEAP[d],e);i=HEAP[d];if(c!=0)_FT_Done_Glyph(i);else HEAP[g]=i}while(0);a=c}}a=a;STACKTOP=d;return a}_FT_Get_Glyph.__index__=Runtime.getFunctionIndex(_FT_Get_Glyph,"_FT_Get_Glyph");
function _FT_Glyph_Transform(e,g,d){var b,a;a=0;var c=e==0;a:do if(c)b=0;else{if(HEAP[e+4]==0){b=0;break a}b=HEAP[e+4];if(HEAP[b+20]!=0){FUNCTION_TABLE[HEAP[b+20]](e,g,d);if(g==0){b=4;break a}_FT_Vector_Transform(e+12,g)}else a=18;b=4;break a}while(0);if(b==0)a=6;return a}_FT_Glyph_Transform.__index__=Runtime.getFunctionIndex(_FT_Glyph_Transform,"_FT_Glyph_Transform");
function _FT_Glyph_Get_CBox(e,g,d){var b,a=d==0;a:do if(!a){HEAP[d+12]=0;HEAP[d+8]=HEAP[d+12];HEAP[d+4]=HEAP[d+8];HEAP[d]=HEAP[d+4];if(e==0)break a;if(HEAP[e+4]==0)break a;b=HEAP[e+4];if(HEAP[b+24]==0)break a;FUNCTION_TABLE[HEAP[b+24]](e,d);if(g==1|g==3){HEAP[d]&=-64;HEAP[d+4]&=-64;HEAP[d+8]=HEAP[d+8]+63&-64;HEAP[d+12]=HEAP[d+12]+63&-64}if(!(g==2|g==3))break a;b=reSign(HEAP[d],32)>>reSign(6,32);HEAP[d]=b;b=reSign(HEAP[d+4],32)>>reSign(6,32);HEAP[d+4]=b;b=reSign(HEAP[d+8],32)>>reSign(6,32);HEAP[d+
8]=b;b=reSign(HEAP[d+12],32)>>reSign(6,32);HEAP[d+12]=b}while(0)}_FT_Glyph_Get_CBox.__index__=Runtime.getFunctionIndex(_FT_Glyph_Get_CBox,"_FT_Glyph_Get_CBox");
function _FT_Glyph_To_Bitmap(e,g,d,b){var a=STACKTOP;STACKTOP+=220;Runtime.memset(a,0,220);var c,f=a+8,h=a+168,i,k=a+208,j,l=a+212;i=0;HEAP[k]=0;j=e==0;a:do if(j)c=0;else{c=HEAP[e];if(c==0){c=0;break a}j=HEAP[c+4];if(j!=_ft_bitmap_glyph_class){if(j==0){c=0;break a}if(HEAP[j+28]==0){c=0;break a}_llvm_memset_p0i8_i32(f,0,160,1,0);_llvm_memset_p0i8_i32(h,0,40,1,0);HEAP[f+156]=h;HEAP[f]=HEAP[c];HEAP[f+72]=HEAP[j+4];i=_ft_new_glyph(HEAP[c],_ft_bitmap_glyph_class,k);if(i!=0){c=4;break a}d!=0&&_FT_Glyph_Transform(c,
0,d);i=h=FUNCTION_TABLE[HEAP[j+28]](c,f);if(h==0)i=_FT_Render_Glyph_Internal(HEAP[c],f,g);g=b==0;b:do if(g){if(d==0)break b;HEAP[l]=0-HEAP[d];HEAP[l+4]=0-HEAP[d+4];_FT_Glyph_Transform(c,0,l)}while(0);if(i!=0){c=4;break a}i=_ft_bitmap_glyph_init(HEAP[k],f);if(i!=0){c=4;break a}d=HEAP[k];f=c+12;HEAP[a]=HEAP[f];HEAP[a+4]=HEAP[f+4];d=d+12;HEAP[d]=HEAP[a];HEAP[d+4]=HEAP[a+4];b!=0&&_FT_Done_Glyph(c);HEAP[e]=HEAP[k]}c=i!=0?4:15;break a}while(0);a:do if(c==0){i=6;c=4;break a}while(0);a:do if(c==4){if(HEAP[k]==
0)break a;_FT_Done_Glyph(HEAP[k])}while(0);e=i;STACKTOP=a;return e}_FT_Glyph_To_Bitmap.__index__=Runtime.getFunctionIndex(_FT_Glyph_To_Bitmap,"_FT_Glyph_To_Bitmap");function _FT_Done_Glyph(e){var g,d,b,a=e!=0;a:do if(a){g=HEAP[HEAP[e]];b=HEAP[e+4];HEAP[b+12]!=0&&FUNCTION_TABLE[HEAP[b+12]](e);b=e;g=g;d=b;if(b==0)break a;FUNCTION_TABLE[HEAP[g+8]](g,d)}while(0)}_FT_Done_Glyph.__index__=Runtime.getFunctionIndex(_FT_Done_Glyph,"_FT_Done_Glyph");
function _FT_TrueTypeGX_Validate(e,g,d,b){var a;if(e==0)e=35;else if(d==0)e=6;else{a=HEAP[e+96];a=_ft_module_get_service(a,__str22);e=a!=0?FUNCTION_TABLE[HEAP[a]](e,g,d,b):7}return e}_FT_TrueTypeGX_Validate.__index__=Runtime.getFunctionIndex(_FT_TrueTypeGX_Validate,"_FT_TrueTypeGX_Validate");function _FT_TrueTypeGX_Free(e,g){var d,b,a=e==0;a:do if(!a){d=HEAP[e+100];b=g;d=d;b=b;if(b==0)break a;FUNCTION_TABLE[HEAP[d+8]](d,b)}while(0)}
_FT_TrueTypeGX_Free.__index__=Runtime.getFunctionIndex(_FT_TrueTypeGX_Free,"_FT_TrueTypeGX_Free");function _FT_ClassicKern_Validate(e,g,d){var b;if(e==0)e=35;else if(d==0)e=6;else{b=HEAP[e+96];b=_ft_module_get_service(b,__str123);e=b!=0?FUNCTION_TABLE[HEAP[b]](e,g,d):7}return e}_FT_ClassicKern_Validate.__index__=Runtime.getFunctionIndex(_FT_ClassicKern_Validate,"_FT_ClassicKern_Validate");
function _FT_ClassicKern_Free(e,g){var d,b,a=e==0;a:do if(!a){d=HEAP[e+100];b=g;d=d;b=b;if(b==0)break a;FUNCTION_TABLE[HEAP[d+8]](d,b)}while(0)}_FT_ClassicKern_Free.__index__=Runtime.getFunctionIndex(_FT_ClassicKern_Free,"_FT_ClassicKern_Free");function _FT_Library_SetLcdFilterWeights(){return 7}_FT_Library_SetLcdFilterWeights.__index__=Runtime.getFunctionIndex(_FT_Library_SetLcdFilterWeights,"_FT_Library_SetLcdFilterWeights");function _FT_Library_SetLcdFilter(){return 7}
_FT_Library_SetLcdFilter.__index__=Runtime.getFunctionIndex(_FT_Library_SetLcdFilter,"_FT_Library_SetLcdFilter");
function _ft_face_get_mm_service(e,g){var d=null,b,a;HEAP[g]=0;if(e==0)a=35;else{a=6;var c=(HEAP[e+8]&256)!=0;a:do if(c){d=HEAP[HEAP[e+128]+32+4];var f=d==4294967294;b:do if(f)d=0;else{if(d!=0)break b;d=HEAP[e+96];if(HEAP[HEAP[d]+32]!=0){var h=FUNCTION_TABLE[HEAP[HEAP[d]+32]](d,__str24);d=4}else{var i=0;d=6}d=b=d==6?i:h;var k=HEAP[e+128];b=b!=0?d:4294967294;HEAP[k+32+4]=b}while(0);HEAP[g]=d;if(HEAP[g]==0)break a;a=0}while(0);a=a}return a}
_ft_face_get_mm_service.__index__=Runtime.getFunctionIndex(_ft_face_get_mm_service,"_ft_face_get_mm_service");function _FT_Get_Multi_Master(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b;b=_ft_face_get_mm_service(e,d);var a=b==0;a:do if(a){b=6;if(HEAP[HEAP[d]]==0)break a;b=FUNCTION_TABLE[HEAP[HEAP[d]]](e,g)}while(0);b=b;STACKTOP=d;return b}_FT_Get_Multi_Master.__index__=Runtime.getFunctionIndex(_FT_Get_Multi_Master,"_FT_Get_Multi_Master");
function _FT_Get_MM_Var(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b;b=_ft_face_get_mm_service(e,d);var a=b==0;a:do if(a){b=6;if(HEAP[HEAP[d]+12]==0)break a;b=FUNCTION_TABLE[HEAP[HEAP[d]+12]](e,g)}while(0);b=b;STACKTOP=d;return b}_FT_Get_MM_Var.__index__=Runtime.getFunctionIndex(_FT_Get_MM_Var,"_FT_Get_MM_Var");
function _FT_Set_MM_Design_Coordinates(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;a=_ft_face_get_mm_service(e,b);var c=a==0;a:do if(c){a=6;if(HEAP[HEAP[b]+4]==0)break a;a=FUNCTION_TABLE[HEAP[HEAP[b]+4]](e,g,d)}while(0);e=a;STACKTOP=b;return e}_FT_Set_MM_Design_Coordinates.__index__=Runtime.getFunctionIndex(_FT_Set_MM_Design_Coordinates,"_FT_Set_MM_Design_Coordinates");
function _FT_Set_Var_Design_Coordinates(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;a=_ft_face_get_mm_service(e,b);var c=a==0;a:do if(c){a=6;if(HEAP[HEAP[b]+16]==0)break a;a=FUNCTION_TABLE[HEAP[HEAP[b]+16]](e,g,d)}while(0);e=a;STACKTOP=b;return e}_FT_Set_Var_Design_Coordinates.__index__=Runtime.getFunctionIndex(_FT_Set_Var_Design_Coordinates,"_FT_Set_Var_Design_Coordinates");
function _FT_Set_MM_Blend_Coordinates(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;a=_ft_face_get_mm_service(e,b);var c=a==0;a:do if(c){a=6;if(HEAP[HEAP[b]+8]==0)break a;a=FUNCTION_TABLE[HEAP[HEAP[b]+8]](e,g,d)}while(0);e=a;STACKTOP=b;return e}_FT_Set_MM_Blend_Coordinates.__index__=Runtime.getFunctionIndex(_FT_Set_MM_Blend_Coordinates,"_FT_Set_MM_Blend_Coordinates");
function _FT_Set_Var_Blend_Coordinates(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;a=_ft_face_get_mm_service(e,b);var c=a==0;a:do if(c){a=6;if(HEAP[HEAP[b]+8]==0)break a;a=FUNCTION_TABLE[HEAP[HEAP[b]+8]](e,g,d)}while(0);e=a;STACKTOP=b;return e}_FT_Set_Var_Blend_Coordinates.__index__=Runtime.getFunctionIndex(_FT_Set_Var_Blend_Coordinates,"_FT_Set_Var_Blend_Coordinates");
function _FT_OpenType_Validate(e,g,d,b,a,c,f){var h,i;h=e==0;a:do if(h)i=35;else{i=d==0;b:do if(!i){if(b==0)break b;if(a==0)break b;if(c==0)break b;if(f==0)break b;h=HEAP[e+96];h=h=_ft_module_get_service(h,__str25);i=h!=0?FUNCTION_TABLE[HEAP[h]](e,g,d,b,a,c,f):7;break a}while(0);i=6}while(0);return i}_FT_OpenType_Validate.__index__=Runtime.getFunctionIndex(_FT_OpenType_Validate,"_FT_OpenType_Validate");
function _FT_OpenType_Free(e,g){var d,b,a=e==0;a:do if(!a){d=HEAP[e+100];b=g;d=d;b=b;if(b==0)break a;FUNCTION_TABLE[HEAP[d+8]](d,b)}while(0)}_FT_OpenType_Free.__index__=Runtime.getFunctionIndex(_FT_OpenType_Free,"_FT_OpenType_Free");
function __tt_check_patents_in_range(e,g){var d,b=null,a,c,f;f=0;if(_FT_Stream_EnterFrame(e,g)!=0)f=0;else{a=HEAP[e+32];c=a+g;for(b=1;;){var h=b==1?a:b==5?k:b==6?j:b==7?l:b==8?m:i;if(!(h<c)){d=4;break}d=unSign(HEAP[h],8);if(d==6){d=13;break}else if(d==7){d=13;break}else if(d==8){d=13;break}else if(d==9){d=13;break}else if(d==10){d=13;break}else if(d==11){d=13;break}else if(d==64)d=14;else if(d==65)d=15;else if(d==113){d=16;break}else if(d==114){d=16;break}else if(d==115){d=16;break}else if(d==116){d=
16;break}else if(d==117){d=16;break}else d=d==176?7:d==177?7:d==178?7:d==179?7:d==180?7:d==181?7:d==182?7:d==183?7:d==184?8:d==185?8:d==186?8:d==187?8:d==188?8:d==189?8:d==190?8:d==191?8:9;if(d==9){var i=h+1;b=9;d=2}else if(d==14){if(h+1>=c){d=4;break}k=unSign(HEAP[h+1],8)+2;var k=h+k;b=5;d=2}else if(d==15){if(h+1>=c){d=4;break}j=(unSign(HEAP[h+1],8)+1)*2;var j=h+j;b=6;d=2}else if(d==7){l=unSign(HEAP[h],8)-174;var l=h+l;b=7;d=2}else if(d==8){m=unSign(HEAP[h],8)*2+-365;var m=h+m;b=8;d=2}}if(d!=4)if(d==
13)f=1;else if(d==16)f=1;if(HEAP[e+20]!=0){c=HEAP[e+28];a=HEAP[e];a!=0&&FUNCTION_TABLE[HEAP[c+8]](c,a);HEAP[e]=0}HEAP[e+32]=0;HEAP[e+36]=0;f=unSign(f,8)}return f&255}__tt_check_patents_in_range.__index__=Runtime.getFunctionIndex(__tt_check_patents_in_range,"__tt_check_patents_in_range");
function __tt_check_patents_in_table(e,g){var d=STACKTOP;STACKTOP+=12;Runtime.memset(d,0,12);var b=null,a,c,f,h,i=d+4,k=d+8;a=HEAP[e+104];f=c=0;b=HEAP[e+96];h=0;if(HEAP[HEAP[b]+32]!=0)h=FUNCTION_TABLE[HEAP[HEAP[b]+32]](b,__str8);h=h;var j=h!=0;a:do if(j){HEAP[d]=0;HEAP[i]=0;HEAP[k]=0;var l=c,m=g,o=h+8,n=e;for(b=1;;){var p=b==3?q:0;if(!(((b==3?r:l)!=0^1)&HEAP[d]!=m))break;var r=FUNCTION_TABLE[HEAP[o]](n,0+p,d,i,k);c=r;var q=p+1;b=3}if(c!=0)break a;c=_FT_Stream_Seek(a,HEAP[i]);if(c!=0)break a;f=__tt_check_patents_in_range(a,
HEAP[k])}while(0);a=unSign(f,8)&255;STACKTOP=d;return a}__tt_check_patents_in_table.__index__=Runtime.getFunctionIndex(__tt_check_patents_in_table,"__tt_check_patents_in_table");
function _FT_Face_CheckTrueTypePatents(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);var d,b=null,a,c,f,h,i,k=g+4;a=0;var j=e!=0;a:do if(j){if((HEAP[e+8]&8)==0)break a;a=e;c=HEAP[a+104];f=__tt_check_patents_in_table(a,1718642541);var l=f!=0;b:do if(!l){f=__tt_check_patents_in_table(a,1886545264);if(f!=0){d=2;break b}i=HEAP[a+96];h=0;if(HEAP[HEAP[i]+32]!=0)h=FUNCTION_TABLE[HEAP[HEAP[i]+32]](i,__str127);h=h;if(h==0){d=2;break b}i=a+16;h=h;var m=a,o=c,n=c,p=c,r=c,q=c,s=c,u=c,t=c;f=f;var v=p+8,
w=s+8,x=t+8;b=5;c:for(;;){var y=b==8?N:0,A=b==8?L:f,z=0+y;if(!(unSign(HEAP[i],32)>unSign(z,32))){b=6;d=26;break c}z=FUNCTION_TABLE[HEAP[h]](m,z,k);var C=HEAP[k]==0;d:do if(C)b=28;else{b=_FT_Stream_Seek(o,z);HEAP[g]=b;if(HEAP[g]!=0){b=7;break d}b=_FT_Stream_ReadShort(n,g);b=reSign(b,16);if(HEAP[g]!=0){b=9;break d}if(reSign(b,32)>=reSign(0,32)){b=b*2+8;if(reSign(b,32)<reSign(0,32)){HEAP[g]=85;b=11;break d}else{b=_FT_Stream_Seek(p,HEAP[v]+b);HEAP[g]=b;if(b!=0){b=12;break d}}}else{b=_FT_Stream_Seek(s,
HEAP[w]+8);HEAP[g]=b;if(b!=0){b=14;break d}else b=14;for(;;){var B=b==23?G:0;d=_FT_Stream_ReadShort(u,g);d=unSign(d,16);if(HEAP[g]!=0){b=15;d=16;break}G=(d&1&255)!=0?6:4;if((d&8)!=0){var D=G+2;b=18}else if((d&64)!=0){var E=G+4;b=20}else{var F=G+8;F=(d&128)!=0?F:G;b=21}var G=(d&256)!=0?1:B,H=_FT_Stream_Seek(t,HEAP[x]+(b==20?E:b==18?D:F));HEAP[g]=H;if(H!=0){d=22;break}if((d&32)==0){b=23;d=16;break}else{b=23;d=15}}if(d==16){if((b==23?G:B)==0){b=16;break d}}else if(d==22){b=22;break d}}b=_FT_Stream_ReadShort(r,
g);b=unSign(b,16);if(HEAP[g]!=0){b=24;break d}var J=__tt_check_patents_in_range(q,b);if(J!=0){b=25;d=26;break c}else b=25}while(0);var L=b==22?A:b==11?A:b==25?0:b==24?A:b==16?A:b==14?A:b==12?A:b==9?A:b==7?A:A,N=y+1;b=8;d=6}f=b==25?J:A}while(0);a=a=unSign(f,8);a=a&255}while(0);e=unSign(a,8)&255;STACKTOP=g;return e}_FT_Face_CheckTrueTypePatents.__index__=Runtime.getFunctionIndex(_FT_Face_CheckTrueTypePatents,"_FT_Face_CheckTrueTypePatents");
function _FT_Face_SetUnpatentedHinting(){return unSign(0,8)&255}_FT_Face_SetUnpatentedHinting.__index__=Runtime.getFunctionIndex(_FT_Face_SetUnpatentedHinting,"_FT_Face_SetUnpatentedHinting");
function _ft_pfr_check(e){var g=null,d,b;b=0;if(e!=0){g=HEAP[HEAP[e+128]+32+12];b=g==4294967294;a:do if(b)g=0;else{if(g!=0)break a;g=HEAP[e+96];if(HEAP[HEAP[g]+32]!=0){var a=FUNCTION_TABLE[HEAP[HEAP[g]+32]](g,__str28);g=3}else{var c=0;g=5}g=d=g==5?c:a;var f=HEAP[e+128];d=d!=0?g:4294967294;HEAP[f+32+12]=d}while(0);b=g}return b}_ft_pfr_check.__index__=Runtime.getFunctionIndex(_ft_pfr_check,"_ft_pfr_check");
function _FT_Get_PFR_Metrics(e,g,d,b,a){var c;if(e==0)e=6;else{c=_ft_pfr_check(e);if(c!=0)e=FUNCTION_TABLE[HEAP[c]](e,g,d,b,a);else{if(g!=0){c=unSign(HEAP[e+68],16);HEAP[g]=c}if(d!=0){g=unSign(HEAP[e+68],16);HEAP[d]=g}d=g=65536;if(HEAP[e+88]!=0){d=HEAP[HEAP[e+88]+12+4];g=HEAP[HEAP[e+88]+12+8]}if(b!=0)HEAP[b]=d;if(a!=0)HEAP[a]=g;e=2}e=e}return e}_FT_Get_PFR_Metrics.__index__=Runtime.getFunctionIndex(_FT_Get_PFR_Metrics,"_FT_Get_PFR_Metrics");
function _FT_Get_PFR_Kerning(e,g,d,b){var a;if(e==0)e=6;else{a=_ft_pfr_check(e);e=e=a!=0?FUNCTION_TABLE[HEAP[a+4]](e,g,d,b):_FT_Get_Kerning(e,g,d,2,b)}return e}_FT_Get_PFR_Kerning.__index__=Runtime.getFunctionIndex(_FT_Get_PFR_Kerning,"_FT_Get_PFR_Kerning");function _FT_Get_PFR_Advance(e,g,d){var b;b=_ft_pfr_check(e);return b!=0?FUNCTION_TABLE[HEAP[b+8]](e,g,d):6}_FT_Get_PFR_Advance.__index__=Runtime.getFunctionIndex(_FT_Get_PFR_Advance,"_FT_Get_PFR_Advance");
function _FT_Outline_GetInsideBorder(e){e=_FT_Outline_Get_Orientation(e);return unSign(e==0,1)}_FT_Outline_GetInsideBorder.__index__=Runtime.getFunctionIndex(_FT_Outline_GetInsideBorder,"_FT_Outline_GetInsideBorder");function _FT_Outline_GetOutsideBorder(e){e=_FT_Outline_Get_Orientation(e);return unSign(e!=0,1)}_FT_Outline_GetOutsideBorder.__index__=Runtime.getFunctionIndex(_FT_Outline_GetOutsideBorder,"_FT_Outline_GetOutsideBorder");
function _ft_stroke_border_grow(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b=null,a,c,f,h;a=HEAP[e+4];c=g+HEAP[e];HEAP[d]=0;var i=unSign(c,32)>unSign(a,32);a:do if(i){f=a;h=HEAP[e+24];var k=c;if(unSign(f,32)<unSign(k,32)){k=c;f=f;for(b=0;;){j=b==0?f:j;b=unSign(j,32)>>>unSign(1,32);var j=j+16+b;if(unSign(j,32)<unSign(k,32))b=1;else break}f=j}k=_ft_mem_realloc(h,8,a,f,HEAP[e+8],d);HEAP[e+8]=k;if(HEAP[d]!=0)break a;h=_ft_mem_realloc(h,1,a,f,HEAP[e+12],d);HEAP[e+12]=h;if(HEAP[d]!=0)break a;
HEAP[e+4]=f}while(0);a=HEAP[d];STACKTOP=d;return a}_ft_stroke_border_grow.__index__=Runtime.getFunctionIndex(_ft_stroke_border_grow,"_ft_stroke_border_grow");
function _ft_stroke_border_close(e,g){var d=STACKTOP;STACKTOP+=32;Runtime.memset(d,0,32);var b=null,a=d+8,c=d+16,f,h,i,k,j=d+24,l,m;f=HEAP[e+20];l=h=HEAP[e];if(unSign(f+1,32)>=unSign(l,32))HEAP[e]=f;else{h-=1;HEAP[e]=h;l=HEAP[e+8];m=HEAP[e+8]+8*h;HEAP[c]=HEAP[m];HEAP[c+4]=HEAP[m+4];l=l+8*f;HEAP[l]=HEAP[c];HEAP[l+4]=HEAP[c+4];c=g!=0;a:do if(c){i=HEAP[e+8]+8*f+8;k=HEAP[e+8]+8*h+-8;if(i<k){l=a;m=a+4;var o=j,n=j+4,p=d,r=d+4;i=i;k=k;for(b=1;;){z=b==1?0:z;var q=z*-1;b=k+8*(q+-1);var s=k+8*q,u=k+8*q+4,t=
i+8*(z+1),v=i+8*z,w=i+8*z+4;q=HEAP[v];var x=HEAP[w],y=HEAP[s],A=HEAP[u];HEAP[v]=y;HEAP[w]=A;HEAP[s]=q;HEAP[u]=x;var z=z+1;if(t<b)b=2;else break}HEAP[r]=A;HEAP[p]=y;HEAP[n]=x;HEAP[o]=q;HEAP[m]=x;HEAP[l]=q}l=HEAP[e+12]+f+1;m=HEAP[e+12]+h+-1;if(!(l<m))break a;l=l;m=m;for(b=5;;){C=b==5?0:C;n=C*-1;o=m+(n+-1);p=m+n;n=l+(C+1);r=l+C;i=HEAP[r];HEAP[r]=HEAP[p];HEAP[p]=i;var C=C+1;if(n<o)b=7;else break}}while(0);HEAP[HEAP[e+12]+f]|=4;HEAP[HEAP[e+12]+(h-1)]|=8}HEAP[e+20]=-1;HEAP[e+16]=0;STACKTOP=d}
_ft_stroke_border_close.__index__=Runtime.getFunctionIndex(_ft_stroke_border_close,"_ft_stroke_border_close");
function _ft_stroke_border_lineto(e,g,d){var b=STACKTOP;STACKTOP+=16;Runtime.memset(b,0,16);var a=b+8,c,f,h;c=0;var i=HEAP[e+16]!=0;a:do if(i){h=HEAP[e+8];f=HEAP[e]-1;var k=g;HEAP[a]=HEAP[k];HEAP[a+4]=HEAP[k+4];h=h+8*f;HEAP[h]=HEAP[a];HEAP[h+4]=HEAP[a+4]}else{c=_ft_stroke_border_grow(e,1);if(c!=0)break a;f=HEAP[e+8]+8*HEAP[e];h=HEAP[e+12]+HEAP[e];k=g;HEAP[b]=HEAP[k];HEAP[b+4]=HEAP[k+4];f=f;HEAP[f]=HEAP[b];HEAP[f+4]=HEAP[b+4];HEAP[h]=1;HEAP[e]+=1}while(0);HEAP[e+16]=d;e=c;STACKTOP=b;return e}
_ft_stroke_border_lineto.__index__=Runtime.getFunctionIndex(_ft_stroke_border_lineto,"_ft_stroke_border_lineto");
function _ft_stroke_border_cubicto(e,g,d,b){var a=STACKTOP;STACKTOP+=24;Runtime.memset(a,0,24);var c=a+8,f=a+16,h,i,k;h=_ft_stroke_border_grow(e,3);if(h==0){i=HEAP[e+8]+8*HEAP[e];k=HEAP[e+12]+HEAP[e];HEAP[f]=HEAP[g];HEAP[f+4]=HEAP[g+4];HEAP[i]=HEAP[f];HEAP[i+4]=HEAP[f+4];HEAP[c]=HEAP[d];HEAP[c+4]=HEAP[d+4];g=i+8;HEAP[g]=HEAP[c];HEAP[g+4]=HEAP[c+4];HEAP[a]=HEAP[b];HEAP[a+4]=HEAP[b+4];b=i+16;HEAP[b]=HEAP[a];HEAP[b+4]=HEAP[a+4];HEAP[k]=2;HEAP[k+1]=2;HEAP[k+2]=1;HEAP[e]+=3}HEAP[e+16]=0;STACKTOP=a;return h}
_ft_stroke_border_cubicto.__index__=Runtime.getFunctionIndex(_ft_stroke_border_cubicto,"_ft_stroke_border_cubicto");function _ft_stroke_border_done(e){var g,d;d=HEAP[e+24];g=HEAP[e+8];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+8]=0;g=HEAP[e+12];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+12]=0;HEAP[e]=0;HEAP[e+4]=0;HEAP[e+20]=-1;HEAP[e+28]=0}_ft_stroke_border_done.__index__=Runtime.getFunctionIndex(_ft_stroke_border_done,"_ft_stroke_border_done");
function _ft_stroke_border_get_counts(e,g,d){var b,a=null,c,f,h,i,k;f=c=0;h=HEAP[e];i=HEAP[e+12];k=0;var j=c;k=k;var l=f;a=-1;a:for(;;){b=a==5?q:0;var m=a==5?p:l,o=a==5?r:k;p=i+b;var n=j+b;if(h+b*-1==0){b=7;break a}if((unSign(HEAP[p],8)&4)!=0)if(o!=0){b=2;break a}else a=1;else if(o==0){b=2;break a}else a=4;a=a==4?o:1;r=unSign(HEAP[p],8)&8;p=m+1;var p=(r=r!=0)?p:m,r=r?0:a,q=b+1;a=5;b=0}a:do if(b==2){f=m;c=n;b=8;break a}else if(b==7){f=m;k=o;c=n;if(k!=0){b=8;break a}HEAP[e+28]=1;b=10;break a}while(0);
if(b==8)f=c=0;HEAP[g]=c;HEAP[d]=f;return 0}_ft_stroke_border_get_counts.__index__=Runtime.getFunctionIndex(_ft_stroke_border_get_counts,"_ft_stroke_border_get_counts");
function _FT_Stroker_New(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a,c;if(e==0)a=6;else{a=HEAP[e];c=_ft_mem_alloc(a,120,d);if(HEAP[d]==0){HEAP[c+116]=e;b=c+52;HEAP[b+24]=a;HEAP[b+8]=0;HEAP[b+12]=0;HEAP[b]=0;HEAP[b+4]=0;HEAP[b+20]=-1;HEAP[b+28]=0;b=c+52+32;HEAP[b+24]=a;HEAP[b+8]=0;HEAP[b+12]=0;HEAP[b]=0;HEAP[b+4]=0;HEAP[b+20]=-1;HEAP[b+28]=0}HEAP[g]=c;a=HEAP[d]}a=a;STACKTOP=d;return a}_FT_Stroker_New.__index__=Runtime.getFunctionIndex(_FT_Stroker_New,"_FT_Stroker_New");
function _FT_Stroker_Set(e,g,d,b,a){HEAP[e+44]=g;HEAP[e+32]=d;HEAP[e+36]=b;HEAP[e+40]=a;if(e!=0){g=e+52;HEAP[g]=0;HEAP[g+20]=-1;HEAP[g+28]=0;e=e+52+32;HEAP[e]=0;HEAP[e+20]=-1;HEAP[e+28]=0}}_FT_Stroker_Set.__index__=Runtime.getFunctionIndex(_FT_Stroker_Set,"_FT_Stroker_Set");function _FT_Stroker_Rewind(e){var g;if(e!=0){g=e+52;HEAP[g]=0;HEAP[g+20]=-1;HEAP[g+28]=0;e=e+52+32;HEAP[e]=0;HEAP[e+20]=-1;HEAP[e+28]=0}}_FT_Stroker_Rewind.__index__=Runtime.getFunctionIndex(_FT_Stroker_Rewind,"_FT_Stroker_Rewind");
function _FT_Stroker_Done(e){var g,d,b=e!=0;a:do if(b){g=HEAP[HEAP[e+116]];_ft_stroke_border_done(e+52);_ft_stroke_border_done(e+52+32);HEAP[e+116]=0;d=e;g=g;d=d;if(d==0)break a;FUNCTION_TABLE[HEAP[g+8]](g,d)}while(0)}_FT_Stroker_Done.__index__=Runtime.getFunctionIndex(_FT_Stroker_Done,"_FT_Stroker_Done");
function _ft_stroker_arcto(e,g){var d=STACKTOP;STACKTOP+=48;Runtime.memset(d,0,48);var b=null,a=d+8,c,f,h=d+16,i=d+24,k=d+32,j=d+40,l,m,o,n;o=HEAP[e+44];n=e+52+32*g;m=5898240-g*11796480;f=HEAP[e+4]-HEAP[e];var p=f=reSign(f,32)%reSign(23592960,32);if(reSign(p,32)<reSign(0,32)){var r=f+23592960;f=r;b=0}else b=-1;p=reSign(b==0?r:p,32)>reSign(11796480,32);f=f;if(p){c=f-23592960;b=2}else b=18;c=f=b==2?c:f;if(f==11796480)c=m*-2;m=m+HEAP[e];p=c;c=e+8;l=0;HEAP[h]=o;HEAP[h+4]=0;_FT_Vector_Rotate(h,m);HEAP[h]=
HEAP[c]+HEAP[h];HEAP[h+4]=HEAP[c+4]+HEAP[h+4];f=reSign(p,32)>=reSign(0,32)?5898240:-5898240;r=i+4;var q=c+4,s=i+4,u=a+4,t=d+4,v=k+4,w=h+4,x=k+4,y=j+4,A=i+4,z=j+4,C=h+4,B=i+4,D=i+4,E=k+4,F=j+4;b=6;a:for(;;){var G=b==16?O:m,H=b==16?M:p;if((b==16?M:p)==0)break a;O=reSign(H,32)>reSign(5898240,32);b:do if(O){var J=G+5898240;b=8}else{if(reSign(H,32)<reSign(-5898240,32)){var L=G+-5898240;b=10}else{var N=H+G;if(reSign(H,32)<reSign(0,32))b=12;else{b=12;break b}}var I=b==10?L:N,P=b==10?-5898240:H,K=0-P;b=14}while(0);
var O=b==8?J:b==14?I:N;M=b==8?5898240:b==14?P:H;l=reSign(b==8?5898240:b==14?K:H,32)>>reSign(1,32);HEAP[i]=o;HEAP[D]=0;_FT_Vector_Rotate(i,O);HEAP[i]=HEAP[c]+HEAP[i];HEAP[s]=HEAP[q]+HEAP[r];HEAP[a]=72899491;HEAP[u]=0;_ft_trig_pseudo_rotate(a,l);b=Math.floor(reSign(HEAP[a],32)/reSign(4096,32))*3+196608;l=5898240-l;HEAP[d]=72899491;HEAP[t]=0;_ft_trig_pseudo_rotate(d,l);l=Math.floor(reSign(HEAP[d],32)/reSign(4096,32))*4;b=_FT_MulDiv(o,l,b);G=G+f;HEAP[k]=b;HEAP[E]=0;_FT_Vector_Rotate(k,G);HEAP[k]=HEAP[h]+
HEAP[k];HEAP[x]=HEAP[w]+HEAP[v];G=O-f;HEAP[j]=b;HEAP[F]=0;_FT_Vector_Rotate(j,G);HEAP[j]=HEAP[i]+HEAP[j];HEAP[z]=HEAP[A]+HEAP[y];l=b=_ft_stroke_border_cubicto(n,k,j,i);if(b!=0)break a;HEAP[h]=HEAP[i];HEAP[C]=HEAP[B];var M=H-M;b=16}a=l;HEAP[n+16]=0;STACKTOP=d;return a}_ft_stroker_arcto.__index__=Runtime.getFunctionIndex(_ft_stroker_arcto,"_ft_stroker_arcto");
function _ft_stroker_cap(e,g){var d=STACKTOP;STACKTOP+=24;Runtime.memset(d,0,24);var b,a,c,f,h=d+8,i,k=d+16;c=0;var j=HEAP[e+32]==1;a:do if(j){HEAP[e]=g;HEAP[e+4]=g+11796480;c=_ft_stroker_arcto(e,0)}else if(HEAP[e+32]==2){b=HEAP[e+44];i=e+52+0;f=5898240+g;a=b;c=h;a=a;f=f;HEAP[c]=a;HEAP[c+4]=0;_FT_Vector_Rotate(c,f);a=b;f=g;c=d;a=a;f=f;HEAP[c]=a;HEAP[c+4]=0;_FT_Vector_Rotate(c,f);HEAP[d]=HEAP[e+8]+HEAP[d]+HEAP[h];HEAP[d+4]=HEAP[e+8+4]+HEAP[d+4]+HEAP[h+4];c=_ft_stroke_border_lineto(i,d,0);if(c!=0)break a;
f=g-5898240;a=b;c=h;a=a;f=f;HEAP[c]=a;HEAP[c+4]=0;_FT_Vector_Rotate(c,f);c=b;a=g;b=d;c=c;a=a;HEAP[b]=c;HEAP[b+4]=0;_FT_Vector_Rotate(b,a);HEAP[d]=HEAP[h]+HEAP[d]+HEAP[e+8];HEAP[d+4]=HEAP[h+4]+HEAP[d+4]+HEAP[e+8+4];c=_ft_stroke_border_lineto(i,d,0)}else{if(HEAP[e+32]!=0)break a;b=HEAP[e+44];i=e+52+0;f=5898240+g;a=b;c=k;a=a;f=f;HEAP[c]=a;HEAP[c+4]=0;_FT_Vector_Rotate(c,f);HEAP[k]=HEAP[e+8]+HEAP[k];HEAP[k+4]=HEAP[e+8+4]+HEAP[k+4];c=_ft_stroke_border_lineto(i,k,0);if(c!=0)break a;c=g-5898240;a=b;b=k;
a=a;c=c;HEAP[b]=a;HEAP[b+4]=0;_FT_Vector_Rotate(b,c);HEAP[k]=HEAP[e+8]+HEAP[k];HEAP[k+4]=HEAP[e+8+4]+HEAP[k+4];c=_ft_stroke_border_lineto(i,k,0)}while(0);h=c;STACKTOP=d;return h}_ft_stroker_cap.__index__=Runtime.getFunctionIndex(_ft_stroker_cap,"_ft_stroker_cap");
function _ft_stroker_inside(e,g){var d=STACKTOP;STACKTOP+=16;Runtime.memset(d,0,16);var b=null,a,c,f,h,i=d+8;f=e+52+32*g;a=5898240-g*11796480;c=HEAP[e+4]-HEAP[e];var k=c=reSign(c,32)%reSign(23592960,32);if(reSign(k,32)<reSign(0,32)){var j=c+23592960;c=j;b=0}else b=-1;b=reSign(b==0?j:k,32)>reSign(11796480,32);c=c;if(b){h=c-23592960;b=2}else b=6;b=h=b==2?h:c;b=h==11796480?a:Math.floor(reSign(b,32)/reSign(2,32));h=b+HEAP[e];b=b;HEAP[d]=72899491;HEAP[d+4]=0;_ft_trig_pseudo_rotate(d,b);b=Math.floor(reSign(HEAP[d],
32)/reSign(4096,32));c=_FT_MulFix(HEAP[e+40],b);if(reSign(c,32)<=reSign(65535,32)){h=a+HEAP[e+4];a=HEAP[e+44];HEAP[i]=a;HEAP[i+4]=0;_FT_Vector_Rotate(i,h);HEAP[i]=HEAP[e+8]+HEAP[i];HEAP[i+4]=HEAP[e+8+4]+HEAP[i+4];HEAP[f+16]=0}else{b=_FT_DivFix(HEAP[e+44],b);a=a+h;HEAP[i]=b;HEAP[i+4]=0;_FT_Vector_Rotate(i,a);HEAP[i]=HEAP[e+8]+HEAP[i];HEAP[i+4]=HEAP[e+8+4]+HEAP[i+4]}f=_ft_stroke_border_lineto(f,i,0);STACKTOP=d;return f}_ft_stroker_inside.__index__=Runtime.getFunctionIndex(_ft_stroker_inside,"_ft_stroker_inside");
function _ft_stroker_outside(e,g){var d=STACKTOP;STACKTOP+=40;Runtime.memset(d,0,40);var b,a=null,c,f,h,i,k,j,l,m,o;j=d+8;var n,p,r,q;i=d+16;var s=d+24;l=d+32;n=e+52+32*g;m=HEAP[e+36]==0;a:do if(m)h=_ft_stroker_arcto(e,g);else{c=HEAP[e+44];k=5898240-g*11796480;q=unSign(HEAP[e+36]==2,1);h=HEAP[e+4];f=HEAP[e];h=h;f=h-f;h=f=reSign(f,32)%reSign(23592960,32);if(reSign(h,32)<reSign(0,32)){f=o=f+23592960;a=1}else a=16;h=reSign(a==1?o:h,32)>reSign(11796480,32);f=f;if(h){var u=f-23592960;a=3}else a=17;p=f=
a==3?u:f;if(f==11796480){p=k;f=HEAP[e]}else{p=Math.floor(reSign(p,32)/reSign(2,32));f=p+HEAP[e]+k}h=p;HEAP[j]=72899491;HEAP[j+4]=0;_ft_trig_pseudo_rotate(j,h);r=h=h=Math.floor(reSign(HEAP[j],32)/reSign(4096,32));h=b=_FT_MulFix(HEAP[e+40],r);var t=reSign(b,32)>reSign(65535,32);b:do if(t)b=6;else{b=b=p;t=0-b;b=b=reSign(b,32)>=reSign(0,32)?b:t;if(reSign(b,32)<=reSign(57,32)){b=6;break b}var v=e;if(q==0){a=7;b=10;break b}l=_FT_MulFix(c,HEAP[v+40]);m=f;j=i;l=l;m=m;HEAP[j]=l;HEAP[j+4]=0;_FT_Vector_Rotate(j,
m);HEAP[i]=HEAP[e+8]+HEAP[i];HEAP[i+4]=HEAP[e+8+4]+HEAP[i+4];j=p;j=5898240-j;HEAP[d]=72899491;HEAP[d+4]=0;_ft_trig_pseudo_rotate(d,j);j=j=j=j=j=j=Math.floor(reSign(HEAP[d],32)/reSign(4096,32));l=0-j;j=j=reSign(j,32)>=reSign(0,32)?j:l;j=_FT_DivFix(65536-h,j);j=_FT_MulFix(c,j);o=k+f;m=j;l=s;m=m;o=o;HEAP[l]=m;HEAP[l+4]=0;_FT_Vector_Rotate(l,o);HEAP[s]=HEAP[i]+HEAP[s];HEAP[s+4]=HEAP[i+4]+HEAP[s+4];h=_ft_stroke_border_lineto(n,s,0);if(h!=0)break a;l=f-k;j=j;f=s;j=j;l=l;HEAP[f]=j;HEAP[f+4]=0;_FT_Vector_Rotate(f,
l);HEAP[s]=HEAP[i]+HEAP[s];HEAP[s+4]=HEAP[i+4]+HEAP[s+4];h=_ft_stroke_border_lineto(n,s,0);if(h!=0)break a;k=k+HEAP[e+4];c=c;i=s;c=c;k=k;HEAP[i]=c;HEAP[i+4]=0;_FT_Vector_Rotate(i,k);HEAP[s]=HEAP[e+8]+HEAP[s];HEAP[s+4]=HEAP[e+8+4]+HEAP[s+4];h=_ft_stroke_border_lineto(n,s,1);break a}while(0);if(b==6){var w=e;a=6}h=c=_FT_DivFix(HEAP[(a==6?w:v)+44],r);q=f;c=l;f=h;h=q;HEAP[c]=f;HEAP[c+4]=0;_FT_Vector_Rotate(c,h);HEAP[l]=HEAP[e+8]+HEAP[l];HEAP[l+4]=HEAP[e+8+4]+HEAP[l+4];h=c=_ft_stroke_border_lineto(n,l,
0);if(c!=0)break a;f=k+HEAP[e+4];c=HEAP[e+44];k=l;c=c;f=f;HEAP[k]=c;HEAP[k+4]=0;_FT_Vector_Rotate(k,f);HEAP[l]=HEAP[e+8]+HEAP[l];HEAP[l+4]=HEAP[e+8+4]+HEAP[l+4];h=_ft_stroke_border_lineto(n,l,1)}while(0);n=h;STACKTOP=d;return n}_ft_stroker_outside.__index__=Runtime.getFunctionIndex(_ft_stroker_outside,"_ft_stroker_outside");
function _ft_stroker_process_corner(e){var g=null,d,b,a;b=0;d=HEAP[e+4]-HEAP[e];var c=d=reSign(d,32)%reSign(23592960,32);if(reSign(c,32)<reSign(0,32)){var f=d+23592960;d=f;g=0}else g=-1;g=reSign(g==0?f:c,32)>reSign(11796480,32);d=d;if(g){a=d-23592960;g=2}else g=8;g=g==2?a:d;d=g==0;a:do if(!d){a=0;if(reSign(g,32)<reSign(0,32))a=1;b=c=_ft_stroker_inside(e,a);if(c!=0)break a;b=_ft_stroker_outside(e,1-a)}while(0);return b}
_ft_stroker_process_corner.__index__=Runtime.getFunctionIndex(_ft_stroker_process_corner,"_ft_stroker_process_corner");
function _ft_stroker_subpath_start(e,g){var d=STACKTOP;STACKTOP+=16;Runtime.memset(d,0,16);var b,a,c;a=d+8;b=g+5898240;HEAP[d]=HEAP[e+44];HEAP[d+4]=0;_FT_Vector_Rotate(d,b);HEAP[a]=HEAP[d]+HEAP[e+8];HEAP[a+4]=HEAP[d+4]+HEAP[e+8+4];c=b=e+52;reSign(HEAP[c+20],32)>=reSign(0,32)&&_ft_stroke_border_close(c,0);HEAP[c+20]=HEAP[c];HEAP[c+16]=0;var f=_ft_stroke_border_lineto(c,a,0);c=f;if(f==0){HEAP[a]=HEAP[e+8]-HEAP[d];HEAP[a+4]=HEAP[e+8+4]-HEAP[d+4];b+=32;b=b;reSign(HEAP[b+20],32)>=reSign(0,32)&&_ft_stroke_border_close(b,
0);HEAP[b+20]=HEAP[b];HEAP[b+16]=0;c=a=_ft_stroke_border_lineto(b,a,0);HEAP[e+20]=g;HEAP[e+16]=0}a=c;STACKTOP=d;return a}_ft_stroker_subpath_start.__index__=Runtime.getFunctionIndex(_ft_stroker_subpath_start,"_ft_stroker_subpath_start");
function _FT_Stroker_LineTo(e,g){var d=STACKTOP;STACKTOP+=32;Runtime.memset(d,0,32);var b,a=null,c,f,h=d+8,i,k=d+16,j=d+24;HEAP[k]=HEAP[g]-HEAP[e+8];HEAP[k+4]=HEAP[g+4]-HEAP[e+8+4];a=HEAP[k+4];c=HEAP[k];i=c==0;a:do if(i){if(a!=0){b=1;break a}f=0;b=2;break a}else b=1;while(0);if(b==1){HEAP[d]=c;HEAP[d+4]=a;_ft_trig_prenorm(d);_ft_trig_pseudo_polarize(d);f=HEAP[d+4]}c=f;b=c+5898240;HEAP[k]=HEAP[e+44];HEAP[k+4]=0;_FT_Vector_Rotate(k,b);a=HEAP[e+16]!=0;a:do{if(a)f=_ft_stroker_subpath_start(e,c);else{HEAP[e+
4]=c;f=_ft_stroker_process_corner(e)}b=f!=0?4:5;break a}while(0);if(b==5){i=e+52;var l=g+4,m=k+4,o=j+4,n=k+4,p=k+4,r=f;for(a=5;;){t=a==8?t:0;var q=a==8?0:r;b=i+32*t;var s=0+t*-1;if(!(reSign(a==8?s:1,32)>=reSign(0,32))){b=10;break}HEAP[j]=HEAP[k]+HEAP[g];HEAP[o]=HEAP[m]+HEAP[l];var u=_ft_stroke_border_lineto(b,j,1);if(u!=0){b=7;break}HEAP[k]=0-HEAP[k];HEAP[p]=0-HEAP[n];var t=t+1;a=8;b=6}if(b==10){f=q;HEAP[e]=c;HEAP[h]=HEAP[g];HEAP[h+4]=HEAP[g+4];k=e+8;HEAP[k]=HEAP[h];HEAP[k+4]=HEAP[h+4]}else if(b==
7)f=u}h=f;STACKTOP=d;return h}_FT_Stroker_LineTo.__index__=Runtime.getFunctionIndex(_FT_Stroker_LineTo,"_FT_Stroker_LineTo");
function _FT_Stroker_ConicTo(e,g,d){var b=STACKTOP;STACKTOP+=392;Runtime.memset(b,0,392);var a,c=null,f=b+8,h=b+16,i=b+24,k=b+32,j=b+40,l=b+48,m=b+56,o=b+64,n=b+72,p=b+80,r=b+88,q,s=b+96,u,t=b+368,v=b+372,w=b+376,x=b+384;q=0;u=s+240;HEAP[r]=HEAP[d];HEAP[r+4]=HEAP[d+4];HEAP[s]=HEAP[r];HEAP[s+4]=HEAP[r+4];HEAP[p]=HEAP[g];HEAP[p+4]=HEAP[g+4];g=s+8;HEAP[g]=HEAP[p];HEAP[g+4]=HEAP[p+4];g=e+8;HEAP[n]=HEAP[g];HEAP[n+4]=HEAP[g+4];g=s+16;HEAP[g]=HEAP[n];HEAP[g+4]=HEAP[n+4];n=l+4;g=m+4;p=m+4;r=j+4;var y=j+4,
A=l+4,z=m+4,C=i+4,B=i+4,D=k+4,E=k+4,F=m+4,G=m+4,H=l+4,J=l+4,L=e+16,N=e+4,I=h+4,P=e+44,K=w+4,O=w+4,M=e+44,Q=x+4,R=x+4,T=f+4,V=f+4,U=b+4,S=b+4,X=HEAP[f],Y=HEAP[b],W=HEAP[m],da=HEAP[l];c=-1;a:for(;;){var ba=c==-1?1:c==22?ba:c==32?0:0,aa=c==-1?da:c==22?ea:c==32?sa:sa,ca=c==-1?W:c==22?Z:c==32?wa:wa,$=c==-1?s:c==22?na:c==32?va:va,la=c==-1?Y:c==22?la:c==32?pa:pa,ga=c==-1?X:c==22?ga:c==32?ta:ta;if(!(s<=$)){a=35;break a}HEAP[v]=0;HEAP[t]=HEAP[v];a=$<u;b:do if(a){c=34;var ea=HEAP[$+8]-HEAP[$+16];HEAP[n]=HEAP[$+
8+4]-HEAP[$+16+4];var Z=HEAP[$]-HEAP[$+8];HEAP[g]=HEAP[$+4]-HEAP[$+8+4];a=reSign(ea,32)<=reSign(-2,32);var ha=reSign(ea,32)>reSign(1,32);ha=a|ha;c:do if(ha)a=1;else{if(reSign(HEAP[H],32)<=reSign(-2,32)){a=1;break c}if(reSign(HEAP[J],32)>reSign(1,32)){c=2;a=1}else{c=2;a=3}break c}while(0);if(a==1)c=1;ha=c==1?0:1;a=reSign(Z,32)<=reSign(-2,32);var ia=reSign(Z,32)>reSign(1,32);ia=a|ia;c:do if(ia)a=5;else{if(reSign(HEAP[F],32)<=reSign(-2,32)){a=5;break c}if(reSign(HEAP[G],32)>reSign(1,32)){a=5;break c}c=
7;a=8;break c}while(0);if(a==5)c=5;a=(c==5?0:1)!=0;if(ha!=0){if(a)HEAP[v]=0;else{a=HEAP[p];if(Z==0&a==0)c=41;else{HEAP[j]=Z;HEAP[r]=a;_ft_trig_prenorm(j);_ft_trig_pseudo_polarize(j);var ja=HEAP[y];c=12}HEAP[v]=c==12?ja:0}HEAP[t]=HEAP[v]}else{ha=HEAP[A];if(ea==0&ha==0)c=42;else{HEAP[k]=ea;HEAP[D]=ha;_ft_trig_prenorm(k);_ft_trig_pseudo_polarize(k);var fa=HEAP[E];c=15}ha=c==15?fa:0;if(a){HEAP[v]=ha;HEAP[t]=HEAP[v]}else{HEAP[t]=ha;a=HEAP[z];if(Z==0&a==0)c=44;else{HEAP[i]=Z;HEAP[C]=a;_ft_trig_prenorm(i);
_ft_trig_pseudo_polarize(i);var ka=HEAP[B];c=18}HEAP[v]=c==18?ka:0}}a=reSign(HEAP[v]-HEAP[t],32)%reSign(23592960,32);ha=a+23592960;a=reSign(a,32)<reSign(0,32)?ha:a;ha=a-23592960;a=reSign(a,32)>reSign(11796480,32)?ha:a;ha=0-a;a=reSign(a,32)>=reSign(0,32)?a:ha;a=reSign(a,32)<=reSign(1966079,32);if((unSign(a,1)&255)!=0){c=21;break b}HEAP[$+32]=HEAP[$+16];na=HEAP[$+8];a=$+24;ha=Math.floor(reSign(na+HEAP[$+16],32)/reSign(2,32));HEAP[a]=ha;a=HEAP[a];ha=$+8;na=Math.floor(reSign(na+HEAP[$],32)/reSign(2,32));
HEAP[ha]=na;na=$+16;a=Math.floor(reSign(HEAP[ha]+a,32)/reSign(2,32));HEAP[na]=a;HEAP[$+32+4]=HEAP[$+16+4];na=HEAP[$+8+4];a=$+24;ha=Math.floor(reSign(na+HEAP[$+16+4],32)/reSign(2,32));HEAP[a+4]=ha;a=HEAP[a+4];ha=$+8;na=Math.floor(reSign(na+HEAP[$+4],32)/reSign(2,32));HEAP[ha+4]=na;na=$+16;a=Math.floor(reSign(HEAP[ha+4]+a,32)/reSign(2,32));HEAP[na+4]=a;var na=$+16;c=22;a=0;continue a}else c=34;while(0);var sa=c==21?ea:aa,wa=c==21?Z:ca;if(ba!=0){q=HEAP[t];if(HEAP[L]!=0)q=_ft_stroker_subpath_start(e,
q);else{HEAP[N]=q;q=_ft_stroker_process_corner(e)}}va=reSign(HEAP[v]-HEAP[t],32)%reSign(23592960,32);a=va+23592960;va=reSign(va,32)<reSign(0,32)?a:va;a=va-23592960;va=reSign(va,32)>reSign(11796480,32)?a:va;c=Math.floor(reSign(va,32)/reSign(2,32));var Aa=HEAP[t];HEAP[h]=72899491;HEAP[I]=0;_ft_trig_pseudo_rotate(h,c);va=Math.floor(reSign(HEAP[h],32)/reSign(4096,32));va=_FT_DivFix(HEAP[P],va);a=$+8;ha=$+8+4;ia=$;var Da=$+4;Aa=Aa+5898240+c;for(c=27;;){var pa=c==29?Ha:la,ta=c==29?za:ga;c=c==29?Ca:0;var ma=
c*-11796480,ya=ma+5898240,qa=Aa+ma,ua=e+52+c*32,Ba=ua,Na=e+52+c*32+8,Ea=e+52+c*32+12;ma=e+52+c*32+16;if(!(reSign(c,32)<=reSign(1,32)))break;HEAP[w]=va;HEAP[w+4]=0;_FT_Vector_Rotate(w,qa);HEAP[w]=HEAP[a]+HEAP[w];HEAP[O]=HEAP[ha]+HEAP[K];var ra=HEAP[v];HEAP[x]=HEAP[M];HEAP[x+4]=0;_FT_Vector_Rotate(x,ra+ya);HEAP[x]=HEAP[ia]+HEAP[x];HEAP[R]=HEAP[Da]+HEAP[Q];ra=_ft_stroke_border_grow(ua,2);if(ra!=0){a=30;break a}q=HEAP[Na]+8*HEAP[Ba];Ca=HEAP[Ea]+HEAP[Ba];var za=HEAP[w];HEAP[T]=HEAP[w+4];HEAP[q]=za;HEAP[q+
4]=HEAP[V];var Ha=HEAP[x];HEAP[U]=HEAP[x+4];q=q+8;HEAP[q]=Ha;HEAP[q+4]=HEAP[S];HEAP[Ca]=0;HEAP[Ca+1]=1;HEAP[Ba]+=2;HEAP[ma]=0;q=ra;var Ca=c+1;c=29}var va=$+-16;if(!(s>va)){c=32;a=0;continue a}HEAP[e]=HEAP[v];c=33;a=0}if(a==30){HEAP[ma]=0;q=ra;HEAP[l]=sa;HEAP[m]=wa;HEAP[b]=pa;HEAP[f]=ta}else if(a==35){HEAP[l]=aa;HEAP[m]=ca;HEAP[b]=la;HEAP[f]=ga;HEAP[o]=HEAP[d];HEAP[o+4]=HEAP[d+4];e=e+8;HEAP[e]=HEAP[o];HEAP[e+4]=HEAP[o+4]}o=q;STACKTOP=b;return o}
_FT_Stroker_ConicTo.__index__=Runtime.getFunctionIndex(_FT_Stroker_ConicTo,"_FT_Stroker_ConicTo");
function _FT_Stroker_CubicTo(e,g,d,b){var a=STACKTOP;STACKTOP+=476;Runtime.memset(a,0,476);var c,f=null,h=a+8,i,k=a+16,j=a+24,l=a+32,m=a+40,o=a+48,n=a+56,p=a+64,r=a+72,q=a+80,s=a+88,u=a+96,t=a+104,v=a+112,w=a+120,x=a+128,y=a+136,A,z=a+144,C,B=a+440,D=a+444,E=a+448,F=a+452,G=a+460,H=a+468;A=0;C=z+256;HEAP[y]=HEAP[b];HEAP[y+4]=HEAP[b+4];HEAP[z]=HEAP[y];HEAP[z+4]=HEAP[y+4];HEAP[x]=HEAP[d];HEAP[x+4]=HEAP[d+4];d=z+8;HEAP[d]=HEAP[x];HEAP[d+4]=HEAP[x+4];HEAP[w]=HEAP[g];HEAP[w+4]=HEAP[g+4];g=z+16;HEAP[g]=
HEAP[w];HEAP[g+4]=HEAP[w+4];g=e+8;HEAP[v]=HEAP[g];HEAP[v+4]=HEAP[g+4];g=z+24;HEAP[g]=HEAP[v];HEAP[g+4]=HEAP[v+4];v=q+4;g=s+4;w=u+4;d=s+4;x=u+4;y=p+4;var J=p+4,L=r+4,N=r+4,I=q+4,P=s+4,K=o+4,O=o+4,M=n+4,Q=n+4,R=q+4,T=u+4,V=l+4,U=l+4,S=s+4,X=u+4,Y=k+4,W=k+4,da=j+4,ba=j+4,aa=m+4,ca=m+4,$=u+4,la=u+4,ga=s+4,ea=s+4,Z=q+4,ha=q+4,ia=e+16,ja=e+4,fa=h+4,ka=e+44,na=a+4,sa=e+44,wa=F+4,Aa=F+4,Da=G+4,pa=G+4,ta=e+44,ma=H+4,ya=H+4,qa=A,ua=HEAP[u],Ba=HEAP[s],Na=HEAP[q];f=-1;a:for(;;){var Ea=f==-1?1:f==36?Ea:f==49?
0:0,ra=f==-1?Na:f==36?Pa:f==49?Sa:Sa,za=f==-1?Ba:f==36?Ja:f==49?$a:$a,Ha=f==-1?ua:f==36?La:f==49?Wa:Wa,Ca=f==-1?qa:f==36?Ca:f==49?Ya:Ya,va=f==-1?z:f==36?i:f==49?db:db;if(!(z<=va)){c=52;break a}HEAP[D]=0;HEAP[E]=HEAP[D];HEAP[B]=HEAP[E];c=va<C;b:do if(c){f=51;var Pa=HEAP[va+16]-HEAP[va+24];HEAP[v]=HEAP[va+16+4]-HEAP[va+24+4];var Ja=HEAP[va+8]-HEAP[va+16];HEAP[g]=HEAP[va+8+4]-HEAP[va+16+4];var La=HEAP[va]-HEAP[va+8];HEAP[w]=HEAP[va+4]-HEAP[va+8+4];c=reSign(Pa,32)<=reSign(-2,32);var xa=reSign(Pa,32)>
reSign(1,32);xa=c|xa;c:do if(xa)c=1;else{if(reSign(HEAP[Z],32)<=reSign(-2,32)){c=1;break c}if(reSign(HEAP[ha],32)>reSign(1,32)){f=2;c=1}else{f=2;c=3}break c}while(0);if(c==1)f=1;xa=f==1?0:1;c=reSign(Ja,32)<=reSign(-2,32);var oa=reSign(Ja,32)>reSign(1,32);oa=c|oa;c:do if(oa)c=5;else{if(reSign(HEAP[ga],32)<=reSign(-2,32)){c=5;break c}if(reSign(HEAP[ea],32)>reSign(1,32)){f=6;c=5}else{f=6;c=7}break c}while(0);if(c==5)f=5;oa=f==5?0:1;c=reSign(La,32)<=reSign(-2,32);var Fa=reSign(La,32)>reSign(1,32);Fa=
c|Fa;c:do if(Fa)c=9;else{if(reSign(HEAP[$],32)<=reSign(-2,32)){c=9;break c}if(reSign(HEAP[la],32)>reSign(1,32)){f=10;c=9}else{f=10;c=11}break c}while(0);if(c==9)f=9;c=oa!=0;if(xa!=0|(f==9?0:1)!=0)if(c){HEAP[D]=0;HEAP[E]=HEAP[D];HEAP[B]=HEAP[E]}else if(xa!=0){f=HEAP[d];if(Ja==0&f==0)f=60;else{HEAP[r]=Ja;HEAP[L]=f;_ft_trig_prenorm(r);_ft_trig_pseudo_polarize(r);var Ma=HEAP[N];f=15}HEAP[D]=f==15?Ma:0;HEAP[B]=HEAP[D];f=HEAP[x];if(La==0&f==0)f=61;else{HEAP[p]=La;HEAP[y]=f;_ft_trig_prenorm(p);_ft_trig_pseudo_polarize(p);
var Ka=HEAP[J];f=17}HEAP[E]=f==17?Ka:0}else{f=HEAP[I];if(Pa==0&f==0)f=62;else{HEAP[n]=Pa;HEAP[M]=f;_ft_trig_prenorm(n);_ft_trig_pseudo_polarize(n);var Ra=HEAP[Q];f=20}HEAP[B]=f==20?Ra:0;f=HEAP[P];if(Ja==0&f==0)f=63;else{HEAP[o]=Ja;HEAP[K]=f;_ft_trig_prenorm(o);_ft_trig_pseudo_polarize(o);var Qa=HEAP[O];f=22}HEAP[E]=f==22?Qa:0;HEAP[D]=HEAP[E]}else{f=HEAP[R];if(Pa==0&f==0)f=64;else{HEAP[m]=Pa;HEAP[aa]=f;_ft_trig_prenorm(m);_ft_trig_pseudo_polarize(m);var Va=HEAP[ca];f=25}f=f==25?Va:0;if(c){HEAP[D]=
f;HEAP[B]=HEAP[D];f=HEAP[T];if(La==0&f==0)f=66;else{HEAP[l]=La;HEAP[V]=f;_ft_trig_prenorm(l);_ft_trig_pseudo_polarize(l);var Ta=HEAP[U];f=27}HEAP[E]=f==27?Ta:0}else{HEAP[B]=f;f=HEAP[S];if(Ja==0&f==0)f=67;else{HEAP[j]=Ja;HEAP[da]=f;_ft_trig_prenorm(j);_ft_trig_pseudo_polarize(j);var Ua=HEAP[ba];f=30}HEAP[D]=f==30?Ua:0;f=HEAP[X];if(La==0&f==0)f=68;else{HEAP[k]=La;HEAP[Y]=f;_ft_trig_prenorm(k);_ft_trig_pseudo_polarize(k);var ab=HEAP[W];f=32}HEAP[E]=f==32?ab:0}}f=reSign(HEAP[D]-HEAP[B],32)%reSign(23592960,
32);c=f+23592960;f=reSign(f,32)<reSign(0,32)?c:f;c=f-23592960;f=reSign(f,32)>reSign(11796480,32)?c:f;c=0-f;f=reSign(f,32)>=reSign(0,32)?f:c;c=reSign(HEAP[E]-HEAP[D],32)%reSign(23592960,32);xa=c+23592960;c=reSign(c,32)<reSign(0,32)?xa:c;xa=c-23592960;c=reSign(c,32)>reSign(11796480,32)?xa:c;xa=0-c;c=reSign(c,32)>=reSign(0,32)?c:xa;f=reSign(f,32)>reSign(1966079,32);c=reSign(c,32)>reSign(1966079,32);if((unSign((f|c?0:1)&255,8)&255)!=0){f=35;break b}i=va;HEAP[i+48]=HEAP[i+24];xa=HEAP[i+8];oa=HEAP[i+16];
f=i+8;c=Math.floor(reSign(xa+HEAP[i],32)/reSign(2,32));HEAP[f]=c;Fa=i+40;f=Math.floor(reSign(oa+HEAP[i+24],32)/reSign(2,32));HEAP[Fa]=f;xa=Math.floor(reSign(oa+xa,32)/reSign(2,32));oa=i+16;c=Math.floor(reSign(xa+c,32)/reSign(2,32));HEAP[oa]=c;oa=i+32;f=Math.floor(reSign(xa+f,32)/reSign(2,32));HEAP[oa]=f;xa=i+24;f=Math.floor(reSign(f+c,32)/reSign(2,32));HEAP[xa]=f;HEAP[i+48+4]=HEAP[i+24+4];xa=HEAP[i+8+4];oa=HEAP[i+16+4];f=i+8;c=Math.floor(reSign(xa+HEAP[i+4],32)/reSign(2,32));HEAP[f+4]=c;Fa=i+40;f=
Math.floor(reSign(oa+HEAP[i+24+4],32)/reSign(2,32));HEAP[Fa+4]=f;xa=Math.floor(reSign(oa+xa,32)/reSign(2,32));oa=i+16;c=Math.floor(reSign(xa+c,32)/reSign(2,32));HEAP[oa+4]=c;oa=i+32;f=Math.floor(reSign(xa+f,32)/reSign(2,32));HEAP[oa+4]=f;i=i+24;f=Math.floor(reSign(f+c,32)/reSign(2,32));HEAP[i+4]=f;i=va+24;f=36;c=0;continue a}else f=51;while(0);var Sa=f==35?Pa:ra,$a=f==35?Ja:za,Wa=f==35?La:Ha;if(Ea!=0){var eb=HEAP[B];if(HEAP[ia]!=0){var Ga=_ft_stroker_subpath_start(e,eb);f=38}else{HEAP[ja]=eb;var ob=
_ft_stroker_process_corner(e);f=40}eb=f==40?ob:Ga;if(eb!=0){c=42;break a}else f=41}else f=37;db=f==41?0:Ca;f=HEAP[D]-HEAP[B];c=0-f;f=reSign(f,32)>=reSign(0,32)?f:c;c=Math.floor(reSign(f,32)/reSign(2,32));f=HEAP[E]-HEAP[D];xa=0-f;f=reSign(f,32)>=reSign(0,32)?f:xa;xa=Math.floor(reSign(f,32)/reSign(2,32));f=Math.floor(reSign(HEAP[B]+HEAP[D],32)/reSign(2,32));var Oa=Math.floor(reSign(HEAP[E]+HEAP[D],32)/reSign(2,32));HEAP[h]=72899491;HEAP[fa]=0;_ft_trig_pseudo_rotate(h,c);c=Math.floor(reSign(HEAP[h],
32)/reSign(4096,32));c=_FT_DivFix(HEAP[ka],c);HEAP[a]=72899491;HEAP[na]=0;_ft_trig_pseudo_rotate(a,xa);xa=Math.floor(reSign(HEAP[a],32)/reSign(4096,32));xa=_FT_DivFix(HEAP[sa],xa);oa=va+16;Fa=va+16+4;var Xa=va+8,bb=va+8+4,jb=va,Za=va+4;Oa=Oa+5898240;var fb=f+5898240;for(f=44;;){var Ya=f==47?0:db;f=f==47?kb:0;var Ia=f*-11796480,cb=Ia+5898240,pb=Oa+Ia,gb=fb+Ia;Ia=e+52+f*32;if(!(reSign(f,32)<=reSign(1,32)))break;HEAP[F]=c;HEAP[F+4]=0;_FT_Vector_Rotate(F,gb);HEAP[F]=HEAP[oa]+HEAP[F];HEAP[Aa]=HEAP[Fa]+
HEAP[wa];HEAP[G]=xa;HEAP[G+4]=0;_FT_Vector_Rotate(G,pb);HEAP[G]=HEAP[Xa]+HEAP[G];HEAP[pa]=HEAP[bb]+HEAP[Da];var hb=HEAP[E];HEAP[H]=HEAP[ta];HEAP[H+4]=0;_FT_Vector_Rotate(H,hb+cb);HEAP[H]=HEAP[jb]+HEAP[H];HEAP[ya]=HEAP[Za]+HEAP[ma];hb=_ft_stroke_border_cubicto(Ia,F,G,H);if(hb!=0){c=46;break a}var kb=f+1;f=47}var db=va+-24;if(!(z>db)){f=49;c=0;continue a}HEAP[e]=HEAP[E];f=50;c=0}if(c==42){HEAP[q]=Sa;HEAP[s]=$a;HEAP[u]=Wa;A=eb}else if(c==46){HEAP[q]=Sa;HEAP[s]=$a;HEAP[u]=Wa;A=hb}else if(c==52){HEAP[q]=
ra;HEAP[s]=za;HEAP[u]=Ha;A=Ca;HEAP[t]=HEAP[b];HEAP[t+4]=HEAP[b+4];e=e+8;HEAP[e]=HEAP[t];HEAP[e+4]=HEAP[t+4]}t=A;STACKTOP=a;return t}_FT_Stroker_CubicTo.__index__=Runtime.getFunctionIndex(_FT_Stroker_CubicTo,"_FT_Stroker_CubicTo");
function _FT_Stroker_BeginSubPath(e,g,d){var b=STACKTOP;STACKTOP+=16;Runtime.memset(b,0,16);var a=b+8;HEAP[e+16]=1;HEAP[a]=HEAP[g];HEAP[a+4]=HEAP[g+4];var c=e+8;HEAP[c]=HEAP[a];HEAP[c+4]=HEAP[a+4];HEAP[e+17]=d;HEAP[b]=HEAP[g];HEAP[b+4]=HEAP[g+4];e=e+24;HEAP[e]=HEAP[b];HEAP[e+4]=HEAP[b+4];STACKTOP=b;return 0}_FT_Stroker_BeginSubPath.__index__=Runtime.getFunctionIndex(_FT_Stroker_BeginSubPath,"_FT_Stroker_BeginSubPath");
function _FT_Stroker_EndSubPath(e){var g=STACKTOP;STACKTOP+=16;Runtime.memset(g,0,16);var d,b=null,a,c,f,h,i,k,j,l,m,o=g+8;f=0;var n=HEAP[e+17]!=0;a:do if(n){a=e+52;f=_ft_stroker_cap(e,HEAP[e]);if(f!=0)break a;c=e;f=c+52;c=c+52+32;i=0;h=HEAP[c]-HEAP[c+20];if(reSign(h,32)>reSign(0,32)){var p=i=_ft_stroke_border_grow(f,h);if(p!=0){f=p;break a}else{k=HEAP[f+8]+8*HEAP[f];j=HEAP[f+12]+HEAP[f];l=HEAP[c+8]+8*HEAP[c]+-8;m=HEAP[c+12]+HEAP[c]+-1;if(HEAP[c+8]+8*HEAP[c+20]<=l){p=g;var r=g+4,q=c+8,s=c+20;l=l;
k=k;m=m;j=j;b=2;for(d=3;;)if(d==3){x=b==3?x:0;var u=x*-1;b=l+8*(u+-1);d=m+u;var t=k+8*x+4,v=j+x,w=HEAP[l+8*u];u=HEAP[l+8*u+4];HEAP[k+8*x]=w;HEAP[t]=u;HEAP[v]=HEAP[d];HEAP[v]&=-13;var x=x+1;if(HEAP[q]+8*HEAP[s]<=b)d=b=3;else{b=3;break}}else if(d==4){z=b==7?z:0;var y=z*-1;b=l+8*(y+-1);d=m+y;v=k+8*z+4;t=j+z;var A=HEAP[l+8*y];y=HEAP[l+8*y+4];HEAP[k+8*z]=A;HEAP[v]=y;HEAP[t]=HEAP[d];d=HEAP[t]&12;d=d==4?23:d==8?23:7;if(d==23)HEAP[t]^=12;var z=z+1;if(HEAP[q]+8*HEAP[s]<=b){b=7;d=4}else{b=7;break}}q=b==7?A:
w;HEAP[r]=b==7?y:u;HEAP[p]=q}HEAP[c]=HEAP[c+20];HEAP[f]=h+HEAP[f];HEAP[f+16]=0;HEAP[c+16]=0}}f=c=i;if(c!=0)break a;f=e+24;HEAP[o]=HEAP[f];HEAP[o+4]=HEAP[f+4];f=e+8;HEAP[f]=HEAP[o];HEAP[f+4]=HEAP[o+4];f=_ft_stroker_cap(e,HEAP[e+20]+11796480);if(f!=0)break a;_ft_stroke_border_close(a,0)}else{a=HEAP[e+8]!=HEAP[e+24];b:do if(a)d=13;else{d=HEAP[e+8+4]!=HEAP[e+24+4]?13:14;break b}while(0);if(d==13){f=a=_FT_Stroker_LineTo(e,e+24);if(a!=0)break a}HEAP[e+4]=HEAP[e+20];c=HEAP[e+4];a=HEAP[e];c=c;a=c-a;a=c=reSign(a,
32)%reSign(23592960,32);if(reSign(c,32)<reSign(0,32)){var C=a+23592960;a=C;b=16}else b=14;c=reSign(b==16?C:c,32)>reSign(11796480,32);a=a;if(c){var B=a-23592960;b=18}else b=32;a=c=b==18?B:a;if(c!=0){c=0;if(reSign(a,32)<reSign(0,32))c=1;f=a=_ft_stroker_inside(e,c);if(a!=0)break a;f=_ft_stroker_outside(e,1-c);if(f!=0)break a}_ft_stroke_border_close(e+52,1);_ft_stroke_border_close(e+52+32,0)}while(0);e=f;STACKTOP=g;return e}
_FT_Stroker_EndSubPath.__index__=Runtime.getFunctionIndex(_FT_Stroker_EndSubPath,"_FT_Stroker_EndSubPath");function _FT_Stroker_GetBorderCounts(e,g,d,b){var a=STACKTOP;STACKTOP+=8;Runtime.memset(a,0,8);var c,f=a+4,h;HEAP[a]=0;HEAP[f]=0;var i=e==0;a:do if(i)c=0;else{if(unSign(g,32)>unSign(1,32)){c=0;break a}h=_ft_stroke_border_get_counts(e+52+32*g,a,f);c=3;break a}while(0);if(c==0)h=6;if(d!=0)HEAP[d]=HEAP[a];if(b!=0)HEAP[b]=HEAP[f];e=h;STACKTOP=a;return e}
_FT_Stroker_GetBorderCounts.__index__=Runtime.getFunctionIndex(_FT_Stroker_GetBorderCounts,"_FT_Stroker_GetBorderCounts");function _FT_Stroker_GetCounts(e,g,d){var b=STACKTOP;STACKTOP+=16;Runtime.memset(b,0,16);var a=b+4,c,f=b+8,h=b+12,i,k;i=c=0;k=_ft_stroke_border_get_counts(e+52,b,a);var j=k!=0;a:do if(!j){k=_ft_stroke_border_get_counts(e+52+32,f,h);if(k!=0)break a;c=HEAP[f]+HEAP[b];i=HEAP[h]+HEAP[a]}while(0);HEAP[g]=c;HEAP[d]=i;e=k;STACKTOP=b;return e}
_FT_Stroker_GetCounts.__index__=Runtime.getFunctionIndex(_FT_Stroker_GetCounts,"_FT_Stroker_GetCounts");
function _FT_Stroker_ExportBorder(e,g,d){var b=null,a,c,f,h,i,k,j,l=g==0|g==1;a:do if(l){a=e+52+g*32;if(HEAP[a+28]==0)break a;c=d;a=a;c=c;h=HEAP[a]*8;f=HEAP[a+8];i=HEAP[c+4];b=reSign(HEAP[c+2],16);_llvm_memcpy_p0i8_p0i8_i32(i+8*b,f,h,1,0);f=HEAP[a];h=HEAP[a+12];i=HEAP[c+8];b=reSign(HEAP[c+2],16);i=i+b;if(f!=0){h=h;f=f;i=i;for(b=2;;){o=b==2?0:o;var m=h+o;b=i+o;if((unSign(HEAP[m],8)&1&255)!=0)HEAP[b]=1;else{m=(unSign(HEAP[m],8)&2)!=0;HEAP[b]=m?2:0}var o=o+1;if(o!=f)b=5;else break}}b=HEAP[a];i=HEAP[a+
12];h=HEAP[c+12];f=reSign(HEAP[c],16);k=h+2*f;j=HEAP[c+2];if(b!=0){f=h=c;i=i;m=b;k=k;j=unSign(j,16);for(b=8;;){r=b==8?0:r;p=b==8?k:p;b=j+r&65535;if((unSign(HEAP[i+r],8)&8)!=0){HEAP[p]=b;var n=p+2;HEAP[f]=HEAP[h]+1;b=10}else b=9;var p=b==10?n:p,r=r+1;if(r!=m)b=12;else break}}HEAP[c+2]=(HEAP[a]&65535)+HEAP[c+2]}while(0)}_FT_Stroker_ExportBorder.__index__=Runtime.getFunctionIndex(_FT_Stroker_ExportBorder,"_FT_Stroker_ExportBorder");
function _FT_Stroker_Export(e,g){_FT_Stroker_ExportBorder(e,0,g);_FT_Stroker_ExportBorder(e,1,g)}_FT_Stroker_Export.__index__=Runtime.getFunctionIndex(_FT_Stroker_Export,"_FT_Stroker_Export");
function _FT_Stroker_ParseOutline(e,g,d){var b=STACKTOP;STACKTOP+=136;Runtime.memset(b,0,136);var a,c=null,f,h,i,k=b+8,j,l,m=b+16,o=b+24,n=b+32,p=b+40,r=b+48,q=b+56,s,u=b+64,t=b+72,v=b+80,w,x,y,A,z=b+88,C=b+96,B=b+104,D=b+112,E=b+120,F=b+128,G=g==0;a:do if(G)a=0;else{if(e==0){a=0;break a}l=e;if(l!=0){j=l+52;HEAP[j]=0;HEAP[j+20]=-1;HEAP[j+28]=0;j=l+52+32;HEAP[j]=0;HEAP[j+20]=-1;HEAP[j+28]=0}j=y=0;l=q;var H=q+4,J=v,L=q,N=v+4,I=q+4,P=r,K=r+4,O=u,M=r,Q=u+4,R=r+4,T=t,V=v,U=t+4,S=v+4,X=v,Y=u,W=v+4,da=u+
4,ba=u,aa=v,ca=v+4,$=u+4,la=v+4,ga=k,ea=k+4,Z=k,ha=k+4,ia=b,ja=b+4,fa=b,ka=b+4,na=n,sa=n+4,wa=D,Aa=n,Da=D+4,pa=n+4,ta=o,ma=o+4,ya=E,qa=o,ua=E+4,Ba=o+4,Na=m,Ea=m+4,ra=F,za=m,Ha=F+4,Ca=m+4,va=t,Pa=t+4,Ja=p,La=p+4,xa=C,oa=C+4,Fa=p+4,Ma=t,Ka=C,Ra=B,Qa=t+4,Va=C+4,Ta=B+4,Ua=t,ab=C,Sa=t+4,$a=C+4,Wa=z,eb=z+4;b:for(;;){x=reSign(HEAP[g],16);A=j;if(!(reSign(x,32)>reSign(A,32))){a=28;break b}A=reSign(HEAP[HEAP[g+12]+2*j],16);x=HEAP[g+4]+8*A;w=y;if(!(unSign(A,32)<=unSign(w,32))){w=HEAP[g+4]+8*y;HEAP[l]=HEAP[w];
HEAP[H]=HEAP[w+4];HEAP[J]=HEAP[L];HEAP[N]=HEAP[I];w=HEAP[g+4]+8*A;HEAP[P]=HEAP[w];HEAP[K]=HEAP[w+4];HEAP[O]=HEAP[M];HEAP[Q]=HEAP[R];HEAP[T]=HEAP[V];HEAP[U]=HEAP[S];w=HEAP[g+4]+8*y;y=HEAP[g+8]+y;h=reSign(HEAP[y],8)&3;if(h==2){a=6;break b}if(h==0){if((reSign(HEAP[HEAP[g+8]+A],8)&3)==1){HEAP[X]=HEAP[Y];HEAP[W]=HEAP[da];x+=-8}else{f=Math.floor(reSign(HEAP[ba]+HEAP[X],32)/reSign(2,32));HEAP[aa]=f;f=Math.floor(reSign(HEAP[$]+HEAP[ca],32)/reSign(2,32));HEAP[la]=f}w+=-8;y+=-1}i=unSign(d,8)&255;f=e;h=v;i=
i;HEAP[f+16]=1;var Ga=h;HEAP[ga]=HEAP[Ga];HEAP[ea]=HEAP[Ga+4];Ga=f+8;HEAP[Ga]=HEAP[Z];HEAP[Ga+4]=HEAP[ha];HEAP[f+17]=i;h=h;HEAP[ia]=HEAP[h];HEAP[ja]=HEAP[h+4];f=f+24;HEAP[f]=HEAP[fa];HEAP[f+4]=HEAP[ka];f=0;c:for(;;){if(!(w<x)){a=24;break c}w+=8;y+=1;a=h=reSign(HEAP[y],8)&3;a=a==0?12:a==1?30:31;if(a==31){if(w+8>x){a=6;break b}if((reSign(HEAP[y+1],8)&3)!=2){a=6;break b}w+=16;y+=2;a=w+-16;HEAP[na]=HEAP[a];HEAP[sa]=HEAP[a+4];HEAP[wa]=HEAP[Aa];HEAP[Da]=HEAP[pa];a=w+-8;HEAP[ta]=HEAP[a];HEAP[ma]=HEAP[a+
4];HEAP[ya]=HEAP[qa];HEAP[ua]=HEAP[Ba];if(!(w<=x)){a=22;break c}f=w;HEAP[Na]=HEAP[f];HEAP[Ea]=HEAP[f+4];HEAP[ra]=HEAP[za];HEAP[Ha]=HEAP[Ca];f=_FT_Stroker_CubicTo(e,D,E,F);if(f!=0){a=11;break b}else a=10}else if(a==12){HEAP[va]=HEAP[w];HEAP[Pa]=HEAP[w+4];a=x;h=e;i=f;y=y;Ga=HEAP[Ja];for(c=12;;){var ob=c==17?Ia:0,Oa=c==17?fb:Ga,Xa=c==17?0:i,bb=y+(ob+1);if(!(w<a)){a=15;break c}w+=8;var jb=reSign(HEAP[bb],8)&3,Za=w,fb=HEAP[Za];HEAP[La]=HEAP[Za+4];HEAP[xa]=fb;HEAP[oa]=HEAP[Fa];if(jb==1)break;else if(jb!=
0){a=34;break b}var Ya=Math.floor(reSign(HEAP[Ka]+HEAP[Ma],32)/reSign(2,32));HEAP[Ra]=Ya;Ya=Math.floor(reSign(HEAP[Va]+HEAP[Qa],32)/reSign(2,32));HEAP[Ta]=Ya;Ya=_FT_Stroker_ConicTo(h,t,B);if(Ya!=0){a=16;break b}HEAP[Ua]=HEAP[ab];HEAP[Sa]=HEAP[$a];var Ia=ob+1;c=17}HEAP[Ja]=fb;y=bb;f=_FT_Stroker_ConicTo(e,t,C);if(f!=0){a=11;break b}else a=10}else if(a==30){HEAP[Wa]=HEAP[w];HEAP[eb]=HEAP[w+4];f=_FT_Stroker_LineTo(e,z);if(f!=0){a=11;break b}else a=10}}if(a==24){var cb=f;c=24}else if(a==22){var pb=_FT_Stroker_CubicTo(e,
D,E,v);f=pb;c=22}else if(a==15){HEAP[Ja]=Oa;var gb=_FT_Stroker_ConicTo(e,t,v);f=gb;c=15}if((c==24?cb:c==22?pb:gb)!=0){a=11;break b}f=_FT_Stroker_EndSubPath(e);if(f!=0){a=11;break b}}y=A+1;j+=1;a=4}b:do if(a==28){s=0;a=29;break a}else if(a==34){HEAP[Ja]=fb;f=Xa;a=6;break b}else if(a==16){HEAP[Ja]=fb;f=Ya;a=11;break b}while(0);if(a==6){s=20;a=29;break a}else if(a==11){s=f;a=29;break a}}while(0);if(a==0)s=6;e=s;STACKTOP=b;return e}
_FT_Stroker_ParseOutline.__index__=Runtime.getFunctionIndex(_FT_Stroker_ParseOutline,"_FT_Stroker_ParseOutline");
function _FT_Glyph_Stroke(e,g,d){var b=STACKTOP;STACKTOP+=12;Runtime.memset(b,0,12);var a,c,f,h,i,k,j,l;a=b+4;var m=b+8;c=6;var o=e==0;a:do if(!o){j=HEAP[e];if(j==0)break a;if(HEAP[j+4]!=_ft_outline_glyph_class)break a;c=_FT_Glyph_Copy(j,b);if(c!=0)break a;l=j=HEAP[b];l=l+20;c=_FT_Stroker_ParseOutline(g,l,0);var n=c!=0;b:do if(!n){_FT_Stroker_GetCounts(g,a,m);k=l;c=HEAP[j];k=k;c!=0&&_FT_Outline_Done_Internal(HEAP[c],k);h=HEAP[m];f=HEAP[a];k=HEAP[j];i=l;c=k;f=f;h=h;i=i;if(k==0)c=33;else{c=n=_FT_Outline_New_Internal(HEAP[c],
f,h,i);if(n!=0)break b;HEAP[l+2]=0;HEAP[l]=0;a=l;g=g;a=a;_FT_Stroker_ExportBorder(g,0,a);_FT_Stroker_ExportBorder(g,1,a);d!=0&&_FT_Done_Glyph(HEAP[e]);HEAP[e]=j;break a}}while(0);_FT_Done_Glyph(j);if(d!=0)break a;HEAP[e]=0}while(0);e=c;STACKTOP=b;return e}_FT_Glyph_Stroke.__index__=Runtime.getFunctionIndex(_FT_Glyph_Stroke,"_FT_Glyph_Stroke");
function _FT_Glyph_StrokeBorder(e,g,d,b){var a=STACKTOP;STACKTOP+=12;Runtime.memset(a,0,12);var c,f,h,i,k,j,l,m,o=a+4,n=a+8;c=6;var p=e==0;a:do if(!p){l=HEAP[e];if(l==0)break a;if(HEAP[l+4]!=_ft_outline_glyph_class)break a;c=_FT_Glyph_Copy(l,a);if(c!=0)break a;m=l=HEAP[a];j=m=m+20;j=_FT_Outline_Get_Orientation(j);j=j=j=unSign(j!=0,1);if(d!=0)j=j==0?1:0;var r=_FT_Stroker_ParseOutline(g,m,0);c=r;r=r!=0;b:do if(!r){_FT_Stroker_GetBorderCounts(g,j,o,n);k=m;c=HEAP[l];k=k;c!=0&&_FT_Outline_Done_Internal(HEAP[c],
k);h=HEAP[n];f=HEAP[o];k=HEAP[l];i=m;c=k;f=f;h=h;i=i;if(k==0)c=33;else{c=r=_FT_Outline_New_Internal(HEAP[c],f,h,i);if(r!=0)break b;HEAP[m+2]=0;HEAP[m]=0;_FT_Stroker_ExportBorder(g,j,m);b!=0&&_FT_Done_Glyph(HEAP[e]);HEAP[e]=l;break a}}while(0);_FT_Done_Glyph(l);if(b!=0)break a;HEAP[e]=0}while(0);e=c;STACKTOP=a;return e}_FT_Glyph_StrokeBorder.__index__=Runtime.getFunctionIndex(_FT_Glyph_StrokeBorder,"_FT_Glyph_StrokeBorder");
function _FT_GlyphSlot_Oblique(e){var g=STACKTOP;STACKTOP+=16;Runtime.memset(g,0,16);var d=null,b,a,c,f;f=e+108;e=HEAP[e+72]!=1869968492;a:do if(!e){HEAP[g]=65536;HEAP[g+8]=0;HEAP[g+4]=24576;HEAP[g+12]=65536;b=f;a=g;if(b==0)break a;if(a==0)break a;c=HEAP[b+4];b=reSign(HEAP[b+2],16);b=c+8*b;if(!(c<b))break a;a=a;b=b;c=c;for(d=3;;){h=d==3?0:h;d=c+8*(h+1);_FT_Vector_Transform(c+8*h,a);var h=h+1;if(d<b)d=4;else break a}}while(0);STACKTOP=g}
_FT_GlyphSlot_Oblique.__index__=Runtime.getFunctionIndex(_FT_GlyphSlot_Oblique,"_FT_GlyphSlot_Oblique");
function _FT_GlyphSlot_Embolden(e){var g,d,b,a,c,f;d=HEAP[e];b=HEAP[e+4];f=HEAP[e+72]!=1869968492;a:do if(f){g=HEAP[e+72]!=1651078259?0:1;break a}else g=1;while(0);a:do if(g==1){f=HEAP[HEAP[b+88]+12+8];c=unSign(HEAP[b+68],16);f=_FT_MulFix(c,f);f=c=Math.floor(reSign(f,32)/reSign(24,32));if(HEAP[e+72]==1869968492){_FT_Outline_Embolden(e+108,c);c*=2;f=c}else{c&=-64;if(c==0)c=64;f&=-64;if(_FT_GlyphSlot_Own_Bitmap(e)!=0)break a;a=_FT_Bitmap_Embolden(d,e+76,c,f);if(a!=0)break a}if(HEAP[e+64]!=0)HEAP[e+
64]=c+HEAP[e+64];if(HEAP[e+64+4]!=0)HEAP[e+64+4]=f+HEAP[e+64+4];HEAP[e+24]=c+HEAP[e+24];HEAP[e+24+4]=f+HEAP[e+24+4];HEAP[e+24+12]=f+HEAP[e+24+12];HEAP[e+24+16]=c+HEAP[e+24+16];a=HEAP[e+24+20];c=Math.floor(reSign(c,32)/reSign(2,32));HEAP[e+24+20]=a-c;HEAP[e+24+24]=f+HEAP[e+24+24];HEAP[e+24+28]=f+HEAP[e+24+28];if(HEAP[e+72]!=1651078259)break a;c=HEAP[e+104];f=(reSign(f,32)>>reSign(6,32))+c;HEAP[e+104]=f}while(0)}_FT_GlyphSlot_Embolden.__index__=Runtime.getFunctionIndex(_FT_GlyphSlot_Embolden,"_FT_GlyphSlot_Embolden");
function _FT_Get_PS_Font_Info(e,g){var d,b,a;d=6;var c=e!=0;a:do if(c){b=HEAP[e+96];a=0;if(HEAP[HEAP[b]+32]!=0)a=FUNCTION_TABLE[HEAP[HEAP[b]+32]](b,__str21);b=a=a;if(a==0)break a;if(HEAP[b]==0)break a;d=FUNCTION_TABLE[HEAP[b]](e,g)}while(0);return d}_FT_Get_PS_Font_Info.__index__=Runtime.getFunctionIndex(_FT_Get_PS_Font_Info,"_FT_Get_PS_Font_Info");
function _FT_Has_PS_Glyph_Names(e){var g,d,b;g=0;var a=e!=0;a:do if(a){d=HEAP[e+96];b=0;if(HEAP[HEAP[d]+32]!=0)b=FUNCTION_TABLE[HEAP[HEAP[d]+32]](d,__str21);d=b=b;if(b==0)break a;if(HEAP[d+8]==0)break a;g=FUNCTION_TABLE[HEAP[d+8]](e)}while(0);return g}_FT_Has_PS_Glyph_Names.__index__=Runtime.getFunctionIndex(_FT_Has_PS_Glyph_Names,"_FT_Has_PS_Glyph_Names");
function _FT_Get_PS_Font_Private(e,g){var d,b,a;d=6;var c=e!=0;a:do if(c){b=HEAP[e+96];a=0;if(HEAP[HEAP[b]+32]!=0)a=FUNCTION_TABLE[HEAP[HEAP[b]+32]](b,__str21);b=a=a;if(a==0)break a;if(HEAP[b+12]==0)break a;d=FUNCTION_TABLE[HEAP[b+12]](e,g)}while(0);return d}_FT_Get_PS_Font_Private.__index__=Runtime.getFunctionIndex(_FT_Get_PS_Font_Private,"_FT_Get_PS_Font_Private");
function _FT_Get_WinFNT_Header(e,g){var d=null,b,a,c;c=6;var f=e!=0;a:do if(f){d=HEAP[HEAP[e+128]+32+16];a=d==4294967294;b:do if(a)d=0;else{if(d!=0)break b;d=HEAP[e+96];if(HEAP[HEAP[d]+32]!=0){var h=FUNCTION_TABLE[HEAP[HEAP[d]+32]](d,__str30);d=3}else{var i=0;d=5}d=b=d==5?i:h;var k=HEAP[e+128];b=b!=0?d:4294967294;HEAP[k+32+16]=b}while(0);a=d;if(a==0)break a;c=FUNCTION_TABLE[HEAP[a]](e,g)}while(0);return c}_FT_Get_WinFNT_Header.__index__=Runtime.getFunctionIndex(_FT_Get_WinFNT_Header,"_FT_Get_WinFNT_Header");
function _FT_Get_X11_Font_Format(e){var g;g=0;if(e!=0){e=HEAP[e+96];g=0;if(HEAP[HEAP[e]+32]!=0)g=FUNCTION_TABLE[HEAP[HEAP[e]+32]](e,__str31);g=g}return g}_FT_Get_X11_Font_Format.__index__=Runtime.getFunctionIndex(_FT_Get_X11_Font_Format,"_FT_Get_X11_Font_Format");function _tt_get_kerning(e,g,d,b){var a;a=HEAP[e+532];HEAP[b]=0;HEAP[b+4]=0;if(a!=0){e=FUNCTION_TABLE[HEAP[a+128]](e,g,d);HEAP[b]=e}return 0}_tt_get_kerning.__index__=Runtime.getFunctionIndex(_tt_get_kerning,"_tt_get_kerning");
function _tt_get_advances(e,g,d,b,a){var c=STACKTOP;STACKTOP+=8;Runtime.memset(c,0,8);var f=null,h,i,k=c+2,j=c+4,l=c+6;i=unSign((b&512)==0,1);b=(b&16)!=0;h=0;var m=unSign(h,32)<unSign(d,32);a:do if(b){if(!m)break a;var o=i;f=g;var n=e,p=a,r=d;h=h;var q=h+1;r=unSign(r,32)>unSign(q,32)?r:q;q=r-h;var s=h+f;for(f=0;;){t=f==0?0:t;var u=s+t;f=p+4*(h+t);if(HEAP[n+296]!=0)FUNCTION_TABLE[HEAP[HEAP[n+532]+156]](n,1,u,c,k);else{HEAP[c]=0;HEAP[k]=HEAP[n+68]}u=unSign(HEAP[k],16);HEAP[f]=u;var t=t+1;if(t!=q)f=
5;else break}unSign(o,8);h=r}else{if(!m)break a;r=unSign(i,8);f=g;o=e;n=a;s=d;p=h;if((r&255)!=0){h=o+532;r=o+468+12;q=o+216+10;var v=p+1;v=unSign(s,32)>unSign(v,32)?s:v;s=v-p;u=p+f;for(f=8;;){x=f==11?x:0;f=n+4*(p+x);FUNCTION_TABLE[HEAP[HEAP[h]+156]](o,0,u+x,j,l);if(HEAP[r]!=0)HEAP[l]=HEAP[q];var w=unSign(HEAP[l],16);HEAP[f]=w;var x=x+1;if(x!=s)f=11;else break}f=12}else{var y=p+1;y=unSign(s,32)>unSign(y,32)?s:y;h=y-p;r=p+f;for(f=14;;){A=f==14?0:A;f=n+4*(p+A);FUNCTION_TABLE[HEAP[HEAP[o+532]+156]](o,
0,r+A,j,l);q=unSign(HEAP[l],16);HEAP[f]=q;var A=A+1;if(A!=h)f=15;else break}f=16}h=f==16?y:v}while(0);STACKTOP=c;return 0}_tt_get_advances.__index__=Runtime.getFunctionIndex(_tt_get_advances,"_tt_get_advances");function _tt_size_select(e,g){var d,b,a;d=HEAP[e];b=0;HEAP[e+112]=g;var c=(HEAP[HEAP[e]+8]&1&255)!=0;a:do if(c){_FT_Select_Metrics(HEAP[e],g);_tt_size_reset(e)}else{b=HEAP[d+532];a=e+12;b=FUNCTION_TABLE[HEAP[b+152]](d,g,a);if(b==0)break a;HEAP[e+112]=-1}while(0);return b}
_tt_size_select.__index__=Runtime.getFunctionIndex(_tt_size_select,"_tt_size_select");function _tt_size_request(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a,c;c=0;var f=(HEAP[HEAP[e]+8]&2)!=0;a:do if(f){b=HEAP[e];c=HEAP[b+532];c=FUNCTION_TABLE[HEAP[c+148]](b,g,d);if(c!=0){HEAP[e+112]=-1;b=0}else{a=_tt_size_select(e,HEAP[d]);b=1}break a}else b=0;while(0);if(b==0){_FT_Request_Metrics(HEAP[e],g);if((HEAP[HEAP[e]+8]&1&255)!=0)c=_tt_size_reset(e);a=c}a=a;STACKTOP=d;return a}
_tt_size_request.__index__=Runtime.getFunctionIndex(_tt_size_request,"_tt_size_request");
function _Load_Glyph(e,g,d,b){var a=STACKTOP;STACKTOP+=248;Runtime.memset(a,0,248);var c,f=null,h,i,k,j,l,m,o,n,p,r,q,s,u,t,v,w=a+16,x=a+32,y,A,z,C,B,D,E=a+40,F;b=b;F=HEAP[e+4];var G=e==0;a:do if(G)y=37;else if(g==0)y=36;else if(F==0)y=6;else{y=d;y=unSign(HEAP[F+16],32)<=unSign(y,32);b:do if(y){if(HEAP[HEAP[F+128]+52]!=0)break b;y=6;break a}while(0);y=(b&2)!=0;b:do if(y){if((HEAP[F+8]&8192)!=0)b&=-3;if((b&32768)==0)break b;b|=2}while(0);y=(b&1025)!=0;b:do if(y){b|=9;if((HEAP[F+8]&8192)!=0)break b;
b|=2}while(0);A=e;z=d;C=b;y=g;A=A;z=z;C=C;D=HEAP[A+4];q=HEAP[y+112]!=-1;b:do if(q){if((C&8)!=0){c=12;break b}c=A;n=z;q=C;o=y;c=c;n=n;q=q;r=HEAP[c+4];p=HEAP[r+532];s=HEAP[r+104];o=FUNCTION_TABLE[HEAP[p+104]](r,HEAP[o+112],n,q,s,c+76,x);if(o==0){HEAP[c+108+2]=0;HEAP[c+108]=0;n=unSign(HEAP[x+1],8)<<6;HEAP[c+24]=n;n=unSign(HEAP[x],8)<<6;HEAP[c+24+4]=n;n=reSign(HEAP[x+2],8)<<6;HEAP[c+24+8]=n;n=reSign(HEAP[x+3],8)<<6;HEAP[c+24+12]=n;n=unSign(HEAP[x+4],8)<<6;HEAP[c+24+16]=n;n=reSign(HEAP[x+5],8)<<6;HEAP[c+
24+20]=n;n=reSign(HEAP[x+6],8)<<6;HEAP[c+24+24]=n;n=unSign(HEAP[x+7],8)<<6;HEAP[c+24+28]=n;HEAP[c+72]=1651078259;if((q&16)!=0){q=reSign(HEAP[x+5],8);HEAP[c+100]=q;q=reSign(HEAP[x+6],8);HEAP[c+104]=q}else{q=reSign(HEAP[x+2],8);HEAP[c+100]=q;q=reSign(HEAP[x+3],8);HEAP[c+104]=q}if(o!=0){c=12;break b}B=D;B=(HEAP[B+8]&1&255)!=0;c:do if(B){_tt_loader_init(E,y,A,C,1);_load_truetype_glyph(E,z,0,1);HEAP[A+56]=HEAP[E+60];HEAP[A+60]=HEAP[E+36+12]+HEAP[E+176]+(0-HEAP[E+180]);if(HEAP[D+468+12]==0)break c;if((C&
512)!=0)break c;c=unSign(HEAP[D+216+10],16);HEAP[A+56]=c}while(0);B=0;c=19}else c=12;break b}else c=12;while(0);b:do if(c==12){B=(C&1)==0;c:do if(B){if(HEAP[y+72+36]!=0){c=21;break c}B=36;break b}while(0);if((C&16384)!=0)B=6;else{B=_tt_loader_init(E,y,A,C,0);if(B==0){HEAP[A+72]=1869968492;HEAP[A+128]=0;HEAP[A+108+16]=0;B=_load_truetype_glyph(E,z,0,0);D=B==0;c:do if(D){q=HEAP[A+72]==1668246896;o=HEAP[E+12];d:do if(q){HEAP[A+128]=HEAP[o+20+28];HEAP[A+132]=HEAP[HEAP[E+12]+20+32]}else{n=A+108;r=o+20;
HEAP[n]=HEAP[r];HEAP[n+2]=HEAP[r+2];HEAP[n+4]=HEAP[r+4];HEAP[n+8]=HEAP[r+8];HEAP[n+12]=HEAP[r+12];HEAP[n+16]=HEAP[r+16];HEAP[A+108+16]&=-513;if(HEAP[E+68]==0){c=25;break d}_FT_Outline_Translate(A+108,0-HEAP[E+68],0)}while(0);q=(C&2)==0;d:do if(q)if(HEAP[HEAP[E+160]+284+53]!=0){c=HEAP[HEAP[E+160]+284+56];if(c==0)c=59;else if(c==1){c=60;break d}else c=c==4?61:c==5?62:63;if(c==63)HEAP[A+108+16]|=8;else if(c==59)HEAP[A+108+16]|=32;else if(c==61)HEAP[A+108+16]|=48;else if(c==62)HEAP[A+108+16]|=16}else HEAP[A+
108+16]|=8;while(0);q=z;o=E;n=q;p=HEAP[o];q=HEAP[o+8];s=HEAP[o+4];r=65536;if((HEAP[o+16]&1)==0)r=HEAP[s+12+8];if(HEAP[q+72]!=1668246896)_FT_Outline_Get_CBox(q+108,a);else{u=o+36;HEAP[a]=HEAP[u];HEAP[a+4]=HEAP[u+4];HEAP[a+8]=HEAP[u+8];HEAP[a+12]=HEAP[u+12]}u=HEAP[o+60];f=HEAP[p+468+12]!=0;d:do if(f){if((HEAP[o+16]&512)!=0){c=30;break d}u=unSign(HEAP[p+216+10],16)}while(0);HEAP[q+56]=u;HEAP[q+24+8]=HEAP[a];HEAP[q+24+12]=HEAP[a+12];HEAP[q+24+16]=HEAP[o+76]-HEAP[o+68];u=HEAP[p+468+12]==0;d:do if(u){if((HEAP[o+
16]&2)!=0)break d;j=unSign(HEAP[s+12],16);i=n;f=p;h=j;i=i;j=0;l=HEAP[f+752];m=HEAP[f+740]+8;k=0;var H=HEAP[f+748],J=f+756;h=h;k=k;f=32;e:for(;;){c=f==36?N:0;var L=k+c;if(!(unSign(H,32)>unSign(L,32))){c=41;break e}if(unSign(HEAP[HEAP[J]+L],8)==h){c=35;break e}var N=c+1;f=36;c=34}e:do if(c==41){c=38;break e}else if(c==35){k=L;i+=2;c=l;if(!(unSign(i,32)<unSign(c,32))){c=38;break e}var I=m+l*k+i;j=I;f=37;c=39;break e}while(0);if(c==38){var P=j;f=38}f=i=f==38?P:I;if(i==0)break d;f=unSign(HEAP[f],8)<<6;
HEAP[q+24+16]=f}while(0);HEAP[q+24]=HEAP[a+8]-HEAP[a];HEAP[q+24+4]=HEAP[a+12]-HEAP[a+4];s=HEAP[p+296]==0;d:do if(s)c=45;else{if(HEAP[p+300+34]==0){c=45;break d}t=_FT_DivFix(HEAP[o+184+4]-HEAP[a+12],r)&65535;t=reSign(t,16);v=HEAP[o+192+4];if(reSign(HEAP[o+184+4],32)<=reSign(v,32))v=0;else{v=_FT_DivFix(HEAP[o+184+4]-HEAP[o+192+4],r)&65535;v=unSign(v,16)}c=47;break d}while(0);if(c==45){t=_FT_DivFix(HEAP[a+12]-HEAP[a+4],r)&65535;t=reSign(t,16);v=p;if(HEAP[p+368]!=-1){v=reSign(HEAP[v+368+70],16);s=reSign(HEAP[p+
368+72],16);v=v-s}else{v=reSign(HEAP[v+216+4],16);s=reSign(HEAP[p+216+6],16);v=v-s}t=Math.floor(reSign(v-t,32)/reSign(2,32))}p=s=HEAP[HEAP[p+128]+52];u=s!=0;d:do if(u){if(HEAP[HEAP[p]+8]==0){c=51;break d}HEAP[w]=0;HEAP[w+4]=t;HEAP[w+8]=v;s=FUNCTION_TABLE[HEAP[HEAP[p]+8]](HEAP[p+4],n,1,w);if(s!=0){c=52;break c}else{t=HEAP[w+4];v=HEAP[w+8]}}while(0);HEAP[q+60]=v;if((HEAP[o+16]&1)==0){t=_FT_MulFix(t,r);v=_FT_MulFix(v,r)}o=HEAP[q+24+8];n=Math.floor(reSign(HEAP[q+24+16],32)/reSign(2,32));HEAP[q+24+20]=
o-n;HEAP[q+24+24]=t;HEAP[q+24+28]=v}while(0);D=(C&1)==0;c:do if(D){if(!(unSign(HEAP[y+12+2],16)<=unSign(23,16))){c=57;break c}HEAP[A+108+16]|=256}while(0)}B=B}}while(0);y=y=y=B}while(0);e=y;STACKTOP=a;return e}_Load_Glyph.__index__=Runtime.getFunctionIndex(_Load_Glyph,"_Load_Glyph");
function _tt_get_interface(e,g){var d,b;b=_ft_service_list_lookup(_tt_services,g);var a=b!=0;a:do if(a)d=b;else{if(e!=0){d=_FT_Get_Module(HEAP[e+4],__str537);var c=d!=0;b:do if(c){d=HEAP[HEAP[d]+20];if(d==0)break b;d=FUNCTION_TABLE[HEAP[d+16]](e,g);break a}while(0)}d=0}while(0);return d}_tt_get_interface.__index__=Runtime.getFunctionIndex(_tt_get_interface,"_tt_get_interface");
function _tt_face_get_location(e,g,d){var b,a,c,f;b=a=0;var h=unSign(HEAP[e+732],32)>unSign(g,32);a:do if(h){c=HEAP[e+736];b=g;if(HEAP[e+160+50]!=0){c=c+b*4;f=HEAP[e+736]+HEAP[e+732]*4;c+=4;b=unSign(HEAP[c+-4],8)<<24;a=unSign(HEAP[c+-4+1],8)<<16;var i=unSign(HEAP[c+-4+2],8)<<8,k=unSign(HEAP[c+-4+3],8);a=b=a|b|i|k;if(!(c+4<=f))break a;c+=4;f=unSign(HEAP[c+-4],8)<<24;a=unSign(HEAP[c+-4+1],8)<<16;i=unSign(HEAP[c+-4+2],8)<<8;c=unSign(HEAP[c+-4+3],8);a=a|f|i|c}else{c=c+b*2;f=HEAP[e+736]+HEAP[e+732]*2;
c+=2;b=unSign(HEAP[c+-2],8)<<8&65535;a=unSign(HEAP[c+-2+1],8);a=b=unSign(b|a,16);if(c+2<=f){c+=2;f=unSign(HEAP[c+-2],8)<<8&65535;c=unSign(HEAP[c+-2+1],8);a=unSign(f|c,16)}b<<=1;a<<=1}}while(0);g=b;if(unSign(HEAP[e+704],32)<=unSign(g,32))e=HEAP[d]=0;else{g=a;if(unSign(HEAP[e+704],32)<=unSign(g,32))a=HEAP[e+704];g=b;HEAP[d]=unSign(a,32)>=unSign(g,32)?a-b:HEAP[e+704]-b;e=b}return e}_tt_face_get_location.__index__=Runtime.getFunctionIndex(_tt_face_get_location,"_tt_face_get_location");
function _tt_face_load_cvt(e,g){var d=STACKTOP;STACKTOP+=8;Runtime.memset(d,0,8);var b=null,a,c,f,h,i=d+4;h=HEAP[g+28];var k=FUNCTION_TABLE[HEAP[e+508]](e,1668707360,g,i);HEAP[d]=k;k=HEAP[d]!=0;a:do if(k){HEAP[e+668]=0;HEAP[e+672]=0;HEAP[d]=0}else{f=Math.floor(unSign(HEAP[i],32)/unSign(2,32));HEAP[e+668]=f;f=_ft_mem_realloc(h,2,0,HEAP[e+668],0,d);HEAP[e+672]=f;if(HEAP[d]!=0)break a;f=_FT_Stream_EnterFrame(g,HEAP[e+668]*2);HEAP[d]=f;if(HEAP[d]!=0)break a;c=HEAP[e+672];a=c+2*HEAP[e+668];f=g;if(c<a){a=
a;var j=g;c=c;for(b=4;;){s=b==4?0:s;var l=b==4?f:j,m=c+2*(s+1),o=c+2*s,n=HEAP[l+32];if(n+1<HEAP[l+36]){var p=n+2,r=reSign(HEAP[p+-2],8)<<8&65535;b=unSign(HEAP[p+-2+1],8);r=r|b;b=6}else b=5;var q=b==5?0:r;HEAP[l+32]=b==5?n:p;l=reSign(q,16)&65535;HEAP[o]=l;var s=s+1;if(m<a)b=8;else break}b=9}else b=3;f=b==9?j:f;if(HEAP[f+20]!=0){a=HEAP[f+28];c=HEAP[f];a=a;c=c;c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[f]=0}HEAP[f+32]=0;HEAP[f+36]=0;if(HEAP[e+708]==0)break a;f=_tt_face_vary_cvt(e,g);HEAP[d]=f}while(0);
h=HEAP[d];STACKTOP=d;return h}_tt_face_load_cvt.__index__=Runtime.getFunctionIndex(_tt_face_load_cvt,"_tt_face_load_cvt");
function _tt_get_metrics_incr_overrides(e,g){var d=STACKTOP;STACKTOP+=16;Runtime.memset(d,0,16);var b,a;b=HEAP[e];a=HEAP[HEAP[b+128]+52]!=0;a:do if(a){if(HEAP[HEAP[HEAP[HEAP[b+128]+52]]+8]==0)break a;HEAP[d]=HEAP[e+52];HEAP[d+4]=0;HEAP[d+8]=HEAP[e+56];HEAP[d+12]=0;b=FUNCTION_TABLE[HEAP[HEAP[HEAP[HEAP[b+128]+52]]+8]](HEAP[HEAP[HEAP[b+128]+52]+4],g,0,d);if(b!=0)break a;a=HEAP[d]&65535;b=HEAP[d+8]&65535;a=reSign(a,16);HEAP[e+52]=a;a=unSign(b,16);HEAP[e+56]=a;a=reSign(0,16);HEAP[e+176]=a;a=unSign(0,16);
HEAP[e+180]=a;if(HEAP[e+64]!=0)break a;HEAP[e+64]=1;b=unSign(b,16);HEAP[e+60]=b;STACKTOP=d;return}while(0);STACKTOP=d}_tt_get_metrics_incr_overrides.__index__=Runtime.getFunctionIndex(_tt_get_metrics_incr_overrides,"_tt_get_metrics_incr_overrides");
function _translate_array(e,g,d,b){var a=null;if(d!=0){a=0;if(unSign(a,32)<unSign(e,32)){var c=a;a=c+1;var f=(unSign(e,32)>unSign(a,32)?e:a)-c;for(a=0;;){a=a==0?0:h;h=c+a;HEAP[g+8*h]=d+HEAP[g+8*h];var h=a+1;if(h!=f)a=1;else break}}c=b;a=4}else a=-1;d=(a==4?c:b)!=0;a:do if(d){a=0;c=e;if(!(unSign(a,32)<unSign(c,32)))break a;h=c=g;f=b;var i=e,k=a;a=k+1;i=(unSign(i,32)>unSign(a,32)?i:a)-k;for(a=6;;){j=a==6?0:j;a=k+j;HEAP[c+8*a+4]=f+HEAP[h+8*a+4];var j=j+1;if(j!=i)a=8;else break}}while(0)}
_translate_array.__index__=Runtime.getFunctionIndex(_translate_array,"_translate_array");function _TT_Access_Glyph_Frame(e,g,d,b){var a,c;g=HEAP[e+24];c=_FT_Stream_Seek(g,d);var f=c!=0;a:do if(f)d=0;else{c=_FT_Stream_EnterFrame(g,b);if(c!=0){d=0;break a}HEAP[e+200]=HEAP[g+32];HEAP[e+204]=HEAP[g+36];a=0;d=3;break a}while(0);if(d==0)a=c;return a}_TT_Access_Glyph_Frame.__index__=Runtime.getFunctionIndex(_TT_Access_Glyph_Frame,"_TT_Access_Glyph_Frame");
function _TT_Forget_Glyph_Frame(e){var g,d;g=HEAP[e+24];if(HEAP[g+20]!=0){d=HEAP[g+28];e=HEAP[g];e!=0&&FUNCTION_TABLE[HEAP[d+8]](d,e);HEAP[g]=0}HEAP[g+32]=0;HEAP[g+36]=0}_TT_Forget_Glyph_Frame.__index__=Runtime.getFunctionIndex(_TT_Forget_Glyph_Frame,"_TT_Forget_Glyph_Frame");
function _TT_Load_Glyph_Header(e){var g;g=HEAP[e+200];if(g+10>HEAP[e+204])e=20;else{g+=2;var d=reSign(HEAP[g+-2],8)<<8&65535,b=unSign(HEAP[g+-2+1],8);HEAP[e+32]=d|b;g+=2;d=reSign(HEAP[g+-2],8)<<8&65535;b=unSign(HEAP[g+-2+1],8);d=reSign(d|b,16);HEAP[e+36]=d;g+=2;d=reSign(HEAP[g+-2],8)<<8&65535;b=unSign(HEAP[g+-2+1],8);d=reSign(d|b,16);HEAP[e+36+4]=d;g+=2;d=reSign(HEAP[g+-2],8)<<8&65535;b=unSign(HEAP[g+-2+1],8);d=reSign(d|b,16);HEAP[e+36+8]=d;g+=2;d=reSign(HEAP[g+-2],8)<<8&65535;b=unSign(HEAP[g+-2+
1],8);d=reSign(d|b,16);HEAP[e+36+12]=d;HEAP[e+200]=g;e=0}return e}_TT_Load_Glyph_Header.__index__=Runtime.getFunctionIndex(_TT_Load_Glyph_Header,"_TT_Load_Glyph_Header");
function _TT_Load_Simple_Glyph(e){var g,d=null,b,a,c,f,h,i,k,j,l,m,o,n,p,r;a=HEAP[e+200];c=HEAP[e+204];f=HEAP[e+12];h=reSign(HEAP[e+32],16);k=HEAP[e];r=h==0;a:do if(r)g=0;else{r=reSign(HEAP[f+20],16);var q=reSign(HEAP[f+56],16);p=HEAP[f+8];if(unSign(h+r+q,32)<=unSign(p,32)){g=0;break a}b=r=_FT_GlyphLoader_CheckPoints(f,0,h);g=r!=0?3:2;break a}while(0);a:do if(g==0){b=0;g=2;break a}while(0);a:do if(g==2){p=HEAP[f+56+12];q=h;r=p+2*q;q=reSign(q,32)>reSign(4094,32);b:do if(!q){if(a+(h+1)*2>c){g=4;break b}a+=
2;b=unSign(HEAP[a+-2],8)<<8&65535;j=unSign(HEAP[a+-2+1],8);i=b|j;if(reSign(h,32)>reSign(0,32))HEAP[p]=i;p+=2;b=r;j=p;i=i;d=7;c:for(;;){g=d==10?v:0;d=d==10?t:i;var s=j+2*g;if(!(s<b)){g=12;break c}a+=2;l=unSign(HEAP[a+-2],8)<<8&65535;var u=unSign(HEAP[a+-2+1],8);HEAP[s]=l|u;if(reSign(HEAP[s],16)<=reSign(d,16)){g=9;break c}var t=HEAP[s],v=g+1;d=10;g=8}if(g==12){p=s;j=0;if(reSign(h,32)>reSign(0,32)){j=reSign(HEAP[p+-2],16)+1;if(reSign(j,32)<reSign(0,32)){g=4;break b}}p=reSign(HEAP[f+20+2],16);b=reSign(HEAP[f+
56+2],16);i=HEAP[f+4];if(unSign(p+4+j+b,32)<=unSign(i,32))b=0;else{b=p=_FT_GlyphLoader_CheckPoints(f,j+4,0);if(p!=0)break a}i=f+56;p=HEAP[i+12]+2;l=r;u=p;d=15;c:for(;;){g=d==18?x:0;var w=u+2*g;d=u+2*(g+-1);if(!(w<l)){g=20;break c}m=HEAP[w];if(reSign(HEAP[d],16)>=reSign(m,16)){g=17;break c}var x=g+1;d=18;g=16}if(g==20){p=w;HEAP[HEAP[e+8]+140]=0;HEAP[HEAP[e+8]+136]=0;if(a+2>c){g=4;break b}a+=2;d=unSign(HEAP[a+-2],8)<<8&65535;l=unSign(HEAP[a+-2+1],8);l=d=d|l;if(unSign(HEAP[k+260+26],16)<unSign(l,16)){b=
22;break a}else{l=c-a;u=unSign(d,16);if(reSign(l,32)<reSign(u,32)){b=22;break a}else{if((HEAP[e+16]&2)==0){l=HEAP[e+8];u=unSign(d,16);HEAP[l+140]=u;HEAP[HEAP[e+8]+136]=HEAP[HEAP[e+160]+392];l=unSign(d,16);_llvm_memcpy_p0i8_p0i8_i32(HEAP[HEAP[e+160]+392],a,l,1,0)}d=unSign(d,16);a+=d;d=HEAP[i+8];l=d+j;c:for(;;){if(!(d<l)){g=32;break c}if(a+1>c){g=4;break b}g=HEAP[a];HEAP[d]=g;d+=1;a+=1;if((unSign(g,8)&8)==0){g=23;continue c}if(a+1>c){g=4;break b}m=HEAP[a];a+=1;u=unSign(m,8);if(d+u>l){g=4;break b}if(m==
0){g=23;continue c}g=g;u=d;m=unSign(m+-1,8);o=m+1;for(d=28;;){y=d==28?0:y;HEAP[u+y]=g;var y=y+1;if(y!=o)d=29;else break}d=u+1+m;g=23}o=HEAP[i+4];l=o+8*j;d=HEAP[i+8];n=0;if(a+0>c){g=4;break b}l=l;m=u=c;o=o;n=n;var A=d;d=33;c:for(;;){g=d==33?0:L;var z=d==33?n:J,C=A+g,B=d=o+8*g;if(!(d<l)){g=44;break c}var D=HEAP[C],E=(unSign(D,8)&2)!=0;d:do if(E){if(a+1>u){g=35;break c}var F=unSign(HEAP[a],8);a+=1;if((unSign(D,8)&16)!=0){d=36;break d}var G=0-F;d=37}else{if((unSign(D,8)&16)!=0){d=40;break d}if(a+2>m){g=
35;break c}a+=2;var H=reSign(HEAP[a+-2],8)<<8&65535;d=unSign(HEAP[a+-2+1],8);H=reSign(H|d,16);d=42}while(0);var J=(d==36?F:d==37?G:d==42?H:0)+z;HEAP[B]=J;HEAP[C]=D&-19;var L=g+1;d=38;g=34}if(g==44){o=HEAP[f+56+4];l=o+8*j;d=HEAP[i+8];n=0;l=l;m=u=c;o=o;n=n;A=d;d=44;c:for(;;){g=d==49?O:0;z=d==49?K:n;C=A+g;B=o+8*g+4;if(!(o+8*g<l)){g=55;break c}D=HEAP[C];E=(unSign(D,8)&4)!=0;d:do if(E){if(a+1>u){g=46;break c}var N=unSign(HEAP[a],8);a+=1;if((unSign(D,8)&32)!=0){d=47;break d}var I=0-N;d=48}else{if((unSign(D,
8)&32)!=0){d=51;break d}if(a+2>m){g=46;break c}a+=2;var P=reSign(HEAP[a+-2],8)<<8&65535;d=unSign(HEAP[a+-2+1],8);P=reSign(P|d,16);d=53}while(0);var K=(d==47?N:d==48?I:d==53?P:0)+z;HEAP[B]=K;HEAP[C]=D&1;var O=g+1;d=49;g=45}if(g==55){HEAP[i+2]=j&65535;HEAP[i]=h&65535;HEAP[e+200]=a;break a}}}}}else if(g==17)p=w}else if(g==9){b=8;break a}}while(0);b=20}while(0);return b}_TT_Load_Simple_Glyph.__index__=Runtime.getFunctionIndex(_TT_Load_Simple_Glyph,"_TT_Load_Simple_Glyph");
function _TT_Load_Composite_Glyph(e){var g,d=null,b,a,c,f,h;c=HEAP[e+200];f=HEAP[e+204];b=HEAP[e+12];h=0;var i=b+56+32;h=h;var k=h+1;d=-1;a:for(;;){A=d==17?A:0;g=h+A;var j=k+A,l=_FT_GlyphLoader_CheckSubGlyphs(b,j);if(l!=0){g=1;break a}if(c+4>f){g=3;break a}g=HEAP[i]+32*g;HEAP[g+12]=0;HEAP[g+8]=HEAP[g+12];c+=2;var m=unSign(HEAP[c+-2],8)<<8&65535;d=unSign(HEAP[c+-2+1],8);HEAP[g+4]=m|d;c+=2;m=unSign(HEAP[c+-2],8)<<8&65535;d=unSign(HEAP[c+-2+1],8);m=unSign(m|d,16);HEAP[g]=m;m=(unSign(HEAP[g+4],16)&1&
255)!=0?4:2;if((unSign(HEAP[g+4],16)&8)!=0){var o=m+2;d=5}else if((unSign(HEAP[g+4],16)&64)!=0){var n=m+4;d=7}else{var p=unSign(HEAP[g+4],16)&128;d=m+8;p=p!=0?d:m;d=8}if(c+(d==7?n:d==5?o:p)>f){g=3;break a}m=(unSign(HEAP[g+4],16)&1&255)!=0;d=c;if(m){c=d+2;m=reSign(HEAP[c+-2],8)<<8&65535;d=unSign(HEAP[c+-2+1],8);m=reSign(m|d,16);HEAP[g+8]=m;c+=2;m=reSign(HEAP[c+-2],8)<<8&65535;d=unSign(HEAP[c+-2+1],8);m=reSign(m|d,16);HEAP[g+12]=m}else{m=reSign(HEAP[d],8);HEAP[g+8]=m;c+=1;m=reSign(HEAP[c],8);HEAP[g+
12]=m;c+=1}m=(unSign(HEAP[g+4],16)&8)!=0;b:do if(m){c+=2;var r=reSign(HEAP[c+-2],8)<<8&65535;d=unSign(HEAP[c+-2+1],8);r=reSign(r|d,16)<<2;d=12}else if((unSign(HEAP[g+4],16)&64)!=0){c+=2;var q=reSign(HEAP[c+-2],8)<<8&65535,s=unSign(HEAP[c+-2+1],8);q=reSign(q|s,16)<<2;c+=2;s=reSign(HEAP[c+-2],8)<<8&65535;d=unSign(HEAP[c+-2+1],8);s=reSign(s|d,16)<<2;d=14}else{if((unSign(HEAP[g+4],16)&128)==0){d=15;break b}c+=2;var u=reSign(HEAP[c+-2],8)<<8&65535,t=unSign(HEAP[c+-2+1],8);u=reSign(u|t,16)<<2;c+=2;t=reSign(HEAP[c+
-2],8)<<8&65535;var v=unSign(HEAP[c+-2+1],8);t=reSign(t|v,16)<<2;c+=2;v=reSign(HEAP[c+-2],8)<<8&65535;var w=unSign(HEAP[c+-2+1],8);v=reSign(v|w,16)<<2;c+=2;w=reSign(HEAP[c+-2],8)<<8&65535;d=unSign(HEAP[c+-2+1],8);w=reSign(w|d,16)<<2;d=16}while(0);m=d==16?w:d==15?65536:d==14?s:r;var x=d==16?t:d==15?0:d==14?0:0,y=d==16?v:d==15?0:d==14?0:0;HEAP[g+16]=d==16?u:d==15?65536:d==14?q:r;HEAP[g+16+4]=y;HEAP[g+16+8]=x;HEAP[g+16+12]=m;g=(unSign(HEAP[g+4],16)&32)!=0;var A=A+1;if(g){d=17;g=0}else{g=18;break a}}if(g==
1)a=l;else if(g==3)a=21;else if(g==18){a=0;h=j;HEAP[b+56+28]=h;b=HEAP[e+24];b=HEAP[b+8];HEAP[e+168]=c+b-f;HEAP[e+200]=c}return a}_TT_Load_Composite_Glyph.__index__=Runtime.getFunctionIndex(_TT_Load_Composite_Glyph,"_TT_Load_Composite_Glyph");
function _TT_Hint_Glyph(e,g){var d=STACKTOP;STACKTOP+=60;Runtime.memset(d,0,60);var b,a,c,f=d+4,h,i=d+8,k=d+16,j=d+24,l=d+32,m,o,n=d+40;o=e+124;a=HEAP[HEAP[e+8]+140];b=HEAP[o+16];h=unSign(HEAP[o+8],16)-4;b=HEAP[b+8*h];b=(b+32&-64)-b;if(b!=0){h=HEAP[o+16];var p=unSign(HEAP[o+8],16);_translate_array(p,h,b,0)}if(a!=0){b=unSign(HEAP[o+8],16)*8;_llvm_memcpy_p0i8_p0i8_i32(HEAP[o+12],HEAP[o+16],b,1,0)}_llvm_memcpy_p0i8_p0i8_i32(HEAP[e+160]+284,HEAP[e+4]+172,68,4,0);b=HEAP[e+160];if(g!=0){HEAP[b+216+4]=65536;
HEAP[HEAP[e+160]+216+8]=65536;b=unSign(HEAP[o+8],16)*8;_llvm_memcpy_p0i8_p0i8_i32(HEAP[o+20],HEAP[o+16],b,1,0)}else{HEAP[b+216+4]=HEAP[HEAP[e+4]+44+4];HEAP[HEAP[e+160]+216+8]=HEAP[HEAP[e+4]+44+8]}b=HEAP[o+16];h=unSign(HEAP[o+8],16)-3;b=b+8*h;h=HEAP[o+16];p=unSign(HEAP[o+8],16)-3;HEAP[b]=HEAP[h+8*p]+32&-64;b=HEAP[o+16];h=unSign(HEAP[o+8],16)-1;b=b+8*h;h=HEAP[o+16];p=unSign(HEAP[o+8],16)-1;HEAP[b+4]=HEAP[h+8*p+4]+32&-64;h=a!=0;a:do if(h){b=HEAP[e+12];b=b+56;HEAP[n]=HEAP[b];HEAP[n+2]=HEAP[b+2];HEAP[n+
4]=HEAP[b+4];HEAP[n+8]=HEAP[b+8];HEAP[n+12]=HEAP[b+12];HEAP[n+16]=HEAP[b+16];h=a;b=HEAP[HEAP[e+160]+392];a=HEAP[e+160];b=b;h=h;HEAP[a+444+16]=b;HEAP[a+444+16+4]=h;a=0;if(a!=0){m=a;b=3}else{HEAP[HEAP[e+160]+560]=g;_llvm_memcpy_p0i8_p0i8_i32(HEAP[e+160]+144,o,36,4,0);a=(HEAP[e+16]&1)!=0;b:do if(a)b=4;else{if(HEAP[HEAP[e+4]+292]==0){b=4;break b}c=1;b=6;break b}while(0);if(b==4)c=0;c=c&255;unSign(c,8);a=c=HEAP[e+160];b=a+444+16;HEAP[a+356]=HEAP[b];HEAP[a+364]=HEAP[b+4];HEAP[a+360]=0;HEAP[a+352]=3;_llvm_memcpy_p0i8_p0i8_i32(c+
36,c+144,36,4,0);_llvm_memcpy_p0i8_p0i8_i32(c+72,c+144,36,4,0);_llvm_memcpy_p0i8_p0i8_i32(c+108,c+144,36,4,0);HEAP[c+284+60]=1;HEAP[c+284+62]=1;HEAP[c+284+64]=1;HEAP[c+284+10]=16384;HEAP[c+284+10+2]=0;a=c+284+10;HEAP[f]=HEAP[a];HEAP[f+2]=HEAP[a+2];a=c+284+14;HEAP[a]=HEAP[f];HEAP[a+2]=HEAP[f+2];f=c+284+10;HEAP[d]=HEAP[f];HEAP[d+2]=HEAP[f+2];f=c+284+6;HEAP[f]=HEAP[d];HEAP[f+2]=HEAP[d+2];HEAP[c+284+28]=1;HEAP[c+284+20]=1;HEAP[c+16]=0;HEAP[c+428]=0;a=f=FUNCTION_TABLE[HEAP[HEAP[c]+688]](c);f=f!=0;b:do if(f){if(HEAP[HEAP[e+
160]+561]==0)break b;m=a;b=3;break a}while(0);HEAP[HEAP[n+8]]=HEAP[HEAP[n+8]]|4|HEAP[HEAP[e+160]+284+56]<<5&255;b=10}break a}else b=10;while(0);if(b==10){if(HEAP[e+65]==0){m=HEAP[o+16];n=unSign(HEAP[o+8],16)-4;m=m+8*n;HEAP[l]=HEAP[m];HEAP[l+4]=HEAP[m+4];m=e+68;HEAP[m]=HEAP[l];HEAP[m+4]=HEAP[l+4];l=HEAP[o+16];m=unSign(HEAP[o+8],16)-3;l=l+8*m;HEAP[j]=HEAP[l];HEAP[j+4]=HEAP[l+4];l=e+76;HEAP[l]=HEAP[j];HEAP[l+4]=HEAP[j+4];j=HEAP[o+16];l=unSign(HEAP[o+8],16)-2;j=j+8*l;HEAP[k]=HEAP[j];HEAP[k+4]=HEAP[j+
4];j=e+184;HEAP[j]=HEAP[k];HEAP[j+4]=HEAP[k+4];k=HEAP[o+16];o=unSign(HEAP[o+8],16)-1;o=k+8*o;HEAP[i]=HEAP[o];HEAP[i+4]=HEAP[o+4];o=e+192;HEAP[o]=HEAP[i];HEAP[o+4]=HEAP[i+4]}m=0}i=m;STACKTOP=d;return i}_TT_Hint_Glyph.__index__=Runtime.getFunctionIndex(_TT_Hint_Glyph,"_TT_Hint_Glyph");
function _load_truetype_glyph(e,g,d,b){var a=STACKTOP;STACKTOP+=264;Runtime.memset(a,0,264);var c,f=null,h,i,k,j,l,m,o,n,p=a+8,r=a+16,q=a+24;i=a+32;l=a+36;var s,u,t,v;n=a+40;k=a+48;j=a+56;m=a+64;var w=a+72,x=a+80,y=a+88,A=a+96,z,C;t=a+104;var B,D,E,F,G,H,J,L,N=a+108,I=a+110,P=a+112,K=a+114,O=a+116,M=a+124,Q=a+132,R=a+140,T=a+148,V=a+156,U=a+164,S=a+172,X,Y,W,da,ba=a+180,aa=a+184,ca=a+224,$,la,ga,ea=a+232;C=0;W=HEAP[e];o=HEAP[e+12];da=0;$=HEAP[ba]=0;Y=unSign(d,32)>unSign(1,32);a:do if(Y){Y=unSign(HEAP[W+
260+30],16);X=d;if(!(unSign(Y,32)<unSign(X,32))){c=1;break a}C=21;c=2;break a}else c=1;while(0);a:do if(c==1){Y=g;if(unSign(HEAP[W+16],32)<=unSign(Y,32))C=16;else{HEAP[e+20]=g;if((HEAP[e+16]&1)==0){X=HEAP[HEAP[e+4]+44+4];Y=HEAP[HEAP[e+4]+44+8]}else Y=X=65536;F=g;E=e;G=F;F=HEAP[E];HEAP[N]=0;HEAP[I]=0;HEAP[P]=0;HEAP[K]=0;H=unSign((HEAP[E+16]&512)==0,1);s=G;u=H&255;H=F;s=s;J=u;L=N;u=P;FUNCTION_TABLE[HEAP[HEAP[H+532]+156]](H,0,s,L,u);s=J!=0;b:do if(s){if(HEAP[H+468+12]==0){c=6;break b}HEAP[u]=HEAP[H+
216+10]}while(0);unSign((HEAP[E+16]&512)==0,1);G=G;F=F;G=G;H=I;s=K;if(HEAP[F+296]!=0)FUNCTION_TABLE[HEAP[HEAP[F+532]+156]](F,1,G,H,s);else{HEAP[H]=0;HEAP[s]=HEAP[F+68]}F=reSign(HEAP[N],16);HEAP[E+52]=F;F=unSign(HEAP[P],16);HEAP[E+56]=F;F=reSign(HEAP[I],16);HEAP[E+176]=F;F=unSign(HEAP[K],16);HEAP[E+180]=F;if(HEAP[E+64]==0){HEAP[E+64]=1;F=unSign(HEAP[P],16);HEAP[E+60]=F}if(HEAP[HEAP[W+128]+52]!=0){C=FUNCTION_TABLE[HEAP[HEAP[HEAP[HEAP[W+128]+52]]]](HEAP[HEAP[HEAP[W+128]+52]+4],g,ca);if(C!=0)break a;
$=1;E=0;HEAP[e+28]=HEAP[ca+4];_llvm_memset_p0i8_i32(aa,0,40,1,0);H=HEAP[ca+4];G=HEAP[ca];F=aa;G=G;H=H;HEAP[F]=G;HEAP[F+4]=H;HEAP[F+8]=0;HEAP[F+32]=0;HEAP[F+20]=0;HEAP[F+24]=0;HEAP[e+24]=aa}else E=_tt_face_get_location(W,g,e+28);if(reSign(HEAP[e+28],32)>reSign(0,32)){C=HEAP[e+84]==0;b:do if(C){if(HEAP[HEAP[W+128]+52]!=0){c=13;break b}C=8;break a}while(0);C=E=FUNCTION_TABLE[HEAP[W+512]](e,g,E+HEAP[e+84],HEAP[e+28]);if(E!=0)break a;da=1;C=FUNCTION_TABLE[HEAP[W+520]](e);if(C!=0)break a;if(b!=0)break a}H=
HEAP[e+28]==0;b:do if(!H){if(HEAP[e+32]==0){c=17;break b}HEAP[e+68]=HEAP[e+36]-HEAP[e+52];HEAP[e+68+4]=0;HEAP[e+76]=HEAP[e+56]+HEAP[e+68];HEAP[e+76+4]=0;HEAP[e+184]=0;HEAP[e+184+4]=HEAP[e+36+12]+HEAP[e+176];HEAP[e+192]=0;HEAP[e+192+4]=HEAP[e+184+4]-HEAP[e+180];_tt_get_metrics_incr_overrides(e,g);if(reSign(HEAP[e+32],16)>reSign(0,16)){C=FUNCTION_TABLE[HEAP[W+524]](e);if(C!=0)break a;FUNCTION_TABLE[HEAP[W+516]](e);da=0;v=e;l=HEAP[v+12];z=0;C=l+56;i=reSign(HEAP[C+2],16);p=HEAP[C+4];r=v+68;HEAP[A]=HEAP[r];
HEAP[A+4]=HEAP[r+4];p=p+8*i;HEAP[p]=HEAP[A];HEAP[p+4]=HEAP[A+4];p=HEAP[C+4];r=i+1;q=v+76;HEAP[y]=HEAP[q];HEAP[y+4]=HEAP[q+4];p=p+8*r;HEAP[p]=HEAP[y];HEAP[p+4]=HEAP[y+4];p=HEAP[C+4];r=i+2;q=v+184;HEAP[x]=HEAP[q];HEAP[x+4]=HEAP[q+4];p=p+8*r;HEAP[p]=HEAP[x];HEAP[p+4]=HEAP[x+4];p=HEAP[C+4];r=i+3;q=v+192;HEAP[w]=HEAP[q];HEAP[w+4]=HEAP[q+4];p=p+8*r;HEAP[p]=HEAP[w];HEAP[p+4]=HEAP[w+4];HEAP[HEAP[C+8]+i]=0;HEAP[HEAP[C+8]+(i+1)]=0;HEAP[HEAP[C+8]+(i+2)]=0;HEAP[HEAP[C+8]+(i+3)]=0;i+=4;p=HEAP[HEAP[v]+708]!=0;
c:do if(p){p=HEAP[HEAP[v]+100];z=_TT_Vary_Get_Glyph_Deltas(HEAP[v],HEAP[v+20],t,i);if(z!=0){h=z;f=25;c=26}else{r=i;if(reSign(0,32)<reSign(r,32)){r=C+4;w=C+4;q=C+4;x=C+4;y=i;reSign(y,32);reSign(1,32);y=(reSign(y,32)>reSign(1,32)?y:1)-0;for(f=27;;){B=f==27?0:B;A=0+B;HEAP[HEAP[r]+8*A]=HEAP[HEAP[t]+8*A]+HEAP[HEAP[w]+8*A];HEAP[HEAP[q]+8*A+4]=HEAP[HEAP[t]+8*A+4]+HEAP[HEAP[x]+8*A+4];B=B+1;if(B!=y)f=28;else{f=28;break}}}B=HEAP[t];p=p;r=B;B!=0&&FUNCTION_TABLE[HEAP[p+8]](p,r);HEAP[t]=0;c=32}break c}else c=
32;while(0);if(c==32){if((HEAP[v+16]&2)==0){t=l+56;l=v+124;t=t;HEAP[l+8]=HEAP[t+2]-0;HEAP[l+10]=HEAP[t]-0;HEAP[l+12]=HEAP[t+20]+0;HEAP[l+16]=HEAP[t+4]+0;HEAP[l+20]=HEAP[t+24]+0;HEAP[l+24]=HEAP[t+8]+0;HEAP[l+28]=HEAP[t+12]+0;HEAP[l+32]=0;l=unSign(HEAP[v+124+8],16)*8+32;_llvm_memcpy_p0i8_p0i8_i32(HEAP[v+124+20],HEAP[v+124+16],l,1,0)}if((HEAP[v+16]&1)==0){B=HEAP[C+4];D=HEAP[C+4]+8*i;l=HEAP[HEAP[v+4]+44+4];t=HEAP[HEAP[v+4]+44+8];if(B<D){l=l;t=t;D=D;B=B;for(f=34;;){Z=f==34?0:Z;p=B+8*(Z+1);w=B+8*Z;r=B+
8*Z+4;q=_FT_MulFix(HEAP[w],l);HEAP[w]=q;w=_FT_MulFix(HEAP[r],t);HEAP[r]=w;var Z=Z+1;if(p<D)f=35;else break}}l=HEAP[C+4]+8*(i-4);HEAP[m]=HEAP[l];HEAP[m+4]=HEAP[l+4];l=v+68;HEAP[l]=HEAP[m];HEAP[l+4]=HEAP[m+4];m=HEAP[C+4]+8*(i-3);HEAP[j]=HEAP[m];HEAP[j+4]=HEAP[m+4];m=v+76;HEAP[m]=HEAP[j];HEAP[m+4]=HEAP[j+4];j=HEAP[C+4]+8*(i-2);HEAP[k]=HEAP[j];HEAP[k+4]=HEAP[j+4];j=v+184;HEAP[j]=HEAP[k];HEAP[j+4]=HEAP[k+4];C=HEAP[C+4]+8*(i-1);HEAP[n]=HEAP[C];HEAP[n+4]=HEAP[C+4];C=v+192;HEAP[C]=HEAP[n];HEAP[C+4]=HEAP[n+
4]}if((HEAP[v+16]&2)==0){HEAP[v+124+8]+=4;z=_TT_Hint_Glyph(v,0)}D=z;f=40}C=v=f==25?h:D;if(v!=0)break a;_FT_GlyphLoader_Add(o);break a}else if(HEAP[e+32]==-1){F=reSign(HEAP[o+20+2],16);E=reSign(HEAP[o+20],16);C=FUNCTION_TABLE[HEAP[W+528]](e);if(C!=0)break a;G=HEAP[e+168];FUNCTION_TABLE[HEAP[W+516]](e);da=0;if(HEAP[W+708]!=0){s=HEAP[W+100];C=_TT_Vary_Get_Glyph_Deltas(W,g,ba,HEAP[o+56+28]+4);if(C!=0)break a;u=HEAP[o+56+32]+32*HEAP[o+20+28];J=HEAP[o+56+28];f=0;L=J;if(reSign(f,32)<reSign(L,32)){L=J;u=
u;J=f;f=J+1;L=reSign(L,32)>reSign(f,32)?L:f;var ha=L-J;for(f=45;;){fa=f==45?0:fa;c=J+fa;var ia=u+32*fa+8;f=u+32*fa+12;if((unSign(HEAP[u+32*fa+4],16)&2)!=0){var ja=HEAP[ia];ja=reSign(HEAP[HEAP[ba]+8*c]&65535,16)+ja;HEAP[ia]=ja;ia=HEAP[f];c=reSign(HEAP[HEAP[ba]+8*c+4]&65535,16)+ia;HEAP[f]=c}var fa=fa+1;if(fa!=ha){f=48;c=46}else{c=49;break}}f=L}HEAP[e+68]=HEAP[HEAP[ba]+8*f]+HEAP[e+68];HEAP[e+68+4]=HEAP[HEAP[ba]+8*f+4]+HEAP[e+68+4];HEAP[e+76]=HEAP[HEAP[ba]+8*(f+1)]+HEAP[e+76];HEAP[e+76+4]=HEAP[HEAP[ba]+
8*(f+1)+4]+HEAP[e+76+4];HEAP[e+184]=HEAP[HEAP[ba]+8*(f+2)]+HEAP[e+184];HEAP[e+184+4]=HEAP[HEAP[ba]+8*(f+2)+4]+HEAP[e+184+4];HEAP[e+192]=HEAP[HEAP[ba]+8*(f+3)]+HEAP[e+192];HEAP[e+192+4]=HEAP[HEAP[ba]+8*(f+3)+4]+HEAP[e+192+4];f=HEAP[ba];s=s;u=f;f!=0&&FUNCTION_TABLE[HEAP[s+8]](s,u);HEAP[ba]=0}if((HEAP[e+16]&1)==0){f=_FT_MulFix(HEAP[e+68],X);HEAP[e+68]=f;f=_FT_MulFix(HEAP[e+76],X);HEAP[e+76]=f;f=_FT_MulFix(HEAP[e+184+4],Y);HEAP[e+184+4]=f;f=_FT_MulFix(HEAP[e+192+4],Y);HEAP[e+192+4]=f}if((HEAP[e+16]&1024)!=
0){_FT_GlyphLoader_Add(o);HEAP[HEAP[e+8]+72]=1668246896;break a}else{la=0;ga=F;J=HEAP[o+56+28];f=HEAP[o+20+28];s=HEAP[e+24];u=HEAP[e+28];_FT_GlyphLoader_Add(o);J=J;L=o+20+32;ha=S;ia=S+4;var ka=ea;ja=ka;ka=ka+4;var na=S+4,sa=U,wa=U+4,Aa=ea+8,Da=Aa;Aa=Aa+4;var pa=U+4,ta=V,ma=V+4,ya=ea+16,qa=ya;ya=ya+4;var ua=V+4,Ba=T,Na=T+4,Ea=ea+24,ra=Ea;Ea=Ea+4;var za=T+4,Ha=o+20+2,Ca=d+1,va=o+20+32,Pa=f,Ja=ea,La=R,xa=Ja,oa=R+4;Ja=Ja+4;var Fa=R+4,Ma=ea+8,Ka=Q,Ra=Ma,Qa=Q+4;Ma=Ma+4;var Va=Q+4,Ta=ea+16,Ua=M,ab=Ta,Sa=
M+4;Ta=Ta+4;var $a=M+4,Wa=ea+24,eb=O,Ga=Wa,ob=O+4;Wa=Wa+4;var Oa=O+4,Xa=o+20+2,bb=F;ga=ga;la=la;var jb=HEAP[ha],Za=HEAP[sa],fb=HEAP[ta],Ya=HEAP[Ba],Ia=HEAP[La],cb=HEAP[Ka],pb=HEAP[Ua],gb=HEAP[eb],hb=0+f,kb=0+Pa;f=54;c:for(;;){c=f==67?cc:0;var db=f==67?sb:gb,ub=f==67?Db:pb,yb=f==67?Cb:cb,rb=f==67?Yb:Ia,zb=f==67?ib:Ya,Fb=f==67?tb:fb,Ib=f==67?vb:Za,qb=f==67?Gb:jb,xb=f==67?Mb:la,Jb=f==67?Ob:ga,Hb=f==67?Eb:0,Nb=hb+c,lb=kb+c;if(!(unSign(0+c,32)<unSign(J,32))){c=82;break c}C=HEAP[L];vb=e+68;var Gb=HEAP[vb];
HEAP[ia]=HEAP[vb+4];HEAP[ja]=Gb;HEAP[ka]=HEAP[na];tb=e+76;var vb=HEAP[tb];HEAP[wa]=HEAP[tb+4];HEAP[Da]=vb;HEAP[Aa]=HEAP[pa];ib=e+184;var tb=HEAP[ib];HEAP[ma]=HEAP[ib+4];HEAP[qa]=tb;HEAP[ya]=HEAP[ua];var Kb=e+192,ib=HEAP[Kb];HEAP[Na]=HEAP[Kb+4];HEAP[ra]=ib;HEAP[Ea]=HEAP[za];Kb=HEAP[Ha];var wb=reSign(Kb,16);C=_load_truetype_glyph(e,HEAP[C+32*Nb],Ca,0);if(C!=0){c=56;break c}Eb=HEAP[va];var Mb=Eb+32*Pa+32*Hb;if((unSign(HEAP[Eb+32*lb+4],16)&512)==0){var Ab=HEAP[xa];HEAP[oa]=HEAP[Ja];var mb=e+68;HEAP[mb]=
Ab;HEAP[mb+4]=HEAP[Fa];mb=HEAP[Ra];HEAP[Qa]=HEAP[Ma];var Bb=e+76;HEAP[Bb]=mb;HEAP[Bb+4]=HEAP[Va];Bb=HEAP[ab];HEAP[Sa]=HEAP[Ta];var nb=e+184;HEAP[nb]=Bb;HEAP[nb+4]=HEAP[$a];nb=HEAP[Ga];HEAP[ob]=HEAP[Wa];sb=e+192;HEAP[sb]=nb;HEAP[sb+4]=HEAP[Oa];f=58}else f=57;var sb=f==58?nb:db,Db=f==58?Bb:ub,Cb=f==58?mb:yb,Yb=f==58?Ab:rb,Ob=reSign(HEAP[Xa],16);cc=Ob==wb;d:do if(!cc){var Lb=e,Xb=HEAP[Lb+12];Nb=HEAP[Xb+20+4];var Qb=HEAP[Xb+20+2],Rb=reSign(Qb,16),Sb=HEAP[Eb+32*lb+4]&255&-56,Tb=Sb!=0;e:do if(Tb){if(!(unSign(wb,
32)<unSign(Rb,32)))break e;f=wb+1;unSign(Rb,32);unSign(f,32);var Pb=reSign(Kb,16);f=Pb+1;var Ub=reSign(Qb,16);Ub=(unSign(f,32)>unSign(Ub,32)?f:Ub)-Pb;var dc=Eb+32*lb+16;for(f=61;;){Zb=f==61?0:Zb;_FT_Vector_Transform(Nb+8*(Pb+Zb),dc);var Zb=Zb+1;if(Zb!=Ub)f=63;else break}}while(0);Qb=(unSign(HEAP[Eb+32*lb+4],16)&2)==0;Tb=HEAP[Eb+32*lb+8];Pb=HEAP[Eb+32*lb+12];e:do if(Qb){Ub=bb+Tb;f=wb+Pb;dc=unSign(Ub,32)>=unSign(wb,32);var gc=unSign(f,32)>=unSign(Rb,32);if(dc|gc)break d;else{var $b=HEAP[Xb+20+4]+8*
Ub;f=HEAP[Xb+20+4]+8*f;var hc=HEAP[$b]-HEAP[f];$b=HEAP[$b+4]-HEAP[f+4];f=68}}else if(Tb==0&Pb==0)break d;else{var ac=Sb!=0;f:do if(ac){if((unSign(HEAP[Eb+32*lb+4],16)&2048)==0){f=71;break f}var Vb=_FT_MulFix(HEAP[Eb+32*lb+16],HEAP[Eb+32*lb+16]);Vb=_FT_MulFix(HEAP[Eb+32*lb+16+4],HEAP[Eb+32*lb+16+4])+Vb;Vb=_FT_SqrtFixed(Vb);var Wb=_FT_MulFix(HEAP[Eb+32*lb+16+12],HEAP[Eb+32*lb+16+12]);Wb=_FT_MulFix(HEAP[Eb+32*lb+16+8],HEAP[Eb+32*lb+16+8])+Wb;Wb=_FT_SqrtFixed(Wb);Vb=_FT_MulFix(Tb,Vb);Wb=_FT_MulFix(Pb,
Wb);f=72}else f=145;while(0);ac=f==72?Vb:f==71?Tb:Tb;var ec=f==72?Wb:f==71?Pb:Pb;if((HEAP[Lb+16]&1)!=0){f=73;break e}var bc=HEAP[HEAP[Lb+4]+44+8],fc=_FT_MulFix(ac,HEAP[HEAP[Lb+4]+44+4]);bc=_FT_MulFix(ec,bc);if((unSign(HEAP[Eb+32*lb+4],16)&4)==0){f=75;break e}var ic=fc+32&-64,jc=bc+32&-64;f=77}while(0);Lb=f==77?ic:f==75?fc:f==73?ac:hc;f=f==77?jc:f==75?bc:f==73?ec:$b;Lb!=0|f!=0&&_translate_array(Rb-wb,Nb+8*wb,Lb,f)}while(0);var Eb=Hb+1,cc=c+1;f=67;c=55}if(c==82){HEAP[eb]=db;HEAP[Ua]=ub;HEAP[Ka]=yb;
HEAP[La]=rb;HEAP[Ba]=zb;HEAP[ta]=Fb;HEAP[sa]=Ib;HEAP[ha]=qb;la=xb;ga=Jb;HEAP[e+24]=s;HEAP[e+28]=u;HEAP[e+168]=G;if((HEAP[e+16]&2)!=0)break a;if((unSign(HEAP[la+4],16)&256)==0)break a;o=F;if(!(unSign(ga,32)>unSign(o,32)))break a;n=F;h=E;o=e;n=n;h=h;k=HEAP[o+12]+20;j=HEAP[k+2]==-4;c:do if(j)c=86;else{j=reSign(HEAP[HEAP[o+12]+20+2],16);m=reSign(HEAP[HEAP[o+12]+56+2],16);Z=reSign(HEAP[k+2],16);t=HEAP[HEAP[o+12]+4];if(unSign(j+4+m+Z,32)<=unSign(t,32)){c=86;break c}j=reSign(HEAP[k+2],16)+4;j=_FT_GlyphLoader_CheckPoints(HEAP[o+
12],j,0);HEAP[i]=j;if(j==0){c=90;break c}break a}while(0);if(c==86)HEAP[i]=0;j=HEAP[k+4];m=reSign(HEAP[k+2],16);Z=o+68;HEAP[q]=HEAP[Z];HEAP[q+4]=HEAP[Z+4];j=j+8*m;HEAP[j]=HEAP[q];HEAP[j+4]=HEAP[q+4];j=HEAP[k+4];m=reSign(HEAP[k+2],16)+1;Z=o+76;HEAP[r]=HEAP[Z];HEAP[r+4]=HEAP[Z+4];j=j+8*m;HEAP[j]=HEAP[r];HEAP[j+4]=HEAP[r+4];j=HEAP[k+4];m=reSign(HEAP[k+2],16)+2;Z=o+184;HEAP[p]=HEAP[Z];HEAP[p+4]=HEAP[Z+4];j=j+8*m;HEAP[j]=HEAP[p];HEAP[j+4]=HEAP[p+4];j=HEAP[k+4];m=reSign(HEAP[k+2],16)+3;Z=o+192;HEAP[a]=
HEAP[Z];HEAP[a+4]=HEAP[Z+4];j=j+8*m;HEAP[j]=HEAP[a];HEAP[j+4]=HEAP[a+4];j=HEAP[k+8];m=reSign(HEAP[k+2],16);HEAP[j+m]=0;j=HEAP[k+8];m=reSign(HEAP[k+2],16)+1;HEAP[j+m]=0;j=HEAP[k+8];m=reSign(HEAP[k+2],16)+2;HEAP[j+m]=0;j=HEAP[k+8];k=reSign(HEAP[k+2],16)+3;HEAP[j+k]=0;j=HEAP[o+24];k=_FT_Stream_Seek(j,HEAP[o+168]);HEAP[i]=k;k=k!=0;c:do if(!k){k=_FT_Stream_ReadShort(j,i);if(HEAP[i]!=0)break c;m=m=HEAP[HEAP[o]+260+26];m=unSign(k,16)>unSign(m,16);Z=k;d:do{if(m){m=unSign(Z,16);Z=HEAP[o+28];if(!(reSign(m,
32)>reSign(Z,32))){HEAP[l]=HEAP[HEAP[o+160]+388];m=unSign(k,16);m=_Update_Max(HEAP[HEAP[o+160]+8],l,1,HEAP[o+160]+392,m);HEAP[i]=m;m=HEAP[o+160];l=unSign(HEAP[l]&65535,16);HEAP[m+388]=l;if(HEAP[i]==0)break d}}else if(Z!=0)break d;break a}while(0);m=unSign(k,16);l=HEAP[HEAP[o+160]+392];j=j;l=l;m=m;j=_FT_Stream_ReadAt(j,HEAP[j+8],l,m);HEAP[i]=j;if(j==0){HEAP[HEAP[o+8]+136]=HEAP[HEAP[o+160]+392];i=HEAP[o+8];k=unSign(k,16);HEAP[i+140]=k;i=HEAP[o+12]+20;k=n;j=h;h=o+124;i=i;k=k;j=j;HEAP[h+8]=HEAP[i+2]-
(k&65535);HEAP[h+10]=HEAP[i]-(j&65535);HEAP[h+12]=HEAP[i+20]+8*k;HEAP[h+16]=HEAP[i+4]+8*k;HEAP[h+20]=HEAP[i+24]+8*k;HEAP[h+24]=HEAP[i+8]+k;HEAP[h+28]=HEAP[i+12]+2*j;HEAP[h+32]=k&65535;h=n;n=unSign(HEAP[o+124+8],16);i=h;i=unSign(n,32)>unSign(i,32);n=o+124;if(i){h=h;i=h+1;for(f=96;;){z=f==96?0:z;j=h+z;k=i+z;HEAP[HEAP[(f==96?n:v)+24]+j]=HEAP[HEAP[o+124+24]+j]&-25;v=unSign(HEAP[o+124+8],16);k=unSign(v,32)>unSign(k,32);v=o+124;z=z+1;if(k)f=97;else break}f=98}else f=154;HEAP[o+124+8]=HEAP[(f==98?v:n)+8]+
4;_TT_Hint_Glyph(o,1)}break a}while(0);break a}else if(c==56){HEAP[eb]=db;HEAP[Ua]=ub;HEAP[Ka]=yb;HEAP[La]=rb;HEAP[Ba]=ib;HEAP[ta]=tb;HEAP[sa]=vb;HEAP[ha]=Gb;break a}}}else{C=20;break a}}while(0);HEAP[e+36]=0;HEAP[e+36+8]=0;HEAP[e+36+4]=0;HEAP[e+36+12]=0;if(b!=0)break a;HEAP[e+68]=HEAP[e+36]-HEAP[e+52];HEAP[e+68+4]=0;HEAP[e+76]=HEAP[e+56]+HEAP[e+68];HEAP[e+76+4]=0;HEAP[e+184]=0;HEAP[e+184+4]=HEAP[e+36+12]+HEAP[e+176];HEAP[e+192]=0;HEAP[e+192+4]=HEAP[e+184+4]-HEAP[e+180];_tt_get_metrics_incr_overrides(e,
g);if(HEAP[HEAP[e]+708]!=0){E=HEAP[HEAP[e]+100];C=_TT_Vary_Get_Glyph_Deltas(HEAP[e],g,ba,4);if(C!=0)break a;HEAP[e+68]=HEAP[HEAP[ba]]+HEAP[e+68];HEAP[e+68+4]=HEAP[HEAP[ba]+4]+HEAP[e+68+4];HEAP[e+76]=HEAP[HEAP[ba]+8]+HEAP[e+76];HEAP[e+76+4]=HEAP[HEAP[ba]+8+4]+HEAP[e+76+4];HEAP[e+184]=HEAP[HEAP[ba]+16]+HEAP[e+184];HEAP[e+184+4]=HEAP[HEAP[ba]+16+4]+HEAP[e+184+4];HEAP[e+192]=HEAP[HEAP[ba]+24]+HEAP[e+192];HEAP[e+192+4]=HEAP[HEAP[ba]+24+4]+HEAP[e+192+4];F=HEAP[ba];C=E;E=F;E!=0&&FUNCTION_TABLE[HEAP[C+8]](C,
E);HEAP[ba]=0}if((HEAP[e+16]&1)==0){C=_FT_MulFix(HEAP[e+68],X);HEAP[e+68]=C;C=_FT_MulFix(HEAP[e+76],X);HEAP[e+76]=C;C=_FT_MulFix(HEAP[e+184+4],Y);HEAP[e+184+4]=C;C=_FT_MulFix(HEAP[e+192+4],Y);HEAP[e+192+4]=C}C=0}}while(0);da!=0&&FUNCTION_TABLE[HEAP[W+516]](e);$!=0&&FUNCTION_TABLE[HEAP[HEAP[HEAP[HEAP[W+128]+52]]+4]](HEAP[HEAP[HEAP[W+128]+52]+4],ca);e=C;STACKTOP=a;return e}_load_truetype_glyph.__index__=Runtime.getFunctionIndex(_load_truetype_glyph,"_load_truetype_glyph");
function _tt_loader_init(e,g,d,b,a){var c=STACKTOP;STACKTOP+=8;Runtime.memset(c,0,8);var f,h=null,i,k,j,l,m,o,n,p,r,q=c+4,s,u,t,v,w,x,y,A,z,C,B;b=b;y=HEAP[d+4];A=HEAP[y+104];_llvm_memset_p0i8_i32(e,0,208,1,0);w=(b&2)==0;a:do if(w){if(a!=0){f=1;break a}w=HEAP[g+301]==0;b:do if(w){w=g;r=0;s=HEAP[w+300]==0;c:do if(s){s=r=w;u=HEAP[r];t=HEAP[u+100];v=u+260;HEAP[s+300]=1;HEAP[s+301]=0;h=unSign(HEAP[v+20],16);HEAP[s+120]=h;h=unSign(HEAP[v+22],16);HEAP[s+132]=h;HEAP[s+116]=0;HEAP[s+128]=0;HEAP[s+140]=0;HEAP[s+
144]=0;HEAP[s+240]=HEAP[u+668];HEAP[s+248]=HEAP[v+18];h=s+72;HEAP[h+37]=0;HEAP[h+38]=0;f=h;h=2;d:for(;;){h=h==2?0:D;HEAP[f+20+(0+h)*4]=0;var D=h+1;if(D!=4)h=3;else break d}h=_ft_mem_realloc(t,16,0,HEAP[s+120],0,q);HEAP[s+124]=h;D=HEAP[q]!=0;d:do if(!D){h=_ft_mem_realloc(t,16,0,HEAP[s+132],0,q);HEAP[s+136]=h;if(HEAP[q]!=0)break d;h=_ft_mem_realloc(t,4,0,HEAP[s+240],0,q);HEAP[s+244]=h;if(HEAP[q]!=0)break d;h=unSign(HEAP[s+248],16);h=_ft_mem_realloc(t,4,0,h,0,q);HEAP[s+252]=h;if(HEAP[q]!=0)break d;h=
HEAP[v+16];h+=4;f=s+256;n=unSign(h,16)&65535;o=t;n=n;p=f;_llvm_memset_p0i8_i32(p,0,36,1,0);HEAP[p]=o;f=unSign(n,16);f=_ft_mem_realloc(o,8,0,f,0,c);HEAP[p+12]=f;var E=HEAP[c]!=0;e:do if(E)f=9;else{f=unSign(n,16);f=_ft_mem_realloc(o,8,0,f,0,c);HEAP[p+16]=f;if(HEAP[c]!=0){f=9;break e}f=unSign(n,16);f=_ft_mem_realloc(o,8,0,f,0,c);HEAP[p+20]=f;if(HEAP[c]!=0){f=9;break e}f=unSign(n,16);f=_ft_mem_realloc(o,1,0,f,0,c);HEAP[p+24]=f;if(HEAP[c]!=0){f=9;break e}f=reSign(0,16);f=_ft_mem_realloc(o,2,0,f,0,c);HEAP[p+
28]=f;if(HEAP[c]!=0){f=9;break e}HEAP[p+4]=n;HEAP[p+6]=0;f=15;break e}while(0);f==9&&_tt_glyphzone_done(p);f=HEAP[c];HEAP[q]=f;if(f!=0)break d;HEAP[s+256+8]=h;_llvm_memcpy_p0i8_p0i8_i32(s+172,_tt_default_graphics_state,68,4,0);h=HEAP[HEAP[u+96]+4];HEAP[u+688]=HEAP[h+180];if(HEAP[u+688]==0)HEAP[u+688]=_TT_RunIns.__index__;o=s;n=HEAP[o];if(HEAP[o+292]!=0){f=j=HEAP[o+296];h=18}else{f=m=HEAP[HEAP[n+96]+40];h=20}if((h==20?m:j)==0)HEAP[q]=153;else{_TT_Load_Context(f,n,o);HEAP[f+428]=0;HEAP[f+16]=0;HEAP[f+
476]=64;HEAP[f+480]=0;HEAP[f+484]=0;HEAP[f+488]=0;HEAP[f+564]=65536;h=f+216;j=f+244;HEAP[h]=0;HEAP[h+2]=0;HEAP[h+4]=0;HEAP[h+8]=0;HEAP[j+8]=0;HEAP[j+16]=0;HEAP[j+12]=65536;m=HEAP[n+652];j=HEAP[n+656];h=f;j=j;m=m;HEAP[h+444+0]=j;HEAP[h+444+0+4]=m;h=f;HEAP[h+444+8]=0;HEAP[h+444+8+4]=0;h=f;HEAP[h+444+16]=0;HEAP[h+444+16+4]=0;h=HEAP[n+652]!=0;e:do if(h){h=f;j=h+444+0;HEAP[h+356]=HEAP[j];HEAP[h+364]=HEAP[j+4];HEAP[h+360]=0;HEAP[h+352]=1;m=j=0;if(m==0){j=l=FUNCTION_TABLE[HEAP[n+688]](f);if(l==0)break e;
else h=23}else h=63;HEAP[q]=h==63?m:l;break d}else j=0;while(0);h=o;l=f;h=h;HEAP[h+116]=HEAP[l+396];HEAP[h+128]=HEAP[l+408];HEAP[h+140]=HEAP[l+420];HEAP[h+144]=HEAP[l+424];l=l;m=h;for(h=24;;){F=h==24?0:F;h=0+F;s=m+148+h*8+4;u=HEAP[l+444+h*8+4];HEAP[m+148+h*8]=HEAP[l+444+h*8];HEAP[s]=u;var F=F+1;if(F!=3)h=26;else{h=26;break}}F=j;HEAP[q]=F;if(F!=0)break d;r=F;f=29;break c}}while(0);_tt_size_done_bytecode(r);r=C=HEAP[q];if(C!=0){h=5;f=30}else{h=5;f=29}break c}else f=29;while(0);c:do if(f==29){if(HEAP[w+
301]==0){q=HEAP[w];r=x=0;if(unSign(HEAP[w+240],32)>unSign(r,32)){q=q+672;x=x;r=x+1;for(h=31;;){G=h==31?0:G;F=x+G;l=r+G;h=HEAP[w+244];j=HEAP[w+72+16];m=reSign(HEAP[HEAP[q]+2*F],16);j=_FT_MulFix(m,j);HEAP[h+4*F]=j;F=unSign(HEAP[w+240],32)>unSign(l,32);var G=G+1;if(F)h=32;else break}}x=0;G=unSign(HEAP[w+256+8],16);q=x;if(unSign(G,32)>unSign(q,32)){G=w+256+12;q=w+256+12;r=w+256+16;F=w+256+16;l=w+256+8;x=x;j=x+1;for(h=35;;){H=h==35?0:H;m=x+H;h=j+H;HEAP[HEAP[G]+8*m]=0;HEAP[HEAP[q]+8*m+4]=0;HEAP[HEAP[r]+
8*m]=0;HEAP[HEAP[F]+8*m+4]=0;m=unSign(HEAP[l],16);h=unSign(m,32)>unSign(h,32);var H=H+1;if(h)h=36;else break}}x=0;H=unSign(HEAP[w+248],16);G=x;G=unSign(H,32)>unSign(G,32);H=w;if(G){G=w+248;var J=w;x=x;q=x+1;for(h=39;;){L=h==39?0:L;r=q+L;HEAP[HEAP[(h==39?H:J)+252]+4*(x+L)]=0;F=unSign(HEAP[G],16);r=unSign(F,32)>unSign(r,32);var L=L+1;if(r)h=40;else break}h=41}else h=76;_llvm_memcpy_p0i8_p0i8_i32((h==41?J:H)+172,_tt_default_graphics_state,68,4,0);r=x=_tt_size_run_prep(w);if(x==0)h=43;else{h=43;f=30;
break c}HEAP[w+301]=1}z=J=r;if(J!=0){f=47;break c}else break b}while(0);if(f==30)z=h==5?C:x;k=z;f=49;break a}while(0);if(HEAP[g+292]!=0){var N=HEAP[g+296];h=50}else{var I=HEAP[HEAP[y+96]+40];h=52}z=C=h==52?I:N;if(C==0){k=153;f=49}else{C=(reSign(b,32)>>reSign(16,32)&15)!=2;C=unSign(C,1);_TT_Load_Context(z,y,g);if(HEAP[z+604]!=C){HEAP[z+604]=C;N=unSign(HEAP[g+240],32)>unSign(0,32);C=g;if(N){N=g+72+16;I=y+672;J=g+240;B=g;for(h=53;;){i=h==53?0:i;w=1+i;L=0+i;H=HEAP[(h==53?C:B)+244];G=HEAP[N];x=reSign(HEAP[HEAP[I]+
2*L],16);G=_FT_MulFix(x,G);HEAP[H+4*L]=G;w=unSign(HEAP[J],32)>unSign(w,32);i=i+1;if(w)h=54;else break}h=55}else h=80;_tt_size_run_prep(h==55?B:C)}if((unSign(HEAP[z+284+52],8)&1&255)!=0)b|=2;(unSign(HEAP[z+284+52],8)&2)!=0&&_llvm_memcpy_p0i8_p0i8_i32(z+284,_tt_default_graphics_state,68,4,0);HEAP[z+561]=b&255&-128;HEAP[e+160]=z;HEAP[e+164]=HEAP[z+392];f=1}break a}else f=1;while(0);a:do if(f==1){if(HEAP[HEAP[y+128]+52]!=0)HEAP[e+84]=0;else{k=FUNCTION_TABLE[HEAP[y+508]](y,1735162214,A,0);if(k==142)HEAP[e+
84]=0;else if(k!=0){k=k;break a}else{k=A;k=k=HEAP[k+8];HEAP[e+84]=k}}if(a==0){i=B=HEAP[HEAP[d+156]];k=i+20;i=i+56;HEAP[k+2]=0;HEAP[k]=0;HEAP[k+28]=0;_llvm_memcpy_p0i8_p0i8_i32(i,k,36,4,0);HEAP[e+12]=B}HEAP[e+16]=b;HEAP[e]=y;HEAP[e+4]=g;HEAP[e+8]=d;HEAP[e+24]=A;k=0}while(0);e=k;STACKTOP=c;return e}_tt_loader_init.__index__=Runtime.getFunctionIndex(_tt_loader_init,"_tt_loader_init");
function _tt_glyphzone_done(e){var g,d;d=HEAP[e];if(d!=0){g=HEAP[e+28];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+28]=0;g=HEAP[e+24];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+24]=0;g=HEAP[e+16];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+16]=0;g=HEAP[e+12];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+12]=0;g=HEAP[e+20];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+20]=0;HEAP[e+8]=0;HEAP[e+4]=HEAP[e+8];HEAP[e+10]=0;HEAP[e+6]=0;HEAP[e]=0}}
_tt_glyphzone_done.__index__=Runtime.getFunctionIndex(_tt_glyphzone_done,"_tt_glyphzone_done");
function _tt_face_init(e,g,d,b,a){var c=STACKTOP;STACKTOP+=40;Runtime.memset(c,0,40);var f,h=null,i,k,j,l,m=c+4,o,n,p,r=c+8,q,s,u,t,v=c+12,w;i=c+16;n=c+20;var x,y,A;h=_FT_Get_Module(HEAP[HEAP[g+96]+4],__str537);h=h!=0?HEAP[HEAP[h]+20]:0;var z=h==0;a:do if(z)f=6;else{A=_FT_Stream_Seek(e,0);if(A!=0){f=1;break a}A=FUNCTION_TABLE[HEAP[h+4]](e,g,d,b,a);if(A!=0){f=1;break a}z=HEAP[g+148]!=65536;b:do if(z){if(HEAP[g+148]==131072){f=5;break b}if(HEAP[g+148]!=1953658213){f=6;break a}}while(0);HEAP[g+8]|=2048;
if(reSign(d,32)<reSign(0,32)){y=0;f=8}else{A=FUNCTION_TABLE[HEAP[h+8]](e,g,d,b,a);if(A!=0){f=1;break a}h=g;if(h==0)h=0;else{A=h;if(HEAP[h+20]!=0){q=h=HEAP[A+20];for(h=11;;){f=h==14?C:0;n=_trick_names_6890+(0+f)*17;w=1+f;if(!(reSign(h==14?w:0,32)<=reSign(7,32))){f=17;break}if(_strstr(q,n)!=0){f=13;break}var C=f+1;h=14;f=12}if(f==17)x=0;else if(f==13)x=1;h=x;h=(h&255)!=0?1:0}else{h=A;_llvm_memset_p0i8_i32(n,0,20,1,0);x=h+152;A=h+156;C=h+156;d=h;b=d+156;a=d+156;z=d+508;var B=d+508,D=d+104,E=d+156,F=
d+156,G=d+104;h=18;b:for(;;){Z=h==57?Z:0;var H=0+Z,J=H&65535;h=unSign(HEAP[x],16);if(!(reSign(h,32)>reSign(H,32))){f=59;break b}h=HEAP[HEAP[A]+16*H];if(h==1668707360){h=58;f=21}else if(h==1718642541){h=58;f=20}else if(h==1886545264){h=58;f=22}else{h=58;f=57}c:do if(f==20){h=20;f=21;break c}else if(f==22){h=22;f=21;break c}while(0);c:do if(f==21){var L=h==22?2:h==20?1:0;h=unSign(J,16)&65535;var N=unSign(h,16),I=unSign(h,16),P=unSign(h,16),K=unSign(h,16);h=21;for(;;){f=h==55?ga:0;var O=h==55?ea:0;h=
_sfnt_id_6968+O*24+L*8+4;var M=_sfnt_id_6968+O*24+L*8,Q=n+O*4;if(!(reSign(O,32)<=reSign(4,32)))break c;if(HEAP[HEAP[C]+16*H+12]==HEAP[h]){var R=f==0;e:do if(R)if(HEAP[HEAP[b]+16*N+4]!=0){w=HEAP[HEAP[a]+16*I+4];h=24}else{if(HEAP[z]==0){h=26;break e}if(FUNCTION_TABLE[HEAP[B]](d,HEAP[HEAP[E]+16*P],HEAP[D],0)==0){h=28;break e}ea=HEAP[HEAP[F]+16*K+12];ga=HEAP[G];if(_FT_Stream_EnterFrame(ga,ea)!=0){h=29;break e}if(unSign(ea,32)>unSign(3,32)){var T=ga+32,V=ga+36,U=ga+32,S=ea+-4;for(h=31;;){aa=h==31?0:aa;
ba=h==31?0:ba;u=S+aa*-4;var X=HEAP[T];if(X+3<HEAP[V]){t=X+4;h=reSign(HEAP[t+-4],8)<<24;var Y=unSign(HEAP[t+-4+1],8)<<16,W=unSign(HEAP[t+-4+2],8)<<8,da=unSign(HEAP[t+-4+3],8);Y=Y|h|W|da;h=33}else h=32;W=h==32?0:Y;HEAP[U]=h==32?X:t;var ba=W+ba;h=unSign(u,32)>unSign(3,32);var aa=aa+1;if(h)h=35;else break}h=36}else h=30;T=h==36?ba:0;ea=h==36?u:ea;if(ea!=0){V=ga+32;U=ga+36;S=ga+32;X=ga+32;for(h=38;;){la=h==42?la:0;$=h==42?$:T;W=la*-8+24;if(HEAP[V]<HEAP[U]){h=HEAP[S];var ca=HEAP[h];HEAP[X]=h+1;h=40}else h=
39;h=reSign(h==39?0:ca,8)&255;var $=(unSign(h,8)<<W)+$,la=la+1;if(la!=ea)h=42;else break}h=43}else h=125;T=h==43?$:T;if(HEAP[ga+20]!=0){h=HEAP[ga+28];ea=HEAP[ga];ea!=0&&FUNCTION_TABLE[HEAP[h+8]](h,ea);HEAP[ga]=0}HEAP[ga+32]=0;HEAP[ga+36]=0;h=48}else h=113;while(0);R=h==113?f:h==24?w:h==26?0:h==28?0:h==48?T:0;ga=HEAP[Q];if(HEAP[M]==R){s=ga+1;HEAP[Q]=s;h=49}else h=27;if((h==49?s:ga)==3){f=52;break b}else h=51}else h=56;var ga=h==51?R:f,ea=O+1;h=55;f=23}}while(0);var Z=Z+1;h=57;f=19}if(f==59)q=0;else if(f==
52)q=1;h=q;h=(h&255)!=0?1:0}}h=h;if((h&255)!=0)HEAP[g+8]|=8192;h=e;q=g;n=h;w=HEAP[n+28];h=FUNCTION_TABLE[HEAP[q+508]](q,1751412088,n,i);HEAP[v]=h;h=h!=0;f=unSign(HEAP[i],32)<=unSign(7,32);h=h|f;b:do if(h)A=0;else{u=q+740;h=HEAP[i];f=n;h=h;u=u;ca=t=_FT_Stream_EnterFrame(f,h);s=ca==0;c:do if(s){HEAP[u]=HEAP[f+32];HEAP[f+32]=0;HEAP[f+36]=0;o=t;HEAP[v]=o;if(o!=0){h=64;break c}h=HEAP[q+740];u=h+HEAP[i];h+=2;o=unSign(HEAP[h+-2],8)<<8&65535;f=unSign(HEAP[h+-2+1],8);f=unSign(o|f,16);h+=2;o=unSign(HEAP[h+
-2],8)<<8&65535;t=unSign(HEAP[h+-2+1],8);t=unSign(o|t,16);h+=4;o=unSign(HEAP[h+-4],8)<<24;ca=unSign(HEAP[h+-4+1],8)<<16;s=unSign(HEAP[h+-4+2],8)<<8;Y=unSign(HEAP[h+-4+3],8);o=ca|o|s|Y;if(unSign(o,32)>unSign(-65537,32))o&=65535;ca=f!=0;d:do if(ca)f=68;else{if(unSign(t,32)>unSign(255,32)){f=68;break d}if(unSign(o,32)>unSign(65537,32)){f=68;break d}f=_ft_mem_realloc(w,1,0,t,0,v);HEAP[q+756]=f;if(HEAP[v]!=0){f=71;break d}s=0;f=t;w=o;u=u;t=q+756;ca=o;s=s;Y=h;h=Y+(0*ca+w);$=0+s;la=unSign($,32)<unSign(f,
32)^1|h>u;e:do if(la)h=72;else{ba=ca+w;aa=s+1;for(h=73;;){k=h==73?0:k;x=ca*k;h=Y+(ba+x);j=aa+k;HEAP[HEAP[t]+(s+k)]=HEAP[Y+x];k=k+1;if(unSign(j,32)<unSign(f,32)^1|h>u){h=74;break e}else h=74}}while(0);s=h==72?$:j;HEAP[q+748]=s;HEAP[q+744]=HEAP[i];HEAP[q+752]=o;f=76;break d}while(0);d:do if(f==68){HEAP[v]=3;f=71;break d}while(0);if(f==71){j=q+740;i=k=n;j=j;k=k!=0;d:do if(k){if(HEAP[i+20]==0)break d;o=HEAP[i+28];h=HEAP[j];o=o;h=h;h!=0&&FUNCTION_TABLE[HEAP[o+8]](o,h);HEAP[j]=0}while(0);HEAP[j]=0;HEAP[q+
744]=0}A=v=HEAP[v];if(v!=0){f=1;break a}else break b}else{HEAP[v]=ca;h=62}while(0);A=h==62?ca:o;f=1;break a}while(0);v=(HEAP[g+8]&1&255)!=0;b:do if(v){if(HEAP[HEAP[g+128]+52]==0){i=e;p=g;i=i;j=FUNCTION_TABLE[HEAP[p+508]](p,1735162214,i,p+704);k=j==142;c:do{if(k){HEAP[p+704]=0;f=83}else f=j!=0?84:83;break c}while(0);c:do if(f==83)if(FUNCTION_TABLE[HEAP[p+508]](p,1819239265,i,r)!=0)j=144;else{if(HEAP[p+160+50]!=0){j=2;if(unSign(HEAP[r],32)>unSign(262143,32)){j=8;break c}else{k=j;k=unSign(HEAP[r],32)>>>
unSign(k,32);HEAP[p+732]=k}}else{j=1;if(unSign(HEAP[r],32)>unSign(131071,32)){j=8;break c}else{k=j;k=unSign(HEAP[r],32)>>>unSign(k,32);HEAP[p+732]=k}}k=HEAP[p+732]!=HEAP[p+16];d:do if(k){o=HEAP[p+16];if(!(unSign(HEAP[p+732],32)<unSign(o,32))){f=88;break d}o=HEAP[p+16]<<j;h=HEAP[p+156];q=unSign(HEAP[p+152],16);q=h+16*q;n=i;n=n=n=HEAP[n+8];s=2147483647;w=h;if(h<q){u=n;t=q;ca=h;s=s;for(h=89;;){ja=h==89?0:ja;ia=h==89?s:ia;var ha=ca+16*(ja+1);h=HEAP[(h==89?w:ha)+8]-u;f=reSign(h,32)>reSign(0,32);Y=reSign(h,
32)<reSign(ia,32);var ia=f&Y?h:ia,ja=ja+1;if(ha<t)f=h=90;else{f=91;break}}s=ia;h=91}else h=87;if((h==91?ha:w)==q)s=HEAP[i+4]-n;h=s;if(!(reSign(o,32)<=reSign(h,32))){f=88;break d}HEAP[p+732]=HEAP[p+16];HEAP[r]=o}while(0);k=p+736;o=HEAP[r];j=i;o=o;k=k;o=h=_FT_Stream_EnterFrame(j,o);if(h==0){HEAP[k]=HEAP[j+32];HEAP[j+32]=0;HEAP[j+36]=0}j=j=j=o}while(0);A=p=p=p=j;h=84}else{var fa=A;h=98}if((h==98?fa:p)==0){var ka=_tt_face_load_cvt(g,e);A=ka;h=99}else{var na=A;h=101}if((h==101?na:ka)==0){l=e;i=g;l=l;j=
FUNCTION_TABLE[HEAP[i+508]](i,1718642541,l,m);if(j!=0){HEAP[i+656]=0;j=HEAP[i+652]=0}else{HEAP[i+652]=HEAP[m];i=i+656;j=HEAP[m];l=l;j=j;i=i;j=_FT_Stream_EnterFrame(l,j);if(j==0){HEAP[i]=HEAP[l+32];HEAP[l+32]=0;HEAP[l+36]=0}j=l=l=j}A=l=l=l=j;h=104}else{var sa=A;h=106}if((h==106?sa:l)!=0)break b;i=e;j=g;i=i;k=FUNCTION_TABLE[HEAP[j+508]](j,1886545264,i,c);if(k!=0){HEAP[j+664]=0;k=HEAP[j+660]=0}else{HEAP[j+660]=HEAP[c];j=j+664;k=HEAP[c];i=i;k=k;j=j;k=_FT_Stream_EnterFrame(i,k);if(k==0){HEAP[j]=HEAP[i+
32];HEAP[i+32]=0;HEAP[i+36]=0}k=i=i=k}A=i=i=k}while(0);e=g;HEAP[e+512]=_TT_Access_Glyph_Frame.__index__;HEAP[e+520]=_TT_Load_Glyph_Header.__index__;HEAP[e+524]=_TT_Load_Simple_Glyph.__index__;HEAP[e+528]=_TT_Load_Composite_Glyph.__index__;HEAP[e+516]=_TT_Forget_Glyph_Frame.__index__;f=1}break a}while(0);a:do if(f==6){A=2;f=1;break a}while(0);if(f==1)y=A;y=y;STACKTOP=c;return y}_tt_face_init.__index__=Runtime.getFunctionIndex(_tt_face_init,"_tt_face_init");
function _tt_face_done(e){var g=null,d,b,a,c,f,h,i;if(e!=0){h=HEAP[e+100];i=HEAP[e+104];c=HEAP[e+532];HEAP[e+692+4]!=0&&FUNCTION_TABLE[HEAP[e+692+4]](HEAP[e+692]);c!=0&&FUNCTION_TABLE[HEAP[c+12]](e);d=HEAP[e+104];c=e+736;b=d!=0;a:do if(b){if(HEAP[d+20]==0)break a;a=HEAP[d+28];f=HEAP[c];a=a;f=f;f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,f);HEAP[c]=0}while(0);HEAP[c]=0;HEAP[e+732]=0;c=HEAP[e+104];d=HEAP[c+28];b=HEAP[e+756];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[e+756]=0;d=e+740;b=c!=0;a:do if(b){if(HEAP[c+
20]==0)break a;a=HEAP[c+28];f=HEAP[d];a=a;f=f;f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,f);HEAP[d]=0}while(0);HEAP[d]=0;c=HEAP[e+672];c!=0&&FUNCTION_TABLE[HEAP[h+8]](h,c);HEAP[e+672]=0;HEAP[e+668]=0;c=e+656;d=i!=0;a:do if(d){if(HEAP[i+20]==0)break a;b=HEAP[i+28];a=HEAP[c];b=b;a=a;a!=0&&FUNCTION_TABLE[HEAP[b+8]](b,a);HEAP[c]=0}while(0);HEAP[c]=0;c=e+664;d=i!=0;a:do if(d){if(HEAP[i+20]==0)break a;b=HEAP[i+28];a=HEAP[c];b=b;a=a;a!=0&&FUNCTION_TABLE[HEAP[b+8]](b,a);HEAP[c]=0}while(0);HEAP[c]=0;HEAP[e+652]=0;
HEAP[e+660]=0;i=HEAP[e+712];c=i!=0;a:do if(c){b=HEAP[i+4];d=h;b=b;b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[i+4]=0;a=HEAP[i+8];d=h;b=a;a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[i+8]=0;if(HEAP[i+20]!=0){b=unSign(HEAP[i],32)>unSign(0,32);d=HEAP[i+20];if(b){b=h;a=i+20;f=i;var k=i+20,j=b+8;for(g=22;;){n=g==22?0:n;var l=1+n,m=0+n;o=HEAP[(g==22?d:o)+8*m+4];o!=0&&FUNCTION_TABLE[HEAP[j]](b,o);HEAP[HEAP[a]+8*m+4]=0;g=unSign(HEAP[f],32)>unSign(l,32);var o=HEAP[k],n=n+1;if(g)g=25;else break}g=26}else g=62;a=
g==26?o:d;d=h;b=a;a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[i+20]=0}a=HEAP[i+28];d=h;b=a;a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[i+28]=0;a=HEAP[i+36];d=h;b=a;a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[i+36]=0;a=i;d=h;b=a;if(a==0)break a;FUNCTION_TABLE[HEAP[d+8]](d,b)}while(0);HEAP[e+712]=0}}_tt_face_done.__index__=Runtime.getFunctionIndex(_tt_face_done,"_tt_face_done");
function _tt_size_run_prep(e){var g=null,d,b,a,c;a=HEAP[e];if(HEAP[e+292]!=0){c=d=HEAP[e+296];g=0}else{c=b=HEAP[HEAP[a+96]+40];g=2}if((g==2?b:d)==0)e=153;else{_TT_Load_Context(c,a,e);HEAP[c+428]=0;HEAP[c+16]=0;HEAP[c+488]=0;g=HEAP[a+660];b=HEAP[a+664];d=c;HEAP[d+444+8]=b;HEAP[d+444+8+4]=g;d=c;HEAP[d+444+16]=0;HEAP[d+444+16+4]=0;g=HEAP[a+660]!=0;a:do if(g){d=c;b=d+444+8;HEAP[d+356]=HEAP[b];HEAP[d+364]=HEAP[b+4];HEAP[d+360]=0;HEAP[d+352]=2;d=0;if(d!=0)break a;if(HEAP[e+292]!=0)break a;d=FUNCTION_TABLE[HEAP[a+
688]](c)}else d=0;while(0);_llvm_memcpy_p0i8_p0i8_i32(e+172,c+284,68,4,0);a=c;HEAP[e+116]=HEAP[a+396];HEAP[e+128]=HEAP[a+408];HEAP[e+140]=HEAP[a+420];HEAP[e+144]=HEAP[a+424];for(g=5;;){f=g==5?0:f;c=0+f;g=e+148+c*8+4;b=HEAP[a+444+c*8+4];HEAP[e+148+c*8]=HEAP[a+444+c*8];HEAP[g]=b;var f=f+1;if(f!=3)g=8;else break}e=d}return e}_tt_size_run_prep.__index__=Runtime.getFunctionIndex(_tt_size_run_prep,"_tt_size_run_prep");
function _tt_size_done_bytecode(e){var g;g=HEAP[HEAP[e]+100];if(HEAP[e+292]!=0){HEAP[e+296]=0;HEAP[e+292]=0}var d=HEAP[e+244];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+244]=0;HEAP[e+240]=0;d=HEAP[e+252];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+252]=0;HEAP[e+248]=0;_tt_glyphzone_done(e+256);d=HEAP[e+124];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+124]=0;d=HEAP[e+136];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+136]=0;HEAP[e+116]=0;HEAP[e+120]=0;HEAP[e+128]=0;HEAP[e+132]=0;HEAP[e+140]=0;HEAP[e+
144]=0;HEAP[e+300]=0;HEAP[e+301]=0}_tt_size_done_bytecode.__index__=Runtime.getFunctionIndex(_tt_size_done_bytecode,"_tt_size_done_bytecode");function _tt_size_init(e){HEAP[e+300]=0;HEAP[e+301]=0;HEAP[e+72+36]=0;HEAP[e+112]=-1;return 0}_tt_size_init.__index__=Runtime.getFunctionIndex(_tt_size_init,"_tt_size_init");function _tt_size_done(e){HEAP[e+300]!=0&&_tt_size_done_bytecode(e);HEAP[e+72+36]=0}_tt_size_done.__index__=Runtime.getFunctionIndex(_tt_size_done,"_tt_size_done");
function _tt_size_reset(e){var g,d,b,a;HEAP[e+72+36]=0;b=HEAP[e];a=e+44;g=e+12;HEAP[a]=HEAP[g];HEAP[a+2]=HEAP[g+2];HEAP[a+4]=HEAP[g+4];HEAP[a+8]=HEAP[g+8];HEAP[a+12]=HEAP[g+12];HEAP[a+16]=HEAP[g+16];HEAP[a+20]=HEAP[g+20];HEAP[a+24]=HEAP[g+24];var c=HEAP[a]==0;a:do if(c)g=0;else{if(HEAP[a+2]==0){g=0;break a}if((unSign(HEAP[b+160+16],16)&8)!=0){d=unSign(HEAP[b+68],16);g=unSign(HEAP[a],16)<<6;d=_FT_DivFix(g,d);HEAP[a+4]=d;d=unSign(HEAP[b+68],16);g=unSign(HEAP[a+2],16)<<6;d=_FT_DivFix(g,d);HEAP[a+8]=
d;d=HEAP[a+8];g=reSign(HEAP[b+70],16);d=_FT_MulFix(g,d)+32&-64;HEAP[a+12]=d;d=HEAP[a+8];g=reSign(HEAP[b+72],16);d=_FT_MulFix(g,d)+32&-64;HEAP[a+16]=d;d=HEAP[a+8];g=reSign(HEAP[b+74],16);d=_FT_MulFix(g,d)+32&-64;HEAP[a+20]=d;d=HEAP[a+4];b=reSign(HEAP[b+76],16);b=_FT_MulFix(b,d)+32&-64;HEAP[a+24]=b}b=HEAP[a+2];b=unSign(HEAP[a],16)>=unSign(b,16);d=a;if(b){HEAP[e+72+16]=HEAP[d+4];HEAP[e+72+8]=HEAP[a];HEAP[e+72]=65536;b=unSign(HEAP[a],16);a=unSign(HEAP[a+2],16);a=_FT_MulDiv(a,65536,b);HEAP[e+72+4]=a}else{HEAP[e+
72+16]=HEAP[d+8];HEAP[e+72+8]=HEAP[a+2];b=unSign(HEAP[a+2],16);a=unSign(HEAP[a],16);a=_FT_MulDiv(a,65536,b);HEAP[e+72]=a;HEAP[e+72+4]=65536}HEAP[e+301]=0;HEAP[e+72+36]=1;d=0;g=6;break a}while(0);if(g==0)d=151;return d}_tt_size_reset.__index__=Runtime.getFunctionIndex(_tt_size_reset,"_tt_size_reset");function _tt_driver_init(e){return _TT_New_Context(e)==0?153:0}_tt_driver_init.__index__=Runtime.getFunctionIndex(_tt_driver_init,"_tt_driver_init");
function _tt_driver_done(e){if(HEAP[e+40]!=0){_TT_Done_Context(HEAP[e+40]);HEAP[e+40]=0}}_tt_driver_done.__index__=Runtime.getFunctionIndex(_tt_driver_done,"_tt_driver_done");function _tt_slot_init(e){return _FT_GlyphLoader_CreateExtra(HEAP[HEAP[e+156]])}_tt_slot_init.__index__=Runtime.getFunctionIndex(_tt_slot_init,"_tt_slot_init");
function _TT_Done_Context(e){var g,d;d=HEAP[e+8];HEAP[e+440]=0;HEAP[e+442]=0;g=HEAP[e+24];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+24]=0;HEAP[e+20]=0;g=HEAP[e+436];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+436]=0;HEAP[e+432]=0;HEAP[e+428]=0;g=HEAP[e+392];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+392]=0;HEAP[e+388]=0;HEAP[e+4]=0;HEAP[e]=0;e!=0&&FUNCTION_TABLE[HEAP[d+8]](d,e)}_TT_Done_Context.__index__=Runtime.getFunctionIndex(_TT_Done_Context,"_TT_Done_Context");
function _Update_Max(e,g,d,b,a){var c=STACKTOP;STACKTOP+=4;Runtime.memset(c,0,4);var f,h,i=unSign(HEAP[g],32)<unSign(a,32);a:do if(i){e=_ft_mem_realloc(e,1,d*HEAP[g],a*d,HEAP[b],c);HEAP[b]=e;if(HEAP[c]!=0){h=HEAP[c];f=0}else{HEAP[g]=a;f=1}break a}else f=1;while(0);if(f==1)h=0;g=h;STACKTOP=c;return g}_Update_Max.__index__=Runtime.getFunctionIndex(_Update_Max,"_Update_Max");
function _TT_Load_Context(e,g,d){var b=STACKTOP;STACKTOP+=12;Runtime.memset(b,0,12);var a=null,c=b+8;HEAP[e]=g;g=g+260;HEAP[e+4]=d;if(d!=0){HEAP[e+396]=HEAP[d+116];HEAP[e+400]=HEAP[d+120];HEAP[e+408]=HEAP[d+128];HEAP[e+412]=HEAP[d+132];HEAP[e+404]=HEAP[d+124];HEAP[e+416]=HEAP[d+136];_llvm_memcpy_p0i8_p0i8_i32(e+244,d+72,40,4,0);var f=e+216;a=d+44;HEAP[f]=HEAP[a];HEAP[f+2]=HEAP[a+2];HEAP[f+4]=HEAP[a+4];HEAP[f+8]=HEAP[a+8];HEAP[f+12]=HEAP[a+12];HEAP[f+16]=HEAP[a+16];HEAP[f+20]=HEAP[a+20];HEAP[f+24]=
HEAP[a+24];HEAP[e+420]=HEAP[d+140];HEAP[e+424]=HEAP[d+144];f=b+4;for(a=0;;){j=a==0?0:j;a=0+j;var h=HEAP[d+148+a*8],i=HEAP[d+148+a*8+4],k=e;HEAP[k+444+a*8]=h;HEAP[k+444+a*8+4]=i;var j=j+1;if(j!=3)a=1;else break}HEAP[f]=i;HEAP[b]=h;_llvm_memcpy_p0i8_p0i8_i32(e+284,d+172,68,4,0);HEAP[e+380]=HEAP[d+240];HEAP[e+384]=HEAP[d+244];HEAP[e+468]=HEAP[d+248];HEAP[e+472]=HEAP[d+252];_llvm_memcpy_p0i8_p0i8_i32(e+180,d+256,36,4,0);_llvm_memset_p0i8_i32(e+36,0,36,1,0);_llvm_memcpy_p0i8_p0i8_i32(e+72,e+36,36,4,0);
_llvm_memcpy_p0i8_p0i8_i32(e+108,e+36,36,4,0)}HEAP[c]=HEAP[e+20];d=unSign(HEAP[g+24],16)+32;d=_Update_Max(HEAP[e+8],c,4,e+24,d);HEAP[e+20]=HEAP[c];if(d==0){HEAP[c]=HEAP[e+388];g=unSign(HEAP[g+26],16);d=_Update_Max(HEAP[e+8],c,1,e+392,g);c=unSign(HEAP[c]&65535,16);HEAP[e+388]=c;if(d==0){HEAP[e+144+8]=0;HEAP[e+144+10]=0;_llvm_memcpy_p0i8_p0i8_i32(e+72,e+144,36,4,0);_llvm_memcpy_p0i8_p0i8_i32(e+108,e+144,36,4,0);_llvm_memcpy_p0i8_p0i8_i32(e+36,e+144,36,4,0);HEAP[e+488]=0}}STACKTOP=b}
_TT_Load_Context.__index__=Runtime.getFunctionIndex(_TT_Load_Context,"_TT_Load_Context");
function _TT_New_Context(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);var d,b,a,c,f=g+4;b=HEAP[e+8];a=HEAP[e+40]==0;a:do if(a){d=_ft_mem_alloc(b,608,f);a=HEAP[f]!=0;b:do if(!a){a=b;b=d;a=a;HEAP[b+8]=a;HEAP[b+432]=32;a=_ft_mem_realloc(a,16,0,HEAP[b+432],0,g);HEAP[b+436]=a;a=b;if(HEAP[g]!=0){_TT_Done_Context(a);b=HEAP[g];HEAP[f]=b;if(b!=0)break b}else{HEAP[a+440]=0;HEAP[b+442]=0;HEAP[b+20]=0;HEAP[b+388]=0;HEAP[b+24]=0;HEAP[b+392]=0;HEAP[b]=0;HEAP[b+4]=0;HEAP[f]=0}HEAP[e+40]=d;d=2;break a}while(0);
c=0;d=4;break a}else d=2;while(0);if(d==2)c=HEAP[e+40];e=c;STACKTOP=g;return e}_TT_New_Context.__index__=Runtime.getFunctionIndex(_TT_New_Context,"_TT_New_Context");
function _TT_MulFix14(e,g){var d=null,b,a,c;b=e;var f=a=g;c=f^b;if(reSign(b,32)<reSign(0,32)){b=0-b;var h=a;d=0}else d=-1;if(reSign(d==0?h:f,32)<reSign(0,32))a=0-a;d=reSign(b,32)>>reSign(16,32)&65535;b=(b&65535)*a;d=d*a;a=unSign(d,32)>>>unSign(16,32);d=d*65536+8192;b=d+b;d=d;if(unSign(b,32)<unSign(d,32))a+=1;b=unSign(b,32)>>>unSign(14,32);d=a<<18|b;c=reSign(c,32)>=reSign(0,32);a=d;return c?a:0-a}_TT_MulFix14.__index__=Runtime.getFunctionIndex(_TT_MulFix14,"_TT_MulFix14");
function _TT_DotFix14(e,g,d,b){var a,c;c=(e&65535)*d;a=(reSign(e,32)>>reSign(16,32))*d;e=a*65536+c;d=reSign(a,32)>>reSign(16,32);a=reSign(c,32)>>reSign(31,32);c=c;c=unSign(e,32)<unSign(c,32);c=unSign(c,1);d=a+d+c;c=(g&65535)*b;a=(reSign(g,32)>>reSign(16,32))*b;g=a*65536+c;b=reSign(a,32)>>reSign(16,32);a=reSign(c,32)>>reSign(31,32);c=c;c=unSign(g,32)<unSign(c,32);c=unSign(c,1);c=a+b+c;g=g+e;e=unSign(g,32)<unSign(e,32);e=unSign(e,1);e=c+d+e;d=reSign(e,32)>>reSign(31,32);c=g+d;g=g;g=unSign(c,32)<unSign(g,
32);g=unSign(g,1);e=e+d+g;g=c;c=g+8192;d=g;d=unSign(c,32)<unSign(d,32);e=unSign(d,1)+e;e=e<<18;return unSign(c,32)>>>unSign(14,32)|e}_TT_DotFix14.__index__=Runtime.getFunctionIndex(_TT_DotFix14,"_TT_DotFix14");
function _Current_Ratio(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);var d,b;if(HEAP[e+244+12]==0)if(HEAP[e+284+10+2]==0)HEAP[e+244+12]=HEAP[e+244];else{d=e+244;if(HEAP[e+284+10]==0)HEAP[e+244+12]=HEAP[d+4];else{d=HEAP[d];b=reSign(HEAP[e+284+10],16);d=_FT_MulDiv(b,d,16384);b=HEAP[e+244+4];var a=reSign(HEAP[e+284+10+2],16);b=_FT_MulDiv(a,b,16384);HEAP[g]=d;HEAP[g+4]=b;d=_FT_Vector_Length(g);HEAP[e+244+12]=d}}e=HEAP[e+244+12];STACKTOP=g;return e}
_Current_Ratio.__index__=Runtime.getFunctionIndex(_Current_Ratio,"_Current_Ratio");function _Read_CVT(e,g){return HEAP[HEAP[e+384]+4*g]}_Read_CVT.__index__=Runtime.getFunctionIndex(_Read_CVT,"_Read_CVT");function _Read_CVT_Stretched(e,g){var d=_Current_Ratio(e);return _FT_MulFix(HEAP[HEAP[e+384]+4*g],d)}_Read_CVT_Stretched.__index__=Runtime.getFunctionIndex(_Read_CVT_Stretched,"_Read_CVT_Stretched");function _Write_CVT(e,g,d){HEAP[HEAP[e+384]+4*g]=d}
_Write_CVT.__index__=Runtime.getFunctionIndex(_Write_CVT,"_Write_CVT");function _Write_CVT_Stretched(e,g,d){var b=HEAP[e+384];e=_Current_Ratio(e);d=_FT_DivFix(d,e);HEAP[b+4*g]=d}_Write_CVT_Stretched.__index__=Runtime.getFunctionIndex(_Write_CVT_Stretched,"_Write_CVT_Stretched");function _Move_CVT(e,g,d){HEAP[HEAP[e+384]+4*g]=d+HEAP[HEAP[e+384]+4*g]}_Move_CVT.__index__=Runtime.getFunctionIndex(_Move_CVT,"_Move_CVT");
function _Move_CVT_Stretched(e,g,d){var b=HEAP[e+384],a=HEAP[HEAP[e+384]+4*g];e=_Current_Ratio(e);d=_FT_DivFix(d,e)+a;HEAP[b+4*g]=d}_Move_CVT_Stretched.__index__=Runtime.getFunctionIndex(_Move_CVT_Stretched,"_Move_CVT_Stretched");
function _Ins_Goto_CodeRange(e,g,d){var b;b=reSign(g,32)<=reSign(0,32);var a=reSign(g,32)>reSign(3,32);if(b|a){HEAP[e+12]=132;e=1}else{b=e+444+(g-1)*8;if(HEAP[b]==0){HEAP[e+12]=138;e=1}else if(unSign(HEAP[b+4],32)<unSign(d,32)){HEAP[e+12]=131;e=1}else{HEAP[e+356]=HEAP[b];HEAP[e+364]=HEAP[b+4];HEAP[e+360]=d;HEAP[e+352]=g;e=0}}return e&255}_Ins_Goto_CodeRange.__index__=Runtime.getFunctionIndex(_Ins_Goto_CodeRange,"_Ins_Goto_CodeRange");
function _Direct_Move(e,g,d,b){var a;a=reSign(HEAP[e+284+14],16);if(a!=0){var c=HEAP[g+16],f=unSign(d,16);c=c+8*f;f=HEAP[g+16];var h=unSign(d,16);f=HEAP[f+8*h];a=_FT_MulDiv(b,a*65536,HEAP[e+564])+f;HEAP[c]=a;a=HEAP[g+24];c=unSign(d,16);f=HEAP[g+24];h=unSign(d,16);HEAP[a+c]=HEAP[f+h]|8}a=c=reSign(HEAP[e+284+14+2],16);if(c!=0){c=HEAP[g+16];f=unSign(d,16);c=c+8*f;f=HEAP[g+16];h=unSign(d,16);f=HEAP[f+8*h+4];e=_FT_MulDiv(b,a*65536,HEAP[e+564])+f;HEAP[c+4]=e;e=HEAP[g+24];b=unSign(d,16);g=HEAP[g+24];d=unSign(d,
16);HEAP[e+b]=HEAP[g+d]|16}}_Direct_Move.__index__=Runtime.getFunctionIndex(_Direct_Move,"_Direct_Move");function _Direct_Move_Orig(e,g,d,b){var a;a=reSign(HEAP[e+284+14],16);if(a!=0){var c=HEAP[g+12],f=unSign(d,16);c=c+8*f;f=HEAP[g+12];var h=unSign(d,16);f=HEAP[f+8*h];a=_FT_MulDiv(b,a*65536,HEAP[e+564])+f;HEAP[c]=a}a=c=reSign(HEAP[e+284+14+2],16);if(c!=0){c=HEAP[g+12];f=unSign(d,16);c=c+8*f;g=HEAP[g+12];d=unSign(d,16);d=HEAP[g+8*d+4];e=_FT_MulDiv(b,a*65536,HEAP[e+564])+d;HEAP[c+4]=e}}
_Direct_Move_Orig.__index__=Runtime.getFunctionIndex(_Direct_Move_Orig,"_Direct_Move_Orig");function _Direct_Move_X(e,g,d,b){e=HEAP[g+16];var a=unSign(d,16);e=e+8*a;a=HEAP[g+16];var c=unSign(d,16);HEAP[e]=b+HEAP[a+8*c];b=HEAP[g+24];e=unSign(d,16);g=HEAP[g+24];d=unSign(d,16);HEAP[b+e]=HEAP[g+d]|8}_Direct_Move_X.__index__=Runtime.getFunctionIndex(_Direct_Move_X,"_Direct_Move_X");
function _Direct_Move_Y(e,g,d,b){e=HEAP[g+16];var a=unSign(d,16);e=e+8*a;a=HEAP[g+16];var c=unSign(d,16);HEAP[e+4]=b+HEAP[a+8*c+4];b=HEAP[g+24];e=unSign(d,16);g=HEAP[g+24];d=unSign(d,16);HEAP[b+e]=HEAP[g+d]|16}_Direct_Move_Y.__index__=Runtime.getFunctionIndex(_Direct_Move_Y,"_Direct_Move_Y");function _Direct_Move_Orig_X(e,g,d,b){e=HEAP[g+12];var a=unSign(d,16);e=e+8*a;g=HEAP[g+12];d=unSign(d,16);HEAP[e]=b+HEAP[g+8*d]}_Direct_Move_Orig_X.__index__=Runtime.getFunctionIndex(_Direct_Move_Orig_X,"_Direct_Move_Orig_X");
function _Direct_Move_Orig_Y(e,g,d,b){e=HEAP[g+12];var a=unSign(d,16);e=e+8*a;g=HEAP[g+12];d=unSign(d,16);HEAP[e+4]=b+HEAP[g+8*d+4]}_Direct_Move_Orig_Y.__index__=Runtime.getFunctionIndex(_Direct_Move_Orig_Y,"_Direct_Move_Orig_Y");function _Round_None(e,g,d){var b=reSign(g,32)>=reSign(0,32);a:do{if(b){e=d+g;if(g==0)break a;if(!(reSign(e,32)<reSign(0,32)))break a}else{e=g-d;if(!(reSign(e,32)>reSign(0,32)))break a}e=0}while(0);return e}_Round_None.__index__=Runtime.getFunctionIndex(_Round_None,"_Round_None");
function _Round_To_Grid(e,g,d){var b=reSign(g,32)>=reSign(0,32);a:do{if(b){e=g+32+d;var a=g==0;b:do if(!a){if(reSign(e,32)<=reSign(0,32))break b;e&=-64;break a}while(0)}else{e=0-(d+32+(0-g)&-64);if(!(reSign(e,32)>reSign(0,32)))break a}e=0}while(0);return e}_Round_To_Grid.__index__=Runtime.getFunctionIndex(_Round_To_Grid,"_Round_To_Grid");
function _Round_To_Half_Grid(e,g,d){var b=reSign(g,32)>=reSign(0,32);a:do{if(b){e=(d+g&-64)+32;if(g==0)break a;if(!(reSign(e,32)<reSign(0,32)))break a}else{e=-32-(d-g&-64);if(!(reSign(e,32)>reSign(0,32)))break a}e=0}while(0);return e}_Round_To_Half_Grid.__index__=Runtime.getFunctionIndex(_Round_To_Half_Grid,"_Round_To_Half_Grid");
function _Round_Down_To_Grid(e,g,d){var b=reSign(g,32)>=reSign(0,32);a:do{if(b){e=d+g;var a=g==0;b:do if(!a){if(reSign(e,32)<=reSign(0,32))break b;e&=-64;break a}while(0)}else{e=0-(d-g&-64);if(!(reSign(e,32)>reSign(0,32)))break a}e=0}while(0);return e}_Round_Down_To_Grid.__index__=Runtime.getFunctionIndex(_Round_Down_To_Grid,"_Round_Down_To_Grid");
function _Round_Up_To_Grid(e,g,d){var b=reSign(g,32)>=reSign(0,32);a:do{if(b){e=g+63+d;var a=g==0;b:do if(!a){if(reSign(e,32)<=reSign(0,32))break b;e&=-64;break a}while(0)}else{e=0-(d+63+(0-g)&-64);if(!(reSign(e,32)>reSign(0,32)))break a}e=0}while(0);return e}_Round_Up_To_Grid.__index__=Runtime.getFunctionIndex(_Round_Up_To_Grid,"_Round_Up_To_Grid");
function _Round_To_Double_Grid(e,g,d){var b=reSign(g,32)>=reSign(0,32);a:do{if(b){e=g+16+d;var a=g==0;b:do if(!a){if(reSign(e,32)<=reSign(0,32))break b;e&=-32;break a}while(0)}else{e=0-(d+16+(0-g)&-32);if(!(reSign(e,32)>reSign(0,32)))break a}e=0}while(0);return e}_Round_To_Double_Grid.__index__=Runtime.getFunctionIndex(_Round_To_Double_Grid,"_Round_To_Double_Grid");
function _Round_Super(e,g,d){if(reSign(g,32)>=reSign(0,32)){d=0-HEAP[e+476]&g+(0-HEAP[e+480])+HEAP[e+484]+d;g=g!=0;a:do if(g){if(!(reSign(d,32)<reSign(0,32)))break a;d=0}while(0);d+=HEAP[e+480]}else{d=0-(0-HEAP[e+476]&0-HEAP[e+480]+HEAP[e+484]+(0-g)+d);if(reSign(d,32)>reSign(0,32))d=0;d-=HEAP[e+480]}return d}_Round_Super.__index__=Runtime.getFunctionIndex(_Round_Super,"_Round_Super");
function _Round_Super_45(e,g,d){if(reSign(g,32)>=reSign(0,32)){var b=HEAP[e+476];d=Math.floor(reSign(g+(0-HEAP[e+480])+HEAP[e+484]+d,32)/reSign(b,32));d=HEAP[e+476]*d;g=g!=0;a:do if(g){if(!(reSign(d,32)<reSign(0,32)))break a;d=0}while(0);d+=HEAP[e+480]}else{b=HEAP[e+476];d=Math.floor(reSign(0-HEAP[e+480]+HEAP[e+484]+(0-g)+d,32)/reSign(b,32))*-1*HEAP[e+476];if(reSign(d,32)>reSign(0,32))d=0;d-=HEAP[e+480]}return d}_Round_Super_45.__index__=Runtime.getFunctionIndex(_Round_Super_45,"_Round_Super_45");
function _SetSuperRound(e,g,d){var b;b=d&192;b=b==0?3:b==64?4:b==128?5:b==192?6:7;if(b==3){g=Math.floor(reSign(g,32)/reSign(2,32));HEAP[e+476]=g}else if(b==4)HEAP[e+476]=g;else if(b==5)HEAP[e+476]=g*2;else if(b==6)HEAP[e+476]=g;g=d&48;b=g==0?8:g==16?9:g==32?10:g==48?11:12;if(b==8)HEAP[e+480]=0;else if(b==9){g=Math.floor(reSign(HEAP[e+476],32)/reSign(4,32));HEAP[e+480]=g}else if(b==10){g=Math.floor(reSign(HEAP[e+476],32)/reSign(2,32));HEAP[e+480]=g}else if(b==11){g=Math.floor(reSign(HEAP[e+476]*3,
32)/reSign(4,32));HEAP[e+480]=g}if((d&15)==0)HEAP[e+484]=HEAP[e+476]-1;else{d=Math.floor(reSign(((d&15)-4)*HEAP[e+476],32)/reSign(8,32));HEAP[e+484]=d}d=Math.floor(reSign(HEAP[e+476],32)/reSign(256,32));HEAP[e+476]=d;d=Math.floor(reSign(HEAP[e+480],32)/reSign(256,32));HEAP[e+480]=d;d=Math.floor(reSign(HEAP[e+484],32)/reSign(256,32));HEAP[e+484]=d}_SetSuperRound.__index__=Runtime.getFunctionIndex(_SetSuperRound,"_SetSuperRound");
function _Project(e,g,d){var b=reSign(HEAP[e+284+10+2],16);e=reSign(HEAP[e+284+10],16);return _TT_DotFix14(g,d,e,b)}_Project.__index__=Runtime.getFunctionIndex(_Project,"_Project");function _Dual_Project(e,g,d){var b=reSign(HEAP[e+284+6+2],16);e=reSign(HEAP[e+284+6],16);return _TT_DotFix14(g,d,e,b)}_Dual_Project.__index__=Runtime.getFunctionIndex(_Dual_Project,"_Dual_Project");function _Project_x(e,g){return g}_Project_x.__index__=Runtime.getFunctionIndex(_Project_x,"_Project_x");
function _Project_y(e,g,d){return d}_Project_y.__index__=Runtime.getFunctionIndex(_Project_y,"_Project_y");
function _Compute_Funcs(e){var g=e+284;if(HEAP[e+284+14]==16384){g=reSign(HEAP[g+10],16)*65536;HEAP[e+564]=g}else{var d=e+284+10;if(HEAP[g+14+2]==16384){g=reSign(HEAP[d+2],16)*65536;HEAP[e+564]=g}else{g=reSign(HEAP[d],16);g=reSign(HEAP[e+284+14],16)*g;d=reSign(HEAP[e+284+10+2],16);g=(reSign(HEAP[e+284+14+2],16)*d+g)*4;HEAP[e+564]=g}}HEAP[e+572]=HEAP[e+284+10]==16384?_Project_x.__index__:HEAP[e+284+10+2]==16384?_Project_y.__index__:_Project.__index__;HEAP[e+576]=HEAP[e+284+6]==16384?_Project_x.__index__:
HEAP[e+284+6+2]==16384?_Project_y.__index__:_Dual_Project.__index__;HEAP[e+584]=_Direct_Move.__index__;HEAP[e+588]=_Direct_Move_Orig.__index__;g=HEAP[e+564]==1073741824;a:do if(g){d=e;if(HEAP[e+284+14]==16384){HEAP[d+584]=_Direct_Move_X.__index__;HEAP[e+588]=_Direct_Move_Orig_X.__index__}else{if(HEAP[d+284+14+2]!=16384)break a;HEAP[e+584]=_Direct_Move_Y.__index__;HEAP[e+588]=_Direct_Move_Orig_Y.__index__}}while(0);g=reSign(HEAP[e+564],32)>=reSign(-67108863,32);a:do if(g){if(!(reSign(HEAP[e+564],32)<=
reSign(67108863,32)))break a;HEAP[e+564]=1073741824}while(0);HEAP[e+244+12]=0}_Compute_Funcs.__index__=Runtime.getFunctionIndex(_Compute_Funcs,"_Compute_Funcs");
function _Normalize(e,g,d,b){e=STACKTOP;STACKTOP+=16;Runtime.memset(e,0,16);var a=null,c,f,h=e+8,i;i=g;d=d;g=reSign(i,32)>=reSign(-65535,32);a=reSign(i,32)<=reSign(65535,32);g=g&a;a:do if(g){g=reSign(d,32)>=reSign(-65535,32);a=reSign(d,32)<=reSign(65535,32);if(!(g&a))break a;i*=256;d*=256;f=d;c=i;f=f;HEAP[h]=c;HEAP[h+4]=f;a=c=c=_FT_Vector_Length(h);if(a!=0){c=_FT_MulDiv(i,16384,a)&65535;HEAP[b]=c;c=_FT_MulDiv(d,16384,a)&65535;HEAP[b+2]=c}STACKTOP=e;return}while(0);h=d;HEAP[e]=i;HEAP[e+4]=h;a=_FT_Vector_Length(e);
i=_FT_MulDiv(i,16384,a);d=_FT_MulDiv(d,16384,a);a=d*d+i*i;if(reSign(i,32)<reSign(0,32)){i=0-i;h=1}else h=0;if(reSign(d,32)<reSign(0,32)){d=0-d;g=1}else g=0;var k=a;if(reSign(k,32)<=reSign(268435455,32)){i=i;d=d;for(a=4;;){m=a==4?d:m;o=a==4?i:o;var j=reSign(o,32)<reSign(m,32),l=m+1;a=o+1;var m=j?m:l,o=j?a:o;j=m*m+o*o;if(reSign(j,32)<=reSign(268435455,32))a=5;else break}d=m;i=o;a=6}else a=21;if(reSign(a==6?j:k,32)>reSign(268451839,32)){m=i;d=d;for(a=8;;){c=a==8?d:c;f=a==8?m:f;i=reSign(f,32)<reSign(c,
32);j=c-1;o=f-1;c=i?c:j;f=i?o:f;if(reSign(c*c+f*f,32)>reSign(268451839,32))a=9;else break}d=c;i=f}if(h!=0)i=0-i;if(g!=0)d=0-d;HEAP[b]=i&65535;HEAP[b+2]=d&65535;STACKTOP=e}_Normalize.__index__=Runtime.getFunctionIndex(_Normalize,"_Normalize");
function _Ins_SxVTL(e,g,d,b,a){var c,f,h=unSign(HEAP[e+108+8],16)<=unSign(g,16);a:do if(h)c=0;else{c=d;if(unSign(HEAP[e+72+8],16)<=unSign(c,16)){c=0;break a}f=HEAP[e+72+16];d=unSign(d,16);d=f+8*d;f=HEAP[e+108+16];g=unSign(g,16);f=f+8*g;g=HEAP[d]-HEAP[f];d=HEAP[d+4]-HEAP[f+4];if((b&1&255)!=0){b=d;d=g;g=0-b}_Normalize(e,g,d,a);f=0;c=5;break a}while(0);if(c==0){if(HEAP[e+561]!=0)HEAP[e+12]=134;f=1}return f&255}_Ins_SxVTL.__index__=Runtime.getFunctionIndex(_Ins_SxVTL,"_Ins_SxVTL");
function _SkipCode(e){var g,d;HEAP[e+360]=HEAP[e+372]+HEAP[e+360];g=HEAP[e+364];var b=reSign(HEAP[e+360],32)<reSign(g,32);a:do if(b){HEAP[e+368]=HEAP[HEAP[e+356]+HEAP[e+360]];g=unSign(HEAP[e+368],8);g=reSign(HEAP[_opcode_length+g],8);HEAP[e+372]=g;if(reSign(HEAP[e+372],32)<reSign(0,32)){g=HEAP[e+364];if(reSign(HEAP[e+360]+1,32)>reSign(g,32)){g=0;break a}g=HEAP[e+372];g=2-unSign(HEAP[HEAP[e+356]+(HEAP[e+360]+1)],8)*g;HEAP[e+372]=g}g=HEAP[e+364];if(!(reSign(HEAP[e+372]+HEAP[e+360],32)<=reSign(g,32))){g=
0;break a}d=0;g=4;break a}else g=0;while(0);if(g==0){HEAP[e+12]=131;d=1}return d&255}_SkipCode.__index__=Runtime.getFunctionIndex(_SkipCode,"_SkipCode");
function _Compute_Point_Displacement(e,g,d,b,a){var c=STACKTOP;STACKTOP+=36;Runtime.memset(c,0,36);var f;if((unSign(HEAP[e+368],8)&1&255)!=0){_llvm_memcpy_p0i8_p0i8_i32(c,e+36,36,4,0);f=HEAP[e+284+2]}else{_llvm_memcpy_p0i8_p0i8_i32(c,e+72,36,4,0);f=HEAP[e+284+4]}var h=f;if(unSign(HEAP[c+8],16)<=unSign(h,16)){if(HEAP[e+561]!=0)HEAP[e+12]=134;HEAP[a]=0;d=1}else{_llvm_memcpy_p0i8_p0i8_i32(b,c,36,4,0);HEAP[a]=f;b=HEAP[e+572];a=HEAP[c+16];h=unSign(f,16);a=HEAP[a+8*h+4];h=HEAP[c+12];var i=unSign(f,16);
a=a-HEAP[h+8*i+4];h=HEAP[c+16];i=unSign(f,16);h=HEAP[h+8*i];i=HEAP[c+12];f=unSign(f,16);f=FUNCTION_TABLE[b](e,h-HEAP[i+8*f],a);b=HEAP[e+564];a=reSign(HEAP[e+284+14],16)*65536;b=_FT_MulDiv(f,a,b);HEAP[g]=b;g=HEAP[e+564];e=reSign(HEAP[e+284+14+2],16)*65536;e=_FT_MulDiv(f,e,g);HEAP[d]=e;d=0}d=d&255;STACKTOP=c;return d}_Compute_Point_Displacement.__index__=Runtime.getFunctionIndex(_Compute_Point_Displacement,"_Compute_Point_Displacement");
function _Move_Zp2_Point(e,g,d,b,a){var c=HEAP[e+284+14]!=0;a:do if(c){var f=HEAP[e+108+16],h=unSign(g,16);f=f+8*h;h=HEAP[e+108+16];var i=unSign(g,16);HEAP[f]=d+HEAP[h+8*i];if(a==0)break a;f=HEAP[e+108+24];h=unSign(g,16);i=HEAP[e+108+24];var k=unSign(g,16);HEAP[f+h]=HEAP[i+k]|8}while(0);d=HEAP[e+284+14+2]!=0;a:do if(d){c=HEAP[e+108+16];f=unSign(g,16);c=c+8*f;f=HEAP[e+108+16];h=unSign(g,16);HEAP[c+4]=b+HEAP[f+8*h+4];if(a==0)break a;c=HEAP[e+108+24];f=unSign(g,16);h=HEAP[e+108+24];i=unSign(g,16);HEAP[c+
f]=HEAP[h+i]|16}while(0)}_Move_Zp2_Point.__index__=Runtime.getFunctionIndex(_Move_Zp2_Point,"_Move_Zp2_Point");
function __iup_worker_interpolate(e,g,d,b,a){var c=null,f,h,i,k,j,l;b=b;a=a;var m=unSign(g,32)>unSign(d,32);a:do if(!m){c=b;if(unSign(HEAP[e+12],32)<=unSign(c,32))break a;c=a;if(unSign(HEAP[e+12],32)<=unSign(c,32))break a;f=HEAP[HEAP[e+8]+8*b];c=h=HEAP[HEAP[e+8]+8*a];if(reSign(f,32)>reSign(c,32)){c=f;f=h;h=c;c=b;b=a;a=c}i=HEAP[HEAP[e]+8*b];k=HEAP[HEAP[e]+8*a];j=HEAP[HEAP[e+4]+8*b]-i;l=HEAP[HEAP[e+4]+8*a]-k;if(f==h){c=g;var o=d;if(!(unSign(c,32)<=unSign(o,32)))break a;o=e;var n=i,p=j,r=e+4,q=d,s=l,
u=c;h=u+1;for(c=4;;){t=c==4?0:t;c=u+t;l=h+t;j=HEAP[HEAP[o]+8*c];k=reSign(j,32)<=reSign(n,32);f=s+j;j=p+j;HEAP[HEAP[r]+8*c]=k?j:f;c=unSign(l,32)<=unSign(q,32);var t=t+1;if(c)c=5;else break}}else{c=g;o=d;if(!(unSign(c,32)<=unSign(o,32)))break a;o=e;n=i;p=j;r=e+4;q=d;s=k;u=l;h=h-f;l=l+k+(0-i)+(0-j);k=e+8;f=f;j=j+i;i=c;var v=i+1;for(c=7;;){G=c==7?0:G;E=c==7?0:E;F=c==7?0:F;var w=i+G,x=v+G;c=HEAP[HEAP[o]+8*w];if(reSign(c,32)<=reSign(n,32)){var y=p+c;c=9}else if(reSign(c,32)>=reSign(s,32)){var A=u+c;c=11}else{if(E==
0){var z=_FT_MulDiv(l,65536,h);c=12}else c=23;var C=c==12?1:E,B=c==12?z:F,D=_FT_MulFix(HEAP[HEAP[k]+8*w]-f,B);D=j+D;c=14}var E=c==14?C:c==11?E:E,F=c==14?B:c==11?F:F;HEAP[HEAP[r]+8*w]=c==14?D:c==11?A:y;c=unSign(x,32)<=unSign(q,32);var G=G+1;if(c)c=15;else break}}}while(0)}__iup_worker_interpolate.__index__=Runtime.getFunctionIndex(__iup_worker_interpolate,"__iup_worker_interpolate");
function _Ins_DELTAP(e,g){var d,b=null,a=HEAP[g],c=e+28,f=e+28,h=e+28,i=e+24,k=e+28,j=e+24,l=e+28,m=e+36+8,o=e+368,n=e+284+48,p=e+284+50,r=e+584,q=e+36,s=e+561,u=e+12;b=-1;a:for(;;){C=b==7?C:0;var t=unSign(1+C,32)<=unSign(a,32),v=HEAP[c];if(!t){d=11;break a}if(reSign(v,32)<=reSign(1,32)){d=1;break a}HEAP[h]=HEAP[f]-2;t=HEAP[HEAP[i]+4*(HEAP[k]+1)]&65535;var w=HEAP[HEAP[j]+4*HEAP[l]],x=unSign(HEAP[m],16)>unSign(t,16);b:do if(x){var y=unSign(w&240,32)>>>unSign(4,32);d=unSign(HEAP[o],8);if(d==113){b=
12;d=3}else if(d==114){b=12;d=5}else{b=12;d=13}if(d==3){var A=y+16;b=3}else if(d==5){var z=y+32;b=5}d=b==5?z:b==3?A:y;d=reSign(HEAP[n],16)+d;b=_Current_Ratio(e);y=unSign(HEAP[e+244+8],16);if(_FT_MulFix(y,b)!=d)break b;d=(w&15)-8;b=d+1;d=(reSign(d,32)>=reSign(0,32)?b:d)*64;b=1<<reSign(HEAP[p],16);d=Math.floor(reSign(d,32)/reSign(b,32));b=HEAP[r];y=unSign(t,16)&65535;FUNCTION_TABLE[b](e,q,y,d)}else{if(HEAP[s]==0)break b;HEAP[u]=134}while(0);var C=C+1;b=7;d=0}if(d==1)HEAP[e+12]=129;else if(d==11)HEAP[e+
32]=v}_Ins_DELTAP.__index__=Runtime.getFunctionIndex(_Ins_DELTAP,"_Ins_DELTAP");
function _Ins_UNKNOWN(e){var g,d=null,b,a;b=HEAP[e+416];a=b+16*HEAP[e+408];var c=e+368;b=b;for(d=-1;;){g=d==3?h:0;var f=b+16*g;h=b+16*g+8;d=b+16*g+12;if(!(f<a)){g=5;break}if((HEAP[h]&255)==HEAP[c])if(HEAP[d]!=0){g=1;break}var h=g+1;d=3;g=0}if(g==1){b=f;a=HEAP[e+432];if(reSign(HEAP[e+428],32)>=reSign(a,32))HEAP[e+12]=130;else{c=HEAP[e+428];a=HEAP[e+436]+16*c;HEAP[e+428]=c+1;HEAP[a]=HEAP[e+352];HEAP[a+4]=HEAP[e+360]+1;HEAP[a+8]=1;HEAP[a+12]=HEAP[b+4];_Ins_Goto_CodeRange(e,HEAP[b],HEAP[b+4]);HEAP[e+
376]=0}}else if(g==5)HEAP[e+12]=128}_Ins_UNKNOWN.__index__=Runtime.getFunctionIndex(_Ins_UNKNOWN,"_Ins_UNKNOWN");
function _TT_RunIns(e){var g=STACKTOP;STACKTOP+=230;Runtime.memset(g,0,230);var d,b=null,a,c,f,h,i,k=g+8,j,l,m=g+16,o=g+24,n=g+32,p=g+40,r=g+48,q,s,u,t,v,w,x=g+56,y=g+92,A=g+94,z=g+98,C,B=g+102,D=g+138,E=g+140,F=g+144,G=g+148,H=g+184,J=g+186,L=g+190,N=g+194,I,P,K,O,M,Q=g+210,R,T,V,U=g+218,S=g+222,X=g+226,Y;Y=0;HEAP[e+244+12]=0;var W=e+592;if(HEAP[e+216]!=HEAP[e+216+2]){HEAP[W]=_Read_CVT_Stretched.__index__;HEAP[e+596]=_Write_CVT_Stretched.__index__;HEAP[e+600]=_Move_CVT_Stretched.__index__}else{HEAP[W]=
_Read_CVT.__index__;HEAP[e+596]=_Write_CVT.__index__;HEAP[e+600]=_Move_CVT.__index__}_Compute_Funcs(e);W=unSign(HEAP[e+284+28]&255,8)&255;W=unSign(W,8);d=W==0?378:W==1?379:W==2?380:W==3?381:W==4?382:W==5?383:W==6?384:W==7?385:386;if(d==378)HEAP[e+568]=_Round_To_Half_Grid.__index__;else if(d==379)HEAP[e+568]=_Round_To_Grid.__index__;else if(d==380)HEAP[e+568]=_Round_To_Double_Grid.__index__;else if(d==381)HEAP[e+568]=_Round_Down_To_Grid.__index__;else if(d==382)HEAP[e+568]=_Round_Up_To_Grid.__index__;
else if(d==383)HEAP[e+568]=_Round_None.__index__;else if(d==384)HEAP[e+568]=_Round_Super.__index__;else if(d==385)HEAP[e+568]=_Round_Super_45.__index__;W=k+4;var da=k+4,ba=g+4,aa=g+4,ca=X+2,$=X+2,la=S+2,ga=S+2,ea=U+2,Z=U+2,ha=Q+4,ia=Q+4,ja=N+4,fa=N+8,ka=N+12,na=N+4,sa=N+4,wa=N+4,Aa=N+4,Da=N+4,pa=N+4,ta=N+8,ma=B+16,ya=x+16,qa=r+4,ua=r+4,Ba=p+4,Na=p+4,Ea=n+4,ra=n+4,za=o+4,Ha=o+4,Ca=m+4,va=m+4;a:for(;;){HEAP[e+368]=HEAP[HEAP[e+356]+HEAP[e+360]];c=unSign(HEAP[e+368],8);c=reSign(HEAP[_opcode_length+c],
8);HEAP[e+372]=c;if(reSign(HEAP[e+372],32)<reSign(0,32)){c=HEAP[e+364];if(reSign(HEAP[e+360]+1,32)>reSign(c,32)){d=3;break a}c=HEAP[e+372];c=2-unSign(HEAP[HEAP[e+356]+(HEAP[e+360]+1)],8)*c;HEAP[e+372]=c}c=HEAP[e+364];if(reSign(HEAP[e+372]+HEAP[e+360],32)>reSign(c,32)){d=3;break a}var Pa=HEAP[e+16];c=unSign(HEAP[e+368],8);c=unSign(HEAP[_Pop_Push_Count+c],8)>>>unSign(4,8);c=unSign(c,8);HEAP[e+28]=Pa-c;c=reSign(HEAP[e+28],32)<reSign(0,32);Pa=e;if(c){d=7;break a}var Ja=HEAP[Pa+28];c=unSign(HEAP[e+368],
8);Ja=(unSign(HEAP[_Pop_Push_Count+c],8)&15)+Ja;HEAP[e+32]=Ja;Ja=HEAP[e+20];c=unSign(HEAP[e+32],32)>unSign(Ja,32);Ja=e;if(c){d=10;break a}HEAP[Ja+376]=1;HEAP[e+12]=0;c=HEAP[e+24]+4*HEAP[e+28];a=HEAP[e+368];d=unSign(a,8);d=d==0?387:d==1?387:d==2?387:d==3?387:d==4?387:d==5?387:d==6?388:d==7?388:d==8?389:d==9?389:d==10?390:d==11?391:d==12?392:d==13?393:d==14?394:d==15?395:d==16?396:d==17?397:d==18?398:d==19?399:d==20?400:d==21?401:d==22?402:d==23?403:d==24?404:d==25?405:d==26?406:d==27?31:d==28?407:
d==29?408:d==30?409:d==31?410:d==32?411:d==33?14:d==34?412:d==35?413:d==36?414:d==37?415:d==38?416:d==39?417:d==40?418:d==41?419:d==42?420:d==43?421:d==44?68:d==45?422:d==46?423:d==47?423:d==48?424:d==49?424:d==50?425:d==51?425:d==52?426:d==53?426:d==54?427:d==55?427:d==56?428:d==57?429:d==58?430:d==59?430:d==60?431:d==61?432:d==62?433:d==63?433:d==64?434:d==65?435:d==66?436:d==67?437:d==68?438:d==69?439:d==70?440:d==71?440:d==72?441:d==73?442:d==74?442:d==75?443:d==76?444:d==77?445:d==78?446:d==
79?447:d==80?448:d==81?449:d==82?450:d==83?451:d==84?452:d==85?453:d==86?454:d==87?455:d==88?456:d==89?14:d==90?457:d==91?458:d==92?459:d==93?460:d==94?461:d==95?462:d==96?463:d==97?464:d==98?465:d==99?466:d==100?467:d==101?468:d==102?469:d==103?470:d==104?471:d==105?471:d==106?471:d==107?471:d==108?472:d==109?472:d==110?472:d==111?472:d==112?473:d==113?474:d==114?474:d==115?225:d==116?225:d==117?225:d==118?475:d==119?476:d==120?477:d==121?478:d==122?479:d==123?480:d==124?481:d==125?482:d==126?14:
d==127?14:d==128?483:d==129?484:d==130?485:d==131?486:d==132?486:d==133?487:d==134?488:d==135?488:d==136?489:d==137?291:d==138?490:d==139?491:d==140?492:d==141?493:d==142?494:d==143?495:496;b:do if(d==496){if(unSign(a,8)>unSign(-33,8)){a=c;c=e;d=a;a=HEAP[d]&65535;d=HEAP[d+4]+1;b=a;b=unSign(HEAP[c+72+8],16)<=unSign(b,16);c:do if(!b){b=d;if(unSign(HEAP[c+380]+1,32)<=unSign(b,32))break c;b=HEAP[c+36+8];if(unSign(HEAP[c+284],16)>=unSign(b,16))break c;d=d==0?0:FUNCTION_TABLE[HEAP[c+592]](c,d-1);b=d-HEAP[c+
284+44];j=0-b;b=reSign(b,32)>=reSign(0,32)?b:j;j=HEAP[c+284+40];if(reSign(b,32)<reSign(j,32)){d=reSign(d,32)>=reSign(0,32);b=HEAP[c+284+44];d=d?b:0-b}if(HEAP[c+284+62]==0){b=HEAP[c+72+12];j=unSign(a,16);b=b+8*j;j=HEAP[c+36+12];f=unSign(HEAP[c+284],16);j=HEAP[j+8*f];f=reSign(HEAP[c+284+14],16);j=_TT_MulFix14(d,f)+j;HEAP[b]=j;b=HEAP[c+72+12];j=unSign(a,16);b=b+8*j;j=HEAP[c+36+12];f=unSign(HEAP[c+284],16);j=HEAP[j+8*f+4];f=reSign(HEAP[c+284+14+2],16);j=_TT_MulFix14(d,f)+j;HEAP[b+4]=j;b=HEAP[c+72+16];
j=unSign(a,16);f=HEAP[c+36+16];t=unSign(a,16);f=f+8*t;HEAP[k]=HEAP[f];HEAP[W]=HEAP[f+4];b=b+8*j;HEAP[b]=HEAP[k];HEAP[b+4]=HEAP[da]}b=HEAP[c+576];j=HEAP[c+72+12];f=unSign(a,16);j=HEAP[j+8*f+4];f=HEAP[c+36+12];t=unSign(HEAP[c+284],16);j=j-HEAP[f+8*t+4];f=HEAP[c+72+12];t=unSign(a,16);f=HEAP[f+8*t];t=HEAP[c+36+12];i=unSign(HEAP[c+284],16);b=FUNCTION_TABLE[b](c,f-HEAP[t+8*i],j);j=HEAP[c+572];f=HEAP[c+72+16];t=unSign(a,16);f=HEAP[f+8*t+4];t=HEAP[c+36+16];i=unSign(HEAP[c+284],16);f=f-HEAP[t+8*i+4];t=HEAP[c+
72+16];i=unSign(a,16);t=HEAP[t+8*i];i=HEAP[c+36+16];I=unSign(HEAP[c+284],16);j=FUNCTION_TABLE[j](c,t-HEAP[i+8*I],f);f=HEAP[c+284+32]!=0;d:do if(f){if(!(reSign(d^b,32)<reSign(0,32)))break d;d=0-d}while(0);f=(unSign(HEAP[c+368],8)&4)!=0;t=c;if(f){f=HEAP[t+284+60]==HEAP[c+284+62];d:do if(f){t=d-b;i=0-t;t=reSign(t,32)>=reSign(0,32)?t:i;i=HEAP[c+284+36];if(!(reSign(t,32)>=reSign(i,32)))break d;d=b}while(0);f=HEAP[c+568];t=unSign(HEAP[c+368],8)&3;d=FUNCTION_TABLE[f](c,d,HEAP[c+244+20+t*4])}else{f=unSign(HEAP[t+
368],8)&3;f=HEAP[c+244+20+f*4];d=d;i=f;f=reSign(d,32)>=reSign(0,32);t=d;I=i;d:do{if(f){i=I+t;if(d==0)break d;if(!(reSign(i,32)<reSign(0,32)))break d}else{i=t-I;if(!(reSign(i,32)>reSign(0,32)))break d}i=0}while(0);d=d=d=i}f=(unSign(HEAP[c+368],8)&8)!=0;d:do if(f){i=reSign(b,32)>=reSign(0,32);t=HEAP[c+284+24];if(i){i=d;if(!(reSign(t,32)>reSign(i,32)))break d;d=HEAP[c+284+24]}else{i=d;if(!(reSign(0-t,32)<reSign(i,32)))break d;d=0-HEAP[c+284+24]}}while(0);b=HEAP[c+584];d=d-j;j=unSign(a,16);FUNCTION_TABLE[b](c,
c+72,j&65535,d);HEAP[c+284+2]=HEAP[c+284];if((unSign(HEAP[c+368],8)&16)!=0)HEAP[c+284]=a;HEAP[c+284+4]=a;d=14;break b}while(0);if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134}else if(unSign(a,8)>unSign(-65,8)){a=c;c=e;a=a;d=a=HEAP[a]&65535;d=unSign(HEAP[c+72+8],16)<=unSign(d,16);c:do if(!d){d=HEAP[c+36+8];if(unSign(HEAP[c+284],16)>=unSign(d,16))break c;b=HEAP[c+284+60]==0;d:do if(b)d=334;else{if(HEAP[c+284+62]==0){d=334;break d}h=HEAP[c+72+20];d=unSign(a,16);h=h+8*d;d=HEAP[c+36+20];b=unSign(HEAP[c+
284],16);d=d+8*b;b=c;if(HEAP[c+216+4]==HEAP[c+216+8]){h=FUNCTION_TABLE[HEAP[b+576]](c,HEAP[h]-HEAP[d],HEAP[h+4]-HEAP[d+4]);h=_FT_MulFix(h,HEAP[c+216+4])}else{b=_FT_MulFix(HEAP[h]-HEAP[d],HEAP[b+216+4]);HEAP[g]=b;h=_FT_MulFix(HEAP[h+4]-HEAP[d+4],HEAP[c+216+8]);HEAP[ba]=h;h=FUNCTION_TABLE[HEAP[c+576]](c,HEAP[g],HEAP[aa])}d=337;break d}while(0);if(d==334){h=HEAP[c+72+12];d=unSign(a,16);h=h+8*d;d=HEAP[c+36+12];b=unSign(HEAP[c+284],16);d=d+8*b;h=FUNCTION_TABLE[HEAP[c+576]](c,HEAP[h]-HEAP[d],HEAP[h+4]-
HEAP[d+4])}d=h-HEAP[c+284+44];b=0-d;d=reSign(d,32)>=reSign(0,32)?d:b;b=HEAP[c+284+40];if(reSign(d,32)<reSign(b,32)){h=reSign(h,32)>=reSign(0,32);d=HEAP[c+284+44];h=h?d:0-d}d=(unSign(HEAP[c+368],8)&4)!=0;b=c;if(d){d=HEAP[b+568];b=unSign(HEAP[c+368],8)&3;d=FUNCTION_TABLE[d](c,h,HEAP[c+244+20+b*4])}else{d=unSign(HEAP[b+368],8)&3;b=HEAP[c+244+20+d*4];d=h;f=b;b=reSign(d,32)>=reSign(0,32);j=d;t=f;d:do{if(b){f=t+j;if(d==0)break d;if(!(reSign(f,32)<reSign(0,32)))break d}else{f=j-t;if(!(reSign(f,32)>reSign(0,
32)))break d}f=0}while(0);d=d=d=f}b=(unSign(HEAP[c+368],8)&8)!=0;d:do if(b){f=reSign(h,32)>=reSign(0,32);j=HEAP[c+284+24];if(f){f=d;if(!(reSign(j,32)>reSign(f,32)))break d;d=HEAP[c+284+24]}else{f=d;if(!(reSign(0-j,32)<reSign(f,32)))break d;d=0-HEAP[c+284+24]}}while(0);h=HEAP[c+572];b=HEAP[c+72+16];j=unSign(a,16);b=HEAP[b+8*j+4];j=HEAP[c+36+16];f=unSign(HEAP[c+284],16);b=b-HEAP[j+8*f+4];j=HEAP[c+72+16];f=unSign(a,16);j=HEAP[j+8*f];f=HEAP[c+36+16];t=unSign(HEAP[c+284],16);h=FUNCTION_TABLE[h](c,j-HEAP[f+
8*t],b);b=HEAP[c+584];d=d-h;j=unSign(a,16);FUNCTION_TABLE[b](c,c+72,j&65535,d);HEAP[c+284+2]=HEAP[c+284];HEAP[c+284+4]=a;if((unSign(HEAP[c+368],8)&16)==0){d=14;break b}HEAP[c+284]=a;d=14;break b}while(0);if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134}else if(unSign(a,8)>unSign(-73,8)){a=c;c=e;a=a;d=unSign(HEAP[c+368],8)-183;b=unSign(d,16);j=HEAP[c+20]+1+(0-HEAP[c+16]);b=unSign(b,32)>=unSign(j,32);j=c;if(b)HEAP[j+12]=130;else{HEAP[c+360]=HEAP[j+360]+1;b=d;if(unSign(0,16)<unSign(b,16)){b=c;a=a;M=d;
unSign(M,16);unSign(1,16);d=b+360;j=b+360;f=b+356;t=b+360;i=b+356;I=b+360;M=(unSign(M,16)>unSign(1,16)?M:1)-0;for(b=350;;){La=b==350?0:La;b=unSign(0+La,16);HEAP[j]=HEAP[d]+2;K=unSign(HEAP[HEAP[f]+(HEAP[t]-2)],8)*256;K=unSign(HEAP[HEAP[i]+(HEAP[I]-1)],8)+K;K=reSign(K,16)&65535;K=reSign(K,16);HEAP[a+4*b]=K;var La=La+1;if(La!=M)b=351;else break}}HEAP[c+376]=0}}else{a=unSign(a,8)>unSign(-81,8);d=e;c=c;if(a){a=d;d=c;b=unSign(HEAP[a+368],8)-175;c=unSign(b,16);j=HEAP[a+20]+1+(0-HEAP[a+16]);if(unSign(c,32)>=
unSign(j,32))HEAP[a+12]=130;else{c=b;if(!(unSign(1,16)<=unSign(c,16))){d=14;break b}c=a+356;a=a+360;d=d;j=b;for(b=354;;){xa=b==354?0:xa;i=1+xa;b=2+xa;f=unSign(i,16)-1;t=HEAP[c];I=HEAP[a];i=unSign(i,16)+I;t=unSign(HEAP[t+i],8);HEAP[d+4*f]=t;b=unSign(b,16)<=unSign(j,16);var xa=xa+1;if(b)b=355;else break}}}else _Ins_UNKNOWN(d,c)}d=14;break b}else if(d==387){c=(unSign(a,8)&1)<<14&65535;d=c^16384;if(unSign(a,8)<=unSign(3,8)){HEAP[e+284+10]=c;HEAP[e+284+10+2]=d;HEAP[e+284+6]=c;HEAP[e+284+6+2]=d}if((unSign(a,
8)&2)==0){HEAP[e+284+14]=c;HEAP[e+284+14+2]=d}_Compute_Funcs(e);d=14;break b}else if(d==388){a=e+284+10;d=unSign(HEAP[e+368],8);b=unSign(HEAP[c]&65535,16);c=unSign(HEAP[c+4]&65535,16);if(_Ins_SxVTL(e,c&65535,b&65535,d,a)!=0){d=14;break b}c=e+284+10;HEAP[X]=HEAP[c];HEAP[ca]=HEAP[c+2];c=e+284+6;HEAP[c]=HEAP[X];HEAP[c+2]=HEAP[$];_Compute_Funcs(e);d=14;break b}else if(d==389){a=e+284+14;d=unSign(HEAP[e+368],8);b=unSign(HEAP[c]&65535,16);c=unSign(HEAP[c+4]&65535,16);if(_Ins_SxVTL(e,c&65535,b&65535,d,a)!=
0){d=14;break b}_Compute_Funcs(e);d=14;break b}else if(d==390){d=HEAP[c+4]&65535;a=reSign(d,16);d=HEAP[c]&65535;c=reSign(d,16);_Normalize(e,c,a,e+284+10);c=e+284+10;HEAP[S]=HEAP[c];HEAP[la]=HEAP[c+2];c=e+284+6;HEAP[c]=HEAP[S];HEAP[c+2]=HEAP[ga];_Compute_Funcs(e);d=14;break b}else if(d==391){d=HEAP[c+4]&65535;a=reSign(d,16);d=HEAP[c]&65535;c=reSign(d,16);_Normalize(e,c,a,e+284+14);_Compute_Funcs(e);d=14;break b}else if(d==392){a=reSign(HEAP[e+284+10],16);HEAP[c]=a;a=reSign(HEAP[e+284+10+2],16);HEAP[c+
4]=a;d=14;break b}else if(d==393){a=reSign(HEAP[e+284+14],16);HEAP[c]=a;a=reSign(HEAP[e+284+14+2],16);HEAP[c+4]=a;d=14;break b}else if(d==394){c=e+284+10;HEAP[U]=HEAP[c];HEAP[ea]=HEAP[c+2];c=e+284+14;HEAP[c]=HEAP[U];HEAP[c+2]=HEAP[Z];_Compute_Funcs(e);d=14;break b}else if(d==395){a=c;c=e;d=a;b=HEAP[d]&65535;a=HEAP[d+4]&65535;f=HEAP[d+8]&65535;j=HEAP[d+12]&65535;d=HEAP[d+16]&65535;t=j;t=unSign(HEAP[c+36+8],16)<=unSign(t,16);c:do if(!t){t=d;if(unSign(HEAP[c+36+8],16)<=unSign(t,16))break c;t=a;if(unSign(HEAP[c+
72+8],16)<=unSign(t,16))break c;t=f;if(unSign(HEAP[c+72+8],16)<=unSign(t,16))break c;t=b;if(unSign(HEAP[c+108+8],16)<=unSign(t,16))break c;t=HEAP[c+36+16];i=unSign(d,16);t=HEAP[t+8*i];i=HEAP[c+36+16];I=unSign(j,16);t=t-HEAP[i+8*I];i=HEAP[c+36+16];I=unSign(d,16);i=HEAP[i+8*I+4];I=HEAP[c+36+16];M=unSign(j,16);i=i-HEAP[I+8*M+4];I=HEAP[c+72+16];M=unSign(f,16);I=HEAP[I+8*M];M=HEAP[c+72+16];K=unSign(a,16);I=I-HEAP[M+8*K];M=HEAP[c+72+16];K=unSign(f,16);M=HEAP[M+8*K+4];K=HEAP[c+72+16];O=unSign(a,16);M=M-
HEAP[K+8*O+4];K=HEAP[c+36+16];O=unSign(j,16);K=HEAP[K+8*O];O=HEAP[c+72+16];P=unSign(a,16);K=K-HEAP[O+8*P];O=HEAP[c+36+16];P=unSign(j,16);O=HEAP[O+8*P+4];P=HEAP[c+72+16];var oa=unSign(a,16);O=O-HEAP[P+8*oa+4];P=HEAP[c+108+24];oa=unSign(b,16);var Fa=HEAP[c+108+24];v=unSign(b,16);HEAP[P+oa]=HEAP[Fa+v]|24;P=_FT_MulDiv(I,0-i,64);oa=P=_FT_MulDiv(M,t,64)+P;Fa=0-oa;oa=reSign(oa,32)>=reSign(0,32)?oa:Fa;if(reSign(oa,32)>reSign(63,32)){d=_FT_MulDiv(K,0-i,64);d=_FT_MulDiv(O,t,64)+d;j=_FT_MulDiv(d,I,P);HEAP[Q]=
j;d=_FT_MulDiv(d,M,P);HEAP[ha]=d;d=HEAP[c+108+16];j=unSign(b,16);d=d+8*j;j=HEAP[c+72+16];f=unSign(a,16);HEAP[d]=HEAP[Q]+HEAP[j+8*f];d=HEAP[c+108+16];b=unSign(b,16);d=d+8*b;c=HEAP[c+72+16];a=unSign(a,16);HEAP[d+4]=HEAP[ia]+HEAP[c+8*a+4]}else{t=HEAP[c+108+16];i=unSign(b,16);t=t+8*i;i=HEAP[c+72+16];I=unSign(a,16);i=HEAP[i+8*I];I=HEAP[c+72+16];M=unSign(f,16);I=HEAP[I+8*M];M=HEAP[c+36+16];K=unSign(j,16);M=HEAP[M+8*K];K=HEAP[c+36+16];O=unSign(d,16);i=Math.floor(reSign(I+i+M+HEAP[K+8*O],32)/reSign(4,32));
HEAP[t]=i;t=HEAP[c+108+16];b=unSign(b,16);b=t+8*b;t=HEAP[c+72+16];a=unSign(a,16);a=HEAP[t+8*a+4];t=HEAP[c+72+16];f=unSign(f,16);f=HEAP[t+8*f+4];t=HEAP[c+36+16];j=unSign(j,16);j=HEAP[t+8*j+4];c=HEAP[c+36+16];d=unSign(d,16);c=Math.floor(reSign(f+a+j+HEAP[c+8*d+4],32)/reSign(4,32));HEAP[b+4]=c}d=14;break b}while(0);if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134;d=14;break b}else if(d==396){HEAP[e+284]=HEAP[c]&65535;d=14;break b}else if(d==397){HEAP[e+284+2]=HEAP[c]&65535;d=14;break b}else if(d==398){HEAP[e+
284+4]=HEAP[c]&65535;d=14;break b}else if(d==399){a=c;c=e;a=a;d=HEAP[a];d=d==0?497:d==1?498:499;if(d==499){if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134;d=14;break b}else if(d==497)_llvm_memcpy_p0i8_p0i8_i32(c+36,c+180,36,4,0);else d==498&&_llvm_memcpy_p0i8_p0i8_i32(c+36,c+144,36,4,0);HEAP[c+284+60]=HEAP[a]&65535;d=14;break b}else if(d==400){a=c;c=e;a=a;d=HEAP[a];d=d==0?500:d==1?501:502;if(d==502){if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134;d=14;break b}else if(d==500)_llvm_memcpy_p0i8_p0i8_i32(c+
72,c+180,36,4,0);else d==501&&_llvm_memcpy_p0i8_p0i8_i32(c+72,c+144,36,4,0);HEAP[c+284+62]=HEAP[a]&65535;d=14;break b}else if(d==401){a=c;c=e;a=a;d=HEAP[a];d=d==0?503:d==1?504:505;if(d==505){if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134;d=14;break b}else if(d==503)_llvm_memcpy_p0i8_p0i8_i32(c+108,c+180,36,4,0);else d==504&&_llvm_memcpy_p0i8_p0i8_i32(c+108,c+144,36,4,0);HEAP[c+284+64]=HEAP[a]&65535;d=14;break b}else if(d==402){a=c;c=e;a=a;d=HEAP[a];d=d==0?506:d==1?507:508;if(d==508){if(HEAP[c+561]==
0){d=14;break b}HEAP[c+12]=134;d=14;break b}else if(d==506)_llvm_memcpy_p0i8_p0i8_i32(c+36,c+180,36,4,0);else d==507&&_llvm_memcpy_p0i8_p0i8_i32(c+36,c+144,36,4,0);_llvm_memcpy_p0i8_p0i8_i32(c+72,c+36,36,4,0);_llvm_memcpy_p0i8_p0i8_i32(c+108,c+36,36,4,0);HEAP[c+284+60]=HEAP[a]&65535;HEAP[c+284+62]=HEAP[a]&65535;HEAP[c+284+64]=HEAP[a]&65535;d=14;break b}else if(d==403){if(reSign(HEAP[c],32)<reSign(0,32))HEAP[e+12]=132;else HEAP[e+284+20]=HEAP[c];d=14;break b}else if(d==404){HEAP[e+284+28]=1;HEAP[e+
568]=_Round_To_Grid.__index__;d=14;break b}else if(d==405){HEAP[e+284+28]=0;HEAP[e+568]=_Round_To_Half_Grid.__index__;d=14;break b}else if(d==406){HEAP[e+284+24]=HEAP[c];d=14;break b}else if(d==31){j=b=e;f=b+368;for(b=31;;){t=b==37?Ra:1;if(_SkipCode(j)==1){d=14;break b}Ra=unSign(HEAP[f],8);if(Ra==88){b=33;d=34}else if(Ra==89){b=33;d=36}else{b=33;d=37}if(d==34){var Ma=t+1;b=34}else if(d==36){var Ka=t-1;b=36}var Ra=b==36?Ka:b==34?Ma:t;if(Ra!=0){b=37;d=32}else{d=14;break b}}}else if(d==407){HEAP[e+360]=
HEAP[c]+HEAP[e+360];if(reSign(HEAP[e+360],32)<reSign(0,32))HEAP[e+12]=132;HEAP[e+376]=0;d=14;break b}else if(d==408){HEAP[e+284+36]=HEAP[c];d=14;break b}else if(d==409){HEAP[e+284+40]=HEAP[c];d=14;break b}else if(d==410){c=reSign(HEAP[c],32)>>reSign(10,32);HEAP[e+284+44]=c;d=14;break b}else if(d==411){HEAP[c+4]=HEAP[c];d=14;break b}else if(d==412){HEAP[e+32]=0;d=14;break b}else if(d==413){a=HEAP[c];HEAP[c]=HEAP[c+4];HEAP[c+4]=a;d=14;break b}else if(d==414){HEAP[c]=HEAP[e+16];d=14;break b}else if(d==
415){a=HEAP[c];d=reSign(a,32)<=reSign(0,32);c:do if(!d){d=a;if(reSign(HEAP[e+28],32)<reSign(d,32))break c;HEAP[c]=HEAP[HEAP[e+24]+4*(HEAP[e+28]-a)];d=14;break b}while(0);HEAP[e+12]=134;d=14;break b}else if(d==416){a=c;c=e;a=a;a=HEAP[a];d=reSign(a,32)<=reSign(0,32);c:do if(!d){d=a;if(reSign(HEAP[c+28],32)<reSign(d,32))break c;d=HEAP[HEAP[c+24]+4*(HEAP[c+28]-a)];_llvm_memmove_p0i8_p0i8_i32(HEAP[c+24]+4*(HEAP[c+28]-a),HEAP[c+24]+4*(HEAP[c+28]+1+(0-a)),a*4+-4,1,0);HEAP[HEAP[c+24]+4*(HEAP[c+28]-1)]=d;
d=14;break b}while(0);HEAP[c+12]=134;d=14;break b}else if(d==417){a=c;c=e;a=a;d=HEAP[a]&65535;a=HEAP[a+4]&65535;b=d;b=unSign(HEAP[c+72+8],16)<=unSign(b,16);c:do if(!b){b=a;if(unSign(HEAP[c+36+8],16)<=unSign(b,16))break c;b=HEAP[c+572];j=HEAP[c+36+16];f=unSign(a,16);j=HEAP[j+8*f+4];f=HEAP[c+72+16];t=unSign(d,16);j=j-HEAP[f+8*t+4];f=HEAP[c+36+16];t=unSign(a,16);f=HEAP[f+8*t];t=HEAP[c+72+16];i=unSign(d,16);b=FUNCTION_TABLE[b](c,f-HEAP[t+8*i],j);b=Math.floor(reSign(b,32)/reSign(2,32));j=HEAP[c+584];d=
unSign(d,16);FUNCTION_TABLE[j](c,c+72,d&65535,b);d=HEAP[c+584];b=0-b;a=unSign(a,16);FUNCTION_TABLE[d](c,c+36,a&65535,b);d=14;break b}while(0);if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134;d=14;break b}else if(d==418){_Ins_UNKNOWN(e,c);d=14;break b}else if(d==419){a=c;c=e;a=a;d=a=HEAP[a]&65535;if(unSign(HEAP[c+36+8],16)<=unSign(d,16)){if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134}else{d=-1;if(HEAP[c+284+14]!=0)d&=-9;if(HEAP[c+284+14+2]!=0)d&=-17;b=HEAP[c+36+24];j=unSign(a,16);c=HEAP[c+36+24];a=unSign(a,
16);HEAP[b+j]=d&HEAP[c+a]}d=14;break b}else if(d==420){a=c;c=e;a=a;d=j=HEAP[a+4];d=unSign(HEAP[c+420]+1,32)<=unSign(d,32);c:do if(!d){b=HEAP[c+404]+16*j;f=HEAP[c+420]+1!=HEAP[c+396];d:do if(f)d=49;else{d=HEAP[b+8]!=j?49:50;break d}while(0);if(d==49){b=HEAP[c+404];f=d=b+16*HEAP[c+396];j=j;t=b;for(b=49;;){b=b==52?Va:0;var Qa=t+16*b;if(Qa>=f)break;if(HEAP[t+16*b+8]==j)break;var Va=b+1;b=52}b=Qa;if(b==d)break c}if(HEAP[b+12]==0)break c;d=HEAP[c+432];if(reSign(HEAP[c+428],32)>=reSign(d,32))HEAP[c+12]=
130;else{if(!(reSign(HEAP[a],32)>reSign(0,32))){d=14;break b}d=HEAP[c+436]+16*HEAP[c+428];HEAP[d]=HEAP[c+352];HEAP[d+4]=HEAP[c+360]+1;HEAP[d+8]=HEAP[a];HEAP[d+12]=HEAP[b+4];HEAP[c+428]+=1;_Ins_Goto_CodeRange(c,HEAP[b],HEAP[b+4]);HEAP[c+376]=0}d=14;break b}while(0);HEAP[c+12]=134;d=14;break b}else if(d==421){a=c;c=e;a=a;a=b=HEAP[a];a=unSign(HEAP[c+420]+1,32)<=unSign(a,32);c:do if(!a){a=HEAP[c+404]+16*b;j=HEAP[c+420]+1!=HEAP[c+396];d:do if(j)d=59;else{d=HEAP[a+8]!=b?59:60;break d}while(0);if(d==59){a=
HEAP[c+404];j=d=a+16*HEAP[c+396];f=b;a=a;for(b=59;;){b=b==62?Ua:0;var Ta=a+16*b;if(Ta>=j)break;if(HEAP[a+16*b+8]==f)break;var Ua=b+1;b=62}a=Ta;if(a==d)break c}if(HEAP[a+12]==0)break c;d=HEAP[c+432];d=reSign(HEAP[c+428],32)>=reSign(d,32);b=c;if(d)HEAP[b+12]=130;else{d=HEAP[b+436]+16*HEAP[c+428];HEAP[d]=HEAP[c+352];HEAP[d+4]=HEAP[c+360]+1;HEAP[d+8]=1;HEAP[d+12]=HEAP[a+4];HEAP[c+428]+=1;_Ins_Goto_CodeRange(c,HEAP[a],HEAP[a+4]);HEAP[c+376]=0}d=14;break b}while(0);HEAP[c+12]=134;d=14;break b}else if(d==
68){a=c;c=e;a=a;d=HEAP[c+404];j=d+16*HEAP[c+396];a=HEAP[a];f=j;t=a;d=d;b=68;c:for(;;){b=b==71?Sa:0;var ab=d+16*b;if(!(ab<f))break c;if(HEAP[d+16*b+8]==t)break c;var Sa=b+1;b=71}d=ab;if(d==j){b=HEAP[c+400];b=unSign(HEAP[c+396],32)>=unSign(b,32);j=c;if(b){HEAP[j+12]=140;d=14;break b}else HEAP[c+396]=HEAP[j+396]+1}b=unSign(a,32)>unSign(65535,32);j=c;if(b)HEAP[j+12]=140;else{HEAP[d]=HEAP[j+352];b=unSign(a&65535,16);HEAP[d+8]=b;HEAP[d+4]=HEAP[c+360]+1;HEAP[d+12]=1;d=a;if(unSign(HEAP[c+420],32)<unSign(d,
32)){a=unSign(a&65535,16);HEAP[c+420]=a}a=c;for(d=c+368;;){if(_SkipCode(a)!=0){d=14;break b}b=unSign(HEAP[d],8);if(b==44)break;else if(b==45){d=14;break b}else if(b==137)break}HEAP[c+12]=137}d=14;break b}else if(d==422){c=e;a=reSign(HEAP[c+428],32)<=reSign(0,32);d=c;if(a)HEAP[d+12]=136;else{HEAP[c+428]=HEAP[d+428]-1;a=HEAP[c+436]+16*HEAP[c+428];HEAP[a+8]-=1;HEAP[c+376]=0;if(reSign(HEAP[a+8],32)>reSign(0,32)){HEAP[c+428]+=1;HEAP[c+360]=HEAP[a+12]}else _Ins_Goto_CodeRange(c,HEAP[a],HEAP[a+4])}d=14;
break b}else if(d==423){a=c;c=e;a=a;d=a=HEAP[a]&65535;d=unSign(HEAP[c+36+8],16)<=unSign(d,16);b=c;if(d){if(HEAP[b+561]==0){d=14;break b}HEAP[c+12]=134}else{if((unSign(HEAP[b+368],8)&1&255)!=0){d=HEAP[c+572];b=HEAP[c+36+16];j=unSign(a,16);b=HEAP[b+8*j+4];j=HEAP[c+36+16];f=unSign(a,16);d=FUNCTION_TABLE[d](c,HEAP[j+8*f],b);d=FUNCTION_TABLE[HEAP[c+568]](c,d,HEAP[c+244+20])-d}else d=0;b=HEAP[c+584];j=unSign(a,16);FUNCTION_TABLE[b](c,c+36,j&65535,d);HEAP[c+284]=a;HEAP[c+284+2]=a}d=14;break b}else if(d==
424){b=e;if(HEAP[b+144+10]==0){d=14;break b}if((unSign(HEAP[b+368],8)&1&255)!=0){I=8;HEAP[N]=HEAP[b+144+12];HEAP[ja]=HEAP[b+144+16];HEAP[fa]=HEAP[b+144+20]}else{I=16;HEAP[N]=HEAP[b+144+12]+4;HEAP[pa]=HEAP[b+144+16]+4;HEAP[ta]=HEAP[b+144+20]+4}c=unSign(HEAP[b+144+8],16);HEAP[ka]=c;c=b+144+28;a=b+144+32;d=b+144+8;j=b+144+8;f=b+144+24;t=I;i=b+144+24;I=I;M=b+144+10;K=unSign(1,16);O=reSign(0,16);b=81;c:for(;;){Ia=b==99?Ia:0;Ya=b==99?Ya:0;P=K+Ia&65535;b=unSign(HEAP[HEAP[c]+2*(O+Ia)],16);oa=unSign(HEAP[a],
16);oa=b-oa;b=unSign(HEAP[d],16);if(unSign(b,32)<=unSign(oa,32)){var $a=unSign(HEAP[j],16)-1;b=83}else b=82;oa=b==83?$a:oa;b=85;d:for(;;){b=b==85?0:eb;var Wa=Ya+b;if(unSign(Wa,32)>unSign(oa,32))break d;if((HEAP[HEAP[f]+Wa]&t)!=0)break d;var eb=b+1;b=87}Fa=unSign(Wa,32)<=unSign(oa,32);d:do if(Fa){v=Wa+1;w=unSign(v,32)<=unSign(oa,32);e:do if(w){w=Wa+1;var Ga=Wa+2;for(b=90;;){bb=b==90?0:bb;Xa=b==90?Wa:Xa;var ob=Ga+bb;b=Wa+bb;var Oa=w+bb;if((HEAP[HEAP[i]+Oa]&I)!=0){__iup_worker_interpolate(N,Xa+1,b,Xa,
Oa);b=92}else b=91;var Xa=b==92?Oa:Xa;b=unSign(ob,32)<=unSign(oa,32);var bb=bb+1;if(b)b=94;else break}if(Xa==Wa){b=95;break e}b=unSign((Xa&65535)+1,16);__iup_worker_interpolate(N,b,oa,Xa,Wa);if(Wa==0){b=97;break d}__iup_worker_interpolate(N,Ya,Wa-1,Xa,Wa);b=105;break d}else b=611;while(0);var jb=b==95?ob:v;w=b==95?Xa:Wa;v=HEAP[HEAP[na]+8*w]-HEAP[HEAP[N]+8*w];if(v==0){b=96;break d}Ga=unSign(Ya,32)<unSign(w,32);e:do if(Ga){b=Ya+1;Oa=(unSign(w,32)>unSign(b,32)?w:b)-Ya;for(b=100;;){Za=b==100?0:Za;b=Ya+
Za;HEAP[HEAP[sa]+8*b]=HEAP[HEAP[wa]+8*b]+v;var Za=Za+1;if(Za!=Oa)b=101;else break e}}while(0);if(!(unSign(w+1,32)<=unSign(oa,32))){b=102;break d}Ga=w+1;w=w+2;for(b=103;;){fb=b==103?0:fb;b=w+fb;Oa=Ga+fb;HEAP[HEAP[Aa]+8*Oa]=HEAP[HEAP[Da]+8*Oa]+v;b=unSign(b,32)<=unSign(oa,32);var fb=fb+1;if(b)b=104;else{b=104;break d}}}else b=88;while(0);var Ya=b==102?jb:b==96?jb:b==105?ob:b==97?ob:b==88?Wa:jb;b=reSign(HEAP[M],16)>reSign(P,16);var Ia=Ia+1;if(b)b=99;else break c}d=14;break b}else if(d==425){b=e;j=HEAP[b+
284+20];j=reSign(HEAP[b+16],32)<reSign(j,32);f=b;if(j){HEAP[f+12]=134;d=14;break b}else{if(_Compute_Point_Displacement(f,J,L,G,H)!=0){d=14;break b}j=b+284+20;f=b;t=f+28;i=b+28;I=b+24;M=b+28;K=b+108+8;O=b+561;P=b+284+20;oa=b+284+20;for(Fa=b;;){if(!(reSign(HEAP[j],32)>reSign(0,32))){d=112;break}HEAP[i]=HEAP[t]-1;w=HEAP[HEAP[I]+4*HEAP[M]]&65535;if(unSign(HEAP[K],16)<=unSign(w,16)){if(HEAP[O]!=0){d=109;break}}else{d=HEAP[L];v=HEAP[J];w=unSign(w,16)&65535;_Move_Zp2_Point(Fa,w,v,d,1)}HEAP[oa]=HEAP[P]-1;
d=108}if(d==112){HEAP[f+284+20]=1;HEAP[b+32]=HEAP[b+28];d=14;break b}else if(d==109){HEAP[b+12]=134;d=14;break b}}}else if(d==426){c=c;a=e;c=c;c=HEAP[c]&65535;d=HEAP[a+144+10];d=unSign(c,16)>=unSign(d,16);b=a;if(d){if(HEAP[b+561]==0){d=14;break b}HEAP[a+12]=134}else{if(_Compute_Point_Displacement(b,E,F,B,D)!=0){d=14;break b}if(c==0)b=0;else{d=HEAP[a+144+28];b=reSign(c,16)-1;b=HEAP[d+2*b]+1+(0-HEAP[a+144+32])}d=HEAP[a+144+28];c=reSign(c,16);c=d=HEAP[d+2*c]-HEAP[a+144+32];if(unSign(HEAP[a+108+8],16)<=
unSign(c,16))d=HEAP[a+108+8]!=0?HEAP[a+108+8]-1:0;b=b;c=d;if(!(unSign(b,16)<=unSign(c,16))){d=14;break b}c=a+108+16;a=a;j=d;f=b;t=f+1;b=117;c:for(;;){cb=b==117?0:cb;b=t+cb;i=f+cb;I=HEAP[ma]!=HEAP[c];d:do if(I)d=119;else{d=HEAP[D]!=i?119:120;break d}while(0);if(d==119){d=HEAP[F];I=HEAP[E];i=unSign(i,16)&65535;_Move_Zp2_Point(a,i,I,d,1)}d=unSign(b,16)<=unSign(j,16);var cb=cb+1;if(d)b=120;else break c}}d=14;break b}else if(d==427){c=c;a=e;c=c;c=unSign(HEAP[c],32)>unSign(1,32);d=a;if(c){if(HEAP[d+561]==
0){d=14;break b}HEAP[a+12]=134}else{if(_Compute_Point_Displacement(d,A,z,x,y)!=0){d=14;break b}c=HEAP[a+284+64]!=0;c:do if(c)d=125;else{if(HEAP[a+108+8]==0){d=125;break c}C=HEAP[a+108+8]-1;d=127;break c}while(0);c:do if(d==125){C=HEAP[a+284+64]!=1;d:do if(!C){if(reSign(HEAP[a+108+10],16)<=reSign(0,16)){d=128;break d}C=HEAP[a+108+28];c=reSign(HEAP[a+108+10],16)-1;c=C=HEAP[C+2*c];if(!(unSign(HEAP[a+108+8],16)<=unSign(c,16)))break c;if(HEAP[a+561]==0){d=14;break b}HEAP[a+12]=134;d=14;break b}while(0);
C=0}while(0);c=C;if(!(unSign(0,16)<=unSign(c,16))){d=14;break b}c=a+108+16;a=a;j=C;b=133;c:for(;;){pb=b==133?0:pb;b=1+pb;f=0+pb;t=HEAP[ya]!=HEAP[c];d:do if(t)d=135;else{d=HEAP[y]!=f?135:136;break d}while(0);if(d==135){d=HEAP[z];t=HEAP[A];f=unSign(f,16)&65535;_Move_Zp2_Point(a,f,t,d,0)}d=unSign(b,16)<=unSign(j,16);var pb=pb+1;if(d)b=136;else break c}}d=14;break b}else if(d==428){j=c;b=e;j=j;f=HEAP[b+284+20]+1;f=reSign(HEAP[b+16],32)<reSign(f,32);t=b;if(f){HEAP[t+12]=134;d=14;break b}else{f=reSign(HEAP[t+
284+14],16);v=_TT_MulFix14(HEAP[j],f);f=reSign(HEAP[b+284+14+2],16);w=_TT_MulFix14(HEAP[j],f);j=b+284+20;f=b;t=f+28;i=b+28;I=b+24;M=b+28;K=b+108+8;O=b+561;P=b+284+20;oa=b+284+20;Fa=b;v=v;for(w=w;;){if(!(reSign(HEAP[j],32)>reSign(0,32))){d=143;break}HEAP[i]=HEAP[t]-1;d=HEAP[HEAP[I]+4*HEAP[M]]&65535;if(unSign(HEAP[K],16)<=unSign(d,16)){if(HEAP[O]!=0){d=140;break}}else{d=unSign(d,16)&65535;_Move_Zp2_Point(Fa,d,v,w,1)}HEAP[oa]=HEAP[P]-1;d=139}if(d==143){HEAP[f+284+20]=1;HEAP[b+32]=HEAP[b+28];d=14;break b}else if(d==
140){HEAP[b+12]=134;d=14;break b}}}else if(d==429){j=e;d=HEAP[j+284+20];d=reSign(HEAP[j+16],32)<reSign(d,32);b=j;if(d){HEAP[b+12]=134;d=14;break b}else{b=HEAP[b+284+60]==0;c:do if(b)d=144;else{if(HEAP[j+284+62]==0){d=144;break c}if(HEAP[j+284+64]==0){d=144;break c}q=0;d=148;break c}while(0);if(d==144)q=1;f=q;d=HEAP[j+36+8];if(unSign(HEAP[j+284+2],16)>=unSign(d,16)){if(HEAP[j+561]==0){d=14;break b}HEAP[j+12]=134;d=14;break b}else{d=j+36;if(f!=0){d=HEAP[d+12];b=unSign(HEAP[j+284+2],16);b=d+8*b}else{d=
HEAP[d+20];b=unSign(HEAP[j+284+2],16);b=d+8*b}d=HEAP[j+36+16];t=unSign(HEAP[j+284+2],16);t=d+8*t;d=HEAP[j+36+8];i=unSign(HEAP[j+284+2],16)>=unSign(d,16);c:do if(i)d=151;else{d=HEAP[j+72+8];if(unSign(HEAP[j+284+4],16)>=unSign(d,16)){d=151;break c}s=HEAP[j+576];u=j+72;if(f!=0){u=HEAP[u+12];d=unSign(HEAP[j+284+4],16);u=HEAP[u+8*d+4]-HEAP[b+4];d=HEAP[j+72+12];i=unSign(HEAP[j+284+4],16);s=FUNCTION_TABLE[s](j,HEAP[d+8*i]-HEAP[b],u)}else{u=HEAP[u+20];d=unSign(HEAP[j+284+4],16);u=HEAP[u+8*d+4]-HEAP[b+4];
d=HEAP[j+72+20];i=unSign(HEAP[j+284+4],16);s=FUNCTION_TABLE[s](j,HEAP[d+8*i]-HEAP[b],u)}u=HEAP[j+572];d=HEAP[j+72+16];i=unSign(HEAP[j+284+4],16);d=HEAP[d+8*i+4]-HEAP[t+4];i=HEAP[j+72+16];I=unSign(HEAP[j+284+4],16);u=FUNCTION_TABLE[u](j,HEAP[i+8*I]-HEAP[t],d);d=155;break c}while(0);if(d==151)u=s=0;f=f!=0;i=b+4;I=b;M=t+4;t=t;K=u;O=s;P=b+4;oa=b;for(Fa=s!=0^1;;){d=reSign(HEAP[j+284+20],32)>reSign(0,32);var gb=j;if(!d){d=165;break}d=HEAP[gb+24];HEAP[j+28]-=1;d=HEAP[d+4*HEAP[j+28]];b=unSign(HEAP[j+108+
8],16);b=unSign(b,32)<=unSign(d,32);v=j;if(b){if(HEAP[v+561]!=0){d=157;break}}else{b=HEAP[v+576];v=j+108;if(f){var hb=FUNCTION_TABLE[b](j,HEAP[HEAP[j+108+12]+8*d]-HEAP[I],HEAP[HEAP[v+12]+8*d+4]-HEAP[i]);b=159}else{var kb=FUNCTION_TABLE[b](j,HEAP[HEAP[j+108+20]+8*d]-HEAP[oa],HEAP[HEAP[v+20]+8*d+4]-HEAP[P]);b=161}b=b==161?kb:hb;v=FUNCTION_TABLE[HEAP[j+572]](j,HEAP[HEAP[j+108+16]+8*d]-HEAP[t],HEAP[HEAP[j+108+16]+8*d+4]-HEAP[M]);w=(Ga=b!=0^1)?0:v;if(Ga|Fa)b=646;else{var db=_FT_MulDiv(b,K,O);b=162}Ga=
HEAP[j+584];b=(b==162?db:w)-v;d=unSign(d&65535,16);FUNCTION_TABLE[Ga](j,j+108,d&65535,b)}HEAP[j+284+20]-=1;d=156}if(d==165){HEAP[gb+284+20]=1;HEAP[j+32]=HEAP[j+28];d=14;break b}else if(d==157){HEAP[j+12]=134;d=14;break b}}}}else if(d==430){a=c;c=e;d=a;b=a=HEAP[d]&65535;b=unSign(HEAP[c+72+8],16)<=unSign(b,16);c:do if(!b){b=HEAP[c+36+8];if(unSign(HEAP[c+284],16)>=unSign(b,16))break c;if(HEAP[c+284+62]==0){b=HEAP[c+72+12];j=unSign(a,16);f=HEAP[c+36+12];t=unSign(HEAP[c+284],16);f=f+8*t;HEAP[r]=HEAP[f];
HEAP[qa]=HEAP[f+4];b=b+8*j;HEAP[b]=HEAP[r];HEAP[b+4]=HEAP[ua];b=HEAP[c+588];j=HEAP[d+4];f=unSign(a,16);FUNCTION_TABLE[b](c,c+72,f&65535,j);b=HEAP[c+72+16];j=unSign(a,16);f=HEAP[c+72+12];t=unSign(a,16);f=f+8*t;HEAP[p]=HEAP[f];HEAP[Ba]=HEAP[f+4];b=b+8*j;HEAP[b]=HEAP[p];HEAP[b+4]=HEAP[Na]}b=HEAP[c+572];j=HEAP[c+72+16];f=unSign(a,16);j=HEAP[j+8*f+4];f=HEAP[c+36+16];t=unSign(HEAP[c+284],16);j=j-HEAP[f+8*t+4];f=HEAP[c+72+16];t=unSign(a,16);f=HEAP[f+8*t];t=HEAP[c+36+16];i=unSign(HEAP[c+284],16);j=FUNCTION_TABLE[b](c,
f-HEAP[t+8*i],j);b=HEAP[c+584];d=HEAP[d+4]-j;j=unSign(a,16);FUNCTION_TABLE[b](c,c+72,j&65535,d);HEAP[c+284+2]=HEAP[c+284];HEAP[c+284+4]=a;if((unSign(HEAP[c+368],8)&1&255)==0){d=14;break b}HEAP[c+284]=a;d=14;break b}while(0);if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134;d=14;break b}else if(d==431){c=e;a=HEAP[c+284+20];a=reSign(HEAP[c+16],32)<reSign(a,32);c:do if(!a){b=HEAP[c+36+8];if(unSign(HEAP[c+284],16)>=unSign(b,16))break c;for(;;){d=reSign(HEAP[c+284+20],32)>reSign(0,32);var ub=c;if(!d){d=177;
break}HEAP[c+28]=HEAP[ub+28]-1;d=HEAP[HEAP[c+24]+4*HEAP[c+28]]&65535;b=unSign(HEAP[c+72+8],16)<=unSign(d,16);j=c;if(b){if(HEAP[j+561]!=0){d=174;break}}else{b=HEAP[j+572];j=HEAP[c+72+16];f=unSign(d,16);j=HEAP[j+8*f+4];f=HEAP[c+36+16];t=unSign(HEAP[c+284],16);j=j-HEAP[f+8*t+4];f=HEAP[c+72+16];t=unSign(d,16);f=HEAP[f+8*t];t=HEAP[c+36+16];i=unSign(HEAP[c+284],16);j=FUNCTION_TABLE[b](c,f-HEAP[t+8*i],j);b=HEAP[c+584];j=0-j;d=unSign(d,16);FUNCTION_TABLE[b](c,c+72,d&65535,j)}HEAP[c+284+20]-=1;d=172}if(d==
177){HEAP[ub+284+20]=1;HEAP[c+32]=HEAP[c+28];d=14;break b}else if(d==174){HEAP[c+12]=134;d=14;break b}}while(0);if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134;d=14;break b}else if(d==432){HEAP[e+284+28]=2;HEAP[e+568]=_Round_To_Double_Grid.__index__;d=14;break b}else if(d==433){a=c;c=e;a=a;d=HEAP[a+4];b=a=HEAP[a]&65535;b=unSign(HEAP[c+36+8],16)<=unSign(b,16);c:do if(!b){b=d;if(unSign(HEAP[c+380],32)<=unSign(b,32))break c;d=FUNCTION_TABLE[HEAP[c+592]](c,d);if(HEAP[c+284+60]==0){b=HEAP[c+36+12];j=unSign(a,
16);b=b+8*j;j=reSign(HEAP[c+284+14],16);j=_TT_MulFix14(d,j);HEAP[b]=j;b=HEAP[c+36+12];j=unSign(a,16);b=b+8*j;j=reSign(HEAP[c+284+14+2],16);j=_TT_MulFix14(d,j);HEAP[b+4]=j;b=HEAP[c+36+16];j=unSign(a,16);f=HEAP[c+36+12];t=unSign(a,16);f=f+8*t;HEAP[n]=HEAP[f];HEAP[Ea]=HEAP[f+4];b=b+8*j;HEAP[b]=HEAP[n];HEAP[b+4]=HEAP[ra]}b=HEAP[c+572];j=HEAP[c+36+16];f=unSign(a,16);j=HEAP[j+8*f+4];f=HEAP[c+36+16];t=unSign(a,16);b=FUNCTION_TABLE[b](c,HEAP[f+8*t],j);if((unSign(HEAP[c+368],8)&1&255)!=0){j=d-b;f=0-j;j=reSign(j,
32)>=reSign(0,32)?j:f;f=HEAP[c+284+36];if(reSign(j,32)>reSign(f,32))d=b;d=FUNCTION_TABLE[HEAP[c+568]](c,d,HEAP[c+244+20])}j=HEAP[c+584];d=d-b;b=unSign(a,16);FUNCTION_TABLE[j](c,c+36,b&65535,d);HEAP[c+284]=a;HEAP[c+284+2]=a;d=14;break b}while(0);if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134;d=14;break b}else if(d==434){a=c;c=e;b=a;a=unSign(HEAP[HEAP[c+356]+(HEAP[c+360]+1)],8);d=unSign(a,16);j=HEAP[c+20]+1+(0-HEAP[c+16]);if(unSign(d,32)>=unSign(j,32))HEAP[c+12]=130;else{d=a;if(unSign(1,16)<=unSign(d,
16)){d=c+356;j=c+360;f=b;t=a;for(b=184;;){yb=b==184?0:yb;M=1+yb;b=2+yb;i=unSign(M,16)-1;I=HEAP[d];K=HEAP[j];M=unSign(M,16)+1+K;I=unSign(HEAP[I+M],8);HEAP[f+4*i]=I;b=unSign(b,16)<=unSign(t,16);var yb=yb+1;if(b)b=185;else break}}d=HEAP[c+32];a=unSign(a,16)+d;HEAP[c+32]=a}d=14;break b}else if(d==435){a=c;c=e;d=a;a=unSign(HEAP[HEAP[c+356]+(HEAP[c+360]+1)],8);b=unSign(a,16);j=HEAP[c+20]+1+(0-HEAP[c+16]);b=unSign(b,32)>=unSign(j,32);j=c;if(b)HEAP[j+12]=130;else{HEAP[c+360]=HEAP[j+360]+2;b=a;if(unSign(0,
16)<unSign(b,16)){b=c;d=d;K=a;unSign(K,16);unSign(1,16);j=b+360;f=b+360;t=b+356;i=b+360;I=b+356;M=b+360;K=(unSign(K,16)>unSign(1,16)?K:1)-0;for(b=188;;){rb=b==188?0:rb;b=unSign(0+rb,16);HEAP[f]=HEAP[j]+2;O=unSign(HEAP[HEAP[t]+(HEAP[i]-2)],8)*256;O=unSign(HEAP[HEAP[I]+(HEAP[M]-1)],8)+O;O=reSign(O,16)&65535;O=reSign(O,16);HEAP[d+4*b]=O;var rb=rb+1;if(rb!=K)b=189;else break}}HEAP[c+376]=0;d=HEAP[c+32];a=unSign(a,16)+d;HEAP[c+32]=a}d=14;break b}else if(d==436){a=HEAP[c];d=unSign(HEAP[e+468],16);b=a;d=
unSign(d,32)<=unSign(b,32);b=e;if(d)d=HEAP[b+561]!=0?192:14;else{HEAP[HEAP[b+472]+4*a]=HEAP[c+4];d=14}break b}else if(d==437){a=HEAP[c];d=unSign(HEAP[e+468],16);b=a;d=unSign(d,32)<=unSign(b,32);b=e;if(d){if(HEAP[b+561]!=0){d=192;break b}HEAP[c]=0}else HEAP[c]=HEAP[HEAP[b+472]+4*a];d=14;break b}else if(d==438){d=a=HEAP[c];d=unSign(HEAP[e+380],32)<=unSign(d,32);b=e;if(d)d=HEAP[b+561]!=0?192:14;else{FUNCTION_TABLE[HEAP[b+596]](e,a,HEAP[c+4]);d=14}break b}else if(d==439){d=a=HEAP[c];d=unSign(HEAP[e+380],
32)<=unSign(d,32);b=e;if(d){if(HEAP[b+561]!=0){d=192;break b}HEAP[c]=0}else{a=FUNCTION_TABLE[HEAP[b+592]](e,a);HEAP[c]=a}d=14;break b}else if(d==440){a=c;c=e;a=a;d=HEAP[a];b=unSign(HEAP[c+108+8],16);j=d;b=unSign(b,32)<=unSign(j,32);j=c;if(b)if(HEAP[j+561]!=0){HEAP[c+12]=134;d=14;break b}else c=0;else{b=(unSign(HEAP[j+368],8)&1&255)!=0;j=c;c=b?FUNCTION_TABLE[HEAP[j+576]](c,HEAP[HEAP[c+108+12]+8*d],HEAP[HEAP[c+108+12]+8*d+4]):FUNCTION_TABLE[HEAP[j+572]](c,HEAP[HEAP[c+108+16]+8*d],HEAP[HEAP[c+108+16]+
8*d+4])}HEAP[a]=c;d=14;break b}else if(d==441){a=c;c=e;d=a;b=a=HEAP[d]&65535;b=unSign(HEAP[c+108+8],16)<=unSign(b,16);j=c;if(b){if(HEAP[j+561]==0){d=14;break b}HEAP[c+12]=134}else{b=HEAP[j+572];j=HEAP[c+108+16];f=unSign(a,16);j=HEAP[j+8*f+4];f=HEAP[c+108+16];t=unSign(a,16);j=FUNCTION_TABLE[b](c,HEAP[f+8*t],j);b=HEAP[c+584];d=HEAP[d+4]-j;j=unSign(a,16);FUNCTION_TABLE[b](c,c+108,j&65535,d);if(HEAP[c+284+64]!=0){d=14;break b}d=HEAP[c+108+12];b=unSign(a,16);c=HEAP[c+108+16];a=unSign(a,16);c=c+8*a;HEAP[o]=
HEAP[c];HEAP[za]=HEAP[c+4];c=d+8*b;HEAP[c]=HEAP[o];HEAP[c+4]=HEAP[Ha]}d=14;break b}else if(d==442){a=c;c=e;a=a;b=HEAP[a+4]&65535;d=j=HEAP[a]&65535;f=unSign(HEAP[c+36+8],16)<=unSign(d,16);c:do if(f)d=199;else{d=b;if(unSign(HEAP[c+72+8],16)<=unSign(d,16)){d=199;break c}l=(unSign(HEAP[c+368],8)&1&255)!=0;d=c;if(l){l=HEAP[d+572];d=HEAP[c+36+16];f=unSign(j,16);d=HEAP[d+8*f+4];f=HEAP[c+72+16];t=unSign(b,16);d=d-HEAP[f+8*t+4];f=HEAP[c+36+16];j=unSign(j,16);j=HEAP[f+8*j];f=HEAP[c+72+16];b=unSign(b,16);l=
FUNCTION_TABLE[l](c,j-HEAP[f+8*b],d)}else{l=HEAP[d+36+20];d=unSign(j,16);l=l+8*d;d=HEAP[c+72+20];b=unSign(b,16);d=d+8*b;b=c;if(HEAP[c+216+4]==HEAP[c+216+8]){l=FUNCTION_TABLE[HEAP[b+576]](c,HEAP[l]-HEAP[d],HEAP[l+4]-HEAP[d+4]);l=_FT_MulFix(l,HEAP[c+216+4])}else{b=_FT_MulFix(HEAP[l]-HEAP[d],HEAP[b+216+4]);HEAP[m]=b;l=_FT_MulFix(HEAP[l+4]-HEAP[d+4],HEAP[c+216+8]);HEAP[Ca]=l;l=FUNCTION_TABLE[HEAP[c+576]](c,HEAP[m],HEAP[va])}}d=202;break c}while(0);if(d==199)if(HEAP[c+561]!=0){HEAP[c+12]=134;d=14;break b}else l=
0;HEAP[a]=l;d=14;break b}else if(d==443){d=e;a=_Current_Ratio(d);d=unSign(HEAP[d+244+8],16);a=a=_FT_MulFix(d,a);HEAP[c]=a;d=14;break b}else if(d==444){d=e;a=_Current_Ratio(d);d=unSign(HEAP[d+244+8],16);a=a=_FT_MulFix(d,a);HEAP[c]=a;d=14;break b}else if(d==445){HEAP[e+284+32]=1;d=14;break b}else if(d==446){HEAP[e+284+32]=0;d=14;break b}else if(d==447){HEAP[e+12]=135;d=14;break b}else if(d==448){a=HEAP[c+4];a=reSign(HEAP[c],32)<reSign(a,32);a=unSign(a,1);HEAP[c]=a;d=14;break b}else if(d==449){a=HEAP[c+
4];a=reSign(HEAP[c],32)<=reSign(a,32);a=unSign(a,1);HEAP[c]=a;d=14;break b}else if(d==450){a=HEAP[c+4];a=reSign(HEAP[c],32)>reSign(a,32);a=unSign(a,1);HEAP[c]=a;d=14;break b}else if(d==451){a=HEAP[c+4];a=reSign(HEAP[c],32)>=reSign(a,32);a=unSign(a,1);HEAP[c]=a;d=14;break b}else if(d==452){a=unSign(HEAP[c]==HEAP[c+4],1);HEAP[c]=a;d=14;break b}else if(d==453){a=unSign(HEAP[c]!=HEAP[c+4],1);HEAP[c]=a;d=14;break b}else if(d==454){a=(FUNCTION_TABLE[HEAP[e+568]](e,HEAP[c],0)&127)==64;a=unSign(a,1);HEAP[c]=
a;d=14;break b}else if(d==455){a=(FUNCTION_TABLE[HEAP[e+568]](e,HEAP[c],0)&127)==0;a=unSign(a,1);HEAP[c]=a;d=14;break b}else if(d==456){c=c;a=e;c=c;if(HEAP[c]!=0){d=14;break b}c=a;a=a+368;for(b=203;;){j=b==211?0:0;f=b==211?xb:1;if(_SkipCode(c)==1)break;xb=unSign(HEAP[a],8);if(xb==27){b=206;d=209}else if(xb==88){b=206;d=207}else if(xb==89){b=206;d=210}else{b=206;d=211}if(d==209){var zb=unSign(f==1,1);b=209}else if(d==207){var Fb=f+1;b=207}else if(d==210){var Ib=f-1,qb=unSign(Ib==0,1);b=210}var xb=
b==210?Ib:b==209?f:b==206?f:Fb;if((b==210?qb:b==209?zb:b==206?j:j)==0)b=211;else break}d=14;break b}else if(d==457){a=HEAP[c]==0;c:do if(a)d=212;else{if(HEAP[c+4]==0){d=212;break c}V=1;d=214;break c}while(0);if(d==212)V=0;HEAP[c]=V;d=14;break b}else if(d==458){a=HEAP[c]!=0;c:do if(a)d=216;else{if(HEAP[c+4]!=0){d=216;break c}T=0;d=219;break c}while(0);if(d==216)T=1;HEAP[c]=T;d=14;break b}else if(d==459){a=unSign(HEAP[c]==0,1);HEAP[c]=a;d=14;break b}else if(d==460){_Ins_DELTAP(e,c);d=14;break b}else if(d==
461){HEAP[e+284+48]=HEAP[c]&65535;d=14;break b}else if(d==462){HEAP[e+284+50]=HEAP[c]&65535;d=14;break b}else if(d==463){HEAP[c]=HEAP[c+4]+HEAP[c];d=14;break b}else if(d==464){HEAP[c]-=HEAP[c+4];d=14;break b}else if(d==465){if(HEAP[c+4]==0)HEAP[e+12]=133;else{a=_FT_MulDiv_No_Round(HEAP[c],64,HEAP[c+4]);HEAP[c]=a}d=14;break b}else if(d==466){a=_FT_MulDiv(HEAP[c],HEAP[c+4],64);HEAP[c]=a;d=14;break b}else if(d==467){a=HEAP[c];d=0-a;a=reSign(a,32)>=reSign(0,32)?a:d;HEAP[c]=a;d=14;break b}else if(d==468){HEAP[c]=
0-HEAP[c];d=14;break b}else if(d==469){HEAP[c]&=-64;d=14;break b}else if(d==470){HEAP[c]=HEAP[c]+63&-64;d=14;break b}else if(d==471){a=HEAP[e+568];d=unSign(HEAP[e+368],8)-104;a=FUNCTION_TABLE[a](e,HEAP[c],HEAP[e+244+20+d*4]);HEAP[c]=a;d=14;break b}else if(d==472){a=unSign(HEAP[e+368],8)-108;b=HEAP[e+244+20+a*4];a=d=HEAP[c];j=b;d=reSign(d,32)>=reSign(0,32);b=a;f=j;c:do{if(d){j=f+b;if(a==0)break c;if(!(reSign(j,32)<reSign(0,32)))break c}else{j=b-f;if(!(reSign(j,32)>reSign(0,32)))break c}j=0}while(0);
a=a=j;HEAP[c]=a;d=14;break b}else if(d==473){d=a=HEAP[c];d=unSign(HEAP[e+380],32)<=unSign(d,32);b=e;if(d)d=HEAP[b+561]!=0?192:14;else{d=HEAP[b+384];c=_FT_MulFix(HEAP[c+4],HEAP[e+244+16]);HEAP[d+4*a]=c;d=14}break b}else if(d==474){_Ins_DELTAP(e,c);d=14;break b}else if(d==225){b=c;j=e;b=b;f=b=HEAP[b];t=j+28;i=j;I=i+28;M=j+28;K=j+24;O=j+28;P=j+24;oa=j+28;Fa=j+380;v=j+561;w=j+368;Ga=j+284+48;Oa=j;var Jb=j+284+50,Hb=j+600,Nb=j,lb=Oa+244+8;b=225;c:for(;;){var Gb=b==235?mb:0;d=unSign(1+Gb,32)<=unSign(f,
32);var vb=HEAP[t];if(!d){d=237;break c}if(reSign(vb,32)<=reSign(1,32)){d=227;break c}HEAP[M]=HEAP[I]-2;var tb=HEAP[HEAP[K]+4*(HEAP[O]+1)],Kb=HEAP[HEAP[P]+4*HEAP[oa]],ib=unSign(HEAP[Fa],32)<=unSign(tb,32);d:do if(ib){if(HEAP[v]!=0){d=229;break c}}else{var wb=unSign(Kb&240,32)>>>unSign(4,32);d=unSign(HEAP[w],8);if(d==116){b=510;d=231}else if(d==117){b=510;d=233}else{b=510;d=511}if(d==231){var Mb=wb+16;b=231}else if(d==233){var Ab=wb+32;b=233}d=b==233?Ab:b==231?Mb:wb;d=reSign(HEAP[Ga],16)+d;b=_Current_Ratio(Oa);
wb=unSign(HEAP[lb],16);if(_FT_MulFix(wb,b)!=d)break d;d=(Kb&15)-8;b=d+1;d=(reSign(d,32)>=reSign(0,32)?b:d)*64;b=1<<reSign(HEAP[Jb],16);d=Math.floor(reSign(d,32)/reSign(b,32));FUNCTION_TABLE[HEAP[Hb]](Nb,tb,d)}while(0);var mb=Gb+1;b=235;d=226}if(d==237){HEAP[j+32]=vb;d=14;break b}else if(d==227){HEAP[i+12]=129;d=14;break b}else if(d==229){HEAP[j+12]=134;d=14;break b}}else if(d==475){_SetSuperRound(e,16384,HEAP[c]);HEAP[e+284+28]=6;HEAP[e+568]=_Round_Super.__index__;d=14;break b}else if(d==476){_SetSuperRound(e,
11585,HEAP[c]);HEAP[e+284+28]=7;HEAP[e+568]=_Round_Super_45.__index__;d=14;break b}else if(d==477){if(HEAP[c+4]==0){d=14;break b}HEAP[e+360]=HEAP[c]+HEAP[e+360];if(reSign(HEAP[e+360],32)<reSign(0,32))HEAP[e+12]=132;HEAP[e+376]=0;d=14;break b}else if(d==478){if(HEAP[c+4]!=0){d=14;break b}HEAP[e+360]=HEAP[c]+HEAP[e+360];if(reSign(HEAP[e+360],32)<reSign(0,32))HEAP[e+12]=132;HEAP[e+376]=0;d=14;break b}else if(d==479){HEAP[e+284+28]=5;HEAP[e+568]=_Round_None.__index__;d=14;break b}else if(d==480){_Ins_UNKNOWN(e,
c);d=14;break b}else if(d==481){HEAP[e+284+28]=4;HEAP[e+568]=_Round_Up_To_Grid.__index__;d=14;break b}else if(d==482){HEAP[e+284+28]=3;HEAP[e+568]=_Round_Down_To_Grid.__index__;d=14;break b}else if(d==483){b=e;j=HEAP[b+284+20];j=reSign(HEAP[b+16],32)<reSign(j,32);f=b;if(j){HEAP[f+12]=129;d=14;break b}else{j=f+284+20;f=b;t=f+28;i=b+28;I=b+24;M=b+28;K=b+144+8;Fa=b;O=Fa+561;P=b+284+20;oa=b+284+20;Fa=Fa+144+24;for(v=b+144+24;;){if(!(reSign(HEAP[j],32)>reSign(0,32))){d=246;break}HEAP[i]=HEAP[t]-1;Oa=HEAP[HEAP[I]+
4*HEAP[M]]&65535;if(unSign(HEAP[K],16)<=unSign(Oa,16)){if(HEAP[O]!=0){d=243;break}}else{d=HEAP[Fa];w=unSign(Oa,16);Ga=HEAP[v];Oa=unSign(Oa,16);HEAP[d+w]=HEAP[Ga+Oa]^1}HEAP[oa]=HEAP[P]-1;d=242}if(d==246){HEAP[f+284+20]=1;HEAP[b+32]=HEAP[b+28];d=14;break b}else if(d==243){HEAP[b+12]=134;d=14;break b}}}else if(d==484){c=c;a=e;c=c;d=HEAP[c+4]&65535;c=HEAP[c]&65535;b=d;b=unSign(HEAP[a+144+8],16)<=unSign(b,16);c:do if(!b){b=c;if(unSign(HEAP[a+144+8],16)<=unSign(b,16))break c;b=c;c=d;if(!(unSign(b,16)<=
unSign(c,16))){d=14;break b}c=a+144+24;a=a+144+24;d=d;j=b;f=j+1;for(b=250;;){Bb=b==250?0:Bb;M=j+Bb;b=f+Bb;t=HEAP[c];i=unSign(M,16);I=HEAP[a];M=unSign(M,16);HEAP[t+i]=HEAP[I+M]|1;b=unSign(b,16)<=unSign(d,16);var Bb=Bb+1;if(b)b=251;else break}d=14;break b}while(0);if(HEAP[a+561]==0){d=14;break b}HEAP[a+12]=134;d=14;break b}else if(d==485){c=c;a=e;c=c;d=HEAP[c+4]&65535;c=HEAP[c]&65535;b=d;b=unSign(HEAP[a+144+8],16)<=unSign(b,16);c:do if(!b){b=c;if(unSign(HEAP[a+144+8],16)<=unSign(b,16))break c;b=c;c=
d;if(!(unSign(b,16)<=unSign(c,16))){d=14;break b}c=a+144+24;a=a+144+24;d=d;j=b;f=j+1;for(b=256;;){nb=b==256?0:nb;M=j+nb;b=f+nb;t=HEAP[c];i=unSign(M,16);I=HEAP[a];M=unSign(M,16);HEAP[t+i]=HEAP[I+M]&-2;b=unSign(b,16)<=unSign(d,16);var nb=nb+1;if(b)b=257;else break}d=14;break b}while(0);if(HEAP[a+561]==0){d=14;break b}HEAP[a+12]=134;d=14;break b}else if(d==486){_Ins_UNKNOWN(e,c);d=14;break b}else if(d==487){a=c;c=e;a=a;d=HEAP[a]&255;if(d==255)HEAP[c+284+53]=1;else{if(d!=0){b=(HEAP[a]&256)!=0;c:do if(b){j=
unSign(HEAP[c+244+8],16);f=d;if(!(reSign(j,32)<=reSign(f,32)))break c;HEAP[c+284+53]=1}while(0);b=(HEAP[a]&512)!=0;c:do if(b){if(HEAP[c+244+37]==0)break c;HEAP[c+284+53]=1}while(0);b=(HEAP[a]&1024)!=0;c:do if(b){if(HEAP[c+244+38]==0)break c;HEAP[c+284+53]=1}while(0);b=(HEAP[a]&2048)!=0;c:do if(b){j=unSign(HEAP[c+244+8],16);f=d;if(!(reSign(j,32)>reSign(f,32)))break c;HEAP[c+284+53]=0}while(0);d=(HEAP[a]&4096)!=0;c:do if(d){if(HEAP[c+244+37]==0)break c;HEAP[c+284+53]=0}while(0);if((HEAP[a]&8192)==0){d=
14;break b}if(HEAP[c+244+38]==0){d=14;break b}}HEAP[c+284+53]=0}d=14;break b}else if(d==488){a=c;c=e;d=a;a=HEAP[d+4]&65535;b=d=HEAP[d]&65535;b=unSign(HEAP[c+72+8],16)<=unSign(b,16);c:do if(!b){b=a;if(unSign(HEAP[c+108+8],16)<=unSign(b,16))break c;b=HEAP[c+72+12];j=unSign(d,16);j=b+8*j;b=HEAP[c+108+12];f=unSign(a,16);f=b+8*f;b=HEAP[j]-HEAP[f];j=HEAP[j+4]-HEAP[f+4];if((unSign(HEAP[c+368],8)&1&255)!=0){f=j;j=b;b=0-f}_Normalize(c,b,j,c+284+6);b=HEAP[c+72+16];d=unSign(d,16);d=b+8*d;b=HEAP[c+108+16];a=
unSign(a,16);a=b+8*a;b=HEAP[d]-HEAP[a];j=HEAP[d+4]-HEAP[a+4];if((unSign(HEAP[c+368],8)&1&255)!=0){f=j;j=b;b=0-f}_Normalize(c,b,j,c+284+10);_Compute_Funcs(c);d=14;break b}while(0);if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134;d=14;break b}else if(d==489){a=c;c=e;a=a;d=0;if((HEAP[a]&1&255)!=0)d=35;b=(HEAP[a]&2)!=0;c:do if(b){if(HEAP[c+244+37]==0)break c;d|=128}while(0);b=(HEAP[a]&4)!=0;c:do if(b){if(HEAP[c+244+38]==0)break c;d|=256}while(0);b=(HEAP[a]&32)!=0;c:do if(b){if(HEAP[c+604]==0)break c;d|=
4096}while(0);HEAP[a]=d;d=14;break b}else if(d==291){a=c;c=e;a=a;d=HEAP[c+416];f=j=d+16*HEAP[c+408];t=a;d=d;b=291;c:for(;;){b=b==294?Db:0;var sb=d+16*b;if(!(sb<f))break c;if(HEAP[d+16*b+8]==HEAP[t])break c;var Db=b+1;b=294}d=sb;if(d==j){b=HEAP[c+412];b=unSign(HEAP[c+408],32)>=unSign(b,32);j=c;if(b){HEAP[j+12]=141;d=14;break b}else HEAP[c+408]=HEAP[j+408]+1}b=reSign(HEAP[a],32)<reSign(0,32);c:do if(!b){if(reSign(HEAP[a],32)>reSign(255,32))break c;b=unSign(HEAP[a]&255,8);HEAP[d+8]=b;HEAP[d+4]=HEAP[c+
360]+1;HEAP[d]=HEAP[c+352];HEAP[d+12]=1;d=HEAP[c+424];if(unSign(HEAP[a],32)>unSign(d,32)){a=unSign(HEAP[a]&255,8);HEAP[c+424]=a}a=c;for(d=c+368;;){if(_SkipCode(a)!=0){d=14;break b}b=unSign(HEAP[d],8);if(b==44)break;else if(b==45){d=14;break b}else if(b==137)break}HEAP[c+12]=137;d=14;break b}while(0);HEAP[c+12]=141;d=14;break b}else if(d==490){c=c;a=HEAP[c+8];d=HEAP[c+4];b=HEAP[c];HEAP[c+8]=b;HEAP[c+4]=a;HEAP[c]=d;d=14;break b}else if(d==491){a=HEAP[c];if(!(reSign(HEAP[c+4],32)>reSign(a,32))){d=14;
break b}HEAP[c]=HEAP[c+4];d=14;break b}else if(d==492){a=HEAP[c];if(!(reSign(HEAP[c+4],32)<reSign(a,32))){d=14;break b}HEAP[c]=HEAP[c+4];d=14;break b}else if(d==493){a=c;c=e;a=a;if(!(reSign(HEAP[a],32)>=reSign(0,32))){d=14;break b}HEAP[c+284+56]=HEAP[a];d=14;break b}else if(d==494){a=c;c=e;d=a;a=HEAP[d+4];d=HEAP[d];b=reSign(a,32)<=reSign(0,32);j=reSign(a,32)>reSign(2,32);if(b|j){if(HEAP[c+561]==0){d=14;break b}HEAP[c+12]=134}else{if(d!=0)d=a;HEAP[c+284+52]=(a&255^-1)&HEAP[c+284+52]|d&255}d=14;break b}else if(d==
495){_Ins_UNKNOWN(e,c);d=14;break b}while(0);if(d==192)HEAP[e+12]=134;c=e;if(HEAP[e+12]!=0){if(HEAP[c+12]!=128){d=9;break a}d=HEAP[e+416];c=c=d+16*HEAP[e+408];a=e+368;d=d;for(b=357;;){b=b==364?Yb:0;var Cb=d+16*b;j=d+16*b+12;f=d+16*b+8;if(!(Cb<c)){d=366;break a}if(HEAP[j]!=0)if(HEAP[a]==(HEAP[f]&255))break;var Yb=b+1;b=364}d=Cb;var Ob=HEAP[e+432];c=reSign(HEAP[e+428],32)>=reSign(Ob,32);Ob=e;if(c){d=361;break a}c=HEAP[Ob+436]+16*HEAP[e+428];HEAP[c]=HEAP[e+352];HEAP[c+4]=HEAP[e+360]+1;HEAP[c+8]=1;HEAP[c+
12]=HEAP[d+4];if(_Ins_Goto_CodeRange(e,HEAP[d],HEAP[d+4])==1){d=9;break a}}else{HEAP[e+16]=HEAP[c+32];if(HEAP[e+376]!=0)HEAP[e+360]=HEAP[e+372]+HEAP[e+360];Y=c=Y+1;if(reSign(c,32)>reSign(1E6,32)){d=368;break a}}var Lb=HEAP[e+364];c=reSign(HEAP[e+360],32)>=reSign(Lb,32);Lb=e;if(c){d=370;break a}if(HEAP[Lb+488]==0)d=2;else{d=373;break a}}a:do if(d==3){HEAP[e+12]=131;d=9;break a}else if(d==7){HEAP[Pa+12]=129;d=9;break a}else if(d==10){HEAP[Ja+12]=130;d=9;break a}else if(d==361){HEAP[Ob+12]=134;d=9;break a}else if(d==
366){HEAP[e+12]=128;d=9;break a}else if(d==368){R=139;d=369;break a}else if(d==370){if(!(reSign(HEAP[Lb+428],32)>reSign(0,32))){d=373;break a}HEAP[e+12]=131;d=9;break a}while(0);if(d==9){k=HEAP[e+12]!=0;a:do if(k){if(HEAP[e+488]!=0)break a;HEAP[HEAP[e+4]+301]=0}while(0);R=HEAP[e+12]}else if(d==373)R=0;e=R;STACKTOP=g;return e}_TT_RunIns.__index__=Runtime.getFunctionIndex(_TT_RunIns,"_TT_RunIns");
function _ft_var_readpackedpoints(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b=null,a,c,f,h;f=HEAP[e+28];a=HEAP[d]=0;if(HEAP[e+32]<HEAP[e+36]){var i=HEAP[e+32];a=HEAP[i];HEAP[e+32]=i+1}a=reSign(a,8);h=unSign(a&255,8);HEAP[g]=h;if(h==0)c=4294967295;else{if((h&128)!=0){a=0;if(HEAP[e+32]<HEAP[e+36]){i=HEAP[e+32];a=HEAP[i];HEAP[e+32]=i+1}a=reSign(a,8);a=unSign(a&255,8);h=(h&127)<<8|a}f=_ft_mem_realloc(f,2,0,h,0,d);if(HEAP[d]!=0)c=0;else{h=i=a=h;b=4;a:for(;;){var k=b==4?0:b==19?v:b==13?
p:b==30?C:x;if(!(reSign(k,32)<reSign(a,32)))break a;if(HEAP[e+32]<HEAP[e+36]){b=HEAP[e+32];c=HEAP[b];HEAP[e+32]=b+1;b=6}else b=31;var j=b==31?0:c;b=reSign(j,8)&255;var l=unSign(b,8);if((l&128)!=0){l=l&127;p=HEAP[e+32];if(p+1<HEAP[e+36]){var m=p+2,o=reSign(HEAP[m+-2],8)<<8&65535;b=unSign(HEAP[m+-2+1],8);o=o|b;b=8}else b=32;var n=b==32?0:o;HEAP[e+32]=b==32?p:m;p=reSign(n,16)&65535;HEAP[f+2*k]=p;n=unSign(HEAP[f+2*k],16);var p=k+1;if(reSign(l,32)<=reSign(0,32))break a;if(reSign(l+p,32)>=reSign(i,32))break a;
if(!(reSign(0,32)<reSign(l,32))){b=13;continue a}v=j&127;k=k+1;for(b=14;;){t=b==14?0:t;u=b==14?n:u;j=f+2*(k+t);l=HEAP[e+32];if(l+1<HEAP[e+36]){var r=l+2,q=reSign(HEAP[r+-2],8)<<8&65535;b=unSign(HEAP[r+-2+1],8);q=q|b;b=16}else b=15;var s=b==15?0:q;HEAP[e+32]=b==15?l:r;b=reSign(s,16)&65535;var u=unSign(b,16)+u;HEAP[j]=u&65535;var t=t+1;if(t!=v)b=18;else break}var v=k+v;b=19}else{if(HEAP[e+32]<HEAP[e+36]){x=HEAP[e+32];var w=HEAP[x];HEAP[e+32]=x+1;b=20}else b=33;x=reSign(b==33?0:w,8)&255;x=unSign(x,8);
HEAP[f+2*k]=x;n=unSign(HEAP[f+2*k],16);var x=k+1;if(reSign(l,32)<=reSign(0,32))break a;if(reSign(l+x,32)>=reSign(h,32))break a;if(!(reSign(0,32)<reSign(l,32))){b=24;continue a}C=unSign(j,8);k=k+1;for(b=25;;){z=b==25?0:z;A=b==25?n:A;j=f+2*(k+z);if(HEAP[e+32]<HEAP[e+36]){b=HEAP[e+32];var y=HEAP[b];HEAP[e+32]=b+1;b=27}else b=26;b=reSign(b==26?0:y,8)&255;var A=unSign(b,8)+A;HEAP[j]=A&65535;var z=z+1;if(z!=C)b=29;else break}var C=k+C;b=30}}c=f}}c=c;STACKTOP=d;return c}
_ft_var_readpackedpoints.__index__=Runtime.getFunctionIndex(_ft_var_readpackedpoints,"_ft_var_readpackedpoints");
function _ft_var_readpackeddeltas(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a=null,c,f,h;h=HEAP[e+28];HEAP[d]=0;f=_ft_mem_realloc(h,2,0,g,0,d);if(HEAP[d]!=0)c=0;else{a=1;a:for(;;){A=a==8?A:0;if(!(unSign(A,32)<unSign(g,32))){b=23;break a}if(HEAP[e+32]<HEAP[e+36]){var i=HEAP[e+32],k=HEAP[i];HEAP[e+32]=i+1;a=3}else a=22;i=reSign(a==22?0:k,8)&255;i=unSign(i,8);var j=(i&128)!=0;b:do if(j){var l=i&63;for(a=5;;){var m=a==7?p:0,o=A+m;b=f+2*o;a=unSign(l,32)<unSign(m,32)^1;var n=unSign(o,
32)<unSign(g,32);if(!(a&n)){a=6;break b}HEAP[b]=0;var p=m+1;a=7}}else{l=i&63;if((i&64)!=0){a=9;b=10}else{a=9;b=11}for(;;)if(b==10){var r=a==14?t:0,q=A+r;b=f+2*q;a=unSign(l,32)<unSign(r,32)^1;n=unSign(q,32)<unSign(g,32);if(!(a&n)){a=10;break b}t=HEAP[e+32];if(t+1<HEAP[e+36]){var s=t+2,u=reSign(HEAP[s+-2],8)<<8&65535;a=unSign(HEAP[s+-2+1],8);u=u|a;a=12}else a=15;n=a==15?0:u;HEAP[e+32]=a==15?t:s;t=reSign(n,16)&65535;HEAP[b]=t;var t=r+1;a=14;b=10}else if(b==11){var v=a==18?y:0,w=A+v;b=f+2*w;a=unSign(l,
32)<unSign(v,32)^1;n=unSign(w,32)<unSign(g,32);if(!(a&n)){a=11;break b}if(HEAP[e+32]<HEAP[e+36]){y=HEAP[e+32];var x=HEAP[y];HEAP[e+32]=y+1;a=16}else a=19;y=reSign(a==19?0:x,8)&255;y=reSign(y,8);HEAP[b]=y;var y=v+1;a=18;b=11}}while(0);var A=a==10?q:a==6?o:w;j=a==10?r:a==6?m:v;if(unSign(i&63,32)>=unSign(j,32)){b=20;break a}else{a=8;b=2}}if(b==23)c=f;else if(b==20){f!=0&&FUNCTION_TABLE[HEAP[h+8]](h,f);c=0}}c=c;STACKTOP=d;return c}
_ft_var_readpackeddeltas.__index__=Runtime.getFunctionIndex(_ft_var_readpackeddeltas,"_ft_var_readpackeddeltas");
function _ft_var_apply_tuple(e,g,d,b,a){var c,f=null,h,i;i=65536;h=0;var k=e+4,j=e+4,l=e+4;g=(unSign(g,16)&16384)==0;var m=e+4,o=e+4,n=e+4,p=e+4,r=e+4,q=i;for(f=-1;;){var s=f==13?w:q;c=h;if(!(unSign(HEAP[e],32)>unSign(c,32))){c=15;break}if(HEAP[d+4*h]==0)f=14;else{if(HEAP[HEAP[k]+4*h]==0){c=1;break}if(!(reSign(HEAP[HEAP[j]+4*h],32)>=reSign(0,32)))if(reSign(HEAP[d+4*h],32)>reSign(0,32)){c=1;break}if(!(reSign(HEAP[HEAP[l]+4*h],32)<=reSign(0,32)))if(reSign(HEAP[d+4*h],32)<reSign(0,32)){c=1;break}c=HEAP[HEAP[m]+
4*h];if(g){var u=0-c;u=reSign(c,32)>=reSign(0,32)?c:u;u=_FT_MulDiv(s,u,65536);f=6}else{f=HEAP[b+4*h];if(reSign(c,32)<=reSign(f,32)){c=8;break}c=HEAP[a+4*h];if(reSign(HEAP[HEAP[o]+4*h],32)>=reSign(c,32)){c=8;break}c=HEAP[d+4*h];c=reSign(HEAP[HEAP[n]+4*h],32)<reSign(c,32);f=h;if(c){var t=_FT_MulDiv(HEAP[HEAP[p]+4*h]-HEAP[b+4*h],65536,HEAP[d+4*f]-HEAP[b+4*h]);t=_FT_MulDiv(s,t,65536);f=11}else{var v=_FT_MulDiv(HEAP[a+4*h]-HEAP[HEAP[r]+4*h],65536,HEAP[a+4*f]-HEAP[d+4*h]);v=_FT_MulDiv(s,v,65536);f=12}}}var w=
f==12?v:f==11?t:f==6?u:s;h+=1;f=13;c=0}if(c==1)i=0;else if(c==8)i=0;else if(c==15)i=s;return i}_ft_var_apply_tuple.__index__=Runtime.getFunctionIndex(_ft_var_apply_tuple,"_ft_var_apply_tuple");
function _TT_Get_MM_Var(e,g){var d=STACKTOP;STACKTOP+=44;Runtime.memset(d,0,44);var b,a=null,c,f,h,i=d+4,k,j,l,m,o,n=d+8,p=d+24;f=HEAP[e+104];h=HEAP[e+100];HEAP[i]=0;c=HEAP[e+712]==0;a:do if(c){c=FUNCTION_TABLE[HEAP[e+508]](e,1735811442,f,d);HEAP[i]=c;if(HEAP[i]!=0){b=0;break a}c=FUNCTION_TABLE[HEAP[e+508]](e,1719034226,f,d);HEAP[i]=c;if(HEAP[i]!=0){b=0;break a}c=f;c=c=c=HEAP[c+8];var r=_FT_Stream_ReadFields(f,_fvar_fields_12035,n);HEAP[i]=r;if(HEAP[i]!=0){b=0;break a}r=HEAP[n]!=65536;b:do if(!r){if(HEAP[n+
6]!=2)break b;if(HEAP[n+10]!=20)break b;if(unSign(HEAP[n+8],16)>unSign(16382,16))break b;k=unSign(HEAP[n+14],16);a=(unSign(HEAP[n+8],16)+1)*4;if(k!=a)break b;if(unSign(HEAP[n+12],16)>unSign(32511,16))break b;k=unSign(HEAP[n+4],16);a=unSign(HEAP[n+12],16);a=unSign(HEAP[n+14],16)*a;m=unSign(HEAP[n+8],16)*20;j=HEAP[d];if(unSign(a+k+m,32)>unSign(j,32))break b;k=_ft_mem_alloc(h,40,i);HEAP[e+712]=k;if(HEAP[i]!=0){b=0;break a}k=HEAP[e+712];a=unSign(HEAP[n+8],16)*3;m=unSign(HEAP[n+12],16);a=(a+m)*2;m=unSign(HEAP[n+
12],16);a=(unSign(HEAP[n+8],16)*m+a)*4;a=unSign(HEAP[n+8],16)*5+20+a;HEAP[k+12]=a;k=_ft_mem_alloc(h,HEAP[HEAP[e+712]+12],i);if(HEAP[i]!=0){b=0;break a}HEAP[HEAP[e+712]+8]=k;a=unSign(HEAP[n+8],16);HEAP[k]=a;HEAP[k+4]=-1;a=unSign(HEAP[n+12],16);HEAP[k+8]=a;HEAP[k+12]=k+20;a=HEAP[k+12];m=unSign(HEAP[n+8],16);HEAP[k+16]=a+24*m;a=HEAP[k+16];m=unSign(HEAP[n+12],16);j=a+8*m;a=0;m=unSign(HEAP[n+12],16);l=a;if(reSign(m,32)>reSign(l,32)){m=n+8;l=n+12;var q=a;j=j;var s=q+1;for(a=13;;){t=a==13?0:t;u=a==13?j:
u;b=s+t;HEAP[HEAP[k+16]+8*(q+t)]=u;a=unSign(HEAP[m],16);var u=u+4*a;a=unSign(HEAP[l],16);b=reSign(a,32)>reSign(b,32);var t=t+1;if(b)b=a=14;else{b=15;break}}j=u}l=j;a=0;m=unSign(HEAP[n+8],16);j=a;if(reSign(m,32)>reSign(j,32)){m=n+8;j=a;l=l;q=j+1;for(a=17;;){v=a==17?0:v;b=q+v;HEAP[HEAP[k+12]+24*(j+v)]=l+v*5;a=unSign(HEAP[m],16);b=reSign(a,32)>reSign(b,32);var v=v+1;if(b)b=a=18;else{b=19;break}}}a=unSign(HEAP[n+4],16);a=_FT_Stream_Seek(f,a+c);HEAP[i]=a;if(a!=0){b=0;break a}m=HEAP[k+12];a=0;j=n+8;l=f;
s=q=p;var w=p+4,x=p+8,y=p+12;o=p+18;var A=a;a=21;c:for(;;){b=a==24?C:0;a=A+b;var z=unSign(HEAP[j],16);if(!(reSign(z,32)>reSign(a,32))){b=26;break c}a=_FT_Stream_ReadFields(l,_fvaraxis_fields_12036,q);HEAP[i]=a;if(HEAP[i]!=0){b=23;break c}HEAP[m+16]=HEAP[s];HEAP[m+4]=HEAP[w];HEAP[m+8]=HEAP[x];HEAP[m+12]=HEAP[y];C=unSign(HEAP[o],16);HEAP[m+20]=C;C=HEAP[m];a=unSign(HEAP[m+16],32)>>>unSign(24,32)&255;HEAP[C]=a;C=HEAP[m];a=unSign(HEAP[m+16],32)>>>unSign(16,32)&255;HEAP[C+1]=a;C=HEAP[m];a=unSign(HEAP[m+
16],32)>>>unSign(8,32)&255;HEAP[C+2]=a;HEAP[HEAP[m]+3]=HEAP[m+16]&255;HEAP[HEAP[m]+4]=0;m+=24;var C=b+1;a=24;b=22}if(b==26){o=HEAP[k+16];a=0;k=n+12;m=n+8;q=l=j=f;s=n+8;w=f;x=n+8;y=f;o=o;A=a;a=26;c:for(;;){z=a==42?K:0;a=A+z;var B=o+8*z;b=o+8*z+4;var D=unSign(HEAP[k],16);if(!(reSign(D,32)>reSign(a,32))){b=47;break c}a=(unSign(HEAP[m],16)+1)*4;a=_FT_Stream_EnterFrame(j,a);HEAP[i]=a;if(HEAP[i]!=0){b=28;break c}K=HEAP[l+32];if(K+1<HEAP[l+36]){var E=K+2,F=reSign(HEAP[E+-2],8)<<8&65535;a=unSign(HEAP[E+-2+
1],8);F=F|a;a=30}else a=29;D=a==29?0:F;HEAP[l+32]=a==29?K:E;K=reSign(D,16)&65535;K=unSign(K,16);HEAP[b]=K;K=HEAP[q+32];if(K+1<HEAP[q+36]){var G=K+2,H=reSign(HEAP[G+-2],8)<<8&65535;b=unSign(HEAP[G+-2+1],8);H=H|b;a=32}else a=63;b=a==63?0:H;HEAP[q+32]=a==63?K:G;reSign(b,16);K=unSign(HEAP[s],16);if(reSign(K,32)>reSign(0,32)){a=34;b=35}else{a=34;b=36}for(;;)if(b==35){P=a==39?P:0;K=P+1;b=HEAP[B];D=HEAP[w+32];if(D+3<HEAP[w+36]){var J=D+4,L=reSign(HEAP[J+-4],8)<<24;a=unSign(HEAP[J+-4+1],8)<<16;var N=unSign(HEAP[J+
-4+2],8)<<8,I=unSign(HEAP[J+-4+3],8);L=a|L|N|I;a=37}else a=35;N=a==35?0:L;HEAP[w+32]=a==35?D:J;HEAP[b+4*P]=N;var P=P+1;b=unSign(HEAP[x],16);if(reSign(b,32)>reSign(K,32)){a=39;b=35}else{a=40;b=36}}else if(b==36){b=HEAP[y+20]!=0?41:42;break}if(b==41){K=HEAP[y+28];b=HEAP[y];b!=0&&FUNCTION_TABLE[HEAP[K+8]](K,b);HEAP[y]=0}HEAP[y+32]=0;HEAP[y+36]=0;var K=z+1;a=42;b=27}if(b==47){b=48;break a}else if(b==28){b=0;break a}}else if(b==23){b=0;break a}}while(0);HEAP[i]=8;b=0;break a}else b=48;while(0);a:do if(b==
48){if(g==0)break a;k=_ft_mem_alloc(h,HEAP[HEAP[e+712]+12],i);if(HEAP[i]!=0)break a;_llvm_memcpy_p0i8_p0i8_i32(k,HEAP[HEAP[e+712]+8],HEAP[HEAP[e+712]+12],1,0);HEAP[k+12]=k+20;HEAP[k+16]=HEAP[k+12]+24*HEAP[k];j=HEAP[k+16]+8*HEAP[k+8];f=n=0;p=unSign(HEAP[k+8],32)>unSign(f,32);f=k;if(p){n=n;p=j;E=n+1;for(a=51;;){Q=a==51?0:Q;O=a==51?p:O;G=E+Q;HEAP[HEAP[(a==51?f:M)+16]+8*(n+Q)]=O;var O=O+4*HEAP[k];G=unSign(HEAP[k+8],32)>unSign(G,32);var M=k,Q=Q+1;if(G)b=a=52;else{b=53;break}}j=O;a=53}else a=50;m=HEAP[(a==
53?M:f)+12];l=j;f=n=0;if(unSign(HEAP[k],32)>unSign(f,32)){f=l;n=n+1;a=55;b:for(;;){R=a==55?0:R;p=n+R;HEAP[m]=f+R*5;E=HEAP[m+16]==2003265652;G=m;c:do if(E)HEAP[G]=__str740;else{J=m;if(HEAP[G+16]==2003072104)HEAP[J]=__str841;else{u=m;if(HEAP[J+16]==1869640570)HEAP[u]=__str942;else{if(HEAP[u+16]!=1936486004)break c;HEAP[m]=__str1043}}}while(0);m+=24;p=unSign(HEAP[k],32)>unSign(p,32);var R=R+1;if(p){a=59;b=56}else{b=60;break b}}}HEAP[g]=k}while(0);h=HEAP[i];STACKTOP=d;return h}
_TT_Get_MM_Var.__index__=Runtime.getFunctionIndex(_TT_Get_MM_Var,"_TT_Get_MM_Var");
function _TT_Set_MM_Blend(e,g,d){var b=STACKTOP;STACKTOP+=32;Runtime.memset(b,0,32);var a,c=null,f,h,i,k,j,l,m,o=b+4,n,p=b+8,r=b+28,q;HEAP[r]=0;q=HEAP[e+100];HEAP[e+708]=0;f=HEAP[e+712]==0;a:do if(f){f=_TT_Get_MM_Var(e,0);HEAP[r]=f;a=HEAP[r]!=0?0:1;break a}else a=1;while(0);a:do if(a==1){f=HEAP[e+712];h=HEAP[f+8];if(HEAP[h]!=g)HEAP[r]=6;else{c=0;h=g;m=j=d;n=c;c=3;b:for(;;){a=c==7?s:0;c=n+a;i=j+4*c;k=m+4*c;if(!(unSign(c,32)<unSign(h,32))){a=9;break b}if(reSign(HEAP[i],32)<reSign(-65536,32)){a=5;break b}if(reSign(HEAP[k],
32)>reSign(65536,32)){a=5;break b}var s=a+1;c=7;a=4}if(a==9){h=HEAP[f+36]==0;b:do if(h){j=e;h=HEAP[j+104];m=HEAP[h+28];a=HEAP[j+712];j=FUNCTION_TABLE[HEAP[j+508]](j,1735811442,h,o);HEAP[b]=j;j=HEAP[b];i=j!=0;c:do if(i)c=70;else{l=h;n=l=l=HEAP[l+8];l=_FT_Stream_ReadFields(h,_gvar_fields_11813,p);HEAP[b]=l;l=HEAP[b];if(l!=0){c=10;break c}c=unSign(HEAP[p+6],16);HEAP[a+24]=c;c=unSign(HEAP[p+12],16);HEAP[a+32]=c;k=n+HEAP[p+16];c=HEAP[p]!=65536;d:do if(!c){if(HEAP[p+4]!=(HEAP[HEAP[a+8]]&65535))break d;
var u=_ft_mem_realloc(m,4,0,HEAP[a+32]+1,0,b);HEAP[a+36]=u;u=HEAP[b];if(u!=0){c=14;break c}c=(unSign(HEAP[p+14],16)&1&255)!=0;i=HEAP[a+32]+1;if(c){var t=_FT_Stream_EnterFrame(h,i*4);HEAP[b]=t;t=HEAP[b];if(t!=0){c=17;break c}i=c=0;if(unSign(HEAP[a+32],32)>=unSign(i,32)){i=a+36;var v=h;k=k;var w=a+32,x=c,y=x+1,A=v+32,z=v+36;v=v+32;for(c=19;;){L=c==19?0:L;var C=x+L,B=y+L,D=HEAP[i],E=HEAP[A];if(E+3<HEAP[z]){var F=E+4,G=reSign(HEAP[F+-4],8)<<24;c=unSign(HEAP[F+-4+1],8)<<16;var H=unSign(HEAP[F+-4+2],8)<<
8,J=unSign(HEAP[F+-4+3],8);G=c|G|J|H;c=21}else c=20;H=c==20?0:G;HEAP[v]=c==20?E:F;HEAP[D+4*C]=H+k;c=unSign(HEAP[w],32)>=unSign(B,32);var L=L+1;if(c)c=23;else break}}c=h;if(HEAP[c+20]!=0){i=HEAP[c+28];k=HEAP[c];i=i;k=k;k!=0&&FUNCTION_TABLE[HEAP[i+8]](i,k);HEAP[c]=0}HEAP[c+32]=0;HEAP[c+36]=0}else{var N=_FT_Stream_EnterFrame(h,i*2);HEAP[b]=N;N=HEAP[b];if(N!=0){c=29;break c}i=c=0;if(unSign(HEAP[a+32],32)>=unSign(i,32)){i=a+36;v=h;k=k;w=a+32;x=c;y=x+1;A=v+32;z=v+36;v=v+32;for(c=31;;){K=c==31?0:K;C=x+K;
B=y+K;D=HEAP[i];E=HEAP[A];if(E+1<HEAP[z]){var I=E+2,P=reSign(HEAP[I+-2],8)<<8&65535;c=unSign(HEAP[I+-2+1],8);P=P|c;c=33}else c=32;H=c==32?0:P;HEAP[v]=c==32?E:I;c=reSign(H,16)&65535;c=unSign(c,16)*2+k;HEAP[D+4*C]=c;c=unSign(HEAP[w],32)>=unSign(B,32);var K=K+1;if(c)c=35;else break}}c=h;if(HEAP[c+20]!=0){i=HEAP[c+28];k=HEAP[c];i=i;k=k;k!=0&&FUNCTION_TABLE[HEAP[i+8]](i,k);HEAP[c]=0}HEAP[c+32]=0;HEAP[c+36]=0}if(HEAP[a+24]!=0){var O=unSign(HEAP[p+4],16);O=_ft_mem_realloc(m,4,0,HEAP[a+24]*O,0,b);HEAP[a+
28]=O;O=HEAP[b];if(O!=0){c=40;break c}var M=_FT_Stream_Seek(h,n+HEAP[p+8]);HEAP[b]=M;M=HEAP[b];if(M!=0){c=41;break c}var Q=HEAP[a+24];m=unSign(HEAP[p+4],16);Q=_FT_Stream_EnterFrame(h,Q*2*m);HEAP[b]=Q;Q=HEAP[b];if(Q!=0){c=42;break c}j=c=0;if(unSign(HEAP[a+24],32)>unSign(j,32)){j=p+4;m=a+28;n=p+4;z=h;i=p+4;k=a+24;w=c;x=w+1;y=z+32;A=z+36;z=z+32;c=44;e:for(;;){v=c==44?0:U;C=w+v;B=x+v;a=unSign(HEAP[j],16);if(unSign(a,32)>unSign(0,32)){c=45;a=46}else{c=45;a=47}for(;;)if(a==46){V=c==50?V:0;a=V+1;D=HEAP[m];
E=HEAP[n];H=HEAP[y];if(H+1<HEAP[A]){var R=H+2,T=reSign(HEAP[R+-2],8)<<8&65535;c=unSign(HEAP[R+-2+1],8);T=T|c;c=48}else c=46;J=c==46?0:T;HEAP[z]=c==46?H:R;c=reSign(J,16)&65535;c=reSign(c,16)<<2;E=unSign(E,16);HEAP[D+4*(V+C*E)]=c;var V=V+1;c=unSign(HEAP[i],16);if(unSign(c,32)>unSign(a,32)){c=50;a=46}else{c=51;a=47}}else if(a==47){a=unSign(HEAP[k],32)>unSign(B,32);var U=v+1;if(a){c=47;continue e}else break e}}}h=h;if(HEAP[h+20]!=0){a=HEAP[h+28];j=HEAP[h];a=a;j=j;j!=0&&FUNCTION_TABLE[HEAP[a+8]](a,j);
HEAP[h]=0}HEAP[h+32]=0;HEAP[h+36]=0}h=HEAP[b];HEAP[r]=h;if(h!=0)break a;else{a=57;break b}}while(0);HEAP[b]=8;c=13}while(0);HEAP[r]=c==70?j:c==10?l:c==13?8:c==14?u:c==17?t:c==29?N:c==40?O:c==41?M:Q;break a}while(0);if(HEAP[f+4]==0){h=_ft_mem_realloc(q,4,0,g,0,r);HEAP[f+4]=h;if(HEAP[r]!=0)break a;h=1}else{c=h=0;j=g;m=f+4;n=d;i=c;for(c=60;;){a=c==63?S:0;c=i+a;k=n+4*c;if(!(unSign(c,32)<unSign(j,32))){a=65;break}if(HEAP[HEAP[m]+4*c]!=HEAP[k]){a=62;break}var S=a+1;c=63;a=61}if(a!=65)if(a==62)h=2}HEAP[f]=
g;_llvm_memcpy_p0i8_p0i8_i32(HEAP[f+4],d,g*4,1,0);HEAP[e+708]=1;if(HEAP[e+672]==0)break a;f=h;if(f==1)a=68;else if(f==2)a=69;else break a;if(a==68)_tt_face_vary_cvt(e,HEAP[e+104]);else if(a==69){h=HEAP[e+672];f=q;h=h;h!=0&&FUNCTION_TABLE[HEAP[f+8]](f,h);HEAP[e+672]=0;HEAP[e+672]=0;_tt_face_load_cvt(e,HEAP[e+104])}}else if(a==5)HEAP[r]=6}}while(0);e=HEAP[r];STACKTOP=b;return e}_TT_Set_MM_Blend.__index__=Runtime.getFunctionIndex(_TT_Set_MM_Blend,"_TT_Set_MM_Blend");
function _TT_Set_Var_Design(e,g,d){var b=STACKTOP;STACKTOP+=12;Runtime.memset(b,0,12);var a,c=null,f,h,i,k,j,l,m,o,n,p=b+4,r=b+8,q,s,u,t;q=HEAP[r]=0;t=HEAP[e+100];s=HEAP[e+712]==0;a:do if(s){s=_TT_Get_MM_Var(e,0);HEAP[r]=s;a=HEAP[r]!=0?0:1;break a}else a=1;while(0);a:do if(a==1){s=HEAP[e+712];u=HEAP[s+8];if(HEAP[u]!=g)HEAP[r]=6;else{q=_ft_mem_realloc(t,4,0,HEAP[u],0,r);if(HEAP[r]!=0)break a;o=HEAP[u+12];c=0;var v=u;h=k=i=j=d;f=l=q;var w=d;m=q;var x=c;o=o;c=3;b:for(;;){a=c==9?L:0;var y=o+24*a+12,A=
o+24*a+4,z=o+24*a+8,C=x+a,B=j+4*C,D=i+4*C,E=k+4*C,F=h+4*C;c=l+4*C;var G=f+4*C,H=w+4*C,J=m+4*C;if(!(unSign(HEAP[v],32)>unSign(C,32))){a=11;break b}C=HEAP[y];if(reSign(HEAP[B],32)>reSign(C,32)){a=5;break b}B=HEAP[A];if(reSign(HEAP[D],32)<reSign(B,32)){a=5;break b}L=HEAP[z];if(reSign(HEAP[E],32)<reSign(L,32)){L=0-_FT_MulDiv(HEAP[F]-HEAP[z],65536,HEAP[A]-HEAP[z]);HEAP[c]=L}else if(HEAP[y]==HEAP[z])HEAP[G]=0;else{L=_FT_MulDiv(HEAP[H]-HEAP[z],65536,HEAP[y]-HEAP[z]);HEAP[J]=L}var L=a+1;c=9;a=4}if(a==11){v=
HEAP[s+16]==0;b:do if(v){h=e;j=HEAP[h+104];i=HEAP[j+28];k=HEAP[h+712];HEAP[b]=0;HEAP[k+16]=1;h=FUNCTION_TABLE[HEAP[h+508]](h,1635148146,j,p);HEAP[b]=h;if(HEAP[b]!=0){a=12;break b}h=_FT_Stream_EnterFrame(j,HEAP[p]);HEAP[b]=h;if(HEAP[b]!=0){a=12;break b}h=j;c=0;l=HEAP[h+32];if(l+3<HEAP[h+36]){l+=4;c=reSign(HEAP[l+-4],8)<<24;f=unSign(HEAP[l+-4+1],8)<<16;w=unSign(HEAP[l+-4+2],8)<<8;m=unSign(HEAP[l+-4+3],8);c=f|c|w|m}HEAP[h+32]=l;l=h=h=c;h=j;f=0;c=HEAP[h+32];if(c+3<HEAP[h+36]){c+=4;f=reSign(HEAP[c+-4],
8)<<24;w=unSign(HEAP[c+-4+1],8)<<16;m=unSign(HEAP[c+-4+2],8)<<8;x=unSign(HEAP[c+-4+3],8);f=w|f|m|x}HEAP[h+32]=c;h=h=h=f;l=l!=65536;c:do if(!l){if(HEAP[HEAP[k+8]]!=h){a=17;break c}c=_ft_mem_realloc(i,8,0,h,0,b);HEAP[k+20]=c;if(HEAP[b]!=0){a=17;break c}m=HEAP[k+20];o=0;f=h;A=j;w=i;c=F=j;m=m;x=n;o=o;J=A+32;y=A+36;A=A+32;z=F+32;E=F+36;F=F+32;G=c+32;H=c+36;D=c+32;c=19;d:for(;;){B=c==34?W:0;var N=c==34?Y:x,I=o+B;C=m+8*B+4;var P=m+8*B;if(!(reSign(I,32)<reSign(f,32))){a=42;break d}a=HEAP[J];if(a+1<HEAP[y]){var K=
a+2,O=reSign(HEAP[K+-2],8)<<8&65535;c=unSign(HEAP[K+-2+1],8);O=O|c;c=21}else c=41;var M=c==41?0:O;HEAP[A]=c==41?a:K;a=reSign(M,16)&65535;HEAP[P]=a;a=unSign(HEAP[P],16);a=_ft_mem_realloc(w,8,0,a,0,b);HEAP[C]=a;if(HEAP[b]!=0){a=23;break d}a=unSign(HEAP[P],16);if(reSign(a,32)>reSign(0,32)){c=24;a=33}else{c=24;a=34}for(;;)if(a==33){X=c==39?X:0;var Q=X+1;a=HEAP[C];M=HEAP[z];if(M+1<HEAP[E]){var R=M+2,T=reSign(HEAP[R+-2],8)<<8&65535;c=unSign(HEAP[R+-2+1],8);T=T|c;c=35}else c=33;var V=c==33?0:T;HEAP[F]=c==
33?M:R;c=reSign(V,16)&65535;c=reSign(c,16)<<2;HEAP[a+8*X]=c;a=HEAP[C];M=HEAP[G];if(M+1<HEAP[H]){var U=M+2,S=reSign(HEAP[U+-2],8)<<8&65535;c=unSign(HEAP[U+-2+1],8);S=S|c;c=37}else c=58;V=c==58?0:S;HEAP[D]=c==58?M:U;c=reSign(V,16)&65535;c=reSign(c,16)<<2;HEAP[a+8*X+4]=c;var X=X+1;a=unSign(HEAP[P],16);if(reSign(a,32)>reSign(Q,32)){c=39;a=33}else{c=40;a=34}}else if(a==34){var Y=c==40?Q:0,W=B+1;c=34;a=20;continue d}}if(a==42)n=N;else if(a==23){o=I;n=c=o-1;c=reSign(c,32)>=reSign(0,32);f=HEAP[k+20];if(c){w=
i;m=k+20;x=k+20;n=n;o=0-n;J=reSign(o,32)>reSign(0,32);y=w+8;c=reSign(o,32)>reSign(0,32)?o:0;A=n+c+1;for(c=25;;){ba=c==25?0:ba;a=n+ba*-1;da=HEAP[(c==25?f:da)+8*a+4];da!=0&&FUNCTION_TABLE[HEAP[y]](w,da);HEAP[HEAP[m]+8*a+4]=0;var da=HEAP[x],ba=ba+1;if(ba!=A){c=28;a=26}else{a=29;break}}n=-1-(J?o:0);c=29}else c=23;w=c==29?da:f;c=i;f=w;w!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[k+20]=0;HEAP[k+20]=0}}while(0);j=j;if(HEAP[j+20]!=0){i=HEAP[j+28];k=HEAP[j];i=i;k=k;k!=0&&FUNCTION_TABLE[HEAP[i+8]](i,k);HEAP[j]=
0}HEAP[j+32]=0;HEAP[j+36]=0}while(0);v=HEAP[s+20]!=0;b:do if(v){l=HEAP[s+20];j=c=0;if(!(unSign(HEAP[u],32)>unSign(j,32))){a=47;break b}k=i=j=q;h=u;l=l;f=c;w=f+1;c=46;c:for(;;){$=c==46?0:$;c=f+$;y=j+4*c;J=i+4*c;m=k+4*c;x=w+$;o=l+8*$+4;A=unSign(HEAP[l+8*$],16);for(c=48;;){a=c==51?ca:0;var aa=a+1;if(!(unSign(A,32)>unSign(aa,32))){a=54;break}c=HEAP[HEAP[o]+8*aa];if(reSign(HEAP[y],32)<reSign(c,32)){a=50;break}var ca=a+1;c=51;a=49}if(a==50){a=HEAP[HEAP[o]+8*aa+4]-HEAP[HEAP[o]+8*(aa-1)+4];c=_FT_MulDiv(HEAP[J]-
HEAP[HEAP[o]+8*(aa-1)],65536,HEAP[HEAP[o]+8*aa]-HEAP[HEAP[o]+8*(aa-1)]);a=_FT_MulDiv(c,a,65536);HEAP[m]=HEAP[HEAP[o]+8*(aa-1)+4]+a}a=unSign(HEAP[h],32)>unSign(x,32);var $=$+1;if(a){c=54;a=48}else{a=55;break c}}}while(0);s=_TT_Set_MM_Blend(e,g,q);HEAP[r]=s}else if(a==5)HEAP[r]=6}}while(0);e=q;e!=0&&FUNCTION_TABLE[HEAP[t+8]](t,e);r=HEAP[r];STACKTOP=b;return r}_TT_Set_Var_Design.__index__=Runtime.getFunctionIndex(_TT_Set_Var_Design,"_TT_Set_Var_Design");
function _tt_face_vary_cvt(e,g){var d=STACKTOP;STACKTOP+=12;Runtime.memset(d,0,12);var b,a=null,c,f,h,i,k,j,l,m;m=d+4;var o,n,p,r,q,s;f=d+8;l=HEAP[g+28];s=q=r=0;c=HEAP[e+712];if(c==0)HEAP[d]=0;else if(HEAP[e+672]==0)HEAP[d]=0;else{j=FUNCTION_TABLE[HEAP[e+508]](e,1668702578,g,m);HEAP[d]=j;if(HEAP[d]!=0)HEAP[d]=0;else{m=_FT_Stream_EnterFrame(g,HEAP[m]);HEAP[d]=m;if(HEAP[d]!=0)HEAP[d]=0;else{m=HEAP[g+32]-HEAP[g];h=0;j=HEAP[g+32];if(j+3<HEAP[g+36]){j+=4;h=reSign(HEAP[j+-4],8)<<24;i=unSign(HEAP[j+-4+1],
8)<<16;k=unSign(HEAP[j+-4+2],8)<<8;var u=unSign(HEAP[j+-4+3],8);h=i|h|k|u}HEAP[g+32]=j;j=h!=65536;a:do if(j)HEAP[d]=0;else{r=_ft_mem_realloc(l,4,0,HEAP[c],0,d);if(HEAP[d]!=0)break a;q=_ft_mem_realloc(l,4,0,HEAP[c],0,d);if(HEAP[d]!=0)break a;s=_ft_mem_realloc(l,4,0,HEAP[c],0,d);if(HEAP[d]!=0)break a;h=g;k=0;i=HEAP[h+32];if(i+1<HEAP[h+36]){i+=2;k=reSign(HEAP[i+-2],8)<<8&65535;u=unSign(HEAP[i+-2+1],8);k=k|u}HEAP[h+32]=i;h=h=reSign(k,16);o=unSign(h&65535,16);h=g;k=0;i=HEAP[h+32];if(i+1<HEAP[h+36]){i+=
2;k=reSign(HEAP[i+-2],8)<<8&65535;u=unSign(HEAP[i+-2+1],8);k=k|u}HEAP[h+32]=i;h=h=reSign(k,16);n=unSign(h&65535,16)+m;if(!(unSign(o&4095,32)>unSign(0,32)))break a;h=c;i=r;u=k=c;var t=q,v=c,w=c,x=s,y=c,A=c,z=r,C=q,B=s,D=e+668,E=e+672,F=e+672,G=e+668,H=e+672,J=e+672,L=e+668,N=l,I=l,P=c,K=c;n=n;o=o&4095;o=(unSign(1,32)>unSign(o,32)?1:o)-0;a=9;b:for(;;){ka=a==9?0:ka;fa=a==9?n:fa;var O=g;p=HEAP[O+32];if(p+1<HEAP[O+36]){var M=p+2,Q=reSign(HEAP[M+-2],8)<<8&65535,R=unSign(HEAP[M+-2+1],8);Q=Q|R;a=11}else a=
10;R=a==10?0:Q;HEAP[O+32]=a==10?p:M;O=reSign(R,16)&65535;O=unSign(O,16);p=g;R=HEAP[p+32];if(R+1<HEAP[p+36]){var T=R+2,V=reSign(HEAP[T+-2],8)<<8&65535,U=unSign(HEAP[T+-2+1],8);V=V|U;a=13}else a=62;U=a==62?0:V;HEAP[p+32]=a==62?R:T;p=reSign(U,16)&65535;R=unSign(p,16);U=(R&32768)!=0;c:do if(U){a=p=0;b=unSign(HEAP[h],32)>unSign(a,32)?15:16;d:for(;;)if(b==15){var S=g;b=HEAP[S+32];if(b+1<HEAP[S+36]){var X=b+2,Y=reSign(HEAP[X+-2],8)<<8&65535;a=unSign(HEAP[X+-2+1],8);Y=Y|a;a=17}else a=15;var W=a==15?0:Y;HEAP[S+
32]=a==15?b:X;a=reSign(W,16)&65535;a=reSign(a,16)<<2;HEAP[i+4*p]=a;p+=1;a=p;if(unSign(HEAP[k],32)>unSign(a,32)){b=15;continue d}b=16}else if(b==16){b=(R&16384)!=0?20:21;break d}d:do if(b==20){a=p=0;b=unSign(HEAP[u],32)>unSign(a,32)?29:30;e:for(;;)if(b==29){S=g;b=HEAP[S+32];if(b+1<HEAP[S+36]){var da=b+2,ba=reSign(HEAP[da+-2],8)<<8&65535;a=unSign(HEAP[da+-2+1],8);ba=ba|a;a=31}else a=29;W=a==29?0:ba;HEAP[S+32]=a==29?b:da;a=reSign(W,16)&65535;a=reSign(a,16)<<2;HEAP[t+4*p]=a;p+=1;a=p;if(unSign(HEAP[v],
32)>unSign(a,32)){b=29;continue e}b=30}else if(b==30){a=p=0;if(unSign(HEAP[w],32)>unSign(a,32)){b=34;break e}else{b=21;break d}}for(;;){S=g;b=HEAP[S+32];if(b+1<HEAP[S+36]){var aa=b+2,ca=reSign(HEAP[aa+-2],8)<<8&65535;a=unSign(HEAP[aa+-2+1],8);ca=ca|a;a=35}else a=34;W=a==34?0:ca;HEAP[S+32]=a==34?b:aa;a=reSign(W,16)&65535;a=reSign(a,16)<<2;HEAP[x+4*p]=a;p+=1;a=p;if(unSign(HEAP[y],32)>unSign(a,32))b=34;else{b=37;break}}}while(0);p=unSign(R&65535,16)&65535;S=_ft_var_apply_tuple(A,p,z,C,B);p=S==0;d:do if(!p){if((R&
8192)==0)break d;R=HEAP[g+32]-HEAP[g];HEAP[g+32]=HEAP[g]+fa;var $=_ft_var_readpackedpoints(g,f);if(HEAP[f]==0){var la=HEAP[D];a=41}else{var ga=HEAP[f];a=43}U=_ft_var_readpackeddeltas(g,a==43?ga:la);a=$!=0&U!=0;e:do if(a){W=$==4294967295;p=0;if(W){W=p;if(!(unSign(HEAP[G],32)>unSign(W,32))){b=46;break e}for(;;){b=HEAP[H];W=HEAP[HEAP[J]+2*p];var ea=reSign(HEAP[U+2*p],16);W=(_FT_MulFix(ea,S)&65535)+W;HEAP[b+2*p]=W;p+=1;b=p;if(unSign(HEAP[L],32)>unSign(b,32))b=45;else{b=49;break e}}}else{a=HEAP[f];if(!(unSign(p,
32)<unSign(a,32))){b=48;break e}for(;;){a=unSign(HEAP[$+2*p],16);b=HEAP[E];W=HEAP[HEAP[F]+2*a];ea=reSign(HEAP[U+2*p],16);W=(_FT_MulFix(ea,S)&65535)+W;HEAP[b+2*a]=W;p+=1;a=HEAP[f];if(!(unSign(p,32)<unSign(a,32)))break}b=49;break e}}else b=49;while(0);e:do if(b==49){b=$!=4294967295?48:46;break e}while(0);e:do if(b==48){p=$;if(p==0)break e;FUNCTION_TABLE[HEAP[N+8]](N,p)}while(0);$=U;$!=0&&FUNCTION_TABLE[HEAP[I+8]](I,$);$=O+fa;HEAP[g+32]=HEAP[g]+R;a=54;break c}while(0);var Z=O+fa;a=39}else{var ha=(R&
16384)!=0;d:do if(ha){a=p=0;if(!(unSign(HEAP[P]*2,32)>unSign(a,32)))break d;for(;;){S=g;b=HEAP[S+32];if(b+1<HEAP[S+36]){var ia=b+2,ja=reSign(HEAP[ia+-2],8)<<8&65535;a=unSign(HEAP[ia+-2+1],8);ja=ja|a;a=24}else a=22;W=a==22?0:ja;HEAP[S+32]=a==22?b:ia;reSign(W,16);p+=1;a=p;if(!(unSign(HEAP[K]*2,32)>unSign(a,32)))break}}while(0);ha=O+fa;a=23}while(0);var fa=a==54?$:a==39?Z:ha,ka=ka+1;if(ka!=o)a=55;else break b}}while(0);if(HEAP[g+20]!=0){f=HEAP[g+28];c=HEAP[g];c!=0&&FUNCTION_TABLE[HEAP[f+8]](f,c);HEAP[g]=
0}HEAP[g+32]=0;HEAP[g+36]=0}}}r=r;r!=0&&FUNCTION_TABLE[HEAP[l+8]](l,r);q=q;q!=0&&FUNCTION_TABLE[HEAP[l+8]](l,q);s=s;s!=0&&FUNCTION_TABLE[HEAP[l+8]](l,s);l=HEAP[d];STACKTOP=d;return l}_tt_face_vary_cvt.__index__=Runtime.getFunctionIndex(_tt_face_vary_cvt,"_tt_face_vary_cvt");
function _TT_Vary_Get_Glyph_Deltas(e,g,d,b){var a=STACKTOP;STACKTOP+=12;Runtime.memset(a,0,12);var c,f=null,h,i,k,j,l,m,o,n,p,r,q,s,u,t,v,w,x=a+4,y=a+8,A,z;s=HEAP[e+104];r=HEAP[s+28];u=HEAP[e+712];z=A=HEAP[y]=0;e=HEAP[e+708]==0;a:do if(e)c=0;else{if(u==0){c=0;break a}q=_ft_mem_realloc(r,8,0,b,0,a);e=HEAP[a]!=0;b:do if(!e){HEAP[d]=q;e=g;e=unSign(HEAP[u+32],32)<=unSign(e,32);c:do if(!e){if(HEAP[HEAP[u+36]+4*g]==HEAP[HEAP[u+36]+4*(g+1)])break c;e=_FT_Stream_Seek(s,HEAP[HEAP[u+36]+4*g]);HEAP[a]=e;e=HEAP[a]!=
0;d:do if(!e){m=_FT_Stream_EnterFrame(s,HEAP[HEAP[u+36]+4*(g+1)]-HEAP[HEAP[u+36]+4*g]);HEAP[a]=m;if(HEAP[a]!=0)break d;m=HEAP[s+32]-HEAP[s];h=_ft_mem_realloc(r,4,0,HEAP[u],0,a);l=HEAP[a]!=0;e:do if(!l){k=_ft_mem_realloc(r,4,0,HEAP[u],0,a);if(HEAP[a]!=0){c=8;break e}j=_ft_mem_realloc(r,4,0,HEAP[u],0,a);if(HEAP[a]!=0){c=8;break e}i=s;n=0;o=HEAP[i+32];if(o+1<HEAP[i+36]){o+=2;n=reSign(HEAP[o+-2],8)<<8&65535;p=unSign(HEAP[o+-2+1],8);n=n|p}HEAP[i+32]=o;i=i=reSign(n,16);i=unSign(i&65535,16);o=s;p=0;n=HEAP[o+
32];if(n+1<HEAP[o+36]){n+=2;p=reSign(HEAP[n+-2],8)<<8&65535;var C=unSign(HEAP[n+-2+1],8);p=p|C}HEAP[o+32]=n;o=o=reSign(p,16);t=unSign(o&65535,16)+m;if((i&32768)!=0){v=HEAP[s+32]-HEAP[s];HEAP[s+32]=HEAP[s]+t;A=_ft_var_readpackedpoints(s,y);t=HEAP[s+32]-HEAP[s];HEAP[s+32]=HEAP[s]+v}i=i&4095;o=h;n=k;p=j;C=h;var B=k,D=j,E=b,F=b,G=b,H=q,J=q,L=q,N=q,I=b,P=q,K=q,O=q,M=q,Q=r,R=r,T=r,V=A,U=h,S=z;t=t;var X=v;f=14;f:for(;;){c=f==55?Ea:0;var Y=f==55?ua:X,W=f==55?Ba:t,da=f==55?Na:S,ba=0+c;if(!(unSign(i,32)>unSign(ba,
32))){c=57;break f}ba=s;w=HEAP[ba+32];if(w+1<HEAP[ba+36]){var aa=w+2,ca=reSign(HEAP[aa+-2],8)<<8&65535,$=unSign(HEAP[aa+-2+1],8);ca=ca|$;f=16}else f=56;$=f==56?0:ca;HEAP[ba+32]=f==56?w:aa;ba=reSign($,16)&65535;ba=unSign(ba,16);w=s;$=HEAP[w+32];if($+1<HEAP[w+36]){var la=$+2,ga=reSign(HEAP[la+-2],8)<<8&65535;f=unSign(HEAP[la+-2+1],8);ga=ga|f;f=18}else f=67;var ea=f==67?0:ga;HEAP[w+32]=f==67?$:la;w=reSign(ea,16)&65535;$=unSign(w,16);ea=($&32768)!=0;g:do if(ea){f=w=0;if(!(unSign(HEAP[u],32)>unSign(f,
32)))break g;for(;;){var Z=s,ha=HEAP[Z+32];if(ha+1<HEAP[Z+36]){var ia=ha+2,ja=reSign(HEAP[ia+-2],8)<<8&65535;f=unSign(HEAP[ia+-2+1],8);ja=ja|f;f=22}else f=20;var fa=f==20?0:ja;HEAP[Z+32]=f==20?ha:ia;f=reSign(fa,16)&65535;f=reSign(f,16)<<2;HEAP[o+4*w]=f;w+=1;f=w;if(!(unSign(HEAP[u],32)>unSign(f,32)))break}}else{w=HEAP[u+24];if(unSign($&4095,32)>=unSign(w,32)){c=26;break f}_llvm_memcpy_p0i8_p0i8_i32(U,HEAP[u+28]+4*HEAP[u]*($&4095),HEAP[u]*4,1,0)}while(0);ua=($&16384)!=0;g:do if(ua){Ba=w=0;if(unSign(HEAP[u],
32)>unSign(Ba,32))for(Ba=u;;){Na=s;Ea=HEAP[Na+32];if(Ea+1<HEAP[Na+36]){var ka=Ea+2,na=reSign(HEAP[ka+-2],8)<<8&65535;f=unSign(HEAP[ka+-2+1],8);na=na|f;f=30}else f=29;ea=f==29?0:na;HEAP[Na+32]=f==29?Ea:ka;Na=reSign(ea,16)&65535;Na=reSign(Na,16)<<2;HEAP[n+4*w]=Na;w+=1;Na=w;if(!(unSign(HEAP[Ba],32)>unSign(Na,32)))break}Ba=w=0;if(!(unSign(HEAP[u],32)>unSign(Ba,32)))break g;for(;;){Ba=s;Na=HEAP[Ba+32];if(Na+1<HEAP[Ba+36]){var sa=Na+2,wa=reSign(HEAP[sa+-2],8)<<8&65535;Ea=unSign(HEAP[sa+-2+1],8);wa=wa|Ea;
f=36}else f=34;Ea=f==34?0:wa;HEAP[Ba+32]=f==34?Na:sa;Ba=reSign(Ea,16)&65535;Ba=reSign(Ba,16)<<2;HEAP[p+4*w]=Ba;w+=1;Ba=w;if(!(unSign(HEAP[u],32)>unSign(Ba,32)))break}}while(0);ua=unSign($&65535,16);ua=_ft_var_apply_tuple(u,ua&65535,C,B,D);if(ua==0){var Aa=ba+W;f=40}else{var Da=HEAP[s+32]-HEAP[s];if(($&8192)!=0){HEAP[s+32]=HEAP[s]+W;var pa=_ft_var_readpackedpoints(s,x),ta=HEAP[x];f=42}else{var ma=HEAP[y];HEAP[x]=ma;f=44}Na=f==44?V:pa;var ya=f==44?da:pa,qa=HEAP[x];qa=_ft_var_readpackeddeltas(s,(f==
44?ma:ta)==0?E:qa);Ba=HEAP[x];Ba=_ft_var_readpackeddeltas(s,HEAP[x]==0?F:Ba);Ea=Na!=0&Ba!=0&qa!=0;g:do if(Ea){$=Na==4294967295;w=0;if($){if(!(unSign(w,32)<unSign(G,32)))break g;for(;;){$=H+8*w;f=HEAP[J+8*w];ea=reSign(HEAP[qa+2*w],16);f=_FT_MulFix(ea,ua)+f;HEAP[$]=f;$=L+8*w;f=HEAP[N+8*w+4];ea=reSign(HEAP[Ba+2*w],16);f=_FT_MulFix(ea,ua)+f;HEAP[$+4]=f;w+=1;if(!(unSign(w,32)<unSign(I,32)))break g}}else{$=HEAP[x];if(!(unSign(w,32)<unSign($,32)))break g;for(;;){$=unSign(HEAP[ya+2*w],16);$=P+8*$;f=unSign(HEAP[ya+
2*w],16);f=HEAP[K+8*f];ea=reSign(HEAP[qa+2*w],16);f=_FT_MulFix(ea,ua)+f;HEAP[$]=f;$=unSign(HEAP[ya+2*w],16);$=O+8*$;f=unSign(HEAP[ya+2*w],16);f=HEAP[M+8*f+4];ea=reSign(HEAP[Ba+2*w],16);f=_FT_MulFix(ea,ua)+f;HEAP[$+4]=f;w+=1;$=HEAP[x];if(!(unSign(w,32)<unSign($,32)))break g}}}while(0);ua=ya!=4294967295;g:do if(ua){Na=ya;if(Na==0){f=48;break g}FUNCTION_TABLE[HEAP[Q+8]](Q,Na);f=49}else f=46;while(0);ya=f==46?4294967295:f==48?0:0;qa=qa;qa!=0&&FUNCTION_TABLE[HEAP[R+8]](R,qa);qa=Ba;qa!=0&&FUNCTION_TABLE[HEAP[T+
8]](T,qa);qa=ba+W;HEAP[s+32]=HEAP[s]+Da;f=54}var ua=f==54?Da:Y,Ba=f==54?qa:Aa,Na=f==54?ya:da,Ea=c+1;f=55;c=15}if(c==57){v=Y;z=da}else if(c==26){v=Y;z=da;HEAP[a]=8}o=h;h=r;i=o;o!=0&&FUNCTION_TABLE[HEAP[h+8]](h,i);h=0;o=k;k=r;i=o;o!=0&&FUNCTION_TABLE[HEAP[k+8]](k,i);i=j;j=r;k=i;i!=0&&FUNCTION_TABLE[HEAP[j+8]](j,k)}while(0);m=s;if(HEAP[m+20]!=0){l=HEAP[m+28];h=HEAP[m];l=l;h=h;h!=0&&FUNCTION_TABLE[HEAP[l+8]](l,h);HEAP[m]=0}HEAP[m+32]=0;HEAP[m+36]=0;if(HEAP[a]==0)break b}while(0);g=q;r=r;b=g;g!=0&&FUNCTION_TABLE[HEAP[r+
8]](r,b);HEAP[d]=0;break b}while(0);q=0;c=5;break a}while(0);q=HEAP[a];c=5;break a}while(0);if(c==0)q=6;d=q;STACKTOP=a;return d}_TT_Vary_Get_Glyph_Deltas.__index__=Runtime.getFunctionIndex(_TT_Vary_Get_Glyph_Deltas,"_TT_Vary_Get_Glyph_Deltas");
function _read_pfb_tag(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c;HEAP[g]=0;HEAP[d]=0;a=_FT_Stream_ReadShort(e,b);if(HEAP[b]==0){var f=a==-32767|a==-32766;a:do if(f){c=_FT_Stream_ReadLongLE(e,b);if(HEAP[b]!=0)break a;HEAP[d]=c}while(0);HEAP[g]=a}e=HEAP[b];STACKTOP=b;return e}_read_pfb_tag.__index__=Runtime.getFunctionIndex(_read_pfb_tag,"_read_pfb_tag");
function _check_type1_format(e,g,d){var b=STACKTOP;STACKTOP+=6;Runtime.memset(b,0,6);var a,c,f,h,i=b+2;h=_FT_Stream_Seek(e,0);var k=h!=0;a:do if(!k){h=_read_pfb_tag(e,b,i);if(h!=0)break a;if(HEAP[b]!=-32767){h=_FT_Stream_Seek(e,0);if(h!=0)break a}h=f=_FT_Stream_EnterFrame(e,d);if(f!=0)break a;h=0;if(_memcmp(HEAP[e+32],g,d)!=0)h=2;f=e;if(HEAP[f+20]!=0){a=HEAP[f+28];c=HEAP[f];a=a;c=c;c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[f]=0}HEAP[f+32]=0;HEAP[f+36]=0}while(0);e=h;STACKTOP=b;return e}
_check_type1_format.__index__=Runtime.getFunctionIndex(_check_type1_format,"_check_type1_format");
function _t1_allocate_blend(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;a=null;var c,f;g=g;c=d;f=HEAP[e+100];HEAP[b]=0;d=HEAP[e+532];var h=d==0;a:do if(h){d=_ft_mem_alloc(f,420,b);if(HEAP[b]!=0){a=0;break a}HEAP[d+416]=0;HEAP[e+532]=d;a=2;break a}else a=2;while(0);a:do if(a==2){h=g!=0;b:do if(h){if(HEAP[d]==0){a=_ft_mem_realloc(f,32,0,g,0,b);HEAP[d+144+4]=a;if(HEAP[b]!=0)break a;a=_ft_mem_realloc(f,196,0,g,0,b);HEAP[d+212+4]=a;if(HEAP[b]!=0)break a;a=_ft_mem_realloc(f,16,0,g,0,b);
HEAP[d+284+4]=a;if(HEAP[b]!=0)break a;a=_ft_mem_realloc(f,4,0,g*2,0,b);HEAP[d+136]=a;if(HEAP[b]!=0)break a;HEAP[d+140]=HEAP[d+136]+4*g;HEAP[d+144]=e+132;HEAP[d+212]=e+132+36;HEAP[d+284]=e+132+328;a=g;if(unSign(2,32)<=unSign(a,32)){h=g;for(a=7;;){k=a==7?0:k;a=3+k;var i=2+k;HEAP[d+212+i*4]=HEAP[d+144+(18+k)*4]+196;HEAP[d+144+i*4]=HEAP[d+140+4*i]+32;HEAP[d+284+i*4]=HEAP[d+280+4*i]+16;a=unSign(a,32)<=unSign(h,32);var k=k+1;if(a)a=8;else break}}HEAP[d]=g;a=11}else a=HEAP[d]!=g?12:11;break b}else a=11;
while(0);b:do if(a==11){if(c!=0){if(HEAP[d+4]!=0)if(HEAP[d+4]!=c){a=12;break b}HEAP[d+4]=c}g=e=HEAP[d];c=HEAP[d+4];if(e==0)break a;if(c==0)break a;if(HEAP[d+24]!=0)break a;e=_ft_mem_realloc(f,4,0,c*g,0,b);HEAP[d+24]=e;if(HEAP[b]!=0)break a;e=g;if(!(unSign(1,32)<unSign(e,32)))break a;c=c;g=g;g=(unSign(g,32)>unSign(2,32)?g:2)-1;e=1*c;for(a=19;;){j=a==19?0:j;HEAP[d+24+(1+j)*4]=HEAP[d+24]+4*(e+c*j);var j=j+1;if(j!=g)a=20;else break}break a}while(0);HEAP[b]=3}while(0);j=HEAP[b];STACKTOP=b;return j}
_t1_allocate_blend.__index__=Runtime.getFunctionIndex(_t1_allocate_blend,"_t1_allocate_blend");
function _T1_Get_Multi_Master(e,g){var d=null,b,a;b=HEAP[e+532];a=6;if(b!=0){HEAP[g]=HEAP[b+4];HEAP[g+4]=HEAP[b];if(unSign(HEAP[b+4],32)>unSign(0,32)){a=b+4;for(d=0;;){j=d==0?0:j;d=1+j;var c=0+j,f=b+88+c*12,h=b+88+c*12+4,i=g+8+c*12+8,k=g+8+c*12+4;HEAP[g+8+c*12]=HEAP[b+8+c*4];HEAP[k]=HEAP[HEAP[h]];c=HEAP[h];f=unSign(HEAP[f],8)-1;HEAP[i]=HEAP[c+4*f];d=unSign(HEAP[a],32)>unSign(d,32);var j=j+1;if(d)d=1;else break}}a=0}return a}
_T1_Get_Multi_Master.__index__=Runtime.getFunctionIndex(_T1_Get_Multi_Master,"_T1_Get_Multi_Master");
function _T1_Get_MM_Var(e,g){var d=STACKTOP;STACKTOP+=76;Runtime.memset(d,0,76);var b,a=null,c,f,h,i,k,j=d+56,l=d+60,m;i=HEAP[e+100];m=HEAP[e+532];k=_T1_Get_Multi_Master(e,d);HEAP[j]=k;var o=HEAP[j]!=0;a:do if(!o){k=_ft_mem_alloc(i,HEAP[d]*24+20,j);if(HEAP[j]!=0)break a;HEAP[k]=HEAP[d];HEAP[k+4]=HEAP[d+4];HEAP[k+8]=-1;HEAP[k+12]=k+20;var n=c=HEAP[k+16]=0;n=unSign(HEAP[d],32)>unSign(n,32);b:do if(n){f=d+8;h=d+8;var p=d+8,r=d;for(;;){HEAP[HEAP[k+12]+24*c]=HEAP[f+c*12];HEAP[HEAP[k+12]+24*c+4]=HEAP[h+
c*12+4]<<16;HEAP[HEAP[k+12]+24*c+12]=HEAP[p+c*12+8]<<16;b=HEAP[k+12]+24*c;a=Math.floor(reSign(HEAP[HEAP[k+12]+24*c+12]+HEAP[HEAP[k+12]+24*c+4],32)/reSign(2,32));HEAP[b+8]=a;HEAP[HEAP[k+12]+24*c+20]=-1;HEAP[HEAP[k+12]+24*c+16]=-1;b=_strcmp(HEAP[HEAP[k+12]+24*c],__str740)==0;a=HEAP[k+12]+24*c;d:do if(b)HEAP[a+16]=2003265652;else{var q=_strcmp(HEAP[a],__str841)==0,s=HEAP[k+12]+24*c;if(q)HEAP[s+16]=2003072104;else{if(_strcmp(HEAP[s],__str942)!=0)break d;HEAP[HEAP[k+12]+24*c+16]=1869640570}}while(0);c+=
1;b=c;if(unSign(HEAP[r],32)>unSign(b,32))b=2;else{b=6;break b}}}while(0);n=HEAP[m]==1<<HEAP[m+4];b:do if(n){h=HEAP[m+4];f=l;c=HEAP[m+140];f=f;h=h;if(h==1)HEAP[f]=HEAP[c+4];else if(h==2){HEAP[f]=HEAP[c+4]+HEAP[c+12];HEAP[f+4]=HEAP[c+8]+HEAP[c+12]}else{p=c;if(h==3){HEAP[f]=HEAP[c+20]+HEAP[p+28]+HEAP[c+12]+HEAP[c+4];HEAP[f+4]=HEAP[c+24]+HEAP[c+28]+HEAP[c+12]+HEAP[c+8];HEAP[f+8]=HEAP[c+24]+HEAP[c+28]+HEAP[c+20]+HEAP[c+16]}else{HEAP[f]=HEAP[c+52]+HEAP[p+60]+HEAP[c+44]+HEAP[c+36]+HEAP[c+28]+HEAP[c+20]+
HEAP[c+12]+HEAP[c+4];HEAP[f+4]=HEAP[c+56]+HEAP[c+60]+HEAP[c+44]+HEAP[c+40]+HEAP[c+28]+HEAP[c+24]+HEAP[c+12]+HEAP[c+8];HEAP[f+8]=HEAP[c+56]+HEAP[c+60]+HEAP[c+52]+HEAP[c+48]+HEAP[c+28]+HEAP[c+24]+HEAP[c+20]+HEAP[c+16];HEAP[f+12]=HEAP[c+56]+HEAP[c+60]+HEAP[c+52]+HEAP[c+48]+HEAP[c+44]+HEAP[c+40]+HEAP[c+36]+HEAP[c+32]}}f=c=0;if(!(unSign(HEAP[d],32)>unSign(f,32))){b=9;break b}f=m+88;h=d;c:for(;;){p=HEAP[k+12]+24*c;q=HEAP[l+c*4];r=f+c*12;if(reSign(HEAP[HEAP[r+8]],32)>=reSign(q,32)){var u=HEAP[HEAP[r+4]]<<
16;a=11}else{s=unSign(HEAP[r],8);var t=r+8;for(a=13;;){b=a==16?w:0;var v=b+1;if(!(reSign(s,32)>reSign(v,32))){b=18;break}if(reSign(HEAP[HEAP[t]+4*v],32)>=reSign(q,32)){b=15;break}var w=b+1;a=16;b=14}if(b==18){var x=HEAP[r+4];b=unSign(HEAP[r],8)-1;x=HEAP[x+4*b]<<16;a=18}else if(b==15){var y=_FT_MulDiv(q-HEAP[HEAP[r+8]+4*(v-1)],65536,HEAP[HEAP[r+8]+4*v]-HEAP[HEAP[r+8]+4*(v-1)]);b=HEAP[HEAP[r+4]+4*(v-1)]*65536;y=_FT_MulDiv(y,HEAP[HEAP[r+4]+4*v]-HEAP[HEAP[r+4]+4*(v-1)],1)+b;a=15}}HEAP[p+8]=a==11?u:a==
15?y:x;c+=1;b=c;if(unSign(HEAP[h],32)>unSign(b,32))b=10;else{b=20;break c}}}while(0);HEAP[g]=k}while(0);i=HEAP[j];STACKTOP=d;return i}_T1_Get_MM_Var.__index__=Runtime.getFunctionIndex(_T1_Get_MM_Var,"_T1_Get_MM_Var");
function _T1_Set_MM_Blend(e,g,d){var b=null,a;e=HEAP[e+532];a=6;var c=e!=0;a:do if(c){if(HEAP[e+4]!=g)break a;if(unSign(HEAP[e],32)>unSign(0,32)){a=e+4;var f=d,h=e+4,i=e+136,k=e;b=2;b:for(;;){q=b==2?0:q;var j=0+q,l=1+q;if(unSign(HEAP[a],32)>unSign(0,32)){b=HEAP[h];var m=unSign(b,32)>unSign(1,32)?b:1;b=4;c:for(;;){p=b==4?65536:p;r=b==4?0:r;var o=HEAP[f+4*r],n=reSign(o,32)<reSign(0,32);d:do if(n)b=5;else{if(!(reSign(o,32)>reSign(65536,32))){b=6;break d}b=7}while(0);b=b==7?65536:b==6?o:0;o=65536-b;var p=
_FT_MulFix(p,(1<<r&j)==0?o:b),r=r+1;if(r!=m)b=8;else break c}b=10}else b=3;HEAP[HEAP[i]+4*j]=b==10?p:65536;j=unSign(HEAP[k],32)>unSign(l,32);var q=q+1;if(j)b=12;else break b}}a=0}while(0);return a}_T1_Set_MM_Blend.__index__=Runtime.getFunctionIndex(_T1_Set_MM_Blend,"_T1_Set_MM_Blend");
function _T1_Set_MM_Design(e,g,d){var b=STACKTOP;STACKTOP+=64;Runtime.memset(b,0,64);var a,c=null,f,h;f=HEAP[e+532];h=6;var i=f!=0;a:do if(i){if(HEAP[f+4]!=g)break a;if(unSign(HEAP[f+4],32)>unSign(0,32)){h=d;var k=f,j=f+4;c=2;b:for(;;){A=c==2?0:A;var l=0+A,m=k+88+l*12,o=1+A,n=b+l*4,p=HEAP[h+4*l],r=HEAP[k+88+l*12+4];l=HEAP[k+88+l*12+8];var q=unSign(HEAP[m],8);for(c=3;;){var s=c==9?t:0,u=s+-1;a=r+4*s;if(unSign(q,32)>unSign(s,32))c=4;else{c=4;a=8;break}a=HEAP[a];if(p==a){a=5;break}if(reSign(p,32)<reSign(a,
32)){c=6;a=8;break}var t=s+1;c=9;a=4}if(a==8){a=c==6?s:-1;if(reSign(u,32)<reSign(0,32)){var v=HEAP[l];c=11}else if(reSign(a,32)<reSign(0,32)){var w=unSign(HEAP[m],8)-1;w=HEAP[l+4*w];c=12}else{var x=_FT_MulDiv(p-HEAP[r+4*u],HEAP[l+4*a]-HEAP[l+4*u],HEAP[r+4*a]-HEAP[r+4*u]);c=13}}else if(a==5){var y=HEAP[l+4*s];c=5}HEAP[n]=c==13?x:c==12?w:c==11?v:y;o=unSign(HEAP[j],32)>unSign(o,32);var A=A+1;if(o){c=14;a=3}else{a=15;break b}}}h=_T1_Set_MM_Blend(e,g,b)}while(0);e=h;STACKTOP=b;return e}
_T1_Set_MM_Design.__index__=Runtime.getFunctionIndex(_T1_Set_MM_Design,"_T1_Set_MM_Design");
function _T1_Set_Var_Design(e,g,d){var b=STACKTOP;STACKTOP+=16;Runtime.memset(b,0,16);var a=null,c;c=6;if(unSign(g,32)<=unSign(4,32)&g!=0){if(unSign(0,32)<unSign(g,32)){c=(unSign(g,32)>unSign(1,32)?g:1)-0;for(a=0;;){k=a==0?0:k;a=0+k;var f=b+a*4;a=HEAP[d+4*a];if(reSign(a,32)>=reSign(0,32)){var h=a+32768&-65536;a=2}else{var i=0-(32768-a&-65536);a=4}a=reSign(a==2?h:i,32)>>reSign(16,32);HEAP[f]=a;var k=k+1;if(k!=c)a=5;else break}}c=_T1_Set_MM_Design(e,g,b)}e=c;STACKTOP=b;return e}
_T1_Set_Var_Design.__index__=Runtime.getFunctionIndex(_T1_Set_Var_Design,"_T1_Set_Var_Design");
function _T1_Done_Blend(e){var g,d,b,a,c;d=HEAP[e+100];b=HEAP[e+532];if(b!=0){a=HEAP[b];c=HEAP[b+4];g=HEAP[b+24];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+24]=0;g=1;var f=unSign(g,32)<unSign(a,32);a:do if(f)for(var h=a;;){HEAP[b+24+g*4]=0;g+=1;if(!(unSign(g,32)<unSign(h,32)))break a}while(0);g=HEAP[b+212+4];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+212+4]=0;g=HEAP[b+144+4];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+144+4]=0;g=HEAP[b+284+4];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);g=HEAP[b+284+4]=
0;f=unSign(g,32)<unSign(a,32);a:do if(f)for(h=a;;){HEAP[b+212+g*4]=0;HEAP[b+144+g*4]=0;HEAP[b+284+g*4]=0;g+=1;if(!(unSign(g,32)<unSign(h,32)))break a}while(0);a=HEAP[b+136];a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,a);HEAP[b+136]=0;g=HEAP[b+140]=0;if(unSign(g,32)<unSign(c,32))for(;;){a=HEAP[b+8+g*4];a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,a);HEAP[b+8+g*4]=0;g+=1;if(!(unSign(g,32)<unSign(c,32)))break}g=0;if(unSign(g,32)<unSign(c,32))for(;;){a=b+88+12*g;f=HEAP[a+4];f!=0&&FUNCTION_TABLE[HEAP[d+8]](d,f);HEAP[a+4]=
0;HEAP[a]=0;g+=1;if(!(unSign(g,32)<unSign(c,32)))break}b=HEAP[e+532];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[e+532]=0}}_T1_Done_Blend.__index__=Runtime.getFunctionIndex(_T1_Done_Blend,"_T1_Done_Blend");
function _parse_blend_axis_types(e,g){var d=STACKTOP;STACKTOP+=56;Runtime.memset(d,0,56);var b,a=null,c=d+48,f=d+52,h,i;HEAP[f]=0;FUNCTION_TABLE[HEAP[g+20+40]](g,d,4,c);var k=reSign(HEAP[c],32)<reSign(0,32);a:do if(k)HEAP[f]=162;else{i=HEAP[c]==0;var j=reSign(HEAP[c],32)>reSign(4,32);if(i|j)HEAP[f]=3;else{i=_t1_allocate_blend(e,0,HEAP[c]);HEAP[f]=i;if(HEAP[f]!=0)break a;h=HEAP[e+532];i=i=HEAP[e+100];h=j=h;for(a=2;;){b=a==8?r:0;var l=0+b;a=d+l*12;var m=d+l*12+4,o=j+8+l*4,n=h+8+l*4,p=HEAP[c];if(!(reSign(l,
32)<reSign(p,32))){b=7;break}if(HEAP[HEAP[a]]==47)HEAP[a]+=1;l=HEAP[m]-HEAP[a];if(l==0){b=5;break}m=_ft_mem_alloc(i,l+1,f);HEAP[o]=m;if(HEAP[f]!=0){b=7;break}r=HEAP[n];_llvm_memcpy_p0i8_p0i8_i32(r,HEAP[a],l,1,0);HEAP[r+l]=0;var r=b+1;a=8;b=3}if(b!=7)if(b==5)HEAP[f]=3}}while(0);HEAP[g+12]=HEAP[f];STACKTOP=d}_parse_blend_axis_types.__index__=Runtime.getFunctionIndex(_parse_blend_axis_types,"_parse_blend_axis_types");
function _parse_blend_design_positions(e,g){var d=STACKTOP;STACKTOP+=248;Runtime.memset(d,0,248);var b,a=null,c=d+192,f,h,i,k,j=d+196,l=d+244;f=0;FUNCTION_TABLE[HEAP[g+20+40]](g,d,16,c);if(reSign(HEAP[c],32)<reSign(0,32))f=162;else{h=HEAP[c]==0;i=reSign(HEAP[c],32)>reSign(16,32);if(h|i)f=3;else{i=HEAP[g];k=HEAP[g+8];h=HEAP[e+532];var m=g+8,o=g+20+40,n=e+532,p=g+8,r=g+20+20,q=f;a=1;a:for(;;){b=a==14?B:0;var s=a==14?x:q;y=a==14?y:0;A=a==14?A:h;B=0+b;x=d+B*12;a=d+B*12+4;var u=HEAP[c];if(!(reSign(B,32)<
reSign(u,32))){b=16;break a}HEAP[g]=HEAP[x];HEAP[m]=HEAP[a];FUNCTION_TABLE[HEAP[o]](g,j,4,l);x=HEAP[l];if(B==0){var t=reSign(x,32)<=reSign(0,32),v=reSign(HEAP[l],32)>reSign(4,32);if(t|v){b=3;break a}t=HEAP[l];var w=_t1_allocate_blend(e,HEAP[c],t);if(w!=0){b=5;break a}v=HEAP[n];a=6}else if(x!=y){b=9;break a}else a=8;var x=a==8?s:0,y=a==8?y:t,A=a==8?A:v;a=HEAP[l];if(reSign(0,32)<reSign(a,32)){B=A+24+B*4;for(a=10;;){C=a==10?0:C;a=C+1;u=j+C*12+4;HEAP[g]=HEAP[j+C*12];HEAP[p]=HEAP[u];u=HEAP[B];var z=FUNCTION_TABLE[HEAP[r]](g,
0);HEAP[u+4*C]=z;var C=C+1;u=HEAP[l];if(reSign(a,32)<reSign(u,32))a=11;else break}}var B=b+1;a=14;b=2}if(b==16){f=s;HEAP[g]=i;HEAP[g+8]=k}else if(b==3)f=3;else if(b==5)f=w;else if(b==9)f=3}}HEAP[g+12]=f;STACKTOP=d}_parse_blend_design_positions.__index__=Runtime.getFunctionIndex(_parse_blend_design_positions,"_parse_blend_design_positions");
function _parse_blend_design_map(e,g){var d=STACKTOP;STACKTOP+=300;Runtime.memset(d,0,300);var b,a=null,c,f=d+4,h=d+52,i,k,j,l=d+56,m=d+296;HEAP[d]=0;j=HEAP[e+100];FUNCTION_TABLE[HEAP[g+20+40]](g,f,4,h);var o=reSign(HEAP[h],32)<reSign(0,32);a:do if(o)HEAP[d]=162;else{i=HEAP[h]==0;k=reSign(HEAP[h],32)>reSign(4,32);if(i|k)HEAP[d]=3;else{i=HEAP[g];k=HEAP[g+8];c=_t1_allocate_blend(e,0,HEAP[h]);HEAP[d]=c;if(HEAP[d]!=0)break a;c=c=HEAP[e+532];var n=g,p=g+8,r=g+20+40,q=g,s=l,u=j,t=g,v=g+8,w=g+20+16,x=g,
y=g+20+20,A=g;a=2;b:for(;;){var z=a==9?H:0;a=0+z;b=c+88+a*12;var C=c+88+a*12+4,B=c+88+a*12+8,D=f+a*12,E=f+a*12+4,F=HEAP[h];if(!(reSign(a,32)<reSign(F,32))){b=12;break b}HEAP[n]=HEAP[D];HEAP[p]=HEAP[E];FUNCTION_TABLE[HEAP[r]](q,s,20,m);a=reSign(HEAP[m],32)<=reSign(0,32);D=reSign(HEAP[m],32)>reSign(20,32);if(a|D){b=4;break b}a=_ft_mem_realloc(u,4,0,HEAP[m]*2,0,d);HEAP[C]=a;if(HEAP[d]!=0){b=6;break b}HEAP[B]=HEAP[C]+4*HEAP[m];HEAP[b]=HEAP[m]&255;b=HEAP[m];if(reSign(0,32)<reSign(b,32)){a=7;b=8}else{a=
7;b=9}for(;;)if(b==8){G=a==8?G:0;b=G+1;a=l+G*12+4;HEAP[t]=HEAP[l+G*12]+1;HEAP[v]=HEAP[a]+-1;a=HEAP[C];D=FUNCTION_TABLE[HEAP[w]](x);HEAP[a+4*G]=D;a=HEAP[B];D=FUNCTION_TABLE[HEAP[y]](A,0);HEAP[a+4*G]=D;var G=G+1;a=HEAP[m];if(reSign(b,32)<reSign(a,32))b=a=8;else{a=10;b=9}}else if(b==9){var H=z+1;a=9;b=3;continue b}}if(b==12){HEAP[g]=i;HEAP[g+8]=k}else if(b==4)HEAP[d]=3}}while(0);HEAP[g+12]=HEAP[d];STACKTOP=d}_parse_blend_design_map.__index__=Runtime.getFunctionIndex(_parse_blend_design_map,"_parse_blend_design_map");
function _parse_weight_vector(e,g){var d=STACKTOP;STACKTOP+=196;Runtime.memset(d,0,196);var b,a=null,c=d+192,f,h,i;f=0;h=HEAP[e+532];FUNCTION_TABLE[HEAP[g+20+40]](g,d,16,c);var k=reSign(HEAP[c],32)<reSign(0,32);a:do if(k)f=162;else{b=HEAP[c]==0;i=reSign(HEAP[c],32)>reSign(16,32);if(b|i)f=3;else{i=h==0;b:do if(i)b=1;else{if(HEAP[h]==0){b=1;break b}if(HEAP[h]==HEAP[c]){b=7;break b}f=3;break a}while(0);if(b==1){f=h=_t1_allocate_blend(e,HEAP[c],0);if(h!=0)break a;h=HEAP[e+532]}b=HEAP[g];i=HEAP[g+8];var j=
HEAP[c];if(reSign(0,32)<reSign(j,32)){j=g;var l=g+8,m=h+140,o=h+136,n=g+20+20,p=g;for(a=8;;){t=a==8?0:t;a=1+t;var r=0+t,q=d+r*12+4;HEAP[j]=HEAP[d+r*12];HEAP[l]=HEAP[q];q=HEAP[m];var s=HEAP[o],u=FUNCTION_TABLE[HEAP[n]](p,0);HEAP[s+4*r]=u;HEAP[q+4*r]=HEAP[s+4*r];r=HEAP[c];a=reSign(a,32)<reSign(r,32);var t=t+1;if(a)a=9;else break}}HEAP[g]=b;HEAP[g+8]=i}}while(0);HEAP[g+12]=f;STACKTOP=d}_parse_weight_vector.__index__=Runtime.getFunctionIndex(_parse_weight_vector,"_parse_weight_vector");
function _parse_buildchar(e,g){var d=FUNCTION_TABLE[HEAP[g+20+32]](g,0,0,0);HEAP[e+544]=d}_parse_buildchar.__index__=Runtime.getFunctionIndex(_parse_buildchar,"_parse_buildchar");function _parse_private(e,g){HEAP[g+372]|=1}_parse_private.__index__=Runtime.getFunctionIndex(_parse_private,"_parse_private");
function _read_binary_data(e,g,d){var b,a,c,f;f=HEAP[e+8];FUNCTION_TABLE[HEAP[e+20+8]](e);c=HEAP[e];var h=c<f;a:do if(h){b=unSign(HEAP[c],8)-48;if(!(unSign(b,32)<=unSign(9,32))){b=1;break a}b=FUNCTION_TABLE[HEAP[e+20+16]](e);FUNCTION_TABLE[HEAP[e+20+12]](e);HEAP[d]=HEAP[e]+1;if(!(reSign(b,32)>=reSign(0,32))){b=1;break a}c=b;if(!(reSign(f-HEAP[d],32)>reSign(c,32))){b=1;break a}HEAP[e]+=b+1;HEAP[g]=b;a=unSign(HEAP[e+12]==0,1);b=4;break a}else b=1;while(0);if(b==1){HEAP[e+12]=3;a=0}return a}
_read_binary_data.__index__=Runtime.getFunctionIndex(_read_binary_data,"_read_binary_data");
function _parse_font_matrix(e,g){var d=STACKTOP;STACKTOP+=24;Runtime.memset(d,0,24);var b,a,c;a=e+132+304;c=e+132+320;b=FUNCTION_TABLE[HEAP[g+20+32]](g,6,d,3);if(reSign(b,32)<reSign(0,32))HEAP[g+12]=3;else{b=HEAP[d+12];var f=0-b;b=reSign(b,32)>=reSign(0,32)?b:f;if(b==0)HEAP[g+12]=3;else{f=_FT_DivFix(65536E3,b);f=reSign(f,32)>>reSign(16,32)&65535;HEAP[e+68]=f;if(b!=65536){f=_FT_DivFix(HEAP[d],b);HEAP[d]=f;f=_FT_DivFix(HEAP[d+4],b);HEAP[d+4]=f;f=_FT_DivFix(HEAP[d+8],b);HEAP[d+8]=f;f=_FT_DivFix(HEAP[d+
16],b);HEAP[d+16]=f;b=_FT_DivFix(HEAP[d+20],b);HEAP[d+20]=b;b=reSign(HEAP[d+12],32)<reSign(0,32)?-65536:65536;HEAP[d+12]=b}HEAP[a]=HEAP[d];HEAP[a+8]=HEAP[d+4];HEAP[a+4]=HEAP[d+8];HEAP[a+12]=HEAP[d+12];a=reSign(HEAP[d+16],32)>>reSign(16,32);HEAP[c]=a;a=reSign(HEAP[d+20],32)>>reSign(16,32);HEAP[c+4]=a}}STACKTOP=d}_parse_font_matrix.__index__=Runtime.getFunctionIndex(_parse_font_matrix,"_parse_font_matrix");
function _parse_encoding(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a=null,c,f,h,i,k,j,l,m;f=HEAP[g+8];h=HEAP[e+488];FUNCTION_TABLE[HEAP[g+20+8]](g);c=HEAP[g];if(c>=f)HEAP[g+12]=3;else{j=unSign(HEAP[c],8)-48;j=unSign(j,32)<=unSign(9,32);a:do if(!j){if(HEAP[c]==91){b=0;break a}var o=c+17>=f;b:do if(!o){if(_strncmp(c,__str751,16)!=0)break b;HEAP[e+132+236]=2;STACKTOP=d;return}while(0);o=c+15>=f;b:do if(!o){if(_strncmp(c,__str852,14)!=0)break b;HEAP[e+132+236]=4;STACKTOP=d;return}while(0);
o=c+18>=f;b:do if(!o){if(_strncmp(c,__str953,17)!=0)break b;HEAP[e+132+236]=3;STACKTOP=d;return}while(0);HEAP[g+12]=162;STACKTOP=d;return}while(0);i=e+132+240;j=g+100;l=HEAP[g+16];m=0;if(HEAP[c]==91){k=256;m=1;HEAP[g]+=1}else k=FUNCTION_TABLE[HEAP[g+20+16]](g);FUNCTION_TABLE[HEAP[g+20+8]](g);if(!(HEAP[g]>=f)){HEAP[i]=k;HEAP[g+96]=HEAP[i];var n=_ft_mem_realloc(l,2,0,k,0,d);HEAP[i+12]=n;n=HEAP[d]!=0;a:do if(!n){n=_ft_mem_realloc(l,4,0,k,0,d);HEAP[i+16]=n;if(HEAP[d]!=0)break a;h=FUNCTION_TABLE[HEAP[HEAP[h]]](j,
k,l);HEAP[d]=h;if(HEAP[d]!=0)break a;a=0;h=k;if(reSign(a,32)<reSign(h,32)){h=j+36+8;i=j;n=k;l=a;a=l+1;n=(reSign(n,32)>reSign(a,32)?n:a)-l;for(a=6;;){b=a==6?0:p;FUNCTION_TABLE[HEAP[h]](i,l+b,__str650,8);var p=b+1;if(p!=n)b=a=7;else{b=8;break}}}a=0;FUNCTION_TABLE[HEAP[g+20+8]](g);h=p=f;i=m;m=i!=0;i=i!=0;f=f;k=k;l=j+36+8;n=j;j=j+24;var r=a;a=10;b:for(;;){t=a==46?t:r;if(!(HEAP[g]<p)){b=50;break b}c=HEAP[g];b=HEAP[c]==100;c:do if(b){if(!(c+3<h))break c;if(HEAP[c+1]!=101)break c;if(HEAP[c+2]!=102)break c;
if(HEAP[c+3]==32){b=16;break b}if(HEAP[c+3]==13){b=16;break b}if(HEAP[c+3]==10){b=16;break b}if(HEAP[c+3]==9){b=16;break b}if(HEAP[c+3]==12){b=16;break b}if(HEAP[c+3]==0){b=16;break b}if(HEAP[c+3]==47){b=16;break b}if(HEAP[c+3]==40){b=16;break b}if(HEAP[c+3]==41){b=16;break b}if(HEAP[c+3]==60){b=16;break b}if(HEAP[c+3]==62){b=16;break b}if(HEAP[c+3]==91){b=16;break b}if(HEAP[c+3]==93){b=16;break b}if(HEAP[c+3]==123){b=16;break b}if(HEAP[c+3]==125){b=16;break b}if(HEAP[c+3]==37){b=16;break b}}while(0);
o=c;if(HEAP[c]==93){b=34;break b}b=unSign(HEAP[o],8)-48;var q=unSign(b,32)<=unSign(9,32);c:do if(q){if(m){a=39;b=37;break c}var s=FUNCTION_TABLE[HEAP[g+20+16]](g);FUNCTION_TABLE[HEAP[g+20+8]](g);a=40;b=37;break c}else{if(m){a=36;b=37;break c}FUNCTION_TABLE[HEAP[g+20+12]](g);if(HEAP[g+12]!=0){b=43;break b}else{a=38;b=46;break c}}while(0);c:do if(b==37){a=a==40?s:a==36?t:t;c=HEAP[g];q=HEAP[c]!=47;d:do if(!q){b=c+2>=f;q=reSign(t,32)>=reSign(k,32);if(b|q){b=41;break d}c+=1;HEAP[g]=c;FUNCTION_TABLE[HEAP[g+
20+12]](g);if(HEAP[g+12]!=0){b=43;break b}var u=HEAP[g]-c;b=FUNCTION_TABLE[HEAP[l]](n,a,c,u+1);HEAP[g+12]=b;if(HEAP[g+12]!=0){b=43;break b}HEAP[HEAP[HEAP[j]+4*a]+u]=0;u=t+1;a=45;break c}while(0);if(i){b=47;break b}else a=41}while(0);var t=a==45?u:a==41?t:t;FUNCTION_TABLE[HEAP[g+20+8]](g);a=46;b=11}if(b!=50)if(b==16)c+=3;else if(b==34)c=o+1;else if(b==47){HEAP[g+12]=2;STACKTOP=d;return}else if(b==43){STACKTOP=d;return}HEAP[e+132+236]=1;HEAP[g]=c;STACKTOP=d;return}while(0);HEAP[g+12]=HEAP[d]}}STACKTOP=
d}_parse_encoding.__index__=Runtime.getFunctionIndex(_parse_encoding,"_parse_encoding");
function _parse_subrs(e,g){var d=STACKTOP;STACKTOP+=12;Runtime.memset(d,0,12);var b;b=null;var a,c,f,h,i=d+4,k=d+8;a=g+316;c=HEAP[g+16];h=HEAP[e+488];FUNCTION_TABLE[HEAP[g+20+8]](g);f=HEAP[g]<HEAP[g+8];a:do if(f){if(HEAP[HEAP[g]]!=91){b=1;break a}FUNCTION_TABLE[HEAP[g+20+12]](g);FUNCTION_TABLE[HEAP[g+20+8]](g);if(!(HEAP[g]>=HEAP[g+8]))if(HEAP[HEAP[g]]==93){b=3;break a}HEAP[g+12]=3;STACKTOP=d;return}else b=1;while(0);a:do if(b==1){f=FUNCTION_TABLE[HEAP[g+20+16]](g);FUNCTION_TABLE[HEAP[g+20+12]](g);
if(HEAP[g+12]!=0)break a;FUNCTION_TABLE[HEAP[g+20+8]](g);var j=HEAP[g+312]==0;b:do if(j){j=FUNCTION_TABLE[HEAP[HEAP[h]]](a,f,c);HEAP[d]=j;b=HEAP[d]!=0?5:6;break b}else b=6;while(0);if(b==6){j=g+312;var l=e+132+36+4,m=e+132+36+4,o=c;h=h+16;var n=e+132+36+4,p=a+36+8,r=e+132+36+4,q=a;c=c;var s=a+36+8;for(a=a;;){if(_strncmp(HEAP[g],__str1054,3)!=0){b=8;break}FUNCTION_TABLE[HEAP[g+20+12]](g);b=FUNCTION_TABLE[HEAP[g+20+16]](g);if(_read_binary_data(g,i,k)==0){b=10;break}FUNCTION_TABLE[HEAP[g+20+12]](g);
if(HEAP[g+12]!=0){b=10;break}FUNCTION_TABLE[HEAP[g+20+8]](g);if(_strncmp(HEAP[g],__str1155,3)==0){FUNCTION_TABLE[HEAP[g+20+12]](g);FUNCTION_TABLE[HEAP[g+20+8]](g)}if(HEAP[j]!=0)b=7;else{if(reSign(HEAP[l],32)>=reSign(0,32)){var u=HEAP[i];if(reSign(HEAP[m],32)>reSign(u,32)){b=16;break}u=_ft_mem_alloc(o,HEAP[i],d);if(HEAP[d]!=0){b=19;break}_llvm_memcpy_p0i8_p0i8_i32(u,HEAP[k],HEAP[i],1,0);FUNCTION_TABLE[HEAP[h]](u,HEAP[i],4330);HEAP[i]-=HEAP[n];b=FUNCTION_TABLE[HEAP[p]](q,b,u+HEAP[r],HEAP[i]);HEAP[d]=
b;u!=0&&FUNCTION_TABLE[HEAP[c+8]](c,u);u=HEAP[d];b=22}else{var t=FUNCTION_TABLE[HEAP[s]](a,b,HEAP[k],HEAP[i]);HEAP[d]=t;b=24}if((b==24?t:u)!=0){b=19;break}else b=7}}if(b==8){if(HEAP[g+312]!=0)break a;HEAP[g+312]=f;STACKTOP=d;return}else if(b==10){STACKTOP=d;return}else if(b==16)HEAP[d]=3}HEAP[g+12]=HEAP[d];STACKTOP=d;return}while(0);STACKTOP=d}_parse_subrs.__index__=Runtime.getFunctionIndex(_parse_subrs,"_parse_subrs");
function _parse_charstrings(e,g){var d=STACKTOP;STACKTOP+=17;Runtime.memset(d,0,17);var b,a=null,c,f,h,i,k,j,l,m,o,n,p=d+4,r=d+8,q=d+12;c=g+208;f=g+156;h=g+260;i=HEAP[g+16];k=HEAP[e+488];j=HEAP[g+8];n=o=0;m=FUNCTION_TABLE[HEAP[g+20+16]](g);var s=m==0;a:do if(!s){if(HEAP[g+12]!=0)break a;s=HEAP[g+152]==0;b:do if(s){s=FUNCTION_TABLE[HEAP[HEAP[k]]](c,m+6,i);HEAP[d]=s;if(HEAP[d]!=0){b=2;break b}s=FUNCTION_TABLE[HEAP[HEAP[k]]](f,m+6,i);HEAP[d]=s;if(HEAP[d]!=0){b=2;break b}s=FUNCTION_TABLE[HEAP[HEAP[k]]](h,
4,i);HEAP[d]=s;b=HEAP[d]!=0?2:5;break b}else b=5;while(0);b:do if(b==5){l=0;s=g+20+8;var u=g,t=g,v=j,w=j,x=g+20+12,y=g,A=g+12,z=j,C=g,B=g,D=g+152,E=e+132+36+4,F=c+36+8,G=c,H=m+5,J=e+132+36+4,L=i,N=k+16,I=e+132+36+4,P=c+36+8,K=e+132+36+4,O=c,M=i;l=l;a=5;c:for(;;){var Q=a==5?l:a==53?U:a==38?Q:Q;FUNCTION_TABLE[HEAP[s]](u);b=HEAP[t];if(b>=v){b=7;break c}a=b+3<w;d:do if(a){var R=HEAP[b+3]==32;e:do if(!R){if(HEAP[b+3]==13)break e;if(HEAP[b+3]==10)break e;if(HEAP[b+3]==9)break e;if(HEAP[b+3]==12)break e;
if(HEAP[b+3]==0)break e;if(HEAP[b+3]==47)break e;if(HEAP[b+3]==40)break e;if(HEAP[b+3]==41)break e;if(HEAP[b+3]==60)break e;if(HEAP[b+3]==62)break e;if(HEAP[b+3]==91)break e;if(HEAP[b+3]==93)break e;if(HEAP[b+3]==123)break e;if(HEAP[b+3]==125)break e;if(HEAP[b+3]!=37)break d}while(0);R=HEAP[b]==100;e:do if(R){if(HEAP[b+1]!=101)break e;if(HEAP[b+2]==102&Q!=0){b=7;break c}}while(0);if(HEAP[b]!=101)break d;if(HEAP[b+1]!=110)break d;if(HEAP[b+2]==100){b=7;break c}}while(0);FUNCTION_TABLE[HEAP[x]](y);
if(HEAP[A]!=0){b=32;break c}if(HEAP[b]!=47){a=33;b=6;continue c}if(b+1>=z){b=35;break c}b+=1;a=HEAP[C]-b;if(_read_binary_data(B,p,r)==0){b=32;break c}if(HEAP[D]!=0){a=38;b=6;continue c}R=FUNCTION_TABLE[HEAP[f+36+8]](f,Q,b,a+1);HEAP[d]=R;if(HEAP[d]!=0){b=40;break c}HEAP[HEAP[HEAP[f+24]+4*Q]+a]=0;b=HEAP[b]==46;d:do if(b){if(_strcmp(__str650,HEAP[HEAP[f+24]+4*Q])!=0)break d;o=Q;n=1}while(0);b=reSign(HEAP[E],32)<reSign(0,32);a=reSign(H,32)<=reSign(Q,32);if(b|a){var T=FUNCTION_TABLE[HEAP[F]](G,Q,HEAP[r],
HEAP[p]);HEAP[d]=T;a=51}else{b=HEAP[p];if(reSign(HEAP[J],32)>=reSign(b,32)){b=45;break c}b=_ft_mem_alloc(L,HEAP[p],d);if(HEAP[d]!=0){b=40;break c}_llvm_memcpy_p0i8_p0i8_i32(b,HEAP[r],HEAP[p],1,0);FUNCTION_TABLE[HEAP[N]](b,HEAP[p],4330);HEAP[p]-=HEAP[I];var V=FUNCTION_TABLE[HEAP[P]](O,Q,b+HEAP[K],HEAP[p]);HEAP[d]=V;b!=0&&FUNCTION_TABLE[HEAP[M+8]](M,b);V=HEAP[d];a=49}if((a==51?T:V)!=0){b=40;break c}var U=Q+1;a=53;b=6}if(b==7){l=Q;HEAP[g+152]=l;if(n!=0)if(_strcmp(__str650,HEAP[HEAP[f+24]])==0){if(n!=
0)break a}else{q=FUNCTION_TABLE[HEAP[h+36+8]](h,0,HEAP[HEAP[f+24]],HEAP[HEAP[f+28]]);HEAP[d]=q;if(HEAP[d]!=0)break b;q=FUNCTION_TABLE[HEAP[h+36+8]](h,1,HEAP[HEAP[c+24]],HEAP[HEAP[c+28]]);HEAP[d]=q;if(HEAP[d]!=0)break b;q=FUNCTION_TABLE[HEAP[h+36+8]](h,2,HEAP[HEAP[f+24]+4*o],HEAP[HEAP[f+28]+4*o]);HEAP[d]=q;if(HEAP[d]!=0)break b;q=FUNCTION_TABLE[HEAP[h+36+8]](h,3,HEAP[HEAP[c+24]+4*o],HEAP[HEAP[c+28]+4*o]);HEAP[d]=q;if(HEAP[d]!=0)break b;q=FUNCTION_TABLE[HEAP[f+36+8]](f,o,HEAP[HEAP[h+24]],HEAP[HEAP[h+
28]]);HEAP[d]=q;if(HEAP[d]!=0)break b;o=FUNCTION_TABLE[HEAP[c+36+8]](c,o,HEAP[HEAP[h+24]+4],HEAP[HEAP[h+28]+4]);HEAP[d]=o;if(HEAP[d]!=0)break b;f=FUNCTION_TABLE[HEAP[f+36+8]](f,0,HEAP[HEAP[h+24]+8],HEAP[HEAP[h+28]+8]);HEAP[d]=f;if(HEAP[d]!=0)break b;c=FUNCTION_TABLE[HEAP[c+36+8]](c,0,HEAP[HEAP[h+24]+12],HEAP[HEAP[h+28]+12]);HEAP[d]=c;if(HEAP[d]!=0)break b;else break a}HEAP[q]=-117;HEAP[q+1]=-9;HEAP[q+2]=-31;HEAP[q+3]=13;HEAP[q+4]=14;o=__str650;i=FUNCTION_TABLE[HEAP[h+36+8]](h,0,HEAP[HEAP[f+24]],HEAP[HEAP[f+
28]]);HEAP[d]=i;if(i!=0)break b;i=FUNCTION_TABLE[HEAP[h+36+8]](h,1,HEAP[HEAP[c+24]],HEAP[HEAP[c+28]]);HEAP[d]=i;if(HEAP[d]!=0)break b;o=FUNCTION_TABLE[HEAP[f+36+8]](f,0,o,8);HEAP[d]=o;if(HEAP[d]!=0)break b;o=FUNCTION_TABLE[HEAP[c+36+8]](c,0,q,5);HEAP[d]=o;if(HEAP[d]!=0)break b;f=FUNCTION_TABLE[HEAP[f+36+8]](f,l,HEAP[HEAP[h+24]],HEAP[HEAP[h+28]]);HEAP[d]=f;if(HEAP[d]!=0)break b;c=FUNCTION_TABLE[HEAP[c+36+8]](c,l,HEAP[HEAP[h+24]+4],HEAP[HEAP[h+28]+4]);HEAP[d]=c;if(HEAP[d]!=0)break b;HEAP[g+152]+=1;
STACKTOP=d;return}else if(b==32){STACKTOP=d;return}else if(b==35)HEAP[d]=3;else if(b!=40)if(b==45)HEAP[d]=3}while(0);HEAP[g+12]=HEAP[d];STACKTOP=d;return}while(0);STACKTOP=d}_parse_charstrings.__index__=Runtime.getFunctionIndex(_parse_charstrings,"_parse_charstrings");
function _parse_dict(e,g,d,b){var a=STACKTOP;STACKTOP+=20;Runtime.memset(a,0,20);var c,f=null,h,i,k,j,l,m,o=a+4,n=a+8,p=a+12,r=a+16,q;m=0;HEAP[g]=d;HEAP[g+8]=d+b;HEAP[g+12]=0;d=HEAP[g+8];FUNCTION_TABLE[HEAP[g+20+8]](g);f=-1;a:for(;;){A=f==64?A:0;if(!(HEAP[g]<d)){c=20;break a}b=HEAP[g];c=HEAP[b]!=101;b:do if(!c){h=b+6==d;c:do if(!h){if(b+6>=d)break b;if(HEAP[b+5]==32)break c;if(HEAP[b+5]==13)break c;if(HEAP[b+5]==10)break c;if(HEAP[b+5]==9)break c;if(HEAP[b+5]==12)break c;if(HEAP[b+5]==0)break c;if(HEAP[b+
5]==47)break c;if(HEAP[b+5]==40)break c;if(HEAP[b+5]==41)break c;if(HEAP[b+5]==60)break c;if(HEAP[b+5]==62)break c;if(HEAP[b+5]==91)break c;if(HEAP[b+5]==93)break c;if(HEAP[b+5]==123)break c;if(HEAP[b+5]==125)break c;if(HEAP[b+5]!=37)break b}while(0);if(_strncmp(b,__str246,5)==0){c=20;break a}}while(0);c=HEAP[b]!=99;b:do if(!c){h=b+10==d;c:do if(!h){if(b+10>=d)break b;if(HEAP[b+9]==32)break c;if(HEAP[b+9]==13)break c;if(HEAP[b+9]==10)break c;if(HEAP[b+9]==9)break c;if(HEAP[b+9]==12)break c;if(HEAP[b+
9]==0)break c;if(HEAP[b+9]==47)break c;if(HEAP[b+9]==40)break c;if(HEAP[b+9]==41)break c;if(HEAP[b+9]==60)break c;if(HEAP[b+9]==62)break c;if(HEAP[b+9]==91)break c;if(HEAP[b+9]==93)break c;if(HEAP[b+9]==123)break c;if(HEAP[b+9]==125)break c;if(HEAP[b+9]!=37)break b}while(0);if(_strncmp(b,__str57,9)==0){c=20;break a}}while(0);h=HEAP[b]!=70;b:do if(h)c=42;else{c=b+14==d;c:do if(!c){if(b+14>=d){c=42;break b}if(HEAP[b+13]==32)break c;if(HEAP[b+13]==13)break c;if(HEAP[b+13]==10)break c;if(HEAP[b+13]==
9)break c;if(HEAP[b+13]==12)break c;if(HEAP[b+13]==0)break c;if(HEAP[b+13]==47)break c;if(HEAP[b+13]==40)break c;if(HEAP[b+13]==41)break c;if(HEAP[b+13]==60)break c;if(HEAP[b+13]==62)break c;if(HEAP[b+13]==91)break c;if(HEAP[b+13]==93)break c;if(HEAP[b+13]==123)break c;if(HEAP[b+13]==125)break c;if(HEAP[b+13]!=37){c=42;break b}}while(0);if(_strncmp(b,__str58,13)!=0){c=42;break b}if((HEAP[g+372]&1&255)!=0)HEAP[g+372]|=2;HEAP[g]+=13;f=63;c=64;break b}while(0);b:do if(c==42){f=unSign(HEAP[b],8)-48;f=
unSign(f,32)<=unSign(9,32);h=b;if(f){m=h;FUNCTION_TABLE[HEAP[g+20+12]](g);if(HEAP[g+12]!=0){c=20;break a}else f=65}else{f=HEAP[h]!=82;c:do if(!f){if(b+6>=d){c=67;break c}if(HEAP[b+1]!=68|A==0){c=67;break c}HEAP[g]=m;if(_read_binary_data(g,o,n)==0){c=70;break a}else{f=69;break b}}while(0);f=HEAP[b]!=45;c:do if(!f){if(b+6>=d){c=72;break c}if(HEAP[b+1]!=124|A==0){c=72;break c}HEAP[g]=m;if(_read_binary_data(g,p,r)==0){c=75;break a}else{f=74;break b}}while(0);h=HEAP[b]!=47;c:do if(!h){if(b+2>=d){c=76;
break c}b+=1;HEAP[g]=b;FUNCTION_TABLE[HEAP[g+20+12]](g);if(HEAP[g+12]!=0){c=20;break a}q=HEAP[g]-b;f=reSign(q,32)>reSign(0,32);j=reSign(q,32)<=reSign(21,32);if(!(f&j)){f=78;break b}if(!(HEAP[g]<d)){f=79;break b}f=_t1_keywords;j=b;var s=q;q=q;var u=b,t=f;f=80;d:for(;;){c=f==85?x:0;var v=t+36*c,w=HEAP[v];if(w==0){c=82;break d}f=HEAP[j]==HEAP[w];e:do if(f){if(_strlen(w)!=s)break e;if(_memcmp(u,w,q)==0){c=86;break d}}while(0);var x=c+1;f=85;c=81}if(c==82){f=82;break b}else if(c==86){c=w;f=v;b=b=(HEAP[g+
372]&1&255)!=0?2:1;if((b&HEAP[f+32])==0){f=89;break b}if((HEAP[g+372]&2)!=0)if(_strcmp(c,__str50)!=0){f=91;break b}c=g;h=f;b=e;f=c;h=h;j=HEAP[b+532];s=HEAP[h+8]==10;q=h;d:do if(s){FUNCTION_TABLE[HEAP[q+12]](b,f);c=HEAP[f+12]}else{c=HEAP[q+4];c=c==2?106:c==3?107:c==4?108:c==5?109:c==6?110:c==7?111:c==8?112:113;e:do if(c==113){HEAP[a]=b+132;i=a;k=0}else if(c==106){HEAP[a]=b+132+32;i=a;k=0}else if(c==107){HEAP[a]=b+132;i=a;k=0;if(j==0)break e;i=j+144;k=HEAP[j]}else if(c==108){HEAP[a]=b+132+36;i=a;k=
0;if(j==0)break e;i=j+212;k=HEAP[j]}else if(c==109){HEAP[a]=b+132+328;i=a;k=0;if(j==0)break e;i=j+284;k=HEAP[j]}else if(c==110){HEAP[a]=f;i=a;k=0}else if(c==111){HEAP[a]=b;i=a;k=0}else if(c==112){HEAP[a]=HEAP[b+532];i=a;k=0}while(0);c=HEAP[h+8]==8;e:do if(!c){if(HEAP[h+8]==9)break e;c=FUNCTION_TABLE[HEAP[f+20+44]](f,h,i,k,0);break d}while(0);c=FUNCTION_TABLE[HEAP[f+20+48]](f,h,i,k,0)}while(0);c=c=c;HEAP[g+12]=c;if(HEAP[g+12]==0){f=101;break b}var y=g+12;if((HEAP[g+12]&255)!=162){c=104;break a}HEAP[y]=
0;f=103;break b}}while(0);FUNCTION_TABLE[HEAP[g+20+12]](g);if(HEAP[g+12]!=0){c=20;break a}else f=76}}while(0);var A=f==63?A:f==65?1:f==69?0:f==74?0:f==82?0:f==91?0:f==101?0:f==103?0:f==89?0:f==79?0:f==78?0:0;FUNCTION_TABLE[HEAP[g+20+8]](g);f=64;c=0}if(c==20)l=HEAP[g+12];else if(c==70)l=3;else if(c==75)l=3;else if(c==104)l=HEAP[y];e=l;STACKTOP=a;return e}_parse_dict.__index__=Runtime.getFunctionIndex(_parse_dict,"_parse_dict");
function _T1_Size_Get_Globals_Funcs(e){var g,d,b;d=HEAP[HEAP[e]+552];b=_FT_Get_Module(HEAP[HEAP[HEAP[e]+96]+4],__str59);var a=b==0;a:do if(a)e=0;else{if(d==0){e=0;break a}if(HEAP[d]==0){e=0;break a}g=FUNCTION_TABLE[HEAP[d]](b);e=3;break a}while(0);if(e==0)g=0;return g}_T1_Size_Get_Globals_Funcs.__index__=Runtime.getFunctionIndex(_T1_Size_Get_Globals_Funcs,"_T1_Size_Get_Globals_Funcs");
function _T1_Size_Done(e){var g;if(HEAP[e+40]!=0){g=_T1_Size_Get_Globals_Funcs(e);g!=0&&FUNCTION_TABLE[HEAP[g+8]](HEAP[e+40]);HEAP[e+40]=0}}_T1_Size_Done.__index__=Runtime.getFunctionIndex(_T1_Size_Done,"_T1_Size_Done");function _T1_Size_Init(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d,b;d=0;b=_T1_Size_Get_Globals_Funcs(e);var a=b!=0;a:do if(a){d=HEAP[e];d=FUNCTION_TABLE[HEAP[b]](HEAP[HEAP[e]+100],d+132+36,g);if(d!=0)break a;HEAP[e+40]=HEAP[g]}while(0);e=d;STACKTOP=g;return e}
_T1_Size_Init.__index__=Runtime.getFunctionIndex(_T1_Size_Init,"_T1_Size_Init");function _T1_Size_Request(e,g){var d;d=_T1_Size_Get_Globals_Funcs(e);_FT_Request_Metrics(HEAP[e],g);d!=0&&FUNCTION_TABLE[HEAP[d+4]](HEAP[e+40],HEAP[e+12+4],HEAP[e+12+8],0,0);return 0}_T1_Size_Request.__index__=Runtime.getFunctionIndex(_T1_Size_Request,"_T1_Size_Request");function _T1_GlyphSlot_Done(e){HEAP[HEAP[e+156]+36]=0}_T1_GlyphSlot_Done.__index__=Runtime.getFunctionIndex(_T1_GlyphSlot_Done,"_T1_GlyphSlot_Done");
function _T1_GlyphSlot_Init(e){var g,d;g=HEAP[HEAP[e+4]+552];var b=g!=0;a:do if(b){d=_FT_Get_Module(HEAP[HEAP[HEAP[e+4]+96]+4],__str59);if(d==0)break a;d=FUNCTION_TABLE[HEAP[g+4]](d);HEAP[HEAP[e+156]+36]=d}while(0);return 0}_T1_GlyphSlot_Init.__index__=Runtime.getFunctionIndex(_T1_GlyphSlot_Init,"_T1_GlyphSlot_Init");
function _T1_Face_Done(e){var g,d,b;if(e!=0){d=HEAP[e+100];b=e+132;if(HEAP[e+548]!=0){g=HEAP[e+548];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+548]=0;HEAP[e+548]=0;HEAP[e+544]=0}_T1_Done_Blend(e);HEAP[e+532]=0;g=HEAP[b];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b]=0;g=HEAP[b+4];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+4]=0;g=HEAP[b+8];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+8]=0;g=HEAP[b+12];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+12]=0;g=HEAP[b+16];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);
HEAP[b+16]=0;g=HEAP[b+296];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+296]=0;g=HEAP[b+292];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+292]=0;g=HEAP[b+288];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+288]=0;g=HEAP[b+276];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+276]=0;g=HEAP[b+280];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+280]=0;g=HEAP[b+260];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+260]=0;g=HEAP[b+264];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+264]=0;g=HEAP[b+268];g!=0&&FUNCTION_TABLE[HEAP[d+
8]](d,g);HEAP[b+268]=0;g=HEAP[b+240+12];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+240+12]=0;g=HEAP[b+240+16];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+240+16]=0;g=HEAP[b+232];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[b+232]=0;HEAP[e+492]!=0&&_T1_Done_Metrics(d,HEAP[e+492]);HEAP[e+20]=0;HEAP[e+24]=0}}_T1_Face_Done.__index__=Runtime.getFunctionIndex(_T1_Face_Done,"_T1_Face_Done");
function _T1_Face_Init(e,g,d){e=STACKTOP;STACKTOP+=1920;Runtime.memset(e,0,1920);var b,a=null,c,f,h,i,k,j,l,m,o,n,p=e+1500,r=e+1504,q,s=e+1508,u,t=e+1510,v,w=e+1514;v=e+1518;q=e+1520;var x=e+1524,y,A,z=e+1900,C,B,D,E,F=e+1904,G=e+1908;E=g+132;HEAP[g]=1;D=_ft_module_get_service(HEAP[g+96],__str60);HEAP[g+484]=D;B=_FT_Get_Module(HEAP[HEAP[g+96]+4],__str61);HEAP[g+488]=B!=0?HEAP[HEAP[B]+20]:0;B=HEAP[g+488];y=_FT_Get_Module(HEAP[HEAP[g+96]+4],__str59);HEAP[g+552]=y!=0?HEAP[HEAP[y]+20]:0;y=g+132;A=y+36;
C=HEAP[g+488];_llvm_memset_p0i8_i32(x,0,376,1,0);HEAP[x+152]=0;HEAP[x+96]=0;HEAP[x+100+12]=0;HEAP[x+208+12]=0;HEAP[x+156+12]=0;HEAP[x+316+12]=0;HEAP[x+260+12]=0;HEAP[x+368]=0;HEAP[x+372]=0;HEAP[g+536]=-1;HEAP[g+540]=-1;HEAP[g+544]=0;HEAP[A+112]=7;HEAP[A+116]=1;HEAP[A+4]=4;HEAP[A+180]=3932;HEAP[A+108]=2596864;l=HEAP[g+100];o=HEAP[g+104];FUNCTION_TABLE[HEAP[HEAP[C+4]]](x,0,0,l);HEAP[x+72]=o;HEAP[x+80]=0;HEAP[x+76]=0;HEAP[x+88]=0;HEAP[x+84]=0;HEAP[x+92]=0;HEAP[x+93]=0;HEAP[x+94]=0;b=_check_type1_format(o,
__str44,14);HEAP[w]=b;u=b!=0;a:do if(u){m=HEAP[w];if(m!=2){a=2;b=3;break a}else a=2;b=_check_type1_format(o,__str145,10);HEAP[w]=b;b=HEAP[w]!=0?5:6;break a}else b=6;while(0);a:do if(b==6){b=_FT_Stream_Seek(o,0);HEAP[w]=b;if(b!=0){b=5;break a}b=_read_pfb_tag(o,v,q);HEAP[w]=b;if(HEAP[w]!=0){b=5;break a}if(HEAP[v]!=-32767){b=_FT_Stream_Seek(o,0);HEAP[w]=b;if(HEAP[w]!=0){b=5;break a}HEAP[q]=HEAP[o+4]}else HEAP[x+92]=1;if(HEAP[o+20]==0){HEAP[x+76]=HEAP[o]+HEAP[o+8];HEAP[x+80]=HEAP[q];HEAP[x+93]=1;q=HEAP[q];
b=o;q=q;if(reSign(q,32)<reSign(0,32)){HEAP[w]=85;b=5;break a}else{b=_FT_Stream_Seek(b,q+HEAP[b+8]);HEAP[w]=b;if(b!=0){b=5;break a}}}else{b=_ft_mem_alloc(l,HEAP[q],w);HEAP[x+76]=b;if(HEAP[w]!=0){b=5;break a}v=HEAP[q];u=HEAP[x+76];b=o;o=u;v=v;b=b=_FT_Stream_ReadAt(b,HEAP[b+8],o,v);HEAP[w]=b;if(HEAP[w]!=0){b=5;break a}HEAP[x+80]=HEAP[q]}HEAP[x+4]=HEAP[x+76];HEAP[x]=HEAP[x+76];HEAP[x+8]=HEAP[x]+HEAP[x+80];n=HEAP[w];a=14;b=3;break a}while(0);a:do if(b==3){b=(a==14?n:m)!=0?5:15;break a}while(0);a:do if(b==
5){if(HEAP[x+93]!=0){b=15;break a}n=HEAP[x+76];m=l;n=n;n!=0&&FUNCTION_TABLE[HEAP[m+8]](m,n);HEAP[x+76]=0}while(0);w=HEAP[w];HEAP[z]=w;w=w!=0;a:do if(!w){l=_parse_dict(g,x,HEAP[x+76],HEAP[x+80]);HEAP[z]=l;if(HEAP[z]!=0){b=19;break a}a=C;l=x;m=a;o=HEAP[l+72];n=HEAP[l+16];HEAP[p]=0;v=HEAP[l+92]!=0;b:do if(v){a=o;q=a=a=HEAP[a+8];HEAP[l+88]=0;var H=u=o,J=H+8;a=21;c:for(;;){a=_read_pfb_tag(u,s,r);HEAP[p]=a;if(a!=0){a=22;b=23;break c}else a=22;j=HEAP[l+88];if(HEAP[s]!=-32766){b=25;break c}HEAP[l+88]=HEAP[r]+
j;b=HEAP[r];if(reSign(b,32)<reSign(0,32)){b=27;break c}a=_FT_Stream_Seek(H,HEAP[J]+b);HEAP[p]=a;if(a!=0){a=28;b=23;break c}else{a=28;b=22}}if(b==23){b=81;break b}else if(b==25)if(j==0){HEAP[p]=3;a=30;b=29;break b}else{a=_FT_Stream_Seek(o,q);HEAP[p]=a;var L=HEAP[p];if(L!=0){a=31;b=29;break b}a=_ft_mem_alloc(n,HEAP[l+88],p);HEAP[l+84]=a;var N=HEAP[p];if(N!=0){a=32;b=29;break b}HEAP[l+88]=0;u=q=o;H=u+8;for(a=33;;){b=_read_pfb_tag(q,s,r);HEAP[p]=b;if(b!=0|HEAP[s]!=-32766){b=35;break}b=_FT_Stream_ReadAt(u,
HEAP[H],HEAP[l+84]+HEAP[l+88],HEAP[r]);HEAP[p]=b;if(HEAP[p]!=0){b=38;break}HEAP[l+88]=HEAP[r]+HEAP[l+88];a=39;b=34}if(b==35){HEAP[p]=0;b=37;break b}else if(b==38){b=81;break b}}else if(b==27){HEAP[p]=85;a=27;b=29;break b}}else{q=HEAP[l+76];u=u=q+HEAP[l+80];a=40;c:for(;;){b=a==40?u:f;d:for(;;){H=HEAP[q]==101;e:do if(H){if(!(q+9<b))break e;if(HEAP[q+1]!=101)break e;if(HEAP[q+2]!=120)break e;if(HEAP[q+3]!=101)break e;if(HEAP[q+4]==99)break d}while(0);q+=1;if(q>=b){b=50;break c}}HEAP[l]=HEAP[l+76];HEAP[l+
8]=q+9;q=HEAP[l];for(c=HEAP[l+8];;){if(!(q<c))break;if(HEAP[q]==101)if(_strncmp(q,__str246,5)==0){b=52;break c}FUNCTION_TABLE[HEAP[l+20+12]](l);if(HEAP[l+12]!=0)break;FUNCTION_TABLE[HEAP[l+20+8]](l);q=HEAP[l]}q=c;f=HEAP[l+76]+HEAP[l+80];a=54;b=41}if(b==52){u=c;HEAP[l+8]=HEAP[l+76]+HEAP[l+80];FUNCTION_TABLE[HEAP[l+20+12]](l);q=HEAP[l];b=u;c:for(;;){if(q>=b)break c;o=HEAP[q]==32;d:do if(!o){if(HEAP[q]==9)break d;if(HEAP[q]==13)break d;if(HEAP[q]!=10)break c}while(0);q+=1}if(q>=u){HEAP[p]=3;a=64;b=29}else{HEAP[r]=
0-q+HEAP[l+80]+(0-(0-HEAP[l+76]));if(HEAP[l+93]!=0){a=_ft_mem_alloc(n,HEAP[r]+1,p);HEAP[l+84]=a;var I=HEAP[p];if(I!=0){a=65;b=29;break b}else a=65;HEAP[l+88]=HEAP[r]}else{HEAP[l+94]=1;HEAP[l+84]=HEAP[l+76];HEAP[l+88]=HEAP[r];HEAP[l+76]=0;HEAP[l+80]=0}b=unSign(HEAP[q],8)-48;n=unSign(b,32)<=unSign(9,32);c:do if(n)b=68;else{b=unSign(HEAP[q],8)-97;if(unSign(b,32)<=unSign(5,32)){b=68;break c}b=unSign(HEAP[q],8)-65;b=unSign(b,32)<=unSign(5,32)?68:70;break c}while(0);c:do if(b==68){b=unSign(HEAP[q+1],8)-
48;b=unSign(b,32)<=unSign(9,32);d:do if(!b){n=unSign(HEAP[q+1],8)-97;if(unSign(n,32)<=unSign(5,32))break d;n=unSign(HEAP[q+1],8)-65;if(!(unSign(n,32)<=unSign(5,32)))break c}while(0);b=unSign(HEAP[q+2],8)-48;b=unSign(b,32)<=unSign(9,32);d:do if(!b){n=unSign(HEAP[q+2],8)-97;if(unSign(n,32)<=unSign(5,32))break d;n=unSign(HEAP[q+2],8)-65;if(!(unSign(n,32)<=unSign(5,32)))break c}while(0);b=unSign(HEAP[q+3],8)-48;b=unSign(b,32)<=unSign(9,32);d:do if(!b){n=unSign(HEAP[q+3],8)-97;if(unSign(n,32)<=unSign(5,
32))break d;n=unSign(HEAP[q+3],8)-65;if(!(unSign(n,32)<=unSign(5,32)))break c}while(0);HEAP[l]=q;FUNCTION_TABLE[HEAP[HEAP[m+4]+24]](l,HEAP[l+84],HEAP[l+88],t,0);HEAP[l+88]=HEAP[t];HEAP[HEAP[l+84]+HEAP[t]]=0;b=37;break b}while(0);_llvm_memmove_p0i8_p0i8_i32(HEAP[l+84],q,HEAP[r],1,0);b=37}break b}else if(b==50){HEAP[p]=3;a=50;b=29;break b}}while(0);if(b==29){HEAP[z]=a==27?85:a==30?3:a==31?L:a==32?N:a==50?3:a==64?3:I;b=19;break a}else if(b==37){FUNCTION_TABLE[HEAP[m+16]](HEAP[l+84],HEAP[l+88],-9871);
HEAP[HEAP[l+84]]=32;HEAP[HEAP[l+84]+1]=32;HEAP[HEAP[l+84]+2]=32;HEAP[HEAP[l+84]+3]=32;HEAP[l+4]=HEAP[l+84];HEAP[l]=HEAP[l+84];HEAP[l+8]=HEAP[l]+HEAP[l+88]}l=HEAP[p];HEAP[z]=l;if(l!=0){b=19;break a}l=_parse_dict(g,x,HEAP[x+84],HEAP[x+88]);HEAP[z]=l;if(HEAP[z]!=0){b=19;break a}HEAP[A+8]&=-2;l=HEAP[g+532]!=0;b:do if(l){if(HEAP[HEAP[g+532]+416]==0){b=85;break b}if(HEAP[HEAP[g+532]+416]==HEAP[HEAP[g+532]+4]){b=85;break b}HEAP[HEAP[g+532]+416]=0}while(0);l=HEAP[g+532]!=0;b:do if(l){if(HEAP[HEAP[g+532]]!=
0)if(HEAP[HEAP[g+532]+4]!=0){b=89;break b}_T1_Done_Blend(g)}while(0);if(HEAP[g+532]!=0){l=HEAP[HEAP[g+532]+4];m=g+532;for(a=91;;){b=a==94?k:0;n=0+b;if(!(unSign(l,32)>unSign(n,32))){b=97;break}if(HEAP[HEAP[m]+88+n*12]==0){b=93;break}k=b+1;a=94;b=92}b!=97&&b==93&&_T1_Done_Blend(g)}l=HEAP[g+532]!=0;b:do if(l){if(HEAP[g+544]==0){b=99;break b}b=HEAP[g+100];b=_ft_mem_realloc(b,4,0,HEAP[g+544],0,z);HEAP[g+548]=b;if(HEAP[z]==0){b=99;break b}HEAP[g+544]=0;b=19;break a}while(0);HEAP[y+284]=HEAP[x+152];if(HEAP[x+
316+12]!=0){HEAP[x+316+12]=0;HEAP[y+272]=HEAP[x+312];HEAP[y+260]=HEAP[x+316];HEAP[y+276]=HEAP[x+316+24];HEAP[y+280]=HEAP[x+316+28]}l=HEAP[HEAP[g+128]+52]==0;b:do if(l){if(HEAP[x+208+12]!=0){b=103;break b}HEAP[z]=3}while(0);HEAP[x+208+12]=0;HEAP[y+264]=HEAP[x+208];HEAP[y+292]=HEAP[x+208+24];HEAP[y+296]=HEAP[x+208+28];HEAP[y+268]=HEAP[x+156];HEAP[y+288]=HEAP[x+156+24];HEAP[x+156]=0;HEAP[x+156+24]=0;if(HEAP[y+236]!=1){b=19;break a}q=o=0;a=reSign(HEAP[x+100+16],32)>reSign(0,32);l=y+240;if(a){m=x+100+
24;n=x+100+16;q=q;o=o;a=106;b:for(;;){R=a==106?0:R;M=a==106?o:M;O=a==106?q:O;b=1+R;v=0+R;HEAP[HEAP[(a==106?l:Q)+12]+2*v]=0;HEAP[HEAP[y+240+16]+4*v]=__str650;Q=HEAP[HEAP[m]+4*v];u=Q!=0;c:do if(u){H=HEAP[y+284];J=y+288;for(a=108;;){i=a==111?P:0;if(!(reSign(H,32)>reSign(i,32))){a=109;break c}h=HEAP[HEAP[J]+4*i];if(_strcmp(Q,h)==0)break;var P=i+1;a=111}HEAP[HEAP[y+240+12]+2*v]=i&65535;HEAP[HEAP[y+240+16]+4*v]=h;if(_strcmp(__str650,h)==0){a=110;break c}var K=reSign(v,32)<reSign(M,32)?v:M;if(!(reSign(v,
32)>=reSign(O,32))){a=112;break c}a=114}else a=107;while(0);var O=a==110?O:a==112?O:a==114?b:a==107?O:O,M=a==110?M:a==112?K:a==114?K:a==107?M:M;a=reSign(HEAP[n],32)>reSign(b,32);var Q=y+240,R=R+1;if(a){a=113;b=107}else{b=117;break b}}o=M;q=O;a=117}else a=105;HEAP[(a==117?Q:l)+4]=o;HEAP[y+240+8]=q;HEAP[y+240]=HEAP[x+96]}while(0);HEAP[x+100+36+12]!=0&&FUNCTION_TABLE[HEAP[x+100+36+12]](x+100);HEAP[x+208+36+12]!=0&&FUNCTION_TABLE[HEAP[x+208+36+12]](x+208);HEAP[x+156+36+12]!=0&&FUNCTION_TABLE[HEAP[x+156+
36+12]](x+156);HEAP[x+260+36+12]!=0&&FUNCTION_TABLE[HEAP[x+260+36+12]](x+260);HEAP[x+316+36+12]!=0&&FUNCTION_TABLE[HEAP[x+316+36+12]](x+316);j=HEAP[x+16];c=HEAP[x+84];c!=0&&FUNCTION_TABLE[HEAP[j+8]](j,c);HEAP[x+84]=0;if(HEAP[x+93]==0){c=HEAP[x+76];c!=0&&FUNCTION_TABLE[HEAP[j+8]](j,c);HEAP[x+76]=0}FUNCTION_TABLE[HEAP[x+20+4]](x);j=x=HEAP[z];x=x!=0;a:do if(!x){if(reSign(d,32)<reSign(0,32))break a;if(reSign(d,32)>reSign(0,32))j=6;else{z=g;HEAP[z+16]=HEAP[E+284];HEAP[z+4]=0;HEAP[z+8]=2577;if(HEAP[E+24]!=
0)HEAP[z+8]|=4;if(HEAP[g+532]!=0)HEAP[z+8]|=256;HEAP[z+20]=HEAP[E+12];HEAP[z+24]=0;c=HEAP[z+20]!=0;b:do if(c){f=HEAP[E+8];k=HEAP[z+20];if(f==0)break b;j=1;f=f;k=k;a=133;c:for(;;){var T=a==133?k:a==136?U:a==137?T:X,V=a==133?f:a==136?S:a==137?Y:V;if(HEAP[V]==0){b=145;break c}if(HEAP[V]==HEAP[T]){var U=T+1,S=V+1;a=136}else{i=HEAP[V]==32;d:do if(!i){if(HEAP[V]==45)break d;if(HEAP[T]!=32)if(HEAP[T]!=45){b=140;break c}var X=T+1;a=141;b=135;continue c}while(0);var Y=V+1;a=137}b=135}if(b!=145)if(b==140){k=
T;f=V;j=0;if(HEAP[k]!=0)break b;HEAP[z+24]=f}if(j==0)break b;HEAP[z+24]=__str62}else{if(HEAP[E+232]==0)break b;HEAP[z+20]=HEAP[E+232]}while(0);if(HEAP[z+24]==0)HEAP[z+24]=HEAP[E+16]!=0?HEAP[E+16]:__str62;HEAP[z+12]=0;if(HEAP[E+20]!=0)HEAP[z+12]|=1;j=HEAP[E+16]!=0;b:do if(j){if(_strcmp(HEAP[E+16],__str63)!=0)if(_strcmp(HEAP[E+16],__str64)!=0)break b;HEAP[z+12]|=2}while(0);HEAP[z+28]=0;HEAP[z+32]=0;j=reSign(HEAP[E+328],32)>>reSign(16,32);HEAP[z+52]=j;j=reSign(HEAP[E+328+4],32)>>reSign(16,32);HEAP[z+
52+4]=j;j=reSign(HEAP[E+328+8]+65535,32)>>reSign(16,32);HEAP[z+52+8]=j;j=reSign(HEAP[E+328+12]+65535,32)>>reSign(16,32);HEAP[z+52+12]=j;if(HEAP[z+68]==0)HEAP[z+68]=1E3;HEAP[z+70]=HEAP[z+52+12]&65535;HEAP[z+72]=HEAP[z+52+4]&65535;j=unSign(HEAP[z+68],16)*12;j=Math.floor(reSign(j,32)/reSign(10,32))&65535;HEAP[z+74]=j;j=reSign(HEAP[z+74],16);c=reSign(HEAP[z+70],16);f=reSign(HEAP[z+72],16);c=c-f;if(reSign(j,32)<reSign(c,32))HEAP[z+74]=HEAP[z+70]-HEAP[z+72];HEAP[z+76]=HEAP[z+52+8]&65535;f=g;h=F;k=f+132;
c=HEAP[f+488];HEAP[h]=0;i=j=FUNCTION_TABLE[HEAP[HEAP[c+12]]](e,f,0,0,HEAP[k+288],HEAP[f+532],0,0,_T1_Parse_Glyph.__index__);P=j!=0;b:do{if(P){j=c=i;if(c==0){b=163;break b}j=0;b=167}else{HEAP[e+70]=1;HEAP[e+68]=0;HEAP[e+1364]=HEAP[k+272];HEAP[e+1368]=HEAP[k+276];HEAP[e+1372]=HEAP[k+280];HEAP[e+1488]=HEAP[f+548];HEAP[e+1492]=HEAP[f+544];HEAP[h]=0;if(reSign(HEAP[k+284],32)>reSign(0,32)){j=e+40;f=h;k=k+284;i=e+40;h=h;a=156;c:for(;;){W=a==156?0:W;a=1+W;P=0+W;_T1_Parse_Glyph(e,P);P=P==0;d:do if(P)b=158;
else{P=HEAP[h];b=reSign(HEAP[i],32)>reSign(P,32)?158:159;break d}while(0);if(b==158)HEAP[f]=HEAP[j];a=reSign(HEAP[k],32)>reSign(a,32);var W=W+1;if(a)a=159;else{a=159;break c}}}FUNCTION_TABLE[HEAP[HEAP[c+12]+4]](e);j=0;b=163}break b}while(0);if(b==163){c=f=HEAP[F];f=reSign(f,32)>=reSign(0,32);c=c;c=c=c=f?c+32768&-65536:0-(32768-c&-65536);c=reSign(c,32)>>reSign(16,32)&65535;HEAP[z+76]=c}HEAP[z+78]=HEAP[z+74];HEAP[z+80]=HEAP[E+26];HEAP[z+82]=HEAP[E+28];c=g;if(D==0)break a;if(B==0)break a;z=HEAP[B+20];
HEAP[G]=c;HEAP[G+8]=3;HEAP[G+10]=1;HEAP[G+4]=1970170211;j=_FT_CMap_New(HEAP[z+12],0,G,0);if(j!=0&j!=163)break a;j=0;HEAP[G+8]=7;c=0;f=HEAP[E+236];if(f==1)b=174;else if(f==2)b=171;else if(f==3)b=175;else if(f==4)b=173;else break a;if(b==174){HEAP[G+4]=1094992451;HEAP[G+10]=2;var da=HEAP[z+8];c=da;a=174}else if(b==171){HEAP[G+4]=1094995778;HEAP[G+10]=0;var ba=HEAP[z];c=ba;a=171}else if(b==175){HEAP[G+4]=1818326065;HEAP[G+10]=3;var aa=HEAP[z+12];c=aa;a=175}else if(b==173){HEAP[G+4]=1094992453;HEAP[G+
10]=1;var ca=HEAP[z+4];c=ca;a=173}if((a==175?aa:a==174?da:a==173?ca:ba)==0)break a;j=_FT_CMap_New(c,0,G,0)}}while(0);g=j;STACKTOP=e;return g}_T1_Face_Init.__index__=Runtime.getFunctionIndex(_T1_Face_Init,"_T1_Face_Init");function _T1_Driver_Init(){return 0}_T1_Driver_Init.__index__=Runtime.getFunctionIndex(_T1_Driver_Init,"_T1_Driver_Init");function _T1_Driver_Done(){}_T1_Driver_Done.__index__=Runtime.getFunctionIndex(_T1_Driver_Done,"_T1_Driver_Done");
function _t1_get_glyph_name(e,g,d,b){var a=null;e=HEAP[HEAP[e+132+288]+4*g];d=a=d;g=b+-1;for(a=-1;;){i=a==1?i:0;var c=g+i*-1,f=e+i,h=d+i;if(unSign(a==1?c:b,32)<=unSign(1,32))break;if(HEAP[f]==0)break;HEAP[h]=HEAP[f];var i=i+1;a=1}a=h;return HEAP[a]=0}_t1_get_glyph_name.__index__=Runtime.getFunctionIndex(_t1_get_glyph_name,"_t1_get_glyph_name");
function _t1_get_name_index(e,g){var d,b=null,a,c=HEAP[e+132+284],f=e+132+288;for(b=-1;;){d=b==2?i:0;var h=0+d;if(!(reSign(c,32)>reSign(h,32))){d=5;break}if(_strcmp(g,HEAP[HEAP[f]+4*h])==0){d=1;break}var i=d+1;b=2;d=0}if(d==1)a=h;else if(d==5)a=0;return a}_t1_get_name_index.__index__=Runtime.getFunctionIndex(_t1_get_name_index,"_t1_get_name_index");function _t1_get_ps_name(e){return HEAP[e+132+232]}_t1_get_ps_name.__index__=Runtime.getFunctionIndex(_t1_get_ps_name,"_t1_get_ps_name");
function _t1_ps_get_font_info(e,g){_llvm_memcpy_p0i8_p0i8_i32(g,e+132,32,4,0);return 0}_t1_ps_get_font_info.__index__=Runtime.getFunctionIndex(_t1_ps_get_font_info,"_t1_ps_get_font_info");function _t1_ps_get_font_extra(e,g){var d=STACKTOP;STACKTOP+=2;Runtime.memset(d,0,2);HEAP[d]=HEAP[e+132+32];HEAP[g]=HEAP[d];STACKTOP=d;return 0}_t1_ps_get_font_extra.__index__=Runtime.getFunctionIndex(_t1_ps_get_font_extra,"_t1_ps_get_font_extra");function _t1_ps_has_glyph_names(){return 1}
_t1_ps_has_glyph_names.__index__=Runtime.getFunctionIndex(_t1_ps_has_glyph_names,"_t1_ps_has_glyph_names");function _t1_ps_get_font_private(e,g){_llvm_memcpy_p0i8_p0i8_i32(g,e+132+36,196,4,0);return 0}_t1_ps_get_font_private.__index__=Runtime.getFunctionIndex(_t1_ps_get_font_private,"_t1_ps_get_font_private");function _Get_Interface(e,g){return _ft_service_list_lookup(_t1_services,g)}_Get_Interface.__index__=Runtime.getFunctionIndex(_Get_Interface,"_Get_Interface");
function _Get_Kerning(e,g,d,b){var a,c=null,f;HEAP[b]=0;HEAP[b+4]=0;if(HEAP[e+492]!=0){c=HEAP[e+492];d=g<<16|d;g=HEAP[c+36];e=g+16*HEAP[c+40]+-16;c=0;a:for(;;){a=c==0?e:j;j=c==0?g:f;var h=a;for(c=1;;){f=c==5?k:j;if(!(f<=a)){a=9;break a}var i=Math.floor(reSign(h-f,32)/reSign(16,32));i=Math.floor(reSign(i,32)/reSign(2,32));i=f+16*i;c=HEAP[i+4]|HEAP[i]<<16;if(c==d){a=2;break a}if(!(unSign(c,32)<unSign(d,32)))break;var k=i+16;c=5}var j=i+-16;c=6;a=1}if(a==9){HEAP[b]=0;HEAP[b+4]=0}else if(a==2){f=i;HEAP[b]=
HEAP[f+8];HEAP[b+4]=HEAP[f+12]}}return 0}_Get_Kerning.__index__=Runtime.getFunctionIndex(_Get_Kerning,"_Get_Kerning");
function _T1_Parse_Glyph_And_Get_Char_String(e,g,d){var b=STACKTOP;STACKTOP+=24;Runtime.memset(b,0,24);var a=null,c,f,h,i=b+8;h=HEAP[e+4];a=h+132;c=0;h=HEAP[HEAP[h+128]+52];var k=e+1376,j=a+304;HEAP[k]=HEAP[j];HEAP[k+4]=HEAP[j+4];HEAP[k+8]=HEAP[j+8];HEAP[k+12]=HEAP[j+12];k=a+320;HEAP[b]=HEAP[k];HEAP[b+4]=HEAP[k+4];k=e+1392;HEAP[k]=HEAP[b];HEAP[k+4]=HEAP[b+4];if(h!=0){c=f=FUNCTION_TABLE[HEAP[HEAP[h]]](HEAP[h+4],g,d);a=0}else{HEAP[d]=HEAP[HEAP[a+292]+4*g];HEAP[d+4]=HEAP[HEAP[a+296]+4*g];var l=c;a=2}if((a==
2?l:f)==0){var m=FUNCTION_TABLE[HEAP[e+1476+8]](e,HEAP[d],HEAP[d+4]);c=m;a=3}else{var o=c;a=5}d=(a==5?o:m)==0;a:do if(d){if(h==0)break a;if(HEAP[HEAP[h]+8]==0)break a;f=HEAP[e+32];c=reSign(f,32)>=reSign(0,32);f=f;c=c=c=c?f+32768&-65536:0-(32768-f&-65536);c=reSign(c,32)>>reSign(16,32);HEAP[i]=c;HEAP[i+4]=0;c=f=HEAP[e+40];f=reSign(f,32)>=reSign(0,32);c=c;c=c=c=f?c+32768&-65536:0-(32768-c&-65536);c=reSign(c,32)>>reSign(16,32);HEAP[i+8]=c;c=f=HEAP[e+40+4];f=reSign(f,32)>=reSign(0,32);c=c;c=c=c=f?c+32768&
-65536:0-(32768-c&-65536);c=reSign(c,32)>>reSign(16,32);HEAP[i+12]=c;c=FUNCTION_TABLE[HEAP[HEAP[h]+8]](HEAP[h+4],g,0,i);HEAP[e+32]=HEAP[i]<<16;HEAP[e+40]=HEAP[i+8]<<16;HEAP[e+40+4]=HEAP[i+12]<<16}while(0);e=c;STACKTOP=b;return e}_T1_Parse_Glyph_And_Get_Char_String.__index__=Runtime.getFunctionIndex(_T1_Parse_Glyph_And_Get_Char_String,"_T1_Parse_Glyph_And_Get_Char_String");
function _T1_Parse_Glyph(e,g){var d=STACKTOP;STACKTOP+=8;Runtime.memset(d,0,8);var b,a;b=_T1_Parse_Glyph_And_Get_Char_String(e,g,d);var c=b==0;a:do if(c){a=HEAP[e+4];if(HEAP[HEAP[a+128]+52]==0)break a;FUNCTION_TABLE[HEAP[HEAP[HEAP[HEAP[a+128]+52]]+4]](HEAP[HEAP[HEAP[a+128]+52]+4],d)}while(0);STACKTOP=d;return b}_T1_Parse_Glyph.__index__=Runtime.getFunctionIndex(_T1_Parse_Glyph,"_T1_Parse_Glyph");
function _T1_Get_Advances(e,g,d,b,a){var c=STACKTOP;STACKTOP+=1500;Runtime.memset(c,0,1500);var f=null,h,i;f=e+132;h=HEAP[e+488];if((b&16)!=0){f=0;if(unSign(f,32)<unSign(d,32)){var k=f,j=k+1;j=(unSign(d,32)>unSign(j,32)?d:j)-k;for(f=0;;){d=f==0?0:i;HEAP[a+4*(k+d)]=0;i=d+1;if(i!=j)f=1;else break}}a=0}else{i=FUNCTION_TABLE[HEAP[HEAP[h+12]]](c,e,0,0,HEAP[f+288],HEAP[e+532],0,0,_T1_Parse_Glyph.__index__);if(i!=0)a=i;else{HEAP[c+70]=1;HEAP[c+68]=0;HEAP[c+1364]=HEAP[f+272];HEAP[c+1368]=HEAP[f+276];HEAP[c+
1372]=HEAP[f+280];HEAP[c+1488]=HEAP[e+548];HEAP[c+1492]=HEAP[e+544];f=0;if(unSign(f,32)<unSign(d,32)){i=c+40;e=f;f=e+1;d=(unSign(d,32)>unSign(f,32)?d:f)-e;g=e+g;for(f=5;;){l=f==5?0:l;f=e+l;b=a+4*f;f=a+4*f;if(_T1_Parse_Glyph(c,g+l)==0){f=HEAP[i];if(reSign(f,32)>=reSign(0,32)){k=f+32768&-65536;f=7}else{j=0-(32768-f&-65536);f=9}f=reSign(f==7?k:j,32)>>reSign(16,32);HEAP[b]=f}else HEAP[f]=0;var l=l+1;if(l!=d)f=13;else break}}a=0}}a=a;STACKTOP=c;return a}
_T1_Get_Advances.__index__=Runtime.getFunctionIndex(_T1_Get_Advances,"_T1_Get_Advances");
function _T1_Load_Glyph(e,g,d,b){var a=STACKTOP;STACKTOP+=1564;Runtime.memset(a,0,1564);var c,f=null,h,i,k,j,l,m,o=a+8,n,p,r,q=a+1508,s=a+1524,u=a+1532,t,v,w,x=a+1540,y=a+1556,A,z;j=b;b=HEAP[e+4];p=b+132;r=HEAP[HEAP[b+488]+12];v=t=0;n=unSign(HEAP[b+16],32)<=unSign(d,32);a:do if(n){if(HEAP[HEAP[b+128]+52]!=0){c=1;break a}m=6;c=2;break a}else c=1;while(0);a:do if(c==1){if((j&1024)!=0)j|=3;if(g!=0){HEAP[e+172]=HEAP[g+12+4];HEAP[e+176]=HEAP[g+12+8]}else{HEAP[e+172]=65536;HEAP[e+176]=65536}HEAP[e+108+
2]=0;HEAP[e+108]=0;n=(j&1)!=0;b:do if(n)c=5;else{if((j&2)!=0){c=5;break b}l=1;c=7;break b}while(0);if(c==5)l=0;n=l&255;HEAP[e+72]=1869968492;m=HEAP[r];var C=reSign(j,32)>>reSign(16,32)&15,B=unSign(n,8);m=C=FUNCTION_TABLE[m](o,b,g,e,HEAP[p+288],HEAP[b+532],B&255,C,_T1_Parse_Glyph.__index__);if(C!=0)break a;t=1;m=unSign((j&1024)!=0,1);HEAP[o+69]=m;HEAP[o+1364]=HEAP[p+272];HEAP[o+1368]=HEAP[p+276];HEAP[o+1372]=HEAP[p+280];HEAP[o+1488]=HEAP[b+548];HEAP[o+1492]=HEAP[b+544];m=_T1_Parse_Glyph_And_Get_Char_String(o,
d,u);if(m!=0)break a;v=1;t=o+1376;HEAP[q]=HEAP[t];HEAP[q+4]=HEAP[t+4];HEAP[q+8]=HEAP[t+8];HEAP[q+12]=HEAP[t+12];t=o+1392;HEAP[a]=HEAP[t];HEAP[a+4]=HEAP[t+4];HEAP[s]=HEAP[a];HEAP[s+4]=HEAP[a+4];FUNCTION_TABLE[HEAP[r+4]](o);t=0;if(m!=0)break a;HEAP[e+108+16]&=1;HEAP[e+108+16]|=4;C=(j&1024)!=0;B=e;b:do if(C){w=HEAP[B+156];k=HEAP[o+32];i=reSign(k,32)>=reSign(0,32);k=k;i=i=i=i?k+32768&-65536:0-(32768-k&-65536);i=reSign(i,32)>>reSign(16,32);HEAP[e+24+8]=i;i=k=HEAP[o+40];k=reSign(k,32)>=reSign(0,32);i=i;
i=i=i=k?i+32768&-65536:0-(32768-i&-65536);i=reSign(i,32)>>reSign(16,32);HEAP[e+24+16]=i;i=w+12;HEAP[i]=HEAP[q];HEAP[i+4]=HEAP[q+4];HEAP[i+8]=HEAP[q+8];HEAP[i+12]=HEAP[q+12];i=w+28;HEAP[i]=HEAP[s];HEAP[i+4]=HEAP[s+4];HEAP[w+8]=1}else{w=B+24;i=HEAP[o+40];c=reSign(i,32)>=reSign(0,32);i=i;c=c=c=c?i+32768&-65536:0-(32768-i&-65536);c=reSign(c,32)>>reSign(16,32);HEAP[w+16]=c;c=i=HEAP[o+40];i=reSign(i,32)>=reSign(0,32);c=c;c=c=c=i?c+32768&-65536:0-(32768-c&-65536);c=reSign(c,32)>>reSign(16,32);HEAP[e+56]=
c;HEAP[HEAP[e+156]+8]=0;if((j&16)!=0){c=reSign(HEAP[b+132+328+12]-HEAP[b+132+328+4],32)>>reSign(16,32);HEAP[w+28]=c;HEAP[e+60]=HEAP[w+28]}else{i=HEAP[o+40+4];c=reSign(i,32)>=reSign(0,32);i=i;c=c=c=c?i+32768&-65536:0-(32768-i&-65536);c=reSign(c,32)>>reSign(16,32);HEAP[w+28]=c;c=i=HEAP[o+40+4];i=reSign(i,32)>=reSign(0,32);c=c;c=c=c=i?c+32768&-65536:0-(32768-c&-65536);c=reSign(c,32)>>reSign(16,32);HEAP[e+60]=c}HEAP[e+72]=1869968492;c=g!=0;c:do if(c){if(!(unSign(HEAP[g+12+2],16)<=unSign(23,16)))break c;
HEAP[e+108+16]|=256}while(0);i=HEAP[q]!=65536;c:do if(i)c=23;else{if(HEAP[q+12]!=HEAP[q]){c=23;break c}if(HEAP[q+4]!=0){c=23;break c}c=HEAP[q+8]!=0?23:26;break c}while(0);c:do if(c==23){h=k=e+108;i=q;if(k==0)break c;if(i==0)break c;k=HEAP[h+4];h=reSign(HEAP[h+2],16);h=k+8*h;if(!(k<h))break c;i=i;h=h;k=k;for(f=29;;){D=f==29?0:D;c=k+8*(D+1);_FT_Vector_Transform(k+8*D,i);var D=D+1;if(c<h)c=f=30;else{c=31;break}}}while(0);i=HEAP[s]!=0;c:do if(i)c=33;else{c=HEAP[s+4]!=0?33:34;break c}while(0);c==33&&_FT_Outline_Translate(e+
108,HEAP[s],HEAP[s+4]);HEAP[y]=HEAP[w+16];HEAP[y+4]=0;_FT_Vector_Transform(y,q);HEAP[w+16]=HEAP[s]+HEAP[y];HEAP[y]=0;HEAP[y+4]=HEAP[w+28];_FT_Vector_Transform(y,q);HEAP[w+28]=HEAP[s+4]+HEAP[y+4];if((j&1)==0){k=HEAP[o+16];z=HEAP[k+4];h=HEAP[e+172];i=HEAP[e+176];var E=n==0;c:do if(E)c=36;else{c=HEAP[o+72]==0?36:37;break c}while(0);c:do if(c==36){A=E=reSign(HEAP[k+2],16);if(!(reSign(E,32)>reSign(0,32))){c=37;break c}E=h;var F=i;z=z;A=A;var G=0-A;G=reSign(G,32)>reSign(-1,32)?G:-1;A=A+G+1;G=z+8*A;for(f=
38;;){J=f==38?0:J;c=z+8*J+4;f=z+8*J;var H=_FT_MulFix(HEAP[f],E);HEAP[f]=H;f=_FT_MulFix(HEAP[c],F);HEAP[c]=f;var J=J+1;if(J!=A)c=f=39;else{c=40;break}}z=G}while(0);k=_FT_MulFix(HEAP[w+16],h);HEAP[w+16]=k;i=_FT_MulFix(HEAP[w+28],i);HEAP[w+28]=i}_FT_Outline_Get_CBox(e+108,x);HEAP[w]=HEAP[x+8]-HEAP[x];HEAP[w+4]=HEAP[x+12]-HEAP[x+4];HEAP[w+8]=HEAP[x];HEAP[w+12]=HEAP[x+12];if((j&16)==0){c=44;break b}_ft_synthesize_vertical_metrics(w,HEAP[w+28])}while(0);HEAP[e+136]=HEAP[u];HEAP[e+140]=HEAP[u+4]}while(0);
g=v!=0;a:do if(g){if(HEAP[HEAP[b+128]+52]==0)break a;FUNCTION_TABLE[HEAP[HEAP[HEAP[HEAP[b+128]+52]]+4]](HEAP[HEAP[HEAP[b+128]+52]+4],u);HEAP[e+136]=0;HEAP[e+140]=0}while(0);t!=0&&FUNCTION_TABLE[HEAP[r+4]](o);e=m;STACKTOP=a;return e}_T1_Load_Glyph.__index__=Runtime.getFunctionIndex(_T1_Load_Glyph,"_T1_Load_Glyph");
function _T1_Done_Metrics(e,g){var d;d=HEAP[g+36];d!=0&&FUNCTION_TABLE[HEAP[e+8]](e,d);HEAP[g+36]=0;HEAP[g+40]=0;d=HEAP[g+28];d!=0&&FUNCTION_TABLE[HEAP[e+8]](e,d);HEAP[g+28]=0;HEAP[g+32]=0;g!=0&&FUNCTION_TABLE[HEAP[e+8]](e,g)}_T1_Done_Metrics.__index__=Runtime.getFunctionIndex(_T1_Done_Metrics,"_T1_Done_Metrics");
function _t1_get_index(e,g,d){var b,a=null,c,f;if(unSign(g,32)>unSign(65535,32))c=0;else{f=0;var h=HEAP[d+284];d=d+288;f=f;a=1;a:for(;;){b=a==4?k:0;var i=f+b;if(!(reSign(h,32)>reSign(i,32))){b=9;break a}k=HEAP[HEAP[d]+4*i];a=k!=0;b:do if(a){if(HEAP[k]!=HEAP[e])break b;if(_strlen(k)!=g)break b;if(_strncmp(k,e,g)==0){b=6;break a}}while(0);var k=b+1;a=4;b=2}if(b==9)c=0;else if(b==6)c=f=i}return c}_t1_get_index.__index__=Runtime.getFunctionIndex(_t1_get_index,"_t1_get_index");
function _compare_kern_pairs(e,g){var d,b;d=HEAP[e+4]|HEAP[e]<<16;b=HEAP[g+4]|HEAP[g]<<16;return unSign(d,32)>unSign(b,32)?1:unSign(d,32)<unSign(b,32)?-1:0}_compare_kern_pairs.__index__=Runtime.getFunctionIndex(_compare_kern_pairs,"_compare_kern_pairs");
function _T1_Read_Metrics(e,g){var d=STACKTOP;STACKTOP+=28;Runtime.memset(d,0,28);var b,a=null,c,f,h,i,k,j,l,m,o,n,p,r,q,s,u,t;k=d+4;var v,w=d+24;t=HEAP[g+28];HEAP[w]=2;c=e+132;var x=_ft_mem_alloc(t,44,w);v=x;if(HEAP[w]!=0)a=-1;else{a=-1;j=_FT_Stream_EnterFrame(g,HEAP[g+4]);HEAP[w]=j;if(HEAP[w]==0){j=v+4;p=c+328;HEAP[j]=HEAP[p];HEAP[j+4]=HEAP[p+4];HEAP[j+8]=HEAP[p+8];HEAP[j+12]=HEAP[p+12];HEAP[v+20]=HEAP[c+328+12];HEAP[v+24]=HEAP[c+328+4];j=HEAP[e+488];p=j!=0;a:do if(p){if(HEAP[j+24]==0){b=1;break a}n=
FUNCTION_TABLE[HEAP[HEAP[j+24]]](k,HEAP[g+28],HEAP[g+32],HEAP[g+36]);HEAP[w]=n;n=HEAP[w];if(n==0)a=0;else{a=0;b=3;break a}HEAP[k+8]=v;HEAP[k+12]=_t1_get_index.__index__;HEAP[k+16]=c;p=FUNCTION_TABLE[HEAP[HEAP[j+24]+8]](k);HEAP[w]=p;FUNCTION_TABLE[HEAP[HEAP[j+24]+4]](k);b=1;break a}else b=1;while(0);if(b==1){o=HEAP[w];a=1}k=(a==1?o:n)==2;a:do if(k){j=HEAP[g+32];if(!(unSign(HEAP[g+4],32)>unSign(6,32))){b=6;break a}if(!(unSign(HEAP[j+1],8)<=unSign(3,8))){b=6;break a}k=unSign(HEAP[j+2+3],8)<<24;o=unSign(HEAP[j+
2+2],8)<<16;n=unSign(HEAP[j+2+1],8)<<8;j=unSign(HEAP[j+2],8);if((o|k|n|j)!=HEAP[g+4]){b=6;break a}o=g;l=v;k=e;j=o;l=l;HEAP[d]=0;o=HEAP[j+28];n=HEAP[j+32];j=HEAP[j+36];p=n+99;q=p+2>j;b:do{if(q){HEAP[d]=2;b=9}else{q=unSign(HEAP[p+1],8)<<8&65535;s=unSign(HEAP[p],8);q=unSign(q|s,16);p+=q+18;q=p+18>j;c:do if(!q){s=unSign(HEAP[p+1],8)<<8&65535;u=unSign(HEAP[p],8);if(unSign(s|u,16)<=unSign(17,16))break c;p+=14;s=unSign(HEAP[p+3],8)<<24;u=unSign(HEAP[p+2],8)<<16;var y=unSign(HEAP[p+1],8)<<8;p=unSign(HEAP[p],
8);p=n+(u|s|y|p);if(p==n)break c;if(p+2>j){HEAP[d]=2;b=9;break b}else{s=unSign(HEAP[p+1],8)<<8&65535;u=unSign(HEAP[p],8);s=unSign(s|u,16);HEAP[l+40]=s;p+=2;if(p+HEAP[l+40]*4>j){HEAP[d]=2;b=9;break b}else{if(HEAP[l+40]==0)break c;j=_ft_mem_realloc(o,16,0,HEAP[l+40],0,d);HEAP[l+36]=j;if(HEAP[d]!=0){b=9;break b}r=HEAP[l+36];j=p+HEAP[l+40]*4;s=HEAP[k+92];u=HEAP[k+36];y=k+40;a=14;d:for(;;){var A=a==17?h:0,z=0+A;if(!(reSign(u,32)>reSign(z,32))){b=20;break d}m=HEAP[HEAP[y]+4*z];if(HEAP[m+8]==7){b=16;break d}h=
A+1;a=17;b=15}if(b!=20)if(b==16){u=m;u=_FT_Set_Charmap(k,u);HEAP[d]=u;if(HEAP[d]!=0){b=9;break b}}if(p<j){y=u=k;A=y!=0;z=j;r=r;var C=u!=0;d:do if(C){var B=u+92,D=u+92,E=y+92,F=y+92;if(A){a=21;b=22}else{a=21;b=23}for(;;)if(b==22){I=a==28?I:0;var G=r+16*I+4;b=r+16*I+8;var H=r+16*I+12,J=r+16*I;a=unSign(HEAP[p],8);if(HEAP[B]!=0){var L=HEAP[D];L=FUNCTION_TABLE[HEAP[HEAP[L+12]+12]](L,a);a=26}else a=22;HEAP[J]=a==22?0:L;a=unSign(HEAP[p+1],8);if(HEAP[E]!=0){var N=HEAP[F];N=FUNCTION_TABLE[HEAP[HEAP[N+12]+
12]](N,a);a=24}else a=59;HEAP[G]=a==59?0:N;a=reSign(HEAP[p+2+1],8)<<8&65535;G=unSign(HEAP[p+2],8);a=reSign(a|G,16);HEAP[b]=a;HEAP[H]=0;p+=4;var I=I+1;if(p<z){a=28;b=22}else{b=29;break d}}else if(b==23){K=a==32?K:0;G=r+16*K+4;b=r+16*K+8;H=r+16*K+12;J=r+16*K;a=unSign(HEAP[p],8);if(HEAP[B]!=0){var P=HEAP[D];P=FUNCTION_TABLE[HEAP[HEAP[P+12]+12]](P,a);a=30}else a=23;HEAP[J]=a==23?0:P;unSign(HEAP[p+1],8);HEAP[G]=0;a=reSign(HEAP[p+2+1],8)<<8&65535;G=unSign(HEAP[p+2],8);a=reSign(a|G,16);HEAP[b]=a;HEAP[H]=
0;p+=4;var K=K+1;if(p<z){a=32;b=23}else{b=29;break d}}}else if(A){B=y+92;D=y+92;for(a=33;;){M=a==37?M:0;F=r+16*M+4;b=r+16*M+8;E=r+16*M+12;a=r+16*M;unSign(HEAP[p],8);HEAP[a]=0;a=unSign(HEAP[p+1],8);if(HEAP[B]!=0){var O=HEAP[D];O=FUNCTION_TABLE[HEAP[HEAP[O+12]+12]](O,a);a=35}else a=34;HEAP[F]=a==34?0:O;a=reSign(HEAP[p+2+1],8)<<8&65535;F=unSign(HEAP[p+2],8);a=reSign(a|F,16);HEAP[b]=a;HEAP[E]=0;p+=4;var M=M+1;if(p<z){a=37;b=34}else{b=29;break d}}}else for(a=73;;){Q=a==38?Q:0;B=r+16*Q+4;b=r+16*Q+8;a=r+
16*Q+12;D=r+16*Q;unSign(HEAP[p],8);HEAP[D]=0;unSign(HEAP[p+1],8);HEAP[B]=0;B=reSign(HEAP[p+2+1],8)<<8&65535;D=unSign(HEAP[p+2],8);B=reSign(B|D,16);HEAP[b]=B;HEAP[a]=0;p+=4;var Q=Q+1;if(p<z)b=a=38;else{b=29;break d}}while(0)}if(s!=0){i=_FT_Set_Charmap(k,s);HEAP[d]=i;a=40}else{var R=HEAP[d];a=42}if((a==42?R:i)!=0)break c;_qsort(HEAP[l+36],HEAP[l+40],16,_compare_kern_pairs.__index__)}}}while(0);b=HEAP[d]!=0?9:45}break b}while(0);if(b==9){m=HEAP[l+36];h=o;i=m;m!=0&&FUNCTION_TABLE[HEAP[h+8]](h,i);HEAP[l+
36]=0;HEAP[l+40]=0}l=m=m=HEAP[d];HEAP[w]=l;a=45;b=48;break a}else b=6;while(0);if(b==6){f=HEAP[w];a=6}f=(a==6?f:l)==0;a:do if(f){m=c+328;h=v+4;HEAP[m]=HEAP[h];HEAP[m+4]=HEAP[h+4];HEAP[m+8]=HEAP[h+8];HEAP[m+12]=HEAP[h+12];m=reSign(HEAP[v+4],32)>>reSign(16,32);HEAP[e+52]=m;m=reSign(HEAP[v+4+4],32)>>reSign(16,32);HEAP[e+52+4]=m;m=reSign(HEAP[v+4+8]+65535,32)>>reSign(16,32);HEAP[e+52+8]=m;m=reSign(HEAP[v+4+12]+65535,32)>>reSign(16,32);HEAP[e+52+12]=m;m=reSign(HEAP[v+20]+32768,32)>>reSign(16,32)&65535;
HEAP[e+70]=m;m=reSign(HEAP[v+24]+32768,32)>>reSign(16,32)&65535;HEAP[e+72]=m;if(HEAP[v+40]==0)break a;HEAP[e+8]|=64;HEAP[e+492]=v;v=0}while(0);if(HEAP[g+20]!=0){f=HEAP[g+28];c=HEAP[g];c!=0&&FUNCTION_TABLE[HEAP[f+8]](f,c);HEAP[g]=0}HEAP[g+32]=0;HEAP[g+36]=0}j=v;a=56}if((a==56?j:x)!=0)_T1_Done_Metrics(t,v);t=HEAP[w];STACKTOP=d;return t}_T1_Read_Metrics.__index__=Runtime.getFunctionIndex(_T1_Read_Metrics,"_T1_Read_Metrics");
function _T1_Get_Track_Kerning(e,g,d,b){var a=null,c;c=HEAP[e+492];if(c==0)g=6;else{if(reSign(HEAP[c+32],32)>reSign(0,32)){e=c+28;c=c+32;for(a=1;;){k=a==1?0:k;a=0+k;var f=1+k,h=HEAP[e];if(HEAP[h+20*a]==d)if(reSign(HEAP[h+20*a+4],32)>reSign(g,32))HEAP[b]=HEAP[h+20*a+8];else if(reSign(HEAP[h+20*a+12],32)<reSign(g,32))HEAP[b]=HEAP[h+20*a+16];else{var i=_FT_MulDiv(g-HEAP[h+20*a+4],HEAP[h+20*a+16]-HEAP[h+20*a+8],HEAP[h+20*a+12]-HEAP[h+20*a+4]);HEAP[b]=HEAP[h+20*a+8]+i}a=reSign(HEAP[c],32)>reSign(f,32);
var k=k+1;if(a)a=4;else break}}g=0}return g}_T1_Get_Track_Kerning.__index__=Runtime.getFunctionIndex(_T1_Get_Track_Kerning,"_T1_Get_Track_Kerning");function _cff_get_kerning(e,g,d,b){var a;a=HEAP[e+532];HEAP[b]=0;HEAP[b+4]=0;if(a!=0){e=FUNCTION_TABLE[HEAP[a+128]](e,g,d);HEAP[b]=e}return 0}_cff_get_kerning.__index__=Runtime.getFunctionIndex(_cff_get_kerning,"_cff_get_kerning");
function _Load_Glyph92(e,g,d,b){var a=STACKTOP;STACKTOP+=1028;Runtime.memset(a,0,1028);var c,f=null,h,i,k,j,l,m,o,n,p,r,q,s,u,t,v,w,x=a+8,y,A=a+16,z,C,B,D=a+944,E=a+960,F=a+968,G=a+976,H=a+980,J=a+984,L=a+1E3,N=a+1016,I=a+1024,P=a+1026,K,O;b=b;O=g;var M=e==0;a:do if(M)s=37;else{if(O==0)b|=3;s=(b&1&255)!=0;b:do if(s)O=0;else{if(O==0)break b;if(HEAP[g]==HEAP[e+4])break b;s=35;break a}while(0);u=O;z=d;t=b;s=e;u=u;q=z;t=t;z=HEAP[s+4];B=HEAP[z+692];C=0;r=HEAP[B+1324+128]==65535;b:do if(r)c=7;else{if(HEAP[B+
1152+12]==0){c=7;break b}if(q==0){c=10;break b}c=q;q=B+1152;r=c=c;if(unSign(HEAP[q+16],32)>=unSign(r,32)){var Q=unSign(HEAP[HEAP[q+12]+2*c],16);f=11}else{var R=0;f=13}q=c=f==13?R:Q;if(c!=0){c=10;break b}y=6;c=15;break b}while(0);b:do if(c==7){c=q;if(!(unSign(HEAP[B+12],32)<=unSign(c,32))){c=10;break b}y=6;c=15;break b}while(0);b:do if(c==10){if((t&1024)!=0)t|=3;HEAP[s+164]=65536;HEAP[s+168]=65536;y=u!=0;c:do if(y){HEAP[s+164]=HEAP[u+12+4];HEAP[s+168]=HEAP[u+12+8];if(u==0){c=19;break c}c=HEAP[u];y=
HEAP[c+532];c=HEAP[c+104];if(HEAP[u+44]==-1){c=19;break c}if(HEAP[y+140]==0){c=19;break c}if((t&8)!=0){c=19;break c}m=FUNCTION_TABLE[HEAP[y+104]](z,HEAP[u+44],q,t,c,s+76,F);if(m!=0){c=19;break c}HEAP[s+108+2]=0;HEAP[s+108]=0;u=unSign(HEAP[F+1],8)<<6;HEAP[s+24]=u;u=unSign(HEAP[F],8)<<6;HEAP[s+24+4]=u;u=reSign(HEAP[F+2],8)<<6;HEAP[s+24+8]=u;u=reSign(HEAP[F+3],8)<<6;HEAP[s+24+12]=u;u=unSign(HEAP[F+4],8)<<6;HEAP[s+24+16]=u;u=reSign(HEAP[F+5],8)<<6;HEAP[s+24+20]=u;u=reSign(HEAP[F+6],8)<<6;HEAP[s+24+24]=
u;u=unSign(HEAP[F+7],8)<<6;HEAP[s+24+28]=u;HEAP[s+72]=1651078259;if((t&16)!=0){t=reSign(HEAP[F+5],8);HEAP[s+100]=t;t=reSign(HEAP[F+6],8);HEAP[s+104]=t}else{t=reSign(HEAP[F+2],8);HEAP[s+100]=t;t=reSign(HEAP[F+3],8);HEAP[s+104]=t}y=m;break b}while(0);if((t&16384)!=0)y=6;else{y=HEAP[B+1892]!=0;c=B;c:do if(y){l=_cff_fd_select_get(c+2024,q);r=unSign(l,8);m=HEAP[B+1892];if(unSign(r,32)>=unSign(m,32))l=(HEAP[B+1892]&255)-1;r=HEAP[B+1324+64];m=unSign(l,8);m=HEAP[HEAP[B+1896+m*4]+64];j=unSign(l,8);j=HEAP[B+
1896+j*4]+48;HEAP[D]=HEAP[j];HEAP[D+4]=HEAP[j+4];HEAP[D+8]=HEAP[j+8];HEAP[D+12]=HEAP[j+12];l=unSign(l,8);l=HEAP[B+1896+l*4]+68;HEAP[x]=HEAP[l];HEAP[x+4]=HEAP[l+4];HEAP[E]=HEAP[x];HEAP[E+4]=HEAP[x+4];if(r==m)break c;C=_FT_MulDiv(HEAP[s+164],r,m);HEAP[s+164]=C;C=_FT_MulDiv(HEAP[s+168],r,m);HEAP[s+168]=C;C=1}else{r=c+1324+48;HEAP[D]=HEAP[r];HEAP[D+4]=HEAP[r+4];HEAP[D+8]=HEAP[r+8];HEAP[D+12]=HEAP[r+12];r=B+1324+68;HEAP[a]=HEAP[r];HEAP[a+4]=HEAP[r+4];HEAP[E]=HEAP[a];HEAP[E+4]=HEAP[a+4]}while(0);HEAP[s+
108+2]=0;HEAP[s+108]=0;y=(t&1)!=0;c:do if(y)c=30;else{if((t&2)!=0){c=30;break c}w=1;c=32;break c}while(0);if(c==30)w=0;y=w&255;HEAP[s+72]=1869968492;m=reSign(t,32)>>reSign(16,32)&15;r=unSign(y,8);j=z;i=u;l=s;h=r&255;r=A;j=j;i=i;k=l;h=h;m=m;l=HEAP[j+692];_llvm_memset_p0i8_i32(r,0,928,1,0);p=unSign(h,8);h=j;i=i;k=k;o=p&255;j=r;p=h;i=i;k=k;h=o;HEAP[j+64]=0;HEAP[j+65]=1;HEAP[j+4]=p;HEAP[j+8]=k;HEAP[j]=HEAP[p+100];p=k!=0;c:do if(p){o=HEAP[HEAP[k+156]];HEAP[j+12]=o;HEAP[j+16]=o+20;HEAP[j+20]=o+56;n=o;o=
n+20;n=n+56;HEAP[o+2]=0;HEAP[o]=0;HEAP[o+28]=0;_llvm_memcpy_p0i8_p0i8_i32(n,o,36,4,0);HEAP[j+72]=0;HEAP[j+68]=0;if(h==0){c=35;break c}if(i==0){c=35;break c}o=HEAP[i+40];HEAP[j+72]=HEAP[o];HEAP[j+68]=HEAP[HEAP[k+156]+36]}while(0);HEAP[j+24]=0;HEAP[j+28]=0;HEAP[j+32]=0;HEAP[j+32+4]=0;HEAP[j+40]=0;HEAP[j+40+4]=0;HEAP[r+76]=l;HEAP[r+892]=HEAP[l+84+8];HEAP[r+908]=HEAP[l+1308];j=HEAP[l+1324+44];l=HEAP[r+892];l=l=l=j==1?0:unSign(l,32)<=unSign(1239,32)?107:unSign(l,32)<=unSign(33899,32)?1131:32768;HEAP[r+
900]=l;HEAP[r+920]=m;if((t&256)!=0)HEAP[A+753]=1;HEAP[A+66]=0;m=r=_cff_get_glyph_data(z,q,G,H);r=r!=0;c:do if(!r){j=u;l=q;m=A;j=j;i=l;k=m;h=HEAP[HEAP[k+4]+692];l=h+1324;p=HEAP[h+1892]!=0;d:do if(p){o=_cff_fd_select_get(h+2024,i);l=unSign(o,8);n=HEAP[h+1892];if(unSign(l,32)>=unSign(n,32)){m=3;c=40;break c}else{l=unSign(o,8);l=HEAP[h+1896+l*4];if(HEAP[k+68]==0){c=42;break d}if(j==0){c=42;break d}n=HEAP[j+40];o=unSign(o,8);HEAP[k+72]=HEAP[n+4+o*4]}}while(0);HEAP[m+888]=HEAP[l+532+8];HEAP[m+904]=HEAP[l+
564];i=HEAP[HEAP[m+76]+1324+44];j=HEAP[m+888];j=j=j=i==1?0:unSign(j,32)<=unSign(1239,32)?107:unSign(j,32)<=unSign(33899,32)?1131:32768;HEAP[m+896]=j;HEAP[m+744]=HEAP[l+172+352];HEAP[m+748]=HEAP[l+172+356];m=_cff_decoder_parse_charstrings(A,HEAP[G],HEAP[H]);_cff_free_glyph_data(z,G,HEAP[H]);if(m!=0){c=40;break c}j=HEAP[HEAP[z+128]+52]!=0;d:do if(j){HEAP[s+136]=0;HEAP[s+140]=0}else{l=B+1176;if(HEAP[l+24]==0){c=50;break d}HEAP[s+136]=HEAP[l+28]+HEAP[HEAP[l+24]+4*q]+-1;HEAP[s+140]=HEAP[H]}while(0);if(m!=
0){c=40;break c}j=A;l=HEAP[j+8];if(l!=0){j=HEAP[j+16];l=l+108;HEAP[l]=HEAP[j];HEAP[l+2]=HEAP[j+2];HEAP[l+4]=HEAP[j+4];HEAP[l+8]=HEAP[j+8];HEAP[l+12]=HEAP[j+12];HEAP[l+16]=HEAP[j+16]}if(m!=0){c=40;break c}l=HEAP[HEAP[z+128]+52]!=0;d:do if(l){if(HEAP[HEAP[HEAP[HEAP[z+128]+52]]+8]==0){c=55;break d}HEAP[J]=HEAP[A+32];HEAP[J+4]=0;HEAP[J+8]=HEAP[A+40];HEAP[J+12]=HEAP[A+40+4];m=FUNCTION_TABLE[HEAP[HEAP[HEAP[HEAP[z+128]+52]]+8]](HEAP[HEAP[HEAP[z+128]+52]+4],q,0,J);HEAP[A+32]=HEAP[J];HEAP[A+40]=HEAP[J+8];
HEAP[A+40+4]=HEAP[J+12]}while(0);if(m!=0){c=40;break c}l=s;if((t&1024)!=0){l=HEAP[l+156];HEAP[s+24+8]=HEAP[A+32];HEAP[s+24+16]=HEAP[A+744];j=l+12;HEAP[j]=HEAP[D];HEAP[j+4]=HEAP[D+4];HEAP[j+8]=HEAP[D+8];HEAP[j+12]=HEAP[D+12];j=l+28;HEAP[j]=HEAP[E];HEAP[j+4]=HEAP[E+4];HEAP[l+8]=1}else{l=l+24;HEAP[l+16]=HEAP[A+744];HEAP[s+56]=HEAP[A+744];HEAP[HEAP[s+156]+8]=0;j=HEAP[z+296]==0;d:do if(j)c=59;else{if(HEAP[z+300+34]==0){c=59;break d}if(HEAP[z+300+36]==0){c=59;break d}v=1;c=62;break d}while(0);if(c==59)v=
0;j=c=v&255;if(c!=0){HEAP[I]=0;HEAP[P]=0;FUNCTION_TABLE[HEAP[HEAP[z+532]+156]](z,1,q,I,P);c=reSign(HEAP[I],16);HEAP[l+24]=c;c=unSign(HEAP[P],16);HEAP[l+28]=c}else{c=z;if(HEAP[z+368]!=-1){c=reSign(HEAP[c+368+70],16);i=reSign(HEAP[z+368+72],16);HEAP[l+28]=c-i}else{c=reSign(HEAP[c+216+4],16);i=reSign(HEAP[z+216+6],16);HEAP[l+28]=c-i}}HEAP[s+60]=HEAP[l+28];HEAP[s+72]=1869968492;HEAP[s+108+16]=0;c=u!=0;d:do if(c){if(!(unSign(HEAP[u+12+2],16)<=unSign(23,16)))break d;HEAP[s+108+16]|=256}while(0);HEAP[s+
108+16]|=4;i=HEAP[D]!=65536;d:do if(i)c=68;else{if(HEAP[D+12]!=65536){c=68;break d}if(HEAP[D+4]!=0){c=68;break d}c=HEAP[D+8]!=0?68:71;break d}while(0);d:do if(c==68){h=k=s+108;i=D;if(k==0)break d;if(i==0)break d;k=HEAP[h+4];h=reSign(HEAP[h+2],16);h=k+8*h;if(!(k<h))break d;i=i;h=h;k=k;for(f=74;;){T=f==74?0:T;c=k+8*(T+1);_FT_Vector_Transform(k+8*T,i);var T=T+1;if(c<h)c=f=75;else{c=76;break}}}while(0);i=HEAP[E]!=0;d:do if(i)c=78;else{c=HEAP[E+4]!=0?78:79;break d}while(0);c==78&&_FT_Outline_Translate(s+
108,HEAP[E],HEAP[E+4]);HEAP[N]=HEAP[l+16];HEAP[N+4]=0;_FT_Vector_Transform(N,D);HEAP[l+16]=HEAP[E]+HEAP[N];HEAP[N]=0;HEAP[N+4]=HEAP[l+28];_FT_Vector_Transform(N,D);HEAP[l+28]=HEAP[E+4]+HEAP[N+4];i=(t&1)==0;d:do if(i)c=81;else{c=C!=0?81:82;break d}while(0);if(c==81){k=s+108;n=HEAP[k+4];h=HEAP[s+164];i=HEAP[s+168];p=y==0;d:do if(p)c=83;else{c=HEAP[A+68]==0?83:84;break d}while(0);d:do if(c==83){K=p=reSign(HEAP[k+2],16);if(!(reSign(p,32)>reSign(0,32))){c=84;break d}p=h;o=i;n=n;f=K;var V=0-f;K=reSign(V,
32)>reSign(-1,32)?V:-1;K=f+1+K;V=reSign(V,32)>reSign(-1,32)?V:-1;V=f+V+1;for(f=85;;){S=f==85?0:S;f=n+8*S;c=n+8*S+4;var U=_FT_MulFix(HEAP[f],p);HEAP[f]=U;f=_FT_MulFix(HEAP[c],o);HEAP[c]=f;var S=S+1;if(S!=V)c=f=86;else{c=87;break}}n=n+8*K}while(0);k=_FT_MulFix(HEAP[l+16],h);HEAP[l+16]=k;i=_FT_MulFix(HEAP[l+28],i);HEAP[l+28]=i}_FT_Outline_Get_CBox(s+108,L);HEAP[l]=HEAP[L+8]-HEAP[L];HEAP[l+4]=HEAP[L+12]-HEAP[L+4];HEAP[l+8]=HEAP[L];HEAP[l+12]=HEAP[L+12];if(j!=0){j=HEAP[l+8];i=Math.floor(reSign(HEAP[l+
16],32)/reSign(2,32));HEAP[l+20]=j-i}else{if((t&16)==0){c=40;break c}_ft_synthesize_vertical_metrics(l,HEAP[l+28])}}}while(0);y=m}}while(0);s=s=s=y}while(0);e=s;STACKTOP=a;return e}_Load_Glyph92.__index__=Runtime.getFunctionIndex(_Load_Glyph92,"_Load_Glyph92");
function _cff_get_advances(e,g,d,b,a){var c,f=null,h;f=b;h=0;b=HEAP[e+84];f|=256;e=e+88;var i=f,k=b+60,j=b+56;h=h;g=0+g;if((f&16)!=0){f=-1;c=0}else{f=-1;c=1}for(;;)if(c==0){n=f==4?n:0;var l=f==4?0:h;f=0+n;c=g+n;var m=a+4*f;if(!(unSign(f,32)<unSign(d,32))){f=0;break}var o=_Load_Glyph92(b,HEAP[e],c,i);if(o!=0){f=2;break}HEAP[m]=HEAP[k];var n=n+1;f=4;c=0}else if(c==1){q=f==6?q:0;var p=f==6?0:h;f=0+q;c=g+q;m=a+4*f;if(!(unSign(f,32)<unSign(d,32))){f=1;break}var r=_Load_Glyph92(b,HEAP[e],c,i);if(r!=0){f=
5;break}HEAP[m]=HEAP[j];var q=q+1;f=6;c=1}return h=f==0?l:f==2?o:f==1?p:r}_cff_get_advances.__index__=Runtime.getFunctionIndex(_cff_get_advances,"_cff_get_advances");
function _cff_get_glyph_name(e,g,d,b){var a=null;a=HEAP[e+692];if(HEAP[a+2056]==0)b=2;else{g=HEAP[HEAP[a+1152+8]+2*g];g=unSign(g,16);g=_cff_index_get_sid_string(a,g);if(g!=0){a=d;d=d=g;g=a;e=b+-1;for(a=1;;){i=a==3?i:0;var c=e+i*-1,f=d+i,h=g+i;if(unSign(a==3?c:b,32)<=unSign(1,32))break;if(HEAP[f]==0)break;HEAP[h]=HEAP[f];var i=i+1;a=3}a=h;d=f;HEAP[a]=0;unSign(HEAP[d]!=0,1)}b=0}return b}_cff_get_glyph_name.__index__=Runtime.getFunctionIndex(_cff_get_glyph_name,"_cff_get_glyph_name");
function _cff_get_name_index(e,g){var d,b=null,a,c,f,h,i;c=HEAP[e+692];f=c+1152;h=_ft_module_get_service(HEAP[e+96],__str60);if(h==0)a=0;else{i=0;var k=c+12;f=f+8;h=h+20;i=i;b=1;a:for(;;){p=b==5?p:0;var j=i+p;if(!(unSign(HEAP[k],32)>unSign(j,32))){d=12;break a}var l=HEAP[HEAP[f]+2*j],m=unSign(l,16)>unSign(390,16);b:do{if(m){d=unSign(l,16)-391;if(!(unSign(HEAP[c+1312],32)>unSign(d,32))){b=3;d=5;break b}var o=HEAP[HEAP[c+1316]+4*d];b=4}else{var n=HEAP[h];d=unSign(l,16);n=FUNCTION_TABLE[n](d);b=7}d=
6;break b}while(0);b:do if(d==6){b=b==7?n:o;if(b==0)break b;if(_strcmp(g,b)==0){d=9;break a}else b=8}while(0);var p=p+1;b=5;d=2}if(d==12)a=0;else if(d==9)a=i=j}return a}_cff_get_name_index.__index__=Runtime.getFunctionIndex(_cff_get_name_index,"_cff_get_name_index");function _cff_ps_has_glyph_names(e){e=reSign(HEAP[e+8]&512,32)>reSign(0,32);return unSign(e,1)}_cff_ps_has_glyph_names.__index__=Runtime.getFunctionIndex(_cff_ps_has_glyph_names,"_cff_ps_has_glyph_names");
function _cff_ps_get_font_info(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b=null,a,c;a=HEAP[e+692];HEAP[d]=0;var f=a!=0;a:do if(f){var h=a;if(HEAP[h+2060]==0){b=a+1324;c=HEAP[e+100];c=_ft_mem_alloc(c,32,d);if(HEAP[d]!=0)break a;var i=_cff_index_get_sid_string(a,HEAP[b]);HEAP[c]=i;i=_cff_index_get_sid_string(a,HEAP[b+4]);HEAP[c+4]=i;i=_cff_index_get_sid_string(a,HEAP[b+12]);HEAP[c+8]=i;i=_cff_index_get_sid_string(a,HEAP[b+16]);HEAP[c+12]=i;i=_cff_index_get_sid_string(a,HEAP[b+20]);HEAP[c+
16]=i;HEAP[c+20]=HEAP[b+28];HEAP[c+24]=HEAP[b+24];HEAP[c+26]=HEAP[b+32]&65535;HEAP[c+28]=HEAP[b+36]&65535;HEAP[a+2060]=c;c=a;b=1}else b=5;if((b==1?c:h)==0)break a;_llvm_memcpy_p0i8_p0i8_i32(g,HEAP[a+2060],32,4,0)}while(0);a=HEAP[d];STACKTOP=d;return a}_cff_ps_get_font_info.__index__=Runtime.getFunctionIndex(_cff_ps_get_font_info,"_cff_ps_get_font_info");function _cff_get_ps_name(e){return HEAP[HEAP[e+692]+1304]}_cff_get_ps_name.__index__=Runtime.getFunctionIndex(_cff_get_ps_name,"_cff_get_ps_name");
function _cff_get_cmap_info(e,g){var d,b,a;d=0;b=HEAP[HEAP[HEAP[e]+96]+4];HEAP[g]=0;HEAP[g+4]=0;var c=HEAP[e+12]!=_cff_cmap_encoding_class_rec;a:do if(c){if(HEAP[e+12]==_cff_cmap_unicode_class_rec)break a;a=_FT_Get_Module(b,__str537);a=_ft_module_get_service(a,__str9);if(a==0)break a;if(HEAP[a]==0)break a;d=FUNCTION_TABLE[HEAP[a]](e,g)}while(0);return d}_cff_get_cmap_info.__index__=Runtime.getFunctionIndex(_cff_get_cmap_info,"_cff_get_cmap_info");
function _cff_get_ros(e,g,d,b){var a,c;a=0;e=HEAP[e+692];var f=e!=0;a:do if(f){c=e+1324;if(HEAP[c+128]==65535)a=6;else{if(g!=0){if(HEAP[e+2064]==0){var h=_cff_index_get_sid_string(e,HEAP[c+128]);HEAP[e+2064]=h}HEAP[g]=HEAP[e+2064]}if(d!=0){if(HEAP[e+2068]==0){h=_cff_index_get_sid_string(e,HEAP[c+132]);HEAP[e+2068]=h}HEAP[d]=HEAP[e+2068]}if(b==0)break a;HEAP[b]=HEAP[c+136]}}while(0);return a}_cff_get_ros.__index__=Runtime.getFunctionIndex(_cff_get_ros,"_cff_get_ros");
function _cff_get_is_cid(e,g){var d,b;d=HEAP[e+692];HEAP[g]=0;var a=d!=0;a:do if(a){b=d+1324;if(HEAP[b+128]==65535)break a;HEAP[g]=1}while(0);return 0}_cff_get_is_cid.__index__=Runtime.getFunctionIndex(_cff_get_is_cid,"_cff_get_is_cid");
function _cff_get_cid_from_glyph_index(e,g,d){var b,a;b=0;e=HEAP[e+692];var c=e!=0;a:do if(c){a=e+1324;if(HEAP[a+128]==65535)b=6;else{a=g;if(unSign(HEAP[e+12],32)<unSign(a,32))b=6;else{a=unSign(HEAP[HEAP[e+1152+8]+2*g],16);if(d==0)break a;HEAP[d]=a}}}while(0);return b}_cff_get_cid_from_glyph_index.__index__=Runtime.getFunctionIndex(_cff_get_cid_from_glyph_index,"_cff_get_cid_from_glyph_index");
function _cff_get_interface(e,g){var d;d=_ft_service_list_lookup(_cff_services,g);if(d!=0)d=d;else if(e==0)d=0;else{d=_FT_Get_Module(HEAP[e+4],__str537);d=d=d!=0?FUNCTION_TABLE[HEAP[HEAP[d]+32]](d,g):0}return d}_cff_get_interface.__index__=Runtime.getFunctionIndex(_cff_get_interface,"_cff_get_interface");
function _cff_parse_integer(e,g){var d,b,a,c;b=e;a=unSign(HEAP[b],8);b+=1;c=0;var f=a==28;a:do{if(f){if(b+2>g){d=0;break a}a=unSign(HEAP[b],8)<<8&65535;b=unSign(HEAP[b+1],8);c=reSign(a|b,16)}else if(a==29){if(b+4>g){d=0;break a}a=unSign(HEAP[b],8)<<24;c=unSign(HEAP[b+1],8)<<16;d=unSign(HEAP[b+2],8)<<8;b=unSign(HEAP[b+3],8);c=c|a|d|b}else{d=reSign(a,32)<=reSign(246,32);f=a;if(d)c=f-139;else{d=reSign(f,32)<=reSign(250,32);f=b+1>g;if(d){if(f){d=0;break a}a=a*256;b=unSign(HEAP[b],8);c=a+-63124+b}else{if(f){d=
0;break a}a=(251-a)*256;b=0-unSign(HEAP[b],8);c=a+-108+b}}}d=2;break a}while(0);if(d==0)c=0;return c}_cff_parse_integer.__index__=Runtime.getFunctionIndex(_cff_parse_integer,"_cff_parse_integer");
function _cff_parse_real(e,g,d,b){var a,c=null,f,h,i,k,j,l,m,o,n,p;f=e;m=l=0;if(b!=0)HEAP[b]=0;p=n=o=j=e=k=0;i=i=4;f=f;o=o;n=n;c=1;a:for(;;){var r=c==1?n:c==12?x:c==10?r:c==9?r:r,q=c==1?o:c==12?q:c==10?q:c==9?w:q,s=c==1?f:c==12?u:c==10?u:c==9?u:u;a=c==1?i:c==12?v:c==10?v:c==9?v:v;if((c==1?4:c==12?v:c==10?v:c==9?v:v)!=0){h=s+1;if(h>=g){a=4;break a}else c=3}else c=2;var u=c==3?h:s,t=unSign(HEAP[u],8);t=reSign(t,32)>>reSign(a,32)&15;var v=4-a;if(t==14){l=1;c=6}else{if(unSign(t,32)>unSign(9,32)){a=7;
break a}if(reSign(e,32)>reSign(214748363,32)){var w=q+1;c=9}else{if(t==0)if(e==0){c=10;a=2;continue a}var x=r+1;e=e*10+t;c=12}}a=2}a:do if(a!=4)if(a==7){n=r;o=q;h=t;f=u;i=v;w=h;if(w==10){x=g;s=i;var y=f,A=o;for(c=13;;){var z=c==13?A:c==23?z:c==22?z:c==21?z:G,C=c==13?y:c==23?D:c==22?D:c==21?D:D;a=c==13?s:c==23?F:c==22?F:c==21?F:F;if(a!=0){var B=C+1;if(B>=x){c=15;a=16;break}else c=15}else c=14;var D=c==15?B:C,E=unSign(HEAP[D],8);E=reSign(E,32)>>reSign(a,32)&15;var F=4-a;if(unSign(E,32)>unSign(9,32)){a=
18;break}a=e;if(E!=0|a!=0){if(!(reSign(a,32)<=reSign(214748363,32))){c=21;a=14;continue}if(!(reSign(p,32)<=reSign(8,32))){c=22;a=14;continue}p+=1;e=e*10+E;c=23}else{var G=z-1;c=20}a=14}if(a==16)break a;else if(a==18){o=z;f=D;h=E;i=F;c=18}}else c=7;c=(c==7?w:E)==12;b:do{if(c){m=1;a=25}else a=h==11?25:26;break b}while(0);b:do if(a==25){h=g;w=i;x=f;for(c=25;;){s=c==25?x:J;a=c==25?w:L;if(a!=0){var H=s+1;if(H>=h){a=29;break}else c=28}else c=27;var J=c==28?H:s;L=unSign(HEAP[J],8);c=reSign(L,32)>>reSign(a,
32)&15;var L=4-a;if(unSign(c,32)>unSign(9,32)){a=31;break}j=j*10+c;if(reSign(j,32)>reSign(1E3,32)){a=29;break}else{c=32;a=27}}if(a==29)break a;else if(a==31){f=J;i=L;if(m==0){a=26;break b}j=0-j}}while(0);j=o+d+j;if(b!=0){p=n+p;j=n+j;if(reSign(p,32)<=reSign(5,32))if(reSign(e,32)>reSign(32767,32)){k=_FT_DivFix(e,10);HEAP[b]=j+1+(0-p)}else{k=reSign(j,32)>reSign(0,32);n=j;b:do if(k){c=reSign(n,32)<=reSign(5,32)?n:5;j-=c;c=c-p;e*=HEAP[_power_tens+c*4];if(!(reSign(e,32)>reSign(32767,32))){a=37;break b}e=
Math.floor(reSign(e,32)/reSign(10,32));j+=1}else j=n-p;while(0);k=e<<16;HEAP[b]=j}else{k=HEAP[_power_tens+(p-5)*4];k=Math.floor(reSign(e,32)/reSign(k,32));k=reSign(k,32)>reSign(32767,32);n=p;if(k){k=_FT_DivFix(e,HEAP[_power_tens+(n-4)*4]);HEAP[b]=j-4}else{k=_FT_DivFix(e,HEAP[_power_tens+(n-5)*4]);HEAP[b]=j-5}}}else{n=j+n;p-=j;c=n;o=0-c;c=reSign(c,32)>=reSign(0,32)?c:o;if(reSign(c,32)>reSign(5,32))break a;if(reSign(n,32)<reSign(0,32)){var N=HEAP[_power_tens+(0-n)*4];e=Math.floor(reSign(e,32)/reSign(N,
32));p=N=n+p;c=41}else{var I=p;c=43}if((c==43?I:N)==10){e=Math.floor(reSign(e,32)/reSign(10,32));var P=p-1;p=P;c=44}else{var K=p;c=46}n=reSign(c==46?K:P,32)>reSign(0,32);c=p;if(n){n=HEAP[_power_tens+c*4];n=Math.floor(reSign(e,32)/reSign(n,32));if(reSign(n,32)>reSign(32767,32))break a;k=_FT_DivFix(e,HEAP[_power_tens+p*4])}else{e*=HEAP[_power_tens+(0-c)*4];if(reSign(e,32)>reSign(32767,32))break a;k=e<<16}}if(l==0)break a;k=0-k}while(0);return k}
_cff_parse_real.__index__=Runtime.getFunctionIndex(_cff_parse_real,"_cff_parse_real");function _cff_parse_fixed_scaled(e,g){var d=HEAP[e+4],b=HEAP[e];return HEAP[HEAP[e]]==30?_cff_parse_real(b,d,g,0):_cff_parse_integer(b,d)*65536*HEAP[_power_tens+g*4]}_cff_parse_fixed_scaled.__index__=Runtime.getFunctionIndex(_cff_parse_fixed_scaled,"_cff_parse_fixed_scaled");
function _cff_parse_font_matrix(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d=null,b,a,c,f,h,i;a=HEAP[e+412];c=a+48;f=a+68;a=a+64;h=e+16;i=161;if(HEAP[e+404]>=e+16+24){i=0;e=h;h+=4;d=HEAP[e+4];var k=HEAP[e];if(HEAP[HEAP[e]]==30)b=_cff_parse_real(k,d,0,g);else{e=_cff_parse_integer(k,d);if(reSign(e,32)>reSign(32767,32)){k=d=5;var j=k+1;for(d=1;;){o=d==4?o:0;var l=j+o;b=k+o;var m=_power_tens+b*4;if(!(reSign(d==4?l:5,32)<=reSign(9,32)))break;if(reSign(HEAP[m],32)>reSign(e,32))break;var o=
o+1;d=4}d=b;b=HEAP[_power_tens+(d-5)*4];b=Math.floor(reSign(e,32)/reSign(b,32));b=reSign(b,32)>reSign(32767,32);o=d;if(b){HEAP[g]=o-4;b=_FT_DivFix(e,HEAP[_power_tens+(d-4)*4])}else{HEAP[g]=o-5;b=_FT_DivFix(e,HEAP[_power_tens+(d-5)*4])}}else{HEAP[g]=0;b=e<<16}}b=b;HEAP[c]=b;HEAP[g]=0-HEAP[g];b=reSign(HEAP[g],32)<reSign(0,32);e=reSign(HEAP[g],32)>reSign(9,32);if(b|e){HEAP[c]=65536;HEAP[c+8]=0;HEAP[c+8]=0;HEAP[c+12]=65536;HEAP[f]=0;HEAP[f+4]=0;HEAP[a]=1}else{b=HEAP[g];e=h;h+=4;b=_cff_parse_fixed_scaled(e,
b);HEAP[c+8]=b;b=HEAP[g];e=h;h+=4;b=_cff_parse_fixed_scaled(e,b);HEAP[c+4]=b;b=HEAP[g];e=h;h+=4;b=_cff_parse_fixed_scaled(e,b);HEAP[c+12]=b;c=HEAP[g];b=h;h+=4;c=_cff_parse_fixed_scaled(b,c);HEAP[f]=c;h=_cff_parse_fixed_scaled(h,HEAP[g]);HEAP[f+4]=h;HEAP[a]=HEAP[_power_tens+HEAP[g]*4]}}f=i;STACKTOP=g;return f}_cff_parse_font_matrix.__index__=Runtime.getFunctionIndex(_cff_parse_font_matrix,"_cff_parse_font_matrix");
function _cff_parse_font_bbox(e){var g=null,d,b,a,c,f,h;h=HEAP[e+412]+80;b=e+16;g=161;if(HEAP[e+404]>=e+16+16){e=b;b+=4;g=HEAP[e+4];var i=HEAP[e];if(HEAP[HEAP[e]]==30){f=_cff_parse_real(i,g,0,0);g=0}else{var k=_cff_parse_integer(i,g)<<16;g=2}f=g==0?f:k;f=reSign(f,32)>=reSign(0,32)?f+32768&-65536:0-(32768-f&-65536);HEAP[h]=f;f=b;b+=4;k=HEAP[f+4];e=HEAP[f];if(HEAP[HEAP[f]]==30){c=_cff_parse_real(e,k,0,0);g=4}else{var j=_cff_parse_integer(e,k)<<16;g=6}c=g==4?c:j;c=reSign(c,32)>=reSign(0,32)?c+32768&
-65536:0-(32768-c&-65536);HEAP[h+4]=c;c=b;b+=4;j=HEAP[c+4];f=HEAP[c];if(HEAP[HEAP[c]]==30){a=_cff_parse_real(f,j,0,0);g=8}else{var l=_cff_parse_integer(f,j)<<16;g=10}a=g==8?a:l;a=reSign(a,32)>=reSign(0,32)?a+32768&-65536:0-(32768-a&-65536);HEAP[h+8]=a;b=b;a=HEAP[b+4];l=HEAP[b];if(HEAP[HEAP[b]]==30){d=_cff_parse_real(l,a,0,0);g=12}else{var m=_cff_parse_integer(l,a)<<16;g=14}d=g==12?d:m;d=reSign(d,32)>=reSign(0,32)?d+32768&-65536:0-(32768-d&-65536);HEAP[h+12]=d;g=0}return g}
_cff_parse_font_bbox.__index__=Runtime.getFunctionIndex(_cff_parse_font_bbox,"_cff_parse_font_bbox");
function _cff_parse_private_dict(e){var g,d,b;d=HEAP[e+412];g=e+16;b=161;if(HEAP[e+404]>=e+16+8){e=g;g+=4;b=HEAP[e+4];var a=HEAP[e];if(HEAP[HEAP[e]]==30){e=_cff_parse_real(a,b,0,0);e=reSign(e,32)>>reSign(16,32)}else e=_cff_parse_integer(a,b);e=e;HEAP[d+116]=e;g=g;e=HEAP[g+4];b=HEAP[g];if(HEAP[HEAP[g]]==30){g=_cff_parse_real(b,e,0,0);g=reSign(g,32)>>reSign(16,32)}else g=_cff_parse_integer(b,e);g=g;HEAP[d+112]=g;b=0}return b}
_cff_parse_private_dict.__index__=Runtime.getFunctionIndex(_cff_parse_private_dict,"_cff_parse_private_dict");
function _cff_parse_cid_ros(e){var g,d,b;d=HEAP[e+412];g=e+16;b=161;if(HEAP[e+404]>=e+16+12){e=g;g+=4;b=HEAP[e+4];var a=HEAP[e];if(HEAP[HEAP[e]]==30){e=_cff_parse_real(a,b,0,0);e=reSign(e,32)>>reSign(16,32)}else e=_cff_parse_integer(a,b);e=e;HEAP[d+128]=e;e=g;g+=4;b=HEAP[e+4];a=HEAP[e];if(HEAP[HEAP[e]]==30){e=_cff_parse_real(a,b,0,0);e=reSign(e,32)>>reSign(16,32)}else e=_cff_parse_integer(a,b);e=e;HEAP[d+132]=e;g=g;e=HEAP[g+4];b=HEAP[g];if(HEAP[HEAP[g]]==30){g=_cff_parse_real(b,e,0,0);g=reSign(g,
32)>>reSign(16,32)}else g=_cff_parse_integer(b,e);g=g;HEAP[d+136]=g;b=0}return b}_cff_parse_cid_ros.__index__=Runtime.getFunctionIndex(_cff_parse_cid_ros,"_cff_parse_cid_ros");
function _cff_parser_run(e,g,d){var b,a=null,c,f,h,i,k,j,l;f=g;h=0;HEAP[e+404]=e+16;HEAP[e+4]=g;HEAP[e+8]=d;HEAP[e+12]=g;a:for(;;){if(!(f<d)){b=36;break a}i=unSign(HEAP[f],8);g=unSign(i,32)<=unSign(26,32)|i==31;var m=HEAP[e+404]-(e+16);b:do if(g){j=Math.floor(reSign(m,32)/reSign(4,32));HEAP[HEAP[e+404]]=f;k=i;if(i==12){f+=1;if(f>=d){b=13;break a}k=unSign(HEAP[f],8)|256}k|=HEAP[e+408];l=_cff_field_handlers;k=k;l=l;a=16;c:for(;;){var o=a==19?p:0,n=l+28*o;b=l+28*o+4;if(HEAP[n]==0){b=38;break c}if(HEAP[b]==
k){b=18;break c}var p=o+1;a=19;b=17}c:do if(b!=38)if(b==18){l=n;k=HEAP[e+412]+HEAP[l+8];if(HEAP[l]!=6)if(j==0){b=20;break a}o=HEAP[l];b=o==1?41:o==2?42:o==3?43:o==4?41:o==5?41:o==6?44:45;if(b==45){h=FUNCTION_TABLE[HEAP[l+16]](e);if(h!=0){b=36;break a}else{b=28;break c}}else if(b==41){c=e+16;o=HEAP[c+4];b=HEAP[c];if(HEAP[HEAP[c]]==30){c=_cff_parse_real(b,o,0,0);c=reSign(c,32)>>reSign(16,32)}else c=_cff_parse_integer(b,o);c=c=c=c}else if(b==42){c=e+16;o=HEAP[c+4];b=HEAP[c];c=c=c=c=HEAP[HEAP[c]]==30?
_cff_parse_real(b,o,0,0):_cff_parse_integer(b,o)<<16}else if(b==43)c=_cff_parse_fixed_scaled(e+16,3);else if(b==44){c=HEAP[e+412]+HEAP[l+24];b=e+16;o=j;if(unSign(HEAP[l+20],32)<unSign(o,32))j=HEAP[l+20];HEAP[c]=j&255;c=0;if(j==0){b=28;break c}o=l+12;l=l+12;var r=b;k=k;j=j;c=c;for(a=27;;){w=a==27?0:w;t=a==27?c:t;v=a==27?k:v;b=r+4*w;a=HEAP[r+4*(w+1)];var q=HEAP[b];if(HEAP[HEAP[b]]==30){var s=_cff_parse_real(q,a,0,0);s=reSign(s,32)>>reSign(16,32);a=30}else{var u=_cff_parse_integer(q,a);a=32}var t=t+
(a==30?s:u);b=unSign(HEAP[o],8);b=b==1?50:b==2?51:b==4?52:53;if(b==53)HEAP[v]=t;else if(b==50)HEAP[v]=t&255;else if(b==51)HEAP[v]=t&65535;else if(b==52)HEAP[v]=t;b=unSign(HEAP[l],8);var v=v+b,w=w+1;if(w!=j)a=34;else break}c=t;b=28;break c}l=unSign(HEAP[l+12],8);b=l==1?46:l==2?47:l==4?48:49;if(b==49)HEAP[k]=c;else if(b==46)HEAP[k]=c&255;else if(b==47)HEAP[k]=c&65535;else if(b==48)HEAP[k]=c}while(0);HEAP[e+404]=e+16}else{if(reSign(m,32)>reSign(383,32)){b=1;break a}j=HEAP[e+404];HEAP[j]=f;HEAP[e+404]=
j+4;if(i==30){f+=1;for(i=d;;){if(f>=i){b=5;break a}j=unSign(HEAP[f],8)>>>unSign(4,8);if(unSign(j,8)==15){b=7;break}if((unSign(HEAP[f],8)&15)==15){b=7;break}f+=1;b=4}i=15}else if(i==28)f+=2;else if(i==29)f+=4;else{if(!(unSign(i,32)>unSign(246,32)))break b;f+=1}}while(0);f+=1;b=0}if(b==1)h=6;else if(b!=5)if(b==13)h=6;else if(b==20)h=6;return h}_cff_parser_run.__index__=Runtime.getFunctionIndex(_cff_parser_run,"_cff_parser_run");
function _cff_index_read_offset(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b=null,a,c;a=HEAP[e];c=0;var f=unSign(HEAP[e+12],8);a=_FT_Stream_ReadAt(a,HEAP[a+8],d,f);f=a==0;a:do if(f){var h=unSign(HEAP[e+12],8);if(!(reSign(h,32)>reSign(0,32)))break a;c=c;h=unSign(HEAP[e+12],8);h=(reSign(1,32)>reSign(h,32)?1:h)-0;for(b=0;;){k=b==0?0:k;i=(b==0?c:i)<<8;var i=unSign(HEAP[d+(0+k)],8)|i,k=k+1;if(k!=h)b=2;else break}c=i}while(0);HEAP[g]=a;i=c;STACKTOP=d;return i}
_cff_index_read_offset.__index__=Runtime.getFunctionIndex(_cff_index_read_offset,"_cff_index_read_offset");
function _cff_index_init(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;a=null;var c,f,h,i;i=HEAP[g+28];_llvm_memset_p0i8_i32(e,0,32,1,0);HEAP[e]=g;HEAP[e+4]=HEAP[g+8];h=_FT_Stream_ReadShort(g,b);var k=HEAP[b]==0;a:do if(k){if(h!=0){a=_FT_Stream_ReadChar(g,b);if(HEAP[b]!=0){a=0;break a}k=a==0;var j=unSign(a,8)>unSign(4,8);if(k|j){HEAP[b]=8;a=0;break a}else{k=unSign(h,16);HEAP[e+8]=k;HEAP[e+12]=a;h=unSign(h,16)+1;k=unSign(a,8);h=h*k;HEAP[e+16]=HEAP[e+4]+3+h;a=unSign(a,8);h=h-a;a=g;h=
h;if(reSign(h,32)<reSign(0,32)){HEAP[b]=85;a=0;break a}else{a=_FT_Stream_Seek(a,h+HEAP[a+8]);HEAP[b]=a;if(a!=0){a=0;break a}h=_cff_index_read_offset(e,b);if(HEAP[b]!=0){a=0;break a}if(h==0){HEAP[b]=8;a=0;break a}else{h-=1;HEAP[e+20]=h;if(d!=0){d=e+28;a=h;f=g;g=a;d=d;g=_FT_Stream_EnterFrame(f,g);if(g==0){HEAP[d]=HEAP[f+32];HEAP[f+32]=0;HEAP[f+36]=0}f=f=g;HEAP[b]=f;f=HEAP[b];a=5}else{d=h;c=g;g=d;c=c=reSign(g,32)<reSign(0,32)?85:_FT_Stream_Seek(c,g+HEAP[c+8]);HEAP[b]=c;c=HEAP[b];a=8}}}}}else{var l=HEAP[b];
a=9}a=(a==9?l:a==5?f:c)!=0?0:10;break a}else a=0;while(0);if(a==0){l=HEAP[e+24];l!=0&&FUNCTION_TABLE[HEAP[i+8]](i,l);HEAP[e+24]=0}e=HEAP[b];STACKTOP=b;return e}_cff_index_init.__index__=Runtime.getFunctionIndex(_cff_index_init,"_cff_index_init");
function _cff_index_done(e){var g,d,b,a,c;if(HEAP[e]!=0){a=HEAP[e];c=HEAP[a+28];if(HEAP[e+28]!=0){b=e+28;var f=a!=0;a:do if(f){if(HEAP[a+20]==0)break a;g=HEAP[a+28];d=HEAP[b];g=g;d=d;d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[b]=0}while(0);HEAP[b]=0}b=HEAP[e+24];b!=0&&FUNCTION_TABLE[HEAP[c+8]](c,b);HEAP[e+24]=0;_llvm_memset_p0i8_i32(e,0,32,1,0)}}_cff_index_done.__index__=Runtime.getFunctionIndex(_cff_index_done,"_cff_index_done");
function _cff_index_get_pointers(e,g,d){var b=STACKTOP;STACKTOP+=8;Runtime.memset(b,0,8);var a,c=null,f,h,i,k,j,l,m=b+4,o,n;HEAP[m]=0;o=HEAP[HEAP[e]+28];n=0;HEAP[g]=0;i=HEAP[e+24]==0;a:do if(i){i=e;HEAP[b]=0;k=HEAP[i];f=HEAP[k+28];c=HEAP[i+8]!=0;b:do if(c){if(HEAP[i+24]!=0){a=1;break b}a=HEAP[i+12];c=HEAP[i+8]+1;j=unSign(a,8)*c;c=_ft_mem_realloc(f,4,0,HEAP[i+8]+1,0,b);HEAP[i+24]=c;if(HEAP[b]!=0){a=2;break b}c=_FT_Stream_Seek(k,HEAP[i+4]+3);HEAP[b]=c;if(HEAP[b]!=0){a=2;break b}c=_FT_Stream_EnterFrame(k,
j);HEAP[b]=c;if(HEAP[b]!=0){a=2;break b}c=HEAP[i+24];l=HEAP[k+32];j=l+j;a=unSign(a,8);a=a==1?47:a==2?48:a==3?49:50;c:do if(a==50){if(!(l<j))break c;var p=j,r=c;for(c=6;;){a=c==6?0:t;h=r+4*(a+1);c=r+4*a;t=unSign(HEAP[l],8)<<24;var q=unSign(HEAP[l+1],8)<<16,s=unSign(HEAP[l+2],8)<<8,u=unSign(HEAP[l+3],8);HEAP[c]=q|t|s|u;l+=4;var t=a+1;if(l<p)a=c=18;else{a=19;break}}c=h}else if(a==47){if(!(l<j))break c;p=j;r=c;for(c=8;;){a=c==8?0:w;var v=r+4*(a+1);c=r+4*a;w=unSign(HEAP[l],8);HEAP[c]=w;l+=1;var w=a+1;
if(l<p)a=c=11;else{a=12;break}}c=v}else if(a==48){if(!(l<j))break c;p=j;r=c;for(c=9;;){a=c==9?0:y;var x=r+4*(a+1);c=r+4*a;y=unSign(HEAP[l],8)<<8&65535;q=unSign(HEAP[l+1],8);y=unSign(y|q,16);HEAP[c]=y;l+=2;var y=a+1;if(l<p)a=c=14;else{a=15;break}}c=x}else if(a==49){if(!(l<j))break c;p=j;r=c;for(c=10;;){a=c==10?0:z;var A=r+4*(a+1);c=r+4*a;z=reSign(HEAP[l],8)<<16;q=unSign(HEAP[l+1],8)<<8;s=unSign(HEAP[l+2],8);HEAP[c]=q|z|s;l+=3;var z=a+1;if(l<p)a=c=16;else{a=17;break}}c=A}while(0);a=k;if(HEAP[a+20]!=
0){c=HEAP[a+28];h=HEAP[a];c=c;h=h;h!=0&&FUNCTION_TABLE[HEAP[c+8]](c,h);HEAP[a]=0}HEAP[a+32]=0;HEAP[a+36]=0;a=1;break b}else a=1;while(0);b:do if(a==1){a=HEAP[b];if(a!=0)break b;HEAP[m]=a;a=23;break a}while(0);a=HEAP[i+24];c=f;f=a;a!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[i+24]=0;a=HEAP[b];HEAP[m]=a;a=a!=0?25:23;break a}else a=23;while(0);a:do if(a==23){if(HEAP[e+8]==0)break a;i=_ft_mem_realloc(o,4,0,HEAP[e+8]+1,0,m);if(HEAP[m]!=0)break a;if(d!=0){n=_ft_mem_alloc(o,HEAP[e+8]+HEAP[e+20],m);if(HEAP[m]!=
0)break a}l=HEAP[e+28];f=c=HEAP[HEAP[e+24]]-1;if(unSign(HEAP[e+20],32)<=unSign(f,32))c=0;HEAP[i]=d==0?l+c:n+c;if(unSign(HEAP[e+8],32)>=unSign(1,32)){f=e+24;h=d==0;v=l;x=i;A=e+8;k=n;z=y=w=i;l=l;r=p=j=t=i;q=e+20;s=e+8;u=c;c=31;b:for(;;){Q=c==31?0:Q;M=c==31?0:M;var C=c==31?u:K;K=1+Q;var B=x+4*K,D=w+4*K,E=y+4*K;a=0+Q;var F=z+4*a,G=t+4*a,H=j+4*K,J=p+4*K,L=r+4*K,N=2+Q,I=HEAP[HEAP[f]+4*K]-1;a=I==0;var P=unSign(I,32)<unSign(C,32);P=a|P;c:do if(P)a=36;else{if(unSign(HEAP[q],32)>unSign(I,32)){c=33;a=34;break c}if(unSign(HEAP[s],
32)>unSign(K,32)){c=35;a=36}else{c=35;a=34}break c}while(0);if(a==36)c=36;var K=c==36?C:c==35?I:I;c:do if(h){HEAP[B]=v+K;c=38}else{HEAP[D]=k+K+M;if(K==C){c=40;break c}_llvm_memcpy_p0i8_p0i8_i32(HEAP[G],l+C,HEAP[E]-HEAP[F],1,0);HEAP[HEAP[H]]=0;HEAP[L]=HEAP[J]+1;var O=M+1;c=41}while(0);var M=c==41?O:c==40?M:M;a=unSign(HEAP[A],32)>=unSign(N,32);var Q=Q+1;if(a){c=42;a=32}else{a=43;break b}}}HEAP[g]=i;if(d==0)break a;HEAP[d]=n}while(0);e=HEAP[m];STACKTOP=b;return e}
_cff_index_get_pointers.__index__=Runtime.getFunctionIndex(_cff_index_get_pointers,"_cff_index_get_pointers");
function _cff_index_access_element(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c,f=null,h,i;h=g;HEAP[a]=0;g=e==0;a:do if(g)c=0;else{g=h;if(unSign(HEAP[e+8],32)<=unSign(g,32)){c=0;break a}g=HEAP[e];f=0;c=HEAP[e+24]==0;var k=e;b:do if(c){i=unSign(HEAP[k+12],8)*h;i=_FT_Stream_Seek(g,HEAP[e+4]+3+i);HEAP[a]=i;if(HEAP[a]!=0){c=2;break a}i=_cff_index_read_offset(e,a);if(HEAP[a]!=0){c=2;break a}if(i==0)break b;var j=e,l=e+8;h=h+1;for(f=5;;){f=f==5?0:p;var m=h+f,o=_cff_index_read_offset(j,
a);if(o!=0){f=7;break}var n=unSign(HEAP[l],32)>unSign(m,32),p=f+1;if(n)f=9;else{f=9;break}}f=f==9?0:o;h=m}else{i=HEAP[HEAP[k+24]+4*h];if(i==0)break b;j=HEAP[e+24];l=e+8;h=h+1;for(f=10;;){f=f==10?0:s;var r=h+f,q=HEAP[j+4*r];if(q!=0){f=11;break}n=unSign(HEAP[l],32)>unSign(r,32);var s=f+1;if(n)f=13;else{f=13;break}}f=f==11?q:0;h=r}while(0);m=f;m=unSign(HEAP[g+4]+1,32)<unSign(m,32);b:do if(m)c=15;else{m=HEAP[g+4]+1+(0-f);c=unSign(HEAP[e+16],32)>unSign(m,32)?15:16;break b}while(0);if(c==15)f=HEAP[g+4]+
1+(0-HEAP[e+16]);m=i==0;b:do if(!m){m=i;if(unSign(f,32)<=unSign(m,32))break b;HEAP[b]=f-i;b=e;if(HEAP[e+28]!=0)HEAP[d]=HEAP[b+28]+i+-1;else{e=_FT_Stream_Seek(g,HEAP[b+16]+-1+i);HEAP[a]=e;if(HEAP[a]!=0){c=2;break a}e=f-i;b=d;d=g;e=e;g=b;e=_FT_Stream_EnterFrame(d,e);if(e==0){HEAP[g]=HEAP[d+32];HEAP[d+32]=0;HEAP[d+36]=0}d=d=e;HEAP[a]=d}c=2;break a}while(0);HEAP[d]=0;HEAP[b]=0;c=2;break a}while(0);if(c==0)HEAP[a]=6;d=HEAP[a];STACKTOP=a;return d}
_cff_index_access_element.__index__=Runtime.getFunctionIndex(_cff_index_access_element,"_cff_index_access_element");
function _cff_index_get_name(e,g){var d=STACKTOP;STACKTOP+=12;Runtime.memset(d,0,12);var b,a,c,f,h,i,k=d+4,j=d+8,l;h=e+20;i=HEAP[HEAP[h]+28];l=0;var m=_cff_index_access_element(h,g,d,k);HEAP[j]=m;m=HEAP[j]!=0;a:do if(!m){l=_ft_mem_alloc(i,HEAP[k]+1,j);if(HEAP[j]==0){_llvm_memcpy_p0i8_p0i8_i32(l,HEAP[d],HEAP[k],1,0);HEAP[l+HEAP[k]]=0}f=h;c=d;if(HEAP[f+28]!=0)break a;f=HEAP[f];var o=c;c=f;f=o;o=c!=0;b:do if(o){if(HEAP[c+20]==0)break b;b=HEAP[c+28];a=HEAP[f];b=b;a=a;a!=0&&FUNCTION_TABLE[HEAP[b+8]](b,
a);HEAP[f]=0}while(0);HEAP[f]=0}while(0);h=l;STACKTOP=d;return h}_cff_index_get_name.__index__=Runtime.getFunctionIndex(_cff_index_get_name,"_cff_index_get_name");function _cff_index_get_sid_string(e,g){var d;if(g==65535)d=0;else if(unSign(g,32)>unSign(390,32)){d=g-391;d=d=unSign(HEAP[e+1312],32)>unSign(d,32)?HEAP[HEAP[e+1316]+4*d]:0}else d=HEAP[e+2056]==0?0:FUNCTION_TABLE[HEAP[HEAP[e+2056]+20]](g);return d}_cff_index_get_sid_string.__index__=Runtime.getFunctionIndex(_cff_index_get_sid_string,"_cff_index_get_sid_string");
function _cff_fd_select_get(e,g){var d,b=null,a,c,f,h,i;a=0;f=unSign(HEAP[e],8);d=f==0?7:f==3?8:9;if(d==7)a=HEAP[HEAP[e+8]+g];else if(d==8){f=HEAP[e+20];if(unSign(g-HEAP[e+16],32)<unSign(f,32))a=HEAP[e+24];else{c=HEAP[e+8];f=c+HEAP[e+12];c+=2;i=unSign(HEAP[c+-2],8)<<8&65535;b=unSign(HEAP[c+-2+1],8);i=i=unSign(i|b,16);c=c;for(b=1;;){o=b==6?o:0;var k=b==6?m:i,j=o*3;d=c+(j+3);b=c+(j+2);var l=c+(j+1);j=c+j;if(unSign(g,32)<unSign(k,32)){d=3;break}h=HEAP[j];m=unSign(HEAP[l],8)<<8&65535;b=unSign(HEAP[b],
8);var m=unSign(m|b,16);if(unSign(g,32)<unSign(m,32)){d=5;break}var o=o+1;if(d<f){b=6;d=2}else{d=3;break}}if(d!=3)if(d==5){f=m;i=k;a=h;HEAP[e+16]=i;HEAP[e+20]=f-i;HEAP[e+24]=h}}}return unSign(a,8)&255}_cff_fd_select_get.__index__=Runtime.getFunctionIndex(_cff_fd_select_get,"_cff_fd_select_get");
function _cff_charset_compute_cids(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a=null,c,f;f=HEAP[b]=0;var h=HEAP[e+16]!=0;a:do if(!h){var i=g;if(unSign(0,32)<unSign(i,32)){i=HEAP[e+8];var k=e+8;c=g;f=f;c=(unSign(c,32)>unSign(1,32)?c:1)-0;for(a=0;;){m=a==0?0:m;l=a==0?f:l;a=0+m;if(unSign(HEAP[i+2*a],16)>unSign(l,16)){var j=HEAP[HEAP[k]+2*a];a=2}else a=1;var l=a==2?j:l,m=m+1;if(m!=c)a=4;else break}f=l}i=unSign(f,16)+1;i=_ft_mem_realloc(d,2,0,i,0,b);HEAP[e+12]=i;if(HEAP[b]!=0)break a;
c=i=g-1;if(reSign(i,32)>=reSign(0,32)){i=e+12;k=e+8;c=c;a=0-c;a=reSign(a,32)>reSign(0,32)?a:0;var o=c+a+1;for(a=9;;){r=a==9?0:r;var n=c+r*-1;a=n&65535;var p=HEAP[i];n=unSign(HEAP[HEAP[k]+2*n],16);HEAP[p+2*n]=a;var r=r+1;if(r!=o)a=10;else break}}i=unSign(f,16);HEAP[e+16]=i;HEAP[e+20]=g}while(0);e=HEAP[b];STACKTOP=b;return e}_cff_charset_compute_cids.__index__=Runtime.getFunctionIndex(_cff_charset_compute_cids,"_cff_charset_compute_cids");
function _cff_subfont_load(e,g,d,b,a,c){var f=STACKTOP;STACKTOP+=424;Runtime.memset(f,0,424);var h,i,k,j=f+416;k=f+420;var l;HEAP[j]=0;l=e+172;_llvm_memset_p0i8_i32(f,0,416,1,0);HEAP[f+404]=f+16;HEAP[f+408]=4096;HEAP[f+412]=e;HEAP[f]=c;_llvm_memset_p0i8_i32(e,0,172,1,0);HEAP[e+32]=-6553600;HEAP[e+36]=3276800;HEAP[e+44]=2;HEAP[e+48]=65536;HEAP[e+48+12]=65536;HEAP[e+152]=8720;HEAP[e]=65535;HEAP[e+4]=65535;HEAP[e+8]=65535;HEAP[e+12]=65535;HEAP[e+16]=65535;HEAP[e+20]=65535;HEAP[e+124]=65535;HEAP[e+128]=
65535;HEAP[e+132]=65535;HEAP[e+168]=65535;d=_cff_index_access_element(g,d,j,k);if(d==0)d=_cff_parser_run(f,HEAP[j],HEAP[j]+HEAP[k]);if(HEAP[g+28]==0){g=HEAP[g];k=g!=0;a:do if(k){if(HEAP[g+20]==0)break a;h=HEAP[g+28];i=HEAP[j];h=h;i=i;i!=0&&FUNCTION_TABLE[HEAP[h+8]](h,i);HEAP[j]=0}while(0);HEAP[j]=0}j=d!=0;a:do if(!j){if(HEAP[e+128]!=65535)break a;g=HEAP[e+112]!=0;b:do if(g){if(HEAP[e+116]==0)break b;_llvm_memset_p0i8_i32(l,0,360,1,0);HEAP[l+200]=7;HEAP[l+204]=1;HEAP[l+332]=-1;HEAP[l+340]=3932;HEAP[l+
196]=2596864;k=l;h=c;d=f;k=k;h=h;_llvm_memset_p0i8_i32(d,0,416,1,0);HEAP[d+404]=d+16;HEAP[d+408]=8192;HEAP[d+412]=k;HEAP[d]=h;d=_FT_Stream_Seek(b,a+HEAP[e+112]);if(d!=0)break a;d=_FT_Stream_EnterFrame(b,HEAP[e+116]);if(d!=0)break a;d=_cff_parser_run(f,HEAP[b+32],HEAP[b+36]);k=b;if(HEAP[k+20]!=0){h=HEAP[k+28];i=HEAP[k];h=h;i=i;i!=0&&FUNCTION_TABLE[HEAP[h+8]](h,i);HEAP[k]=0}HEAP[k+32]=0;HEAP[k+36]=0;if(d!=0)break a;HEAP[l]&=-2}while(0);if(HEAP[l+348]==0)break a;d=_FT_Stream_Seek(b,a+HEAP[e+112]+HEAP[l+
348]);if(d!=0)break a;d=_cff_index_init(e+532,b,1);if(d!=0)break a;d=_cff_index_get_pointers(e+532,e+564,0)}while(0);e=d;STACKTOP=f;return e}_cff_subfont_load.__index__=Runtime.getFunctionIndex(_cff_subfont_load,"_cff_subfont_load");
function _cff_size_get_globals_funcs(e){var g,d,b;d=HEAP[HEAP[HEAP[e]+692]+2052];b=_FT_Get_Module(HEAP[HEAP[HEAP[e]+96]+4],__str59);var a=b==0;a:do if(a)e=0;else{if(d==0){e=0;break a}if(HEAP[d]==0){e=0;break a}g=FUNCTION_TABLE[HEAP[d]](b);e=3;break a}while(0);if(e==0)g=0;return g}_cff_size_get_globals_funcs.__index__=Runtime.getFunctionIndex(_cff_size_get_globals_funcs,"_cff_size_get_globals_funcs");
function _cff_size_done(e){var g=null,d,b,a,c;d=HEAP[HEAP[e]+692];b=HEAP[e+40];var f=b!=0;a:do if(f){a=_cff_size_get_globals_funcs(e);if(a==0)break a;FUNCTION_TABLE[HEAP[a+8]](HEAP[b]);var h=HEAP[d+1892];c=h;if(h==0)break a;a=a+8;h=b;c=c;var i=c*4;for(g=2;;){k=g==2?0:k;FUNCTION_TABLE[HEAP[a]](HEAP[h+(i+k*-4)]);var k=k+1;if(k!=c)g=3;else break}}while(0)}_cff_size_done.__index__=Runtime.getFunctionIndex(_cff_size_done,"_cff_size_done");
function _cff_make_private_dict(e,g){var d,b,a;d=e+172;_llvm_memset_p0i8_i32(g,0,196,1,0);HEAP[g+8]=HEAP[d];a=unSign(HEAP[g+8],8);b=0;var c=a;c=unSign(b,32)<unSign(c,32);a:do if(c)for(var f=a;;){HEAP[g+12+b*2]=HEAP[d+4+b*4]&65535;b+=1;if(!(unSign(b,32)<unSign(f,32)))break a}while(0);HEAP[g+9]=HEAP[d+1];a=unSign(HEAP[g+9],8);b=0;c=a;c=unSign(b,32)<unSign(c,32);a:do if(c)for(f=a;;){HEAP[g+40+b*2]=HEAP[d+60+b*4]&65535;b+=1;if(!(unSign(b,32)<unSign(f,32)))break a}while(0);HEAP[g+10]=HEAP[d+2];a=unSign(HEAP[g+
10],8);b=0;c=a;c=unSign(b,32)<unSign(c,32);a:do if(c)for(f=a;;){HEAP[g+60+b*2]=HEAP[d+100+b*4]&65535;b+=1;if(!(unSign(b,32)<unSign(f,32)))break a}while(0);HEAP[g+11]=HEAP[d+3];a=unSign(HEAP[g+11],8);b=0;c=a;c=unSign(b,32)<unSign(c,32);a:do if(c)for(f=a;;){HEAP[g+88+b*2]=HEAP[d+156+b*4]&65535;b+=1;if(!(unSign(b,32)<unSign(f,32)))break a}while(0);HEAP[g+108]=HEAP[d+196];HEAP[g+112]=HEAP[d+200];HEAP[g+116]=HEAP[d+204];HEAP[g+120]=HEAP[d+208]&65535;HEAP[g+122]=HEAP[d+212]&65535;HEAP[g+124]=HEAP[d+216];
a=unSign(HEAP[g+124],8);b=0;c=a;c=unSign(b,32)<unSign(c,32);a:do if(c)for(f=a;;){HEAP[g+128+b*2]=HEAP[d+220+b*4]&65535;b+=1;if(!(unSign(b,32)<unSign(f,32)))break a}while(0);HEAP[g+125]=HEAP[d+217];a=unSign(HEAP[g+125],8);b=0;c=a;c=unSign(b,32)<unSign(c,32);a:do if(c)for(f=a;;){HEAP[g+154+b*2]=HEAP[d+272+b*4]&65535;b+=1;if(!(unSign(b,32)<unSign(f,32)))break a}while(0);HEAP[g+126]=HEAP[d+324];HEAP[g+184]=HEAP[d+336];HEAP[g+4]=HEAP[d+332]}
_cff_make_private_dict.__index__=Runtime.getFunctionIndex(_cff_make_private_dict,"_cff_make_private_dict");
function _cff_size_init(e){var g=STACKTOP;STACKTOP+=200;Runtime.memset(g,0,200);var d,b=null,a,c,f,h=g+4,i;HEAP[g]=0;a=_cff_size_get_globals_funcs(e);var k=a!=0;a:do if(k){c=HEAP[e];f=HEAP[c+692];c=HEAP[HEAP[e]+100];c=_ft_mem_alloc(c,132,g);if(HEAP[g]!=0){d=0;break a}_cff_make_private_dict(f+1324,h);var j=FUNCTION_TABLE[HEAP[a]](HEAP[HEAP[e]+100],h,c);HEAP[g]=j;if(HEAP[g]!=0){d=0;break a}i=j=HEAP[f+1892];var l=a,m=c,o=e;i=i;f=f+1892;var n=i*4,p=i+-1;for(b=2;;){d=b==5?u:0;var r=d*-1,q=f+4*(i+r),s=
m+(n+d*-4);r=p+r;if((b==5?r:j)==0){d=7;break}_cff_make_private_dict(HEAP[q],h);b=FUNCTION_TABLE[HEAP[l]](HEAP[HEAP[o]+100],h,s);HEAP[g]=b;if(HEAP[g]!=0){d=4;break}var u=d+1;b=5;d=3}if(d==7){HEAP[e+40]=c;d=8;break a}else if(d==4){d=0;break a}}else d=8;while(0);if(d==8)HEAP[e+44]=-1;e=HEAP[g];STACKTOP=g;return e}_cff_size_init.__index__=Runtime.getFunctionIndex(_cff_size_init,"_cff_size_init");
function _cff_size_select(e,g){var d=null,b,a,c,f,h,i;HEAP[e+44]=g;_FT_Select_Metrics(HEAP[e],g);b=_cff_size_get_globals_funcs(e);var k=b!=0;a:do if(k){a=HEAP[e];c=HEAP[a+692];f=HEAP[e+40];h=HEAP[c+1324+64];FUNCTION_TABLE[HEAP[b+4]](HEAP[f],HEAP[e+12+4],HEAP[e+12+8],0,0);i=a=HEAP[c+1892];if(a==0)break a;var j=a=h,l=e+12+4;h=h;var m=e+12+8,o=b+4;f=f;var n=e+12+4,p=e+12+8;i=i;c=c+1892;var r=i*4;for(d=0;;){w=d==0?0:w;var q=f+(r+w*-4);d=HEAP[HEAP[c+4*(i+w*-1)]+64];if(a!=d){var s=_FT_MulDiv(HEAP[l],j,
d),u=_FT_MulDiv(HEAP[m],h,d);d=3}else{var t=HEAP[n],v=HEAP[p];d=5}FUNCTION_TABLE[HEAP[o]](HEAP[q],d==5?t:s,d==5?v:u,0,0);var w=w+1;if(w!=i)d=6;else break}}while(0);return 0}_cff_size_select.__index__=Runtime.getFunctionIndex(_cff_size_select,"_cff_size_select");
function _cff_size_request(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a=null,c,f,h,i,k;f=(HEAP[HEAP[e]+8]&2)!=0;a:do if(f){b=HEAP[e];f=HEAP[b+532];if(FUNCTION_TABLE[HEAP[f+148]](b,g,d)!=0){HEAP[e+44]=-1;b=0}else{c=_cff_size_select(e,HEAP[d]);b=1}break a}else b=0;while(0);if(b==0){_FT_Request_Metrics(HEAP[e],g);c=_cff_size_get_globals_funcs(e);b=c!=0;a:do if(b){f=HEAP[e];a=HEAP[f+692];h=HEAP[e+40];i=HEAP[a+1324+64];FUNCTION_TABLE[HEAP[c+4]](HEAP[h],HEAP[e+12+4],HEAP[e+12+8],0,0);k=
f=HEAP[a+1892];if(f==0)break a;var j=f=i,l=e+12+4;i=i;var m=e+12+8,o=c+4;h=h;var n=e+12+4,p=e+12+8;k=k;var r=a+1892,q=k*4;for(a=2;;){x=a==2?0:x;var s=h+(q+x*-4);a=HEAP[HEAP[r+4*(k+x*-1)]+64];if(f!=a){var u=_FT_MulDiv(HEAP[l],j,a),t=_FT_MulDiv(HEAP[m],i,a);a=5}else{var v=HEAP[n],w=HEAP[p];a=7}FUNCTION_TABLE[HEAP[o]](HEAP[s],a==7?v:u,a==7?w:t,0,0);var x=x+1;if(x!=k)a=8;else break}}while(0);c=0}u=c;STACKTOP=d;return u}_cff_size_request.__index__=Runtime.getFunctionIndex(_cff_size_request,"_cff_size_request");
function _cff_slot_done(e){HEAP[HEAP[e+156]+36]=0}_cff_slot_done.__index__=Runtime.getFunctionIndex(_cff_slot_done,"_cff_slot_done");function _cff_slot_init(e){var g,d;g=HEAP[HEAP[HEAP[e+4]+692]+2052];var b=g!=0;a:do if(b){d=_FT_Get_Module(HEAP[HEAP[HEAP[e+4]+96]+4],__str59);if(d==0)break a;d=FUNCTION_TABLE[HEAP[g+8]](d);HEAP[HEAP[e+156]+36]=d}while(0);return 0}_cff_slot_init.__index__=Runtime.getFunctionIndex(_cff_slot_init,"_cff_slot_init");
function _cff_strcpy(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b=g!=0?_strlen(g)+1:0;b=_ft_mem_dup(e,g,b,d);STACKTOP=d;return b}_cff_strcpy.__index__=Runtime.getFunctionIndex(_cff_strcpy,"_cff_strcpy");
function _cff_face_init(e,g,d,b,a){var c=STACKTOP;STACKTOP+=104;Runtime.memset(c,0,104);var f,h=null,i,k,j,l,m,o,n,p,r,q,s,u,t,v,w,x,y,A,z,C,B;o=c+4;var D,E,F,G,H,J,L;x=c+8;var N,I=c+12,P,K=c+16;B=c+48;var O,M,Q=c+80,R,T=c+88,V,U,S,X,Y,W,da,ba,aa=c+92;V=1;U=0;N=HEAP[HEAP[g+96]+4];M=_FT_Get_Module(N,__str537);r=M!=0?HEAP[HEAP[M]+20]:0;M=r==0;a:do if(M)f=4;else{M=HEAP[g+96];M=M=_ft_module_get_service(M,__str60);O=N;q=__str59;O=_FT_Get_Module(O,q);O=O=O=O=O!=0?HEAP[HEAP[O]+20]:0;q=_FT_Stream_Seek(e,
0);HEAP[T]=q;if(q!=0){f=2;break a}q=FUNCTION_TABLE[HEAP[r+4]](e,g,d,b,a);HEAP[T]=q;if(HEAP[T]==0){if(HEAP[g+148]!=1330926671){f=4;break a}if(reSign(d,32)<reSign(0,32)){R=0;f=6;break a}else if(reSign(d,32)>reSign(0,32)){HEAP[T]=6;f=2;break a}else{U=1;q=FUNCTION_TABLE[HEAP[g+508]](g,1751474532,e,0);HEAP[T]=q;if(HEAP[T]==0){V=0;b=FUNCTION_TABLE[HEAP[r+8]](e,g,0,b,a);HEAP[T]=b}else{b=FUNCTION_TABLE[HEAP[r+40]](g,e);HEAP[T]=b}if(HEAP[T]!=0){f=2;break a}b=FUNCTION_TABLE[HEAP[g+508]](g,1128678944,e,0);HEAP[T]=
b;if(b!=0){f=2;break a}}}else{b=_FT_Stream_Seek(e,0);HEAP[T]=b;if(HEAP[T]!=0){f=2;break a}HEAP[T]=0}a=HEAP[g+100];b=_ft_mem_alloc(a,2072,T);if(HEAP[T]!=0){f=2;break a}HEAP[g+692]=b;q=unSign(V,8);r=e;s=d;e=b;q=q&255;A=N;r=r;N=s;e=e;z=q;P=HEAP[r+28];_llvm_memset_p0i8_i32(e,0,2072,1,0);_llvm_memset_p0i8_i32(K,0,32,1,0);HEAP[e]=r;HEAP[e+4]=P;s=e+1324;q=r;q=q=q=HEAP[q+8];G=_FT_Stream_ReadFields(r,_cff_header_fields_6394,e);HEAP[I]=G;G=HEAP[I]!=0;b:do if(!G){H=HEAP[e+16]!=1;c:do if(!H){if(unSign(HEAP[e+
18],8)<=unSign(3,8)){f=11;break c}if(unSign(HEAP[e+19],8)>unSign(4,8)){f=11;break c}H=unSign(HEAP[e+18],8)-4;G=r;H=H;if(reSign(H,32)<reSign(0,32))HEAP[I]=85;else{G=_FT_Stream_Seek(G,H+HEAP[G+8]);HEAP[I]=G;if(G!=0){f=15;break b}G=_cff_index_init(e+20,r,0);HEAP[I]=G;if(HEAP[I]!=0){f=15;break b}G=_cff_index_init(e+1208,r,0);HEAP[I]=G;if(HEAP[I]!=0){f=15;break b}G=_cff_index_init(K,r,1);HEAP[I]=G;if(HEAP[I]!=0){f=15;break b}G=_cff_index_init(e+84,r,1);HEAP[I]=G;if(HEAP[I]!=0){f=15;break b}G=_cff_index_get_pointers(K,
e+1316,e+1320);HEAP[I]=G;if(HEAP[I]!=0){f=15;break b}HEAP[e+1312]=HEAP[K+8];HEAP[e+8]=HEAP[e+20+8];G=N;if(reSign(HEAP[e+8],32)<=reSign(G,32)){HEAP[I]=6;var ca=N;h=22}else h=21;if(reSign(h==22?ca:G,32)<reSign(0,32)){f=15;break b}ca=_cff_subfont_load(e+1324,e+1208,N,r,q,A);HEAP[I]=ca;if(HEAP[I]!=0){f=15;break b}ca=_FT_Stream_Seek(r,q+HEAP[s+108]);HEAP[I]=ca;if(HEAP[I]!=0){f=15;break b}ca=_cff_index_init(e+1176,r,0);HEAP[I]=ca;if(HEAP[I]!=0){f=15;break b}if(HEAP[s+128]!=65535){ca=_FT_Stream_Seek(r,q+
HEAP[s+160]);HEAP[I]=ca;if(HEAP[I]!=0){f=15;break b}ca=_cff_index_init(B,r,0);HEAP[I]=ca;if(HEAP[I]!=0){f=15;break b}ca=unSign(HEAP[B+8],32)>unSign(32,32);d:do if(!ca){HEAP[e+1892]=HEAP[B+8];G=_ft_mem_realloc(P,568,0,HEAP[B+8],0,I);if(HEAP[I]!=0)break d;H=h=0;if(unSign(HEAP[B+8],32)>unSign(H,32)){G=G;H=B+8;J=h;L=J+1;for(h=32;;){h=h==32?0:y;f=J+h;y=L+h;HEAP[e+1896+f*4]=G+568*f;f=unSign(HEAP[H],32)>unSign(y,32);y=h+1;if(f)f=h=33;else{f=34;break}}}h=0;G=B+8;H=r;J=q;L=A;D=h;h=36;e:for(;;){f=h==39?C:0;
F=D+f;if(!(unSign(HEAP[G],32)>unSign(F,32))){f=41;break e}F=_cff_subfont_load(HEAP[e+1896+F*4],B,F,H,J,L);HEAP[I]=F;if(HEAP[I]!=0){f=38;break e}C=f+1;h=39;f=37}if(f==41){L=q+HEAP[s+164];H=HEAP[e+1176+8];J=r;G=e+2024;H=H;J=J;L=L;L=_FT_Stream_Seek(J,L);HEAP[x]=L;L=HEAP[x]!=0;e:do if(!L){f=_FT_Stream_ReadChar(J,x);if(HEAP[x]!=0){f=42;break e}HEAP[G]=f;HEAP[G+20]=0;f=unSign(f,8);f=f==0?273:f==3?274:275;if(f==275){HEAP[x]=3;f=42;break e}else if(f==273)HEAP[G+12]=H;else if(f==274){D=_FT_Stream_ReadShort(J,
x);D=unSign(D,16);if(HEAP[x]!=0){f=42;break e}HEAP[G+12]=D*3+2}F=G+8;E=HEAP[G+12];D=J;E=E;F=F;var $=_FT_Stream_EnterFrame(D,E);E=$;if($==0){HEAP[F]=HEAP[D+32];HEAP[D+32]=0;HEAP[D+36]=0}D=D=E;HEAP[x]=D}while(0);G=G=HEAP[x];HEAP[I]=G}}while(0);_cff_index_done(B);if(HEAP[I]!=0){f=15;break b}}else HEAP[e+1892]=0;if(HEAP[s+108]==0)HEAP[I]=2;else{HEAP[e+12]=HEAP[e+1176+8];f=_cff_index_get_pointers(e+84,e+1308,0);HEAP[I]=f;if(HEAP[I]!=0){f=15;break b}f=HEAP[e+12]!=0;d:do if(f){x=HEAP[s+128]==65535;e:do if(x)f=
51;else{if(z==0){f=51;break e}w=1;f=53;break e}while(0);if(f==51)w=0;f=w&255;w=unSign(f,8);f=HEAP[s+100];x=HEAP[e+12];y=r;C=q;B=w&255;w=e+1152;x=x;y=y;A=C;z=f;C=B;B=HEAP[y+28];HEAP[o]=0;P=unSign(z,32)>unSign(2,32);e:do if(P){HEAP[w+4]=z+A;f=_FT_Stream_Seek(y,HEAP[w+4]);HEAP[o]=f;if(HEAP[o]!=0){f=55;break e}f=_FT_Stream_ReadChar(y,o);f=unSign(f,8);HEAP[w]=f;if(HEAP[o]!=0){f=55;break e}f=_ft_mem_realloc(B,2,0,x,0,o);HEAP[w+8]=f;if(HEAP[o]!=0){f=55;break e}HEAP[HEAP[w+8]]=0;f=HEAP[w];f=f==0?276:f==1?
71:f==2?71:277;if(f==277){HEAP[o]=3;f=55;break e}else if(f==276){if(x==0){f=60;break e}f=_FT_Stream_EnterFrame(y,x*2+-2);HEAP[o]=f;if(HEAP[o]!=0){f=55;break e}A=1;f=x;if(unSign(A,32)<unSign(f,32)){h=y;f=x;v=A;m=v+1;u=h+32;j=h+36;l=h+32;h=v+1;var la=(unSign(f,32)>unSign(h,32)?f:h)-v;for(h=62;;){t=h==62?0:ha;var ga=v+t;ha=HEAP[w+8];A=HEAP[u];if(A+1<HEAP[j]){var ea=A+2;h=reSign(HEAP[ea+-2],8)<<8&65535;var Z=unSign(HEAP[ea+-2+1],8);Z=h|Z;h=64}else h=63;z=h==63?0:Z;HEAP[l]=h==63?A:ea;h=reSign(z,16)&65535;
HEAP[ha+2*ga]=h;var ha=t+1;if(ha!=la)h=66;else{h=66;break}}unSign(f,32);unSign(m,32)}f=y;if(HEAP[f+20]!=0){v=HEAP[f+28];m=HEAP[f];v=v;m=m;m!=0&&FUNCTION_TABLE[HEAP[v+8]](v,m);HEAP[f]=0}HEAP[f+32]=0;HEAP[f+36]=0;f=60;break e}else if(f==71){A=1;ha=x;Z=ea=y;y=x;A=A;h=71;f:for(;;){z=h==71?A:j;P=unSign(z,32)<unSign(ha,32);ca=unSign(z,32)>=unSign(y,32)^1;if(!P){f=76;break f}if(!ca){h=75;f=78;break f}P=_FT_Stream_ReadShort(ea,o);if(HEAP[o]!=0){h=77;f=80;break f}if(HEAP[w]==2){h=_FT_Stream_ReadShort(Z,o);
la=unSign(h,16);if(HEAP[o]!=0){h=79;f=80;break f}else h=79}else{h=_FT_Stream_ReadChar(Z,o);t=unSign(h,8);if(HEAP[o]!=0){h=83;f=80;break f}else h=83}ca=h==79?la:t;h=unSign(P,16);G=65535-ca;if(unSign(h,32)>unSign(G,32)){u=65535-unSign(P,16);h=84}else h=318;ca=h==84?u:ca;G=unSign(P,16);H=G&65535;J=z+1;unSign(P,16);for(h=73;;){ga=h==73?0:ga;j=J+ga;f=ga+1;HEAP[HEAP[w+8]+2*(z+ga)]=h==73?H:l;ga=ga+1;l=ga+G&65535;h=unSign(j,32)>=unSign(y,32)^1;f=unSign(f,32)<=unSign(ca,32);if(h&f)f=h=74;else{h=74;f=72;continue f}}}f:do if(f==
76){f=60;break e}else if(f==78)for(;;){f=_FT_Stream_ReadShort(ea,o);if(HEAP[o]!=0){h=78;break f}if(HEAP[w]==2){h=_FT_Stream_ReadShort(Z,o);v=unSign(h,16);if(HEAP[o]!=0){h=88;break f}else h=88}else{h=_FT_Stream_ReadChar(Z,o);m=unSign(h,8);if(HEAP[o]!=0){h=91;break f}else h=91}u=h==88?v:m;h=unSign(f,16);u=65535-u;if(unSign(h,32)>unSign(u,32)){unSign(f,16);h=87}else h=86;f=78}while(0);f=55;break e}}else{f=HEAP[w+4]=z;f=f==0?278:f==1?279:f==2?280:281;if(f==281){HEAP[o]=3;f=55;break e}else if(f==278){if(unSign(x,
32)>unSign(229,32)){HEAP[o]=3;f=55}else{f=_ft_mem_realloc(B,2,0,x,0,o);HEAP[w+8]=f;if(HEAP[o]!=0){f=55;break e}_llvm_memcpy_p0i8_p0i8_i32(HEAP[w+8],_cff_isoadobe_charset,x*2,1,0);f=60}break e}else if(f==279){if(unSign(x,32)>unSign(166,32)){HEAP[o]=3;f=55}else{f=_ft_mem_realloc(B,2,0,x,0,o);HEAP[w+8]=f;if(HEAP[o]!=0){f=55;break e}_llvm_memcpy_p0i8_p0i8_i32(HEAP[w+8],_cff_expert_charset,x*2,1,0);f=60}break e}else if(f==280){if(unSign(x,32)>unSign(87,32)){HEAP[o]=3;f=55}else{f=_ft_mem_realloc(B,2,0,
x,0,o);HEAP[w+8]=f;if(HEAP[o]!=0){f=55;break e}_llvm_memcpy_p0i8_p0i8_i32(HEAP[w+8],_cff_expertsubset_charset,x*2,1,0);f=60}break e}}while(0);e:do if(f==60){if(C!=0){n=_cff_charset_compute_cids(w,x,B);HEAP[o]=n;h=95}else{p=HEAP[o];h=97}f=(h==97?p:n)!=0?55:98;break e}while(0);if(f==55){p=HEAP[w+8];f=B;n=p;p!=0&&FUNCTION_TABLE[HEAP[f+8]](f,n);HEAP[w+8]=0;f=HEAP[w+12];n=B;p=f;f!=0&&FUNCTION_TABLE[HEAP[n+8]](n,p);HEAP[w+12]=0;HEAP[w]=0;HEAP[w+4]=0;HEAP[w+8]=0}f=HEAP[o];HEAP[I]=f;if(f!=0){f=15;break b}if(HEAP[s+
128]!=65535)break d;h=HEAP[s+104];f=HEAP[e+12];n=e+1152;r=r;q=q;o=e+116;n=n;p=f;r=r;q=q;s=h;HEAP[c]=0;f=HEAP[n+8]==0;e:do if(f){HEAP[c]=3;h=105}else{m=0;f:for(;;){HEAP[o+12+m*2]=0;HEAP[o+524+m*2]=0;m=h=m+1;if(!(unSign(h,32)<=unSign(255,32)))break f}v=unSign(s,32)>unSign(1,32);f:do if(v){HEAP[o+4]=s+q;h=_FT_Stream_Seek(r,HEAP[o+4]);HEAP[c]=h;var ia=HEAP[c];if(ia!=0){h=109;break e}h=_FT_Stream_ReadChar(r,c);h=unSign(h,8);HEAP[o]=h;var ja=HEAP[c];if(ja!=0){h=111;break e}h=_FT_Stream_ReadChar(r,c);u=
unSign(h,8);var fa=HEAP[c];if(fa!=0){h=112;break e}else h=112;f=HEAP[o]&127;f=f==0?114:f==1?125:142;g:do if(f==142){HEAP[c]=3;h=142;break e}else if(f==114){HEAP[o+8]=u+1;h=_FT_Stream_EnterFrame(r,u);HEAP[c]=h;var ka=HEAP[c];if(ka!=0){h=114;break e}else h=114;t=HEAP[r+32];m=1;j=u;if(unSign(m,32)<=unSign(j,32)){j=p;l=n+8;la=u;t=t;for(h=116;;){h=h==116?0:na;f=unSign(HEAP[t+h],8);if(unSign(m,32)<unSign(j,32)){HEAP[o+524+f*2]=m&65535;HEAP[o+12+f*2]=HEAP[HEAP[l]+2*m]}m+=1;f=unSign(m,32)<=unSign(la,32);
var na=h+1;if(f){h=119;f=117}else{h=119;f=120;break}}}m=r;if(HEAP[m+20]!=0){j=HEAP[m+28];l=HEAP[m];j=j;l=l;l!=0&&FUNCTION_TABLE[HEAP[j+8]](j,l);HEAP[m]=0}HEAP[m+32]=0;HEAP[m+36]=0}else if(f==125){m=HEAP[o+8]=0;j=u;la=l=r;t=p;ga=n+8;h=125;h:for(;;){f=h==138?wa:1;if(!(unSign(m,32)<unSign(j,32))){f=139;break h}ea=_FT_Stream_ReadChar(l,c);unSign(ea,8);if(HEAP[c]!=0){h=127;f=128;break h}Z=_FT_Stream_ReadChar(la,c);h=unSign(Z,8);if(HEAP[c]!=0){h=129;f=128;break h}wa=h+1;if(unSign(HEAP[o+8],32)<unSign(wa,
32))HEAP[o+8]=wa;if(unSign(wa+f,32)>unSign(f,32)){ha=unSign(Z,8)+1;w=unSign(ea,8);for(h=132;;){h=h==132?0:sa;sa=w+h;x=f+h;B=x&65535;C=unSign(x,32)<unSign(t,32);y=unSign(sa,32)<=unSign(255,32);if(C&y){HEAP[o+524+sa*2]=B;HEAP[o+12+sa*2]=HEAP[HEAP[ga]+2*x]}var sa=h+1;if(sa!=ha)h=135;else break}unSign(ea,8);unSign(Z,8)}m+=1;var wa=wa+f;h=138;f=126}if(f==139){if(!(unSign(HEAP[o+8],32)>unSign(256,32))){f=141;break g}HEAP[o+8]=256}else if(f==128)break f}while(0);if((HEAP[o]&128)==0)break f;h=_FT_Stream_ReadChar(r,
c);u=unSign(h,8);var Aa=HEAP[c];if(Aa!=0){h=143;break e}m=0;u=u;l=j=r;la=p;t=n+8;h=145;g:for(;;){if(!(unSign(m,32)<unSign(u,32))){h=146;break g}h=_FT_Stream_ReadChar(j,c);ga=unSign(h,8);if(HEAP[c]!=0){h=147;break g}ea=_FT_Stream_ReadShort(l,c);if(HEAP[c]!=0){h=149;break g}HEAP[o+12+ga*2]=ea;for(h=150;;){X=h==153?i:0;if(!(unSign(X,32)<unSign(la,32))){f=156;break}if(HEAP[HEAP[t]+2*X]==ea){f=152;break}i=X+1;h=153;f=151}if(f==152)HEAP[o+524+ga*2]=X&65535;m+=1;h=156;f=146}}else{h=s;f=h==0?282:h==1?283:
169;if(f==169){HEAP[c]=3;h=169;break e}else if(f==282)_llvm_memcpy_p0i8_p0i8_i32(o+12,_cff_standard_encoding,512,1,0);else f==283&&_llvm_memcpy_p0i8_p0i8_i32(o+12,_cff_expert_encoding,512,1,0);HEAP[o+8]=0;k=_cff_charset_compute_cids(n,p,HEAP[r+28]);HEAP[c]=k;if(k!=0){h=158;break e}m=0;h=n;u=h+16;j=h+12;h=159;g:for(;;){l=unSign(HEAP[o+12+m*2],16);la=l!=0;h:do{if(la)if(unSign(HEAP[u],32)>=unSign(l,32)){h=unSign(HEAP[HEAP[j]+2*l],16);var Da=m;if(h==0){h=164;f=162;break h}HEAP[o+524+Da*2]=h&65535;HEAP[o+
8]=m+1;h=165;f=166}else{var pa=m;h=163;f=162}else{var ta=m;h=161;f=162}break h}while(0);if(f==162){HEAP[o+524+(h==161?ta:h==164?Da:pa)*2]=0;HEAP[o+12+m*2]=0}m=h=m+1;if(unSign(h,32)<=unSign(255,32))h=166;else{h=166;break g}}}while(0);X=HEAP[c];HEAP[I]=X;if(X!=0){f=15;break b}else break d}while(0);HEAP[I]=h==105?3:h==109?ia:h==111?ja:h==112?fa:h==114?ka:h==142?3:h==143?Aa:h==158?k:3;f=15;break b}while(0);X=_cff_index_get_name(e,N);HEAP[e+1304]=X}}f=15;break b}while(0);HEAP[I]=2}while(0);_cff_index_done(K);
I=HEAP[I];HEAP[T]=I;if(I!=0){f=2;break a}HEAP[b+2052]=O;HEAP[b+2056]=M;HEAP[g+4]=d;HEAP[g+16]=HEAP[b+12];I=b+1324;if(HEAP[I+128]==65535)if(M==0){f=4;break a}if(HEAP[I+64]==0){K=V==0?unSign(HEAP[g+68],16):1E3;HEAP[I+64]=K}M=I+48;K=I+68;i=I+64;X=HEAP[M+12];k=0-X;X=k=reSign(X,32)>=reSign(0,32)?X:k;if(k!=65536){k=_FT_DivFix(HEAP[i],X);HEAP[i]=k;i=_FT_DivFix(HEAP[M],X);HEAP[M]=i;i=_FT_DivFix(HEAP[M+8],X);HEAP[M+8]=i;i=_FT_DivFix(HEAP[M+4],X);HEAP[M+4]=i;i=_FT_DivFix(HEAP[M+12],X);HEAP[M+12]=i;M=_FT_DivFix(HEAP[K],
X);HEAP[K]=M;M=_FT_DivFix(HEAP[K+4],X);HEAP[K+4]=M}M=reSign(HEAP[K],32)>>reSign(16,32);HEAP[K]=M;M=reSign(HEAP[K+4],32)>>reSign(16,32);HEAP[K+4]=M;i=K=HEAP[b+1892];if(K!=0){K=b+1324;M=Q;X=Q+4;Q=Q+4;i=i;k=HEAP[M];Da=b+1892;h=176;b:for(;;){W=h==176?0:W;da=h==176?k:da;pa=HEAP[Da+4*(i+W*-1)];if(HEAP[pa+64]!=0){ta=unSign(HEAP[K+64],32)<=unSign(1,32);c:do if(ta)h=350;else{if(unSign(HEAP[pa+64],32)<=unSign(1,32)){h=178;break c}Y=HEAP[pa+64];h=HEAP[K+64];Y=unSign(Y,32)<=unSign(h,32)?Y:h;h=180}while(0);h=
h==180?Y:h==178?1:1;_FT_Matrix_Multiply_Scaled(K+48,pa+48,h);_FT_Vector_Transform_Scaled(pa+68,K+48,h);h=_FT_MulDiv(HEAP[pa+64],HEAP[K+64],h);HEAP[pa+64]=h;h=179}else{var ma=pa+48;h=K+48;HEAP[ma]=HEAP[h];HEAP[ma+4]=HEAP[h+4];HEAP[ma+8]=HEAP[h+8];HEAP[ma+12]=HEAP[h+12];h=K+68;ma=HEAP[h];HEAP[X]=HEAP[h+4];h=pa+68;HEAP[h]=ma;HEAP[h+4]=HEAP[Q];HEAP[pa+64]=HEAP[K+64];h=183}da=h==183?ma:da;ta=pa+48;h=pa+68;ia=pa+64;pa=HEAP[ta+12];fa=0-pa;pa=reSign(pa,32)>=reSign(0,32)?pa:fa;if(pa!=65536){fa=_FT_DivFix(HEAP[ia],
pa);HEAP[ia]=fa;if(unSign(HEAP[ia],32)>unSign(1E5,32)){fa=Math.floor(unSign(HEAP[ia]+500,32)/unSign(1E3,32));HEAP[ia]=fa}ia=_FT_DivFix(HEAP[ta],pa);HEAP[ta]=ia;ia=_FT_DivFix(HEAP[ta+8],pa);HEAP[ta+8]=ia;ia=_FT_DivFix(HEAP[ta+4],pa);HEAP[ta+4]=ia;ia=_FT_DivFix(HEAP[ta+12],pa);HEAP[ta+12]=ia;ta=_FT_DivFix(HEAP[h],pa);HEAP[h]=ta;pa=_FT_DivFix(HEAP[h+4],pa);HEAP[h+4]=pa}pa=reSign(HEAP[h],32)>>reSign(16,32);HEAP[h]=pa;pa=reSign(HEAP[h+4],32)>>reSign(16,32);HEAP[h+4]=pa;W=W+1;if(W!=i){h=186;f=177}else{h=
186;f=187;break b}}HEAP[M]=da}if(V!=0){Y=0;HEAP[g]=HEAP[b+8];ma=b;HEAP[g+16]=HEAP[I+128]!=65535?HEAP[ma+1152+16]+1:HEAP[ma+1176+8];ma=reSign(HEAP[I+80],32)>>reSign(16,32);HEAP[g+52]=ma;ma=reSign(HEAP[I+80+4],32)>>reSign(16,32);HEAP[g+52+4]=ma;ma=reSign(HEAP[I+80+8]+65535,32)>>reSign(16,32);HEAP[g+52+8]=ma;ma=reSign(HEAP[I+80+12]+65535,32)>>reSign(16,32);HEAP[g+52+12]=ma;HEAP[g+68]=HEAP[I+64]&65535;HEAP[g+70]=HEAP[g+52+12]&65535;HEAP[g+72]=HEAP[g+52+4]&65535;ma=unSign(HEAP[g+68],16)*12;ma=Math.floor(reSign(ma,
32)/reSign(10,32))&65535;HEAP[g+74]=ma;ma=reSign(HEAP[g+74],16);da=reSign(HEAP[g+70],16);W=reSign(HEAP[g+72],16);da=da-W;if(reSign(ma,32)<reSign(da,32))HEAP[g+74]=HEAP[g+70]-HEAP[g+72];ma=reSign(HEAP[I+32],32)>>reSign(16,32)&65535;HEAP[g+80]=ma;ma=reSign(HEAP[I+36],32)>>reSign(16,32)&65535;HEAP[g+82]=ma;d=_cff_index_get_name(b,d);HEAP[g+20]=d;d=HEAP[g+20]!=0;ma=I;b:do if(d){Q=W=_cff_index_get_sid_string(b,HEAP[ma+12]);da=HEAP[g+20];i=HEAP[g+20];k=_strlen(i)+1;K=reSign(k,32)<=reSign(6,32);M=i+6;N=
wa=i;Da=k;i=X=i;k=k;Da=reSign(7,32)<reSign(Da,32);pa=wa;ta=N;ia=wa+1;fa=N+1;ka=wa+2;Aa=N+2;ja=wa+3;na=N+3;sa=wa+4;O=N+4;wa=wa+5;N=N+5;c:do if(!K){e=k+-7;h=191;d:for(;;){o=h==191?1:h==199?ya:ya;if(HEAP[M]!=43){f=193;break c}ya=reSign(HEAP[pa],8)<=reSign(64,8);e:do if(ya)f=196;else{if(reSign(HEAP[ta],8)>reSign(90,8)){h=195;f=196}else{h=195;f=197}break e}while(0);if(f==196)h=196;ya=h==196?0:o;o=reSign(HEAP[ia],8)<=reSign(64,8);e:do if(o)f=203;else{if(reSign(HEAP[fa],8)>reSign(90,8)){h=202;f=203}else{h=
202;f=204}break e}while(0);if(f==203)h=203;ya=h==203?0:ya;o=reSign(HEAP[ka],8)<=reSign(64,8);e:do if(o)f=207;else{if(reSign(HEAP[Aa],8)>reSign(90,8)){h=206;f=207}else{h=206;f=208}break e}while(0);if(f==207)h=207;ya=h==207?0:ya;o=reSign(HEAP[ja],8)<=reSign(64,8);e:do if(o)f=211;else{if(reSign(HEAP[na],8)>reSign(90,8)){h=210;f=211}else{h=210;f=212}break e}while(0);if(f==211)h=211;ya=h==211?0:ya;o=reSign(HEAP[sa],8)<=reSign(64,8);e:do if(o)f=215;else{if(reSign(HEAP[O],8)>reSign(90,8)){h=214;f=215}else{h=
214;f=216}break e}while(0);if(f==215)h=215;var ya=h==215?0:ya;if(reSign(HEAP[wa],8)<=reSign(64,8)){f=193;break c}if(!((reSign(HEAP[N],8)>reSign(90,8)^1)&ya!=0)){f=193;break c}if(Da)h=199;else{h=199;f=192;continue d}for(;;){qa=h==200?qa:0;HEAP[i+qa]=HEAP[X+(qa+7)];var qa=qa+1;if(qa!=e)h=200;else break}if(ya!=0){h=201;f=192}else{h=201;f=193;break c}}}while(0);M=HEAP[I+16]!=0;c:do if(M){K=_cff_index_get_sid_string(b,HEAP[I+16]);if(K==0){f=220;break c}da=K}while(0);if(W==0){f=223;break b}if(da==0){f=
223;break b}W=Q;da=da;h=224;c:for(;;){ba=h==224?da:h==226?Ba:h==227?ba:Ea;var ua=h==224?W:h==226?Na:h==227?ra:ua;if(HEAP[ua]==0){f=236;break c}if(HEAP[ua]==HEAP[ba]){var Ba=ba+1,Na=ua+1;h=226}else{Q=HEAP[ua]==32;d:do if(!Q){if(HEAP[ua]==45)break d;if(HEAP[ba]!=32)if(HEAP[ba]!=45){f=230;break c}var Ea=ba+1;h=231;f=225;continue c}while(0);var ra=ua+1;h=227}f=225}if(f==236){f=223;break b}else if(f==230){da=ba;Q=ua;if(HEAP[da]!=0){f=223;break b}if(HEAP[Q]==0){f=223;break b}Y=S=_cff_strcpy(a,Q);h=233;
f=234;break b}}else{ba=_cff_index_get_sid_string(b,HEAP[ma+168]);if(ba==0){f=223;break b}ba=_cff_strcpy(a,ba);HEAP[g+20]=ba;f=223;break b}while(0);if(f==223){var za=Y;h=223}if((h==223?za:S)!=0)HEAP[g+24]=Y;else{S=_cff_strcpy(a,__str62);HEAP[g+24]=S}S=2065;if(U!=0)S|=8;if(HEAP[I+24]!=0)S|=4;HEAP[g+8]=S;S=0;if(HEAP[I+28]!=0)S|=1;U=za=_cff_index_get_sid_string(b,HEAP[I+20]);za=za!=0;b:do if(za){if(_strcmp(U,__str63)!=0)if(_strcmp(U,__str64)!=0){f=244;break b}S|=2}while(0);U=(S&2)==0;b:do if(U){if(HEAP[g+
24]==0){f=247;break b}if(_strncmp(HEAP[g+24],__str63,4)!=0)if(_strncmp(HEAP[g+24],__str64,5)!=0){f=247;break b}S|=2}while(0);HEAP[g+12]=S}if(HEAP[I+128]==65535)HEAP[g+8]|=512;U=HEAP[I+128]!=65535;b:do if(U){if(V==0){f=253;break b}HEAP[g+8]|=4096}while(0);U=b+116;S=0;za=HEAP[g+36];ba=g+40;ua=S;h=253;b:for(;;){Ca=h==258?Ca:0;var Ha=ua+Ca;if(!(unSign(za,32)>unSign(Ha,32))){f=260;break b}Ba=HEAP[HEAP[ba]+4*Ha];if(HEAP[Ba+8]==3)if(HEAP[Ba+10]==1){f=256;break b}if(HEAP[Ba+8]==0){f=256;break b}var Ca=Ca+
1;h=258;f=255}b:do if(f==260){S=Ha;if(V!=0)if(HEAP[b+1324+128]!=65535){f=2;break a}if(unSign(S+1,32)>unSign(15,32)){f=2;break a}HEAP[aa]=g;HEAP[aa+8]=3;HEAP[aa+10]=1;HEAP[aa+4]=1970170211;S=HEAP[g+36];V=_FT_CMap_New(_cff_cmap_unicode_class_rec,0,aa,0);HEAP[T]=V;if(HEAP[T]!=0&HEAP[T]!=163){f=2;break a}HEAP[T]=0;if(HEAP[g+92]!=0){f=265;break b}var va=S;if(HEAP[g+36]!=va)h=264;else{h=264;f=267;break b}HEAP[g+92]=HEAP[HEAP[g+40]+4*S];f=265;break b}else if(f==256){S=Ha;f=265;break b}while(0);if(f==265){var Pa=
S;h=265}if(unSign(h==265?Pa:va,32)>unSign(15,32)){f=2;break a}if(HEAP[U+8]==0){f=2;break a}HEAP[aa]=g;HEAP[aa+8]=7;if(HEAP[U+4]==0){HEAP[aa+10]=0;HEAP[aa+4]=1094995778}else{g=aa+10;if(HEAP[U+4]==1){HEAP[g]=1;HEAP[aa+4]=1094992453}else{HEAP[g]=2;HEAP[aa+4]=1094992451}}g=_cff_cmap_encoding_class_rec;aa=_FT_CMap_New(g,0,aa,0);HEAP[T]=aa;f=2;break a}while(0);a:do if(f==4){f=HEAP[T]=2;break a}while(0);if(f==2)R=HEAP[T];R=R;STACKTOP=c;return R}
_cff_face_init.__index__=Runtime.getFunctionIndex(_cff_face_init,"_cff_face_init");
function _cff_face_done(e){var g=null,d,b,a,c,f,h,i,k,j=e==0;a:do if(!j){d=HEAP[e+100];k=HEAP[e+532];k!=0&&FUNCTION_TABLE[HEAP[k+12]](e);k=b=HEAP[e+692];if(b==0)break a;k=k;b=HEAP[k+4];_cff_index_done(k+84);_cff_index_done(k+1208);_cff_index_done(k+20);_cff_index_done(k+1176);if(HEAP[k+1892]!=0){if(unSign(HEAP[k+1892],32)>unSign(0,32)){c=b;a=c+8;for(g=3;;){l=g==3?0:l;g=1+l;i=HEAP[k+1896+(0+l)*4];if(i!=0){_cff_index_done(i+532);f=HEAP[i+564];f!=0&&FUNCTION_TABLE[HEAP[a]](c,f);HEAP[i+564]=0}g=unSign(HEAP[k+
1892],32)>unSign(g,32);var l=l+1;if(g)g=8;else break}}g=HEAP[k+1896];c=b;a=g;g!=0&&FUNCTION_TABLE[HEAP[c+8]](c,a);HEAP[k+1896]=0}c=k+116;HEAP[c]=0;HEAP[c+4]=0;HEAP[c+8]=0;a=HEAP[k];c=k+1152;a=a;i=a=HEAP[a+28];g=c;f=i;i=HEAP[g+12];f=f;h=i;i!=0&&FUNCTION_TABLE[HEAP[f+8]](f,h);HEAP[g+12]=0;HEAP[g+16]=0;g=HEAP[c+8];a=a;i=g;g!=0&&FUNCTION_TABLE[HEAP[a+8]](a,i);HEAP[c+8]=0;HEAP[c]=0;HEAP[c+4]=0;g=k+1324;a=b;c=g;if(g!=0){_cff_index_done(c+532);g=HEAP[c+564];a=a;g=g;g!=0&&FUNCTION_TABLE[HEAP[a+8]](a,g);HEAP[c+
564]=0}a=HEAP[k];c=k+2024;a=a;if(HEAP[c+8]!=0){g=c+8;a=a;g=g;i=a!=0;b:do if(i){if(HEAP[a+20]==0)break b;f=HEAP[a+28];h=HEAP[g];f=f;h=h;h!=0&&FUNCTION_TABLE[HEAP[f+8]](f,h);HEAP[g]=0}while(0);HEAP[g]=0}HEAP[c+12]=0;HEAP[c]=0;HEAP[c+4]=0;g=HEAP[k+2060];c=b;a=g;g!=0&&FUNCTION_TABLE[HEAP[c+8]](c,a);HEAP[k+2060]=0;g=HEAP[k+1304];c=b;a=g;g!=0&&FUNCTION_TABLE[HEAP[c+8]](c,a);HEAP[k+1304]=0;g=HEAP[k+1308];c=b;a=g;g!=0&&FUNCTION_TABLE[HEAP[c+8]](c,a);HEAP[k+1308]=0;g=HEAP[k+1316];c=b;a=g;g!=0&&FUNCTION_TABLE[HEAP[c+
8]](c,a);HEAP[k+1316]=0;c=HEAP[k+1320];b=b;a=c;c!=0&&FUNCTION_TABLE[HEAP[b+8]](b,a);HEAP[k+1320]=0;k=HEAP[e+692];d=d;b=k;k!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[e+692]=0}while(0)}_cff_face_done.__index__=Runtime.getFunctionIndex(_cff_face_done,"_cff_face_done");function _cff_driver_init(){return 0}_cff_driver_init.__index__=Runtime.getFunctionIndex(_cff_driver_init,"_cff_driver_init");function _cff_driver_done(){}_cff_driver_done.__index__=Runtime.getFunctionIndex(_cff_driver_done,"_cff_driver_done");
function _check_points(e,g){var d,b,a=g==0;a:do if(a)d=0;else{d=reSign(HEAP[HEAP[e+12]+20+2],16);a=reSign(HEAP[HEAP[e+12]+56+2],16);var c=HEAP[HEAP[e+12]+4];if(unSign(g+d+a,32)<=unSign(c,32)){d=0;break a}b=_FT_GlyphLoader_CheckPoints(HEAP[e+12],g,0);d=2;break a}while(0);if(d==0)b=0;return b}_check_points.__index__=Runtime.getFunctionIndex(_check_points,"_check_points");
function _cff_builder_add_point(e,g,d,b){var a,c;a=HEAP[e+20];if(HEAP[e+65]!=0){e=HEAP[a+4];c=reSign(HEAP[a+2],16);e=e+8*c;c=HEAP[a+8];var f=reSign(HEAP[a+2],16);c=c+f;g=reSign(g,32)>>reSign(16,32);HEAP[e]=g;d=reSign(d,32)>>reSign(16,32);HEAP[e+4]=d;b=b!=0?1:2;HEAP[c]=b}HEAP[a+2]+=1}_cff_builder_add_point.__index__=Runtime.getFunctionIndex(_cff_builder_add_point,"_cff_builder_add_point");
function _cff_builder_start_point(e,g,d){var b,a,c,f;b=0;var h=HEAP[e+64]==0;a:do if(h){HEAP[e+64]=1;a=e;b=HEAP[a+20];if(HEAP[a+65]==0)HEAP[b]+=1;else{c=reSign(HEAP[HEAP[a+12]+20],16);f=reSign(HEAP[HEAP[a+12]+56],16);var i=HEAP[HEAP[a+12]+8];f=unSign(c+1+f,32)>unSign(i,32);b:do if(f){c=a=_FT_GlyphLoader_CheckPoints(HEAP[a+12],0,1);if(a==0)break b;b=a;break a}else c=0;while(0);if(reSign(HEAP[b],16)>reSign(0,16)){a=HEAP[b+12];f=reSign(HEAP[b],16)-1;HEAP[a+2*f]=HEAP[b+2]-1}HEAP[b]+=1;b=a=c;if(a!=0)break a}a=
g;c=d;b=e;a=a;c=c;f=i=_check_points(b,1);i==0&&_cff_builder_add_point(b,a,c,1);b=b=b=f}while(0);return b}_cff_builder_start_point.__index__=Runtime.getFunctionIndex(_cff_builder_start_point,"_cff_builder_start_point");
function _cff_builder_close_contour(e){var g,d,b,a;e=HEAP[e+20];var c=e==0;a:do if(!c){if(reSign(HEAP[e],16)>reSign(1,16)){g=HEAP[e+12];d=reSign(HEAP[e],16)-2;g=reSign(HEAP[g+2*d],16)+1}else g=0;g=g;var f=reSign(HEAP[e+2],16)>reSign(1,16);b:do if(f){d=HEAP[e+4]+8*g;b=HEAP[e+4];a=reSign(HEAP[e+2],16);b=b+8*a+-8;a=HEAP[e+8];var h=reSign(HEAP[e+2],16);a=a+h+-1;if(HEAP[d]!=HEAP[b])break b;if(HEAP[d+4]!=HEAP[b+4])break b;if(HEAP[a]!=1)break b;HEAP[e+2]-=1}while(0);if(!(reSign(HEAP[e],16)>reSign(0,16)))break a;
d=reSign(HEAP[e+2],16)-1;f=e;if(d==g){HEAP[e]=HEAP[f]-1;HEAP[e+2]-=1}else{g=HEAP[f+12];d=reSign(HEAP[e],16)-1;HEAP[g+2*d]=HEAP[e+2]-1}}while(0)}_cff_builder_close_contour.__index__=Runtime.getFunctionIndex(_cff_builder_close_contour,"_cff_builder_close_contour");
function _cff_lookup_glyph_by_stdcharcode(e,g){var d,b=null,a,c;if(HEAP[e+1152+8]==0)c=-1;else{a=reSign(g,32)<reSign(0,32);var f=reSign(g,32)>reSign(255,32);if(a|f)c=-1;else{a=unSign(g,32)<=unSign(255,32)?unSign(HEAP[_cff_standard_encoding+g*2],16):0;a=a&65535;f=HEAP[e+12];var h=e+1152+8;for(b=2;;){d=b==5?k:0;var i=0+d;if(!(unSign(f,32)>unSign(i,32))){d=7;break}if(HEAP[HEAP[h]+2*i]==a){d=4;break}var k=d+1;b=5;d=3}if(d==7)c=-1;else if(d==4)c=i}}return c}
_cff_lookup_glyph_by_stdcharcode.__index__=Runtime.getFunctionIndex(_cff_lookup_glyph_by_stdcharcode,"_cff_lookup_glyph_by_stdcharcode");function _cff_get_glyph_data(e,g,d,b){var a=STACKTOP;STACKTOP+=8;Runtime.memset(a,0,8);if(HEAP[HEAP[e+128]+52]!=0){g=FUNCTION_TABLE[HEAP[HEAP[HEAP[HEAP[e+128]+52]]]](HEAP[HEAP[HEAP[e+128]+52]+4],g,a);HEAP[d]=HEAP[a];HEAP[b]=HEAP[a+4];d=g}else{e=HEAP[e+692];d=_cff_index_access_element(e+1176,g,d,b)}d=d;STACKTOP=a;return d}
_cff_get_glyph_data.__index__=Runtime.getFunctionIndex(_cff_get_glyph_data,"_cff_get_glyph_data");
function _cff_free_glyph_data(e,g,d){var b=STACKTOP;STACKTOP+=8;Runtime.memset(b,0,8);var a,c;if(HEAP[HEAP[e+128]+52]!=0){HEAP[b]=HEAP[g];HEAP[b+4]=d;FUNCTION_TABLE[HEAP[HEAP[HEAP[HEAP[e+128]+52]]+4]](HEAP[HEAP[HEAP[e+128]+52]+4],b)}else{e=HEAP[e+692];e=e+1176;if(HEAP[e+28]==0){e=HEAP[e];d=e!=0;a:do if(d){if(HEAP[e+20]==0)break a;a=HEAP[e+28];c=HEAP[g];a=a;c=c;c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[g]=0}while(0);HEAP[g]=0}}STACKTOP=b}
_cff_free_glyph_data.__index__=Runtime.getFunctionIndex(_cff_free_glyph_data,"_cff_free_glyph_data");
function _cff_operator_seac(e,g,d,b,a,c){var f=STACKTOP;STACKTOP+=40;Runtime.memset(f,0,40);var h=null,i,k=f+8,j,l,m,o=f+16,n=f+24,p=f+32,r=f+36,q;d=d;b=b;m=HEAP[e+4];var s=HEAP[e+924]!=0;a:do{if(!s){d+=HEAP[e+32];b+=HEAP[e+32+4];if(HEAP[HEAP[m+128]+52]!=0){j=q=a;l=c;h=1}else{l=HEAP[m+692];var u=_cff_lookup_glyph_by_stdcharcode(l,a);j=u;l=_cff_lookup_glyph_by_stdcharcode(l,c);h=3}h=reSign(h==3?u:q,32)<reSign(0,32);b:do if(!h){if(reSign(l,32)<reSign(0,32))break b;c=HEAP[e+66]!=0;c:do if(c){a=HEAP[e+
8];c=HEAP[HEAP[a+156]];i=_FT_GlyphLoader_CheckSubGlyphs(c,2);if(i!=0){a=6;break c}q=HEAP[c+56+32];HEAP[q]=j;HEAP[q+4]=514;HEAP[q+8]=0;HEAP[q+12]=0;q+=32;HEAP[q]=l;HEAP[q+4]=2;u=reSign(d,32)>>reSign(16,32);HEAP[q+8]=u;u=reSign(b,32)>>reSign(16,32);HEAP[q+12]=u;HEAP[a+128]=2;HEAP[a+132]=HEAP[c+20+32];HEAP[a+72]=1668246896;HEAP[c+56+28]=2;a=8;break c}else a=8;while(0);c:do if(a==8){i=HEAP[e+12];c=i+56;HEAP[c+2]=0;HEAP[c]=0;HEAP[c+28]=0;_FT_GlyphLoader_Adjust_Points(i);c=i;i=c+20;c=c+56;HEAP[c+32]=HEAP[i+
32]+32*HEAP[i+28];if(_cff_get_glyph_data(m,j,p,r)==0){HEAP[e+924]=1;i=_cff_decoder_parse_charstrings(e,HEAP[p],HEAP[r]);HEAP[e+924]=0;_cff_free_glyph_data(m,p,HEAP[r]);if(i!=0)break c}i=e+32;HEAP[k]=HEAP[i];HEAP[k+4]=HEAP[i+4];HEAP[o]=HEAP[k];HEAP[o+4]=HEAP[k+4];i=e+40;HEAP[f]=HEAP[i];HEAP[f+4]=HEAP[i+4];HEAP[n]=HEAP[f];HEAP[n+4]=HEAP[f+4];c=HEAP[e+744];HEAP[e+32]=0;HEAP[e+32+4]=0;HEAP[e+24]=d-g;HEAP[e+28]=b;i=q=_cff_get_glyph_data(m,l,p,r);if(q==0){HEAP[e+924]=1;i=_cff_decoder_parse_charstrings(e,
HEAP[p],HEAP[r]);HEAP[e+924]=0;_cff_free_glyph_data(m,p,HEAP[r]);if(i!=0)break c}q=e+32;HEAP[q]=HEAP[o];HEAP[q+4]=HEAP[o+4];q=e+40;HEAP[q]=HEAP[n];HEAP[q+4]=HEAP[n+4];HEAP[e+744]=c;HEAP[e+24]=0;HEAP[e+28]=0}while(0);j=i;break a}while(0)}j=160}while(0);e=j;STACKTOP=f;return e}_cff_operator_seac.__index__=Runtime.getFunctionIndex(_cff_operator_seac,"_cff_operator_seac");
function _cff_decoder_parse_charstrings(e,g,d){var b=STACKTOP;STACKTOP+=12;Runtime.memset(b,0,12);var a,c=null,f=b+4,h,i,k,j,l,m,o,n,p,r=b+8,q,s,u,t,v,w,x,y,A,z;HEAP[b]=e;HEAP[f]=g;e=HEAP[b];g=HEAP[HEAP[HEAP[b]+76]+1324+44];HEAP[HEAP[b]+756]=0;HEAP[HEAP[b]+752]=1;HEAP[r]=f^b^r;s=reSign(HEAP[r],32)>>reSign(10,32);m=HEAP[r];q=reSign(HEAP[r],32)>>reSign(20,32);HEAP[r]=(s^m^q)&65535;if(HEAP[r]==0)HEAP[r]=29572;HEAP[HEAP[b]+276]=HEAP[b]+80;HEAP[HEAP[b]+676]=HEAP[b]+280;m=HEAP[b]+280;q=HEAP[HEAP[b]+276];
s=HEAP[e+68];HEAP[e+64]=0;HEAP[m]=HEAP[f];HEAP[m+4]=HEAP[f]+d;o=HEAP[m+4];HEAP[m+8]=HEAP[m];f=HEAP[m+8];d=0;n=HEAP[e+24];p=HEAP[e+28];s!=0&&FUNCTION_TABLE[HEAP[s+4]](HEAP[s]);a:for(;;){if(!(f<o)){a=90;break a}v=HEAP[f];f+=1;if(unSign(v,8)>unSign(31,8)|v==28){u=16;a=v==28;b:do if(a){if(f+1>=o){a=5;break a}c=unSign(HEAP[f],8)<<8&65535;w=unSign(HEAP[f+1],8);c=reSign(c|w,16);f+=2}else if(unSign(v,8)<=unSign(-10,8))c=unSign(v,8)-139;else if(unSign(v,8)<=unSign(-6,8)){if(f>=o){a=5;break a}c=unSign(v,8)*
256;w=unSign(HEAP[f],8);c=c+-63124+w;f+=1}else{c=f;if(v!=-1){if(c>=o){a=5;break a}c=(251-unSign(v,8))*256;c=0-unSign(HEAP[f],8)+-108+c;f+=1}else{if(c+3>=o){a=5;break a}c=unSign(HEAP[f],8)<<24;w=unSign(HEAP[f+1],8)<<16;x=unSign(HEAP[f+2],8)<<8;z=unSign(HEAP[f+3],8);c=w|c|x|z;f+=4;if(g!=2)break b;u=0}}while(0);if(reSign(HEAP[HEAP[b]+276]-q,32)>reSign(191,32)){a=16;break a}c<<=u;u=HEAP[b];v=HEAP[u+276];HEAP[v]=c;HEAP[u+276]=v+4;a=3}else{j=HEAP[HEAP[b]+276];t=Math.floor(reSign(j-(HEAP[b]+80),32)/reSign(4,
32));u=0;v=unSign(v,8);if(v==1){c=258;a=18}else if(v==3){c=258;a=20}else if(v==4){c=258;a=21}else if(v==5){c=258;a=22}else if(v==6){c=258;a=23}else if(v==7){c=258;a=24}else if(v==8){c=258;a=25}else if(v==9){c=258;a=26}else if(v==10){c=258;a=27}else if(v==11){c=258;a=28}else if(v==12){c=258;a=29}else if(v==13){c=258;a=65}else if(v==14){c=258;a=66}else if(v==16){c=258;a=67}else if(v==18){c=258;a=68}else if(v==19){c=258;a=69}else if(v==20){c=258;a=70}else if(v==21){c=258;a=71}else if(v==22){c=258;a=
72}else if(v==23){c=258;a=73}else if(v==24){c=258;a=74}else if(v==25){c=258;a=75}else if(v==26){c=258;a=76}else if(v==27){c=258;a=77}else if(v==29){c=258;a=78}else if(v==30){c=258;a=79}else if(v==31){c=258;a=80}else{a=5;break a}if(a==18){u=19;c=18}else if(a==20)c=u=20;else if(a==21){u=3;c=21}else if(a==22){u=4;c=22}else if(a==23){u=5;c=23}else if(a==24){u=6;c=24}else if(a==25){u=7;c=25}else if(a==26){u=53;c=26}else if(a==27){u=49;c=27}else if(a==28){u=51;c=28}else if(a==29){if(f>=o){a=5;break a}else c=
29;v=HEAP[f];f+=1;v=unSign(v,8);a=v==0?31:v==1?32:v==2?33:v==3?34:v==4?35:v==5?36:v==6?37:v==7?38:v==8?39:v==9?40:v==10?41:v==11?42:v==12?43:v==13?44:v==14?45:v==15?46:v==16?47:v==17?48:v==18?49:v==20?50:v==21?51:v==22?52:v==23?53:v==24?54:v==26?55:v==27?56:v==28?57:v==29?58:v==30?59:v==33?60:v==34?61:v==35?62:v==36?63:v==37?64:81;if(a==81){f+=-1;if(u==0){a=5;break a}else c=81}else if(a==31){u=25;c=31}else if(a==32){u=20;c=32}else if(a==33){u=19;c=33}else if(a==34){u=44;c=34}else if(a==35){u=45;c=
35}else if(a==36){u=46;c=36}else if(a==37){u=56;c=37}else if(a==38){u=57;c=38}else if(a==39){u=42;c=39}else if(a==40){u=26;c=40}else if(a==41){u=27;c=41}else if(a==42){u=28;c=42}else if(a==43){u=29;c=43}else if(a==44){u=43;c=44}else if(a==45){u=30;c=45}else if(a==46){u=47;c=46}else if(a==47){u=54;c=47}else if(a==48){u=55;c=48}else if(a==49){u=35;c=49}else if(a==50){u=40;c=50}else if(a==51){u=41;c=51}else if(a==52){u=48;c=52}else if(a==53){u=31;c=53}else if(a==54){u=32;c=54}else if(a==55){u=33;c=55}else if(a==
56){u=39;c=56}else if(a==57){u=36;c=57}else if(a==58){u=37;c=58}else if(a==59){u=38;c=59}else if(a==60){u=58;c=60}else if(a==61){u=15;c=61}else if(a==62){u=14;c=62}else if(a==63){u=16;c=63}else if(a==64){u=17;c=64}}else if(a==65){u=52;c=65}else if(a==66){u=18;c=66}else if(a==67){u=34;c=67}else if(a==68){u=21;c=68}else if(a==69){u=23;c=69}else if(a==70){u=24;c=70}else if(a==71){u=1;c=71}else if(a==72){u=2;c=72}else if(a==73){u=22;c=73}else if(a==74){u=10;c=74}else if(a==75){u=11;c=75}else if(a==76){u=
13;c=76}else if(a==77){u=8;c=77}else if(a==78){u=50;c=78}else if(a==79){u=12;c=79}else if(a==80){u=9;c=80}v=unSign(HEAP[_cff_argument_counts+u],8);if((v&128)!=0){v=reSign(t,32)>reSign(0,32);b:do if(v){if(HEAP[HEAP[b]+752]==0)break b;a=u;a=a==1?86:a==2?84:a==3?84:a==18?259:a==19?86:a==20?86:a==21?86:a==22?86:a==23?86:a==24?86:260;if(a==260)break b;else if(a==86){var C=t&1;c=86}else if(a==84){var B=t&2;c=84}else if(a==259){l=l=t==5|t==1?1:0;c=88}if((c==88?l:c==86?C:B)==0)break b;a=HEAP[b];c=HEAP[HEAP[b]+
748];c=(reSign(HEAP[q],32)>>reSign(16,32))+c;HEAP[a+744]=c;if(HEAP[HEAP[b]+753]!=0){a=90;break a}else c=89;t-=1}while(0);v=HEAP[HEAP[b]+752]=0}v&=15;a=v;if(reSign(t,32)<reSign(a,32)){a=94;break a}j+=4*(0-v);t=v=t-v;a=u;if(a==1)a=261;else if(a==2)a=262;else if(a==3)a=263;else if(a==4)a=104;else if(a==5)a=264;else if(a==6)a=264;else if(a==7)a=265;else if(a==8)a=266;else if(a==9)a=144;else if(a==10)a=267;else if(a==11)a=268;else if(a==12)a=144;else if(a==13)a=269;else if(a==14)a=187;else if(a==15)a=
172;else if(a==16)a=169;else if(a==17)a=175;else if(a==18){a=270;break a}else if(a==19)a=271;else if(a==20)a=271;else if(a==21)a=271;else if(a==22)a=271;else if(a==23)a=272;else if(a==24)a=272;else if(a==25)a=110;else if(a==26)a=273;else if(a==27)a=274;else if(a==28)a=275;else if(a==29)a=276;else if(a==30)a=277;else if(a==31)a=278;else if(a==32)a=279;else if(a==33)a=280;else if(a==35)a=110;else if(a==36)a=281;else if(a==37)a=282;else if(a==38)a=283;else if(a==39)a=284;else if(a==40)a=285;else if(a==
41)a=286;else if(a==44)a=287;else if(a==45)a=288;else if(a==47)a=289;else if(a==48)a=290;else if(a==49)a=244;else if(a==50)a=249;else if(a==51)a=254;else if(a==52)a=291;else if(a==53)a=292;else if(a==54)a=293;else if(a==55)a=294;else if(a==56){a=295;break a}else if(a==57)a=296;else if(a==58)a=297;else{a=298;break a}b:do if(a==261){_cff_builder_close_contour(e);HEAP[e+64]=0;n+=HEAP[j+-8];p+=HEAP[j+-4];j=q}else if(a==262){_cff_builder_close_contour(e);HEAP[e+64]=0;n+=HEAP[j+-4];j=q}else if(a==263){_cff_builder_close_contour(e);
HEAP[e+64]=0;p+=HEAP[j+-4];j=q}else if(a==104){if(_cff_builder_start_point(e,n,p)!=0){a=90;break a}a=Math.floor(reSign(t,32)/reSign(2,32));if(_check_points(e,a)!=0){a=90;break a}if(reSign(t,32)<=reSign(1,32)){a=94;break a}j+=4*(0-(t&-2));for(a=HEAP[HEAP[b]+276]>j?108:109;;)if(a==108){n+=HEAP[j];p+=HEAP[j+4];_cff_builder_add_point(e,n,p,1);j+=8;a=HEAP[HEAP[b]+276]>j?108:109}else if(a==109){j=q;break b}}else if(a==264){c=unSign(u==5,1);if(reSign(v,32)<=reSign(0,32)){a=94;break a}if(_cff_builder_start_point(e,
n,p)!=0){a=90;break a}if(_check_points(e,t)!=0){a=90;break a}j=q;w=c;for(c=113;;){a=c==116?D:w;if(!(HEAP[HEAP[b]+276]>j)){a=120;break}D=HEAP[j];if(a!=0)n+=D;else p+=D;D=e;c=n;x=p;if(_check_points(D,1)!=0){a=117;break a}_cff_builder_add_point(D,c,x,1);j+=4;var D=a^1;c=116;a=114}j=q}else if(a==265){if(reSign(t,32)<=reSign(5,32)){a=94;break a}a=reSign(t,32)%reSign(6,32);a=t-a;if(_cff_builder_start_point(e,n,p)!=0){a=90;break a}c=Math.floor(reSign(a,32)/reSign(2,32));if(_check_points(e,c)!=0){a=90;break a}j+=
4*(0-a);for(a=HEAP[HEAP[b]+276]>j?124:125;;)if(a==124){n+=HEAP[j];p+=HEAP[j+4];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+8];p+=HEAP[j+12];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+16];p+=HEAP[j+20];_cff_builder_add_point(e,n,p,1);j+=24;a=HEAP[HEAP[b]+276]>j?124:125}else if(a==125){j=q;break b}}else if(a==266){if(reSign(t,32)<=reSign(3,32)){a=94;break a}a=reSign(t,32)%reSign(4,32);a=t-a;if(reSign(t-a,32)>reSign(0,32))a+=1;if(_cff_builder_start_point(e,n,p)!=0){a=90;break a}j+=4*(0-a);if((a&1&255)!=
0){p+=HEAP[j];j+=4;a-=1}a=Math.floor(reSign(a,32)/reSign(4,32))*3;if(_check_points(e,a)!=0){a=90;break a}for(a=HEAP[HEAP[b]+276]>j?142:143;;)if(a==142){n+=HEAP[j];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+4];p+=HEAP[j+8];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+12];_cff_builder_add_point(e,n,p,1);j+=16;a=HEAP[HEAP[b]+276]>j?142:143}else if(a==143){j=q;break b}}else if(a==144){if(_cff_builder_start_point(e,n,p)!=0){a=90;break a}if(reSign(t,32)<=reSign(3,32)){a=94;break a}c=reSign(t,32)%reSign(4,32);
c=t-c;if(reSign(t-c,32)>reSign(0,32))c+=1;j+=4*(0-c);w=Math.floor(reSign(c,32)/reSign(4,32))*3;if(_check_points(e,w)!=0){a=94;break a}w=unSign(u==9,1);if(reSign(c,32)>reSign(3,32)){w=w;x=c+-4;for(c=149;;){F=c==149?0:F;E=c==149?w:E;a=x+F*-4;c=HEAP[j];if(E!=0){n+=c;_cff_builder_add_point(e,n,p,0);n+=HEAP[j+4];p+=HEAP[j+8];_cff_builder_add_point(e,n,p,0);p+=HEAP[j+12];if(a==1)n+=HEAP[j+16]}else{p+=c;_cff_builder_add_point(e,n,p,0);n+=HEAP[j+4];p+=HEAP[j+8];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+12];
if(a==1)p+=HEAP[j+16]}_cff_builder_add_point(e,n,p,1);j+=16;var E=E^1;a=reSign(a,32)>reSign(3,32);var F=F+1;if(a){c=154;a=150}else{a=155;break}}}j=q}else if(a==267){if(reSign(t,32)<=reSign(7,32)){a=94;break a}w=t-2;w=0-reSign(w,32)%reSign(6,32)+2+w;c=Math.floor(reSign(w-2,32)/reSign(6,32));if(_cff_builder_start_point(e,n,p)!=0){a=90;break a}if(_check_points(e,c*3+2)!=0){a=90;break a}j+=4*(0-w);w=c;x=c+-1;for(c=165;;){a=c==167?L:0;var G=x+a*-1;c=reSign(c==167?G:w,32)>reSign(0,32);n+=HEAP[j];p+=HEAP[j+
4];G=e;var H=n,J=p;if(!c){a=168;break}_cff_builder_add_point(G,H,J,0);n+=HEAP[j+8];p+=HEAP[j+12];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+16];p+=HEAP[j+20];_cff_builder_add_point(e,n,p,1);j+=24;var L=a+1;c=167;a=166}_cff_builder_add_point(G,H,J,1);j=q}else if(a==268){if(reSign(t,32)<=reSign(7,32)){a=94;break a}w=t&-2;c=Math.floor(reSign(w-6,32)/reSign(2,32));if(_cff_builder_start_point(e,n,p)!=0){a=90;break a}if(_check_points(e,c+3)!=0){a=90;break a}j+=4*(0-w);w=c;x=c+-1;for(c=159;;){a=c==161?K:
0;var N=x+a*-1;c=reSign(c==161?N:w,32)>reSign(0,32);n+=HEAP[j];p+=HEAP[j+4];N=e;var I=n,P=p;if(!c){a=162;break}_cff_builder_add_point(N,I,P,1);j+=8;var K=a+1;c=161;a=160}_cff_builder_add_point(N,I,P,0);n+=HEAP[j+8];p+=HEAP[j+12];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+16];p+=HEAP[j+20];_cff_builder_add_point(e,n,p,1);j=q}else if(a==269){if(reSign(t,32)<=reSign(3,32)){a=94;break a}a=reSign(t,32)%reSign(4,32);a=t-a;if(reSign(t-a,32)>reSign(0,32))a+=1;if(_cff_builder_start_point(e,n,p)!=0){a=90;break a}j+=
4*(0-a);if((a&1&255)!=0){n+=HEAP[j];j+=4;a-=1}a=Math.floor(reSign(a,32)/reSign(4,32))*3;if(_check_points(e,a)!=0){a=90;break a}for(a=HEAP[HEAP[b]+276]>j?133:134;;)if(a==133){p+=HEAP[j];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+4];p+=HEAP[j+8];_cff_builder_add_point(e,n,p,0);p+=HEAP[j+12];_cff_builder_add_point(e,n,p,1);j+=16;a=HEAP[HEAP[b]+276]>j?133:134}else if(a==134){j=q;break b}}else if(a==187){if(_cff_builder_start_point(e,n,p)!=0){a=90;break a}if(_check_points(e,6)!=0){a=90;break a}for(c=189;;){O=
c==189?0:O;a=6+O*-1;n+=HEAP[j];p+=HEAP[j+4];if(a==1){c=190;a=193}else if(a==4){c=190;a=193}else{c=190;a=191}if(a==191)c=191;a=unSign((c==191?0:c==190?1:1)&255,8);_cff_builder_add_point(e,n,p,a&255);j+=8;var O=O+1;if(O!=6){c=193;a=190}else{a=194;break}}j=q}else if(a==172){if(_cff_builder_start_point(e,n,p)!=0){a=90;break a}if(_check_points(e,6)!=0){a=90;break a}c=p;n+=HEAP[j];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+4];p+=HEAP[j+8];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+12];_cff_builder_add_point(e,
n,p,1);n+=HEAP[j+16];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+20];p=c;_cff_builder_add_point(e,n,p,0);n+=HEAP[j+24];_cff_builder_add_point(e,n,p,1);j=q}else if(a==169){if(_cff_builder_start_point(e,n,p)!=0){a=90;break a}if(_check_points(e,6)!=0){a=90;break a}c=p;n+=HEAP[j];p+=HEAP[j+4];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+8];p+=HEAP[j+12];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+16];_cff_builder_add_point(e,n,p,1);n+=HEAP[j+20];_cff_builder_add_point(e,n,p,0);n+=HEAP[j+24];p+=HEAP[j+28];_cff_builder_add_point(e,
n,p,0);n+=HEAP[j+32];p=c;_cff_builder_add_point(e,n,p,1);j=q}else if(a==175){A=y=0;if(_cff_builder_start_point(e,n,p)!=0){a=90;break a}if(_check_points(e,6)!=0){a=90;break a}w=n;x=p;z=j;c=5;z=z;y=y;A=A;c=c;var M=c*-1;M=reSign(M,32)>reSign(-1,32)?M:-1;M=c+1+M;c=177;c:for(;;){T=c==177?0:T;a=T*2;var Q=(c==177?y:Q)+HEAP[z+4*a],R=(c==177?A:R)+HEAP[z+4*(a+1)],T=T+1;if(T!=M)a=c=178;else{a=179;break c}}A=R;y=Q;if(reSign(y,32)<reSign(0,32)){y=0-y;var V=A;c=180}else c=179;if(reSign(c==180?V:R,32)<reSign(0,
32))A=0-A;c=A;c=reSign(y,32)>reSign(c,32);z=unSign(c,1);y=c=5;c=y*-1;c=reSign(c,32)>reSign(-1,32)?c:-1;A=y+1+c;for(c=183;;){U=c==183?0:U;a=y+U*-1;n+=HEAP[j];p+=HEAP[j+4];a=unSign(a==3,1);_cff_builder_add_point(e,n,p,a&255);j+=8;var U=U+1;if(U!=A)a=c=184;else{a=185;break}}if(z!=0){n+=HEAP[j];p=x}else{n=w;p+=HEAP[j]}_cff_builder_add_point(e,n,p,1);j=q}else if(a==271){if(s!=0){c=HEAP[s+12];w=j+4*(0-(t&-2));x=Math.floor(reSign(t,32)/reSign(2,32));j=u==19|u==21?1:0;FUNCTION_TABLE[c](HEAP[s],j,x,w)}j=HEAP[b];
c=HEAP[HEAP[b]+756];c=Math.floor(reSign(t,32)/reSign(2,32))+c;HEAP[j+756]=c;j=q}else if(a==272){if(reSign(v,32)>reSign(0,32)){if(s!=0){c=HEAP[s+12];w=j+4*(0-(t&-2));x=Math.floor(reSign(t,32)/reSign(2,32));FUNCTION_TABLE[c](HEAP[s],0,x,w)}c=HEAP[b];w=HEAP[HEAP[b]+756];w=Math.floor(reSign(t,32)/reSign(2,32))+w;HEAP[c+756]=w}c=reSign(HEAP[HEAP[b]+756]+7,32)>>reSign(3,32);if(f+c>=o){a=5;break a}if(s!=0){j=s;if(u==23){j=HEAP[j+16];c=HEAP[HEAP[b]+756];w=reSign(HEAP[HEAP[e+20]+2],16);FUNCTION_TABLE[j](HEAP[s],
w,c,f)}else FUNCTION_TABLE[HEAP[j+20]](HEAP[s],HEAP[HEAP[b]+756],f)}j=reSign(HEAP[HEAP[b]+756]+7,32)>>reSign(3,32);f+=j;j=q}else if(a==273){if(reSign(HEAP[j],32)<reSign(0,32))HEAP[j]=0-HEAP[j];j+=4}else if(a==274){HEAP[j]=HEAP[j+4]+HEAP[j];j+=4}else if(a==275){HEAP[j]-=HEAP[j+4];j+=4}else if(a==276){c=_FT_DivFix(HEAP[j],HEAP[j+4]);HEAP[j]=c;j+=4}else if(a==277){HEAP[j]=0-HEAP[j];j+=4}else if(a==278){c=HEAP[r];if(reSign(c,32)>reSign(32767,32))c+=1;HEAP[j]=c;c=_FT_MulFix(HEAP[r],65536-HEAP[r]);HEAP[r]=
c;if(c==0)HEAP[r]+=10355;j+=4}else if(a==279){c=_FT_MulFix(HEAP[j],HEAP[j+4]);HEAP[j]=c;j+=4}else if(a==280){if(reSign(HEAP[j],32)>reSign(0,32)){c=HEAP[j];w=reSign(9,32)<=reSign(0,32);x=c;c:do if(w){var S=_FT_DivFix(HEAP[j],x)+1+x;S=reSign(S,32)>>reSign(1,32);c=203}else for(c=299;;){a=c==299?x:X;X=_FT_DivFix(HEAP[j],a)+1+a;var X=reSign(X,32)>>reSign(1,32);if(X==a){c=205;a=206;break c}else a=c=205}while(0);c=c==203?S:X;HEAP[j]=c}else HEAP[j]=0;j+=4}else if(a==281){c=HEAP[j];HEAP[j]=HEAP[j+4];HEAP[j+
4]=c;j+=8}else if(a==282){c=reSign(HEAP[j],32)>>reSign(16,32);w=reSign(c,32)<reSign(0,32);c:do if(w)c=0;else{x=c;if(!(reSign(t-2,32)<reSign(x,32))){a=210;break c}c=t-2}while(0);HEAP[j]=HEAP[j+4*(c^-1)];j+=4}else if(a==283){w=reSign(HEAP[j],32)>>reSign(16,32);c=reSign(HEAP[j+4],32)>>reSign(16,32);if(reSign(w,32)<=reSign(0,32))w=1;j+=4*(0-w);if(j<q){a=94;break a}x=c;z=reSign(x,32)>=reSign(0,32);c:do if(z){if(!(reSign(x,32)>reSign(0,32))){a=214;break c}y=w-1;A=w;M=reSign(A-2,32)>=reSign(0,32);c=c;if(M){var Y=
A+-1;A=A+-2;M=c*-1;M=reSign(M,32)>reSign(-1,32)?M:-1;var W=c+1+M;c=215;d:for(;;){ba=c==218?ba:0;a=HEAP[j+4*y];for(c=216;;){da=c==216?0:da;c=da*-1;HEAP[j+4*(Y+c)]=HEAP[j+4*(A+c)];var da=da+1;if(da!=Y)c=217;else break}HEAP[j]=a;var ba=ba+1;if(ba!=W){c=218;a=216}else{a=219;break d}}Y=-1-M;c=219}else{var aa=c*-1;aa=reSign(aa,32)>reSign(-1,32)?aa:-1;A=c+1+aa;for(c=221;;){ca=c==221?0:ca;HEAP[j]=HEAP[j+4*y];var ca=ca+1;if(ca!=A)a=c=222;else{a=223;break}}aa=-1-aa;c=223}c=c==223?aa:Y}else{y=w;A=w-1;M=c;W=
reSign(w-1,32)>reSign(0,32);d:do if(W){var $=y+-1,la=reSign($,32)>reSign(1,32)?$:1;$=M+1;$=reSign($,32)>reSign(0,32)?$:0;var ga=$-M;c=225;for(;;){Z=c==228?Z:0;a=HEAP[j];for(c=226;;){ea=c==226?0:ea;HEAP[j+4*ea]=HEAP[j+4*(ea+1)];var ea=ea+1;if(ea!=la)c=227;else break}HEAP[j+4*A]=a;var Z=Z+1;if(Z!=ga){c=228;a=226}else{c=228;a=229;break d}}}else{var ha=M+1;ha=reSign(ha,32)>reSign(0,32)?ha:0;la=ha-M;for(c=230;;){ia=c==230?0:ia;HEAP[j+4*A]=HEAP[j];var ia=ia+1;if(ia!=la)a=c=231;else{c=231;a=229;break d}}}while(0);
c=c==228?$:ha}while(0);j+=4*w}else if(a==284){HEAP[j+4]=HEAP[j];j+=8}else if(a==285){c=HEAP[j];w=reSign(HEAP[j+4],32)>>reSign(16,32);x=reSign(w,32)>=reSign(0,32);z=reSign(w,32)<=reSign(31,32);if(!(x&z))break b;HEAP[HEAP[b]+760+w*4]=c}else if(a==286){c=reSign(HEAP[j],32)>>reSign(16,32);w=0;x=reSign(c,32)>=reSign(0,32);z=reSign(c,32)<=reSign(31,32);if(x&z)w=HEAP[HEAP[b]+760+c*4];HEAP[j]=w;j+=4}else if(a==287){c=HEAP[j]==0;c:do if(c)a=234;else{if(HEAP[j+4]==0){a=234;break c}i=65536;a=236;break c}while(0);
if(a==234)i=0;HEAP[j]=i;j+=4}else if(a==288){c=HEAP[j]!=0;c:do if(c)a=238;else{if(HEAP[j+4]!=0){a=238;break c}h=0;a=241;break c}while(0);if(a==238)h=65536;HEAP[j]=h;j+=4}else if(a==289){c=unSign(HEAP[j]==0,1);c=c!=0?65536:0;HEAP[j]=c;j+=4}else if(a==290){c=HEAP[j+12];c=reSign(HEAP[j+8],32)<=reSign(c,32);c=unSign(c,1);if(c==0)HEAP[j]=HEAP[j+4];j+=4}else if(a==244){o=reSign(HEAP[j],32)>>reSign(16,32);c=o=HEAP[HEAP[b]+896]+o;if(unSign(HEAP[HEAP[b]+888],32)<=unSign(c,32)){a=5;break a}if(reSign(m-(HEAP[b]+
280),32)>reSign(383,32)){a=5;break a}HEAP[m+8]=f;m+=12;HEAP[m]=HEAP[HEAP[HEAP[b]+904]+4*o];HEAP[m+4]=HEAP[HEAP[HEAP[b]+904]+4*(o+1)];HEAP[m+8]=HEAP[m];if(HEAP[m]==0){a=5;break a}if(HEAP[m+4]==HEAP[m]){a=5;break a}HEAP[HEAP[b]+676]=m;f=HEAP[m];o=HEAP[m+4]}else if(a==249){o=reSign(HEAP[j],32)>>reSign(16,32);c=o=HEAP[HEAP[b]+900]+o;if(unSign(HEAP[HEAP[b]+892],32)<=unSign(c,32)){a=5;break a}if(reSign(m-(HEAP[b]+280),32)>reSign(383,32)){a=5;break a}HEAP[m+8]=f;m+=12;HEAP[m]=HEAP[HEAP[HEAP[b]+908]+4*o];
HEAP[m+4]=HEAP[HEAP[HEAP[b]+908]+4*(o+1)];HEAP[m+8]=HEAP[m];if(HEAP[m]==0){a=5;break a}if(HEAP[m+4]==HEAP[m]){a=5;break a}HEAP[HEAP[b]+676]=m;f=HEAP[m];o=HEAP[m+4]}else if(a==254){if(HEAP[HEAP[b]+676]<=HEAP[b]+280){a=5;break a}HEAP[HEAP[b]+676]+=-12;m=HEAP[HEAP[b]+676];f=HEAP[m+8];o=HEAP[m+4]}else if(a==291){n=HEAP[b];p=HEAP[HEAP[b]+748];p=(reSign(HEAP[j+4],32)>>reSign(16,32))+p;HEAP[n+744]=p;HEAP[HEAP[b]+32]=HEAP[j];HEAP[HEAP[b]+32+4]=0;n=HEAP[j]+HEAP[HEAP[b]+24];p=HEAP[HEAP[b]+28];j=q}else if(a==
292)j=q;else if(a==293){c=-2-(reSign(HEAP[j+-8],32)>>reSign(16,32));j+=4*c;if(j<q){a=94;break a}}else if(a==294)j+=4;else if(a==296){n=HEAP[b];p=HEAP[HEAP[b]+748];p=(reSign(HEAP[j+8],32)>>reSign(16,32))+p;HEAP[n+744]=p;HEAP[HEAP[b]+32]=HEAP[j];HEAP[HEAP[b]+32+4]=HEAP[j+4];n=HEAP[j]+HEAP[HEAP[b]+24];p=HEAP[j+4]+HEAP[HEAP[b]+28];j=q}else if(a==297){n=HEAP[j]+HEAP[HEAP[b]+24];p=HEAP[j+4]+HEAP[HEAP[b]+28];j=q}while(0);HEAP[HEAP[b]+276]=j;if(reSign(HEAP[HEAP[b]+276]-q,32)>reSign(191,32)){a=16;break a}else a=
3}}a:do if(a==5){a=197;break a}else if(a==16){k=130;a=195;break a}else if(a==90){a=118;break a}else if(a==94){k=129;a=195;break a}else if(a==298){k=7;a=195;break a}else if(a==270){if(reSign(t,32)>reSign(3,32)){k=HEAP[HEAP[b]+744];e=reSign(HEAP[j+-4],32)>>reSign(16,32);h=reSign(HEAP[j+-8],32)>>reSign(16,32);d=_cff_operator_seac(HEAP[b],0,HEAP[j+-16],HEAP[j+-12],h,e);HEAP[HEAP[b]+744]=k}else{_cff_builder_close_contour(e);if(s!=0){h=HEAP[s+8];i=reSign(HEAP[HEAP[e+20]+2],16);if(FUNCTION_TABLE[h](HEAP[s],
i)!=0){a=197;break a}FUNCTION_TABLE[HEAP[s+24]](HEAP[s],HEAP[e+20],HEAP[e+72],HEAP[HEAP[b]+920])}_FT_GlyphLoader_Add(HEAP[e+12])}k=d;a=195;break a}else if(a==295){k=reSign(HEAP[j+16],32)>>reSign(16,32);h=reSign(HEAP[j+12],32)>>reSign(16,32);d=_cff_operator_seac(HEAP[b],HEAP[j],HEAP[j+4],HEAP[j+8],h,k);_FT_GlyphLoader_Add(HEAP[e+12]);k=d;a=195;break a}else if(a==117){a=118;break a}while(0);if(a==197)k=3;else if(a==118)k=d;k=k;STACKTOP=b;return k}
_cff_decoder_parse_charstrings.__index__=Runtime.getFunctionIndex(_cff_decoder_parse_charstrings,"_cff_decoder_parse_charstrings");function _cff_cmap_encoding_init(e){HEAP[e+16]=HEAP[HEAP[e]+692]+116+524;return 0}_cff_cmap_encoding_init.__index__=Runtime.getFunctionIndex(_cff_cmap_encoding_init,"_cff_cmap_encoding_init");function _cff_cmap_encoding_done(e){HEAP[e+16]=0}_cff_cmap_encoding_done.__index__=Runtime.getFunctionIndex(_cff_cmap_encoding_done,"_cff_cmap_encoding_done");
function _cff_cmap_encoding_char_index(e,g){var d;d=0;if(unSign(g,32)<=unSign(255,32))d=unSign(HEAP[HEAP[e+16]+2*g],16);return d}_cff_cmap_encoding_char_index.__index__=Runtime.getFunctionIndex(_cff_cmap_encoding_char_index,"_cff_cmap_encoding_char_index");
function _cff_cmap_encoding_char_next(e,g){var d,b=null,a,c;a=0;c=HEAP[g];HEAP[g]=0;if(unSign(c,32)<=unSign(254,32)){b=c=c+1;var f=e+16,h=b,i=a,k=h+1;for(b=0;;){d=b==5?o:0;var j=b==5?0:i,l=h+d;o=k+d;if(unSign(b==5?o:c,32)>unSign(255,32)){d=2;break}var m=unSign(HEAP[HEAP[f]+2*l],16);if(m!=0){d=4;break}var o=d+1;b=5;d=1}if(d==2)a=j;else if(d==4){a=m;b=l;HEAP[g]=b}}return a}_cff_cmap_encoding_char_next.__index__=Runtime.getFunctionIndex(_cff_cmap_encoding_char_next,"_cff_cmap_encoding_char_next");
function _cff_sid_to_glyph_name(e,g){var d;d=HEAP[e+692];var b=unSign(HEAP[HEAP[d+1152+8]+2*g],16);return _cff_index_get_sid_string(d,b)}_cff_sid_to_glyph_name.__index__=Runtime.getFunctionIndex(_cff_sid_to_glyph_name,"_cff_sid_to_glyph_name");function _cff_cmap_unicode_init(e){var g,d,b,a,c;g=HEAP[e];d=HEAP[g+100];b=HEAP[g+692];a=b+1152;c=HEAP[b+2056];return HEAP[a+8]==0?163:FUNCTION_TABLE[HEAP[c+4]](d,e,HEAP[b+12],_cff_sid_to_glyph_name.__index__,0,g)}
_cff_cmap_unicode_init.__index__=Runtime.getFunctionIndex(_cff_cmap_unicode_init,"_cff_cmap_unicode_init");function _cff_cmap_unicode_done(e){var g,d=HEAP[e+20];g=HEAP[HEAP[e]+100];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+20]=0;HEAP[e+16]=0}_cff_cmap_unicode_done.__index__=Runtime.getFunctionIndex(_cff_cmap_unicode_done,"_cff_cmap_unicode_done");function _cff_cmap_unicode_char_index(e,g){return FUNCTION_TABLE[HEAP[HEAP[HEAP[HEAP[e]+692]+2056]+8]](e,g)}
_cff_cmap_unicode_char_index.__index__=Runtime.getFunctionIndex(_cff_cmap_unicode_char_index,"_cff_cmap_unicode_char_index");function _cff_cmap_unicode_char_next(e,g){return FUNCTION_TABLE[HEAP[HEAP[HEAP[HEAP[e]+692]+2056]+12]](e,g)}_cff_cmap_unicode_char_next.__index__=Runtime.getFunctionIndex(_cff_cmap_unicode_char_next,"_cff_cmap_unicode_char_next");
function _parse_font_matrix160(e,g){var d=STACKTOP;STACKTOP+=24;Runtime.memset(d,0,24);var b,a,c;if(reSign(HEAP[g+96],32)>=reSign(0,32)){a=HEAP[e+140+164]+252*HEAP[g+96];b=a+216;a=a+232;FUNCTION_TABLE[HEAP[g+20+32]](g,6,d,3);c=HEAP[d+12];var f=0-c;c=reSign(c,32)>=reSign(0,32)?c:f;f=_FT_DivFix(c,1E3);f=_FT_DivFix(65536,f)&65535;HEAP[e+68]=f;if(c!=65536){f=_FT_DivFix(HEAP[d],c);HEAP[d]=f;f=_FT_DivFix(HEAP[d+4],c);HEAP[d+4]=f;f=_FT_DivFix(HEAP[d+8],c);HEAP[d+8]=f;f=_FT_DivFix(HEAP[d+16],c);HEAP[d+16]=
f;c=_FT_DivFix(HEAP[d+20],c);HEAP[d+20]=c;HEAP[d+12]=65536}HEAP[b]=HEAP[d];HEAP[b+8]=HEAP[d+4];HEAP[b+4]=HEAP[d+8];HEAP[b+12]=HEAP[d+12];b=reSign(HEAP[d+16],32)>>reSign(16,32);HEAP[a]=b;b=reSign(HEAP[d+20],32)>>reSign(16,32);HEAP[a+4]=b}STACKTOP=d;return 0}_parse_font_matrix160.__index__=Runtime.getFunctionIndex(_parse_font_matrix160,"_parse_font_matrix160");
function _parse_fd_array(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b=null,a,c,f;a=e+140;c=HEAP[e+100];HEAP[d]=0;f=FUNCTION_TABLE[HEAP[g+20+16]](g);var h=HEAP[a+164]==0;a:do if(h){var i=_ft_mem_realloc(c,252,0,f,0,d);HEAP[a+164]=i;if(HEAP[d]!=0)break a;HEAP[a+160]=f;if(!(reSign(HEAP[a+160],32)>reSign(0,32)))break a;i=a+164;var k=a+160;for(b=2;;){j=b==2?0:j;b=1+j;HEAP[HEAP[i]+252*(0+j)+4]=4;b=reSign(HEAP[k],32)>reSign(b,32);var j=j+1;if(b)b=3;else break}}while(0);a=HEAP[d];STACKTOP=
d;return a}_parse_fd_array.__index__=Runtime.getFunctionIndex(_parse_fd_array,"_parse_fd_array");function _parse_expansion_factor(e,g){var d;if(reSign(HEAP[g+96],32)>=reSign(0,32)){d=HEAP[e+140+164]+252*HEAP[g+96];var b=FUNCTION_TABLE[HEAP[g+20+20]](g,0);HEAP[d+208]=b;HEAP[d+180]=HEAP[d+208]}return 0}_parse_expansion_factor.__index__=Runtime.getFunctionIndex(_parse_expansion_factor,"_parse_expansion_factor");function _cid_slot_done(e){HEAP[HEAP[e+156]+36]=0}
_cid_slot_done.__index__=Runtime.getFunctionIndex(_cid_slot_done,"_cid_slot_done");function _cid_slot_init(e){var g,d;g=HEAP[HEAP[e+4]+320];var b=g!=0;a:do if(b){d=_FT_Get_Module(HEAP[HEAP[HEAP[e+4]+96]+4],__str59);if(d==0)break a;d=FUNCTION_TABLE[HEAP[g+4]](d);HEAP[HEAP[e+156]+36]=d}while(0);return 0}_cid_slot_init.__index__=Runtime.getFunctionIndex(_cid_slot_init,"_cid_slot_init");
function _cid_size_get_globals_funcs(e){var g,d,b;d=HEAP[HEAP[e]+320];b=_FT_Get_Module(HEAP[HEAP[HEAP[e]+96]+4],__str59);var a=b==0;a:do if(a)e=0;else{if(d==0){e=0;break a}if(HEAP[d]==0){e=0;break a}g=FUNCTION_TABLE[HEAP[d]](b);e=3;break a}while(0);if(e==0)g=0;return g}_cid_size_get_globals_funcs.__index__=Runtime.getFunctionIndex(_cid_size_get_globals_funcs,"_cid_size_get_globals_funcs");
function _cid_size_done(e){var g;if(HEAP[e+40]!=0){g=_cid_size_get_globals_funcs(e);g!=0&&FUNCTION_TABLE[HEAP[g+8]](HEAP[e+40]);HEAP[e+40]=0}}_cid_size_done.__index__=Runtime.getFunctionIndex(_cid_size_done,"_cid_size_done");
function _cid_size_init(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d,b;d=0;b=_cid_size_get_globals_funcs(e);var a=b!=0;a:do if(a){d=HEAP[e];d=d=HEAP[d+140+164]+252*HEAP[d+4];d=FUNCTION_TABLE[HEAP[b]](HEAP[HEAP[e]+100],d,g);if(d!=0)break a;HEAP[e+40]=HEAP[g]}while(0);e=d;STACKTOP=g;return e}_cid_size_init.__index__=Runtime.getFunctionIndex(_cid_size_init,"_cid_size_init");
function _cid_size_request(e,g){var d;_FT_Request_Metrics(HEAP[e],g);d=_cid_size_get_globals_funcs(e);d!=0&&FUNCTION_TABLE[HEAP[d+4]](HEAP[e+40],HEAP[e+12+4],HEAP[e+12+8],0,0);return 0}_cid_size_request.__index__=Runtime.getFunctionIndex(_cid_size_request,"_cid_size_request");
function _cid_face_done(e){var g=null,d,b,a;if(e!=0){b=e+140;a=b+24;d=HEAP[e+100];if(HEAP[e+316]!=0){var c=reSign(HEAP[b+160],32)>reSign(0,32),f=HEAP[e+316];if(c){c=b+160;var h=e+316;for(g=0;;){l=g==0?0:l;j=g==0?f:j;g=0+l;var i=1+l;if(HEAP[j+8*g+4]!=0){var k=HEAP[HEAP[j+8*g+4]];k!=0&&FUNCTION_TABLE[HEAP[d+8]](d,k);HEAP[HEAP[j+8*g+4]]=0;k=HEAP[j+8*g+4];k!=0&&FUNCTION_TABLE[HEAP[d+8]](d,k);HEAP[j+8*g+4]=0}g=reSign(HEAP[c],32)>reSign(i,32);var j=HEAP[h],l=l+1;if(g)g=6;else break}g=7}else g=24;f=g==7?
j:f;f!=0&&FUNCTION_TABLE[HEAP[d+8]](d,f);HEAP[e+316]=0}f=HEAP[a];f!=0&&FUNCTION_TABLE[HEAP[d+8]](d,f);HEAP[a]=0;f=HEAP[a+4];f!=0&&FUNCTION_TABLE[HEAP[d+8]](d,f);HEAP[a+4]=0;f=HEAP[a+8];f!=0&&FUNCTION_TABLE[HEAP[d+8]](d,f);HEAP[a+8]=0;f=HEAP[a+12];f!=0&&FUNCTION_TABLE[HEAP[d+8]](d,f);HEAP[a+12]=0;f=HEAP[a+16];f!=0&&FUNCTION_TABLE[HEAP[d+8]](d,f);HEAP[a+16]=0;a=HEAP[b+164];a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,a);HEAP[b+164]=0;HEAP[b+160]=0;a=HEAP[b];a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,a);HEAP[b]=0;a=HEAP[b+
12];a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,a);HEAP[b+12]=0;a=HEAP[b+16];a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,a);HEAP[b+16]=0;HEAP[e+20]=0;HEAP[e+24]=0;b=HEAP[e+324];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[e+324]=0;b=HEAP[e+328];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[e+328]=0}}_cid_face_done.__index__=Runtime.getFunctionIndex(_cid_face_done,"_cid_face_done");
function _cid_face_init(e,g,d){var b=STACKTOP;STACKTOP+=642;Runtime.memset(b,0,642);var a,c=null,f,h,i,k,j,l,m,o,n,p,r,q,s=b+4,u,t=b+8,v,w=b+264,x,y,A,z,C,B,D=b+268,E=b+534,F=b+638;HEAP[g]=1;k=HEAP[g+136];if(k==0){k=HEAP[HEAP[g+96]+4];c=__str61;k=_FT_Get_Module(k,c);k=k=k!=0?HEAP[HEAP[k]+20]:0;HEAP[g+136]=k}if(HEAP[g+320]==0){k=HEAP[HEAP[g+96]+4];c=__str59;k=_FT_Get_Module(k,c);k=k!=0?HEAP[HEAP[k]+20]:0;HEAP[g+320]=k}k=e=_FT_Stream_Seek(e,0);e=e!=0;a:do if(!e){k=d;i=g;h=k;f=HEAP[i+100];k=E;_llvm_memset_p0i8_i32(k,
0,104,1,0);j=E;k=HEAP[i+136];c=HEAP[i+100];r=HEAP[i+104];n=j;z=r;c=c;k=k;_llvm_memset_p0i8_i32(n,0,100,1,0);FUNCTION_TABLE[HEAP[HEAP[k+4]]](n,0,0,c);k=HEAP[n+72]=z;u=k=k=HEAP[k+8];k=r=_FT_Stream_EnterFrame(z,31);p=k!=0;b:do if(p){c=215;a=8}else{if(_strncmp(HEAP[z+32],__str93,31)!=0)r=2;A=z;if(HEAP[A+20]!=0){c=HEAP[A+28];p=HEAP[A];c=c;p=p;p!=0&&FUNCTION_TABLE[HEAP[c+8]](c,p);HEAP[A]=0}HEAP[A+32]=0;HEAP[A+36]=0;A=r;if(A!=0){c=7;a=8;break b}p=r=D;v=D+10;l=z+4;m=z;y=u;x=z;u=u;var G=z;var H=c=z,J=B,L=
c!=0,N=z+8;z=z+8;var I=m+8,P=0-D+7,K=G+32;o=G+32;var O=G+36,M=c+20,Q=c+28,R=0-D+10;c=9;c:for(;;){var T=c==47?ea:J,V=HEAP[N];c=10;d:for(;;){a=c==26?aa:0;var U=c==26?256:266,S=c==26?v:r,X=V+a*256,Y=HEAP[l]-HEAP[z];if(Y==0){a=12;break c}U=reSign(Y,32)<=reSign(U,32)?Y:U;var W=_FT_Stream_ReadAt(m,HEAP[I],S,U);if(W!=0){a=14;break c}if(reSign(U,32)<=reSign(255,32))HEAP[S+U]=0;S=S+U+-10;for(c=17;;){U=c==24?ba:0;Y=D+(U+1);var da=D+U;if(!(da<S))break;if(HEAP[da]==83)if(_strncmp(da,__str194,9)==0){a=20;break d}if(HEAP[Y]==
115)if(_strncmp(da,__str295,6)==0){a=22;break d}var ba=U+1;c=24}_llvm_memmove_p0i8_p0i8_i32(p,da,10,1,0);var aa=a+1;c=26;a=11}if(a==22){var ca=P+X+da;c=22}else if(a==20){var $=R+X+da;c=20}a=c==22?ca:$;V=a-y;var la=_FT_Stream_Seek(x,u);if(la!=0){c=27;a=28;break c}else c=27;S=n+76;var ga=_FT_Stream_EnterFrame(G,V);if(ga!=0){a=31;break c}HEAP[S]=HEAP[K];HEAP[o]=0;HEAP[O]=0;HEAP[n+84]=a;HEAP[n+80]=V;HEAP[n+4]=HEAP[n+76];HEAP[n]=HEAP[n+76];HEAP[n+8]=HEAP[n]+V;HEAP[n+96]=-1;C=HEAP[n];FUNCTION_TABLE[HEAP[n+
20+12]](n);FUNCTION_TABLE[HEAP[n+20+8]](n);V=HEAP[n];FUNCTION_TABLE[HEAP[n+20+12]](n);FUNCTION_TABLE[HEAP[n+20+8]](n);S=HEAP[n+8];U=HEAP[n];c=30;d:for(;;){var ea=c==42?Z:V,Z=c==42?ia:U,ha=n;if(!(Z<S))break d;if(HEAP[ha+12]!=0){a=33;break c}if(HEAP[Z]==83)if(_strncmp(Z,__str194,9)==0){a=37;break c}if(HEAP[Z+1]==115)if(_strncmp(Z,__str295,6)==0){a=40;break c}FUNCTION_TABLE[HEAP[n+20+12]](n);FUNCTION_TABLE[HEAP[n+20+8]](n);C=ea;var ia=HEAP[n];c=42}var ja=ha+76;d:do if(L){if(HEAP[M]==0)break d;c=HEAP[Q];
V=HEAP[ja];V!=0&&FUNCTION_TABLE[HEAP[c+8]](c,V);HEAP[ja]=0}while(0);HEAP[ja]=0;ja=_FT_Stream_Seek(H,a);if(ja==0){c=47;a=10}else{c=47;a=28;break c}}if(a==12){B=T;c=12;a=8;break b}else if(a==14){B=T;c=14;a=8;break b}else if(a==28){var fa=c==27?la:ja;B=c==47?ea:T;c=28;a=8;break b}else if(a==31){B=T;c=31;a=8;break b}else if(a==33){B=ea;var ka=HEAP[n+12];c=33}else if(a==40){B=ea;c=40;a=8;break b}else if(a==37){r=ga;B=ea;if(_strncmp(C,__str396,5)==0){var na=_atol(B);HEAP[n+88]=na}na=r;c=39}n=c==33?ka:na;
HEAP[F]=n;if(n!=0){a=52;break b}n=HEAP[j+80];r=HEAP[j+76];c=i;x=E;r=r;p=n;n=x;HEAP[n]=r;HEAP[n+8]=r+p;HEAP[n+12]=0;u=r;r=y=u+p;p=y+-1+-17;v=c+140+160;y=m=l=y;c=c;K=x;x=u;N=K;Q=c+140;u=c;G=N;H=N+12;J=N+96;L=Q+164;N=N+96;z=K+20+48;I=K;P=K+20+44;K=K;o=Q;O=c+312;M=Q+24;Q=Q+56;c=53;c:for(;;){R=c==70?za:x;HEAP[n]=R;FUNCTION_TABLE[HEAP[n+20+8]](n);if(HEAP[n]>=r)c=54;else{var sa=HEAP[n]+-17;c=55}V=c==55?sa:p;S=R<V;d:do if(S){c=R+1;U=(V>c?V:c)+(0-R);c=57;for(;;){wa=c==57?0:wa;a=R+wa;c=HEAP[a]==37;f:do if(c){if(_strncmp(a,
__str54147,17)!=0)break f;if(!(reSign(HEAP[v],32)>reSign(0,32)))break f;HEAP[n+96]+=1}while(0);var wa=wa+1;if(wa!=U){c=60;a=58}else{c=60;a=63;break d}}}while(0);R=HEAP[n];if(R>=l){a=64;break c}FUNCTION_TABLE[HEAP[n+20+12]](n);if(HEAP[n]>=m){a=64;break c}if(HEAP[n+12]!=0){a=64;break c}V=HEAP[R]==47&R+2<y;d:do if(V){c=R+1;S=HEAP[n]-c;U=reSign(S,32)>reSign(0,32);Y=reSign(S,32)<=reSign(21,32);if(!(U&Y))break d;U=c;c=69;e:for(;;){a=c==76?qa:0;var Aa=_cid_field_records+a*36;Y=HEAP[Aa];if(Y==0){a=72;break e}var Da=
HEAP[U]==HEAP[Y];f:do if(Da){if(_strlen(Y)==S)c=74;else break f;for(;;){c=c==78?ya:0;var pa=R+(c+2),ta=c+1,ma=Y+ta;if(!(reSign(ta,32)<reSign(S,32)))break;if(HEAP[pa]!=HEAP[ma])break;var ya=c+1;c=78}if(reSign(ta,32)>=reSign(S,32)){a=80;break e}}while(0);var qa=a+1;c=76;a=71}if(a!=72)if(a==80){S=HEAP[Aa+8]==10;e:do if(S){FUNCTION_TABLE[HEAP[Aa+12]](u,G);var ua=HEAP[H];c=82}else{a=HEAP[Aa+4];if(a==0){c=213;a=214}else if(a==2){c=213;a=86}else if(a==3){c=213;a=84}else if(a==5){c=213;a=87}else{c=213;a=
88}if(a==88){if(reSign(HEAP[J],32)<reSign(0,32)){c=88;a=89;break e}c=HEAP[L]+252*HEAP[N];if(HEAP[Aa+4]==4){var Ba=c;c=91}else{var Na=c;c=92}}else if(a==86)c=86;else if(a==84)c=84;else if(a==87)c=87;HEAP[w]=c==92?Na:c==91?Ba:c==87?Q:c==86?O:c==84?M:o;c=HEAP[Aa+8]==8;f:do if(!c){if(HEAP[Aa+8]==9){a=93;break f}var Ea=FUNCTION_TABLE[HEAP[P]](K,Aa,w,0,0);c=94;a=89;break e}while(0);var ra=FUNCTION_TABLE[HEAP[z]](I,Aa,w,0,0);c=93}while(0);HEAP[n+12]=c==94?Ea:c==93?ra:c==82?ua:160;if(HEAP[n+12]!=0){c=89;
a=95;break c}}}while(0);var za=HEAP[n];c=70;a=54}if(a==64){var Ha=HEAP[n+12];c=64}else if(a==95){var Ca=HEAP[n+12];c=95}n=c==95?Ca:Ha;HEAP[F]=n;if(n!=0){a=52;break b}if(reSign(h,32)<reSign(0,32)){a=52;break b}h=_ft_mem_alloc(f,40,F);HEAP[i+328]=h;if(HEAP[F]!=0){a=52;break b}h=HEAP[j+88]!=0;c:do if(h){f=_ft_mem_alloc(f,HEAP[j+88],F);HEAP[i+324]=f;if(HEAP[F]!=0){a=52;break b}c=HEAP[j+84];h=HEAP[j+88];n=i;f=HEAP[i+324];h=h;c=c;n=n;u=HEAP[n+104];n=_FT_Stream_Seek(u,c);n=n!=0;d:do if(n)c=101;else{l=f;
f=l+h;c=v=t;f=f;h=u+4;n=u;p=r=t;l=l;m=c;y=u+8;x=n+8;u=u+8;c=102;e:for(;;){J=c==102?0:0;G=c==102?1:Ra;L=c==102?m:Ja;H=c==102?l:Ka;N=H<f;c=103;f:for(;;){a=c==117?Ja:L;if(!N){c=124;a=130;break e}if(v>=a){c=132;z=HEAP[y];v=HEAP[h]-z;if(v==0){a=104;break e}var va=unSign(v,32)<=unSign(256,32)?v:256;va=_FT_Stream_ReadAt(n,HEAP[x],r,va);if(va!=0){a=107;break e}v=p;var Pa=v+HEAP[u]+(0-z);c=108}else c=132;var Ja=c==108?Pa:a,La=unSign(HEAP[v],8)-48;a=unSign(La,32)<=unSign(9,32);La=HEAP[v];if(a){a=110;break f}if(!(unSign(La,
8)<=unSign(96,8)))if(!(unSign(HEAP[v],8)>unSign(102,8))){a=114;break f}if(!(unSign(HEAP[v],8)<=unSign(64,8)))if(!(unSign(HEAP[v],8)>unSign(70,8))){a=116;break f}a=HEAP[v]==32;g:do if(!a){if(HEAP[v]==9)break g;if(HEAP[v]==13)break g;if(HEAP[v]==10)break g;if(HEAP[v]==12)break g;if(HEAP[v]!=0){a=123;break f}}while(0);v+=1;c=117;a=124}if(a==110){var xa=La-48;c=110}else if(a==123)if(HEAP[v]==62)c=123;else{c=123;a=125;break e}else if(a==116){var oa=HEAP[v]-55;c=116}else if(a==114){var Fa=HEAP[v]-97;c=
114}Ka=c==116?oa:c==114?Fa:c==110?xa:0;a=c==116?J:c==114?J:c==110?J:1;if(G!=0){HEAP[H]=Ka<<4;c=126}else{HEAP[H]+=Ka;var Ma=H+1;c=128}var Ka=c==128?Ma:H,Ra=1-G;if(a!=0){c=129;a=130;break e}v+=1;c=131;a=103}if(a!=130)if(a==104){c=104;break d}else if(a==107){n=va;if(n!=0){a=52;break b}}else if(a==125){c=125;break d}f=HEAP[j+88];j=HEAP[i+324];a=HEAP[i+328];j=j;f=f;HEAP[a]=j;HEAP[a+4]=f;HEAP[a+8]=0;HEAP[a+32]=0;HEAP[a+20]=0;HEAP[a+24]=0;HEAP[i+140+168]=0;a=134;break c}while(0);a=52;break b}else{_llvm_memcpy_p0i8_p0i8_i32(HEAP[i+
328],HEAP[i+104],40,4,0);HEAP[i+140+168]=HEAP[E+84]}while(0);j=i;f=j+140;i=HEAP[j+100];h=HEAP[j+328];p=n=0;r=HEAP[j+136];v=_ft_mem_realloc(i,8,0,HEAP[f+160],0,b);HEAP[j+316]=v;v=HEAP[b]!=0;c:do if(!v){o=HEAP[j+316];c=0;l=f+160;m=f+164;y=i;x=f+168;G=u=h;H=h+32;Y=h;L=J=i;N=f+168;I=z=h;P=r+16;K=p;o=o;O=c;M=n;Q=Y+20;R=Y+28;S=V=Y;U=Y+32;Y=Y+36;Da=I+8;c=136;d:for(;;){pa=c==163?jb:0;var Qa=c==163?eb:M,Va=c==163?Ga:K;a=O+pa;ma=o+8*pa;var Ta=o+8*pa+4;if(!(reSign(HEAP[l],32)>reSign(a,32))){a=168;break d}var Ua=
HEAP[m],ab=HEAP[Ua+252*a+4],Sa=HEAP[Ua+252*a+240];if(unSign(Sa+1,32)>unSign(Qa,32)){var $a=Sa+4&-4,Wa=_ft_mem_realloc(y,4,Qa,$a,Va,b);if(HEAP[b]!=0){c=138;a=139;break d}else c=138}else c=167;var eb=c==167?Qa:$a,Ga=c==167?Va:Wa;c=_FT_Stream_Seek(u,HEAP[Ua+252*a+244]+HEAP[x]);HEAP[b]=c;if(c!=0){c=141;a=139;break d}c=_FT_Stream_EnterFrame(G,HEAP[Ua+252*a+248]*(Sa+1));HEAP[b]=c;if(HEAP[b]!=0){c=142;a=139;break d}HEAP[s]=HEAP[H];q=0;if(unSign(q,32)<=unSign(Sa,32)){a=Ua+252*a+248;e:for(;;){c=HEAP[a];var ob=
unSign(c&255,8)&255;Ua=HEAP[s];if(ob!=0){var Oa=unSign((c&255)+-1,8)+1;for(c=145;;){bb=c==145?0:bb;Xa=(c==145?0:Xa)<<8;var Xa=unSign(HEAP[Ua+bb],8)|Xa,bb=bb+1;if(bb!=Oa)c=146;else break}Oa=unSign(ob+-1,8)+1;Oa=Ua+Oa;c=147}else c=144;ob=c==144?0:Xa;HEAP[s]=c==144?Ua:Oa;HEAP[Ga+4*q]=ob;q+=1;if(!(unSign(q,32)<=unSign(Sa,32)))break e}}if(HEAP[Q]!=0){a=HEAP[R];c=HEAP[V];c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[S]=0}HEAP[U]=0;HEAP[Y]=0;a=HEAP[Ga+4*Sa]-HEAP[Ga];c=_ft_mem_realloc(J,4,0,Sa+1,0,b);HEAP[Ta]=
c;if(HEAP[b]!=0){c=154;a=139;break d}c=HEAP[Ta];q=_ft_mem_alloc(L,a,b);HEAP[c]=q;if(HEAP[b]!=0){c=155;a=139;break d}c=_FT_Stream_Seek(z,HEAP[Ga]+HEAP[N]);HEAP[b]=c;if(HEAP[b]!=0){c=156;a=139;break d}a=_FT_Stream_ReadAt(I,HEAP[Da],HEAP[HEAP[Ta]],a);HEAP[b]=a;if(HEAP[b]!=0){c=157;a=139;break d}q=1;a=unSign(q,32)<=unSign(Sa,32)?159:160;e:for(;;)if(a==159){HEAP[HEAP[Ta]+4*q]=HEAP[HEAP[Ta]+4*(q-1)]+(HEAP[Ga+4*q]-HEAP[Ga+4*(q-1)]);q+=1;if(unSign(q,32)<=unSign(Sa,32)){a=159;continue e}a=160}else if(a==160){a=
reSign(ab,32)>=reSign(0,32)?162:163;break e}e:do if(a==162){q=0;if(!(unSign(q,32)<unSign(Sa,32)))break e;for(;;){FUNCTION_TABLE[HEAP[P]](HEAP[HEAP[Ta]+4*q],HEAP[Ga+4*(q+1)]-HEAP[Ga+4*q],4330);q+=1;if(unSign(q,32)<unSign(Sa,32))a=164;else{a=165;break}}}while(0);HEAP[ma]=Sa;var jb=pa+1;c=163;a=137}if(a==168){n=Qa;p=Va}else if(a==139){p=c==157?Ga:c==156?Ga:c==155?Ga:c==154?Ga:c==142?Ga:c==141?Ga:Wa;n=c==157?eb:c==156?eb:c==155?eb:c==154?eb:c==142?eb:c==141?eb:Qa;p=p;if(HEAP[j+316]==0)break c;l=c=0;m=
reSign(HEAP[f+160],32)>reSign(l,32);l=HEAP[j+316];if(m){m=j+316;y=i;x=j+316;u=j+316;G=i;H=j+316;J=f+160;L=j+316;N=c;z=y+8;I=G+8;P=N+1;for(c=173;;){fb=c==173?0:fb;a=N+fb;K=P+fb;if(HEAP[(c==173?l:Za)+8*a+4]!=0){Za=HEAP[HEAP[HEAP[m]+8*a+4]];Za!=0&&FUNCTION_TABLE[HEAP[z]](y,Za);HEAP[HEAP[HEAP[x]+8*a+4]]=0}Za=HEAP[HEAP[u]+8*a+4];Za!=0&&FUNCTION_TABLE[HEAP[I]](G,Za);HEAP[HEAP[H]+8*a+4]=0;a=reSign(HEAP[J],32)>reSign(K,32);var Za=HEAP[L],fb=fb+1;if(a){c=179;a=174}else{a=180;break}}c=180}else c=171;y=c==180?
Za:l;l=i;m=y;y!=0&&FUNCTION_TABLE[HEAP[l+8]](l,m);HEAP[j+316]=0}}while(0);a=p;i=i;j=a;a!=0&&FUNCTION_TABLE[HEAP[i+8]](i,j);a=a=HEAP[b];HEAP[F]=a;a=52;break b}while(0);if(a==8)HEAP[F]=c==215?k:c==7?A:c==12?2:c==31?ga:c==40?2:c==14?W:fa;k=k=k=E;if(HEAP[k+76]!=0){c=HEAP[k+72];i=k+76;c=c;i=i;j=c!=0;b:do if(j){if(HEAP[c+20]==0){a=184;break b}f=HEAP[c+28];h=HEAP[i];f=f;h=h;h!=0&&FUNCTION_TABLE[HEAP[f+8]](f,h);HEAP[i]=0}while(0);HEAP[i]=0}FUNCTION_TABLE[HEAP[k+20+4]](k);k=c=HEAP[F];if(c!=0)break a;if(reSign(d,
32)<reSign(0,32))break a;if(d!=0)k=6;else{j=g+140;i=j+24;HEAP[g+16]=HEAP[j+156];HEAP[g+36]=0;HEAP[g+4]=d;HEAP[g+8]=2065;if(HEAP[i+24]!=0)HEAP[g+8]|=4;HEAP[g+20]=HEAP[i+12];HEAP[g+24]=__str62;f=HEAP[g+20]!=0;b:do if(f){h=HEAP[i+8];c=HEAP[g+20];if(h==0){a=194;break b}h=h;n=c;c=193;c:for(;;){var Ya=c==193?n:c==196?cb:c==197?Ya:gb,Ia=c==193?h:c==196?pb:c==197?hb:Ia;if(HEAP[Ia]==0){a=205;break c}if(HEAP[Ia]==HEAP[Ya]){var cb=Ya+1,pb=Ia+1;c=196}else{a=HEAP[Ia]==32;d:do if(!a){if(HEAP[Ia]==45)break d;if(HEAP[Ya]!=
32)if(HEAP[Ya]!=45){a=200;break c}var gb=Ya+1;c=201;a=195;continue c}while(0);var hb=Ia+1;c=197}a=195}if(a!=205)if(a==200){c=Ya;h=Ia;if(HEAP[c]!=0){a=194;break b}HEAP[g+24]=h}}else{if(HEAP[j]==0){a=194;break b}HEAP[g+20]=HEAP[j]}while(0);HEAP[g+12]=0;if(HEAP[i+20]!=0)HEAP[g+12]|=1;c=HEAP[i+16]!=0;b:do if(c){if(_strcmp(HEAP[i+16],__str63)!=0)if(_strcmp(HEAP[i+16],__str64)!=0){a=209;break b}HEAP[g+12]|=2}while(0);HEAP[g+28]=0;HEAP[g+32]=0;c=reSign(HEAP[j+56],32)>>reSign(16,32);HEAP[g+52]=c;c=reSign(HEAP[j+
56+4],32)>>reSign(16,32);HEAP[g+52+4]=c;c=reSign(HEAP[j+56+8]+65535,32)>>reSign(16,32);HEAP[g+52+8]=c;c=reSign(HEAP[j+56+12]+65535,32)>>reSign(16,32);HEAP[g+52+12]=c;if(HEAP[g+68]==0)HEAP[g+68]=1E3;HEAP[g+70]=HEAP[g+52+12]&65535;HEAP[g+72]=HEAP[g+52+4]&65535;c=unSign(HEAP[g+68],16)*12;c=Math.floor(reSign(c,32)/reSign(10,32))&65535;HEAP[g+74]=c;c=reSign(HEAP[g+74],16);j=reSign(HEAP[g+70],16);f=reSign(HEAP[g+72],16);j=j-f;if(reSign(c,32)<reSign(j,32))HEAP[g+74]=HEAP[g+70]-HEAP[g+72];HEAP[g+80]=HEAP[i+
26];HEAP[g+82]=HEAP[i+28]}}while(0);g=k;STACKTOP=b;return g}_cid_face_init.__index__=Runtime.getFunctionIndex(_cid_face_init,"_cid_face_init");function _cid_driver_init(){return 0}_cid_driver_init.__index__=Runtime.getFunctionIndex(_cid_driver_init,"_cid_driver_init");function _cid_driver_done(){}_cid_driver_done.__index__=Runtime.getFunctionIndex(_cid_driver_done,"_cid_driver_done");
function _cid_get_postscript_name(e){e=HEAP[e+140];var g=e!=0;a:do if(g){if(HEAP[e]!=47)break a;e+=1}while(0);return e}_cid_get_postscript_name.__index__=Runtime.getFunctionIndex(_cid_get_postscript_name,"_cid_get_postscript_name");function _cid_ps_get_font_info(e,g){_llvm_memcpy_p0i8_p0i8_i32(g,e+140+24,32,4,0);return 0}_cid_ps_get_font_info.__index__=Runtime.getFunctionIndex(_cid_ps_get_font_info,"_cid_ps_get_font_info");
function _cid_ps_get_font_extra(e,g){var d=STACKTOP;STACKTOP+=2;Runtime.memset(d,0,2);HEAP[d]=HEAP[e+312];HEAP[g]=HEAP[d];STACKTOP=d;return 0}_cid_ps_get_font_extra.__index__=Runtime.getFunctionIndex(_cid_ps_get_font_extra,"_cid_ps_get_font_extra");function _cid_get_ros(e,g,d,b){e=e+140;if(g!=0)HEAP[g]=HEAP[e+12];if(d!=0)HEAP[d]=HEAP[e+16];if(b!=0)HEAP[b]=HEAP[e+20];return 0}_cid_get_ros.__index__=Runtime.getFunctionIndex(_cid_get_ros,"_cid_get_ros");
function _cid_get_is_cid(e,g){if(g!=0)HEAP[g]=1;return 0}_cid_get_is_cid.__index__=Runtime.getFunctionIndex(_cid_get_is_cid,"_cid_get_is_cid");function _cid_get_cid_from_glyph_index(e,g,d){if(d!=0)HEAP[d]=g;return 0}_cid_get_cid_from_glyph_index.__index__=Runtime.getFunctionIndex(_cid_get_cid_from_glyph_index,"_cid_get_cid_from_glyph_index");function _cid_get_interface(e,g){return _ft_service_list_lookup(_cid_services,g)}_cid_get_interface.__index__=Runtime.getFunctionIndex(_cid_get_interface,"_cid_get_interface");
function _cid_load_glyph(e,g){var d=STACKTOP;STACKTOP+=40;Runtime.memset(d,0,40);var b;b=null;var a,c,f,h,i,k,j,l,m,o,n,p;h=d+8;var r=d+12,q,s,u;k=d+16;var t,v=d+24;n=HEAP[e+4];p=n+140;m=HEAP[n+328];l=HEAP[r]=0;q=HEAP[n+100];f=0;s=HEAP[n+136];u=HEAP[HEAP[n+128]+52];var w=u!=0;a:do{if(w){m=FUNCTION_TABLE[HEAP[HEAP[u]]](HEAP[u+4],g,k);HEAP[r]=m;if(HEAP[r]!=0){b=0;break a}HEAP[h]=HEAP[k];m=unSign(HEAP[p+148]&255,8)&255;o=h;a=m;c=HEAP[o];b=0;if(m!=0){m=b;c=c;b=a+-1;a=unSign(b,8);h=unSign(b,8)+1;for(b=
2;;){t=b==2?0:y;b=(b==2?m:x)<<8;var x=unSign(HEAP[c+t],8)|b,y=t+1;if(y!=h)b=3;else break}c=c+(a+1);b=x}HEAP[o]=c;o=o=o=b;m=HEAP[k+4]!=0;b:do if(m){f=HEAP[k+4]-HEAP[p+148];l=_ft_mem_alloc(q,f,r);if(HEAP[r]!=0)break b;_llvm_memcpy_p0i8_p0i8_i32(l,HEAP[k]+HEAP[p+148],f,1,0)}while(0);FUNCTION_TABLE[HEAP[HEAP[u]+4]](HEAP[u+4],k);b=HEAP[r]!=0?0:9}else{b=HEAP[p+152]+HEAP[p+148];k=_FT_Stream_Seek(m,HEAP[p+144]+HEAP[p+168]+b*g);HEAP[r]=k;if(HEAP[r]!=0){b=0;break a}b=_FT_Stream_EnterFrame(m,b*2);HEAP[r]=b;
if(HEAP[r]!=0){b=0;break a}HEAP[h]=HEAP[m+32];x=unSign(HEAP[p+148]&255,8)&255;o=h;b=x;k=HEAP[o];f=0;if(x!=0){f=f;k=k;b=b+-1;x=unSign(b,8);y=unSign(b,8)+1;for(b=12;;){A=b==12?0:A;b=(b==12?f:j)<<8;j=unSign(HEAP[k+A],8)|b;var A=A+1;if(A!=y)b=13;else break}k=k+(x+1);f=j}HEAP[o]=k;o=o=o=f;A=unSign(HEAP[p+152]&255,8)&255;f=h;b=A;j=HEAP[f];k=0;if(A!=0){k=k;j=j;b=b+-1;A=unSign(b,8);x=unSign(b,8)+1;for(b=16;;){i=b==16?0:i;b=(b==16?k:t)<<8;t=unSign(HEAP[j+i],8)|b;i=i+1;if(i!=x)b=17;else break}j=j+(A+1);k=t}HEAP[f]=
j;t=f=f=k;HEAP[h]+=HEAP[p+148];k=unSign(HEAP[p+152]&255,8)&255;f=h;b=k;i=HEAP[f];h=0;if(k!=0){h=h;i=i;b=b+-1;k=unSign(b,8);j=unSign(b,8)+1;for(b=20;;){a=b==20?0:a;c=(b==20?h:c)<<8;c=unSign(HEAP[i+a],8)|c;a=a+1;if(a!=j)b=21;else break}i=i+(k+1);h=c}HEAP[f]=i;f=f=h;f=f-t;c=m;if(HEAP[c+20]!=0){a=HEAP[c+28];b=HEAP[c];a=a;b=b;b!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[c]=0}HEAP[c+32]=0;HEAP[c+36]=0;c=o;if(unSign(HEAP[p+160],32)<=unSign(c,32)){HEAP[r]=9;b=0}else{if(f==0){b=0;break a}l=_ft_mem_alloc(q,f,
r);if(HEAP[r]!=0){b=0;break a}m=_FT_Stream_ReadAt(m,t+HEAP[p+168],l,f);HEAP[r]=m;b=HEAP[r]!=0?0:9}}break a}while(0);a:do if(b==9){m=HEAP[n+316]+8*o;HEAP[e+1364]=HEAP[m];HEAP[e+1368]=HEAP[m+4];HEAP[e+1372]=0;m=HEAP[p+164]+252*o;c=e+1376;a=m+216;HEAP[c]=HEAP[a];HEAP[c+4]=HEAP[a+4];HEAP[c+8]=HEAP[a+8];HEAP[c+12]=HEAP[a+12];c=m+232;HEAP[d]=HEAP[c];HEAP[d+4]=HEAP[c+4];c=e+1392;HEAP[c]=HEAP[d];HEAP[c+4]=HEAP[d+4];HEAP[e+1360]=HEAP[m+4];m=HEAP[e+1360];m=reSign(m,32)>=reSign(0,32)?m:0;reSign(HEAP[e+1360],
32)>=reSign(0,32)&&FUNCTION_TABLE[HEAP[s+16]](l,f,4330);m=FUNCTION_TABLE[HEAP[e+1476+8]](e,l+m,f-m);HEAP[r]=m;c=l;l=q;m=c;c!=0&&FUNCTION_TABLE[HEAP[l+8]](l,m);l=0;if(HEAP[r]!=0)break a;if(u==0)break a;if(HEAP[HEAP[u]+8]==0)break a;c=HEAP[e+32];m=reSign(c,32)>=reSign(0,32);c=c;m=m=m=m?c+32768&-65536:0-(32768-c&-65536);m=reSign(m,32)>>reSign(16,32);HEAP[v]=m;HEAP[v+4]=0;m=c=HEAP[e+40];c=reSign(c,32)>=reSign(0,32);m=m;m=m=m=c?m+32768&-65536:0-(32768-m&-65536);m=reSign(m,32)>>reSign(16,32);HEAP[v+8]=
m;m=c=HEAP[e+40+4];c=reSign(c,32)>=reSign(0,32);m=m;m=m=m=c?m+32768&-65536:0-(32768-m&-65536);m=reSign(m,32)>>reSign(16,32);HEAP[v+12]=m;m=FUNCTION_TABLE[HEAP[HEAP[u]+8]](HEAP[u+4],g,0,v);HEAP[r]=m;HEAP[e+32]=HEAP[v]<<16;HEAP[e+40]=HEAP[v+8]<<16;HEAP[e+40+4]=HEAP[v+12]<<16}while(0);n=HEAP[r];STACKTOP=d;return n}_cid_load_glyph.__index__=Runtime.getFunctionIndex(_cid_load_glyph,"_cid_load_glyph");
function _cid_slot_load_glyph(e,g,d,b){var a=STACKTOP;STACKTOP+=1556;Runtime.memset(a,0,1556);var c,f=null,h,i,k,j,l,m,o=a+8,n,p,r=a+1508,q=a+1524,s,u=a+1532,t=a+1548,v;b=b;n=HEAP[e+4];p=HEAP[n+136];var w=unSign(HEAP[n+16],32)<=unSign(d,32);a:do if(w)m=6;else{if((b&1024)!=0)b|=3;HEAP[e+164]=HEAP[g+12+4];HEAP[e+168]=HEAP[g+12+8];HEAP[e+108+2]=0;HEAP[e+108]=0;m=(b&1)!=0;b:do if(m)c=2;else{if((b&2)!=0){c=2;break b}l=1;c=4;break b}while(0);if(c==2)l=0;j=l&255;HEAP[e+72]=1869968492;m=HEAP[HEAP[p+12]];
s=reSign(b,32)>>reSign(16,32)&15;h=unSign(j,8);m=s=FUNCTION_TABLE[m](o,HEAP[e+4],g,e,0,0,h&255,s,_cid_load_glyph.__index__);if(s!=0)break a;m=unSign((b&1024)!=0,1);HEAP[o+69]=m;m=_cid_load_glyph(o,d);if(m!=0)break a;s=o+1376;HEAP[r]=HEAP[s];HEAP[r+4]=HEAP[s+4];HEAP[r+8]=HEAP[s+8];HEAP[r+12]=HEAP[s+12];s=o+1392;HEAP[a]=HEAP[s];HEAP[a+4]=HEAP[s+4];HEAP[q]=HEAP[a];HEAP[q+4]=HEAP[a+4];FUNCTION_TABLE[HEAP[HEAP[p+12]+4]](o);HEAP[e+108+16]&=1;HEAP[e+108+16]|=4;s=e;if((b&1024)!=0){s=HEAP[s+156];h=HEAP[o+
32];j=reSign(h,32)>=reSign(0,32);h=h;j=j=j=j?h+32768&-65536:0-(32768-h&-65536);j=reSign(j,32)>>reSign(16,32);HEAP[e+24+8]=j;j=h=HEAP[o+40];h=reSign(h,32)>=reSign(0,32);j=j;j=j=j=h?j+32768&-65536:0-(32768-j&-65536);j=reSign(j,32)>>reSign(16,32);HEAP[e+24+16]=j;j=s+12;HEAP[j]=HEAP[r];HEAP[j+4]=HEAP[r+4];HEAP[j+8]=HEAP[r+8];HEAP[j+12]=HEAP[r+12];j=s+28;HEAP[j]=HEAP[q];HEAP[j+4]=HEAP[q+4];HEAP[s+8]=1}else{s=s+24;i=HEAP[o+40];h=reSign(i,32)>=reSign(0,32);i=i;h=h=h=h?i+32768&-65536:0-(32768-i&-65536);h=
reSign(h,32)>>reSign(16,32);HEAP[s+16]=h;h=i=HEAP[o+40];i=reSign(i,32)>=reSign(0,32);h=h;h=h=h=i?h+32768&-65536:0-(32768-h&-65536);h=reSign(h,32)>>reSign(16,32);HEAP[e+56]=h;HEAP[HEAP[e+156]+8]=0;h=reSign(HEAP[n+140+56+12]-HEAP[n+140+56+4],32)>>reSign(16,32);HEAP[s+28]=h;HEAP[e+60]=HEAP[s+28];HEAP[e+72]=1869968492;if(unSign(HEAP[g+12+2],16)<=unSign(23,16))HEAP[e+108+16]|=256;h=v=e+108;i=r;v=v==0;b:do if(!v){if(i==0)break b;c=HEAP[h+4];var x=reSign(HEAP[h+2],16);k=c+8*x;if(!(c<k))break b;x=i;k=k;c=
c;for(f=16;;){y=f==16?0:y;f=c+8*(y+1);_FT_Vector_Transform(c+8*y,x);var y=y+1;if(f<k)f=17;else break}}while(0);_FT_Outline_Translate(e+108,HEAP[q],HEAP[q+4]);HEAP[t]=HEAP[s+16];HEAP[t+4]=0;_FT_Vector_Transform(t,r);HEAP[s+16]=HEAP[q]+HEAP[t];HEAP[t]=0;HEAP[t+4]=HEAP[s+28];_FT_Vector_Transform(t,r);HEAP[s+28]=HEAP[q+4]+HEAP[t+4];if((b&1)==0){i=HEAP[o+16];k=HEAP[i+4];v=HEAP[e+164];h=HEAP[e+168];j=j==0;b:do if(j)c=20;else{c=HEAP[o+72]==0?20:21;break b}while(0);b:do if(c==20){f=j=reSign(HEAP[i+2],16);
if(!(reSign(j,32)>reSign(0,32)))break b;j=v;x=h;k=k;f=f;var A=0-f;A=reSign(A,32)>reSign(-1,32)?A:-1;A=f+A+1;var z=k+8*A;for(f=22;;){B=f==22?0:B;c=k+8*B+4;f=k+8*B;var C=_FT_MulFix(HEAP[f],j);HEAP[f]=C;f=_FT_MulFix(HEAP[c],x);HEAP[c]=f;var B=B+1;if(B!=A)c=f=23;else{c=24;break}}k=z}while(0);j=_FT_MulFix(HEAP[s+16],v);HEAP[s+16]=j;j=_FT_MulFix(HEAP[s+28],h);HEAP[s+28]=j}_FT_Outline_Get_CBox(e+108,u);HEAP[s]=HEAP[u+8]-HEAP[u];HEAP[s+4]=HEAP[u+12]-HEAP[u+4];HEAP[s+8]=HEAP[u];HEAP[s+12]=HEAP[u+12];if((b&
16)==0)break a;_ft_synthesize_vertical_metrics(s,HEAP[s+28])}}while(0);e=m;STACKTOP=a;return e}_cid_slot_load_glyph.__index__=Runtime.getFunctionIndex(_cid_slot_load_glyph,"_cid_slot_load_glyph");
function _pfr_extra_items_parse(e,g,d,b){var a,c=null,f,h,i,k,j,l;f=0;h=HEAP[e];var m=h+1>g;a:do if(m)a=2;else{var o=unSign(HEAP[h],8);i=o;h+=1;c=0;for(;;){if((c==13?j:o)==0){a=9;break a}if(h+2>g){a=2;break a}j=unSign(HEAP[h],8);h+=1;k=unSign(HEAP[h],8);h+=1;if(h+j>g){a=2;break a}if(d!=0){l=d;k=k;l=l;for(c=5;;){a=c==8?p:0;var n=l+8*a;c=n;if(HEAP[l+8*a+4]==0){a=12;break}if(HEAP[c]==k){a=7;break}var p=a+1;c=8;a=6}if(a!=12)if(a==7){f=FUNCTION_TABLE[HEAP[n+4]](h,h+j,b);if(f!=0){a=9;break a}}}h+=j;i=j=
i-1;c=13;a=1}}while(0);if(a==2)f=8;HEAP[e]=h;return f}_pfr_extra_items_parse.__index__=Runtime.getFunctionIndex(_pfr_extra_items_parse,"_pfr_extra_items_parse");
function _pfr_extra_item_load_bitmap_info(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c=null,f,h,i,k;e=e;f=HEAP[d];HEAP[b]=0;k=e+5>g;a:do if(k)a=8;else{e+=3;i=unSign(HEAP[e],8);e+=1;a=unSign(HEAP[e],8);e+=1;k=HEAP[d+96];if(unSign(a+HEAP[d+92],32)>unSign(k,32)){k=HEAP[d+92]+3+a&-4;f=_ft_mem_realloc(f,36,HEAP[d+92],k,HEAP[d+100],b);HEAP[d+100]=f;if(HEAP[b]!=0){a=0;break a}HEAP[d+96]=k}f=8;if((i&1&255)!=0)f+=1;if((i&2)!=0)f+=1;if((i&4)!=0)f+=1;if((i&8)!=0)f+=1;if((i&16)!=0)f+=1;h=HEAP[d+
100]+36*HEAP[d+92];if(e+f*a>g){a=8;break a}g=a;if(unSign(0,32)<unSign(g,32)){g=(i&1&255)!=0;f=(i&2)!=0;k=(i&4)!=0;var j=(i&8)!=0;i=(i&16)!=0;var l=a;h=h;l=(unSign(l,32)>unSign(1,32)?l:1)-0;for(c=10;;){B=c==10?0:B;var m=h+36*B,o=h+36*B+4,n=h+36*B+8,p=h+36*B+20,r=h+36*B+24,q=h+36*B+28;c=e;if(g){e=c+2;var s=unSign(HEAP[e+-2],8)<<8&65535;c=unSign(HEAP[e+-2+1],8);s=unSign(s|c,16);c=12}else{var u=unSign(HEAP[c],8);e+=1;c=14}HEAP[m]=c==14?u:s;c=e;if(f){e=c+2;var t=unSign(HEAP[e+-2],8)<<8&65535;c=unSign(HEAP[e+
-2+1],8);t=unSign(t|c,16);c=15}else{var v=unSign(HEAP[c],8);e+=1;c=17}HEAP[o]=c==17?v:t;o=unSign(HEAP[e],8);HEAP[n]=o;e+=1;e=e;if(k){e=e+3;var w=unSign(HEAP[e+-3],8)<<16;n=unSign(HEAP[e+-3+1],8)<<8;o=unSign(HEAP[e+-3+2],8);w=n|w|o;c=18}else{e=e+2;var x=unSign(HEAP[e+-2],8)<<8&65535;n=unSign(HEAP[e+-2+1],8);x=unSign(x|n,16);c=20}HEAP[p]=c==20?x:w;e=e;if(j){e=e+3;var y=unSign(HEAP[e+-3],8)<<16;p=unSign(HEAP[e+-3+1],8)<<8;n=unSign(HEAP[e+-3+2],8);y=p|y|n;c=21}else{e=e+2;var A=unSign(HEAP[e+-2],8)<<8&
65535;p=unSign(HEAP[e+-2+1],8);A=unSign(A|p,16);c=23}HEAP[r]=c==23?A:y;r=e;if(i){e=r+2;var z=unSign(HEAP[e+-2],8)<<8&65535;r=unSign(HEAP[e+-2+1],8);z=unSign(z|r,16);c=24}else{var C=unSign(HEAP[r],8);e+=1;c=26}HEAP[q]=c==26?C:z;var B=B+1;if(B!=l)c=27;else break}}HEAP[d+92]=a+HEAP[d+92];a=0;break a}while(0);if(a==8)HEAP[b]=8;d=HEAP[b];STACKTOP=b;return d}_pfr_extra_item_load_bitmap_info.__index__=Runtime.getFunctionIndex(_pfr_extra_item_load_bitmap_info,"_pfr_extra_item_load_bitmap_info");
function _pfr_extra_item_load_font_id(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;HEAP[b]=0;a=HEAP[d];g=g-e;var c=HEAP[d+80]!=0;a:do if(!c){var f=_ft_mem_alloc(a,g+1,b);HEAP[d+80]=f;if(HEAP[b]!=0)break a;_llvm_memcpy_p0i8_p0i8_i32(HEAP[d+80],e,g,1,0);HEAP[HEAP[d+80]+g]=0}while(0);e=HEAP[b];STACKTOP=b;return e}_pfr_extra_item_load_font_id.__index__=Runtime.getFunctionIndex(_pfr_extra_item_load_font_id,"_pfr_extra_item_load_font_id");
function _pfr_extra_item_load_stem_snaps(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a=null,c,f;e=e;HEAP[b]=0;f=HEAP[d];var h=HEAP[d+68+8]!=0;a:do if(!h){a=e+1>g;b:do if(!a){a=unSign(HEAP[e],8);e+=1;c=a&15;a=unSign(a,32)>>>unSign(4,32);a=a+c;if(e+a*2>g)break b;g=_ft_mem_realloc(f,4,0,a,0,b);if(HEAP[b]!=0)break a;HEAP[d+68+8]=g;HEAP[d+56+8]=g+4*c;if(a==0)break a;d=e;g=g;e=a;for(a=4;;){i=a==4?0:i;a=g+4*i;f=i*2;c=d+(f+1);f=reSign(HEAP[d+f],8)<<8&65535;c=unSign(HEAP[c],8);c=reSign(f|c,
16);HEAP[a]=c;var i=i+1;if(i!=e)a=5;else break}break a}while(0);HEAP[b]=8}while(0);i=HEAP[b];STACKTOP=b;return i}_pfr_extra_item_load_stem_snaps.__index__=Runtime.getFunctionIndex(_pfr_extra_item_load_stem_snaps,"_pfr_extra_item_load_stem_snaps");
function _pfr_extra_item_load_kerning_pairs(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c,f;c=e;HEAP[b]=0;f=HEAP[d];e=_ft_mem_alloc(f,24,b);var h=HEAP[b]!=0;a:do if(!h){a=c+4>g;b:do if(!a){HEAP[e+4]=HEAP[c];c+=1;c+=2;a=reSign(HEAP[c+-2],8)<<8&65535;var i=unSign(HEAP[c+-2+1],8);HEAP[e+6]=a|i;HEAP[e+5]=HEAP[c];c+=1;HEAP[e+12]=c+HEAP[d+4]+(0-HEAP[d+148]);HEAP[e+8]=3;if((unSign(HEAP[e+5],8)&1&255)!=0)HEAP[e+8]+=2;if((unSign(HEAP[e+5],8)&2)!=0)HEAP[e+8]+=1;a=unSign(HEAP[e+4],8);if(c+
HEAP[e+8]*a>g)break b;if(HEAP[e+4]!=0){f=(unSign(HEAP[e+5],8)&1&255)!=0;h=g=c;if(f){g=h+2;f=unSign(HEAP[g+-2],8)<<8&65535;h=unSign(HEAP[g+-2+1],8);f=unSign(f|h,16);g+=2;h=unSign(HEAP[g+-2],8)<<8&65535;g=unSign(HEAP[g+-2+1],8);g=unSign(h|g,16);f=f<<16;g=unSign(g&65535,16)|f;HEAP[e+16]=g;g=HEAP[e+8];g=(unSign(HEAP[e+4],8)-1)*g;g=c+g;g+=2;c=unSign(HEAP[g+-2],8)<<8&65535;f=unSign(HEAP[g+-2+1],8);f=unSign(c|f,16);g+=2;c=unSign(HEAP[g+-2],8)<<8&65535;g=unSign(HEAP[g+-2+1],8);g=unSign(c|g,16);c=f<<16;c=
unSign(g&65535,16)|c;HEAP[e+20]=c}else{f=unSign(HEAP[h],8);g+=1;g=unSign(HEAP[g],8);f=f<<16;g=unSign(g&65535,16)|f;HEAP[e+16]=g;g=HEAP[e+8];g=(unSign(HEAP[e+4],8)-1)*g;g=c+g;f=unSign(HEAP[g],8);g+=1;g=unSign(HEAP[g],8);c=f<<16;c=unSign(g&65535,16)|c;HEAP[e+20]=c}HEAP[e]=0;HEAP[HEAP[d+140]]=e;HEAP[d+140]=e;c=HEAP[d+132];e=unSign(HEAP[e+4],8)+c;HEAP[d+132]=e}else{e=e;d=f;e=e;e!=0&&FUNCTION_TABLE[HEAP[d+8]](d,e)}break a}while(0);i=e;e=f;a=i;i!=0&&FUNCTION_TABLE[HEAP[e+8]](e,a);e=0;HEAP[b]=8}while(0);
d=HEAP[b];STACKTOP=b;return d}_pfr_extra_item_load_kerning_pairs.__index__=Runtime.getFunctionIndex(_pfr_extra_item_load_kerning_pairs,"_pfr_extra_item_load_kerning_pairs");
function _pfr_aux_name_load(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c,f=null,h,i;g=g;h=HEAP[a]=0;i=g!=0;a:do if(i){if(HEAP[e+(g-1)]!=0){c=1;break a}g-=1}while(0);i=unSign(g!=0,1);var k=g;f=1;a:for(;;){c=f==6?l:0;l=0+c;f=e+l;var j=e+l;if(!(unSign(l,32)<unSign(k,32))){c=9;break a}if(unSign(HEAP[f],8)<=unSign(31,8)){c=4;break a}if(reSign(HEAP[j],8)<reSign(0,8)){c=4;break a}var l=c+1;f=6;c=3}a:do if(c==4)i=0;else if(c==9){if(i==0)break a;h=_ft_mem_alloc(d,g+1,a);if(HEAP[a]!=0)break a;
_llvm_memcpy_p0i8_p0i8_i32(h,e,g,1,0);HEAP[h+g]=0}while(0);HEAP[b]=h;e=HEAP[a];STACKTOP=a;return e}_pfr_aux_name_load.__index__=Runtime.getFunctionIndex(_pfr_aux_name_load,"_pfr_aux_name_load");
function _pfr_glyph_close_contour(e){var g,d,b,a,c;g=HEAP[e+28]+56;if(HEAP[e+32]!=0){d=reSign(HEAP[g+2],16)-1;b=0;if(reSign(HEAP[g],16)>reSign(0,16)){b=HEAP[g+12];a=reSign(HEAP[g],16)-1;b=reSign(HEAP[b+2*a],16)}a=b;var f=reSign(d,32)>reSign(a,32);a:do if(f){a=HEAP[g+4]+8*b;c=HEAP[g+4]+8*d;if(HEAP[a]!=HEAP[c])break a;if(HEAP[a+4]!=HEAP[c+4])break a;HEAP[g+2]-=1;d-=1}while(0);b=b;if(reSign(d,32)>=reSign(b,32)){b=HEAP[g+12];a=HEAP[g];c=reSign(a,16);HEAP[b+2*c]=d&65535;HEAP[g]=a+1}HEAP[e+32]=0}}
_pfr_glyph_close_contour.__index__=Runtime.getFunctionIndex(_pfr_glyph_close_contour,"_pfr_glyph_close_contour");
function _pfr_glyph_line_to(e,g){var d=STACKTOP;STACKTOP+=8;Runtime.memset(d,0,8);var b,a,c,f;b=HEAP[e+28];a=b+56;var h=HEAP[e+32]==0;a:do if(h)c=8;else{c=reSign(HEAP[b+20+2],16);f=reSign(HEAP[b+56+2],16);var i=HEAP[b+4];if(unSign(c+1+f,32)>unSign(i,32)){c=f=_FT_GlyphLoader_CheckPoints(b,1,0);if(f!=0)break a}else c=0;f=reSign(HEAP[a+2],16);i=HEAP[a+4];var k=g;HEAP[d]=HEAP[k];HEAP[d+4]=HEAP[k+4];i=i+8*f;HEAP[i]=HEAP[d];HEAP[i+4]=HEAP[d+4];HEAP[HEAP[a+8]+f]=1;HEAP[a+2]+=1}while(0);b=c;STACKTOP=d;return b}
_pfr_glyph_line_to.__index__=Runtime.getFunctionIndex(_pfr_glyph_line_to,"_pfr_glyph_line_to");
function _pfr_glyph_load_rec(e,g,d,b,a){var c=STACKTOP;STACKTOP+=104;Runtime.memset(c,0,104);var f,h=null,i=c+8,k=c+16,j,l,m=c+24,o,n=c+28,p=c+36,r=c+44,q=c+52,s=c+60,u,t,v,w,x=c+64,y,A,z,C,B=c+96,D=c+100,E,F,G,H,J;C=_FT_Stream_Seek(g,b+d);b=C!=0;a:do if(!b){C=_FT_Stream_EnterFrame(g,a);if(C!=0)break a;o=HEAP[g+32];l=o+a;w=a==0;b:do if(!w){if(reSign(HEAP[o],8)>=reSign(0,8)){f=2;break b}F=HEAP[e+28];j=F+20;u=HEAP[e+16];h=o;y=l;C=e;HEAP[B]=h;y=y;HEAP[D]=0;h=HEAP[C+28];A=HEAP[h];G=HEAP[B]+1>y;c:do if(G)f=
4;else{E=HEAP[B];h=unSign(HEAP[E],8);HEAP[B]=E+1;if((h&128)==0){f=4;break c}E=h&63;if((h&8)!=0){z=y;h=B;z=z;h=h=_pfr_extra_items_parse(h,z,0,0);HEAP[D]=h;if(HEAP[D]!=0){f=6;break c}}h=HEAP[C+16];z=HEAP[C+20];if(unSign(E+h,32)>unSign(z,32)){z=h+3+E&-4;if(unSign(z,32)>unSign(64,32)){HEAP[D]=8;f=6;break c}else{var L=_ft_mem_realloc(A,24,HEAP[C+20],z,HEAP[C+24],D);HEAP[C+24]=L;if(HEAP[D]!=0){f=6;break c}HEAP[C+20]=z}}h=HEAP[C+24]+24*h;E=E;var N=J=L=z=y,I=y;H=C+16;var P=C+16,K=y,O=y,M=y,Q=y,R=y,T=y,V=
h;for(h=10;;){var U=h==41?ea:0,S=V+24*U+16,X=V+24*U+20,Y=V+24*U+12,W=V+24*U+8;f=V+24*U+4;h=V+24*U;if(!(unSign(0+U,32)<unSign(E,32))){f=42;break}if(HEAP[B]+1>z){f=13;break}var da=HEAP[B],ba=unSign(HEAP[da],8);HEAP[B]=da+1;HEAP[h]=65536;if((ba&16)!=0){if(HEAP[B]+2>L){f=13;break}HEAP[B]+=2;da=reSign(HEAP[HEAP[B]+-2],8)<<8&65535;var aa=unSign(HEAP[HEAP[B]+-2+1],8);da=reSign(da|aa,16)<<4;HEAP[h]=da}HEAP[f]=65536;if((ba&32)!=0){if(HEAP[B]+2>J){f=13;break}HEAP[B]+=2;h=reSign(HEAP[HEAP[B]+-2],8)<<8&65535;
da=unSign(HEAP[HEAP[B]+-2+1],8);h=reSign(h|da,16)<<4;HEAP[f]=h}f=ba&3;if(f==1){h=146;f=21}else if(f==2){h=146;f=24}else{h=146;f=147}if(f==21){if(HEAP[B]+2>R){f=13;break}HEAP[B]+=2;var ca=reSign(HEAP[HEAP[B]+-2],8)<<8&65535;f=unSign(HEAP[HEAP[B]+-2+1],8);ca=reSign(ca|f,16);h=22}else if(f==24){if(HEAP[B]+1>T){f=13;break}f=HEAP[B];var $=reSign(HEAP[f],8);HEAP[B]=f+1;h=25}da=h==25?$:h==22?ca:0;f=unSign(ba,32)>>>unSign(2,32)&3;if(f==1){h=147;f=26}else if(f==2){h=147;f=29}else{h=147;f=148}if(f==26){if(HEAP[B]+
2>M){f=13;break}HEAP[B]+=2;var la=reSign(HEAP[HEAP[B]+-2],8)<<8&65535;f=unSign(HEAP[HEAP[B]+-2+1],8);la=reSign(la|f,16);h=27}else if(f==29){if(HEAP[B]+1>Q){f=13;break}f=HEAP[B];var ga=reSign(HEAP[f],8);HEAP[B]=f+1;h=30}f=h==30?ga:h==27?la:0;HEAP[W]=da;HEAP[Y]=f;f=HEAP[B];if((ba&64)!=0){if(f+2>N){f=13;break}HEAP[B]+=2;f=unSign(HEAP[HEAP[B]+-2],8)<<8&65535;h=unSign(HEAP[HEAP[B]+-2+1],8);f=unSign(f|h,16);HEAP[X]=f}else{if(f+1>O){f=13;break}f=HEAP[B];h=unSign(HEAP[f],8);HEAP[X]=h;HEAP[B]=f+1}f=HEAP[B];
if((ba&128)!=0){if(f+3>I){f=13;break}HEAP[B]+=3;ea=reSign(HEAP[HEAP[B]+-3],8)<<16;f=unSign(HEAP[HEAP[B]+-3+1],8)<<8;h=unSign(HEAP[HEAP[B]+-3+2],8);HEAP[S]=f|ea|h}else{if(f+2>K){f=13;break}HEAP[B]+=2;ea=unSign(HEAP[HEAP[B]+-2],8)<<8&65535;f=unSign(HEAP[HEAP[B]+-2+1],8);ea=unSign(ea|f,16);HEAP[S]=ea}HEAP[P]=HEAP[H]+1;var ea=U+1;h=41;f=11}if(f==42){f=6;break c}else if(f==13){f=4;break c}}while(0);if(f==4)HEAP[D]=8;C=h=h=HEAP[D];h=g;if(HEAP[h+20]!=0){y=HEAP[h+28];A=HEAP[h];y=y;A=A;A!=0&&FUNCTION_TABLE[HEAP[y+
8]](y,A);HEAP[h]=0}HEAP[h+32]=0;HEAP[h+36]=0;if(C!=0)break a;A=HEAP[e+16]-u;y=0;for(;;){f=A;if(!(reSign(y,32)<reSign(f,32)))break a;z=HEAP[e+24]+24*u+24*y;G=reSign(HEAP[j+2],16);C=_pfr_glyph_load_rec(e,g,d,HEAP[z+16],HEAP[z+20]);if(C!=0)break a;z=HEAP[e+24]+24*u+24*y;E=reSign(HEAP[j+2],16)-G;h=HEAP[z]!=65536;d:do if(h)f=49;else{if(HEAP[z+4]!=65536){f=49;break d}J=HEAP[F+20+4]+8*G;h=0;f=E;if(!(reSign(h,32)<reSign(f,32))){f=52;break d}f=z+8;L=z+12;N=E;J=J;h=h;I=h+1;N=(reSign(N,32)>reSign(I,32)?N:I)-
h;for(h=56;;){Z=h==56?0:Z;h=J+8*Z+4;I=J+8*Z;HEAP[I]=HEAP[f]+HEAP[I];HEAP[h]=HEAP[L]+HEAP[h];var Z=Z+1;if(Z!=N)h=57;else break}f=52;break d}while(0);d:do if(f==49){H=HEAP[j+4]+8*G;h=0;L=E;if(!(reSign(h,32)<reSign(L,32)))break d;L=z;J=z+8;N=z+4;I=z+12;P=E;H=H;h=h;K=h+1;P=(reSign(P,32)>reSign(K,32)?P:K)-h;for(h=51;;){ha=h==51?0:ha;f=H+8*ha+4;h=H+8*ha;K=_FT_MulFix(HEAP[h],HEAP[L]);HEAP[h]=HEAP[J]+K;h=_FT_MulFix(HEAP[f],HEAP[N]);HEAP[f]=HEAP[I]+h;var ha=ha+1;if(ha!=P)f=h=53;else{f=54;break}}}while(0);
y+=1;f=47}}while(0);o=o;u=l;l=e;HEAP[m]=o;o=u;HEAP[s]=0;u=HEAP[HEAP[l+28]];F=HEAP[m]+1>o;b:do if(F)f=60;else{h=HEAP[m];j=unSign(HEAP[h],8);HEAP[m]=h+1;if((j&128)!=0){f=60;break b}v=t=0;w=(j&4)!=0;c:do if(w){if(HEAP[m]+1>o){f=60;break b}C=HEAP[m];h=unSign(HEAP[C],8);HEAP[m]=C+1;t=h&15;v=unSign(h,32)>>>unSign(4,32)}else{if((j&2)!=0){if(HEAP[m]+1>o){f=60;break b}h=HEAP[m];t=unSign(HEAP[h],8);HEAP[m]=h+1}if((j&1&255)==0){f=67;break c}if(HEAP[m]+1>o){f=60;break b}h=HEAP[m];v=unSign(HEAP[h],8);HEAP[m]=
h+1}while(0);w=h=v+t;if(unSign(HEAP[l+4],32)<unSign(w,32)){w=h+7&-8;C=_ft_mem_realloc(u,4,HEAP[l+4],w,HEAP[l+8],s);HEAP[l+8]=C;if(HEAP[s]!=0){f=69;break b}HEAP[l+4]=w}HEAP[l+12]=HEAP[l+8]+4*t;w=h;y=C=o;A=l+8;G=o;h=72;c:for(;;){f=h==83?sa:0;L=h==83?na:0;z=h==83?ka:0;E=0+f;if(!(unSign(E,32)<unSign(w,32))){f=85;break c}if((E&7)==0){if(HEAP[m]+1>C){f=75;break c}h=HEAP[m];var ia=unSign(HEAP[h],8);HEAP[m]=h+1;h=76}else h=84;L=h==76?ia:L;h=HEAP[m];if((L&1&255)!=0){if(h+2>y){f=75;break c}HEAP[m]+=2;var ja=
reSign(HEAP[HEAP[m]+-2],8)<<8&65535;ka=unSign(HEAP[HEAP[m]+-2+1],8);ja=reSign(ja|ka,16);h=79}else{if(h+1>G){f=75;break c}ka=HEAP[m];var fa=unSign(HEAP[ka],8)+z;HEAP[m]=ka+1;h=82}var ka=h==82?fa:ja;HEAP[HEAP[A]+4*E]=ka;var na=unSign(L,32)>>>unSign(1,32),sa=f+1;h=83;f=73}if(f==85){if((j&8)!=0){j=o;h=m;j=j;h=h=_pfr_extra_items_parse(h,j,0,0);HEAP[s]=h;if(HEAP[s]!=0){f=69;break b}}h=l;HEAP[h+32]=0;HEAP[x+4]=0;HEAP[x]=HEAP[x+4];h=x;HEAP[q]=HEAP[h];HEAP[q+4]=HEAP[h+4];h=x+24;HEAP[h]=HEAP[q];HEAP[h+4]=HEAP[q+
4];j=x+24;w=x+24+4;C=n;y=n+4;A=h=x+24;G=h+4;E=n+4;z=x+24+4;L=x+24;J=x;N=x+8;I=x+16;H=k;P=k+4;K=k+4;O=i;M=i+4;Q=i+4;R=c;T=c+4;V=c+4;ba=S=U=x;X=x+24+4;Y=x+4;h=x;W=r;da=h;aa=r+4;var wa=h+4;var Aa=h=x+24,Da=h+4,pa=r+4,ta=x+24,ma=x,ya=x+4;h=x;var qa=p,ua=h,Ba=p+4,Na=h+4,Ea=h=x+24,ra=h+4,za=p+4,Ha=o,Ca=o,va=o,Pa=v,Ja=l+12,La=o,xa=o,oa=o,Fa=t,Ma=l+8,Ka=o,Ra=o,Qa=l,Va=l,Ta=l;t=t;var Ua=l+8;v=v;var ab=l+12,Sa=HEAP[C],$a=HEAP[W],Wa=HEAP[qa],eb=HEAP[H],Ga=HEAP[O],ob=HEAP[R];h=87;c:for(;;){var Oa=h==140?sb:ob,
Xa=h==140?Db:Ga,bb=h==140?Cb:eb,jb=h==140?gb:Wa,Za=h==140?hb:$a,fb=h==140?yb:Sa;if(HEAP[m]+1>Ha){f=89;break c}f=HEAP[m];var Ya=unSign(HEAP[f],8);HEAP[m]=f+1;var Ia=Ya&15;f=unSign(Ya,32)>>>unSign(4,32);if(f==0){h=90;f=100}else if(f==1){h=90;f=91}else if(f==2){h=90;f=93}else if(f==3){h=90;f=95}else if(f==4){h=90;f=91}else if(f==5){h=90;f=91}else if(f==6){h=90;f=97}else if(f==7){h=90;f=98}else{h=90;f=99}if(f==99)h=99;else if(f==91)h=91;else if(f==93){if(unSign(Ia,32)>=unSign(t,32)){f=89;break c}HEAP[ba]=
HEAP[HEAP[Ua]+4*Ia];HEAP[Y]=HEAP[X];var cb=HEAP[da];HEAP[aa]=HEAP[wa];HEAP[Aa]=cb;HEAP[Da]=HEAP[pa];h=94}else if(f==95){if(unSign(Ia,32)>=unSign(v,32)){f=89;break c}HEAP[ma]=HEAP[ta];HEAP[ya]=HEAP[HEAP[ab]+4*Ia];var pb=HEAP[ua];HEAP[Ba]=HEAP[Na];HEAP[Ea]=pb;HEAP[ra]=HEAP[za];h=96}else if(f==97)h=97;else if(f==98)h=98;var gb=h==99?jb:h==98?jb:h==97?jb:h==96?pb:h==94?jb:h==91?jb:jb,hb=h==99?Za:h==98?Za:h==97?Za:h==96?Za:h==94?cb:h==91?Za:Za,kb=h==99?4:h==98?3:h==97?3:h==96?0:h==94?0:h==91?1:0;Ia=h==
99?Ia:h==98?3627:h==97?2958:h==96?0:h==94?0:h==91?Ia:0;h=100;d:for(;;){var db=h==125?Nb:0,ub=h==125?xb:Ia,yb=h==125?Hb:fb,rb=h==125?Jb:kb,zb=x+db*8+4,Fb=x+db*8;if(!(unSign(db,32)<unSign(rb,32)))break d;f=ub&3;f=f==0?102:f==1?107:f==2?109:111;if(f==111)HEAP[Fb]=HEAP[j];else if(f==102){if(HEAP[m]+1>oa){f=103;break c}f=HEAP[m];h=unSign(HEAP[f],8);HEAP[m]=f+1;if(unSign(h,32)>=unSign(Fa,32)){f=103;break c}HEAP[Fb]=HEAP[HEAP[Ma]+4*h]}else if(f==107){if(HEAP[m]+2>Ka){f=103;break c}HEAP[m]+=2;f=reSign(HEAP[HEAP[m]+
-2],8)<<8&65535;h=unSign(HEAP[HEAP[m]+-2+1],8);f=reSign(f|h,16);HEAP[Fb]=f}else if(f==109){if(HEAP[m]+1>Ra){f=103;break c}f=HEAP[m];h=reSign(HEAP[f],8);HEAP[m]=f+1;HEAP[Fb]=h+HEAP[L]}f=unSign(ub,32)>>>unSign(2,32)&3;f=f==0?112:f==1?116:f==2?118:120;if(f==120)HEAP[zb]=HEAP[w];else if(f==112){if(HEAP[m]+1>va){f=103;break c}f=HEAP[m];h=unSign(HEAP[f],8);HEAP[m]=f+1;if(unSign(h,32)>=unSign(Pa,32)){f=103;break c}HEAP[zb]=HEAP[HEAP[Ja]+4*h]}else if(f==116){if(HEAP[m]+2>La){f=103;break c}HEAP[m]+=2;f=reSign(HEAP[HEAP[m]+
-2],8)<<8&65535;h=unSign(HEAP[HEAP[m]+-2+1],8);f=reSign(f|h,16);HEAP[zb]=f}else if(f==118){if(HEAP[m]+1>xa){f=103;break c}f=HEAP[m];h=reSign(HEAP[f],8);HEAP[m]=f+1;HEAP[zb]=h+HEAP[z]}if(db!=0|rb!=4){var Ib=unSign(ub,32)>>>unSign(4,32);h=124}else{if(HEAP[m]+1>Ca){f=103;break c}xb=HEAP[m];var qb=unSign(HEAP[xb],8);HEAP[m]=xb+1;h=122}var xb=h==124?Ib:qb,Jb=h==124?rb:3,Hb=HEAP[Fb];HEAP[y]=HEAP[zb];HEAP[A]=Hb;HEAP[G]=HEAP[E];var Nb=db+1;h=125}f=unSign(Ya,32)>>>unSign(4,32);if(f==0){f=149;break c}else f=
f==1?128:f==2?128:f==3?128:f==4?150:f==5?150:151;if(f==151){var lb=HEAP[Qa+28],Gb=lb+56,vb=HEAP[Qa+32]==0;d:do if(vb)h=151;else{var tb=reSign(HEAP[lb+20+2],16);sb=reSign(HEAP[lb+56+2],16);Db=HEAP[lb+4];if(unSign(tb+3+sb,32)>unSign(Db,32)){var Kb=_FT_GlyphLoader_CheckPoints(lb,3,0);if(Kb!=0){h=136;break d}}var ib=HEAP[Gb+4],wb=reSign(HEAP[Gb+2],16);tb=ib+8*wb;ib=HEAP[Gb+8];wb=reSign(HEAP[Gb+2],16);sb=ib+wb;ib=HEAP[J];HEAP[P]=HEAP[J+4];HEAP[tb]=ib;HEAP[tb+4]=HEAP[K];wb=HEAP[N];HEAP[M]=HEAP[N+4];var Mb=
tb+8;HEAP[Mb]=wb;HEAP[Mb+4]=HEAP[Q];Mb=HEAP[I];HEAP[T]=HEAP[I+4];tb=tb+16;HEAP[tb]=Mb;HEAP[tb+4]=HEAP[V];HEAP[sb]=2;HEAP[sb+1]=2;HEAP[sb+2]=1;HEAP[Gb+2]+=3;h=138}while(0);lb=h==138?Mb:h==136?Oa:Oa;Gb=h==138?wb:h==136?Xa:Xa;vb=h==138?ib:h==136?bb:bb;tb=h==138?0:h==136?Kb:8;HEAP[s]=tb;h=137}else if(f==128){var Ab=_pfr_glyph_line_to(Va,U);HEAP[s]=Ab;h=128}else if(f==150){var mb=HEAP[Ta+28];_pfr_glyph_close_contour(Ta);HEAP[Ta+32]=1;sb=reSign(HEAP[mb+20+2],16);Db=reSign(HEAP[mb+56+2],16);Cb=HEAP[mb+4];
sb=unSign(sb+1+Db,32)>unSign(Cb,32);d:do if(sb)f=130;else{sb=reSign(HEAP[mb+20],16);Db=reSign(HEAP[mb+56],16);Cb=HEAP[mb+8];if(unSign(sb+1+Db,32)>unSign(Cb,32)){f=130;break d}f=132;break d}while(0);d:do if(f==130){var Bb=_FT_GlyphLoader_CheckPoints(mb,1,1);if(Bb==0){h=130;f=132}else{h=130;f=133}break d}while(0);if(f==132){var nb=_pfr_glyph_line_to(Ta,S);h=132}mb=h==132?nb:Bb;HEAP[s]=mb;h=133}var sb=h==137?lb:h==133?Oa:Oa,Db=h==137?Gb:h==133?Xa:Xa,Cb=h==137?vb:h==133?bb:bb;if((h==137?tb:h==133?mb:
Ab)!=0){f=141;break c}else{h=140;f=88}}if(f==89){HEAP[R]=Oa;HEAP[O]=Xa;HEAP[H]=bb;HEAP[qa]=jb;HEAP[W]=Za;HEAP[C]=fb;f=60;break b}else if(f==103){HEAP[R]=Oa;HEAP[O]=Xa;HEAP[H]=bb;HEAP[qa]=gb;HEAP[W]=hb;HEAP[C]=yb;f=60;break b}else if(f==149){HEAP[R]=Oa;HEAP[O]=Xa;HEAP[H]=bb;HEAP[qa]=gb;HEAP[W]=hb;HEAP[C]=yb;f=l;_pfr_glyph_close_contour(f);_FT_GlyphLoader_Add(HEAP[f+28]);f=69;break b}else if(f==141){HEAP[R]=sb;HEAP[O]=Db;HEAP[H]=Cb;HEAP[qa]=gb;HEAP[W]=hb;HEAP[C]=yb;f=69;break b}}else if(f==75){f=60;
break b}}while(0);if(f==60)HEAP[s]=8;C=l=l=HEAP[s];l=g;if(HEAP[l+20]!=0){o=HEAP[l+28];u=HEAP[l];o=o;u=u;u!=0&&FUNCTION_TABLE[HEAP[o+8]](o,u);HEAP[l]=0}HEAP[l+32]=0;HEAP[l+36]=0}while(0);e=C;STACKTOP=c;return e}_pfr_glyph_load_rec.__index__=Runtime.getFunctionIndex(_pfr_glyph_load_rec,"_pfr_glyph_load_rec");
function _pfr_cmap_init(e){var g,d=null,b,a;b=0;a=HEAP[e];HEAP[e+16]=HEAP[a+288+120];HEAP[e+20]=HEAP[a+288+128];a=HEAP[e+16];var c=e+20;e=e+20;for(d=-1;;){g=d==2?f:0;d=1+g;f=0+g;if(!(unSign(a,32)>unSign(d,32))){g=5;break}d=HEAP[HEAP[e]+16*d];if(unSign(HEAP[HEAP[c]+16*f],32)>=unSign(d,32)){g=1;break}var f=g+1;d=2;g=0}if(g==1)b=8;return b}_pfr_cmap_init.__index__=Runtime.getFunctionIndex(_pfr_cmap_init,"_pfr_cmap_init");function _pfr_cmap_done(e){HEAP[e+20]=0;HEAP[e+16]=0}
_pfr_cmap_done.__index__=Runtime.getFunctionIndex(_pfr_cmap_done,"_pfr_cmap_done");function _pfr_cmap_char_index(e,g){var d,b=null,a,c=e+20,f=HEAP[e+16];for(b=-1;;){var h=b==-1?f:b==4?h:i;k=b==-1?0:b==4?k:k;if(!(unSign(k,32)<unSign(h,32))){d=6;break}i=Math.floor(unSign(h-k,32)/unSign(2,32));var i=k+i;b=HEAP[c]+16*i;if(HEAP[b]==g){d=1;break}d=i+1;var k=(b=unSign(HEAP[b],32)<unSign(g,32))?d:k;b=b?4:2;d=0}if(d==1){a=i;a=a+1}else if(d==6)a=0;return a}
_pfr_cmap_char_index.__index__=Runtime.getFunctionIndex(_pfr_cmap_char_index,"_pfr_cmap_char_index");
function _pfr_cmap_char_next(e,g){var d,b=null,a,c,f,h;a=0;c=HEAP[g]+1;f=HEAP[e+16];h=e+20;var i=c,k=a;b=-1;a:for(;;){d=b==5?r:0;var j=b==5?0:k,l=i+d;for(b=0;;){var m=b==0?f:b==7?m:n,o=b==0?0:b==7?p:p;if(!(unSign(o,32)<unSign(m,32))){d=9;break a}var n=(unSign(m-o,32)>>>unSign(1,32))+o;b=HEAP[h]+16*n;if(HEAP[b]==l)break;p=n+1;var p=(b=unSign(HEAP[b],32)<unSign(l,32))?p:o;b=b?7:3}if(n!=0){d=4;break a}var r=d+1;b=5;d=0}a:do if(d==4){a=n;c=l;a+=1}else if(d==9){a=j;f=o;c=0;h=f;if(!(unSign(HEAP[e+16],32)>
unSign(h,32)))break a;h=HEAP[e+20]+16*f;a=f;if(a==0)break a;a+=1;c=HEAP[h]}while(0);HEAP[g]=c;return a}_pfr_cmap_char_next.__index__=Runtime.getFunctionIndex(_pfr_cmap_char_next,"_pfr_cmap_char_next");
function _pfr_face_done(e){var g=null,d,b,a;if(e!=0){a=HEAP[HEAP[e+96]+8];HEAP[e+20]=0;HEAP[e+24]=0;var c=HEAP[e+100];b=e+288;d=HEAP[b+80];d!=0&&FUNCTION_TABLE[HEAP[c+8]](c,d);HEAP[b+80]=0;d=HEAP[b+84];d!=0&&FUNCTION_TABLE[HEAP[c+8]](c,d);HEAP[b+84]=0;d=HEAP[b+88];d!=0&&FUNCTION_TABLE[HEAP[c+8]](c,d);HEAP[b+88]=0;d=HEAP[b+68+8];d!=0&&FUNCTION_TABLE[HEAP[c+8]](c,d);HEAP[b+68+8]=0;HEAP[b+68+4]=0;HEAP[b+56+8]=0;HEAP[b+56+4]=0;d=HEAP[b+100];d!=0&&FUNCTION_TABLE[HEAP[c+8]](c,d);HEAP[b+100]=0;HEAP[b+92]=
0;HEAP[b+96]=0;d=HEAP[b+128];d!=0&&FUNCTION_TABLE[HEAP[c+8]](c,d);HEAP[b+128]=0;HEAP[b+120]=0;HEAP[b+124]=0;d=HEAP[b+108];d!=0&&FUNCTION_TABLE[HEAP[c+8]](c,d);HEAP[b+108]=0;HEAP[b+104]=0;d=HEAP[b+136];if(d!=0){var f=c+8;for(g=7;;){g=g==7?d:h;var h=HEAP[g];g=g;g!=0&&FUNCTION_TABLE[HEAP[f]](c,g);if(h!=0)g=10;else break}}HEAP[b+136]=0;HEAP[b+140]=0;HEAP[b+132]=0;b=HEAP[e+32];b!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[e+32]=0}}_pfr_face_done.__index__=Runtime.getFunctionIndex(_pfr_face_done,"_pfr_face_done");
function _pfr_face_init(e,g,d){var b=STACKTOP;STACKTOP+=40;Runtime.memset(b,0,40);var a,c=null,f,h,i,k,j,l,m,o;f=b+4;var n,p,r,q,s,u,t;k=b+8;j=b+12;var v,w;l=b+16;var x=b+20;m=b+24;var y,A,z,C=b+28;p=g+132;var B=a=_FT_Stream_Seek(e,0);u=B==0;a:do if(u){var D=a=_FT_Stream_ReadFields(e,_pfr_header_fields,p);if(D==0)c=0;else{c=0;a=2;break a}HEAP[p+36]=HEAP[p+72]*65536+HEAP[p+36];a=a;HEAP[x]=a;if(a!=0){a=4;break a}p=g+132;u=1;w=HEAP[p]!=1346785840;b:do if(w)a=6;else{if(unSign(HEAP[p+4],32)>unSign(4,32)){a=
6;break b}if(unSign(HEAP[p+12],32)<=unSign(57,32)){a=6;break b}a=HEAP[p+8]!=3338?6:9;break b}while(0);if(a==6)u=0;a=a=unSign(u,8);if((a&255)==0)HEAP[x]=2;else{p=HEAP[g+132+20];a=e;w=p;p=m;u=0;w=_FT_Stream_Seek(a,w);HEAP[l]=w;w=HEAP[l]!=0;b:do if(!w){s=_FT_Stream_ReadShort(a,l);s=unSign(s,16);if(HEAP[l]!=0)break b;u=s}while(0);HEAP[p]=u;a=HEAP[l];HEAP[x]=a;if(a!=0){a=4;break a}HEAP[g]=HEAP[m];if(reSign(d,32)<reSign(0,32)){a=4;break a}m=d;if(reSign(HEAP[g],32)<=reSign(m,32))HEAP[x]=6;else{m=unSign(HEAP[g+
132+72]!=0,1);c=HEAP[g+132+20];p=d;l=e;a=m&255;m=g+240;l=l;u=p;c=c;p=a;c=_FT_Stream_Seek(l,c);HEAP[k]=c;a=HEAP[k];w=a!=0;b:do if(w)c=137;else{c=_FT_Stream_ReadShort(l,k);s=unSign(c,16);t=HEAP[k];if(t!=0){c=16;break b}else c=16;s=s;if(unSign(u,32)>=unSign(s,32)){HEAP[x]=6;a=4;break a}else{s=u*5;c=l;s=s;if(reSign(s,32)<reSign(0,32)){HEAP[k]=85;c=19}else{v=_FT_Stream_Seek(c,s+HEAP[c+8]);HEAP[k]=v;if(v!=0){c=21;break b}c=_FT_Stream_ReadShort(l,k);u=unSign(c,16);o=HEAP[k];if(o!=0){c=22;break b}c=_FT_Stream_ReadOffset(l,
k);q=HEAP[k];if(q!=0){c=23;break b}HEAP[m]=u;HEAP[m+4]=c;c=_FT_Stream_Seek(l,c);HEAP[k]=c;var E=HEAP[k];if(E!=0){c=24;break b}c=_FT_Stream_EnterFrame(l,u);HEAP[k]=c;var F=HEAP[k];if(F!=0){c=25;break b}else c=25;HEAP[j]=HEAP[l+32];v=HEAP[j]+u;q=HEAP[j]+13>v;c:do if(q)a=34;else{HEAP[j]+=3;a=reSign(HEAP[HEAP[j]+-3],8)<<16;q=unSign(HEAP[HEAP[j]+-3+1],8)<<8;t=unSign(HEAP[HEAP[j]+-3+2],8);HEAP[m+8]=q|a|t;HEAP[j]+=3;a=reSign(HEAP[HEAP[j]+-3],8)<<16;q=unSign(HEAP[HEAP[j]+-3+1],8)<<8;t=unSign(HEAP[HEAP[j]+
-3+2],8);HEAP[m+8+4]=q|a|t;HEAP[j]+=3;a=reSign(HEAP[HEAP[j]+-3],8)<<16;q=unSign(HEAP[HEAP[j]+-3+1],8)<<8;t=unSign(HEAP[HEAP[j]+-3+2],8);HEAP[m+8+8]=q|a|t;HEAP[j]+=3;a=reSign(HEAP[HEAP[j]+-3],8)<<16;q=unSign(HEAP[HEAP[j]+-3+1],8)<<8;t=unSign(HEAP[HEAP[j]+-3+2],8);HEAP[m+8+12]=q|a|t;q=HEAP[j];a=unSign(HEAP[q],8);HEAP[j]=q+1;q=0;t=(a&4)!=0;d:do if(t){q+=1;if((a&8)!=0)q+=1;if((a&3)!=0)break d;q+=3}while(0);t=(a&16)!=0;d:do if(t){q+=1;if((a&32)==0)break d;q+=1}while(0);if(HEAP[j]+q>v){a=34;break c}q=(a&
4)!=0;d:do if(q){o=HEAP[j];if((a&8)!=0){HEAP[j]=o+2;t=reSign(HEAP[HEAP[j]+-2],8)<<8&65535;o=unSign(HEAP[HEAP[j]+-2+1],8);t=reSign(t|o,16)}else{t=unSign(HEAP[o],8);HEAP[j]=o+1}HEAP[m+28]=t;if((a&3)!=0)break d;HEAP[j]+=3;t=reSign(HEAP[HEAP[j]+-3],8)<<16;o=unSign(HEAP[HEAP[j]+-3+1],8)<<8;E=unSign(HEAP[HEAP[j]+-3+2],8);HEAP[m+36]=o|t|E}while(0);if((a&16)!=0){t=HEAP[j];if((a&32)!=0){HEAP[j]=t+2;q=reSign(HEAP[HEAP[j]+-2],8)<<8&65535;t=unSign(HEAP[HEAP[j]+-2+1],8);q=reSign(q|t,16)}else{q=unSign(HEAP[t],
8);HEAP[j]=t+1}HEAP[m+32]=q}if((a&64)!=0){q=v;a=j;q=q;a=a=_pfr_extra_items_parse(a,q,0,0);HEAP[k]=a;if(HEAP[k]!=0){a=42;break c}}if(HEAP[j]+5>v){a=34;break c}HEAP[j]+=2;a=unSign(HEAP[HEAP[j]+-2],8)<<8&65535;q=unSign(HEAP[HEAP[j]+-2+1],8);a=unSign(a|q,16);HEAP[m+40]=a;HEAP[j]+=3;a=unSign(HEAP[HEAP[j]+-3],8)<<16;q=unSign(HEAP[HEAP[j]+-3+1],8)<<8;t=unSign(HEAP[HEAP[j]+-3+2],8);HEAP[m+44]=q|a|t;if(p==0){a=42;break c}if(HEAP[j]+1>v){a=34;break c}p=HEAP[m+40];a=HEAP[j];p=unSign(HEAP[a],8)*65536+p;HEAP[m+
40]=p;HEAP[j]=a+1;a=42;break c}while(0);if(a==34)HEAP[k]=8;j=l;if(HEAP[j+20]!=0){m=HEAP[j+28];l=HEAP[j];m=m;l=l;l!=0&&FUNCTION_TABLE[HEAP[m+8]](m,l);HEAP[j]=0}HEAP[j+32]=0;HEAP[j+36]=0;k=HEAP[k];HEAP[x]=k;if(k!=0){a=4;break a}c=HEAP[g+240+40];j=HEAP[g+240+44];k=e;e=g+288;k=k;j=j;l=c;m=HEAP[k+28];HEAP[e]=m;HEAP[e+4]=j;HEAP[e+136]=0;HEAP[e+140]=e+136;c=_FT_Stream_Seek(k,j);HEAP[b]=c;p=HEAP[b];v=p!=0;c:do if(v)c=50;else{c=_FT_Stream_EnterFrame(k,l);HEAP[b]=c;n=HEAP[b];if(n!=0){c=51;break c}else c=51;
HEAP[e+148]=HEAP[k+32];HEAP[f]=HEAP[k+32];n=HEAP[f]+l;l=HEAP[f]+15>n;d:do if(l)a=54;else{HEAP[f]+=2;l=unSign(HEAP[HEAP[f]+-2],8)<<8&65535;p=unSign(HEAP[HEAP[f]+-2+1],8);l=unSign(l|p,16);HEAP[e+8]=l;HEAP[f]+=2;l=unSign(HEAP[HEAP[f]+-2],8)<<8&65535;p=unSign(HEAP[HEAP[f]+-2+1],8);l=unSign(l|p,16);HEAP[e+12]=l;HEAP[f]+=2;l=unSign(HEAP[HEAP[f]+-2],8)<<8&65535;p=unSign(HEAP[HEAP[f]+-2+1],8);l=unSign(l|p,16);HEAP[e+16]=l;HEAP[f]+=2;l=reSign(HEAP[HEAP[f]+-2],8)<<8&65535;p=unSign(HEAP[HEAP[f]+-2+1],8);l=reSign(l|
p,16);HEAP[e+20]=l;HEAP[f]+=2;l=reSign(HEAP[HEAP[f]+-2],8)<<8&65535;p=unSign(HEAP[HEAP[f]+-2+1],8);l=reSign(l|p,16);HEAP[e+20+4]=l;HEAP[f]+=2;l=reSign(HEAP[HEAP[f]+-2],8)<<8&65535;p=unSign(HEAP[HEAP[f]+-2+1],8);l=reSign(l|p,16);HEAP[e+20+8]=l;HEAP[f]+=2;l=reSign(HEAP[HEAP[f]+-2],8)<<8&65535;p=unSign(HEAP[HEAP[f]+-2+1],8);l=reSign(l|p,16);HEAP[e+20+12]=l;p=HEAP[f];l=unSign(HEAP[p],8);HEAP[e+36]=l;HEAP[f]=p+1;if((l&4)==0){if(HEAP[f]+2>n){a=54;break d}HEAP[f]+=2;p=reSign(HEAP[HEAP[f]+-2],8)<<8&65535;
v=unSign(HEAP[HEAP[f]+-2+1],8);p=reSign(p|v,16);HEAP[e+40]=p}if((l&128)!=0){p=_pfr_extra_items_parse(f,n,_pfr_phy_font_extra_items,e);HEAP[b]=p;if(HEAP[b]!=0){a=57;break d}}if(HEAP[f]+3>n){a=54;break d}HEAP[f]+=3;p=unSign(HEAP[HEAP[f]+-3],8)<<16;v=unSign(HEAP[HEAP[f]+-3+1],8)<<8;q=unSign(HEAP[HEAP[f]+-3+2],8);o=v|p|q;if(o!=0){p=HEAP[f];if(HEAP[f]+o>n){a=54;break d}v=o;HEAP[f]+=v;t=q=m;o=o;c=60;e:for(;;){E=c==69?G:o;if((c==69?G:v)==0){c=61;a=63;break e}if(p+4>HEAP[f]){c=62;a=63;break e}p+=2;c=unSign(HEAP[p+
-2],8)<<8&65535;G=unSign(HEAP[p+-2+1],8);c=unSign(c|G,16);G=unSign(c,32)<=unSign(3,32);a=unSign(c,32)>unSign(E,32);if(G|a){c=64;a=63;break e}G=p+c+-2;p+=2;a=unSign(HEAP[p+-2],8)<<8&65535;F=unSign(HEAP[p+-2+1],8);a=unSign(a|F,16);a=a==1?66:a==2?136:a==3?71:69;f:do if(a==66){F=_pfr_aux_name_load(p,c-4,q,e+84);HEAP[b]=F;if(HEAP[b]!=0){c=66;a=67;break e}}else if(a==136){if(p+32>G)break f;p+=10;p+=2;F=reSign(HEAP[p+-2],8)<<8&65535;u=unSign(HEAP[p+-2+1],8);F=reSign(F|u,16);HEAP[e+44]=F;p+=2;F=reSign(HEAP[p+
-2],8)<<8&65535;u=unSign(HEAP[p+-2+1],8);F=reSign(F|u,16);HEAP[e+48]=F;p+=2;F=reSign(HEAP[p+-2],8)<<8&65535;u=unSign(HEAP[p+-2+1],8);F=reSign(F|u,16);HEAP[e+52]=F;p+=16}else if(a==71){F=_pfr_aux_name_load(p,c-4,t,e+88);HEAP[b]=F;if(HEAP[b]!=0){c=71;a=67;break e}}while(0);p=G;var G=E-c;c=69;a=61}if(a!=63)if(a==67){a=108;break d}}if(HEAP[f]+1>n){a=54;break d}G=HEAP[f];a=unSign(HEAP[G],8);HEAP[e+104]=a;HEAP[f]=G+1;if(HEAP[f]+a*2>n){a=54;break d}G=_ft_mem_realloc(m,4,0,a,0,b);HEAP[e+108]=G;if(HEAP[b]!=
0){a=57;break d}c=a;c=unSign(0,32)<unSign(c,32);G=HEAP[f];if(c){c=a;unSign(c,32);unSign(1,32);a=(unSign(c,32)>unSign(1,32)?c:1)-0;for(c=76;;){H=c==76?0:H;p=0+H;HEAP[f]=(c==76?G:r)+2;c=HEAP[e+108];r=reSign(HEAP[HEAP[f]+-2],8)<<8&65535;v=unSign(HEAP[HEAP[f]+-2+1],8);r=reSign(r|v,16);HEAP[c+4*p]=r;r=HEAP[f];var H=H+1;if(H!=a)c=77;else break}c=78}else c=75;if((c==78?r:G)+8>n){a=54;break d}r=HEAP[f];H=unSign(HEAP[r],8);HEAP[e+112]=H;HEAP[f]=r+1;r=HEAP[f];H=unSign(HEAP[r],8);HEAP[e+116]=H;HEAP[f]=r+1;HEAP[f]+=
2;r=unSign(HEAP[HEAP[f]+-2],8)<<8&65535;H=unSign(HEAP[HEAP[f]+-2+1],8);r=unSign(r|H,16);HEAP[e+68]=r;HEAP[f]+=2;r=unSign(HEAP[HEAP[f]+-2],8)<<8&65535;H=unSign(HEAP[HEAP[f]+-2+1],8);r=unSign(r|H,16);HEAP[e+56]=r;HEAP[f]+=2;r=unSign(HEAP[HEAP[f]+-2],8)<<8&65535;H=unSign(HEAP[HEAP[f]+-2+1],8);a=unSign(r|H,16);HEAP[e+120]=a;HEAP[e+124]=0-HEAP[k+32]+HEAP[f]+j;r=_ft_mem_realloc(m,16,0,a,0,b);HEAP[e+128]=r;if(HEAP[b]!=0){a=57;break d}r=4;if((l&2)!=0)r+=1;if((l&4)!=0)r+=2;if((l&8)!=0)r+=1;if((l&16)!=0)r+=
1;if((l&32)!=0)r+=1;if(HEAP[f]+r*a>n){a=54;break d}r=a;if(!(unSign(0,32)<unSign(r,32))){a=57;break d}r=(l&2)!=0;H=(l&4)!=0;G=(l&8)!=0;n=(l&16)!=0;j=(l&32)!=0;c=a;unSign(c,32);unSign(1,32);m=(unSign(c,32)>unSign(1,32)?c:1)-0;for(c=88;;){O=c==88?0:O;a=0+O;l=HEAP[e+128];c=HEAP[f];if(r){HEAP[f]=c+2;var J=unSign(HEAP[HEAP[f]+-2],8)<<8&65535;c=unSign(HEAP[HEAP[f]+-2+1],8);J=unSign(J|c,16);c=90}else{h=unSign(HEAP[c],8);HEAP[f]=c+1;c=92}HEAP[l+16*a]=c==92?h:J;if(H){HEAP[f]+=2;var L=reSign(HEAP[HEAP[f]+-2],
8)<<8&65535;c=unSign(HEAP[HEAP[f]+-2+1],8);L=reSign(L|c,16);c=93}else{i=HEAP[e+40];c=95}HEAP[l+16*a+4]=c==95?i:L;if(G)HEAP[f]+=1;c=HEAP[f];if(n){HEAP[f]=c+2;var N=unSign(HEAP[HEAP[f]+-2],8)<<8&65535;c=unSign(HEAP[HEAP[f]+-2+1],8);N=unSign(N|c,16);c=97}else{var I=unSign(HEAP[c],8);HEAP[f]=c+1;c=99}HEAP[l+16*a+8]=c==99?I:N;c=HEAP[f];if(j){HEAP[f]=c+3;var P=unSign(HEAP[HEAP[f]+-3],8)<<16;c=unSign(HEAP[HEAP[f]+-3+1],8)<<8;p=unSign(HEAP[HEAP[f]+-3+2],8);P=c|P|p;c=100}else{HEAP[f]=c+2;var K=unSign(HEAP[HEAP[f]+
-2],8)<<8&65535;c=unSign(HEAP[HEAP[f]+-2+1],8);K=unSign(K|c,16);c=102}HEAP[l+16*a+12]=c==102?K:P;var O=O+1;if(O!=m)c=103;else{c=103;break}}a=57;break d}while(0);d:do if(a==54){HEAP[b]=8;a=57;break d}while(0);if(a==57){f=k;if(HEAP[f+20]!=0){h=HEAP[f+28];i=HEAP[f];h=h;i=i;i!=0&&FUNCTION_TABLE[HEAP[h+8]](h,i);HEAP[f]=0}HEAP[f+32]=0;HEAP[f+36]=0;f=k;f=f=HEAP[f+8];HEAP[e+144]=f;HEAP[e+148]=0}f=HEAP[b];HEAP[x]=f;if(f!=0){a=4;break a}f=g+288;HEAP[g+4]=d;HEAP[g+16]=HEAP[f+120]+1;HEAP[g+8]=1;i=0;d=HEAP[f+
120];h=f+128;i=i;c=109;d:for(;;){A=c==112?A:0;y=i+A;if(!(unSign(d,32)>unSign(y,32)))break d;if(HEAP[HEAP[h]+16*y+12]!=0)break d;A=A+1;c=112}i=y;if(HEAP[f+120]==i)if(HEAP[f+92]!=0)HEAP[g+8]=0;else{HEAP[x]=3;a=4;break a}if((HEAP[f+36]&4)==0)HEAP[g+8]|=4;y=HEAP[g+8];HEAP[g+8]=(HEAP[f+36]&1&255)!=0?y|32:y|16;if(HEAP[f+92]!=0)HEAP[g+8]|=2;if(HEAP[f+132]!=0)HEAP[g+8]|=64;HEAP[g+20]=HEAP[f+84];if(HEAP[g+20]==0)HEAP[g+20]=HEAP[f+80];HEAP[g+24]=HEAP[f+88];HEAP[g+28]=0;HEAP[g+32]=0;y=g+52;A=f+20;HEAP[y]=HEAP[A];
HEAP[y+4]=HEAP[A+4];HEAP[y+8]=HEAP[A+8];HEAP[y+12]=HEAP[A+12];HEAP[g+68]=HEAP[f+12]&65535;HEAP[g+70]=HEAP[f+20+12]&65535;HEAP[g+72]=HEAP[f+20+4]&65535;y=unSign(HEAP[g+68],16)*12;y=Math.floor(reSign(y,32)/reSign(10,32))&65535;HEAP[g+74]=y;y=reSign(HEAP[g+74],16);A=reSign(HEAP[g+70],16);d=reSign(HEAP[g+72],16);A=A-d;if(reSign(y,32)<reSign(A,32))HEAP[g+74]=HEAP[g+70]-HEAP[g+72];if(HEAP[f+92]!=0){y=HEAP[f+92];A=HEAP[HEAP[g+104]+28];A=_ft_mem_realloc(A,16,0,y,0,x);HEAP[g+32]=A;if(HEAP[x]!=0){a=4;break a}d=
HEAP[g+32];A=HEAP[f+100];h=y;if(unSign(0,32)<unSign(h,32)){h=y;A=A;d=d;h=(unSign(h,32)>unSign(1,32)?h:1)-0;for(c=122;;){z=c==122?0:z;i=d+16*z+12;I=d+16*z+8;J=d+16*z+4;L=d+16*z+2;N=A+36*z+4;K=A+36*z;HEAP[d+16*z]=HEAP[N]&65535;HEAP[L]=HEAP[K]&65535;HEAP[J]=HEAP[N]<<6;HEAP[I]=HEAP[K]<<6;HEAP[i]=HEAP[N]<<6;z=z+1;if(z!=h)c=123;else{c=123;break}}}HEAP[g+28]=y}if((HEAP[f+36]&4)==0)HEAP[g+76]=HEAP[f+40]&65535;else{y=0;A=d=HEAP[f+120];z=HEAP[f+128];if(d!=0){z=z;y=y;A=A;for(c=128;;){R=c==128?0:R;Q=c==128?y:
Q;d=z+16*R+4;if(reSign(HEAP[d],32)>reSign(Q,32)){var M=HEAP[d];c=130}else c=129;var Q=c==130?M:Q,R=R+1;if(R!=A)c=132;else{c=132;break}}y=Q}HEAP[g+76]=y&65535}HEAP[g+78]=HEAP[g+74];M=0-unSign(HEAP[g+68],16);M=Math.floor(reSign(M,32)/reSign(10,32))&65535;HEAP[g+80]=M;M=Math.floor(unSign(HEAP[g+68],16)/unSign(30,16));HEAP[g+82]=M;HEAP[C]=g;HEAP[C+8]=3;HEAP[C+10]=1;HEAP[C+4]=1970170211;C=_FT_CMap_New(_pfr_cmap_class_rec,0,C,0);HEAP[x]=C;if(HEAP[f+132]==0){a=4;break a}HEAP[g+8]|=64;a=4;break a}while(0);
HEAP[x]=c==50?p:n;a=4;break a}}}while(0);HEAP[x]=c==137?a:c==16?t:c==19?85:c==21?v:c==22?o:c==23?q:c==24?E:F}}a=4;break a}else{c=-1;a=2}while(0);if(a==2)HEAP[x]=c==-1?B:D;g=HEAP[x];STACKTOP=b;return g}_pfr_face_init.__index__=Runtime.getFunctionIndex(_pfr_face_init,"_pfr_face_init");
function _pfr_slot_init(e){var g;g=HEAP[HEAP[e+156]];e=e+160;_llvm_memset_p0i8_i32(e,0,36,1,0);HEAP[e+28]=g;HEAP[e+32]=0;e=g+20;g=g+56;HEAP[e+2]=0;HEAP[e]=0;HEAP[e+28]=0;_llvm_memcpy_p0i8_p0i8_i32(g,e,36,4,0);return 0}_pfr_slot_init.__index__=Runtime.getFunctionIndex(_pfr_slot_init,"_pfr_slot_init");
function _pfr_slot_done(e){var g,d;e=e+160;d=HEAP[HEAP[e+28]];g=HEAP[e+8];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+8]=0;HEAP[e+12]=0;HEAP[e+4]=0;g=HEAP[e+24];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+24]=0;HEAP[e+20]=0;HEAP[e+16]=0;HEAP[e+28]=0;HEAP[e+32]=0}_pfr_slot_done.__index__=Runtime.getFunctionIndex(_pfr_slot_done,"_pfr_slot_done");
function _pfr_slot_load(e,g,d,b){var a=STACKTOP;STACKTOP+=80;Runtime.memset(a,0,80);var c,f=null,h,i,k,j,l,m,o,n,p,r,q,s,u,t,v,w,x,y,A,z,C,B,D,E,F,G,H,J=a+8,L,N,I,P,K,O,M,Q,R;L=a+28;B=a+32;j=a+36;l=a+40;m=a+44;i=a+48;o=a+52;h=a+56;var T=a+60,V,U=a+64;k=d;V=HEAP[e+4];d=e+108;if(k!=0)k-=1;M=V==0;a:do if(M)c=1;else{M=k;if(unSign(HEAP[V+288+120],32)<=unSign(M,32)){c=1;break a}w=(b&9)==0;b:do if(w){M=g;Q=k;O=e;M=M;f=Q;Q=HEAP[O+4];R=HEAP[Q+104];z=Q+288;C=HEAP[z+128]+16*f;n=HEAP[z+100];r=HEAP[z+92];u=M+
12;s=M+12+2;n=n;f=4;c:for(;;){f=f==8?E:0;q=0+f;c=n+36*f+4;p=D=n+36*f;if(!(unSign(r,32)>unSign(q,32))){c=10;break c}q=HEAP[p];p=unSign(HEAP[u],16);if(q==p){c=HEAP[c];q=unSign(HEAP[s],16);if(c==q){c=6;break c}}E=f+1;f=8;c=5}if(c!=10)if(c==6){n=D;r=4;if((HEAP[n+8]&1&255)!=0)r+=1;if((HEAP[n+8]&2)!=0)r+=1;if((HEAP[n+8]&4)!=0)r+=1;u=_FT_Stream_Seek(R,HEAP[n+24]+HEAP[z+144])!=0;c:do if(!u){f=_FT_Stream_EnterFrame(R,r*HEAP[n+28]);if(f!=0){c=16;break c}f=HEAP[C];s=HEAP[n+8];q=HEAP[n+28];c=HEAP[R+36];y=HEAP[R+
32];c=c;I=q;q=s;P=f;s=L;p=B;f=q&255&1;t=4;if(f!=0)t+=1;if((q&2)!=0)t+=1;if((q&4)!=0)t+=1;K=I;I=t;y=y;t=t;x=c;P=A=P;K=K;if(f!=0){f=21;c=22}else{f=21;c=23}d:for(;;)if(c==22){var S=f==21?K:G,X=f==21?0:F;for(f=22;;){F=f==26?G:X;if(!(unSign(F,32)<unSign(S,32))){c=25;break d}G=unSign(F+S,32)>>>unSign(1,32);v=y+G*I;if(v+t>x){c=25;break d}v+=2;f=unSign(HEAP[v+-2],8)<<8&65535;c=unSign(HEAP[v+-2+1],8);f=unSign(f|c,16);if(f==A){c=29;break d}if(unSign(f,32)<unSign(P,32)){f=26;c=27}else{f=26;c=22;continue d}}}else if(c==
23){S=f==21?K:N;X=f==21?0:H;for(f=23;;){H=f==31?N:X;if(!(unSign(H,32)<unSign(S,32))){c=25;break d}N=unSign(H+S,32)>>>unSign(1,32);v=y+N*I;if(v+t>x){c=25;break d}f=unSign(HEAP[v],8);v+=1;if(f==A){c=29;break d}if(unSign(f,32)<unSign(P,32)){f=31;c=32}else{f=31;c=23;continue d}}}if(c==25){HEAP[p]=0;HEAP[s]=0}else if(c==29){f=v;if((q&2)!=0){v=f+2;f=unSign(HEAP[v+-2],8)<<8&65535;I=unSign(HEAP[v+-2+1],8);f=unSign(f|I,16);HEAP[p]=f}else{f=unSign(HEAP[f],8);HEAP[p]=f;v+=1}f=v;if((q&4)!=0){v=f+3;f=unSign(HEAP[v+
-3],8)<<16;q=unSign(HEAP[v+-3+1],8)<<8;p=unSign(HEAP[v+-3+2],8);HEAP[s]=q|f|p}else{v=f+2;f=unSign(HEAP[v+-2],8)<<8&65535;q=unSign(HEAP[v+-2+1],8);f=unSign(f|q,16);HEAP[s]=f}}f=R;if(HEAP[f+20]!=0){s=HEAP[f+28];q=HEAP[f];s=s;q=q;q!=0&&FUNCTION_TABLE[HEAP[s+8]](s,q);HEAP[f]=0}HEAP[f+32]=0;HEAP[f+36]=0;if(HEAP[B]!=0){HEAP[j]=0;HEAP[l]=0;HEAP[m]=0;HEAP[i]=0;HEAP[o]=0;HEAP[h]=0;HEAP[m]=HEAP[C+4];if(HEAP[z+16]!=HEAP[z+12]){f=_FT_MulDiv(HEAP[m],HEAP[z+12],HEAP[z+16]);HEAP[m]=f}HEAP[O+56]=HEAP[m];f=HEAP[z+
16];c=HEAP[C+4];z=unSign(HEAP[M+12],16)<<8;f=_FT_MulDiv(z,c,f);HEAP[m]=f;if(_FT_Stream_Seek(R,HEAP[L]+HEAP[Q+132+56])!=0){c=16;break c}f=_FT_Stream_EnterFrame(R,HEAP[B]);if(f!=0){c=16;break c}else f=42;HEAP[T]=HEAP[R+32];B=HEAP[m];D=HEAP[R+36];L=T;w=D;C=B;E=j;F=l;G=i;H=o;N=m;B=h;D=HEAP[L];v=D+1>w;d:do if(v)c=44;else{v=HEAP[D];D+=1;n=r=z=s=u=0;c=unSign(v,8)&3;c=c==0?131:c==1?132:c==2?133:c==3?134:135;if(c==131){if(D+1>w){c=44;break d}c=HEAP[D];D+=1;u=reSign(c,8)>>reSign(4,8);u=reSign(u,8);c=reSign(c,
8)<<4&255;c=reSign(c,8)>>reSign(4,8);s=reSign(c,8)}else if(c==132){if(D+2>w){c=44;break d}u=reSign(HEAP[D],8);D+=1;s=reSign(HEAP[D],8);D+=1}else if(c==133){if(D+4>w){c=44;break d}D+=2;c=reSign(HEAP[D+-2],8)<<8&65535;u=unSign(HEAP[D+-2+1],8);u=reSign(c|u,16);D+=2;c=reSign(HEAP[D+-2],8)<<8&65535;s=unSign(HEAP[D+-2+1],8);s=reSign(c|s,16)}else if(c==134){if(D+6>w){c=44;break d}D+=3;c=reSign(HEAP[D+-3],8)<<16;u=unSign(HEAP[D+-3+1],8)<<8;s=unSign(HEAP[D+-3+2],8);u=u|c|s;D+=3;c=reSign(HEAP[D+-3],8)<<16;
s=unSign(HEAP[D+-3+1],8)<<8;q=unSign(HEAP[D+-3+2],8);s=s|c|q}v=unSign(v,8)>>>unSign(2,8);c=unSign(v,8)&3;c=c==0?136:c==1?137:c==2?138:c==3?139:140;if(c==136)r=z=0;else if(c==137){if(D+1>w){c=44;break d}c=HEAP[D];D+=1;z=reSign(c,8)>>reSign(4,8);z=reSign(z,8)&15;r=reSign(c,8)&15}else if(c==138){if(D+2>w){c=44;break d}z=unSign(HEAP[D],8);D+=1;r=unSign(HEAP[D],8);D+=1}else if(c==139){if(D+4>w){c=44;break d}D+=2;c=unSign(HEAP[D+-2],8)<<8&65535;z=unSign(HEAP[D+-2+1],8);z=unSign(c|z,16);D+=2;c=unSign(HEAP[D+
-2],8)<<8&65535;r=unSign(HEAP[D+-2+1],8);r=unSign(c|r,16)}v=unSign(v,8)>>>unSign(2,8);c=unSign(v,8)&3;c=c==0?141:c==1?142:c==2?143:c==3?144:58;if(c==141)n=C;else if(c==142){if(D+1>w){c=44;break d}n=reSign(HEAP[D],8)<<8;D+=1}else if(c==143){if(D+2>w){c=44;break d}D+=2;f=reSign(HEAP[D+-2],8)<<8&65535;var Y=unSign(HEAP[D+-2+1],8);n=reSign(f|Y,16)}else if(c==144){if(D+3>w){c=44;break d}D+=3;f=reSign(HEAP[D+-3],8)<<16;Y=unSign(HEAP[D+-3+1],8)<<8;c=unSign(HEAP[D+-3+2],8);n=Y|f|c}HEAP[E]=u;HEAP[F]=s;HEAP[G]=
z;HEAP[H]=r;HEAP[N]=n;f=unSign(v,8)>>>unSign(2,8);f=unSign(f,8);HEAP[B]=f;HEAP[L]=D;Y=0;f=58;c=59;break d}while(0);if(c==44)f=44;f=Y=f==58?Y:8;L=reSign(HEAP[o]+HEAP[l],32)<reSign(0,32);d:do if(L)f=23;else{if(Y!=0)break d;HEAP[O+72]=1651078259;HEAP[O+76+4]=HEAP[i];HEAP[O+76]=HEAP[o];f=reSign(HEAP[i]+7,32)>>reSign(3,32);HEAP[O+76+8]=f;HEAP[O+76+18]=1;HEAP[O+24]=HEAP[i]<<6;HEAP[O+24+4]=HEAP[o]<<6;HEAP[O+24+8]=HEAP[j]<<6;HEAP[O+24+12]=HEAP[l]<<6;f=(reSign(HEAP[m],32)>>reSign(2,32))+32&-64;HEAP[O+24+16]=
f;f=reSign(0-HEAP[O+24],32)>>reSign(1,32);HEAP[O+24+20]=f;HEAP[O+24+24]=0;HEAP[O+24+28]=HEAP[M+12+20];HEAP[O+100]=HEAP[j];HEAP[O+104]=HEAP[o]+HEAP[l];f=HEAP[o]*HEAP[O+76+8];f=_ft_glyphslot_alloc_bitmap(O,f);if(f!=0)break d;f=O+76;B=unSign(HEAP[Q+132+76]&255,8)&2;E=HEAP[h];D=HEAP[R+36];F=B&255;B=HEAP[T];D=D;E=E;F=F;G=f;H=0;N=reSign(HEAP[G],32)>reSign(0,32);e:do if(N){if(!(reSign(HEAP[G+4],32)>reSign(0,32)))break e;f=unSign(F,8);c=G;v=f&255;f=J;c=c;v=v;HEAP[f]=HEAP[c+12];HEAP[f+4]=HEAP[c+8];HEAP[f+
8]=HEAP[c+4];HEAP[f+12]=HEAP[c];HEAP[f+16]=HEAP[f+12]*HEAP[f+8];if(v==0){HEAP[f]+=(HEAP[c]-1)*HEAP[f+4];HEAP[f+4]=0-HEAP[f+4]}f=E;c=f==0?145:f==1?146:f==2?147:148;if(c==148)H=3;else if(c==145){c=B;f=D;n=J;p=c;f=f;q=HEAP[n+8];s=HEAP[n];u=0;c=r=(f-p)*8;if(reSign(HEAP[n+16],32)<reSign(c,32)){var W=HEAP[n+16];r=W;f=68}else f=145;c=f==68?W:c;f=c&7;if(reSign(c,32)>reSign(0,32)){c=f;v=n+8;w=n;z=n+4;n=C=n;r=r;u=u;s=s;q=q;p=p;I=0-r;f=reSign(I,32)>reSign(-1,32)?I:-1;y=r+f+1;f=70;f:for(;;){ja=f==70?0:ja;aa=
f==70?p:aa;ca=f==70?0:ca;ia=f==70?128:ia;ha=f==70?q:ha;Z=f==70?s:Z;ea=f==70?u:ea;if((r+ja*-1&7)==c){var da=unSign(HEAP[aa],8),ba=aa+1;f=72}else f=71;var aa=f==72?ba:aa;ca=f==72?da:ca;f=ea|ia;ea=(ca&128)!=0?f:ea;var ca=ca<<1;ia=unSign(ia,32)>>>unSign(1,32);ha=ha-1;t=reSign(ha,32)<=reSign(0,32);g:do if(t){HEAP[Z]=ea&255;var $=HEAP[v];HEAP[C]=HEAP[w]+HEAP[z];var la=HEAP[n];f=74}else{if(ia!=0){f=76;break g}HEAP[Z]=ea&255;var ga=Z+1;f=77}while(0);var ea=f==77?0:f==76?ea:0,Z=f==77?ga:f==76?Z:la,ha=f==77?
ha:f==76?ha:$,ia=f==77?128:f==76?ia:128,ja=ja+1;if(ja!=y)f=78;else break f}reSign(I,32);reSign(-1,32);s=Z;u=ea;f=79}else{var fa=128;f=81}if((f==81?fa:ia)==128)break e;HEAP[s]=u&255}else if(c==146){v=B;f=D;c=J;t=v;v=f;z=HEAP[c+8];C=HEAP[c];n=128;r=0;w=HEAP[c+16];x=1;HEAP[a]=0;y=HEAP[a+4]=0;A=1;u=reSign(w,32)>reSign(0,32);f:do if(u){s=a;q=a+4;p=a+4;I=A;f=84;for(;;){if((f==84?I:ua)!=0){var ka=v;ua=x;t=t;x=HEAP[s];for(f=86;;){var na=f==86?x:ta,sa=f==86?t:ma,wa=f==86?ua:ya;if(wa!=0){if(sa>=ka){f=88;break}ta=
unSign(HEAP[sa],8);var Aa=sa+1,Da=reSign(ta,32)>>reSign(4,32);HEAP[q]=ta&15;y=Da;f=90}else{var pa=HEAP[p];y=pa;f=92}var ta=f==92?na:Da,ma=f==92?sa:Aa,ya=f==92?1:0;if((f==92?pa:Da)==0)f=93;else{f=93;break}}ua=f==88?sa:ma;ka=f==88?wa:ya;HEAP[s]=f==88?na:ta;t=ua;x=ka;f=89}else{var qa=x;f=95}if((f==95?qa:ka)!=0)r=n|r;n=unSign(n,32)>>>unSign(1,32);z=ua=z-1;ua=reSign(ua,32)<=reSign(0,32);h:do if(ua){HEAP[C]=r&255;z=HEAP[c+8];n=128;HEAP[c]+=HEAP[c+4];C=HEAP[c];r=0}else{if(n!=0)break h;HEAP[C]=r&255;n=128;
r=0;C+=1}while(0);y-=1;ua=reSign(y,32)<=reSign(0,32);var ua=unSign(ua,1);A=ua;w=f=w-1;if(reSign(f,32)>reSign(0,32))f=99;else break f}}while(0);if(n==128)break e;HEAP[C]=r&255}else if(c==147){f=B;c=D;r=J;f=f;v=c;p=HEAP[r+8];s=HEAP[r];q=128;u=0;c=w=HEAP[r+16];if(reSign(w,32)>reSign(0,32)){v=v;w=r+8;z=r;C=r+4;r=n=r;u=u;s=s;q=q;p=p;I=f;y=c+-1;f=102;f:for(;;){t=f==102?0:Sa;A=f==104?va:I;P=f==104?Pa:1;Ra=f==104?Ra:p;Qa=f==104?Qa:q;Va=f==104?Va:s;Ta=f==104?Ta:u;Ua=f==104?Ua:0;x=y+t*-1;if((f==104?ab:1)!=
0){f=103;c=105}else{f=103;c=106}g:for(;;)if(c==105){ab=f==107?Ca:0;var Ba=f==107?Ha:P,Na=f==107?0:Ua,Ea=A+(ab+1),ra=A+ab;if(ra>=v){f=105;c=106;continue g}var za=unSign(HEAP[ra],8),Ha=Ba^1,Ca=ab+1;if(za==0){f=107;c=105}else{f=107;c=106}}else if(c==106){var va=f==103?A:f==107?Ea:ra,Pa=f==103?P:f==107?Ha:Ba,Ja=f==103?Ua:f==107?za:Na,La=Ta|Qa;La=Pa!=0?La:Ta;var xa=unSign(Qa,32)>>>unSign(1,32),oa=Ra-1;c=reSign(oa,32)<=reSign(0,32)?108:109;break g}g:do if(c==108){HEAP[Va]=La&255;var Fa=HEAP[w];HEAP[n]=
HEAP[z]+HEAP[C];var Ma=HEAP[r];f=108}else if(c==109){if(xa!=0){f=109;break g}HEAP[Va]=La&255;var Ka=Va+1;f=111}while(0);var Ra=f==111?oa:f==109?oa:Fa,Qa=f==111?128:f==109?xa:128,Va=f==111?Ka:f==109?Va:Ma,Ta=f==111?0:f==109?La:0,Ua=Ja-1;ab=reSign(Ua,32)<=reSign(0,32);var ab=unSign(ab,1);if(!(reSign(x,32)>reSign(0,32)))break f;var Sa=t+1;f=104}q=Qa;s=Va;u=Ta}if(q==128)break e;HEAP[s]=u&255}}while(0);f=f=f=H}while(0);J=R;if(HEAP[J+20]!=0){j=HEAP[J+28];l=HEAP[J];j=j;l=l;l!=0&&FUNCTION_TABLE[HEAP[j+8]](j,
l);HEAP[J]=0}HEAP[J+32]=0;HEAP[J+36]=0;O=J=f;if(J==0){c=118;break a}else break b}}while(0)}}while(0);if((b&16384)!=0)O=6;else{J=HEAP[V+288+128]+16*k;HEAP[e+72]=1869968492;HEAP[d+2]=0;HEAP[d]=0;k=HEAP[V+132+56];i=HEAP[J+8];m=HEAP[J+12];j=HEAP[V+104];l=k;k=e+160;j=j;l=l;m=m;o=i;h=HEAP[k+28];i=h+20;h=h+56;HEAP[i+2]=0;HEAP[i]=0;HEAP[i+28]=0;_llvm_memcpy_p0i8_p0i8_i32(h,i,36,4,0);HEAP[k+16]=0;O=k=k=_pfr_glyph_load_rec(k,j,l,m,o);if(O!=0){c=118;break a}k=e+24;b=unSign((b&1)==0,1);j=d;l=HEAP[e+160+28]+20;
HEAP[j]=HEAP[l];HEAP[j+2]=HEAP[l+2];HEAP[j+4]=HEAP[l+4];HEAP[j+8]=HEAP[l+8];HEAP[j+12]=HEAP[l+12];HEAP[j+16]=HEAP[l+16];HEAP[d+16]&=-2;HEAP[d+16]|=4;j=g!=0;b:do if(j){if(!(unSign(HEAP[g+12+2],16)<=unSign(23,16)))break b;HEAP[d+16]|=256}while(0);HEAP[k+16]=0;HEAP[k+28]=0;J=HEAP[J+4];j=HEAP[V+288+16];l=HEAP[V+288+12];if(j!=l)J=_FT_MulDiv(J,l,j);j=k;if((HEAP[V+288+36]&1&255)!=0)HEAP[j+28]=J;else HEAP[j+16]=J;HEAP[e+56]=HEAP[k+16];HEAP[e+60]=HEAP[k+28];HEAP[k+20]=0;HEAP[k+24]=0;if(b!=0){e=HEAP[g+12+4];
g=HEAP[g+12+8];j=HEAP[d+4];V=reSign(HEAP[d+2],16);if(reSign(V,32)>reSign(0,32)){V=e;b=g;J=d+2;j=j;for(f=126;;){$a=f==126?0:$a;l=1+$a;m=j+8*$a+4;i=j+8*$a;o=_FT_MulFix(HEAP[i],V);HEAP[i]=o;i=_FT_MulFix(HEAP[m],b);HEAP[m]=i;m=reSign(HEAP[J],16);l=reSign(m,32)>reSign(l,32);var $a=$a+1;if(l)f=127;else break}}$a=_FT_MulFix(HEAP[k+16],e);HEAP[k+16]=$a;$a=_FT_MulFix(HEAP[k+28],g);HEAP[k+28]=$a}_FT_Outline_Get_CBox(d,U);HEAP[k]=HEAP[U+8]-HEAP[U];HEAP[k+4]=HEAP[U+12]-HEAP[U+4];HEAP[k+8]=HEAP[U];HEAP[k+12]=
HEAP[U+12]-HEAP[k+4]}c=118;break a}while(0);if(c==1)O=6;U=O;STACKTOP=a;return U}_pfr_slot_load.__index__=Runtime.getFunctionIndex(_pfr_slot_load,"_pfr_slot_load");
function _pfr_face_get_kerning(e,g,d,b){var a,c=null,f,h,i,k,j,l,m,o,n,p,r,q;g=g;d=d;j=0;l=e+288;HEAP[b]=0;HEAP[b+4]=0;if(g!=0)g-=1;if(d!=0)d-=1;var s=g;s=unSign(HEAP[l+120],32)<unSign(s,32);a:do if(!s){i=d;if(unSign(HEAP[l+120],32)<unSign(i,32))break a;f=HEAP[HEAP[l+128]+16*g];i=HEAP[HEAP[l+128]+16*d];f=f<<16;h=unSign(i&65535,16)|f;f=o=HEAP[l+136];i=HEAP[e+104];k=m=h;f=f;c=3;b:for(;;){var u=c==7?t:f;if((c==7?t:o)==0){a=9;break b}if(unSign(HEAP[u+16],32)<=unSign(m,32))if(unSign(HEAP[u+20],32)>=unSign(k,
32)){a=5;break b}var t=HEAP[u];c=7;a=4}if(a!=9)if(a==5){f=u;j=_FT_Stream_Seek(i,HEAP[f+12]);if(j!=0)break a;j=unSign(HEAP[f+4],8);j=_FT_Stream_EnterFrame(i,HEAP[f+8]*j);if(j!=0)break a;m=unSign(HEAP[f+4],8);o=HEAP[f+8];a=m;k=r=a-1&a;if(r!=0){a=k;for(c=12;;){var v=c==12?a:w,w=v-1&v;if(w==0)break;else c=13}a=v}a=a=a=a;k=o*a;n=m-a;p=HEAP[i+32];r=HEAP[f+5]&1;m=HEAP[f+5]&2;var x=n!=0;b:do if(x){q=q=p+o*n;if(r!=0){q=q+4;a=unSign(HEAP[q+-4],8)<<24;n=unSign(HEAP[q+-4+1],8)<<16;x=unSign(HEAP[q+-4+2],8)<<8;
var y=unSign(HEAP[q+-4+3],8);a=n|a|x|y}else{q=q+2;a=unSign(HEAP[q+-2],8)<<16;a=unSign(HEAP[q+-1],8)|a}if(a==h){a=17;break b}n=h;if(!(unSign(a,32)<unSign(n,32))){a=20;break b}q=q;p=q=m!=0?q+2:q+1;a=20;break b}else a=20;while(0);b:do if(a==20){n=o;y=x=h;var A=k,z=p;if(r!=0){c=20;a=22}else{c=20;a=23}for(;;)if(a==22){var C=c==20?z:c==26?C:F;a=c==20?A:c==27?B:B;if(!(unSign(a,32)>unSign(n,32))){c=22;a=25;break}var B=unSign(a,32)>>>unSign(1,32);q=C+B;q+=4;a=unSign(HEAP[q+-4],8)<<24;c=unSign(HEAP[q+-4+1],
8)<<16;var D=unSign(HEAP[q+-4+2],8)<<8,E=unSign(HEAP[q+-4+3],8);a=c|a|D|E;if(a==x){c=24;a=28;break}if(unSign(a,32)<unSign(y,32)){var F=C+B;c=27}else c=26;a=22}else if(a==23){var G=c==20?z:c==30?G:J;a=c==20?A:c==30?H:H;if(!(unSign(a,32)>unSign(n,32))){c=23;a=25;break}var H=unSign(a,32)>>>unSign(1,32);q=G+H;q+=2;a=unSign(HEAP[q+-2],8)<<16;a=unSign(HEAP[q+-1],8)|a;if(a==x){c=29;a=28;break}if(unSign(a,32)<unSign(y,32)){var J=G+H;c=31}else c=30;a=23}if(a==25){q=q=p=c==22?C:G;if(r!=0){q=q+4;o=unSign(HEAP[q+
-4],8)<<24;a=unSign(HEAP[q+-4+1],8)<<16;k=unSign(HEAP[q+-4+2],8)<<8;r=unSign(HEAP[q+-4+3],8);a=a|o|k|r}else{q=q+2;o=unSign(HEAP[q+-2],8)<<16;a=unSign(HEAP[q+-1],8)|o}a=a==h?17:33;break b}else if(a==28){a=17;break b}}while(0);if(a==17){h=HEAP[q];if(m!=0){h=reSign(h,8)<<8&65535;h=unSign(HEAP[q+1],8)|h;h=reSign(h,16)}else h=unSign(h,8);f=reSign(HEAP[f+6],16);HEAP[b]=f+h}i=i;if(HEAP[i+20]!=0){f=HEAP[i+28];h=HEAP[i];f=f;h=h;h!=0&&FUNCTION_TABLE[HEAP[f+8]](f,h);HEAP[i]=0}HEAP[i+32]=0;HEAP[i+36]=0}}while(0);
return j}_pfr_face_get_kerning.__index__=Runtime.getFunctionIndex(_pfr_face_get_kerning,"_pfr_face_get_kerning");function _pfr_get_kerning(e,g,d,b){var a;a=e+288;_pfr_face_get_kerning(e,g,d,b);e=HEAP[a+12]!=HEAP[a+16];a:do if(e){if(HEAP[b]!=0){g=_FT_MulDiv(HEAP[b],HEAP[a+12],HEAP[a+16]);HEAP[b]=g}if(HEAP[b+4]==0)break a;g=_FT_MulDiv(HEAP[b],HEAP[a+12],HEAP[a+16]);HEAP[b+4]=g}while(0);return 0}_pfr_get_kerning.__index__=Runtime.getFunctionIndex(_pfr_get_kerning,"_pfr_get_kerning");
function _pfr_get_advance(e,g,d){var b,a;g=g;b=6;HEAP[d]=0;var c=g==0;a:do if(!c){g-=1;if(e==0)break a;a=e+288;var f=g;if(!(unSign(HEAP[a+120],32)>unSign(f,32)))break a;HEAP[d]=HEAP[HEAP[a+128]+16*g+4];b=0}while(0);return b}_pfr_get_advance.__index__=Runtime.getFunctionIndex(_pfr_get_advance,"_pfr_get_advance");
function _pfr_get_metrics(e,g,d,b,a){var c;c=e+288;e=HEAP[e+88];if(g!=0)HEAP[g]=HEAP[c+12];if(d!=0)HEAP[d]=HEAP[c+16];d=g=65536;if(e!=0){g=HEAP[c+16];d=unSign(HEAP[e+12],16)<<6;g=_FT_DivFix(d,g);c=HEAP[c+16];e=unSign(HEAP[e+12+2],16)<<6;d=_FT_DivFix(e,c)}if(b!=0)HEAP[b]=g;if(a!=0)HEAP[a]=d;return 0}_pfr_get_metrics.__index__=Runtime.getFunctionIndex(_pfr_get_metrics,"_pfr_get_metrics");function _pfr_get_service(e,g){return _ft_service_list_lookup(_pfr_services,g)}
_pfr_get_service.__index__=Runtime.getFunctionIndex(_pfr_get_service,"_pfr_get_service");
function _T42_Face_Init(e,g,d,b,a){e=STACKTOP;STACKTOP+=372;Runtime.memset(e,0,372);var c,f=null,h,i,k,j,l,m,o,n=e+4,p,r=e+16,q=e+20,s,u,t=e+324,v,w,x,y,A,z,C=e+328,B=e+360;z=g+132;HEAP[g+500]=0;HEAP[g]=1;A=_ft_module_get_service(HEAP[g+96],__str60);HEAP[g+484]=A;y=_FT_Get_Module(HEAP[HEAP[g+96]+4],__str61);HEAP[g+488]=y!=0?HEAP[HEAP[y]+20]:0;y=HEAP[g+488];s=g+132;u=HEAP[g+100];v=HEAP[g+488];_llvm_memset_p0i8_i32(q,0,304,1,0);HEAP[q+144]=0;HEAP[q+88]=0;HEAP[q+92+12]=0;HEAP[q+200+12]=0;HEAP[q+148+
12]=0;var D=_ft_mem_alloc(u,12,t);HEAP[g+492]=D;D=HEAP[t]!=0;a:do if(!D){l=HEAP[g+104];j=u;c=v;m=q;l=l;j=j;c=c;HEAP[r]=0;FUNCTION_TABLE[HEAP[HEAP[c+4]]](m,0,0,j);HEAP[m+72]=l;HEAP[m+80]=0;HEAP[m+76]=0;HEAP[m+84]=0;c=_FT_Stream_Seek(l,0);HEAP[r]=c;p=HEAP[r]!=0;b:do if(p)c=1;else{c=_FT_Stream_EnterFrame(l,17);HEAP[r]=c;if(HEAP[r]!=0){c=1;break b}if(_memcmp(HEAP[l+32],__str24193,17)!=0)HEAP[r]=2;c=l;if(HEAP[c+20]!=0){p=HEAP[c+28];k=HEAP[c];p=p;k=k;k!=0&&FUNCTION_TABLE[HEAP[p+8]](p,k);HEAP[c]=0}HEAP[c+
32]=0;HEAP[c+36]=0;if(HEAP[r]!=0){c=1;break b}c=_FT_Stream_Seek(l,0);HEAP[r]=c;if(HEAP[r]!=0){c=1;break b}c=HEAP[l+4];if(HEAP[l+20]==0){HEAP[m+76]=HEAP[l]+HEAP[l+8];HEAP[m+80]=c;HEAP[m+84]=1;p=c;c=l;l=p;if(reSign(l,32)<reSign(0,32)){HEAP[r]=85;c=1;break b}else{c=_FT_Stream_Seek(c,l+HEAP[c+8]);HEAP[r]=c;if(c!=0){c=1;break b}}}else{p=_ft_mem_alloc(j,c,r);HEAP[m+76]=p;if(HEAP[r]!=0){c=1;break b}p=c;k=HEAP[m+76];l=l;k=k;p=p;l=l=_FT_Stream_ReadAt(l,HEAP[l+8],k,p);HEAP[r]=l;if(HEAP[r]!=0){c=1;break b}HEAP[m+
80]=c}HEAP[m+4]=HEAP[m+76];HEAP[m]=HEAP[m+76];HEAP[m+8]=HEAP[m]+HEAP[m+80];c=HEAP[r];if(c!=0){c=1;break b}HEAP[t]=c;c=12;break b}while(0);if(c==1){if(HEAP[m+84]==0){l=HEAP[m+76];j=j;l=l;l!=0&&FUNCTION_TABLE[HEAP[j+8]](j,l);HEAP[m+76]=0}m=HEAP[r];HEAP[t]=m;if(m!=0){c=15;break a}}m=HEAP[q+80];j=HEAP[q+76];f=g;k=q;j=j;l=m;m=k;HEAP[m]=j;HEAP[m+8]=j+l;HEAP[m+12]=0;o=HEAP[m+8];FUNCTION_TABLE[HEAP[m+20+8]](m);p=l=j=o;f=f;var E=k;var F=k=o,G=o;o=o;x=n+8;w=f;var H=E,J=E+12,L=f+132,N=E+20+48,I=E,P=E+20+44;
E=E;var K=f+132+32,O=f+132,M=f+132+328;f=12;b:for(;;){if(!(HEAP[m]<j)){f=17;c=33;break b}var Q=HEAP[m],R=HEAP[Q],T=R!=70;c:do if(T){f=54;c=31}else{f=Q+25>=k;d:do if(!f){if(_strncmp(Q,__str58,13)!=0)break d;FUNCTION_TABLE[HEAP[m+20+12]](m);FUNCTION_TABLE[HEAP[m+20+8]](m);c=HEAP[m];f=19;e:for(;;){h=f==24?i:c;if(!(h<F))break e;if(HEAP[h]==107&h+5<G)if(_strncmp(h,__str29198,5)==0)break e;FUNCTION_TABLE[HEAP[m+20+12]](m);if(HEAP[m+12]!=0){c=23;break b}FUNCTION_TABLE[HEAP[m+20+8]](m);i=HEAP[m];f=24}T=h<
o;e:do if(T){FUNCTION_TABLE[HEAP[m+20+12]](m);FUNCTION_TABLE[HEAP[m+20+36]](m,n);if(HEAP[x]!=3){f=26;break e}var V=HEAP[m];f=27}else f=21;while(0);HEAP[m]=f==27?V:f==26?c:c;f=28;c=30;break c}while(0);var U=HEAP[Q];f=18;c=31;break c}while(0);c:do if(c==31)if((f==18?U:R)!=47|Q+2>=l){FUNCTION_TABLE[HEAP[m+20+12]](m);if(HEAP[m+12]!=0){f=53;c=33;break b}else f=53}else{T=Q+1;HEAP[m]=T;FUNCTION_TABLE[HEAP[m+20+12]](m);if(HEAP[m+12]!=0){f=32;c=33;break b}var S=HEAP[m]-T;f=reSign(S,32)>reSign(0,32);var X=
reSign(S,32)<=reSign(21,32);if(!(f&X))break c;if(!(HEAP[m]<p))break c;X=T;f=36;d:for(;;){f=f==39?da:0;var Y=_t42_keywords+f*36;c=Y;if(!(reSign(f,32)<reSign(20,32)))break c;c=HEAP[c];var W=c==0;e:do if(!W){if(HEAP[X]!=HEAP[c])break e;if(_strlen(c)!=S)break e;if(_memcmp(T,c,S)==0){c=41;break d}}while(0);var da=f+1;f=39;c=37}T=HEAP[Y+8]==10;d:do if(T){FUNCTION_TABLE[HEAP[Y+12]](w,H);var ba=HEAP[J];f=43}else{f=HEAP[Y+4];c=f==2?112:f==3?113:f==5?114:115;if(c==115)HEAP[e]=L;else if(c==112)HEAP[e]=K;else if(c==
113)HEAP[e]=O;else if(c==114)HEAP[e]=M;f=HEAP[Y+8]==8;e:do if(!f){if(HEAP[Y+8]==9){c=46;break e}var aa=FUNCTION_TABLE[HEAP[P]](E,Y,e,0,0);f=47;c=48;break d}while(0);var ca=FUNCTION_TABLE[HEAP[N]](I,Y,e,0,0);f=46}while(0);HEAP[m+12]=f==43?ba:f==46?ca:aa;if(HEAP[m+12]!=0){f=48;c=49;break b}else f=48}while(0);FUNCTION_TABLE[HEAP[m+20+8]](m);f=30;c=17}b:do if(c==33){c=55;break b}else if(c==49){var $=HEAP[m+12];f=49;c=51;break b}else if(c==23){c=55;break b}while(0);if(c==55){var la=HEAP[m+12];f=55}m=f==
49?$:la;HEAP[t]=m;if(m!=0){c=15;break a}if(HEAP[s+301]!=42)HEAP[t]=2;else{HEAP[s+284]=HEAP[q+144];if(HEAP[q+200+12]==0)HEAP[t]=3;HEAP[q+200+12]=0;HEAP[s+264]=HEAP[q+200];HEAP[s+292]=HEAP[q+200+24];HEAP[s+296]=HEAP[q+200+28];HEAP[s+268]=HEAP[q+148];HEAP[s+288]=HEAP[q+148+24];HEAP[q+148]=0;HEAP[q+148+24]=0;if(HEAP[s+236]!=1){c=15;break a}x=w=0;f=reSign(HEAP[q+92+16],32)>reSign(0,32);m=s+240;if(f){j=s+240+16;l=q+92+24;p=s+284;k=s+288;F=s+240+12;G=s+240+16;o=q+92+16;var ga=s+240;x=x;w=w;f=61;b:for(;;){ka=
f==61?0:ka;fa=f==61?w:fa;ja=f==61?x:ja;c=1+ka;H=0+ka;HEAP[HEAP[(f==61?m:ga)+12]+2*H]=0;HEAP[HEAP[j]+4*H]=__str650;J=HEAP[HEAP[l]+4*H];L=J!=0;c:do if(L){N=HEAP[p];for(f=63;;){var ea=f==66?ha:0;if(!(reSign(N,32)>reSign(ea,32))){f=64;break c}var Z=HEAP[HEAP[k]+4*ea];if(_strcmp(J,Z)==0)break;var ha=ea+1;f=66}HEAP[HEAP[F]+2*H]=ea&65535;HEAP[HEAP[G]+4*H]=Z;if(_strcmp(__str650,Z)==0){f=65;break c}var ia=reSign(H,32)<reSign(fa,32)?H:fa;if(!(reSign(H,32)>=reSign(ja,32))){f=67;break c}f=69}else f=62;while(0);
var ja=f==65?ja:f==67?ja:f==69?c:f==62?ja:ja,fa=f==65?fa:f==67?ia:f==69?ia:f==62?fa:fa;f=reSign(HEAP[o],32)>reSign(c,32);var ka=ka+1;if(f){f=68;c=62}else{c=72;break b}}w=fa;x=ja;f=72}else f=60;HEAP[(f==72?ga:m)+4]=w;HEAP[s+240+8]=x;HEAP[s+240]=HEAP[q+88]}}while(0);HEAP[q+92+36+12]!=0&&FUNCTION_TABLE[HEAP[q+92+36+12]](q+92);HEAP[q+200+36+12]!=0&&FUNCTION_TABLE[HEAP[q+200+36+12]](q+200);HEAP[q+148+36+12]!=0&&FUNCTION_TABLE[HEAP[q+148+36+12]](q+148);HEAP[q+252+36+12]!=0&&FUNCTION_TABLE[HEAP[q+252+36+
12]](q+252);i=HEAP[q+16];if(HEAP[q+84]==0){h=HEAP[q+76];h!=0&&FUNCTION_TABLE[HEAP[i+8]](i,h);HEAP[q+76]=0}FUNCTION_TABLE[HEAP[q+20+4]](q);t=q=HEAP[t];q=q!=0;a:do if(!q){if(reSign(d,32)<reSign(0,32))break a;if(reSign(d,32)>reSign(0,32))t=6;else{HEAP[g+16]=HEAP[z+284];HEAP[g+36]=0;HEAP[g+4]=0;HEAP[g+8]=529;if(HEAP[z+24]!=0)HEAP[g+8]|=4;HEAP[g+8]|=2048;HEAP[g+20]=HEAP[z+12];HEAP[g+24]=__str62;t=HEAP[g+20]!=0;b:do if(t){h=HEAP[z+8];i=HEAP[g+20];if(h==0)break b;h=h;i=i;f=84;c:for(;;){var na=f==84?i:f==
87?wa:f==88?na:Da,sa=f==84?h:f==87?Aa:f==88?pa:sa;if(HEAP[sa]==0){c=96;break c}if(HEAP[sa]==HEAP[na]){var wa=na+1,Aa=sa+1;f=87}else{V=HEAP[sa]==32;d:do if(!V){if(HEAP[sa]==45)break d;if(HEAP[na]!=32)if(HEAP[na]!=45){c=91;break c}var Da=na+1;f=92;c=86;continue c}while(0);var pa=sa+1;f=88}c=86}if(c!=96)if(c==91){i=na;h=sa;if(HEAP[i]!=0)break b;HEAP[g+24]=h}}else{if(HEAP[z+232]==0)break b;HEAP[g+20]=HEAP[z+232]}while(0);HEAP[g+28]=0;HEAP[g+32]=0;HEAP[C]=1;HEAP[C+4]=HEAP[g+492];HEAP[C+8]=HEAP[g+496];
if(b!=0){HEAP[C]|=16;HEAP[C+24]=b;HEAP[C+28]=a}t=h=_FT_Open_Face(HEAP[HEAP[g+96]+4],C,0,g+500);if(h!=0)break a;_FT_Done_Size(HEAP[HEAP[g+500]+88]);h=g+52;i=HEAP[g+500]+52;HEAP[h]=HEAP[i];HEAP[h+4]=HEAP[i+4];HEAP[h+8]=HEAP[i+8];HEAP[h+12]=HEAP[i+12];HEAP[g+68]=HEAP[HEAP[g+500]+68];HEAP[g+70]=HEAP[HEAP[g+500]+70];HEAP[g+72]=HEAP[HEAP[g+500]+72];HEAP[g+74]=HEAP[HEAP[g+500]+74];HEAP[g+76]=HEAP[HEAP[g+500]+76];HEAP[g+78]=HEAP[HEAP[g+500]+78];HEAP[g+80]=HEAP[z+26];HEAP[g+82]=HEAP[z+28];HEAP[g+12]=0;if(HEAP[z+
20]!=0)HEAP[g+12]|=1;if((HEAP[HEAP[g+500]+12]&2)!=0)HEAP[g+12]|=2;if((HEAP[HEAP[g+500]+8]&32)!=0)HEAP[g+8]|=32;if(A==0)break a;if(y==0)break a;h=HEAP[y+20];HEAP[B]=g;HEAP[B+8]=3;HEAP[B+10]=1;HEAP[B+4]=1970170211;t=_FT_CMap_New(HEAP[h+12],0,B,0);if(t!=0&t!=163)break a;t=0;HEAP[B+8]=7;i=0;V=HEAP[z+236];if(V==1)c=109;else if(V==2)c=106;else if(V==3)c=110;else if(V==4)c=108;else break a;if(c==109){HEAP[B+4]=1094992451;HEAP[B+10]=2;var ta=HEAP[h+8];i=ta;f=109}else if(c==106){HEAP[B+4]=1094995778;HEAP[B+
10]=0;var ma=HEAP[h];i=ma;f=106}else if(c==110){HEAP[B+4]=1818326065;HEAP[B+10]=3;var ya=HEAP[h+12];i=ya;f=110}else if(c==108){HEAP[B+4]=1094992453;HEAP[B+10]=1;var qa=HEAP[h+4];i=qa;f=108}if((f==110?ya:f==109?ta:f==108?qa:ma)==0)break a;t=_FT_CMap_New(i,0,B,0)}}while(0);g=t;STACKTOP=e;return g}_T42_Face_Init.__index__=Runtime.getFunctionIndex(_T42_Face_Init,"_T42_Face_Init");
function _T42_Face_Done(e){var g,d;if(e!=0){g=e+132;d=HEAP[e+100];HEAP[e+500]!=0&&_FT_Done_Face(HEAP[e+500]);var b=HEAP[g];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g]=0;b=HEAP[g+4];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+4]=0;b=HEAP[g+8];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+8]=0;b=HEAP[g+12];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+12]=0;b=HEAP[g+16];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+16]=0;b=HEAP[g+296];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+296]=0;b=HEAP[g+292];b!=0&&
FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+292]=0;b=HEAP[g+288];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+288]=0;b=HEAP[g+264];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+264]=0;b=HEAP[g+268];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+268]=0;b=HEAP[g+240+12];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+240+12]=0;b=HEAP[g+240+16];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+240+16]=0;b=HEAP[g+232];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g+232]=0;g=HEAP[e+492];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+
492]=0;g=HEAP[e+536+20];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+536+20]=0;HEAP[e+536+16]=0;HEAP[e+20]=0;HEAP[e+24]=0}}_T42_Face_Done.__index__=Runtime.getFunctionIndex(_T42_Face_Done,"_T42_Face_Done");function _T42_Driver_Init(e){var g=_FT_Get_Module(HEAP[e+4],__str49);HEAP[e+40]=HEAP[g];return 0}_T42_Driver_Init.__index__=Runtime.getFunctionIndex(_T42_Driver_Init,"_T42_Driver_Init");function _T42_Driver_Done(){}_T42_Driver_Done.__index__=Runtime.getFunctionIndex(_T42_Driver_Done,"_T42_Driver_Done");
function _T42_Size_Init(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d,b;b=_FT_New_Size(HEAP[HEAP[e]+500],g);HEAP[e+44]=HEAP[g];e=HEAP[g];var a=e==0;a:do if(!a){d=HEAP[e];var c=d==0;b:do if(!c){if(HEAP[d+96]==0)break b;HEAP[d+88]=e;break a}while(0)}while(0);STACKTOP=g;return b}_T42_Size_Init.__index__=Runtime.getFunctionIndex(_T42_Size_Init,"_T42_Size_Init");
function _T42_Size_Request(e,g){var d,b,a;a=HEAP[e];d=HEAP[e+44];var c=d==0;a:do if(!c){b=HEAP[d];var f=b==0;b:do if(!f){if(HEAP[b+96]==0)break b;HEAP[b+88]=d;break a}while(0)}while(0);d=_FT_Request_Size(HEAP[a+500],g);if(d==0){b=e+12;a=HEAP[HEAP[a+500]+88]+12;HEAP[b]=HEAP[a];HEAP[b+2]=HEAP[a+2];HEAP[b+4]=HEAP[a+4];HEAP[b+8]=HEAP[a+8];HEAP[b+12]=HEAP[a+12];HEAP[b+16]=HEAP[a+16];HEAP[b+20]=HEAP[a+20];HEAP[b+24]=HEAP[a+24]}return d}
_T42_Size_Request.__index__=Runtime.getFunctionIndex(_T42_Size_Request,"_T42_Size_Request");
function _T42_Size_Select(e,g){var d,b,a;a=HEAP[e];d=HEAP[e+44];var c=d==0;a:do if(!c){b=HEAP[d];var f=b==0;b:do if(!f){if(HEAP[b+96]==0)break b;HEAP[b+88]=d;break a}while(0)}while(0);d=_FT_Select_Size(HEAP[a+500],g);if(d==0){b=e+12;a=HEAP[HEAP[a+500]+88]+12;HEAP[b]=HEAP[a];HEAP[b+2]=HEAP[a+2];HEAP[b+4]=HEAP[a+4];HEAP[b+8]=HEAP[a+8];HEAP[b+12]=HEAP[a+12];HEAP[b+16]=HEAP[a+16];HEAP[b+20]=HEAP[a+20];HEAP[b+24]=HEAP[a+24]}return d}
_T42_Size_Select.__index__=Runtime.getFunctionIndex(_T42_Size_Select,"_T42_Size_Select");function _T42_Size_Done(e){var g,d=null,b=HEAP[e+44],a=HEAP[HEAP[HEAP[e]+500]+108];for(d=-1;;){g=d==2?c:a;if((d==2?c:a)==0){g=4;break}if(HEAP[g+8]==b){g=1;break}var c=HEAP[g+4];d=2;g=0}if(g==1){_FT_Done_Size(HEAP[e+44]);HEAP[e+44]=0}}_T42_Size_Done.__index__=Runtime.getFunctionIndex(_T42_Size_Done,"_T42_Size_Done");
function _T42_GlyphSlot_Init(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d,b;d=HEAP[e+4];b=0;var a=HEAP[d+500];if(HEAP[d+84]==0)HEAP[e+160]=HEAP[a+84];else{b=_FT_New_GlyphSlot(a,g);HEAP[e+160]=HEAP[g]}e=b;STACKTOP=g;return e}_T42_GlyphSlot_Init.__index__=Runtime.getFunctionIndex(_T42_GlyphSlot_Init,"_T42_GlyphSlot_Init");function _T42_GlyphSlot_Done(e){_FT_Done_GlyphSlot(HEAP[e+160])}_T42_GlyphSlot_Done.__index__=Runtime.getFunctionIndex(_T42_GlyphSlot_Done,"_T42_GlyphSlot_Done");
function _T42_GlyphSlot_Load(e,g,d,b){var a,c;c=HEAP[HEAP[HEAP[e+4]+96]+40];a=HEAP[e+160];_ft_glyphslot_free_bitmap(a);_llvm_memset_p0i8_i32(a+24,0,32,1,0);_llvm_memset_p0i8_i32(a+108,0,20,1,0);_llvm_memset_p0i8_i32(a+76,0,24,1,0);HEAP[a+100]=0;HEAP[a+104]=0;HEAP[a+128]=0;HEAP[a+132]=0;HEAP[a+136]=0;HEAP[a+140]=0;HEAP[a+152]=0;HEAP[a+72]=0;HEAP[a+56]=0;HEAP[a+60]=0;g=FUNCTION_TABLE[HEAP[c+80]](HEAP[e+160],HEAP[g+44],d,b|8);if(g==0){d=e+24;b=HEAP[e+160]+24;HEAP[d]=HEAP[b];HEAP[d+4]=HEAP[b+4];HEAP[d+
8]=HEAP[b+8];HEAP[d+12]=HEAP[b+12];HEAP[d+16]=HEAP[b+16];HEAP[d+20]=HEAP[b+20];HEAP[d+24]=HEAP[b+24];HEAP[d+28]=HEAP[b+28];HEAP[e+56]=HEAP[HEAP[e+160]+56];HEAP[e+60]=HEAP[HEAP[e+160]+60];HEAP[e+72]=HEAP[HEAP[e+160]+72];d=e+108;b=HEAP[e+160]+108;HEAP[d]=HEAP[b];HEAP[d+2]=HEAP[b+2];HEAP[d+4]=HEAP[b+4];HEAP[d+8]=HEAP[b+8];HEAP[d+12]=HEAP[b+12];HEAP[d+16]=HEAP[b+16];d=e+76;b=HEAP[e+160]+76;HEAP[d]=HEAP[b];HEAP[d+4]=HEAP[b+4];HEAP[d+8]=HEAP[b+8];HEAP[d+12]=HEAP[b+12];HEAP[d+16]=HEAP[b+16];HEAP[d+18]=HEAP[b+
18];HEAP[d+19]=HEAP[b+19];HEAP[d+20]=HEAP[b+20];HEAP[e+100]=HEAP[HEAP[e+160]+100];HEAP[e+104]=HEAP[HEAP[e+160]+104];HEAP[e+128]=HEAP[HEAP[e+160]+128];HEAP[e+132]=HEAP[HEAP[e+160]+132];HEAP[e+136]=HEAP[HEAP[e+160]+136];HEAP[e+140]=HEAP[HEAP[e+160]+140]}return g}_T42_GlyphSlot_Load.__index__=Runtime.getFunctionIndex(_T42_GlyphSlot_Load,"_T42_GlyphSlot_Load");
function _t42_parse_font_matrix(e,g){var d=STACKTOP;STACKTOP+=24;Runtime.memset(d,0,24);var b,a,c;b=e+132+304;a=e+132+320;FUNCTION_TABLE[HEAP[g+20+32]](g,6,d,3);c=HEAP[d+12];var f=0-c;c=reSign(c,32)>=reSign(0,32)?c:f;f=_FT_DivFix(65536E3,c);f=reSign(f,32)>>reSign(16,32)&65535;HEAP[e+68]=f;if(c!=65536){f=_FT_DivFix(HEAP[d],c);HEAP[d]=f;f=_FT_DivFix(HEAP[d+4],c);HEAP[d+4]=f;f=_FT_DivFix(HEAP[d+8],c);HEAP[d+8]=f;f=_FT_DivFix(HEAP[d+16],c);HEAP[d+16]=f;c=_FT_DivFix(HEAP[d+20],c);HEAP[d+20]=c;HEAP[d+12]=
65536}HEAP[b]=HEAP[d];HEAP[b+8]=HEAP[d+4];HEAP[b+4]=HEAP[d+8];HEAP[b+12]=HEAP[d+12];b=reSign(HEAP[d+16],32)>>reSign(16,32);HEAP[a]=b;b=reSign(HEAP[d+20],32)>>reSign(16,32);HEAP[a+4]=b;STACKTOP=d}_t42_parse_font_matrix.__index__=Runtime.getFunctionIndex(_t42_parse_font_matrix,"_t42_parse_font_matrix");
function _t42_parse_encoding(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a=null,c,f,h,i,k,j,l,m;f=HEAP[g+8];h=HEAP[e+488];FUNCTION_TABLE[HEAP[g+20+8]](g);c=HEAP[g];if(c>=f)HEAP[g+12]=3;else{j=unSign(HEAP[c],8)-48;j=unSign(j,32)<=unSign(9,32);a:do if(!j){if(HEAP[c]==91){b=0;break a}var o=c+17>=f;b:do if(!o){if(_strncmp(c,__str751,16)!=0)break b;HEAP[e+132+236]=2;STACKTOP=d;return}while(0);o=c+15>=f;b:do if(!o){if(_strncmp(c,__str852,14)!=0)break b;HEAP[e+132+236]=4;STACKTOP=d;return}while(0);
o=c+18>=f;b:do if(!o){if(_strncmp(c,__str953,17)!=0)break b;HEAP[e+132+236]=3;STACKTOP=d;return}while(0);HEAP[g+12]=3;STACKTOP=d;return}while(0);i=e+132+240;j=g+92;l=HEAP[g+16];m=0;if(HEAP[c]==91){k=256;m=1;HEAP[g]+=1}else k=FUNCTION_TABLE[HEAP[g+20+16]](g);FUNCTION_TABLE[HEAP[g+20+8]](g);if(!(HEAP[g]>=f)){HEAP[i]=k;HEAP[g+88]=HEAP[i];a=_ft_mem_realloc(l,2,0,k,0,d);HEAP[i+12]=a;a=HEAP[d]!=0;a:do if(!a){a=_ft_mem_realloc(l,4,0,k,0,d);HEAP[i+16]=a;if(HEAP[d]!=0)break a;h=FUNCTION_TABLE[HEAP[HEAP[h]]](j,
k,l);HEAP[d]=h;if(HEAP[d]!=0)break a;a=0;h=k;if(unSign(a,32)<unSign(h,32)){h=j+36+8;i=j;var n=k;l=a;a=l+1;n=(unSign(n,32)>unSign(a,32)?n:a)-l;for(a=6;;){b=a==6?0:p;FUNCTION_TABLE[HEAP[h]](i,l+b,__str650,8);var p=b+1;if(p!=n)b=a=7;else{b=8;break}}}a=0;FUNCTION_TABLE[HEAP[g+20+8]](g);h=p=f;m=m!=0;f=f;k=k;i=j+36+8;l=j;j=j+24;n=a;a=10;b:for(;;){t=a==28?t:n;if(!(HEAP[g]<p)){b=35;break b}c=HEAP[g];b=HEAP[c]==100;c:do if(b){if(!(c+3<h))break c;if(HEAP[c+1]!=101)break c;if(HEAP[c+2]!=102)break c;a=unSign(HEAP[c+
3],8)&255;if(a==0){b=42;break b}else if(a==9){b=42;break b}else if(a==10){b=42;break b}else if(a==12){b=42;break b}else if(a==13){b=42;break b}else if(a==32){b=42;break b}}while(0);o=c;if(HEAP[c]==93){b=20;break b}b=unSign(HEAP[o],8)-48;var r=unSign(b,32)<=unSign(9,32);c:do if(r){if(m){a=25;b=23;break c}var q=FUNCTION_TABLE[HEAP[g+20+16]](g);FUNCTION_TABLE[HEAP[g+20+8]](g);a=26;b=23;break c}else{if(m){a=22;b=23;break c}FUNCTION_TABLE[HEAP[g+20+12]](g);if(HEAP[g+12]!=0){b=30;break b}else{a=24;b=28;
break c}}while(0);c:do if(b==23){a=a==26?q:a==22?t:t;c=HEAP[g];if(HEAP[c]!=47){a=23;break c}r=c+2<f;var s=unSign(t,32)<unSign(k,32);if(!(r&s)){a=27;break c}c+=1;HEAP[g]=c;FUNCTION_TABLE[HEAP[g+20+12]](g);if(HEAP[g+12]!=0){b=30;break b}var u=HEAP[g]-c;r=FUNCTION_TABLE[HEAP[i]](l,a,c,u+1);HEAP[g+12]=r;if(HEAP[g+12]!=0){b=30;break b}HEAP[HEAP[HEAP[j]+4*a]+u]=0;u=t+1;a=32}while(0);var t=a==23?t:a==27?t:a==32?u:t;FUNCTION_TABLE[HEAP[g+20+8]](g);a=28;b=11}if(b!=35)if(b==42)c+=3;else if(b==20)c=o+1;else if(b==
30){STACKTOP=d;return}HEAP[e+132+236]=1;HEAP[g]=c;STACKTOP=d;return}while(0);HEAP[g+12]=HEAP[d]}}STACKTOP=d}_t42_parse_encoding.__index__=Runtime.getFunctionIndex(_t42_parse_encoding,"_t42_parse_encoding");
function _t42_parse_sfnts(e,g){var d=STACKTOP;STACKTOP+=8;Runtime.memset(d,0,8);var b,a=null,c,f,h,i=d+4,k;c=HEAP[g+16];h=HEAP[g+8];k=f=0;FUNCTION_TABLE[HEAP[g+20+8]](g);var j=HEAP[g]>=h;a:do if(j)b=0;else{var l=HEAP[g],m=unSign(HEAP[l]!=91,1);HEAP[g]=l+1;if(m!=0){b=0;break a}FUNCTION_TABLE[HEAP[g+20+8]](g);l=h;m=c;var o=e+492,n=e+492,p=e+492,r=c,q=e+492,s=e+492,u=e+492,t=e+496,v=e+492,w=c,x=e+492,y=e+492,A=h,z=f,C=k;a=1;b:for(;;){var B=a==46?Q:0,D=a==46?R:C,E=a==46?S:0,F=a==46?T:z,G=a==46?X:0;b=
a==46?U:0;var H=a==46?Y:0,J=a==46?W:0;if(!(HEAP[g]<l)){b=48;break b}var L=HEAP[g];if(HEAP[L]==93){b=4;break b}var N=HEAP[L]==60;c:do if(N){FUNCTION_TABLE[HEAP[g+20+12]](g);if(HEAP[g+12]!=0){b=7;break b}var I=Math.floor(reSign(HEAP[g]+-1+(0-L),32)/reSign(2,32)),P=_ft_mem_realloc(m,1,B,I,F,d);if(HEAP[d]!=0){b=9;break b}HEAP[g]=L;FUNCTION_TABLE[HEAP[g+20+24]](g,P,I,i,1);var K=HEAP[i];a=10}else{a=unSign(HEAP[L],8)-48;if(!(unSign(a,32)<=unSign(9,32))){a=12;break c}if(D!=0){b=15;break b}var O=FUNCTION_TABLE[HEAP[g+
20+16]](g);if(reSign(O,32)<reSign(0,32)){b=17;break b}FUNCTION_TABLE[HEAP[g+20+12]](g);if(HEAP[g+12]!=0){b=19;break b}var M=HEAP[g]+1;if(reSign(A-HEAP[g],32)<reSign(O,32)){b=21;break b}HEAP[g]+=O+1;a=22}while(0);var Q=a==22?B:a==12?B:I,R=a==22?0:a==12?D:1,T=a==22?M:a==12?F:P;B=a==22?O:a==12?b:K;if(T==0){b=23;break b}if(HEAP[T+(B-1)]==0){var V=reSign(B,32)%reSign(2,32);U=B-1;V=V==1?U:B;a=25}else a=24;var U=a==24?B:V;if(U==0){b=28;break b}else a=27;c:for(;;){var S=a==31?fa:E,X=a==31?ka:G;B=a==31?wa:
0;var Y=a==31?na:H,W=a==31?sa:J;if(!(reSign(B,32)<reSign(U,32)))break c;if(X==0){a=45;b=52}else if(X==1){a=45;b=34}else if(X==2){a=45;b=41}else{a=45;b=31}d:do if(b==52){a=unSign(S,32)<=unSign(11,32);b=HEAP[o];if(a){HEAP[b+S]=HEAP[T+B];var da=S+1;a=30;b=31;break d}else{var ba=unSign(HEAP[b+4],8)*16;ba=unSign(HEAP[HEAP[n]+5],8)+ba;var aa=ba*16+12;a=_ft_mem_realloc(r,1,12,aa,HEAP[p],d);HEAP[q]=a;if(HEAP[d]!=0){b=33;break b}else{a=32;b=34;break d}}}while(0);d:do if(b==34){var ca=a==32?ba:Y,$=a==32?aa:
W;if(unSign(S,32)<unSign($,32)){HEAP[HEAP[s]+S]=HEAP[T+B];var la=S+1;a=35;b=31;break d}else{if(reSign(0,32)<reSign(ca,32)){var ga=HEAP[u];for(a=36;;){ea=a==36?$:ea;Z=a==36?0:Z;b=Z*16;a=ga+(b+27);L=ga+(b+26);N=ga+(b+25);b=unSign(HEAP[ga+(b+24)],8)<<24;N=unSign(HEAP[N],8)<<16;L=unSign(HEAP[L],8)<<8;a=unSign(HEAP[a],8);var ea=((N|b|L|a)+3&-4)+ea,Z=Z+1;if(Z!=ca)a=37;else break}a=38}else a=55;ga=a==38?ea:$;HEAP[t]=ga;a=_ft_mem_realloc(w,1,ca*16+12,ga+1,HEAP[v],d);HEAP[x]=a;if(HEAP[d]!=0){b=33;break b}else{a=
40;b=41;break d}}}while(0);if(b==41){var ha=a==40?ca:Y,ia=a==40?ga:W;if(unSign(S,32)>=unSign(ia,32)){b=42;break b}HEAP[HEAP[y]+S]=HEAP[T+B];var ja=S+1;a=43}var fa=a==43?ja:a==35?la:a==30?da:S,ka=a==43?2:a==35?1:a==30?0:X,na=a==43?ha:a==35?ca:a==30?Y:Y,sa=a==43?ia:a==35?$:a==30?W:W,wa=B+1;a=31}FUNCTION_TABLE[HEAP[g+20+8]](g);a=46;b=3}if(b==48){k=D;f=F;HEAP[d]=3;b=2;break a}else if(b==4){k=D;f=F;HEAP[g]+=1;b=6;break a}else if(b==7){k=D;f=F;b=6;break a}else if(b==9){k=D;f=P;b=2;break a}else if(b==23){k=
R;f=0;HEAP[d]=3;b=2;break a}else if(b==28){k=R;f=T;HEAP[d]=3;b=2;break a}else if(b==33){k=R;f=T;b=2;break a}else if(b==42){k=R;f=T;HEAP[d]=3;b=2;break a}else if(b==15){k=D;f=F;HEAP[d]=3;b=2;break a}else if(b==17){k=0;f=F;HEAP[d]=3;b=2;break a}else if(b==19){STACKTOP=d;return}else if(b==21){k=0;f=M;HEAP[d]=3;b=2;break a}}while(0);a:do if(b==0){HEAP[d]=3;b=2;break a}while(0);if(b==2)HEAP[g+12]=HEAP[d];h=k!=0;a:do if(h){f=f;c=c;f=f;if(f==0)break a;FUNCTION_TABLE[HEAP[c+8]](c,f);STACKTOP=d;return}while(0);
STACKTOP=d}_t42_parse_sfnts.__index__=Runtime.getFunctionIndex(_t42_parse_sfnts,"_t42_parse_sfnts");
function _t42_parse_charstrings(e,g){var d,b=null,a,c,f,h,i,k,j,l,m,o;a=g+200;c=g+148;f=g+252;h=HEAP[g+16];k=HEAP[e+488];j=HEAP[g+8];o=m=0;FUNCTION_TABLE[HEAP[g+20+8]](g);b=HEAP[g]>=j;a:do if(b)i=3;else{b=unSign(HEAP[HEAP[g]],8)-48;var n=unSign(b,32)<=unSign(9,32),p=g;b:do if(n){b=FUNCTION_TABLE[HEAP[p+20+16]](g);HEAP[g+144]=b;d=HEAP[g+12]!=0?1:2;break b}else if(HEAP[HEAP[p]]==60){b=0;FUNCTION_TABLE[HEAP[g+20+12]](g);if(HEAP[g+12]!=0){d=1;break b}FUNCTION_TABLE[HEAP[g+20+8]](g);i=HEAP[g];var r=j,
q=b;for(b=3;;){l=b==10?u:q;if(!(HEAP[g]<r)){d=12;break}if(HEAP[HEAP[g]]==47){var s=l+1;b=5}else if(HEAP[HEAP[g]]==62){d=8;break}else b=7;var u=b==7?l:s;FUNCTION_TABLE[HEAP[g+20+12]](g);if(HEAP[g+12]!=0){d=9;break}FUNCTION_TABLE[HEAP[g+20+8]](g);b=10;d=4}if(d==12){d=2;break b}else if(d==9)return;else if(d==8){b=l;HEAP[g+144]=b;HEAP[g]=i;d=2;break b}}else{i=3;break a}while(0);b:do if(d==2)if(HEAP[g]>=j){i=3;break a}else{i=FUNCTION_TABLE[HEAP[HEAP[k]]](a,HEAP[g+144],h);if(i!=0)break a;i=FUNCTION_TABLE[HEAP[HEAP[k]]](c,
HEAP[g+144],h);if(i!=0)break a;i=FUNCTION_TABLE[HEAP[HEAP[k]]](f,4,h);if(i!=0)break a;l=0;n=u=s=j;p=c+36+8;r=c;q=c+24;var t=c+24,v=j,w=a+36+8,x=a,y=a+24,A=g+144,z=l;b=16;c:for(;;){var C=b==16?z:b==42?G:C;FUNCTION_TABLE[HEAP[g+20+8]](g);d=HEAP[g];if(d>=s){b=17;d=18;break c}var B=HEAP[d];if(B==101){var D=d+3<u;d:do if(D){if(HEAP[d+1]!=110)break d;if(HEAP[d+2]==100)b=21;else break d;var E=unSign(HEAP[d+3],8)&255;if(E==0){d=52;break c}else if(E==9){d=52;break c}else if(E==10){d=52;break c}else if(E==
12){d=52;break c}else if(E==13){d=52;break c}else if(E==32){d=52;break c}}while(0);var F=HEAP[d];b=22}else b=19;if((b==22?F:B)==62){b=28;d=18;break c}else b=28;FUNCTION_TABLE[HEAP[g+20+12]](g);if(HEAP[g+12]!=0){d=30;break c}if(HEAP[d]==47)b=31;else{b=31;d=17;continue c}if(d+1>=n){d=33;break c}d=d+1;B=HEAP[g]-d;i=FUNCTION_TABLE[HEAP[p]](r,C,d,B+1);if(i!=0){b=34;d=35;break c}else b=34;HEAP[HEAP[HEAP[q]+4*C]+B]=0;d=HEAP[d]==46;d:do if(d){if(_strcmp(__str650,HEAP[HEAP[t]+4*C])!=0)break d;m=C;o=1}while(0);
FUNCTION_TABLE[HEAP[g+20+8]](g);d=HEAP[g];FUNCTION_TABLE[HEAP[g+20+16]](g);if(HEAP[g]>=v){d=40;break c}b=HEAP[g]-d;i=FUNCTION_TABLE[HEAP[w]](x,C,d,b+1);if(i!=0){b=41;d=35;break c}HEAP[HEAP[HEAP[y]+4*C]+b]=0;var G=C+1;if(unSign(HEAP[A],32)<=unSign(G,32)){b=42;d=18;break c}else{b=42;d=17}}if(d==18)l=b==17?C:b==28?C:G;else if(d==52)l=C;else if(d==30)break;else if(d==33){i=3;break a}else if(d==35)break a;else if(d==40){i=3;break a}HEAP[g+144]=l;if(o==0){i=3;break a}else{if(_strcmp(__str650,HEAP[HEAP[c+
24]])==0)break b;i=FUNCTION_TABLE[HEAP[f+36+8]](f,0,HEAP[HEAP[c+24]],HEAP[HEAP[c+28]]);if(i!=0)break a;i=FUNCTION_TABLE[HEAP[f+36+8]](f,1,HEAP[HEAP[a+24]],HEAP[HEAP[a+28]]);if(i!=0)break a;i=FUNCTION_TABLE[HEAP[f+36+8]](f,2,HEAP[HEAP[c+24]+4*m],HEAP[HEAP[c+28]+4*m]);if(i!=0)break a;i=FUNCTION_TABLE[HEAP[f+36+8]](f,3,HEAP[HEAP[a+24]+4*m],HEAP[HEAP[a+28]+4*m]);if(i!=0)break a;i=FUNCTION_TABLE[HEAP[c+36+8]](c,m,HEAP[HEAP[f+24]],HEAP[HEAP[f+28]]);if(i!=0)break a;i=FUNCTION_TABLE[HEAP[a+36+8]](a,m,HEAP[HEAP[f+
24]+4],HEAP[HEAP[f+28]+4]);if(i!=0)break a;i=FUNCTION_TABLE[HEAP[c+36+8]](c,0,HEAP[HEAP[f+24]+8],HEAP[HEAP[f+28]+8]);if(i!=0)break a;i=FUNCTION_TABLE[HEAP[a+36+8]](a,0,HEAP[HEAP[f+24]+12],HEAP[HEAP[f+28]+12]);if(i!=0)break a}}while(0);return}while(0);HEAP[g+12]=i}_t42_parse_charstrings.__index__=Runtime.getFunctionIndex(_t42_parse_charstrings,"_t42_parse_charstrings");
function _t42_get_glyph_name(e,g,d,b){var a=null;e=HEAP[HEAP[e+132+288]+4*g];d=a=d;g=b+-1;for(a=-1;;){i=a==1?i:0;var c=g+i*-1,f=e+i,h=d+i;if(unSign(a==1?c:b,32)<=unSign(1,32))break;if(HEAP[f]==0)break;HEAP[h]=HEAP[f];var i=i+1;a=1}a=h;return HEAP[a]=0}_t42_get_glyph_name.__index__=Runtime.getFunctionIndex(_t42_get_glyph_name,"_t42_get_glyph_name");
function _t42_get_name_index(e,g){var d,b=null,a,c;c=0;var f=HEAP[e+132+284],h=e+132+288;c=c;for(b=-1;;){d=b==4?k:0;var i=c+d;if(!(reSign(f,32)>reSign(i,32))){d=6;break}k=HEAP[HEAP[h]+4*i];if(HEAP[g]==HEAP[k])if(_strcmp(g,k)==0){d=1;break}var k=d+1;b=4;d=0}if(d==1){c=i;a=_atol(HEAP[HEAP[e+132+292]+4*c])}else if(d==6)a=0;return a}_t42_get_name_index.__index__=Runtime.getFunctionIndex(_t42_get_name_index,"_t42_get_name_index");function _t42_get_ps_font_name(e){return HEAP[e+132+232]}
_t42_get_ps_font_name.__index__=Runtime.getFunctionIndex(_t42_get_ps_font_name,"_t42_get_ps_font_name");function _t42_ps_get_font_info(e,g){_llvm_memcpy_p0i8_p0i8_i32(g,e+132,32,4,0);return 0}_t42_ps_get_font_info.__index__=Runtime.getFunctionIndex(_t42_ps_get_font_info,"_t42_ps_get_font_info");function _t42_ps_get_font_extra(e,g){var d=STACKTOP;STACKTOP+=2;Runtime.memset(d,0,2);HEAP[d]=HEAP[e+132+32];HEAP[g]=HEAP[d];STACKTOP=d;return 0}
_t42_ps_get_font_extra.__index__=Runtime.getFunctionIndex(_t42_ps_get_font_extra,"_t42_ps_get_font_extra");function _t42_ps_has_glyph_names(){return 1}_t42_ps_has_glyph_names.__index__=Runtime.getFunctionIndex(_t42_ps_has_glyph_names,"_t42_ps_has_glyph_names");function _t42_ps_get_font_private(e,g){_llvm_memcpy_p0i8_p0i8_i32(g,e+132+36,196,4,0);return 0}_t42_ps_get_font_private.__index__=Runtime.getFunctionIndex(_t42_ps_get_font_private,"_t42_ps_get_font_private");
function _T42_Get_Interface(e,g){return _ft_service_list_lookup(_t42_services,g)}_T42_Get_Interface.__index__=Runtime.getFunctionIndex(_T42_Get_Interface,"_T42_Get_Interface");
function _fnt_font_done(e){var g,d,b,a,c,f;a=HEAP[e+100];c=HEAP[e+104];f=HEAP[e+132];if(f!=0){if(HEAP[f+160]!=0){b=f+160;var h=c!=0;a:do if(h){if(HEAP[c+20]==0)break a;g=HEAP[c+28];d=HEAP[b];g=g;d=d;d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[b]=0}while(0);HEAP[b]=0}b=HEAP[f+168];b!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[f+168]=0;f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,f);HEAP[e+132]=0}}_fnt_font_done.__index__=Runtime.getFunctionIndex(_fnt_font_done,"_fnt_font_done");
function _fnt_font_load(e,g){var d,b,a,c;c=e+4;d=_FT_Stream_Seek(g,HEAP[e]);var f=d!=0;a:do if(!f){d=_FT_Stream_ReadFields(g,_winfnt_header_fields,c);if(d!=0)break a;d=HEAP[c]!=512;b:do if(d){if(HEAP[c]==768)break b;d=2;break a}while(0);d=d=d=unSign(HEAP[e+4]==768,1)!=0?148:118;if(unSign(HEAP[c+4],32)<unSign(d,32))d=2;else{if(HEAP[c]==512){HEAP[c+128]=0;HEAP[c+132]=0;HEAP[c+134]=0;HEAP[c+136]=0;HEAP[c+138]=0}if((unSign(HEAP[c+68],16)&1&255)!=0)d=2;else{d=_FT_Stream_Seek(g,HEAP[e]);if(d!=0)break a;
a=e+160;b=HEAP[c+4];d=g;b=b;a=a;b=_FT_Stream_EnterFrame(d,b);if(b==0){HEAP[a]=HEAP[d+32];HEAP[d+32]=0;HEAP[d+36]=0}d=d=d=b}}}while(0);return d}_fnt_font_load.__index__=Runtime.getFunctionIndex(_fnt_font_load,"_fnt_font_load");function _fnt_cmap_init(e){var g;g=HEAP[HEAP[e]+132];var d=unSign(HEAP[g+4+100],8);HEAP[e+16]=d;g=unSign(HEAP[g+4+101],8);HEAP[e+20]=g+1+(0-HEAP[e+16]);return 0}_fnt_cmap_init.__index__=Runtime.getFunctionIndex(_fnt_cmap_init,"_fnt_cmap_init");
function _fnt_cmap_char_index(e,g){var d,b;d=g;b=0;d-=HEAP[e+16];var a=d;if(unSign(HEAP[e+20],32)>unSign(a,32))b=d+1;return b}_fnt_cmap_char_index.__index__=Runtime.getFunctionIndex(_fnt_cmap_char_index,"_fnt_cmap_char_index");function _fnt_cmap_char_next(e,g){var d,b,a;b=d=0;var c=a=HEAP[g]+1;c=unSign(HEAP[e+16],32)>=unSign(c,32);var f=HEAP[e+16];a:do if(c){b=f;d=1}else{a-=f;var h=a;if(!(unSign(HEAP[e+20],32)>unSign(h,32)))break a;b=a+HEAP[e+16];d=a+1}while(0);HEAP[g]=b;return d}
_fnt_cmap_char_next.__index__=Runtime.getFunctionIndex(_fnt_cmap_char_next,"_fnt_cmap_char_next");function _FNT_Face_Done(e){var g;if(e!=0){g=HEAP[e+100];_fnt_font_done(e);_ft_mem_free(g,HEAP[e+32]);HEAP[e+32]=0;HEAP[e+28]=0}}_FNT_Face_Done.__index__=Runtime.getFunctionIndex(_FNT_Face_Done,"_FNT_Face_Done");
function _FNT_Face_Init(e,g,d){var b=STACKTOP;STACKTOP+=158;Runtime.memset(b,0,158);var a,c=null,f,h,i,k,j,l,m,o,n,p,r=b+4,q=b+8,s;k=b+14;l=b+34;m=b+54;o=b+70;n=b+86;var u=b+102,t=b+110,v=b+118,w=b+126,x,y=b+142,A,z,C,B=b+146;A=HEAP[g+100];p=HEAP[g+104];j=HEAP[g+100];HEAP[g+132]=0;i=_FT_Stream_Seek(p,0);HEAP[b]=i;i=HEAP[b];var D=i!=0;a:do if(D){c=-1;a=1}else{f=_FT_Stream_ReadFields(p,_winmz_header_fields,r);HEAP[b]=f;f=HEAP[b];if(f!=0){c=0;a=1;break a}else c=0;HEAP[b]=2;D=HEAP[r]==23117;b:do if(D){var E=
unSign(HEAP[r+2],16);E=_FT_Stream_Seek(p,E);HEAP[b]=E;E=HEAP[b];if(E!=0){c=3;a=1;break a}h=_FT_Stream_ReadFields(p,_winne_header_fields,q);HEAP[b]=h;h=HEAP[b];if(h!=0){c=4;a=1;break a}else c=4;HEAP[b]=2;D=HEAP[q]==17742;c:do{if(D){s=unSign(HEAP[r+2],16);s=unSign(HEAP[q+2],16)+s;m=l=0;s=_FT_Stream_Seek(p,s);HEAP[b]=s;s=HEAP[b];if(s!=0){c=6;a=1;break a}var F=unSign(HEAP[q+4],16);c=unSign(HEAP[q+2],16);F=_FT_Stream_EnterFrame(p,F-c);HEAP[b]=F;F=HEAP[b];if(F!=0){c=7;a=1;break a}c=p;o=0;k=HEAP[c+32];if(k+
1<HEAP[c+36]){k+=2;o=reSign(HEAP[k+-2+1],8)<<8&65535;n=unSign(HEAP[k+-2],8);o=o|n}HEAP[c+32]=k;c=c=reSign(o,16);k=c&65535;c=10;d:for(;;){a=p;o=HEAP[a+32];if(o+1<HEAP[a+36]){var G=o+2;c=reSign(HEAP[G+-2+1],8)<<8&65535;n=unSign(HEAP[G+-2],8);var H=c|n;c=12}else c=11;n=c==11?0:H;HEAP[a+32]=c==11?o:G;a=reSign(n,16)&65535;if(a==0){a=14;break d}o=p;n=HEAP[o+32];if(n+1<HEAP[o+36]){var J=n+2;c=reSign(HEAP[J+-2+1],8)<<8&65535;u=unSign(HEAP[J+-2],8);var L=c|u;c=16}else c=15;u=c==15?0:L;HEAP[o+32]=c==15?n:J;
var N=reSign(u,16)&65535;if(a==-32760){a=18;break d}c=HEAP[p+32];a=unSign(N,16)*12+4;HEAP[p+32]=c+a;c=19;a=11}if(a!=14)if(a==18){l=a=N;a=p;a=a=HEAP[a+8];m=a+4+HEAP[p+32]+(0-HEAP[p+36])}a=p;if(HEAP[a+20]!=0){o=HEAP[a+28];n=HEAP[a];o=o;n=n;n!=0&&FUNCTION_TABLE[HEAP[o+8]](o,n);HEAP[a]=0}HEAP[a+32]=0;HEAP[a+36]=0;a=l==0;d:do if(!a){if(m==0)break d;a=unSign(l,16)*118;o=HEAP[p+4];if(unSign(a,32)>unSign(o,32)){HEAP[b]=3;c=25;a=1;break a}else{a=unSign(l,16);HEAP[g]=a;a=unSign(l,16);l=d;if(reSign(a,32)<=reSign(l,
32)){HEAP[b]=6;c=26;a=1;break a}else{if(reSign(d,32)<reSign(0,32)){a=27;break b}z=_ft_mem_alloc(j,172,b);HEAP[g+132]=z;z=HEAP[b];if(z!=0){c=28;a=1;break a}else c=28;j=_FT_Stream_Seek(p,d*12+m);HEAP[b]=j;if(HEAP[b]!=0){a=30;break b}j=_FT_Stream_EnterFrame(p,12);HEAP[b]=j;if(HEAP[b]!=0){a=30;break b}j=HEAP[g+132];a=p;m=0;l=HEAP[a+32];if(l+1<HEAP[a+36]){l+=2;m=reSign(HEAP[l+-2+1],8)<<8&65535;o=unSign(HEAP[l+-2],8);m=m|o}HEAP[a+32]=l;a=a=reSign(m,16);a=unSign(a&65535,16);l=unSign(k,16);HEAP[j]=a<<l;j=
HEAP[g+132];a=p;m=0;l=HEAP[a+32];if(l+1<HEAP[a+36]){l+=2;m=reSign(HEAP[l+-2+1],8)<<8&65535;o=unSign(HEAP[l+-2],8);m=m|o}HEAP[a+32]=l;a=a=reSign(m,16);a=unSign(a&65535,16);k=unSign(k,16);HEAP[j+164]=a<<k;HEAP[p+32]+=8;j=p;if(HEAP[j+20]!=0){a=HEAP[j+28];k=HEAP[j];a=a;k=k;k!=0&&FUNCTION_TABLE[HEAP[a+8]](a,k);HEAP[j]=0}HEAP[j+32]=0;HEAP[j+36]=0;p=_fnt_font_load(HEAP[g+132],p);HEAP[b]=p;break c}}}while(0);HEAP[b]=3;c=23}else{if(HEAP[q]!=17744)break c;var I=unSign(HEAP[r+2],16);I=_FT_Stream_Seek(p,I);HEAP[b]=
I;I=HEAP[b];if(I!=0){c=38;a=1;break a}C=_FT_Stream_ReadFields(p,_winpe32_header_fields,k);HEAP[b]=C;C=HEAP[b];if(C!=0){c=39;a=1;break a}G=HEAP[k]!=17744;d:do if(!G){if(HEAP[k+4]!=332)break d;if(HEAP[k+8]!=224)break d;if(HEAP[k+10]!=267)break d;c=HEAP[g]=0;J=k+6;H=l;L=k+12;N=l+8;q=c;c=44;e:for(;;){a=c==49?P:0;r=q+a;if(!(unSign(HEAP[J],16)>unSign(r,16))){a=51;break e}r=_FT_Stream_ReadFields(p,_winpe32_section_fields,H);HEAP[b]=r;if(HEAP[b]!=0){a=46;break e}if(HEAP[L]==HEAP[N]){a=48;break e}var P=a+
1;c=49;a=45}if(a==51){HEAP[b]=3;c=51;a=1;break a}else if(a==46){a=27;break b}else if(a==48){var K=_FT_Stream_Seek(p,HEAP[l+16]);HEAP[b]=K;K=HEAP[b];if(K!=0){c=48;a=1;break a}var O=_FT_Stream_ReadFields(p,_winpe_rsrc_dir_fields,m);HEAP[b]=O;O=HEAP[b];if(O!=0){c=52;a=1;break a}x=HEAP[l+16];c=0;J=m+12;H=m+14;L=u;N=u+4;q=u+4;r=u+4;D=l+16;var M=u+4,Q=l+16,R=u+4,T=o,V=o+12,U=o+14,S=t,X=t+4,Y=t+4,W=t+4,da=l+16,ba=t+4,aa=l+16,ca=t+4,$=n,la=n+12,ga=n+14,ea=v,Z=t+4,ha=u,ia=v+4,ja=x,fa=w,ka=g,na=d,sa=j,wa=g+
132,Aa=g+132,Da=l+16,pa=w,ta=l+8,ma=g+132,ya=w+4,qa=g+132,ua=g,Ba=g,Na=c;x=x+16;c=53;e:for(;;){a=c==87?La:0;var Ea=Na+a,ra=unSign(Ea,16),za=unSign(HEAP[J],16);za=unSign(HEAP[H],16)+za;if(!(reSign(ra,32)<reSign(za,32))){a=88;break e}c=unSign(Ea,16)*8;c=_FT_Stream_Seek(p,x+c);HEAP[b]=c;if(HEAP[b]!=0){c=55;a=56;break e}c=_FT_Stream_ReadFields(p,_winpe_rsrc_dir_entry_fields,L);HEAP[b]=c;if(HEAP[b]!=0){c=57;a=56;break e}else c=57;if(reSign(HEAP[N],32)>=reSign(0,32)){a=59;break e}HEAP[r]=HEAP[q]&2147483647;
c=HEAP[M]+HEAP[D];Ea=_FT_Stream_Seek(p,HEAP[R]+HEAP[Q]);HEAP[b]=Ea;if(HEAP[b]!=0){c=60;a=56;break e}Ea=_FT_Stream_ReadFields(p,_winpe_rsrc_dir_fields,T);HEAP[b]=Ea;if(HEAP[b]!=0){c=61;a=56;break e}Ea=c+16;c=62;f:for(;;){ra=c==86?Ja:0;c=unSign(ra,16);za=unSign(HEAP[V],16);za=unSign(HEAP[U],16)+za;if(!(reSign(c,32)<reSign(za,32)))break f;c=unSign(ra,16)*8;c=_FT_Stream_Seek(p,Ea+c);HEAP[b]=c;if(HEAP[b]!=0){c=64;a=65;break e}c=_FT_Stream_ReadFields(p,_winpe_rsrc_dir_entry_fields,S);HEAP[b]=c;if(HEAP[b]!=
0){c=66;a=65;break e}else c=66;if(reSign(HEAP[X],32)>=reSign(0,32)){a=68;break e}HEAP[W]=HEAP[Y]&2147483647;c=HEAP[ba]+HEAP[da];za=_FT_Stream_Seek(p,HEAP[ca]+HEAP[aa]);HEAP[b]=za;if(HEAP[b]!=0){c=69;a=65;break e}za=_FT_Stream_ReadFields(p,_winpe_rsrc_dir_fields,$);HEAP[b]=za;if(HEAP[b]!=0){c=70;a=65;break e}za=c+16;for(c=71;;){var Ha=c==84?Pa:0,Ca=unSign(Ha,16),va=unSign(HEAP[la],16);va=unSign(HEAP[ga],16)+va;if(!(reSign(Ca,32)<reSign(va,32)))break;Ca=unSign(Ha,16)*8;Ca=_FT_Stream_Seek(p,za+Ca);HEAP[b]=
Ca;if(HEAP[b]!=0){a=73;break e}Ca=_FT_Stream_ReadFields(p,_winpe_rsrc_dir_entry_fields,ea);HEAP[b]=Ca;if(HEAP[b]!=0){a=73;break e}if(reSign(HEAP[Z],32)<reSign(0,32)){a=76;break e}if(HEAP[ha]==8){Ca=_FT_Stream_Seek(p,HEAP[ia]+ja);HEAP[b]=Ca;if(HEAP[b]!=0){a=73;break e}Ca=_FT_Stream_ReadFields(p,_winpe_rsrc_data_entry_fields,fa);HEAP[b]=Ca;if(HEAP[b]!=0){a=73;break e}if(HEAP[ka]==na){Ca=_ft_mem_alloc(sa,172,b);HEAP[wa]=Ca;if(HEAP[b]!=0){a=73;break e}HEAP[HEAP[Aa]]=HEAP[pa]+HEAP[Da]+(0-HEAP[ta]);HEAP[HEAP[ma]+
164]=HEAP[ya];Ca=_fnt_font_load(HEAP[qa],p);HEAP[b]=Ca;if(HEAP[b]!=0){a=81;break e}}HEAP[Ba]=HEAP[ua]+1}var Pa=Ha+1;c=84}var Ja=ra+1;c=86}var La=a+1;c=87;a=54}if(a==88)break c;else if(a==56){a=27;break b}else if(a==59){HEAP[b]=3;c=59;a=1;break a}else if(a==65){a=27;break b}else if(a==68){HEAP[b]=3;c=68;a=1;break a}else if(a==73){a=27;break b}else if(a==76){HEAP[b]=3;c=76;a=1;break a}else if(a==81){a=30;break b}}}while(0);HEAP[b]=3;c=41}a=1;break a}while(0);if(HEAP[g]==0){HEAP[b]=3;c=89;a=1;break a}else{p=
d;if(reSign(HEAP[g],32)<=reSign(p,32)){HEAP[b]=6;c=90;a=1;break a}else{p=HEAP[b];if(p!=0){a=30;break b}HEAP[y]=p;a=92;break b}}}else a=30;while(0);b:do if(a==30){_fnt_font_done(g);a=27;break b}while(0);if(a==27){var xa=HEAP[b];HEAP[y]=xa;if(xa==0)c=27;else{c=27;a=93;break a}}if(reSign(d,32)<reSign(0,32)){a=95;break a}var oa=HEAP[y];c=96;a=93;break a}while(0);a:do if(a==1){var Fa=c==-1?i:c==0?f:c==3?E:c==4?h:c==6?s:c==7?F:c==23?3:c==25?3:c==26?6:c==28?z:c==38?I:c==39?C:c==41?3:c==51?3:c==48?K:c==52?
O:c==59?3:c==68?3:c==76?3:c==89?3:6;HEAP[y]=Fa;c=1;a=93;break a}while(0);a:do if(a==93){i=(c==96?oa:c==1?Fa:xa)==2;b:do if(i){i=_ft_mem_alloc(A,172,y);HEAP[g+132]=i;if(HEAP[y]!=0)break a;HEAP[g]=1;i=HEAP[g+132];HEAP[i]=0;HEAP[i+164]=HEAP[e+4];i=_fnt_font_load(i,e);HEAP[y]=i;if(HEAP[y]!=0){a=99;break b}if(reSign(d,32)>reSign(0,32)){HEAP[y]=6;a=99;break b}else if(reSign(d,32)<reSign(0,32))break a;else{a=100;break b}}else a=100;while(0);b:do if(a==100){if(HEAP[y]!=0){a=99;break b}i=g;f=HEAP[g+132];HEAP[i+
4]=d;HEAP[i+8]=18;if(HEAP[f+4+96]==HEAP[f+4+98])HEAP[i+8]|=4;if(HEAP[f+4+82]!=0)HEAP[i+12]|=1;if(unSign(HEAP[f+4+86],16)>unSign(799,16))HEAP[i+12]|=2;h=_ft_mem_realloc(A,16,0,1,0,y);HEAP[i+32]=h;if(HEAP[y]!=0){a=99;break b}HEAP[i+28]=1;h=HEAP[i+32];HEAP[h+2]=HEAP[f+4+96];HEAP[h]=HEAP[f+4+80]+HEAP[f+4+92];z=unSign(HEAP[f+4+70],16)<<6;HEAP[h+4]=z;z=HEAP[f+4+74];if(z==0)z=72;C=K=HEAP[f+4+72];if(K==0)C=72;K=unSign(C,16);K=_FT_MulDiv(HEAP[h+4],K,72);HEAP[h+12]=K;HEAP[h+12]=HEAP[h+12]+32&-64;K=HEAP[h+12];
O=unSign(HEAP[f+4+92],16)<<6;if(reSign(K,32)>reSign(O,32)){K=unSign(HEAP[f+4+92],16)<<6;HEAP[h+12]=K;C=unSign(C,16);C=_FT_MulDiv(HEAP[h+12],72,C);HEAP[h+4]=C}z=unSign(z,16);z=_FT_MulDiv(HEAP[h+4],z,72);HEAP[h+8]=z;HEAP[h+8]=HEAP[h+8]+32&-64;h=B;_llvm_memset_p0i8_i64(B+4,0,8,4,0);HEAP[h]=i;if(HEAP[f+4+88]==77){HEAP[B+4]=1634889070;HEAP[B+8]=1}h=_FT_CMap_New(_fnt_cmap_class_rec,0,B,0);HEAP[y]=h;if(h!=0){a=99;break b}if(HEAP[i+36]!=0)HEAP[i+92]=HEAP[HEAP[i+40]];h=unSign(HEAP[f+4+101],8);z=0-unSign(HEAP[f+
4+100],8);HEAP[i+16]=h+2+z;h=HEAP[f+4+4];if(unSign(HEAP[f+4+112],32)>=unSign(h,32))HEAP[y]=3;else{h=HEAP[f+4+4]-HEAP[f+4+112];z=_ft_mem_alloc(A,h+1,y);HEAP[f+168]=z;if(HEAP[y]!=0){a=99;break b}_llvm_memcpy_p0i8_p0i8_i32(HEAP[f+168],HEAP[f+160]+HEAP[f+4+112],h,1,0);HEAP[HEAP[f+168]+h]=0;z=HEAP[f+168];C=_strlen(HEAP[f+168])+1;h=_ft_mem_realloc(A,1,h,C,z,y);HEAP[f+168]=h;if(HEAP[y]!=0){a=99;break b}HEAP[i+20]=HEAP[f+168];HEAP[i+24]=__str62;e=(HEAP[i+12]&1&255)!=0;if((HEAP[i+12]&2)!=0)HEAP[i+24]=e?__str1207:
__str63;else{if(!e)break a;HEAP[i+24]=__str3209}break a}}while(0);i=f=g;if(f==0)break a;f=HEAP[i+100];_fnt_font_done(i);h=HEAP[i+32];f=f;h=h;h!=0&&FUNCTION_TABLE[HEAP[f+8]](f,h);HEAP[i+32]=0;HEAP[i+28]=0}while(0);y=HEAP[y];STACKTOP=b;return y}_FNT_Face_Init.__index__=Runtime.getFunctionIndex(_FNT_Face_Init,"_FNT_Face_Init");
function _FNT_Size_Select(e){var g;g=HEAP[HEAP[e]+132]+4;_FT_Select_Metrics(HEAP[e],0);var d=unSign(HEAP[g+76],16)*64;HEAP[e+12+12]=d;d=unSign(HEAP[g+76],16);var b=unSign(HEAP[g+92],16);HEAP[e+12+16]=(d-b)*64;g=unSign(HEAP[g+98],16)*64;HEAP[e+12+24]=g;return 0}_FNT_Size_Select.__index__=Runtime.getFunctionIndex(_FNT_Size_Select,"_FNT_Size_Select");
function _FNT_Size_Request(e,g){var d,b,a,c,f,h;a=HEAP[HEAP[e]+132]+4;c=HEAP[HEAP[e]+32];f=23;h=HEAP[g+8];h=HEAP[g+16]!=0?Math.floor(reSign(HEAP[g+16]*h+36,32)/reSign(72,32)):h;h=reSign(h+32,32)>>reSign(6,32);d=HEAP[g];d=d==0?7:d==1?8:9;a:do if(d==9){f=7;d=5;break a}else if(d==7){if(reSign(HEAP[c+12]+32,32)>>reSign(6,32)!=h){d=2;break a}f=0;d=3;break a}else if(d==8){if(unSign(HEAP[a+92],16)!=h){d=2;break a}f=0;d=3;break a}while(0);a:do if(d==2){d=f!=0?5:3;break a}while(0);if(d==5)b=f;else if(d==3){b=
HEAP[e];b=HEAP[b+132]+4;_FT_Select_Metrics(HEAP[e],0);a=unSign(HEAP[b+76],16)*64;HEAP[e+12+12]=a;a=unSign(HEAP[b+76],16);c=unSign(HEAP[b+92],16);HEAP[e+12+16]=(a-c)*64;b=unSign(HEAP[b+98],16)*64;HEAP[e+12+24]=b;b=0}return b}_FNT_Size_Request.__index__=Runtime.getFunctionIndex(_FNT_Size_Request,"_FNT_Size_Request");
function _FNT_Load_Glyph(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c=null,f,h,i,k,j,l;d=d;h=HEAP[g];HEAP[b]=0;g=e+76;var m=h==0;a:do{if(!m){i=HEAP[h+132];var o=i==0;b:do if(!o){f=d;if(unSign(HEAP[h+16],32)<=unSign(f,32))break b;if(d!=0)d-=1;else d=unSign(HEAP[i+4+102],8);j=f=unSign(HEAP[i+4]==768,1);k=f=f!=0?6:4;a=HEAP[i+160];f=j!=0?148:118;f=a+f+d*k;f+=2;k=reSign(HEAP[f+-2+1],8)<<8&65535;a=unSign(HEAP[f+-2],8);k=reSign(k|a,16);HEAP[g+4]=k;f=f;if(j!=0){f=f+4;j=unSign(HEAP[f+-4+
3],8)<<24;k=unSign(HEAP[f+-4+2],8)<<16;a=unSign(HEAP[f+-4+1],8)<<8;f=unSign(HEAP[f+-4],8);k=k|j|a|f}else{f=f+2;j=unSign(HEAP[f+-2+1],8)<<8&65535;f=unSign(HEAP[f+-2],8);k=unSign(j|f,16)}f=k;if(unSign(HEAP[i+4+4],32)<=unSign(f,32)){HEAP[b]=3;break a}else{f=HEAP[i+160]+k;a=HEAP[HEAP[e+4]+100];j=reSign(HEAP[g+4]+7,32)>>reSign(3,32);HEAP[g+8]=j;c=unSign(HEAP[i+4+92],16);HEAP[g]=c;HEAP[g+18]=1;c=HEAP[i+4+4];if(unSign(j*HEAP[g]+k,32)>=unSign(c,32)){HEAP[b]=3;break a}else{k=_ft_mem_realloc(a,HEAP[g],0,j,
0,b);HEAP[g+12]=k;if(HEAP[b]!=0)break a;k=HEAP[g+12];a=reSign(j,32)>reSign(0,32)?9:10;for(;;)if(a==9){l=f+HEAP[g];c=k;if(f<l){a=g+8;l=l;var n=c;for(c=11;;){p=c==11?n:p;HEAP[p]=HEAP[f];f+=1;var p=p+HEAP[a];if(f<l)c=12;else break}}j=a=j-1;k+=1;a=reSign(a,32)>reSign(0,32)?9:10}else if(a==10){HEAP[HEAP[e+156]+4]=1;HEAP[e+100]=0;d=unSign(HEAP[i+4+76],16);HEAP[e+104]=d;HEAP[e+72]=1651078259;HEAP[e+24]=HEAP[g+4]<<6;HEAP[e+24+4]=HEAP[g]<<6;HEAP[e+24+16]=HEAP[g+4]<<6;HEAP[e+24+8]=0;HEAP[e+24+12]=HEAP[e+104]<<
6;_ft_synthesize_vertical_metrics(e+24,HEAP[g]<<6);break a}}}}while(0)}HEAP[b]=6}while(0);e=HEAP[b];STACKTOP=b;return e}_FNT_Load_Glyph.__index__=Runtime.getFunctionIndex(_FNT_Load_Glyph,"_FNT_Load_Glyph");function _winfnt_get_header(e,g){_llvm_memcpy_p0i8_p0i8_i32(g,HEAP[e+132]+4,156,4,0);return 0}_winfnt_get_header.__index__=Runtime.getFunctionIndex(_winfnt_get_header,"_winfnt_get_header");function _winfnt_get_service(e,g){return _ft_service_list_lookup(_winfnt_services,g)}
_winfnt_get_service.__index__=Runtime.getFunctionIndex(_winfnt_get_service,"_winfnt_get_service");
function _pcf_get_metric(e,g,d){var b=STACKTOP;STACKTOP+=5;Runtime.memset(b,0,5);var a,c=(g&-256)==0;a:do if(c){a=a=(g&4)!=0?_pcf_metric_msb_header:_pcf_metric_header;a=_FT_Stream_ReadFields(e,a,d)}else{a=_FT_Stream_ReadFields(e,_pcf_compressed_metric_header,b);if(a!=0)break a;var f=unSign(HEAP[b],8)-128;HEAP[d]=f;f=unSign(HEAP[b+1],8)-128;HEAP[d+2]=f;f=unSign(HEAP[b+2],8)-128;HEAP[d+4]=f;f=unSign(HEAP[b+3],8)-128;HEAP[d+6]=f;f=unSign(HEAP[b+4],8)-128;HEAP[d+8]=f;HEAP[d+10]=0}while(0);e=a;STACKTOP=
b;return e}_pcf_get_metric.__index__=Runtime.getFunctionIndex(_pcf_get_metric,"_pcf_get_metric");
function _pcf_seek_to_table_type(e,g,d,b,a,c){var f,h=null,i,k,j;i=3;j=j=0;h=-1;a:for(;;){f=h==2?m:0;var l=j+f;m=g+16*l;if(!(unSign(l,32)<unSign(d,32))){f=9;break a}if(HEAP[m]==b){f=1;break a}var m=f+1;h=2;f=0}a:do if(f==1){j=l;i=HEAP[g+16*j+12];if(!(unSign(HEAP[e+8],32)>unSign(i,32))){i=HEAP[g+16*j+12]-HEAP[e+8];e=e;i=i;d=reSign(i,32)<reSign(0,32);b:do if(!d){i=e=_FT_Stream_Seek(e,i+HEAP[e+8]);if(e!=0)break b;HEAP[c]=HEAP[g+16*j+8];HEAP[a]=HEAP[g+16*j+4];k=0;f=7;break a}while(0)}i=83;f=3;break a}else if(f==
9){f=3;break a}while(0);if(f==3){HEAP[c]=0;k=i}return k}_pcf_seek_to_table_type.__index__=Runtime.getFunctionIndex(_pcf_seek_to_table_type,"_pcf_seek_to_table_type");
function _pcf_find_property(e,g){var d,b=null,a,c,f;c=HEAP[e+284];f=0;var h=HEAP[e+280],i=f;b=-1;a:for(;;){d=b==1?m:0;var k=b==1?l:0,j=i+d;b=c+12*j;if(reSign(h,32)<=reSign(j,32)){d=2;break a}if(k!=0){d=4;break a}var l=_strcmp(HEAP[b],g)==0?1:0,m=d+1;b=1;d=0}a:do if(d==2){f=j;if(k!=0){d=5;break a}a=0;d=8;break a}else if(d==4){f=j;d=5;break a}while(0);if(d==5)a=c+12*f+-12;return a}_pcf_find_property.__index__=Runtime.getFunctionIndex(_pcf_find_property,"_pcf_find_property");
function _pcf_get_accel(e,g,d){var b=STACKTOP;STACKTOP+=12;Runtime.memset(b,0,12);var a=b+4,c=b+8,f;HEAP[c]=0;f=g+196;g=_pcf_seek_to_table_type(e,HEAP[g+184+8],HEAP[g+184+4],d,b,a);HEAP[c]=g;g=HEAP[c]!=0;a:do if(!g){d=_FT_Stream_ReadLongLE(e,c);HEAP[b]=d;if(HEAP[c]!=0)break a;if((HEAP[b]&-256)!=0)if((HEAP[b]&-256)!=256)break a;d=e;a=f;if((HEAP[b]&4)!=0){d=_FT_Stream_ReadFields(d,_pcf_accel_msb_header,a);HEAP[c]=d}else{d=_FT_Stream_ReadFields(d,_pcf_accel_header,a);HEAP[c]=d}if(HEAP[c]!=0)break a;
d=_pcf_get_metric(e,HEAP[b]&255,f+20);HEAP[c]=d;if(d!=0)break a;d=_pcf_get_metric(e,HEAP[b]&255,f+36);HEAP[c]=d;if(HEAP[c]!=0)break a;d=f+52;if((HEAP[b]&-256)==256){d=_pcf_get_metric(e,HEAP[b]&255,d);HEAP[c]=d;if(HEAP[c]!=0)break a;d=_pcf_get_metric(e,HEAP[b]&255,f+68);HEAP[c]=d}else{a=f+20;HEAP[d]=HEAP[a];HEAP[d+2]=HEAP[a+2];HEAP[d+4]=HEAP[a+4];HEAP[d+6]=HEAP[a+6];HEAP[d+8]=HEAP[a+8];HEAP[d+10]=HEAP[a+10];HEAP[d+12]=HEAP[a+12];d=f+68;a=f+36;HEAP[d]=HEAP[a];HEAP[d+2]=HEAP[a+2];HEAP[d+4]=HEAP[a+4];
HEAP[d+6]=HEAP[a+6];HEAP[d+8]=HEAP[a+8];HEAP[d+10]=HEAP[a+10];HEAP[d+12]=HEAP[a+12]}}while(0);e=HEAP[c];STACKTOP=b;return e}_pcf_get_accel.__index__=Runtime.getFunctionIndex(_pcf_get_accel,"_pcf_get_accel");
function _pcf_load_font(e,g){var d=STACKTOP;STACKTOP+=108;Runtime.memset(d,0,108);var b,a=null,c,f,h,i,k,j,l,m,o,n,p;h=d+4;var r,q,s,u,t,v,w,x,y,A,z,C,B,D=d+20,E;A=d+24;q=d+28;var F,G,H,J,L,N,I,P,K,O;E=d+32;var M;i=d+36;w=d+52;v=d+56;var Q,R;M=d+60;var T;K=d+64;P=d+68;var V,U,S,X,Y,W,da,ba,aa,ca,$,la,ga;Q=d+72;S=d+76;T=d+80;var ea,Z,ha;Y=d+84;var ia,ja=d+88,fa=d+104;HEAP[fa]=0;c=HEAP[g+100];W=g+184;da=HEAP[g+100];var ka=_FT_Stream_Seek(e,0);HEAP[Y]=ka;ka=HEAP[Y]!=0;a:do if(ka)b=0;else{ka=_FT_Stream_ReadFields(e,
_winpe_rsrc_dir_entry_fields,W);HEAP[Y]=ka;if(HEAP[Y]!=0){b=0;break a}a=HEAP[W]!=1885562369;b:do if(!a){if(unSign(HEAP[W+4],32)>unSign(134217727,32))break b;if(HEAP[W+4]==0)break b;a=_ft_mem_realloc(da,16,0,HEAP[W+4],0,Y);HEAP[g+184+8]=a;if(HEAP[Y]!=0){a=6;b=2}else{a=HEAP[g+184+8];ia=0;ka=W+4;var na=e,sa=ia,wa=a;a=7;c:for(;;){b=a==10?Da:0;Da=sa+b;var Aa=wa+16*b;if(!(unSign(HEAP[ka],32)>unSign(Da,32))){b=12;break c}Da=_FT_Stream_ReadFields(na,_winpe_rsrc_data_entry_fields,Aa);HEAP[Y]=Da;if(HEAP[Y]!=
0){b=9;break c}var Da=b+1;a=10;b=8}if(b==12){a=HEAP[g+184+8];ia=0;Y=W+4;W=W+4;ka=Da=da=a;na=ja;sa=ja+4;wa=ja+8;Aa=ja+12;var pa=Z=a,ta=a,ma=ja+4;$=ja+8;ja=ja+12;var ya=ga=a,qa=a,ua=a,Ba=a;ia=ia;var Na=HEAP[na],Ea=-1-ia;a=12;c:for(;;){b=a==23?ob:0;ea=a==23?ba:Na;ob=Ea+b*-1;a=ia+b;if(unSign(HEAP[Y]-1,32)>unSign(a,32))a=13;else{a=13;b=22;break c}for(;;){ha=a==18?ca:0;ba=a==18?Ga:ea;var ra=a==18?la:0,za=ra+1,Ha=ua+16*za+12,Ca=ya+16*za+12;a=ta+16*za;var va=ta+16*za+4,Pa=ta+16*za+8,Ja=ta+16*za+12,La=pa+
16*za,xa=pa+16*za+4,oa=pa+16*za+8,Fa=pa+16*za+12,Ma=Da+16*za+12,Ka=Ba+16*ra+8;za=qa+16*ra+12;var Ra=ga+16*ra+8,Qa=Z+16*ra,Va=Z+16*ra+4,Ta=Z+16*ra+8,Ua=Z+16*ra+12,ab=ka+16*ra,Sa=ka+16*ra+4,$a=ka+16*ra+8,Wa=ka+16*ra+12,eb=da+16*ra+12;if(!(unSign(ob+HEAP[W],32)>unSign(ra,32)))break;ca=HEAP[Ma];if(unSign(HEAP[eb],32)>unSign(ca,32)){aa=HEAP[ab];HEAP[sa]=HEAP[Sa];HEAP[wa]=HEAP[$a];HEAP[Aa]=HEAP[Wa];HEAP[Qa]=HEAP[La];HEAP[Va]=HEAP[xa];HEAP[Ta]=HEAP[oa];HEAP[Ua]=HEAP[Fa];HEAP[a]=aa;HEAP[va]=HEAP[ma];HEAP[Pa]=
HEAP[$];HEAP[Ja]=HEAP[ja];a=14}else a=20;ca=a==14?1:ha;var Ga=a==14?aa:ba;la=HEAP[Ca];if(unSign(HEAP[Ra],32)>unSign(la,32)){b=16;break c}la=HEAP[Ha]-HEAP[Ka];if(unSign(HEAP[za],32)>unSign(la,32)){b=16;break c}la=ra+1;a=18}if(ha==0){a=21;b=22;break c}var ob=b+1;a=23;b=13}if(b==22){HEAP[na]=a==13?ea:ba;HEAP[fa]=0}else if(b==16){HEAP[na]=Ga;a=16;b=2;break a}}else if(b==9){ha=HEAP[g+184+8];ea=da;ha=ha;ha!=0&&FUNCTION_TABLE[HEAP[ea+8]](ea,ha);HEAP[g+184+8]=0;ea=HEAP[Y];HEAP[fa]=ea;if(ea!=0){b=26;break a}}ea=
g;ba=e;aa=ea;ca=0;ea=HEAP[aa+100];ha=0;Ga=_pcf_seek_to_table_type(ba,HEAP[aa+184+8],HEAP[aa+184+4],1,Q,S);HEAP[T]=Ga;Ga=Ga!=0;c:do if(!Ga){la=_FT_Stream_ReadLongLE(ba,T);HEAP[Q]=la;if(HEAP[T]!=0){b=27;break c}if((HEAP[Q]&-256)!=0){b=27;break c}a=ba;if((HEAP[Q]&4)!=0){la=_FT_Stream_ReadLong(a,T);X=HEAP[T];a=30}else{la=_FT_Stream_ReadLongLE(a,T);var Oa=HEAP[T];a=32}if((a==32?Oa:X)!=0){b=27;break c}Y=Math.floor(unSign(HEAP[S],32)/unSign(9,32));W=la;if(unSign(Y,32)<unSign(W,32))HEAP[T]=8;else{HEAP[aa+
280]=la;ca=_ft_mem_realloc(ea,12,0,la,0,T);if(HEAP[T]!=0){b=27;break c}ga=0;Y=la;W=ca;da=ba;Da=ga;a=35;d:for(;;){b=a==39?Xa:0;ka=Da+b;na=W+12*ka;if(!(unSign(ka,32)<unSign(Y,32))){b=41;break d}if((HEAP[Q]&4)!=0){ka=_FT_Stream_ReadFields(da,_pcf_property_msb_header,na);HEAP[T]=ka}else{ka=_FT_Stream_ReadFields(da,_pcf_property_header,na);HEAP[T]=ka}if(HEAP[T]!=0){b=37;break d}var Xa=b+1;a=39;b=36}if(b==41){Y=(la&3)!=0;d:do if(Y){Y=ga=4-(la&3);b=ba;Y=Y;if(reSign(Y,32)<reSign(0,32))HEAP[T]=85;else{b=_FT_Stream_Seek(b,
Y+HEAP[b+8]);HEAP[T]=b;if(b==0){b=43;break d}}HEAP[T]=83;b=27;break c}while(0);a=ba;if((HEAP[Q]&4)!=0){Z=_FT_Stream_ReadLong(a,T);var bb=HEAP[T];a=44}else{Z=_FT_Stream_ReadLongLE(a,T);var jb=HEAP[T];a=46}if((a==46?jb:bb)!=0){b=27;break c}Y=Z;if(unSign(HEAP[S]-la*9,32)<unSign(Y,32))HEAP[T]=8;else{ha=_ft_mem_realloc(ea,1,0,Z,0,T);if(HEAP[T]!=0){b=27;break c}W=ha;da=Z;Y=ba;W=W;da=da;Y=Y=_FT_Stream_ReadAt(Y,HEAP[Y+8],W,da);HEAP[T]=Y;if(HEAP[T]!=0){b=27;break c}$=_ft_mem_realloc(ea,12,0,la,0,T);if(HEAP[T]!=
0){b=27;break c}HEAP[aa+284]=$;ga=0;la=la;Y=ca;W=Z;da=$;Da=ha;ka=ea;na=$;Aa=wa=sa=ca;Z=Z;pa=$;ta=ha;ma=ea;$=$;ja=ca;ga=ga;for(a=50;;){b=a==66?Ya:0;ra=ga+b;qa=ja+12*ra+8;ua=$+12*ra+8;ya=pa+12*ra+8;Ba=Aa+12*ra+8;ia=wa+12*ra+4;Na=sa+12*ra+4;Ea=na+12*ra+4;ob=da+12*ra;Ha=Y+12*ra;if(!(unSign(ra,32)<unSign(la,32))){b=68;break}ra=HEAP[Ha];Ha=reSign(ra,32)<reSign(0,32);za=unSign(ra,32)>unSign(W,32);if(Ha|za){b=52;break}ra=Da+ra;if(ra!=0){var Za=_strlen(ra)+1;a=54}else a=53;a=_ft_mem_dup(ka,ra,a==54?Za:0,T);
HEAP[ob]=a;if(HEAP[T]!=0){a=56;b=57;break}else a=56;HEAP[Ea]=HEAP[Na];if(HEAP[ia]!=0){qa=HEAP[Ba];ua=reSign(qa,32)<reSign(0,32);Ba=unSign(qa,32)>unSign(Z,32);if(ua|Ba){b=59;break}qa=ta+qa;if(qa!=0){var fb=_strlen(qa)+1;a=61}else a=60;a=_ft_mem_dup(ma,qa,a==61?fb:0,T);HEAP[ya]=a;if(HEAP[T]!=0){a=63;b=57;break}}else HEAP[ua]=HEAP[qa];var Ya=b+1;a=66;b=51}if(b==68)HEAP[T]=0;else if(b==52)HEAP[T]=9;else if(b!=57)if(b==59)HEAP[T]=9}}}}while(0);X=ca;Q=ea;S=X;X!=0&&FUNCTION_TABLE[HEAP[Q+8]](Q,S);Q=ha;S=
ea;X=Q;Q!=0&&FUNCTION_TABLE[HEAP[S+8]](S,X);T=HEAP[T];HEAP[fa]=T;if(T!=0){b=26;break a}T=HEAP[g+184+4];a=HEAP[g+184+8];T=T=T;Q=a;a=71;c:for(;;){b=a==74?R:0;R=0+b;S=Q+16*R;if(!(unSign(R,32)<unSign(T,32))){b=77;break c}if(HEAP[S]==256){b=73;break c}R=b+1;a=74;b=72}if(b==77)U=0;else if(b==73)U=1;U=U;U=R=U&255;if(R==0){R=_pcf_get_accel(e,g,2);HEAP[fa]=R;if(HEAP[fa]!=0){b=26;break a}}R=g;Q=e;R=R;HEAP[M]=0;T=HEAP[R+100];S=_pcf_seek_to_table_type(Q,HEAP[R+184+8],HEAP[R+184+4],4,K,P);HEAP[M]=S;if(S!=0){O=
HEAP[M];a=79}else{V=_FT_Stream_ReadLongLE(Q,M);HEAP[K]=V;V=HEAP[M]!=0;c:do if(!V){V=(HEAP[K]&-256)!=0;d:do if(V){if((HEAP[K]&-256)==256){b=82;break d}a=81;b=83;break d}else b=82;while(0);d:do if(b==82){a=(HEAP[K]&4)!=0;V=Q;if((HEAP[K]&-256)==0)if(a){V=_FT_Stream_ReadLong(V,M);L=HEAP[M];a=84}else{V=_FT_Stream_ReadLongLE(V,M);N=HEAP[M];a=86}else if(a){a=_FT_Stream_ReadShort(V,M);V=unSign(a,16);var Ia=HEAP[M];a=87}else{a=_FT_Stream_ReadShortLE(V,M);V=unSign(a,16);var cb=HEAP[M];a=88}if((a==84?L:a==86?
N:a==88?cb:Ia)!=0)a=89;else{HEAP[R+288]=V;if(V==0)a=91;else{a=(HEAP[K]&-256)==0;S=HEAP[P];e:do{if(a){a=Math.floor(unSign(S,32)/unSign(12,32));b=V;if(!(unSign(a,32)<unSign(b,32))){b=93;break e}a=92}else{a=Math.floor(unSign(S,32)/unSign(5,32));b=V;if(!(unSign(a,32)<unSign(b,32))){b=93;break e}a=94}break d}while(0);a=_ft_mem_realloc(T,16,0,V,0,M);HEAP[R+292]=a;if(HEAP[M]!=0)a=95;else{a=HEAP[R+292];P=V;L=a;N=Q;Ia=a;for(a=96;;){a=a==99?I:0;I=0+a;b=Ia+16*I+12;cb=L+16*I;if(!(unSign(I,32)<unSign(P,32))){b=
101;break}I=_pcf_get_metric(N,HEAP[K],cb);HEAP[M]=I;HEAP[b]=0;if(HEAP[M]!=0){b=98;break}I=a+1;a=99;b=97}if(b==101)if(HEAP[M]==0){b=103;break c}a=HEAP[R+292];b=T;K=a;a!=0&&FUNCTION_TABLE[HEAP[b+8]](b,K);HEAP[R+292]=0;b=103;break c}}}}while(0);HEAP[fa]=a==81?3:a==89?3:a==91?8:a==92?8:a==94?8:64;b=26;break a}while(0);V=HEAP[M];a=103}M=a==79?O:V;HEAP[fa]=M;if(M!=0){b=26;break a}M=g;K=e;O=M;HEAP[E]=0;M=HEAP[O+100];I=_pcf_seek_to_table_type(K,HEAP[O+184+8],HEAP[O+184+4],8,w,v);HEAP[E]=I;I=HEAP[E]!=0;c:do if(I){B=
HEAP[E];a=106}else{P=_FT_Stream_EnterFrame(K,8);HEAP[E]=P;if(HEAP[E]!=0){C=HEAP[E];a=108}else{I=K;L=0;P=HEAP[I+32];if(P+3<HEAP[I+36]){P+=4;L=reSign(HEAP[P+-4+3],8)<<24;N=unSign(HEAP[P+-4+2],8)<<16;Ia=unSign(HEAP[P+-4+1],8)<<8;cb=unSign(HEAP[P+-4],8);L=N|L|Ia|cb}HEAP[I+32]=P;I=I=L;HEAP[w]=I;I=K;if((HEAP[w]&4)!=0){I=I;L=0;P=HEAP[I+32];if(P+3<HEAP[I+36]){P+=4;L=reSign(HEAP[P+-4],8)<<24;N=unSign(HEAP[P+-4+1],8)<<16;Ia=unSign(HEAP[P+-4+2],8)<<8;cb=unSign(HEAP[P+-4+3],8);L=N|L|Ia|cb}HEAP[I+32]=P;P=I=I=
L}else{I=I;L=0;P=HEAP[I+32];if(P+3<HEAP[I+36]){P+=4;L=reSign(HEAP[P+-4+3],8)<<24;N=unSign(HEAP[P+-4+2],8)<<16;Ia=unSign(HEAP[P+-4+1],8)<<8;cb=unSign(HEAP[P+-4],8);L=N|L|Ia|cb}HEAP[I+32]=P;P=I=I=L}I=K;if(HEAP[I+20]!=0){L=HEAP[I+28];N=HEAP[I];L=L;N=N;N!=0&&FUNCTION_TABLE[HEAP[L+8]](L,N);HEAP[I]=0}HEAP[I+32]=0;HEAP[I+36]=0;if((HEAP[w]&-256)==0){I=reSign(HEAP[O+288],32)<reSign(0,32);d:do if(!I){if(HEAP[O+288]!=P)break d;I=_ft_mem_realloc(M,4,0,P,0,E);if(HEAP[E]!=0){J=HEAP[E];a=118}else{a=0;F=P;if(unSign(a,
32)<unSign(F,32)){F=K;L=I;cb=P;N=I;Ia=a;a=Ia+1;unSign(cb,32);unSign(a,32);cb=(unSign(cb,32)>unSign(a,32)?cb:a)-Ia;for(a=120;;){a=a==120?0:G;b=Ia+a;G=N+4*b;b=L+4*b;if((HEAP[w]&4)!=0){G=_FT_Stream_ReadLong(F,E);HEAP[b]=G}else{b=_FT_Stream_ReadLongLE(F,E);HEAP[G]=b}G=a+1;if(G!=cb){a=123;b=121}else{b=124;break}}}if(HEAP[E]==0){a=0;G=K;F=a;L=F+1;a=126;e:for(;;){H=a==132?H:0;N=L+H;b=i+(F+H)*4;if(!(unSign(a==132?N:0,32)<=unSign(3,32))){b=134;break e}if((HEAP[w]&4)!=0){a=_FT_Stream_ReadLong(G,E);HEAP[b]=
a;u=HEAP[E];a=128}else{a=_FT_Stream_ReadLongLE(G,E);HEAP[b]=a;t=HEAP[E];a=130}if((a==130?t:u)!=0){b=131;break e}H=H+1;a=132;b=127}if(b==134){a=0;u=P;if(unSign(a,32)<unSign(u,32)){t=u=I;H=O+292;G=K+8;F=I;K=P;b=a;a=b+1;unSign(K,32);unSign(a,32);K=(unSign(K,32)>unSign(a,32)?K:a)-b;a=135;e:for(;;){a=a==135?0:s;s=b+a;P=F+4*s;L=t+4*s;N=reSign(HEAP[u+4*s],32)>=reSign(0,32);f:do if(N){Ia=HEAP[v];if(!(unSign(HEAP[L],32)<=unSign(Ia,32)))break f;HEAP[HEAP[H]+16*s+12]=HEAP[P]+HEAP[G]}while(0);s=a+1;if(s!=K)a=
138;else break e}}HEAP[O+308]=HEAP[w]}}a=I;w=M;v=a;a!=0&&FUNCTION_TABLE[HEAP[w+8]](w,v);F=HEAP[E];a=144}break c}while(0)}HEAP[fa]=3;b=26;break a}}while(0);E=a==106?B:a==108?C:a==118?J:F;HEAP[fa]=E;if(E!=0){b=26;break a}a=g;C=e;B=a;HEAP[D]=0;E=HEAP[B+100];J=0;a=_pcf_seek_to_table_type(C,HEAP[B+184+8],HEAP[B+184+4],32,A,q);HEAP[D]=a;q=HEAP[D]!=0;c:do if(q){o=HEAP[D];a=146}else{a=_FT_Stream_EnterFrame(C,14);HEAP[D]=a;if(HEAP[D]!=0){n=HEAP[D];a=148}else{a=C;w=0;q=HEAP[a+32];if(q+3<HEAP[a+36]){q+=4;w=
reSign(HEAP[q+-4+3],8)<<24;v=unSign(HEAP[q+-4+2],8)<<16;s=unSign(HEAP[q+-4+1],8)<<8;u=unSign(HEAP[q+-4],8);w=v|w|s|u}HEAP[a+32]=q;a=a=w;HEAP[A]=a;a=C;if((HEAP[A]&4)!=0){a=a;w=0;q=HEAP[a+32];if(q+1<HEAP[a+36]){q+=2;w=reSign(HEAP[q+-2],8)<<8&65535;v=unSign(HEAP[q+-2+1],8);w=w|v}HEAP[a+32]=q;a=a=reSign(w,16);a=reSign(a&65535,16);q=C;v=0;w=HEAP[q+32];if(w+1<HEAP[q+36]){w+=2;v=reSign(HEAP[w+-2],8)<<8&65535;s=unSign(HEAP[w+-2+1],8);v=v|s}HEAP[q+32]=w;q=q=reSign(v,16);w=reSign(q&65535,16);q=C;s=0;v=HEAP[q+
32];if(v+1<HEAP[q+36]){v+=2;s=reSign(HEAP[v+-2],8)<<8&65535;u=unSign(HEAP[v+-2+1],8);s=s|u}HEAP[q+32]=v;q=q=reSign(s,16);v=reSign(q&65535,16);q=C;u=0;s=HEAP[q+32];if(s+1<HEAP[q+36]){s+=2;u=reSign(HEAP[s+-2],8)<<8&65535;t=unSign(HEAP[s+-2+1],8);u=u|t}HEAP[q+32]=s;q=q=reSign(u,16);q=reSign(q&65535,16);s=C;t=0;u=HEAP[s+32];if(u+1<HEAP[s+36]){u+=2;t=reSign(HEAP[u+-2],8)<<8&65535;H=unSign(HEAP[u+-2+1],8);t=t|H}HEAP[s+32]=u;s=s=reSign(t,16);HEAP[B+304]=s&65535}else{a=a;w=0;q=HEAP[a+32];if(q+1<HEAP[a+36]){q+=
2;w=reSign(HEAP[q+-2+1],8)<<8&65535;v=unSign(HEAP[q+-2],8);w=w|v}HEAP[a+32]=q;a=a=reSign(w,16);a=reSign(a&65535,16);q=C;v=0;w=HEAP[q+32];if(w+1<HEAP[q+36]){w+=2;v=reSign(HEAP[w+-2+1],8)<<8&65535;s=unSign(HEAP[w+-2],8);v=v|s}HEAP[q+32]=w;q=q=reSign(v,16);w=reSign(q&65535,16);q=C;s=0;v=HEAP[q+32];if(v+1<HEAP[q+36]){v+=2;s=reSign(HEAP[v+-2+1],8)<<8&65535;u=unSign(HEAP[v+-2],8);s=s|u}HEAP[q+32]=v;q=q=reSign(s,16);v=reSign(q&65535,16);q=C;u=0;s=HEAP[q+32];if(s+1<HEAP[q+36]){s+=2;u=reSign(HEAP[s+-2+1],
8)<<8&65535;t=unSign(HEAP[s+-2],8);u=u|t}HEAP[q+32]=s;q=q=reSign(u,16);q=reSign(q&65535,16);s=C;t=0;u=HEAP[s+32];if(u+1<HEAP[s+36]){u+=2;t=reSign(HEAP[u+-2+1],8)<<8&65535;H=unSign(HEAP[u+-2],8);t=t|H}HEAP[s+32]=u;s=s=reSign(t,16);HEAP[B+304]=s&65535}s=C;if(HEAP[s+20]!=0){u=HEAP[s+28];t=HEAP[s];u=u;t=t;t!=0&&FUNCTION_TABLE[HEAP[u+8]](u,t);HEAP[s]=0}HEAP[s+32]=0;HEAP[s+36]=0;if((HEAP[A]&-256)!=0)a=163;else{F=(q+1+(0-v))*(w+1+(0-a));q=_ft_mem_realloc(E,8,0,F,0,D);if(HEAP[D]!=0)a=165;else{s=_FT_Stream_EnterFrame(C,
F*2);HEAP[D]=s;s=HEAP[D]!=0;d:do if(!s){H=G=0;J=F;if(reSign(G,32)<reSign(J,32)){O=C;J=q;s=w+1+(0-a);v=v;w=w+1+(0-a);u=a;t=q;a=F;G=G;H=H;F=G+1;reSign(a,32);reSign(F,32);F=O+32;b=O+36;M=O+32;O=O+32;K=G+1;K=(reSign(a,32)>reSign(K,32)?a:K)-G;for(a=166;;){yb=a==166?0:yb;ub=a==166?H:ub;I=G+yb;P=HEAP[F];a=P+1<HEAP[b];if((HEAP[A]&4)!=0){if(a){x=P+2;var pb=reSign(HEAP[x+-2],8)<<8&65535,gb=unSign(HEAP[x+-2+1],8);pb=pb|gb;a=168}else a=276;gb=a==276?0:pb;HEAP[M]=a==276?P:x;gb=reSign(gb,16)&65535;gb=reSign(gb,
16);a=170}else{if(a){y=P+2;var hb=reSign(HEAP[y+-2+1],8)<<8&65535,kb=unSign(HEAP[y+-2],8);hb=hb|kb;a=172}else a=277;kb=a==277?0:hb;HEAP[O]=a==277?P:y;kb=reSign(kb,16)&65535;kb=reSign(kb,16);a=174}a=a==174?kb:gb;if(a!=-1){var db=J+8*ub;P=(Math.floor(reSign(I,32)/reSign(s,32))+v)*256;I=reSign(I,32)%reSign(w,32)+u+P;HEAP[db]=I;HEAP[t+8*ub+4]=a&65535;db=ub+1;a=175}else a=369;var ub=a==175?db:ub,yb=yb+1;if(yb!=K)a=177;else break}H=ub}A=C;if(HEAP[A+20]!=0){x=HEAP[A+28];y=HEAP[A];x=x;y=y;y!=0&&FUNCTION_TABLE[HEAP[x+
8]](x,y);HEAP[A]=0}HEAP[A+32]=0;HEAP[A+36]=0;J=_ft_mem_realloc(E,8,0,H,0,D);if(HEAP[D]!=0)break d;G=0;z=H;if(reSign(G,32)<reSign(z,32)){z=J;A=q;x=J;y=q;hb=H;pb=G;db=pb+1;reSign(hb,32);reSign(db,32);hb=(reSign(hb,32)>reSign(db,32)?hb:db)-pb;for(a=184;;){l=a==184?0:l;db=pb+l;gb=x+8*db+4;kb=y+8*db+4;HEAP[z+8*db]=HEAP[A+8*db];HEAP[gb]=HEAP[kb];l=l+1;if(l!=hb)a=185;else break}}HEAP[B+296]=H;HEAP[B+300]=J;l=q;z=E;A=l;l!=0&&FUNCTION_TABLE[HEAP[z+8]](z,A);z=HEAP[D];a=189;break c}while(0);A=J;p=E;l=A;A!=0&&
FUNCTION_TABLE[HEAP[p+8]](p,l);p=q;l=E;A=p;p!=0&&FUNCTION_TABLE[HEAP[l+8]](l,A);p=HEAP[D];a=193;break c}}HEAP[fa]=a==163?3:64;b=26;break a}}while(0);D=a==146?o:a==148?n:a==189?z:p;HEAP[fa]=D;if(D!=0){b=26;break a}if(U!=0){D=_pcf_get_accel(e,g,256);HEAP[fa]=D;if(HEAP[fa]!=0){b=26;break a}}D=g;HEAP[D]=1;HEAP[D+4]=0;HEAP[D+8]=146;if(HEAP[g+196+3]!=0)HEAP[D+8]|=4;l=g;HEAP[d]=0;o=l;n=HEAP[o+100];HEAP[h]=0;HEAP[h+4]=0;HEAP[h+8]=0;HEAP[h+12]=0;HEAP[o+12]=0;p=z=_pcf_find_property(l,__str214);z=z!=0;c:do if(z){if(HEAP[p+
4]==0)break c;A=HEAP[HEAP[p+8]]==79;d:do if(!A){if(HEAP[HEAP[p+8]]==111)break d;if(HEAP[HEAP[p+8]]==73)break d;if(HEAP[HEAP[p+8]]!=105)break c}while(0);HEAP[o+12]|=1;A=HEAP[HEAP[p+8]]==79;d:do if(A)b=203;else{if(HEAP[HEAP[p+8]]==111){b=203;break d}m=__str3209;b=206;break d}while(0);if(b==203)m=__str1215;HEAP[h+8]=m}while(0);p=m=_pcf_find_property(l,__str3217);m=m!=0;c:do if(m){if(HEAP[p+4]==0)break c;if(HEAP[HEAP[p+8]]!=66)if(HEAP[HEAP[p+8]]!=98)break c;HEAP[o+12]|=2;HEAP[h+4]=__str63}while(0);p=
m=_pcf_find_property(l,__str5219);m=m!=0;c:do if(m){if(HEAP[p+4]==0)break c;if(HEAP[HEAP[p+8]]==0)break c;if(HEAP[HEAP[p+8]]==78)break c;if(HEAP[HEAP[p+8]]==110)break c;HEAP[h+12]=HEAP[p+8]}while(0);p=m=_pcf_find_property(l,__str6220);m=m!=0;c:do if(m){if(HEAP[p+4]==0)break c;if(HEAP[HEAP[p+8]]==0)break c;if(HEAP[HEAP[p+8]]==78)break c;if(HEAP[HEAP[p+8]]==110)break c;HEAP[h]=HEAP[p+8]}while(0);p=m=m=p=0;l=4-m;a=219;c:for(;;){zb=a==219?0:zb;rb=a==219?p:rb;A=m+zb;z=h+A*4;A=i+A*4;HEAP[A]=0;if(HEAP[z]!=
0){r=_strlen(HEAP[z]);HEAP[A]=r;r=rb+1+HEAP[A];a=225}else a=224;var rb=a==225?r:rb,zb=zb+1;if(zb!=l)a=227;else break c}p=rb;if(p==0){HEAP[h]=__str62;r=_strlen(HEAP[h]);HEAP[i]=r;p=HEAP[i]+1}r=_ft_mem_alloc(n,p,d);HEAP[o+24]=r;if(HEAP[d]!=0){k=HEAP[d];a=230}else{r=HEAP[o+24];m=0;var Fb=o+24;r=r;rb=m;zb=4-rb;a=232;c:for(;;){Jb=a==232?0:Jb;xb=a==232?r:xb;o=rb+Jb;n=HEAP[h+o*4];m=HEAP[i+o*4];if(n==0)a=233;else{if(HEAP[Fb]!=xb){HEAP[xb]=32;j=xb+1;a=234}else a=394;var Ib=a==234?j:xb;_llvm_memcpy_p0i8_p0i8_i32(Ib,
n,m,1,0);b=o==0?236:o==3?236:238;d:do if(b==236){if(unSign(0,32)<unSign(m,32))a=236;else break d;for(;;){qb=a==240?qb:0;o=Ib+qb;if(HEAP[o]==32)HEAP[o]=45;var qb=qb+1;if(qb!=m){a=240;b=237}else break d}}while(0);Ib=Ib+m;a=238}var xb=a==238?Ib:xb,Jb=Jb+1;if(Jb!=zb)a=242;else break c}r=xb;HEAP[r]=0;Fb=HEAP[d];a=243}h=a==230?k:Fb;HEAP[fa]=h;if(h!=0){b=26;break a}j=_pcf_find_property(g,__str8222);h=j==0;c:do if(h)b=245;else{if(HEAP[j+4]==0){b=245;break c}i=HEAP[j+8];h=c;i=i;k=fa;j=j=i!=0?_strlen(i)+1:
0;h=h=_ft_mem_dup(h,i,j,k);HEAP[D+20]=h;if(HEAP[fa]!=0){b=26;break a}else{b=248;break c}}while(0);if(b==245)HEAP[D+20]=0;HEAP[D+16]=HEAP[g+288]+1;HEAP[D+28]=1;h=_ft_mem_realloc(c,16,0,1,0,fa);HEAP[D+32]=h;if(HEAP[fa]!=0){b=26;break a}h=HEAP[D+32];i=k=0;_llvm_memset_p0i8_i32(h,0,16,1,0);HEAP[h]=(HEAP[g+196+12]&65535)+(HEAP[g+196+8]&65535);j=_pcf_find_property(g,__str9223);if(j!=0){j=Math.floor(reSign(HEAP[j+8]+5,32)/reSign(10,32))&65535;HEAP[h+2]=j}else{j=reSign(HEAP[h],16)*2;j=Math.floor(reSign(j,
32)/reSign(3,32))&65535;HEAP[h+2]=j}j=qb=_pcf_find_property(g,__str10224);if(qb!=0){j=Math.floor(reSign(HEAP[j+8]*460800+36135,32)/reSign(72270,32));HEAP[h+4]=j}j=qb=_pcf_find_property(g,__str11225);if(qb!=0){j=reSign(HEAP[j+8]&65535,16)<<6;HEAP[h+12]=j}j=qb=_pcf_find_property(g,__str12226);if(qb!=0)k=HEAP[j+8]&65535;j=qb=_pcf_find_property(g,__str13227);if(qb!=0)i=HEAP[j+8]&65535;j=HEAP[h+12]==0;c:do if(j){HEAP[h+12]=HEAP[h+4];if(i==0)break c;qb=HEAP[h+12];qb=reSign(i,16)*qb;qb=Math.floor(reSign(qb,
32)/reSign(72,32));HEAP[h+12]=qb}while(0);j=k==0;c:do if(j)b=259;else{if(i==0){b=259;break c}j=HEAP[h+12];k=reSign(k,16)*j;i=reSign(i,16);i=Math.floor(reSign(k,32)/reSign(i,32));HEAP[h+8]=i;b=261;break c}while(0);if(b==259)HEAP[h+8]=HEAP[h+12];h=k=_pcf_find_property(g,__str14228);i=_pcf_find_property(g,__str15229);k=k!=0;c:do if(k){if(HEAP[h+4]==0){b=264;break c}if(i==0){b=264;break c}if(HEAP[i+4]==0){b=264;break c}i=HEAP[i+8];f=c;i=i;k=fa;j=j=i!=0?_strlen(i)+1:0;f=f=_ft_mem_dup(f,i,j,k);HEAP[g+176]=
f;if(HEAP[fa]!=0){b=26;break a}f=HEAP[h+8];c=c;f=f;h=fa;i=i=f!=0?_strlen(f)+1:0;c=c=_ft_mem_dup(c,f,i,h);HEAP[g+180]=c;f=HEAP[fa];a=270;b=271;break c}else b=264;while(0);if(b==264){var Hb=HEAP[fa];a=264}b=(a==264?Hb:f)!=0?26:273}break a}while(0);a=3;b=2;break a}while(0);a:do if(b==0){a=0;b=2;break a}while(0);a:do if(b==2){HEAP[fa]=a==0?1:a==3?3:a==6?64:9;b=26;break a}while(0);if(b==26)HEAP[fa]=3;fa=HEAP[fa];STACKTOP=d;return fa}_pcf_load_font.__index__=Runtime.getFunctionIndex(_pcf_load_font,"_pcf_load_font");
function _pcf_cmap_init(e){var g;g=HEAP[e];HEAP[e+16]=HEAP[g+296];HEAP[e+20]=HEAP[g+300];return 0}_pcf_cmap_init.__index__=Runtime.getFunctionIndex(_pcf_cmap_init,"_pcf_cmap_init");function _pcf_cmap_done(e){HEAP[e+20]=0;HEAP[e+16]=0}_pcf_cmap_done.__index__=Runtime.getFunctionIndex(_pcf_cmap_done,"_pcf_cmap_done");
function _pcf_cmap_char_index(e,g){var d,b=null,a,c;a=HEAP[e+20];c=0;var f=HEAP[e+16];for(b=-1;;){var h=b==-1?f:b==4?h:i;k=b==-1?0:b==4?k:k;if(!(unSign(k,32)<unSign(h,32))){d=6;break}var i=unSign(h+k,32)>>>unSign(1,32);b=HEAP[a+8*i];if(g==b){d=1;break}d=i+1;var k=(b=unSign(g,32)<unSign(b,32))?k:d;b=b?2:4;d=0}if(d==1){c=i;c=unSign(HEAP[a+8*c+4],16)+1}return c}_pcf_cmap_char_index.__index__=Runtime.getFunctionIndex(_pcf_cmap_char_index,"_pcf_cmap_char_index");
function _pcf_cmap_char_next(e,g){var d,b=null,a,c,f,h;a=HEAP[e+20];h=HEAP[g]+1;c=f=0;var i=h,k=h;c=c;var j=HEAP[e+16];b=-1;a:for(;;){var l=b==-1?j:b==4?l:o,m=b==-1?c:b==4?n:n;if(!(unSign(m,32)<unSign(l,32))){d=6;break a}var o=unSign(l+m,32)>>>unSign(1,32);n=HEAP[a+8*o];if(i==n){d=1;break a}d=o+1;var n=(b=unSign(k,32)<unSign(n,32))?m:d;if(b){b=2;d=0;continue a}b=4;d=0}a:do if(d==1){f=o;f=unSign(HEAP[a+8*f+4],16)+1}else if(d==6){c=m;h=0;i=c;if(!(unSign(HEAP[e+16],32)>unSign(i,32)))break a;h=HEAP[a+
8*c];f=unSign(HEAP[a+8*c+4],16)+1}while(0);HEAP[g]=h;return f}_pcf_cmap_char_next.__index__=Runtime.getFunctionIndex(_pcf_cmap_char_next,"_pcf_cmap_char_next");
function _PCF_Face_Done(e){var g=null,d,b,a,c=e==0;a:do if(!c){d=HEAP[e+100];b=HEAP[e+300];a=d;b=b;b!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[e+300]=0;var f=HEAP[e+292];a=d;b=f;f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[e+292]=0;a=HEAP[e+284]!=0;b:do if(a){if(!(reSign(HEAP[e+280],32)>reSign(0,32)))break b;f=b=d;g=2;c:for(;;){l=g==2?0:l;g=0+l;var h=1+l,i=HEAP[e+284],k=i+12*g!=0;d:do if(k){var j=HEAP[i+12*g];j!=0&&FUNCTION_TABLE[HEAP[b+8]](b,j);HEAP[i+12*g]=0;if(HEAP[i+12*g+4]==0)break d;j=HEAP[i+12*
g+8];j!=0&&FUNCTION_TABLE[HEAP[f+8]](f,j);HEAP[i+12*g+8]=0}while(0);g=reSign(HEAP[e+280],32)>reSign(h,32);var l=l+1;if(g)g=8;else break c}}while(0);f=HEAP[e+284];a=d;b=f;f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[e+284]=0;f=HEAP[e+184+8];a=d;b=f;f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[e+184+8]=0;f=HEAP[e+20];a=d;b=f;f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[e+20]=0;f=HEAP[e+24];a=d;b=f;f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[e+24]=0;f=HEAP[e+32];a=d;b=f;f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[e+
32]=0;f=HEAP[e+176];a=d;b=f;f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[e+176]=0;a=HEAP[e+180];d=d;b=a;a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[e+180]=0;if(HEAP[e+104]!=e+132)break a;d=e+132;a=d!=0;b:do if(a){if(HEAP[d+24]==0)break b;FUNCTION_TABLE[HEAP[d+24]](d)}while(0);HEAP[e+104]=HEAP[e+172]}while(0)}_PCF_Face_Done.__index__=Runtime.getFunctionIndex(_PCF_Face_Done,"_PCF_Face_Done");
function _PCF_Face_Init(e,g){var d=STACKTOP;STACKTOP+=12;Runtime.memset(d,0,12);var b,a,c;a=e;c=_pcf_load_font(a,g);var f=c!=0;a:do if(f){_PCF_Face_Done(g);b=_FT_Stream_OpenGzip(g+132,a);f=(b&255)==7;b:do if(!f){c=b;if(c!=0){c=_FT_Stream_OpenLZW(g+132,a);if((c&255)==7)break b;if(c!=0)break b}HEAP[g+172]=a;HEAP[g+104]=g+132;a=HEAP[g+104];var h=_pcf_load_font(a,g);c=h;if(h==0){b=4;break a}}while(0);_PCF_Face_Done(g);c=2;b=15;break a}else b=4;while(0);if(b==4){f=HEAP[g+180];a=HEAP[g+176];c=0;h=f!=0;
a:do if(h){if(a==0)break a;b=f;if(HEAP[b]!=105)if(HEAP[b]!=73)break a;if(HEAP[b+1]!=115)if(HEAP[b+1]!=83)break a;if(HEAP[b+2]!=111)if(HEAP[b+2]!=79)break a;b+=3;if(_strcmp(b,__str16230)!=0){if(_strcmp(b,__str17231)!=0)break a;if(_strcmp(HEAP[g+176],__str18232)!=0)break a}c=1}while(0);HEAP[d]=g;_llvm_memset_p0i8_i64(d+4,0,8,4,0);if(c!=0){HEAP[d+4]=1970170211;HEAP[d+8]=3;HEAP[d+10]=1}c=_FT_CMap_New(_pcf_cmap_class,0,d,0)}a=c;STACKTOP=d;return a}
_PCF_Face_Init.__index__=Runtime.getFunctionIndex(_PCF_Face_Init,"_PCF_Face_Init");function _PCF_Size_Select(e,g){var d;d=HEAP[e]+196;_FT_Select_Metrics(HEAP[e],g);HEAP[e+12+12]=HEAP[d+8]<<6;HEAP[e+12+16]=0-HEAP[d+12]<<6;d=reSign(HEAP[d+36+4],16)<<6;HEAP[e+12+24]=d;return 0}_PCF_Size_Select.__index__=Runtime.getFunctionIndex(_PCF_Size_Select,"_PCF_Size_Select");
function _PCF_Size_Request(e,g){var d,b,a,c,f,h;a=HEAP[e];c=HEAP[HEAP[e]+32];f=23;h=HEAP[g+8];h=HEAP[g+16]!=0?Math.floor(reSign(HEAP[g+16]*h+36,32)/reSign(72,32)):h;h=reSign(h+32,32)>>reSign(6,32);d=HEAP[g];d=d==0?7:d==1?8:9;a:do if(d==9){f=7;d=5;break a}else if(d==7){if(reSign(HEAP[c+12]+32,32)>>reSign(6,32)!=h){d=2;break a}f=0;d=3;break a}else if(d==8){if(HEAP[a+196+12]+HEAP[a+196+8]!=h){d=2;break a}f=0;d=3;break a}while(0);a:do if(d==2){d=f!=0?5:3;break a}while(0);if(d==5)b=f;else if(d==3){b=HEAP[e]+
196;_FT_Select_Metrics(HEAP[e],0);HEAP[e+12+12]=HEAP[b+8]<<6;HEAP[e+12+16]=0-HEAP[b+12]<<6;b=reSign(HEAP[b+36+4],16)<<6;HEAP[e+12+24]=b;b=0}return b}_PCF_Size_Request.__index__=Runtime.getFunctionIndex(_PCF_Size_Request,"_PCF_Size_Request");
function _PCF_Glyph_Load(e,g,d){var b,a=null,c,f,h,i,k,j;i=d;g=HEAP[g];h=0;d=e+76;j=g==0;a:do if(j)b=0;else{j=i;if(unSign(HEAP[g+16],32)<=unSign(j,32)){b=0;break a}c=HEAP[g+104];if(i!=0)i-=1;i=HEAP[g+292]+16*i;j=reSign(HEAP[i+6],16);j=reSign(HEAP[i+8],16)+j;HEAP[d]=j;j=reSign(HEAP[i+2],16);b=reSign(HEAP[i],16);HEAP[d+4]=j-b;HEAP[d+16]=1;HEAP[d+18]=1;j=1<<(HEAP[g+308]&3);b=j==1?23:j==2?24:j==4?25:j==8?26:27;if(b==27){k=3;b=5;break a}else if(b==23){h=reSign(HEAP[d+4]+7,32)>>reSign(3,32);HEAP[d+8]=h}else if(b==
24){h=reSign(HEAP[d+4]+15,32)>>reSign(4,32)<<1;HEAP[d+8]=h}else if(b==25){h=reSign(HEAP[d+4]+31,32)>>reSign(5,32)<<2;HEAP[d+8]=h}else if(b==26){h=reSign(HEAP[d+4]+63,32)>>reSign(6,32)<<3;HEAP[d+8]=h}j=HEAP[d]*HEAP[d+8];h=b=_ft_glyphslot_alloc_bitmap(e,j);if(b!=0){b=2;break a}h=_FT_Stream_Seek(c,HEAP[i+12]);if(h!=0){b=2;break a}f=HEAP[d+12];b=j;h=c;c=f;b=b;h=h=h=_FT_Stream_ReadAt(h,HEAP[h+8],c,b);if(h!=0){b=2;break a}c=(HEAP[g+308]&8)==0;b:do if(c){a=j;b=HEAP[d+12];f=a;if(a==0)break b;b=b;f=f;for(a=
9;;){o=a==9?0:o;a=b+o;var l=unSign(HEAP[a],8),m=unSign(l,32)>>>unSign(1,32)&85;l=l<<1&170|m;m=unSign(l,32)>>>unSign(2,32)&51;l=l<<2&204|m;m=unSign(l,32)>>>unSign(4,32)&15;HEAP[a]=(l<<4&240|m)&255;var o=o+1;if(o!=f)a=11;else break}}while(0);o=unSign((HEAP[g+308]&4)!=0,1);c=unSign((HEAP[g+308]&8)!=0,1);o=unSign(o!=0^c!=0,1)!=0;b:do if(o){c=1<<(unSign(HEAP[g+308]&48,32)>>>unSign(4,32));if(c==2)b=28;else if(c==4)b=29;else break b;if(b==28){f=j;c=HEAP[d+12];b=f;if(!(unSign(f,32)>unSign(1,32)))break b;
c=c;b=b+-2;for(a=14;;){n=a==14?0:n;a=n*2;f=c+(a+1);a=c+a;l=b+n*-2;m=HEAP[a];HEAP[a]=HEAP[f];HEAP[f]=m;f=unSign(l,32)>unSign(1,32);var n=n+1;if(f)a=16;else break}}else if(b==29){f=j;c=HEAP[d+12];b=f;if(!(unSign(f,32)>unSign(3,32)))break b;c=c;b=b+-4;for(a=19;;){q=a==19?0:q;m=q*4;l=c+(m+3);f=c+(m+1);a=c+(m+2);var p=c+m;m=b+q*-4;var r=HEAP[p];HEAP[p]=HEAP[l];HEAP[l]=r;l=HEAP[f];HEAP[f]=HEAP[a];HEAP[a]=l;f=unSign(m,32)>unSign(3,32);var q=q+1;if(f)a=20;else break}}}while(0);HEAP[e+72]=1651078259;n=reSign(HEAP[i],
16);HEAP[e+100]=n;n=reSign(HEAP[i+6],16);HEAP[e+104]=n;n=reSign(HEAP[i+4],16)<<6;HEAP[e+24+16]=n;n=reSign(HEAP[i],16)<<6;HEAP[e+24+8]=n;n=reSign(HEAP[i+6],16)<<6;HEAP[e+24+12]=n;n=reSign(HEAP[i+2],16);i=reSign(HEAP[i],16);HEAP[e+24]=n-i<<6;HEAP[e+24+4]=HEAP[d]<<6;_ft_synthesize_vertical_metrics(e+24,HEAP[g+196+12]+HEAP[g+196+8]<<6);b=2;break a}while(0);a:do if(b==0){h=6;b=2;break a}while(0);if(b==2)k=h;return k}_PCF_Glyph_Load.__index__=Runtime.getFunctionIndex(_PCF_Glyph_Load,"_PCF_Glyph_Load");
function _pcf_get_bdf_property(e,g,d){e=_pcf_find_property(e,g);if(e!=0){HEAP[d]=HEAP[e+4]!=0?1:2;HEAP[d+4]=HEAP[e+8];d=0}else d=6;return d}_pcf_get_bdf_property.__index__=Runtime.getFunctionIndex(_pcf_get_bdf_property,"_pcf_get_bdf_property");function _pcf_get_charset_id(e,g,d){HEAP[g]=HEAP[e+176];HEAP[d]=HEAP[e+180];return 0}_pcf_get_charset_id.__index__=Runtime.getFunctionIndex(_pcf_get_charset_id,"_pcf_get_charset_id");
function _pcf_driver_requester(e,g){return _ft_service_list_lookup(_pcf_services,g)}_pcf_driver_requester.__index__=Runtime.getFunctionIndex(_pcf_driver_requester,"_pcf_driver_requester");
function _hash_bucket(e,g){var d=null,b,a,c;b=0;a=HEAP[g+12];if(HEAP[e]!=0){b=b;for(d=0;;){c=d==0?0:c;var f=d==0?b:i;d=e+(c+1);i=f<<5;f=0-f;var h=reSign(HEAP[e+c],8),i=i+f+h;c=c+1;if(HEAP[d]!=0)d=1;else break}b=i}c=HEAP[g+4];b=unSign(b,32)%unSign(c,32);c=a+4*b;b=g+4;c=c;for(d=4;;){var k=d==4?c:d==8?j:l;if(HEAP[k]==0)break;j=HEAP[HEAP[k]];if(HEAP[j]==HEAP[e])if(_strcmp(j,e)==0)break;var j=k+-4;if(j<a){var l=a+4*(HEAP[b]-1);d=9}else d=8}return c=k}
_hash_bucket.__index__=Runtime.getFunctionIndex(_hash_bucket,"_hash_bucket");function _hash_free(e,g){var d=null,b,a;if(e!=0){b=HEAP[e+4];a=HEAP[e+12];if(reSign(0,32)<reSign(b,32)){b=(reSign(b,32)>reSign(1,32)?b:1)-0;for(d=0;;){f=d==0?0:f;d=a+4*f;var c=HEAP[d];c!=0&&FUNCTION_TABLE[HEAP[g+8]](g,c);HEAP[d]=0;var f=f+1;if(f!=b)d=3;else break}}a=HEAP[e+12];a!=0&&FUNCTION_TABLE[HEAP[g+8]](g,a);HEAP[e+12]=0}}_hash_free.__index__=Runtime.getFunctionIndex(_hash_free,"_hash_free");
function _hash_insert(e,g,d,b){var a=STACKTOP;STACKTOP+=8;Runtime.memset(a,0,8);var c=null,f,h,i,k,j,l,m,o=a+4;m=_hash_bucket(e,d);HEAP[o]=0;l=HEAP[m];var n=l==0;a:do if(n){l=_ft_mem_alloc(b,8,o);if(HEAP[o]!=0)break a;HEAP[m]=l;HEAP[l]=e;HEAP[l+4]=g;f=HEAP[d];if(reSign(HEAP[d+8],32)>=reSign(f,32)){f=b;h=d;f=f;i=HEAP[h+12];j=HEAP[h+4];HEAP[a]=0;HEAP[h+4]<<=1;k=Math.floor(reSign(HEAP[h+4],32)/reSign(3,32));HEAP[h]=k;k=_ft_mem_realloc(f,4,0,HEAP[h+4],0,a);HEAP[h+12]=k;k=HEAP[a];if(k!=0){HEAP[o]=k;break a}else{k=
i;c=j;if(reSign(0,32)<reSign(c,32)){h=h;c=j;j=k;reSign(c,32);reSign(1,32);k=(reSign(c,32)>reSign(1,32)?c:1)-0;for(c=2;;){r=c==2?0:r;c=j+4*r;if(HEAP[c]!=0){var p=_hash_bucket(HEAP[HEAP[c]],h);HEAP[p]=HEAP[c]}var r=r+1;if(r!=k)c=6;else break}}i=i;f=f;h=i;i!=0&&FUNCTION_TABLE[HEAP[f+8]](f,h);f=HEAP[a];HEAP[o]=f;if(f!=0)break a}}HEAP[d+8]+=1}else HEAP[l+4]=g;while(0);e=HEAP[o];STACKTOP=a;return e}_hash_insert.__index__=Runtime.getFunctionIndex(_hash_insert,"_hash_insert");
function __bdf_list_ensure(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a,c,f;HEAP[d]=0;var h=unSign(HEAP[e+4],32)<unSign(g,32);a:do if(h){a=HEAP[e+4];c=unSign(a,32)>>>unSign(1,32);c=a+4+c;f=HEAP[e+12];if(a==536870911)HEAP[d]=64;else{b=a;var i=unSign(c,32)<unSign(b,32);b:do if(i)b=1;else{b=unSign(c,32)>unSign(536870911,32)?1:2;break b}while(0);if(b==1)c=536870911;a=_ft_mem_realloc(f,4,a,c,HEAP[e],d);HEAP[e]=a;if(HEAP[d]!=0)break a;HEAP[e+4]=c}}while(0);h=HEAP[d];STACKTOP=d;return h}
__bdf_list_ensure.__index__=Runtime.getFunctionIndex(__bdf_list_ensure,"__bdf_list_ensure");function __bdf_list_shift(e){var g=null,d=e==0;a:do if(!d){if(HEAP[e+8]==0)break a;if(unSign(HEAP[e+8],32)<=unSign(1,32))HEAP[e+8]=0;else{var b=unSign(HEAP[e+8],32)>unSign(1,32),a=e;if(b){b=e;var c=e+8,f=e;for(g=3;;){i=g==3?0:i;var h=2+i;HEAP[HEAP[g==3?a:f]+4*(0+i)]=HEAP[HEAP[b]+4*(1+i)];g=unSign(HEAP[c],32)>unSign(h,32);var i=i+1;if(g)g=4;else break}g=5}else g=9;HEAP[e+8]=HEAP[(g==5?f:a)+8]-1}}while(0)}
__bdf_list_shift.__index__=Runtime.getFunctionIndex(__bdf_list_shift,"__bdf_list_shift");
function __bdf_list_join(e,g){var d,b=null,a,c,f,h;HEAP[g]=0;h=e==0;a:do if(h)d=0;else{if(HEAP[e+8]==0){d=0;break a}h=HEAP[HEAP[e]];d=a=c=0;d=unSign(HEAP[e+8],32)>unSign(d,32)?3:4;b:for(;;)if(d==3){f=HEAP[HEAP[e]+4*a];if(HEAP[f]!=0){d=h;f=f;c=c;var i=c+1;for(b=5;;){j=b==5?0:j;var k=i+j;b=f+(j+1);HEAP[d+(c+j)]=HEAP[f+j];var j=j+1;if(HEAP[b]!=0)b=6;else break}c=k}d=HEAP[e+8];if(unSign(a+1,32)<unSign(d,32)){HEAP[h+c]=32;c+=1}a+=1;d=a;d=unSign(HEAP[e+8],32)>unSign(d,32)?3:4}else if(d==4){d=h!=_empty?
10:11;break b}if(d==10)HEAP[h+c]=0;HEAP[g]=c;a=h;d=13;break a}while(0);if(d==0)a=0;return a}__bdf_list_join.__index__=Runtime.getFunctionIndex(__bdf_list_join,"__bdf_list_join");
function __bdf_list_split(e,g,d,b){var a=STACKTOP;STACKTOP+=32;Runtime.memset(a,0,32);var c,f=null,h,i,k,j,l;l=0;HEAP[e+8]=0;var m=b==0;a:do if(!m){if(HEAP[d]==0)break a;var o=g==0;b:do if(!o){if(HEAP[g]==0){c=2;break b}_llvm_memset_p0i8_i32(a,0,32,1,0);h=0;j=f=k=g;f=3;c:for(;;){var n=f==8?q:0,p=j+n,r=j+(n+1);if((f==8?r:k)==0){c=10;break c}if(HEAP[p]==0){c=10;break c}q=HEAP[p]!=43;d:do if(q)c=6;else{if(HEAP[r]!=0){c=6;break d}h=1;c=8;break d}while(0);if(c==6){q=unSign(HEAP[p],8)>>>unSign(3,8);q=unSign(q,
8);f=unSign(HEAP[p],8)>>>unSign(3,8);f=unSign(f,8);f=HEAP[a+f];f=1<<(reSign(HEAP[p],8)&7)&255|f;HEAP[a+q]=f}var q=n+1;f=8;c=5}i=0;f=k=d;j=j=f+b;n=e+8;p=e+4;r=e+8;var s=e,u=e,t=e+8,v=e+8;h=h!=0;var w=f,x=l;f=10;c:for(;;){var y=f==29?C:x;c=f==29?B:w;if(c>=j){c=31;break c}if(HEAP[c]==0){c=31;break c}d:for(;;){if(HEAP[k]==0)break d;f=unSign(HEAP[k],8)>>>unSign(3,8);f=unSign(f,8);f=reSign(HEAP[a+f],8);var A=reSign(HEAP[k],8)&7;if((reSign(f,32)>>reSign(A,32)&1)!=0)break d;k+=1}if(HEAP[n]==HEAP[p]){var z=
__bdf_list_ensure(s,HEAP[r]+1);if(z!=0){c=19;break c}else f=18}else f=15;var C=f==18?0:y;B=HEAP[t];HEAP[HEAP[u]+4*B]=k>c?c:_empty;HEAP[v]=B+1;B=k;d:do if(h)for(;;){if(HEAP[k]==0)break d;c=unSign(HEAP[k],8)>>>unSign(3,8);c=unSign(c,8);c=reSign(HEAP[a+c],8);i=reSign(HEAP[k],8)&7;if((reSign(c,32)>>reSign(i,32)&1&255)==0)break d;HEAP[k]=0;k+=1}else{if(HEAP[k]==0)break d;HEAP[k]=0;k+=1}while(0);B=k<=B;d:do if(B)c=28;else{if(HEAP[k]!=0){f=27;c=28}else{f=27;c=29}break d}while(0);if(c==28)f=28;i=f==28?0:
1;var B=k;f=29;c=13}if(c==31){l=y;g=HEAP[e+4];if(unSign(i+HEAP[e+8],32)>=unSign(g,32)){l=__bdf_list_ensure(e,HEAP[e+8]+1+i);if(l!=0)break a}if(i!=0){g=HEAP[e+8];HEAP[HEAP[e]+4*g]=_empty;HEAP[e+8]=g+1}HEAP[HEAP[e]+4*HEAP[e+8]]=0;break a}else if(c==19){l=z;break a}}while(0);l=6}while(0);e=l;STACKTOP=a;return e}__bdf_list_split.__index__=Runtime.getFunctionIndex(__bdf_list_split,"__bdf_list_split");
function __bdf_atoul(e){var g;g=null;var d,b,a;d=e;e=10;var c=d==0;a:do if(c)g=0;else{if(HEAP[d]==0){g=0;break a}b=e;g=b==8?12:b==16?13:14;if(g==14){e=10;a=_ddigits}else if(g==12)a=_odigits;else if(g==13)a=_hdigits;b=HEAP[d]==48;b:do if(b){if(HEAP[d+1]!=120)if(HEAP[d+1]!=88)break b;e=16;a=_hdigits;d+=2}while(0);b=0;a=a;e=e;d=d;b=b;for(g=5;;){i=g==8?i:0;var f=g==8?h:b;h=d+i;g=reSign(HEAP[h],8)>>reSign(3,8);g=reSign(g,8);g=unSign(HEAP[a+g],8);c=reSign(HEAP[h],8)&7;if((reSign(g,32)>>reSign(c,32)&1&255)==
0)break;g=f*e;h=reSign(HEAP[h],8);var h=unSign(HEAP[_a2i+h],8)+g,i=i+1;g=8}b=b=f;g=11;break a}while(0);if(g==0)b=0;return b}__bdf_atoul.__index__=Runtime.getFunctionIndex(__bdf_atoul,"__bdf_atoul");
function __bdf_atol(e){var g,d=null,b,a,c,f;b=e;e=10;d=b==0;a:do if(d)g=0;else{if(HEAP[b]==0){g=0;break a}c=e;g=c==8?14:c==16?15:16;if(g==16){e=10;f=_ddigits}else if(g==14)f=_odigits;else if(g==15)f=_hdigits;c=0;if(HEAP[b]==45){b+=1;c=1}g=HEAP[b]==48;b:do if(g){if(HEAP[b+1]!=120)if(HEAP[b+1]!=88)break b;e=16;f=_hdigits;b+=2}while(0);g=0;f=f;e=e;b=b;g=g;for(d=6;;){k=d==9?k:0;a=d==9?i:g;i=b+k;d=reSign(HEAP[i],8)>>reSign(3,8);d=reSign(d,8);d=unSign(HEAP[f+d],8);var h=reSign(HEAP[i],8)&7;if((reSign(d,
32)>>reSign(h,32)&1&255)==0)break;d=e*a;i=reSign(HEAP[i],8);var i=unSign(HEAP[_a2i+i],8)+d,k=k+1;d=9}a=g=a;c=a=c!=0?0-a:a;g=13;break a}while(0);if(g==0)c=0;return c}__bdf_atol.__index__=Runtime.getFunctionIndex(__bdf_atol,"__bdf_atol");
function __bdf_atos(e){var g,d=null,b,a,c,f;b=e;e=10;d=b==0;a:do if(d)g=0;else{if(HEAP[b]==0){g=0;break a}c=e;g=c==8?14:c==16?15:16;if(g==16){e=10;f=_ddigits}else if(g==14)f=_odigits;else if(g==15)f=_hdigits;c=0;if(HEAP[b]==45){b+=1;c=1}g=HEAP[b]==48;b:do if(g){if(HEAP[b+1]!=120)if(HEAP[b+1]!=88)break b;e=16;f=_hdigits;b+=2}while(0);g=0;f=f;e=e;b=b;g=g;for(d=6;;){k=d==9?k:0;a=d==9?i:g;i=b+k;d=reSign(HEAP[i],8)>>reSign(3,8);d=reSign(d,8);d=unSign(HEAP[f+d],8);var h=reSign(HEAP[i],8)&7;if((reSign(d,
32)>>reSign(h,32)&1&255)==0)break;d=reSign(a,16)*e&65535;i=reSign(HEAP[i],8);var i=unSign(HEAP[_a2i+i],8)+d,k=k+1;d=9}a=g=a;c=a=c!=0?reSign(0-a,16):reSign(a,16);g=13;break a}while(0);if(g==0)c=0;return c&65535}__bdf_atos.__index__=Runtime.getFunctionIndex(__bdf_atos,"__bdf_atos");function _by_encoding(e,g){var d;d=HEAP[g+4];if(reSign(HEAP[e+4],32)<reSign(d,32))d=-1;else{d=HEAP[g+4];d=reSign(HEAP[e+4],32)>reSign(d,32)?1:0}return d}_by_encoding.__index__=Runtime.getFunctionIndex(_by_encoding,"_by_encoding");
function __bdf_add_comment(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;a=HEAP[e+16520];HEAP[b]=0;a=_ft_mem_realloc(a,1,HEAP[e+88],HEAP[e+88]+1+d,HEAP[e+84],b);HEAP[e+84]=a;if(HEAP[b]==0){a=HEAP[e+84]+HEAP[e+88];_llvm_memcpy_p0i8_p0i8_i32(a,g,d,1,0);HEAP[a+d]=10;HEAP[e+88]=HEAP[e+88]+1+d}e=HEAP[b];STACKTOP=b;return e}__bdf_add_comment.__index__=Runtime.getFunctionIndex(__bdf_add_comment,"__bdf_add_comment");
function __bdf_add_property(e,g,d){var b=STACKTOP;STACKTOP+=8;Runtime.memset(b,0,8);var a,c=null,f,h,i,k,j,l,m=b+4;l=HEAP[e+16520];HEAP[m]=0;var o=_hash_bucket(g,HEAP[e+128]);k=HEAP[o];o=k!=0;a:do if(o){j=HEAP[e+80]+16*HEAP[k+4];a=HEAP[j+4];if(a==1)a=28;else if(a==2)a=29;else if(a==3)a=30;else break a;if(a==28){f=HEAP[j+12];a=l;f=f;f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,f);HEAP[j+12]=0;if(d==0)break a;if(HEAP[d]==0)break a;f=d;a=l;f=f;c=m;h=h=f!=0?_strlen(f)+1:0;a=a=_ft_mem_dup(a,f,h,c);HEAP[j+12]=a}else if(a==
29){a=__bdf_atol(d);HEAP[j+12]=a}else if(a==30){a=__bdf_atoul(d);HEAP[j+12]=a}}else{j=e+16532;k=g;j=j;k=_hash_bucket(k,j);k=k=k=HEAP[k];if(k==0){j=e;k=g;j=j;a=HEAP[j+16520];HEAP[b]=0;c=j+16532;f=k;c=c;f=_hash_bucket(f,c);f=f=HEAP[f];f=f!=0;b:do if(!f){f=_ft_mem_realloc(a,16,HEAP[j+16528],HEAP[j+16528]+1,HEAP[j+16524],b);HEAP[j+16524]=f;f=HEAP[b];h=f!=0;c:do if(h)c=34;else{h=HEAP[j+16524]+16*HEAP[j+16528];_llvm_memset_p0i8_i32(h,0,16,1,0);c=_strlen(k)+1;var n=_ft_mem_realloc(a,1,0,c,0,b);HEAP[h]=n;
n=HEAP[b];if(n!=0){c=6;break c}_llvm_memcpy_p0i8_p0i8_i32(HEAP[h],k,c,1,0);HEAP[h+4]=1;HEAP[h+8]=0;c=HEAP[j+16528]+83;var p=_hash_insert(HEAP[h],c,j+16532,a);HEAP[b]=p;p=HEAP[b];if(p!=0){c=8;break c}HEAP[j+16528]+=1;break b}while(0);HEAP[m]=c==34?f:c==6?n:p;break a}while(0);k=HEAP[b];HEAP[m]=k;if(k!=0)break a;j=e+16532;k=g;j=j;k=_hash_bucket(k,j);k=k=k=HEAP[k]}if(HEAP[e+76]==HEAP[e+72]){if(HEAP[e+72]==0){j=_ft_mem_realloc(l,16,0,1,0,m);HEAP[e+80]=j}else{j=_ft_mem_realloc(l,16,HEAP[e+72],HEAP[e+72]+
1,HEAP[e+80],m);HEAP[e+80]=j}if(HEAP[m]!=0)break a;j=HEAP[e+80]+16*HEAP[e+72];_llvm_memset_p0i8_i32(j,0,16,1,0);HEAP[e+72]+=1}j=a=HEAP[k+4];a=unSign(a,32)>=unSign(83,32)?HEAP[e+16524]+16*(j-83):__bdf_properties+16*j;j=HEAP[e+80]+16*HEAP[e+76];HEAP[j]=HEAP[a];HEAP[j+4]=HEAP[a+4];HEAP[j+8]=HEAP[a+8];a=HEAP[a+4];a=a==1?31:a==2?32:a==3?33:17;b:do if(a==31){HEAP[j+12]=0;if(d==0)break b;if(HEAP[d]==0)break b;c=d;f=l;c=c;h=m;i=i=c!=0?_strlen(c)+1:0;f=f=_ft_mem_dup(f,c,i,h);HEAP[j+12]=f;if(HEAP[m]!=0)break a}else if(a==
32){f=__bdf_atol(d);HEAP[j+12]=f}else if(a==33){f=__bdf_atoul(d);HEAP[j+12]=f}while(0);if(_memcmp(g,__str8246,7)!=0){a=_hash_insert(HEAP[j],HEAP[e+76],HEAP[e+128],l);HEAP[m]=a;if(HEAP[m]!=0)break a}HEAP[e+76]+=1;if(_memcmp(g,__str10248,12)==0)HEAP[e+36]=HEAP[j+12];else if(_memcmp(g,__str19257,11)==0)HEAP[e+40]=HEAP[j+12];else if(_memcmp(g,__str20258,12)==0)HEAP[e+44]=HEAP[j+12];else{if(_memcmp(g,__str67305,7)!=0)break a;if(HEAP[j+12]==0)HEAP[m]=3;else{a=HEAP[HEAP[j+12]]==112;b:do if(!a){if(HEAP[HEAP[j+
12]]==80)break b;g=HEAP[HEAP[j+12]]==109;c:do if(!g){if(HEAP[HEAP[j+12]]==77)break c;if(HEAP[HEAP[j+12]]!=99)if(HEAP[HEAP[j+12]]!=67)break a;HEAP[e+28]=32;break a}while(0);HEAP[e+28]=16;break a}while(0);HEAP[e+28]=8}}}while(0);e=HEAP[m];STACKTOP=b;return e}__bdf_add_property.__index__=Runtime.getFunctionIndex(__bdf_add_property,"__bdf_add_property");
function __bdf_parse_glyphs(e,g,d,b,a){d=STACKTOP;STACKTOP+=8;Runtime.memset(d,0,8);var c,f=null,h,i,k,j,l,m;b=d+4;k=g;HEAP[b]=0;m=HEAP[a+32];g=HEAP[m+16520];var o=_memcmp(e,__str8246,7)==0;a:do{if(o){k-=7;c=e+7;if(HEAP[c]!=0){c+=1;k-=1}h=__bdf_add_comment(HEAP[a+32],c,k);HEAP[b]=h;f=1}else{o=(HEAP[a]&32)==0;var n=e;b:do if(o)if(_memcmp(n,__str84,5)!=0){HEAP[b]=180;c=3;break a}else{c=__bdf_list_split(a+8232,__str85,e,k);HEAP[b]=c;if(HEAP[b]!=0){c=3;break a}c=__bdf_atoul(HEAP[HEAP[a+8232]+4]);HEAP[m+
48]=c;HEAP[a+4]=HEAP[m+48];if(HEAP[a+4]==0)HEAP[m+48]=64;if(unSign(HEAP[a+4],32)>unSign(1114111,32)){HEAP[b]=6;c=3;break a}else{c=_ft_mem_realloc(g,36,0,HEAP[m+48],0,b);HEAP[m+56]=c;if(HEAP[b]!=0){c=3;break a}HEAP[a]|=32}}else if(_memcmp(n,__str86,7)==0){_qsort(HEAP[m+56],HEAP[m+52],36,_by_encoding.__index__);HEAP[a]&=-2}else{c=_memcmp(e,__str87,7)==0;i=a;if(c){HEAP[i+28]=0;HEAP[a]&=-4033}else{c=(HEAP[i]&64)!=0;c:do if(c){if(HEAP[a+28]!=-1)break c;if(HEAP[HEAP[a+36]+4]==0)break b}while(0);if(_memcmp(e,
__str88,9)==0){i=HEAP[a+24];c=g;i=i;i!=0&&FUNCTION_TABLE[HEAP[c+8]](c,i);HEAP[a+24]=0;c=__bdf_list_split(a+8232,__str85,e,k);HEAP[b]=c;if(c!=0){c=3;break a}__bdf_list_shift(a+8232);c=__bdf_list_join(a+8232,d);if(c==0){c=HEAP[b]=3;break a}else{i=_ft_mem_realloc(g,1,0,HEAP[d]+1,0,b);HEAP[a+24]=i;if(HEAP[b]!=0){c=3;break a}_llvm_memcpy_p0i8_p0i8_i32(HEAP[a+24],c,HEAP[d]+1,1,0);HEAP[a]|=64}}else{i=_memcmp(e,__str89,8)==0;c=a;if(i)if((HEAP[c]&64)==0){HEAP[b]=181;c=3;break a}else{c=__bdf_list_split(a+8232,
__str85,e,k);HEAP[b]=c;if(HEAP[b]!=0){c=3;break a}c=__bdf_atol(HEAP[HEAP[a+8232]+4]);HEAP[a+28]=c;if(unSign(HEAP[a+28],32)>unSign(65535,32)){c=HEAP[b]=3;break a}else{if(reSign(HEAP[a+28],32)>=reSign(0,32)){c=reSign(HEAP[a+28],32)>>reSign(5,32);i=a+28;if((1<<(HEAP[a+28]&31)&HEAP[a+40+c*4])!=0){HEAP[i]=-1;HEAP[m+16516]=1}else{c=reSign(HEAP[i],32)>>reSign(5,32);i=reSign(HEAP[a+28],32)>>reSign(5,32);HEAP[a+40+c*4]=1<<(HEAP[a+28]&31)|HEAP[a+40+i*4]}}if(reSign(HEAP[a+28],32)>=reSign(0,32)){if(HEAP[m+52]==
HEAP[m+48]){c=_ft_mem_realloc(g,36,HEAP[m+48],HEAP[m+48]+64,HEAP[m+56],b);HEAP[m+56]=c;if(HEAP[b]!=0){c=3;break a}HEAP[m+48]+=64}i=HEAP[m+52];c=HEAP[m+56]+36*i;HEAP[m+52]=i+1;HEAP[c]=HEAP[a+24];HEAP[c+4]=HEAP[a+28]}else if(HEAP[HEAP[a+36]+4]!=0){if(HEAP[m+64]==HEAP[m+60]){c=_ft_mem_realloc(g,36,HEAP[m+60],HEAP[m+60]+4,HEAP[m+68],b);HEAP[m+68]=c;if(HEAP[b]!=0){c=3;break a}HEAP[m+60]+=4}c=HEAP[m+68]+36*HEAP[m+64];HEAP[c]=HEAP[a+24];i=HEAP[m+64];HEAP[c+4]=i;HEAP[m+64]=i+1}else{i=HEAP[a+24];c=g;i=i;i!=
0&&FUNCTION_TABLE[HEAP[c+8]](c,i);HEAP[a+24]=0}HEAP[a+24]=0;HEAP[a]&=1073741823;HEAP[a]|=128}}else{i=m;c=HEAP[c+28]==-1?HEAP[i+68]+36*(HEAP[m+64]-1):HEAP[i+56]+36*(HEAP[m+52]-1);if((HEAP[a]&2048)!=0){i=HEAP[a+8];j=unSign(HEAP[c+12+2],16);if(unSign(i,32)>=unSign(j,32)){if(!(reSign(HEAP[a],32)>=reSign(0,32)))break b;HEAP[a]|=-2147483648;HEAP[m+16516]=1}else{i=HEAP[c+28]<<1;l=HEAP[c+24]+HEAP[c+28]*HEAP[a+8];j=i;if(unSign(0,32)<unSign(j,32)){j=e;var p=i;f=i;l=l;var r=(unSign(f,32)>unSign(1,32)?f:1)-0;
f=26;c:for(;;){v=f==26?0:v;t=f==26?l:t;var q=0+v;f=1+v;var s=reSign(HEAP[j+q],8);HEAP[t]=HEAP[_a2i+s]+HEAP[t]*16;s=unSign(f,32)<unSign(p,32);d:do if(s){if((q&1&255)==0){f=28;break d}var u=t+1;HEAP[u]=0;f=29}else f=27;while(0);var t=f==29?u:f==28?t:t,v=v+1;if(v!=r)f=30;else{f=30;break c}}l=t}j=unSign(HEAP[c+12],16);j=unSign(HEAP[HEAP[a+32]+16518],16)*j&7;if(HEAP[c+12]!=0)HEAP[l]=HEAP[_nibble_mask+j]&HEAP[l];j=HEAP[e+i]==48;c:do if(j)c=35;else{c=reSign(HEAP[e+i],8);c=HEAP[_a2i+c]!=0?35:36;break c}while(0);
c:do if(c==35){if((HEAP[a]&1073741824)!=0)break c;HEAP[a]|=1073741824;HEAP[m+16516]=1}while(0);HEAP[a+8]+=1}}else if(_memcmp(e,__str90,6)==0)if((HEAP[a]&128)==0){HEAP[b]=182;c=3;break a}else{i=__bdf_list_split(a+8232,__str85,e,k);HEAP[b]=i;if(HEAP[b]!=0){c=3;break a}i=__bdf_atoul(HEAP[HEAP[a+8232]+4])&65535;HEAP[c+8]=i;HEAP[a]|=256}else if(_memcmp(e,__str91,6)==0){i=__bdf_list_split(a+8232,__str85,e,k);HEAP[b]=i;if(HEAP[b]!=0){c=3;break a}i=__bdf_atoul(HEAP[HEAP[a+8232]+4])&65535;HEAP[c+10]=i;if((HEAP[a]&
256)==0){i=HEAP[m+20]*HEAP[m+16];j=unSign(HEAP[c+10],16);i=_FT_MulDiv(j,72E3,i)&65535;HEAP[c+8]=i}HEAP[a]|=512}else if(_memcmp(e,__str92,3)==0){i=__bdf_list_split(a+8232,__str85,e,k);HEAP[b]=i;if(HEAP[b]!=0){c=3;break a}i=__bdf_atos(HEAP[HEAP[a+8232]+4]);HEAP[c+12]=i;i=__bdf_atos(HEAP[HEAP[a+8232]+8]);HEAP[c+12+2]=i;i=__bdf_atos(HEAP[HEAP[a+8232]+12]);HEAP[c+12+4]=i;i=__bdf_atos(HEAP[HEAP[a+8232]+16]);HEAP[c+12+6]=i;HEAP[c+12+8]=HEAP[c+12+6]+HEAP[c+12+2];HEAP[c+12+10]=0-HEAP[c+12+6];i=HEAP[a+18];
j=HEAP[c+12+8];i=reSign(i,16)>=reSign(j,16)?i:j;HEAP[a+18]=i;i=HEAP[a+20];j=HEAP[c+12+10];i=reSign(i,16)>=reSign(j,16)?i:j;HEAP[a+20]=i;HEAP[a+22]=HEAP[c+12+4]+HEAP[c+12];i=HEAP[a+16];j=HEAP[a+22];i=reSign(i,16)>=reSign(j,16)?i:j;HEAP[a+16]=i;i=HEAP[a+12];j=HEAP[c+12+4];i=reSign(i,16)<=reSign(j,16)?i:j;HEAP[a+12]=i;i=HEAP[a+14];j=HEAP[c+12+4];i=reSign(i,16)>=reSign(j,16)?i:j;HEAP[a+14]=i;if((HEAP[a]&512)==0)HEAP[c+10]=HEAP[c+12];i=HEAP[HEAP[a+36]]!=0;c:do if(i){j=HEAP[m+20]*HEAP[m+16];p=unSign(HEAP[c+
10],16);j=_FT_MulDiv(p,72E3,j)&65535;if(HEAP[c+8]==j)break c;HEAP[c+8]=j;if(HEAP[a+28]==-1){j=unSign(HEAP[m+64]-1,32)>>>unSign(5,32);p=unSign(HEAP[m+64]-1,32)>>>unSign(5,32);HEAP[m+8324+j*4]=1<<(HEAP[m+64]-1&31)|HEAP[m+8324+p*4]}else{j=reSign(HEAP[c+4],32)>>reSign(5,32);p=reSign(HEAP[c+4],32)>>reSign(5,32);HEAP[m+132+j*4]=1<<(HEAP[c+4]&31)|HEAP[m+132+p*4]}HEAP[a]|=4096;HEAP[m+16516]=1}while(0);HEAP[a]|=1024}else if(_memcmp(e,__str93312,6)==0)if((HEAP[a]&1024)==0){HEAP[b]=183;c=3;break a}else{i=unSign(HEAP[c+
12],16);i=unSign(HEAP[HEAP[a+32]+16518],16)*i+7;i=reSign(i,32)>>reSign(3,32);HEAP[c+28]=i;i=HEAP[c+28];i=unSign(HEAP[c+12+2],16)*i;if(unSign(i,32)>unSign(65535,32)){HEAP[b]=184;c=3;break a}else{HEAP[c+32]=i&65535;i=unSign(HEAP[c+32],16);i=_ft_mem_realloc(g,1,0,i,0,b);HEAP[c+24]=i;if(HEAP[b]!=0){c=3;break a}HEAP[a+8]=0;HEAP[a]|=2048}}else{c=HEAP[b]=3;break a}}}}}while(0);var w=HEAP[b];f=10}c=2;break a}while(0);a:do if(c==2){c=(f==10?w:h)!=0?3:49;break a}while(0);a:do if(c==3){if((HEAP[a]&64)==0)break a;
h=HEAP[a+24];e=g;h=h;h!=0&&FUNCTION_TABLE[HEAP[e+8]](e,h);HEAP[a+24]=0}while(0);a=HEAP[b];STACKTOP=d;return a}__bdf_parse_glyphs.__index__=Runtime.getFunctionIndex(__bdf_parse_glyphs,"__bdf_parse_glyphs");
function __bdf_parse_properties(e,g,d,b,a){d=STACKTOP;STACKTOP+=140;Runtime.memset(d,0,140);var c,f=null,h,i,k,j,l,m,o,n=d+4,p=d+8,r=d+12;o=0;var q=_memcmp(e,__str94,13)==0;a:do if(q){if(_bdf_get_font_property(HEAP[a+32],__str19257)==0){o=HEAP[a+32];m=reSign(HEAP[HEAP[a+32]+4+8],16);HEAP[o+40]=m;o=reSign(HEAP[HEAP[a+32]+4+8],16);_sprintf(r,__str95,o);o=__bdf_add_property(HEAP[a+32],__str19257,r);if(o!=0)break a;HEAP[HEAP[a+32]+16516]=1}if(_bdf_get_font_property(HEAP[a+32],__str20258)==0){o=HEAP[a+
32];m=reSign(HEAP[HEAP[a+32]+4+10],16);HEAP[o+44]=m;o=reSign(HEAP[HEAP[a+32]+4+10],16);_sprintf(r,__str95,o);o=__bdf_add_property(HEAP[a+32],__str20258,r);if(o!=0)break a;HEAP[HEAP[a+32]+16516]=1}HEAP[a]&=-17;HEAP[b]=__bdf_parse_glyphs.__index__}else{if(_memcmp(e,__str96,21)==0)break a;if(_memcmp(e,__str8246,7)==0){HEAP[p]=e;HEAP[n]=HEAP[p];HEAP[p]+=7;if(HEAP[HEAP[p]]!=0){o=HEAP[p];HEAP[o]=0;HEAP[p]=o+1}}else{o=HEAP[a+32];m=g;j=e;l=m;f=n;m=p;k=o;i=o=j;HEAP[f]=i;b:for(;;){if(HEAP[o]==0)break b;if(HEAP[o]==
32)break b;if(HEAP[o]==9)break b;o+=1}f=-1;if(HEAP[o]!=0){f=reSign(HEAP[o],8);HEAP[o]=0}c=i;k=k;i=c;k=k;var s=c==0;b:do if(s)c=14;else{if(HEAP[i]==0){c=14;break b}c=k+16532;h=i;i=c;h=_hash_bucket(h,i);h=h=h=HEAP[h];if(h==0)h=0;else{h=HEAP[h+4];h=unSign(h,32)>=unSign(83,32)?HEAP[k+16524]+16*(h-83):__bdf_properties+16*h}c=17;break b}while(0);if(c==14)h=0;k=i=k=h;if(f!=-1){HEAP[o]=f&255;var u=k;f=18}else f=17;f=(f==18?u:i)!=0;b:do if(f){if(HEAP[k+4]==1)break b;o=__bdf_list_split(a+8232,__str85,e,g);
if(o!=0)break a;HEAP[n]=HEAP[HEAP[a+8232]];__bdf_list_shift(a+8232);e=__bdf_list_join(a+8232,d);HEAP[p]=e;o=__bdf_add_property(HEAP[a+32],HEAP[n],HEAP[p]);break a}while(0);i=o;o=j+l;HEAP[i]=0;i+=1;j=i;f=21;b:for(;;){l=f==23?v:0;var t=j+l;if(HEAP[t]==0)break b;if(HEAP[t]!=32)if(HEAP[t]!=9)break b;var v=l+1;f=23}i=t;if(HEAP[i]==34)i+=1;m=HEAP[m]=i;b:for(;;){if(o<=m)break b;if(HEAP[o+-1]!=32)if(HEAP[o+-1]!=9)break b;o+=-1;HEAP[o]=0}m=o>i;b:do if(m){if(HEAP[o+-1]!=34)break b;o+=-1;HEAP[o]=0}while(0)}o=
__bdf_add_property(HEAP[a+32],HEAP[n],HEAP[p])}while(0);a=o;STACKTOP=d;return a}__bdf_parse_properties.__index__=Runtime.getFunctionIndex(__bdf_parse_properties,"__bdf_parse_properties");
function __bdf_parse_start(e,g,d,b,a){d=STACKTOP;STACKTOP+=416;Runtime.memset(d,0,416);var c,f=null,h,i,k,j;i=d+256;var l=d+272,m=d+276,o=d+280,n,p=d+284,r,q=d+288;g=g;n=0;HEAP[p]=0;if(HEAP[a+32]!=0)n=HEAP[HEAP[a+32]+16520];var s=_memcmp(e,__str8246,7)==0;a:do if(s){if(HEAP[HEAP[a+36]+8]==0)break a;if(HEAP[a+32]==0)break a;g-=7;f=e+7;if(HEAP[f]!=0){f+=1;g-=1}f=__bdf_add_comment(HEAP[a+32],f,g);HEAP[p]=f}else if((HEAP[a]&1)==0){n=HEAP[a+8248];if(_memcmp(e,__str97,9)!=0)HEAP[p]=176;else{HEAP[a]=1;HEAP[a+
32]=0;f=_ft_mem_alloc(n,16548,p);if(HEAP[p]!=0)break a;HEAP[a+32]=f;HEAP[f+16520]=HEAP[a+8248];HEAP[a+8248]=0;k=n;j=f+16532;k=k;HEAP[m]=0;HEAP[j+4]=241;r=Math.floor(reSign(241,32)/reSign(3,32));HEAP[j]=r;HEAP[j+8]=0;k=_ft_mem_realloc(k,4,0,241,0,m);HEAP[j+12]=k;j=j=HEAP[m];HEAP[p]=j;if(HEAP[p]!=0)break a;r=__bdf_properties;j=f+16532;k=n;r=r;for(f=7;;){c=f==10?w:0;var u=r+16*c,t=0+c,v=1+c;if(!(unSign(f==10?v:0,32)<unSign(83,32))){c=12;break}f=_hash_insert(HEAP[u],t,j,k);HEAP[p]=f;if(HEAP[p]!=0){c=
9;break}var w=c+1;f=10;c=8}if(c==12){f=HEAP[a+32];j=_ft_mem_alloc(n,16,p);HEAP[f+128]=j;if(HEAP[p]!=0)break a;j=n;f=HEAP[HEAP[a+32]+128];j=j;HEAP[l]=0;HEAP[f+4]=241;k=Math.floor(reSign(241,32)/reSign(3,32));HEAP[f]=k;HEAP[f+8]=0;j=_ft_mem_realloc(j,4,0,241,0,l);HEAP[f+12]=j;f=f=HEAP[l];HEAP[p]=f;if(HEAP[p]!=0)break a;HEAP[HEAP[a+32]+28]=HEAP[HEAP[a+36]+12];HEAP[HEAP[a+32]+36]=-1}}}else if(_memcmp(e,__str98,15)==0)if((HEAP[a]&8)==0)HEAP[p]=179;else{f=__bdf_list_split(a+8232,__str85,e,g);HEAP[p]=f;
if(HEAP[p]!=0)break a;f=HEAP[a+32];j=__bdf_atoul(HEAP[HEAP[a+8232]+4]);HEAP[f+72]=j;HEAP[a+4]=HEAP[f+72];f=HEAP[a+32];j=_ft_mem_realloc(n,16,0,HEAP[a+4],0,p);HEAP[f+80]=j;if(HEAP[p]!=0)break a;HEAP[a]|=16;HEAP[b]=__bdf_parse_properties.__index__}else if(_memcmp(e,__str99,15)==0)if((HEAP[a]&4)==0)HEAP[p]=178;else{f=__bdf_list_split(a+8232,__str85,e,g);HEAP[p]=f;if(HEAP[p]!=0)break a;f=HEAP[a+32];j=__bdf_atos(HEAP[HEAP[a+8232]+4]);HEAP[f+4]=j;f=HEAP[a+32];j=__bdf_atos(HEAP[HEAP[a+8232]+8]);HEAP[f+4+
2]=j;f=HEAP[a+32];j=__bdf_atos(HEAP[HEAP[a+8232]+12]);HEAP[f+4+4]=j;f=HEAP[a+32];j=__bdf_atos(HEAP[HEAP[a+8232]+16]);HEAP[f+4+6]=j;HEAP[HEAP[a+32]+4+8]=HEAP[HEAP[a+32]+4+6]+HEAP[HEAP[a+32]+4+2];HEAP[HEAP[a+32]+4+10]=0-HEAP[HEAP[a+32]+4+6];HEAP[a]|=8}else if(_memcmp(e,__str17255,4)==0){f=__bdf_list_split(a+8232,__str85,e,g);HEAP[p]=f;if(HEAP[p]!=0)break a;__bdf_list_shift(a+8232);f=__bdf_list_join(a+8232,o);if(f==0)HEAP[p]=3;else{j=HEAP[HEAP[a+32]];c=n;j=j;j!=0&&FUNCTION_TABLE[HEAP[c+8]](c,j);HEAP[HEAP[a+
32]]=0;c=HEAP[a+32];j=_ft_mem_realloc(n,1,0,HEAP[o]+1,0,p);HEAP[c]=j;if(HEAP[p]!=0)break a;_llvm_memcpy_p0i8_p0i8_i32(HEAP[HEAP[a+32]],f,HEAP[o]+1,1,0);c=HEAP[a+36];f=HEAP[a+32];j=c;k=f==0;b:do if(k)c=21;else{if(HEAP[f]==0){c=21;break b}if(HEAP[HEAP[f]]==0){c=21;break b}k=c=HEAP[f+16520];c=i;k=k;_llvm_memset_p0i8_i32(c,0,16,1,0);HEAP[c+12]=k;HEAP[f+28]=HEAP[j+12];c=_strlen(HEAP[f])+1;if(unSign(c,32)>unSign(255,32)){c=25;break b}else{_llvm_memcpy_p0i8_p0i8_i32(d,HEAP[f],c,1,0);e=__bdf_list_split(i,
__str83,d,c);b=e!=0;c:do if(!b){if(HEAP[i+8]!=15)break c;h=reSign(HEAP[HEAP[HEAP[i]+44]],8);if(h==67)c=47;else if(h==77)c=48;else if(h==80)c=49;else if(h==99)c=47;else if(h==109)c=48;else if(h==112)c=49;else break c;if(c==47)HEAP[f+28]=32;else if(c==48)HEAP[f+28]=16;else if(c==49)HEAP[f+28]=8}while(0);i=i;b=h=HEAP[i+12];if(h!=0){h=HEAP[i];b=b;h=h;h!=0&&FUNCTION_TABLE[HEAP[b+8]](b,h);HEAP[i]=0;_llvm_memset_p0i8_i32(i,0,16,1,0)}i=e;HEAP[p]=i;if(i!=0)break a;HEAP[a]|=2;break a}}while(0);HEAP[p]=6}}else if(_memcmp(e,
__str100,4)==0)if((HEAP[a]&2)==0)HEAP[p]=177;else{f=__bdf_list_split(a+8232,__str85,e,g);HEAP[p]=f;if(HEAP[p]!=0)break a;f=HEAP[a+32];j=__bdf_atoul(HEAP[HEAP[a+8232]+4]);HEAP[f+16]=j;f=HEAP[a+32];j=__bdf_atoul(HEAP[HEAP[a+8232]+8]);HEAP[f+20]=j;f=HEAP[a+32];j=__bdf_atoul(HEAP[HEAP[a+8232]+12]);HEAP[f+24]=j;j=HEAP[a+8232+8]==5;k=HEAP[a+32];b:do if(j){c=__bdf_atos(HEAP[HEAP[a+8232]+16]);HEAP[k+16518]=c;f=c=HEAP[HEAP[a+32]+16518];r=0;u=c!=0;c:do if(u){c=f;for(f=33;;){y=f==33?0:y;x=f==33?c:x;f=0+y;if((unSign(x,
16)&1&255)!=0)r=f;var x=unSign(x,16)>>>unSign(1,16),y=y+1;if(x!=0)f=36;else break}if(unSign(r,16)<=unSign(3,16)){c=38;break c}h=8;c=41;break c}else c=38;while(0);if(c==38)h=1<<unSign(r,16)&65535;r=f=h;if(!(unSign(HEAP[HEAP[a+32]+16518],16)>unSign(r,16)))if(HEAP[HEAP[a+32]+16518]==f){c=43;break b}HEAP[HEAP[a+32]+16518]=f<<1}else HEAP[k+16518]=1;while(0);HEAP[a]|=4}else if(_memcmp(e,__str84,5)==0)if((HEAP[a]&8)==0)HEAP[p]=179;else{f=HEAP[a+32];j=reSign(HEAP[HEAP[a+32]+4+8],16);HEAP[f+40]=j;f=reSign(HEAP[HEAP[a+
32]+4+8],16);_sprintf(q,__str95,f);f=__bdf_add_property(HEAP[a+32],__str19257,q);HEAP[p]=f;if(HEAP[p]!=0)break a;f=HEAP[a+32];j=reSign(HEAP[HEAP[a+32]+4+10],16);HEAP[f+44]=j;f=reSign(HEAP[HEAP[a+32]+4+10],16);_sprintf(q,__str95,f);f=__bdf_add_property(HEAP[a+32],__str20258,q);HEAP[p]=f;if(HEAP[p]!=0)break a;HEAP[HEAP[a+32]+16516]=1;HEAP[b]=__bdf_parse_glyphs.__index__;HEAP[p]=-1}else HEAP[p]=3;while(0);a=HEAP[p];STACKTOP=d;return a}
__bdf_parse_start.__index__=Runtime.getFunctionIndex(__bdf_parse_start,"__bdf_parse_start");
function _bdf_free_font(e){var g=null,d,b,a;if(e!=0){a=HEAP[e+16520];d=HEAP[e];d!=0&&FUNCTION_TABLE[HEAP[a+8]](a,d);HEAP[e]=0;if(HEAP[e+128]!=0){_hash_free(HEAP[e+128],a);d=HEAP[e+128];d!=0&&FUNCTION_TABLE[HEAP[a+8]](a,d);HEAP[e+128]=0}d=HEAP[e+84];d!=0&&FUNCTION_TABLE[HEAP[a+8]](a,d);var c=d=HEAP[e+84]=0;g=unSign(HEAP[e+72],32)>unSign(c,32);c=HEAP[e+80];if(g){for(g=4;;){if(HEAP[(g==4?c:b)+16*d+4]==1){b=HEAP[HEAP[e+80]+16*d+12];b!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[HEAP[e+80]+16*d+12]=0}d+=1;
b=d;g=unSign(HEAP[e+72],32)>unSign(b,32);b=HEAP[e+80];if(g)g=9;else break}g=10}else g=50;d=g==10?b:c;d!=0&&FUNCTION_TABLE[HEAP[a+8]](a,d);d=HEAP[e+80]=0;b=HEAP[e+56];c=d;if(unSign(HEAP[e+52],32)>unSign(c,32))for(;;){c=HEAP[b];c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[b]=0;c=HEAP[b+24];c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[b+24]=0;d+=1;b+=36;c=d;if(!(unSign(HEAP[e+52],32)>unSign(c,32)))break}d=0;b=HEAP[e+68];c=d;if(unSign(HEAP[e+64],32)>unSign(c,32))for(;;){c=HEAP[b];c!=0&&FUNCTION_TABLE[HEAP[a+
8]](a,c);HEAP[b]=0;c=HEAP[b+24];c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[b+24]=0;d+=1;b+=36;c=d;if(!(unSign(HEAP[e+64],32)>unSign(c,32)))break}d=HEAP[e+56];d!=0&&FUNCTION_TABLE[HEAP[a+8]](a,d);HEAP[e+56]=0;d=HEAP[e+68];d!=0&&FUNCTION_TABLE[HEAP[a+8]](a,d);d=HEAP[e+68]=0;b=HEAP[e+92+12];c=d;if(unSign(HEAP[e+92+20],32)>unSign(c,32))for(;;){c=HEAP[b];c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[b]=0;c=HEAP[b+24];c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[b+24]=0;d+=1;b+=36;c=d;if(!(unSign(HEAP[e+92+20],
32)>unSign(c,32)))break}d=HEAP[e+92+12];d!=0&&FUNCTION_TABLE[HEAP[a+8]](a,d);HEAP[e+92+12]=0;_hash_free(e+16532,a);b=HEAP[e+16524];c=d=0;if(unSign(HEAP[e+16528],32)>unSign(c,32))for(g=31;;){i=g==31?0:i;g=b+16*i;var f=b+16*i+4;c=b+16*i+12;var h=HEAP[g];h!=0&&FUNCTION_TABLE[HEAP[a+8]](a,h);HEAP[g]=0;if(HEAP[f]==1){g=HEAP[c];g!=0&&FUNCTION_TABLE[HEAP[a+8]](a,g);HEAP[c]=0}d+=1;c=d;c=unSign(HEAP[e+16528],32)>unSign(c,32);var i=i+1;if(c)g=37;else break}d=HEAP[e+16524];d!=0&&FUNCTION_TABLE[HEAP[a+8]](a,
d);HEAP[e+16524]=0}}_bdf_free_font.__index__=Runtime.getFunctionIndex(_bdf_free_font,"_bdf_free_font");function _bdf_get_font_property(e,g){var d,b,a=e==0;a:do if(a)d=0;else{if(HEAP[e+72]==0){d=0;break a}if(g==0){d=0;break a}if(HEAP[g]==0){d=0;break a}b=HEAP[e+128];d=g;b=b;d=_hash_bucket(d,b);d=d=d=HEAP[d];b=d=d!=0?HEAP[e+80]+16*HEAP[d+4]:0;d=6;break a}while(0);if(d==0)b=0;return b}_bdf_get_font_property.__index__=Runtime.getFunctionIndex(_bdf_get_font_property,"_bdf_get_font_property");
function _bdf_cmap_init(e){var g;g=HEAP[e];HEAP[e+16]=HEAP[HEAP[g+140]+52];HEAP[e+20]=HEAP[g+144];return 0}_bdf_cmap_init.__index__=Runtime.getFunctionIndex(_bdf_cmap_init,"_bdf_cmap_init");function _bdf_cmap_done(e){HEAP[e+20]=0;HEAP[e+16]=0}_bdf_cmap_done.__index__=Runtime.getFunctionIndex(_bdf_cmap_done,"_bdf_cmap_done");
function _bdf_cmap_char_index(e,g){var d,b=null,a,c;a=HEAP[e+20];c=0;var f=HEAP[e+16];for(b=-1;;){var h=b==-1?f:b==4?h:i;k=b==-1?0:b==4?k:k;if(!(unSign(k,32)<unSign(h,32))){d=6;break}var i=unSign(h+k,32)>>>unSign(1,32);b=HEAP[a+8*i];if(g==b){d=1;break}d=i+1;var k=(b=unSign(g,32)<unSign(b,32))?k:d;b=b?2:4;d=0}if(d==1){c=i;c=HEAP[a+8*c+4]+1}return unSign(c,16)}_bdf_cmap_char_index.__index__=Runtime.getFunctionIndex(_bdf_cmap_char_index,"_bdf_cmap_char_index");
function _bdf_cmap_char_next(e,g){var d,b=null,a,c,f,h;a=HEAP[e+20];f=0;h=HEAP[g]+1;c=0;var i=h,k=h;c=c;var j=HEAP[e+16];b=-1;a:for(;;){var l=b==-1?j:b==4?l:o,m=b==-1?c:b==4?n:n;if(!(unSign(m,32)<unSign(l,32))){d=6;break a}var o=unSign(l+m,32)>>>unSign(1,32);n=HEAP[a+8*o];if(i==n){d=1;break a}d=o+1;var n=(b=unSign(k,32)<unSign(n,32))?m:d;if(b){b=2;d=0;continue a}b=4;d=0}a:do if(d==1){f=o;f=HEAP[a+8*f+4]+1}else if(d==6){c=m;h=0;i=c;if(!(unSign(HEAP[e+16],32)>unSign(i,32)))break a;h=HEAP[a+8*c];f=HEAP[a+
8*c+4]+1}while(0);HEAP[g]=h;return unSign(f,16)}_bdf_cmap_char_next.__index__=Runtime.getFunctionIndex(_bdf_cmap_char_next,"_bdf_cmap_char_next");
function _BDF_Face_Done(e){var g,d;if(e!=0){d=HEAP[e+100];_bdf_free_font(HEAP[e+140]);g=HEAP[e+144];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+144]=0;g=HEAP[e+132];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+132]=0;g=HEAP[e+136];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+136]=0;g=HEAP[e+20];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+20]=0;g=HEAP[e+24];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+24]=0;g=HEAP[e+32];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+32]=0;g=HEAP[e+140];g!=0&&FUNCTION_TABLE[HEAP[d+
8]](d,g);HEAP[e+140]=0}}_BDF_Face_Done.__index__=Runtime.getFunctionIndex(_BDF_Face_Done,"_BDF_Face_Done");
function _BDF_Face_Init(e,g){var d=STACKTOP;STACKTOP+=100;Runtime.memset(d,0,100);var b,a=null,c,f,h,i,k,j,l,m,o,n,p;i=d+4;k=d+20;var r,q,s,u,t,v,w,x,y;u=d+36;var A,z,C;q=d+40;C=d+44;o=d+48;var B,D=d+52;h=d+56;l=d+60;var E,F,G=d+76;f=d+88;HEAP[D]=0;c=HEAP[g+100];HEAP[h]=0;n=_FT_Stream_Seek(e,0);HEAP[D]=n;n=HEAP[D]!=0;a:do if(n)b=65;else{HEAP[l]=1;HEAP[l+4]=1;HEAP[l+8]=0;HEAP[l+12]=8;n=c;v=e;n=n;x=l;s=h;HEAP[C]=0;a=n;HEAP[o]=0;l=p=_ft_mem_alloc(a,8252,o);if(HEAP[o]!=0)a=175;else{a=175;w=x!=0?x:__bdf_opts;
HEAP[l+36]=w;HEAP[l+12]=32767;x=HEAP[l+8248]=n;w=l+8232;x=x;_llvm_memset_p0i8_i32(w,0,16,1,0);HEAP[w+12]=x;x=l;v=v;w=__bdf_parse_start.__index__;x=x;y=C;z=0;C=HEAP[v+28];HEAP[q]=0;var H=w==0;b:do if(H){HEAP[q]=6;b=1;break b}else{z=t=_ft_mem_realloc(C,1,0,1024,0,q);if(HEAP[q]!=0){a=2;b=3;break b}HEAP[u]=w;A=1;HEAP[z]=0;var J=v,L=C,N=u,I=x,P=u,K=x,O=z;A=A;a=4;c:for(;;){b=a==35?La:0;var M=a==4?256:Ja,Q=a==4?0:ta,R=a==4?0:Pa,T=a==4?0:ma,V=a==4?1024:fa,U=a==4?1:ya,S=a==4?O:na,X=a==4?0:qa,Y=a==4?1:ya,W=
A+b;a=5;d:for(;;){var da=a==12?256:M,ba=a==12?ta:Q,aa=a==12?Ca:R,ca=a==12?ma:T,$=a==12?fa:V,la=a==12?ya:U,ga=a==12?na:S,ea=a==12?qa:X,Z=a==12?ya:Y;a=6;e:for(;;){var ha=a==26?ta:ba,ia=a==26?0:aa,ja=a==26?fa:ca,fa=a==26?za:$,ka=a==26?1:la,na=a==26?Ha:ga,sa=a==26?qa:ea,wa=a==26?1:Z;a=7;f:for(;;){ta=a==24?Ea:ha;var Aa=a==24?0:ia;ma=a==24?Ea:ja;ya=a==24?1:ka;qa=a==24?ra:sa;if((a==24?1:wa)!=0){var Da=_FT_Stream_TryRead(J,na+ma,fa-ma),pa=Da+ma;a=9}else a=8;var ta=a==9?Da:ta,ma=a==9?0:ma,ya=a==9?0:ya,qa=
a==9?pa:qa;if(reSign(Aa,32)<reSign(qa,32))if(reSign(HEAP[na+Aa],8)==da)break e;else a=11;else a=174;for(;;){a=a==14?Na:a==174?0:0;var ua=Aa+a,Ba=na+ua;if(reSign(ua,32)>=reSign(qa,32))break;if(HEAP[Ba]==10)break;if(HEAP[Ba]==13)break;var Na=a+1;a=14}if(!(reSign(ua,32)>=reSign(qa,32)))break d;if(ta==0){a=19;b=21;break c}else a=19;if(Aa==0)break f;var Ea=qa-Aa;_llvm_memcpy_p0i8_p0i8_i32(na,na+Aa,Ea,1,0);var ra=qa-Ea;a=24}if(unSign(fa,32)>unSign(65535,32)){b=25;break c}var za=fa*2,Ha=_ft_mem_realloc(L,
1,fa,za,na,q);if(HEAP[q]!=0){a=26;b=27;break c}else a=26}var Ca=Aa+1;a=12}M=reSign(HEAP[na+ua],8);HEAP[na+ua]=0;Q=HEAP[na+Aa]!=35;d:do if(Q){a=HEAP[na+Aa]!=26;R=reSign(ua,32)>reSign(Aa,32);if(!(a&R))break d;a=FUNCTION_TABLE[HEAP[u]](na+Aa,ua-Aa,W,N,I);HEAP[q]=a;R=HEAP[q];if(R==-1){var va=FUNCTION_TABLE[HEAP[u]](na+Aa,ua-Aa,W,P,K);HEAP[q]=va;a=30}else a=28;if((a==30?va:R)!=0){a=32;b=21;break c}}while(0);HEAP[na+ua]=M&255;var Pa=ua+1;Ja=M==10;d:do if(Ja)a=29;else{if(M==13){a=34;break d}a=36}while(0);
var Ja=a==36?256:a==29?13:10,La=b+1;a=35;b=5}if(b==21){A=W;z=na;HEAP[y]=A;b=1;break b}else if(b==25){z=na;HEAP[q]=6;b=1;break b}else if(b==27){z=Ha;a=27;b=3;break b}}while(0);if(b==1){var xa=z;a=1}a=a==1?xa:a==2?t:Ha;u=C;t=a;a!=0&&FUNCTION_TABLE[HEAP[u+8]](u,t);a=HEAP[q];HEAP[o]=a;a=a!=0;b:do if(a)b=54;else{a=HEAP[l+32]!=0;c:do if(a){if(HEAP[HEAP[l+32]+28]!=8)HEAP[HEAP[l+32]+32]=HEAP[HEAP[l+32]+4];if(HEAP[l+4]!=HEAP[HEAP[l+32]+64]+HEAP[HEAP[l+32]+52])HEAP[HEAP[l+32]+16516]=1;if(HEAP[HEAP[l+36]]==
0)break c;if(HEAP[HEAP[l+32]+52]==0)if(HEAP[HEAP[l+32]+64]==0)break c;q=reSign(HEAP[l+16],16);u=reSign(HEAP[l+12],16);q=q-u;u=unSign(HEAP[HEAP[l+32]+4],16);if(q!=u){HEAP[HEAP[l+32]+4]=HEAP[l+16]-HEAP[l+12];HEAP[HEAP[l+32]+16516]=1}if(HEAP[HEAP[l+32]+4+4]!=HEAP[l+12]){HEAP[HEAP[l+32]+4+4]=HEAP[l+12];HEAP[HEAP[l+32]+16516]=1}if(HEAP[HEAP[l+32]+4+8]!=HEAP[l+18]){HEAP[HEAP[l+32]+4+8]=HEAP[l+18];HEAP[HEAP[l+32]+16516]=1}if(HEAP[HEAP[l+32]+4+10]!=HEAP[l+20]){HEAP[HEAP[l+32]+4+10]=HEAP[l+20];HEAP[HEAP[l+
32]+4+6]=0-HEAP[l+20];HEAP[HEAP[l+32]+16516]=1}q=reSign(HEAP[l+18],16);q=reSign(HEAP[l+20],16)+q;u=unSign(HEAP[HEAP[l+32]+4+2],16);if(q==u)break c;HEAP[HEAP[l+32]+4+2]=HEAP[l+20]+HEAP[l+18]}while(0);a=l;if((HEAP[l]&1&255)!=0)HEAP[o]=(HEAP[a]&32)==0?185:186;else{q=HEAP[a+32]!=0;c:do if(q){a=HEAP[HEAP[l+32]+16520];if(HEAP[HEAP[l+32]+88]==0)break c;u=HEAP[l+32];a=_ft_mem_realloc(a,1,HEAP[HEAP[l+32]+88],HEAP[HEAP[l+32]+88]+1,HEAP[HEAP[l+32]+84],o);HEAP[u+84]=a;if(HEAP[o]!=0){b=54;break b}HEAP[HEAP[HEAP[l+
32]+84]+HEAP[HEAP[l+32]+88]]=0}else{if(HEAP[o]!=0)break c;HEAP[o]=3}while(0);HEAP[s]=HEAP[l+32]}b=51;break b}while(0);if(b==54){_bdf_free_font(HEAP[l+32]);a=n;s=HEAP[l+32];a=a;q=s;s!=0&&FUNCTION_TABLE[HEAP[a+8]](a,q);HEAP[l+32]=0}w=l;a=51}if((a==51?w:p)!=0){p=l+8232;s=HEAP[p+12];if(s!=0){a=HEAP[p];s=s;a=a;a!=0&&FUNCTION_TABLE[HEAP[s+8]](s,a);HEAP[p]=0;_llvm_memset_p0i8_i32(p,0,16,1,0)}a=n;n=l;l=a;p=n;n!=0&&FUNCTION_TABLE[HEAP[l+8]](l,p)}o=HEAP[o];HEAP[D]=o;if(o==176){_BDF_Face_Done(g);B=2;b=172}else{if(HEAP[D]!=
0){b=65;break a}HEAP[g+140]=HEAP[h];HEAP[g]=1;HEAP[g+4]=0;HEAP[g+8]=146;o=_bdf_get_font_property(HEAP[h],__str67305);n=o!=0;b:do if(n){if(HEAP[o+4]!=1)break b;if(HEAP[o+12]==0)break b;l=HEAP[HEAP[o+12]]==77;c:do if(!l){if(HEAP[HEAP[o+12]]==109)break c;if(HEAP[HEAP[o+12]]==67)break c;if(HEAP[HEAP[o+12]]!=99)break b}while(0);HEAP[g+8]|=4}while(0);o=n=_bdf_get_font_property(HEAP[h],__str8222);n=n==0;b:do if(n)b=75;else{if(HEAP[o+12]==0){b=75;break b}n=HEAP[o+12];o=c;n=n;l=D;p=p=n!=0?_strlen(n)+1:0;o=
o=_ft_mem_dup(o,n,p,l);HEAP[g+20]=o;if(HEAP[D]!=0){b=65;break a}else{b=78;break b}}while(0);if(b==75)HEAP[g+20]=0;l=g;HEAP[d]=0;o=l;n=HEAP[o+100];p=HEAP[l+140];HEAP[i]=0;HEAP[i+4]=0;HEAP[i+8]=0;HEAP[i+12]=0;HEAP[o+12]=0;l=s=_bdf_get_font_property(p,__str214);s=s!=0;b:do if(s){if(HEAP[l+4]!=1)break b;if(HEAP[l+12]==0)break b;a=HEAP[HEAP[l+12]]==79;c:do if(!a){if(HEAP[HEAP[l+12]]==111)break c;if(HEAP[HEAP[l+12]]==73)break c;if(HEAP[HEAP[l+12]]!=105)break b}while(0);HEAP[o+12]|=1;a=HEAP[HEAP[l+12]]==
79;c:do if(a)b=87;else{if(HEAP[HEAP[l+12]]==111){b=87;break c}m=__str3209;b=90;break c}while(0);if(b==87)m=__str1215;HEAP[i+8]=m}while(0);l=m=_bdf_get_font_property(p,__str3217);m=m!=0;b:do if(m){if(HEAP[l+4]!=1)break b;if(HEAP[l+12]==0)break b;if(HEAP[HEAP[l+12]]!=66)if(HEAP[HEAP[l+12]]!=98)break b;HEAP[o+12]|=2;HEAP[i+4]=__str63}while(0);l=m=_bdf_get_font_property(p,__str5219);m=m!=0;b:do if(m){if(HEAP[l+4]!=1)break b;if(HEAP[l+12]==0)break b;if(HEAP[HEAP[l+12]]==0)break b;if(HEAP[HEAP[l+12]]==
78)break b;if(HEAP[HEAP[l+12]]==110)break b;HEAP[i+12]=HEAP[l+12]}while(0);l=m=_bdf_get_font_property(p,__str6220);m=m!=0;b:do if(m){if(HEAP[l+4]!=1)break b;if(HEAP[l+12]==0)break b;if(HEAP[HEAP[l+12]]==0)break b;if(HEAP[HEAP[l+12]]==78)break b;if(HEAP[HEAP[l+12]]==110)break b;HEAP[i]=HEAP[l+12]}while(0);l=m=m=l=0;p=4-m;a=105;b:for(;;){Fa=a==105?0:Fa;oa=a==105?l:oa;a=m+Fa;s=i+a*4;a=k+a*4;HEAP[a]=0;if(HEAP[s]!=0){r=_strlen(HEAP[s]);HEAP[a]=r;r=oa+1+HEAP[a];a=112}else a=111;var oa=a==112?r:oa,Fa=Fa+
1;if(Fa!=p)a=114;else break b}l=oa;if(l==0){HEAP[i]=__str62;r=_strlen(HEAP[i]);HEAP[k]=r;l=HEAP[k]+1}r=_ft_mem_alloc(n,l,d);HEAP[o+24]=r;if(HEAP[d]!=0){j=HEAP[d];a=117}else{r=HEAP[o+24];m=0;var Ma=o+24;r=r;oa=m;Fa=4-oa;a=119;b:for(;;){Va=a==119?0:Va;Qa=a==119?r:Qa;o=oa+Va;n=HEAP[i+o*4];m=HEAP[k+o*4];if(n==0)a=120;else{if(HEAP[Ma]!=Qa){HEAP[Qa]=32;E=Qa+1;a=121}else a=233;var Ka=a==121?E:Qa;_llvm_memcpy_p0i8_p0i8_i32(Ka,n,m,1,0);b=o==0?123:o==3?123:125;c:do if(b==123){if(unSign(0,32)<unSign(m,32))a=
123;else break c;for(;;){Ra=a==127?Ra:0;o=Ka+Ra;if(HEAP[o]==32)HEAP[o]=45;var Ra=Ra+1;if(Ra!=m){a=127;b=124}else break c}}while(0);Ka=Ka+m;a=125}var Qa=a==125?Ka:Qa,Va=Va+1;if(Va!=Fa)a=129;else break b}r=Qa;HEAP[r]=0;Ma=HEAP[d];a=130}i=a==117?j:Ma;HEAP[D]=i;if(i!=0){b=65;break a}HEAP[g+16]=HEAP[HEAP[h]+48]+1;HEAP[g+28]=1;i=_ft_mem_realloc(c,16,0,1,0,D);HEAP[g+32]=i;if(HEAP[D]!=0){b=65;break a}i=HEAP[g+32];k=j=0;_llvm_memset_p0i8_i32(i,0,16,1,0);HEAP[i]=(HEAP[HEAP[h]+44]&65535)+(HEAP[HEAP[h]+40]&65535);
o=_bdf_get_font_property(HEAP[h],__str9223);if(o!=0){E=Math.floor(reSign(HEAP[o+12]+5,32)/reSign(10,32))&65535;HEAP[i+2]=E}else{E=reSign(HEAP[i],16)*2;E=Math.floor(reSign(E,32)/reSign(3,32))&65535;HEAP[i+2]=E}o=E=_bdf_get_font_property(HEAP[h],__str10224);if(E!=0){E=Math.floor(reSign(HEAP[o+12]*460800+36135,32)/reSign(72270,32));HEAP[i+4]=E}else{E=reSign(HEAP[i+2],16)<<6;HEAP[i+4]=E}o=E=_bdf_get_font_property(HEAP[h],__str11225);if(E!=0){E=reSign(HEAP[o+12]&65535,16)<<6;HEAP[i+12]=E}o=E=_bdf_get_font_property(HEAP[h],
__str12226);if(E!=0)j=HEAP[o+12]&65535;o=E=_bdf_get_font_property(HEAP[h],__str13227);if(E!=0)k=HEAP[o+12]&65535;E=HEAP[i+12]==0;b:do if(E){HEAP[i+12]=HEAP[i+4];if(k==0)break b;Ra=HEAP[i+12];Ra=reSign(k,16)*Ra;Ra=Math.floor(reSign(Ra,32)/reSign(72,32));HEAP[i+12]=Ra}while(0);E=j==0;b:do if(E)b=141;else{if(k==0){b=141;break b}E=HEAP[i+12];j=reSign(j,16)*E;k=reSign(k,16);k=Math.floor(reSign(j,32)/reSign(k,32));HEAP[i+8]=k;b=143;break b}while(0);if(b==141)HEAP[i+8]=HEAP[i+12];E=HEAP[HEAP[h]+56];i=_ft_mem_realloc(c,
8,0,HEAP[HEAP[h]+48],0,D);HEAP[g+144]=i;if(HEAP[D]!=0){b=65;break a}HEAP[g+164]=0;if(unSign(HEAP[HEAP[h]+48],32)>unSign(0,32)){i=g+144;k=E;j=g+144;E=E;Ra=g+164;for(a=146;;){F=a==146?0:F;Ka=0+F;Qa=Ka&65535;Va=E+36*Ka+4;Ma=1+F;HEAP[HEAP[i]+8*Ka]=HEAP[k+36*Ka+4];HEAP[HEAP[j]+8*Ka+4]=Qa;if(HEAP[Va]==HEAP[HEAP[h]+36]&Ka!=-1)HEAP[Ra]=Ka;Ka=unSign(HEAP[HEAP[h]+48],32)>unSign(Ma,32);F=F+1;if(Ka)a=149;else break}}F=0;i=k=_bdf_get_font_property(HEAP[h],__str14228);h=_bdf_get_font_property(HEAP[h],__str15229);
k=k!=0;b:do if(k){if(h==0)break b;if(HEAP[i+4]!=1)break b;if(HEAP[h+4]!=1)break b;if(HEAP[i+12]==0)break b;if(HEAP[h+12]==0)break b;h=HEAP[h+12];f=c;h=h;k=D;j=j=h!=0?_strlen(h)+1:0;f=f=_ft_mem_dup(f,h,j,k);HEAP[g+132]=f;if(HEAP[D]!=0){b=65;break a}f=HEAP[i+12];c=c;f=f;h=D;i=i=f!=0?_strlen(f)+1:0;c=c=_ft_mem_dup(c,f,i,h);HEAP[g+136]=c;if(HEAP[D]!=0){b=65;break a}c=HEAP[g+136];f=HEAP[c]==105;c:do if(f)b=162;else{b=HEAP[c]==73?162:163;break c}while(0);c:do if(b==162){if(HEAP[c+1]!=115)if(HEAP[c+1]!=
83)break c;if(HEAP[c+2]!=111)if(HEAP[c+2]!=79)break c;c+=3;if(_strcmp(c,__str16230)!=0){if(_strcmp(c,__str17231)!=0)break c;if(_strcmp(HEAP[g+132],__str18232)!=0)break c}F=1}while(0);HEAP[G]=g;_llvm_memset_p0i8_i64(G+4,0,8,4,0);if(F!=0){HEAP[G+4]=1970170211;HEAP[G+8]=3;HEAP[G+10]=1}G=_FT_CMap_New(_bdf_cmap_class,0,G,0);HEAP[D]=G;b=65;break a}while(0);HEAP[f]=g;HEAP[f+4]=1094995778;HEAP[f+8]=7;HEAP[f+10]=0;G=_FT_CMap_New(_bdf_cmap_class,0,f,0);HEAP[D]=G;if(HEAP[g+36]==0){b=65;break a}HEAP[g+92]=HEAP[HEAP[g+
40]];b=65}break a}while(0);if(b==65)B=HEAP[D];B=B;STACKTOP=d;return B}_BDF_Face_Init.__index__=Runtime.getFunctionIndex(_BDF_Face_Init,"_BDF_Face_Init");function _BDF_Size_Select(e,g){var d;d=HEAP[HEAP[e]+140];_FT_Select_Metrics(HEAP[e],g);HEAP[e+12+12]=HEAP[d+40]<<6;HEAP[e+12+16]=0-HEAP[d+44]<<6;d=unSign(HEAP[d+4],16)<<6;HEAP[e+12+24]=d;return 0}_BDF_Size_Select.__index__=Runtime.getFunctionIndex(_BDF_Size_Select,"_BDF_Size_Select");
function _BDF_Size_Request(e,g){var d,b,a,c,f,h;a=HEAP[e];c=HEAP[a+32];a=HEAP[a+140];f=23;h=HEAP[g+8];h=HEAP[g+16]!=0?Math.floor(reSign(HEAP[g+16]*h+36,32)/reSign(72,32)):h;h=reSign(h+32,32)>>reSign(6,32);d=HEAP[g];d=d==0?7:d==1?8:9;a:do if(d==9){f=7;d=5;break a}else if(d==7){if(reSign(HEAP[c+12]+32,32)>>reSign(6,32)!=h){d=2;break a}f=0;d=3;break a}else if(d==8){if(HEAP[a+44]+HEAP[a+40]!=h){d=2;break a}f=0;d=3;break a}while(0);a:do if(d==2){d=f!=0?5:3;break a}while(0);if(d==5)b=f;else if(d==3){b=
HEAP[HEAP[e]+140];_FT_Select_Metrics(HEAP[e],0);HEAP[e+12+12]=HEAP[b+40]<<6;HEAP[e+12+16]=0-HEAP[b+44]<<6;b=unSign(HEAP[b+4],16)<<6;HEAP[e+12+24]=b;b=0}return b}_BDF_Size_Request.__index__=Runtime.getFunctionIndex(_BDF_Size_Request,"_BDF_Size_Request");
function _BDF_Glyph_Load(e,g,d){var b=STACKTOP;STACKTOP+=36;Runtime.memset(b,0,36);var a,c,f,h;c=d;d=HEAP[g];g=0;f=e+76;h=unSign(HEAP[HEAP[d+140]+16518],16);var i=d==0;a:do if(i)a=0;else{a=c;if(unSign(HEAP[d+16],32)<=unSign(a,32)){a=0;break a}if(c==0)c=HEAP[d+164];else c-=1;_llvm_memcpy_p0i8_p0i8_i32(b,HEAP[HEAP[d+140]+56]+36*c,36,1,0);c=unSign(HEAP[b+12+2],16);HEAP[f]=c;c=unSign(HEAP[b+12],16);HEAP[f+4]=c;HEAP[f+8]=HEAP[b+28];a=HEAP[b+24];c=e;a=a;_ft_glyphslot_free_bitmap(c);HEAP[c+76+12]=a;h=h;
a=h==1?6:h==2?7:h==4?8:h==8?9:10;if(a==6)HEAP[f+18]=1;else if(a==7)HEAP[f+18]=3;else if(a==8)HEAP[f+18]=4;else if(a==9){HEAP[f+18]=2;HEAP[f+16]=256}HEAP[e+72]=1651078259;h=reSign(HEAP[b+12+4],16);HEAP[e+100]=h;h=reSign(HEAP[b+12+8],16);HEAP[e+104]=h;h=unSign(HEAP[b+10],16)<<6;HEAP[e+24+16]=h;h=reSign(HEAP[b+12+4],16)<<6;HEAP[e+24+8]=h;h=reSign(HEAP[b+12+8],16)<<6;HEAP[e+24+12]=h;HEAP[e+24]=HEAP[f+4]<<6;HEAP[e+24+4]=HEAP[f]<<6;d=unSign(HEAP[HEAP[d+140]+4+2],16)<<6;_ft_synthesize_vertical_metrics(e+
24,d);a=5;break a}while(0);if(a==0)g=6;e=g;STACKTOP=b;return e}_BDF_Glyph_Load.__index__=Runtime.getFunctionIndex(_BDF_Glyph_Load,"_BDF_Glyph_Load");
function _bdf_get_bdf_property(e,g,d){var b;e=_bdf_get_font_property(HEAP[e+140],g);var a=e!=0;a:do if(a){g=HEAP[e+4];if(g==1)g=3;else if(g==2)g=4;else if(g==3)g=5;else{g=6;break a}if(g==3){HEAP[d]=1;HEAP[d+4]=HEAP[e+12]}else if(g==4){HEAP[d]=2;HEAP[d+4]=HEAP[e+12]}else if(g==5){HEAP[d]=3;HEAP[d+4]=HEAP[e+12]}b=0;g=1;break a}else g=6;while(0);if(g==6)b=6;return b}_bdf_get_bdf_property.__index__=Runtime.getFunctionIndex(_bdf_get_bdf_property,"_bdf_get_bdf_property");
function _bdf_get_charset_id(e,g,d){HEAP[g]=HEAP[e+132];HEAP[d]=HEAP[e+136];return 0}_bdf_get_charset_id.__index__=Runtime.getFunctionIndex(_bdf_get_charset_id,"_bdf_get_charset_id");function _bdf_driver_requester(e,g){return _ft_service_list_lookup(_bdf_services,g)}_bdf_driver_requester.__index__=Runtime.getFunctionIndex(_bdf_driver_requester,"_bdf_driver_requester");
function _tt_face_goto_table(e,g,d,b){var a,c=null,f,h;f=HEAP[e+156];e=unSign(HEAP[e+152],16);e=f+16*e;f=f;c=-1;a:for(;;){a=c==3?k:0;k=f+16*a+12;var i=f+16*a;c=i;if(!(i<e)){a=5;break a}if(HEAP[c]==g)if(HEAP[k]!=0){a=1;break a}var k=a+1;c=3;a=0}a:do if(a==1){g=i=f=i;if(i==0){a=6;break a}if(b!=0)HEAP[b]=HEAP[g+12];h=_FT_Stream_Seek(d,HEAP[g+8]);a=9;break a}else if(a==5){a=6;break a}while(0);if(a==6)h=142;return h}_tt_face_goto_table.__index__=Runtime.getFunctionIndex(_tt_face_goto_table,"_tt_face_goto_table");
function _tt_face_load_font_dir(e,g){var d=STACKTOP;STACKTOP+=40;Runtime.memset(d,0,40);var b,a=null,c,f,h,i,k,j,l,m=d+4,o,n,p,r=d+20,q=d+36,s;s=HEAP[g+28];HEAP[r+12]=HEAP[g+8];a=_FT_Stream_ReadLong(g,q);HEAP[r]=a;var u=HEAP[q]!=0;a:do if(!u){a=_FT_Stream_ReadFields(g,_offset_table_fields_3900,r);HEAP[q]=a;if(HEAP[q]!=0)break a;a=g;c=r;f=a;j=k=i=h=0;l=HEAP[c+12]+12;a=_FT_Stream_Seek(f,l);HEAP[d]=a;var t=HEAP[d],v=t!=0;b:do if(v)a=1;else{a=0;v=c+4;var w=f,x=m,y=m+8,A=m+12,z=f+4,C=m,B=m+12,D=m+8,E=
f,F=f;l=l;f=f;var G=m,H=m,J=m,L=a,N=h;a=2;c:for(;;){b=a==19?U:0;var I=a==19?V:N,P=L+b;if(!(unSign(HEAP[v],16)>unSign(P,16))){b=23;break c}var K=_FT_Stream_ReadFields(w,_table_dir_entry_fields_3826,x);HEAP[d]=K;if(HEAP[d]!=0){b=4;break c}a=HEAP[z];K=unSign(HEAP[A]+HEAP[y],32)>unSign(a,32);d:do if(K)a=5;else{a=5;var O=I+1,M=HEAP[C]==1751474532;e:do if(!M){if(HEAP[G]==1651008868)break e;if(HEAP[H]==1397313095){k=1;a=18}else{if(HEAP[J]!=1296389185){a=20;break d}j=1;a=21}break d}while(0);i=1;if(unSign(HEAP[B],
32)<=unSign(53,32)){b=9;break c}a=_FT_Stream_Seek(E,HEAP[D]+12);HEAP[d]=a;var Q=HEAP[d];if(Q!=0){a=10;b=12;break c}M=_FT_Stream_ReadLong(F,d);var R=HEAP[d];if(R!=0){a=13;b=12;break c}else a=13;if(M!=1594834165){b=15;break c}a=(unSign(P,16)+1)*16+l;a=_FT_Stream_Seek(f,a);HEAP[d]=a;var T=HEAP[d];if(T!=0){a=16;b=12;break c}else a=16}while(0);var V=a==16?O:a==21?O:a==20?O:a==18?O:I,U=b+1;a=19;b=3}c:do if(b==23){h=I;b=6;break c}else if(b==4){h=I;a=P;a-=1;HEAP[c+4]=a;b=6;break c}else if(b==9){HEAP[d]=142;
a=9;b=11;break b}else if(b==12){a=a==10?Q:a==13?R:T;h=O;HEAP[q]=a;if(a!=0)break a;else{b=30;break c}}else if(b==15){HEAP[d]=142;a=15;b=11;break b}while(0);if(b==6){HEAP[c+4]=h;if(HEAP[c+4]==0){HEAP[d]=2;a=24;b=11;break b}else{a=i!=0;c:do if(!a){if(k!=0)if(j!=0)break c;HEAP[d]=142;a=28;b=11;break b}while(0);HEAP[d]=0;HEAP[q]=0}}HEAP[e+152]=HEAP[r+4];HEAP[e+148]=HEAP[r];a=unSign(HEAP[e+152],16);a=_ft_mem_realloc(s,16,0,a,0,q);HEAP[e+156]=a;if(HEAP[q]!=0)break a;a=_FT_Stream_Seek(g,HEAP[r+12]+12);HEAP[q]=
a;if(HEAP[q]!=0)break a;a=unSign(HEAP[e+152],16)*16;a=_FT_Stream_EnterFrame(g,a);HEAP[q]=a;if(HEAP[q]!=0)break a;a=HEAP[e+156];s=unSign(HEAP[r+4],16);m=reSign(s,32)>reSign(0,32);s=g;if(m){P=I=m=g;O=g+4;r=r+4;p=g;R=a;for(a=34;;){$=a==34?0:$;ca=a==34?R:ca;U=a==34?s:p;V=1+$;u=HEAP[U+32];if(u+3<HEAP[U+36]){o=u+4;var S=reSign(HEAP[o+-4],8)<<24;a=unSign(HEAP[o+-4+1],8)<<16;Q=unSign(HEAP[o+-4+2],8)<<8;T=unSign(HEAP[o+-4+3],8);S=a|S|Q|T;a=36}else a=35;Q=a==35?0:S;HEAP[U+32]=a==35?u:o;HEAP[ca]=Q;U=HEAP[m+
32];if(U+3<HEAP[m+36]){n=U+4;var X=reSign(HEAP[n+-4],8)<<24;a=unSign(HEAP[n+-4+1],8)<<16;u=unSign(HEAP[n+-4+2],8)<<8;Q=unSign(HEAP[n+-4+3],8);X=a|X|u|Q;a=38}else a=51;u=a==51?0:X;HEAP[m+32]=a==51?U:n;HEAP[ca+4]=u;U=HEAP[I+32];if(U+3<HEAP[I+36]){var Y=U+4,W=reSign(HEAP[Y+-4],8)<<24;a=unSign(HEAP[Y+-4+1],8)<<16;u=unSign(HEAP[Y+-4+2],8)<<8;Q=unSign(HEAP[Y+-4+3],8);W=a|W|u|Q;a=40}else a=52;u=a==52?0:W;HEAP[I+32]=a==52?U:Y;HEAP[ca+8]=u;U=HEAP[P+32];if(U+3<HEAP[P+36]){var da=U+4,ba=reSign(HEAP[da+-4],8)<<
24;a=unSign(HEAP[da+-4+1],8)<<16;u=unSign(HEAP[da+-4+2],8)<<8;Q=unSign(HEAP[da+-4+3],8);ba=a|ba|u|Q;a=42}else a=53;u=a==53?0:ba;HEAP[P+32]=a==53?U:da;HEAP[ca+12]=u;a=HEAP[O];if(unSign(HEAP[ca+12]+HEAP[ca+8],32)>unSign(a,32))a=60;else{var aa=ca+16;a=44}var ca=a==44?aa:ca;a=unSign(HEAP[r],16);a=reSign(a,32)>reSign(V,32);var $=$+1;if(a)a=46;else break}a=47}else a=33;p=a==47?p:s;if(HEAP[p+20]!=0){o=HEAP[p+28];n=HEAP[p];o=o;n=n;n!=0&&FUNCTION_TABLE[HEAP[o+8]](o,n);HEAP[p]=0}HEAP[p+32]=0;HEAP[p+36]=0;break a}while(0);
HEAP[q]=a==1?t:a==9?142:a==15?142:a==24?2:142}while(0);q=HEAP[q];STACKTOP=d;return q}_tt_face_load_font_dir.__index__=Runtime.getFunctionIndex(_tt_face_load_font_dir,"_tt_face_load_font_dir");
function _tt_face_load_any(e,g,d,b,a){var c,f=null,h,i,k,j,l,m;d=d;h=g!=0;a:do{if(h){h=g;g=e;h=h;i=HEAP[g+156];g=unSign(HEAP[g+152],16);g=g=i+16*g;h=h;i=i;f=0;b:for(;;){c=f==4?o:0;o=i+16*c+12;f=l=i+16*c;if(!(l<g)){c=6;break b}if(HEAP[f]==h)if(HEAP[o]!=0){c=2;break b}var o=c+1;f=4;c=1}b:do if(c!=6)if(c==2){l=c=i=l;if(c==0)break b;d+=HEAP[l+8];m=HEAP[l+12];c=11;break a}while(0);j=142;c=10}else{m=HEAP[HEAP[e+104]+4];c=11}break a}while(0);a:do if(c==11){l=a!=0;b:do if(l){c=a;if(HEAP[c]==0){HEAP[a]=m;
k=0;c=12;break a}else{if(c==0)break b;m=HEAP[a]}}while(0);e=HEAP[e+104];j=_FT_Stream_ReadAt(e,d,b,m);c=10;break a}while(0);if(c==10)k=j;return k}_tt_face_load_any.__index__=Runtime.getFunctionIndex(_tt_face_load_any,"_tt_face_load_any");function _tt_face_load_generic_header(e,g,d){d=FUNCTION_TABLE[HEAP[e+508]](e,d,g,0);if(d==0){e=e+160;d=_FT_Stream_ReadFields(g,_header_fields_3996,e)}return d}_tt_face_load_generic_header.__index__=Runtime.getFunctionIndex(_tt_face_load_generic_header,"_tt_face_load_generic_header");
function _tt_face_load_head(e,g){return _tt_face_load_generic_header(e,g,1751474532)}_tt_face_load_head.__index__=Runtime.getFunctionIndex(_tt_face_load_head,"_tt_face_load_head");function _tt_face_load_bhed(e,g){return _tt_face_load_generic_header(e,g,1651008868)}_tt_face_load_bhed.__index__=Runtime.getFunctionIndex(_tt_face_load_bhed,"_tt_face_load_bhed");
function _tt_face_load_maxp(e,g){var d,b;b=e+260;d=FUNCTION_TABLE[HEAP[e+508]](e,1835104368,g,0);var a=d!=0;a:do if(!a){d=_FT_Stream_ReadFields(g,_maxp_fields_4025,b);if(d!=0)break a;HEAP[b+6]=0;HEAP[b+8]=0;HEAP[b+10]=0;HEAP[b+12]=0;HEAP[b+14]=0;HEAP[b+16]=0;HEAP[b+18]=0;HEAP[b+20]=0;HEAP[b+22]=0;HEAP[b+24]=0;HEAP[b+26]=0;HEAP[b+28]=0;HEAP[b+30]=0;if(!(reSign(HEAP[b],32)>reSign(65535,32)))break a;d=_FT_Stream_ReadFields(g,_maxp_fields_extra_4026,b);if(d!=0)break a;if(unSign(HEAP[b+20],16)<=unSign(63,
16))HEAP[b+20]=64;if(unSign(HEAP[b+16],16)>unSign(-5,16))HEAP[b+16]=-5;if(!(unSign(HEAP[b+30],16)>unSign(100,16)))break a;HEAP[b+30]=100}while(0);return d}_tt_face_load_maxp.__index__=Runtime.getFunctionIndex(_tt_face_load_maxp,"_tt_face_load_maxp");
function _tt_face_load_name(e,g){var d=STACKTOP;STACKTOP+=8;Runtime.memset(d,0,8);var b=null,a,c,f,h,i=d+4,k,j,l,m,o;h=HEAP[g+28];m=e+348;HEAP[m+16]=g;var n=FUNCTION_TABLE[HEAP[e+508]](e,1851878757,g,i);HEAP[d]=n;n=HEAP[d]!=0;a:do if(!n){f=g;c=f=f=HEAP[f+8];f=_FT_Stream_ReadFields(g,_name_table_fields_4061,m);HEAP[d]=f;if(HEAP[d]!=0)break a;k=c+6+HEAP[m+4]*12;f=j=c+HEAP[i];if(unSign(k,32)>unSign(f,32))HEAP[d]=145;else{l=HEAP[m+4];HEAP[m+4]=0;f=_ft_mem_realloc(h,20,0,l,0,d);HEAP[m+12]=f;if(HEAP[d]!=
0)break a;f=_FT_Stream_EnterFrame(g,l*12);HEAP[d]=f;if(HEAP[d]!=0)break a;o=HEAP[m+12];if(l!=0){f=g;a=m+8;c=c;k=k;j=j;o=o;l=l;b=5;b:for(;;){s=b==5?0:s;q=b==5?o:q;var p=_FT_Stream_ReadFields(f,_name_record_fields_4062,q);HEAP[d]=p;p=p!=0;c:do if(p)b=6;else{if(HEAP[q+8]==0){b=7;break c}HEAP[q+12]=HEAP[a]+HEAP[q+12]+c;b=unSign(HEAP[q+12],32)<unSign(k,32);d:do if(!b){b=HEAP[q+12];b=unSign(HEAP[q+8],16)+b;if(unSign(b,32)>unSign(j,32))break d;var r=q+20;b=11;break c}while(0);HEAP[q+12]=0;HEAP[q+8]=0;b=
10}while(0);var q=b==11?r:b==10?q:b==7?q:q,s=s+1;if(s!=l)b=8;else break b}o=q}f=Math.floor(reSign(o-HEAP[m+12],32)/reSign(20,32));HEAP[m+4]=f;f=g;if(HEAP[f+20]!=0){a=HEAP[f+28];c=HEAP[f];a=a;c=c;c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[f]=0}HEAP[f+32]=0;HEAP[f+36]=0;HEAP[e+344]=HEAP[m+4]&65535}}while(0);h=HEAP[d];STACKTOP=d;return h}_tt_face_load_name.__index__=Runtime.getFunctionIndex(_tt_face_load_name,"_tt_face_load_name");
function _tt_face_free_name(e){var g=null,d,b;d=HEAP[HEAP[e+96]+8];e=e+348;b=HEAP[e+12];var a=HEAP[e+4];if(HEAP[e+12]!=0){if(a!=0)for(g=0;;){g=g==0?0:h;h=b+20*g+16;var c=b+20*g+8,f=HEAP[h];f!=0&&FUNCTION_TABLE[HEAP[d+8]](d,f);HEAP[h]=0;HEAP[c]=0;var h=g+1;if(h!=a)g=3;else break}b=HEAP[e+12];b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[e+12]=0}HEAP[e+4]=0;HEAP[e]=0;HEAP[e+8]=0}_tt_face_free_name.__index__=Runtime.getFunctionIndex(_tt_face_free_name,"_tt_face_free_name");
function _tt_face_load_cmap(e,g){var d,b,a;d=FUNCTION_TABLE[HEAP[e+508]](e,1668112752,g,e+504);var c=d!=0;a:do if(!c){a=e+500;b=HEAP[e+504];d=g;b=b;a=a;var f=b=_FT_Stream_EnterFrame(d,b);if(f==0){HEAP[a]=HEAP[d+32];HEAP[d+32]=0;HEAP[d+36]=0;d=a=b;if(a==0)break a}else d=f;HEAP[e+504]=0}while(0);return d}_tt_face_load_cmap.__index__=Runtime.getFunctionIndex(_tt_face_load_cmap,"_tt_face_load_cmap");
function _tt_face_load_os2(e,g){var d,b;d=FUNCTION_TABLE[HEAP[e+508]](e,1330851634,g,0);var a=d!=0;a:do if(!a){b=e+368;d=_FT_Stream_ReadFields(g,_os2_fields_4158,b);if(d!=0)break a;HEAP[b+80]=0;HEAP[b+84]=0;HEAP[b+88]=0;HEAP[b+90]=0;HEAP[b+92]=0;HEAP[b+94]=0;HEAP[b+96]=0;if(HEAP[b]==0)break a;d=_FT_Stream_ReadFields(g,_os2_fields_extra_4159,b);if(d!=0)break a;if(!(unSign(HEAP[b],16)>unSign(1,16)))break a;d=_FT_Stream_ReadFields(g,_os2_fields_extra2_4160,b)}while(0);return d}
_tt_face_load_os2.__index__=Runtime.getFunctionIndex(_tt_face_load_os2,"_tt_face_load_os2");function _tt_face_load_post(e,g){var d,b;b=e+468;d=FUNCTION_TABLE[HEAP[e+508]](e,1886352244,g,0);if(d!=0)d=d;else{d=_FT_Stream_ReadFields(g,_post_fields_4185,b);d=d!=0?d:0}return d}_tt_face_load_post.__index__=Runtime.getFunctionIndex(_tt_face_load_post,"_tt_face_load_post");
function _tt_face_load_pclt(e,g){var d,b;b=e+556;d=FUNCTION_TABLE[HEAP[e+508]](e,1346587732,g,0);if(d==0)d=_FT_Stream_ReadFields(g,_pclt_fields_4199,b);return d}_tt_face_load_pclt.__index__=Runtime.getFunctionIndex(_tt_face_load_pclt,"_tt_face_load_pclt");
function _tt_face_load_gasp(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b=null,a,c,f,h,i;h=HEAP[g+28];var k=FUNCTION_TABLE[HEAP[e+508]](e,1734439792,g,0);HEAP[d]=k;k=HEAP[d]!=0;a:do if(!k){f=_FT_Stream_EnterFrame(g,4);HEAP[d]=f;if(HEAP[d]!=0)break a;f=g;c=0;a=HEAP[f+32];if(a+1<HEAP[f+36]){a+=2;c=reSign(HEAP[a+-2],8)<<8&65535;var j=unSign(HEAP[a+-2+1],8);c=c|j}HEAP[f+32]=a;f=f=reSign(c,16);HEAP[e+548]=f&65535;f=g;c=0;a=HEAP[f+32];if(a+1<HEAP[f+36]){a+=2;c=reSign(HEAP[a+-2],8)<<8&65535;
j=unSign(HEAP[a+-2+1],8);c=c|j}HEAP[f+32]=a;f=f=reSign(c,16);HEAP[e+548+2]=f&65535;f=g;if(HEAP[f+20]!=0){a=HEAP[f+28];c=HEAP[f];a=a;c=c;c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[f]=0}HEAP[f+32]=0;HEAP[f+36]=0;f=unSign(HEAP[e+548],16)>unSign(1,16);a=e+548+2;if(f){HEAP[a]=0;HEAP[d]=8}else{i=unSign(HEAP[a],16);c=_ft_mem_realloc(h,4,0,i,0,d);if(HEAP[d]!=0)break a;f=_FT_Stream_EnterFrame(g,i*4);HEAP[d]=f;if(HEAP[d]!=0)break a;HEAP[e+548+4]=c;f=i;if(unSign(0,32)<unSign(f,32)){f=c;a=g;c=c;j=g;i=i;i=(unSign(i,
32)>unSign(1,32)?i:1)-0;for(b=9;;){u=b==9?0:u;var l=0+u,m=f+4*l;l=c+4*l+2;var o=HEAP[a+32];if(o+1<HEAP[a+36]){var n=o+2,p=reSign(HEAP[n+-2],8)<<8&65535;b=unSign(HEAP[n+-2+1],8);p=p|b;b=11}else b=10;var r=b==10?0:p;HEAP[a+32]=b==10?o:n;b=reSign(r,16)&65535;HEAP[m]=b;m=HEAP[j+32];if(m+1<HEAP[j+36]){var q=m+2,s=reSign(HEAP[q+-2],8)<<8&65535;b=unSign(HEAP[q+-2+1],8);s=s|b;b=13}else b=20;o=b==20?0:s;HEAP[j+32]=b==20?m:q;m=reSign(o,16)&65535;HEAP[l]=m;var u=u+1;if(u!=i)b=15;else break}}f=g;if(HEAP[f+20]!=
0){a=HEAP[f+28];c=HEAP[f];a=a;c=c;c!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[f]=0}HEAP[f+32]=0;HEAP[f+36]=0}}while(0);h=HEAP[d];STACKTOP=d;return h}_tt_face_load_gasp.__index__=Runtime.getFunctionIndex(_tt_face_load_gasp,"_tt_face_load_gasp");
function _tt_face_load_hmtx(e,g,d){var b=STACKTOP;STACKTOP+=8;Runtime.memset(b,0,8);var a,c=null,f,h,i,k,j=b+4,l,m,o,n;k=HEAP[g+28];i=d!=0;a:do{if(i){i=e+300+36;f=e+300+40;a=FUNCTION_TABLE[HEAP[e+508]](e,1986884728,g,j);HEAP[b]=a;if(HEAP[b]!=0){a=0;break a}m=l=unSign(HEAP[e+300+34],16);o=Math.floor(unSign(HEAP[j],32)/unSign(4,32));if(unSign(m,32)>unSign(o,32))l=Math.floor(unSign(HEAP[j],32)/unSign(4,32));HEAP[e+300+34]=0;m=i;o=f}else{i=e+216+36;f=e+216+40;a=FUNCTION_TABLE[HEAP[e+508]](e,1752003704,
g,j);HEAP[b]=a;if(HEAP[b]!=0){a=0;break a}m=l=unSign(HEAP[e+216+34],16);o=Math.floor(unSign(HEAP[j],32)/unSign(4,32));if(unSign(m,32)>unSign(o,32))l=Math.floor(unSign(HEAP[j],32)/unSign(4,32));HEAP[e+216+34]=0;m=i;o=f}a=3;break a}while(0);a:do if(a==3){i=unSign(HEAP[e+260+4],16)-l;f=Math.floor(unSign(HEAP[j]-l*4,32)/unSign(2,32));if(reSign(i,32)<reSign(0,32))i=0;h=_ft_mem_realloc(k,4,0,l,0,b);HEAP[m]=h;if(HEAP[b]!=0)break a;h=_ft_mem_realloc(k,2,0,i,0,b);HEAP[o]=h;if(HEAP[b]!=0)break a;h=_FT_Stream_EnterFrame(g,
HEAP[j]);HEAP[b]=h;if(HEAP[b]!=0)break a;n=HEAP[g+32];c=HEAP[m];h=c+4*l;if(c<h){h=h;var p=n;n=c;for(c=10;;){w=c==10?0:w;a=n+4*(w+1);c=n+4*w+2;var r=n+4*w,q=w*4,s=p+(q+4),u=p+(q+3),t=p+(q+2),v=p+(q+1);q=unSign(HEAP[p+q],8)<<8&65535;v=unSign(HEAP[v],8);HEAP[r]=q|v;r=reSign(HEAP[t],8)<<8&65535;u=unSign(HEAP[u],8);HEAP[c]=r|u;var w=w+1;if(a<h)a=c=11;else{a=12;break}}n=s}h=HEAP[o];p=f;c=i;p=reSign(p,32)<=reSign(c,32)?p:c;c=h+2*p;if(h<c){p=c;n=n;h=h;for(c=14;;){y=c==14?0:y;var x=h+2*(y+1);a=h+2*y;u=y*2;
c=n+(u+1);u=reSign(HEAP[n+u],8)<<8&65535;c=unSign(HEAP[c],8);HEAP[a]=u|c;var y=y+1;if(x<p)a=c=15;else{a=16;break}}h=x}p=f;p=reSign(i,32)>reSign(p,32);n=reSign(f,32)>reSign(0,32);p=p&n;b:do if(p){n=HEAP[HEAP[o]+2*(f-1)];c=HEAP[o]+2*i;if(!(h<c)){a=19;break b}n=n;u=c;h=h;for(c=18;;){z=c==18?0:z;var A=h+2*(z+1);HEAP[h+2*z]=n;var z=z+1;if(A<u)a=c=20;else{a=21;break}}h=A}while(0);i=g;if(HEAP[i+20]!=0){f=HEAP[i+28];h=HEAP[i];f=f;h=h;h!=0&&FUNCTION_TABLE[HEAP[f+8]](f,h);HEAP[i]=0}HEAP[i+32]=0;HEAP[i+36]=
0;i=l&65535;f=e;if(d!=0)HEAP[f+300+34]=i;else HEAP[f+216+34]=i}while(0);e=HEAP[b];STACKTOP=b;return e}_tt_face_load_hmtx.__index__=Runtime.getFunctionIndex(_tt_face_load_hmtx,"_tt_face_load_hmtx");
function _tt_face_load_hhea(e,g,d){var b,a,c=d!=0;a:do{if(c){b=e+300;d=FUNCTION_TABLE[HEAP[e+508]](e,1986553185,g,0);if(d!=0){b=0;break a}a=b}else{d=FUNCTION_TABLE[HEAP[e+508]](e,1751672161,g,0);if(d!=0){b=0;break a}a=e+216}b=2;break a}while(0);a:do if(b==2){d=e=_FT_Stream_ReadFields(g,_metrics_header_fields_4401,a);if(e!=0)break a;HEAP[a+36]=0;HEAP[a+40]=0}while(0);return d}_tt_face_load_hhea.__index__=Runtime.getFunctionIndex(_tt_face_load_hhea,"_tt_face_load_hhea");
function _tt_face_get_metrics(e,g,d,b,a){var c,f,h;h=e+300;c=e+216;h=g!=0?h:c;g=HEAP[h+34];var i=g==0;a:do if(i)c=1;else{if(HEAP[h+36]==0){c=1;break a}e=unSign(HEAP[e+260+4],16);c=d;if(unSign(e,32)<=unSign(c,32)){c=1;break a}f=unSign(g,16);e=d;f=unSign(f,32)>unSign(e,32);e=h;if(f){d=HEAP[e+36]+4*d;HEAP[b]=HEAP[d+2];HEAP[a]=HEAP[d]}else{f=HEAP[e+40];e=unSign(g,16);HEAP[b]=HEAP[f+2*(d-e)];d=HEAP[h+36];g=unSign(g,16)-1;HEAP[a]=HEAP[d+4*g]}f=0;c=6;break a}while(0);if(c==1){HEAP[a]=0;f=HEAP[b]=0}return f}
_tt_face_get_metrics.__index__=Runtime.getFunctionIndex(_tt_face_get_metrics,"_tt_face_get_metrics");function _tt_cmap_init(e,g){HEAP[e+16]=g;return 0}_tt_cmap_init.__index__=Runtime.getFunctionIndex(_tt_cmap_init,"_tt_cmap_init");
function _tt_cmap0_validate(e,g){var d,b=null,a;a=e+2;a+=2;var c=unSign(HEAP[a+-2],8)<<8&65535;a=unSign(HEAP[a+-2+1],8);a=unSign(c|a,16);c=e+a>HEAP[g+4];a=unSign(a,32)<=unSign(261,32);if(c|a){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 149763";}else{if(HEAP[g+8]!=0){a=e+6;c=g+172;a=a;for(b=0;;){d=b==3?h:0;h=a+d;var f=1+d;if(!(unSign(b==3?f:0,32)<=unSign(255,32))){d=5;break}h=unSign(HEAP[h],8);if(unSign(HEAP[c],32)<=unSign(h,32)){d=2;break}var h=d+1;b=3;d=1}if(d!=5)if(d==
2){_ft_validator_error(g,16);throw"Reached an unreachable! Original .ll line: 149795";}}return 0}}_tt_cmap0_validate.__index__=Runtime.getFunctionIndex(_tt_cmap0_validate,"_tt_cmap0_validate");function _tt_cmap0_char_index(e,g){var d;d=HEAP[e+16];return unSign(g,32)<=unSign(255,32)?unSign(HEAP[d+(g+6)],8):0}_tt_cmap0_char_index.__index__=Runtime.getFunctionIndex(_tt_cmap0_char_index,"_tt_cmap0_char_index");
function _tt_cmap0_char_next(e,g){var d,b=null,a,c,f,h;a=HEAP[e+16];c=HEAP[g];h=f=0;a+=6;a=a;var i=h;c=c+1;for(b=-1;;){d=b==1?m:0;var k=b==1?0:i,j=c+d;m=a+j;if(!(unSign(j,32)<=unSign(255,32))){d=4;break}var l=unSign(HEAP[m],8),m=d+1;if(l!=0){d=2;break}else{b=1;d=0}}if(d==2){h=l;f=c=j}else if(d==4)h=k;HEAP[g]=f;return h}_tt_cmap0_char_next.__index__=Runtime.getFunctionIndex(_tt_cmap0_char_next,"_tt_cmap0_char_next");
function _tt_cmap0_get_info(e,g){var d;d=HEAP[e+16]+4;HEAP[g+4]=0;var b=unSign(HEAP[d],8)<<8&65535;d=unSign(HEAP[d+1],8);b=unSign(b|d,16);HEAP[g]=b;return 0}_tt_cmap0_get_info.__index__=Runtime.getFunctionIndex(_tt_cmap0_get_info,"_tt_cmap0_get_info");
function _tt_cmap2_validate(e,g){var d,b=null,a,c,f,h,i;a=e+2;var k=unSign(HEAP[a],8)<<8&65535;a=unSign(HEAP[a+1],8);c=unSign(k|a,16);a=e+c>HEAP[g+4];k=unSign(c,32)<=unSign(517,32);if(a|k){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 150025";}else{a=a=e+6;f=h=0;k=g+8;h=h;f=f+1;b=0;a:for(;;){d=b==4?m:0;i=b==4?l:h;var j=f+d;l=unSign(b==4?j:0,32)<=unSign(255,32);j=a;if(!l){d=6;break a}a=j+2;l=unSign(HEAP[a+-2],8)<<8&65535;b=unSign(HEAP[a+-2+1],8);l=unSign(l|b,16);if(unSign(HEAP[k],
32)>unSign(1,32))if((l&7)!=0){d=2;break a}l=unSign(l,32)>>>unSign(3,32);var l=unSign(l,32)>unSign(i,32)?l:i,m=d+1;b=4;d=1}if(d==6){h=i;i=j;i=i+(h+1)*8;if(HEAP[g+4]<i){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 150113";}else{f=0;j=h;k=g+8;c=e+c;h=g+8;l=g+172;f=f;b=7;a:for(;;){s=b==13?s:0;if(!(unSign(f+s,32)<=unSign(j,32))){d=23;break a}a+=2;d=unSign(HEAP[a+-2],8)<<8&65535;b=unSign(HEAP[a+-2+1],8);d=unSign(d|b,16);a+=2;b=unSign(HEAP[a+-2],8)<<8&65535;m=unSign(HEAP[a+-2+
1],8);b=unSign(b|m,16);a+=2;m=reSign(HEAP[a+-2],8)<<8&65535;var o=unSign(HEAP[a+-2+1],8);m=reSign(m|o,16);a+=2;o=unSign(HEAP[a+-2],8)<<8&65535;var n=unSign(HEAP[a+-2+1],8);o=unSign(o|n,16);n=b==0;b:do if(!n){if(unSign(HEAP[k],32)>unSign(1,32)){if(unSign(d,32)>unSign(255,32)){d=9;break a}if(unSign(b+d,32)>unSign(256,32)){d=9;break a}}if(o==0)break b;var p=a+-2+o;if(p<i){d=14;break a}if(p+b*2>c){d=14;break a}if(HEAP[h]==0)break b;for(p=a+b*2;;){if(!(a<p))break b;a+=2;var r=unSign(HEAP[a+-2],8)<<8&65535,
q=unSign(HEAP[a+-2+1],8);r=unSign(r|q,16);if(r!=0){r=r+m&65535;if(unSign(HEAP[l],32)<=unSign(r,32)){d=20;break a}}}}while(0);var s=s+1;b=13;d=8}if(d==23)return 0;else if(d==9){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 150221";}else if(d==14){_ft_validator_error(g,9);throw"Reached an unreachable! Original .ll line: 150243";}else if(d==20){_ft_validator_error(g,16);throw"Reached an unreachable! Original .ll line: 150287";}}}else if(d==2){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 150072";
}}}_tt_cmap2_validate.__index__=Runtime.getFunctionIndex(_tt_cmap2_validate,"_tt_cmap2_validate");function _tt_cmap2_get_subheader(e,g){var d,b,a,c,f;d=0;var h=unSign(g,32)<=unSign(65535,32);a:do if(h){b=g&255;a=unSign(g,32)>>>unSign(8,32);c=e+6;f=e+518;if(a==0){a=f;c+=b*2;f=unSign(HEAP[c],8)<<8&65535;c=unSign(HEAP[c+1],8);if((f|c)!=0)break a}else{c+=a*2;a=unSign(HEAP[c],8)<<8&65535;c=unSign(HEAP[c+1],8);c=unSign(a|c,16)&-8;a=f+c;if(a==f)break a}d=a}while(0);return d}
_tt_cmap2_get_subheader.__index__=Runtime.getFunctionIndex(_tt_cmap2_get_subheader,"_tt_cmap2_get_subheader");
function _tt_cmap2_char_index(e,g){var d,b,a,c,f,h,i,k;d=HEAP[e+16];b=0;d=_tt_cmap2_get_subheader(d,g);var j=d!=0;a:do if(j){a=d;c=g&255;a+=2;f=unSign(HEAP[a+-2],8)<<8&65535;i=unSign(HEAP[a+-2+1],8);f=unSign(f|i,16);a+=2;i=unSign(HEAP[a+-2],8)<<8&65535;h=unSign(HEAP[a+-2+1],8);h=unSign(i|h,16);a+=2;i=reSign(HEAP[a+-2],8)<<8&65535;k=unSign(HEAP[a+-2+1],8);i=reSign(i|k,16);k=unSign(HEAP[a],8)<<8&65535;var l=unSign(HEAP[a+1],8);k=unSign(k|l,16);c-=f;f=h;if(!(unSign(c,32)<unSign(f,32)))break a;if(k==
0)break a;a+=c*2+k;c=unSign(HEAP[a],8)<<8&65535;a=unSign(HEAP[a+1],8);c=unSign(c|a,16);if(c==0)break a;b=c+i&65535}while(0);return b}_tt_cmap2_char_index.__index__=Runtime.getFunctionIndex(_tt_cmap2_char_index,"_tt_cmap2_char_index");
function _tt_cmap2_char_next(e,g){var d,b=null,a,c,f,h,i;a=HEAP[e+16];f=c=0;var k=HEAP[g]+1;h=h=k;var j=c;b=-1;a:for(;;){var l=b==2?i:j;d=b==2?y:h;if(!(unSign(b==2?y:k,32)<=unSign(65535,32))){d=12;break a}y=_tt_cmap2_get_subheader(a,d);var m=y!=0;b:do if(m){i=y;i+=2;var o=unSign(HEAP[i+-2],8)<<8&65535,n=unSign(HEAP[i+-2+1],8);b=unSign(o|n,16);i+=2;o=unSign(HEAP[i+-2],8)<<8&65535;n=unSign(HEAP[i+-2+1],8);o=unSign(o|n,16);i+=2;n=reSign(HEAP[i+-2],8)<<8&65535;var p=unSign(HEAP[i+-2+1],8);n=reSign(n|
p,16);p=unSign(HEAP[i],8)<<8&65535;var r=unSign(HEAP[i+1],8);r=unSign(p|r,16);var q=d&255;if(r==0){b=1;break b}p=q-b;var s=unSign(q,32)<unSign(b,32);p=s?0:p;b=s?b:q;i+=p*2+r;r=b+(d&-256);for(b=3;;){q=b==9?x:0;var u=b==9?w:l,t=r+q;if(!(unSign(p+q,32)<unSign(o,32))){b=4;break b}i+=2;w=unSign(HEAP[i+-2],8)<<8&65535;x=unSign(HEAP[i+-2+1],8);w=unSign(w|x,16);if(w!=0){var v=w+n&65535;if(v!=0){d=6;break a}else b=5}else b=10;var w=b==5?0:u,x=q+1;b=9}}else b=11;while(0);i=b==1?l:b==11?l:u;var y=((b==1?d:b==
11?d:t)&-256)+256;b=2;d=0}if(d==6){c=v;f=h=t}else if(d==12)c=l;HEAP[g]=f;return c}_tt_cmap2_char_next.__index__=Runtime.getFunctionIndex(_tt_cmap2_char_next,"_tt_cmap2_char_next");function _tt_cmap2_get_info(e,g){var d;d=HEAP[e+16]+4;HEAP[g+4]=2;var b=unSign(HEAP[d],8)<<8&65535;d=unSign(HEAP[d+1],8);b=unSign(b|d,16);HEAP[g]=b;return 0}_tt_cmap2_get_info.__index__=Runtime.getFunctionIndex(_tt_cmap2_get_info,"_tt_cmap2_get_info");
function _tt_cmap4_init(e,g){var d;HEAP[e+16]=g;d=g+6;var b=unSign(HEAP[d],8)<<8&65535;d=unSign(HEAP[d+1],8);b=unSign(b|d,16)>>>unSign(1,16);b=unSign(b,16);HEAP[e+32]=b;HEAP[e+24]=-1;return HEAP[e+28]=0}_tt_cmap4_init.__index__=Runtime.getFunctionIndex(_tt_cmap4_init,"_tt_cmap4_init");
function _tt_cmap4_set_range(e,g){var d,b=null,a,c,f,h,i,k;a=g;h=HEAP[e+16];k=HEAP[e+32];var j=e+44,l=e+40,m=e+48,o=k-1,n=e+40,p=e+44,r=a,q=r*2,s=k*2,u=k*2,t=k*2,v=q+s+u+t,w=v+16;v=v+18;var x=q+s,y=x+u;t=y+t+17;u=y+17;y=y+16;x=x+17;s=q+s+16;var A=q+15;q=q+14;b=-1;a:for(;;){d=b==11?J:0;var z=r+d,C=d*2;i=h+(w+C);J=h+(v+C);b=h+(t+C);var B=h+(u+C),D=h+(y+C),E=h+(x+C),F=h+(s+C),G=h+(A+C);C=h+(q+C);if(!(unSign(z,32)<unSign(k,32))){d=16;break a}var H=unSign(HEAP[C],8)<<8&65535;G=unSign(HEAP[G],8);H=unSign(H|
G,16);HEAP[j]=H;H=unSign(HEAP[F],8)<<8&65535;E=unSign(HEAP[E],8);H=unSign(H|E,16);HEAP[l]=H;H=reSign(HEAP[D],8)<<8&65535;B=unSign(HEAP[B],8);H=reSign(H|B,16);HEAP[m]=H;H=unSign(HEAP[i],8)<<8&65535;b=unSign(HEAP[b],8);b=H|b;H=unSign(b,16);B=unSign(o,32)<=unSign(z,32);b:do if(B){if(HEAP[n]!=65535)break b;if(HEAP[p]!=65535)break b;D=HEAP[e];D=HEAP[D+500]+HEAP[D+504];if(H==0){d=6;break a}E=unSign(b,16);if(J+E>D){d=7;break a}}while(0);if(H!=65535){d=10;break a}var J=d+1;b=11;d=0}a:do if(d==6){a=z;d=9;
break a}else if(d==7){a=z;HEAP[e+48]=1;d=9;break a}else if(d==10){h=H;i=i;a=z;if(h==0){d=9;break a}f=i+h;d=13;break a}else if(d==16){a=z;c=-1;d=17;break a}while(0);a:do if(d==9){f=0;d=13;break a}while(0);if(d==13){HEAP[e+52]=f;HEAP[e+36]=a;c=0}return c}_tt_cmap4_set_range.__index__=Runtime.getFunctionIndex(_tt_cmap4_set_range,"_tt_cmap4_set_range");
function _tt_cmap4_next(e){var g,d=null,b,a,c,f,h,i;i=unSign(HEAP[e+24],32)>unSign(65534,32);a:do if(!i){c=b=HEAP[e+24]+1;if(unSign(HEAP[e+40],32)>unSign(c,32))b=HEAP[e+40];b:for(;;){g=HEAP[e+52];a=HEAP[e+44];c=HEAP[e+48];f=a;if(unSign(b,32)<=unSign(f,32))if(g!=0){f=g+(b-HEAP[e+40])*2;g=c;c=a;a=f;b=b;f=b+1;for(d=3;;){d=d==7?n:0;var k=b+d,j=f+d,l=d*2,m=a+(l+1);l=unSign(HEAP[a+l],8)<<8&65535;m=unSign(HEAP[m],8);m=unSign(l|m,16);if(m!=0){var o=m+g&65535;if(o!=0){g=5;break b}}m=unSign(j,32)<=unSign(c,
32);var n=d+1;if(m)d=7;else break}b=j}else{g=a;b=b;c=b+c;a=b+1;for(d=1;;){f=d==1?0:q;h=b+f;var p=a+f,r=c+f&65535;if(r!=0){g=9;break b}d=unSign(p,32)<=unSign(g,32);var q=f+1;if(d)d=10;else break}b=p}g=_tt_cmap4_set_range(e,HEAP[e+36]+1);if(reSign(g,32)<reSign(0,32))break a;g=b;if(!(unSign(HEAP[e+40],32)>unSign(g,32))){g=16;continue b}b=HEAP[e+40];g=16}if(g==5){b=k;h=o;HEAP[e+24]=b;HEAP[e+28]=h;return}else if(g==9){i=r;b=h;HEAP[e+24]=b;HEAP[e+28]=i;return}}while(0);HEAP[e+24]=-1;HEAP[e+28]=0}
_tt_cmap4_next.__index__=Runtime.getFunctionIndex(_tt_cmap4_next,"_tt_cmap4_next");
function _tt_cmap4_validate(e,g){var d,b=null,a,c,f,h,i,k,j,l,m,o;c=e+2;c+=2;h=unSign(HEAP[c+-2],8)<<8&65535;c=unSign(HEAP[c+-2+1],8);f=unSign(h|c,16);o=0;if(unSign(f,32)<=unSign(15,32)){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151423";}else{if(e+f>HEAP[g+4])if(HEAP[g+8]!=0){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151445";}else f=HEAP[g+4]-e;c=e+6;c+=2;h=unSign(HEAP[c+-2],8)<<8&65535;i=unSign(HEAP[c+-2+1],8);m=unSign(h|i,16);h=unSign(HEAP[g+
8],32)>unSign(1,32);a:do if(h){if((m&1&255)==0){d=2;break a}_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151495";}while(0);m=Math.floor(unSign(m,32)/unSign(2,32));h=f;if(unSign(m*8+16,32)>unSign(h,32)){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151511";}else{h=unSign(HEAP[g+8],32)>unSign(1,32);a:do if(h){c+=2;h=unSign(HEAP[c+-2],8)<<8&65535;i=unSign(HEAP[c+-2+1],8);h=unSign(h|i,16);c+=2;i=unSign(HEAP[c+-2],8)<<8&65535;k=unSign(HEAP[c+-2+
1],8);i=unSign(i|k,16);c+=2;k=unSign(HEAP[c+-2],8)<<8&65535;c=unSign(HEAP[c+-2+1],8);c=unSign(k|c,16);if(((c|h)&1&255)!=0){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151585";}else{h=Math.floor(unSign(h,32)/unSign(2,32));c=Math.floor(unSign(c,32)/unSign(2,32));k=m;k=unSign(h,32)>unSign(k,32);b:do if(!k){j=m;if(unSign(h*2,32)<unSign(j,32))break b;if(c+h!=m)break b;if(1<<i==h){d=7;break a}}while(0);_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151624";
}}while(0);h=e+14;i=e+16+m*2;j=i+m*2;k=j+m*2;l=k+m*2;c=unSign(HEAP[g+8],32)>unSign(1,32);a:do if(c){c=h+(m*2+-2);var n=unSign(HEAP[c],8)<<8&65535;c=unSign(HEAP[c+1],8);if((n|c)==-1){d=9;break a}_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151681";}while(0);n=m;var p=m-1;f=e+f;m=m-1;o=o;b=9;a:for(;;){B=b==26?B:0;a=b==26?A:o;A=b==26?w:0;d=b==26?v:0;C=b==26?C:0;var r=B*2;b=j+r;c=r+1;var q=j+c,s=h+r;w=h+c;var u=i+r;v=i+c;r=k+r;var t=k+c;if(!(unSign(C,32)<unSign(n,32))){d=
35;break a}c=r;u=unSign(HEAP[u],8)<<8&65535;v=unSign(HEAP[v],8);u=u|v;var v=unSign(u,16);s=unSign(HEAP[s],8)<<8&65535;w=unSign(HEAP[w],8);var w=unSign(s|w,16);b=reSign(HEAP[b],8)<<8&65535;q=unSign(HEAP[q],8);q=reSign(b|q,16);r=unSign(HEAP[r],8)<<8&65535;t=unSign(HEAP[t],8);r=unSign(r|t,16);if(unSign(v,32)>unSign(w,32)){d=11;break a}if(unSign(v,32)<=unSign(A,32)&C!=0){if(HEAP[g+8]!=0){d=13;break a}d=unSign(d,32)>unSign(v,32);A=unSign(A,32)>unSign(w,32);if(d|A){var x=a|1;b=15}else{var y=a|2;b=17}}else b=
12;var A=b==17?y:b==15?x:a;d=r==65535?36:r==0?26:37;b:do if(d==37){c+=r;t=HEAP[g+8]!=0;c:do if(t){if(c<l){d=18;break a}if(c+(w+1+(0-v))*2>f){d=18;break a}}else{if(!(m!=C|v!=65535|w!=65535)){d=22;break c}if(c<l){d=23;break a}if(c+(w+1+(0-v))*2>HEAP[g+4]){d=23;break a}}while(0);if(HEAP[g+8]==0)break b;t=unSign(u,16);for(b=25;;){d=b==30?z:0;if(!(unSign(t+d,32)<unSign(w,32)))break b;c+=2;z=unSign(HEAP[c+-2],8)<<8&65535;b=unSign(HEAP[c+-2+1],8);z=unSign(z|b,16);if(z!=0){z=z+q&65535;if(unSign(HEAP[g+172],
32)<=unSign(z,32)){d=28;break a}}var z=d+1;b=30;d=27}}else if(d==36)if(unSign(HEAP[g+8],32)>unSign(1,32)|p!=C|v!=65535|w!=65535){d=32;break a}while(0);var C=C+1,B=B+1;b=26;d=10}if(d==35)return a=o=a;else if(d==11){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151755";}else if(d==13){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151773";}else if(d==18){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151824";}else if(d==
28){_ft_validator_error(g,16);throw"Reached an unreachable! Original .ll line: 151902";}else if(d==23){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151855";}else if(d==32){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 151930";}}}}_tt_cmap4_validate.__index__=Runtime.getFunctionIndex(_tt_cmap4_validate,"_tt_cmap4_validate");
function _tt_cmap4_char_map_linear(e,g,d){var b,a=null,c,f,h,i,k,j,l,m,o;j=HEAP[g];l=0;m=HEAP[e+16]+6;c=unSign(HEAP[m],8)<<8&65535;k=unSign(HEAP[m+1],8);c=unSign(c|k,16)&-2;k=unSign(c,32)>>>unSign(1,32);if(k==0)e=0;else{var n=j;if(d!=0){var p=n+1;j=p;a=1}else a=28;a:for(;;){if(!(unSign(a==23?R:a==28?n:p,32)<=unSign(65535,32))){b=22;break a}m=HEAP[e+16]+14;o=HEAP[e+16]+16+c;R=k;var r=j,q=j,s=c,u=c,t=k-1,v=e;m=m;o=o;var w=f,x=h,y=s+u,A=s+2+u,z=s+1;u=z+u;a=3;b:for(;;){b=a==17?Q:0;var C=a==17?O:x,B=a==
17?P:w,D=a==17?M:m,E=b*2,F=o+E,G=o+(y+E);a=o+(A+E);var H=o+(u+E),J=o+(z+E),L=o+(s+E),N=o+(E+1);E=0+b;if(!(unSign(E,32)<unSign(R,32))){b=19;break b}D=D+2;P=unSign(HEAP[D+-2],8)<<8&65535;var I=unSign(HEAP[D+-2+1],8);I=unSign(P|I,16);P=unSign(HEAP[F],8)<<8&65535;F=unSign(HEAP[N],8);var P=unSign(P|F,16);F=unSign(r,32)>=unSign(P,32);N=unSign(q,32)<=unSign(I,32);if(F&N){i=reSign(HEAP[L],8)<<8&65535;var K=unSign(HEAP[J],8);i=reSign(i|K,16);K=unSign(HEAP[G],8)<<8&65535;H=unSign(HEAP[H],8);H=K|H;K=unSign(H,
16);if(unSign(t,32)<=unSign(E,32)&P==65535&I==65535){E=HEAP[v];E=HEAP[E+500]+HEAP[E+504];if(K==0){b=6;break b}H=unSign(H,16);if(a+H>E){b=7;break b}}if(K==65535)a=10;else{b=12;break b}}else a=18;var O=a==10?65535:C,M=a==10?G:D,Q=b+1;a=17;b=4}b:do if(b==19){h=C;f=B;b=15;break b}else if(b==6){h=0;f=65535;b=9;break b}else if(b==7){f=65535;i=1;h=0;b=9;break b}else if(b==12){h=K;f=P;m=G;if(h==0){b=9;break b}m+=(j-f)*2+h;l=unSign(HEAP[m],8)<<8&65535;R=unSign(HEAP[m+1],8);l=unSign(l|R,16);if(l==0){b=15;break b}l=
l+i&65535;b=15;break b}while(0);if(b==9)l=j+i&65535;if(d==0){b=20;break a}if(l!=0){b=22;break a}var R=j+1;j=R;a=23;b=24}a:do if(b==22){if(d==0)break a;if(l==0)break a;HEAP[g]=j}while(0);e=l}return e}_tt_cmap4_char_map_linear.__index__=Runtime.getFunctionIndex(_tt_cmap4_char_map_linear,"_tt_cmap4_char_map_linear");
function _tt_cmap4_char_map_binary(e,g,d){var b,a=null,c,f,h,i,k,j,l,m,o,n,p,r,q;o=HEAP[g];n=0;p=HEAP[e+16]+6;f=unSign(HEAP[p],8)<<8&65535;var s=unSign(HEAP[p+1],8);f=unSign(f|s,16)&-2;s=f==0;a:do if(s)c=0;else{m=c=unSign(f,32)>>>unSign(1,32);i=65535;if(d!=0)o+=1;l=c;j=e+16;k=f+2;var u=r=o;l=l;var t=m,v=i,w=h;a=2;b:for(;;){var x=a==2?w:a==4?E:E,y=a==2?v:a==4?D:D,A=a==2?t:a==4?B:B,z=a==2?l:a==6?z:B,C=a==2?0:a==6?F:C;if(!(unSign(C,32)<unSign(z,32))){b=41;break b}var B=unSign(z+C,32)>>>unSign(1,32);
p=HEAP[j]+14+B*2;D=unSign(HEAP[p],8)<<8&65535;E=unSign(HEAP[p+1],8);var D=unSign(D|E,16);p+=k;E=unSign(HEAP[p],8)<<8&65535;b=unSign(HEAP[p+1],8);var E=unSign(E|b,16);if(unSign(r,32)<unSign(E,32)){a=4;b=3;continue b}if(!(unSign(u,32)>unSign(D,32))){b=7;break b}var F=B+1;a=6;b=3}b:do if(b==41){h=x;i=y;m=A}else if(b==7){h=E;i=D;m=B;p+=f;l=reSign(HEAP[p],8)<<8&65535;j=unSign(HEAP[p+1],8);j=reSign(l|j,16);p+=f;l=unSign(HEAP[p],8)<<8&65535;k=unSign(HEAP[p+1],8);k=unSign(l|k,16);l=m;l=unSign(c-1,32)<=unSign(l,
32);c:do if(l){if(h!=65535){b=9;break c}if(i!=65535){b=9;break c}a=HEAP[e];a=HEAP[a+500]+HEAP[a+504];if(k==0){b=9;break c}if(!(p+k+2>a)){b=9;break c}j=1;k=0}while(0);if((HEAP[e+20]&2)!=0){l=m;if(k==65535)m=l+1;r=u=l;t=e+16;v=o;w=f+2;var G=f,H=f,J=r,L=k,N=J*2+12,I=J+-1;a=15;c:for(;;){b=a==21?R:0;var P=a==21?Q:L,K=b*-1,O=J+K,M=N+b*-2;K=I+K;if((a==21?K:u)==0){b=23;break c}q=p;p=HEAP[t]+M;a=unSign(HEAP[p],8)<<8&65535;M=unSign(HEAP[p+1],8);a=unSign(a|M,16);if(unSign(v,32)>unSign(a,32)){b=17;break c}i=
a;p+=w;Q=unSign(HEAP[p],8)<<8&65535;R=unSign(HEAP[p+1],8);h=unSign(Q|R,16);p+=G;Q=reSign(HEAP[p],8)<<8&65535;R=unSign(HEAP[p+1],8);j=reSign(Q|R,16);p+=H;Q=unSign(HEAP[p],8)<<8&65535;R=unSign(HEAP[p+1],8);var Q=unSign(Q|R,16);if(Q!=65535)m=K;var R=b+1;a=21;b=16}if(b==23){k=P;r=O}else if(b==17){k=P;r=O;p=q}a=l+1==m;c:do if(a){if(r!=l){p=HEAP[e+16]+14+l*2;i=unSign(HEAP[p],8)<<8&65535;h=unSign(HEAP[p+1],8);i=unSign(i|h,16);p+=f+2;h=unSign(HEAP[p],8)<<8&65535;m=unSign(HEAP[p+1],8);h=unSign(h|m,16);p+=
f;m=reSign(HEAP[p],8)<<8&65535;j=unSign(HEAP[p+1],8);j=reSign(m|j,16);p+=f;m=unSign(HEAP[p],8)<<8&65535;b=unSign(HEAP[p+1],8);k=unSign(m|b,16)}m=l;r=l+1;b=c;u=e+16;t=f+2;v=o;G=w=f;r=r;k=k;H=r*2+14;for(a=25;;){J=a==31?S:0;var T=a==31?U:k,V=r+J;a=H+J*2;if(!(unSign(V,32)<unSign(b,32)))break;p=HEAP[u]+a;a=unSign(HEAP[p],8)<<8&65535;L=unSign(HEAP[p+1],8);a=unSign(a|L,16);p+=t;L=unSign(HEAP[p],8)<<8&65535;N=unSign(HEAP[p+1],8);L=unSign(L|N,16);if(unSign(v,32)<unSign(L,32))break;i=a;h=L;p+=w;U=reSign(HEAP[p],
8)<<8&65535;S=unSign(HEAP[p+1],8);j=reSign(U|S,16);p+=G;U=unSign(HEAP[p],8)<<8&65535;S=unSign(HEAP[p+1],8);var U=unSign(U|S,16);if(U!=65535)m=V;var S=J+1;a=31}k=T;r=V;r-=1;if(m!=l){b=33;break c}m=r;b=34;break b}while(0);if(m!=r){p=HEAP[e+16]+14+m*2;i=unSign(HEAP[p],8)<<8&65535;var X=unSign(HEAP[p+1],8);i=unSign(i|X,16);p+=f+2;X=unSign(HEAP[p],8)<<8&65535;h=unSign(HEAP[p+1],8);h=unSign(X|h,16);p+=f;X=reSign(HEAP[p],8)<<8&65535;n=unSign(HEAP[p+1],8);j=reSign(X|n,16);p+=f;X=unSign(HEAP[p],8)<<8&65535;
n=unSign(HEAP[p+1],8);k=X=unSign(X|n,16);a=35}else{var Y=k;a=38}}else{var W=k;if(W==65535){b=34;break b}else a=37}if((a==38?Y:a==35?X:W)!=0){p+=(o-h)*2+k;n=unSign(HEAP[p],8)<<8&65535;l=unSign(HEAP[p+1],8);n=unSign(n|l,16);if(n==0){b=34;break b}n=n+j&65535}else n=o+j&65535}while(0);j=d!=0;b:do if(j){l=e;k=i;k=unSign(o,32)>unSign(k,32);c:do if(k){m+=1;if(m!=c){b=43;break c}c=0;break a}while(0);if(_tt_cmap4_set_range(l,m)!=0){if(n==0){b=46;break b}HEAP[g]=o}else{HEAP[l+24]=o;k=l;if(n!=0){var da=HEAP[k+
28]=n;a=48}else{HEAP[k+24]=o;_tt_cmap4_next(l);var ba=HEAP[l+28];n=ba;a=50}if((a==50?ba:da)==0){b=46;break b}HEAP[g]=HEAP[l+24]}}while(0);c=n}while(0);return c}_tt_cmap4_char_map_binary.__index__=Runtime.getFunctionIndex(_tt_cmap4_char_map_binary,"_tt_cmap4_char_map_binary");
function _tt_cmap4_char_index(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);HEAP[d]=g;var b=unSign(HEAP[d],32)>unSign(65535,32)?0:(HEAP[e+20]&1&255)!=0?_tt_cmap4_char_map_linear(e,d,0):_tt_cmap4_char_map_binary(e,d,0);STACKTOP=d;return b}_tt_cmap4_char_index.__index__=Runtime.getFunctionIndex(_tt_cmap4_char_index,"_tt_cmap4_char_index");
function _tt_cmap4_char_next(e,g){var d,b;if(unSign(HEAP[g],32)>unSign(65534,32))d=0;else{var a=(HEAP[e+20]&1&255)!=0;a:do if(a)d=_tt_cmap4_char_map_linear(e,g,1);else{b=e;if(HEAP[g]==HEAP[b+24]){_tt_cmap4_next(b);d=HEAP[b+28];if(d==0)break a;HEAP[g]=HEAP[b+24]}else d=_tt_cmap4_char_map_binary(e,g,1)}while(0);d=d}return d}_tt_cmap4_char_next.__index__=Runtime.getFunctionIndex(_tt_cmap4_char_next,"_tt_cmap4_char_next");
function _tt_cmap4_get_info(e,g){var d;d=HEAP[e+16]+4;HEAP[g+4]=4;var b=unSign(HEAP[d],8)<<8&65535;d=unSign(HEAP[d+1],8);b=unSign(b|d,16);HEAP[g]=b;return 0}_tt_cmap4_get_info.__index__=Runtime.getFunctionIndex(_tt_cmap4_get_info,"_tt_cmap4_get_info");
function _tt_cmap6_validate(e,g){var d,b=null,a,c,f;if(e+10>HEAP[g+4]){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 153371";}else{a=e+2;a+=2;c=unSign(HEAP[a+-2],8)<<8&65535;var h=unSign(HEAP[a+-2+1],8);c=unSign(c|h,16);a=e+8;a+=2;h=unSign(HEAP[a+-2],8)<<8&65535;f=unSign(HEAP[a+-2+1],8);f=unSign(h|f,16);h=e+c>HEAP[g+4];a:do if(!h){c=c;if(unSign(f*2+10,32)>unSign(c,32))break a;if(HEAP[g+8]!=0){c=f;h=g+172;a=a;f=f+-1;for(b=5;;){d=b==5?0:j;var i=d*2;j=a+i;i=a+(i+1);var k=
f+d*-1;if((b==5?c:k)==0){d=7;break}j=unSign(HEAP[j],8)<<8&65535;b=unSign(HEAP[i],8);j=unSign(j|b,16);if(unSign(HEAP[h],32)<=unSign(j,32)){d=2;break}var j=d+1;b=3;d=4}if(d!=7)if(d==2){_ft_validator_error(g,16);throw"Reached an unreachable! Original .ll line: 153461";}}return 0}while(0);_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 153436";}}_tt_cmap6_validate.__index__=Runtime.getFunctionIndex(_tt_cmap6_validate,"_tt_cmap6_validate");
function _tt_cmap6_char_index(e,g){var d,b,a,c;d=HEAP[e+16];b=0;d=d+6;d+=2;a=unSign(HEAP[d+-2],8)<<8&65535;c=unSign(HEAP[d+-2+1],8);a=unSign(a|c,16);d+=2;c=unSign(HEAP[d+-2],8)<<8&65535;var f=unSign(HEAP[d+-2+1],8);c=unSign(c|f,16);a=g-a;if(unSign(a,32)<unSign(c,32)){d+=a*2;b=unSign(HEAP[d],8)<<8&65535;d=unSign(HEAP[d+1],8);b=unSign(b|d,16)}return b}_tt_cmap6_char_index.__index__=Runtime.getFunctionIndex(_tt_cmap6_char_index,"_tt_cmap6_char_index");
function _tt_cmap6_char_next(e,g){var d,b=null,a,c,f,h,i,k;a=HEAP[e+16];c=0;f=HEAP[g]+1;h=0;i=a+6;i+=2;a=unSign(HEAP[i+-2],8)<<8&65535;k=unSign(HEAP[i+-2+1],8);k=unSign(a|k,16);i+=2;a=unSign(HEAP[i+-2],8)<<8&65535;var j=unSign(HEAP[i+-2+1],8);a=unSign(a|j,16);if(!(unSign(f,32)>unSign(65535,32))){if(unSign(f,32)<unSign(k,32))f=k;k=f-k;i+=k*2;f=f;i=i;j=h;for(b=1;;){d=b==4?n:0;var l=b==4?0:j,m=d*2;n=i+m;b=i+(m+1);m=f+d;if(!(unSign(k+d,32)<unSign(a,32))){d=7;break}var o=unSign(HEAP[n],8)<<8&65535;n=unSign(HEAP[b],
8);o=unSign(o|n,16);if(o!=0){d=3;break}var n=d+1;b=4;d=2}if(d==7)h=l;else if(d==3){h=o;c=m}}HEAP[g]=c;return h}_tt_cmap6_char_next.__index__=Runtime.getFunctionIndex(_tt_cmap6_char_next,"_tt_cmap6_char_next");function _tt_cmap6_get_info(e,g){var d;d=HEAP[e+16]+4;HEAP[g+4]=6;var b=unSign(HEAP[d],8)<<8&65535;d=unSign(HEAP[d+1],8);b=unSign(b|d,16);HEAP[g]=b;return 0}_tt_cmap6_get_info.__index__=Runtime.getFunctionIndex(_tt_cmap6_get_info,"_tt_cmap6_get_info");
function _tt_cmap8_validate(e,g){var d,b=null,a,c,f;a=e+4;if(e+16+8192>HEAP[g+4]){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 153829";}else{a+=4;c=unSign(HEAP[a+-4],8)<<24;f=unSign(HEAP[a+-4+1],8)<<16;var h=unSign(HEAP[a+-4+2],8)<<8;a=unSign(HEAP[a+-4+3],8);c=f|c|h|a;a=unSign(HEAP[g+4]-e,32)<unSign(c,32);c=unSign(c,32)<=unSign(8207,32);if(a|c){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 153879";}else{c=e+12;a=c+8192;a+=4;f=unSign(HEAP[a+
-4],8)<<24;h=unSign(HEAP[a+-4+1],8)<<16;var i=unSign(HEAP[a+-4+2],8)<<8,k=unSign(HEAP[a+-4+3],8);f=h|f|i|k;if(a+f*12>HEAP[g+4]){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 153931";}else{h=g+8;i=g+172;b=0;a:for(;;){d=b==15?q:0;var j=b==15?o:0,l=0+d;if(!(unSign(l,32)<unSign(f,32))){d=23;break a}a+=4;o=unSign(HEAP[a+-4],8)<<24;q=unSign(HEAP[a+-4+1],8)<<16;k=unSign(HEAP[a+-4+2],8)<<8;b=unSign(HEAP[a+-4+3],8);q=q|o|k|b;a+=4;o=unSign(HEAP[a+-4],8)<<24;k=unSign(HEAP[a+-4+1],
8)<<16;b=unSign(HEAP[a+-4+2],8)<<8;var m=unSign(HEAP[a+-4+3],8),o=k|o|b|m;a+=4;k=unSign(HEAP[a+-4],8)<<24;b=unSign(HEAP[a+-4+1],8)<<16;m=unSign(HEAP[a+-4+2],8)<<8;var n=unSign(HEAP[a+-4+3],8);k=b|k|m|n;if(unSign(q,32)>unSign(o,32)){d=2;break a}l=l!=0;j=unSign(q,32)<=unSign(j,32);if(l&j){d=4;break a}j=HEAP[h]!=0;b:do if(j){l=HEAP[i];if(unSign(o+k+(0-q),32)>=unSign(l,32)){d=6;break a}if((q&-65536)!=0){l=o+1-q;for(b=8;;){b=b==8?0:p;n=q+b;if(l+b*-1==0)break b;m=unSign(n,32)>>>unSign(16,32);p=n&65535;
n=unSign(m,32)>>>unSign(3,32);n=unSign(HEAP[c+n],8);m=m&7;if((reSign(128,32)>>reSign(m,32)&n)==0){d=10;break a}m=unSign(p,32)>>>unSign(3,32);m=unSign(HEAP[c+m],8);p=p&7;if((reSign(128,32)>>reSign(p,32)&m)==0){d=12;break a}var p=b+1;b=13}}else{if((o&-65536)!=0){d=16;break a}l=o+1-q;for(b=17;;){b=b==17?0:r;if(l+b*-1==0)break b;r=q+b&65535;m=unSign(r,32)>>>unSign(3,32);m=unSign(HEAP[c+m],8);r=r&7;if((reSign(128,32)>>reSign(r,32)&m)!=0){d=18;break a}var r=b+1;b=19}}}while(0);var q=d+1;b=15;d=1}if(d==
23)return 0;else if(d==2){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 154043";}else if(d==4){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 154054";}else if(d==6){_ft_validator_error(g,16);throw"Reached an unreachable! Original .ll line: 154072";}else if(d==10){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 154100";}else if(d==12){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 154116";}else if(d==
16){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 154138";}else if(d==18){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 154155";}}}}}_tt_cmap8_validate.__index__=Runtime.getFunctionIndex(_tt_cmap8_validate,"_tt_cmap8_validate");
function _tt_cmap8_char_index(e,g){var d,b=null,a,c,f;a=HEAP[e+16];c=0;a=a+8204;a+=4;var h=unSign(HEAP[a+-4],8)<<24,i=unSign(HEAP[a+-4+1],8)<<16;b=unSign(HEAP[a+-4+2],8)<<8;var k=unSign(HEAP[a+-4+3],8);h=i|h|b|k;i=h+-1;for(b=-1;;){d=b==5?m:0;m=i+d*-1;if((b==5?m:h)==0){d=2;break}a+=4;var j=unSign(HEAP[a+-4],8)<<24;f=unSign(HEAP[a+-4+1],8)<<16;m=unSign(HEAP[a+-4+2],8)<<8;b=unSign(HEAP[a+-4+3],8);j=f|j|m|b;a+=4;f=unSign(HEAP[a+-4],8)<<24;m=unSign(HEAP[a+-4+1],8)<<16;b=unSign(HEAP[a+-4+2],8)<<8;k=unSign(HEAP[a+
-4+3],8);m=m|f|b|k;a+=4;f=unSign(HEAP[a+-4],8)<<24;b=unSign(HEAP[a+-4+1],8)<<16;k=unSign(HEAP[a+-4+2],8)<<8;var l=unSign(HEAP[a+-4+3],8);f=b|f|k|l;if(unSign(g,32)<unSign(j,32)){d=2;break}if(unSign(g,32)<=unSign(m,32)){d=4;break}var m=d+1;b=5;d=0}if(d!=2)if(d==4){c=j;c=g+f+(0-c)}return c}_tt_cmap8_char_index.__index__=Runtime.getFunctionIndex(_tt_cmap8_char_index,"_tt_cmap8_char_index");
function _tt_cmap8_char_next(e,g){var d,b=null,a,c,f,h,i;a=0;c=HEAP[g]+1;f=0;h=HEAP[e+16];i=h+8204;i+=4;var k=unSign(HEAP[i+-4],8)<<24,j=unSign(HEAP[i+-4+1],8)<<16;b=unSign(HEAP[i+-4+2],8)<<8;i=unSign(HEAP[i+-4+3],8);k=j|k|b|i;i=h+8208;c=c;h=f;j=k+-1;for(b=-1;;){d=b==5?s:0;var l=b==5?q:h;q=b==5?p:c;s=j+d*-1;if((b==5?s:k)==0){d=7;break}i+=4;p=unSign(HEAP[i+-4],8)<<24;s=unSign(HEAP[i+-4+1],8)<<16;b=unSign(HEAP[i+-4+2],8)<<8;var m=unSign(HEAP[i+-4+3],8);s=s|p|b|m;i+=4;p=unSign(HEAP[i+-4],8)<<24;b=unSign(HEAP[i+
-4+1],8)<<16;m=unSign(HEAP[i+-4+2],8)<<8;var o=unSign(HEAP[i+-4+3],8);b=b|p|m|o;i+=4;p=unSign(HEAP[i+-4],8)<<24;m=unSign(HEAP[i+-4+1],8)<<16;o=unSign(HEAP[i+-4+2],8)<<8;var n=unSign(HEAP[i+-4+3],8);m=m|p|o|n;var p=unSign(q,32)<unSign(s,32)?s:q;if(unSign(p,32)<=unSign(b,32)){var r=0-s+p+m;if(r!=0){d=2;break}else b=1}else b=6;var q=b==1?0:l,s=d+1;b=5;d=0}if(d==2){f=r;a=c=p}else if(d==7)f=l;HEAP[g]=a;return f}_tt_cmap8_char_next.__index__=Runtime.getFunctionIndex(_tt_cmap8_char_next,"_tt_cmap8_char_next");
function _tt_cmap8_get_info(e,g){var d;d=HEAP[e+16]+8;HEAP[g+4]=8;var b=unSign(HEAP[d],8)<<24,a=unSign(HEAP[d+1],8)<<16,c=unSign(HEAP[d+2],8)<<8;d=unSign(HEAP[d+3],8);HEAP[g]=a|b|c|d;return 0}_tt_cmap8_get_info.__index__=Runtime.getFunctionIndex(_tt_cmap8_get_info,"_tt_cmap8_get_info");
function _tt_cmap10_validate(e,g){var d,b=null,a,c,f;a=e+4;if(e+20>HEAP[g+4]){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 154697";}else{a+=4;c=unSign(HEAP[a+-4],8)<<24;var h=unSign(HEAP[a+-4+1],8)<<16;f=unSign(HEAP[a+-4+2],8)<<8;a=unSign(HEAP[a+-4+3],8);c=h|c|f|a;a=e+16;a+=4;h=unSign(HEAP[a+-4],8)<<24;f=unSign(HEAP[a+-4+1],8)<<16;b=unSign(HEAP[a+-4+2],8)<<8;var i=unSign(HEAP[a+-4+3],8);f=f|h|b|i;h=unSign(HEAP[g+4]-e,32)<unSign(c,32);a:do if(!h){c=c;if(unSign(f*2+20,32)>
unSign(c,32))break a;if(HEAP[g+8]!=0){c=f;h=g+172;a=a;f=f+-1;for(b=5;;){d=b==5?0:j;i=d*2;j=a+i;i=a+(i+1);var k=f+d*-1;if((b==5?c:k)==0){d=7;break}j=unSign(HEAP[j],8)<<8&65535;b=unSign(HEAP[i],8);j=unSign(j|b,16);if(unSign(HEAP[h],32)<=unSign(j,32)){d=2;break}var j=d+1;b=3;d=4}if(d!=7)if(d==2){_ft_validator_error(g,16);throw"Reached an unreachable! Original .ll line: 154810";}}return 0}while(0);_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 154785";}}
_tt_cmap10_validate.__index__=Runtime.getFunctionIndex(_tt_cmap10_validate,"_tt_cmap10_validate");
function _tt_cmap10_char_index(e,g){var d,b,a,c;d=HEAP[e+16];b=0;d=d+12;d+=4;a=unSign(HEAP[d+-4],8)<<24;c=unSign(HEAP[d+-4+1],8)<<16;var f=unSign(HEAP[d+-4+2],8)<<8,h=unSign(HEAP[d+-4+3],8);a=c|a|f|h;d+=4;c=unSign(HEAP[d+-4],8)<<24;f=unSign(HEAP[d+-4+1],8)<<16;h=unSign(HEAP[d+-4+2],8)<<8;var i=unSign(HEAP[d+-4+3],8);c=f|c|h|i;a=g-a;if(unSign(a,32)<unSign(c,32)){d+=a*2;b=unSign(HEAP[d],8)<<8&65535;d=unSign(HEAP[d+1],8);b=unSign(b|d,16)}return b}
_tt_cmap10_char_index.__index__=Runtime.getFunctionIndex(_tt_cmap10_char_index,"_tt_cmap10_char_index");
function _tt_cmap10_char_next(e,g){var d=null,b,a,c,f,h;b=HEAP[e+16];a=HEAP[g]+1;c=0;f=b+12;f+=4;b=unSign(HEAP[f+-4],8)<<24;h=unSign(HEAP[f+-4+1],8)<<16;d=unSign(HEAP[f+-4+2],8)<<8;var i=unSign(HEAP[f+-4+3],8);h=h|b|d|i;f+=4;b=unSign(HEAP[f+-4],8)<<24;d=unSign(HEAP[f+-4+1],8)<<16;i=unSign(HEAP[f+-4+2],8)<<8;var k=unSign(HEAP[f+-4+3],8);b=d|b|i|k;if(unSign(a,32)<unSign(h,32))a=h;h=a-h;f+=h*2;a=a;f=f;c=c;for(d=1;;){o=d==5?o:0;var j=d==5?0:c,l=o*2;d=f+(l+1);i=f+l;l=a+o;if(!(unSign(h+o,32)<unSign(b,32))){d=
2;break}var m=unSign(HEAP[i],8)<<8&65535;d=unSign(HEAP[d],8);m=unSign(m|d,16);if(m!=0){d=3;break}var o=o+1;d=5}c=d==2?j:m;a=l;HEAP[g]=a;return c}_tt_cmap10_char_next.__index__=Runtime.getFunctionIndex(_tt_cmap10_char_next,"_tt_cmap10_char_next");function _tt_cmap10_get_info(e,g){var d;d=HEAP[e+16]+8;HEAP[g+4]=10;var b=unSign(HEAP[d],8)<<24,a=unSign(HEAP[d+1],8)<<16,c=unSign(HEAP[d+2],8)<<8;d=unSign(HEAP[d+3],8);HEAP[g]=a|b|c|d;return 0}
_tt_cmap10_get_info.__index__=Runtime.getFunctionIndex(_tt_cmap10_get_info,"_tt_cmap10_get_info");function _tt_cmap12_init(e,g){var d;d=g;HEAP[e+16]=d;d+=12;var b=unSign(HEAP[d],8)<<24,a=unSign(HEAP[d+1],8)<<16,c=unSign(HEAP[d+2],8)<<8;d=unSign(HEAP[d+3],8);HEAP[e+40]=a|b|c|d;return HEAP[e+24]=0}_tt_cmap12_init.__index__=Runtime.getFunctionIndex(_tt_cmap12_init,"_tt_cmap12_init");
function _tt_cmap12_validate(e,g){var d,b=null,a,c,f;if(e+16>HEAP[g+4]){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 155262";}else{a=e+4;a+=4;c=unSign(HEAP[a+-4],8)<<24;f=unSign(HEAP[a+-4+1],8)<<16;var h=unSign(HEAP[a+-4+2],8)<<8;a=unSign(HEAP[a+-4+3],8);c=f|c|h|a;a=e+12;a+=4;f=unSign(HEAP[a+-4],8)<<24;h=unSign(HEAP[a+-4+1],8)<<16;var i=unSign(HEAP[a+-4+2],8)<<8,k=unSign(HEAP[a+-4+3],8);f=h|f|i|k;h=unSign(HEAP[g+4]-e,32)<unSign(c,32);a:do if(!h){i=c;if(unSign(f*12+16,
32)>unSign(i,32))break a;i=f;k=g+8;var j=g+172;for(b=1;;){d=b==9?s:0;b=b==9?r:0;var l=0+d;if(!(unSign(l,32)<unSign(i,32))){d=11;break}a+=4;r=unSign(HEAP[a+-4],8)<<24;var m=unSign(HEAP[a+-4+1],8)<<16,o=unSign(HEAP[a+-4+2],8)<<8,n=unSign(HEAP[a+-4+3],8);m=m|r|o|n;a+=4;r=unSign(HEAP[a+-4],8)<<24;o=unSign(HEAP[a+-4+1],8)<<16;n=unSign(HEAP[a+-4+2],8)<<8;var p=unSign(HEAP[a+-4+3],8),r=o|r|n|p;a+=4;o=unSign(HEAP[a+-4],8)<<24;n=unSign(HEAP[a+-4+1],8)<<16;p=unSign(HEAP[a+-4+2],8)<<8;var q=unSign(HEAP[a+-4+
3],8);o=n|o|p|q;if(unSign(m,32)>unSign(r,32)){d=3;break}l=l!=0;b=unSign(m,32)<=unSign(b,32);if(l&b){d=5;break}if(HEAP[k]!=0){b=HEAP[j];if(unSign(r+o+(0-m),32)>=unSign(b,32)){d=7;break}}var s=d+1;b=9;d=2}if(d==11)return 0;else if(d==3){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 155462";}else if(d==5){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 155473";}else if(d==7){_ft_validator_error(g,16);throw"Reached an unreachable! Original .ll line: 155491";
}}while(0);_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 155353";}}_tt_cmap12_validate.__index__=Runtime.getFunctionIndex(_tt_cmap12_validate,"_tt_cmap12_validate");
function _tt_cmap12_next(e){var g,d=null,b,a,c;if(HEAP[e+28]!=-1){b=HEAP[e+28]+1;a=HEAP[e+36];c=HEAP[e+40];var f=e+16;b=b;a=a;var h=a*12,i=h+24,k=h+27,j=h+26,l=h+25,m=h+23,o=h+22,n=h+21,p=h+20,r=h+19,q=h+18,s=h+17;h=h+16;d=0;a:for(;;){g=d==7?L:0;L=d==7?G:b;var u=a+g,t=g*12,v=i+t;d=k+t;var w=j+t,x=l+t,y=m+t,A=o+t,z=n+t,C=p+t,B=r+t,D=q+t,E=s+t,F=h+t;if(!(unSign(c,32)>unSign(u,32))){g=8;break a}t=HEAP[f];F=unSign(HEAP[t+F],8)<<24;E=unSign(HEAP[t+E],8)<<16;D=unSign(HEAP[t+D],8)<<8;B=unSign(HEAP[t+B],
8);B=E|F|D|B;C=unSign(HEAP[t+C],8)<<24;z=unSign(HEAP[t+z],8)<<16;A=unSign(HEAP[t+A],8)<<8;y=unSign(HEAP[t+y],8);y=z|C|A|y;v=unSign(HEAP[t+v],8)<<24;x=unSign(HEAP[t+x],8)<<16;w=unSign(HEAP[t+w],8)<<8;d=unSign(HEAP[t+d],8);d=x|v|w|d;L=unSign(L,32)<unSign(B,32)?B:L;w=L+d-B;for(d=2;;){d=d==2?0:J;var G=L+d,H=w+d;if(!(unSign(G,32)<=unSign(y,32)))break;if(H!=0){g=4;break a}var J=d+1;d=5}var L=g+1;d=7;g=1}if(g!=8)if(g==4){a=u;c=H;b=G;HEAP[e+28]=b;HEAP[e+32]=c;HEAP[e+36]=a;return}}HEAP[e+24]=0}
_tt_cmap12_next.__index__=Runtime.getFunctionIndex(_tt_cmap12_next,"_tt_cmap12_next");
function _tt_cmap12_char_map_binary(e,g,d){var b,a=null,c,f,h,i,k,j,l,m;f=0;h=HEAP[e+16]+12;i=unSign(HEAP[h],8)<<24;k=unSign(HEAP[h+1],8)<<16;var o=unSign(HEAP[h+2],8)<<8;c=unSign(HEAP[h+3],8);i=k|i|o|c;k=HEAP[g];o=i==0;a:do if(o)c=0;else{l=i;c=-1;if(d!=0)k+=1;a=i;m=e+16;var n=k,p=k,r=a,q=l,s=j,u=c;a=2;b:for(;;){var t=a==2?u:a==4?B:B,v=a==2?s:a==4?z:z,w=a==2?q:a==4?A:A,x=a==2?r:a==6?x:A,y=a==2?0:a==6?D:y;if(!(unSign(y,32)<unSign(x,32))){b=9;break b}var A=unSign(x+y,32)>>>unSign(1,32);h=HEAP[m]+16+
A*12;h+=4;z=unSign(HEAP[h+-4],8)<<24;B=unSign(HEAP[h+-4+1],8)<<16;b=unSign(HEAP[h+-4+2],8)<<8;a=unSign(HEAP[h+-4+3],8);var z=B|z|b|a;h+=4;B=unSign(HEAP[h+-4],8)<<24;b=unSign(HEAP[h+-4+1],8)<<16;a=unSign(HEAP[h+-4+2],8)<<8;var C=unSign(HEAP[h+-4+3],8),B=b|B|a|C;if(unSign(n,32)<unSign(z,32)){a=4;b=3;continue b}else a=4;if(!(unSign(p,32)>unSign(B,32))){b=7;break b}var D=A+1;a=6;b=3}if(b==9){c=t;j=v;l=w}else if(b==7){c=B;j=z;l=A;f=unSign(HEAP[h],8)<<24;m=unSign(HEAP[h+1],8)<<16;n=unSign(HEAP[h+2],8)<<
8;p=unSign(HEAP[h+3],8);f=m|f|n|p;f=k+f+(0-j)}n=d!=0;b:do if(n){m=e;b=c;b=unSign(k,32)>unSign(b,32);c:do if(b){l+=1;if(l!=i)break c;c=0;break a}while(0);HEAP[m+24]=1;HEAP[m+28]=k;HEAP[m+36]=l;p=f==0;r=m;c:do{if(p){_tt_cmap12_next(r);if(HEAP[m+24]==0){b=14;break c}var E=HEAP[m+32];f=E;a=13;b=15}else{HEAP[r+32]=f;b=14}break c}while(0);if(b==14){var F=f;a=14}if((a==14?F:E)==0){b=18;break b}HEAP[g]=HEAP[m+28]}while(0);c=f}while(0);return c}
_tt_cmap12_char_map_binary.__index__=Runtime.getFunctionIndex(_tt_cmap12_char_map_binary,"_tt_cmap12_char_map_binary");function _tt_cmap12_char_index(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);HEAP[d]=g;var b=_tt_cmap12_char_map_binary(e,d,0);STACKTOP=d;return b}_tt_cmap12_char_index.__index__=Runtime.getFunctionIndex(_tt_cmap12_char_index,"_tt_cmap12_char_index");
function _tt_cmap12_char_next(e,g){var d,b;if(HEAP[e+28]==-1)d=0;else{var a=HEAP[e+24]==0;a:do if(a)d=1;else{if(HEAP[e+28]!=HEAP[g]){d=1;break a}_tt_cmap12_next(e);if(HEAP[e+24]!=0){b=HEAP[e+32];if(b==0){d=4;break a}HEAP[g]=HEAP[e+28]}else b=0;d=4;break a}while(0);if(d==1)b=_tt_cmap12_char_map_binary(e,g,1);d=b}return d}_tt_cmap12_char_next.__index__=Runtime.getFunctionIndex(_tt_cmap12_char_next,"_tt_cmap12_char_next");
function _tt_cmap12_get_info(e,g){var d;d=HEAP[e+16]+8;HEAP[g+4]=12;var b=unSign(HEAP[d],8)<<24,a=unSign(HEAP[d+1],8)<<16,c=unSign(HEAP[d+2],8)<<8;d=unSign(HEAP[d+3],8);HEAP[g]=a|b|c|d;return 0}_tt_cmap12_get_info.__index__=Runtime.getFunctionIndex(_tt_cmap12_get_info,"_tt_cmap12_get_info");function _tt_cmap13_init(e,g){var d;d=g;HEAP[e+16]=d;d+=12;var b=unSign(HEAP[d],8)<<24,a=unSign(HEAP[d+1],8)<<16,c=unSign(HEAP[d+2],8)<<8;d=unSign(HEAP[d+3],8);HEAP[e+40]=a|b|c|d;return HEAP[e+24]=0}
_tt_cmap13_init.__index__=Runtime.getFunctionIndex(_tt_cmap13_init,"_tt_cmap13_init");
function _tt_cmap13_validate(e,g){var d,b=null,a,c,f;if(e+16>HEAP[g+4]){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 156272";}else{a=e+4;a+=4;c=unSign(HEAP[a+-4],8)<<24;f=unSign(HEAP[a+-4+1],8)<<16;var h=unSign(HEAP[a+-4+2],8)<<8;a=unSign(HEAP[a+-4+3],8);c=f|c|h|a;a=e+12;a+=4;f=unSign(HEAP[a+-4],8)<<24;h=unSign(HEAP[a+-4+1],8)<<16;var i=unSign(HEAP[a+-4+2],8)<<8,k=unSign(HEAP[a+-4+3],8);f=h|f|i|k;h=unSign(HEAP[g+4]-e,32)<unSign(c,32);a:do if(!h){i=c;if(unSign(f*12+16,
32)>unSign(i,32))break a;i=f;k=g+8;var j=g+172;for(b=1;;){d=b==9?s:0;b=b==9?r:0;var l=0+d;if(!(unSign(l,32)<unSign(i,32))){d=11;break}a+=4;r=unSign(HEAP[a+-4],8)<<24;var m=unSign(HEAP[a+-4+1],8)<<16,o=unSign(HEAP[a+-4+2],8)<<8,n=unSign(HEAP[a+-4+3],8);m=m|r|o|n;a+=4;r=unSign(HEAP[a+-4],8)<<24;o=unSign(HEAP[a+-4+1],8)<<16;n=unSign(HEAP[a+-4+2],8)<<8;var p=unSign(HEAP[a+-4+3],8),r=o|r|n|p;a+=4;o=unSign(HEAP[a+-4],8)<<24;n=unSign(HEAP[a+-4+1],8)<<16;p=unSign(HEAP[a+-4+2],8)<<8;var q=unSign(HEAP[a+-4+
3],8);o=n|o|p|q;if(unSign(m,32)>unSign(r,32)){d=3;break}l=l!=0;b=unSign(m,32)<=unSign(b,32);if(l&b){d=5;break}if(HEAP[k]!=0)if(unSign(HEAP[j],32)<=unSign(o,32)){d=7;break}var s=d+1;b=9;d=2}if(d==11)return 0;else if(d==3){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 156472";}else if(d==5){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 156483";}else if(d==7){_ft_validator_error(g,16);throw"Reached an unreachable! Original .ll line: 156498";}}while(0);
_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 156363";}}_tt_cmap13_validate.__index__=Runtime.getFunctionIndex(_tt_cmap13_validate,"_tt_cmap13_validate");
function _tt_cmap13_next(e){var g,d=null,b,a,c;if(HEAP[e+28]!=-1){b=HEAP[e+28]+1;a=HEAP[e+36];c=HEAP[e+40];var f=e+16;a=a;b=b;var h=a*12,i=h+24,k=h+27,j=h+26,l=h+25,m=h+23,o=h+22,n=h+21,p=h+20,r=h+19,q=h+18,s=h+17;h=h+16;for(d=0;;){g=d==5?H:0;H=d==5?G:b;var u=a+g,t=g*12,v=i+t;d=k+t;var w=j+t,x=l+t,y=m+t,A=o+t,z=n+t,C=p+t,B=r+t,D=q+t,E=s+t;t=h+t;if(!(unSign(c,32)>unSign(u,32))){g=7;break}var F=HEAP[f];G=unSign(HEAP[F+t],8)<<24;E=unSign(HEAP[F+E],8)<<16;D=unSign(HEAP[F+D],8)<<8;B=unSign(HEAP[F+B],8);
G=E|G|D|B;C=unSign(HEAP[F+C],8)<<24;z=unSign(HEAP[F+z],8)<<16;A=unSign(HEAP[F+A],8)<<8;y=unSign(HEAP[F+y],8);y=z|C|A|y;v=unSign(HEAP[F+v],8)<<24;x=unSign(HEAP[F+x],8)<<16;w=unSign(HEAP[F+w],8)<<8;d=unSign(HEAP[F+d],8);F=x|v|w|d;var G=unSign(H,32)<unSign(G,32)?G:H;if(unSign(G,32)<=unSign(y,32))if(F!=0){g=3;break}var H=g+1;d=5;g=1}if(g!=7)if(g==3){c=F;b=G;a=u;HEAP[e+28]=b;HEAP[e+32]=c;HEAP[e+36]=a;return}}HEAP[e+24]=0}_tt_cmap13_next.__index__=Runtime.getFunctionIndex(_tt_cmap13_next,"_tt_cmap13_next");
function _tt_cmap13_char_map_binary(e,g,d){var b,a=null,c,f,h,i,k,j,l;f=0;h=HEAP[e+16]+12;i=unSign(HEAP[h],8)<<24;k=unSign(HEAP[h+1],8)<<16;var m=unSign(HEAP[h+2],8)<<8;c=unSign(HEAP[h+3],8);i=k|i|m|c;k=HEAP[g];m=i==0;a:do if(m)c=0;else{j=i;c=-1;if(d!=0)k+=1;a=i;l=e+16;var o=k,n=k,p=a,r=j,q=c;a=2;b:for(;;){var s=a==2?q:a==4?A:A,u=a==2?r:a==4?w:w,t=a==2?p:a==6?t:w,v=a==2?0:a==6?z:v;if(!(unSign(v,32)<unSign(t,32))){b=9;break b}var w=unSign(t+v,32)>>>unSign(1,32);h=HEAP[l]+16+w*12;h+=4;A=unSign(HEAP[h+
-4],8)<<24;b=unSign(HEAP[h+-4+1],8)<<16;a=unSign(HEAP[h+-4+2],8)<<8;var x=unSign(HEAP[h+-4+3],8);b=b|A|a|x;h+=4;A=unSign(HEAP[h+-4],8)<<24;a=unSign(HEAP[h+-4+1],8)<<16;x=unSign(HEAP[h+-4+2],8)<<8;var y=unSign(HEAP[h+-4+3],8),A=a|A|x|y;if(unSign(o,32)<unSign(b,32)){a=4;b=3;continue b}else a=4;if(!(unSign(n,32)>unSign(A,32))){b=7;break b}var z=w+1;a=6;b=3}if(b==9){c=s;j=u}else if(b==7){c=A;j=w;f=unSign(HEAP[h],8)<<24;l=unSign(HEAP[h+1],8)<<16;o=unSign(HEAP[h+2],8)<<8;n=unSign(HEAP[h+3],8);f=l|f|o|n}o=
d!=0;b:do if(o){l=e;b=c;b=unSign(k,32)>unSign(b,32);c:do if(b){j+=1;if(j!=i)break c;c=0;break a}while(0);HEAP[l+24]=1;HEAP[l+28]=k;HEAP[l+36]=j;n=f==0;p=l;c:do{if(n){_tt_cmap13_next(p);if(HEAP[l+24]==0){b=14;break c}var C=HEAP[l+32];f=C;a=13;b=15}else{HEAP[p+32]=f;b=14}break c}while(0);if(b==14){var B=f;a=14}if((a==14?B:C)==0){b=18;break b}HEAP[g]=HEAP[l+28]}while(0);c=f}while(0);return c}_tt_cmap13_char_map_binary.__index__=Runtime.getFunctionIndex(_tt_cmap13_char_map_binary,"_tt_cmap13_char_map_binary");
function _tt_cmap13_char_index(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);HEAP[d]=g;var b=_tt_cmap13_char_map_binary(e,d,0);STACKTOP=d;return b}_tt_cmap13_char_index.__index__=Runtime.getFunctionIndex(_tt_cmap13_char_index,"_tt_cmap13_char_index");
function _tt_cmap13_char_next(e,g){var d,b;if(HEAP[e+28]==-1)d=0;else{var a=HEAP[e+24]==0;a:do if(a)d=1;else{if(HEAP[e+28]!=HEAP[g]){d=1;break a}_tt_cmap13_next(e);if(HEAP[e+24]!=0){b=HEAP[e+32];if(b==0){d=4;break a}HEAP[g]=HEAP[e+28]}else b=0;d=4;break a}while(0);if(d==1)b=_tt_cmap13_char_map_binary(e,g,1);d=b}return d}_tt_cmap13_char_next.__index__=Runtime.getFunctionIndex(_tt_cmap13_char_next,"_tt_cmap13_char_next");
function _tt_cmap13_get_info(e,g){var d;d=HEAP[e+16]+8;HEAP[g+4]=13;var b=unSign(HEAP[d],8)<<24,a=unSign(HEAP[d+1],8)<<16,c=unSign(HEAP[d+2],8)<<8;d=unSign(HEAP[d+3],8);HEAP[g]=a|b|c|d;return 0}_tt_cmap13_get_info.__index__=Runtime.getFunctionIndex(_tt_cmap13_get_info,"_tt_cmap13_get_info");function _tt_cmap14_done(e){var g,d,b;b=HEAP[e+36];HEAP[e+28]=0;var a=b!=0;a:do if(a){if(HEAP[e+32]==0)break a;d=HEAP[e+32];g=b;d=d;d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+32]=0}while(0)}
_tt_cmap14_done.__index__=Runtime.getFunctionIndex(_tt_cmap14_done,"_tt_cmap14_done");function _tt_cmap14_ensure(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c,f;f=HEAP[e+28];HEAP[b]=0;var h=unSign(HEAP[e+28],32)<unSign(g,32);a:do if(h){HEAP[e+36]=d;d=_ft_mem_realloc(d,4,f,g,HEAP[e+32],b);HEAP[e+32]=d;if(HEAP[b]!=0){c=HEAP[b];a=0}else{HEAP[e+28]=g;a=1}break a}else a=1;while(0);if(a==1)c=HEAP[b];e=c;STACKTOP=b;return e}
_tt_cmap14_ensure.__index__=Runtime.getFunctionIndex(_tt_cmap14_ensure,"_tt_cmap14_ensure");function _tt_cmap14_init(e,g){var d;d=g;HEAP[e+16]=d;d+=6;var b=unSign(HEAP[d],8)<<24,a=unSign(HEAP[d+1],8)<<16,c=unSign(HEAP[d+2],8)<<8;d=unSign(HEAP[d+3],8);HEAP[e+24]=a|b|c|d;HEAP[e+28]=0;return HEAP[e+32]=0}_tt_cmap14_init.__index__=Runtime.getFunctionIndex(_tt_cmap14_init,"_tt_cmap14_init");
function _tt_cmap14_validate(e,g){var d,b=null,a,c,f,h,i,k,j,l;a=e+2;a+=4;c=unSign(HEAP[a+-4],8)<<24;f=unSign(HEAP[a+-4+1],8)<<16;var m=unSign(HEAP[a+-4+2],8)<<8;h=unSign(HEAP[a+-4+3],8);c=f|c|m|h;a+=4;f=unSign(HEAP[a+-4],8)<<24;m=unSign(HEAP[a+-4+1],8)<<16;h=unSign(HEAP[a+-4+2],8)<<8;i=unSign(HEAP[a+-4+3],8);f=m|f|h|i;m=unSign(HEAP[g+4]-e,32)<unSign(c,32);a:do if(!m){h=c;if(unSign(f*11+10,32)>unSign(h,32))break a;i=1;h=0;b:for(;;){d=f;if(!(unSign(h,32)<unSign(d,32))){d=32;break b}a+=3;d=unSign(HEAP[a+
-3],8)<<16;k=unSign(HEAP[a+-3+1],8)<<8;j=unSign(HEAP[a+-3+2],8);k=k|d|j;a+=4;d=unSign(HEAP[a+-4],8)<<24;j=unSign(HEAP[a+-4+1],8)<<16;l=unSign(HEAP[a+-4+2],8)<<8;var o=unSign(HEAP[a+-4+3],8);j=j|d|l|o;a+=4;d=unSign(HEAP[a+-4],8)<<24;l=unSign(HEAP[a+-4+1],8)<<16;o=unSign(HEAP[a+-4+2],8)<<8;b=unSign(HEAP[a+-4+3],8);d=l|d|o|b;l=c;if(unSign(j,32)>=unSign(l,32)){d=3;break b}l=c;if(unSign(d,32)>=unSign(l,32)){d=3;break b}i=i;if(unSign(k,32)<unSign(i,32)){d=6;break b}i=k+1;if(j!=0){j=e+j;j+=4;k=unSign(HEAP[j+
-4],8)<<24;l=unSign(HEAP[j+-4+1],8)<<16;o=unSign(HEAP[j+-4+2],8)<<8;b=unSign(HEAP[j+-4+3],8);k=l|k|o|b;if(j+k*4>HEAP[g+4]){d=8;break b}k=k;j=j;for(b=9;;){l=b==14?s:0;o=b==14?q:0;var n=l*4,p=j+n;b=j+(n+3);var r=j+(n+2);n=j+(n+1);if(!(unSign(0+l,32)<unSign(k,32)))break;p=unSign(HEAP[p],8)<<16;n=unSign(HEAP[n],8)<<8;r=unSign(HEAP[r],8);r=n|p|r;b=unSign(HEAP[b],8);if(unSign(b+r,32)>unSign(1114111,32)){d=11;break b}if(unSign(r,32)<unSign(o,32)){d=13;break b}var q=r+1+b,s=l+1;b=14}}if(d!=0){l=e+d;l+=4;
d=unSign(HEAP[l+-4],8)<<24;k=unSign(HEAP[l+-4+1],8)<<16;j=unSign(HEAP[l+-4+2],8)<<8;o=unSign(HEAP[l+-4+3],8);d=k|d|j|o;k=HEAP[g+4]-l;if(unSign(d*4,32)>unSign(k,32)){d=18;break b}d=d;k=g+8;j=g+172;l=l;for(b=19;;){o=b==27?w:0;b=b==27?v:0;var u=o*5,t=l+u;r=l+(u+4);p=l+(u+3);n=l+(u+2);u=l+(u+1);if(!(unSign(0+o,32)<unSign(d,32)))break;t=unSign(HEAP[t],8)<<16;u=unSign(HEAP[u],8)<<8;n=unSign(HEAP[n],8);n=u|t|n;p=unSign(HEAP[p],8)<<8&65535;r=unSign(HEAP[r],8);r=unSign(p|r,16);if(unSign(n,32)>unSign(1114111,
32)){d=21;break b}if(unSign(n,32)<unSign(b,32)){d=23;break b}var v=n+1;if(HEAP[k]!=0)if(unSign(HEAP[j],32)<=unSign(r,32)){d=25;break b}var w=o+1;b=27}}h+=1;d=2}if(d==32)return 0;else if(d==3){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 157578";}else if(d==6){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 157589";}else if(d==8){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 157648";}else if(d==11){_ft_validator_error(g,
8);throw"Reached an unreachable! Original .ll line: 157680";}else if(d==13){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 157689";}else if(d==18){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 157778";}else if(d==21){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 157820";}else if(d==23){_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 157829";}else if(d==25){_ft_validator_error(g,16);throw"Reached an unreachable! Original .ll line: 157845";
}}while(0);_ft_validator_error(g,8);throw"Reached an unreachable! Original .ll line: 157473";}_tt_cmap14_validate.__index__=Runtime.getFunctionIndex(_tt_cmap14_validate,"_tt_cmap14_validate");function _tt_cmap14_char_index(){return 0}_tt_cmap14_char_index.__index__=Runtime.getFunctionIndex(_tt_cmap14_char_index,"_tt_cmap14_char_index");function _tt_cmap14_char_next(e,g){return HEAP[g]=0}_tt_cmap14_char_next.__index__=Runtime.getFunctionIndex(_tt_cmap14_char_next,"_tt_cmap14_char_next");
function _tt_cmap14_get_info(e,g){HEAP[g+4]=14;HEAP[g]=-1;return 0}_tt_cmap14_get_info.__index__=Runtime.getFunctionIndex(_tt_cmap14_get_info,"_tt_cmap14_get_info");
function _tt_cmap14_char_map_def_binary(e,g){var d,b=null,a,c,f;a=e;f=unSign(HEAP[a],8)<<24;b=unSign(HEAP[a+1],8)<<16;var h=unSign(HEAP[a+2],8)<<8,i=unSign(HEAP[a+3],8);f=b|f|h|i;a+=4;a=a;for(b=-1;;){var k=b==-1?f:b==3?k:l,j=b==-1?0:b==3?m:j;if(!(unSign(j,32)<unSign(k,32))){d=6;break}var l=unSign(k+j,32)>>>unSign(1,32);d=a+l*4+3;b=unSign(HEAP[d+-3],8)<<16;h=unSign(HEAP[d+-3+1],8)<<8;i=unSign(HEAP[d+-3+2],8);b=h|b|i;d=unSign(HEAP[d],8);if(unSign(g,32)<unSign(b,32))b=1;else{if(!(unSign(d+b,32)<unSign(g,
32))){d=4;break}var m=l+1;b=3}d=0}if(d==4)c=1;else if(d==6)c=0;return c}_tt_cmap14_char_map_def_binary.__index__=Runtime.getFunctionIndex(_tt_cmap14_char_map_def_binary,"_tt_cmap14_char_map_def_binary");
function _tt_cmap14_char_map_nondef_binary(e,g){var d,b=null,a,c,f,h;a=e;f=unSign(HEAP[a],8)<<24;b=unSign(HEAP[a+1],8)<<16;var i=unSign(HEAP[a+2],8)<<8,k=unSign(HEAP[a+3],8);f=b|f|i|k;a+=4;a=a;for(b=-1;;){h=b==-1?f:b==3?h:l;var j=b==-1?0:b==3?o:j;if(!(unSign(j,32)<unSign(h,32))){d=6;break}var l=unSign(h+j,32)>>>unSign(1,32),m=a+l*5+3;d=unSign(HEAP[m+-3],8)<<16;b=unSign(HEAP[m+-3+1],8)<<8;i=unSign(HEAP[m+-3+2],8);d=b|d|i;if(unSign(g,32)<unSign(d,32))b=1;else{if(!(unSign(g,32)>unSign(d,32))){d=4;break}var o=
l+1;b=3}d=0}if(d==4){h=m;c=unSign(HEAP[h],8)<<8&65535;h=unSign(HEAP[h+1],8);c=unSign(c|h,16)}else if(d==6)c=0;return c}_tt_cmap14_char_map_nondef_binary.__index__=Runtime.getFunctionIndex(_tt_cmap14_char_map_nondef_binary,"_tt_cmap14_char_map_nondef_binary");
function _tt_cmap14_find_variant(e,g){var d,b=null,a,c,f;a=e;f=unSign(HEAP[a],8)<<24;b=unSign(HEAP[a+1],8)<<16;var h=unSign(HEAP[a+2],8)<<8,i=unSign(HEAP[a+3],8);f=b|f|h|i;a+=4;a=a;for(b=-1;;){var k=b==-1?f:b==3?k:l,j=b==-1?0:b==3?o:j;if(!(unSign(j,32)<unSign(k,32))){d=6;break}var l=unSign(k+j,32)>>>unSign(1,32),m=a+l*11+3;d=unSign(HEAP[m+-3],8)<<16;b=unSign(HEAP[m+-3+1],8)<<8;h=unSign(HEAP[m+-3+2],8);d=b|d|h;if(unSign(g,32)<unSign(d,32))b=1;else{if(!(unSign(g,32)>unSign(d,32))){d=4;break}var o=l+
1;b=3}d=0}if(d==4)c=c=m;else if(d==6)c=0;return c}_tt_cmap14_find_variant.__index__=Runtime.getFunctionIndex(_tt_cmap14_find_variant,"_tt_cmap14_find_variant");
function _tt_cmap14_char_var_index(e,g,d,b){var a=null,c;b=_tt_cmap14_find_variant(HEAP[e+16]+6,b);var f=b==0;a:do if(f)a=0;else{b+=4;a=unSign(HEAP[b+-4],8)<<24;c=unSign(HEAP[b+-4+1],8)<<16;var h=unSign(HEAP[b+-4+2],8)<<8,i=unSign(HEAP[b+-4+3],8);a=c|a|h|i;c=unSign(HEAP[b],8)<<24;h=unSign(HEAP[b+1],8)<<16;i=unSign(HEAP[b+2],8)<<8;var k=unSign(HEAP[b+3],8);c=h=h|c|i|k;if(a!=0)if(_tt_cmap14_char_map_def_binary(HEAP[e+16]+a,d)!=0){a=FUNCTION_TABLE[HEAP[HEAP[g+12]+12]](g,d);break a}else{var j=c;a=2}else a=
5;a=(a==2?j:h)!=0?_tt_cmap14_char_map_nondef_binary(HEAP[e+16]+c,d):0}while(0);return a}_tt_cmap14_char_var_index.__index__=Runtime.getFunctionIndex(_tt_cmap14_char_var_index,"_tt_cmap14_char_var_index");
function _tt_cmap14_char_var_isdefault(e,g,d){var b=null,a;d=_tt_cmap14_find_variant(HEAP[e+16]+6,d);var c=d==0;a:do{if(!c){d+=4;b=unSign(HEAP[d+-4],8)<<24;a=unSign(HEAP[d+-4+1],8)<<16;var f=unSign(HEAP[d+-4+2],8)<<8,h=unSign(HEAP[d+-4+3],8);b=a|b|f|h;d+=4;a=unSign(HEAP[d+-4],8)<<24;f=unSign(HEAP[d+-4+1],8)<<16;h=unSign(HEAP[d+-4+2],8)<<8;var i=unSign(HEAP[d+-4+3],8);a=f=f|a|h|i;if(b!=0)if(_tt_cmap14_char_map_def_binary(HEAP[e+16]+b,g)!=0){b=1;break a}else{var k=a;b=2}else b=7;b=(b==2?k:f)!=0;b:do if(b){if(_tt_cmap14_char_map_nondef_binary(HEAP[e+
16]+a,g)==0)break b;b=0;break a}while(0)}b=-1}while(0);return b}_tt_cmap14_char_var_isdefault.__index__=Runtime.getFunctionIndex(_tt_cmap14_char_var_isdefault,"_tt_cmap14_char_var_isdefault");
function _tt_cmap14_variants(e,g){var d=null,b,a,c,f;a=HEAP[e+24];b=HEAP[e+16]+10;if(_tt_cmap14_ensure(e,a+1,g)!=0)b=0;else{c=HEAP[e+32];f=0;if(unSign(f,32)<unSign(a,32)){f=f;var h=f+1;a=unSign(a,32)>unSign(h,32)?a:h;h=a-f;for(d=1;;){l=d==1?0:l;d=c+4*(f+l);var i=l*11,k=b+(i+2),j=b+(i+1);i=unSign(HEAP[b+i],8)<<16;j=unSign(HEAP[j],8)<<8;k=unSign(HEAP[k],8);HEAP[d]=j|i|k;var l=l+1;if(l!=h)d=2;else break}f=a}HEAP[c+4*f]=0;b=c}return b}
_tt_cmap14_variants.__index__=Runtime.getFunctionIndex(_tt_cmap14_variants,"_tt_cmap14_variants");
function _tt_cmap14_char_variants(e,g,d){var b,a=null,c,f;c=HEAP[e+24];f=HEAP[e+16]+10;if(_tt_cmap14_ensure(e,c+1,g)!=0)e=0;else{a=HEAP[e+32];if(c!=0){g=e+16;var h=e+16,i=a;a=1;a:for(;;){v=a==1?0:v;t=a==1?i:t;var k=v*11;b=f+(k+10);var j=f+(k+9),l=f+(k+8),m=f+(k+7),o=f+(k+6),n=f+(k+5),p=f+(k+4),r=f+(k+3),q=f+(k+2),s=f+(k+1);k=unSign(HEAP[f+k],8)<<16;s=unSign(HEAP[s],8)<<8;q=unSign(HEAP[q],8);q=s|k|q;r=unSign(HEAP[r],8)<<24;p=unSign(HEAP[p],8)<<16;n=unSign(HEAP[n],8)<<8;o=unSign(HEAP[o],8);o=p|r|n|
o;m=unSign(HEAP[m],8)<<24;l=unSign(HEAP[l],8)<<16;j=unSign(HEAP[j],8)<<8;b=unSign(HEAP[b],8);j=l|m|j|b;l=o==0;b:do if(l)b=4;else{b=_tt_cmap14_char_map_def_binary(HEAP[h]+o,d)!=0?3:4;break b}while(0);b:do if(b==4){if(j==0){a=4;b=5;break b}if(_tt_cmap14_char_map_nondef_binary(HEAP[g]+j,d)!=0){a=6;b=3}else{a=6;b=5}break b}while(0);if(b==3){HEAP[t]=q;var u=t+4;a=3}var t=a==3?u:a==6?t:t,v=v+1;if(v!=c)a=5;else break a}a=t}HEAP[a]=0;e=HEAP[e+32]}return e}
_tt_cmap14_char_variants.__index__=Runtime.getFunctionIndex(_tt_cmap14_char_variants,"_tt_cmap14_char_variants");function _tt_cmap14_def_char_count(e){var g=null,d,b;d=e;d+=4;e=unSign(HEAP[d+-4],8)<<24;b=unSign(HEAP[d+-4+1],8)<<16;g=unSign(HEAP[d+-4+2],8)<<8;var a=unSign(HEAP[d+-4+3],8);e=b|e|g|a;b=0;d+=3;if(e!=0){d=d;b=b;for(g=0;;){f=g==0?0:f;c=g==0?b:c;g=unSign(HEAP[d+f*4],8);var c=c+1+g,f=f+1;if(f!=e)g=1;else break}b=c}return b}
_tt_cmap14_def_char_count.__index__=Runtime.getFunctionIndex(_tt_cmap14_def_char_count,"_tt_cmap14_def_char_count");
function _tt_cmap14_get_def_chars(e,g,d){var b;b=null;var a,c,f,h;g=g;b=_tt_cmap14_def_char_count(g);g+=4;c=unSign(HEAP[g+-4],8)<<24;f=unSign(HEAP[g+-4+1],8)<<16;h=unSign(HEAP[g+-4+2],8)<<8;var i=unSign(HEAP[g+-4+3],8);c=f|c|h|i;d=_tt_cmap14_ensure(e,b+1,d)!=0;a:do if(d)a=0;else{f=HEAP[e+32];b=c!=0?1:2;for(;;)if(b==1){g+=3;b=unSign(HEAP[g+-3],8)<<16;h=unSign(HEAP[g+-3+1],8)<<8;i=unSign(HEAP[g+-3+2],8);h=h|b|i;b=unSign(HEAP[g],8)+1;g+=1;f=f;h=h;i=b;var k=f+4*i;for(b=1;;){j=b==3?j:0;HEAP[f+4*j]=h+j;
var j=j+1;if(j!=i)b=3;else break}f=k;c=b=c-1;b=b!=0?1:2}else if(b==2){HEAP[f]=0;a=HEAP[e+32];break a}}while(0);return a}_tt_cmap14_get_def_chars.__index__=Runtime.getFunctionIndex(_tt_cmap14_get_def_chars,"_tt_cmap14_get_def_chars");
function _tt_cmap14_get_nondef_chars(e,g,d){var b=null,a,c;g=g;g+=4;a=unSign(HEAP[g+-4],8)<<24;c=unSign(HEAP[g+-4+1],8)<<16;b=unSign(HEAP[g+-4+2],8)<<8;var f=unSign(HEAP[g+-4+3],8);a=c|a|b|f;if(_tt_cmap14_ensure(e,a+1,d)!=0)e=0;else{e=HEAP[e+32];c=0;if(unSign(c,32)<unSign(a,32)){d=g;g=c;c=g+1;a=unSign(a,32)>unSign(c,32)?a:c;c=a-g;for(b=1;;){k=b==1?0:k;b=e+4*(g+k);var h=k*5;f=d+(h+2);var i=d+(h+1);h=unSign(HEAP[d+h],8)<<16;i=unSign(HEAP[i],8)<<8;f=unSign(HEAP[f],8);HEAP[b]=i|h|f;var k=k+1;if(k!=c)b=
2;else break}c=a}HEAP[e+4*c]=0;e=e}return e}_tt_cmap14_get_nondef_chars.__index__=Runtime.getFunctionIndex(_tt_cmap14_get_nondef_chars,"_tt_cmap14_get_nondef_chars");
function _tt_cmap14_variant_chars(e,g,d){var b=null,a,c,f,h,i,k,j,l,m,o;d=_tt_cmap14_find_variant(HEAP[e+16]+6,d);var n=d==0;a:do if(n)a=0;else{d+=4;a=unSign(HEAP[d+-4],8)<<24;k=unSign(HEAP[d+-4+1],8)<<16;i=unSign(HEAP[d+-4+2],8)<<8;c=unSign(HEAP[d+-4+3],8);c=k|a|i|c;d+=4;a=unSign(HEAP[d+-4],8)<<24;k=unSign(HEAP[d+-4+1],8)<<16;i=unSign(HEAP[d+-4+2],8)<<8;f=unSign(HEAP[d+-4+3],8);f=a=k|a|i|f;if(c==0)if(f==0){a=0;break a}else if(c==0){a=_tt_cmap14_get_nondef_chars(e,HEAP[e+16]+f,g);break a}else{var p=
f;b=2}else b=35;k=e;if((b==2?p:a)==0)a=_tt_cmap14_get_def_chars(e,HEAP[k+16]+c,g);else{h=k;d=HEAP[e+16]+f;a=HEAP[e+16]+c;d+=4;k=unSign(HEAP[d+-4],8)<<24;i=unSign(HEAP[d+-4+1],8)<<16;m=unSign(HEAP[d+-4+2],8)<<8;var r=unSign(HEAP[d+-4+3],8);k=i|k|m|r;l=_tt_cmap14_def_char_count(a);a+=4;i=unSign(HEAP[a+-4],8)<<24;m=unSign(HEAP[a+-4+1],8)<<16;r=unSign(HEAP[a+-4+2],8)<<8;b=unSign(HEAP[a+-4+3],8);i=m|i|r|b;if(k==0)a=_tt_cmap14_get_def_chars(e,HEAP[e+16]+c,g);else if(l==0)a=_tt_cmap14_get_nondef_chars(e,
HEAP[e+16]+f,g);else if(_tt_cmap14_ensure(h,l+1+k,g)!=0)a=0;else{c=HEAP[h+32];a+=3;f=unSign(HEAP[a+-3],8)<<16;h=unSign(HEAP[a+-3+1],8)<<8;m=unSign(HEAP[a+-3+2],8);j=h|f|m;l=unSign(HEAP[a],8);a+=1;h=1;d+=3;f=unSign(HEAP[d+-3],8)<<16;m=unSign(HEAP[d+-3+1],8)<<8;r=unSign(HEAP[d+-3+2],8);f=m|f|r;d+=2;m=1;b=0;r=c;var q=i,s=c,u=k;j=j;o=o;var t=b;l=l;f=f;m=m;h=h;b=4;b:for(;;){var v=b==4?h:b==14?v:H,w=b==4?m:b==14?P:w,x=b==4?f:b==14?K:x,y=b==4?l:b==14?y:L,A=b==4?t:b==14?I:F,z=b==4?o:b==14?z:G,C=b==4?j:b==
14?C:J;if(unSign(y+C,32)<unSign(x,32)){F=unSign(0,32)<=unSign(y,32);c:do if(F){G=A+1;for(b=6;;){E=b==6?0:E;var B=G+E,D=E+1;HEAP[r+4*(A+E)]=C+E;var E=E+1;if(unSign(D,32)<=unSign(y,32))b=7;else{b=7;break c}}}else b=33;while(0);var F=b==33?A:B,G=b==33?0:D,H=v+1;if(unSign(H,32)>unSign(q,32)){b=8;break b}a+=3;J=unSign(HEAP[a+-3],8)<<16;L=unSign(HEAP[a+-3+1],8)<<8;b=unSign(HEAP[a+-3+2],8);var J=L|J|b,L=unSign(HEAP[a],8);a+=1;b=10}else{if(unSign(x,32)<unSign(C,32)){HEAP[s+4*A]=x;var N=A+1;b=11}else b=48;
var I=b==11?N:A,P=w+1;if(unSign(P,32)>unSign(u,32)){b=13;break b}d+=3;K=unSign(HEAP[d+-3],8)<<16;b=unSign(HEAP[d+-3+1],8)<<8;A=unSign(HEAP[d+-3+2],8);var K=b|K|A;d+=2;b=14}}f=b==13?P:w;r=b==13?I:F;o=b==13?z:G;h=b==13?v:H;m=f;f=x;l=y;b=r;o=o;j=C;r=k;r=unSign(m,32)<=unSign(r,32);b:do if(r){HEAP[c+4*b]=f;b+=1;q=k;if(!(unSign(m,32)<unSign(q,32)))break b;q=c;u=k;s=b;m=m;b=m+1;u=unSign(u,32)>unSign(b,32)?u:b;t=s+u;A=u-m;for(b=15;;){R=b==15?0:R;b=q+4*(s+R);d+=3;var O=unSign(HEAP[d+-3],8)<<16,M=unSign(HEAP[d+
-3+1],8)<<8,Q=unSign(HEAP[d+-3+2],8);HEAP[b]=M|O|Q;d+=2;var R=R+1;if(R!=A)b=17;else break}b=t-m;m=u;b=b}else{q=i;if(!(unSign(h,32)<=unSign(q,32)))break b;o=0;q=l;if(unSign(o,32)<=unSign(q,32)){q=c;l=l;t=o;o=b;s=o+1;u=t+1;j=t+j;for(b=21;;){U=b==21?0:U;var T=s+U,V=u+U;HEAP[q+4*(o+U)]=j+U;b=unSign(V,32)<=unSign(l,32);var U=U+1;if(b)b=22;else break}b=T;o=V}l=i;if(!(unSign(h,32)<unSign(l,32)))break b;o=c;j=i;l=b;b=h;h=b+1;h=unSign(j,32)>unSign(h,32)?j:h;j=h-b;b=25;c:for(;;){ca=b==25?0:ca;aa=b==25?l:aa;
a+=3;var S=unSign(HEAP[a+-3],8)<<16,X=unSign(HEAP[a+-3+1],8)<<8,Y=unSign(HEAP[a+-3+2],8);S=X|S|Y;Y=HEAP[a];X=unSign(Y,8);a+=1;if(unSign(0,32)<=unSign(X,32)){var W=unSign(Y,8),da=W+1;Y=aa+1;for(b=27;;){ba=b==27?0:ba;HEAP[o+4*(aa+ba)]=S+ba;var ba=ba+1;if(ba!=da)b=28;else break}W=Y+W;b=29}else b=26;Y=b==29?da:0;var aa=b==29?W:aa,ca=ca+1;if(ca!=j)b=31;else break c}h=h;l=X;b=aa;o=Y;j=S}while(0);HEAP[c+4*b]=0;a=c}}}while(0);return a}
_tt_cmap14_variant_chars.__index__=Runtime.getFunctionIndex(_tt_cmap14_variant_chars,"_tt_cmap14_variant_chars");
function _tt_face_build_cmaps(e){var g=STACKTOP;STACKTOP+=192;Runtime.memset(g,0,192);var d,b,a,c,f,h,i,k,j,l=g+12,m=g+188;b=HEAP[e+500];a=b+HEAP[e+504];f=b;c=f==0;a:do if(!c){if(f+4>a)break a;f+=2;c=unSign(HEAP[f+-2],8)<<8&65535;var o=unSign(HEAP[f+-2+1],8);f=f;if((c|o)==0){f=f+2;c=unSign(HEAP[f+-2],8)<<8&65535;o=unSign(HEAP[f+-2+1],8);c=unSign(c|o,16);o=a;var n=g+8,p=g+10,r=e,q=g,s=g+4,u=e+504;b=b;var t=l;a=a;e=e+260+4;var v=l+172,w=l+16,x=l;l=l+12;b:for(;;){if(c==0)break b;if(!(f+8<=o))break b;
f+=2;h=unSign(HEAP[f+-2],8)<<8&65535;var y=unSign(HEAP[f+-2+1],8);HEAP[n]=h|y;f+=2;h=unSign(HEAP[f+-2],8)<<8&65535;y=unSign(HEAP[f+-2+1],8);HEAP[p]=h|y;HEAP[q]=r;HEAP[s]=0;f+=4;h=unSign(HEAP[f+-4],8)<<24;y=unSign(HEAP[f+-4+1],8)<<16;var A=unSign(HEAP[f+-4+2],8)<<8;i=unSign(HEAP[f+-4+3],8);y=y|h|A|i;A=y!=0;c:do if(A){if(!(unSign(HEAP[u]-2,32)>=unSign(y,32)))break c;h=b+y;i=unSign(HEAP[h],8)<<8&65535;k=unSign(HEAP[h+1],8);i=unSign(i|k,16);k=_tt_cmap_classes;d:for(;;){if(HEAP[k]==0){d=13;break d}j=HEAP[k];
if(HEAP[j+40]==i){d=8;break d}k+=4;d=7}d:do if(d==8){i=0;HEAP[t]=h;HEAP[t+4]=a;HEAP[t+8]=0;HEAP[t+12]=0;k=unSign(HEAP[e],16);HEAP[v]=k;if(__setjmp(w)==0)i=FUNCTION_TABLE[HEAP[j+44]](h,x);if(HEAP[l]!=0){d=13;break d}if(_FT_CMap_New(j,h,g,m)!=0){d=13;break d}HEAP[HEAP[m]+20]=i}while(0)}while(0);c-=1;d=3}}STACKTOP=g;return}while(0);STACKTOP=g}_tt_face_build_cmaps.__index__=Runtime.getFunctionIndex(_tt_face_build_cmaps,"_tt_face_build_cmaps");
function _tt_get_cmap_info(e,g){return FUNCTION_TABLE[HEAP[HEAP[e+12]+48]](e,g)}_tt_get_cmap_info.__index__=Runtime.getFunctionIndex(_tt_get_cmap_info,"_tt_get_cmap_info");
function _tt_face_load_kern(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b=null,a,c,f,h,i,k,j;j=k=0;a=FUNCTION_TABLE[HEAP[e+508]](e,1801810542,g,d);var l=a!=0;a:do if(!l)if(unSign(HEAP[d],32)<=unSign(3,32))a=142;else{f=e+772;c=HEAP[d];a=g;c=c;f=f;var m=c=_FT_Stream_EnterFrame(a,c);if(m==0){HEAP[f]=HEAP[a+32];HEAP[a+32]=0;HEAP[a+36]=0;a=f=c;if(f!=0)break a;HEAP[e+776]=HEAP[d];f=HEAP[e+772];h=f+HEAP[d];f+=2;f+=2;c=unSign(HEAP[f+-2],8)<<8&65535;m=unSign(HEAP[f+-2+1],8);c=unSign(c|m,16);
if(unSign(c,32)>unSign(32,32))c=32;i=0;c=c;var o=m=h,n=h;h=h;i=i;k=k;j=j;b=4;b:for(;;){var p=b==11?G:0,r=b==11?E:j,q=b==11?F:k,s=i+p;if(!(unSign(s,32)<unSign(c,32)))break b;var u=1<<s;if(f+6>m)break b;var t=f;f+=2;f+=2;var v=unSign(HEAP[f+-2],8)<<8&65535;b=unSign(HEAP[f+-2+1],8);v=unSign(v|b,16);f+=2;b=unSign(HEAP[f+-2],8)<<8&65535;var w=unSign(HEAP[f+-2+1],8);b=unSign(b|w,16);if(unSign(v,32)<=unSign(6,32))break b;E=t+v;G=E>o?n:E;E=(b&-9)!=1;c:do if(E)b=9;else{if(f+8>h){b=10;break c}f+=2;var x=unSign(HEAP[f+
-2],8)<<8&65535;F=unSign(HEAP[f+-2+1],8);x=unSign(x|F,16);f+=6;F=x*6;if(reSign(G-f,32)<reSign(F,32)){var y=Math.floor(reSign(G-f,32)/reSign(6,32));b=13}else b=12;t=b==13?y:x;x=u|q;if(t==0){b=15;break c}f+=4;F=unSign(HEAP[f+-4],8)<<24;v=unSign(HEAP[f+-4+1],8)<<16;b=unSign(HEAP[f+-4+2],8)<<8;w=unSign(HEAP[f+-4+3],8);F=v|F|b|w;f+=2;t=t+-1;for(b=16;;){v=b==19?B:0;b=b==19?C:F;if(t+v*-1==0)break;f+=4;C=unSign(HEAP[f+-4],8)<<24;w=unSign(HEAP[f+-4+1],8)<<16;var A=unSign(HEAP[f+-4+2],8)<<8,z=unSign(HEAP[f+
-4+3],8),C=w|C|A|z;if(unSign(C,32)<=unSign(b,32)){b=18;break c}f+=2;var B=v+1;b=19}var D=u|r;b=20}while(0);var E=b==20?D:b==15?r:b==10?r:b==9?r:r,F=b==20?x:b==15?x:b==10?q:b==9?q:x;f=G;var G=p+1;b=11}j=r;k=q;i=s;HEAP[e+780]=i;HEAP[e+784]=k;HEAP[e+788]=j}else a=m}while(0);l=a;STACKTOP=d;return l}_tt_face_load_kern.__index__=Runtime.getFunctionIndex(_tt_face_load_kern,"_tt_face_load_kern");
function _tt_face_get_kerning(e,g,d){var b=null,a,c,f;a=0;c=HEAP[e+772];f=c+HEAP[e+776];c+=4;var h=HEAP[e+780],i=e+784;g=g<<16|d;e=e+788;a=a;b=-1;a:for(;;){var k=b==2?B:a;E=b==2?E:1;d=b==2?D:h;if((b==2?D:h)==0)break a;if(!(c+6<=f))break a;D=c;c+=2;c+=2;B=unSign(HEAP[c+-2],8)<<8&65535;var j=unSign(HEAP[c+-2+1],8);j=unSign(B|j,16);c+=2;B=unSign(HEAP[c+-2],8)<<8&65535;var l=unSign(HEAP[c+-2+1],8);B=unSign(B|l,16);D=D+j;D=D>f?f:D;j=(E&HEAP[i])==0;b:do if(j)b=24;else{if(c+8>D){b=1;break b}c+=2;l=unSign(HEAP[c+
-2],8)<<8&65535;var m=unSign(HEAP[c+-2+1],8);l=unSign(l|m,16);c+=6;m=l*6;if(reSign(D-c,32)<reSign(m,32)){var o=Math.floor(reSign(D-c,32)/reSign(6,32));b=4}else b=3;l=b==4?o:l;if(unSign(B,32)>>>unSign(8,32)!=0){b=6;break b}if((E&HEAP[e])!=0){m=c;for(b=8;;){var n=b==8?l:b==13?n:p;b=b==8?0:b==13?v:v;if(!(unSign(b,32)<unSign(n,32))){b=9;break b}var p=unSign(n+b,32)>>>unSign(1,32),r=m+p*6+4,q=unSign(HEAP[r+-4],8)<<24,s=unSign(HEAP[r+-4+1],8)<<16,u=unSign(HEAP[r+-4+2],8)<<8,t=unSign(HEAP[r+-4+3],8);q=s|
q|u|t;if(q==g)break;v=p+1;var v=(q=unSign(q,32)<unSign(g,32))?v:b;b=q?13:11}var w=reSign(HEAP[r],8)<<8&65535,x=unSign(HEAP[r+1],8);w=reSign(w|x,16);b=10}else{for(b=7;;){m=b==16?A:0;if(l+m*-1==0){b=17;break b}c+=4;b=unSign(HEAP[c+-4],8)<<24;q=unSign(HEAP[c+-4+1],8)<<16;s=unSign(HEAP[c+-4+2],8)<<8;u=unSign(HEAP[c+-4+3],8);var y=c;if((q|b|s|u)==g)break;c=y+2;var A=m+1;b=16}var z=reSign(HEAP[y],8)<<8&65535;x=unSign(HEAP[c+1],8);z=reSign(z|x,16);b=15}x=b==15?z:w;if((B&8)!=0){b=19;break b}var C=x+k;b=20}while(0);
var B=b==6?k:b==20?C:b==1?k:b==24?k:b==19?x:b==17?k:k;c=D;var D=d-1,E=E<<1;b=2}return a=k}_tt_face_get_kerning.__index__=Runtime.getFunctionIndex(_tt_face_get_kerning,"_tt_face_get_kerning");
function _tt_name_entry_ascii_from_utf16(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b=null,a,c,f;a=HEAP[e+16];c=Math.floor(unSign(HEAP[e+8],16)/unSign(2,16));f=unSign(c,16);c=_ft_mem_realloc(g,1,0,f+1,0,d);if(HEAP[d]!=0)a=0;else{if(unSign(0,32)<unSign(f,32)){var h=(unSign(f,32)>unSign(1,32)?f:1)-0;for(b=1;;){l=b==1?0:l;b=c+(0+l);var i=l*2,k=a+(i+1);i=unSign(HEAP[a+i],8)<<8&65535;k=unSign(HEAP[k],8);k=unSign(i|k,16);i=unSign(k,32)<=unSign(31,32);var j=unSign(k,32)>unSign(127,32);HEAP[b]=
(i|j?63:k)&255;var l=l+1;if(l!=h)b=2;else break}}HEAP[c+f]=0;a=c}a=a;STACKTOP=d;return a}_tt_name_entry_ascii_from_utf16.__index__=Runtime.getFunctionIndex(_tt_name_entry_ascii_from_utf16,"_tt_name_entry_ascii_from_utf16");
function _tt_name_entry_ascii_from_other(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b=null,a,c,f;f=HEAP[e+16];c=unSign(HEAP[e+8],16);a=_ft_mem_realloc(g,1,0,c+1,0,d);if(HEAP[d]!=0)a=0;else{if(unSign(0,32)<unSign(c,32)){var h=(unSign(c,32)>unSign(1,32)?c:1)-0;for(b=1;;){b=b==1?0:l;l=a+(0+b);var i=unSign(HEAP[f+b],8),k=unSign(i,32)<=unSign(31,32),j=unSign(i,32)>unSign(127,32);HEAP[l]=(k|j?63:i)&255;var l=b+1;if(l!=h)b=2;else break}}HEAP[a+c]=0;a=a}a=a;STACKTOP=d;return a}
_tt_name_entry_ascii_from_other.__index__=Runtime.getFunctionIndex(_tt_name_entry_ascii_from_other,"_tt_name_entry_ascii_from_other");
function _tt_face_get_name(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c=null,f,h,i,k,j,l,m,o,n,p,r;f=HEAP[e+100];h=HEAP[b]=0;p=n=o=m=-1;r=0;l=HEAP[e+348+12];if(unSign(HEAP[e+344],16)>unSign(0,16)){var q=e+344;n=n;c=0;a:for(;;){x=c==0?0:x;var s=c==0?n:a,u=0+x,t=1+x,v=HEAP[l+6]==g;b:do if(v){if(HEAP[l+8]==0){c=2;break b}c=unSign(HEAP[l],16);if(c==0){c=3;a=5}else if(c==1){c=3;a=31}else if(c==2){c=3;a=5}else if(c==3){c=3;a=32}else{c=3;break b}if(a==5){p=unSign(u,16);c=5}else if(a==
31)if(HEAP[l+4]==0){o=unSign(u,16);c=7}else{if(HEAP[l+2]!=0){c=8;break b}m=unSign(u,16);c=9}else if(a==32){if(s!=-1)if((unSign(HEAP[l+4],16)&1023)!=9){c=10;break b}c=unSign(HEAP[l+2],16);if(c!=0)if(c!=1)if(c!=10){c=33;break b}r=(unSign(HEAP[l+4],16)&1023)==9;r=unSign(r,1);var w=unSign(u,16);c=12}}else c=1;while(0);a=c==7?s:c==8?s:c==9?s:c==12?w:c==33?s:c==10?s:c==5?s:c==3?s:c==2?s:s;l+=20;c=unSign(HEAP[q],16)>unSign(t,16);var x=x+1;if(c)c=4;else{c=4;break a}}n=a}g=m;if(reSign(o,32)>=reSign(0,32))g=
o;o=0;m=reSign(n,32)<reSign(0,32);a:do if(m)a=17;else{if(!(reSign(g,32)<reSign(0,32)))if(r==0){a=17;break a}var y=l=HEAP[e+348+12]+20*n;q=unSign(HEAP[y+2],16);if(q==0){c=34;a=35}else if(q==1){c=34;a=35}else if(q==10){c=34;a=36}else{c=34;a=20;break a}if(a==35){o=_tt_name_entry_ascii_from_utf16.__index__;a=18;break a}else if(a==36){o=_tt_name_entry_ascii_from_utf16.__index__;a=18;break a}}while(0);a:do if(a==17){if(reSign(g,32)>=reSign(0,32)){l=i=HEAP[e+348+12]+20*g;o=_tt_name_entry_ascii_from_other.__index__;
c=19}else{if(!(reSign(p,32)>=reSign(0,32))){a=18;break a}l=k=HEAP[e+348+12]+20*p;o=_tt_name_entry_ascii_from_utf16.__index__;c=21}a=20;break a}while(0);if(a==18){j=l;c=18}p=(c==18?j:c==34?y:c==21?k:i)!=0;a:do if(p){if(o==0)break a;h=HEAP[l+16]==0;b:do if(h){h=HEAP[e+348+16];y=unSign(HEAP[l+8],16);y=_ft_mem_realloc(f,1,0,y,0,b);HEAP[l+16]=y;y=HEAP[b]!=0;c:do if(!y){i=_FT_Stream_Seek(h,HEAP[l+12]);HEAP[b]=i;if(HEAP[b]!=0)break c;j=unSign(HEAP[l+8],16);k=HEAP[l+16];i=h;k=k;j=j;i=i=_FT_Stream_ReadAt(i,
HEAP[i+8],k,j);HEAP[b]=i;if(HEAP[b]==0)break b}while(0);e=HEAP[l+16];f=f;h=e;e!=0&&FUNCTION_TABLE[HEAP[f+8]](f,h);HEAP[l+16]=0;h=HEAP[l+8]=0;break a}while(0);h=FUNCTION_TABLE[o](l,f)}while(0);HEAP[d]=h;d=HEAP[b];STACKTOP=b;return d}_tt_face_get_name.__index__=Runtime.getFunctionIndex(_tt_face_get_name,"_tt_face_get_name");
function _sfnt_init_face(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c=null,f,h,i,k,j,l,m,o;d=d;i=HEAP[HEAP[g+96]+4];m=HEAP[g+532];k=m==0;a:do if(k){m=i;i=__str537;m=_FT_Get_Module(m,i);m=i=m=m=m=m!=0?HEAP[HEAP[m]+20]:0;if(i==0){f=3;a=1}else{HEAP[g+532]=m;HEAP[g+508]=HEAP[m];a=2}break a}else a=2;while(0);a:do if(a==2){f=HEAP[g+96];f=_ft_module_get_service(f,__str60);HEAP[g+536]=f;i=g;f=e;i=i;k=HEAP[f+28];HEAP[i+132]=0;HEAP[i+132+4]=0;HEAP[i+132+8]=0;a=f;l=a=a=HEAP[a+8];j=_FT_Stream_ReadLong(f,
b);var n=HEAP[b]!=0;b:do{if(n){var p=HEAP[b];c=3;a=4}else if(j!=65536&j!=1953784678&j!=1330926671&j!=1953658213&j!=1954115633&j!=131072){o=2;a=5}else{HEAP[i+132]=1953784678;c=i+132;if(j==1953784678){c=_FT_Stream_ReadFields(f,_ttc_header_fields_9565,c);HEAP[b]=c;if(HEAP[b]!=0){var r=HEAP[b];c=6;a=4;break b}else{c=_ft_mem_realloc(k,4,0,HEAP[i+132+8],0,b);HEAP[i+132+12]=c;if(HEAP[b]!=0){var q=HEAP[b];c=7;a=4;break b}else{c=_FT_Stream_EnterFrame(f,HEAP[i+132+8]*4);HEAP[b]=c;if(HEAP[b]!=0){var s=HEAP[b];
c=8;a=4;break b}else{if(reSign(HEAP[i+132+8],32)>reSign(0,32)){h=i+132+12;c=f;i=i+132+8;k=c+32;a=c+36;l=c+32;for(c=9;;){A=c==9?0:A;j=0+A;n=1+A;var u=HEAP[h],t=HEAP[k];if(t+3<HEAP[a]){var v=t+4,w=reSign(HEAP[v+-4],8)<<24;c=unSign(HEAP[v+-4+1],8)<<16;var x=unSign(HEAP[v+-4+2],8)<<8,y=unSign(HEAP[v+-4+3],8);w=c|w|y|x;c=11}else c=10;x=c==10?0:w;HEAP[l]=c==10?t:v;HEAP[u+4*j]=x;c=reSign(HEAP[i],32)>reSign(n,32);var A=A+1;if(c)c=13;else break}}c=f;if(HEAP[c+20]!=0){f=HEAP[c+28];h=HEAP[c];f=f;h=h;h!=0&&FUNCTION_TABLE[HEAP[f+
8]](f,h);HEAP[c]=0}HEAP[c+32]=0;HEAP[c+36]=0}}}}else{HEAP[c+4]=65536;HEAP[i+132+8]=1;c=_ft_mem_alloc(k,4,b);HEAP[i+132+12]=c;if(HEAP[b]!=0){var z=HEAP[b];c=19;a=4;break b}else HEAP[HEAP[i+132+12]]=l}h=HEAP[b];c=20;a=4}break b}while(0);b:do if(a==4){o=f=c==3?p:c==6?r:c==7?q:c==8?s:c==19?z:h;if(f!=0){a=5;break b}if(reSign(d,32)<reSign(0,32))d=0;o=d;if(reSign(HEAP[g+132+8],32)<=reSign(o,32))f=6;else{o=_FT_Stream_Seek(e,HEAP[HEAP[g+132+12]+4*d]);if(o==0){o=FUNCTION_TABLE[HEAP[m+132]](g,e);if(o==0){HEAP[g]=
HEAP[g+132+8];HEAP[g+4]=d}}f=o}break a}while(0);f=o}while(0);e=f;STACKTOP=b;return e}_sfnt_init_face.__index__=Runtime.getFunctionIndex(_sfnt_init_face,"_sfnt_init_face");
function _sfnt_load_face(e,g,d,b,a){d=STACKTOP;STACKTOP+=32;Runtime.memset(d,0,32);var c,f=null,h,i,k,j,l,m,o,n,p,r=d+4;m=l=0;o=HEAP[g+532];if(reSign(0,32)<reSign(b,32)){b=(reSign(b,32)>reSign(1,32)?b:1)-0;f=0;a:for(;;){c=f==0?0:q;q=0+c;f=a+8*q;q=HEAP[a+8*q]==1768386662;b:do if(q)l=1;else{if(HEAP[f]!=1768386675)break b;m=1}while(0);var q=c+1;if(q!=b){f=4;c=1}else{c=5;break a}}}f=HEAP[HEAP[g+128]+52]!=0;a:do if(f)c=15;else{a=g;f=HEAP[a+156];a=unSign(HEAP[a+152],16);a=a=f+16*a;b=f;f=7;b:for(;;){c=f==
11?s:0;f=b+16*c+12;s=i=b+16*c;if(!(i<a)){c=13;break b}if(HEAP[s]==1735162214)if(HEAP[f]!=0){c=9;break b}var s=c+1;f=11;c=8}if(c!=13)if(c==9){f=i;if(f!=0){c=15;break a}}i=g;f=HEAP[i+156];i=unSign(HEAP[i+152],16);i=i=f+16*i;s=f;for(f=16;;){c=f==20?h:0;f=s+16*c+12;h=j=s+16*c;if(!(j<i)){c=22;break}if(HEAP[h]==1128678944)if(HEAP[f]!=0){c=18;break}h=c+1;f=20;c=17}if(c!=22)if(c==18){f=j;if(f!=0){c=15;break a}}k=0;c=25;break a}while(0);if(c==15)k=1;k=c=k&255;j=0;f=c==0;a:do if(f){if(HEAP[o+84]!=0){j=FUNCTION_TABLE[HEAP[o+
84]](g,e);HEAP[d]=j;j=p=unSign(HEAP[d]==0,1);f=26}else{n=j;f=28}c=(f==28?n:p)==0?29:30;break a}else c=29;while(0);a:do if(c==29){c=FUNCTION_TABLE[HEAP[o+32]](g,e);HEAP[d]=c;c=c!=0?31:30;break a}while(0);a:do if(c==30)if(HEAP[g+160+18]==0)HEAP[d]=8;else{c=FUNCTION_TABLE[HEAP[o+44]](g,e);HEAP[d]=c;c=FUNCTION_TABLE[HEAP[o+40]](g,e);HEAP[d]=c;c=FUNCTION_TABLE[HEAP[o+56]](g,e);HEAP[d]=c;c=FUNCTION_TABLE[HEAP[o+52]](g,e);HEAP[d]=c;h=HEAP[d];n=j==0;b:do if(n){c=FUNCTION_TABLE[HEAP[o+36]](g,e,0);HEAP[d]=
c;p=HEAP[d]==0;c:do{if(p){var u=FUNCTION_TABLE[HEAP[o+136]](g,e,0);HEAP[d]=u;u=HEAP[d];if(u==142)f=33;else{f=33;c=35;break c}HEAP[d]=147;if(HEAP[HEAP[g+128]+52]==0){c=37;break c}if(HEAP[HEAP[HEAP[HEAP[g+128]+52]]+8]==0){c=37;break c}HEAP[g+216+34]=0}else{var t=HEAP[d];if(t==142)f=40;else{f=40;c=35;break c}if(HEAP[g+148]==1953658213)k=0;else{HEAP[d]=143;if(HEAP[HEAP[g+128]+52]==0){c=37;break c}if(HEAP[HEAP[HEAP[HEAP[g+128]+52]]+8]==0){c=37;break c}HEAP[g+216+34]=0}}HEAP[d]=0;c=39;break c}while(0);
c:do if(c==37){var v=HEAP[d];f=37;c=35;break c}while(0);if(c==35)if((f==37?v:f==33?u:t)!=0)break a;c=FUNCTION_TABLE[HEAP[o+36]](g,e,1);HEAP[d]=c;c=c==0;c:do if(c){f=FUNCTION_TABLE[HEAP[o+136]](g,e,1);HEAP[d]=f;if(HEAP[d]!=0)break c;HEAP[g+296]=1}while(0);if(HEAP[d]!=0&HEAP[d]!=142)break a;c=FUNCTION_TABLE[HEAP[o+48]](g,e);HEAP[d]=c;if(HEAP[d]==0)break b;HEAP[g+368]=-1}while(0);c=HEAP[o+140]!=0;b:do if(c){n=FUNCTION_TABLE[HEAP[o+140]](g,e);HEAP[d]=n;if(HEAP[d]==0)break b;if(HEAP[d]!=142)break a;HEAP[d]=
0}while(0);c=FUNCTION_TABLE[HEAP[o+80]](g,e);HEAP[d]=c;if(c!=0){if(HEAP[d]!=142)break a;HEAP[g+556]=0}c=FUNCTION_TABLE[HEAP[o+76]](g,e);HEAP[d]=c;c=FUNCTION_TABLE[HEAP[o+72]](g,e);HEAP[d]=c;c=unSign(HEAP[g+260+4],16);HEAP[g+16]=c;HEAP[g+20]=0;HEAP[g+24]=0;n=HEAP[g+368]==-1;b:do if(n)c=58;else{if((unSign(HEAP[g+368+64],16)&256)==0){c=58;break b}if(l==0){c=_tt_face_get_name(g,16,g+20);HEAP[d]=c;if(HEAP[d]!=0)break a}if(HEAP[g+20]==0){c=_tt_face_get_name(g,1,g+20);HEAP[d]=c;if(HEAP[d]!=0)break a}if(m==
0){c=_tt_face_get_name(g,17,g+24);HEAP[d]=c;if(HEAP[d]!=0)break a}if(HEAP[g+24]!=0){c=64;break b}c=_tt_face_get_name(g,2,g+24);HEAP[d]=c;if(HEAP[d]!=0)break a;else{c=64;break b}}while(0);b:do if(c==58){n=_tt_face_get_name(g,21,g+20);HEAP[d]=n;if(n!=0)break a;n=HEAP[g+20]==0;c:do if(n){if(l!=0){c=67;break c}f=_tt_face_get_name(g,16,g+20);HEAP[d]=f;if(HEAP[d]!=0)break a}while(0);if(HEAP[g+20]==0){n=_tt_face_get_name(g,1,g+20);HEAP[d]=n;if(HEAP[d]!=0)break a}n=_tt_face_get_name(g,22,g+24);HEAP[d]=n;
if(n!=0)break a;n=HEAP[g+24]==0;c:do if(n){if(m!=0){c=72;break c}f=_tt_face_get_name(g,17,g+24);HEAP[d]=f;if(HEAP[d]!=0)break a}while(0);if(HEAP[g+24]!=0){c=64;break b}n=_tt_face_get_name(g,2,g+24);HEAP[d]=n;if(HEAP[d]!=0)break a}while(0);n=g;p=HEAP[n+8];if(k==1)p|=1;p|=24;f=h==0;b:do if(f){if(HEAP[g+468]==196608){c=78;break b}p|=512}while(0);if(HEAP[g+468+12]!=0)p|=4;if(HEAP[g+296]!=0)p|=32;if(HEAP[g+784]!=0)p|=64;h=g;f=HEAP[h+156];h=unSign(HEAP[h+152],16);h=h=f+16*h;i=f;f=83;b:for(;;){c=f==87?x:
0;f=i+16*c+12;var w=i+16*c;s=w;if(!(w<h)){c=89;break b}if(HEAP[s]==1735162214)if(HEAP[f]!=0){c=85;break b}var x=c+1;f=87;c=84}b:do if(c!=89)if(c==85){f=w;if(f==0)break b;h=g;f=HEAP[h+156];h=unSign(HEAP[h+152],16);h=h=f+16*h;i=f;f=91;c:for(;;){c=f==96?A:0;f=i+16*c+12;var y=i+16*c;s=y;if(!(y<h)){c=98;break c}if(HEAP[s]==1719034226)if(HEAP[f]!=0){c=94;break c}var A=c+1;f=96;c=93}if(c!=98)if(c==94){f=y;if(f==0)break b;h=g;f=HEAP[h+156];h=unSign(HEAP[h+152],16);h=h=f+16*h;i=f;for(f=99;;){c=f==103?C:0;
f=i+16*c+12;var z=i+16*c;s=z;if(!(z<h)){c=105;break}if(HEAP[s]==1735811442)if(HEAP[f]!=0){c=101;break}var C=c+1;f=103;c=100}if(c!=105)if(c==101){f=z;if(f==0)break b;p|=256}}}while(0);HEAP[n+8]=p;p=0;f=k!=1;b:do if(f)c=107;else{if(HEAP[g+368]==-1){c=107;break b}c=(unSign(HEAP[g+368+64],16)&512)!=0;c:do{if(!c)if((unSign(HEAP[g+368+64],16)&1&255)==0)break c;p|=1}while(0);if((unSign(HEAP[g+368+64],16)&32)==0){c=113;break b}p|=2;c=113;break b}while(0);b:do if(c==107){if((unSign(HEAP[g+160+44],16)&1&255)!=
0)p|=2;if((unSign(HEAP[g+160+44],16)&2)==0){c=113;break b}p|=1}while(0);HEAP[n+12]=p;_tt_face_build_cmaps(g);if(reSign(HEAP[n+36],32)>reSign(0,32)){f=117;b:for(;;){F=f==117?0:F;p=1+F;h=HEAP[HEAP[n+40]+4*(0+F)];i=unSign(HEAP[h+10],16);s=unSign(HEAP[h+8],16);for(f=118;;){c=f==124?D:0;a=_tt_encodings_9541+c*12+4;var B=_tt_encodings_9541+c*12;b=B;if(B<_tt_encodings_9541+132)f=119;else{f=119;c=126;break}if(HEAP[b]==s){if(HEAP[a]==i){c=120;break}if(HEAP[a]==-1){c=120;break}}var D=c+1;f=124;c=119}if(c==
120){var E=HEAP[B+8];f=120}HEAP[h+4]=f==120?E:0;c=reSign(HEAP[n+36],32)>reSign(p,32);var F=F+1;if(c){f=126;c=118}else{c=127;break b}}}p=f=HEAP[g+612];if(f!=0){h=HEAP[HEAP[g+104]+28];f=HEAP[g+160+18];a=HEAP[g+368+2];i=f==0;b:do if(i)c=129;else{c=HEAP[g+368]==-1?129:130;break b}while(0);if(c==129){a=0;f=1}h=_ft_mem_realloc(h,16,0,p,0,d);HEAP[n+32]=h;if(HEAP[d]!=0)break a;h=p;i=o+152;s=r+20;a=reSign(a,16);b=r;q=Math.floor(unSign(f,16)/unSign(2,16));q=unSign(q,16);var G=unSign(f,16),H=r,J=r+2,L=r+2;for(f=
132;;){c=f==135?K:0;f=0+c;var N=unSign(f,32)<unSign(h,32),I=n;if(!N){c=137;break}N=HEAP[I+32];var P=FUNCTION_TABLE[HEAP[i]](g,f,r);HEAP[d]=P;if(HEAP[d]!=0){c=134;break}K=reSign(HEAP[s],32)>>reSign(6,32)&65535;HEAP[N+16*f]=K;K=unSign(HEAP[b],16)*a;K=Math.floor(reSign(q+K,32)/reSign(G,32))&65535;HEAP[N+16*f+2]=K;K=unSign(HEAP[H],16)<<6;HEAP[N+16*f+8]=K;K=unSign(HEAP[J],16)<<6;HEAP[N+16*f+12]=K;K=unSign(HEAP[L],16)<<6;HEAP[N+16*f+4]=K;var K=c+1;f=135;c=133}if(c==137){HEAP[n+8]=HEAP[I+8]|2;HEAP[n+28]=
p}else if(c==134)break a}f=(HEAP[n+8]&2)==0;b:do if(f){if((HEAP[n+8]&1)!=0){c=140;break b}HEAP[n+8]|=1}while(0);if((HEAP[n+8]&1&255)==0)break a;f=reSign(HEAP[g+160+36],16);HEAP[n+52]=f;f=reSign(HEAP[g+160+38],16);HEAP[n+52+4]=f;f=reSign(HEAP[g+160+40],16);HEAP[n+52+8]=f;f=reSign(HEAP[g+160+42],16);HEAP[n+52+12]=f;HEAP[n+68]=HEAP[g+160+18];HEAP[n+70]=HEAP[g+216+4];HEAP[n+72]=HEAP[g+216+6];HEAP[n+74]=0-HEAP[n+72]+HEAP[n+70]+HEAP[g+216+8];HEAP[n+76]=HEAP[g+216+10];f=HEAP[g+296]!=0?HEAP[g+300+10]:HEAP[n+
74];HEAP[n+78]=f;f=HEAP[g+468+8];p=Math.floor(reSign(HEAP[g+468+10],16)/reSign(2,16));HEAP[n+80]=f-p;HEAP[n+82]=HEAP[g+468+10]}while(0);e=HEAP[d];STACKTOP=d;return e}_sfnt_load_face.__index__=Runtime.getFunctionIndex(_sfnt_load_face,"_sfnt_load_face");
function _sfnt_done_face(e){var g,d,b,a,c,f;if(e!=0){c=HEAP[e+100];f=HEAP[e+532];g=f!=0;a:do if(g){HEAP[f+116]!=0&&FUNCTION_TABLE[HEAP[f+116]](e);if(HEAP[f+144]==0)break a;FUNCTION_TABLE[HEAP[f+144]](e)}while(0);g=e+792;if(HEAP[g+20]!=0){a=HEAP[e+104];if(HEAP[g]!=0){var h=a!=0;a:do if(h){if(HEAP[a+20]==0)break a;d=HEAP[a+28];b=HEAP[g];d=d;b=b;b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g]=0}while(0);HEAP[g]=0}HEAP[g+4]=0;HEAP[g+8]=0;HEAP[g+12]=0}a=HEAP[e+104];g=e+772;h=a!=0;a:do if(h){if(HEAP[a+20]==
0)break a;d=HEAP[a+28];b=HEAP[g];d=d;b=b;b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g]=0}while(0);HEAP[g]=0;HEAP[e+776]=0;HEAP[e+780]=0;HEAP[e+784]=0;HEAP[e+788]=0;g=HEAP[e+132+12];g!=0&&FUNCTION_TABLE[HEAP[c+8]](c,g);HEAP[e+132+12]=0;HEAP[e+132+8]=0;g=HEAP[e+156];g!=0&&FUNCTION_TABLE[HEAP[c+8]](c,g);HEAP[e+156]=0;HEAP[e+152]=0;a=HEAP[e+104];g=e+500;h=a!=0;a:do if(h){if(HEAP[a+20]==0)break a;d=HEAP[a+28];b=HEAP[g];d=d;b=b;b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[g]=0}while(0);HEAP[g]=0;HEAP[e+504]=
0;g=HEAP[e+216+36];g!=0&&FUNCTION_TABLE[HEAP[c+8]](c,g);HEAP[e+216+36]=0;g=HEAP[e+216+40];g!=0&&FUNCTION_TABLE[HEAP[c+8]](c,g);HEAP[e+216+40]=0;if(HEAP[e+296]!=0){g=HEAP[e+300+36];g!=0&&FUNCTION_TABLE[HEAP[c+8]](c,g);HEAP[e+300+36]=0;g=HEAP[e+300+40];g!=0&&FUNCTION_TABLE[HEAP[c+8]](c,g);HEAP[e+300+40]=0;HEAP[e+296]=0}g=HEAP[e+548+4];g!=0&&FUNCTION_TABLE[HEAP[c+8]](c,g);HEAP[e+548+4]=0;HEAP[e+548+2]=0;f!=0&&FUNCTION_TABLE[HEAP[f+60]](e);f=HEAP[e+20];f!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[e+20]=
0;f=HEAP[e+24];f!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[e+24]=0;f=HEAP[e+32];f!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[e+32]=0;HEAP[e+28]=0;f=HEAP[e+700];f!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[e+700]=0;HEAP[e+532]=0}}_sfnt_done_face.__index__=Runtime.getFunctionIndex(_sfnt_done_face,"_sfnt_done_face");
function _get_sfnt_table(e,g){var d,b;d=g==0?4:g==1?5:g==2?6:g==3?7:g==4?8:g==5?9:g==6?10:11;if(d==11)b=0;else if(d==4)b=e+160;else if(d==5)b=e+260;else if(d==6)b=d=HEAP[e+368]!=-1?e+368:0;else if(d==7)b=e+216;else if(d==8)b=d=HEAP[e+296]!=0?e+300:0;else if(d==9)b=e+468;else if(d==10)b=d=HEAP[e+556]!=0?e+556:0;return b}_get_sfnt_table.__index__=Runtime.getFunctionIndex(_get_sfnt_table,"_get_sfnt_table");
function _sfnt_table_info(e,g,d,b,a){var c,f,h=d==0;a:do if(h)c=0;else{if(b==0){c=0;break a}if(a==0){c=0;break a}c=unSign(HEAP[e+152],16);f=g;if(unSign(c,32)<=unSign(f,32))f=142;else{HEAP[d]=HEAP[HEAP[e+156]+16*g];HEAP[b]=HEAP[HEAP[e+156]+16*g+8];HEAP[a]=HEAP[HEAP[e+156]+16*g+12];f=0}c=4;break a}while(0);if(c==0)f=6;return f}_sfnt_table_info.__index__=Runtime.getFunctionIndex(_sfnt_table_info,"_sfnt_table_info");
function _sfnt_get_glyph_name(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c=null;e=_tt_face_get_ps_name(e,g,a);if(e==0){g=HEAP[a];c=d;d=d=g;g=c;var f=b+-1;for(c=0;;){j=c==2?j:0;var h=f+j*-1,i=d+j,k=g+j;if(unSign(c==2?h:b,32)<=unSign(1,32))break;if(HEAP[i]==0)break;HEAP[k]=HEAP[i];var j=j+1;c=2}c=k;d=i;HEAP[c]=0;unSign(HEAP[d]!=0,1)}STACKTOP=a;return e}_sfnt_get_glyph_name.__index__=Runtime.getFunctionIndex(_sfnt_get_glyph_name,"_sfnt_get_glyph_name");
function _sfnt_get_name_index(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a=null,c,f,h;h=-1;if(reSign(HEAP[e+16],32)<reSign(0,32))c=0;else{if(HEAP[e+16]!=-1)h=HEAP[e+16];f=0;h=h;f=f;for(a=2;;){b=a==6?k:0;var i=f+b;if(!(unSign(i,32)<unSign(h,32))){b=8;break}if(_tt_face_get_ps_name(e,i,d)==0)if(_strcmp(g,HEAP[d])==0){b=4;break}var k=b+1;a=6;b=3}if(b==8)c=0;else if(b==4)c=f=i}c=c;STACKTOP=d;return c}_sfnt_get_name_index.__index__=Runtime.getFunctionIndex(_sfnt_get_name_index,"_sfnt_get_name_index");
function _sfnt_get_ps_name(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);var d=null,b,a,c,f,h,i,k,j,l,m,o,n,p=g+4;m=0;if(HEAP[e+700]!=0)e=HEAP[e+700];else{n=o=-1;d=unSign(HEAP[e+344],16);if(reSign(d,32)>reSign(0,32)){b=HEAP[e+348+12];d=unSign(HEAP[e+344],16);c=(reSign(1,32)>reSign(d,32)?1:d)-0;d=1;a:for(;;){f=d==1?0:f;i=0+f;h=b+20*i+8;var r=b+20*i,q=b+20*i+2,s=b+20*i+4,u=HEAP[b+20*i+6]==6;b:do if(u){if(HEAP[h]==0)break b;var t=HEAP[r];if(t==3){d=HEAP[q]==1;c:do if(d){if(HEAP[s]!=1033)break c;
o=i}while(0);a=HEAP[r];d=6}else d=3;if((d==6?a:t)!=1)break b;if(HEAP[q]!=0)break b;if(HEAP[s]!=0)break b;n=i}while(0);f=f+1;if(f!=c)d=4;else break a}}d=o!=-1;a:do if(d){c=HEAP[e+100];a=HEAP[e+348+12]+20*o;m=Math.floor(unSign(HEAP[a+8],16)/unSign(2,16));f=unSign(m,16);HEAP[g]=0;m=unSign(HEAP[a+8],16)+1;m=_ft_mem_alloc(c,m,g);if(HEAP[g]!=0)break a;b=HEAP[e+348+16];i=m;h=_FT_Stream_Seek(b,HEAP[a+12]);HEAP[g]=h;h=HEAP[g]!=0;b:do if(!h){h=unSign(HEAP[a+8],16);h=_FT_Stream_EnterFrame(b,h);HEAP[g]=h;if(HEAP[g]!=
0)break b;o=HEAP[b+32];if(f!=0){o=o;n=f;p=i;d=22;c:for(;;){j=d==22?0:j;k=d==22?p:k;d=j*2;a=o+(d+1);c=HEAP[o+d]==0;d:do if(c){if(!(unSign(HEAP[a],8)>unSign(31,8))){d=24;break d}if(!(reSign(HEAP[a],8)>=reSign(0,8))){d=25;break d}HEAP[k]=HEAP[a];l=k+1;d=27}else d=23;while(0);k=d==27?l:d==25?k:d==24?k:k;j=j+1;if(j!=n)d=26;else break c}i=k}HEAP[i]=0;l=b;if(HEAP[l+20]!=0){k=HEAP[l+28];j=HEAP[l];k=k;j=j;j!=0&&FUNCTION_TABLE[HEAP[k+8]](k,j);HEAP[l]=0}HEAP[l+32]=0;HEAP[l+36]=0;break a}while(0);f=m;m=c;b=f;
f!=0&&FUNCTION_TABLE[HEAP[m+8]](m,b);m=0;HEAP[a+8]=0;HEAP[a+12]=0;b=HEAP[a+16];c=c;f=b;b!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[a+16]=0}else{if(n==-1)break a;b=HEAP[e+100];a=HEAP[e+348+12]+20*n;c=unSign(HEAP[a+8],16);HEAP[p]=0;m=_ft_mem_alloc(b,c+1,p);if(HEAP[p]!=0)break a;f=HEAP[e+348+16];i=_FT_Stream_Seek(f,HEAP[a+12]);HEAP[p]=i;i=HEAP[p]!=0;b:do if(!i){h=m;i=c;f=f;h=h;i=i;f=f=_FT_Stream_ReadAt(f,HEAP[f+8],h,i);HEAP[p]=f;if(HEAP[p]!=0)break b;HEAP[m+c]=0;break a}while(0);HEAP[a+12]=0;HEAP[a+8]=
0;i=HEAP[a+16];c=b;f=i;i!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[a+16]=0;m=m;b=b;a=m;m!=0&&FUNCTION_TABLE[HEAP[b+8]](b,a);m=0}while(0);e=HEAP[e+700]=m}e=e;STACKTOP=g;return e}_sfnt_get_ps_name.__index__=Runtime.getFunctionIndex(_sfnt_get_ps_name,"_sfnt_get_ps_name");
function _sfnt_get_charset_id(e,g,d){var b=STACKTOP;STACKTOP+=16;Runtime.memset(b,0,16);var a=b+8,c;c=_tt_face_find_bdf_prop(e,__str14228,a);var f=c==0;a:do if(f){c=_tt_face_find_bdf_prop(e,__str15229,b);if(c!=0)break a;var h=HEAP[a]!=1;b:do if(!h){if(HEAP[b]!=1)break b;HEAP[g]=HEAP[b+4];HEAP[d]=HEAP[a+4];break a}while(0);c=6}while(0);e=c;STACKTOP=b;return e}_sfnt_get_charset_id.__index__=Runtime.getFunctionIndex(_sfnt_get_charset_id,"_sfnt_get_charset_id");
function _sfnt_get_interface(e,g){return _ft_service_list_lookup(_sfnt_services,g)}_sfnt_get_interface.__index__=Runtime.getFunctionIndex(_sfnt_get_interface,"_sfnt_get_interface");function _tt_face_load_sfnt_header_stub(){return 7}_tt_face_load_sfnt_header_stub.__index__=Runtime.getFunctionIndex(_tt_face_load_sfnt_header_stub,"_tt_face_load_sfnt_header_stub");function _tt_face_load_directory_stub(){return 7}
_tt_face_load_directory_stub.__index__=Runtime.getFunctionIndex(_tt_face_load_directory_stub,"_tt_face_load_directory_stub");function _tt_face_load_hdmx_stub(){return 7}_tt_face_load_hdmx_stub.__index__=Runtime.getFunctionIndex(_tt_face_load_hdmx_stub,"_tt_face_load_hdmx_stub");function _tt_face_free_hdmx_stub(){}_tt_face_free_hdmx_stub.__index__=Runtime.getFunctionIndex(_tt_face_free_hdmx_stub,"_tt_face_free_hdmx_stub");
function _tt_face_set_sbit_strike_stub(e,g,d,b){var a=STACKTOP;STACKTOP+=20;Runtime.memset(a,0,20);HEAP[a]=0;HEAP[a+4]=g;HEAP[a+8]=d;HEAP[a+12]=0;HEAP[a+16]=0;HEAP[b]=2147483647;e=_FT_Match_Size(e,a,0,b);STACKTOP=a;return e}_tt_face_set_sbit_strike_stub.__index__=Runtime.getFunctionIndex(_tt_face_set_sbit_strike_stub,"_tt_face_set_sbit_strike_stub");function _tt_face_load_sbit_stub(){return 7}_tt_face_load_sbit_stub.__index__=Runtime.getFunctionIndex(_tt_face_load_sbit_stub,"_tt_face_load_sbit_stub");
function _tt_face_free_sbit_stub(){}_tt_face_free_sbit_stub.__index__=Runtime.getFunctionIndex(_tt_face_free_sbit_stub,"_tt_face_free_sbit_stub");function _tt_face_load_charmap_stub(){return 7}_tt_face_load_charmap_stub.__index__=Runtime.getFunctionIndex(_tt_face_load_charmap_stub,"_tt_face_load_charmap_stub");function _tt_face_free_charmap_stub(){return 0}_tt_face_free_charmap_stub.__index__=Runtime.getFunctionIndex(_tt_face_free_charmap_stub,"_tt_face_free_charmap_stub");
function _Load_SBit_Range_Codes(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a=null,c,f,h,i,k;k=HEAP[g+28];i=_FT_Stream_ReadLong(g,b);var j=HEAP[b]!=0;a:do if(!j){h=HEAP[e+24]=i;if(d!=0){h=_ft_mem_realloc(k,4,0,h,0,b);HEAP[e+28]=h;if(HEAP[b]!=0)break a;h=i*4}else h=h*2;c=_ft_mem_realloc(k,2,0,i,0,b);HEAP[e+32]=c;if(HEAP[b]!=0)break a;h=_FT_Stream_EnterFrame(g,h);HEAP[b]=h;if(HEAP[b]!=0)break a;h=i;if(unSign(0,32)<unSign(h,32)){h=e+32;c=g;f=d!=0;var l=e+28,m=e+8,o=g,n=i;b:do if(f){var p=
c+32,r=c+36,q=c+32,s=o+32,u=o+36,t=o+32,v=(unSign(n,32)>unSign(1,32)?n:1)-0;for(a=5;;){F=a==9?F:0;var w=0+F,x=HEAP[h],y=HEAP[p];if(y+1<HEAP[r]){var A=y+2,z=reSign(HEAP[A+-2],8)<<8&65535;a=unSign(HEAP[A+-2+1],8);z=z|a;a=7}else a=6;var C=a==6?0:z;HEAP[q]=a==6?y:A;a=reSign(C,16)&65535;HEAP[x+2*w]=a;x=HEAP[l];y=HEAP[m];C=HEAP[s];if(C+1<HEAP[u]){var B=C+2,D=reSign(HEAP[B+-2],8)<<8&65535;a=unSign(HEAP[B+-2+1],8);D=D|a;a=11}else a=22;var E=a==22?0:D;HEAP[t]=a==22?C:B;a=reSign(E,16)&65535;a=unSign(a,16)+
y;HEAP[x+4*w]=a;var F=F+1;if(F!=v)a=9;else break b}}else{p=(unSign(n,32)>unSign(1,32)?n:1)-0;for(a=13;;){J=a==13?0:J;r=0+J;q=HEAP[h];s=HEAP[c+32];if(s+1<HEAP[c+36]){var G=s+2,H=reSign(HEAP[G+-2],8)<<8&65535;u=unSign(HEAP[G+-2+1],8);H=H|u;a=15}else a=14;u=a==14?0:H;HEAP[c+32]=a==14?s:G;s=reSign(u,16)&65535;HEAP[q+2*r]=s;var J=J+1;if(J!=p)a=17;else break b}}while(0)}h=g;if(HEAP[h+20]!=0){c=HEAP[h+28];f=HEAP[h];c=c;f=f;f!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[h]=0}HEAP[h+32]=0;HEAP[h+36]=0}while(0);
e=HEAP[b];STACKTOP=b;return e}_Load_SBit_Range_Codes.__index__=Runtime.getFunctionIndex(_Load_SBit_Range_Codes,"_Load_SBit_Range_Codes");
function _tt_face_load_eblc(e,g){var d=STACKTOP;STACKTOP+=16;Runtime.memset(d,0,16);var b,a=null,c,f,h,i,k,j,l,m=d+4,o=d+8,n,p=d+12,r,q;HEAP[p]=0;r=HEAP[g+28];HEAP[e+612]=0;n=FUNCTION_TABLE[HEAP[e+508]](e,1161972803,g,0);HEAP[p]=n;n=HEAP[p]!=0;a:do if(n){n=FUNCTION_TABLE[HEAP[e+508]](e,1651273571,g,0);HEAP[p]=n;b=n!=0?0:1;break a}else b=1;while(0);a:do if(b==1){n=g;n=n=n=HEAP[n+8];l=_FT_Stream_EnterFrame(g,8);HEAP[p]=l;if(l!=0)break a;l=g;c=0;i=HEAP[l+32];if(i+3<HEAP[l+36]){i+=4;c=reSign(HEAP[i+-4],
8)<<24;f=unSign(HEAP[i+-4+1],8)<<16;j=unSign(HEAP[i+-4+2],8)<<8;q=unSign(HEAP[i+-4+3],8);c=f|c|j|q}HEAP[l+32]=i;i=l=l=c;l=g;f=0;c=HEAP[l+32];if(c+3<HEAP[l+36]){c+=4;f=reSign(HEAP[c+-4],8)<<24;j=unSign(HEAP[c+-4+1],8)<<16;q=unSign(HEAP[c+-4+2],8)<<8;var s=unSign(HEAP[c+-4+3],8);f=j|f|q|s}HEAP[l+32]=c;l=l=l=f;c=g;if(HEAP[c+20]!=0){f=HEAP[c+28];j=HEAP[c];f=f;j=j;j!=0&&FUNCTION_TABLE[HEAP[f+8]](f,j);HEAP[c]=0}HEAP[c+32]=0;HEAP[c+36]=0;i=i!=131072;b:do if(!i){if(unSign(l,32)>unSign(65535,32)){b=7;break b}i=
_ft_mem_realloc(r,48,0,l,0,p);HEAP[e+616]=i;if(HEAP[p]!=0)break a;HEAP[e+612]=l;c=HEAP[e+616];f=l;i=_FT_Stream_EnterFrame(g,l*48);HEAP[p]=i;if(HEAP[p]!=0)break a;i=f;c=c;f=f+-1;a=11;c:for(;;){k=a==11?0:k;j=c+48*k;s=c+48*k+16;q=c+48*k+28;b=f+k*-1;if((a==11?i:b)==0){b=12;break c}a=_FT_Stream_ReadFields(g,_strike_start_fields_10745,j);HEAP[p]=a;if(HEAP[p]!=0){b=12;break c}s=_FT_Stream_ReadFields(g,_sbit_line_metrics_fields_10744,s);HEAP[p]=s;if(HEAP[p]!=0){b=12;break c}q=_FT_Stream_ReadFields(g,_sbit_line_metrics_fields_10744,
q);HEAP[p]=q;if(HEAP[p]!=0){b=12;break c}j=_FT_Stream_ReadFields(g,_strike_end_fields_10746,j);HEAP[p]=j;if(HEAP[p]!=0){b=12;break c}k=k+1;a=16;b=17}k=g;if(HEAP[k+20]!=0){i=HEAP[k+28];c=HEAP[k];i=i;c=c;c!=0&&FUNCTION_TABLE[HEAP[i+8]](i,c);HEAP[k]=0}HEAP[k+32]=0;HEAP[k+36]=0;k=HEAP[e+616];l=i=l;a=21;c:for(;;){if((a==94?h:i)==0){b=23;break c}q=HEAP[k];h=_FT_Stream_Seek(g,n+HEAP[k+8]);HEAP[p]=h;if(HEAP[p]!=0){b=23;break c}h=_FT_Stream_EnterFrame(g,HEAP[k]*8);HEAP[p]=h;if(HEAP[p]!=0){b=23;break c}h=_ft_mem_realloc(r,
40,0,HEAP[k],0,p);HEAP[k+4]=h;if(HEAP[p]!=0){b=23;break c}j=HEAP[k+4];h=g;if(q!=0){c=k+8;f=n;j=j;q=q;for(a=27;;){D=a==27?0:D;var u=a==27?h:B;b=j+40*D;s=j+40*D+2;B=j+40*D+36;var t=HEAP[u+32];if(t+1<HEAP[u+36]){var v=t+2,w=reSign(HEAP[v+-2],8)<<8&65535;a=unSign(HEAP[v+-2+1],8);w=w|a;a=29}else a=28;var x=a==28?0:w;HEAP[u+32]=a==28?t:v;a=reSign(x,16)&65535;HEAP[b]=a;b=g;u=HEAP[b+32];if(u+1<HEAP[b+36]){var y=u+2,A=reSign(HEAP[y+-2],8)<<8&65535;a=unSign(HEAP[y+-2+1],8);A=A|a;a=31}else a=99;t=a==99?0:A;
HEAP[b+32]=a==99?u:y;a=reSign(t,16)&65535;HEAP[s]=a;s=HEAP[c];b=g;u=HEAP[b+32];if(u+3<HEAP[b+36]){var z=u+4,C=reSign(HEAP[z+-4],8)<<24;a=unSign(HEAP[z+-4+1],8)<<16;t=unSign(HEAP[z+-4+2],8)<<8;x=unSign(HEAP[z+-4+3],8);C=a|C|t|x;a=33}else a=100;t=a==100?0:C;HEAP[b+32]=a==100?u:z;HEAP[B]=f+s+t;var B=g,D=D+1;if(D!=q)a=35;else break}a=36}else a=26;h=a==36?B:h;if(HEAP[h+20]!=0){c=HEAP[h+28];f=HEAP[h];c=c;f=f;f!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[h]=0}HEAP[h+32]=0;HEAP[h+36]=0;q=h=HEAP[k];c=j=HEAP[k+
4];f=q+-1;a=40;d:for(;;){j=a==93?Z:0;t=x=c+40*j;var E=c+40*j+16,F=c+40*j+12,G=c+40*j+4,H=c+40*j+2;u=c+40*j+24;q=c+40*j+28;s=c+40*j+8;b=c+40*j+6;var J=f+j*-1;if((a==93?J:h)==0)break d;Z=_FT_Stream_Seek(g,HEAP[c+40*j+36]);HEAP[p]=Z;if(HEAP[p]!=0){a=42;b=43;break c}Z=_FT_Stream_EnterFrame(g,8);HEAP[p]=Z;if(HEAP[p]!=0){a=44;b=43;break c}Z=g;J=HEAP[Z+32];if(J+1<HEAP[Z+36]){var L=J+2,N=reSign(HEAP[L+-2],8)<<8&65535;a=unSign(HEAP[L+-2+1],8);N=N|a;a=46}else a=45;var I=a==45?0:N;HEAP[Z+32]=a==45?J:L;Z=reSign(I,
16)&65535;HEAP[G]=Z;Z=g;J=HEAP[Z+32];if(J+1<HEAP[Z+36]){var P=J+2,K=reSign(HEAP[P+-2],8)<<8&65535;a=unSign(HEAP[P+-2+1],8);K=K|a;a=48}else a=101;I=a==101?0:K;HEAP[Z+32]=a==101?J:P;Z=reSign(I,16)&65535;HEAP[b]=Z;Z=g;b=HEAP[Z+32];if(b+3<HEAP[Z+36]){var O=b+4,M=reSign(HEAP[O+-4],8)<<24;a=unSign(HEAP[O+-4+1],8)<<16;J=unSign(HEAP[O+-4+2],8)<<8;I=unSign(HEAP[O+-4+3],8);M=a|M|J|I;a=50}else a=102;J=a==102?0:M;HEAP[Z+32]=a==102?b:O;HEAP[s]=J;Z=g;if(HEAP[Z+20]!=0){a=HEAP[Z+28];b=HEAP[Z];b!=0&&FUNCTION_TABLE[HEAP[a+
8]](a,b);HEAP[Z]=0;a=53}else a=103;HEAP[Z+32]=0;HEAP[Z+36]=0;Z=g;J=HEAP[Z+28];b=unSign(HEAP[G],16);if(b==1)b=96;else if(b==2)b=97;else if(b==3)b=96;else if(b==4)b=85;else if(b==5)b=98;else{b=91;break c}if(b==96){b=unSign(HEAP[G]==1,1);var Q=HEAP[t];if(unSign(HEAP[H],16)<unSign(Q,16)){b=55;break c}a=HEAP[H];var R=unSign(a,16);Q=HEAP[t];t=0-unSign(Q,16);R=R+1+t;HEAP[u]=R;x=R+1;u=b!=0?4:2;R=_ft_mem_realloc(J,4,0,x,0,o);HEAP[q]=R;R=HEAP[o];if(R!=0){a=56;b=58;break c}var T=_FT_Stream_EnterFrame(Z,x*u);
HEAP[o]=T;T=HEAP[o];if(T!=0){a=59;b=58;break c}if(unSign(0,32)<unSign(x,32))if(b!=0){b=Z+32;u=Z+36;t=Z+32;unSign(x,32);unSign(1,32);a=unSign(a,16)+2;Q=unSign(Q,16);Q=a-Q;Q=unSign(Q,32)>unSign(1,32)?Q:1;for(a=61;;){S=a==65?S:0;x=HEAP[q];E=HEAP[s];F=HEAP[b];if(F+3<HEAP[u]){var V=F+4,U=reSign(HEAP[V+-4],8)<<24;a=unSign(HEAP[V+-4+1],8)<<16;H=unSign(HEAP[V+-4+2],8)<<8;G=unSign(HEAP[V+-4+3],8);U=a|U|G|H;a=63}else a=62;H=a==62?0:U;HEAP[t]=a==62?F:V;HEAP[x+4*S]=H+E;var S=S+1;if(S!=Q)a=65;else break}}else{unSign(x,
32);unSign(1,32);b=Z+32;u=Z+36;t=Z+32;a=unSign(a,16)+2;Q=unSign(Q,16);Q=a-Q;Q=unSign(Q,32)>unSign(1,32)?Q:1;for(a=67;;){W=a==67?0:W;x=HEAP[q];E=HEAP[s];F=HEAP[b];if(F+1<HEAP[u]){var X=F+2,Y=reSign(HEAP[X+-2],8)<<8&65535;a=unSign(HEAP[X+-2+1],8);Y=Y|a;a=69}else a=68;H=a==68?0:Y;HEAP[t]=a==68?F:X;a=reSign(H,16)&65535;a=unSign(a,16)+E;HEAP[x+4*W]=a;var W=W+1;if(W!=Q)a=71;else break}}if(HEAP[Z+20]!=0){Q=HEAP[Z+28];q=HEAP[Z];q!=0&&FUNCTION_TABLE[HEAP[Q+8]](Q,q);HEAP[Z]=0}HEAP[Z+32]=0;HEAP[Z+36]=0;Q=HEAP[o];
a=79}else if(b==97){var da=_FT_Stream_ReadLong(Z,d);HEAP[F]=da;if(HEAP[d]!=0){var ba=HEAP[d];a=81}else{var aa=_FT_Stream_ReadFields(Z,_sbit_metrics_fields,E);HEAP[d]=aa;aa=unSign(HEAP[d]!=0,1);a=83}da=a==83?aa:ba;HEAP[o]=da;a=84}else if(b==85){var ca=_Load_SBit_Range_Codes(x,Z,1);HEAP[o]=ca;a=85}else if(b==98){var $=_FT_Stream_ReadLong(Z,m);HEAP[F]=$;if(HEAP[m]!=0){var la=HEAP[m];a=86}else{var ga=_FT_Stream_ReadFields(Z,_sbit_metrics_fields,E);HEAP[m]=ga;ga=unSign(HEAP[m]!=0,1);a=88}$=a==86?la:ga;
HEAP[o]=$;if($!=0){a=89;b=58;break c}var ea=_Load_SBit_Range_Codes(x,Z,0);HEAP[o]=ea;a=90}Z=a==79?Q:a==84?da:a==85?ca:ea;HEAP[p]=Z;if(Z!=0){a=92;b=43;break c}var Z=j+1;a=93}l=h=l-1;k+=48;a=94;b=22}if(b==23)break a;else if(b==43)break a;else if(b==91){HEAP[o]=3;a=91}else if(b==55){HEAP[o]=3;a=55}else if(b==58){var ha=a==56?R:a==59?T:$;a=58}HEAP[p]=a==55?3:a==91?3:ha;break a}while(0);HEAP[p]=3}while(0);m=HEAP[p];STACKTOP=d;return m}
_tt_face_load_eblc.__index__=Runtime.getFunctionIndex(_tt_face_load_eblc,"_tt_face_load_eblc");
function _tt_face_free_eblc(e){var g,d=null,b,a,c,f,h,i,k;f=HEAP[e+100];h=HEAP[e+616];i=h+48*HEAP[e+612];if(h!=0){g=h<i?0:1;a:for(;;)if(g==0){k=c=HEAP[h+4];g=c+40*HEAP[h];c=c!=0;b:do if(c){if(!(k<g))break b;var j=f,l=f,m=g;k=k;for(d=2;;){r=d==2?0:r;var o=k+40*r+28;d=k+40*r+32;var n=k+40*(r+1),p=HEAP[o];p!=0&&FUNCTION_TABLE[HEAP[j+8]](j,p);HEAP[o]=0;o=HEAP[d];o!=0&&FUNCTION_TABLE[HEAP[l+8]](l,o);HEAP[d]=0;var r=r+1;if(n<m)d=7;else break}k=n}while(0);j=HEAP[h+4];g=f;c=j;j!=0&&FUNCTION_TABLE[HEAP[g+
8]](g,c);HEAP[h+4]=0;HEAP[h]=0;h+=48;g=h<i?0:1}else if(g==1){h=HEAP[e+616];b=f;a=h;g=h!=0?11:12;break a}g==11&&FUNCTION_TABLE[HEAP[b+8]](b,a);HEAP[e+616]=0}HEAP[e+612]=0}_tt_face_free_eblc.__index__=Runtime.getFunctionIndex(_tt_face_free_eblc,"_tt_face_free_eblc");function _tt_face_set_sbit_strike(e,g,d){return _FT_Match_Size(e,g,0,d)}_tt_face_set_sbit_strike.__index__=Runtime.getFunctionIndex(_tt_face_set_sbit_strike,"_tt_face_set_sbit_strike");
function _tt_face_load_strike_metrics(e,g,d){if(unSign(HEAP[e+612],32)<=unSign(g,32))d=6;else{e=HEAP[e+616]+48*g;g=unSign(HEAP[e+44],8);HEAP[d]=g;g=unSign(HEAP[e+45],8);HEAP[d+2]=g;g=reSign(HEAP[e+16],8)<<6;HEAP[d+12]=g;g=reSign(HEAP[e+16+1],8)<<6;HEAP[d+16]=g;g=reSign(HEAP[e+16+6],8);var b=unSign(HEAP[e+16+2],8);e=reSign(HEAP[e+16+7],8);HEAP[d+24]=b+g+e<<6;HEAP[d+20]=HEAP[d+12]-HEAP[d+16];d=0}return d}_tt_face_load_strike_metrics.__index__=Runtime.getFunctionIndex(_tt_face_load_strike_metrics,"_tt_face_load_strike_metrics");
function _find_sbit_range(e,g,d,b){var a,c=null,f,h,i,k;h=unSign(HEAP[g+40],16);var j=unSign(h,32)>unSign(e,32);a:do if(j)a=0;else{h=unSign(HEAP[g+42],16);i=e;if(unSign(h,32)<unSign(i,32)){a=0;break a}h=HEAP[g+4];i=h+40*HEAP[g];if(h==0){a=0;break a}i=i;var l=e,m=e;h=h;c=2;b:for(;;){a=c==2?0:k;var o=h+40*a,n=o;c=h+40*a+2;if(!(o<i)){a=16;break b}n=unSign(HEAP[n],16);if(unSign(n,32)<=unSign(l,32)){c=unSign(HEAP[c],16);if(unSign(c,32)>=unSign(m,32)){a=4;break b}}k=a+1;c=14;a=3}if(a==16){a=0;break a}else if(a==
4){h=o;g=(e&65535)-HEAP[h];a=unSign(HEAP[h+4],16);if(a==1)a=18;else if(a==2)a=19;else if(a==3)a=18;else if(a==4)a=7;else if(a==5)a=7;else{a=0;break a}if(a==18){f=HEAP[h+28];var p=unSign(g,16);HEAP[b]=HEAP[f+4*p]}else if(a==19){f=HEAP[h+8];p=HEAP[h+12];f=unSign(g,16)*p+f;HEAP[b]=f}else if(a==7){k=0;g=HEAP[h+24];o=h+32;e=e;k=k;for(c=7;;){r=c==10?r:0;p=k+r;if(!(unSign(g,32)>unSign(p,32))){a=12;break}if(unSign(HEAP[HEAP[o]+2*p],16)==e){a=9;break}var r=r+1;c=10;a=8}if(a==12){a=0;break a}else if(a==9){k=
p;f=h;HEAP[b]=HEAP[h+4]==4?HEAP[HEAP[f+28]+4*k]:k*HEAP[h+12]+HEAP[f+8]}}HEAP[d]=h;f=0;a=13;break a}}while(0);if(a==0){HEAP[d]=0;HEAP[b]=0;f=6}return f}_find_sbit_range.__index__=Runtime.getFunctionIndex(_find_sbit_range,"_find_sbit_range");
function _tt_find_sbit_image(e,g,d,b,a,c){var f,h,i=HEAP[e+616]==0;a:do if(i)f=0;else{f=d;if(unSign(HEAP[e+612],32)<=unSign(f,32)){f=0;break a}e=HEAP[e+616]+48*d;g=_find_sbit_range(g,e,b,c);if(g!=0){f=0;break a}HEAP[a]=e;h=0;f=3;break a}while(0);if(f==0){HEAP[b]=0;HEAP[a]=0;HEAP[c]=0;h=6}return h}_tt_find_sbit_image.__index__=Runtime.getFunctionIndex(_tt_find_sbit_image,"_tt_find_sbit_image");
function _tt_load_sbit_metrics(e,g,d){var b=STACKTOP;STACKTOP+=13;Runtime.memset(b,0,13);var a,c,f,h=b+8;f=0;a=unSign(HEAP[g+6],16);a=a==1?6:a==2?6:a==6?7:a==7?7:a==8?6:a==9?7:8;a:do if(a==8){h=HEAP[g+4]==2;b:do if(!h){if(HEAP[g+4]==5)break b;c=3;a=4;break a}while(0);g=g+16;HEAP[b]=HEAP[g];HEAP[b+1]=HEAP[g+1];HEAP[b+2]=HEAP[g+2];HEAP[b+3]=HEAP[g+3];HEAP[b+4]=HEAP[g+4];HEAP[b+5]=HEAP[g+5];HEAP[b+6]=HEAP[g+6];HEAP[b+7]=HEAP[g+7];d=d;HEAP[d]=HEAP[b];HEAP[d+1]=HEAP[b+1];HEAP[d+2]=HEAP[b+2];HEAP[d+3]=
HEAP[b+3];HEAP[d+4]=HEAP[b+4];HEAP[d+5]=HEAP[b+5];HEAP[d+6]=HEAP[b+6];HEAP[d+7]=HEAP[b+7];a=0;break a}else if(a==6){f=g=_FT_Stream_ReadFields(e,_sbit_small_metrics_fields_11020,h);if(g!=0){a=0;break a}HEAP[d]=HEAP[h];HEAP[d+1]=HEAP[h+1];HEAP[d+2]=HEAP[h+2];HEAP[d+3]=HEAP[h+3];HEAP[d+4]=HEAP[h+4];HEAP[d+5]=0;HEAP[d+6]=0;a=HEAP[d+7]=0;break a}else if(a==7){f=_FT_Stream_ReadFields(e,_sbit_metrics_fields,d);a=0;break a}while(0);if(a==0)c=f;c=c;STACKTOP=b;return c}
_tt_load_sbit_metrics.__index__=Runtime.getFunctionIndex(_tt_load_sbit_metrics,"_tt_load_sbit_metrics");
function _Load_SBit_Image(e,g,d,b,a,c,f,h,i,k){var j=STACKTOP;STACKTOP+=20;Runtime.memset(j,0,20);var l=null,m,o,n,p,r,q,s,u,t,v,w,x,y,A,z,C,B,D,E;s=j+4;u=j+8;v=j+16;q=HEAP[h+28];l=a+76;b=_FT_Stream_Seek(h,b+d);HEAP[j]=b;var F=HEAP[j]!=0;a:do if(F)b=0;else{b=_tt_load_sbit_metrics(h,g,i);HEAP[j]=b;if(HEAP[j]!=0){b=0;break a}if(k==0){b=unSign(HEAP[i+1],8);HEAP[l+4]=b;b=unSign(HEAP[i],8);HEAP[l]=b;b=unSign(HEAP[e+46],8);b=b==1?64:b==2?65:b==4?66:b==8?67:68;if(b==68){b=z=3;break a}else if(b==64){HEAP[l+
18]=1;b=reSign(HEAP[l+4]+7,32)>>reSign(3,32);HEAP[l+8]=b}else if(b==65){HEAP[l+18]=3;b=reSign(HEAP[l+4]+3,32)>>reSign(2,32);HEAP[l+8]=b}else if(b==66){HEAP[l+18]=4;b=reSign(HEAP[l+4]+1,32)>>reSign(1,32);HEAP[l+8]=b}else if(b==67){HEAP[l+18]=2;HEAP[l+8]=HEAP[l+4]}b=F=HEAP[l+8]*HEAP[l];if(F==0){b=0;break a}b=_ft_glyphslot_alloc_bitmap(a,b);HEAP[j]=b;if(HEAP[j]!=0){b=0;break a}}b=unSign(HEAP[g+6],16);b=b==1?69:b==2?69:b==5?69:b==6?69:b==7?69:b==8?70:b==9?39:71;b:do if(b==71){b=z=3;break a}else if(b==
69){q=unSign(HEAP[g+6],16);z=unSign(HEAP[e+46],8);t=c;u=f;v=q&65535;a=i;e=h;q=l;s=t;l=u;u=z;h=v;v=a;z=e;t=reSign(t,32)<reSign(0,32);c:do if(t)b=6;else{t=unSign(HEAP[v+1],8);a=HEAP[q+4];if(reSign(t+s,32)>reSign(a,32)){b=6;break c}if(reSign(l,32)<reSign(0,32)){b=6;break c}t=unSign(HEAP[v],8);a=HEAP[q];if(reSign(t+l,32)>reSign(a,32)){b=6;break c}e=unSign(HEAP[v+1],8);d=unSign(HEAP[v],8);t=e*u;a=0;h=unSign(h,16);b=h==1?72:h==2?73:h==5?73:h==6?72:h==7?73:74;if(b==74){p=3;b=13;break c}else if(b==72){n=
u;b=n==1?75:n==2?76:n==4?77:78;if(b==78)B=e;else if(b==75)B=reSign(e+7,32)>>reSign(3,32);else if(b==76)B=reSign(e+3,32)>>reSign(2,32);else if(b==77)B=reSign(e+1,32)>>reSign(1,32);C=B*d;a=1}else if(b==73){t=u*e;C=reSign(t*d+7,32)>>reSign(3,32)}n=h=_FT_Stream_EnterFrame(z,C);if(h!=0){b=10;break c}v=unSign(HEAP[v],8);u=u*s;h=unSign(a,8);s=HEAP[z+32];t=t;a=h&255;h=l;l=q;c=s;q=t;s=a;u=u;a=h;t=v;h=HEAP[l+8];v=HEAP[l+12];if(reSign(h,32)<reSign(0,32))v+=(1-HEAP[l])*h;l=reSign(u,32)>>reSign(3,32);v+=h*a+l;
x=w=0;t=l=t;b=reSign(l,32)>reSign(0,32)?16:17;d:for(;;)if(b==16){y=v;A=q;e=u&255&7;a=8-e;d=A;if(reSign(d,32)>reSign(7,32)){A-=8;var G=x;l=e!=0;f=unSign(e,8);k=unSign(a,8);y=y;w=w;x=x;c=c;A=A+-8;if(l){l=18;b=19}else{l=18;b=20}for(;;)if(b==19){P=l==21?P:0;L=l==21?L:c;var H=l==21?I:x;B=l==21?N:w;m=A+P*-8;o=y+(P+1);N=y+P;if(unSign(l==21?I:G,32)<=unSign(7,32)){D=unSign(HEAP[L],8)<<8-H&65535|B;E=L+1;var J=H+8;l=23}else l=19;var L=l==23?E:L;I=l==23?J:H;l=l==23?D:B;H=unSign(l,16)>>>unSign(8,16)&255;B=HEAP[N];
C=unSign(H,8);B=reSign(C,32)>>reSign(f,32)&255|B;HEAP[N]=B;N=HEAP[o];N=unSign(H,8)<<k&255|N;HEAP[o]=N;var N=l<<8,I=I-8;l=reSign(m,32)>=reSign(0,32);var P=P+1;if(l){l=21;b=19}else{l=21;break}}else if(b==20){S=l==27?S:0;T=l==27?T:c;H=l==27?U:x;B=l==27?V:w;var K=A+S*-8,O=y+(S+1);V=y+S;if(unSign(l==27?U:G,32)<=unSign(7,32)){var M=unSign(HEAP[T],8)<<8-H&65535|B,Q=T+1,R=H+8;l=25}else l=20;var T=l==25?Q:T;U=l==25?R:H;l=l==25?M:B;H=unSign(l,16)>>>unSign(8,16)&255;HEAP[V]=H|HEAP[V];var V=l<<8,U=U-8;l=reSign(K,
32)>=reSign(0,32);var S=S+1;if(l){l=27;b=20}else{l=27;break}}y=l==27?K:m;k=l==27?U:I;f=l==27?V:N;G=l==27?O:o;c=l==27?T:L;A=y;x=k;w=f;y=G;A=G=A+8;l=22}else l=16;if(reSign(l==22?G:d,32)>reSign(0,32)){l=A;if(reSign(x,32)<reSign(l,32)){w=unSign(HEAP[c],8)<<8-x&65535|w;c+=1;x+=8}l=unSign(w,16)>>>unSign(8,16)&255;d=A;l=(reSign(255,32)>>reSign(d,32)&255^-1)&l;d=HEAP[y];f=unSign(l,8);e=unSign(e,8);e=reSign(f,32)>>reSign(e,32)&255|d;HEAP[y]=e;e=unSign(a,8);d=A;if(reSign(e,32)<reSign(d,32)){e=HEAP[y+1];l=unSign(l,
8);a=unSign(a,8);HEAP[y+1]=l<<a&255|e}w=unSign(w,16)<<A&65535;x-=A}if(s!=0)x=w=0;v+=h;t=l=t-1;b=reSign(l,32)>reSign(0,32)?16:17}else if(b==17){r=z;b=HEAP[r+20]!=0?33:34;break d}if(b==33){m=HEAP[r+28];o=HEAP[r];m=m;o=o;o!=0&&FUNCTION_TABLE[HEAP[m+8]](m,o);HEAP[r]=0}HEAP[r+32]=0;HEAP[r+36]=0;b=10;break c}while(0);c:do if(b==6){n=6;b=10;break c}while(0);if(b==10)p=n;z=r=p;b=3;break a}else if(b==70){r=h;if(reSign(1,32)<reSign(0,32))HEAP[j]=85;else{r=_FT_Stream_Seek(r,1+HEAP[r+8]);HEAP[j]=r;if(r==0)break b}HEAP[j]=
83;b=0;break a}while(0);p=_FT_Stream_ReadShort(h,j);if(HEAP[j]!=0){b=0;break a}r=unSign(p,16);r=_ft_mem_realloc(q,4,0,r,0,j);if(HEAP[j]!=0){b=0;break a}E=p;n=unSign(p,16)*4;n=_FT_Stream_EnterFrame(h,n);HEAP[j]=n;if(HEAP[j]==0){D=r;n=h;if(E!=0){y=o=m=h;D=D;E=unSign(E+-1,16)+1;for(l=42;;){J=l==42?0:X;Q=l==42?n:y;M=D+4*J;O=D+4*J+2;K=D+4*J+3;R=HEAP[Q+32];if(R+1<HEAP[Q+36]){w=R+2;L=reSign(HEAP[w+-2],8)<<8&65535;T=unSign(HEAP[w+-2+1],8);H=L|T;l=44}else l=43;L=l==43?0:H;HEAP[Q+32]=l==43?R:w;Q=reSign(L,16)&
65535;HEAP[M]=Q;if(HEAP[m+32]<HEAP[m+36]){M=HEAP[m+32];x=HEAP[M];HEAP[m+32]=M+1;l=46}else l=79;M=reSign(l==79?0:x,8)&255;HEAP[O]=M;if(HEAP[o+32]<HEAP[o+36]){O=HEAP[o+32];A=HEAP[O];HEAP[o+32]=O+1;l=48}else l=80;O=reSign(l==80?0:A,8)&255;HEAP[K]=O;var X=J+1;if(X!=E)l=50;else break}l=51}else l=101;n=l==51?y:n;if(HEAP[n+20]!=0){m=HEAP[n+28];o=HEAP[n];m=m;o=o;o!=0&&FUNCTION_TABLE[HEAP[m+8]](m,o);HEAP[n]=0}HEAP[n+32]=0;HEAP[n+36]=0;E=p=p;D=r;n=e;m=k+1;o=f;J=c;K=e;O=d;M=a;Q=h;E=E;D=D;unSign(E,16);E=unSign(E+
-1,16);for(l=55;;){R=l==59?t:0;T=D+4*R+3;L=D+4*R+2;U=E+R*-1&65535;if((l==59?U:p)==0)break;U=unSign(HEAP[D+4*R],16);U=_find_sbit_range(U,n,s,v);HEAP[j]=U;if(HEAP[j]!=0)break;T=reSign(HEAP[T],8)+o;L=reSign(HEAP[L],8)+J;L=_Load_SBit_Image(K,HEAP[s],O,HEAP[v],M,L,T,Q,u,m);HEAP[j]=L;if(HEAP[j]!=0)break;t=R+1;l=59}}r=r;p=q;n=r;r!=0&&FUNCTION_TABLE[HEAP[p+8]](p,n);b=0;break a}while(0);if(b==0)z=HEAP[j];r=z;STACKTOP=j;return r}_Load_SBit_Image.__index__=Runtime.getFunctionIndex(_Load_SBit_Image,"_Load_SBit_Image");
function _tt_face_load_sbit_image(e,g,d,b,a,c,f){var h=STACKTOP;STACKTOP+=12;Runtime.memset(h,0,12);var i,k=null,j,l,m,o,n,p,r,q=h+4,s=h+8;d=_tt_find_sbit_image(e,d,g,s,q,h);g=d!=0;a:do if(!g){d=FUNCTION_TABLE[HEAP[e+508]](e,1161970772,a,0);if(d!=0){d=j=FUNCTION_TABLE[HEAP[e+508]](e,1650745716,a,0);if(j!=0)break a}d=a;d=d=d=HEAP[d+8];d=j=_Load_SBit_Image(HEAP[q],HEAP[s],d,HEAP[h],HEAP[e+84],0,0,a,f,0);if(j!=0)break a;if((reSign(HEAP[HEAP[q]+47],8)&1&255)!=0){j=reSign(HEAP[HEAP[q]+16],8);p=reSign(HEAP[HEAP[q]+
16+1],8);j=j-p;p=0-unSign(HEAP[f+1],8);p=Math.floor(reSign(p,32)/reSign(2,32))&255;HEAP[f+5]=p;p=unSign(HEAP[f],8);p=Math.floor(reSign(j-p,32)/reSign(2,32))&255;HEAP[f+6]=p;j=Math.floor(reSign(j*12,32)/reSign(10,32))&255;HEAP[f+7]=j}if((b&64)==0)break a;p=f;j=c;l=p;p=HEAP[j+12];m=HEAP[j];n=HEAP[j+8];o=0;var u=m;r=n;b:for(;;){if(!(reSign(o,32)<reSign(u,32))){i=12;break b}i=p;p=p+r;for(k=6;;){k=k==9?v:0;var t=i+k;if(!(t<p))break;if(HEAP[t]!=0){i=8;break b}var v=k+1;k=9}p=p;o+=1;i=5}p=m;if(reSign(o,
32)>=reSign(p,32)){HEAP[j+4]=0;HEAP[j]=0;HEAP[j+8]=0;HEAP[j+18]=1}else{if(reSign(o,32)>reSign(0,32)){p=HEAP[j+12];_llvm_memmove_p0i8_p0i8_i32(p,p+n*o,(m-o)*n,1,0);HEAP[l]-=o&255;HEAP[l+3]-=o&255;HEAP[l+6]-=o&255;HEAP[j]-=o;m-=o}p=HEAP[j+12]+(m-1)*n;o=0;u=m;r=n;t=0-n;k=15;b:for(;;){var w=o;if(!(reSign(w,32)<reSign(u,32))){i=23;break b}i=p;var x=p+r;for(k=17;;){var y=k==20?z:0,A=i+y;if(!(A<x))break;if(HEAP[A]!=0){i=19;break b}var z=y+1;k=20}p+=t;o+=1;k=22;i=16}if(i==23)k=23;else if(i==19){var C=o;k=
19}if(reSign(k==19?C:w,32)>reSign(0,32)){HEAP[l]-=o&255;m-=o;HEAP[j]-=o}b:for(;;){p=HEAP[j+12];i=o=p+n*m;k=n;c:for(;;){if(!(p<i))break c;if(reSign(HEAP[p],8)<reSign(0,8)){i=27;break b}p+=k}p=HEAP[j+12];o=p+n*m;u=HEAP[j+4];if(p<o){k=30;i=31}else{k=30;i=32}for(;;)if(i==31){i=k==37?F:u;k=p;r=HEAP[k]<<1;F=i;t=reSign(8,32)<reSign(F,32);F=k;if(t){i=i;r=r;t=k;for(k=33;;){E=k==33?0:E;y=k==33?r:D;var B=t+(E+1);x=16+E*8;D=t+E;k=HEAP[(k==33?F:B)+1];y=unSign(k,8)>>>unSign(7,8)|y;HEAP[D]=y;var D=k<<1;k=reSign(x,
32)<reSign(i,32);var E=E+1;if(k)k=34;else break}r=D;k=35}else k=31;HEAP[k==35?B:F]=r;p+=n;var F=HEAP[j+4];if(p<o){k=37;i=31}else{k=37;i=32}}else if(i==32){HEAP[j+4]=(k==30?u:F)-1;HEAP[l+2]+=1;HEAP[l+5]+=1;HEAP[l+1]-=1;if(reSign(HEAP[j+4],32)>reSign(0,32)){i=38;continue b}else{i=27;break b}}}m=n*m;n=n;k=l+1;l=l+1;b:for(;;){i=HEAP[j+4]-1;p=HEAP[j+12];o=reSign(i,32)>>reSign(3,32);p=p+o;o=p+m;i=i&7;for(i=reSign(128,32)>>reSign(i,32)&255;;){if(!(p<o))break;if((HEAP[p]&i)!=0){i=41;break b}p+=n}HEAP[j+4]-=
1;HEAP[l]=HEAP[k]-1;if(reSign(HEAP[j+4],32)>reSign(0,32))i=39;else{i=45;break b}}}}while(0);e=d;STACKTOP=h;return e}_tt_face_load_sbit_image.__index__=Runtime.getFunctionIndex(_tt_face_load_sbit_image,"_tt_face_load_sbit_image");
function _load_post_names(e){var g=STACKTOP;STACKTOP+=12;Runtime.memset(g,0,12);var d,b=null,a,c,f,h,i,k,j,l,m,o,n,p=g+4,r,q=g+8;r=HEAP[e+104];i=FUNCTION_TABLE[HEAP[e+508]](e,1886352244,r,q);var s=i!=0;a:do if(!s){h=r;h=h=HEAP[h+8];h=HEAP[q]+h;a=HEAP[e+468];i=r;if(reSign(32,32)<reSign(0,32))i=85;else{i=k=_FT_Stream_Seek(i,32+HEAP[i+8]);if(k!=0)break a;if(a==131072){i=r;h=h;a=e;i=i;k=h;h=HEAP[i+28];f=0;l=_FT_Stream_ReadShort(i,g);l=unSign(l,16);m=HEAP[g]!=0;b:do if(m)d=3;else{m=unSign(HEAP[a+260+4],
16);o=l;if(reSign(m,32)<reSign(o,32))HEAP[g]=3;else{m=_ft_mem_realloc(h,2,0,l,0,g);o=HEAP[g]!=0;c:do if(!o){b=_FT_Stream_EnterFrame(i,l*2);HEAP[g]=b;if(HEAP[g]!=0)break c;f=l;b=reSign(0,32)<reSign(f,32);f=i;if(b){c=m;b=l;var u=i;reSign(b,32);reSign(1,32);var t=(reSign(b,32)>reSign(1,32)?b:1)-0;for(b=6;;){z=b==6?0:z;var v=b==6?f:u;d=c+2*(0+z);var w=HEAP[v+32];if(w+1<HEAP[v+36]){var x=w+2,y=reSign(HEAP[x+-2],8)<<8&65535;b=unSign(HEAP[x+-2+1],8);y=y|b;b=8}else b=7;var A=b==7?0:y;HEAP[v+32]=b==7?w:x;
b=reSign(A,16)&65535;HEAP[d]=b;var z=z+1;if(z!=t){b=10;d=7}else{d=11;break}}b=11}else b=5;f=b==11?u:f;if(HEAP[f+20]!=0){b=HEAP[f+28];c=HEAP[f];b=b;c=c;c!=0&&FUNCTION_TABLE[HEAP[b+8]](b,c);HEAP[f]=0}HEAP[f+32]=0;c=HEAP[f+36]=0;f=l;if(reSign(0,32)<reSign(f,32)){f=m;b=l;c=c;reSign(b,32);reSign(1,32);t=(reSign(b,32)>reSign(1,32)?b:1)-0;b=15;d:for(;;){D=b==15?0:D;B=b==15?c:B;d=unSign(HEAP[f+2*(0+D)],16);v=reSign(d,32)>reSign(257,32);e:do if(v){b=d-257;w=unSign(B,16);if(!(reSign(w,32)<reSign(b,32))){b=
17;break e}var C=b&65535;b=18}else b=16;while(0);var B=b==18?C:b==17?B:B,D=D+1;if(D!=t){b=19;d=16}else{d=21;break d}}c=B}f=unSign(c,16);f=_ft_mem_realloc(h,4,0,f,0,g);if(HEAP[g]!=0)break c;b=0;t=c;v=k;w=i;var E=A=k,F=k,G=h,H=f,J=f,L=i,N=f,I=k,P=b,K=i+8,O=i+8,M=i+8,Q=L+8,R=i+8;b=23;d:for(;;){var T=b==36?Y:0,V=P+T;if(!(unSign(V,16)<unSign(t,16))){d=26;break d}if(reSign(HEAP[K],32)>=reSign(v,32)){d=26;break d}d=_FT_Stream_ReadChar(w,g);var U=unSign(d,8);if(HEAP[g]!=0){d=28;break d}var S=reSign(U,32)>
reSign(A,32);e:do if(S){b=29;d=31}else{d=I-U;if(reSign(HEAP[R],32)>reSign(d,32)){b=30;d=31}else{b=30;d=32}break e}while(0);e:do if(d==31){if(!(reSign(E-HEAP[O],32)>=reSign(0,32))){b=31;break e}var X=F-HEAP[M];b=33}while(0);d=b==30?U:b==33?X:0;b=unSign(V,16);U=_ft_mem_realloc(G,1,0,d+1,0,g);HEAP[H+4*b]=U;if(HEAP[g]!=0){d=28;break d}b=unSign(V,16);b=_FT_Stream_ReadAt(L,HEAP[Q],HEAP[J+4*b],d);HEAP[g]=b;if(HEAP[g]!=0){d=28;break d}Y=unSign(V,16);HEAP[HEAP[N+4*Y]+d]=0;var Y=T+1;b=36;d=24}d:do if(d==26){b=
V;t=c;if(unSign(b,16)<unSign(t,16)){t=c;v=h;A=w=f;E=b;for(b=37;;){d=b==37?0:W;b=E+d;if(!(unSign(b,16)<unSign(t,16))){d=42;break}F=unSign(b,16);G=_ft_mem_realloc(v,1,0,1,0,g);HEAP[w+4*F]=G;if(HEAP[g]!=0){d=39;break}W=unSign(b,16);HEAP[HEAP[A+4*W]]=0;var W=d+1;b=40;d=38}if(d!=42)if(d==39){d=45;break d}}j=a+628+4;HEAP[j]=l&65535;HEAP[j+2]=c;HEAP[j+4]=m;HEAP[j+8]=f;j=0;d=44;break b}while(0);b=c;if(!(unSign(0,16)<unSign(b,16)))break c;t=f;v=h;w=f;b=c;unSign(b,16);unSign(1,16);c=v+8;A=(unSign(b,16)>unSign(1,
16)?b:1)-0;for(b=47;;){da=b==47?0:da;d=0+da;b=unSign(d,16);b=HEAP[t+4*b];b!=0&&FUNCTION_TABLE[HEAP[c]](v,b);d=unSign(d,16);HEAP[w+4*d]=0;var da=da+1;if(da!=A){b=50;d=48}else{d=51;break}}}while(0);i=f;d=h;a=i;i!=0&&FUNCTION_TABLE[HEAP[d+8]](d,a);d=m;h=h;a=d;d!=0&&FUNCTION_TABLE[HEAP[h+8]](h,a)}d=3;break b}while(0);if(d==3)j=HEAP[g];i=h=j}else if(a==163840){a=r;h=e;m=a;a=HEAP[m+28];i=_FT_Stream_ReadShort(m,p);i=unSign(i,16);k=HEAP[p]!=0;b:do if(k)d=57;else{k=unSign(HEAP[h+260+4],16);l=i;k=reSign(k,
32)<reSign(l,32);l=reSign(i,32)>reSign(258,32);if(k|l)HEAP[p]=3;else{k=l=_ft_mem_realloc(a,1,0,i,0,p);if(HEAP[p]!=0)b=95;else{o=i;f=k;m=m;f=f;o=o;m=m=_FT_Stream_ReadAt(m,HEAP[m+8],f,o);HEAP[p]=m;if(HEAP[p]==0){m=i;o=k;f=i;for(b=58;;){d=b==62?ba:0;b=0+d;c=o+b;if(!(reSign(b,32)<reSign(m,32))){d=65;break}c=HEAP[c];reSign(c,8);t=reSign(c,8);t=reSign(b+t,32)<reSign(0,32);reSign(c,8);if(t){d=60;break}c=reSign(c,8);if(reSign(b+c,32)>reSign(f,32)){d=60;break}var ba=d+1;b=62;d=59}if(d==65){n=h+628+4;HEAP[n]=
i&65535;HEAP[n+4]=k;n=0;d=66;break b}else if(d==60)HEAP[p]=3}var aa=k;b=67}h=b==67?aa:l;d=a;a=h;h!=0&&FUNCTION_TABLE[HEAP[d+8]](d,a)}d=57;break b}while(0);if(d==57)n=HEAP[p];i=h=n}else i=3;HEAP[e+628]=1}}while(0);e=i;STACKTOP=g;return e}_load_post_names.__index__=Runtime.getFunctionIndex(_load_post_names,"_load_post_names");
function _tt_face_free_ps_names(e){var g=null,d,b,a,c,f;c=HEAP[e+100];f=e+628;var h=HEAP[f]!=0;a:do if(h){d=HEAP[e+468];if(d==131072){d=f+4;b=HEAP[d+4];a=c;b=b;b!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[d+4]=0;HEAP[d]=0;b=unSign(HEAP[d+2],16)>unSign(0,16);a=HEAP[d+8];if(b){b=c;var i=d+8,k=d+2,j=d+8;for(g=1;;){n=g==1?0:n;var l=g==1?a:o;g=0+n;o=1+n;var m=unSign(g,16);l=HEAP[l+4*m];l!=0&&FUNCTION_TABLE[HEAP[b+8]](b,l);l=HEAP[i];g=unSign(g,16);HEAP[l+4*g]=0;g=unSign(HEAP[k],16)>unSign(o,16);var o=HEAP[j],
n=n+1;if(g)g=4;else break}g=5}else g=15;i=g==5?o:a;a=c;b=i;i!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[d+8]=0;HEAP[d+2]=0}else{if(d!=163840)break a;a=f+4;b=HEAP[a+4];d=c;b=b;b!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[a+4]=0;HEAP[a]=0}}while(0);HEAP[f]=0}_tt_face_free_ps_names.__index__=Runtime.getFunctionIndex(_tt_face_free_ps_names,"_tt_face_free_ps_names");
function _tt_face_get_ps_name(e,g,d){var b,a,c,f,h;g=g;if(e==0)e=35;else{a=unSign(HEAP[e+260+4],16);f=g;if(unSign(a,32)<=unSign(f,32))e=16;else{f=HEAP[e+536];if(f==0)e=7;else{a=e+628;c=FUNCTION_TABLE[HEAP[f+16]](0);HEAP[d]=c;c=HEAP[e+468];var i=c==65536;a:do if(i){if(!(unSign(g,32)<=unSign(257,32)))break a;h=FUNCTION_TABLE[HEAP[f+16]](g);HEAP[d]=h}else if(c==131072){h=a+4;if(HEAP[a]==0){b=_load_post_names(e);if(b!=0)break a}b=unSign(HEAP[h],16);var k=g;if(!(unSign(b,32)>unSign(k,32)))break a;b=HEAP[HEAP[h+
4]+2*g];if(unSign(b,16)<=unSign(257,16)){h=HEAP[f+16];b=unSign(b,16);h=FUNCTION_TABLE[h](b);HEAP[d]=h}else{h=HEAP[h+8];b=unSign(b,16)-258;HEAP[d]=HEAP[h+4*b]}}else{if(c!=163840)break a;h=a+4;if(HEAP[a]==0){b=_load_post_names(e);if(b!=0)break a}b=unSign(HEAP[h],16);k=g;if(!(unSign(b,32)>unSign(k,32)))break a;g=reSign(HEAP[HEAP[h+4]+g],8)+g;h=FUNCTION_TABLE[HEAP[f+16]](g);HEAP[d]=h}while(0);e=0}}}return e}_tt_face_get_ps_name.__index__=Runtime.getFunctionIndex(_tt_face_get_ps_name,"_tt_face_get_ps_name");
function _tt_face_find_bdf_prop(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c=null,f,h,i,k,j,l,m,o;l=e+792;m=HEAP[e+88];k=0;HEAP[d]=0;c=HEAP[l+20]==0;a:do if(c){k=HEAP[e+104];c=e;e=k;k=c+792;_llvm_memset_p0i8_i32(k,0,24,1,0);f=_tt_face_goto_table(c,1111770656,e,b);c=f!=0;b:do if(!c){if(unSign(HEAP[b],32)<=unSign(7,32))break b;i=k;f=HEAP[b];c=e;f=f;i=i;f=_FT_Stream_EnterFrame(c,f);if(f==0){HEAP[i]=HEAP[c+32];HEAP[c+32]=0;HEAP[c+36]=0;f=c=f;if(c!=0)break b;HEAP[k+4]=HEAP[k]+HEAP[b];
i=HEAP[k];i+=2;c=unSign(HEAP[i+-2],8)<<8&65535;j=unSign(HEAP[i+-2+1],8);j=unSign(c|j,16);i+=2;c=unSign(HEAP[i+-2],8)<<8&65535;var n=unSign(HEAP[i+-2+1],8);c=unSign(c|n,16);i+=4;n=unSign(HEAP[i+-4],8)<<24;var p=unSign(HEAP[i+-4+1],8)<<16,r=unSign(HEAP[i+-4+2],8)<<8;i=unSign(HEAP[i+-4+3],8);i=p|n|r|i;j=j!=1;c:do if(!j){if(unSign(i,32)<=unSign(7,32))break c;j=Math.floor(unSign(i-8,32)/unSign(4,32));n=c;if(unSign(j,32)<unSign(n,32))break c;j=HEAP[b];if(unSign(i+1,32)>unSign(j,32))break c;HEAP[k+16]=c;
HEAP[k+8]=HEAP[k]+i;HEAP[k+12]=HEAP[b]-i;c=HEAP[k+16];i=HEAP[k]+8;n=c;j=i+n*4;if(n!=0){j=j;n=c;for(c=8;;){q=c==8?0:q;h=c==8?j:h;c=unSign(HEAP[i+2],8)<<8&65535;p=unSign(HEAP[i+2+1],8);c=unSign(c|p,16)*10;h=h+c;i+=4;var q=q+1;if(q!=n)c=9;else break}j=h}if(HEAP[k+8]<j)break c;HEAP[k+20]=1;k=e=f;a=e!=0?18:19;break a}while(0);h=k;e=q=e;h=h;q=q!=0;c:do if(q){if(HEAP[e+20]==0)break c;c=HEAP[e+28];f=HEAP[h];c=c;f=f;f!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[h]=0}while(0);HEAP[h]=0;_llvm_memset_p0i8_i32(k,
0,24,1,0)}break b}while(0);k=8;a=18;break a}else a=19;while(0);a:do if(a==19){c=HEAP[l+16];e=HEAP[l]+8;i=e+c*4;k=6;if(m==0)break a;if(g==0)break a;f=_strlen(g);if(f==0)break a;h=c;q=m+12+2;i=i;j=c+-1;c=22;b:for(;;){n=c==22?0:v;var s=c==22?i:t;p=j+n*-1;if((c==22?h:p)==0){a=28;break b}e+=2;var u=unSign(HEAP[e+-2],8)<<8&65535;c=unSign(HEAP[e+-2+1],8);c=unSign(u|c,16);e+=2;u=unSign(HEAP[e+-2],8)<<8&65535;p=unSign(HEAP[e+-2+1],8);u=unSign(u|p,16);if(unSign(HEAP[q],16)==c){a=23;break b}var t=s+u*10,v=n+
1;c=24;a=26}if(a!=28)if(a==23){i=s;c=u;e=i;h=l+12;q=l+12;f=f;i=l+12;j=l+8;n=g;p=l+12;r=l+12;var w=l+8,x=o,y=c+-1;c=23;b:for(;;){a=c==31?H:0;var A=c==31?G:x,z=y+a*-1;if((c==31?z:u)==0){a=40;break b}c=unSign(HEAP[e+4],8)<<8&65535;z=unSign(HEAP[e+4+1],8);z=unSign(c|z,16);var C=(z&16)!=0;c:do if(C){var B=unSign(HEAP[e],8)<<24;c=unSign(HEAP[e+1],8)<<16;var D=unSign(HEAP[e+2],8)<<8,E=unSign(HEAP[e+3],8);c=c|B|D|E;B=unSign(HEAP[e+6],8)<<24;D=unSign(HEAP[e+6+1],8)<<16;E=unSign(HEAP[e+6+2],8)<<8;var F=unSign(HEAP[e+
6+3],8);B=D|B|E|F;if(!(unSign(HEAP[h],32)>unSign(c,32))){c=29;break c}if(!(unSign(HEAP[q]-c,32)>unSign(f,32))){c=30;break c}if(_strncmp(n,HEAP[j]+c,HEAP[i]-c)!=0){c=32;break c}c=z&15;if(c!=0)if(c!=1)if(c==2){a=41;break b}else if(c==3){a=42;break b}else{c=33;break c}if(!(unSign(HEAP[p],32)>unSign(B,32))){c=34;break c}if(_memchr(HEAP[w]+B,0,HEAP[r])!=0){a=36;break b}else c=35}else c=39;while(0);var G=c==34?B:c==35?B:c==33?B:c==32?B:c==30?B:c==29?B:A;e+=10;var H=a+1;c=31;a=25}if(a==40)o=A;else if(a==
41){o=B;HEAP[d]=2;HEAP[d+4]=o;k=0}else if(a==42){o=B;HEAP[d]=3;HEAP[d+4]=o;k=0}else if(a==36){o=B;HEAP[d]=1;HEAP[d+4]=HEAP[l+8]+o;k=0}}}while(0);g=k;STACKTOP=b;return g}_tt_face_find_bdf_prop.__index__=Runtime.getFunctionIndex(_tt_face_find_bdf_prop,"_tt_face_find_bdf_prop");
function _af_sort_pos(e,g){var d=null;if(unSign(1,32)<unSign(e,32)){var b=(unSign(e,32)>unSign(2,32)?e:2)-1;d=0;a:for(;;){o=d==0?0:o;var a=0+o,c=1+o;for(d=1;;){d=d==5?m:0;var f=d*-1,h=a+f,i=g+4*h,k=g+4*h,j=c+f,l=g+4*j;f=g+4*j;if(j==0)break;h=HEAP[g+4*h];if(reSign(HEAP[g+4*j],32)>reSign(h,32))break;m=HEAP[l];HEAP[f]=HEAP[i];HEAP[k]=m;var m=d+1;d=5}var o=o+1;if(o!=b)d=4;else break a}}}_af_sort_pos.__index__=Runtime.getFunctionIndex(_af_sort_pos,"_af_sort_pos");
function _af_face_globals_free(e){var g=null,d,b,a=e!=0;a:do if(a){d=HEAP[HEAP[e]+100];var c=b=e,f=e,h=d,i=e;for(g=0;;){o=g==0?0:o;var k=0+o,j=_af_script_classes+k*4,l=c+12+k*4,m=f+12+k*4;g=i+12+k*4;if(HEAP[b+12+k*4]!=0){k=HEAP[j];HEAP[k+20]!=0&&FUNCTION_TABLE[HEAP[k+20]](HEAP[l]);l=HEAP[m];l!=0&&FUNCTION_TABLE[HEAP[h+8]](h,l);HEAP[g]=0}var o=o+1;if(o!=4)g=6;else break}HEAP[e+4]=0;HEAP[e+8]=0;HEAP[e]=0;b=e;d=d;b=b;if(b==0)break a;FUNCTION_TABLE[HEAP[d+8]](d,b)}while(0)}
_af_face_globals_free.__index__=Runtime.getFunctionIndex(_af_face_globals_free,"_af_face_globals_free");
function _af_axis_hints_new_edge(e,g,d,b,a){var c=STACKTOP;STACKTOP+=4;Runtime.memset(c,0,4);var f,h=null,i,k;i=HEAP[c]=0;k=HEAP[e+16];k=reSign(HEAP[e+12],32)>=reSign(k,32);a:do if(k){k=h=HEAP[e+16];if(reSign(h,32)>=reSign(44739242,32)){HEAP[c]=64;f=0}else{f=reSign(k,32)>>reSign(2,32);k=k+4+f;f=h;var j=reSign(k,32)<reSign(f,32);b:do if(j)f=1;else{f=reSign(k,32)>reSign(44739242,32)?1:2;break b}while(0);if(f==1)k=44739242;b=_ft_mem_realloc(b,48,h,k,HEAP[e+20],c);HEAP[e+20]=b;if(HEAP[c]!=0){f=0;break a}HEAP[e+
16]=k;f=5}break a}else f=5;while(0);if(f==5){b=HEAP[e+20];i=b+48*HEAP[e+12];k=e+24;i=i;for(h=5;;){o=h==10?o:0;f=o*-1;var l=i+48*f;h=l;j=f=j=i+48*(f+-1);if(!(l>b))break;var m=reSign(HEAP[j],16);if(reSign(m,32)<reSign(g,32))break;if(reSign(HEAP[j],16)==g)if(HEAP[k]==d)break;_llvm_memcpy_p0i8_p0i8_i32(h,f,48,1,0);var o=o+1;h=10}i=l;HEAP[e+12]+=1;_llvm_memset_p0i8_i32(i,0,48,1,0);HEAP[i]=g&65535;HEAP[i+13]=d&255}HEAP[a]=i;e=HEAP[c];STACKTOP=c;return e}
_af_axis_hints_new_edge.__index__=Runtime.getFunctionIndex(_af_axis_hints_new_edge,"_af_axis_hints_new_edge");function _af_glyph_hints_dump_points(){}_af_glyph_hints_dump_points.__index__=Runtime.getFunctionIndex(_af_glyph_hints_dump_points,"_af_glyph_hints_dump_points");function _af_glyph_hints_dump_segments(){}_af_glyph_hints_dump_segments.__index__=Runtime.getFunctionIndex(_af_glyph_hints_dump_segments,"_af_glyph_hints_dump_segments");function _af_glyph_hints_dump_edges(){}
_af_glyph_hints_dump_edges.__index__=Runtime.getFunctionIndex(_af_glyph_hints_dump_edges,"_af_glyph_hints_dump_edges");function _af_direction_compute(e,g){var d,b,a;a=reSign(g,32)>=reSign(e,32);b=reSign(0-e,32)<=reSign(g,32);if(a)if(b){a=2;d=g;b=e}else{a=-1;d=0-e;b=g}else if(b){a=1;d=e;b=g}else{a=-2;d=g;b=e}b*=14;d=d;var c=0-d;d=reSign(d,32)>=reSign(0,32)?d:c;b=b;c=0-b;b=reSign(b,32)>=reSign(0,32)?b:c;if(reSign(d,32)<=reSign(b,32))a=4;return a}
_af_direction_compute.__index__=Runtime.getFunctionIndex(_af_direction_compute,"_af_direction_compute");
function _af_glyph_hints_done(e){var g=null,d,b,a,c=e!=0;a:do if(c){if(HEAP[e]==0)break a;d=HEAP[e];a=e;var f=b=d;for(g=0;;){m=g==0?0:m;var h=0+m,i=a+48+h*28+8,k=a+48+h*28+12,j=a+48+h*28+16;g=a+48+h*28+20;var l=a+48+h*28+4;HEAP[a+48+h*28]=0;HEAP[l]=0;h=HEAP[i];h!=0&&FUNCTION_TABLE[HEAP[b+8]](b,h);HEAP[i]=0;HEAP[k]=0;HEAP[j]=0;i=HEAP[g];i!=0&&FUNCTION_TABLE[HEAP[f+8]](f,i);HEAP[g]=0;var m=m+1;if(m!=2)g=5;else break}b=HEAP[e+44];a=d;b=b;b!=0&&FUNCTION_TABLE[HEAP[a+8]](a,b);HEAP[e+44]=0;HEAP[e+36]=0;
HEAP[e+40]=0;a=HEAP[e+32];d=d;b=a;a!=0&&FUNCTION_TABLE[HEAP[d+8]](d,b);HEAP[e+32]=0;HEAP[e+28]=0;HEAP[e+24]=0;HEAP[e]=0}while(0)}_af_glyph_hints_done.__index__=Runtime.getFunctionIndex(_af_glyph_hints_done,"_af_glyph_hints_done");
function _af_glyph_hints_reload(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a=null,c,f,h,i,k,j,l,m,o,n,p,r,q;HEAP[d]=0;h=HEAP[e+4];i=HEAP[e+12];k=HEAP[e+8];j=HEAP[e+16];l=HEAP[e];HEAP[e+28]=0;HEAP[e+40]=0;HEAP[e+48]=0;HEAP[e+48+12]=0;HEAP[e+48+28]=0;HEAP[e+48+28+12]=0;f=reSign(HEAP[g],16);m=c=HEAP[e+36];m=unSign(f,32)>unSign(m,32);a:do if(m){f=f+3&-4;c=_ft_mem_realloc(l,4,c,f,HEAP[e+44],d);HEAP[e+44]=c;if(HEAP[d]!=0){b=0;break a}HEAP[e+36]=f;b=2;break a}else b=2;while(0);a:do if(b==
2){f=reSign(HEAP[g+2],16)+2;m=c=HEAP[e+24];if(unSign(f,32)>unSign(m,32)){f=f+9&-8;c=_ft_mem_realloc(l,40,c,f,HEAP[e+32],d);HEAP[e+32]=c;if(HEAP[d]!=0)break a;HEAP[e+24]=f}f=reSign(HEAP[g+2],16);HEAP[e+28]=f;f=reSign(HEAP[g],16);HEAP[e+40]=f;HEAP[e+48+24]=2;HEAP[e+48+28+24]=-1;if(_FT_Outline_Get_Orientation(g)==1){HEAP[e+48+24]=-2;HEAP[e+48+28+24]=1}HEAP[e+4]=h;HEAP[e+12]=i;HEAP[e+8]=k;HEAP[e+16]=j;HEAP[e+116]=0;HEAP[e+120]=0;c=HEAP[e+32];if(HEAP[e+28]==0)break a;m=c+40*HEAP[e+28];o=HEAP[g+4];n=HEAP[g+
8];f=reSign(HEAP[HEAP[g+12]],16);p=a=c+40*f;f=c;if(f<m){q=h;r=k;var s=i,u=j,t=g,v=g+12,w=c,x=m;o=o;n=n;p=p;var y=a;a=7;b:for(;;){F=a==7?0:F;B=a==7?0:B;D=a==7?y:D;E=a==7?p:E;b=n+F;var A=o+8*F;a=o+8*F+4;HEAP[f+12]=HEAP[A]&65535;HEAP[f+14]=HEAP[a]&65535;A=_FT_MulFix(HEAP[A],q);HEAP[f+16]=r+A;HEAP[f+4]=HEAP[f+16];a=_FT_MulFix(HEAP[a],s);HEAP[f+20]=u+a;HEAP[f+8]=HEAP[f+20];b=reSign(HEAP[b],8)&3;b=b==0?30:b==2?31:32;if(b==32)HEAP[f]=0;else if(b==30)HEAP[f]=1;else if(b==31)HEAP[f]=2;HEAP[f+36]=E;E=HEAP[E+
32]=f;b=f==D;c:do if(b){var z=B+1;a=reSign(HEAP[t],16);if(!(reSign(z,32)<reSign(a,32))){a=10;break c}var C=reSign(HEAP[HEAP[v]+2*z],16);C=w+40*C;a=11}else a=38;while(0);var B=a==11?z:a==10?z:B,D=a==11?C:a==10?D:D,E=a==11?C:a==10?E:E;f+=40;var F=F+1;if(f<x){a=12;b=8}else{b=14;break b}}}r=HEAP[e+44];q=r+4*HEAP[e+40];a=HEAP[g+12];if(r<q){f=c;q=q;r=r;s=a;for(a=16;;){H=a==16?0:H;u=s+2*H;b=r+4*(H+1);t=r+4*H;G=reSign(a==16?0:G,16);HEAP[t]=f+40*G;var G=HEAP[u]+1,H=H+1;if(b<q)b=a=17;else{b=18;break}}}f=a=
c;if(!(f<m))break a;c=m;m=a;a=20;b:for(;;){M=a==20?4:M;O=a==20?0:O;K=a==20?0:K;P=a==20?m:P;if(f==P){var J=HEAP[P+36],L=reSign(HEAP[P+12],16),N=reSign(HEAP[J+12],16);L=L-N;N=reSign(HEAP[P+14],16);var I=reSign(HEAP[J+14],16);N=N-I;I=_af_direction_compute(L,N);J=J+40;a=22}else a=21;q=a==22?N:O;r=a==22?L:K;var P=a==22?J:P;HEAP[f+2]=(a==22?I:M)&255;O=HEAP[f+32];K=reSign(HEAP[O+12],16);M=reSign(HEAP[f+12],16);var K=K-M;O=reSign(HEAP[O+14],16);M=reSign(HEAP[f+14],16);var O=O-M,M=_af_direction_compute(K,
O);HEAP[f+3]=M&255;a=(unSign(HEAP[f],16)&3)!=0;c:do if(a)b=25;else{b=f;if(HEAP[f+3]==HEAP[f+2]){if(HEAP[b+3]!=4){b=25;break c}b=_ft_corner_is_flat(r,q,K,O)!=0?25:27}else{b=reSign(HEAP[b+2],8);a=0-reSign(HEAP[f+3],8);b=b==a?25:27}break c}while(0);if(b==25)HEAP[f]|=256;f+=40;if(f<c){a=27;b=21}else{b=28;break b}}}while(0);h=HEAP[d];STACKTOP=d;return h}_af_glyph_hints_reload.__index__=Runtime.getFunctionIndex(_af_glyph_hints_reload,"_af_glyph_hints_reload");
function _af_glyph_hints_save(e,g){var d=null,b,a,c,f;b=HEAP[e+32];a=b+40*HEAP[e+28];c=HEAP[g+4];f=HEAP[g+8];if(b<a)for(d=0;;){l=d==0?0:l;var h=f+l,i=c+8*l+4,k=b+40*l+20,j=b+40*l;d=b+40*(l+1);HEAP[c+8*l]=HEAP[b+40*l+16];HEAP[i]=HEAP[k];if((unSign(HEAP[j],16)&1&255)!=0)HEAP[h]=0;else{i=(unSign(HEAP[j],16)&2)!=0;HEAP[h]=i?2:1}var l=l+1;if(d<a)d=3;else break}}_af_glyph_hints_save.__index__=Runtime.getFunctionIndex(_af_glyph_hints_save,"_af_glyph_hints_save");
function _af_glyph_hints_align_strong_points(e,g){var d,b=null,a,c,f,h,i,k;a=HEAP[e+32];c=a+40*HEAP[e+28];f=e+48+g*28;h=HEAP[f+20];f=h+48*HEAP[f+12];i=g==0?64:128;var j=h<f;a:do if(j){k=a;if(!(k<c))break a;var l=i,m=c,o=g==1,n=h,p=g==0,r=i&65535,q=f+-48,s=Math.floor(reSign(f-h,32)/reSign(48,32)),u=h,t=h,v=h,w=h,x=h,y=h;k=k;var A=reSign(s,32)<=reSign(8,32);b=1;b:for(;;){$=b==1?0:$;var z=k+40*$,C=k+40*$+14,B=k+40*$+12,D=k+40*$+8,E=k+40*$+4,F=k+40*$+16,G=k+40*$+20,H=k+40*($+1),J=(unSign(HEAP[z],16)&
l)!=0;c:do if(!J){if((unSign(HEAP[z],16)&256)!=0)if((unSign(HEAP[z],16)&512)==0)break c;if(o){var L=reSign(HEAP[C],16),N=HEAP[D];b=7}else{var I=reSign(HEAP[B],16),P=HEAP[E];b=9}var K=b==9?P:N,O=b==9?I:L,M=reSign(HEAP[n],16)-O;M=reSign(M,32)>=reSign(0,32);d:do if(M){var Q=0-HEAP[n+4]+HEAP[n+8]+(0-(0-K));b=10}else{b=reSign(HEAP[q],16);if(reSign(O-b,32)>=reSign(0,32)){var R=0-HEAP[q+4]+HEAP[q+8]+K;b=12}else{if(A){b=13;d=14}else{b=13;d=15}e:for(;;)if(d==14){var T=b==17?V:0;d=u+48*T;if(!(reSign(T,32)<
reSign(s,32))){d=16;break e}d=reSign(HEAP[d],16);if(reSign(d,32)>=reSign(O,32)){d=16;break e}var V=T+1;b=17;d=14}else if(d==15){var U=b==13?s:b==24?U:X,S=b==13?0:b==24?W:S;if(!(reSign(S,32)<reSign(U,32))){b=15;d=20;break e}var X=reSign(S+U,32)>>reSign(1,32),Y=y+48*X;d=reSign(HEAP[Y],16);if(reSign(O,32)<reSign(d,32)){b=22;d=15;continue e}else b=22;if(!(reSign(O,32)>reSign(d,32))){d=25;break e}var W=X+1;b=24;d=15}e:do if(d==16){if(reSign(HEAP[t+48*T],16)!=O){b=16;break e}var da=HEAP[v+48*T+8];b=19;
break d}else if(d==25){var ba=HEAP[Y+8];b=25;break d}while(0);b=b==16?T:S;var aa=w+48*b+-48;b=x+48*b;if(HEAP[aa+16]==0){d=reSign(HEAP[b],16);var ca=reSign(HEAP[aa],16);b=_FT_DivFix(HEAP[b+8]-HEAP[aa+8],d-ca);HEAP[aa+16]=b}b=HEAP[aa+8];d=HEAP[aa+16];aa=reSign(HEAP[aa],16);aa=_FT_MulFix(O-aa,d)+b;b=27}}while(0);K=b==27?aa:b==25?ba:b==19?da:b==12?R:Q;if(p)HEAP[F]=K;else HEAP[G]=K;HEAP[z]=r|HEAP[z]}while(0);var $=$+1;if(H<m)b=5;else break b}}while(0)}
_af_glyph_hints_align_strong_points.__index__=Runtime.getFunctionIndex(_af_glyph_hints_align_strong_points,"_af_glyph_hints_align_strong_points");
function _af_iup_interp(e,g,d,b){var a=null,c,f,h,i;c=HEAP[d+28];f=HEAP[b+28];h=HEAP[d+24]-c;i=HEAP[b+24]-f;var k=e>g;a:do if(!k)if(c==f){a=e;if(!(a<=g))break a;var j=c,l=h,m=g,o=i,n=a;for(a=0;;){s=a==0?0:s;var p=n+40*(s+1),r=n+40*s+24;a=HEAP[n+40*s+28];var q=reSign(a,32)<=reSign(j,32);a=a;a=q?l+a:o+a;HEAP[r]=a;var s=s+1;if(p<=m)a=4;else break}}else{a=f;j=reSign(c,32)<reSign(a,32);a=e;l=a<=g;if(j){if(!l)break a;j=c;l=h;m=g;o=f;n=i;p=d+24;r=f-c;q=b+24;var u=d+24,t=c,v=a;for(a=6;;){z=a==6?0:z;var w=
v+40*(z+1),x=v+40*z+24;a=HEAP[v+40*z+28];var y=reSign(a,32)<=reSign(j,32),A=a;if(y)a=l+A;else if(reSign(A,32)>=reSign(o,32))a=n+a;else{y=HEAP[p];a=_FT_MulDiv(a-t,HEAP[q]-HEAP[u],r)+y}HEAP[x]=a;var z=z+1;if(w<=m)a=10;else break}}else{if(!l)break a;j=f;l=i;m=g;o=c;n=h;p=d+24;r=f-c;q=b+24;u=d+24;t=c;v=a;for(a=7;;){C=a==7?0:C;w=v+40*(C+1);x=v+40*C+24;a=HEAP[v+40*C+28];y=reSign(a,32)<=reSign(j,32);A=a;if(y)a=l+A;else if(reSign(A,32)>=reSign(o,32))a=n+a;else{y=HEAP[p];a=_FT_MulDiv(a-t,HEAP[q]-HEAP[u],r)+
y}HEAP[x]=a;var C=C+1;if(w<=m)a=14;else break}}}while(0)}_af_iup_interp.__index__=Runtime.getFunctionIndex(_af_iup_interp,"_af_iup_interp");
function _af_glyph_hints_align_weak_points(e,g){var d,b=null,a,c,f,h,i,k;a=HEAP[e+32];c=a+40*HEAP[e+28];f=HEAP[e+44];h=f+4*HEAP[e+40];var j=g==0;a:do if(j){i=64;k=a;if(!(k<c)){d=1;break a}for(var l=c;;){HEAP[k+24]=HEAP[k+16];HEAP[k+28]=HEAP[k+4];k+=40;if(k<l)d=2;else{d=1;break a}}}else{i=128;k=a;if(!(k<c)){d=1;break a}for(l=c;;){HEAP[k+24]=HEAP[k+20];HEAP[k+28]=HEAP[k+8];k+=40;if(k<l)d=4;else{d=1;break a}}}while(0);if(f<h){i=l=j=i;b=5;a:for(;;){var m=b==5?0:q,o=f+4*(m+1);k=HEAP[f+4*m];var n=HEAP[k+
36],p=k;b:for(;;){if(k>n){b=7;d=8;break b}else b=7;d=(unSign(HEAP[k],16)&j)!=0;var r=k;if(d){d=10;break b}k=r+40;d=7}b:for(;;)if(d==8){var q=m+1;if(o<h){b=8;d=6;continue a}else break a}else if(d==10){var s=k>=n;c:do if(!s){if((unSign(HEAP[k+40],16)&i)==0){d=13;break c}k+=40;d=10;continue b}while(0);s=k;k+=40;c:for(;;){if(k>n){d=15;break c}d=(unSign(HEAP[k],16)&l)!=0;var u=k;if(d){d=17;break c}k=u+40;d=14}if(d==15)if(s==r){s=HEAP[r+24]-HEAP[r+28];if(s==0){b=19;d=8;continue b}if(p<r){b=20;d=21}else{b=
20;d=22}c:for(;;)if(d==21){t=b==21?t:0;d=p+40*(t+1);HEAP[p+40*t+24]=HEAP[p+40*t+28]+s;var t=t+1;if(d<r)d=b=21;else{b=21;d=22}}else if(d==22)if(r+40<=n){b=22;d=23;break c}else{b=22;d=8;continue b}for(;;){v=b==23?v:0;d=r+40*(v+2);b=v+1;HEAP[r+40*b+24]=HEAP[r+40*b+28]+s;var v=v+1;if(d<=n)d=b=23;else{b=23;d=8;continue b}}}else{s<n&&_af_iup_interp(s+40,n,s,r);if(!(r>a)){b=25;d=8;continue b}_af_iup_interp(p,r+-40,s,r);b=26;d=8}else if(d==17){_af_iup_interp(s+40,u+-40,s,k);d=10}}}}f=g==0;k=a;a=k<c;a:do if(f){if(!a)break a;
for(h=c;;){HEAP[k+16]=HEAP[k+24];k+=40;if(!(k<h))break a}}else{if(!a)break a;for(h=c;;){HEAP[k+20]=HEAP[k+24];k+=40;if(!(k<h))break a}}while(0)}_af_glyph_hints_align_weak_points.__index__=Runtime.getFunctionIndex(_af_glyph_hints_align_weak_points,"_af_glyph_hints_align_weak_points");function _af_dummy_hints_init(e,g){HEAP[e+112]=g;HEAP[e+104]=HEAP[g+4+24];return 0}_af_dummy_hints_init.__index__=Runtime.getFunctionIndex(_af_dummy_hints_init,"_af_dummy_hints_init");
function _af_dummy_hints_apply(){return 0}_af_dummy_hints_apply.__index__=Runtime.getFunctionIndex(_af_dummy_hints_apply,"_af_dummy_hints_apply");
function _af_latin_metrics_init_widths(e,g,d){var b=STACKTOP;STACKTOP+=968;Runtime.memset(b,0,968);var a=null,c,f,h,i,k,j,l=b+12,m=b+136,o,n,p,r;j=HEAP[g+100];_llvm_memset_p0i8_i32(l,0,124,1,0);HEAP[l]=j;HEAP[e+40+8]=0;HEAP[e+40+396+8]=0;j=m+4;i=0;var q=g!=0;a:do if(q){if(HEAP[g+92]!=0){k=HEAP[g+92];i=k=FUNCTION_TABLE[HEAP[HEAP[k+12]+12]](k,d);a=1}else{var s=i;a=3}f=h=a==3?s:k;if(h==0)break a;a=_FT_Load_Glyph(g,f,1);if(a!=0)break a;if(reSign(HEAP[HEAP[g+84]+108+2],16)<=reSign(0,16))break a;_llvm_memset_p0i8_i32(m,
0,832,1,0);HEAP[m+36]=HEAP[e+36];HEAP[j+8]=65536;HEAP[j+4]=HEAP[j+8];HEAP[j+16]=0;HEAP[j+12]=HEAP[j+16];HEAP[j]=g;HEAP[j+20]=0;HEAP[j+24]=0;h=m;f=l;h=h;HEAP[f+112]=h;HEAP[f+104]=HEAP[h+4+24];a=_af_glyph_hints_reload(l,HEAP[g+84]+108);if(a!=0)break a;f=0;h=l+48;var u=l,t=l,v=b,w=b+4,x=b+8,y=b+4,A=b+8;a=8;for(;;){if(!(reSign(a==28?o:0,32)<=reSign(1,32)))break a;o=e+40+f*396;n=h+f*28;r=0;a=_af_latin_hints_compute_segments(u,f);if(a!=0)break a;_af_latin_hints_link_segments(t,f);a=HEAP[n+8];p=a+52*HEAP[n];
if(a<p){n=o+12;p=p;var z=a;r=r;a=11;c:for(;;){J=a==11?0:J;H=a==11?r:H;var C=z+52*J;c=z+52*J+2;var B=z+52*(J+1),D=HEAP[z+52*J+20],E=D!=0;d:do if(E){if(!(HEAP[D+20]==C&D>C)){a=13;break d}a=reSign(HEAP[c],16);var F=reSign(HEAP[D+2],16);a=a-F;F=0-a;a=reSign(a,32)<reSign(0,32)?F:a;if(!(unSign(H,32)<=unSign(15,32))){a=14;break d}HEAP[n+H*12]=a;var G=H+1;a=16}else a=12;while(0);var H=a==16?G:a==14?H:a==13?H:H,J=J+1;if(B<p)a=15;else break c}r=H}n=o+12;a=r;c=n;n=a;if(unSign(1,32)<unSign(n,32)){c=C=B=z=p=n=
c;a=a;D=HEAP[v];unSign(a,32);unSign(2,32);E=(unSign(a,32)>unSign(2,32)?a:2)-1;a=20;c:for(;;){ca=a==20?0:ca;F=a==20?D:P;var L=0+ca,N=1+ca;for(a=21;;){var I=a==25?aa:0,P=a==25?ba:F,K=I*-1,O=L+K;a=C+12*O;var M=c+12*O;K=N+K;var Q=z+12*K,R=z+12*K+4,T=z+12*K+8,V=C+12*K+-8,U=C+12*K+-4,S=B+12*K,X=B+12*K+4,Y=B+12*K+8,W=c+12*K+-8,da=c+12*K+-4;if(K==0)break;O=HEAP[p+12*O];if(reSign(HEAP[n+12*K],32)>reSign(O,32))break;var ba=HEAP[Q];HEAP[w]=HEAP[R];HEAP[x]=HEAP[T];HEAP[S]=HEAP[a];HEAP[X]=HEAP[V];HEAP[Y]=HEAP[U];
HEAP[M]=ba;HEAP[W]=HEAP[y];HEAP[da]=HEAP[A];var aa=I+1;a=25}var ca=ca+1;if(ca!=E)a=24;else break c}HEAP[v]=P}HEAP[o+8]=r;f=o=f+1;a=28}}while(0);f=0;g=e+36;d=f;m=2-d;for(a=4;;){ga=a==4?0:ga;ba=d+ga;aa=e+40+ba*396+12;s=e+40+ba*396+204;G=e+40+ba*396+208;P=e+40+ba*396+212;if(HEAP[e+40+ba*396+8]!=0){var $=HEAP[aa];a=31}else{var la=Math.floor(reSign(HEAP[g]*50,32)/reSign(2048,32));a=33}ba=a==33?la:$;aa=Math.floor(reSign(ba,32)/reSign(5,32));HEAP[s]=aa;HEAP[G]=ba;HEAP[P]=0;var ga=ga+1;if(ga!=m)a=34;else break}_af_glyph_hints_done(l);
STACKTOP=b}_af_latin_metrics_init_widths.__index__=Runtime.getFunctionIndex(_af_latin_metrics_init_widths,"_af_latin_metrics_init_widths");
function _af_latin_metrics_check_digits(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a=null,c;c=1;var f=g!=0;a=-1;a:for(;;){b=a==5?l:0;k=a==5?k:0;j=a==5?j:0;l=48+b;var h=49+b;if(!(unSign(a==5?h:48,32)<=unSign(57,32))){b=12;break a}b:do if(f)if(HEAP[g+92]!=0){a=HEAP[g+92];a=FUNCTION_TABLE[HEAP[HEAP[a+12]+12]](a,l);if(a==0){a=4;break b}if(_FT_Get_Advance(g,a,2051,d)!=0){a=6;break b}var i=HEAP[d];if(k==0){a=7;break b}if(i!=j){b=9;break a}else a=8}else a=3;else a=1;while(0);var k=a==1?
k:a==8?k:a==6?k:a==4?k:a==3?k:1,j=a==1?j:a==8?j:a==6?j:a==4?j:a==3?j:i,l=b+1;a=5;b=0}if(b==9)c=0;HEAP[e+32]=c;STACKTOP=d}_af_latin_metrics_check_digits.__index__=Runtime.getFunctionIndex(_af_latin_metrics_check_digits,"_af_latin_metrics_check_digits");
function _af_latin_metrics_init(e,g){var d=STACKTOP;STACKTOP+=96;Runtime.memset(d,0,96);var b,a=null,c=d+48,f,h,i,k;i=0;k=HEAP[g+92];var j=unSign(HEAP[g+68],16);HEAP[e+36]=j;i=i;a=-1;a:for(;;){o=a==2?o:0;var l=a==2?m:i;m=_latin_encodings_4600+(0+o)*4;if(HEAP[m]==0){b=4;break a}var m=_FT_Select_Charmap(g,HEAP[m]);if(m==0){b=1;break a}var o=o+1;a=2;b=0}a:do if(b==1){b=5;break a}else if(b==4){i=l;b=i==0?5:6;break a}while(0);if(b==5){_af_latin_metrics_init_widths(e,g,111);f=e+40+396;h=HEAP[g+84];l=h+
108+2;m=h+108+4;i=h+108;o=h+108+12;j=h+108;var n=h+108+8;h=h+108+8;var p=g!=0,r=g+92,q=g+92,s=f+216,u=f+220,t=f+216;f=f+216;var v=(reSign(1,32)>reSign(6,32)?1:6)-0;a=5;a:for(;;){ga=a==63?ga:0;var w=0+ga,x=_af_latin_blue_chars+w*13+12;a=7;b:for(;;){var y=a==13?la:0,A=a==13?ca:0,z=a==13?$:0;a=_af_latin_blue_chars+w*13+y;if(a>=x)break b;if(HEAP[a]==0)break b;ca=reSign(HEAP[a],8);c:do if(p)if(HEAP[r]!=0){a=HEAP[q];a=FUNCTION_TABLE[HEAP[HEAP[a+12]+12]](a,ca);if(a==0){a=12;break c}if(_FT_Load_Glyph(g,a,
1)!=0){a=14;break c}if(reSign(HEAP[l],16)<=reSign(0,16)){a=15;break c}$=HEAP[m];a=reSign(HEAP[i],16);b=reSign(a,32)>reSign(0,32);d:do if(b){la=HEAP[o];var C=HEAP[j],B=reSign(C,16);a=17;e:for(;;){T=a==17?0:T;V=a==17?0:V;var D=a==17?0:X;Y=a==17?0:Y;U=a==17?0:U;S=a==17?-1:S;var E=HEAP[la+2*Y];X=reSign(E,16);var F=reSign(X,32)<=reSign(D,32);f:do if(F)a=18;else{a=18;var G=reSign(D,32)<=reSign(X,32);b=w==0?22:w==2?22:w==3?22:19;if(b==19){if(!G){a=19;break f}reSign(E,16);var H=reSign(E,16)+1-D;a=20;g:for(;;){K=
a==20?0:K;P=a==20?U:P;I=a==20?S:I;var J=D+K;G=$+8*J+4;var L=reSign(I,32)<reSign(0,32);h:do if(L)b=32;else{if(reSign(HEAP[G],32)<reSign(P,32)){a=31;b=32}else{a=31;b=33}break h}while(0);if(b==32){var N=HEAP[G];a=32}var I=a==32?J:I,P=a==32?N:P,K=K+1;if(K!=H)a=33;else break g}a=35}else if(b==22){if(!G){a=22;break f}reSign(E,16);H=reSign(E,16)+1-D;a=23;g:for(;;){R=a==23?0:R;Q=a==23?U:Q;M=a==23?S:M;J=D+R;G=$+8*J+4;L=reSign(M,32)<reSign(0,32);h:do if(L)b=26;else{if(reSign(HEAP[G],32)>reSign(Q,32)){a=25;
b=26}else{a=25;b=27}break h}while(0);if(b==26){var O=HEAP[G];a=26}var M=a==26?J:M,Q=a==26?O:Q,R=R+1;if(R!=H)a=27;else break g}a=29}H=a==35?P:Q;J=a==35?I:M;if(J==S){a=37;break f}a=38}while(0);var T=a==38?D:a==37?T:a==18?T:a==22?T:T,V=a==38?X:a==37?V:a==18?V:a==22?V:V,U=a==38?H:a==37?H:a==18?U:a==22?U:U,S=a==38?J:a==37?J:a==18?S:a==22?S:S,X=X+1,Y=Y+1;if(Y!=B)a=21;else break e}reSign(C,16);if(reSign(S,32)>=reSign(0,32))a=40;else{a=40;break d}e:for(;;){W=a==41?W:S;a=W-1;var W=reSign(W,32)>reSign(T,32)?
a:V;b=HEAP[$+8*W+4]-U;a=reSign(b,32)<reSign(-5,32);b=reSign(b,32)>reSign(5,32);if(((a|b)^1)&W!=S)a=41;else break e}a=43;e:for(;;){da=a==43?S:da;a=da+1;var da=reSign(da,32)<reSign(V,32)?a:T;b=HEAP[$+8*da+4]-U;a=reSign(b,32)<reSign(-5,32);b=reSign(b,32)>reSign(5,32);if(((a|b)^1)&da!=S)a=44;else break e}b=(reSign(HEAP[HEAP[n]+W],8)&3)!=1;e:do if(b)a=45;else{if((reSign(HEAP[HEAP[h]+da],8)&3)!=1){a=46;break e}a=48}while(0);if(((a==48?0:a==46?1:1)&255)==0){a=47;break d}HEAP[c+z*4]=U;var ba=z+1;a=50;break c}else a=
16;while(0);HEAP[d+A*4]=a==47?U:a==40?U:0;var aa=A+1;a=42}else a=11;else a=9;while(0);var ca=a==9?A:a==42?aa:a==50?A:a==15?A:a==14?A:a==12?A:A,$=a==9?z:a==42?z:a==50?ba:a==15?z:a==14?z:a==12?z:z,la=y+1;a=13}x=A==0&z==0;b:do if(!x){_af_sort_pos(z,c);_af_sort_pos(A,d);C=y=u+HEAP[s]*28;B=y+12;HEAP[f]=HEAP[t]+1;if(A==0){a=Math.floor(reSign(z,32)/reSign(2,32));HEAP[B]=HEAP[c+a*4];HEAP[C]=HEAP[B]}else{a=z==0;b=Math.floor(reSign(A,32)/reSign(2,32));b=HEAP[d+b*4];if(a){HEAP[B]=b;HEAP[C]=HEAP[B]}else{HEAP[C]=
b;a=Math.floor(reSign(z,32)/reSign(2,32));HEAP[B]=HEAP[c+a*4]}}D=HEAP[B]!=HEAP[C];c:do if(D){E=HEAP[C];F=HEAP[B];a=reSign(F,32)>reSign(E,32);G=unSign(a,1);if(w==0){a=67;b=57}else if(w==2){a=67;b=57}else if(w==3){a=67;b=57}else{a=67;b=55}if(b==55)a=55;a=a==55?0:a==67?1:a==67?1:1;b=unSign(G,8);if(a==b)break c;a=Math.floor(reSign(E+F,32)/reSign(2,32));HEAP[C]=a;HEAP[B]=HEAP[C]}while(0);HEAP[y+24]=0;if(w!=0)if(w!=2)if(w!=3)break b;HEAP[y+24]|=2;if(w!=3)break b;HEAP[y+24]|=4}while(0);var ga=ga+1;if(ga!=
v)a=63;else break a}_af_latin_metrics_check_digits(e,g)}_FT_Set_Charmap(g,k);STACKTOP=d;return 0}_af_latin_metrics_init.__index__=Runtime.getFunctionIndex(_af_latin_metrics_init,"_af_latin_metrics_init");
function _af_latin_metrics_scale_dim(e,g,d){var b,a=null,c,f,h,i,k,j,l;if(d==0){c=HEAP[g+4];f=HEAP[g+12]}else{c=HEAP[g+8];f=HEAP[g+16]}h=e+40+d*396;k=HEAP[h+388]==c;a:do if(k){b=HEAP[h+392]==f?1:2;break a}else b=2;while(0);a:do if(b==2){HEAP[h+388]=c;HEAP[h+392]=f;i=e+40+396;a=k=0;j=HEAP[i+216];var m=i,o=a;a=2;b:for(;;){b=a==5?r:0;var n=o+b,p=m+220+n*28+24;if(!(unSign(j,32)>unSign(n,32))){b=8;break b}if((HEAP[p]&4)!=0){b=4;break b}var r=b+1;a=5;b=3}if(b==8){var q=k;a=8}else if(b==4){var s=i+220+n*
28;k=s;a=4}m=(a==8?q:s)!=0;b:do if(m){i=_FT_MulFix(HEAP[k+12],HEAP[g+8]);j=i+40&-64;if(i==j)break b;if(d!=1)break b;c=_FT_MulDiv(c,j,i)}while(0);HEAP[h]=c;HEAP[h+4]=f;k=e+4;if(d==0){HEAP[k+4]=c;HEAP[e+4+12]=f}else{HEAP[k+8]=c;HEAP[e+4+16]=f}k=a=0;i=unSign(HEAP[h+8],32)>unSign(k,32);k=h;if(i){i=c;j=h+8;var u=h;m=a;o=m+1;for(a=14;;){w=a==14?0:w;p=a==14?k:u;var t=o+w,v=m+w;a=_FT_MulFix(HEAP[p+12+v*12],i);HEAP[p+12+v*12+4]=a;HEAP[p+12+v*12+8]=HEAP[p+12+v*12+4];p=unSign(HEAP[j],32)>unSign(t,32);var w=
w+1;if(p)a=15;else break}a=16}else a=34;k=_FT_MulFix(HEAP[(a==16?u:k)+208],c);k=reSign(k,32)<=reSign(39,32);k=unSign(k,1);HEAP[h+212]=k;if(d!=1)break a;k=a=0;if(!(unSign(HEAP[h+216],32)>unSign(k,32)))break a;k=h;i=c;j=f;m=c;o=f;t=p=c;v=h+216;var x=a,y=x+1;for(a=19;;){E=a==19?0:E;var A=y+E;l=k+220+(x+E)*28;a=_FT_MulFix(HEAP[l],i);HEAP[l+4]=j+a;HEAP[l+8]=HEAP[l+4];a=_FT_MulFix(HEAP[l+12],m);HEAP[l+12+4]=o+a;HEAP[l+12+8]=HEAP[l+12+4];HEAP[l+24]&=-2;var z=_FT_MulFix(HEAP[l]-HEAP[l+12],p);a=reSign(z,32)<=
reSign(48,32);z=reSign(z,32)>=reSign(-48,32);if(a&z){z=HEAP[l+12]-HEAP[l];a=0-z;a=reSign(z,32)<reSign(0,32)?a:z;a=_FT_MulFix(a,t);if(reSign(a,32)<=reSign(31,32))a=36;else if(reSign(a,32)<=reSign(63,32)){var C=(a-16&-32)+32;a=21}else{var B=a+32&-64;a=23}a=a==23?B:a==21?C:0;z=reSign(z,32)<reSign(0,32);var D=0-a;a=z?D:a;HEAP[l+8]=HEAP[l+4]+32&-64;HEAP[l+12+8]=a+HEAP[l+8];HEAP[l+24]|=1}a=unSign(HEAP[v],32)>unSign(A,32);var E=E+1;if(a)a=26;else break}}while(0)}
_af_latin_metrics_scale_dim.__index__=Runtime.getFunctionIndex(_af_latin_metrics_scale_dim,"_af_latin_metrics_scale_dim");function _af_latin_metrics_scale(e,g){HEAP[e+4+20]=HEAP[g+20];HEAP[e+4]=HEAP[g];_af_latin_metrics_scale_dim(e,g,0);_af_latin_metrics_scale_dim(e,g,1)}_af_latin_metrics_scale.__index__=Runtime.getFunctionIndex(_af_latin_metrics_scale,"_af_latin_metrics_scale");
function _af_latin_hints_compute_segments(e,g){var d=STACKTOP;STACKTOP+=60;Runtime.memset(d,0,60);var b,a=null,c,f,h,i=d+4,k=d+8,j,l,m,o,n,p,r,q;c=e+48+g*28;f=HEAP[e];h=0;HEAP[i]=0;j=HEAP[e+44];l=j+4*HEAP[e+40];_llvm_memset_p0i8_i32(k,0,52,1,0);HEAP[k+32]=32E3;HEAP[k]=0;m=HEAP[c+24];o=0-m;o=m=reSign(m,32)>=reSign(0,32)?m:o;HEAP[c]=0;r=g==0;var s=HEAP[e+32];a:do if(r){n=s;p=n+40*HEAP[e+28];if(!(n<p)){b=1;break a}p=p;n=n;for(a=0;;){w=a==0?0:w;b=n+40*(w+1);a=n+40*w+28;var u=n+40*w+14,t=n+40*w+24,v=reSign(HEAP[n+
40*w+12],16);HEAP[t]=v;u=reSign(HEAP[u],16);HEAP[a]=u;var w=w+1;if(b<p)b=a=2;else{b=3;break}}}else{n=s;p=n+40*HEAP[e+28];if(!(n<p)){b=1;break a}p=p;n=n;for(a=5;;){q=a==5?0:q;b=n+40*(q+1);a=n+40*q+28;u=n+40*q+12;t=n+40*q+24;v=reSign(HEAP[n+40*q+14],16);HEAP[t]=v;u=reSign(HEAP[u],16);HEAP[a]=u;q=q+1;if(b<p)b=a=6;else{b=7;break}}}while(0);a=1;a:for(;;){if(!(j<l)){b=40;break a}r=HEAP[j];q=HEAP[r+36];if(r!=q){s=reSign(HEAP[q+3],8);w=0-s;s=(reSign(s,32)>=reSign(0,32)?s:w)==m;b:do if(s){w=reSign(HEAP[r+
3],8);q=0-w;if((reSign(w,32)>=reSign(0,32)?w:q)!=m)break b;q=r;w=m;for(q=q;;){r=HEAP[r+36];var x=reSign(HEAP[r+3],8);b=0-x;b=(reSign(x,32)>=reSign(0,32)?x:b)!=w;x=r;if(b)break;if(x==q)break b}r=HEAP[x+32]}while(0);w=s=q=r;q=m;b=c;p=f;n=j;o=o;a=9;b:for(;;){var y=a==26?F:0;u=a==26?L:32E3;t=a==26?N:-32E3;var A=a==26?I:o;v=a==26?P:0;var z=v!=0;c:do if(z){var C=HEAP[r+24],B=reSign(C,32)<reSign(u,32)?C:u;C=reSign(C,32)>reSign(t,32)?C:t;if(reSign(HEAP[r+3],8)==A)if(r!=s){a=15;break c}HEAP[HEAP[i]+44]=r;
var D=HEAP[i],E=reSign(C+B,32)>>reSign(1,32)&65535;HEAP[D+2]=E;if((unSign(HEAP[r]|HEAP[HEAP[HEAP[i]+40]],16)&3)!=0)HEAP[HEAP[i]]|=1;E=HEAP[r+28];a=HEAP[HEAP[HEAP[i]+40]+28];D=reSign(a,32)<reSign(E,32)?a:E;E=reSign(a,32)>reSign(E,32)?a:E;HEAP[HEAP[i]+4]=D&65535;HEAP[HEAP[i]+6]=E&65535;HEAP[HEAP[i]+8]=HEAP[HEAP[i]+6]-HEAP[HEAP[i]+4];HEAP[i]=0;a=19}else a=14;while(0);u=a==19?D:a==15?B:u;t=a==19?E:a==15?C:t;v=a==19?0:a==15?v:0;if(r==w)if(y!=0)break b;else a=21;else a=17;var F=a==17?y:1;L=v==0;c:do if(L){N=
reSign(HEAP[r+3],8);I=0-N;if((reSign(N,32)>=reSign(0,32)?N:I)!=q){a=24;break c}var G=reSign(HEAP[r+3],8);HEAP[d]=0;var H=HEAP[b+4];if(reSign(HEAP[b],32)>=reSign(H,32)){a=25;H=HEAP[b+4];if(reSign(H,32)>=reSign(41297762,32)){b=27;break a}var J=(reSign(H,32)>>reSign(2,32))+4+H;N=reSign(J,32)<reSign(H,32);I=reSign(J,32)>reSign(41297762,32);N=N|I?41297762:J;J=_ft_mem_realloc(p,52,H,N,HEAP[b+8],d);HEAP[b+8]=J;J=HEAP[d];if(J!=0){a=28;b=29;break a}HEAP[b+4]=N}H=HEAP[b];h=HEAP[b+8]+52*H;HEAP[b]=H+1;H=HEAP[d];
HEAP[i]=h;h=H;if(H!=0){a=33;b=32;break a}_llvm_memcpy_p0i8_p0i8_i32(HEAP[i],k,52,1,0);HEAP[HEAP[i]+1]=G&255;H=HEAP[r+24];HEAP[HEAP[i]+40]=r;HEAP[HEAP[i]+44]=r;HEAP[HEAP[i]+48]=n;a=34}else a=61;while(0);var L=a==34?H:a==24?u:u,N=a==34?H:a==24?t:t,I=a==34?G:a==24?A:A,P=a==34?1:a==24?0:v;r=HEAP[r+32];a=26}o=A}j+=4;a=37;b=38}a:do if(b==27){HEAP[d]=64;a=27;b=29;break a}else if(b==40){f=HEAP[c+8];c=f+52*HEAP[c];HEAP[i]=f;if(!(HEAP[i]<c)){b=42;break a}c=c;a=41;b:for(;;){f=HEAP[HEAP[i]+40];k=HEAP[HEAP[i]+
44];j=HEAP[f+28];l=HEAP[k+28];A=f==k;c:do if(!A){F=reSign(j,32)<reSign(l,32);B=HEAP[f+36];G=HEAP[B+28];if(F){if(reSign(G,32)<reSign(j,32)){F=HEAP[i];G=HEAP[HEAP[i]+8];B=(reSign(j-HEAP[B+28],32)>>reSign(1,32)&65535)+G;HEAP[F+8]=B}F=HEAP[k+32];if(!(reSign(HEAP[F+28],32)>reSign(l,32)))break c;B=HEAP[i];G=HEAP[HEAP[i]+8];F=(reSign(HEAP[F+28]-l,32)>>reSign(1,32)&65535)+G;HEAP[B+8]=F}else{if(reSign(G,32)>reSign(j,32)){F=HEAP[i];G=HEAP[HEAP[i]+8];B=(reSign(HEAP[B+28]-j,32)>>reSign(1,32)&65535)+G;HEAP[F+
8]=B}F=HEAP[k+32];if(!(reSign(HEAP[F+28],32)<reSign(l,32)))break c;B=HEAP[i];G=HEAP[HEAP[i]+8];F=(reSign(l-HEAP[F+28],32)>>reSign(1,32)&65535)+G;HEAP[B+8]=F}}while(0);HEAP[i]+=52;if(HEAP[i]<c)a=47;else{a=47;break b}}b=42;break a}while(0);a:do if(b==29){h=a==27?64:J;HEAP[i]=0;h=h;break a}while(0);i=h;STACKTOP=d;return i}_af_latin_hints_compute_segments.__index__=Runtime.getFunctionIndex(_af_latin_hints_compute_segments,"_af_latin_hints_compute_segments");
function _af_latin_hints_link_segments(e,g){var d,b=null,a,c,f,h,i,k,j;a=e+48+g*28;c=HEAP[a+8];f=c+52*HEAP[a];h=Math.floor(reSign(HEAP[HEAP[e+112]+36]*8,32)/reSign(2048,32));if(h==0)h=1;i=Math.floor(reSign(HEAP[HEAP[e+112]+36]*6E3,32)/reSign(2048,32));k=c;d=k<f?1:2;a:for(;;)if(d==1){d=reSign(HEAP[k+1],8)!=HEAP[a+24];b:do if(!d){if(HEAP[k+40]==HEAP[k+44])break b;j=c;if(!(j<f))break b;var l=h,m=i,o=f;j=j;b=5;c:for(;;){C=b==5?0:C;var n=j+52*C+1,p=j+52*C+2,r=j+52*C+4,q=j+52*C+6,s=j+52*C,u=j+52*C+32,t=
j+52*C+20,v=j+52*(C+1),w=reSign(HEAP[k+1],8);n=reSign(HEAP[n],8)+w==0;d:do if(n){w=HEAP[k+2];if(!(reSign(HEAP[p],16)>reSign(w,16)))break d;w=reSign(HEAP[k+2],16);w=reSign(HEAP[p],16)-w;var x=0-w;w=reSign(w,32)<reSign(0,32)?x:w;var y=reSign(HEAP[k+4],16);x=reSign(HEAP[k+6],16);b=reSign(HEAP[r],16);if(reSign(b,32)>reSign(y,32)){var A=reSign(HEAP[r],16);b=10}else b=8;y=b==10?A:y;b=reSign(HEAP[q],16);if(reSign(b,32)<reSign(x,32)){var z=reSign(HEAP[q],16);b=12}else b=32;x=(b==12?z:x)-y;if(!(reSign(x,32)>=
reSign(l,32)))break d;x=Math.floor(reSign(m,32)/reSign(x,32));w=w+x;if(reSign(HEAP[k+32],32)>reSign(w,32)){HEAP[k+32]=w;HEAP[k+20]=s}if(!(reSign(HEAP[u],32)>reSign(w,32)))break d;HEAP[u]=w;HEAP[t]=k}while(0);var C=C+1;if(v<o)b=9;else break c}}while(0);k+=52;d=k<f?1:2}else if(d==2){k=c;d=k<f?22:23;break a}if(d==22)a:for(;;){a=HEAP[k+20];c=a!=0;b:do if(c){if(HEAP[a+20]==k)break b;HEAP[k+20]=0;HEAP[k+24]=HEAP[a+20]}while(0);k+=52;if(!(k<f))break a}}
_af_latin_hints_link_segments.__index__=Runtime.getFunctionIndex(_af_latin_hints_link_segments,"_af_latin_hints_link_segments");
function _af_latin_hints_detect_features(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a=null,c,f,h,i,k,j,l,m,o,n;h=_af_latin_hints_compute_segments(e,g);if(h==0){_af_latin_hints_link_segments(e,g);h=e+48+g*28;i=0;k=HEAP[e];a=HEAP[e+112]+40+g*396;j=HEAP[h+8];l=j+52*HEAP[h];HEAP[h+12]=0;f=g==0?HEAP[e+4]:HEAP[e+12];m=g==0?_FT_DivFix(64,HEAP[e+12]):0;var p=_FT_MulFix(HEAP[a+204],f);a=p;if(reSign(p,32)>reSign(16,32))a=16;a=_FT_DivFix(a,f);j=j;p=m*3;var r=h+12,q=h+20,s=a,u=i;a=4;a:for(;;){c=
a==7?z:u;if(!(j<l)){b=21;break a}a=reSign(HEAP[j+8],16);z=reSign(a,32)<reSign(m,32);b:do if(z)a=20;else{if(HEAP[j+24]!=0){a=reSign(HEAP[j+8],16)*2;if(reSign(a,32)<reSign(p,32)){a=6;break b}}var t=HEAP[r],v=j+2,w=j+1;a=9;c:for(;;){b=a==13?n:0;if(!(reSign(t,32)>reSign(b,32))){b=15;break c}a=HEAP[q];var x=reSign(HEAP[v],16),y=reSign(HEAP[a+48*b],16);x=x-y;y=0-x;x=reSign(x,32)<reSign(0,32)?y:x;if(reSign(x,32)<reSign(s,32)){o=a+48*b;if(HEAP[a+48*b+13]==HEAP[w]){b=11;break c}}n=b+1;a=13;b=10}c:do if(b==
11){if(o==0){b=15;break c}HEAP[j+16]=HEAP[o+40];HEAP[HEAP[o+44]+16]=j;HEAP[o+44]=j;a=16;break b}while(0);var A=reSign(HEAP[j+1],8);a=reSign(HEAP[j+2],16);A=_af_axis_hints_new_edge(h,a,A,k,d);if(A!=0){b=17;break a}_llvm_memset_p0i8_i32(HEAP[d],0,48,1,0);HEAP[HEAP[d]+40]=j;HEAP[HEAP[d]+44]=j;HEAP[HEAP[d]]=HEAP[j+2];HEAP[HEAP[d]+13]=HEAP[j+1];a=HEAP[d];t=HEAP[d];v=reSign(HEAP[j+2],16);v=_FT_MulFix(v,f);HEAP[t+8]=v;HEAP[a+4]=HEAP[t+8];HEAP[j+16]=j;a=18}while(0);var z=a==16?c:a==18?0:a==6?c:c;j+=52;a=
7;b=5}a:do if(b==21){i=c;f=HEAP[h+20];o=f+48*HEAP[h+12];n=f;k=n<o;b:do if(k){l=o;c:for(;;){j=b=HEAP[n+40];for(b=b!=0?23:24;;)if(b==23){HEAP[j+12]=n;j=HEAP[j+16];b=HEAP[n+40]!=j?23:24}else if(b==24){n+=48;if(n<l){b=22;continue c}else{b=25;break b}}}}while(0);n=f;if(!(n<o))break a;for(;;){b=f=0;j=HEAP[n+40];f=f;k=b;a=26;c:for(;;){C=a==35?C:k;B=a==35?B:f;b=(unSign(HEAP[j],8)&1&255)!=0;m=C+1;l=B+1;var C=b?C:m,B=b?l:B;reSign(HEAP[j+1],8);reSign(HEAP[j+6],16);reSign(HEAP[j+4],16);l=HEAP[j+24]==0;d:do if(l)b=
29;else{if(HEAP[HEAP[j+24]+12]==0){b=29;break d}if(HEAP[HEAP[j+24]+12]==n){a=30;b=29}else{a=30;b=31}break d}while(0);if(b==29)a=29;l=(a==29?0:1)&255;m=HEAP[j+20]==0;d:do{b=m?l!=0?34:35:HEAP[HEAP[j+20]+12]!=0|l!=0?34:35;break d}while(0);if(b==34){m=HEAP[n+24];b=HEAP[j+20];if(l!=0){var D=HEAP[j+24],E=HEAP[n+28];a=37}else a=34;b=a==37?D:b;m=a==37?E:m;p=m!=0;d:do if(p){a=reSign(HEAP[n],16);r=reSign(HEAP[m],16);a=a-r;r=0-a;a=reSign(a,32)<reSign(0,32)?r:a;r=reSign(HEAP[j+2],16);q=reSign(HEAP[b+2],16);r=
r-q;q=0-r;r=reSign(r,32)<reSign(0,32)?q:r;if(!(reSign(r,32)<reSign(a,32))){a=39;break d}var F=HEAP[b+12];a=40}else{var G=HEAP[b+12];a=43}while(0);b=a==39?m:a==40?F:G;m=n;if(l!=0){HEAP[m+28]=b;HEAP[b+12]|=2}else HEAP[m+24]=b}j=HEAP[j+16];if(HEAP[n+40]!=j)a=35;else break c}b=C;f=B;HEAP[n+12]=0;j=reSign(f,32)>reSign(0,32);c:do if(j){k=b;if(!(reSign(f,32)>=reSign(k,32)))break c;HEAP[n+12]|=1}while(0);j=HEAP[n+28]!=0;c:do if(j){if(HEAP[n+24]==0)break c;HEAP[n+28]=0}while(0);n+=48;if(n<o)b=26;else break a}}else if(b==
17)i=A;while(0);h=c=i}c=h;STACKTOP=d;return c}_af_latin_hints_detect_features.__index__=Runtime.getFunctionIndex(_af_latin_hints_detect_features,"_af_latin_hints_detect_features");
function _af_latin_hints_init(e,g){var d;d=null;var b,a,c,f;f=HEAP[g+4];HEAP[e+112]=g;HEAP[e+104]=HEAP[g+4+24];HEAP[e+4]=HEAP[g+40];HEAP[e+8]=HEAP[g+40+4];HEAP[e+12]=HEAP[g+40+396];HEAP[e+16]=HEAP[g+40+396+4];b=HEAP[g+4+20];a=HEAP[e+104];c=0;if(b==2|b==3)c|=1;if(b==2|b==4){c|=2;var h=b;d=1}else d=9;if((d==9?b:h)!=1)c|=4;if(b==2){c|=8;var i=b;d=4}else d=13;b=(d==4?i:b)==1;a:do if(b)d=6;else{d=(HEAP[f+12]&1&255)!=0?6:7;break a}while(0);if(d==6)a|=1;HEAP[e+104]=a;HEAP[e+108]=c;return 0}
_af_latin_hints_init.__index__=Runtime.getFunctionIndex(_af_latin_hints_init,"_af_latin_hints_init");
function _af_latin_compute_stem_width(e,g,d,b,a){var c,f=null,h,i,k,j,l,m,o,n;o=HEAP[e+112]+40+g*396;k=d;n=0;g=unSign(g==1,1);j=(HEAP[e+108]&4)==0;a:do if(j)c=0;else{if(HEAP[o+212]!=0){c=0;break a}if(reSign(k,32)<reSign(0,32)){k=0-d;n=1}m=g==0;b:do if(m)c=7;else{if((HEAP[e+108]&2)==0){c=4;break b}c=g!=0?6:7;break b}while(0);b:do if(c==7){c=(HEAP[e+108]&1)==0?4:6;break b}while(0);b:do if(c==4){m=(a&2)==0;c:do if(m)c=8;else{if(g==0){c=8;break c}var p=k;if(reSign(p,32)<=reSign(191,32))break b;else{f=
9;c=11;break c}}while(0);if(c==8){var r=k;f=8}f=f==8?r:p;m=(b&1&255)!=0;c:do if(m){if(!(reSign(f,32)<=reSign(79,32))){c=14;break c}k=64}else{if(!(reSign(f,32)<=reSign(55,32))){c=14;break c}k=56}while(0);if(HEAP[o+8]==0)break b;j=m=k-HEAP[o+12+4];if(reSign(j,32)<reSign(0,32)){var q=0-m;f=18}else f=17;if(reSign(f==18?q:j,32)<=reSign(39,32)){k=HEAP[o+12+4];if(!(reSign(k,32)<=reSign(47,32)))break b;k=48}else{m=reSign(k,32)<=reSign(191,32);j=k;if(m){m=j&63;k&=-64;if(reSign(m,32)<=reSign(9,32))k=m+k;else if(reSign(m,
32)<=reSign(31,32))k+=10;else{j=reSign(m,32)<=reSign(53,32);k=k;k=j?k+54:m+k}}else k=j+32&-64}}else if(c==6){m=k;j=HEAP[o+8];k=k;h=o+12;i=j;j=k=k;l=i;if(reSign(0,32)<reSign(l,32)){h=h;l=k;f=i;reSign(f,32);reSign(1,32);i=(reSign(f,32)>reSign(1,32)?f:1)-0;for(f=22;;){t=f==22?0:t;u=f==22?98:u;c=HEAP[h+12*(0+t)+4];f=l-c;var s=0-f;s=reSign(f,32)<reSign(0,32)?s:f;if(reSign(s,32)<reSign(u,32)){j=c;f=24}else f=23;var u=f==24?s:u,t=t+1;if(t!=i){f=26;c=23}else{f=26;c=27;break}}}l=j+32&-64;h=j;h=reSign(k,32)>=
reSign(h,32);l=l;c:do{if(h){i=k;if(!(reSign(l+48,32)>reSign(i,32))){c=30;break c}}else{i=k;if(!(reSign(l-48,32)<reSign(i,32))){c=30;break c}}k=j}while(0);k=k=k=k;if(g!=0)k=reSign(k,32)>reSign(63,32)?k+16&-64:64;else{j=k;if((HEAP[e+108]&8)!=0)k=reSign(j,32)<=reSign(63,32)?64:k+32&-64;else{j=reSign(j,32)<=reSign(47,32);h=k;if(j)k=reSign(h+64,32)>>reSign(1,32);else{j=reSign(h,32)<=reSign(127,32);k=k;if(j){k=k+22&-64;j=f=k-m;if(reSign(j,32)<reSign(0,32)){var v=0-f;f=33}else f=70;if(!(reSign(f==33?v:j,
32)>reSign(15,32)))break b;k=m;if(!(reSign(k,32)<=reSign(47,32)))break b;k=reSign(k+64,32)>>reSign(1,32)}else k=k+32&-64}}}}while(0);if(n!=0)k=0-k;m=k;c=38;break a}while(0);if(c==0)m=d;return m}_af_latin_compute_stem_width.__index__=Runtime.getFunctionIndex(_af_latin_compute_stem_width,"_af_latin_compute_stem_width");
function _af_latin_hints_apply(e,g,d){var b,a=null,c,f,h,i,k,j,l,m,o,n,p,r,q;r=_af_glyph_hints_reload(e,g);var s=r!=0;a:do if(!s){if((HEAP[e+104]&1)==0){r=_af_latin_hints_detect_features(e,0);if(r!=0)break a}q=(HEAP[e+104]&2)==0;b:do if(q){r=_af_latin_hints_detect_features(e,1);if(r!=0)break a;c=d;f=e;c=c;k=f+48+28;a=HEAP[k+20];p=a+48*HEAP[k+12];m=c+40+396;o=HEAP[m];if(!(a<p))break b;c=c+36;f=o;h=m;k=k+24;n=o;m=m;o=o;p=p;var u=a;a=3;c:for(;;){N=a==3?0:N;var t=u+48*(N+1),v=u+48*N+20,w=u+48*N+12,x=
u+48*N,y=u+48*N+13;a=Math.floor(unSign(HEAP[c],32)/unSign(40,32));i=_FT_MulFix(a,f);a=reSign(i,32)>reSign(32,32)?6:5;d:for(;;){H=a==10?H:a==5?0:0;J=a==10?J:a==6?32:i;L=a==10?L:a==5?0:0;var A=m+220+L*28+12;l=A;var z=j=a=h+220+L*28,C=h+220+L*28+24;b=(HEAP[C]&1)==0;e:do if(b)a=16;else{a=unSign((HEAP[C]&2)!=0,1);var B=reSign(HEAP[y],8);B=unSign(B==HEAP[k],1);if(a==B){a=8;break e}var D=reSign(HEAP[x],16)-HEAP[j],E=0-D;D=reSign(D,32)<reSign(0,32)?E:D;B=_FT_MulFix(D,n);D=(E=reSign(B,32)<reSign(J,32))?z:
H;E=E?B:J;if((unSign(HEAP[w],8)&1&255)==0){a=9;break e}if(B==0){a=11;break e}B=reSign(HEAP[x],16);var F=HEAP[j];B=reSign(B,32)<reSign(F,32);B=unSign(B,1);if(a==B){a=12;break e}var G=reSign(HEAP[x],16)-HEAP[A];a=0-G;G=reSign(G,32)<reSign(0,32)?a:G;G=_FT_MulFix(G,o);if(!(reSign(G,32)<reSign(E,32))){a=13;break e}a=14}while(0);var H=a==14?l:a==13?D:a==12?D:a==11?D:a==9?D:a==8?H:H,J=a==14?G:a==13?E:a==12?E:a==11?E:a==9?E:a==8?J:J,L=L+1;if(L!=6)a=10;else break d}if(H!=0)HEAP[v]=H;var N=N+1;if(t<p)a=19;
else break c}}while(0);q=0;a=4;b:for(;;){c=a==23?sa:0;f=c!=0;c:do if(f){a=22;b=26}else{a=22;if((HEAP[e+104]&1)==0){b=24;break c}var I=q;a=25;b=26;break c}while(0);c:do if(b==26){if((a==25?I:c)!=1){b=27;break c}b=(HEAP[e+104]&2)==0?24:27;break c}while(0);if(b==24){c=q;i=e;k=c;f=i+48+k*28;c=HEAP[f+20];f=c+48*HEAP[f+12];l=j=0;n=k==1;c:do if(n){h=c;if(!(h<f))break c;m=f;o=i;p=k;u=j;a=29;d:for(;;){Q=a==29?u:Q;t=(unSign(HEAP[h+12],8)&4)!=0;e:do if(t)a=31;else{x=HEAP[h+20];w=HEAP[h+24];if(x!=0){var P=h;
if(P==0){a=37;break e}else a=37}else{if(w==0){a=32;break e}if(HEAP[w+20]==0){a=33;break e}var K=HEAP[w+20],O=h;a=35}v=a==35?w:P;w=a==35?O:w;HEAP[v+8]=HEAP[(a==35?K:x)+8];HEAP[v+12]|=4;a=w!=0;f:do if(a){if(HEAP[w+20]!=0)break f;x=HEAP[w+4]-HEAP[v+4];y=unSign(HEAP[w+12],8);A=unSign(HEAP[v+12],8);x=_af_latin_compute_stem_width(o,p,x,A,y);HEAP[w+8]=HEAP[v+8]+x;HEAP[w+12]|=4}while(0);if(Q!=0){a=40;break e}var M=h;a=42}while(0);var Q=a==42?M:a==40?Q:a==37?Q:a==31?Q:a==32?Q:Q;h+=48;if(h<m)a=34;else break d}j=
Q}while(0);h=c;if(h<f){n=f;m=i;o=k;p=i;u=k;t=i;v=k;w=i;x=k;y=c;i=i;A=k;l=l;j=j;a=46;c:for(;;){W=a==46?j:W;da=a==46?l:da;z=(unSign(HEAP[h+12],8)&4)!=0;d:do if(z)a=47;else{C=HEAP[h+24];if(C==0){var R=da+1;a=48}else if(HEAP[C+20]!=0){a=h;b=HEAP[a+4]-HEAP[C+4];B=unSign(HEAP[a+12],8);F=unSign(HEAP[C+12],8);b=_af_latin_compute_stem_width(m,o,b,F,B);HEAP[a+8]=HEAP[C+8]+b;HEAP[h+12]|=4;a=50}else if(W==0){B=HEAP[C+4]-HEAP[h+4];var T=unSign(HEAP[C+12],8);a=unSign(HEAP[h+12],8);T=_af_latin_compute_stem_width(p,
u,B,a,T);F=reSign(T,32)<=reSign(64,32);e:do{if(F){var V=HEAP[h+4];a=51;b=52}else{a=reSign(T,32)<=reSign(95,32);var U=HEAP[h+4];if(a){a=53;b=52;break e}HEAP[h+8]=U+32&-64;a=54;b=56}break e}while(0);if(b==52){F=a==51?V:U;b=a==51?32:38;a=a==51?32:26;B=reSign(B,32)>>reSign(1,32);var S=F+B;B=S+32&-64;F=0-(0-b)+S+(0-B);var X=0-F;F=reSign(F,32)<reSign(0,32)?X:F;S=0-a+S+(0-B);X=0-S;S=reSign(S,32)<reSign(0,32)?X:S;F=reSign(F,32)<reSign(S,32);a=B+a;b=B-b;a=F?b:a;b=Math.floor(reSign(T,32)/reSign(2,32));HEAP[h+
8]=a-b;HEAP[C+8]=HEAP[h+8]+T}T=h;HEAP[h+12]|=4;a=h;b=HEAP[C+4]-HEAP[a+4];B=unSign(HEAP[C+12],8);F=unSign(HEAP[a+12],8);b=_af_latin_compute_stem_width(t,v,b,F,B);HEAP[C+8]=HEAP[a+8]+b;a=56}else{b=HEAP[h+4]+HEAP[W+8]+(0-HEAP[W+4]);a=HEAP[C+4]-HEAP[h+4];S=(reSign(a,32)>>reSign(1,32))+b;b=unSign(HEAP[C+12],8);B=unSign(HEAP[h+12],8);a=_af_latin_compute_stem_width(w,x,a,B,b);if((unSign(HEAP[C+12],8)&4)!=0)HEAP[h+8]=HEAP[C+8]-a;else if(reSign(a,32)<=reSign(95,32)){b=S+32&-64;B=(F=reSign(a,32)<=reSign(64,
32))?32:26;F=F?32:38;X=0-(b+(0-F))+S;var Y=0-X;X=reSign(X,32)<reSign(0,32)?Y:X;S=0-b+S+(0-B);Y=0-S;S=reSign(S,32)<reSign(0,32)?Y:S;S=reSign(X,32)<reSign(S,32);B=B+b;b=b-F;b=S?b:B;B=Math.floor(reSign(a,32)/reSign(2,32));HEAP[h+8]=b-B;a=Math.floor(reSign(a,32)/reSign(2,32))+b;HEAP[C+8]=a}else{F=HEAP[h+4]+HEAP[W+8]+(0-HEAP[W+4]);S=HEAP[C+4]-HEAP[h+4];B=(reSign(S,32)>>reSign(1,32))+F;a=unSign(HEAP[C+12],8);b=unSign(HEAP[h+12],8);a=_af_latin_compute_stem_width(i,A,S,b,a);b=F+32&-64;X=reSign(a,32)>>reSign(1,
32);X=0-B+b+X;Y=0-X;X=reSign(X,32)<reSign(0,32)?Y:X;F=(F+32+S&-64)-a;S=reSign(a,32)>>reSign(1,32);B=F+(0-B)+S;S=0-B;B=reSign(B,32)<reSign(0,32)?S:B;b=reSign(X,32)<reSign(B,32)?b:F;HEAP[h+8]=b;HEAP[C+8]=HEAP[h+8]+a}HEAP[h+12]|=4;HEAP[C+12]|=4;if(!(h>y)){a=61;break d}a=HEAP[h+-48+8];if(!(reSign(HEAP[h+8],32)<reSign(a,32))){a=62;break d}HEAP[h+8]=HEAP[h+-48+8];a=64}}while(0);var W=a==64?W:a==62?W:a==61?W:a==56?T:a==50?W:a==48?W:W,da=a==64?da:a==62?da:a==61?da:a==56?da:a==50?da:a==48?R:da;h+=48;if(h<
n)a=63;else break c}j=W;l=da}h=Math.floor(reSign(f-c,32)/reSign(48,32));k=k==0;c:do if(k){if(!(h==6|h==12))break c;a=c;if(h==6){m=a;o=c+96;n=c+192}else{m=a+48;o=c+240;n=c+432}a=HEAP[o+4]-HEAP[m+4];p=HEAP[n+4]-HEAP[o+4];a=p=a-p;if(reSign(p,32)<reSign(0,32)){var ba=0-a;a=70}else a=145;if(!(reSign(a==70?ba:p,32)<=reSign(7,32)))break c;a=HEAP[o+8]*-2+HEAP[n+8]+(0-(0-HEAP[m+8]));HEAP[n+8]-=a;if(HEAP[n+24]!=0)HEAP[HEAP[n+24]+8]-=a;if(h==12){HEAP[c+384+8]-=a;HEAP[c+528+8]-=a}HEAP[n+12]|=4;if(HEAP[n+24]==
0)break c;HEAP[HEAP[n+24]+12]|=4}while(0);h=l!=0;c:do if(h)b=77;else{b=j==0?77:78;break c}while(0);c:do if(b==77){h=c;if(!(h<f))break c;k=f;n=c;m=f;o=c;p=f;u=c;t=f;v=j;a=79;d:for(;;){Z=a==79?v:Z;w=(unSign(HEAP[h+12],8)&4)!=0;e:do if(w)a=80;else{var aa=HEAP[h+28]!=0;f:do if(aa){aa=HEAP[HEAP[h+28]+4]-HEAP[h+4];a=0-aa;aa=reSign(aa,32)<reSign(0,32)?a:aa;if(!(reSign(aa,32)<=reSign(79,32))){a=81;b=83;break f}aa=HEAP[h+28];a=h;HEAP[a+8]=HEAP[a+4]+HEAP[aa+8]+(0-HEAP[aa+4]);a=82;b=84;break f}else{a=152;b=
83}while(0);f:do if(b==83){aa=h;if(Z==0){HEAP[h+8]=HEAP[aa+4]+32&-64;var ca=h;a=85}else{a=83;g:for(;;){a=a==88?la:0;var $=a*-1;x=aa+48*$+-36;$=aa+48*($+-1);if(!($>=o)){b=87;break g}if((unSign(HEAP[x],8)&4)!=0){b=87;break g}var la=a+1;a=88;b=89}aa=h;a=87;g:for(;;){a=a==93?ea:0;var ga=a+1;x=aa+48*ga+12;ga=aa+48*ga;if(!(ga<p)){b=92;break g}if((unSign(HEAP[x],8)&4)!=0){b=92;break g}var ea=a+1;a=93;b=91}aa=$<u|$>=h|ga>=t;g:do if(!aa){if(ga<=h){b=95;break g}aa=HEAP[$+8];if(HEAP[ga+4]==HEAP[$+4]){HEAP[h+
8]=aa;a=97}else{aa=_FT_MulDiv(HEAP[h+4]-HEAP[$+4],HEAP[ga+8]-HEAP[$+8],HEAP[ga+4]-HEAP[$+4])+aa;HEAP[h+8]=aa;a=98}break f}while(0);HEAP[h+8]=(HEAP[h+4]+16+(0-HEAP[Z+4])&-32)+HEAP[Z+8];a=95}}while(0);aa=a==95?Z:a==98?Z:a==97?Z:a==85?ca:Z;HEAP[h+12]|=4;a=h>n;f:do if(a){x=HEAP[h+-48+8];if(!(reSign(HEAP[h+8],32)<reSign(x,32)))break f;HEAP[h+8]=HEAP[h+-48+8]}while(0);if(!(h+48<m)){a=100;break e}if((unSign(HEAP[h+48+12],8)&4)==0){a=102;break e}a=HEAP[h+48+8];if(!(reSign(HEAP[h+8],32)>reSign(a,32))){a=104;
break e}HEAP[h+8]=HEAP[h+48+8];a=105}while(0);var Z=a==105?aa:a==104?aa:a==102?aa:a==100?aa:Z;h+=48;if(h<k){a=103;b=80}else{b=107;break d}}j=Z}while(0);f=q;c=e;f=f;c=c+48+f*28;h=HEAP[c+8];c=h+52*HEAP[c];f=f==0;a=h;h=a<c;c:do if(f){if(!h)break c;k=c;n=a;a=109;d:for(;;){ja=a==109?0:ja;var ha=n+52*(ja+1);m=n+52*ja+44;o=n+52*ja+40;p=HEAP[n+52*ja+12];u=p==0;e:do if(!u){t=HEAP[o];v=HEAP[m];w=p+8;HEAP[t+16]=HEAP[w];HEAP[t]|=64;if(t==v)break e;else a=113;for(;;){var ia=HEAP[(a==115?ia:t)+32];HEAP[ia+16]=
HEAP[w];HEAP[ia]|=64;if(ia==v)break e;else a=115}}while(0);var ja=ja+1;if(ha<k)a=114;else break d}a=ha}else{if(!h)break c;k=c;n=a;a=111;d:for(;;){na=a==111?0:na;var fa=n+52*(na+1);m=n+52*na+44;o=n+52*na+40;p=HEAP[n+52*na+12];u=p==0;e:do if(!u){t=HEAP[o];v=HEAP[m];w=p+8;HEAP[t+20]=HEAP[w];HEAP[t]|=128;if(t==v)break e;else a=119;for(;;){var ka=HEAP[(a==121?ka:t)+32];HEAP[ka+20]=HEAP[w];HEAP[ka]|=128;if(ka==v)break e;else a=121}}while(0);var na=na+1;if(fa<k)a=120;else break d}a=fa}while(0);_af_glyph_hints_align_strong_points(e,
q);_af_glyph_hints_align_weak_points(e,q)}q=c=q+1;if(!(reSign(c,32)<=reSign(1,32)))break b;var sa=q;a=23}_af_glyph_hints_save(e,g)}while(0);return r}_af_latin_hints_apply.__index__=Runtime.getFunctionIndex(_af_latin_hints_apply,"_af_latin_hints_apply");
function _af_cjk_metrics_init(e,g){var d;d=HEAP[g+92];var b=unSign(HEAP[g+68],16);HEAP[e+36]=b;if(_FT_Select_Charmap(g,1970170211)!=0)HEAP[g+92]=0;else{_af_latin_metrics_init_widths(e,g,3E4);_af_latin_metrics_check_digits(e,g)}_FT_Set_Charmap(g,d);return 0}_af_cjk_metrics_init.__index__=Runtime.getFunctionIndex(_af_cjk_metrics_init,"_af_cjk_metrics_init");
function _af_cjk_metrics_scale(e,g){var d;d=e+4;HEAP[d]=HEAP[g];HEAP[d+4]=HEAP[g+4];HEAP[d+8]=HEAP[g+8];HEAP[d+12]=HEAP[g+12];HEAP[d+16]=HEAP[g+16];HEAP[d+20]=HEAP[g+20];HEAP[d+24]=HEAP[g+24];d=e+40+0;HEAP[d]=HEAP[g+4];HEAP[d+4]=HEAP[g+12];d=e+40+396;HEAP[d]=HEAP[g+8];HEAP[d+4]=HEAP[g+16]}_af_cjk_metrics_scale.__index__=Runtime.getFunctionIndex(_af_cjk_metrics_scale,"_af_cjk_metrics_scale");
function _af_cjk_hints_detect_features(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a=null,c,f,h,i,k,j,l,m,o,n,p,r,q,s,u;f=e+48+g*28;a=HEAP[f+8];f=a+52*HEAP[f];s=_af_latin_hints_compute_segments(e,g);u=s!=0;a:do{if(u){q=i=s;b=i==0?9:10}else{a=a;if(a<f){f=f;q=a;a=0;b:for(;;){k=a==0?0:k;s=q+52*(k+1);u=q+52*k;var t=HEAP[q+52*k+40];b=HEAP[q+52*k+44];var v=unSign(HEAP[t],16)&3;HEAP[u]&=-2;for(a=1;;){var w=a==1?v:a==5?j:j;a=a==1?t:a==5?i:i;if(a==b)break;i=HEAP[a+32];j=unSign(HEAP[i],16)&
3;if(w==0&j==0)break;if(i==b){HEAP[u]|=1;a=6}else a=5}k=k+1;if(s<f)a=4;else break b}}q=0;b=9}break a}while(0);if(b==9){j=e+48+g*28;q=HEAP[j+8];i=q+52*HEAP[j];s=HEAP[j+24];u=Math.floor(reSign(HEAP[HEAP[e+112]+36]*8,32)/reSign(2048,32));f=j=g==0?HEAP[e+4]:HEAP[e+12];f=_FT_DivFix(192,f);j=q;if(j<i)a:for(;;){t=HEAP[j+40]==HEAP[j+44];b:do if(!t){if(reSign(HEAP[j+1],8)!=s)break b;k=q;if(!(k<i))break b;for(;;){b=k!=j;d:do if(b){a=reSign(HEAP[j+1],8);if(reSign(HEAP[k+1],8)+a!=0)break d;a=reSign(HEAP[k+2],
16);v=reSign(HEAP[j+2],16);v=a-v;if(reSign(v,32)<reSign(0,32))break d;var x=reSign(HEAP[j+4],16);w=reSign(HEAP[j+6],16);a=reSign(HEAP[k+4],16);if(reSign(a,32)>reSign(x,32)){l=reSign(HEAP[k+4],16);a=22}else a=21;x=a==22?l:x;a=reSign(HEAP[k+6],16);if(reSign(a,32)<reSign(w,32)){m=reSign(HEAP[k+6],16);a=24}else a=145;a=(a==24?m:w)-x;if(!(reSign(a,32)>=reSign(u,32)))break d;w=HEAP[j+32]*9;w=reSign(v*8,32)<reSign(w,32);e:do if(w){x=HEAP[j+32]*7;if(!(reSign(v*8,32)<reSign(x,32)))if(!(reSign(HEAP[j+36],32)<
reSign(a,32)))break e;HEAP[j+32]=v;HEAP[j+36]=a;HEAP[j+20]=k}while(0);w=HEAP[k+32]*9;if(!(reSign(v*8,32)<reSign(w,32)))break d;w=HEAP[k+32]*7;if(!(reSign(v*8,32)<reSign(w,32)))if(!(reSign(HEAP[k+36],32)<reSign(a,32)))break d;HEAP[k+32]=v;HEAP[k+36]=a;HEAP[k+20]=j}while(0);k+=52;if(!(k<i))break b}}while(0);j+=52;if(j<i)b=13;else{b=36;break a}}j=q;if(j<i){l=f;m=q<i;a:for(;;){s=HEAP[j+20];u=s==0;b:do if(!u){if(HEAP[s+20]!=j)break b;a=HEAP[j+2];if(reSign(HEAP[s+2],16)<=reSign(a,16))break b;if(reSign(HEAP[j+
32],32)>=reSign(l,32))break b;k=q;t=s+2;b=s+2;c:for(;;){if(!(k<i))break b;a=HEAP[j+2];v=reSign(HEAP[k+2],16)>reSign(a,16);d:do if(!v){if(j==k)break d;w=HEAP[k+20];if(w==0)break d;if(HEAP[w+20]!=k)break d;a=HEAP[t];if(reSign(HEAP[w+2],16)<reSign(a,16))break d;if(HEAP[j+2]==HEAP[k+2])if(HEAP[b]==HEAP[w+2])break d;a=HEAP[j+32];if(reSign(HEAP[k+32],32)<=reSign(a,32))break d;a=HEAP[k+32];if(reSign(HEAP[j+32]*4,32)<=reSign(a,32))break d;a=HEAP[k+36]*3;if(!(reSign(HEAP[j+36],32)>=reSign(a,32)))break c;if(m)a=
57;else break d;e:for(;;){h=a==62?h:0;a=q+52*(h+1);x=q+52*h+24;var y=q+52*h+20,A=HEAP[y],z=A==k;f:do if(z){HEAP[y]=0;HEAP[x]=s}else{if(A!=w)break f;HEAP[y]=0;HEAP[x]=j}while(0);h=h+1;if(a<i)a=62;else break e}}while(0);k+=52}HEAP[s+20]=0;HEAP[j+20]=HEAP[s+20]}while(0);j+=52;if(j<i)b=39;else{b=67;break a}}}j=q;h=j<i;a:do if(h){a=f;l=i;for(;;){k=m=HEAP[j+20];m=m!=0;c:do if(m){HEAP[k+28]+=1;if(HEAP[k+20]==j)break c;HEAP[j+20]=0;q=reSign(HEAP[k+32],32)<reSign(a,32);d:do if(!q){q=HEAP[k+32]*4;if(reSign(HEAP[j+
32],32)<reSign(q,32))break d;HEAP[k+28]-=1;break c}while(0);HEAP[j+24]=HEAP[k+20]}while(0);j+=52;if(j<l)b=69;else{b=75;break a}}}while(0);h=e+48+g*28;i=0;k=HEAP[e];a=HEAP[e+112]+40+g*396;j=HEAP[h+8];l=j+52*HEAP[h];HEAP[h+12]=0;f=g==0?HEAP[e+4]:HEAP[e+12];m=_FT_MulFix(HEAP[a+204],f);m=reSign(m,32)>reSign(16,32)?_FT_DivFix(16,f):HEAP[a+204];j=j;q=h+12;s=h+20;u=h+12;t=i;a=78;a:for(;;){c=a==103?O:t;if(!(j<l)){b=105;break a}O=reSign(HEAP[q],32)>reSign(0,32);b:do if(O){O=HEAP[s];b=HEAP[j+1];a=HEAP[u];v=
j+2;w=j+20;reSign(a,32);reSign(1,32);x=reSign(a,32)>reSign(1,32)?a:1;a=80;c:for(;;){N=a==80?0:N;I=a==80?65535:I;P=a==80?0:P;y=O+48*P+40;z=A=O+48*P;var C=HEAP[O+48*P+13]!=b;d:do if(C)a=81;else{var B=reSign(HEAP[v],16);a=reSign(HEAP[z],16);B=B-a;a=0-B;B=reSign(B,32)<reSign(0,32)?a:B;a=reSign(B,32)<reSign(m,32);var D=reSign(B,32)<reSign(I,32);if(!(a&D)){a=82;break d}a=HEAP[w];if(a!=0){D=HEAP[y];var E=a+2,F=a+2,G=a+2;for(a=85;;){var H=a==93?n:0,J=a==93?p:D;a=HEAP[J+20];if(a!=0){var L=HEAP[a+2];if(reSign(HEAP[E],
16)>reSign(L,16)){o=reSign(HEAP[F],16);L=reSign(HEAP[a+2],16);o=o-L;a=87}else{r=reSign(HEAP[a+2],16);L=reSign(HEAP[G],16);r=r-L;a=89}L=a==89?r:o;if(reSign(L,32)>=reSign(m,32)){a=90;break}else a=90}else a=86;n=a==90?L:H;p=HEAP[J+16];if(p!=HEAP[y])a=93;else{a=93;break}}if(reSign(a==93?n:L,32)>=reSign(m,32)){a=91;break d}}a=95}while(0);var N=a==95?A:a==91?N:a==82?N:N,I=a==95?B:a==91?I:a==82?I:I,P=P+1;if(P!=x)a=84;else break c}if(N==0){a=97;b=98;break b}HEAP[j+16]=HEAP[N+40];HEAP[HEAP[N+44]+16]=j;HEAP[N+
44]=j;a=99;b=103;break b}else{a=104;b=98}while(0);if(b==98){var K=reSign(HEAP[j+1],8);O=reSign(HEAP[j+2],16);K=_af_axis_hints_new_edge(h,O,K,k,d);if(K!=0){b=100;break a}_llvm_memset_p0i8_i32(HEAP[d],0,48,1,0);HEAP[HEAP[d]+40]=j;HEAP[HEAP[d]+44]=j;HEAP[HEAP[d]]=HEAP[j+2];O=HEAP[d];a=HEAP[d];b=reSign(HEAP[j+2],16);b=_FT_MulFix(b,f);HEAP[a+8]=b;HEAP[O+4]=HEAP[a+8];HEAP[j+16]=j;HEAP[HEAP[d]+13]=HEAP[j+1];a=101}var O=a==99?c:0;j+=52;a=103;b=79}a:do if(b==105){i=c;o=HEAP[h+20];n=o+48*HEAP[h+12];p=o;r=p<
n;b:do if(r){B=n;c:for(;;){j=L=HEAP[p+40];for(b=L!=0?107:108;;)if(b==107){HEAP[j+12]=p;j=HEAP[j+16];b=HEAP[p+40]!=j?107:108}else if(b==108){p+=48;if(p<B){b=106;continue c}else{b=109;break b}}}}while(0);p=o;if(!(p<n))break a;for(;;){r=o=0;j=HEAP[p+40];o=o;r=r;a=110;c:for(;;){M=a==130?M:r;Q=a==130?Q:o;B=(unSign(HEAP[j],8)&1&255)!=0;N=M+1;L=Q+1;var M=B?M:N,Q=B?L:Q;B=HEAP[j+24]==0;d:do if(B)b=114;else{if(HEAP[HEAP[j+24]+12]==p){a=113;b=114}else{a=113;b=115}break d}while(0);if(b==114)a=114;B=(a==114?0:
1)&255;if(HEAP[j+20]!=0|B!=0){N=HEAP[p+24];L=HEAP[j+20];if(B!=0){var R=HEAP[j+24],T=HEAP[p+28];a=117}else a=162;L=a==117?R:L;N=a==117?T:N;I=N!=0;d:do if(I){P=reSign(HEAP[p],16);O=reSign(HEAP[N],16);P=P-O;O=0-P;P=reSign(P,32)<reSign(0,32)?O:P;O=HEAP[L+2];if(reSign(HEAP[j+2],16)>reSign(O,16)){var V=reSign(HEAP[j+2],16);O=reSign(HEAP[L+2],16);V=V-O;a=119}else{var U=reSign(HEAP[L+2],16);O=reSign(HEAP[j+2],16);U=U-O;a=121}if(!(reSign(a==121?U:V,32)<reSign(P,32))){a=122;break d}var S=HEAP[L+12];a=123}else{var X=
HEAP[L+12];a=126}while(0);L=a==122?N:a==123?S:X;N=p;if(B!=0){HEAP[N+28]=L;HEAP[L+12]|=2}else HEAP[N+24]=L}j=HEAP[j+16];if(HEAP[p+40]!=j)a=130;else break c}r=M;o=Q;HEAP[p+12]=0;B=reSign(o,32)>reSign(0,32);c:do if(B){L=r;if(!(reSign(o,32)>=reSign(L,32)))break c;HEAP[p+12]|=1}while(0);o=HEAP[p+28]!=0;c:do if(o){if(HEAP[p+24]==0)break c;HEAP[p+28]=0}while(0);p+=48;if(p<n)b=110;else break a}}else if(b==100)i=K;while(0);q=c=i}c=q;STACKTOP=d;return c}
_af_cjk_hints_detect_features.__index__=Runtime.getFunctionIndex(_af_cjk_hints_detect_features,"_af_cjk_hints_detect_features");function _af_cjk_hints_init(e,g){var d=null,b,a,c;HEAP[e+112]=g;HEAP[e+104]=HEAP[g+4+24];HEAP[e+4]=HEAP[g+40];HEAP[e+8]=HEAP[g+40+4];HEAP[e+12]=HEAP[g+40+396];HEAP[e+16]=HEAP[g+40+396+4];b=HEAP[g+4+20];a=HEAP[e+104];c=0;if(b==2|b==3)c|=1;if(b==2|b==4){c|=2;var f=b;d=1}else d=5;if((d==5?b:f)!=1)c|=4;if(b==2)c|=8;a|=4;HEAP[e+104]=a;HEAP[e+108]=c;return 0}
_af_cjk_hints_init.__index__=Runtime.getFunctionIndex(_af_cjk_hints_init,"_af_cjk_hints_init");
function _af_cjk_compute_stem_width(e,g,d){var b=null,a,c,f,h,i,k;i=HEAP[e+112]+40+g*396;c=d;k=0;g=unSign(g==1,1);if((HEAP[e+108]&4)==0)e=d;else{if(reSign(c,32)<reSign(0,32)){c=0-d;k=1}f=g==0;a:do if(f)d=5;else{if((HEAP[e+108]&2)==0){d=2;break a}d=g!=0?4:5;break a}while(0);a:do if(d==5){d=(HEAP[e+108]&1)==0?2:4;break a}while(0);a:do if(d==2){f=HEAP[i+8]!=0;b:do if(f){var j=c;if(!(reSign(j-HEAP[i+12+4],32)>=reSign(-39,32))){b=6;d=8;break b}var l=c;if(!(reSign(l-HEAP[i+12+4],32)<=reSign(39,32))){b=
7;d=8;break b}c=HEAP[i+12+4];if(!(reSign(c,32)<=reSign(47,32)))break a;c=48;break a}else{var m=c;b=12}while(0);f=b==12?m:b==7?l:j;if(reSign(f,32)<=reSign(53,32)){f=Math.floor(reSign(54-f,32)/reSign(2,32));c+=f}else{if(!(reSign(f,32)<=reSign(191,32)))break a;f=c&63;c&=-64;if(reSign(f,32)<=reSign(9,32))c=f+c;else if(reSign(f,32)<=reSign(21,32))c+=10;else if(reSign(f,32)<=reSign(41,32))c=f+c;else{a=reSign(f,32)<=reSign(53,32);c=c;c=a?c+54:f+c}}}else if(d==4){f=HEAP[i+8];c=c;a=i+12;b=f;f=c=c;h=b;if(reSign(0,
32)<reSign(h,32)){a=a;h=c;b=b;reSign(b,32);reSign(1,32);var o=(reSign(b,32)>reSign(1,32)?b:1)-0;for(b=16;;){r=b==16?0:r;p=b==16?98:p;d=HEAP[a+12*(0+r)+4];b=h-d;var n=0-b;n=reSign(b,32)<reSign(0,32)?n:b;if(reSign(n,32)<reSign(p,32)){f=d;b=18}else b=17;var p=b==18?n:p,r=r+1;if(r!=o){b=20;d=17}else{d=21;break}}}h=f+32&-64;a=f;a=reSign(c,32)>=reSign(a,32);h=h;b:do{if(a){b=c;if(!(reSign(h+48,32)>reSign(b,32))){d=24;break b}}else{b=c;if(!(reSign(h-48,32)<reSign(b,32))){d=24;break b}}c=f}while(0);c=c=c=
c;if(g!=0)c=reSign(c,32)>reSign(63,32)?c+16&-64:64;else{f=c;if((HEAP[e+108]&8)!=0)c=reSign(f,32)<=reSign(63,32)?64:c+32&-64;else{f=reSign(f,32)<=reSign(47,32);a=c;if(f)c=reSign(a+64,32)>>reSign(1,32);else{f=reSign(a,32)<=reSign(127,32);c=c;c=f?c+22&-64:c+32&-64}}}}while(0);if(k!=0)c=0-c;e=c}return e}_af_cjk_compute_stem_width.__index__=Runtime.getFunctionIndex(_af_cjk_compute_stem_width,"_af_cjk_compute_stem_width");
function _af_hint_normal_stem(e,g,d,b,a){var c,f,h,i,k,j,l;l=64;c=(HEAP[e+108]&4)==0;a:do if(c){l=(unSign(HEAP[g+12],8)&1&255)!=0^1;l=unSign(l,1)!=0;b:do if(!l){l=(unSign(HEAP[d+12],8)&1&255)!=0^1;if(unSign(l,1)!=0)break b;l=a==1?55:49;break a}while(0);l=a==1?61:59}while(0);c=HEAP[d+4]-HEAP[g+4];h=unSign(HEAP[d+12],8);var m=unSign(HEAP[g+12],8);a=_af_cjk_compute_stem_width(e,a,c,m,h);c=Math.floor(reSign(HEAP[d+4]+HEAP[g+4],32)/reSign(2,32));b=b+c;c=Math.floor(reSign(a,32)/reSign(2,32));b=b-c;c=a+
b;f=b&63;h=c&63;c=64-f;i=64-h;k=0;m=f==0;a:do if(!m){if(h==0)break a;j=l;if(reSign(a,32)<=reSign(j,32)){j=a;if(!(reSign(h,32)<reSign(j,32)))break a;k=h;k=reSign(c,32)<=reSign(k,32)?c:0-h}else{if(reSign(l,32)<=reSign(63,32)){j=l;if(reSign(f,32)>=reSign(j,32))break a;f=l;if(reSign(c,32)>=reSign(f,32))break a;f=l;if(reSign(h,32)>=reSign(f,32))break a;f=l;if(reSign(i,32)>=reSign(f,32))break a}j=i=reSign(a,32)%reSign(64,32);if(reSign(i,32)<=reSign(31,32)){i=j;if(reSign(c,32)<=reSign(i,32))break a;i=j;
if(reSign(h,32)<=reSign(i,32))break a}else j=64-l;f=l-c;c-=j;i=l-h;h-=j;k=c;if(reSign(f,32)<=reSign(k,32))c=0-f;k=i;if(reSign(h,32)<=reSign(k,32))i=0-h;k=c;j=0-k;k=reSign(k,32)>=reSign(0,32)?k:j;j=i;var o=0-j;j=reSign(j,32)>=reSign(0,32)?j:o;k=reSign(k,32)<=reSign(j,32)?c:i}}while(0);e=(HEAP[e+108]&4)==0;a:do if(e)if(reSign(k,32)>reSign(14,32))k=14;else{if(!(reSign(k,32)<reSign(-14,32)))break a;k=-14}while(0);b=k+b;e=HEAP[d+4];if(reSign(HEAP[g+4],32)<reSign(e,32)){HEAP[g+8]=b;HEAP[d+8]=a+b}else{HEAP[g+
8]=a+b;HEAP[d+8]=b}return k}_af_hint_normal_stem.__index__=Runtime.getFunctionIndex(_af_hint_normal_stem,"_af_hint_normal_stem");
function _af_cjk_hints_apply(e,g){var d,b=null,a,c;c=_af_glyph_hints_reload(e,g);var f=c!=0;a:do if(!f){if((HEAP[e+104]&1)==0){c=_af_cjk_hints_detect_features(e,0);if(c!=0)break a}if((HEAP[e+104]&2)==0){c=_af_cjk_hints_detect_features(e,1);if(c!=0)break a}var h=e+104,i=e,k=e,j=e,l=e,m=e+104;b=3;b:for(;;){Y=b==3?0:Y;var o=0+Y,n=i+48+o*28+12,p=i+48+o*28+20,r=k+48+o*28+12,q=k+48+o*28+20;d=o==0?5:o==1?8:7;c:do if(d==5){d=(HEAP[m]&1)==0?6:7;break c}else if(d==8){d=(HEAP[h]&2)==0?6:7;break c}while(0);if(d==
6){p=HEAP[p];n=p+48*HEAP[n];a=p;var s=a<n;c:do if(s){var u=o==1;for(b=9;;){C=b==9?0:C;B=b==9?0:B;D=b==9?0:D;if((unSign(HEAP[a+12],8)&4)!=0)b=10;else{d=HEAP[a+24];if(d==0){var t=D+1;b=11}else if(d<a){b=a;var v=HEAP[b+4]-HEAP[d+4],w=unSign(HEAP[b+12],8),x=unSign(HEAP[d+12],8);v=_af_cjk_compute_stem_width(i,o,v,x,w);HEAP[b+8]=HEAP[d+8]+v;HEAP[a+12]|=4;b=13}else{var y=a;if(u|B!=0){_af_hint_normal_stem(i,y,d,C,o);b=16}else{var A=_af_hint_normal_stem(i,y,d,0,0);b=14}y=b==16?C:A;var z=a;HEAP[a+12]|=4;HEAP[d+
12]|=4;b=17}}var C=b==17?y:b==13?C:b==11?C:C,B=b==17?z:b==13?B:b==11?B:B,D=b==17?D:b==13?D:b==11?t:D;a+=48;if(a<n)b=18;else{b=18;break c}}}else b=6;while(0);s=b==6?0:D;a=Math.floor(reSign(n-p,32)/reSign(48,32));u=o==0;c:do if(u){if(a==6){b=86;d=20}else if(a==12){b=86;d=22}else break c;if(d==20){var E=p+96,F=p+192;b=20}else if(d==22){var G=p+48,H=p+240,J=p+432;b=22}d=b==22?J:F;v=b==22?H:E;b=b==22?G:p;w=HEAP[v+4]-HEAP[b+4]-(HEAP[d+4]-HEAP[v+4]);x=0-w;x=reSign(w,32)<reSign(0,32)?x:w;if(HEAP[b+24]!=b+
48)break c;if(HEAP[v+24]!=v+48)break c;w=HEAP[d+24]==d+48;x=reSign(x,32)<=reSign(7,32);if(!(w&x))break c;b=HEAP[v+8]*-2+HEAP[d+8]+(0-(0-HEAP[b+8]));HEAP[d+8]-=b;if(HEAP[d+24]!=0)HEAP[HEAP[d+24]+8]-=b;if(a==12){HEAP[p+384+8]-=b;HEAP[p+528+8]-=b}HEAP[d+12]|=4;if(HEAP[d+24]==0)break c;HEAP[HEAP[d+24]+12]|=4}while(0);u=s==0;c:do if(u)b=25;else{a=p;if(a<n){b=33;d=34}else{b=33;d=35}d:for(;;)if(d==34){N=b==38?N:s;d=(unSign(HEAP[a+12],8)&4)!=0;e:do if(d)b=34;else{if(HEAP[a+28]==0){b=36;break e}var L=HEAP[a+
28];b=a;HEAP[b+8]=HEAP[b+4]+HEAP[L+8]+(0-HEAP[L+4]);HEAP[a+12]|=4;L=N-1;b=37}while(0);var N=b==37?L:b==36?N:N;a+=48;if(a<n){b=38;d=34;continue d}if(N==0){b=40;break c}else{b=40;d=35}}else if(d==35){a=p;if(a<n){b=35;break d}else{b=35;break c}}for(;;){d=(unSign(HEAP[a+12],8)&4)!=0;e:do if(!d){v=a;b=43;f:for(;;){b=b==45?P:0;w=b*-1;var I=v+48*(w+-1);w=v+48*w+-36;if(!(I>=p)){b=44;break f}w=(unSign(HEAP[w],8)&4)!=0;var P=b+1;if(w){b=45;break f}else b=45}for(;;){b=b==47?O:b==44?0:0;w=b+1;var K=v+48*w;if(!(K<
n))break;w=(unSign(HEAP[v+48*w+12],8)&4)!=0;var O=b+1;if(w)break;else b=47}if(!(I>=p|K<n))break e;if(I<p){b=a;HEAP[b+8]=HEAP[b+4]+HEAP[K+8]+(0-HEAP[K+4])}else if(K>=n){b=a;HEAP[b+8]=HEAP[b+4]+HEAP[I+8]+(0-HEAP[I+4])}else{b=HEAP[I+8];if(HEAP[K]==HEAP[I])HEAP[a+8]=b;else{v=reSign(HEAP[K],16);w=reSign(HEAP[I],16);v=v-w;w=HEAP[K+8]-HEAP[I+8];x=reSign(HEAP[a],16);var M=reSign(HEAP[I],16);b=_FT_MulDiv(x-M,w,v)+b;HEAP[a+8]=b}}}while(0);a+=48;if(a<n)b=50;else{b=50;break c}}}while(0);q=HEAP[q];r=q+48*HEAP[r];
d=o==0?56:o==1?59:58;c:do if(d==56){if((HEAP[k+108]&1&255)!=0){b=56;d=57}else{b=56;d=58}break c}else if(d==59){if((HEAP[k+108]&2)!=0){b=59;d=57}else{b=59;d=58}break c}while(0);if(d==58)b=58;p=(b==58?0:b==59?1:1)&255;if(q<r){p=p!=0;n=o==0;a=o==0;b=61;c:for(;;){X=b==61?0:X;s=q+48*(X+1);b=q+48*X+4;v=q+48*X+8;u=q+48*X+40;d=HEAP[u];if(p){b=62;d:for(;;){T=b==64?T:d;w=HEAP[T+40];x=T+44;M=HEAP[v];e:do if(n){HEAP[w+16]=M;HEAP[w]|=64;if(HEAP[x]==w)break e;else b=66;for(;;){var Q=HEAP[(b==67?Q:w)+32];HEAP[Q+
16]=HEAP[v];HEAP[Q]|=64;if(HEAP[x]==Q)break e;else b=67}}else{HEAP[w+20]=M;HEAP[w]|=128;if(HEAP[x]==w)break e;else b=63;for(;;){var R=HEAP[(b==65?R:w)+32];HEAP[R+20]=HEAP[v];HEAP[R]|=128;if(HEAP[x]==R)break e;else b=65}}while(0);var T=HEAP[T+16];if(HEAP[u]!=T)b=64;else break d}}else{v=HEAP[v]-HEAP[b];b=70;d:for(;;){S=b==73?S:d;w=HEAP[S+40];x=S+44;e:do if(a){HEAP[w+16]+=v;HEAP[w]|=64;if(HEAP[x]==w)break e;else b=72;for(;;){var V=HEAP[(b==74?V:w)+32];HEAP[V+16]+=v;HEAP[V]|=64;if(HEAP[x]==V)break e;
else b=74}}else{HEAP[w+20]+=v;HEAP[w]|=128;if(HEAP[x]==w)break e;else b=75;for(;;){var U=HEAP[(b==76?U:w)+32];HEAP[U+20]+=v;HEAP[U]|=128;if(HEAP[x]==U)break e;else b=76}}while(0);var S=HEAP[S+16];if(HEAP[u]!=S)b=73;else break d}}var X=X+1;if(s<r)b=79;else break c}}_af_glyph_hints_align_strong_points(j,o);_af_glyph_hints_align_weak_points(l,o)}var Y=Y+1;if(Y!=2)b=7;else break b}_af_glyph_hints_save(e,g)}while(0);return c}_af_cjk_hints_apply.__index__=Runtime.getFunctionIndex(_af_cjk_hints_apply,"_af_cjk_hints_apply");
function _af_indic_metrics_init(e,g){return _af_cjk_metrics_init(e,g)}_af_indic_metrics_init.__index__=Runtime.getFunctionIndex(_af_indic_metrics_init,"_af_indic_metrics_init");function _af_indic_metrics_scale(e,g){_af_cjk_metrics_scale(e,g)}_af_indic_metrics_scale.__index__=Runtime.getFunctionIndex(_af_indic_metrics_scale,"_af_indic_metrics_scale");function _af_indic_hints_init(e,g){return _af_cjk_hints_init(e,g)}_af_indic_hints_init.__index__=Runtime.getFunctionIndex(_af_indic_hints_init,"_af_indic_hints_init");
function _af_indic_hints_apply(e,g,d){return _af_cjk_hints_apply(e,g,d)}_af_indic_hints_apply.__index__=Runtime.getFunctionIndex(_af_indic_hints_apply,"_af_indic_hints_apply");
function _af_loader_load_g(e,g,d,b,a){var c=STACKTOP;STACKTOP+=116;Runtime.memset(c,0,116);var f,h=null,i,k,j,l,m=c+8,o=c+16,n=c+24,p=c+32,r,q,s,u,t,v,w=c+40,x,y,A,z,C,B=c+56,D=c+64,E=c+72,F=c+92,G=c+108;r=HEAP[e];q=HEAP[e+8];s=HEAP[e+136];u=e+12;t=HEAP[r+84];v=HEAP[t+156];k=_FT_Load_Glyph(r,d,b);r=k!=0;a:do if(!r){HEAP[e+140]=HEAP[v+8];if(HEAP[e+140]!=0){i=e+144;x=v+12;HEAP[i]=HEAP[x];HEAP[i+4]=HEAP[x+4];HEAP[i+8]=HEAP[x+8];HEAP[i+12]=HEAP[x+12];i=v+28;HEAP[p]=HEAP[i];HEAP[p+4]=HEAP[i+4];i=e+160;
HEAP[i]=HEAP[p];HEAP[i+4]=HEAP[p+4];i=e+144;HEAP[w]=HEAP[i];HEAP[w+4]=HEAP[i+4];HEAP[w+8]=HEAP[i+8];HEAP[w+12]=HEAP[i+12];_FT_Matrix_Invert(w);_FT_Vector_Transform(e+160,w)}HEAP[t+56]=HEAP[t+24+16];HEAP[t+60]=HEAP[t+24+28];i=HEAP[t+72];f=i==1668246896?60:i==1869968492?61:62;b:do if(f==62)k=7;else if(f==60){i=HEAP[t+128];C=reSign(HEAP[q+20+2],16);k=_FT_GlyphLoader_CheckSubGlyphs(q,i);if(k!=0)break a;_llvm_memcpy_p0i8_p0i8_i32(HEAP[q+56+32],HEAP[t+132],i*32,1,0);HEAP[q+56+28]=i;z=HEAP[q+20+28];i=i;
x=n;A=n+4;l=B+4;j=n+4;y=o;var H=o+4,J=D+4,L=o+4,N=a+1,I=g,P=b,K=m,O=m+4,M=B,Q=B+4,R=m+4,T=c,V=c+4,U=D,S=D+4,X=c+4,Y=C,W=C;C=C;var da=E,ba=E+2,aa=E+4,ca=E+8,$=E+12,la=E+16,ga=E+4,ea=E+4,Z=E+2,ha=u+4,ia=u+8,ja=u+12,fa=u+16,ka=B+4,na=D+4,sa=HEAP[K],wa=HEAP[M],Aa=HEAP[T],Da=HEAP[U],pa=HEAP[x],ta=HEAP[y],ma=k,ya=0+z;z=0+z;h=25;c:for(;;){f=h==40?bb:0;var qa=h==40?La:ma,ua=h==40?Pa:ta,Ba=h==40?Ca:pa,Na=h==40?Ma:Da,Ea=h==40?Ka:Aa,ra=h==40?Ra:wa,za=h==40?Qa:sa;h=ya+f;var Ha=z+f;if(!(unSign(0+f,32)<unSign(i,
32))){f=42;break c}La=HEAP[q+20+32];Pa=e+168;var Ca=HEAP[Pa];HEAP[A]=HEAP[Pa+4];HEAP[l]=HEAP[j];var va=e+176,Pa=HEAP[va];HEAP[H]=HEAP[va+4];HEAP[J]=HEAP[L];var Ja=HEAP[q+20+2];va=reSign(Ja,16);var La=_af_loader_load_g(e,I,HEAP[La+32*h],P,N);if(La!=0){f=27;break c}var xa=HEAP[q+20+32];Ma=(unSign(HEAP[xa+32*Ha+4],16)&512)!=0;Ra=Ka=e+168;if(Ma){var oa=HEAP[Ra];HEAP[O]=HEAP[Ka+4];HEAP[Q]=HEAP[R];Ma=e+176;var Fa=HEAP[Ma];HEAP[V]=HEAP[Ma+4];HEAP[S]=HEAP[X];h=29}else{HEAP[Ra]=Ca;HEAP[Ka+4]=HEAP[ka];Ma=e+
176;HEAP[Ma]=Pa;HEAP[Ma+4]=HEAP[na];h=31}var Ma=h==31?Pa:Fa,Ka=h==31?Ea:Fa,Ra=h==31?Ca:oa,Qa=h==31?za:oa,Va=reSign(HEAP[q+20+2],16)-va,Ta=(unSign(HEAP[xa+32*Ha+4],16)&200)!=0;d:do if(Ta){var Ua=HEAP[q+20+4];h=Ua+8*va;var ab=h+8*Va;if(!(h<ab))break d;var Sa=reSign(Ja,16),$a=Sa+1,Wa=xa+32*Ha+16;for(h=33;;){eb=h==33?0:eb;h=Ua+8*($a+eb);_FT_Vector_Transform(Ua+8*(Sa+eb),Wa);var eb=eb+1;if(h<ab)h=35;else break d}}while(0);if((unSign(HEAP[xa+32*Ha+4],16)&2)==0){h=HEAP[xa+32*Ha+8];Ha=HEAP[xa+32*Ha+12];xa=
unSign(Y+h,32)>=unSign(va,32);Ja=unSign(Ha,32)>=unSign(Va,32);if(xa|Ja){f=36;break c}var Ga=HEAP[q+20+4]+8*W+8*h;bb=HEAP[q+20+4]+8*C+8*(va+Ha);var ob=HEAP[Ga]-HEAP[bb];Ga=HEAP[Ga+4]-HEAP[bb+4];h=37}else{var Oa=_FT_MulFix(HEAP[xa+32*Ha+8],HEAP[ha]);Oa=HEAP[ia]+Oa;var Xa=_FT_MulFix(HEAP[xa+32*Ha+12],HEAP[ja]);Oa=Oa+32&-64;Xa=HEAP[fa]+Xa+32&-64;h=39}bb=h==39?Xa:Ga;h=h==39?Oa:ob;Ha=q+20;HEAP[da]=HEAP[Ha];HEAP[ba]=HEAP[Ha+2];HEAP[aa]=HEAP[Ha+4];HEAP[ca]=HEAP[Ha+8];HEAP[$]=HEAP[Ha+12];HEAP[la]=HEAP[Ha+
16];HEAP[ea]=HEAP[ga]+8*va;HEAP[Z]=Va&65535;_FT_Outline_Translate(E,h,bb);var bb=f+1;h=40;f=26}if(f==42){k=qa;HEAP[y]=ua;HEAP[x]=Ba;HEAP[U]=Na;HEAP[T]=Ea;HEAP[M]=ra;HEAP[K]=za}else if(f==27){k=La;HEAP[y]=Pa;HEAP[x]=Ca;HEAP[U]=Pa;HEAP[T]=Ea;HEAP[M]=Ca;HEAP[K]=za;break a}else if(f==36){HEAP[y]=Pa;HEAP[x]=Ca;HEAP[U]=Ma;HEAP[T]=Ka;HEAP[M]=Ra;HEAP[K]=Qa;k=21;break a}}else if(f==61){HEAP[e+140]!=0&&_FT_Outline_Translate(t+108,HEAP[e+160],HEAP[e+160+4]);i=HEAP[t+108+2]==-4;c:do if(i)f=3;else{i=reSign(HEAP[q+
20+2],16);x=reSign(HEAP[q+56+2],16);A=reSign(HEAP[t+108+2],16);l=HEAP[q+4];f=unSign(i+4+x+A,32)>unSign(l,32)?2:3;break c}while(0);c:do if(f==3){if(HEAP[t+108]!=0){i=reSign(HEAP[q+20],16);x=reSign(HEAP[q+56],16);A=reSign(HEAP[t+108],16);l=HEAP[q+8];if(unSign(x+i+A,32)>unSign(l,32)){f=2;break c}}k=0;f=5;break c}while(0);if(f==2){k=reSign(HEAP[t+108],16);i=reSign(HEAP[t+108+2],16)+4;k=i=_FT_GlyphLoader_CheckPoints(q,i,k);if(i!=0)break a}i=reSign(HEAP[t+108+2],16)*8;_llvm_memcpy_p0i8_p0i8_i32(HEAP[q+
56+4],HEAP[t+108+4],i,1,0);i=reSign(HEAP[t+108],16)*2;_llvm_memcpy_p0i8_p0i8_i32(HEAP[q+56+12],HEAP[t+108+12],i,1,0);i=reSign(HEAP[t+108+2],16);_llvm_memcpy_p0i8_p0i8_i32(HEAP[q+56+8],HEAP[t+108+8],i,1,0);HEAP[q+56+2]=HEAP[t+108+2];HEAP[q+56]=HEAP[t+108];HEAP[e+168]=HEAP[u+8];HEAP[e+168+4]=HEAP[u+16];i=_FT_MulFix(HEAP[t+24+16],HEAP[u+4]);HEAP[e+176]=HEAP[u+8]+i;HEAP[e+176+4]=HEAP[u+16];if(HEAP[t+108+2]==0)break b;HEAP[HEAP[s]+28]!=0&&FUNCTION_TABLE[HEAP[HEAP[s]+28]](u,q+56,s);x=HEAP[g+20]!=1;c:do if(x){l=
u+48;A=HEAP[l+20];i=A+48*HEAP[l+12]+-48;l=reSign(HEAP[l+12],32)<=reSign(1,32);d:do if(!l){if((HEAP[u+104]&4)!=0){f=11;break d}x=HEAP[e+176]-HEAP[i+4];j=HEAP[A+4];y=HEAP[A+8];A=y-j;H=x;l=H+HEAP[i+8];if(reSign(j,32)<=reSign(23,32)){A-=8;var jb=x;h=13}else h=12;if(reSign(h==13?jb:H,32)<=reSign(23,32))l+=8;HEAP[e+168]=A+32&-64;HEAP[e+176]=l+32&-64;y=y;y=reSign(HEAP[e+168],32)>=reSign(y,32);e:do if(y){if(!(reSign(j,32)>reSign(0,32)))break e;HEAP[e+168]-=64}while(0);i=HEAP[i+8];i=reSign(HEAP[e+176],32)<=
reSign(i,32);e:do if(i){if(!(reSign(x,32)>reSign(0,32)))break e;HEAP[e+176]+=64}while(0);HEAP[t+144]=HEAP[e+168]-A;HEAP[t+148]=HEAP[e+176]-l;f=22;break c}while(0);i=HEAP[e+168];A=HEAP[e+176];HEAP[e+168]=i+32&-64;HEAP[e+176]=A+32&-64;HEAP[t+144]=HEAP[e+168]-i;HEAP[t+148]=HEAP[e+176]-A}else{i=HEAP[e+168];A=HEAP[e+176];HEAP[e+168]=HEAP[u+116]+32+i&-64;HEAP[e+176]=HEAP[u+120]+32+A&-64;HEAP[t+144]=HEAP[e+168]-i;HEAP[t+148]=HEAP[e+176]-A}while(0);_FT_GlyphLoader_Add(q)}while(0);if(a!=0)break a;HEAP[G]=
HEAP[t+24+20]-HEAP[t+24+8];HEAP[G+4]=HEAP[t+24+24]-HEAP[t+24+12];k=_FT_MulFix(HEAP[G],HEAP[s+4+4]);HEAP[G]=k;k=_FT_MulFix(HEAP[G+4],HEAP[s+4+8]);HEAP[G+4]=k;if(HEAP[e+140]!=0){i=e+144;k=q+20;i=i;x=k==0;b:do if(!x){if(i==0)break b;j=HEAP[k+4];A=reSign(HEAP[k+2],16);l=j+8*A;if(!(j<l))break b;A=i;l=l;j=j;for(h=46;;){Za=h==46?0:Za;y=j+8*(Za+1);_FT_Vector_Transform(j+8*Za,A);var Za=Za+1;if(y<l)h=47;else break}}while(0);_FT_Vector_Transform(G,e+144)}HEAP[e+168]!=0&&_FT_Outline_Translate(q+20,0-HEAP[e+168],
0);_FT_Outline_Get_CBox(q+20,F);HEAP[F]&=-64;HEAP[F+4]&=-64;HEAP[F+8]=HEAP[F+8]+63&-64;HEAP[F+12]=HEAP[F+12]+63&-64;HEAP[t+24]=HEAP[F+8]-HEAP[F];HEAP[t+24+4]=HEAP[F+12]-HEAP[F+4];HEAP[t+24+8]=HEAP[F];HEAP[t+24+12]=HEAP[F+12];HEAP[t+24+20]=HEAP[G]+HEAP[F]&-64;HEAP[t+24+24]=HEAP[G+4]+HEAP[F+12]&-64;k=(HEAP[HEAP[t+4]+8]&4)!=0;b:do if(k)f=53;else{i=d;k=HEAP[e+4];x=i=i;k=k=unSign(HEAP[k+4],32)>unSign(x,32)?unSign(HEAP[HEAP[k+8]+i],8)&128:0;if((k&255)!=0)if(HEAP[s+32]!=0){f=53;break b}if(HEAP[t+24+16]==
0){f=57;break b}HEAP[t+24+16]=HEAP[e+176]-HEAP[e+168];f=57;break b}while(0);if(f==53){k=_FT_MulFix(HEAP[t+24+16],HEAP[s+4+4]);HEAP[t+24+16]=k;HEAP[t+144]=0;HEAP[t+148]=0}k=_FT_MulFix(HEAP[t+24+28],HEAP[s+4+8]);HEAP[t+24+28]=k;HEAP[t+24+16]=HEAP[t+24+16]+32&-64;HEAP[t+24+28]=HEAP[t+24+28]+32&-64;i=HEAP[v];k=i+20;i=i+56;HEAP[k+2]=0;HEAP[k]=0;HEAP[k+28]=0;_llvm_memcpy_p0i8_p0i8_i32(i,k,36,4,0);k=i=_FT_GlyphLoader_CopyPoints(HEAP[v],q);if(i!=0)break a;i=t+108;x=HEAP[v]+20;HEAP[i]=HEAP[x];HEAP[i+2]=HEAP[x+
2];HEAP[i+4]=HEAP[x+4];HEAP[i+8]=HEAP[x+8];HEAP[i+12]=HEAP[x+12];HEAP[i+16]=HEAP[x+16];HEAP[t+72]=1869968492}while(0);e=k;STACKTOP=c;return e}_af_loader_load_g.__index__=Runtime.getFunctionIndex(_af_loader_load_g,"_af_loader_load_g");
function _af_autofitter_init(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d,b=HEAP[HEAP[e+4]];d=e+20;_llvm_memset_p0i8_i32(d,0,184,1,0);e=d+12;_llvm_memset_p0i8_i32(e,0,124,1,0);HEAP[e]=b;e=d+8;d=_ft_mem_alloc(b,96,g);if(HEAP[g]==0){HEAP[d]=b;HEAP[e]=d}b=HEAP[g];STACKTOP=g;return b}_af_autofitter_init.__index__=Runtime.getFunctionIndex(_af_autofitter_init,"_af_autofitter_init");
function _af_autofitter_done(e){var g,d,b;b=e+20;_af_glyph_hints_done(b+12);HEAP[b]=0;HEAP[b+4]=0;e=HEAP[b+8];var a=e!=0;a:do if(a){g=HEAP[e];_FT_GlyphLoader_Reset(e);d=e;g=g;d=d;if(d==0)break a;FUNCTION_TABLE[HEAP[g+8]](g,d)}while(0);HEAP[b+8]=0}_af_autofitter_done.__index__=Runtime.getFunctionIndex(_af_autofitter_done,"_af_autofitter_done");
function _af_autofitter_load_glyph(e,g,d,b,a){d=STACKTOP;STACKTOP+=44;Runtime.memset(d,0,44);var c,f=null,h,i,k,j,l,m,o,n,p,r,q,s;h=d+4;var u;i=d+8;var t,v=d+12,w=d+40;g=HEAP[g+4];e=e+20;a=a;u=HEAP[g+88];if(u==0)b=6;else{_llvm_memset_p0i8_i32(v,0,28,1,0);HEAP[v]=g;HEAP[v+4]=HEAP[u+12+4];HEAP[v+12]=0;HEAP[v+8]=HEAP[u+12+8];HEAP[v+16]=0;u=unSign(a,32)>>>unSign(16,32)&15;HEAP[v+20]=u;u=HEAP[v+24]=0;HEAP[e]=g;HEAP[e+4]=HEAP[g+116];t=HEAP[e+8];c=t+20;t=t+56;HEAP[c+2]=0;HEAP[c]=0;HEAP[c+28]=0;_llvm_memcpy_p0i8_p0i8_i32(t,
c,36,4,0);t=HEAP[e+4]==0;a:do if(t){c=e+4;u=g;c=c;t=HEAP[u+100];t=_ft_mem_alloc(t,HEAP[u+16]+28,i);var x=HEAP[i]==0;b:do if(x){HEAP[t]=u;HEAP[t+4]=HEAP[u+16];HEAP[t+8]=t+28;n=t;r=HEAP[n];q=HEAP[r+92];s=HEAP[n+8];_llvm_memset_p0i8_i32(HEAP[n+8],127,HEAP[n+4],1,0);p=_FT_Select_Charmap(r,1970170211);if(p!=0)p=0;else{if(HEAP[_af_script_classes+0]!=0){f=r;var y=n+4,A=s,z=s,C=r,B=n+4,D=s,E=s,F=f!=0,G=f+92,H=f+92;f=2;c:for(;;){Q=f==2?0:Q;var J=_af_script_classes+(1+Q)*4;f=0+Q;var L=f&255,N=HEAP[_af_script_classes+
f*4],I=HEAP[N+4]==0;d:do if(!I){var P=HEAP[N+4];if(HEAP[P]!=0)f=4;else break d;e:for(;;){m=f==16?m:0;var K=P+8*(m+1),O=P+8*m+4,M=HEAP[P+8*m];f:do if(F)if(HEAP[G]!=0){f=HEAP[H];f=FUNCTION_TABLE[HEAP[HEAP[f+12]+12]](f,M);HEAP[h]=f;if(f==0)break f;f=HEAP[h];if(!(unSign(HEAP[y],32)>unSign(f,32)))break f;if(HEAP[A+HEAP[h]]!=127)break f;HEAP[z+HEAP[h]]=L}else HEAP[h]=0;else HEAP[h]=0;while(0);for(f=12;;){k=_FT_Get_Next_Char(C,f==12?M:f==18?k:f==19?k:k,h);if(HEAP[h]==0)break;if(unSign(HEAP[O],32)<unSign(k,
32))break;f=HEAP[h];if(unSign(HEAP[B],32)>unSign(f,32))if(HEAP[D+HEAP[h]]==127){HEAP[E+HEAP[h]]=L;f=20}else f=19;else f=18}m=m+1;if(HEAP[K]!=0)f=16;else break e}}while(0);var Q=Q+1;if(HEAP[J]!=0)f=6;else break c}}y=r;A=n+4;C=z=s;B=y!=0;c:do if(B){D=y+92;E=y+92;f=25;for(;;){l=f==29?l:0;f=48+l;F=HEAP[D]!=0;e:do if(F){G=HEAP[E];G=FUNCTION_TABLE[HEAP[HEAP[G+12]+12]](G,f);if(G==0)break e;if(!(unSign(HEAP[A],32)>unSign(G,32)))break e;HEAP[C+G]=HEAP[z+G]|-128}while(0);l=l+1;if(l!=10)f=29;else break c}}while(0)}if(reSign(HEAP[n+
4],32)>reSign(0,32)){s=C=z=A=y=s;n=n+4;for(f=36;;){o=f==36?0:o;f=0+o;B=A+f;D=z+f;E=C+f;F=s+f;G=1+o;if((unSign(HEAP[y+f],8)&-129)==127){HEAP[D]=HEAP[B]&-128;HEAP[F]=HEAP[E]|2}f=reSign(HEAP[n],32)>reSign(G,32);o=o+1;if(f)f=39;else break}}_FT_Set_Charmap(r,q);p=p;HEAP[i]=p;if(p==0)break b;_af_face_globals_free(t);t=0}while(0);HEAP[c]=t;u=k=HEAP[i];if(k==0){HEAP[g+116]=HEAP[e+4];HEAP[g+116+4]=_af_face_globals_free.__index__;c=46}else{j=k;c=45}break a}else c=46;while(0);a:do if(c==46){j=k=u;if(k!=0)break a;
j=b;k=HEAP[e+4];h=j;j=w;i=l=0;HEAP[d]=0;g=h;g=unSign(HEAP[k+4],32)<=unSign(g,32);b:do if(g)HEAP[d]=6;else{l=i;m=l==0;c:do if(m)c=49;else{c=unSign(l+1,32)>=unSign(5,32)?49:50;break c}while(0);if(c==49)l=unSign(HEAP[HEAP[k+8]+h],8)&127;m=HEAP[_af_script_classes+l*4];if(i==0)i=HEAP[m];l=o=HEAP[k+12+HEAP[m]*4];if(o!=0){c=54;break b}o=HEAP[HEAP[k]+100];l=_ft_mem_alloc(o,HEAP[m+8],d);if(HEAP[d]!=0){c=54;break b}HEAP[l]=m;t=HEAP[m+12]!=0;c:do if(t){c=FUNCTION_TABLE[HEAP[m+12]](l,HEAP[k]);HEAP[d]=c;if(HEAP[d]==
0){c=57;break c}HEAP[m+20]!=0&&FUNCTION_TABLE[HEAP[m+20]](l);k=l;h=o;i=k;k!=0&&FUNCTION_TABLE[HEAP[h+8]](h,i);l=0;c=54;break b}while(0);HEAP[k+12+HEAP[m]*4]=l}while(0);HEAP[j]=l;j=k=HEAP[d];if(k!=0)break a;HEAP[e+136]=HEAP[w];j=HEAP[w];if(HEAP[HEAP[HEAP[w]]+16]!=0)FUNCTION_TABLE[HEAP[HEAP[j]+16]](HEAP[w],v);else{j=j+4;HEAP[j]=HEAP[v];HEAP[j+4]=HEAP[v+4];HEAP[j+8]=HEAP[v+8];HEAP[j+12]=HEAP[v+12];HEAP[j+16]=HEAP[v+16];HEAP[j+20]=HEAP[v+20];HEAP[j+24]=HEAP[v+24]}a|=2049;a&=-5;if(HEAP[HEAP[HEAP[w]]+24]!=
0){j=FUNCTION_TABLE[HEAP[HEAP[HEAP[w]]+24]](e+12,HEAP[w]);if(j!=0)break a}j=_af_loader_load_g(e,v,b,a,0)}while(0);b=j}b=b;STACKTOP=d;return b}_af_autofitter_load_glyph.__index__=Runtime.getFunctionIndex(_af_autofitter_load_glyph,"_af_autofitter_load_glyph");
function _ps_mask_ensure(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;a=unSign(HEAP[e+4]+7,32)>>>unSign(3,32);g=unSign(g+7,32)>>>unSign(3,32);HEAP[b]=0;var c=unSign(g,32)>unSign(a,32);a:do if(c){g=g+7&-8;var f=_ft_mem_realloc(d,1,a,g,HEAP[e+8],b);HEAP[e+8]=f;if(HEAP[b]!=0)break a;HEAP[e+4]=g*8}while(0);e=HEAP[b];STACKTOP=b;return e}_ps_mask_ensure.__index__=Runtime.getFunctionIndex(_ps_mask_ensure,"_ps_mask_ensure");
function _ps_mask_set_bit(e,g,d){var b,a;b=0;var c=reSign(g,32)<reSign(0,32);a:do if(!c){a=HEAP[e];if(unSign(g,32)>=unSign(a,32)){b=_ps_mask_ensure(e,g+1,d);if(b!=0)break a;HEAP[e]=g+1}a=HEAP[e+8];var f=reSign(g,32)>>reSign(3,32);a=a+f;f=HEAP[a];var h=g&7;f=reSign(128,32)>>reSign(h,32)&255|f;HEAP[a]=f}while(0);return b}_ps_mask_set_bit.__index__=Runtime.getFunctionIndex(_ps_mask_set_bit,"_ps_mask_set_bit");
function _ps_mask_table_done(e,g){var d=null,b,a=HEAP[e+4];b=HEAP[e+8];if(a!=0)for(d=0;;){d=d==0?0:k;k=b+16*d+8;var c=b+16*d,f=b+16*d+4,h=b+16*d+12,i=HEAP[k];i!=0&&FUNCTION_TABLE[HEAP[g+8]](g,i);HEAP[k]=0;HEAP[c]=0;HEAP[f]=0;HEAP[h]=0;var k=d+1;if(k!=a)d=3;else break}b=HEAP[e+8];b!=0&&FUNCTION_TABLE[HEAP[g+8]](g,b);HEAP[e+8]=0;HEAP[e]=0;HEAP[e+4]=0}_ps_mask_table_done.__index__=Runtime.getFunctionIndex(_ps_mask_table_done,"_ps_mask_table_done");
function _ps_mask_table_alloc(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c,f,h,i;i=c=0;h=HEAP[e];h+=1;a=h;f=unSign(HEAP[e+4],32)<unSign(a,32);a:do if(f){c=h;a=g;g=e;c=c;a=a;f=HEAP[g+4];c=c;HEAP[b]=0;var k=f;if(unSign(c,32)>unSign(k,32)){c=c+7&-8;a=_ft_mem_realloc(a,16,f,c,HEAP[g+8],b);HEAP[g+8]=a;a=HEAP[b];if(a==0){HEAP[g+4]=c;c=g=HEAP[b];a=g!=0?1:0}else{c=a;a=1}}else a=c=0;break a}else a=0;while(0);if(a==0){i=HEAP[e+8]+16*h+-16;HEAP[i]=0;HEAP[i+12]=0;HEAP[e]=h}HEAP[d]=i;e=c;STACKTOP=
b;return e}_ps_mask_table_alloc.__index__=Runtime.getFunctionIndex(_ps_mask_table_alloc,"_ps_mask_table_alloc");function _ps_dimension_done(e,g){_ps_mask_table_done(e+24,g);_ps_mask_table_done(e+12,g);var d=HEAP[e+8];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+8]=0;HEAP[e]=0;HEAP[e+4]=0}_ps_dimension_done.__index__=Runtime.getFunctionIndex(_ps_dimension_done,"_ps_dimension_done");
function _ps_dimension_set_mask_bits(e,g,d,b,a,c){var f=STACKTOP;STACKTOP+=12;Runtime.memset(f,0,12);var h=null,i=f+4,k,j;k=f+8;j=HEAP[e+12];if(j!=0){j=HEAP[e+12+8]+16*j+-16;HEAP[j+12]=a}a=k=_ps_mask_table_alloc(e+12,c,k);if(k==0){e=e+12;h=b;b=0;a=HEAP[e];if(a==0)b=_ps_mask_table_alloc(e,c,f);else HEAP[f]=HEAP[e+8]+16*a+-16;HEAP[i]=HEAP[f];b=e=b;e=e!=0;a:do if(!e){b=_ps_mask_ensure(HEAP[i],h,c);if(b!=0)break a;HEAP[HEAP[i]]=h;a=g;k=unSign(d,32)>>>unSign(3,32);k=a+k;a=d&7;j=reSign(128,32)>>reSign(a,
32);a=HEAP[HEAP[i]+8];if(h==0)break a;a=a;k=k;j=j;var l=h;for(h=4;;){t=h==4?0:t;p=h==4?j:p;r=h==4?k:r;u=h==4?128:u;s=h==4?a:s;h=unSign(HEAP[s],8)&(u^-1);var m=(unSign(HEAP[r],8)&p)!=0,o=h|u;HEAP[s]=(m?o:h)&255;p=reSign(p,32)>>reSign(1,32);if(p==0){var n=r+1;h=6}else h=5;var p=h==6?128:p,r=h==6?n:r;u=reSign(u,32)>>reSign(1,32);if(u==0){var q=s+1;h=8}else h=21;var s=h==8?q:s,u=h==8?128:u,t=t+1;if(t!=l)h=10;else break}h=0}while(0);a=g=b}g=a;STACKTOP=f;return g}
_ps_dimension_set_mask_bits.__index__=Runtime.getFunctionIndex(_ps_dimension_set_mask_bits,"_ps_dimension_set_mask_bits");
function _ps_dimension_add_t1stem(e,g,d,b,a){var c=STACKTOP;STACKTOP+=16;Runtime.memset(c,0,16);var f,h=null,i,k,j,l,m,o;k=c+4;var n,p,r,q,s=c+8;i=c+12;g=g;d=d;j=n=0;if(reSign(d,32)<reSign(0,32)){j|=1;if(d==-21){j|=2;g=d+g}d=0;q=a;h=1}else h=-1;if((h==1?q:a)!=0)HEAP[a]=-1;q=HEAP[e];HEAP[i]=HEAP[e+8];h=0;f=g;l=d;m=h;h=4;a:for(;;){h=h==8?r:0;p=m+h;if(!(unSign(p,32)<unSign(q,32)))break a;if(HEAP[HEAP[i]]==f)if(HEAP[HEAP[i]+4]==l)break a;HEAP[i]+=12;r=h+1;h=8}h=p;p=unSign(h,32)>=unSign(q,32);a:do if(p){p=
b;n=e;l=p;p=i;q=m=0;r=HEAP[n];r+=1;f=r;o=unSign(HEAP[n+4],32)<=unSign(f,32);b:do if(o){m=r;o=l;f=n;l=m;m=o;o=HEAP[f+4];l=l;HEAP[k]=0;var u=o;if(unSign(l,32)>unSign(u,32)){l=l+7&-8;m=_ft_mem_realloc(m,12,o,l,HEAP[f+8],k);HEAP[f+8]=m;m=HEAP[k];if(m==0){HEAP[f+4]=l;m=k=HEAP[k];f=k!=0?11:10}else{m=m;f=11}}else{m=0;f=10}break b}else f=10;while(0);if(f==10){q=HEAP[n+8]+12*r+-12;HEAP[q]=0;HEAP[q+4]=0;HEAP[q+8]=0;HEAP[n]=r}HEAP[p]=q;n=k=m;if(k!=0){f=13;break a}HEAP[HEAP[i]]=g;HEAP[HEAP[i]+4]=d;HEAP[HEAP[i]+
8]=j;f=15;break a}else f=15;while(0);a:do if(f==15){g=b;i=e+12;g=g;k=s;d=0;j=n=HEAP[i];i=i;if(n==0)d=_ps_mask_table_alloc(i,g,c);else HEAP[c]=HEAP[i+8]+16*j+-16;HEAP[k]=HEAP[c];n=i=d;if(i!=0)break a;n=_ps_mask_set_bit(HEAP[s],h,b);if(n!=0)break a;if(a==0)break a;HEAP[a]=h}while(0);e=n;STACKTOP=c;return e}_ps_dimension_add_t1stem.__index__=Runtime.getFunctionIndex(_ps_dimension_add_t1stem,"_ps_dimension_add_t1stem");
function _ps_dimension_end(e,g,d){var b=STACKTOP;STACKTOP+=16;Runtime.memset(b,0,16);var a,c=null,f,h;h=HEAP[e+12];if(h!=0){h=HEAP[e+12+8]+16*h+-16;HEAP[h+12]=g}e=e+24;f=0;g=HEAP[e]-1;h=b+4;var i=b+8,k=b+12,j=b+4,l=b+8,m=b+12,o=HEAP[b],n=e+8,p=e+8,r=e+8,q=e+8,s=g+-1;c=1;a:for(;;){R=c==35?R:0;var u=c==35?Q:o;Q=R*-1;var t=g+Q;Q=s+Q;if(reSign(c==35?Q:g,32)>reSign(0,32))c=2;else{c=2;a=34;break a}b:for(;;){a=c==36?E:0;var v=a*-1,w=t+v;v=Q+v;if(!(reSign(v,32)>=reSign(0,32))){c=37;a=35;break b}c=HEAP[n];
var x=HEAP[p],y=HEAP[c+16*t+8];w=HEAP[x+16*w+-8];x=-1-HEAP[x+16*v];c=-1-HEAP[c+16*t];x=-1-(unSign(x,32)>unSign(c,32)?x:c);for(c=3;;){var A=c==6?D:0,z=x+A*-8,C=w+A,B=y+A;if(!(unSign(z,32)>unSign(7,32)))break;if((HEAP[C]&HEAP[B])!=0){a=5;break b}var D=A+1;c=6}if(z!=0){c=unSign(HEAP[C]&HEAP[B],8);y=reSign(255,32)>>reSign(z,32)^-1;if((c&y)!=0){c=11;a=7;break b}}var E=a+1;c=36;a=37}b:do if(a==5){c=5;a=7;break b}while(0);b:do if(a==7){c=(Q=reSign(v,32)>reSign(t,32))?t:v;Q=Q?v:t;y=reSign(c,32)<reSign(Q,
32);w=reSign(c,32)>=reSign(0,32);y=y&w;c:do if(y){if(!(reSign(HEAP[e],32)>reSign(Q,32))){a=13;break c}a=HEAP[r]+16*c;t=HEAP[q]+16*Q;y=HEAP[a];w=HEAP[t];x=w!=0;d:do if(x){var F=unSign(w,32)>unSign(y,32);e:do if(F){c=41;var G=_ps_mask_ensure(a,w,d);if(G!=0){a=14;break a}if(!(unSign(y,32)<unSign(w,32))){c=15;break e}A=y+1;var H=a,J=a+8;c=y+1;var L=(unSign(w,32)>unSign(c,32)?w:c)-y;for(c=17;;){P=c==17?0:P;c=y+P;var N=HEAP[H];if(!(unSign(c,32)>=unSign(N,32))){N=HEAP[J];var I=reSign(c,32)>>reSign(3,32);
N=N+I;I=HEAP[N];c=c&7;c=reSign(128,32)>>reSign(c,32)&255^-1;HEAP[N]=I&c}var P=P+1;if(P!=L)c=22;else break}unSign(w,32);unSign(A,32);c=23}else c=41;while(0);F=c==23?G:c==15?0:0;A=HEAP[t+8];H=HEAP[a+8];if(unSign(w+7,32)>>>unSign(3,32)==0){c=18;break d}J=unSign(w+7,32)>>>unSign(3,32);for(c=25;;){K=c==25?0:K;c=H+K;HEAP[c]=HEAP[A+K]|HEAP[c];var K=K+1;if(K!=J)c=27;else break}c=28}else c=12;while(0);a=c==28?F:c==18?F:0;HEAP[t]=0;HEAP[t+12]=0;var O=HEAP[e]-Q+-1;if(reSign(O,32)>reSign(0,32)){var M=HEAP[t];
HEAP[h]=HEAP[t+4];HEAP[i]=HEAP[t+8];HEAP[k]=HEAP[t+12];_llvm_memmove_p0i8_p0i8_i32(t,t+16,O*16,1,0);O=t+16*O;HEAP[O]=M;HEAP[O+4]=HEAP[j];HEAP[O+8]=HEAP[l];HEAP[O+12]=HEAP[m];c=30}else c=26;O=c==30?M:u;HEAP[e]-=1;f=a;if(a!=0){c=33;a=34;break a}else{c=33;break b}}while(0);f=0;c=13}while(0);var Q=c==33?O:c==13?u:u,R=R+1;c=35;a=2}if(a==14){HEAP[b]=u;f=G}else if(a==34)HEAP[b]=c==33?O:u;d=f;STACKTOP=b;return d}_ps_dimension_end.__index__=Runtime.getFunctionIndex(_ps_dimension_end,"_ps_dimension_end");
function _ps_hints_stem(e,g,d,b){var a,c=null;g=g;var f=HEAP[e+4]==0;a:do if(f){c=reSign(g,32)<reSign(0,32);var h=reSign(g,32)>reSign(1,32);if(c|h)g=unSign(g!=0,1);c=HEAP[e+12];if(c!=1)if(c!=2)break a;c=e+16+g*36;h=d;var i=e,k=c,j=b,l=d+-1;for(c=1;;){a=c==4?r:0;var m=a*2,o=j+4*m;m=j+4*(m+1);var n=l+a*-1;if((c==4?n:h)==0){a=6;break}var p=_ps_dimension_add_t1stem(k,HEAP[o],HEAP[m],HEAP[i],0);if(p!=0){a=3;break}var r=a+1;c=4;a=2}if(a!=6)if(a==3){c=p;HEAP[e+4]=c}}while(0)}
_ps_hints_stem.__index__=Runtime.getFunctionIndex(_ps_hints_stem,"_ps_hints_stem");
function _ps_hints_t1stem3(e,g,d){var b=STACKTOP;STACKTOP+=16;Runtime.memset(b,0,16);var a,c=null,f,h,i,k,j,l,m=b+4;l=g;d=d;f=0;g=HEAP[e+4]==0;a:do if(g){g=HEAP[e];var o=reSign(l,32)<reSign(0,32);h=reSign(l,32)>reSign(1,32);if(o|h)l=unSign(l!=0,1);l=e+16+l*36;o=HEAP[e+12]==1;b:do if(o){h=l;i=g;k=d;c=1;c:for(;;){j=c==10?v:0;a=j*2;var n=k+4*a,p=k+4*(a+1);a=m+(0+j)*4;var r=1+j;if(!(reSign(c==10?r:0,32)<=reSign(2,32))){a=12;break c}f=HEAP[p];if(reSign(f,32)>=reSign(0,32)){var q=f+32768&-65536;c=3}else{var s=
0-(32768-f&-65536);c=5}f=reSign(c==3?q:s,32)>>reSign(16,32);c=HEAP[n];if(reSign(c,32)>=reSign(0,32)){var u=c+32768&-65536;c=6}else{var t=0-(32768-c&-65536);c=8}c=reSign(c==6?u:t,32)>>reSign(16,32);f=c=_ps_dimension_add_t1stem(h,c,f,i,a);if(c!=0){a=9;break c}var v=j+1;c=10;a=2}if(a==12){d=n;k=HEAP[m+8];i=HEAP[m+4];h=HEAP[m];c=g;f=l;h=h;i=i;k=k;j=c;c=HEAP[f+24];HEAP[b]=HEAP[f+24+8];a=c;p=h;r=i;var w=k,x=c;c=w&7;var y=reSign(128,32)>>reSign(c,32);c=r&7;var A=reSign(128,32)>>reSign(c,32);c=p&7;var z=
reSign(128,32)>>reSign(c,32),C=x+-1,B=reSign(w,32)>>reSign(3,32),D=reSign(r,32)>>reSign(3,32),E=reSign(p,32)>>reSign(3,32);c=12;c:for(;;){var F=c==21?J:0,G=F*-1,H=C+G;G=x+G;if((c==21?H:a)==0){c=13;break c}c=HEAP[b];H=HEAP[c];if(!(unSign(p,32)>=unSign(H,32)))if((unSign(HEAP[HEAP[c+8]+E],8)&z)!=0){c=15;break c}c=HEAP[b];H=HEAP[c];if(!(unSign(r,32)>=unSign(H,32)))if((unSign(HEAP[HEAP[c+8]+D],8)&A)!=0){c=18;break c}c=HEAP[b];H=HEAP[c];if(!(unSign(w,32)>=unSign(H,32)))if((unSign(HEAP[HEAP[c+8]+B],8)&y)!=
0){c=20;break c}HEAP[b]+=16;var J=F+1;c=21}p=G==0;c:do if(p){var L=f=_ps_mask_table_alloc(f+24,j,b);if(L!=0){c=23;a=24}else{c=23;a=25}break c}else a=25;while(0);c:do if(a==25){var N=_ps_mask_set_bit(HEAP[b],h,j);if(N!=0){c=25;a=24;break c}var I=f=_ps_mask_set_bit(HEAP[b],i,j);if(I!=0){c=26;a=24;break c}f=m=_ps_mask_set_bit(HEAP[b],k,j);if(m!=0)break b;else break a}while(0);f=c==23?L:c==25?N:I}else if(a==9)d=n}else f=6;while(0);HEAP[e+4]=f;STACKTOP=b;return}while(0);STACKTOP=b}
_ps_hints_t1stem3.__index__=Runtime.getFunctionIndex(_ps_hints_t1stem3,"_ps_hints_t1stem3");
function _ps_hints_t1reset(e,g){var d=STACKTOP;STACKTOP+=8;Runtime.memset(d,0,8);var b,a,c,f,h,i=d+4,k;k=HEAP[e+4]==0;a:do if(k){k=HEAP[e];var j=HEAP[e+12]==1;b:do if(j){b=g;h=k;f=e+16;b=b;h=h;a=b;b=f;a=a;c=HEAP[b+12];if(c!=0){b=HEAP[b+12+8]+16*c+-16;HEAP[b+12]=a}f=h=_ps_mask_table_alloc(f+12,h,i);if(h!=0)break b;b=g;h=k;f=e+16+36;b=b;h=h;a=b;b=f;a=a;c=HEAP[b+12];if(c!=0){b=HEAP[b+12+8]+16*c+-16;HEAP[b+12]=a}f=h=_ps_mask_table_alloc(f+12,h,d);if(h==0)break a}else f=6;while(0);HEAP[e+4]=f;STACKTOP=
d;return}while(0);STACKTOP=d}_ps_hints_t1reset.__index__=Runtime.getFunctionIndex(_ps_hints_t1reset,"_ps_hints_t1reset");function _ps_hints_t2mask(e,g,d,b){var a,c,f,h,i=HEAP[e+4]==0;a:do if(i){c=e+16;f=HEAP[e];a=HEAP[c];h=HEAP[c+36];if(h+a!=d)break a;a=_ps_dimension_set_mask_bits(c,b,h,a,g,f);if(a==0){a=_ps_dimension_set_mask_bits(c+36,b,0,h,g,f);if(a==0)break a}HEAP[e+4]=a}while(0)}_ps_hints_t2mask.__index__=Runtime.getFunctionIndex(_ps_hints_t2mask,"_ps_hints_t2mask");
function _ps_hints_t2counter(e,g,d){var b,a,c,f,h,i=HEAP[e+4]==0;a:do if(i){a=e+16;c=HEAP[e];f=HEAP[a];h=HEAP[a+36];if(h+f!=g)break a;b=_ps_dimension_set_mask_bits(a,d,0,f,0,c);if(b==0){b=_ps_dimension_set_mask_bits(a+36,d,f,h,0,c);if(b==0)break a}HEAP[e+4]=b}while(0)}_ps_hints_t2counter.__index__=Runtime.getFunctionIndex(_ps_hints_t2counter,"_ps_hints_t2counter");
function _ps_hints_close(e,g){var d,b,a;d=HEAP[e+4];var c=d==0;a:do if(c){b=HEAP[e];a=e+16;d=_ps_dimension_end(a,g,b);if(d!=0)break a;d=_ps_dimension_end(a+36,g,b)}while(0);return d}_ps_hints_close.__index__=Runtime.getFunctionIndex(_ps_hints_close,"_ps_hints_close");function _t1_hints_open(e){var g;HEAP[e+4]=0;HEAP[e+12]=1;g=e+16;HEAP[g]=0;HEAP[g+12]=0;HEAP[g+24]=0;e=e+16+36;HEAP[e]=0;HEAP[e+12]=0;HEAP[e+24]=0}_t1_hints_open.__index__=Runtime.getFunctionIndex(_t1_hints_open,"_t1_hints_open");
function _t1_hints_stem(e,g,d){var b=STACKTOP;STACKTOP+=8;Runtime.memset(b,0,8);var a;a=HEAP[d];a=reSign(a,32)>=reSign(0,32)?a+32768&-65536:0-(32768-a&-65536);a=reSign(a,32)>>reSign(16,32);HEAP[b]=a;d=HEAP[d+4];d=reSign(d,32)>=reSign(0,32)?d+32768&-65536:0-(32768-d&-65536);d=reSign(d,32)>>reSign(16,32);HEAP[b+4]=d;_ps_hints_stem(e,g,1,b);STACKTOP=b}_t1_hints_stem.__index__=Runtime.getFunctionIndex(_t1_hints_stem,"_t1_hints_stem");
function _ps_hints_apply(e,g,d,b){var a=STACKTOP;STACKTOP+=200;Runtime.memset(a,0,200);var c,f=null,h,i,k,j,l,m,o,n,p,r,q,s,u,t,v,w;h=a+64;var x,y,A,z,C,B,D,E,F,G,H,J,L,N,I,P=a+68,K,O,M,Q;M=a+72;I=HEAP[g+2]==0;a:do if(I)c=0;else{if(HEAP[g]==0){c=0;break a}g=g;N=e;I=d;e=M;g=g;N=N;I=I;_llvm_memset_p0i8_i32(e,0,128,1,0);HEAP[e+16]=HEAP[I];K=HEAP[e+16];var R=reSign(HEAP[g+2],16);R=_ft_mem_realloc(K,48,0,R,0,P);HEAP[e+8]=R;R=HEAP[P];var T=R!=0;b:do if(T){f=1;c=4}else{var V=reSign(HEAP[g],16);V=_ft_mem_realloc(K,
8,0,V,0,P);HEAP[e+12]=V;V=HEAP[P];if(V!=0){f=3;c=4;break b}else f=3;z=reSign(HEAP[g+2],16);HEAP[e]=z;z=reSign(HEAP[g],16);HEAP[e+4]=z;B=HEAP[e+8];O=HEAP[e+12];if(unSign(HEAP[e+4],32)>unSign(0,32)){z=g+12;B=D=E=C=B;O=O;f=6;c:for(;;){W=f==6?0:W;c=f==6?0:U;r=n=O+8*W;s=O+8*W+4;p=1+W;f=HEAP[HEAP[z]+2*(0+W)];var U=reSign(f,16)+1;q=U-c;HEAP[r]=C+48*c;HEAP[s]=q;if(reSign(q,32)>reSign(0,32)){r=E+48*c;HEAP[r]=D+48*U+-48;HEAP[r+8]=n;if(reSign(q,32)>reSign(1,32)){var S=q*-1;S=reSign(S,32)>reSign(-2,32)?S:-2;
s=c+-1;f=reSign(f,16);s=s-f;s=(reSign(s,32)>reSign(-2,32)?s:-2)+2+f-c;t=c+1;for(f=8;;){Y=f==8?0:Y;v=t+Y;u=f=E+48*v;v=E+48*v+8;w=c+Y;var X=E+48*w;HEAP[E+48*w+4]=f;HEAP[u]=X;HEAP[v]=n;var Y=Y+1;if(Y!=s)f=9;else break}S=r+48+48*(S+q);f=10}else f=266;HEAP[(f==10?S:r)+4]=B+48*c}f=unSign(HEAP[e+4],32)>unSign(p,32);var W=W+1;if(f)f=14;else{f=14;break c}}}t=C=HEAP[e+8];r=HEAP[g+4];if(unSign(HEAP[e],32)>unSign(0,32)){C=z=C;E=g+8;r=q=p=n=c=O=B=D=r;s=e;t=t;f=17;c:for(;;){ca=f==17?0:ca;f=1+ca;y=0+ca;X=r+8*y+
4;A=p+8*y;x=O+8*y+4;var da=D+8*y;u=t+48*ca+21;v=t+48*ca+20;w=t+48*ca+12;var ba=t+48*ca+4,aa=Math.floor(reSign(HEAP[t+48*ca]-z,32)/reSign(48,32));ba=Math.floor(reSign(HEAP[ba]-C,32)/reSign(48,32));if((reSign(HEAP[HEAP[E]+y],8)&1)==0)HEAP[w]=1;y=HEAP[da]-HEAP[B+8*aa];x=HEAP[x]-HEAP[c+8*aa+4];aa=_psh_compute_dir(y,x)&255;HEAP[v]=aa;A=HEAP[n+8*ba]-HEAP[A];X=HEAP[q+8*ba+4]-HEAP[X];ba=_psh_compute_dir(A,X)&255;HEAP[u]=ba;ba=(HEAP[w]&1&255)!=0;d:do{if(!ba){if(HEAP[v]!=HEAP[u])break d;if(HEAP[u]==4)if(_ft_corner_is_flat(y,
x,A,X)==0)break d}HEAP[w]|=2}while(0);f=unSign(HEAP[s],32)>unSign(f,32);var ca=ca+1;if(f)f=22;else{f=22;break c}}}HEAP[e+20]=g;HEAP[e+24]=I;_psh_glyph_load_points(e,0);z=e;E=C=0;c=unSign(HEAP[z+4],32)>unSign(E,32)?26:27;c:for(;;)if(c==26){if(!(unSign(HEAP[HEAP[z+12]+8*C+4],32)<=unSign(3,32))){O=D=E=B=HEAP[HEAP[z+12]+8*C];n=D+36;p=D+40;E=E;q=G;r=F;f=28;d:for(;;){var $=f==33?0:r,la=f==33?0:q,ga=HEAP[(f==33?ga:E)+4];if(ga==O){c=30;break d}var ea=HEAP[ga+36]-HEAP[n],Z=HEAP[ga+40]-HEAP[p];if(ea!=0){f=
31;c=32;break d}if(Z==0){f=33;c=29}else{f=33;c=32;break d}}if(c==30){F=$;G=la}else if(c==32){F=f==33?0:ea;G=Z;E=ga;f=D;D=B;B=F;O=G;n=f;p=J;q=H;f=32;d:for(;;){var ha=f==32?q:f==37?ka:0,ia=f==32?p:f==37?na:0,ja=f==32?n:f==36?fa:fa,fa=HEAP[ja];if(fa==D){c=35;break d}var ka=HEAP[ja+36]-HEAP[fa+36],na=HEAP[ja+40]-HEAP[fa+40];if((ka!=0^1)&na==0){f=36;c=34;continue d}L=f=_ft_corner_orientation(B,O,ka,na);if(f==0){f=37;c=34}else{f=37;c=38;break d}}if(c==35){H=ha;J=ia}else if(c==38){H=ka;J=na;B=D=ja;F=H;G=
J;H=B;J=E;F=F;G=G;E=D;L=L;f=38;d:for(;;){B=f==44?ta:L;D=f==44?sa:E;O=f==44?pa:G;c=f==44?Da:F;n=f==44?wa:J;p=f==44?0:0;f=39;e:for(;;){Aa=f==39?p:f==40?Aa:Aa;var sa=f==39?n:f==40?wa:wa,wa=HEAP[sa+4],Aa=wa==H?1:Aa,Da=HEAP[wa+36]-HEAP[sa+36],pa=HEAP[wa+40]-HEAP[sa+40];if((Da!=0^1)&pa==0){f=40;continue e}var ta=_ft_corner_orientation(c,O,Da,pa);if(ta==0)f=41;else break e}if(reSign(ta^B,32)<reSign(0,32)){f=42;c=43}else{f=42;c=44}for(;;)if(c==43){ma=f==43?ma:D;HEAP[ma+12]|=4;var ma=HEAP[ma+4];if(ma!=sa)c=
f=43;else{f=43;HEAP[ma+12]|=4;c=44}}else if(c==44)if(Aa==0){f=44;continue d}else{f=44;break d}}J=pa;H=Da;L=ta;G=pa;F=Da}}}C+=1;E=C;c=unSign(HEAP[z+4],32)>unSign(E,32)?26:27}else if(c==27){var ya=_psh_hint_table_init(e+28,N+16,N+16+12,N+16+24,K);HEAP[P]=ya;if(ya!=0){f=27;c=4;break b}else{f=27;c=48;break c}}z=_psh_hint_table_init(e+28+40,N+16+36,N+16+36+12,N+16+36+24,K);Q=HEAP[P]=z;if(z!=0){c=50;break b}C=HEAP[M+24]+4;z=HEAP[M+24]+4+204;D=HEAP[C+196];B=HEAP[z+196];z=D;C=B;E=0;O=_FT_MulFix(HEAP[d+412+
4],B);n=O+32&-64;p=n!=0;c:do if(p){if(O==n){c=53;break c}E=1;B=_FT_MulDiv(B,n,O);q=O;if(reSign(n,32)<reSign(q,32)){q=Math.floor(reSign(D,32)/reSign(50,32));D-=q}_psh_globals_set_scale(HEAP[M+24],D,B,0,0)}while(0);HEAP[M+120]=1;HEAP[M+121]=1;D=b==2|b==3?1:0;HEAP[M+122]=D&255;D=b==2|b==4?1:0;HEAP[M+123]=D&255;D=unSign(b!=1,1);HEAP[M+124]=D;D=0;O=B=a;for(;;){_psh_glyph_load_points(M,D);n=M;p=0;d:for(;;){f=p;if(!(unSign(HEAP[n+4],32)>unSign(f,32))){c=76;break d}c=HEAP[HEAP[n+12]+8*p];if(HEAP[HEAP[n+12]+
8*p+4]!=0){c=f=r=c;q=r+36;r=f;f=60;e:for(;;){var qa=HEAP[f==63?qa:r];if(qa==c){c=62;break d}if(HEAP[qa+36]==HEAP[q])f=63;else break e}f=qa;r=q=c=r=HEAP[f+4];s=f;f=64;e:for(;;){c=f==72?Na:s;t=f==72?ua:r;u=t+36;f=65;f:for(;;){var ua=HEAP[(f==68?ua:t)+4];if(ua==q)break e;if(HEAP[ua+36]==HEAP[u])f=68;else break f}f=HEAP[t+36];u=reSign(HEAP[c+36],32)<reSign(f,32);v=HEAP[ua+36];w=HEAP[t+36];f:do{if(u)if(reSign(v,32)<reSign(w,32)){f=70;c=71}else{f=70;c=72}else if(reSign(v,32)>reSign(w,32)){f=73;c=71}else{f=
73;c=72}break f}while(0);for(;;)if(c==71){Ba=f==71?Ba:f==70?t:t;HEAP[Ba+16]|=64;var Ba=HEAP[Ba+4];if(Ba!=ua)c=f=71;else{f=71;c=72}}else if(c==72){var Na=HEAP[ua];f=72;continue e}}}p+=1;c=59}d:do if(c==76){p=0;c=77;break d}else if(c==62){c=90;break d}while(0);d:for(;;)if(c==77){f=p;if(!(unSign(HEAP[n],32)>unSign(f,32)))break d;r=s=q=HEAP[n+8]+48*p;if((HEAP[q+16]&64)!=0){t=q;u=q+40;v=s;f=78;e:for(;;){var Ea=HEAP[f==78?v:Ea];if(Ea==t){c=80;break e}if(HEAP[Ea+40]==HEAP[u]){f=81;c=79}else{c=82;break e}}if(c==
80){c=90;continue d}else if(c==82){s=Ea;t=q;u=q+40;v=r;for(f=82;;){var ra=HEAP[(f==82?v:ra)+4];if(ra==t){c=84;break}if(HEAP[ra+40]==HEAP[u]){f=85;c=83}else{c=86;break}}if(c==84){c=90;continue d}else if(c==86)r=ra}}f=HEAP[q+40];f=reSign(HEAP[s+40],32)>=reSign(f,32);e:do if(!f){f=HEAP[q+40];if(reSign(HEAP[r+40],32)<=reSign(f,32))break e;HEAP[q+16]|=128;c=90;continue d}while(0);f=HEAP[q+40];if(!(reSign(HEAP[s+40],32)>reSign(f,32))){c=90;continue d}f=HEAP[q+40];if(!(reSign(HEAP[r+40],32)<reSign(f,32))){c=
90;continue d}HEAP[q+16]|=256;c=90}else if(c==90){p+=1;c=77}c=HEAP[M+24];p=D;f=M;n=M+28+D*40;c=c;p=p;q=f;f=HEAP[n+8];n=r=HEAP[n];if(r!=0){c=c;p=p;q=q;r=f;n=n;for(f=95;;){za=f==95?0:za;_psh_hint_align(r+28*za,c,p,q);var za=za+1;if(za!=n)f=96;else break}}f=D;c=M;q=f;n=c+28+q*40;y=HEAP[HEAP[n+32]+8];f=HEAP[HEAP[n+32]];p=p=q==0?1:2;q=HEAP[c+24]+4+q*204;q=HEAP[q+196];q=r=_FT_DivFix(32,q);if(reSign(r,32)>reSign(30,32))q=30;r=f;if(unSign(r,32)>unSign(1,32)){var Ha=HEAP[c]!=0;d:do if(Ha){s=HEAP[y+12];t=HEAP[c];
A=unSign(s,32)<=unSign(t,32)?s:t;y+=16;if(!(unSign(f,32)>unSign(1,32)))break d;s=c;t=c+8;v=u=n;w=q;X=p;y=y;A=A;aa=f;f=0-aa;ba=unSign(f,32)>unSign(-2,32)?f:-2;f=aa+1;x=f+ba;aa=aa*-1;aa=unSign(aa,32)>unSign(-2,32)?aa:-2;aa=f+aa;for(f=101;;){Pa=f==101?0:Pa;da=f==101?A:va;f=y+16*Pa;va=HEAP[y+16*Pa+12];var Ca=HEAP[s],va=unSign(va,32)<=unSign(Ca,32)?va:Ca;Ca=va-da;if(reSign(Ca,32)>reSign(0,32)){da=HEAP[t]+48*da;_psh_hint_table_activate_mask(u,f);_psh_hint_table_find_strong_points(v,da,Ca,w,X)}var Pa=Pa+
1;if(Pa!=aa)f=106;else break}s=y+16*x;f=-1-ba;y=s}while(0);Ha=f;f=102}else f=290;if((f==102?Ha:r)==1){f=HEAP[c];r=HEAP[c+8];_psh_hint_table_activate_mask(n,HEAP[HEAP[n+32]+8]);_psh_hint_table_find_strong_points(n,r,f,q,p)}f=n=HEAP[c];c=HEAP[c+8];if(n!=0){c=c;n=f;f=111;d:for(;;){Ja=f==111?0:Ja;f=c+48*Ja+16;p=HEAP[c+48*Ja+32]!=0;e:do if(p){if((HEAP[f]&16)!=0)break e;HEAP[f]|=16}while(0);var Ja=Ja+1;if(Ja!=n)f=114;else break d}}n=D==1;d:do if(n){f=M;c=d+412;q=f;f=p=HEAP[q];x=HEAP[q+8];if(p==0)break d;
q=p=c;r=c+2076;s=c+2076;t=c+2080;u=c+2072;v=c;w=v+516;X=c+2076;y=c+2076;A=c+2080;ba=c+2072;x=x;aa=f;da=v+516;f=118;e:for(;;){ab=f==118?0:ab;f=x+48*ab+20;var La=x+48*ab+21;Ca=x+48*ab+16;var xa=x+48*ab+36,oa=x+48*ab+44,Fa=HEAP[f]!=2;f:do if(Fa){if(HEAP[f]==-2){c=122;break f}if(HEAP[La]==2){c=122;break f}c=HEAP[La]!=-2?124:122;break f}else c=122;while(0);f:do if(c==122){if((HEAP[Ca]&16)!=0)break f;La=HEAP[xa];Fa=HEAP[q];f=125;g:for(;;){f=f==131?Ra:0;c=p+4+f*32+24;var Ma=p+4+f*32+8,Ka=p+4+f*32+12;if(Fa+
f*-1==0){c=128;break g}Ka=La-HEAP[Ka];if(reSign(0-HEAP[r],32)>reSign(Ka,32)){c=128;break g}Ra=reSign(HEAP[s]+HEAP[Ma],32)>=reSign(La,32);h:do if(Ra){if(HEAP[t]==0)if(!(reSign(HEAP[u],32)>=reSign(Ka,32)))break h;HEAP[oa]=HEAP[c];HEAP[Ca]|=16;HEAP[Ca]|=32}while(0);var Ra=f+1;f=131;c=126}Fa=HEAP[w];Ma=Fa*8;Ka=Fa+15;f=128;for(;;){f=f==137?Ua:0;var Qa=f*-1;c=da+4*(Ma+f*-8);var Va=Ka+Qa,Ta=v+4+Va*32+16;if(Fa+Qa==0)break f;Qa=HEAP[v+4+Va*32+12]-La;if(reSign(0-HEAP[X],32)>reSign(Qa,32))break f;Ua=reSign(HEAP[Ta]-
HEAP[y],32)<=reSign(La,32);h:do if(Ua){if(HEAP[A]==0)if(!(reSign(HEAP[ba],32)>reSign(Qa,32)))break h;HEAP[oa]=HEAP[c];HEAP[Ca]|=16;HEAP[Ca]|=32}while(0);var Ua=f+1;f=137;c=133}}while(0);var ab=ab+1;if(ab!=aa)f=124;else break e}}while(0);f=D;c=M;f=f;f=HEAP[c+24]+4+f*204;n=HEAP[f+196];f=q=HEAP[c];p=HEAP[c+8];if(q!=0){n=c=n;p=p;q=f;for(f=141;;){Sa=f==141?0:Sa;t=p+48*Sa+36;f=p+48*Sa+44;r=p+48*Sa+16;s=HEAP[p+48*Sa+32];if(s!=0){if((HEAP[r]&512)!=0)HEAP[f]=HEAP[s+8];else if((HEAP[r]&1024)!=0)HEAP[f]=HEAP[s+
12]+HEAP[s+8];else{t=HEAP[t]-HEAP[s];if(reSign(t,32)<=reSign(0,32)){s=HEAP[s+8];s=_FT_MulFix(t,c)+s;HEAP[f]=s}else{v=reSign(HEAP[s+4],32)<=reSign(t,32);u=HEAP[s+8];if(v){v=HEAP[s+12];s=_FT_MulFix(t-HEAP[s+4],n);HEAP[f]=v+u+s}else{s=_FT_MulDiv(t,HEAP[s+12],HEAP[s+4])+u;HEAP[f]=s}}}HEAP[r]|=32}var Sa=Sa+1;if(Sa!=q)f=151;else break}}c=D;f=M;c=c;c=HEAP[f+24]+4+c*204;c=HEAP[c+196];n=HEAP[f+16];u=0;p=HEAP[f+8];q=p+48*HEAP[f];r=p;if(r<q){s=q;t=u;for(f=154;;){$a=f==154?t:$a;f=$a+1;var $a=(HEAP[r+16]&16)!=
0?f:$a;r+=48;if(r<s)f=155;else break}u=$a;f=156}else{var Wa=u;f=158}s=(f==158?Wa:$a)==0;d:do if(!s){if(unSign(u,32)<=unSign(16,32))t=B;else{t=_ft_mem_realloc(n,4,0,u,0,h);if(HEAP[h]!=0)break d}u=0;r=p;if(r<q){v=q;X=w=t;u=u;f=161;e:for(;;){Oa=f==161?u:Oa;if((HEAP[r+16]&16)==0)f=162;else{var eb=Oa+-1;for(f=163;;){f=f==166?ob:0;var Ga=f*-1;y=w+4*(eb+Ga);Ga=w+4*(Oa+Ga);if(!(Ga>X))break;A=HEAP[r+36];if(reSign(HEAP[HEAP[y]+36],32)<=reSign(A,32))break;HEAP[Ga]=HEAP[y];var ob=f+1;f=166}HEAP[Ga]=r;eb=Oa+1;
f=165}var Oa=f==165?eb:Oa;r+=48;if(r<v)f=169;else{f=169;break e}}u=Oa}r=p;if(r<q){v=q;w=u;y=X=t;A=c;ba=t;x=u;aa=t;da=u;Ca=t;xa=c;oa=t;La=x+-1;f=172;e:for(;;){Fa=(HEAP[r+16]&16)!=0;f:do if(!Fa){if((HEAP[r+12]&2)!=0){if(HEAP[r+20]==4)break f;if(HEAP[r+20]!=HEAP[r+21])break f;if((HEAP[r+16]&64)==0)if((HEAP[r+12]&4)==0)break f;HEAP[r+12]&=-3}Ma=r+36;f=181;g:for(;;){var Xa=f==184?bb:0;f=X+4*Xa;if(!(unSign(Xa,32)<unSign(w,32)))break g;Ka=HEAP[Ma];if(reSign(HEAP[HEAP[f]+36],32)>reSign(Ka,32))break g;var bb=
Xa+1;f=184}if(Xa==0){f=HEAP[y];Ma=HEAP[f+44];f=_FT_MulFix(HEAP[r+36]-HEAP[f+36],A)+Ma;HEAP[r+44]=f}else{Ma=HEAP[ba+4*(Xa-1)];Ka=r+36;for(f=188;;){f=f==192?Za:0;var jb=f*-1;Ta=aa+4*(La+jb);jb=x+jb;if(jb==0){f=189;break}Qa=HEAP[Ka];if(reSign(HEAP[HEAP[Ta]+36],32)<reSign(Qa,32)){f=190;break}var Za=f+1;f=192}f=f==189?0:jb;if(f==da){f=HEAP[Ca+4*(f-1)];Ma=HEAP[f+44];f=_FT_MulFix(HEAP[r+36]-HEAP[f+36],xa)+Ma;HEAP[r+44]=f}else{f=HEAP[oa+4*f];Ka=HEAP[r+36];if(HEAP[Ma+36]==Ka)HEAP[r+44]=HEAP[Ma+44];else if(HEAP[f+
36]==Ka)HEAP[r+44]=HEAP[f+44];else{Ta=HEAP[Ma+44];f=_FT_MulDiv(Ka-HEAP[Ma+36],HEAP[f+44]-HEAP[Ma+44],HEAP[f+36]-HEAP[Ma+36])+Ta;HEAP[r+44]=f}}}HEAP[r+16]|=32}while(0);r+=48;if(r<v)f=175;else{f=175;break e}}}if(O==t)break d;t=t;r=n;t=t;if(t==0)break d;FUNCTION_TABLE[HEAP[r+8]](r,t)}while(0);n=D;c=M;n=n;p=HEAP[c+24]+4+n*204;n=HEAP[p+196];r=HEAP[p+200];p=HEAP[c+12];q=c=HEAP[c+4];c=c!=0?204:205;d:for(;;)if(c==204){s=HEAP[p];t=s+48*HEAP[p+4];u=w=0;v=s;if(v<t){X=t;w=w;u=u;for(f=206;;){Ia=f==206?u:Ia;cb=
f==206?w:cb;if((HEAP[v+16]&32)!=0){var fb=v;fb=Ia==0?fb:Ia;var Ya=cb+1;f=208}else f=207;var Ia=f==208?fb:Ia,cb=f==208?Ya:cb;v+=48;if(v<X){f=210;c=207}else{c=211;break}}u=Ia;w=cb;f=211}else{var pb=w;f=213}X=unSign(f==213?pb:cb,32)<=unSign(1,32);e:do if(X){if(w==1){r=HEAP[u+44];v=_FT_MulFix(HEAP[u+36],n);r=r-v}v=s;if(!(v<t))break e;y=u;A=n;ba=r;for(x=t;;){if(v!=y){c=_FT_MulFix(HEAP[v+36],A)+ba;HEAP[v+44]=c}v+=48;if(v<x)c=217;else break e}}else{y=s=u;ba=A=n;x=s;aa=u;f=219;f:for(;;){c=f==236?kb:aa;f=
220;g:for(;;){var gb=f==220?c:hb,hb=HEAP[gb+4];if(hb==y){c=222;break f}if((HEAP[hb+16]&32)==0){f=223;break g}else f=223}g:for(;;){var kb=HEAP[(f==224?kb:hb)+4];if((HEAP[kb+16]&32)!=0)break g;else f=224}f=HEAP[kb+36];if(reSign(HEAP[gb+36],32)<=reSign(f,32)){var db=HEAP[gb+36],ub=HEAP[gb+44],yb=HEAP[kb+36]-db,rb=HEAP[kb+44]-ub;f=226}else{var zb=HEAP[kb+36],Fb=HEAP[kb+44],Ib=HEAP[gb+36]-zb,qb=HEAP[gb+44]-Fb;f=228}c=f==228?Ib:yb;oa=f==228?qb:rb;da=f==228?Fb:ub;Ca=f==228?zb:db;if(reSign(c,32)>reSign(0,
32)){var xb=_FT_DivFix(oa,c);f=229}else f=325;xa=f==229?xb:65536;v=HEAP[gb+4];for(oa=da+oa;;){f=HEAP[v+36]-Ca;if(reSign(f,32)<=reSign(0,32)){var Jb=_FT_MulFix(f,A)+da;f=232}else if(reSign(f,32)>=reSign(c,32)){var Hb=_FT_MulFix(f-c,ba);Hb=oa+Hb;f=234}else{var Nb=_FT_MulFix(f,xa)+da;f=235}HEAP[v+44]=f==235?Nb:f==234?Hb:Jb;v=HEAP[v+4];if(v==kb)break}if(kb!=x){f=236;c=220}else{f=236;c=237;break f}}if(c==222){t=hb;u=gb}else if(c==237)u=t=kb}while(0);q=c=q-1;p+=8;c=c!=0?204:205}else if(c==205){k=D;i=M;
k=k;l=HEAP[i+8];m=HEAP[HEAP[i+20]+4];o=HEAP[HEAP[i+20]+8];c=j=0;c=unSign(HEAP[i],32)>unSign(c,32)?239:240;break d}if(c==239){n=k==0;p=m;q=o;r=k==0;s=o;t=i;j=j;l=l;u=j+1;d:do if(n){if(r){f=241;c=242}else{f=241;c=243}for(;;)if(c==242){vb=f==244?vb:0;var lb=u+vb;f=j+vb;c=s+f;v=q+f;var Gb=l+48*(vb+1);w=l+48*vb+16;HEAP[p+8*f]=HEAP[l+48*vb+44];if((HEAP[w]&16)!=0)HEAP[c]=HEAP[v]|32;f=unSign(HEAP[t],32)>unSign(lb,32);var vb=vb+1;if(f){f=244;c=242}else{f=244;break d}}else if(c==243){ib=f==248?ib:0;var tb=
u+ib;f=j+ib;c=s+f;v=q+f;var Kb=l+48*(ib+1);w=l+48*ib+16;HEAP[p+8*f]=HEAP[l+48*ib+44];if((HEAP[w]&16)!=0)HEAP[c]=HEAP[v]|64;f=unSign(HEAP[t],32)>unSign(tb,32);var ib=ib+1;if(f){f=248;c=243}else{f=248;break d}}}else{if(r){f=251;c=252}else{f=251;c=253}for(;;)if(c==252){Ab=f==254?Ab:0;var wb=u+Ab;f=j+Ab;c=s+f;v=q+f;var Mb=l+48*(Ab+1);w=l+48*Ab+16;HEAP[p+8*f+4]=HEAP[l+48*Ab+44];if((HEAP[w]&16)!=0)HEAP[c]=HEAP[v]|32;f=unSign(HEAP[t],32)>unSign(wb,32);var Ab=Ab+1;if(f){f=254;c=252}else{f=254;break d}}else if(c==
253){nb=f==259?nb:0;var mb=u+nb;f=j+nb;c=s+f;v=q+f;var Bb=l+48*(nb+1);w=l+48*nb+16;HEAP[p+8*f+4]=HEAP[l+48*nb+44];if((HEAP[w]&16)!=0)HEAP[c]=HEAP[v]|64;f=unSign(HEAP[t],32)>unSign(mb,32);var nb=nb+1;if(f){f=259;c=253}else{f=259;break d}}}while(0);j=f==259?mb:f==254?wb:f==248?tb:lb;l=f==259?Bb:f==254?Mb:f==248?Kb:Gb;j=j}E!=0&&_psh_globals_set_scale(HEAP[M+24],z,C,0,0);D=c=D+1;if(reSign(c,32)<=reSign(1,32))c=58;else{c=50;break b}}}while(0);if(c==4)Q=f==1?R:f==3?V:ya;d=M;b=HEAP[d+16];_psh_hint_table_done(d+
28+40,b);_psh_hint_table_done(d+28,b);P=HEAP[d+8];i=b;h=P;P!=0&&FUNCTION_TABLE[HEAP[i+8]](i,h);HEAP[d+8]=0;i=HEAP[d+12];b=b;h=i;i!=0&&FUNCTION_TABLE[HEAP[b+8]](b,h);HEAP[d+12]=0;HEAP[d]=0;HEAP[d+4]=0;HEAP[d+16]=0;N=Q;c=264;break a}while(0);if(c==0)N=0;Q=N;STACKTOP=a;return Q}_ps_hints_apply.__index__=Runtime.getFunctionIndex(_ps_hints_apply,"_ps_hints_apply");
function _t2_hints_open(e){var g;HEAP[e+4]=0;HEAP[e+12]=2;g=e+16;HEAP[g]=0;HEAP[g+12]=0;HEAP[g+24]=0;e=e+16+36;HEAP[e]=0;HEAP[e+12]=0;HEAP[e+24]=0}_t2_hints_open.__index__=Runtime.getFunctionIndex(_t2_hints_open,"_t2_hints_open");
function _t2_hints_stems(e,g,d,b){var a=STACKTOP;STACKTOP+=128;Runtime.memset(a,0,128);var c,f=null;if(reSign(d,32)>reSign(0,32)){f=0;a:for(;;){r=f==0?d:r;o=f==0?0:o;var h=reSign(r,32)>reSign(16,32);b:do if(h){f=1;c=3}else{if(reSign(r*2,32)>reSign(0,32)){f=2;c=3}else{f=2;c=4}break b}while(0);if(c==3){var i=f==2?r:16;c=i*2;for(f=3;;){m=f==3?0:m;h=a+m*4;var k=(f==3?o:k)+HEAP[b+4*m];if(reSign(k,32)>=reSign(0,32)){var j=k+32768&-65536;f=6}else{var l=0-(32768-k&-65536);f=8}f=reSign(f==6?j:l,32)>>reSign(16,
32);HEAP[h]=f;var m=m+1;if(m!=c)f=9;else break}f=10}c=f==10?i:r;var o=f==10?k:o;if(reSign(c*2,32)>reSign(0,32)){h=c*2;unSign(h+-1,32);unSign(1,32);for(f=12;;){p=f==12?0:p;f=p*2;var n=f+2;HEAP[a+(f+1)*4]-=HEAP[a+f*4];f=reSign(h,32)>reSign(n,32);var p=p+1;if(f)f=13;else break}}_ps_hints_stem(e,g,c,a);var r=r-c;if(reSign(r,32)>reSign(0,32))f=16;else break a}}STACKTOP=a}_t2_hints_stems.__index__=Runtime.getFunctionIndex(_t2_hints_stems,"_t2_hints_stems");
function _psh_globals_scale_widths(e,g){var d=null,b,a,c,f;b=e+4+g*204;a=HEAP[b];f=c=b+4;b=HEAP[b+196];var h=a!=0;a:do if(h){var i=_FT_MulFix(HEAP[c],b);HEAP[c+4]=i;HEAP[c+8]=HEAP[c+4]+32&-64;c+=12;a=i=a-1;if(i==0)break a;i=b;var k=f+4,j=f+4,l=c,m=a;for(d=0;;){s=d==0?0:s;var o=l+12*s+8,n=l+12*s+4,p=_FT_MulFix(HEAP[l+12*s],i);d=p-HEAP[k];var r=0-d;d=reSign(d,32)<reSign(0,32)?r:d;if(reSign(d,32)<=reSign(127,32)){var q=HEAP[j];d=3}else d=2;p=d==3?q:p;HEAP[n]=p;HEAP[o]=p+32&-64;var s=s+1;if(s!=m)d=5;
else break}}while(0)}_psh_globals_scale_widths.__index__=Runtime.getFunctionIndex(_psh_globals_scale_widths,"_psh_globals_scale_widths");
function _psh_blues_set_zones_0(e,g,d,b,a,c){var f,h=null,i,k,j,l,m,o;d=d;b=b;e=HEAP[a];i=HEAP[c];if(unSign(d,32)>unSign(1,32)){g=g!=0;h=0;a:for(;;){k=b;if((h==0?1:0)!=0|g){k=reSign(HEAP[k+2],16);j=reSign(HEAP[b],16)-k;m=c+4;l=i;h=2}else{k=reSign(HEAP[k],16);j=reSign(HEAP[b+2],16)-k;m=a+4;l=e;h=4}var n=h==4?1:0;m=m;var p=l,r=k;o=k;l=l;m=m;var q=l+-1;h=5;b:for(;;){f=h==10?w:0;var s=m+32*f,u=s,t=f*-1,v=l+t;t=q+t;if((h==10?t:p)==0){f=7;break b}if(reSign(HEAP[u],32)>reSign(r,32)){f=7;break b}if(HEAP[u]==
o){f=9;break b}var w=f+1;h=10;f=6}b:do if(f==7){m=s;l=v;if(v!=0){r=p=m;o=l;l=o+-1;for(h=16;;){J=h==16?0:J;f=J*-1;h=o+f;q=p+32*h+28;u=p+32*h+24;t=p+32*h+20;var x=p+32*h+16,y=p+32*h+12,A=p+32*h+8,z=p+32*h+4,C=r+32*h+-4,B=r+32*h+-8,D=r+32*h+-12,E=r+32*h+-16,F=r+32*h+-20,G=r+32*h+-24,H=r+32*h+-28;HEAP[p+32*h]=HEAP[r+32*(l+f)];HEAP[z]=HEAP[H];HEAP[A]=HEAP[G];HEAP[y]=HEAP[F];HEAP[x]=HEAP[E];HEAP[t]=HEAP[D];HEAP[u]=HEAP[B];HEAP[q]=HEAP[C];var J=J+1;if(J!=o)f=h=17;else{f=18;break}}}HEAP[m]=k;HEAP[m+4]=j;
if(n!=0)e+=1;else i+=1}else if(f==9){m=s;o=HEAP[m+4];p=reSign(j,32)<reSign(0,32);r=j;o=o;if(p){if(!(reSign(r,32)<reSign(o,32)))break b}else if(!(reSign(r,32)>reSign(o,32)))break b;HEAP[m+4]=j}while(0);b+=4;d=k=d-2;if(unSign(k,32)>unSign(1,32)){h=12;f=1}else break a}}HEAP[a]=e;HEAP[c]=i}_psh_blues_set_zones_0.__index__=Runtime.getFunctionIndex(_psh_blues_set_zones_0,"_psh_blues_set_zones_0");
function _psh_blues_set_zones(e,g,d,b,a,c,f){var h=null,i,k,j;i=g;if(f!=0){g=e+1032;f=e+1548}else{g=e;f=e+516}HEAP[g]=0;HEAP[f]=0;_psh_blues_set_zones_0(e,0,i,d,g,f);_psh_blues_set_zones_0(e,1,b,a,g,f);e=HEAP[g];d=HEAP[f];if(reSign(e,32)>reSign(0,32)){k=g+4;i=e;if(e!=0){i=i;h=1;a:for(;;){h=h==1?0:j;j=k+32*(h+1);b=k+32*h;a=k+32*h+4;var l=k+32*h+8,m=k+32*h+12,o=unSign(i+h*-1,32)>unSign(1,32);b:do if(o){var n=HEAP[j]-HEAP[b];if(!(reSign(HEAP[a],32)>reSign(n,32)))break b;HEAP[a]=n}while(0);HEAP[m]=HEAP[b];
HEAP[l]=HEAP[b]+HEAP[a];j=h+1;if(j!=i)h=5;else break a}}k=d;h=9}else h=32;k=reSign(h==9?k:d,32)>reSign(0,32);a:do if(k){h=f+4;i=j=d;if(j==0)break a;i=i;j=h;h=11;b:for(;;){p=h==11?0:p;h=j+32*p;b=j+32*(p+1);a=j+32*p+4;l=j+32*p+12;m=j+32*p+8;o=unSign(i+p*-1,32)>unSign(1,32);c:do if(o){n=HEAP[h]-HEAP[b];if(!(reSign(HEAP[a],32)<reSign(n,32)))break c;HEAP[a]=n}while(0);HEAP[m]=HEAP[h];HEAP[l]=HEAP[h]+HEAP[a];var p=p+1;if(p!=i)h=16;else break b}}while(0);j=g+4;i=e;g=1;h=12;a:for(;;){if((h==21?s:e)!=0){HEAP[j+
12]-=c;h=HEAP[j+8];i=s=i-1;if(s!=0){s=c*2;k=p=c;j=j;b=h;i=i;for(h=22;;){q=h==22?0:q;r=h==22?b:r;l=q+1;h=j+32*l+12;a=j+32*q+8;l=j+32*l+8;m=HEAP[h];o=m-r;if(reSign(s,32)>reSign(o,32)){m=Math.floor(reSign(o,32)/reSign(2,32));HEAP[h]=r+m;HEAP[a]=HEAP[h]}else{HEAP[a]=p+r;HEAP[h]=m-k}var r=HEAP[l],q=q+1;if(q!=i)h=25;else break}s=j+32*i;h=r;j=s}HEAP[j+8]=c+h}j=f+4;i=d;g=s=g-1;if(!(reSign(s,32)>=reSign(0,32)))break a;var s=i;h=21}}
_psh_blues_set_zones.__index__=Runtime.getFunctionIndex(_psh_blues_set_zones,"_psh_blues_set_zones");function _psh_globals_destroy(e){var g,d,b=e!=0;a:do if(b){g=HEAP[e];HEAP[e+4]=0;HEAP[e+4+204]=0;HEAP[e+412]=0;HEAP[e+412+516]=0;HEAP[e+412+1032]=0;HEAP[e+412+1548]=0;d=e;g=g;d=d;if(d==0)break a;FUNCTION_TABLE[HEAP[g+8]](g,d)}while(0)}_psh_globals_destroy.__index__=Runtime.getFunctionIndex(_psh_globals_destroy,"_psh_globals_destroy");
function _psh_globals_new(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a=null,c,f,h;c=_ft_mem_alloc(e,2496,b);if(HEAP[b]==0){HEAP[c]=e;e=c+4+204;h=e+4;a=unSign(HEAP[g+120],16);HEAP[h]=a;h+=12;f=g+128;var i=unSign(HEAP[g+124],8);a=i;if(i!=0){f=f;h=h;i=a;for(a=0;;){a=a==0?0:j;j=h+12*a;var k=reSign(HEAP[f+2*a],16);HEAP[j]=k;var j=a+1;if(j!=i)a=1;else break}}a=unSign(HEAP[g+124],8)+1;HEAP[e]=a;e=c+4;h=e+4;a=unSign(HEAP[g+122],16);HEAP[h]=a;h+=12;f=g+154;a=j=unSign(HEAP[g+125],8);if(j!=
0){j=f;f=h;h=a;for(a=4;;){l=a==4?0:l;a=f+12*l;i=reSign(HEAP[j+2*l],16);HEAP[a]=i;var l=l+1;if(l!=h)a=5;else break}}l=unSign(HEAP[g+125],8)+1;HEAP[e]=l;l=HEAP[g+116];e=g+40;a=unSign(HEAP[g+9],8);j=g+12;f=unSign(HEAP[g+8],8);_psh_blues_set_zones(c+412,f,j,a,e,l,0);l=HEAP[g+116];e=g+88;a=unSign(HEAP[g+11],8);j=g+60;f=unSign(HEAP[g+10],8);_psh_blues_set_zones(c+412,f,j,a,e,l,1);HEAP[c+412+2064]=HEAP[g+108];HEAP[c+412+2068]=HEAP[g+112];HEAP[c+412+2076]=HEAP[g+116];HEAP[c+4+196]=0;HEAP[c+4+200]=0;HEAP[c+
4+204+196]=0;HEAP[c+4+204+200]=0}HEAP[d]=c;g=HEAP[b];STACKTOP=b;return g}_psh_globals_new.__index__=Runtime.getFunctionIndex(_psh_globals_new,"_psh_globals_new");
function _psh_globals_set_scale(e,g,d,b,a){var c,f=null,h,i,k,j,l,m;m=e+4;f=HEAP[m+196]!=g;a:do if(f)c=0;else{c=HEAP[m+200]!=b?0:1;break a}while(0);if(c==0){HEAP[m+196]=g;HEAP[m+200]=b;_psh_globals_scale_widths(e,0)}m=e+4+204;g=HEAP[m+196]!=d;a:do if(g)c=3;else{c=HEAP[m+200]!=a?3:4;break a}while(0);a:do if(c==3){HEAP[m+196]=d;HEAP[m+200]=a;_psh_globals_scale_widths(e,1);f=d;i=a;g=e+412;b=f;h=i;if(reSign(f,32)>reSign(34359737,32)){f=Math.floor(reSign(HEAP[g+2064]*8,32)/reSign(125,32));i=b;f=reSign(f,
32)>reSign(i,32);f=unSign(f,1);HEAP[g+2080]=f}else{f=HEAP[g+2064]*8;f=reSign(b*125,32)<reSign(f,32);f=unSign(f,1);HEAP[g+2080]=f}f=i=HEAP[g+2068];l=b;var o=f,n=o+-1;f=6;b:for(;;){c=f==8?r:0;var p=c*-1;k=n+p;p=o+p;if(reSign(f==8?k:i,32)<=reSign(0,32)){c=9;break b}f=_FT_MulFix(p,l);if(!(reSign(f,32)>reSign(32,32))){c=9;break b}var r=c+1;f=8;c=7}f=p;HEAP[g+2072]=f;i=0;l=g+1548;o=b;n=h;k=b;var q=h,s=b;h=h;var u=b,t=g,v=g+516,w=g+1032;i=i+1;f=9;b:for(;;){var x=f==12?J:0;c=f==12?y:0;var y=i+x;if(c==0){f=
11;c=17}else if(c==1){f=11;c=13}else if(c==2){f=11;c=15}else{f=11;c=16}if(c==16)f=16;else if(c==13)f=13;else if(c==15)f=15;var A=f==16?l:f==15?w:f==13?v:t,z=HEAP[A];if(z!=0){f=17;c=18}else{f=17;c=19}for(;;)if(c==18){H=f==18?H:0;var C=A+4+H*32+28,B=A+4+H*32+12,D=A+4+H*32+24,E=A+4+H*32,F=A+4+H*32+4;c=A+4+H*32+20;f=A+4+H*32+16;var G=_FT_MulFix(HEAP[A+4+H*32+8],o)+n;HEAP[C]=G;C=_FT_MulFix(HEAP[B],k)+q;HEAP[D]=C;D=_FT_MulFix(HEAP[E],s)+h;HEAP[f]=D;F=_FT_MulFix(HEAP[F],u);HEAP[c]=F;HEAP[f]=HEAP[f]+32&-64;
var H=H+1;if(H!=z)c=f=18;else{f=20;c=19}}else if(c==19)if(unSign(y,32)<=unSign(3,32))break;else{c=21;break b}var J=x+1;f=12;c=11}i=0;f=21;for(;;){l=g;if((f==23?j:0)==0){j=l;l=g+1032}else{j=l+516;l=g+1548}f=j+4;k=j=HEAP[j];if(j!=0){l=j=l;o=b;n=f;k=k;f=25;c:for(;;){I=f==25?0:I;q=n+32*I;s=n+32*I+28;h=n+32*I+24;u=n+32*I+16;t=n+32*I+20;v=HEAP[l];for(f=26;;){c=f==29?N:0;var L=j+4+c*32;f=L;if(v+c*-1==0){c=32;break}f=HEAP[q]-HEAP[f];w=0-f;f=reSign(f,32)<reSign(0,32)?w:f;f=_FT_MulFix(f,o);if(reSign(f,32)<=
reSign(63,32)){c=28;break}var N=c+1;f=29;c=27}if(c==28){HEAP[s]=HEAP[L+28];HEAP[h]=HEAP[L+24];HEAP[u]=HEAP[L+16];HEAP[t]=HEAP[L+20]}var I=I+1;if(I!=k){f=32;c=26}else break c}}i=c=i+1;if(!(unSign(c,32)<=unSign(1,32)))break a;j=i;f=23;c=22}}while(0);return 0}_psh_globals_set_scale.__index__=Runtime.getFunctionIndex(_psh_globals_set_scale,"_psh_globals_set_scale");
function _psh_hint_table_done(e,g){var d;d=HEAP[e+24];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+24]=0;HEAP[e+20]=0;HEAP[e+28]=0;d=HEAP[e+12];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+12]=0;d=HEAP[e+8];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+8]=0;HEAP[e+4]=0;HEAP[e]=0;HEAP[e+16]=0}_psh_hint_table_done.__index__=Runtime.getFunctionIndex(_psh_hint_table_done,"_psh_hint_table_done");
function _psh_hint_table_record(e,g){var d,b=null,a,c,f,h;a=HEAP[e+8]+28*g;var i=unSign(HEAP[e],32)<=unSign(g,32);a:do if(!i){if((HEAP[a+16]&4)!=0)break a;HEAP[a+16]|=4;c=HEAP[e+16];f=HEAP[e+4];HEAP[a+20]=0;h=f;var k=a;c=c;f=f+-1;for(b=1;;){d=b==6?o:0;var j=c+4*d,l=f+d*-1;if((b==6?l:h)==0){d=8;break}var m=HEAP[j];b=HEAP[m];if(!(reSign(HEAP[k+4]+HEAP[k],32)<reSign(b,32))){b=HEAP[k];if(!(reSign(HEAP[m+4]+HEAP[m],32)<reSign(b,32))){d=4;break}}var o=d+1;b=6;d=2}if(d!=8)if(d==4){h=m;HEAP[a+20]=h}h=HEAP[e];
if(!(unSign(HEAP[e+4],32)<unSign(h,32)))break a;h=HEAP[e+4];HEAP[HEAP[e+16]+4*h]=a;HEAP[e+4]=h+1}while(0)}_psh_hint_table_record.__index__=Runtime.getFunctionIndex(_psh_hint_table_record,"_psh_hint_table_record");
function _psh_hint_table_init(e,g,d,b,a){b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var c=null,f,h,i,k,j;i=HEAP[g];var l=_ft_mem_realloc(a,4,0,i*2,0,b);HEAP[e+12]=l;l=HEAP[b]!=0;a:do if(!l){j=_ft_mem_realloc(a,28,0,i,0,b);HEAP[e+8]=j;if(HEAP[b]!=0)break a;j=_ft_mem_realloc(a,16,0,i*2+1,0,b);HEAP[e+24]=j;if(HEAP[b]!=0)break a;HEAP[e]=i;HEAP[e+16]=HEAP[e+12]+4*i;HEAP[e+4]=0;HEAP[e+20]=0;HEAP[e+28]=0;k=HEAP[e+8];j=HEAP[g+8];if(i!=0){j=j;k=k;i=i;for(c=3;;){o=c==3?0:o;c=k+28*o+16;f=k+28*o+4;h=j+12*o+
8;var m=j+12*o+4;HEAP[k+28*o]=HEAP[j+12*o];HEAP[f]=HEAP[m];HEAP[c]=HEAP[h];var o=o+1;if(o!=i)c=4;else break}}k=d!=0;b:do if(k){j=HEAP[d+8];i=HEAP[d];HEAP[e+32]=d;if(i==0)break b;for(;;){c=j;f=e;h=c;c=HEAP[h+8];m=h=HEAP[h];if(unSign(0,32)<unSign(m,32)){f=f;m=h;h=c;unSign(m,32);unSign(1,32);m=(unSign(m,32)>unSign(1,32)?m:1)-0;for(c=9;;){t=c==9?0:t;q=c==9?h:q;s=c==9?0:s;var n=c==9?0:u;u=0+t;if(n==0){var p=unSign(HEAP[q],8),r=q+1;c=11}else c=10;var q=c==11?r:q,s=c==11?p:s;c=c==11?128:n;(c&s)!=0&&_psh_hint_table_record(f,
u);var u=reSign(c,32)>>reSign(1,32),t=t+1;if(t!=m)c=14;else break}}i=c=i-1;j+=16;if(c==0)break b}}while(0);if(HEAP[e+4]==HEAP[e])break a;j=i=HEAP[e];if(!(unSign(0,32)<unSign(j,32)))break a;j=e;k=i;k=(unSign(k,32)>unSign(1,32)?k:1)-0;for(c=18;;){v=c==18?0:v;_psh_hint_table_record(j,0+v);var v=v+1;if(v!=k)c=19;else break}}while(0);e=HEAP[b];STACKTOP=b;return e}_psh_hint_table_init.__index__=Runtime.getFunctionIndex(_psh_hint_table_init,"_psh_hint_table_init");
function _psh_hint_table_activate_mask(e,g){var d=null,b,a,c,f;a=HEAP[g+8];c=HEAP[g];f=0;var h=HEAP[e];b=HEAP[e+8];if(h!=0)for(d=0;;){d=d==0?0:i;i=b+28*d+24;HEAP[b+28*d+16]&=-5;HEAP[i]=-1;var i=d+1;if(i!=h)d=1;else break}if(unSign(0,32)<unSign(c,32)){b=e+8;h=e+12;f=f;c=c-0;d=4;a:for(;;){q=d==6?q:0;p=d==4?f:p;l=d==4?a:l;m=d==4?0:m;i=d==4?0:r;r=0+q;if(i==0){var k=unSign(HEAP[l],8),j=l+1;d=8}else d=5;var l=d==8?j:l,m=d==8?k:m;i=d==8?128:i;var o=(i&m)!=0;b:do if(o){d=HEAP[b];if((HEAP[d+28*r+16]&4)!=0){d=
10;break b}HEAP[d+28*r+16]|=4;if(!(unSign(HEAP[e],32)>unSign(p,32))){d=11;break b}HEAP[HEAP[h]+4*p]=d+28*r;var n=p+1;d=12}else d=23;while(0);var p=d==12?n:d==11?p:d==10?p:p,r=reSign(i,32)>>reSign(1,32),q=q+1;if(q!=c)d=6;else break a}f=p}HEAP[e+4]=f;a=HEAP[e+12];if(reSign(f,32)>reSign(1,32)){d=f;k=(reSign(d,32)>reSign(2,32)?d:2)-1;d=15;a:for(;;){u=d==15?0:u;j=1+u;n=0+u;m=l=HEAP[a+4*j];for(d=16;;){d=d==20?s:0;h=d*-1;b=a+4*(j+h);r=n+h;h=a+4*r;f=a+4*r;if(!(reSign(r,32)>=reSign(0,32)))break;r=HEAP[f];
f=HEAP[m];if(reSign(HEAP[r],32)<reSign(f,32))break;HEAP[b]=r;HEAP[h]=l;var s=d+1;d=20}var u=u+1;if(u!=k)d=19;else break a}}}_psh_hint_table_activate_mask.__index__=Runtime.getFunctionIndex(_psh_hint_table_activate_mask,"_psh_hint_table_activate_mask");
function _psh_hint_align(e,g,d,b){var a=STACKTOP;STACKTOP+=12;Runtime.memset(a,0,12);var c,f=null,h,i,k,j,l,m,o,n,p,r,q,s,u,t,v,w;i=g+4+d*204;t=HEAP[i+196];v=HEAP[i+200];if((HEAP[e+16]&8)==0){h=_FT_MulFix(HEAP[e],t);v=v+h;h=_FT_MulFix(HEAP[e+4],t);var x=d!=0;a:do if(x){f=59;c=2}else{f=59;if(HEAP[b+120]==0){c=0;break a}m=d;f=1;c=2;break a}while(0);a:do if(c==2){if((f==1?m:d)==1)if(HEAP[b+121]==0)break a;m=d;x=m!=0;b:do if(x){f=61;c=6}else{f=61;if(HEAP[b+122]!=0){c=4;break b}w=d;f=5;c=6;break b}while(0);
b:do if(c==6){if((f==5?w:m)==1)if(HEAP[b+123]!=0){c=4;break b}u=0;c=9;break b}while(0);if(c==4)u=1;u=u;w=h;HEAP[e+12]=w;HEAP[a]=0;HEAP[a+4]=0;HEAP[a+8]=HEAP[a+4];x=d==1;b:do if(x){f=HEAP[e];p=HEAP[e+4]+HEAP[e];m=g+412;o=p;n=f;p=a;HEAP[p]=0;s=unSign(HEAP[m+2080],8);r=m;var y=HEAP[r];f=y;r=r+4;var A=o,z=m+2076,C=m+2076;o=o;r=r;var B=q,D=f+-1;f=10;c:for(;;){c=f==16?N:0;var E=f==16?L:B,F=D+c*-1,G=r+32*c+8,H=r+32*c+12,J=r+32*c;if((f==16?F:y)==0){f=11;c=13;break c}var L=A-HEAP[H];if(reSign(0-HEAP[z],32)>
reSign(L,32)){f=12;c=13;break c}else f=12;if(reSign(HEAP[C]+HEAP[G],32)>=reSign(o,32)){c=15;break c}var N=c+1;f=16;c=11}c:do if(c==13)q=f==12?L:E;else if(c==15){q=L;r=J;if(s==0){y=q;if(!(reSign(HEAP[m+2072],32)>=reSign(y,32))){c=18;break c}}HEAP[p]|=1;HEAP[p+4]=HEAP[r+16]}while(0);r=m+516;y=f=HEAP[r];r=r+4+32*y+-32;A=n;z=m+2076;C=m+2076;n=n;r=r;o=q;B=f+-1;for(f=18;;){c=f==25?O:0;var I=f==25?K:o,P=c*-1;D=B+P;F=r+32*P+12;G=r+32*P+8;P=r+32*P;if((f==25?D:y)==0){f=20;c=22;break}var K=HEAP[G]-A;if(reSign(0-
HEAP[z],32)>reSign(K,32)){f=21;c=22;break}else f=21;if(reSign(HEAP[F]-HEAP[C],32)<=reSign(n,32)){c=24;break}var O=c+1;f=25;c=20}if(c==22)q=f==20?I:K;else if(c==24){q=K;r=P;if(s==0){f=q;if(!(reSign(HEAP[m+2072],32)>reSign(f,32)))break b}HEAP[p]|=2;HEAP[p+8]=HEAP[r+16]}}while(0);f=HEAP[a];c=f==1?51:f==2?52:f==3?53:54;if(c==54){f=HEAP[e+20];if(f!=0){(HEAP[f+16]&8)==0&&_psh_hint_align(f,g,d,b);v=HEAP[f];v=(reSign(HEAP[f+4],32)>>reSign(1,32))+v;g=HEAP[f+8];g=(reSign(HEAP[f+12],32)>>reSign(1,32))+g;d=HEAP[e];
d=(reSign(HEAP[e+4],32)>>reSign(1,32))+d;t=_FT_MulFix(d-v,t);v=g;t=t;g=0-(reSign(h,32)>>reSign(1,32));v=t+v+g}HEAP[e+8]=v;HEAP[e+12]=w;if(HEAP[b+124]!=0)if(reSign(h,32)<=reSign(64,32)){l=reSign(h,32)>reSign(31,32);k=h;if(l){h=reSign(k,32)>>reSign(1,32);v=v+h&-64;h=64}else{l=reSign(k,32)>reSign(0,32);k=v+32&-64;if(l){l=k;k=v+32+h&-64;j=l-v;var M=0-h+(0-v)+k;v=M;if(reSign(j,32)<reSign(0,32)){j=0-j;var Q=v;f=33}else f=78;if(reSign(f==33?Q:M,32)<reSign(0,32))v=0-v;v=v;v=reSign(j,32)<=reSign(v,32)?l:k}else v=
k}}else{Q=h;h=i;i=Q;Q=reSign(i,32)<=reSign(64,32);b:do if(Q)i=64;else{t=b=i-HEAP[h+4+4];if(reSign(t,32)<reSign(0,32)){l=0-b;f=37}else f=87;b=reSign(f==37?l:t,32)<=reSign(39,32);c:do{if(b){k=i=HEAP[h+4+4];if(!(reSign(k,32)<=reSign(47,32))){f=39;c=41;break c}j=i=48;f=40;c=42}else{M=i;f=43;c=41}break c}while(0);c:do if(c==41){b=reSign(f==43?M:k,32)<=reSign(191,32);var R=i;if(b){f=41;break c}i=R+32&-64;break b}while(0);b=t=(f==40?j:R)&63;i&=-64;if(reSign(t,32)<=reSign(9,32))i=b+i;else if(reSign(b,32)<=
reSign(31,32))i+=10;else{t=reSign(b,32)<=reSign(53,32);i=i;i=t?i+54:b+i}}while(0);h=h=h=i}l=h;k=v;j=l;l=(k+32&-64)-k;k=(k+32+j&-64)+(0-k)+(0-j);j=l;M=0-j;j=reSign(j,32)>=reSign(0,32)?j:M;M=k;R=0-M;M=reSign(M,32)>=reSign(0,32)?M:R;l=l=reSign(j,32)<=reSign(M,32)?l:k;HEAP[e+8]=v+l;HEAP[e+12]=h}else if(c==51)HEAP[e+8]=HEAP[a+4]-w;else if(c==52)HEAP[e+8]=HEAP[a+8];else if(c==53){HEAP[e+8]=HEAP[a+8];HEAP[e+12]=HEAP[a+4]-HEAP[a+8]}u=u!=0;b:do if(u){v=HEAP[e+8];h=HEAP[e+12];h=reSign(h,32)<=reSign(63,32)?
64:h+32&-64;l=HEAP[a];if(l==1)c=55;else if(l==2)c=56;else if(l==3)break b;else c=58;if(c==58){HEAP[e+12]=h;l=(h&64)!=0;v=(reSign(h,32)>>reSign(1,32))+v;v=l?(v&-64)+32:v+32&-64;l=reSign(h,32)>>reSign(1,32);HEAP[e+8]=v-l;HEAP[e+12]=h}else if(c==55){HEAP[e+8]=HEAP[a+4]-h;HEAP[e+12]=h}else if(c==56)HEAP[e+12]=h}while(0);HEAP[e+16]|=8;STACKTOP=a;return}while(0);HEAP[e+8]=v;HEAP[e+12]=h;HEAP[e+16]|=8}STACKTOP=a}_psh_hint_align.__index__=Runtime.getFunctionIndex(_psh_hint_align,"_psh_hint_align");
function _psh_compute_dir(e,g){var d,b,a;d=4;b=0-e;b=reSign(e,32)>=reSign(0,32)?e:b;a=0-g;a=reSign(g,32)>=reSign(0,32)?g:a;var c=reSign(a*12,32)<reSign(b,32);a:do if(c)d=d=reSign(e,32)>=reSign(0,32)?2:-2;else{var f=a;if(!(reSign(b*12,32)<reSign(f,32)))break a;d=d=reSign(g,32)>=reSign(0,32)?-1:1}while(0);return d}_psh_compute_dir.__index__=Runtime.getFunctionIndex(_psh_compute_dir,"_psh_compute_dir");
function _psh_glyph_load_points(e,g){var d,b=null,a,c;a=HEAP[HEAP[e+20]+4];c=HEAP[e+8];var f=HEAP[e];if(f!=0){if(g==0){b=0;d=1}else{b=0;d=2}for(;;)if(d==1){j=b==1?j:0;d=a+8*j;b=a+8*j+4;var h=c+48*j+40,i=c+48*j+36,k=c+48*j+32;HEAP[c+48*j+16]=0;HEAP[k]=0;HEAP[i]=HEAP[d];HEAP[h]=HEAP[b];var j=j+1;if(j!=f)d=b=1;else break}else if(d==2){l=b==2?l:0;d=a+8*l;b=a+8*l+4;h=c+48*l+32;i=c+48*l+36;k=c+48*l+40;HEAP[c+48*l+16]=0;HEAP[h]=0;HEAP[i]=HEAP[b];HEAP[k]=HEAP[d];var l=l+1;if(l!=f)d=b=2;else break}}}
_psh_glyph_load_points.__index__=Runtime.getFunctionIndex(_psh_glyph_load_points,"_psh_glyph_load_points");
function _psh_hint_table_find_strong_points(e,g,d,b,a){var c,f=null,h;g=g;h=HEAP[e+12];e=HEAP[e+4];if(d!=0){var i=0-a,k=a==2,j=0-a,l=0-a;f=0;a:for(;;){D=f==0?0:D;var m=HEAP[g+36],o=(HEAP[g+16]&16)!=0;b:do if(!o){f=1;var n=reSign(HEAP[g+20],8)==a;c:do if(n)c=2;else{if(reSign(HEAP[g+20],8)==j){c=2;break c}if(reSign(HEAP[g+21],8)!=a)if(reSign(HEAP[g+21],8)!=l){f=5;c=7;break c}var p=reSign(HEAP[g+21],8);f=8;c=4;break c}while(0);c:do if(c==2){var r=reSign(HEAP[g+20],8);f=2;c=4;break c}while(0);c:do if(c==
4){c=f==8?p:r;if(c==0)break c;if(c==a){for(f=9;;){o=f==11?s:0;c=h+4*o;if(!(unSign(o,32)<unSign(e,32)))break b;var q=HEAP[c];n=m-HEAP[q];c=reSign(n,32)<reSign(b,32);n=reSign(0-n,32)<reSign(b,32);if(c&n)break;var s=o+1;f=11}HEAP[g+16]|=16;HEAP[g+16]|=512;HEAP[g+32]=q}else{if(i==c)f=15;else break b;for(;;){o=f==18?t:0;c=h+4*o;if(!(unSign(o,32)<unSign(e,32)))break b;var u=HEAP[c];n=m+(0-HEAP[u])+(0-HEAP[u+4]);c=reSign(n,32)<reSign(b,32);n=reSign(0-n,32)<reSign(b,32);if(c&n)break;var t=o+1;f=18}HEAP[g+
16]|=16;HEAP[g+16]|=1024;HEAP[g+32]=u}break b}while(0);if((HEAP[g+16]&64)==0)break b;c=k?256:128;n=((k?128:256)&HEAP[g+16])!=0;c:do{if(n){for(f=20;;){f=f==22?y:0;var v=h+4*f;if(!(unSign(f,32)<unSign(e,32)))break c;var w=HEAP[v],x=m-HEAP[w];v=reSign(x,32)<reSign(b,32);x=reSign(0-x,32)<reSign(b,32);if(v&x)break;var y=f+1;f=22}HEAP[g+16]|=512;HEAP[g+32]=w}else{if((c&HEAP[g+16])!=0)f=27;else break c;for(;;){f=f==30?z:0;v=h+4*f;if(!(unSign(f,32)<unSign(e,32)))break c;var A=HEAP[v];x=m+(0-HEAP[A])+(0-HEAP[A+
4]);v=reSign(x,32)<reSign(b,32);x=reSign(0-x,32)<reSign(b,32);if(v&x)break;var z=f+1;f=30}HEAP[g+16]|=1024;HEAP[g+32]=A}HEAP[g+16]|=16}while(0);if(HEAP[g+32]==0)f=26;else break b;for(;;){c=f==36?B:0;n=h+4*c;if(!(unSign(c,32)<unSign(e,32)))break b;var C=HEAP[n];if(reSign(HEAP[C],32)<=reSign(m,32))if(reSign(HEAP[C+4]+HEAP[C],32)>=reSign(m,32))break;var B=c+1;f=36}HEAP[g+32]=C}while(0);g+=48;var D=D+1;if(D!=d)f=12;else break a}}}
_psh_hint_table_find_strong_points.__index__=Runtime.getFunctionIndex(_psh_hint_table_find_strong_points,"_psh_hint_table_find_strong_points");function _ps_hinter_done(e){var g;HEAP[e+120]=0;HEAP[e+148]=0;e=e+20;g=HEAP[e];_ps_dimension_done(e+16,g);_ps_dimension_done(e+16+36,g);HEAP[e+4]=0;HEAP[e]=0}_ps_hinter_done.__index__=Runtime.getFunctionIndex(_ps_hinter_done,"_ps_hinter_done");
function _ps_hinter_init(e){var g,d,b;d=HEAP[e+8];b=e+20;g=e+20;_llvm_memset_p0i8_i32(g,0,88,1,0);HEAP[g]=d;g=e+108;HEAP[g]=_psh_globals_new.__index__;HEAP[g+4]=_psh_globals_set_scale.__index__;HEAP[g+8]=_psh_globals_destroy.__index__;g=e+120;_llvm_memset_p0i8_i32(g,0,28,1,0);HEAP[g+4]=_t1_hints_open.__index__;HEAP[g+8]=_ps_hints_close.__index__;HEAP[g+12]=_t1_hints_stem.__index__;HEAP[g+16]=_ps_hints_t1stem3.__index__;HEAP[g+20]=_ps_hints_t1reset.__index__;HEAP[g+24]=_ps_hints_apply.__index__;HEAP[e+
120]=b;g=e+148;_llvm_memset_p0i8_i32(g,0,28,1,0);HEAP[g+4]=_t2_hints_open.__index__;HEAP[g+8]=_ps_hints_close.__index__;HEAP[g+12]=_t2_hints_stems.__index__;HEAP[g+16]=_ps_hints_t2mask.__index__;HEAP[g+20]=_ps_hints_t2counter.__index__;HEAP[g+24]=_ps_hints_apply.__index__;HEAP[e+148]=b;return 0}_ps_hinter_init.__index__=Runtime.getFunctionIndex(_ps_hinter_init,"_ps_hinter_init");function _pshinter_get_globals_funcs(e){return e+108}
_pshinter_get_globals_funcs.__index__=Runtime.getFunctionIndex(_pshinter_get_globals_funcs,"_pshinter_get_globals_funcs");function _pshinter_get_t1_funcs(e){return e+120}_pshinter_get_t1_funcs.__index__=Runtime.getFunctionIndex(_pshinter_get_t1_funcs,"_pshinter_get_t1_funcs");function _pshinter_get_t2_funcs(e){return e+148}_pshinter_get_t2_funcs.__index__=Runtime.getFunctionIndex(_pshinter_get_t2_funcs,"_pshinter_get_t2_funcs");
function _New_Profile(e,g,d){var b;if(HEAP[e+92]==0){HEAP[e+88]=HEAP[e+40];HEAP[e+92]=HEAP[e+88];HEAP[e+40]+=32}var a=HEAP[e+40]>=HEAP[e+36];a:do if(a){HEAP[e+44]=98;b=1}else{HEAP[HEAP[e+88]+12]=0;HEAP[HEAP[e+88]+20]=0;HEAP[HEAP[e+88]+16]=0;HEAP[HEAP[e+88]+8]=HEAP[e+40];HEAP[HEAP[e+88]+4]=0;HEAP[HEAP[e+88]+28]=0;b=HEAP[e+88];var c=unSign(HEAP[e+180],8);HEAP[b+12]=c;b=g;b=b==1?8:b==2?9:10;b:do if(b==10){HEAP[e+44]=20;b=1;break a}else if(b==8){HEAP[HEAP[e+88]+12]|=8;if(d==0)break b;HEAP[HEAP[e+88]+
12]|=32}else if(b==9){if(d==0)break b;HEAP[HEAP[e+88]+12]|=16}while(0);if(HEAP[e+96]==0)HEAP[e+96]=HEAP[e+88];HEAP[e+100]=g;HEAP[e+86]=1;b=HEAP[e+87]=0}while(0);return b&255}_New_Profile.__index__=Runtime.getFunctionIndex(_New_Profile,"_New_Profile");
function _End_Profile(e,g){var d;d=Math.floor(reSign(HEAP[e+40]-HEAP[HEAP[e+88]+8],32)/reSign(4,32));if(reSign(d,32)<reSign(0,32)){HEAP[e+44]=99;d=1}else{if(reSign(d,32)>reSign(0,32)){HEAP[HEAP[e+88]+16]=d;if(g!=0){d=HEAP[HEAP[e+88]+12];HEAP[HEAP[e+88]+12]=(HEAP[HEAP[e+88]+12]&8)!=0?d|16:d|32}d=HEAP[e+88];HEAP[e+88]=HEAP[e+40];HEAP[e+40]+=32;HEAP[HEAP[e+88]+16]=0;HEAP[HEAP[e+88]+8]=HEAP[e+40];HEAP[d+28]=HEAP[e+88];HEAP[e+84]+=1}if(HEAP[e+40]>=HEAP[e+36]){HEAP[e+44]=98;d=1}else d=HEAP[e+87]=0}return d&
255}_End_Profile.__index__=Runtime.getFunctionIndex(_End_Profile,"_End_Profile");
function _Insert_Y_Turn(e,g){var d,b=null,a,c,f,h;a=g;h=HEAP[e+48]-1;f=HEAP[e+32]+4*(0-HEAP[e+48]);var i=h,k=a,j=h,l=j+-1;b=-1;a:for(;;){d=b==1?n:0;n=d*-1;var m=j+n;n=l+n;var o=f+4*m;if(reSign(b==1?n:i,32)<reSign(0,32)){d=2;break a}if(!(reSign(HEAP[o],32)>reSign(k,32))){d=4;break a}var n=d+1;b=1;d=0}if(d==2){var p=h=m;b=2}else if(d==4){h=m;b=4}i=reSign(b==2?p:m,32)>=reSign(0,32);a:do if(i){var r=h;b=a;if(reSign(HEAP[f+4*r],32)<reSign(b,32))b=6;else{b=6;d=8;break a}if(!(reSign(r,32)>=reSign(0,32))){d=
10;break a}f=i=f;h=h;a=a;b=0-h;k=reSign(b,32)>reSign(0,32)?b:0;j=h+k+1;for(b=9;;){s=b==9?0:s;l=h+s*-1;var q=HEAP[i+4*l];HEAP[f+4*l]=b==9?a:q;var s=s+1;if(s!=j)b=11;else{b=11;break}}s=-1-k;a=q;h=s;d=10;break a}else d=10;while(0);if(d==10){var u=h;b=10}r=reSign(b==10?u:r,32)<reSign(0,32);a:do if(r){HEAP[e+36]+=-4;r=e;if(HEAP[e+36]<=HEAP[e+40]){HEAP[r+44]=98;c=1;d=14}else{HEAP[e+48]=HEAP[r+48]+1;HEAP[HEAP[e+32]+4*(0-HEAP[e+48])]=a;d=15}break a}else d=15;while(0);if(d==15)c=0;return c&255}
_Insert_Y_Turn.__index__=Runtime.getFunctionIndex(_Insert_Y_Turn,"_Insert_Y_Turn");
function _Split_Conic(e){var g,d;HEAP[e+32]=HEAP[e+16];d=HEAP[e+8];g=e+24;var b=Math.floor(reSign(d+HEAP[e+16],32)/reSign(2,32));HEAP[g]=b;g=HEAP[g];b=e+8;d=Math.floor(reSign(d+HEAP[e],32)/reSign(2,32));HEAP[b]=d;d=HEAP[b];b=e+16;d=Math.floor(reSign(d+g,32)/reSign(2,32));HEAP[b]=d;HEAP[e+32+4]=HEAP[e+16+4];d=HEAP[e+8+4];g=e+24;b=Math.floor(reSign(d+HEAP[e+16+4],32)/reSign(2,32));HEAP[g+4]=b;g=HEAP[g+4];b=e+8;d=Math.floor(reSign(d+HEAP[e+4],32)/reSign(2,32));HEAP[b+4]=d;d=HEAP[b+4];e=e+16;d=Math.floor(reSign(d+
g,32)/reSign(2,32));HEAP[e+4]=d}_Split_Conic.__index__=Runtime.getFunctionIndex(_Split_Conic,"_Split_Conic");
function _Split_Cubic(e){var g,d,b,a;HEAP[e+48]=HEAP[e+24];b=HEAP[e+8];a=HEAP[e+16];d=e+8;g=reSign(HEAP[e]+1+b,32)>>reSign(1,32);HEAP[d]=g;var c=e+40;d=reSign(HEAP[e+24]+1+a,32)>>reSign(1,32);HEAP[c]=d;b=reSign(b+1+a,32)>>reSign(1,32);a=e+16;g=reSign(g+1+b,32)>>reSign(1,32);HEAP[a]=g;a=e+32;d=reSign(d+1+b,32)>>reSign(1,32);HEAP[a]=d;b=e+24;g=reSign(g+1+d,32)>>reSign(1,32);HEAP[b]=g;HEAP[e+48+4]=HEAP[e+24+4];b=HEAP[e+8+4];a=HEAP[e+16+4];d=e+8;g=reSign(HEAP[e+4]+1+b,32)>>reSign(1,32);HEAP[d+4]=g;c=
e+40;d=reSign(HEAP[e+24+4]+1+a,32)>>reSign(1,32);HEAP[c+4]=d;b=reSign(b+1+a,32)>>reSign(1,32);a=e+16;g=reSign(g+1+b,32)>>reSign(1,32);HEAP[a+4]=g;a=e+32;d=reSign(d+1+b,32)>>reSign(1,32);HEAP[a+4]=d;e=e+24;g=reSign(g+1+d,32)>>reSign(1,32);HEAP[e+4]=g}_Split_Cubic.__index__=Runtime.getFunctionIndex(_Split_Cubic,"_Split_Cubic");
function _Line_Up(e,g,d,b,a,c,f){var h;h=null;var i,k;g=g;b=b-g;k=a-d;var j=reSign(k,32)<=reSign(0,32);a:do if(j)h=0;else{h=c;if(reSign(a,32)<reSign(h,32)){h=0;break a}h=f;if(reSign(d,32)>reSign(h,32)){h=0;break a}h=c;if(reSign(d,32)<reSign(h,32)){d=_FT_MulDiv(b,c-d,k);g+=d;d=HEAP[e];c=reSign(c,32)>>reSign(d,32);d=0}else{c=HEAP[e];c=reSign(d,32)>>reSign(c,32);d=HEAP[e+4]-1&d}h=f;h=reSign(a,32)>reSign(h,32);i=HEAP[e];if(h){f=reSign(f,32)>>reSign(i,32);a=0}else{f=reSign(a,32)>>reSign(i,32);a=HEAP[e+
4]-1&a}h=reSign(d,32)>reSign(0,32);b:do if(h)if(c==f){i=0;h=6;break a}else{i=_FT_MulDiv(b,HEAP[e+4]-d,k);g+=i;c+=1}else{if(HEAP[e+87]==0)break b;HEAP[e+40]+=-4;HEAP[e+87]=0}while(0);a=unSign(a==0,1);HEAP[e+87]=a;if(HEAP[e+86]!=0){HEAP[HEAP[e+88]+20]=c;HEAP[e+86]=0}h=f+1+(0-c);if(HEAP[e+40]+4*h>=HEAP[e+36]){HEAP[e+44]=98;i=1}else{if(reSign(b,32)>reSign(0,32)){a=_FT_MulDiv(HEAP[e+4],b,k);f=k;f=reSign(b*HEAP[e+4],32)%reSign(f,32);b=1}else{a=0-_FT_MulDiv(HEAP[e+4],0-b,k);f=k;f=reSign(HEAP[e+4]*-1*b,32)%
reSign(f,32);b=-1}c=0-k;d=HEAP[e+40];if(reSign(h,32)>reSign(0,32)){a=a;f=f;k=k;b=b;d=d;g=g;c=c;h=h;i=0-h;i=reSign(i,32)>reSign(-1,32)?i:-1;i=h+i+1;for(h=12;;){n=h==12?0:n;o=h==12?c:o;m=h==12?g:m;HEAP[d+4*n]=m;m=a+m;o=f+o;h=reSign(o,32)>=reSign(0,32);j=o-k;var l=b+m,m=h?l:m,o=h?j:o,n=n+1;if(n!=i)h=13;else break}d=d+4*i}HEAP[e+40]=d;i=0}h=6;break a}while(0);if(h==0)i=0;return i&255}_Line_Up.__index__=Runtime.getFunctionIndex(_Line_Up,"_Line_Up");
function _Bezier_Up(e,g,d,b,a){var c,f=null,h,i,k,j,l,m;l=HEAP[e+52];i=HEAP[l+8*g+4];k=HEAP[l+4];m=HEAP[e+40];j=reSign(k,32)<reSign(b,32);a:do if(j)c=0;else{c=a;if(reSign(i,32)>reSign(c,32)){c=0;break a}k=k&0-HEAP[e+4];c=a;if(reSign(k,32)>reSign(c,32))k=a;a=c=b;var o=reSign(i,32)<reSign(a,32);b:do if(o)a=b;else{a=0-HEAP[e+4]&HEAP[e+4]+-1+i;j=(HEAP[e+4]&65535)-1&i&65535;c=a;if(j!=0)break b;if(HEAP[e+87]!=0){m+=-4;HEAP[e+87]=0}HEAP[m]=HEAP[l+8*g];m+=4;a+=HEAP[e+4]}while(0);if(HEAP[e+86]!=0){b=HEAP[e+
88];i=HEAP[e];i=reSign(c,32)>>reSign(i,32);HEAP[b+20]=i;HEAP[e+86]=0}b=a;if(reSign(k,32)<reSign(b,32)){c=0;break a}b=HEAP[e];b=reSign(k-a,32)>>reSign(b,32);if(m+4*b+4>=HEAP[e+36]){HEAP[e+40]=m;HEAP[e+44]=98;h=1;c=9}else{b=b=l;k=k;i=g;d=d;o=j=c=g;var n=0-g,p=0-g;l=l;a=a;m=m;for(f=10;;){var r=f==10?m:f==16?C:f==13?w:r,q=f==10?a:f==16?B:f==13?y:q,s=f==10?l:f==16?D:f==13?x:v;f=s<b^1;var u=reSign(q,32)<=reSign(k,32);if(!(f&u))break;HEAP[e+87]=0;u=HEAP[s+4];if(reSign(u,32)>reSign(q,32)){f=HEAP[s+8*i+4];
var t=HEAP[e+16];if(reSign(u-f,32)>=reSign(t,32)){FUNCTION_TABLE[d](s);var v=s+8*c;f=12}else{w=HEAP[s+8*j];x=u-f;w=Math.floor(reSign((q-f)*(HEAP[s]-HEAP[s+8*o]),32)/reSign(x,32))+w;HEAP[r]=w;var w=r+4,x=s+8*n,y=q+HEAP[e+4];f=13}}else{if(u==q){HEAP[e+87]=1;HEAP[r]=HEAP[s];var A=r+4,z=q+HEAP[e+4];f=14}else f=31;var C=f==14?A:r,B=f==14?z:q,D=s+8*p;f=16}}m=r;c=0}break a}while(0);if(c==0){HEAP[e+40]=m;HEAP[e+52]+=8*(0-g);h=0}return h&255}_Bezier_Up.__index__=Runtime.getFunctionIndex(_Bezier_Up,"_Bezier_Up");
function _Bezier_Down(e,g,d,b,a){var c,f;c=HEAP[e+52];HEAP[c+4]=0-HEAP[c+4];HEAP[c+8+4]=0-HEAP[c+8+4];HEAP[c+16+4]=0-HEAP[c+16+4];if(reSign(g,32)>reSign(2,32))HEAP[c+24+4]=0-HEAP[c+24+4];f=HEAP[e+86];g=_Bezier_Up(e,g,d,0-a,0-b);f=f!=0;a:do if(f){if(HEAP[e+86]!=0)break a;HEAP[HEAP[e+88]+20]=0-HEAP[HEAP[e+88]+20]}while(0);HEAP[c+4]=0-HEAP[c+4];return reSign(g,8)&255}_Bezier_Down.__index__=Runtime.getFunctionIndex(_Bezier_Down,"_Bezier_Down");
function _Line_To(e,g,d){var b,a,c,f,h,i,k,j;b=HEAP[e+100];b=b==0?16:b==1?17:b==2?18:1;a:do if(b==16){b=d;c=reSign(HEAP[e+72],32)<reSign(b,32);b=HEAP[e+72];if(c){c=HEAP[e+8];b=reSign((0-HEAP[e+4]&b+-1+HEAP[e+4])-HEAP[e+72],32)>=reSign(c,32);b=unSign(b,1);if(_New_Profile(e,1,b&255)==0){b=1;break a}}else{c=d;if(!(reSign(b,32)>reSign(c,32))){b=1;break a}b=HEAP[e+8];b=reSign(HEAP[e+72]&HEAP[e+4]-1,32)>=reSign(b,32);b=unSign(b,1);if(_New_Profile(e,2,b&255)==0){b=1;break a}}a=1;b=2;break a}else if(b==17){b=
d;if(!(reSign(HEAP[e+72],32)>reSign(b,32))){b=1;break a}b=HEAP[e+8];b=reSign(HEAP[e+72]&HEAP[e+4]-1,32)>=reSign(b,32);b=unSign(b,1);if(_End_Profile(e,b&255)==0){b=HEAP[e+8];b=reSign(HEAP[e+72]&HEAP[e+4]-1,32)>=reSign(b,32);b=unSign(b,1);if(_New_Profile(e,2,b&255)==0){b=1;break a}}a=1;b=2;break a}else if(b==18){b=d;if(!(reSign(HEAP[e+72],32)<reSign(b,32))){b=1;break a}b=HEAP[e+8];b=reSign((0-HEAP[e+4]&HEAP[e+72]+-1+HEAP[e+4])-HEAP[e+72],32)>=reSign(b,32);b=unSign(b,1);if(_End_Profile(e,b&255)==0){b=
HEAP[e+8];b=reSign((0-HEAP[e+4]&HEAP[e+72]+-1+HEAP[e+4])-HEAP[e+72],32)>=reSign(b,32);b=unSign(b,1);if(_New_Profile(e,1,b&255)==0){b=1;break a}}a=1;b=2;break a}while(0);a:do if(b==1){a=HEAP[e+100];b=a==1?19:a==2?20:10;b:do if(b==19){if(_Line_Up(e,HEAP[e+68],HEAP[e+72],g,d,HEAP[e+76],HEAP[e+80])==0){b=10;break b}a=1;break a}else if(b==20){j=HEAP[e+80];i=HEAP[e+76];c=HEAP[e+72];b=HEAP[e+68];f=g;h=d;a=e;b=b;c=c;f=f;h=h;i=i;k=j;j=HEAP[a+86];b=_Line_Up(a,b,0-c,f,0-h,0-k,0-i);c=j!=0;c:do if(c){if(HEAP[a+
86]!=0)break c;HEAP[HEAP[a+88]+20]=0-HEAP[HEAP[a+88]+20]}while(0);a=a=reSign(b,8);if((a&255)==0){b=10;break b}a=1;break a}while(0);HEAP[e+68]=g;HEAP[e+72]=d;a=0}while(0);return a&255}_Line_To.__index__=Runtime.getFunctionIndex(_Line_To,"_Line_To");
function _Conic_To(e,g,d,b,a){var c,f=null,h,i;HEAP[e+52]=e+184;HEAP[HEAP[e+52]+16]=HEAP[e+68];HEAP[HEAP[e+52]+16+4]=HEAP[e+72];HEAP[HEAP[e+52]+8]=g;HEAP[HEAP[e+52]+8+4]=d;HEAP[HEAP[e+52]]=b;for(HEAP[HEAP[e+52]+4]=a;;){f=HEAP[HEAP[e+52]+16+4];g=HEAP[HEAP[e+52]+8+4];i=HEAP[HEAP[e+52]+4];var k=HEAP[HEAP[e+52]];d=(b=reSign(f,32)<=reSign(i,32))?i:f;b=b?f:i;b=reSign(g,32)<reSign(b,32);g=reSign(g,32)>reSign(d,32);if(b|g){g=HEAP[e+52];HEAP[g+32]=HEAP[g+16];f=HEAP[g+8];d=g+24;b=Math.floor(reSign(f+HEAP[g+
16],32)/reSign(2,32));HEAP[d]=b;d=HEAP[d];b=g+8;f=Math.floor(reSign(f+HEAP[g],32)/reSign(2,32));HEAP[b]=f;f=g+16;d=Math.floor(reSign(HEAP[b]+d,32)/reSign(2,32));HEAP[f]=d;HEAP[g+32+4]=HEAP[g+16+4];f=HEAP[g+8+4];d=g+24;b=Math.floor(reSign(f+HEAP[g+16+4],32)/reSign(2,32));HEAP[d+4]=b;d=HEAP[d+4];b=g+8;f=Math.floor(reSign(f+HEAP[g+4],32)/reSign(2,32));HEAP[b+4]=f;g=g+16;f=Math.floor(reSign(HEAP[b+4]+d,32)/reSign(2,32));HEAP[g+4]=f;HEAP[e+52]+=16}else if(f==i)HEAP[e+52]+=-16;else{g=reSign(f,32)<reSign(i,
32)?1:2;if(HEAP[e+100]!=g){d=HEAP[e+4];if(g==1){var j=HEAP[e+8];j=reSign((0-HEAP[e+4]&d+-1+f)-f,32)>=reSign(j,32);j=unSign(j,1);f=4}else{var l=HEAP[e+8];l=reSign(f&d-1,32)>=reSign(l,32);l=unSign(l,1);f=6}f=f==6?l:j;if(HEAP[e+100]!=0){d=reSign(f,8);if(_End_Profile(e,d&255)!=0){c=8;break}}f=reSign(f,8);if(_New_Profile(e,g,f&255)!=0){c=8;break}}f=HEAP[e+80];d=HEAP[e+76];b=e;if(g==1){if(_Bezier_Up(b,2,_Split_Conic.__index__,d,f)!=0){c=8;break}}else if(_Bezier_Down(b,2,_Split_Conic.__index__,d,f)!=0){c=
8;break}}if(HEAP[e+52]>=e+184)c=0;else{c=15;break}}if(c==8)h=1;else if(c==15){h=k;i=i;HEAP[e+68]=h;HEAP[e+72]=i;h=0}return h&255}_Conic_To.__index__=Runtime.getFunctionIndex(_Conic_To,"_Conic_To");
function _Cubic_To(e,g,d,b,a,c,f){var h,i=null,k,j;HEAP[e+52]=e+184;HEAP[HEAP[e+52]+24]=HEAP[e+68];HEAP[HEAP[e+52]+24+4]=HEAP[e+72];HEAP[HEAP[e+52]+16]=g;HEAP[HEAP[e+52]+16+4]=d;HEAP[HEAP[e+52]+8]=b;HEAP[HEAP[e+52]+8+4]=a;HEAP[HEAP[e+52]]=c;for(HEAP[HEAP[e+52]+4]=f;;){i=HEAP[HEAP[e+52]+24+4];d=HEAP[HEAP[e+52]+16+4];b=HEAP[HEAP[e+52]+8+4];j=HEAP[HEAP[e+52]+4];var l=HEAP[HEAP[e+52]];g=(a=reSign(i,32)<=reSign(j,32))?j:i;c=a?i:j;a=(f=reSign(d,32)<=reSign(b,32))?b:d;d=reSign(f?d:b,32)<reSign(c,32);g=reSign(a,
32)>reSign(g,32);if(d|g){_Split_Cubic(HEAP[e+52]);HEAP[e+52]+=24}else if(i==j)HEAP[e+52]+=-24;else{g=reSign(i,32)<=reSign(j,32)?1:2;if(HEAP[e+100]!=g){d=HEAP[e+4];if(g==1){var m=HEAP[e+8];m=reSign((0-HEAP[e+4]&d+-1+i)-i,32)>=reSign(m,32);m=unSign(m,1);i=4}else{var o=HEAP[e+8];o=reSign(i&d-1,32)>=reSign(o,32);o=unSign(o,1);i=6}i=i==6?o:m;if(HEAP[e+100]!=0){d=reSign(i,8);if(_End_Profile(e,d&255)!=0){h=8;break}}i=reSign(i,8);if(_New_Profile(e,g,i&255)!=0){h=8;break}}i=HEAP[e+80];d=HEAP[e+76];b=e;if(g==
1){if(_Bezier_Up(b,3,_Split_Cubic.__index__,d,i)!=0){h=8;break}}else if(_Bezier_Down(b,3,_Split_Cubic.__index__,d,i)!=0){h=8;break}}if(HEAP[e+52]>=e+184)h=0;else{h=15;break}}if(h==8)k=1;else if(h==15){k=l;j=j;HEAP[e+68]=k;HEAP[e+72]=j;k=0}return k&255}_Cubic_To.__index__=Runtime.getFunctionIndex(_Cubic_To,"_Cubic_To");
function _Sort(e){var g,d=null,b,a;a=g=HEAP[e];g=g!=0?0:1;a:for(;;)if(g==0){HEAP[a]=HEAP[HEAP[a+8]];HEAP[a+8]+=4*((HEAP[a+12]&8)!=0?1:-1);HEAP[a+16]-=1;a=g=HEAP[a+4];if(g!=0){g=0;continue a}g=1}else if(g==1){b=e;a=g=HEAP[b];g=g==0?3:4;break a}if(g!=3)if(g==4){g=HEAP[a+4];b=b;for(d=4;;){h=d==10?h:b;var c=d==10?i:g;if((d==10?i:g)==0)break;i=HEAP[c];if(reSign(HEAP[a],32)<=reSign(i,32)){var f=a+4;a=HEAP[f];if(a==0)break;else d=6}else{HEAP[h]=c;HEAP[a+4]=HEAP[c+4];HEAP[c+4]=a;a=HEAP[e];d=9}var h=d==6?
f:e,i=HEAP[a+4];d=10}}}_Sort.__index__=Runtime.getFunctionIndex(_Sort,"_Sort");function _Vertical_Sweep_Init(e,g){var d;d=HEAP[e+104+8];HEAP[e+156]=0-(d&65535);var b=reSign(HEAP[g],16);HEAP[e+148]=d*-1*b;if(reSign(d,32)>reSign(0,32))HEAP[e+148]=(HEAP[e+104]-1)*d+HEAP[e+148];HEAP[e+158]=0;HEAP[e+160]=0}_Vertical_Sweep_Init.__index__=Runtime.getFunctionIndex(_Vertical_Sweep_Init,"_Vertical_Sweep_Init");
function _Vertical_Sweep_Span(e,g,d,b){var a=null,c,f,h;g=HEAP[e];g=reSign(0-HEAP[e+4]&HEAP[e+4]+-1+d,32)>>reSign(g,32);a=HEAP[e+20];if(reSign(0-d+b+(0-HEAP[e+4]),32)<=reSign(a,32)){var i=g;b=i;a=0}else{f=HEAP[e];b=f=reSign(b&0-HEAP[e+4],32)>>reSign(f,32);a=2}i=reSign(a==2?f:i,32)>=reSign(0,32);a:do if(i){f=unSign(HEAP[e+56],16);a=g;if(!(reSign(f,32)>reSign(a,32)))break a;if(reSign(g,32)<reSign(0,32))g=0;f=unSign(HEAP[e+56],16);a=b;if(reSign(f,32)<=reSign(a,32))b=unSign(HEAP[e+56],16)-1;f=reSign(g,
32)>>reSign(3,32)&65535;c=reSign(f,16);f=reSign(b,32)>>reSign(3,32)&65535;a=reSign(f,16);f=g&7;d=reSign(255,32)>>reSign(f,32)&255;f=b&7;f=reSign(127,32)>>reSign(f,32)&255^-1;h=reSign(HEAP[e+158],16);var k=c;if(reSign(h,32)>reSign(k,32))HEAP[e+158]=c&65535;h=reSign(HEAP[e+160],16);k=a;if(reSign(h,32)<reSign(k,32))HEAP[e+160]=a&65535;h=HEAP[e+60]+HEAP[e+148]+c;a=c=a-c;c=reSign(c,32)>reSign(0,32);k=h;if(c){HEAP[h]=d|HEAP[k];a=d=a-1;c=reSign(d,32)>reSign(0,32);d=h;if(c){var j=a;a=0-j;a=reSign(a,32)>reSign(-1,
32)?a:-1;j=j+a+1;for(a=9;;){l=a==9?0:l;HEAP[d+(l+1)]=-1;var l=l+1;if(l!=j)a=10;else break}h=j=d+j;a=11}else a=22;HEAP[h+1]=f|HEAP[(a==11?j:d)+1]}else HEAP[h]=f&d|HEAP[k]}while(0)}_Vertical_Sweep_Span.__index__=Runtime.getFunctionIndex(_Vertical_Sweep_Span,"_Vertical_Sweep_Span");
function _Vertical_Sweep_Drop(e,g,d,b,a,c){var f,h,i,k,j;h=0-HEAP[e+4]&HEAP[e+4]+-1+d;i=b&0-HEAP[e+4];k=h;j=reSign(h,32)>reSign(i,32);a:do if(j){j=HEAP[a+12]&7;if(i+HEAP[e+4]!=h){f=1;break a}f=j;if(f==0)f=19;else if(f==1)f=20;else if(f==4)f=21;else if(f==5)f=20;else{f=1;break a}if(f==19)k=i;else if(f==20){f=HEAP[a+28]==c;b:do if(f){if(!(reSign(HEAP[a+16],32)<=reSign(0,32)))break b;if((HEAP[a+12]&16)==0){f=1;break a}var l=HEAP[e+8];if(reSign(b-d,32)<reSign(l,32)){f=1;break a}}while(0);f=HEAP[c+28]==
a;b:do if(f){c=HEAP[a+20];l=reSign(g,16);if(c!=l)break b;if((HEAP[a+12]&32)==0){f=1;break a}c=HEAP[e+8];if(reSign(b-d,32)<reSign(c,32)){f=1;break a}}while(0);if(j==1)k=i;else{k=Math.floor(reSign(d+-1+b,32)/reSign(2,32));k=0-HEAP[e+4]&HEAP[e+8]+k}}else if(f==21){k=Math.floor(reSign(d+-1+b,32)/reSign(2,32));k=0-HEAP[e+4]&HEAP[e+8]+k}h=f=k==h?i:h;f=HEAP[e];h=f=reSign(h,32)>>reSign(f,32);g=reSign(f,32)>>reSign(3,32)&65535;i=f&65535&7;if(!(reSign(f,32)>=reSign(0,32))){f=13;break a}f=unSign(HEAP[e+56],
16);h=h;if(!(reSign(f,32)>reSign(h,32))){f=13;break a}f=HEAP[e+60];h=HEAP[e+148];h=reSign(g,16)+h;f=unSign(HEAP[f+h],8);h=reSign(i,16);f=(reSign(128,32)>>reSign(h,32)&f)!=0?1:13;break a}else f=13;while(0);a:do if(f==13){h=HEAP[e];h=i=reSign(k,32)>>reSign(h,32);if(!(reSign(i,32)>=reSign(0,32)))break a;i=unSign(HEAP[e+56],16);g=h;if(!(reSign(i,32)>reSign(g,32)))break a;g=reSign(h,32)>>reSign(3,32)&65535;i=h&65535&7;h=g;if(reSign(HEAP[e+158],16)>reSign(h,16))HEAP[e+158]=g;h=g;if(reSign(HEAP[e+160],16)<
reSign(h,16))HEAP[e+160]=g;h=HEAP[e+60];d=HEAP[e+148];d=reSign(g,16)+d;b=HEAP[e+60];a=HEAP[e+148];g=reSign(g,16)+a;g=HEAP[b+g];i=reSign(i,16);i=reSign(128,32)>>reSign(i,32)&255|g;HEAP[h+d]=i}while(0)}_Vertical_Sweep_Drop.__index__=Runtime.getFunctionIndex(_Vertical_Sweep_Drop,"_Vertical_Sweep_Drop");function _Vertical_Sweep_Step(e){var g=HEAP[e+148];g=reSign(HEAP[e+156],16)+g;HEAP[e+148]=g}_Vertical_Sweep_Step.__index__=Runtime.getFunctionIndex(_Vertical_Sweep_Step,"_Vertical_Sweep_Step");
function _Horizontal_Sweep_Init(){}_Horizontal_Sweep_Init.__index__=Runtime.getFunctionIndex(_Horizontal_Sweep_Init,"_Horizontal_Sweep_Init");
function _Horizontal_Sweep_Span(e,g,d,b){var a,c,f,h=HEAP[e+4];h=reSign(b-d,32)<reSign(h,32);a:do if(h){a=0-HEAP[e+4]&HEAP[e+4]+-1+d;c=b&0-HEAP[e+4];if(a!=c)break a;c=HEAP[e+60];f=reSign(g,16)>>reSign(3,16);f=reSign(f,16);c=c+f;f=reSign(g,16)&7;f=reSign(128,32)>>reSign(f,32)&255;var i=HEAP[e];a=reSign(a,32)>>reSign(i,32);if(!(reSign(a,32)>=reSign(0,32)))break a;i=a;if(!(reSign(HEAP[e+104],32)>reSign(i,32)))break a;a=c+HEAP[e+104+8]*-1*a;if(reSign(HEAP[e+104+8],32)>reSign(0,32))a+=HEAP[e+104+8]*(HEAP[e+
104]-1);HEAP[a]=f|HEAP[a]}while(0)}_Horizontal_Sweep_Span.__index__=Runtime.getFunctionIndex(_Horizontal_Sweep_Span,"_Horizontal_Sweep_Span");
function _Horizontal_Sweep_Drop(e,g,d,b,a,c){var f,h,i,k,j;h=0-HEAP[e+4]&HEAP[e+4]+-1+d;i=b&0-HEAP[e+4];k=h;j=reSign(h,32)>reSign(i,32);a:do if(j){j=HEAP[a+12]&7;if(i+HEAP[e+4]!=h){f=1;break a}f=j;if(f==0)f=19;else if(f==1)f=20;else if(f==4)f=21;else if(f==5)f=20;else{f=1;break a}if(f==19)k=i;else if(f==20){f=HEAP[a+28]==c;b:do if(f){if(!(reSign(HEAP[a+16],32)<=reSign(0,32)))break b;if((HEAP[a+12]&16)==0){f=1;break a}var l=HEAP[e+8];if(reSign(b-d,32)<reSign(l,32)){f=1;break a}}while(0);f=HEAP[c+28]==
a;b:do if(f){c=HEAP[a+20];l=reSign(g,16);if(c!=l)break b;if((HEAP[a+12]&32)==0){f=1;break a}c=HEAP[e+8];if(reSign(b-d,32)<reSign(c,32)){f=1;break a}}while(0);if(j==1)k=i;else{k=Math.floor(reSign(d+-1+b,32)/reSign(2,32));k=0-HEAP[e+4]&HEAP[e+8]+k}}else if(f==21){k=Math.floor(reSign(d+-1+b,32)/reSign(2,32));k=0-HEAP[e+4]&HEAP[e+8]+k}h=h=k==h?i:h;f=HEAP[e];h=reSign(h,32)>>reSign(f,32);f=HEAP[e+60];i=reSign(g,16)>>reSign(3,16);i=reSign(i,16);i=f+i;f=reSign(g,16)&7;d=reSign(128,32)>>reSign(f,32)&255;i+=
HEAP[e+104+8]*-1*h;if(reSign(HEAP[e+104+8],32)>reSign(0,32))i+=HEAP[e+104+8]*(HEAP[e+104]-1);if(!(reSign(h,32)>=reSign(0,32))){f=14;break a}h=h;if(!(reSign(HEAP[e+104],32)>reSign(h,32))){f=14;break a}f=(d&HEAP[i])!=0?1:14;break a}else f=14;while(0);a:do if(f==14){h=HEAP[e+60];i=reSign(g,16)>>reSign(3,16);i=reSign(i,16);i=h+i;h=reSign(g,16)&7;d=reSign(128,32)>>reSign(h,32)&255;h=HEAP[e];h=b=reSign(k,32)>>reSign(h,32);if(!(reSign(b,32)>=reSign(0,32)))break a;b=h;if(!(reSign(HEAP[e+104],32)>reSign(b,
32)))break a;i+=HEAP[e+104+8]*-1*h;if(reSign(HEAP[e+104+8],32)>reSign(0,32))i+=HEAP[e+104+8]*(HEAP[e+104]-1);HEAP[i]=d|HEAP[i]}while(0)}_Horizontal_Sweep_Drop.__index__=Runtime.getFunctionIndex(_Horizontal_Sweep_Drop,"_Horizontal_Sweep_Drop");function _Horizontal_Sweep_Step(){}_Horizontal_Sweep_Step.__index__=Runtime.getFunctionIndex(_Horizontal_Sweep_Step,"_Horizontal_Sweep_Step");
function _Render_Single_Pass(e,g){var d=STACKTOP;STACKTOP+=48;Runtime.memset(d,0,48);var b,a=null,c,f,h=d+2,i=d+4,k=d+8,j=d+12,l,m,o,n,p,r,q,s,u=d+16,t=d+24,v=d+32,w,x,y,A=d+40,z,C,B,D,E,F=v+4,G=u+4,H=v+4,J=v+4,L=u+4,N=u+4,I=t+4,P=v+4,K=v+4,O=u+4,M=v+4,Q=u+4,R=v+4,T=u+4,V=v+4,U=v+4,S=t+4,X=t+4,Y=t+4,W=t+4,da=A+4,ba=A+4,aa=t+4,ca=t+4,$=t+4,la=v+4,ga=v+4,ea=t+4,Z=v+4;a:for(;;){if(!(reSign(HEAP[e+1024],32)>=reSign(0,32))){b=171;break a}a=reSign(HEAP[e+960+HEAP[e+1024]*4+2],16);HEAP[e+80]=HEAP[e+4]*a;
a=reSign(HEAP[e+960+HEAP[e+1024]*4],16);HEAP[e+76]=HEAP[e+4]*a;HEAP[e+40]=HEAP[e+28];HEAP[e+44]=0;a=reSign(g,8);c=e;o=a;HEAP[c+92]=0;HEAP[c+87]=0;HEAP[c+86]=0;HEAP[c+36]=HEAP[c+32]+-32;HEAP[c+48]=0;HEAP[c+88]=HEAP[c+40];HEAP[HEAP[c+88]+8]=HEAP[c+40];f=a=HEAP[c+84]=0;b:for(;;){var ha=reSign(HEAP[c+128],16);n=f;n=reSign(ha,32)>reSign(n,32);ha=c;if(!n){b=61;break b}HEAP[ha+100]=0;HEAP[c+96]=0;n=unSign(HEAP[HEAP[c+128+12]+2*f],16);w=unSign(a&65535,16)&65535;r=n&65535;a=o;n=c;p=w;r=r;q=a;w=HEAP[n+128+
4];a=unSign(r,16);a=w+8*a;y=unSign(p,16);HEAP[v]=(HEAP[w+8*y]<<HEAP[n+24])-HEAP[n+8];y=unSign(p,16);HEAP[F]=(HEAP[w+8*y+4]<<HEAP[n+24])-HEAP[n+8];y=unSign(r,16);HEAP[u]=(HEAP[w+8*y]<<HEAP[n+24])-HEAP[n+8];y=unSign(r,16);HEAP[G]=(HEAP[w+8*y+4]<<HEAP[n+24])-HEAP[n+8];if(q!=0){y=HEAP[v];HEAP[v]=HEAP[H];HEAP[J]=y;y=HEAP[u];HEAP[u]=HEAP[L];HEAP[N]=y}HEAP[t]=HEAP[v];HEAP[I]=HEAP[P];y=unSign(p,16);w=w+8*y;y=HEAP[n+128+8];p=unSign(p,16);x=y+p;if((reSign(HEAP[x],8)&4)!=0){p=unSign(HEAP[x],8)>>>unSign(5,8);
HEAP[n+180]=p}p=y=reSign(HEAP[x],8)&3;y=y==2;c:do if(y)b=44;else{if(p==0){p=HEAP[n+128+8];r=unSign(r,16);if((reSign(HEAP[p+r],8)&3)==1){HEAP[v]=HEAP[u];HEAP[K]=HEAP[O];a+=-8}else{r=Math.floor(reSign(HEAP[u]+HEAP[v],32)/reSign(2,32));HEAP[v]=r;r=Math.floor(reSign(HEAP[Q]+HEAP[M],32)/reSign(2,32));HEAP[R]=r;HEAP[u]=HEAP[v];HEAP[T]=HEAP[V]}w+=-8;x+=-1}HEAP[n+68]=HEAP[v];HEAP[n+72]=HEAP[U];p=r=a;var ia=q;q=ia!=0;y=a;var ja=ia!=0,fa=ia!=0,ka=a;ia=ia!=0;x=x;var na=HEAP[A],sa=HEAP[t],wa=z,Aa=C,Da=B,pa=D;
a=6;d:for(;;){var ta=a==6?pa:Za,ma=a==6?Da:fb,ya=a==6?Aa:Ya,qa=a==6?wa:Ia,ua=a==6?sa:Ea,Ba=a==6?na:ra,Na=a==6?x:jb;a=7;e:for(;;){var Ea=a==20?Xa:ua,ra=a==20?bb:Ba,za=a==20?Oa:Na;if(ia){a=8;b=21}else{a=8;b=11}f:for(;;)if(b==21){b=a==24?va:0;var Ha=za+b,Ca=za+(b+1);if(!(w<r)){a=21;b=23;break d}w+=8;a=reSign(HEAP[Ca],8)&3;if(a==0){a=22;break f}else if(a!=1){a=22;break e}a=_Line_To(n,(HEAP[w+4]<<HEAP[n+24])-HEAP[n+8],(HEAP[w]<<HEAP[n+24])-HEAP[n+8])!=0;var va=b+1;if(a){a=24;b=10;break d}else{a=24;b=21}}else if(b==
11){b=a==9?La:0;var Pa=za+b,Ja=za+(b+1);if(!(w<r)){a=11;b=23;break d}w+=8;a=reSign(HEAP[Ja],8)&3;if(a==0){a=39;break f}else if(a!=1){a=39;break e}a=_Line_To(n,(HEAP[w]<<HEAP[n+24])-HEAP[n+8],(HEAP[w+4]<<HEAP[n+24])-HEAP[n+8])!=0;var La=b+1;if(a){a=9;b=10;break d}else{a=9;b=11}}b=a==39?Pa:Ha;var xa=(HEAP[w]<<HEAP[n+24])-HEAP[n+8];HEAP[S]=(HEAP[w+4]<<HEAP[n+24])-HEAP[n+8];f:do if(fa){var oa=HEAP[X];HEAP[Y]=xa;for(a=12;;){za=a==16?Ua:0;var Fa=a==16?Va:ra,Ma=a==16?Qa:oa,Ka=b+(za+2);if(!(w<ka)){b=15;break d}w+=
8;a=reSign(HEAP[Ka],8)&3;var Ra=(HEAP[w]<<HEAP[n+24])-HEAP[n+8],Qa=(HEAP[w+4]<<HEAP[n+24])-HEAP[n+8];if(a==1){a=14;break f}else if(a==0)a=14;else{a=14;b=43;break d}var Va=Math.floor(reSign(Qa+Ma,32)/reSign(2,32)),Ta=Math.floor(reSign(HEAP[W]+Ra,32)/reSign(2,32));HEAP[da]=Ta;if(_Conic_To(n,Ma,HEAP[aa],Va,HEAP[ba])!=0){b=17;break d}HEAP[ca]=Ra;var Ua=za+1;a=16}}else for(a=172;;){za=a==26?ob:0;var ab=a==26?Ga:ra,Sa=a==26?Wa:xa,$a=b+(za+2);if(!(w<ka)){b=19;break d}w+=8;a=reSign(HEAP[$a],8)&3;var Wa=(HEAP[w]<<
HEAP[n+24])-HEAP[n+8],eb=(HEAP[w+4]<<HEAP[n+24])-HEAP[n+8];if(a==1){a=18;break f}else if(a==0)a=18;else{a=18;b=41;break d}var Ga=Math.floor(reSign(Wa+Sa,32)/reSign(2,32));Ta=Math.floor(reSign(HEAP[W]+eb,32)/reSign(2,32));HEAP[da]=Ta;if(_Conic_To(n,Sa,HEAP[aa],Ga,HEAP[ba])!=0){b=25;break d}HEAP[ca]=eb;var ob=za+1;a=26}while(0);var Oa=a==14?Ka:$a,Xa=a==14?Ma:Sa,bb=a==14?Fa:ab;if(_Conic_To(n,Xa,HEAP[$],a==14?Qa:Wa,a==14?Ra:eb)!=0){a=20;b=10;break d}else a=20}b=a==22?Ca:Ja;if(w+8>p){b=31;break d}if((reSign(HEAP[b+
1],8)&3)!=2){b=31;break d}w+=16;var jb=b+2;Ia=(HEAP[w+-16]<<HEAP[n+24])-HEAP[n+8];b=(HEAP[w+-16+4]<<HEAP[n+24])-HEAP[n+8];fb=(HEAP[w+-8]<<HEAP[n+24])-HEAP[n+8];Ya=(HEAP[w+-8+4]<<HEAP[n+24])-HEAP[n+8];a=q?34:33;var Za=a==34?fb:Ya,fb=a==34?Ya:fb,Ya=a==34?Ia:b,Ia=a==34?b:Ia;if(!(w<=y)){b=37;break d}b=(HEAP[w]<<HEAP[n+24])-HEAP[n+8];a=(HEAP[w+4]<<HEAP[n+24])-HEAP[n+8];if(_Cubic_To(n,Ia,Ya,fb,Za,ja?a:b,ja?b:a)!=0){a=36;b=10;break d}else{a=36;b=7}}d:do if(b==23){D=ta;B=ma;C=ya;z=qa;HEAP[t]=Ea;HEAP[A]=ra;
if(_Line_To(n,HEAP[v],HEAP[Z])!=0){b=29;break c}else{b=38;break d}}else if(b==31){D=ta;B=ma;C=ya;z=qa;HEAP[t]=Ea;HEAP[A]=ra;b=44;break c}else if(b==37){D=Za;B=fb;C=Ya;z=Ia;HEAP[t]=Ea;HEAP[A]=ra;if(_Cubic_To(n,z,C,B,D,HEAP[v],HEAP[la])!=0){b=29;break c}else{b=38;break d}}else if(b==10){B=a==24?ma:a==9?ma:a==20?ma:fb;C=a==24?ya:a==9?ya:a==20?ya:Ya;z=a==24?qa:a==9?qa:a==20?qa:Ia;b=a==24?Ea:a==9?Ea:a==20?Xa:Ea;w=a==24?ra:a==9?ra:a==20?bb:ra;D=a==24?ta:a==9?ta:a==20?ta:Za;B=B;C=C;z=z;HEAP[t]=b;HEAP[A]=
w;b=29;break c}else if(b==15){D=ta;B=ma;C=ya;z=qa;HEAP[t]=oa;HEAP[A]=ra;a=15;b=28;break d}else if(b==43){D=ta;B=ma;C=ya;z=qa;HEAP[t]=oa;HEAP[A]=ra;a=43;b=42;break d}else if(b==17){D=ta;B=ma;C=ya;z=qa;HEAP[t]=oa;HEAP[A]=ra;a=17;b=45;break d}else if(b==19){D=ta;B=ma;C=ya;z=qa;HEAP[t]=xa;HEAP[A]=ra;a=19;b=28;break d}else if(b==41){D=ta;B=ma;C=ya;z=qa;HEAP[t]=xa;HEAP[A]=ra;a=41;b=42;break d}else if(b==25){D=ta;B=ma;C=ya;z=qa;HEAP[t]=xa;HEAP[A]=ra;a=25;b=45;break d}while(0);if(b==28){b=a==19?Sa:Ma;HEAP[A]=
a==19?ab:Fa;HEAP[t]=b;if(_Conic_To(n,HEAP[t],HEAP[ea],HEAP[v],HEAP[ga])!=0){b=29;break c}}else if(b==42){b=a==41?Sa:Ma;HEAP[A]=a==41?ab:Fa;HEAP[t]=b;b=44;break c}else if(b==45){b=a==25?Sa:Ma;HEAP[A]=a==25?Ga:Va;HEAP[t]=b;b=29;break c}s=0;b=40;break c}while(0);c:do if(b==44){HEAP[n+44]=20;b=29;break c}while(0);if(b==29)s=1;b=s;if((b&255)!=0){b=47;break b}a=reSign(HEAP[HEAP[c+128+12]+2*f],16)+1;b=(HEAP[c+4]-1&HEAP[c+72])==0;c:do if(b){n=HEAP[c+76];if(!(reSign(HEAP[c+72],32)>=reSign(n,32)))break c;n=
HEAP[c+80];if(!(reSign(HEAP[c+72],32)<=reSign(n,32)))break c;if(HEAP[c+96]==0)break c;if((HEAP[HEAP[c+96]+12]&8)!=(HEAP[HEAP[c+88]+12]&8))break c;HEAP[c+40]+=-4}while(0);b=HEAP[c+88];n=c;if((HEAP[HEAP[c+88]+12]&8)!=0){w=HEAP[c+8];n=reSign(HEAP[c+72]&HEAP[n+4]-1,32)>=reSign(w,32);n=unSign(n,1)}else{w=HEAP[c+8];n=reSign((0-HEAP[c+4]&HEAP[n+72]+-1+HEAP[c+4])-HEAP[c+72],32)>=reSign(w,32);n=unSign(n,1)}n=reSign(n,8);if(_End_Profile(c,n&255)!=0){b=57;break b}if(HEAP[c+96]!=0)HEAP[b+28]=HEAP[c+96];f+=1;
b=1}if(b==47)l=1;else if(b==57)l=1;else if(b==61){l=ha;o=HEAP[l+84];f=HEAP[l+92];n=unSign(o,16)<=unSign(1,16);b:do if(n)b=62;else{if(f==0){b=62;break b}w=o;p=r=l;q=f;y=o;ja=y+-1;for(a=63;;){b=a==63?0:kb;fa=a==63?q:hb;ia=b*-1;ka=y+ia;ia=ja+ia;if((a==63?w:ia)==0){b=74;break}HEAP[fa+4]=unSign(ka,16)>unSign(1,16)?HEAP[fa+8]+4*HEAP[fa+16]:0;ka=HEAP[fa+20];if((HEAP[fa+12]&8)!=0){var cb=HEAP[fa+20]+-1+HEAP[fa+16];a=65}else{var pb=ka+1+(0-HEAP[fa+16]),gb=HEAP[fa+20];HEAP[fa+20]=pb;HEAP[fa+8]+=4*(HEAP[fa+
16]-1);a=67}ia=a==67?gb:cb;if(_Insert_Y_Turn(r,a==67?pb:ka)!=0){b=68;break}if(_Insert_Y_Turn(p,ia+1)!=0){b=68;break}var hb=HEAP[fa+4],kb=b+1;a=70;b=72}if(b==74){b=75;break b}else if(b==68){m=1;b=71;break b}}while(0);b:do if(b==62){HEAP[l+92]=0;b=75;break b}while(0);if(b==75)m=0;l=m;l=(l&255)!=0?1:unSign(HEAP[c+40]>=HEAP[c+36],1)}a=l;c=e;if((a&255)!=0){if(HEAP[c+44]!=98){b=77;break a}HEAP[e+44]=0;a=HEAP[e+960+HEAP[e+1024]*4];b=HEAP[e+960+HEAP[e+1024]*4+2];c=reSign(a,16);c=reSign(b,16)+c;c=Math.floor(reSign(c,
32)/reSign(2,32))&65535;if(reSign(HEAP[e+1024],32)>reSign(6,32)){b=80;break a}a=a;if(reSign(c,16)<reSign(a,16)){b=80;break a}HEAP[e+960+(HEAP[e+1024]+1)*4]=c;HEAP[e+960+(HEAP[e+1024]+1)*4+2]=b;HEAP[e+960+HEAP[e+1024]*4+2]=c-1;HEAP[e+1024]+=1}else{if(HEAP[c+92]!=0){c=e;a=i;HEAP[a]=0;a=k;HEAP[a]=0;a=j;HEAP[a]=0;f=HEAP[c+92];a=HEAP[c];a=reSign(HEAP[c+76],32)>>reSign(a,32)&65535;HEAP[h]=a;a=HEAP[c];a=reSign(HEAP[c+80],32)>>reSign(a,32)&65535;HEAP[d]=a;if(f!=0){o=HEAP[d];n=HEAP[h];a=83;b:for(;;){ub=a==
83?n:ub;db=a==83?o:db;b=HEAP[f+4];w=HEAP[f+20]&65535;a=(HEAP[f+20]&65535)+-1+(HEAP[f+16]&65535);var db=reSign(db,16)>reSign(w,16)?w:db,ub=reSign(ub,16)<reSign(a,16)?a:ub;HEAP[f]=0;f=f;w=HEAP[i];r=HEAP[f];for(a=84;;){var yb=a==88?zb:i,rb=a==88?Fb:w;if(rb==0){a=85;break}if(reSign(HEAP[rb],32)>reSign(r,32)){a=86;break}var zb=rb+4,Fb=HEAP[zb];a=88}HEAP[f+4]=a==85?0:rb;HEAP[yb]=f;f=b;if(b!=0){a=87;b=84}else{b=89;break b}}HEAP[h]=ub;HEAP[d]=db}a=c;if(HEAP[c+48]==0){HEAP[a+44]=20;b=1}else{FUNCTION_TABLE[HEAP[a+
164]](c,d,h);f=a=HEAP[i];a=a!=0;b:do if(a)for(o=HEAP[d];;){b=unSign((HEAP[f+20]&65535)-o,16);HEAP[f+24]=b;f=b=HEAP[f+4];if(b!=0)b=92;else{b=93;break b}}while(0);a=HEAP[d];o=reSign(HEAP[c+48],32)>reSign(0,32);b:do if(o){f=HEAP[HEAP[c+32]+4*(0-HEAP[c+48])];n=reSign(HEAP[d],16);if(f!=n){b=95;break b}HEAP[c+48]-=1}while(0);if(reSign(HEAP[c+48],32)>reSign(0,32)){o=a;a=97;b:for(;;){ib=a==97?0:ib;Cb=a==97?o:Cb;f=a=HEAP[i];if(a!=0){ib=reSign(ib,16);c:for(;;){n=HEAP[f+4];HEAP[f+24]-=ib;if(HEAP[f+24]==0){w=
f;r=HEAP[i];a=101;d:for(;;){b=a==101?r:xb;var Ib=a==101?i:qb;if(b==0){b=106;break d}var qb=b+4,xb=HEAP[qb];if(b==w){b=104;break d}else{a=103;b=102}}if(b==104)HEAP[Ib]=xb;b=f;if((HEAP[f+12]&8)!=0){f=HEAP[k];w=HEAP[b];for(a=107;;){var Jb=a==111?Nb:k,Hb=a==111?lb:f;if(Hb==0){a=108;break}if(reSign(HEAP[Hb],32)>reSign(w,32)){a=109;break}var Nb=Hb+4,lb=HEAP[Nb];a=111}HEAP[b+4]=a==108?0:Hb;HEAP[Jb]=b}else{f=HEAP[j];w=HEAP[b];for(a=113;;){var Gb=a==117?tb:j,vb=a==117?Kb:f;if(vb==0){a=114;break}if(reSign(HEAP[vb],
32)>reSign(w,32)){a=115;break}var tb=vb+4,Kb=HEAP[tb];a=117}HEAP[b+4]=a==114?0:vb;HEAP[Gb]=b}}f=n;if(n!=0)b=100;else break c}}_Sort(k);_Sort(j);ib=HEAP[c+48];f=HEAP[HEAP[c+32]+4*(0-ib)];n=f&65535;HEAP[c+48]=ib-1;var ib=n-Cb;if(reSign(Cb,16)<reSign(n,16)){var wb=Cb+1;w=(f&65535)-Cb;a=121;c:for(;;){Db=a==121?0:Db;r=wb+Db;p=Cb+Db;q=HEAP[k];y=HEAP[j];if(q!=0){a=122;b=123}else{a=122;b=124}d:for(;;)if(b==123){Ab=a==129?Ab:0;Bb=a==129?Bb:y;mb=a==129?mb:q;b=HEAP[mb];fa=HEAP[Bb];ja=(ka=reSign(b,32)>reSign(fa,
32))?b:fa;fa=ka?fa:b;ka=fa&0-HEAP[c+4];ia=0-HEAP[c+4]&ja+-1+HEAP[c+4];b=HEAP[c+4];x=reSign(ja-fa,32)<=reSign(b,32)&ka!=fa&ia!=ja;e:do if(x){if(!(reSign(ka,32)>reSign(ia,32)))if(HEAP[c+4]+ka!=ia){b=126;break e}if((HEAP[mb+12]&7)==2){a=127;b=129;break e}HEAP[mb]=fa;HEAP[Bb]=ja;HEAP[mb+24]=1;var Mb=Ab+1;a=128;b=129;break e}else b=126;while(0);if(b==126){FUNCTION_TABLE[HEAP[c+168]](c,p,fa,ja,mb,Bb);a=126}var Ab=a==127?Ab:a==128?Mb:Ab,mb=HEAP[mb+4],Bb=HEAP[Bb+4];if(mb!=0){a=129;b=123;continue d}if(!(reSign(Ab,
16)>reSign(0,16))){a=131;b=124;continue d}ja=HEAP[k];fa=HEAP[j];if(ja!=0)a=132;else{a=132;b=124;continue d}for(;;){sb=a==167?sb:fa;nb=a==167?nb:ja;if(HEAP[nb+24]!=0){HEAP[nb+24]=0;FUNCTION_TABLE[HEAP[c+172]](c,p,HEAP[nb],HEAP[sb],nb,sb)}var nb=HEAP[nb+4],sb=HEAP[sb+4];if(nb!=0){a=167;b=165}else{a=167;b=124;continue d}}}else if(b==124){FUNCTION_TABLE[HEAP[c+176]](c);b=reSign(r,16)<reSign(n,16)?133:134;break d}if(b==133){_Sort(k);_Sort(j)}var Db=Db+1;if(Db!=w)a=134;else break c}wb=f&65535;a=135}else a=
203;var Cb=a==135?wb:Cb;f=b=HEAP[k];if(b!=0)c:for(;;){b=HEAP[f+4];n=HEAP[f+16]==0;d:do if(n){w=f;r=HEAP[k];for(a=140;;){p=a==140?r:Lb;var Yb=a==140?k:Ob;if(p==0)break d;var Ob=p+4,Lb=HEAP[Ob];if(p==w)break;else a=142}HEAP[Yb]=Lb}while(0);f=b;if(b==0)break c}f=b=HEAP[j];if(b!=0)c:for(;;){b=HEAP[f+4];n=HEAP[f+16]==0;d:do if(n){w=f;r=HEAP[j];for(a=150;;){p=a==150?r:Rb;var Xb=a==150?j:Qb;if(p==0)break d;var Qb=p+4,Rb=HEAP[Qb];if(p==w)break;else a=152}HEAP[Xb]=Rb}while(0);f=b;if(b==0)break c}if(reSign(HEAP[c+
48],32)>reSign(0,32)){a=158;b=98}else break b}a=Cb}b=HEAP[h];if(reSign(a,16)<=reSign(b,16)){b=a+1;for(a=161;;){Sb=a==161?0:Sb;a=b+Sb;FUNCTION_TABLE[HEAP[c+176]](c);o=HEAP[h];a=reSign(a,16)<=reSign(o,16);var Sb=Sb+1;if(a)a=162;else break}}b=0}b=b;if((b&255)!=0){b=168;break a}}HEAP[e+1024]-=1}b=0}if(b==77)E=1;else if(b==80){HEAP[e+1024]=0;HEAP[e+44]=20;E=HEAP[e+44]}else if(b==168)E=HEAP[e+44];else if(b==171)E=0;h=E;STACKTOP=d;return h}
_Render_Single_Pass.__index__=Runtime.getFunctionIndex(_Render_Single_Pass,"_Render_Single_Pass");function _ft_black_new(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b;HEAP[g]=0;b=_ft_mem_alloc(e,24,d);if(HEAP[d]==0){HEAP[b+8]=e;HEAP[g]=b}b=HEAP[d];STACKTOP=d;return b}_ft_black_new.__index__=Runtime.getFunctionIndex(_ft_black_new,"_ft_black_new");function _ft_black_done(e){var g;g=HEAP[e+8];e!=0&&FUNCTION_TABLE[HEAP[g+8]](g,e)}
_ft_black_done.__index__=Runtime.getFunctionIndex(_ft_black_done,"_ft_black_done");function _ft_black_reset(e,g,d){var b;if(e!=0){b=g==0;a:do if(!b){if(reSign(d,32)<=reSign(3075,32))break a;b=g;HEAP[e]=g+1032;HEAP[e+4]=g+d-HEAP[e];HEAP[e+12]=b;return}while(0);HEAP[e]=0;HEAP[e+4]=0;HEAP[e+12]=0}}_ft_black_reset.__index__=Runtime.getFunctionIndex(_ft_black_reset,"_ft_black_reset");function _ft_black_set_mode(){}_ft_black_set_mode.__index__=Runtime.getFunctionIndex(_ft_black_set_mode,"_ft_black_set_mode");
function _ft_black_render(e,g){var d,b,a,c;b=HEAP[g+4];a=HEAP[g];var f=e==0;a:do if(f)d=0;else{if(HEAP[e]==0){d=0;break a}if(HEAP[e+4]==0){d=0;break a}if(b==0)c=20;else{d=HEAP[b+2]==0;b:do if(!d){if(reSign(HEAP[b],16)<=reSign(0,16))break b;d=HEAP[b+12]==0;c:do if(!d){if(HEAP[b+4]==0)break c;d=reSign(HEAP[b+2],16);c=HEAP[b+12];f=reSign(HEAP[b],16)-1;c=reSign(HEAP[c+2*f],16)+1;if(d!=c)c=20;else{d=HEAP[e+12];if((HEAP[g+8]&2)!=0)c=19;else if(a==0)c=20;else{c=HEAP[a+4]==0;d:do if(!c){if(HEAP[a]==0)break d;
if(HEAP[a+12]==0)c=20;else{c=d+128;b=b;HEAP[c]=HEAP[b];HEAP[c+2]=HEAP[b+2];HEAP[c+4]=HEAP[b+4];HEAP[c+8]=HEAP[b+8];HEAP[c+12]=HEAP[b+12];HEAP[c+16]=HEAP[b+16];b=d+104;a=a;HEAP[b]=HEAP[a];HEAP[b+4]=HEAP[a+4];HEAP[b+8]=HEAP[a+8];HEAP[b+12]=HEAP[a+12];HEAP[b+16]=HEAP[a+16];HEAP[b+18]=HEAP[a+18];HEAP[b+19]=HEAP[a+19];HEAP[b+20]=HEAP[a+20];HEAP[d+28]=HEAP[e];a=HEAP[d+28];b=Math.floor(unSign(HEAP[e+4],32)/unSign(4,32));HEAP[d+32]=a+4*b;a=d;if((HEAP[g+8]&1&255)!=0)a=19;else{a=a;d=HEAP[a+128+16]&256;b=a;
d=d;c=b;if(d!=0){HEAP[c]=12;HEAP[b+16]=256;HEAP[b+20]=50}else{HEAP[c]=6;HEAP[b+16]=32;HEAP[b+20]=2}HEAP[b+4]=1<<HEAP[b];d=Math.floor(reSign(HEAP[b+4],32)/reSign(2,32));HEAP[b+8]=d;HEAP[b+12]=HEAP[b]-6;HEAP[a+24]=HEAP[a+12];b=(HEAP[a+128+16]&8)!=0;d=a;e:do if(b)HEAP[d+180]=2;else{HEAP[a+180]=(HEAP[d+128+16]&16)!=0?4:0;if((HEAP[a+128+16]&32)!=0)break e;HEAP[a+180]+=1}while(0);b=unSign((HEAP[a+128+16]&512)==0,1);HEAP[a+181]=b;HEAP[a+164]=_Vertical_Sweep_Init.__index__;HEAP[a+168]=_Vertical_Sweep_Span.__index__;
HEAP[a+172]=_Vertical_Sweep_Drop.__index__;HEAP[a+176]=_Vertical_Sweep_Step.__index__;HEAP[a+1024]=0;HEAP[a+960]=0;HEAP[a+960+2]=(HEAP[a+104]&65535)-1;HEAP[a+56]=HEAP[a+104+4]&65535;HEAP[a+60]=HEAP[a+104+12];b=d=_Render_Single_Pass(a,0);d=d!=0;e:do if(d)c=b;else{c=HEAP[a+181]!=0;f:do if(c){if(HEAP[a+180]==2)break f;HEAP[a+164]=_Horizontal_Sweep_Init.__index__;HEAP[a+168]=_Horizontal_Sweep_Span.__index__;HEAP[a+172]=_Horizontal_Sweep_Drop.__index__;HEAP[a+176]=_Horizontal_Sweep_Step.__index__;HEAP[a+
1024]=0;HEAP[a+960]=0;HEAP[a+960+2]=(HEAP[a+104+4]&65535)-1;b=_Render_Single_Pass(a,1);if(b==0)break f;c=b;break e}while(0);c=0}while(0);a=a=c}c=a}d=4;break a}while(0);c=0}}d=4;break a}while(0);c=20;d=4;break a}while(0);c=0}d=4;break a}while(0);if(d==0)c=96;return c}_ft_black_render.__index__=Runtime.getFunctionIndex(_ft_black_render,"_ft_black_render");function _ft_raster1_init(e){var g;g=HEAP[e+4];FUNCTION_TABLE[HEAP[HEAP[HEAP[e+20]+56]+8]](HEAP[e+60],HEAP[g+172],HEAP[g+176]);return 0}
_ft_raster1_init.__index__=Runtime.getFunctionIndex(_ft_raster1_init,"_ft_raster1_init");function _ft_raster1_set_mode(e,g,d){return FUNCTION_TABLE[HEAP[HEAP[HEAP[e+20]+56]+12]](HEAP[e+60],g,d)}_ft_raster1_set_mode.__index__=Runtime.getFunctionIndex(_ft_raster1_set_mode,"_ft_raster1_set_mode");
function _ft_raster1_transform(e,g,d,b){var a=null,c,f,h,i;i=0;e=HEAP[g+72]!=HEAP[e+24];a:do if(e)i=6;else{var k=d!=0;b:do if(k){f=d;c=g+108;f=f;if(c==0)break b;if(f==0)break b;h=HEAP[c+4];c=reSign(HEAP[c+2],16);c=h+8*c;if(!(h<c))break b;f=f;c=c;h=h;for(a=4;;){j=a==4?0:j;a=h+8*(j+1);_FT_Vector_Transform(h+8*j,f);var j=j+1;if(a<c)a=5;else break}}while(0);if(b==0)break a;_FT_Outline_Translate(g+108,HEAP[b],HEAP[b+4])}while(0);return i}
_ft_raster1_transform.__index__=Runtime.getFunctionIndex(_ft_raster1_transform,"_ft_raster1_transform");function _ft_raster1_get_cbox(e,g,d){_llvm_memset_p0i8_i32(d,0,16,1,0);HEAP[g+72]==HEAP[e+24]&&_FT_Outline_Get_CBox(g+108,d)}_ft_raster1_get_cbox.__index__=Runtime.getFunctionIndex(_ft_raster1_get_cbox,"_ft_raster1_get_cbox");
function _ft_raster1_render(e,g,d,b){var a=STACKTOP;STACKTOP+=68;Runtime.memset(a,0,68);var c,f,h,i,k=a+4,j,l,m,o=a+20;j=HEAP[g+72]!=HEAP[e+24];a:do{if(j)HEAP[a]=6;else{c=d!=2;j=HEAP[e+20];b:do{if(c){if(j!=_ft_raster1_renderer_class)break b}else if(j!=_ft_raster5_renderer_class)break b;i=19;c=3;break a}while(0);c=g+108;b!=0&&_FT_Outline_Translate(c,HEAP[b],HEAP[b+4]);_FT_Outline_Get_CBox(c,k);HEAP[k]&=-64;HEAP[k+4]&=-64;HEAP[k+8]=HEAP[k+8]+63&-64;HEAP[k+12]=HEAP[k+12]+63&-64;j=reSign(HEAP[k+8]-HEAP[k],
32)>>reSign(6,32);l=reSign(HEAP[k+12]-HEAP[k+4],32)>>reSign(6,32);b=g+76;m=HEAP[e+8];if((HEAP[HEAP[g+156]+4]&1&255)!=0){h=HEAP[b+12];f=m;h=h;h!=0&&FUNCTION_TABLE[HEAP[f+8]](f,h);HEAP[b+12]=0;HEAP[HEAP[g+156]+4]&=-2}f=j;if((d&2)==0){d=f+3&-4;HEAP[b+18]=2;HEAP[b+16]=256}else{d=unSign(f+15,32)>>>unSign(4,32)<<1;HEAP[b+18]=1}HEAP[b+4]=j;HEAP[b]=l;HEAP[b+8]=d;d=_ft_mem_realloc(m,l,0,d,0,a);HEAP[b+12]=d;if(HEAP[a]!=0){c=0;break a}HEAP[HEAP[g+156]+4]|=1;_FT_Outline_Translate(c,0-HEAP[k],0-HEAP[k+4]);HEAP[o]=
b;HEAP[o+4]=c;HEAP[o+8]=0;if(HEAP[b+18]==2)HEAP[o+8]|=1;e=FUNCTION_TABLE[HEAP[e+64]](HEAP[e+60],o);HEAP[a]=e;_FT_Outline_Translate(c,HEAP[k],HEAP[k+4]);if(HEAP[a]!=0){c=0;break a}HEAP[g+72]=1651078259;e=reSign(HEAP[k],32)>>reSign(6,32);HEAP[g+100]=e;k=reSign(HEAP[k+12],32)>>reSign(6,32);HEAP[g+104]=k}c=0;break a}while(0);if(c==0)i=HEAP[a];g=i;STACKTOP=a;return g}_ft_raster1_render.__index__=Runtime.getFunctionIndex(_ft_raster1_render,"_ft_raster1_render");
function _gray_record_cell(e){var g,d=null,b,a,c,f=HEAP[e+40]==0;a:do if(f){if((HEAP[e+36]|HEAP[e+32])==0)break a;b=e;d=c=HEAP[b];if(reSign(HEAP[b+24],32)<reSign(d,32))c=HEAP[b+24];d=HEAP[b+1420]+4*HEAP[b+4];var h=c,i=c,k=d;for(d=3;;){var j=d==9?m:k,l=HEAP[j];if(l==0){g=5;break}if(reSign(HEAP[l],32)>reSign(h,32)){g=5;break}if(HEAP[l]==i){g=8;break}var m=l+12;d=9;g=4}if(g==5){d=j;a=HEAP[b+48];h=reSign(HEAP[b+52],32)>=reSign(a,32);a=b;if(h){_longjmp(a+1256,1);throw"Reached an unreachable! Original .ll line: 205177";
}else{h=HEAP[b+52];a=HEAP[a+44]+16*h;HEAP[b+52]=h+1;HEAP[a]=c;HEAP[a+8]=0;HEAP[a+4]=0;HEAP[a+12]=HEAP[d];HEAP[d]=a}}else if(g==8)a=l;b=b=b=a;HEAP[b+8]=HEAP[e+32]+HEAP[b+8];HEAP[b+4]=HEAP[e+36]+HEAP[b+4]}while(0)}_gray_record_cell.__index__=Runtime.getFunctionIndex(_gray_record_cell,"_gray_record_cell");
function _gray_set_cell(e,g,d){var b,a;g=g;d=d;d-=HEAP[e+16];b=g;if(reSign(HEAP[e+12],32)<reSign(b,32))g=HEAP[e+12];g=b=g-HEAP[e+8];if(reSign(b,32)<reSign(0,32))g=-1;var c=HEAP[e]!=g;a:do if(c)b=2;else{b=HEAP[e+4]!=d?2:3;break a}while(0);if(b==2){HEAP[e+40]==0&&_gray_record_cell(e);HEAP[e+32]=0;HEAP[e+36]=0}HEAP[e]=g;HEAP[e+4]=d;b=HEAP[e+28];d=unSign(d,32)>=unSign(b,32);a:do if(d)b=6;else{g=g;if(reSign(HEAP[e+24],32)<=reSign(g,32)){b=6;break a}a=0;b=9;break a}while(0);if(b==6)a=1;HEAP[e+40]=a}
_gray_set_cell.__index__=Runtime.getFunctionIndex(_gray_set_cell,"_gray_set_cell");
function _gray_render_scanline(e,g,d,b,a,c){var f=null,h,i,k,j,l,m,o,n,p;h=b;n=a-d;i=reSign(d,32)>>reSign(8,32);b=reSign(a,32)>>reSign(8,32);k=d-(i<<8);a=a-(b<<8);if(h==c)_gray_set_cell(e,b,g);else{if(i==b){j=c-h;HEAP[e+32]=(a+k)*j+HEAP[e+32]}else{o=(c-h)*(256-k);d=256;p=1;if(reSign(n,32)<reSign(0,32)){o=(c-h)*k;d=0;p=-1;n=0-n}j=n;j=Math.floor(reSign(o,32)/reSign(j,32));m=n;l=o=reSign(o,32)%reSign(m,32);if(reSign(o,32)<reSign(0,32)){j-=1;l=n+l}HEAP[e+32]=(d+k)*j+HEAP[e+32];HEAP[e+36]=j+HEAP[e+36];
i=p+i;_gray_set_cell(e,i,g);h=j+h;k=i!=b;a:do if(k){o=(0-h+c+j)*256;j=n;j=Math.floor(reSign(o,32)/reSign(j,32));m=n;m=reSign(o,32)%reSign(m,32);if(reSign(m,32)<reSign(0,32)){j-=1;m=n+m}l-=n;if(i==b)break a;o=j;j=m;m=n;var r=e+32,q=e+32,s=e+36,u=e+36,t=p,v=e,w=g,x=b;l=l;h=h;i=i+t;for(f=3;;){D=f==3?0:D;B=f==3?h:B;var y=i+t*D;C=j+(f==3?l:C);var A=reSign(C,32)>=reSign(0,32),z=C-m;f=o+1;var C=A?z:C;A=A?f:o;HEAP[q]=A*256+HEAP[r];HEAP[u]=A+HEAP[s];var B=A+B;_gray_set_cell(v,y,w);var D=D+1;if(y!=x)f=5;else break}i=
y;h=B;l=C;j=A}while(0);j=c-h;HEAP[e+32]=(a+256+(0-d))*j+HEAP[e+32]}HEAP[e+36]=j+HEAP[e+36]}}_gray_render_scanline.__index__=Runtime.getFunctionIndex(_gray_render_scanline,"_gray_render_scanline");
function _gray_render_line(e,g,d){var b=null,a,c,f,h,i,k,j,l,m,o,n,p,r,q,s,u;a=reSign(HEAP[e+72],32)>>reSign(8,32);c=reSign(d,32)>>reSign(8,32);f=HEAP[e+68]-HEAP[e+72];h=d-(c<<8);k=g-HEAP[e+64];j=d-HEAP[e+68];s=a;u=c;if(reSign(a,32)>reSign(c,32)){s=c;u=a}s=s;s=reSign(HEAP[e+20],32)<=reSign(s,32);a:do if(!s){o=u;if(reSign(HEAP[e+16],32)>reSign(o,32))break a;if(a==c)_gray_render_scanline(e,a,HEAP[e+64],f,g,h);else{q=1;if(k==0){m=reSign(HEAP[e+64],32)>>reSign(8,32);r=HEAP[e+64]-(m<<8)<<1;o=256;if(reSign(j,
32)<reSign(0,32)){o=0;q=-1}n=o-f;HEAP[e+32]=n*r+HEAP[e+32];HEAP[e+36]=n+HEAP[e+36];a=q+a;_gray_set_cell(e,m,a);n=o+-256+o;p=n*r;var t=a!=c;b:do if(t){var v=p,w=n,x=q;i=m;for(l=c;;){HEAP[e+32]=v+HEAP[e+32];HEAP[e+36]=w+HEAP[e+36];a=x+a;_gray_set_cell(e,i,a);if(a==l)break b}}while(0);n=h+-256+o;HEAP[e+32]=n*r+HEAP[e+32];HEAP[e+36]=n+HEAP[e+36]}else{m=(256-f)*k;o=256;q=1;if(reSign(j,32)<reSign(0,32)){m=k*f;o=0;q=-1;j=0-j}n=j;n=Math.floor(reSign(m,32)/reSign(n,32));r=j;i=m=reSign(m,32)%reSign(r,32);if(reSign(m,
32)<reSign(0,32)){n-=1;i=j+i}l=n+HEAP[e+64];_gray_render_scanline(e,a,HEAP[e+64],f,l,o);a=q+a;n=reSign(l,32)>>reSign(8,32);_gray_set_cell(e,n,a);n=a!=c;b:do if(n){m=k*256;r=j;r=Math.floor(reSign(m,32)/reSign(r,32));p=j;p=reSign(m,32)%reSign(p,32);if(reSign(p,32)<reSign(0,32)){r-=1;p=j+p}i-=j;if(a==c)break b;m=r;r=p;p=j;t=256-o;v=o;w=q;x=c;i=i;l=l;for(b=10;;){var y=b==10?l:C;z=r+(b==10?i:z);C=reSign(z,32)>=reSign(0,32);var A=z-p;b=m+1;var z=C?A:z,C=(C?b:m)+y;_gray_render_scanline(e,a,y,t,C,v);a=w+
a;y=reSign(C,32)>>reSign(8,32);_gray_set_cell(e,y,a);if(a!=x)b=12;else break}l=C;i=z}while(0);_gray_render_scanline(e,a,l,256-o,g,h)}}}while(0);HEAP[e+64]=g;HEAP[e+68]=d;HEAP[e+72]=c<<8}_gray_render_line.__index__=Runtime.getFunctionIndex(_gray_render_line,"_gray_render_line");
function _gray_move_to(e,g){var d,b,a;_gray_record_cell(g);b=HEAP[e]<<2;a=HEAP[e+4]<<2;var c=reSign(a,32)>>reSign(8,32);var f=d=reSign(b,32)>>reSign(8,32);if(reSign(HEAP[g+12],32)<reSign(f,32))d=HEAP[g+12];f=d;if(reSign(HEAP[g+8],32)>reSign(f,32))d=HEAP[g+8]-1;HEAP[g+32]=0;HEAP[g+36]=0;HEAP[g]=d-HEAP[g+8];HEAP[g+4]=c-HEAP[g+16];HEAP[g+72]=c<<8;HEAP[g+40]=0;_gray_set_cell(g,d,c);HEAP[g+64]=b;HEAP[g+68]=a;return 0}_gray_move_to.__index__=Runtime.getFunctionIndex(_gray_move_to,"_gray_move_to");
function _gray_line_to(e,g){_gray_render_line(g,HEAP[e]<<2,HEAP[e+4]<<2);return 0}_gray_line_to.__index__=Runtime.getFunctionIndex(_gray_line_to,"_gray_line_to");
function _gray_conic_to(e,g,d){var b,a=null,c,f,h;h=d+76;HEAP[h]=HEAP[g]<<2;HEAP[h+4]=HEAP[g+4]<<2;HEAP[h+8]=HEAP[e]<<2;HEAP[h+8+4]=HEAP[e+4]<<2;HEAP[h+16]=HEAP[d+64];HEAP[h+16+4]=HEAP[d+68];e=HEAP[h]+HEAP[h+16]+HEAP[h+8]*-2;g=0-e;e=reSign(e,32)>=reSign(0,32)?e:g;g=HEAP[h+4]+HEAP[h+16+4]+HEAP[h+8+4]*-2;c=0-g;c=reSign(g,32)>=reSign(0,32)?g:c;g=e;if(reSign(g,32)<reSign(c,32)){var i=c;e=i;a=0}else a=-1;i=reSign(a==0?i:g,32)<=reSign(64,32);a:do if(i)_gray_render_line(d,HEAP[h],HEAP[h+4]);else{g=0;if(reSign(e,
32)>reSign(64,32)){e=e;g=g+1;for(a=3;;){l=a==3?0:l;var k=g+l,j=reSign(a==3?e:j,32)>>reSign(2,32);c=reSign(j,32)>reSign(64,32);var l=l+1;if(c)a=4;else break}g=k;e=j}f=d+852;HEAP[f]=g;g=f;c=d+20;var m=d+16,o=f,n=f;f=f;var p=d;a=7;for(;;){v=a==7?0:v;var r=HEAP[g+4*v],q=reSign(r,32)>reSign(1,32);c:do if(q){q=HEAP[h+4];var s=HEAP[h+8+4];b=reSign(s,32)<reSign(q,32)?s:q;q=reSign(s,32)>reSign(q,32)?s:q;s=HEAP[h+16+4];b=reSign(s,32)<reSign(b,32)?s:b;q=reSign(s,32)>reSign(q,32)?s:q;b=reSign(b,32)>>reSign(8,
32);s=HEAP[c];if(reSign(b,32)>=reSign(s,32)){b=9;break c}b=reSign(q,32)>>reSign(8,32);q=HEAP[m];if(reSign(b,32)<reSign(q,32)){b=9;break c}var u=h;HEAP[u+32]=HEAP[u+16];a=HEAP[u+8];b=u+24;q=Math.floor(reSign(HEAP[u+16]+a,32)/reSign(2,32));HEAP[b]=q;b=HEAP[b];q=u+8;a=Math.floor(reSign(HEAP[u]+a,32)/reSign(2,32));HEAP[q]=a;a=u+16;b=Math.floor(reSign(HEAP[q]+b,32)/reSign(2,32));HEAP[a]=b;HEAP[u+32+4]=HEAP[u+16+4];a=HEAP[u+8+4];b=u+24;q=Math.floor(reSign(HEAP[u+16+4]+a,32)/reSign(2,32));HEAP[b+4]=q;b=
HEAP[b+4];q=u+8;a=Math.floor(reSign(HEAP[u+4]+a,32)/reSign(2,32));HEAP[q+4]=a;u=u+16;a=Math.floor(reSign(HEAP[q+4]+b,32)/reSign(2,32));HEAP[u+4]=a;h+=16;u=v+1;a=u-1;HEAP[o+4*a]=r-1;HEAP[f+4*u]=HEAP[n+4*a];a=11;b=12;break c}else b=9;while(0);if(b==9){_gray_render_line(p,HEAP[h],HEAP[h+4]);var t=v-1;h+=-16;a=9}var v=a==9?t:u;if(reSign(v,32)>=reSign(0,32))a=12;else break a}}while(0);return 0}_gray_conic_to.__index__=Runtime.getFunctionIndex(_gray_conic_to,"_gray_conic_to");
function _gray_cubic_to(e,g,d,b){var a=null,c,f;f=b+76;HEAP[f]=HEAP[d]<<2;HEAP[f+4]=HEAP[d+4]<<2;HEAP[f+8]=HEAP[g]<<2;HEAP[f+8+4]=HEAP[g+4]<<2;HEAP[f+16]=HEAP[e]<<2;HEAP[f+16+4]=HEAP[e+4]<<2;HEAP[f+24]=HEAP[b+64];HEAP[f+24+4]=HEAP[b+68];e=b+20;g=b+76;d=b+16;a:for(;;){var h=HEAP[f+4];a=HEAP[f+8+4];c=reSign(a,32)<reSign(h,32)?a:h;h=reSign(a,32)>reSign(h,32)?a:h;a=HEAP[f+16+4];c=reSign(a,32)<reSign(c,32)?a:c;h=reSign(a,32)>reSign(h,32)?a:h;a=HEAP[f+24+4];var i=reSign(a,32)<reSign(c,32)?a:c;c=reSign(a,
32)>reSign(h,32)?a:h;h=reSign(i,32)>>reSign(8,32);a=HEAP[e];h=reSign(h,32)>=reSign(a,32);b:do if(!h){c=reSign(c,32)>>reSign(8,32);h=HEAP[d];if(reSign(c,32)<reSign(h,32))break b;c=HEAP[f+24]-HEAP[f];h=HEAP[f+24+4]-HEAP[f+4];a=0-c;a=reSign(c,32)>=reSign(0,32)?c:a;i=0-h;i=reSign(h,32)>=reSign(0,32)?h:i;if(reSign(a,32)>reSign(i,32)){var k=reSign(i*97+a*236,32)>>reSign(8,32);a=3}else{var j=reSign(i*236+a*97,32)>>reSign(8,32);a=5}a=a==5?j:k;i=reSign(a,32)>reSign(32767,32);c:do if(!i){var l=a*42,m=HEAP[f+
8]-HEAP[f],o=HEAP[f+8+4]-HEAP[f+4],n=m*h-o*c,p=0-n;n=reSign(n,32)>=reSign(0,32)?n:p;if(reSign(n,32)>reSign(l,32))break c;n=HEAP[f+16]-HEAP[f];p=HEAP[f+16+4]-HEAP[f+4];var r=n*h-p*c,q=0-r;r=reSign(r,32)>=reSign(0,32)?r:q;if(reSign(r,32)>reSign(l,32))break c;if(reSign(o*h+m*c,32)<reSign(0,32))break c;if(reSign(p*h+n*c,32)<reSign(0,32))break c;if(reSign((HEAP[f+24]-HEAP[f+8])*c+(HEAP[f+24+4]-HEAP[f+8+4])*h,32)<reSign(0,32))break c;if(!(reSign((HEAP[f+24]-HEAP[f+16])*c+(HEAP[f+24+4]-HEAP[f+16+4])*h,32)<
reSign(0,32)))break b}while(0);c=f;HEAP[c+48]=HEAP[c+24];i=HEAP[c+8];l=HEAP[c+16];h=c+8;a=Math.floor(reSign(HEAP[c]+i,32)/reSign(2,32));HEAP[h]=a;m=c+40;h=Math.floor(reSign(HEAP[c+24]+l,32)/reSign(2,32));HEAP[m]=h;i=Math.floor(reSign(l+i,32)/reSign(2,32));l=c+16;a=Math.floor(reSign(i+a,32)/reSign(2,32));HEAP[l]=a;l=c+32;h=Math.floor(reSign(i+h,32)/reSign(2,32));HEAP[l]=h;i=c+24;h=Math.floor(reSign(h+a,32)/reSign(2,32));HEAP[i]=h;HEAP[c+48+4]=HEAP[c+24+4];i=HEAP[c+8+4];l=HEAP[c+16+4];h=c+8;a=Math.floor(reSign(HEAP[c+
4]+i,32)/reSign(2,32));HEAP[h+4]=a;m=c+40;h=Math.floor(reSign(HEAP[c+24+4]+l,32)/reSign(2,32));HEAP[m+4]=h;i=Math.floor(reSign(l+i,32)/reSign(2,32));l=c+16;a=Math.floor(reSign(i+a,32)/reSign(2,32));HEAP[l+4]=a;l=c+32;h=Math.floor(reSign(i+h,32)/reSign(2,32));HEAP[l+4]=h;c=c+24;h=Math.floor(reSign(h+a,32)/reSign(2,32));HEAP[c+4]=h;f+=24;continue a}while(0);_gray_render_line(b,HEAP[f],HEAP[f+4]);if(g==f)break a;f+=-24}return 0}_gray_cubic_to.__index__=Runtime.getFunctionIndex(_gray_cubic_to,"_gray_cubic_to");
function _gray_render_span(e,g,d,b){var a,c=null,f;f=b+1E3;b=HEAP[f+12]+HEAP[f+8]*-1*e;if(reSign(HEAP[f+8],32)>=reSign(0,32))b+=HEAP[f+8]*(HEAP[f]-1);if(reSign(g,32)>reSign(0,32)){b=e=b;f=0-g;f=reSign(f,32)>reSign(-1,32)?f:-1;g=g+f+1;c=1;a:for(;;){q=c==1?0:q;f=d+6*q+2;var h=d+6*q,i=HEAP[d+6*q+4],k=i!=0;b:do if(k)if(unSign(HEAP[f],16)>unSign(7,16)){var j=unSign(HEAP[f],16);c=unSign(i,8);a=reSign(HEAP[h],16);_llvm_memset_p0i8_i32(e+a,c&255,j,1,0)}else{j=reSign(HEAP[h],16);j=b+j;c=unSign(HEAP[f],16);
if(c==1){c=15;a=12}else if(c==2){c=15;a=10}else if(c==3){c=15;a=9}else if(c==4){c=15;a=8}else if(c==5){c=15;a=7}else if(c==6){c=15;a=6}else if(c==7){c=15;a=5}else break b;c:do if(a==5){HEAP[j]=i;var l=j+1;c=5;a=6;break c}while(0);c:do if(a==6){var m=c==5?l:j;HEAP[m]=i;m=m+1;c=6;a=7;break c}while(0);c:do if(a==7){var o=c==6?m:j;HEAP[o]=i;o=o+1;c=7;a=8;break c}while(0);c:do if(a==8){var n=c==7?o:j;HEAP[n]=i;n=n+1;c=8;a=9;break c}while(0);c:do if(a==9){var p=c==8?n:j;HEAP[p]=i;p=p+1;c=9;a=10;break c}while(0);
if(a==10){var r=c==9?p:j;HEAP[r]=i;r=r+1;c=10}HEAP[c==10?r:j]=i}while(0);var q=q+1;if(q!=g)c=13;else break a}}}_gray_render_span.__index__=Runtime.getFunctionIndex(_gray_render_span,"_gray_render_span");
function _gray_hline(e,g,d,b,a){var c,f=null,h;g=g;d=d;c=b=reSign(b,32)>>reSign(9,32);if(reSign(c,32)<reSign(0,32)){b=h=0-b;f=0}else f=-1;f=f==0?h:c;h=(HEAP[e+980+16]&2)!=0;a:do if(h){b=f&511;c=reSign(b,32)>reSign(256,32);var i=b;if(c)b=512-i;else{if(i!=256)break a;b=255}}else{if(!(reSign(f,32)>reSign(255,32)))break a;b=255}while(0);d+=HEAP[e+16];g=f=g+HEAP[e+8];if(reSign(f,32)>reSign(32766,32))g=32767;if(b!=0){f=HEAP[e+1232];h=e+1040+6*f+-6;c=reSign(f,32)>reSign(0,32);a:do if(c){if(HEAP[e+1244]!=
d)break a;c=reSign(HEAP[h],16);if(unSign(HEAP[h+2],16)+c!=g)break a;if(unSign(HEAP[h+4],8)!=b)break a;HEAP[h+2]=(a&65535)+HEAP[h+2];return}while(0);i=HEAP[e+1244]!=d;a:do if(i)c=11;else{if(reSign(f,32)>reSign(31,32)){c=11;break a}h+=6;c=17;break a}while(0);if(c==11){h=HEAP[e+1236]!=0;a:do if(h){if(!(reSign(f,32)>reSign(0,32)))break a;FUNCTION_TABLE[HEAP[e+1236]](HEAP[e+1244],f,e+1040,HEAP[e+1240])}while(0);HEAP[e+1232]=0;HEAP[e+1244]=d;h=e+1040}HEAP[h]=g&65535;HEAP[h+2]=a&65535;HEAP[h+4]=b&255;HEAP[e+
1232]+=1}}_gray_hline.__index__=Runtime.getFunctionIndex(_gray_hline,"_gray_hline");function _gray_convert_glyph_inner(e){var g;if(__setjmp(e+1256)==0){g=_FT_Outline_Decompose(e+980,_func_interface,e);_gray_record_cell(e)}else g=64;return g}_gray_convert_glyph_inner.__index__=Runtime.getFunctionIndex(_gray_convert_glyph_inner,"_gray_convert_glyph_inner");
function _gray_raster_render(e,g){var d=STACKTOP;STACKTOP+=320;Runtime.memset(d,0,320);var b,a=null,c,f,h,i,k,j,l,m,o,n,p;f=HEAP[g+4];j=HEAP[g];i=e==0;a:do if(i)b=0;else{if(HEAP[e]==0){b=0;break a}if(HEAP[e+4]==0){b=0;break a}if(f==0)h=20;else{h=HEAP[f+2]==0;b:do if(!h){if(reSign(HEAP[f],16)<=reSign(0,16))break b;h=HEAP[f+12]==0;c:do if(!h){if(HEAP[f+4]==0)break c;h=reSign(HEAP[f+2],16);i=HEAP[f+12];k=reSign(HEAP[f],16)-1;i=reSign(HEAP[i+2*k],16)+1;if(h!=i)h=20;else{h=HEAP[e+16];i=(HEAP[g+8]&2)==
0;d:do if(i){if(j==0)h=6;else{b=HEAP[j+4]==0;e:do if(!b){if(HEAP[j]==0)break e;if(HEAP[j+12]!=0){b=12;break d}h=6;b=4;break a}while(0);h=0}b=4;break a}while(0);if((HEAP[g+8]&1)==0)h=19;else{if((HEAP[g+8]&2)==0){HEAP[h+1024]=0;HEAP[h+1024+4]=0;HEAP[h+1024+8]=HEAP[j+4];HEAP[h+1024+12]=HEAP[j]}else{i=h+1024;if((HEAP[g+8]&4)!=0){k=g+32;HEAP[i]=HEAP[k];HEAP[i+4]=HEAP[k+4];HEAP[i+8]=HEAP[k+8];HEAP[i+12]=HEAP[k+12]}else{HEAP[i]=-32768;HEAP[h+1024+4]=-32768;HEAP[h+1024+8]=32767;HEAP[h+1024+12]=32767}}p=HEAP[e+
4];k=HEAP[e];i=h;k=k;p=p;HEAP[i+1412]=k;HEAP[i+1416]=p;HEAP[i+1420]=k;HEAP[i+44]=0;HEAP[i+48]=0;HEAP[i+52]=0;HEAP[i+32]=0;HEAP[i+36]=0;HEAP[i+40]=1;i=h+980;f=f;HEAP[i]=HEAP[f];HEAP[i+2]=HEAP[f+2];HEAP[i+4]=HEAP[f+4];HEAP[i+8]=HEAP[f+8];HEAP[i+12]=HEAP[f+12];HEAP[i+16]=HEAP[f+16];HEAP[h+52]=0;HEAP[h+40]=1;HEAP[h+1248]=HEAP[e+8];HEAP[h+1232]=0;if((HEAP[g+8]&2)!=0){HEAP[h+1236]=HEAP[g+12];HEAP[h+1240]=HEAP[g+28]}else{f=h+1E3;j=j;HEAP[f]=HEAP[j];HEAP[f+4]=HEAP[j+4];HEAP[f+8]=HEAP[j+8];HEAP[f+12]=HEAP[j+
12];HEAP[f+16]=HEAP[j+16];HEAP[f+18]=HEAP[j+18];HEAP[f+19]=HEAP[j+19];HEAP[f+20]=HEAP[j+20];HEAP[h+1236]=_gray_render_span.__index__;HEAP[h+1240]=h}f=j=h;h=f+980;i=HEAP[h+4];k=reSign(HEAP[h+2],16);k=i+8*k;if(reSign(HEAP[h+2],16)<=reSign(0,16)){HEAP[f+12]=0;HEAP[f+8]=HEAP[f+12];HEAP[f+20]=0;HEAP[f+16]=HEAP[f+20]}else{HEAP[f+12]=HEAP[i];HEAP[f+8]=HEAP[f+12];HEAP[f+20]=HEAP[i+4];HEAP[f+16]=HEAP[f+20];i+=8;if(i<k){h=k;i=i;for(a=16;;){n=a==16?0:n;b=i+8*(n+1);k=HEAP[i+8*n];p=HEAP[i+8*n+4];if(reSign(HEAP[f+
8],32)>reSign(k,32))HEAP[f+8]=k;if(reSign(HEAP[f+12],32)<reSign(k,32))HEAP[f+12]=k;if(reSign(HEAP[f+16],32)>reSign(p,32))HEAP[f+16]=p;if(reSign(HEAP[f+20],32)<reSign(p,32))HEAP[f+20]=p;n=n+1;if(b<h){a=22;b=17}else{b=23;break}}}n=reSign(HEAP[f+8],32)>>reSign(6,32);HEAP[f+8]=n;n=reSign(HEAP[f+16],32)>>reSign(6,32);HEAP[f+16]=n;n=reSign(HEAP[f+12]+63,32)>>reSign(6,32);HEAP[f+12]=n;n=reSign(HEAP[f+20]+63,32)>>reSign(6,32);HEAP[f+20]=n}n=j+1024;f=HEAP[n];f=reSign(HEAP[j+12],32)<=reSign(f,32);d:do if(f)b=
25;else{h=HEAP[n+8];if(reSign(HEAP[j+8],32)>=reSign(h,32)){b=25;break d}h=HEAP[n+4];if(reSign(HEAP[j+20],32)<=reSign(h,32)){b=25;break d}h=HEAP[n+12];if(reSign(HEAP[j+16],32)>=reSign(h,32)){b=25;break d}h=HEAP[n];if(reSign(HEAP[j+8],32)<reSign(h,32))HEAP[j+8]=HEAP[n];h=HEAP[n+4];if(reSign(HEAP[j+16],32)<reSign(h,32))HEAP[j+16]=HEAP[n+4];h=HEAP[n+8];if(reSign(HEAP[j+12],32)>reSign(h,32))HEAP[j+12]=HEAP[n+8];h=HEAP[n+12];if(reSign(HEAP[j+20],32)>reSign(h,32))HEAP[j+20]=HEAP[n+12];HEAP[j+24]=HEAP[j+
12]-HEAP[j+8];HEAP[j+28]=HEAP[j+20]-HEAP[j+16];h=HEAP[j+1248];i=Math.floor(reSign(HEAP[j+20]-HEAP[j+16],32)/reSign(h,32));if(i==0)i=1;if(reSign(i,32)>reSign(38,32))i=39;HEAP[j+1252]=0;m=HEAP[j+16];k=HEAP[j+20];h=0;p=d;var r=d+4,q=d,s=d;e:for(;;){var u=i;b=reSign(h,32)<reSign(u,32);u=j;if(!b){b=73;break e}o=m+HEAP[u+1248];a=i-1==h;f:do if(a)b=37;else{b=k;b=reSign(o,32)>reSign(b,32)?37:38;break f}while(0);if(b==37)o=k;HEAP[p]=m;HEAP[r]=o;m=q;f:for(;;){if(!(s<=m))break f;HEAP[j+1420]=HEAP[j+1412];HEAP[j+
1424]=HEAP[m+4]-HEAP[m];a=HEAP[j+1424]*4;b=a&15;if(reSign(b,32)>reSign(0,32))a=a+16+(0-b);b=HEAP[j+1416];b-=b&15;b=HEAP[j+1412]+b;HEAP[j+44]=HEAP[j+1412]+a;c=HEAP[j+44]>=b;g:do if(!c){a=Math.floor(reSign(b-HEAP[j+44],32)/reSign(16,32));HEAP[j+48]=a;if(reSign(HEAP[j+48],32)<=reSign(1,32))break g;a=reSign(HEAP[j+1424],32)>reSign(0,32);var t=j;if(a){for(a=44;;){x=a==44?0:x;var v=1+x;HEAP[HEAP[(a==44?t:w)+1420]+4*(0+x)]=0;a=reSign(HEAP[j+1424],32)>reSign(v,32);var w=j,x=x+1;if(a)a=45;else break}a=46}else a=
43;HEAP[(a==46?w:t)+52]=0;HEAP[j+40]=1;HEAP[j+16]=HEAP[m];HEAP[j+20]=HEAP[m+4];HEAP[j+28]=HEAP[m+4]-HEAP[m];a=t=_gray_convert_glyph_inner(j);if(t==0){c=j;t=HEAP[c+52]==0;h:do if(!t){HEAP[c+1232]=0;b=reSign(HEAP[c+1424],32)>reSign(0,32);v=c;if(b){var y=c,A=c,z=c+24,C=c,B=c+1424,D=c;a=48;i:for(;;){var E=a==48?0:I,F=0+E,G=1+E,H=HEAP[HEAP[(a==48?v:D)+1420]+4*F];if(H!=0){a=49;b=50}else{a=49;b=51}j:for(;;)if(b==50){J=a==54?J:0;L=a==54?L:0;N=a==54?N:H;reSign(HEAP[N],32)>reSign(L,32)&J!=0&&_gray_hline(y,
L,F,J*512,HEAP[N]-L);var J=HEAP[N+4]+J;L=J*512-HEAP[N+8];b=L!=0;k:do if(b){if(!(reSign(HEAP[N],32)>=reSign(0,32)))break k;_gray_hline(A,HEAP[N],F,L,1)}while(0);var L=HEAP[N]+1,N=HEAP[N+12];if(N!=0){a=54;b=50;continue j}if(J==0){a=56;b=51;continue j}_gray_hline(C,L,F,J*512,HEAP[z]-L);a=57;b=51}else if(b==51){b=reSign(HEAP[B],32)>reSign(G,32);var I=E+1;if(b){a=51;continue i}else break i}}a=58}else a=125;if(HEAP[(a==58?D:v)+1236]==0)break h;if(!(reSign(HEAP[c+1232],32)>reSign(0,32)))break h;FUNCTION_TABLE[HEAP[c+
1236]](HEAP[c+1244],HEAP[c+1232],c+1040,HEAP[c+1240])}while(0);m+=-8;continue f}else if(a!=64){b=64;break e}}while(0);b=HEAP[m];a=HEAP[m+4];c=(reSign(a-b,32)>>reSign(1,32))+b;if(c==b){b=67;break e}t=HEAP[j+1248];if(reSign(b-a,32)>=reSign(t,32))HEAP[j+1252]+=1;HEAP[m+8]=b;HEAP[m+8+4]=c;HEAP[m]=c;HEAP[m+4]=a;m+=8}h+=1;m=o;b=36}if(b==73){l=reSign(HEAP[u+1252],32)>reSign(8,32);e:do if(l){if(!(reSign(HEAP[j+1248],32)>reSign(16,32)))break e;w=Math.floor(reSign(HEAP[j+1248],32)/reSign(2,32));HEAP[j+1248]=
w}while(0);l=0;b=66;break d}else if(b==67){l=1;b=66;break d}else if(b==64){l=1;b=66;break d}}while(0);if(b==25)l=0;h=l=l}}b=4;break a}while(0);h=20;b=4;break a}while(0);h=0}b=4;break a}while(0);if(b==0)h=6;l=h;STACKTOP=d;return l}_gray_raster_render.__index__=Runtime.getFunctionIndex(_gray_raster_render,"_gray_raster_render");
function _gray_raster_new(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b;HEAP[g]=0;b=_ft_mem_alloc(e,20,d);if(HEAP[d]==0){HEAP[b+12]=e;HEAP[g]=b}b=HEAP[d];STACKTOP=d;return b}_gray_raster_new.__index__=Runtime.getFunctionIndex(_gray_raster_new,"_gray_raster_new");function _gray_raster_done(e){var g;g=HEAP[e+12];e!=0&&FUNCTION_TABLE[HEAP[g+8]](g,e)}_gray_raster_done.__index__=Runtime.getFunctionIndex(_gray_raster_done,"_gray_raster_done");
function _gray_raster_reset(e,g,d){var b;if(e!=0){b=g==0;a:do if(!b){if(reSign(d,32)<=reSign(3475,32))break a;b=g;HEAP[e+16]=b;HEAP[e]=g+1440;HEAP[e+4]=g+d-HEAP[e]&-16;g=Math.floor(unSign(HEAP[e+4],32)/unSign(128,32));HEAP[e+8]=g;return}while(0);HEAP[e]=0;HEAP[e+4]=0;HEAP[e+16]=0}}_gray_raster_reset.__index__=Runtime.getFunctionIndex(_gray_raster_reset,"_gray_raster_reset");
function _ft_smooth_init(e){var g;g=HEAP[e+4];FUNCTION_TABLE[HEAP[HEAP[HEAP[e+20]+56]+8]](HEAP[e+60],HEAP[g+172],HEAP[g+176]);return 0}_ft_smooth_init.__index__=Runtime.getFunctionIndex(_ft_smooth_init,"_ft_smooth_init");function _ft_smooth_set_mode(e,g,d){return FUNCTION_TABLE[HEAP[HEAP[HEAP[e+20]+56]+12]](HEAP[e+60],g,d)}_ft_smooth_set_mode.__index__=Runtime.getFunctionIndex(_ft_smooth_set_mode,"_ft_smooth_set_mode");
function _ft_smooth_transform(e,g,d,b){var a=null,c,f,h,i;i=0;e=HEAP[g+72]!=HEAP[e+24];a:do if(e)i=6;else{var k=d!=0;b:do if(k){f=d;c=g+108;f=f;if(c==0)break b;if(f==0)break b;h=HEAP[c+4];c=reSign(HEAP[c+2],16);c=h+8*c;if(!(h<c))break b;f=f;c=c;h=h;for(a=4;;){j=a==4?0:j;a=h+8*(j+1);_FT_Vector_Transform(h+8*j,f);var j=j+1;if(a<c)a=5;else break}}while(0);if(b==0)break a;_FT_Outline_Translate(g+108,HEAP[b],HEAP[b+4])}while(0);return i}
_ft_smooth_transform.__index__=Runtime.getFunctionIndex(_ft_smooth_transform,"_ft_smooth_transform");function _ft_smooth_get_cbox(e,g,d){_llvm_memset_p0i8_i32(d,0,16,1,0);HEAP[g+72]==HEAP[e+24]&&_FT_Outline_Get_CBox(g+108,d)}_ft_smooth_get_cbox.__index__=Runtime.getFunctionIndex(_ft_smooth_get_cbox,"_ft_smooth_get_cbox");
function _ft_smooth_render_generic(e,g,d,b,a){var c=STACKTOP;STACKTOP+=68;Runtime.memset(c,0,68);var f,h=null,i,k,j,l,m=c+4,o,n,p,r,q,s,u=c+20,t,v;l=0;h=unSign(d==3,1);r=unSign(d==4,1);i=HEAP[g+72]!=HEAP[e+24];a:do{if(i){HEAP[c]=6;f=0}else{if(d!=a)j=19;else{l=g+108;b!=0&&_FT_Outline_Translate(l,HEAP[b],HEAP[b+4]);_FT_Outline_Get_CBox(l,m);HEAP[m]&=-64;HEAP[m+4]&=-64;HEAP[m+8]=HEAP[m+8]+63&-64;HEAP[m+12]=HEAP[m+12]+63&-64;d=reSign(HEAP[m],32)>=reSign(0,32);b:do if(!d){d=HEAP[m]+2147483647;if(reSign(HEAP[m+
8],32)<=reSign(d,32))break b;j=98;f=1;break a}while(0);o=reSign(HEAP[m+8]-HEAP[m],32)>>reSign(6,32);d=reSign(HEAP[m+4],32)>=reSign(0,32);b:do if(!d){d=HEAP[m+4]+2147483647;if(reSign(HEAP[m+12],32)<=reSign(d,32))break b;j=98;f=1;break a}while(0);d=reSign(HEAP[m+12]-HEAP[m+4],32)>>reSign(6,32);f=g+76;p=HEAP[e+8];n=o;a=d;if((HEAP[HEAP[g+156]+4]&1&255)!=0){k=HEAP[f+12];i=p;k=k;k!=0&&FUNCTION_TABLE[HEAP[i+8]](i,k);HEAP[f+12]=0;HEAP[HEAP[g+156]+4]&=-2}i=o;if(h!=0){o*=3;i=o+3&-4}if(r!=0)d*=3;k=HEAP[m];q=
HEAP[m+4];s=reSign(HEAP[m],32)>>reSign(6,32);m=reSign(HEAP[m+12],32)>>reSign(6,32);v=unSign(o,32)>unSign(32767,32);b:do if(!v){if(unSign(d,32)>unSign(32767,32))break b;HEAP[f+18]=2;HEAP[f+16]=256;HEAP[f+4]=o;HEAP[f]=d;HEAP[f+8]=i;_FT_Outline_Translate(l,0-k,0-q);p=_ft_mem_alloc(p,d*i,c);HEAP[f+12]=p;if(HEAP[c]!=0){f=0;break a}HEAP[HEAP[g+156]+4]|=1;HEAP[u]=f;HEAP[u+4]=l;HEAP[u+8]=1;e=FUNCTION_TABLE[HEAP[e+64]](HEAP[e+60],u);HEAP[c]=e;p=h!=0;c:do if(p){e=HEAP[f+12];u=h=a;if(h==0)break c;for(;;){h=
e+o;t=v=n;if(v!=0){v=e;t=t;var w=h,x=t+-1;for(h=16;;){C=h==16?0:C;var y=C*-3;h=w+(y+-1);var A=w+(y+-2);y=w+(y+-3);var z=unSign(HEAP[v+(x+C*-1)],8);HEAP[y]=z&255;HEAP[A]=z&255;HEAP[h]=z&255;var C=C+1;if(C!=t)h=17;else break}}u=h=u-1;e+=i;if(h==0)break c}}while(0);r=r!=0;c:do if(r){v=HEAP[f+12]+(d-a)*i;p=HEAP[f+12];h=o=a;if(o==0)break c;u=e=n=C=o=i;p=p;v=v;t=h;w=C+i;x=w+i;for(h=20;;){B=h==20?0:B;h=v+u*B;A=x*B;y=p+(w+A);z=p+(C+A);_llvm_memcpy_p0i8_p0i8_i32(p+A,h,o,1,0);_llvm_memcpy_p0i8_p0i8_i32(z,h,
n,1,0);_llvm_memcpy_p0i8_p0i8_i32(y,h,e,1,0);var B=B+1;if(B!=t)h=22;else break}}while(0);_FT_Outline_Translate(l,k,q);if(HEAP[c]!=0){f=0;break a}HEAP[g+72]=1651078259;HEAP[g+100]=s;HEAP[g+104]=m;f=0;break a}while(0);j=98}f=1}break a}while(0);if(f==0){g=l!=0;a:do if(g){if(b==0)break a;_FT_Outline_Translate(l,0-HEAP[b],0-HEAP[b+4])}while(0);j=HEAP[c]}b=j;STACKTOP=c;return b}_ft_smooth_render_generic.__index__=Runtime.getFunctionIndex(_ft_smooth_render_generic,"_ft_smooth_render_generic");
function _ft_smooth_render(e,g,d,b){d=d;if(d==1)d=0;return _ft_smooth_render_generic(e,g,d,b,0)}_ft_smooth_render.__index__=Runtime.getFunctionIndex(_ft_smooth_render,"_ft_smooth_render");function _ft_smooth_render_lcd(e,g,d,b){e=_ft_smooth_render_generic(e,g,d,b,3);if(e==0)HEAP[g+76+18]=5;return e}_ft_smooth_render_lcd.__index__=Runtime.getFunctionIndex(_ft_smooth_render_lcd,"_ft_smooth_render_lcd");
function _ft_smooth_render_lcd_v(e,g,d,b){e=_ft_smooth_render_generic(e,g,d,b,4);if(e==0)HEAP[g+76+18]=6;return e}_ft_smooth_render_lcd_v.__index__=Runtime.getFunctionIndex(_ft_smooth_render_lcd_v,"_ft_smooth_render_lcd_v");function _FTC_MruNode_Up(e,g){var d,b,a;d=HEAP[e];if(d!=g){b=HEAP[g+4];a=HEAP[g];HEAP[b]=a;HEAP[a+4]=b;b=HEAP[d+4];HEAP[b]=g;HEAP[d+4]=g;HEAP[g]=d;HEAP[g+4]=b;HEAP[e]=g}}_FTC_MruNode_Up.__index__=Runtime.getFunctionIndex(_FTC_MruNode_Up,"_FTC_MruNode_Up");
function _FTC_MruList_New(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c,f,h,i,k,j;c=HEAP[e+36];a=HEAP[e+4];f=unSign(HEAP[e],32)<unSign(a,32);a:do if(f)a=0;else{if(HEAP[e+4]==0){a=0;break a}j=HEAP[HEAP[e+8]+4];if(HEAP[e+16+12]!=0){_FTC_MruNode_Up(e+8,j);a=FUNCTION_TABLE[HEAP[e+16+12]](j,g,HEAP[e+12]);HEAP[b]=a;if(HEAP[b]==0){a=2;break a}}f=j;a=e+8;f=f;h=HEAP[a];i=HEAP[f+4];k=HEAP[f];HEAP[i]=k;HEAP[k+4]=i;i=f==k;b:do if(i)HEAP[a]=0;else{if(f!=h)break b;HEAP[a]=k}while(0);HEAP[e]-=
1;if(HEAP[e+16+16]==0){a=8;break a}FUNCTION_TABLE[HEAP[e+16+16]](j,HEAP[e+12]);a=8;break a}while(0);a:do if(a==0){j=_ft_mem_alloc(c,HEAP[e+16],b);a=HEAP[b]!=0?2:8;break a}while(0);if(a==8){g=FUNCTION_TABLE[HEAP[e+16+8]](j,g,HEAP[e+12]);HEAP[b]=g;if(g!=0){HEAP[e+16+16]!=0&&FUNCTION_TABLE[HEAP[e+16+16]](j,HEAP[e+12]);e=j;e!=0&&FUNCTION_TABLE[HEAP[c+8]](c,e);j=0}else{f=j;c=e+8;g=HEAP[c];if(g!=0){a=HEAP[g+4];HEAP[g+4]=f;HEAP[a]=f;HEAP[f]=g;HEAP[f+4]=a}else{HEAP[f]=f;HEAP[f+4]=f}HEAP[c]=f;HEAP[e]+=1}}HEAP[d]=
j;d=HEAP[b];STACKTOP=b;return d}_FTC_MruList_New.__index__=Runtime.getFunctionIndex(_FTC_MruList_New,"_FTC_MruList_New");function _FTC_MruList_Remove(e,g){var d,b,a,c;d=e+8;b=HEAP[d];a=HEAP[g+4];c=HEAP[g];HEAP[a]=c;HEAP[c+4]=a;a=g==c;a:do if(a)HEAP[d]=0;else{if(g!=b)break a;HEAP[d]=c}while(0);HEAP[e]-=1;d=HEAP[e+36];HEAP[e+16+16]!=0&&FUNCTION_TABLE[HEAP[e+16+16]](g,HEAP[e+12]);g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g)}_FTC_MruList_Remove.__index__=Runtime.getFunctionIndex(_FTC_MruList_Remove,"_FTC_MruList_Remove");
function _FTC_MruList_RemoveSelection(e,g,d){var b,a=null,c=HEAP[e+8];b=c;var f=e+8,h=b;if(g==0){a=-1;b=0}else{a=-1;b=1}a:for(;;)if(b==0){var i=a==3?k:h;if((a==3?k:c)==0){a=0;break a}_FTC_MruList_Remove(e,i);var k=HEAP[f];a=3;b=0}else if(b==1){var j=a==4?l:h;if((a==4?l:c)==0){a=1;break a}if(FUNCTION_TABLE[g](j,d)==0){a=5;break a}_FTC_MruList_Remove(e,j);var l=HEAP[f];a=4;b=1}b=a=a==0?i:a==5?j:j;c=a!=0;a:do if(c){a=HEAP[b];if(a==b)break a;f=g;i=d;k=e;j=b;l=a;for(a=6;;){a=a==6?l:m;var m=HEAP[a];FUNCTION_TABLE[f](a,
i)!=0&&_FTC_MruList_Remove(k,a);if(m!=j)a=10;else break}}while(0)}_FTC_MruList_RemoveSelection.__index__=Runtime.getFunctionIndex(_FTC_MruList_RemoveSelection,"_FTC_MruList_RemoveSelection");
function _ftc_scaler_lookup_size(e,g,d){var b=STACKTOP;STACKTOP+=8;Runtime.memset(b,0,8);var a=null,c,f=b+4;HEAP[f]=0;c=_FTC_Manager_LookupFace(e,HEAP[g],b);e=c!=0;a:do if(!e){c=_FT_New_Size(HEAP[b],f);if(c!=0)break a;a=HEAP[f];var h=a==0;b:do if(!h){c=HEAP[a];var i=c==0;c:do if(!i){if(HEAP[c+96]==0)break c;HEAP[c+88]=a;break b}while(0)}while(0);a=g;if(HEAP[g+12]!=0){var k=_FT_Set_Pixel_Sizes(HEAP[b],HEAP[g+4],HEAP[a+8]);c=k;a=6}else{var j=_FT_Set_Char_Size(HEAP[b],HEAP[g+4],HEAP[g+8],HEAP[g+16],
HEAP[a+20]);c=j;a=8}if((a==8?j:k)==0)break a;_FT_Done_Size(HEAP[f]);HEAP[f]=0}while(0);HEAP[d]=HEAP[f];g=c;STACKTOP=b;return g}_ftc_scaler_lookup_size.__index__=Runtime.getFunctionIndex(_ftc_scaler_lookup_size,"_ftc_scaler_lookup_size");function _ftc_size_node_done(e){e=HEAP[e+8];e!=0&&_FT_Done_Size(e)}_ftc_size_node_done.__index__=Runtime.getFunctionIndex(_ftc_size_node_done,"_ftc_size_node_done");
function _ftc_size_node_compare(e,g){var d,b,a;a=e+12;var c=HEAP[a]==HEAP[g];a:do if(c){if(HEAP[a+4]!=HEAP[g+4]){d=1;break a}if(HEAP[a+8]!=HEAP[g+8]){d=1;break a}d=unSign(HEAP[a+12]==0,1);c=unSign(HEAP[g+12]!=0,1);if(unSign(d!=0^c!=0,1)==0){d=1;break a}if(HEAP[a+12]==0){if(HEAP[a+16]!=HEAP[g+16]){d=1;break a}if(HEAP[a+20]!=HEAP[g+20]){d=1;break a}}b=a=HEAP[e+8];d=a==0;b:do if(!d){a=HEAP[b];c=a==0;c:do if(!c){if(HEAP[a+96]==0)break c;HEAP[a+88]=b;break b}while(0)}while(0);b=1;d=10;break a}else d=1;
while(0);if(d==1)b=0;return b&255}_ftc_size_node_compare.__index__=Runtime.getFunctionIndex(_ftc_size_node_compare,"_ftc_size_node_compare");function _ftc_size_node_init(e,g,d){var b=e+12;HEAP[b]=HEAP[g];HEAP[b+4]=HEAP[g+4];HEAP[b+8]=HEAP[g+8];HEAP[b+12]=HEAP[g+12];HEAP[b+16]=HEAP[g+16];HEAP[b+20]=HEAP[g+20];return _ftc_scaler_lookup_size(d,g,e+8)}_ftc_size_node_init.__index__=Runtime.getFunctionIndex(_ftc_size_node_init,"_ftc_size_node_init");
function _ftc_size_node_reset(e,g,d){_FT_Done_Size(HEAP[e+8]);var b=e+12;HEAP[b]=HEAP[g];HEAP[b+4]=HEAP[g+4];HEAP[b+8]=HEAP[g+8];HEAP[b+12]=HEAP[g+12];HEAP[b+16]=HEAP[g+16];HEAP[b+20]=HEAP[g+20];return _ftc_scaler_lookup_size(d,g,e+8)}_ftc_size_node_reset.__index__=Runtime.getFunctionIndex(_ftc_size_node_reset,"_ftc_size_node_reset");function _ftc_size_node_compare_faceid(e,g){return unSign(HEAP[e+12]==g,1)&255}
_ftc_size_node_compare_faceid.__index__=Runtime.getFunctionIndex(_ftc_size_node_compare_faceid,"_ftc_size_node_compare_faceid");
function _FTC_Manager_LookupSize(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c=null,f,h,i,k;if(d==0)e=6;else{HEAP[d]=0;if(e==0)e=39;else{h=e+132+8;i=_ftc_size_node_compare.__index__;f=0;k=HEAP[h];var j=k!=0;a:do if(j){c=k;var l=i,m=g,o=k,n=c;for(c=1;;){var p=c==4?r:n;if(FUNCTION_TABLE[l](p,m)!=0){a=3;break}var r=HEAP[p];if(r!=o){c=4;a=2}else{c=4;a=8;break}}if(a==3){c=p;p!=k&&_FTC_MruNode_Up(h,c);HEAP[b]=c;var q=f;c=6;a=7;break a}else if(a==8){a=9;break a}}else a=9;while(0);if(a==
9){var s=_FTC_MruList_New(e+132,g,b);f=s;c=9}if((c==9?s:q)==0)HEAP[d]=HEAP[HEAP[b]+8];e=f}}e=e;STACKTOP=b;return e}_FTC_Manager_LookupSize.__index__=Runtime.getFunctionIndex(_FTC_Manager_LookupSize,"_FTC_Manager_LookupSize");function _ftc_face_node_init(e,g,d){HEAP[e+8]=g;g=FUNCTION_TABLE[HEAP[d+176]](g,HEAP[d],HEAP[d+172],e+12);d=g==0;a:do if(d){if(HEAP[HEAP[e+12]+88]==0)break a;_FT_Done_Size(HEAP[HEAP[e+12]+88])}while(0);return g}
_ftc_face_node_init.__index__=Runtime.getFunctionIndex(_ftc_face_node_init,"_ftc_face_node_init");function _ftc_face_node_done(e,g){_FTC_MruList_RemoveSelection(g+132,_ftc_size_node_compare_faceid.__index__,HEAP[e+8]);_FT_Done_Face(HEAP[e+12]);HEAP[e+12]=0;HEAP[e+8]=0}_ftc_face_node_done.__index__=Runtime.getFunctionIndex(_ftc_face_node_done,"_ftc_face_node_done");function _ftc_face_node_compare(e,g){return unSign(HEAP[e+8]==g,1)&255}
_ftc_face_node_compare.__index__=Runtime.getFunctionIndex(_ftc_face_node_compare,"_ftc_face_node_compare");
function _FTC_Manager_LookupFace(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c=null,f,h,i,k;if(d==0)e=6;else{HEAP[d]=0;if(e==0)e=39;else{h=e+92+8;i=_ftc_face_node_compare.__index__;f=0;k=HEAP[h];var j=k!=0;a:do if(j){c=k;var l=i,m=g,o=k,n=c;for(c=1;;){var p=c==4?r:n;if(FUNCTION_TABLE[l](p,m)!=0){a=3;break}var r=HEAP[p];if(r!=o){c=4;a=2}else{c=4;a=8;break}}if(a==3){c=p;p!=k&&_FTC_MruNode_Up(h,c);HEAP[b]=c;var q=f;c=6;a=7;break a}else if(a==8){a=9;break a}}else a=9;while(0);if(a==
9){var s=_FTC_MruList_New(e+92,g,b);f=s;c=9}if((c==9?s:q)==0)HEAP[d]=HEAP[HEAP[b]+12];e=f}}e=e;STACKTOP=b;return e}_FTC_Manager_LookupFace.__index__=Runtime.getFunctionIndex(_FTC_Manager_LookupFace,"_FTC_Manager_LookupFace");
function _FTC_Manager_New(e,g,d,b,a,c,f){var h=STACKTOP;STACKTOP+=4;Runtime.memset(h,0,4);var i,k;i=g;g=d;k=b;if(e==0)f=33;else{b=HEAP[e];d=_ft_mem_alloc(b,180,h);if(HEAP[h]==0){if(i==0)i=2;if(g==0)g=4;if(k==0)k=2E5;HEAP[d]=e;HEAP[d+4]=b;HEAP[d+12]=k;HEAP[d+176]=a;HEAP[d+172]=c;c=i;e=d+92;a=_ftc_face_list_class;HEAP[e]=0;HEAP[e+4]=c;HEAP[e+8]=0;c=e+16;HEAP[c]=HEAP[a];HEAP[c+4]=HEAP[a+4];HEAP[c+8]=HEAP[a+8];HEAP[c+12]=HEAP[a+12];HEAP[c+16]=HEAP[a+16];HEAP[e+12]=d;HEAP[e+36]=b;a=g;g=d+132;e=_ftc_size_list_class;
HEAP[g]=0;HEAP[g+4]=a;HEAP[g+8]=0;a=g+16;HEAP[a]=HEAP[e];HEAP[a+4]=HEAP[e+4];HEAP[a+8]=HEAP[e+8];HEAP[a+12]=HEAP[e+12];HEAP[a+16]=HEAP[e+16];HEAP[g+12]=d;HEAP[g+36]=b;HEAP[f]=d}f=HEAP[h]}f=f;STACKTOP=h;return f}_FTC_Manager_New.__index__=Runtime.getFunctionIndex(_FTC_Manager_New,"_FTC_Manager_New");
function _FTC_Manager_Done(e){var g=null,d,b,a,c,f=e==0;a:do if(!f){if(HEAP[e]==0)break a;d=HEAP[e+4];c=HEAP[e+88];c=a=c-1;if(a!=-1){a=e;b=d;var h=e;c=c;var i=c+1;for(g=2;;){j=g==2?0:j;var k=c+j*-1;g=h+24+k*4;k=HEAP[a+24+k*4];if(k!=0){FUNCTION_TABLE[HEAP[k+16+28]](k);k=k;k!=0&&FUNCTION_TABLE[HEAP[b+8]](b,k);HEAP[g]=0}var j=j+1;if(j!=i)g=4;else break}}HEAP[e+88]=0;a=a=e+132;b=HEAP[a+8]!=0;b:do if(b){h=a+8;c=a;for(i=a+8;;){_FTC_MruList_Remove(c,HEAP[h]);if(HEAP[i]==0)break b}}while(0);a=a=e+92;b=HEAP[a+
8]!=0;b:do if(b){h=a+8;c=a;for(i=a+8;;){_FTC_MruList_Remove(c,HEAP[h]);if(HEAP[i]==0)break b}}while(0);HEAP[e]=0;HEAP[e+4]=0;a=e;d=d;b=a;if(a==0)break a;FUNCTION_TABLE[HEAP[d+8]](d,b)}while(0)}_FTC_Manager_Done.__index__=Runtime.getFunctionIndex(_FTC_Manager_Done,"_FTC_Manager_Done");
function _FTC_Manager_Reset(e){var g,d,b=e!=0;a:do if(b){d=e+132;var a=HEAP[d+8]!=0;b:do if(a){g=d+8;for(var c=d,f=d+8;;){_FTC_MruList_Remove(c,HEAP[g]);if(HEAP[f]==0)break b}}while(0);g=e+92;if(HEAP[g+8]==0)break a;d=g+8;a=g;for(g=g+8;;){_FTC_MruList_Remove(a,HEAP[d]);if(HEAP[g]==0)break a}}while(0)}_FTC_Manager_Reset.__index__=Runtime.getFunctionIndex(_FTC_Manager_Reset,"_FTC_Manager_Reset");
function _FTC_Manager_RegisterCache(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c=null,f,h;HEAP[b]=6;f=0;h=e!=0;a:do if(h){c=-1;a=g!=0;b:do if(a){if(d==0){a=1;break a}h=HEAP[e+4];if(unSign(HEAP[e+88],32)>unSign(15,32))HEAP[b]=112;else{f=_ft_mem_alloc(h,HEAP[g+20],b);if(HEAP[b]!=0)break b;HEAP[f+48]=e;HEAP[f+52]=h;var i=f+16,k=g;HEAP[i]=HEAP[k];HEAP[i+4]=HEAP[k+4];HEAP[i+8]=HEAP[k+8];HEAP[i+12]=HEAP[k+12];HEAP[i+16]=HEAP[k+16];HEAP[i+20]=HEAP[k+20];HEAP[i+24]=HEAP[k+24];HEAP[i+28]=
HEAP[k+28];HEAP[f+60]=g;HEAP[f+56]=HEAP[e+88];i=FUNCTION_TABLE[HEAP[g+24]](f);HEAP[b]=i;if(HEAP[b]!=0){FUNCTION_TABLE[HEAP[g+28]](f);i=f;f=h;h=i;h!=0&&FUNCTION_TABLE[HEAP[f+8]](f,h);f=0}else{h=HEAP[e+88];HEAP[e+24+h*4]=f;HEAP[e+88]=h+1}}}while(0);var j=d;c=4;a=6;break a}else{c=-1;a=6}while(0);a:do if(a==6){if((c==4?j:d)==0)break a;HEAP[d]=f}while(0);e=HEAP[b];STACKTOP=b;return e}_FTC_Manager_RegisterCache.__index__=Runtime.getFunctionIndex(_FTC_Manager_RegisterCache,"_FTC_Manager_RegisterCache");
function _FTC_Manager_FlushN(e,g){var d=null,b,a;b=HEAP[e+8];if(b==0)b=0;else{a=HEAP[b+4];var c=d=0;for(d=1;;){var f=d==1?a:i,h=d==1?c:j;if(!(unSign(h,32)<unSign(g,32))){d=2;break}var i=HEAP[f+4];if(reSign(HEAP[f+18],16)<=reSign(0,16)){_ftc_node_destroy(f,e);var k=h+1;d=3}else d=7;var j=d==3?k:h;if(f==b){d=5;break}else d=5}b=d=d==2?h:j}return b}_FTC_Manager_FlushN.__index__=Runtime.getFunctionIndex(_FTC_Manager_FlushN,"_FTC_Manager_FlushN");
function _FTC_Manager_RemoveFaceID(e,g){var d,b=null,a,c,f,h,i,k,j,l;_FTC_MruList_RemoveSelection(e+92,_ftc_face_node_compare.__index__,g);a=l=0;d=unSign(HEAP[e+88],32)>unSign(a,32)?0:1;for(;;)if(d==0){i=g;a=HEAP[e+24+l*4];c=i;i=HEAP[a+48];b=0;h=HEAP[a+4]+HEAP[a];f=0;d=h;d=unSign(f,32)<unSign(d,32)?2:3;b:for(;;)if(d==2){k=d=HEAP[a+12]+4*f;j=d=HEAP[k];if(d!=0){d=a+16+12;var m=c,o=a;j=j;k=k;var n=b;for(b=4;;){q=b==4?n:q;r=b==4?k:r;s=b==4?j:s;b=FUNCTION_TABLE[HEAP[d]](s,m,o)!=0;var p=s+8;if(b){HEAP[r]=
HEAP[p];HEAP[s+8]=q;b=6}else b=5;var r=b==6?r:p,q=b==6?s:q,s=HEAP[r];if(s==0)break;else b=8}b=q}f+=1;d=h;d=unSign(f,32)<unSign(d,32)?2:3}else if(d==3){d=b!=0?11:12;break b}if(d==11){c=i+16;f=a+16+4;h=a;d=i+16;i=i;m=a+16+16;o=a;j=a+8;k=a+8;n=b;for(b=11;;){b=b==11?n:u;var u=HEAP[b+8];p=HEAP[c];var t=FUNCTION_TABLE[HEAP[f]](b,h);HEAP[d]=p-t;_ftc_node_mru_unlink(b,i);FUNCTION_TABLE[HEAP[m]](b,o);HEAP[k]=HEAP[j]+1;if(u!=0)b=13;else break}}_ftc_cache_resize(a);l+=1;a=l;d=unSign(HEAP[e+88],32)>unSign(a,
32)?0:1}else if(d==1)break}_FTC_Manager_RemoveFaceID.__index__=Runtime.getFunctionIndex(_FTC_Manager_RemoveFaceID,"_FTC_Manager_RemoveFaceID");function _FTC_Node_Unref(e,g){var d=e!=0;a:do if(d){var b=unSign(HEAP[e+16],16),a=HEAP[g+88];if(!(unSign(b,32)<unSign(a,32)))break a;HEAP[e+18]-=1}while(0)}_FTC_Node_Unref.__index__=Runtime.getFunctionIndex(_FTC_Node_Unref,"_FTC_Node_Unref");function _FTC_Manager_Lookup_Face(e,g,d){return _FTC_Manager_LookupFace(e,g,d)}
_FTC_Manager_Lookup_Face.__index__=Runtime.getFunctionIndex(_FTC_Manager_Lookup_Face,"_FTC_Manager_Lookup_Face");function _FTC_Manager_Lookup_Size(e,g,d,b){var a=STACKTOP;STACKTOP+=28;Runtime.memset(a,0,28);var c=a+24;HEAP[a]=HEAP[g];var f=unSign(HEAP[g+4],16);HEAP[a+4]=f;g=unSign(HEAP[g+6],16);HEAP[a+8]=g;HEAP[a+12]=1;HEAP[a+16]=0;HEAP[a+20]=0;e=_FTC_Manager_LookupSize(e,a,c);if(e!=0){g=0;HEAP[c]=0}else g=HEAP[HEAP[c]];if(d!=0)HEAP[d]=g;if(b!=0)HEAP[b]=HEAP[c];STACKTOP=a;return e}
_FTC_Manager_Lookup_Size.__index__=Runtime.getFunctionIndex(_FTC_Manager_Lookup_Size,"_FTC_Manager_Lookup_Size");function _ftc_node_mru_unlink(e,g){var d,b,a,c;d=g+8;b=HEAP[d];a=HEAP[e+4];c=HEAP[e];HEAP[a]=c;HEAP[c+4]=a;a=e==c;a:do if(a)HEAP[d]=0;else{if(e!=b)break a;HEAP[d]=c}while(0);HEAP[g+20]-=1}_ftc_node_mru_unlink.__index__=Runtime.getFunctionIndex(_ftc_node_mru_unlink,"_ftc_node_mru_unlink");
function _ftc_cache_resize(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);var d=null,b,a,c,f,h,i=g+4;a:for(;;){c=HEAP[e];f=HEAP[e+4];h=f+1+c;if(reSign(HEAP[e+8],32)<reSign(0,32)){d=0;h=f;if(unSign(c,32)>=unSign(h,32)){h=HEAP[e+52];h=_ft_mem_realloc(h,4,(f+1)*2,(f+1)*4,HEAP[e+12],g);HEAP[e+12]=h;if(HEAP[g]!=0)break a}a=HEAP[e+12]+4*c;b=h=HEAP[a];if(h!=0){h=f+1;b=b;a=a;var k=d;for(d=3;;){m=d==3?k:m;l=d==3?a:l;o=d==3?b:o;var j=o+8;if((h&HEAP[o+12])!=0){HEAP[l]=HEAP[j];HEAP[o+8]=m;d=5}else d=4;var l=
d==5?l:j,m=d==5?o:m,o=HEAP[l];if(o==0)break;else d=7}d=m}HEAP[HEAP[e+12]+4*(c+1+f)]=d;HEAP[e+8]+=2;h=f;if(unSign(c,32)>=unSign(h,32)){HEAP[e+4]=f*2+1;HEAP[e]=0}else HEAP[e]=c+1}else{h=h;if(!(reSign(HEAP[e+8],32)>reSign(h,32)))break a;h=f+c;if(unSign(h+1,32)<=unSign(8,32))break a;if(c==0){c=HEAP[e+52];c=_ft_mem_realloc(c,4,(f+1)*2,f+1,HEAP[e+12],i);HEAP[e+12]=c;if(HEAP[i]!=0)break a;c=unSign(HEAP[e+4],32)>>>unSign(1,32);HEAP[e+4]=c;c=HEAP[e+4]}else c-=1;a=HEAP[e+12]+4*c;if(HEAP[a]!=0){f=a;for(d=14;;){var n=
HEAP[d==14?f:n]+8;if(HEAP[n]!=0)d=15;else break}a=n}f=HEAP[e+12]+4*h;HEAP[a]=HEAP[f];HEAP[f]=0;HEAP[e+8]-=2;HEAP[e]=c}}STACKTOP=g}_ftc_cache_resize.__index__=Runtime.getFunctionIndex(_ftc_cache_resize,"_ftc_cache_resize");
function _ftc_node_destroy(e,g){var d,b=null,a,c;c=unSign(HEAP[e+16],16);c=HEAP[g+24+c*4];a=HEAP[g+16];b=FUNCTION_TABLE[HEAP[c+16+4]](e,c);HEAP[g+16]=a-b;_ftc_node_mru_unlink(e,g);b=a=HEAP[c+4]&HEAP[e+12];if(unSign(HEAP[c],32)>unSign(b,32))a=HEAP[c+4]*2+1&HEAP[e+12];a=a=HEAP[c+12]+4*a;for(b=1;;){var f=b==6?h:a;d=HEAP[f];if(d==0){d=3;break}if(d==e){d=5;break}var h=HEAP[f]+8;b=6;d=2}if(d==5){a=f;HEAP[a]=HEAP[e+8];HEAP[e+8]=0;HEAP[c+8]+=1;_ftc_cache_resize(c)}FUNCTION_TABLE[HEAP[c+16+16]](e,c)}
_ftc_node_destroy.__index__=Runtime.getFunctionIndex(_ftc_node_destroy,"_ftc_node_destroy");function _ftc_cache_init(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d;d=HEAP[e+52];HEAP[e]=0;HEAP[e+4]=7;HEAP[e+8]=16;d=_ft_mem_realloc(d,4,0,16,0,g);HEAP[e+12]=d;e=HEAP[g];STACKTOP=g;return e}_ftc_cache_init.__index__=Runtime.getFunctionIndex(_ftc_cache_init,"_ftc_cache_init");
function _ftc_cache_done(e){var g,d=null,b,a,c;if(HEAP[e+52]!=0){c=HEAP[e+52];var f=e!=0;a:do if(f){if(HEAP[e+12]==0)break a;b=HEAP[e+48];var h=a=HEAP[e]+1+HEAP[e+4],i=unSign(0,32)<unSign(h,32);h=e;if(i){i=b;var k=b+16,j=e+16+4,l=e;b=b+16;var m=e+16+16,o=e,n=e+12;a=a;var p=e;unSign(a,32);unSign(1,32);a=(unSign(a,32)>unSign(1,32)?a:1)-0;d=2;b:for(;;){var r=d==2?0:v,q=0+r,s=HEAP[HEAP[(d==2?h:p)+12]+4*q];if(s!=0){d=3;g=4}else{d=3;g=5}for(;;)if(g==4){g=d==4?u:s;var u=HEAP[g+8];HEAP[g+8]=0;_ftc_node_mru_unlink(g,
i);d=HEAP[k];var t=FUNCTION_TABLE[HEAP[j]](g,l);HEAP[b]=d-t;FUNCTION_TABLE[HEAP[m]](g,o);if(u!=0)g=d=4;else{d=4;g=5}}else if(g==5){HEAP[HEAP[n]+4*q]=0;var v=r+1;if(v!=a){d=5;continue b}else break b}}d=7}else d=0;_ftc_cache_resize(d==7?p:h)}while(0);f=HEAP[e+12];f!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f);HEAP[e+12]=0;HEAP[e+4]=0;HEAP[e]=0;HEAP[e+8]=0;HEAP[e+52]=0}}_ftc_cache_done.__index__=Runtime.getFunctionIndex(_ftc_cache_done,"_ftc_cache_done");
function _FTC_Cache_NewNode(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c,f=null,h,i,k,j,l,m,o;m=HEAP[e+48];h=e+16;k=m+20;i=m+20;f=-1;a:for(;;){j=f==-1?4:f==8?p:f==6?n:j;l=FUNCTION_TABLE[HEAP[h]](a,d,e);if(l==0|l!=64){c=1;break a}c=_FTC_Manager_FlushN(m,j);if(c==0){c=3;break a}if(c!=j){f=4;c=0;continue a}var n=j*2;if(!(unSign(n,32)<unSign(c,32)))if(!(unSign(HEAP[i],32)<unSign(n,32))){f=6;c=0;continue a}var p=HEAP[k];f=8;c=0}if(c==1){o=l;f=1}else if(c==3){var r=o=l;f=3}d=(f==3?r:
l)!=0;a:do if(d)HEAP[a]=0;else{m=HEAP[a];h=g;f=e;h=h;m=m;HEAP[m+12]=h;HEAP[m+16]=HEAP[f+56]&65535;HEAP[m+18]=0;k=f;h=m;k=k;j=i=HEAP[k+4]&HEAP[h+12];if(unSign(HEAP[k],32)>unSign(j,32))i=HEAP[k+4]*2+1&HEAP[h+12];i=HEAP[k+12]+4*i;HEAP[h+8]=HEAP[i];HEAP[i]=h;HEAP[k+8]-=1;_ftc_cache_resize(k);h=HEAP[f+48];k=m;h=h;i=h+8;j=k;k=i;i=j;j=l=HEAP[k];if(l!=0){l=HEAP[j+4];HEAP[j+4]=i;HEAP[l]=i;HEAP[i]=j;HEAP[i+4]=l}else{HEAP[i]=i;HEAP[i+4]=i}HEAP[k]=i;HEAP[h+20]+=1;h=HEAP[f+48];k=HEAP[h+16];f=FUNCTION_TABLE[HEAP[f+
16+4]](m,f)+k;HEAP[h+16]=f;f=HEAP[h+12];if(!(unSign(HEAP[h+16],32)>=unSign(f,32)))break a;HEAP[m+18]+=1;h=h;k=h==0;b:do if(!k){i=HEAP[h+8];f=HEAP[h+12];if(unSign(HEAP[h+16],32)<unSign(f,32))break b;if(i==0)break b;f=HEAP[i+4];i=i;j=h;l=h+16;n=h+12;p=f;for(f=17;;){r=f==24?s:p;if(r!=i){var q=HEAP[r+4];f=19}else f=18;var s=f==19?q:0;reSign(HEAP[r+18],16)<=reSign(0,16)&&_ftc_node_destroy(r,j);if(s==0)break;f=HEAP[n];if(unSign(HEAP[l],32)>unSign(f,32))f=24;else break}}while(0);HEAP[m+18]-=1}while(0);HEAP[b]=
HEAP[a];e=o;STACKTOP=a;return e}_FTC_Cache_NewNode.__index__=Runtime.getFunctionIndex(_FTC_Cache_NewNode,"_FTC_Cache_NewNode");function _ftc_cmap_node_free(e,g){var d;d=HEAP[g+52];e!=0&&FUNCTION_TABLE[HEAP[d+8]](d,e)}_ftc_cmap_node_free.__index__=Runtime.getFunctionIndex(_ftc_cmap_node_free,"_ftc_cmap_node_free");
function _ftc_cmap_node_new(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a=null;d=_ft_mem_alloc(HEAP[d+52],288,b);if(HEAP[b]==0){HEAP[d+20]=HEAP[g];HEAP[d+24]=HEAP[g+4];g=Math.floor(unSign(HEAP[g+8],32)/unSign(128,32))*128;HEAP[d+28]=g;for(a=0;;){c=a==0?0:c;HEAP[d+32+(0+c)*2]=-1;var c=c+1;if(c!=128)a=1;else break}}HEAP[e]=d;e=HEAP[b];STACKTOP=b;return e}_ftc_cmap_node_new.__index__=Runtime.getFunctionIndex(_ftc_cmap_node_new,"_ftc_cmap_node_new");
function _ftc_cmap_node_weight(){return 20}_ftc_cmap_node_weight.__index__=Runtime.getFunctionIndex(_ftc_cmap_node_weight,"_ftc_cmap_node_weight");function _ftc_cmap_node_compare(e,g){var d,b,a=HEAP[e+20]==HEAP[g];a:do if(a){if(HEAP[e+24]!=HEAP[g+4]){d=1;break a}d=HEAP[g+8]-HEAP[e+28];d=unSign(d,32)<=unSign(127,32);b=unSign(d,1);d=2;break a}else d=1;while(0);if(d==1)b=0;return b&255}_ftc_cmap_node_compare.__index__=Runtime.getFunctionIndex(_ftc_cmap_node_compare,"_ftc_cmap_node_compare");
function _ftc_cmap_node_remove_faceid(e,g){return unSign(HEAP[e+20]==g,1)&255}_ftc_cmap_node_remove_faceid.__index__=Runtime.getFunctionIndex(_ftc_cmap_node_remove_faceid,"_ftc_cmap_node_remove_faceid");function _FTC_CMapCache_New(e,g){return _FTC_Manager_RegisterCache(e,_ftc_cmap_cache_class,g)}_FTC_CMapCache_New.__index__=Runtime.getFunctionIndex(_FTC_CMapCache_New,"_FTC_CMapCache_New");
function _FTC_CMapCache_Lookup(e,g,d,b){var a=STACKTOP;STACKTOP+=24;Runtime.memset(a,0,24);var c,f=null,h,i,k,j,l,m,o,n;j=a+12;l=a+16;var p,r,q,s=a+20;d=d;b=b;o=h=0;if(reSign(d,32)<reSign(0,32)){o=1;d=0;var u=e;f=0}else f=-1;u=(f==0?u:e)==0;a:do if(u)c=0;else{m=reSign(d,32)<=reSign(15,32);b:do if(m)c=3;else{if(o!=0){c=3;break b}n=g;b=d;HEAP[a]=HEAP[n];c=HEAP[n+4];c=c==0?37:c==1?38:39;if(c==39){c=0;break a}else if(c==37){HEAP[a+4]=HEAP[n+8];HEAP[a+8]=d;c=5;break b}else if(c==38){m=_FTC_Manager_LookupFace(HEAP[e+
48],HEAP[n],j);if(m!=0)c=0;else{_FT_Select_Charmap(HEAP[j],HEAP[n+8]);e=b;j=HEAP[j];e=e;l=0;g=j!=0;c:do if(g){if(HEAP[j+92]==0)break c;l=HEAP[j+92];l=FUNCTION_TABLE[HEAP[HEAP[l+12]+12]](l,e)}while(0);c=j=j=l}break a}}while(0);if(c==3){HEAP[a]=g;HEAP[a+4]=d;HEAP[a+8]=b}m=reSign(g,32)>>reSign(3,32);m=g<<7^m;n=d*211;m=Math.floor(unSign(b,32)/unSign(128,32))+n+m;n=e;p=m;r=_ftc_cmap_node_compare.__index__;m=0;i=f=p&HEAP[n+4];if(unSign(HEAP[n],32)>unSign(i,32))f=HEAP[n+4]*2+1&p;i=f=HEAP[n+12]+4*f;k=p;r=
r;var t=a,v=n,w=f;f=12;b:for(;;){var x=f==18?y:w;c=HEAP[x];HEAP[l]=c;if(c==0){c=14;break b}if(HEAP[HEAP[l]+12]==k)if(FUNCTION_TABLE[r](HEAP[l],t,v)!=0){c=16;break b}var y=HEAP[l]+8;f=18;c=13}if(c==14){var A=_FTC_Cache_NewNode(n,p,a,l);f=14}else if(c==16){f=x;if(HEAP[i]!=HEAP[l]){HEAP[f]=HEAP[HEAP[l]+8];HEAP[HEAP[l]+8]=HEAP[i];HEAP[i]=HEAP[l]}q=HEAP[n+48];c=q+8;HEAP[q+8]!=HEAP[l]&&_FTC_MruNode_Up(c,HEAP[l]);q=m;f=22}m=f==22?q:A;c=HEAP[l];n=m!=0;b:do if(!n)if(unSign(b-HEAP[c+28],32)>unSign(127,32)){c=
0;break a}else{h=unSign(HEAP[c+32+(b-HEAP[c+28])*2],16);if(h!=65535)break b;h=0;m=_FTC_Manager_LookupFace(HEAP[e+48],HEAP[c+20],s);if(m!=0)break b;if(reSign(d,32)>reSign(15,32)){c=0;break a}else{m=HEAP[HEAP[s]+36];f=unSign(d,32)<unSign(m,32);c:do if(f){m=HEAP[HEAP[s]+92];p=HEAP[HEAP[HEAP[s]+40]+4*d];h=m!=p;d:do if(h){if(o!=0)break d;_FT_Set_Charmap(HEAP[s],p)}while(0);r=HEAP[s];i=b;h=r;i=i;k=0;r=r!=0;d:do if(r){if(HEAP[h+92]==0)break d;k=HEAP[h+92];k=FUNCTION_TABLE[HEAP[HEAP[k+12]+12]](k,i)}while(0);
h=h=h=k;if(m==p)break c;if(o!=0)break c;_FT_Set_Charmap(HEAP[s],m)}while(0);HEAP[c+32+(b-HEAP[c+28])*2]=h&65535}}while(0);c=h}while(0);j=c;STACKTOP=a;return j}_FTC_CMapCache_Lookup.__index__=Runtime.getFunctionIndex(_FTC_CMapCache_Lookup,"_FTC_CMapCache_Lookup");function _ftc_gnode_compare(e,g){var d,b,a=HEAP[e+20]!=HEAP[g+4];a:do if(a)d=0;else{if(HEAP[e+24]!=HEAP[g]){d=0;break a}b=1;d=2;break a}while(0);if(d==0)b=0;return unSign(b&255,8)&255}
_ftc_gnode_compare.__index__=Runtime.getFunctionIndex(_ftc_gnode_compare,"_ftc_gnode_compare");function _FTC_GNode_Compare(e,g){var d,b,a=HEAP[e+20]!=HEAP[g+4];a:do if(a)d=0;else{if(HEAP[e+24]!=HEAP[g]){d=0;break a}b=1;d=2;break a}while(0);if(d==0)b=0;d=unSign(b&255,8);return unSign(d&255,8)&255}_FTC_GNode_Compare.__index__=Runtime.getFunctionIndex(_FTC_GNode_Compare,"_FTC_GNode_Compare");
function _ftc_gcache_init(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d,b;b=HEAP[e+52];HEAP[e]=0;HEAP[e+4]=7;HEAP[e+8]=16;b=_ft_mem_realloc(b,4,0,16,0,g);HEAP[e+12]=b;b=HEAP[g];if(b==0){d=HEAP[e+60];var a=HEAP[e+52],c=HEAP[d+32];d=e+64;HEAP[d]=0;HEAP[d+4]=0;HEAP[d+8]=0;var f=d+16;HEAP[f]=HEAP[c];HEAP[f+4]=HEAP[c+4];HEAP[f+8]=HEAP[c+8];HEAP[f+12]=HEAP[c+12];HEAP[f+16]=HEAP[c+16];HEAP[d+12]=e;HEAP[d+36]=a}STACKTOP=g;return b}
_ftc_gcache_init.__index__=Runtime.getFunctionIndex(_ftc_gcache_init,"_ftc_gcache_init");function _ftc_gcache_done(e){_ftc_cache_done(e);e=e+64;var g=HEAP[e+8]!=0;a:do if(g)for(var d=e+8,b=e,a=e+8;;){_FTC_MruList_Remove(b,HEAP[d]);if(HEAP[a]==0)break a}while(0)}_ftc_gcache_done.__index__=Runtime.getFunctionIndex(_ftc_gcache_done,"_ftc_gcache_done");
function _ftc_inode_free(e,g){var d,b;b=HEAP[g+52];if(HEAP[e+28]!=0){_FT_Done_Glyph(HEAP[e+28]);HEAP[e+28]=0}HEAP[e+24]=0;d=HEAP[e+20];HEAP[e+20]=0;var a=d!=0;a:do if(a){HEAP[d+8]-=1;if(HEAP[d+8]!=0)break a;_FTC_MruList_Remove(g+64,d)}while(0);e!=0&&FUNCTION_TABLE[HEAP[b+8]](b,e)}_ftc_inode_free.__index__=Runtime.getFunctionIndex(_ftc_inode_free,"_ftc_inode_free");
function _ftc_inode_new(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c,f,h,i,k,j;a=_ft_mem_alloc(HEAP[d+52],32,b);var l=HEAP[b]==0;a:do if(l){f=a;c=HEAP[g+4];k=HEAP[g];j=HEAP[HEAP[d+60]+32];h=k;i=c;f=f;h=h;i=i;HEAP[f+20]=i;HEAP[f+24]=h;HEAP[i+8]+=1;c=FUNCTION_TABLE[HEAP[j+20]](c,k,d,a+28);HEAP[b]=c;if(HEAP[b]==0)break a;c=d;a=a;c=c;_ftc_inode_free(a,c);a=0}while(0);HEAP[e]=a;e=HEAP[b];STACKTOP=b;return e}_ftc_inode_new.__index__=Runtime.getFunctionIndex(_ftc_inode_new,"_ftc_inode_new");
function _ftc_inode_weight(e){var g,d;d=0;e=HEAP[e+28];g=HEAP[e+8];g=g==1651078259?1:g==1869968492?2:3;if(g==1){d=HEAP[e+28];e=HEAP[e+28+8];g=0-e;d=(reSign(e,32)>=reSign(0,32)?e:g)*d+52}else if(g==2){d=reSign(HEAP[e+20+2],16)*9;e=reSign(HEAP[e+20],16)*2;d=d+40+e}d+=32;return d}_ftc_inode_weight.__index__=Runtime.getFunctionIndex(_ftc_inode_weight,"_ftc_inode_weight");
function _ftc_snode_free(e,g){var d=null,b,a;b=e+32;var c=HEAP[e+28];a=HEAP[g+52];if(c!=0)for(d=0;;){d=d==0?0:h;h=b+16*d+12;var f=HEAP[h];f!=0&&FUNCTION_TABLE[HEAP[a+8]](a,f);HEAP[h]=0;var h=d+1;if(h!=c)d=3;else break}HEAP[e+24]=0;b=HEAP[e+20];HEAP[e+20]=0;c=b!=0;a:do if(c){HEAP[b+8]-=1;if(HEAP[b+8]!=0)break a;_FTC_MruList_Remove(g+64,b)}while(0);e!=0&&FUNCTION_TABLE[HEAP[a+8]](a,e)}_ftc_snode_free.__index__=Runtime.getFunctionIndex(_ftc_snode_free,"_ftc_snode_free");
function _ftc_snode_load(e,g,d,b){var a=STACKTOP;STACKTOP+=8;Runtime.memset(a,0,8);var c,f,h;f=a+4;var i,k;h=HEAP[e+20];c=HEAP[g+4];i=HEAP[e+28];if(unSign(d-HEAP[e+24],32)>=unSign(i,32))b=6;else{e=e+32+16*(d-HEAP[e+24]);i=HEAP[h+16];HEAP[e+12]=0;g=FUNCTION_TABLE[HEAP[i+24]](h,d,g,f);h=g!=0;a:do if(h)d=1;else{f=HEAP[HEAP[f]+84];d=f+76;if(HEAP[f+72]!=1651078259){d=1;break a}h=reSign(HEAP[f+64]+32,32)>>reSign(6,32);i=reSign(HEAP[f+64+4]+32,32)>>reSign(6,32);k=unSign(HEAP[d]&255,8);if(HEAP[d]!=k){d=1;
break a}k=unSign(HEAP[d+4]&255,8);if(HEAP[d+4]!=k){d=1;break a}k=reSign(HEAP[d+8]&255,8);if(HEAP[d+8]!=k){d=1;break a}k=reSign(HEAP[f+100]&255,8);if(HEAP[f+100]!=k){d=1;break a}k=reSign(HEAP[f+104]&255,8);if(HEAP[f+104]!=k){d=1;break a}k=reSign(h&255,8);if(k!=h){d=1;break a}k=reSign(i&255,8);if(k!=i){d=1;break a}HEAP[e]=HEAP[d+4]&255;HEAP[e+1]=HEAP[d]&255;g=reSign(HEAP[d+8]&255,8);HEAP[e+6]=g;HEAP[e+2]=HEAP[f+100]&255;HEAP[e+3]=HEAP[f+104]&255;HEAP[e+8]=h&255;HEAP[e+9]=i&255;HEAP[e+4]=HEAP[d+18];
HEAP[e+5]=(HEAP[d+16]&255)-1;g=d;f=c;c=e;g=g;f=f;d=HEAP[g+8];if(reSign(d,32)<reSign(0,32))d=0-d;d=d*HEAP[g];f=_ft_mem_alloc(f,d,a);HEAP[c+12]=f;HEAP[a]==0&&_llvm_memcpy_p0i8_p0i8_i32(HEAP[c+12],HEAP[g+12],d,1,0);g=c=c=HEAP[a];if(b!=0){c=reSign(HEAP[e+6],16);f=0-c;c=reSign(c,32)>=reSign(0,32)?c:f;f=unSign(HEAP[e+1],8);HEAP[b]=c*f}d=g!=0&g!=64?1:13;break a}while(0);a:do if(d==1){HEAP[e]=-1;HEAP[e+1]=0;g=HEAP[e+12]=0;if(b==0)break a;HEAP[b]=0}while(0);b=g}b=b;STACKTOP=a;return b}
_ftc_snode_load.__index__=Runtime.getFunctionIndex(_ftc_snode_load,"_ftc_snode_load");
function _ftc_snode_new(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c,f,h,i;h=HEAP[d+52];c=0;i=HEAP[g];g=HEAP[g+4];f=FUNCTION_TABLE[HEAP[HEAP[HEAP[d+60]+32]+20]](g,HEAP[d+48]);var k=f==0;a:do if(k)a=0;else{a=f;if(unSign(i,32)>=unSign(a,32)){a=0;break a}c=_ft_mem_alloc(h,288,b);if(HEAP[b]!=0){a=4;break a}a=i&-16;h=f-a;if(unSign(h,32)>unSign(16,32))h=16;f=a;a=g;g=c;f=f;a=a;HEAP[g+20]=a;HEAP[g+24]=f;HEAP[a+8]+=1;HEAP[c+28]=h;i=_ftc_snode_load(c,HEAP[d+48],i,0);HEAP[b]=i;if(i==0){a=
4;break a}d=d;c=c;d=d;_ftc_snode_free(c,d);c=0;a=4;break a}while(0);if(a==0)HEAP[b]=6;HEAP[e]=c;e=HEAP[b];STACKTOP=b;return e}_ftc_snode_new.__index__=Runtime.getFunctionIndex(_ftc_snode_new,"_ftc_snode_new");
function _ftc_snode_weight(e){var g=null,d,b;d=HEAP[e+28];e=e+32;b=288;if(d!=0){b=b;for(g=0;;){h=g==0?0:h;f=g==0?b:f;var a=e+16*h+6;g=e+16*h+1;if(HEAP[e+16*h+12]!=0){var c=reSign(HEAP[a],16);a=0-c;c=reSign(c,32)<reSign(0,32)?a:c;c=unSign(HEAP[g],8)*c+f;g=2}else g=1;var f=g==2?c:f,h=h+1;if(h!=d)g=4;else break}b=f}return b}_ftc_snode_weight.__index__=Runtime.getFunctionIndex(_ftc_snode_weight,"_ftc_snode_weight");
function _ftc_snode_compare(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a=null,c,f;f=HEAP[g];a=HEAP[e+20]!=HEAP[g+4];a:do if(a)g=0;else{g=HEAP[e+28];if(unSign(f-HEAP[e+24],32)>=unSign(g,32)){g=0;break a}c=1;g=2;break a}while(0);if(g==0)c=0;c=g=c&255;g=g!=0;a:do if(g){a=e+32+16*(f-HEAP[e+24]);if(HEAP[a+12]!=0)break a;if(HEAP[a]==-1)break a;HEAP[e+18]+=1;a=HEAP[d+48];var h=d+48,i=e,k=f,j=a,l=a+20,m=a+20;for(a=6;;){var o=a==6?4:a==14?r:a==12?p:o,n=_ftc_snode_load(i,HEAP[h],k,b);if(n==
0|n!=64)break;a=_FTC_Manager_FlushN(j,o);if(a==0)break;if(a==o){var p=o*2;if(!(unSign(p,32)<unSign(a,32)))if(!(unSign(HEAP[m],32)<unSign(p,32))){a=12;continue}var r=HEAP[l];a=14}else a=10}a=n;HEAP[e+18]-=1;if(a!=0)c=0;else HEAP[HEAP[d+48]+16]=HEAP[b]+HEAP[HEAP[d+48]+16]}while(0);e=unSign(c,8)&255;STACKTOP=b;return e}_ftc_snode_compare.__index__=Runtime.getFunctionIndex(_ftc_snode_compare,"_ftc_snode_compare");function _FTC_SNode_Compare(e,g,d){e=_ftc_snode_compare(e,g,d);return unSign(e,8)&255}
_FTC_SNode_Compare.__index__=Runtime.getFunctionIndex(_FTC_SNode_Compare,"_FTC_SNode_Compare");
function _ftc_basic_family_compare(e,g){var d,b,a=HEAP[e+20]!=HEAP[g+8];a:do if(a)d=0;else{if(HEAP[e+20+4]!=HEAP[g+8+4]){d=0;break a}if(HEAP[e+20+8]!=HEAP[g+8+8]){d=0;break a}d=unSign(HEAP[e+20+12]==0,1);a=unSign(HEAP[g+8+12]!=0,1);d=unSign(d!=0^a!=0,1)!=0^1;if(unSign(d,1)!=0){d=0;break a}if(HEAP[e+20+12]==0){if(HEAP[e+20+16]!=HEAP[g+8+16]){d=0;break a}if(HEAP[e+20+20]!=HEAP[g+8+20]){d=0;break a}}if(HEAP[e+20+24]!=HEAP[g+8+24]){d=0;break a}b=1;d=7;break a}while(0);if(d==0)b=0;return unSign(b&255,
8)&255}_ftc_basic_family_compare.__index__=Runtime.getFunctionIndex(_ftc_basic_family_compare,"_ftc_basic_family_compare");function _ftc_basic_family_init(e,g,d){HEAP[e+16]=HEAP[HEAP[d+60]+32];HEAP[e+8]=0;HEAP[e+12]=d;e=e+20;g=g+8;HEAP[e]=HEAP[g];HEAP[e+4]=HEAP[g+4];HEAP[e+8]=HEAP[g+8];HEAP[e+12]=HEAP[g+12];HEAP[e+16]=HEAP[g+16];HEAP[e+20]=HEAP[g+20];HEAP[e+24]=HEAP[g+24];return 0}_ftc_basic_family_init.__index__=Runtime.getFunctionIndex(_ftc_basic_family_init,"_ftc_basic_family_init");
function _ftc_basic_family_get_count(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a,c,f;f=0;c=_FTC_Manager_LookupFace(g,HEAP[e+20],d);var h=c!=0;a:do if(h)b=0;else{if(HEAP[d]==0){b=0;break a}if(c==0)f=HEAP[HEAP[d]+16];a=f;b=4;break a}while(0);if(b==0)a=f;b=a;STACKTOP=d;return b}_ftc_basic_family_get_count.__index__=Runtime.getFunctionIndex(_ftc_basic_family_get_count,"_ftc_basic_family_get_count");
function _ftc_basic_family_load_bitmap(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c;d=_FTC_Manager_LookupSize(d,e+20,a);var f=d==0;a:do if(f){c=HEAP[HEAP[a]];d=_FT_Load_Glyph(c,g,HEAP[e+20+24]|4);if(d!=0)break a;HEAP[b]=c}while(0);e=d;STACKTOP=a;return e}_ftc_basic_family_load_bitmap.__index__=Runtime.getFunctionIndex(_ftc_basic_family_load_bitmap,"_ftc_basic_family_load_bitmap");
function _ftc_basic_family_load_glyph(e,g,d,b){var a=STACKTOP;STACKTOP+=8;Runtime.memset(a,0,8);var c,f,h=a+4;c=_FTC_Manager_LookupSize(HEAP[d+48],e+20,a);d=c==0;a:do if(d){f=HEAP[HEAP[a]];c=_FT_Load_Glyph(f,g,HEAP[e+20+24]);if(c!=0)break a;c=HEAP[HEAP[f+84]+72]==1651078259;b:do if(!c){if(HEAP[HEAP[f+84]+72]==1869968492)break b;c=6;break a}while(0);c=f=_FT_Get_Glyph(HEAP[f+84],h);if(f!=0)break a;HEAP[b]=HEAP[h]}while(0);e=c;STACKTOP=a;return e}
_ftc_basic_family_load_glyph.__index__=Runtime.getFunctionIndex(_ftc_basic_family_load_glyph,"_ftc_basic_family_load_glyph");function _ftc_basic_gnode_compare_faceid(e,g,d){var b,a,c;c=unSign(HEAP[HEAP[e+20]+20]==g,1);var f=c!=0;a:do if(f){b=d;g=e;b=b;a=HEAP[g+20];HEAP[g+20]=0;if(a==0)break a;HEAP[a+8]-=1;if(HEAP[a+8]!=0)break a;_FTC_MruList_Remove(b+64,a)}while(0);return unSign(c,8)&255}_ftc_basic_gnode_compare_faceid.__index__=Runtime.getFunctionIndex(_ftc_basic_gnode_compare_faceid,"_ftc_basic_gnode_compare_faceid");
function _FTC_ImageCache_New(e,g){return _FTC_Manager_RegisterCache(e,_ftc_basic_image_cache_class,g)}_FTC_ImageCache_New.__index__=Runtime.getFunctionIndex(_FTC_ImageCache_New,"_FTC_ImageCache_New");
function _FTC_ImageCache_Lookup(e,g,d,b,a){var c=STACKTOP;STACKTOP+=44;Runtime.memset(c,0,44);var f,h=null,i,k,j,l,m=c+36,o,n,p,r=c+40,q,s=b==0;a:do if(s)k=6;else{HEAP[b]=0;if(a!=0)HEAP[a]=0;i=unSign(HEAP[g+4],32)>unSign(65535,32);k=g;if(i){i=k;HEAP[c+8]=HEAP[i];k=unSign(HEAP[i+4],16);HEAP[c+8+4]=k;k=unSign(HEAP[i+6],16);HEAP[c+8+8]=k;HEAP[c+8+24]=HEAP[i+8]}else{HEAP[c+8]=HEAP[k];HEAP[c+8+4]=HEAP[g+4];HEAP[c+8+8]=HEAP[g+8];HEAP[c+8+24]=HEAP[g+12]}HEAP[c+8+12]=1;HEAP[c+8+16]=0;HEAP[c+8+20]=0;i=reSign(HEAP[c+
8],32)>>reSign(3,32);k=HEAP[c+8]<<7^i;h=HEAP[c+8+4];l=HEAP[c+8+8]*7;i=HEAP[c+8+12]==0?HEAP[c+8+20]*61^HEAP[c+8+16]*33:0;j=l+h+k+i+d+HEAP[c+8+24]*31;i=e;l=c;k=_ftc_basic_family_compare.__index__;HEAP[l]=d;o=i+64+8;n=k;k=0;p=h=HEAP[o];q=h!=0;b:do if(q){h=p;var u=n,t=l,v=p,w=h;for(h=4;;){var x=h==7?y:w;if(FUNCTION_TABLE[u](x,t)!=0){f=6;break}var y=HEAP[x];if(y!=v){h=7;f=5}else{f=10;break}}if(f==6){h=x;x!=p&&_FTC_MruNode_Up(o,h);HEAP[m]=h;f=9;break b}else if(f==10){f=11;break b}}else f=11;while(0);if(f==
11)k=_FTC_MruList_New(i+64,l,m);HEAP[l+4]=HEAP[m];if(k!=0)break a;l=HEAP[l+4];HEAP[l+8]+=1;o=e;j=j;q=_FTC_GNode_Compare.__index__;k=0;n=h=j&HEAP[o+4];if(unSign(HEAP[o],32)>unSign(n,32))h=HEAP[o+4]*2+1&j;n=h=HEAP[o+12]+4*h;p=j;q=q;u=c;t=o;v=h;h=16;b:for(;;){var A=h==22?z:v;f=HEAP[A];HEAP[r]=f;if(f==0){f=18;break b}if(HEAP[HEAP[r]+12]==p)if(FUNCTION_TABLE[q](HEAP[r],u,t)!=0){f=20;break b}var z=HEAP[r]+8;h=22;f=17}b:do if(f==18)k=_FTC_Cache_NewNode(o,j,c,r);else if(f==20){h=A;if(HEAP[n]!=HEAP[r]){HEAP[h]=
HEAP[HEAP[r]+8];HEAP[HEAP[r]+8]=HEAP[n];HEAP[n]=HEAP[r]}h=HEAP[o+48];p=h+8;if(HEAP[h+8]==HEAP[r]){f=25;break b}_FTC_MruNode_Up(p,HEAP[r])}while(0);h=HEAP[r];HEAP[l+8]-=1;HEAP[l+8]==0&&_FTC_MruList_Remove(i+64,l);if(k!=0)break a;HEAP[b]=HEAP[h+28];if(a==0)break a;HEAP[a]=h;HEAP[h+18]+=1}while(0);e=k;STACKTOP=c;return e}_FTC_ImageCache_Lookup.__index__=Runtime.getFunctionIndex(_FTC_ImageCache_Lookup,"_FTC_ImageCache_Lookup");
function _FTC_ImageCache_LookupScaler(e,g,d,b,a,c){var f=STACKTOP;STACKTOP+=44;Runtime.memset(f,0,44);var h,i=null,k,j,l,m=f+36,o,n,p;j=f+40;var r,q;i=a==0;a:do if(i)h=0;else{if(g==0){h=0;break a}HEAP[a]=0;if(c!=0)HEAP[c]=0;k=f+8;i=g;HEAP[k]=HEAP[i];HEAP[k+4]=HEAP[i+4];HEAP[k+8]=HEAP[i+8];HEAP[k+12]=HEAP[i+12];HEAP[k+16]=HEAP[i+16];HEAP[k+20]=HEAP[i+20];HEAP[f+8+24]=d;k=reSign(HEAP[f+8],32)>>reSign(3,32);d=HEAP[f+8]<<7^k;i=HEAP[f+8+4];g=HEAP[f+8+8]*7;k=HEAP[f+8+12]==0?HEAP[f+8+20]*61^HEAP[f+8+16]*
33:0;g=g+i+d+k+b+HEAP[f+8+24]*31;d=e;l=f;k=_ftc_basic_family_compare.__index__;HEAP[l]=b;b=d+64+8;o=k;k=0;n=i=HEAP[b];var s=i!=0;b:do if(s){i=n;var u=o,t=l,v=n,w=i;for(i=5;;){r=i==8?p:w;if(FUNCTION_TABLE[u](r,t)!=0){h=7;break}p=HEAP[r];if(p!=v){i=8;h=6}else{h=11;break}}if(h==7){i=r;r!=n&&_FTC_MruNode_Up(b,i);HEAP[m]=i;h=10;break b}else if(h==11){h=12;break b}}else h=12;while(0);if(h==12)k=_FTC_MruList_New(d+64,l,m);HEAP[l+4]=HEAP[m];if(k!=0){h=15;break a}m=HEAP[l+4];HEAP[m+8]+=1;e=e;r=g;b=_FTC_GNode_Compare.__index__;
k=0;i=p=r&HEAP[e+4];if(unSign(HEAP[e],32)>unSign(i,32))p=HEAP[e+4]*2+1&r;p=i=HEAP[e+12]+4*p;g=r;b=b;l=f;o=e;n=i;i=17;b:for(;;){var x=i==23?q:n;h=HEAP[x];HEAP[j]=h;if(h==0){h=19;break b}if(HEAP[HEAP[j]+12]==g)if(FUNCTION_TABLE[b](HEAP[j],l,o)!=0){h=21;break b}q=HEAP[j]+8;i=23;h=18}b:do if(h==19)k=_FTC_Cache_NewNode(e,r,f,j);else if(h==21){i=x;if(HEAP[p]!=HEAP[j]){HEAP[i]=HEAP[HEAP[j]+8];HEAP[HEAP[j]+8]=HEAP[p];HEAP[p]=HEAP[j]}q=HEAP[e+48];i=q+8;if(HEAP[q+8]==HEAP[j])break b;_FTC_MruNode_Up(i,HEAP[j])}while(0);
j=HEAP[j];HEAP[m+8]-=1;HEAP[m+8]==0&&_FTC_MruList_Remove(d+64,m);if(k!=0){h=15;break a}HEAP[a]=HEAP[j+28];if(c==0){h=15;break a}HEAP[c]=j;HEAP[j+18]+=1;h=15;break a}while(0);if(h==0)k=6;a=k;STACKTOP=f;return a}_FTC_ImageCache_LookupScaler.__index__=Runtime.getFunctionIndex(_FTC_ImageCache_LookupScaler,"_FTC_ImageCache_LookupScaler");
function _ftc_image_type_from_old_desc(e,g){var d,b;HEAP[e]=HEAP[g];d=unSign(HEAP[g+4],16);HEAP[e+4]=d;d=unSign(HEAP[g+6],16);HEAP[e+8]=d;d=0;b=HEAP[g+8];var a=(b&7)==0;a:do if(a){if((b&16)!=0)d|=4096;if((b&256)==0)break a;d|=8}else{d|=8;if((b&128)==0)break a;d|=1}while(0);d|=4;if((b&32)!=0)d|=2;if((b&64)!=0)d|=32;HEAP[e+12]=d}_ftc_image_type_from_old_desc.__index__=Runtime.getFunctionIndex(_ftc_image_type_from_old_desc,"_ftc_image_type_from_old_desc");
function _FTC_Image_Cache_New(e,g){return _FTC_Manager_RegisterCache(e,_ftc_basic_image_cache_class,g)}_FTC_Image_Cache_New.__index__=Runtime.getFunctionIndex(_FTC_Image_Cache_New,"_FTC_Image_Cache_New");function _FTC_Image_Cache_Lookup(e,g,d,b){var a=STACKTOP;STACKTOP+=16;Runtime.memset(a,0,16);if(g==0)e=6;else{_ftc_image_type_from_old_desc(a,g);e=_FTC_ImageCache_Lookup(e,a,d,b,0)}e=e;STACKTOP=a;return e}_FTC_Image_Cache_Lookup.__index__=Runtime.getFunctionIndex(_FTC_Image_Cache_Lookup,"_FTC_Image_Cache_Lookup");
function _FTC_SBitCache_New(e,g){return _FTC_Manager_RegisterCache(e,_ftc_basic_sbit_cache_class,g)}_FTC_SBitCache_New.__index__=Runtime.getFunctionIndex(_FTC_SBitCache_New,"_FTC_SBitCache_New");
function _FTC_SBitCache_Lookup(e,g,d,b,a){var c=STACKTOP;STACKTOP+=44;Runtime.memset(c,0,44);var f,h=null,i,k,j=c+36,l,m=c+40,o,n,p;if(a!=0){HEAP[a]=0;i=b;h=0}else h=-1;if((h==0?i:b)==0)e=6;else{HEAP[b]=0;if(unSign(HEAP[g+4],32)>unSign(65535,32)){HEAP[c+8]=HEAP[g];i=unSign(HEAP[g+4],16);HEAP[c+8+4]=i;i=unSign(HEAP[g+6],16);HEAP[c+8+8]=i;HEAP[c+8+24]=HEAP[g+8]}else{HEAP[c+8]=HEAP[g];HEAP[c+8+4]=HEAP[g+4];HEAP[c+8+8]=HEAP[g+8];HEAP[c+8+24]=HEAP[g+12]}HEAP[c+8+12]=1;HEAP[c+8+16]=0;HEAP[c+8+20]=0;g=reSign(HEAP[c+
8],32)>>reSign(3,32);i=HEAP[c+8]<<7^g;h=HEAP[c+8+4];k=HEAP[c+8+8]*7;g=HEAP[c+8+12]==0?HEAP[c+8+20]*61^HEAP[c+8+16]*33:0;l=HEAP[c+8+24]*31;p=Math.floor(unSign(d,32)/unSign(16,32));i=k+h+i+g+l+p;k=_ftc_basic_family_compare.__index__;HEAP[c]=d;l=e+64+8;g=0;p=HEAP[l];n=p!=0;a:do if(n){h=p;var r=k,q=c,s=p,u=h;for(h=5;;){var t=h==8?o:u;if(FUNCTION_TABLE[r](t,q)!=0){f=7;break}o=HEAP[t];if(o!=s){h=8;f=6}else{f=11;break}}if(f==7){h=t;t!=p&&_FTC_MruNode_Up(l,h);HEAP[j]=h;f=10;break a}else if(f==11){f=12;break a}}else f=
12;while(0);if(f==12)g=_FTC_MruList_New(e+64,c,j);HEAP[c+4]=HEAP[j];t=g==0;a:do if(t){j=HEAP[c+4];HEAP[j+8]+=1;o=e;k=i;n=_FTC_SNode_Compare.__index__;g=0;l=h=k&HEAP[o+4];if(unSign(HEAP[o],32)>unSign(l,32))h=HEAP[o+4]*2+1&k;l=h=HEAP[o+12]+4*h;p=k;n=n;r=c;q=o;s=h;h=15;b:for(;;){var v=h==21?w:s;f=HEAP[v];HEAP[m]=f;if(f==0){f=17;break b}if(HEAP[HEAP[m]+12]==p)if(FUNCTION_TABLE[n](HEAP[m],r,q)!=0){f=19;break b}var w=HEAP[m]+8;h=21;f=16}b:do if(f==17)g=_FTC_Cache_NewNode(o,k,c,m);else if(f==19){h=v;if(HEAP[l]!=
HEAP[m]){HEAP[h]=HEAP[HEAP[m]+8];HEAP[HEAP[m]+8]=HEAP[l];HEAP[l]=HEAP[m]}h=HEAP[o+48];p=h+8;if(HEAP[h+8]==HEAP[m]){f=24;break b}_FTC_MruNode_Up(p,HEAP[m])}while(0);h=HEAP[m];HEAP[j+8]-=1;HEAP[j+8]==0&&_FTC_MruList_Remove(e+64,j);if(g!=0)break a;HEAP[b]=h+32+16*(d-HEAP[h+24]);if(a==0)break a;HEAP[a]=h;HEAP[h+18]+=1}while(0);e=g}e=e;STACKTOP=c;return e}_FTC_SBitCache_Lookup.__index__=Runtime.getFunctionIndex(_FTC_SBitCache_Lookup,"_FTC_SBitCache_Lookup");
function _FTC_SBitCache_LookupScaler(e,g,d,b,a,c){var f=STACKTOP;STACKTOP+=44;Runtime.memset(f,0,44);var h,i=null,k,j,l,m=f+36,o,n,p,r=f+40,q;if(c!=0){HEAP[c]=0;k=a;i=0}else i=-1;k=(i==0?k:a)==0;a:do if(k)h=2;else{if(g==0){h=2;break a}HEAP[a]=0;j=f+8;g=g;HEAP[j]=HEAP[g];HEAP[j+4]=HEAP[g+4];HEAP[j+8]=HEAP[g+8];HEAP[j+12]=HEAP[g+12];HEAP[j+16]=HEAP[g+16];HEAP[j+20]=HEAP[g+20];HEAP[f+8+24]=d;d=reSign(HEAP[f+8],32)>>reSign(3,32);d=HEAP[f+8]<<7^d;g=HEAP[f+8+4];j=HEAP[f+8+8]*7;k=k=HEAP[f+8+12]==0?HEAP[f+
8+20]*61^HEAP[f+8+16]*33:0;i=HEAP[f+8+24]*31;o=Math.floor(unSign(b,32)/unSign(16,32));d=j+g+d+k+i+o;g=e;j=f;k=_ftc_basic_family_compare.__index__;HEAP[j]=b;o=g+64+8;n=k;k=0;p=i=HEAP[o];q=i!=0;b:do if(q){i=p;var s=n,u=j,t=p,v=i;for(i=6;;){var w=i==9?l:v;if(FUNCTION_TABLE[s](w,u)!=0){h=8;break}l=HEAP[w];if(l!=t){i=9;h=7}else{h=12;break}}if(h==8){i=w;w!=p&&_FTC_MruNode_Up(o,i);HEAP[m]=i;h=11;break b}else if(h==12){h=13;break b}}else h=13;while(0);if(h==13)k=_FTC_MruList_New(g+64,j,m);HEAP[j+4]=HEAP[m];
w=k==0;b:do if(w){m=HEAP[j+4];HEAP[m+8]+=1;l=e;o=d;q=_FTC_SNode_Compare.__index__;k=0;n=i=o&HEAP[l+4];if(unSign(HEAP[l],32)>unSign(n,32))i=HEAP[l+4]*2+1&o;n=i=HEAP[l+12]+4*i;p=o;q=q;s=f;u=l;t=i;i=16;c:for(;;){var x=i==22?y:t;h=HEAP[x];HEAP[r]=h;if(h==0){h=18;break c}if(HEAP[HEAP[r]+12]==p)if(FUNCTION_TABLE[q](HEAP[r],s,u)!=0){h=20;break c}var y=HEAP[r]+8;i=22;h=17}c:do if(h==18)k=_FTC_Cache_NewNode(l,o,f,r);else if(h==20){i=x;if(HEAP[n]!=HEAP[r]){HEAP[i]=HEAP[HEAP[r]+8];HEAP[HEAP[r]+8]=HEAP[n];HEAP[n]=
HEAP[r]}i=HEAP[l+48];p=i+8;if(HEAP[i+8]==HEAP[r]){h=25;break c}_FTC_MruNode_Up(p,HEAP[r])}while(0);l=HEAP[r];HEAP[m+8]-=1;HEAP[m+8]==0&&_FTC_MruList_Remove(g+64,m);if(k!=0)break b;HEAP[a]=l+32+16*(b-HEAP[l+24]);if(c==0)break b;HEAP[c]=l;HEAP[l+18]+=1}while(0);j=k;h=32;break a}while(0);if(h==2)j=6;e=j;STACKTOP=f;return e}_FTC_SBitCache_LookupScaler.__index__=Runtime.getFunctionIndex(_FTC_SBitCache_LookupScaler,"_FTC_SBitCache_LookupScaler");
function _FTC_SBit_Cache_New(e,g){return _FTC_Manager_RegisterCache(e,_ftc_basic_sbit_cache_class,g)}_FTC_SBit_Cache_New.__index__=Runtime.getFunctionIndex(_FTC_SBit_Cache_New,"_FTC_SBit_Cache_New");function _FTC_SBit_Cache_Lookup(e,g,d,b){var a=STACKTOP;STACKTOP+=16;Runtime.memset(a,0,16);if(g==0)e=6;else{_ftc_image_type_from_old_desc(a,g);e=_FTC_SBitCache_Lookup(e,a,d,b,0)}e=e;STACKTOP=a;return e}_FTC_SBit_Cache_Lookup.__index__=Runtime.getFunctionIndex(_FTC_SBit_Cache_Lookup,"_FTC_SBit_Cache_Lookup");
function _ft_gzip_alloc(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);e=_ft_mem_alloc(e,g*d,b);STACKTOP=b;return e}_ft_gzip_alloc.__index__=Runtime.getFunctionIndex(_ft_gzip_alloc,"_ft_gzip_alloc");function _ft_gzip_free(e,g){g!=0&&FUNCTION_TABLE[HEAP[e+8]](e,g)}_ft_gzip_free.__index__=Runtime.getFunctionIndex(_ft_gzip_free,"_ft_gzip_free");
function _ft_gzip_check_header(e){var g=STACKTOP;STACKTOP+=8;Runtime.memset(g,0,8);var d,b,a,c,f=g+4;b=_FT_Stream_Seek(e,0);HEAP[g]=b;b=HEAP[g]!=0;a:do if(!b){c=f;a=e;c=c;a=a=_FT_Stream_ReadAt(a,HEAP[a+8],c,4);HEAP[g]=a;if(HEAP[g]!=0)break a;a=HEAP[f]!=31;b:do if(!a){if(HEAP[f+1]!=-117){d=2;break b}if(HEAP[f+2]!=8){d=2;break b}if((unSign(HEAP[f+3],8)&224)!=0){d=2;break b}b=e;b=b=reSign(6,32)<reSign(0,32)?85:_FT_Stream_Seek(b,6+HEAP[b+8]);HEAP[g]=b;if((unSign(HEAP[f+3],8)&4)!=0){b=_FT_Stream_ReadShortLE(e,
g);b=unSign(b,16);if(HEAP[g]!=0)break a;a=b;b=e;a=a;if(reSign(a,32)<reSign(0,32)){HEAP[g]=85;break a}else{b=_FT_Stream_Seek(b,a+HEAP[b+8]);HEAP[g]=b;if(b!=0)break a}}if((unSign(HEAP[f+3],8)&8)!=0){for(b=e;;){d=_FT_Stream_ReadChar(b,g);d=unSign(d,8);if(HEAP[g]!=0){d=11;break}if(d==0){d=13;break}else d=10}if(d==11)break a}if((unSign(HEAP[f+3],8)&16)!=0){for(b=e;;){d=_FT_Stream_ReadChar(b,g);d=unSign(d,8);if(HEAP[g]!=0){d=16;break}if(d==0){d=18;break}else d=15}if(d==16)break a}if((unSign(HEAP[f+3],8)&
2)==0)break a;e=e;e=e=reSign(2,32)<reSign(0,32)?85:_FT_Stream_Seek(e,2+HEAP[e+8]);HEAP[g]=e;break a}while(0);HEAP[g]=3}while(0);e=HEAP[g];STACKTOP=g;return e}_ft_gzip_check_header.__index__=Runtime.getFunctionIndex(_ft_gzip_check_header,"_ft_gzip_check_header");
function _ft_gzip_file_fill_output(e){var g,d=null,b;b=e+12;d=0;HEAP[e+8268]=e+4168;HEAP[b+12]=HEAP[e+8268];HEAP[b+16]=4096;var a=b+16,c=b+4;a:for(;;){if(HEAP[a]==0){g=15;break a}if(HEAP[c]==0){g=e+12;var f=HEAP[e];if(HEAP[f+20]!=0){var h=FUNCTION_TABLE[HEAP[f+20]](f,HEAP[f+8],e+72,4096);if(h==0){g=2;break a}else d=1}else{var i=HEAP[f+4]-HEAP[f+8];if(unSign(i,32)>unSign(4096,32))d=20;else if(i==0){g=6;break a}else d=5;i=d==5?i:4096;_llvm_memcpy_p0i8_p0i8_i32(e+72,HEAP[f]+HEAP[f+8],i,1,0);d=8}d=d==
1?h:i;HEAP[f+8]=d+HEAP[f+8];HEAP[g]=e+72;HEAP[g+4]=d;d=0}g=_inflate(b,0);if(g==1){g=17;break a}else if(g==0)g=0;else{g=18;break a}}a:do if(g==2){g=4;break a}else if(g==6){g=4;break a}else if(g==18){d=85;g=13;break a}else if(g==17){HEAP[e+8272]=HEAP[b+12];if(HEAP[e+8272]!=HEAP[e+8268]){g=13;break a}d=85;g=13;break a}else if(g==15){g=13;break a}while(0);if(g==4)d=85;return d}_ft_gzip_file_fill_output.__index__=Runtime.getFunctionIndex(_ft_gzip_file_fill_output,"_ft_gzip_file_fill_output");
function _ft_gzip_file_io(e,g,d,b){var a,c=null,f,h,i;d=d;i=b;b=0;c=unSign(HEAP[e+8264],32)>unSign(g,32);a:do if(c){a=e;c=HEAP[a];c=_FT_Stream_Seek(c,HEAP[a+68]);if(c==0){h=a+12;_inflateReset(h);HEAP[h+4]=0;HEAP[h]=a+72;HEAP[h+16]=0;HEAP[h+12]=a+4168;HEAP[a+8272]=a+4168+4096;HEAP[a+8268]=HEAP[a+8272];HEAP[a+8264]=0;a=c!=0?0:1}else a=0;break a}else a=1;while(0);a:do if(a==1){c=g;if(unSign(HEAP[e+8264],32)<unSign(c,32)){h=g-HEAP[e+8264];c=e;f=h;h=c+8272;var k=c+8268,j=c+8268,l=c+8268,m=c+8264,o=c+8264,
n=c;f=f;for(c=2;;){var p=c==5?0:0;r=c==5?r:f;a=HEAP[h]-HEAP[k];a=unSign(a,32)>=unSign(r,32)?r:a;HEAP[l]=HEAP[j]+a;HEAP[o]=a+HEAP[m];var r=r-a;if(r==0){a=4;break}if(_ft_gzip_file_fill_output(n)!=0){a=6;break}else{c=5;a=3}}if(a==4){if(p!=0)break a}else if(a==6)break a}if(i==0)break a;h=e+8272;k=e+8268;j=e+8268;l=e+8268;m=e+8268;o=e+8264;n=e+8264;f=e;i=i;d=d;b=b;for(c=8;;){s=c==8?b:s;q=c==8?d:q;u=c==8?i:u;a=HEAP[h]-HEAP[k];a=unSign(a,32)>=unSign(u,32)?u:a;_llvm_memcpy_p0i8_p0i8_i32(q,HEAP[j],a,1,0);
var q=q+a,s=a+s;HEAP[m]=HEAP[l]+a;HEAP[n]=a+HEAP[o];var u=u-a;if(u==0){c=9;a=10;break}if(_ft_gzip_file_fill_output(f)!=0){c=11;a=10;break}else{c=11;a=9}}i=c==9?0:u;b=s;d=q;i=i}while(0);return b}_ft_gzip_file_io.__index__=Runtime.getFunctionIndex(_ft_gzip_file_io,"_ft_gzip_file_io");
function _ft_gzip_stream_close(e){var g,d,b;d=HEAP[e+12];b=HEAP[e+28];if(d!=0){g=d+12;_inflateEnd(g);HEAP[g+32]=0;HEAP[g+36]=0;HEAP[g+40]=0;HEAP[g]=0;HEAP[g+12]=0;HEAP[g+4]=0;HEAP[g+16]=0;HEAP[d+8]=0;HEAP[d]=0;HEAP[d+4]=0;d!=0&&FUNCTION_TABLE[HEAP[b+8]](b,d);HEAP[e+12]=0}}_ft_gzip_stream_close.__index__=Runtime.getFunctionIndex(_ft_gzip_stream_close,"_ft_gzip_stream_close");function _ft_gzip_stream_io(e,g,d,b){return _ft_gzip_file_io(HEAP[e+12],g,d,b)}
_ft_gzip_stream_io.__index__=Runtime.getFunctionIndex(_ft_gzip_stream_io,"_ft_gzip_stream_io");
function _FT_Stream_OpenGzip(e,g){var d=STACKTOP;STACKTOP+=8;Runtime.memset(d,0,8);var b,a=null,c,f,h,i,k,j,l,m=d+4;h=HEAP[g+28];i=_ft_gzip_check_header(g);HEAP[m]=i;i=HEAP[m]!=0;a:do if(!i){_llvm_memset_p0i8_i32(e,0,40,1,0);c=HEAP[e+28]=h;f=m;k=a=0;j=reSign(8276,32)>reSign(0,32);b:do if(j){k=FUNCTION_TABLE[HEAP[c+4]](c,8276);if(k!=0)break b;a=64}else{if(!(reSign(8276,32)<reSign(0,32)))break b;a=6}while(0);HEAP[f]=a;c=c=c=k;f=HEAP[m]==0;b:do if(f){k=e;a=g;f=c;k=k;a=a;j=f+12;HEAP[f+4]=k;HEAP[f]=a;
HEAP[f+8]=HEAP[k+28];HEAP[f+8272]=f+4168+4096;HEAP[f+8268]=HEAP[f+8272];HEAP[f+8264]=0;k=a;var o=l=_ft_gzip_check_header(k),n=o!=0;c:do if(n){a=20;b=6}else{a=20;b=k;b=b=HEAP[b+8];HEAP[f+68]=b;HEAP[j+32]=_ft_gzip_alloc.__index__;HEAP[j+36]=_ft_gzip_free.__index__;HEAP[j+40]=HEAP[k+28];HEAP[j+4]=0;HEAP[j]=f+4168;f=_inflateInit2_(j,-15,__str337,56)!=0;d:do if(!f){if(HEAP[j]==0)break d;f=l;HEAP[m]=f;if(f!=0){b=8;break c}HEAP[e+12]=c;break b}while(0);a=4;b=6;break c}while(0);if(b==6)HEAP[m]=a==20?o:3;
i=c;h=h;c=i;i!=0&&FUNCTION_TABLE[HEAP[h+8]](h,c);break a}while(0);f=g;k=0;a=HEAP[f+8];if(_FT_Stream_Seek(f,HEAP[f+4]-4)==0){k=_FT_Stream_ReadLong(f,d);if(HEAP[d]!=0)k=0;_FT_Stream_Seek(f,a)}f=f=f=k;a=f!=0;k=unSign(f,32)<=unSign(40959,32);if(a&k){a=_ft_mem_alloc(h,f,m);if(HEAP[m]==0){k=_ft_gzip_file_io(c,0,a,f);j=c;if(k==f){i=j;k=i+12;_inflateEnd(k);HEAP[k+32]=0;HEAP[k+36]=0;HEAP[k+40]=0;HEAP[k]=0;HEAP[k+12]=0;HEAP[k+4]=0;HEAP[k+16]=0;HEAP[i+8]=0;HEAP[i]=0;HEAP[i+4]=0;i=c;h=h;i=i;i!=0&&FUNCTION_TABLE[HEAP[h+
8]](h,i);HEAP[e+12]=0;HEAP[e+4]=f;HEAP[e+8]=0;HEAP[e]=a;HEAP[e+20]=0;HEAP[e+24]=_ft_gzip_stream_close.__index__;break a}else{_ft_gzip_file_io(j,0,0,0);f=a;c=h;f=f;f!=0&&FUNCTION_TABLE[HEAP[c+8]](c,f)}}HEAP[m]=0}HEAP[e+4]=2147483647;HEAP[e+8]=0;HEAP[e]=0;HEAP[e+20]=_ft_gzip_stream_io.__index__;HEAP[e+24]=_ft_gzip_stream_close.__index__}while(0);m=HEAP[m];STACKTOP=d;return m}_FT_Stream_OpenGzip.__index__=Runtime.getFunctionIndex(_FT_Stream_OpenGzip,"_FT_Stream_OpenGzip");
function _ft_lzw_check_header(e){var g=STACKTOP;STACKTOP+=2;Runtime.memset(g,0,2);var d,b;d=_FT_Stream_Seek(e,0);var a=d!=0;a:do if(!a){b=g;d=e;b=b;d=d=d=_FT_Stream_ReadAt(d,HEAP[d+8],b,2);if(d!=0)break a;if(HEAP[g]==31)if(HEAP[g+1]==-99)break a;d=3}while(0);e=d;STACKTOP=g;return e}_ft_lzw_check_header.__index__=Runtime.getFunctionIndex(_ft_lzw_check_header,"_ft_lzw_check_header");
function _ft_lzw_stream_close(e){var g,d;g=HEAP[e+12];d=HEAP[e+28];if(g!=0){_ft_lzwstate_done(g+12);HEAP[g+8]=0;HEAP[g]=0;HEAP[g+4]=0;g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+12]=0}}_ft_lzw_stream_close.__index__=Runtime.getFunctionIndex(_ft_lzw_stream_close,"_ft_lzw_stream_close");
function _ft_lzw_stream_io(e,g,d,b){var a,c=null,f,h,i;e=HEAP[e+12];b=b;i=0;c=unSign(HEAP[e+4280],32)>unSign(g,32);a:do if(c){a=HEAP[e+4284]-(e+184);a=unSign(HEAP[e+4280]-g,32)<=unSign(a,32);c=e;if(a){HEAP[e+4284]=HEAP[c+4284]+(0-(HEAP[e+4280]+(0-g)));HEAP[e+4280]=g;a=0}else{a=c;c=HEAP[a];h=_FT_Stream_Seek(c,0);if(h==0){c=a+12;HEAP[c+4]=0;HEAP[c+24]=0;HEAP[c+28]=0;HEAP[c+32]=0;HEAP[c+36]=0;HEAP[c+92]=0;HEAP[c+52]=9;HEAP[c]=0;HEAP[a+4288]=a+184+4096;HEAP[a+4284]=HEAP[a+4288];HEAP[a+4280]=0;a=h!=0?
1:0}else a=1}break a}else a=0;while(0);a:do if(a==0){c=g;if(unSign(HEAP[e+4280],32)<unSign(c,32)){h=g-HEAP[e+4280];c=e;f=h;h=HEAP[c+4288]-HEAP[c+4284];var k=f;if(unSign(h,32)>=unSign(k,32))h=f;HEAP[c+4284]+=h;HEAP[c+4280]=h+HEAP[c+4280];f=h=f-h;k=c+12;var j=c+4280,l=c+4280;f=f;for(c=3;;){a=c==6?o:f;if((c==6?o:h)==0){a=8;break}c=unSign(4096,32)>unSign(a,32)?a:4096;var m=_ft_lzwstate_io(k,0,c);if(unSign(m,32)<unSign(c,32)){a=5;break}HEAP[l]=HEAP[j]+c;var o=a-c;c=6;a=4}if(a!=8)if(a==5)break a}if(b==
0)break a;h=e+4288;k=e+4284;j=e+4284;l=d;f=e+4284;m=e+4284;var n=e+4280,p=e+4280;c=e;var r=b,q=i,s=c+12,u=c+184,t=c+4284,v=c+184,w=c+4284,x=c+4288;for(c=10;;){y=c==10?q:y;A=c==10?r:A;a=HEAP[h]-HEAP[k];a=unSign(a,32)>=unSign(A,32)?A:a;_llvm_memcpy_p0i8_p0i8_i32(l+y,HEAP[j],a,1,0);var y=a+y;HEAP[m]=HEAP[f]+a;HEAP[p]=a+HEAP[n];var A=A-a;if(A==0){a=12;break}HEAP[t]=u;a=_ft_lzwstate_io(s,v,4096);HEAP[x]=HEAP[w]+a;if(a==0){a=14;break}c=15;a=11}if(a==12){i=y;b=0}else if(a==14){i=y;b=A}}while(0);return i}
_ft_lzw_stream_io.__index__=Runtime.getFunctionIndex(_ft_lzw_stream_io,"_ft_lzw_stream_io");
function _FT_Stream_OpenLZW(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a,c,f,h,i,k;b=HEAP[g+28];k=_ft_lzw_check_header(g);HEAP[d]=k;a=HEAP[d]!=0;a:do if(!a){_llvm_memset_p0i8_i32(e,0,40,1,0);HEAP[e+28]=b;k=_ft_mem_alloc(b,4292,d);h=HEAP[d]==0;b:do if(h){f=e;c=g;h=k;i=f;f=c;c=h+12;HEAP[h+4]=i;HEAP[h]=f;HEAP[h+8]=HEAP[i+28];HEAP[h+4288]=h+184+4096;HEAP[h+4284]=HEAP[h+4288];HEAP[h+4280]=0;i=h=_ft_lzw_check_header(f);var j=i!=0;c:do if(j)HEAP[d]=i;else{f=f;c=c;f=f;_llvm_memset_p0i8_i32(c,
0,172,1,0);HEAP[c+164]=f;HEAP[c+168]=HEAP[f+28];HEAP[c+76]=0;HEAP[c+80]=0;HEAP[c+84]=0;HEAP[c+88]=c+100;HEAP[c+96]=64;c=c;HEAP[c+4]=0;HEAP[c+24]=0;HEAP[c+28]=0;HEAP[c+32]=0;HEAP[c+36]=0;HEAP[c+92]=0;HEAP[c+52]=9;HEAP[c]=0;h=h;HEAP[d]=h;if(h!=0)break c;HEAP[e+12]=k;break b}while(0);k=k;b=b;a=k;k!=0&&FUNCTION_TABLE[HEAP[b+8]](b,a);break a}while(0);HEAP[e+4]=2147483647;HEAP[e+8]=0;HEAP[e]=0;HEAP[e+20]=_ft_lzw_stream_io.__index__;HEAP[e+24]=_ft_lzw_stream_close.__index__}while(0);b=HEAP[d];STACKTOP=d;
return b}_FT_Stream_OpenLZW.__index__=Runtime.getFunctionIndex(_FT_Stream_OpenLZW,"_FT_Stream_OpenLZW");
function _ft_lzwstate_get_code(e){var g;g=null;var d,b,a,c;a=HEAP[e+52];c=HEAP[e+24];d=HEAP[e+32]!=0;a:do if(d)g=0;else{g=c;if(reSign(HEAP[e+28],32)<=reSign(g,32)){g=0;break a}g=HEAP[e+60];g=unSign(HEAP[e+56],32)>=unSign(g,32)?0:2;break a}while(0);a:do if(g==0){g=HEAP[e+60];if(unSign(HEAP[e+56],32)>=unSign(g,32)){a+=1;HEAP[e+52]=a;g=HEAP[e+40];g=unSign(HEAP[e+52],32)<unSign(g,32)?(1<<a)-256:HEAP[e+48]+1;HEAP[e+60]=g}if(HEAP[e+32]!=0){a=9;HEAP[e+52]=a;HEAP[e+60]=(1<<a)-256;HEAP[e+32]=0}g=e;if(HEAP[g+
4]==0){d=_FT_Stream_TryRead(HEAP[g+164],g+8,HEAP[g+52]);HEAP[g+28]=d;HEAP[g+36]=d+HEAP[g+36];var f=d;f=unSign(HEAP[g+52],32)>unSign(f,32);f=unSign(f,1);HEAP[g+4]=f;HEAP[g+24]=0;HEAP[g+28]=HEAP[g+28]*8+1+(0-HEAP[g+52]);if(d!=0){c=0;g=2;break a}}b=-1;g=7;break a}while(0);if(g==2){HEAP[e+24]=a+c;b=reSign(c,32)>>reSign(3,32);e=e+8+b;c&=7;b=unSign(HEAP[e],8);g=c;b=reSign(b,32)>>reSign(g,32);e+=1;c=8-c;a=d=a-c;if(unSign(d,32)>unSign(7,32)){b=unSign(HEAP[e],8)<<c|b;e+=1;c+=8;var h=a-8;a=h;g=8}else g=2;if((g==
8?h:d)!=0){h=unSign(HEAP[e],8);b=((1<<a)-1&h)<<c|b}b=b}return b}_ft_lzwstate_get_code.__index__=Runtime.getFunctionIndex(_ft_lzwstate_get_code,"_ft_lzwstate_get_code");
function _ft_lzwstate_stack_grow(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d,b,a,c;d=HEAP[e+96];a=unSign(HEAP[e+92],32)>=unSign(d,32);a:do if(a){a=HEAP[e+168];d=c=HEAP[e+96];var f=unSign(d,32)>>>unSign(1,32);d=d+4+f;if(HEAP[e+88]==e+100)c=HEAP[e+88]=0;a=_ft_mem_realloc(a,1,c,d,HEAP[e+88],g);HEAP[e+88]=a;if(HEAP[g]!=0){b=-1;d=1}else{HEAP[e+96]=d;d=2}break a}else d=2;while(0);if(d==2)b=0;e=b;STACKTOP=g;return e}
_ft_lzwstate_stack_grow.__index__=Runtime.getFunctionIndex(_ft_lzwstate_stack_grow,"_ft_lzwstate_stack_grow");function _ft_lzwstate_reset(e){HEAP[e+4]=0;HEAP[e+24]=0;HEAP[e+28]=0;HEAP[e+32]=0;HEAP[e+36]=0;HEAP[e+92]=0;HEAP[e+52]=9;HEAP[e]=0}_ft_lzwstate_reset.__index__=Runtime.getFunctionIndex(_ft_lzwstate_reset,"_ft_lzwstate_reset");
function _ft_lzwstate_init(e,g){_llvm_memset_p0i8_i32(e,0,172,1,0);HEAP[e+164]=g;HEAP[e+168]=HEAP[g+28];HEAP[e+76]=0;HEAP[e+80]=0;HEAP[e+84]=0;HEAP[e+88]=e+100;HEAP[e+96]=64;HEAP[e+4]=0;HEAP[e+24]=0;HEAP[e+28]=0;HEAP[e+32]=0;HEAP[e+36]=0;HEAP[e+92]=0;HEAP[e+52]=9;HEAP[e]=0}_ft_lzwstate_init.__index__=Runtime.getFunctionIndex(_ft_lzwstate_init,"_ft_lzwstate_init");
function _ft_lzwstate_done(e){var g,d;d=HEAP[e+168];HEAP[e+4]=0;HEAP[e+24]=0;HEAP[e+28]=0;HEAP[e+32]=0;HEAP[e+36]=0;HEAP[e+92]=0;HEAP[e+52]=9;HEAP[e]=0;if(HEAP[e+88]!=e+100){g=HEAP[e+88];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+88]=0}g=HEAP[e+76];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+76]=0;HEAP[e+80]=0;_llvm_memset_p0i8_i32(e,0,172,1,0)}_ft_lzwstate_done.__index__=Runtime.getFunctionIndex(_ft_lzwstate_done,"_ft_lzwstate_done");
function _ft_lzwstate_io(e,g,d){var b=STACKTOP;STACKTOP+=5;Runtime.memset(b,0,5);var a,c=null,f,h,i,k,j,l,m,o=b+4;k=0;j=HEAP[e+68];l=HEAP[e+64];m=HEAP[e+72];var n=d==0;a:do if(!n){a=HEAP[e];if(a==0)a=39;else if(a==1)a=9;else if(a==2)a=28;else break a;b:do if(a==39){if(_FT_Stream_Seek(HEAP[e+164],2)!=0){a=0;break b}if(_FT_Stream_TryRead(HEAP[e+164],o,1)!=1){a=0;break b}a=unSign(HEAP[o],8)&31;HEAP[e+40]=a;a=unSign(HEAP[o],8)&128;HEAP[e+44]=a;HEAP[e+48]=(1<<HEAP[e+40])-256;if(unSign(HEAP[e+40],32)>unSign(16,
32)){a=0;break b}HEAP[e+52]=9;m=unSign(HEAP[e+44]!=0,1);HEAP[e+56]=m;m=0;a=HEAP[e+40];a=unSign(HEAP[e+52],32)<unSign(a,32);f=e;a=a?(1<<HEAP[f+52])-256:HEAP[f+48]+1;HEAP[e+60]=a;a=f=_ft_lzwstate_get_code(e);if(reSign(f,32)<reSign(0,32)){a=0;break b}l=j=a;if(g!=0)HEAP[g+k]=j&255;k+=1;a=d;if(unSign(k,32)>=unSign(a,32))break a;HEAP[e]=1;a=9;break b}while(0);b:for(;;)if(a==0){HEAP[e]=3;break a}else if(a==9){f=h=_ft_lzwstate_get_code(e);if(reSign(h,32)<reSign(0,32)){a=0;continue b}h=f=f;if(h==256){c=10;
if(HEAP[e+44]!=0){HEAP[e+56]=0;HEAP[e+32]=1;f=_ft_lzwstate_get_code(e);if(reSign(f,32)<reSign(0,32)){a=0;continue b}var p=f;f=p;c=11}else{var r=f;c=13}}else c=10;m=h=c==13?r:c==11?p:h;if(unSign(h,32)>unSign(255,32)){h=HEAP[e+56];if(unSign(f-256,32)>=unSign(h,32)){f=HEAP[e+96];if(unSign(HEAP[e+92],32)>=unSign(f,32)){f=_ft_lzwstate_stack_grow(e);if(reSign(f,32)<reSign(0,32)){a=0;continue b}}var q=HEAP[e+92];HEAP[HEAP[e+88]+q]=j&255;HEAP[e+92]=q+1;f=q=l;c=15}else{var s=f;c=22}h=c==22?s:q;i=f;for(c=23;;){var u=
c==20?t:i;if(!(unSign(c==20?t:h,32)>unSign(255,32))){a=25;break}if(HEAP[e+76]==0){a=17;break}a=HEAP[e+96];if(unSign(HEAP[e+92],32)>=unSign(a,32)){a=_ft_lzwstate_stack_grow(e);if(reSign(a,32)<reSign(0,32)){a=17;break}}t=HEAP[e+92];HEAP[HEAP[e+88]+t]=HEAP[HEAP[e+80]+(u-256)];HEAP[e+92]=t+1;var t=unSign(HEAP[HEAP[e+76]+2*(u-256)],16);c=20;a=21}if(a==25)f=u;else if(a==17){a=0;continue b}}j=f;a=HEAP[e+96];if(unSign(HEAP[e+92],32)>=unSign(a,32)){a=_ft_lzwstate_stack_grow(e);if(reSign(a,32)<reSign(0,32)){a=
0;continue b}}a=HEAP[e+92];HEAP[HEAP[e+88]+a]=j&255;HEAP[e+92]=a+1;HEAP[e]=2;a=28}else if(a==28){f=g;h=d;k=k;i=k+1;if(g!=0){c=28;a=29}else{c=28;a=30}for(;;)if(a==29){c=c==31?y:0;var v=k+c;a=f+v;var w=i+c,x=e;if(HEAP[e+92]==0){c=29;break}HEAP[e+92]=HEAP[x+92]-1;HEAP[a]=HEAP[HEAP[e+88]+HEAP[e+92]];var y=c+1;if(w==h){c=31;break b}else{c=31;a=29}}else if(a==30){c=c==34?B:0;var A=k+c,z=i+c,C=e;if(HEAP[e+92]==0){c=30;break}HEAP[e+92]=HEAP[C+92]-1;var B=c+1;if(z==h){c=34;break b}else{c=34;a=30}}a=c==29?
x:C;k=c==29?v:A;f=HEAP[e+48];if(unSign(HEAP[a+56],32)<unSign(f,32)){a=HEAP[e+84];if(unSign(HEAP[e+56],32)>=unSign(a,32)){a=e;h=f=HEAP[a+84];i=HEAP[a+168];h=h==0?512:(unSign(h,32)>>>unSign(2,32))+h;i=_ft_mem_realloc(i,3,f,h,HEAP[a+76],b);HEAP[a+76]=i;if(HEAP[b]!=0){a=0;continue b}else{HEAP[a+80]=HEAP[a+76]+2*h;_llvm_memmove_p0i8_p0i8_i32(HEAP[a+80],HEAP[a+76]+2*f,f,1,0);HEAP[a+84]=h}}HEAP[HEAP[e+76]+2*HEAP[e+56]]=l&65535;HEAP[HEAP[e+80]+HEAP[e+56]]=j&255;HEAP[e+56]+=1}l=m;HEAP[e]=1;a=9}k=c==31?w:z}while(0);
HEAP[e+64]=l;HEAP[e+68]=j;HEAP[e+72]=m;e=k;STACKTOP=b;return e}_ft_lzwstate_io.__index__=Runtime.getFunctionIndex(_ft_lzwstate_io,"_ft_lzwstate_io");
function _ps_table_new(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a;HEAP[e+32]=d;a=_ft_mem_realloc(d,4,0,g,0,b);HEAP[e+24]=a;var c=HEAP[b]!=0;a:do if(c)a=0;else{a=_ft_mem_realloc(d,4,0,g,0,b);HEAP[e+28]=a;if(HEAP[b]!=0){a=0;break a}HEAP[e+16]=g;HEAP[e+12]=-559038737;HEAP[e+20]=0;HEAP[e]=0;HEAP[e+8]=0;HEAP[e+4]=0;g=e+36;HEAP[g]=_ps_table_new.__index__;HEAP[g+4]=_ps_table_done.__index__;HEAP[g+8]=_ps_table_add.__index__;HEAP[g+12]=_ps_table_release.__index__;a=HEAP[b]!=0?0:2;break a}while(0);
if(a==0){g=HEAP[e+24];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+24]=0}e=HEAP[b];STACKTOP=b;return e}_ps_table_new.__index__=Runtime.getFunctionIndex(_ps_table_new,"_ps_table_new");
function _ps_table_add(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c,f=null,h,i,k,j,l,m,o,n;d=d;l=reSign(g,32)<reSign(0,32);a:do if(l)c=0;else{c=g;if(reSign(HEAP[e+16],32)<=reSign(c,32)){c=0;break a}if(reSign(b,32)<reSign(0,32))n=6;else{n=HEAP[e+8];c=unSign(b+HEAP[e+4],32)>unSign(n,32);b:do if(c){m=HEAP[e+8];n=d-HEAP[e];l=HEAP[e+8];if(unSign(n,32)>=unSign(l,32))n=-1;l=m;o=unSign(b+HEAP[e+4],32)>unSign(l,32);l=m;if(o){o=b+HEAP[e+4];m=m;for(f=5;;){var p=f==5?m:r,r=(unSign(f==5?l:r,
32)>>>unSign(2,32))+1+p+1023&-1024;if(unSign(o,32)>unSign(r,32))f=6;else break}f=7}else f=28;m=f==7?r:l;l=e;m=m;o=HEAP[l+32];h=HEAP[l];p=_ft_mem_alloc(o,m,a);HEAP[l]=p;p=HEAP[a]!=0;c:do if(p){HEAP[l]=h;l=m=HEAP[a];if(m==0)break c;n=l;c=3;break a}else{if(h!=0){_llvm_memcpy_p0i8_p0i8_i32(HEAP[l],h,HEAP[l+8],1,0);f=h;i=l;f=f;k=HEAP[i]-f;f=HEAP[i+24];j=f+4*HEAP[i+16];if(f<j){i=k;k=j;j=f;for(f=9;;){s=f==9?0:s;f=j+4*(s+1);var q=j+4*s;if(HEAP[q]!=0)HEAP[q]+=i;var s=s+1;if(f<k)f=12;else break}}i=h;h=o;f=
i;i!=0&&FUNCTION_TABLE[HEAP[h+8]](h,f);h=0}HEAP[l+8]=m}while(0);if(!(reSign(n,32)>=reSign(0,32)))break b;d=HEAP[e]+n}while(0);HEAP[HEAP[e+24]+4*g]=HEAP[e]+HEAP[e+4];HEAP[HEAP[e+28]+4*g]=b;_llvm_memcpy_p0i8_p0i8_i32(HEAP[e]+HEAP[e+4],d,b,1,0);HEAP[e+4]=b+HEAP[e+4];n=0}c=3;break a}while(0);if(c==0)n=6;e=n;STACKTOP=a;return e}_ps_table_add.__index__=Runtime.getFunctionIndex(_ps_table_add,"_ps_table_add");
function _ps_table_done(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d=null,b,a,c,f,h;b=HEAP[e+32];a=HEAP[e];c=a==0;a:do if(!c){c=_ft_mem_alloc(b,HEAP[e+4],g);HEAP[e]=c;if(HEAP[g]!=0)break a;_llvm_memcpy_p0i8_p0i8_i32(HEAP[e],a,HEAP[e+4],1,0);f=a;c=e;f=f;f=HEAP[c]-f;h=HEAP[c+24];d=h+4*HEAP[c+16];if(h<d){c=f;f=d;h=h;for(d=2;;){k=d==2?0:k;d=h+4*(k+1);var i=h+4*k;if(HEAP[i]!=0)HEAP[i]+=c;var k=k+1;if(d<f)d=5;else break}}HEAP[e+8]=HEAP[e+4];e=a;b=b;a=e;if(e==0)break a;FUNCTION_TABLE[HEAP[b+
8]](b,a);STACKTOP=g;return}while(0);STACKTOP=g}_ps_table_done.__index__=Runtime.getFunctionIndex(_ps_table_done,"_ps_table_done");function _ps_table_release(e){var g,d;d=HEAP[e+32];if(HEAP[e+12]==-559038737){g=HEAP[e];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e]=0;g=HEAP[e+24];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+24]=0;g=HEAP[e+28];g!=0&&FUNCTION_TABLE[HEAP[d+8]](d,g);HEAP[e+28]=0;HEAP[e+12]=0}}_ps_table_release.__index__=Runtime.getFunctionIndex(_ps_table_release,"_ps_table_release");
function _skip_spaces(e,g){var d=null,b;b=HEAP[e];a:for(;;){if(!(b<g))break a;var a=HEAP[b]!=32;b:do if(a){if(HEAP[b]==13)break b;if(HEAP[b]==10)break b;if(HEAP[b]==9)break b;if(HEAP[b]==12)break b;if(HEAP[b]==0)break b;if(HEAP[b]!=37)break a;b=b;for(d=7;;){d=d==12?f:0;var c=b+d;if(!(c<g))break;if(HEAP[c]==13)break;if(HEAP[c]==10)break;var f=d+1;d=12}b=c}while(0);b+=1}HEAP[e]=b}_skip_spaces.__index__=Runtime.getFunctionIndex(_skip_spaces,"_skip_spaces");
function _skip_literal_string(e,g){var d,b=null,a,c;b=HEAP[e];a=0;c=3;a:for(;;){if(!(b<g)){d=1;break a}d=HEAP[b];b+=1;if(d==92){if(b==g){d=1;break a}d=unSign(HEAP[b],8);d=d==40?13:d==41?13:d==92?13:d==98?13:d==102?13:d==110?13:d==114?13:d==116?13:3;if(d==3){d=g;var f=b;for(b=3;;){var h=b==7?j:0,i=1+h,k=f+h;if(!((unSign(b==7?i:0,32)>unSign(2,32)^1)&k<d))break;if(unSign(HEAP[k],8)<=unSign(47,8))break;if(unSign(HEAP[k],8)>unSign(55,8))break;var j=h+1;b=7}b=k;d=0}else if(d==13){b+=1;d=0}}else if(d==40){a+=
1;d=0}else{if(d!=41){d=0;continue a}a-=1;if(a==0){d=10;break a}else d=0}}if(d==10)c=0;HEAP[e]=b;return c}_skip_literal_string.__index__=Runtime.getFunctionIndex(_skip_literal_string,"_skip_literal_string");
function _skip_string(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a;HEAP[d]=HEAP[e];a=0;a:for(;;){HEAP[d]+=1;if(!(HEAP[d]<g))break a;_skip_spaces(d,g);if(HEAP[d]>=g)break a;if(!(unSign(HEAP[HEAP[d]],8)<=unSign(47,8)))if(!(unSign(HEAP[HEAP[d]],8)>unSign(57,8)))continue a;if(!(unSign(HEAP[HEAP[d]],8)<=unSign(64,8)))if(!(unSign(HEAP[HEAP[d]],8)>unSign(70,8)))continue a;if(unSign(HEAP[HEAP[d]],8)<=unSign(96,8))break a;if(unSign(HEAP[HEAP[d]],8)>unSign(102,8))break a}var c=HEAP[d]>=g;a:do if(c)b=
7;else{if(HEAP[HEAP[d]]==62){b=7;break a}a=3;b=9;break a}while(0);if(b==7)HEAP[d]+=1;HEAP[e]=HEAP[d];b=a;STACKTOP=d;return b}_skip_string.__index__=Runtime.getFunctionIndex(_skip_string,"_skip_string");
function _skip_procedure(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a=null,c;c=0;HEAP[d]=HEAP[e];var f=c;a=-1;a:for(;;){var h=a==14?p:0,i=a==14?r:f;if(!((HEAP[d]>=g^1)&i==0)){b=16;break a}a=unSign(HEAP[HEAP[d]],8);if(a==37){a=15;b=8}else if(a==40){a=15;b=6}else if(a==60){a=15;b=7}else if(a==123){a=15;b=1}else if(a==125){a=15;b=3}else{a=15;b=14}if(b==8){b=HEAP[d];for(a=8;;){a=a==12?j:0;var k=b+a;if(!(k<g))break;if(HEAP[k]==13)break;if(HEAP[k]==10)break;var j=a+1;a=12}HEAP[d]=k;a=10}else if(b==
6){var l=_skip_literal_string(d,g);a=6}else if(b==7){var m=_skip_string(d,g);a=7}else if(b==1){var o=h+1;a=1}else if(b==3){var n=h-1;if(n==0){b=4;break a}else a=3}var p=a==3?n:a==10?h:a==7?h:a==6?h:a==1?o:h,r=a==3?0:a==10?i:a==7?m:a==6?l:a==1?0:0;HEAP[d]+=1;a=14;b=0}a:do if(b==4){c=0;HEAP[d]+=1}else if(b==16){c=i;if(h==0)break a;c=3}while(0);HEAP[e]=HEAP[d];c=c;STACKTOP=d;return c}_skip_procedure.__index__=Runtime.getFunctionIndex(_skip_procedure,"_skip_procedure");
function _ps_parser_skip_PS_token(e){var g=STACKTOP;STACKTOP+=4;Runtime.memset(g,0,4);var d,b;HEAP[g]=HEAP[e];d=HEAP[e+8];b=0;_skip_spaces(g,d);var a=HEAP[g]>=d;a:do if(!a){var c=HEAP[HEAP[g]]==91;b:do if(!c){if(HEAP[HEAP[g]]==93)break b;if(HEAP[HEAP[g]]==123){b=_skip_procedure(g,d);break a}else if(HEAP[HEAP[g]]==40){b=_skip_literal_string(g,d);break a}else{var f=HEAP[g];if(HEAP[HEAP[g]]==60){a=f+1>=d;c:do if(!a){if(HEAP[HEAP[g]+1]!=60)break c;HEAP[g]+=1;HEAP[g]+=1;break a}while(0);b=_skip_string(g,
d);break a}else{var h=HEAP[g];if(HEAP[f]==62){HEAP[g]=h+1;d=HEAP[g]>=d;c:do if(!d){if(HEAP[HEAP[g]]!=62)break c;HEAP[g]+=1;break a}while(0);b=3;break a}else{if(HEAP[h]==47)HEAP[g]+=1;for(f=d;;){if(!(HEAP[g]<f))break a;if(HEAP[HEAP[g]]==32)break a;if(HEAP[HEAP[g]]==13)break a;if(HEAP[HEAP[g]]==10)break a;if(HEAP[HEAP[g]]==9)break a;if(HEAP[HEAP[g]]==12)break a;if(HEAP[HEAP[g]]==0)break a;if(HEAP[HEAP[g]]==47)break a;if(HEAP[HEAP[g]]==40)break a;if(HEAP[HEAP[g]]==41)break a;if(HEAP[HEAP[g]]==60)break a;
if(HEAP[HEAP[g]]==62)break a;if(HEAP[HEAP[g]]==91)break a;if(HEAP[HEAP[g]]==93)break a;if(HEAP[HEAP[g]]==123)break a;if(HEAP[HEAP[g]]==125)break a;if(HEAP[HEAP[g]]==37)break a;HEAP[g]+=1}}}}}while(0);HEAP[g]+=1}while(0);if(HEAP[e]==HEAP[g])b=3;HEAP[e+12]=b;HEAP[e]=HEAP[g];STACKTOP=g}_ps_parser_skip_PS_token.__index__=Runtime.getFunctionIndex(_ps_parser_skip_PS_token,"_ps_parser_skip_PS_token");function _ps_parser_skip_spaces(e){_skip_spaces(e,HEAP[e+8])}
_ps_parser_skip_spaces.__index__=Runtime.getFunctionIndex(_ps_parser_skip_spaces,"_ps_parser_skip_spaces");
function _ps_parser_to_token(e,g){var d=STACKTOP;STACKTOP+=4;Runtime.memset(d,0,4);var b,a=null,c;HEAP[g+8]=0;HEAP[g]=0;HEAP[g+4]=0;_skip_spaces(e,HEAP[e+8]);HEAP[d]=HEAP[e];c=HEAP[e+8];if(!(HEAP[d]>=c)){b=unSign(HEAP[HEAP[d]],8);b=b==40?18:b==91?4:b==123?19:20;a:do if(b==20){HEAP[g]=HEAP[d];a=HEAP[HEAP[d]]==47?4:1;HEAP[g+8]=a;_ps_parser_skip_PS_token(e);HEAP[d]=HEAP[e];if(HEAP[e+12]!=0)break a;HEAP[g+4]=HEAP[d]}else if(b==18){HEAP[g+8]=2;HEAP[g]=HEAP[d];if(_skip_literal_string(d,c)!=0)break a;HEAP[g+
4]=HEAP[d]}else if(b==4){HEAP[g+8]=3;a=HEAP[d];HEAP[g]=a;HEAP[d]=a+1;HEAP[e]=HEAP[d];a=e;_skip_spaces(a,HEAP[a+8]);HEAP[d]=HEAP[e];var f=c,h=e+12,i=e,k=e,j=e,l=e;a=4;b:for(;;){b=a==10?p:1;if(HEAP[d]>=f){b=12;break b}if(HEAP[h]!=0){b=12;break b}var m=HEAP[HEAP[d]]==91;c:do if(m){var o=b+1;a=6}else{if(HEAP[HEAP[d]]!=93){a=8;break c}var n=b-1;if(reSign(n,32)<=reSign(0,32)){b=11;break b}else a=9}while(0);var p=a==9?n:a==8?b:o;HEAP[i]=HEAP[d];_ps_parser_skip_PS_token(k);_skip_spaces(j,HEAP[j+8]);HEAP[d]=
HEAP[l];a=10;b=5}if(b!=12)if(b==11){HEAP[d]+=1;HEAP[g+4]=HEAP[d]}}else if(b==19){HEAP[g+8]=3;HEAP[g]=HEAP[d];if(_skip_procedure(d,c)!=0)break a;HEAP[g+4]=HEAP[d]}while(0);if(HEAP[g+4]==0){HEAP[g]=0;HEAP[g+8]=0}HEAP[e]=HEAP[d]}STACKTOP=d}_ps_parser_to_token.__index__=Runtime.getFunctionIndex(_ps_parser_to_token,"_ps_parser_to_token");
function _ps_parser_to_token_array(e,g,d,b){var a=STACKTOP;STACKTOP+=24;Runtime.memset(a,0,24);var c,f=null,h,i,k,j=a+12;HEAP[b]=-1;_ps_parser_to_token(e,a);if(HEAP[a+8]==3){h=HEAP[e];i=HEAP[e+8];k=g;d=k+12*d;HEAP[e]=HEAP[a]+1;HEAP[e+8]=HEAP[a+4]+-1;var l=e+8,m=j+8,o=j+4,n=j+8;k=k;if(g!=0){f=0;c=1}else{f=0;c=2}for(;;)if(c==1){q=f==5?q:0;var p=k+12*q;f=p;c=k+12*q+8;var r=k+12*q+4;if(!(HEAP[e]<HEAP[l])){f=1;break}_ps_parser_to_token(e,j);if(HEAP[m]==0){f=3;break}if(p<d){HEAP[f]=HEAP[j];HEAP[r]=HEAP[o];
HEAP[c]=HEAP[n]}var q=q+1;f=5;c=1}else if(c==2){u=f==9?u:0;var s=k+12*u;if(!(HEAP[e]<HEAP[l])){f=2;break}_ps_parser_to_token(e,j);if(HEAP[m]==0){f=8;break}var u=u+1;f=9;c=2}k=f==1?p:f==3?p:f==2?s:s;g=Math.floor(reSign(k-g,32)/reSign(12,32));HEAP[b]=g;HEAP[e]=h;HEAP[e+8]=i}STACKTOP=a}_ps_parser_to_token_array.__index__=Runtime.getFunctionIndex(_ps_parser_to_token_array,"_ps_parser_to_token_array");
function _ps_tofixedarray(e,g,d,b,a){var c=STACKTOP;STACKTOP+=8;Runtime.memset(c,0,8);var f,h=null,i,k,j,l=c+4;HEAP[c]=HEAP[e];i=0;if(!(HEAP[c]>=g)){k=HEAP[HEAP[c]];j=0;var m=k==91;a:do{if(m){j=93;f=0}else if(k==123){j=125;f=0}else f=j!=0?0:1;break a}while(0);if(f==0)HEAP[c]+=1;k=j;m=b!=0;var o=j==0;j=i;a:do if(o){var n=j+1,p=j+0;if(m){l=b+4*p;var r=n+0;if(!(HEAP[c]<g)){h=3;f=5;break a}_skip_spaces(c,g);if(HEAP[c]>=g){h=4;f=5;break a}var q=HEAP[c];if(HEAP[HEAP[c]]==k){h=9;f=10;break a}if(reSign(p,
32)>=reSign(d,32)){h=8;f=5;break a}g=_PS_Conv_ToFixed(c,g,a);HEAP[l]=g;if(q==HEAP[c]){h=6;f=7}else{h=6;f=5}}else{var s=n+0;if(!(HEAP[c]<g)){h=11;f=5;break a}_skip_spaces(c,g);if(HEAP[c]>=g){h=12;f=5;break a}var u=HEAP[c];if(HEAP[HEAP[c]]==k){h=14;f=10;break a}g=_PS_Conv_ToFixed(c,g,a);HEAP[l]=g;if(u==HEAP[c]){h=13;f=7}else{h=13;f=5}}break a}else{if(m){h=15;f=16}else{h=15;f=17}for(;;)if(f==16){w=h==19?w:0;var t=j+w;f=b+4*t;if(!(HEAP[c]<g)){h=16;f=5;break a}_skip_spaces(c,g);if(HEAP[c]>=g){h=18;f=5;
break a}var v=HEAP[c];if(HEAP[HEAP[c]]==k){h=22;f=10;break a}if(reSign(t,32)>=reSign(d,32)){h=21;f=5;break a}h=_PS_Conv_ToFixed(c,g,a);HEAP[f]=h;if(v==HEAP[c]){h=20;f=7;break a}var w=w+1;h=19;f=16}else if(f==17){n=h==27?n:0;var x=j+n;if(!(HEAP[c]<g)){h=17;f=5;break a}_skip_spaces(c,g);if(HEAP[c]>=g){h=23;f=5;break a}var y=HEAP[c];if(HEAP[HEAP[c]]==k){h=24;f=10;break a}f=_PS_Conv_ToFixed(c,g,a);HEAP[l]=f;if(y==HEAP[c]){h=25;f=7;break a}n=n+1;h=27;f=17}}while(0);if(f==5)i=h==4?p:h==8?p:h==3?p:h==6?
r:h==11?p:h==12?p:h==13?s:h==18?t:h==21?t:h==16?t:h==17?x:x;else if(f==10){r=h==9?q:h==14?u:h==22?v:y;i=h==9?p:h==14?p:h==22?t:x;HEAP[c]=r+1}else if(f==7)i=-1}HEAP[e]=HEAP[c];e=i;STACKTOP=c;return e}_ps_tofixedarray.__index__=Runtime.getFunctionIndex(_ps_tofixedarray,"_ps_tofixedarray");
function _ps_parser_load_field(e,g,d,b){var a=STACKTOP;STACKTOP+=48;Runtime.memset(a,0,48);var c,f=null,h=a+12,i,k,j,l=a+16,m=a+20,o,n,p=a+32;_ps_parser_to_token(e,a);var r=HEAP[a+8]==0;a:do if(r)c=2;else{k=1;j=0;HEAP[h]=HEAP[a];i=HEAP[a+4];o=HEAP[g+8]==7;b:do{if(o){o=HEAP[e];n=HEAP[e+8];HEAP[e]=HEAP[a]+1;HEAP[e+8]=HEAP[a+4]+-1;_ps_parser_to_token(e,m);HEAP[e]=o;HEAP[e+8]=n;c=HEAP[m+8]==3?0:1}else c=HEAP[a+8]==3?0:1;break b}while(0);if(c==0){if(b==0){c=2;break a}k=b;j=1;HEAP[h]+=1;i+=-1}o=k;n=d;var q=
g+16,s=i,u=g+8,t=i,v=g+20,w=i,x=i,y=i,A=e+16,z=i,C=i,B=a+8,D=a+8;i=i;var E=p,F=p,G=p+4,H=p+8,J=p+12;j=j;k=k+-1;f=1;b:for(;;){var L=f==1?0:ca,N=n+4*(j+L);c=k+L*-1;if((f==1?o:c)==0){c=57;break b}N=HEAP[N]+HEAP[q];_skip_spaces(h,s);c=HEAP[u];if(c==1)c=59;else if(c==2)c=21;else if(c==3)c=19;else if(c==4)c=20;else if(c==5)c=27;else if(c==6)c=27;else if(c==7)c=60;else{c=61;break b}c:do if(c==59){var I=HEAP[h];ca=I+3>=t;d:do if(ca)c=5;else{if(HEAP[I]!=116){c=5;break d}if(HEAP[I+1]!=114){c=5;break d}if(HEAP[I+
2]!=117){c=5;break d}if(HEAP[I+3]!=101){c=5;break d}var P=I+5;f=9;c=10;break d}while(0);d:do if(c==5){if(!(I+4<t)){f=5;break d}if(HEAP[I]!=102){f=11;break d}if(HEAP[I+1]!=97){f=12;break d}if(HEAP[I+2]!=108){f=13;break d}if(HEAP[I+3]!=115){f=14;break d}if(HEAP[I+4]!=101){f=15;break d}var K=I+6;f=16}while(0);ca=f==9?1:f==5?0:f==11?0:f==12?0:f==13?0:f==14?0:f==15?0:0;HEAP[h]=f==9?P:f==5?I:f==11?I:f==12?I:f==13?I:f==14?I:f==15?I:K;I=unSign(ca,8);f=10;c=18;break c}else if(c==21){var O=_PS_Conv_ToInt(h,
w);f=21;c=18;break c}else if(c==19){var M=_PS_Conv_ToFixed(h,x,0);f=19;c=18;break c}else if(c==20){var Q=_PS_Conv_ToFixed(h,y,3);f=20;c=18;break c}else if(c==27){c=HEAP[A];f=z-HEAP[h];if(HEAP[h]>=C){f=27;c=28;break c}if(HEAP[B]==4){var R=f-1;HEAP[h]+=1;f=30}else{if(HEAP[D]!=2){c=33;break b}HEAP[h]+=1;var T=f-2;f=32}f=f==32?T:R;if(HEAP[N]!=0){var V=HEAP[N];V!=0&&FUNCTION_TABLE[HEAP[c+8]](c,V);HEAP[N]=0}c=_ft_mem_alloc(c,f+1,l);if(HEAP[l]!=0){c=38;break b}_llvm_memcpy_p0i8_p0i8_i32(c,HEAP[h],f,1,0);
HEAP[c+f]=0;HEAP[N]=c;f=39;c=28;break c}else if(c==60){c=N;f=_ps_tofixedarray(h,i,4,E,0);if(reSign(f,32)<reSign(0,32)){c=40;break b}ca=HEAP[F];if(reSign(ca,32)>=reSign(0,32)){var U=ca+32768&-65536;f=42}else{var S=0-(32768-ca&-65536);f=44}HEAP[c]=f==42?U:S;ca=HEAP[G];if(reSign(ca,32)>=reSign(0,32)){var X=ca+32768&-65536;f=45}else{var Y=0-(32768-ca&-65536);f=47}HEAP[c+4]=f==45?X:Y;ca=HEAP[H];if(reSign(ca,32)>=reSign(0,32)){var W=ca+32768&-65536;f=48}else{var da=0-(32768-ca&-65536);f=50}HEAP[c+8]=f==
48?W:da;ca=HEAP[J];if(reSign(ca,32)>=reSign(0,32)){var ba=ca+32768&-65536;f=51}else{var aa=0-(32768-ca&-65536);f=53}HEAP[c+12]=f==51?ba:aa;f=54;c=28;break c}while(0);if(c==18){ca=f==21?O:f==20?Q:f==19?M:I;f=unSign(HEAP[v],8);c=f==1?22:f==2?24:f==4?25:26;if(c==26)HEAP[N]=ca;else if(c==22)HEAP[N]=ca&255;else if(c==24)HEAP[N]=ca&65535;else if(c==25)HEAP[N]=ca}var ca=L+1;f=28;c=55}if(c==57){HEAP[l]=0;c=34;break a}else if(c==61){c=2;break a}else if(c==38){c=34;break a}else if(c==33){HEAP[l]=3;c=34;break a}else if(c==
40){HEAP[l]=3;c=34;break a}}while(0);if(c==2)HEAP[l]=3;e=HEAP[l];STACKTOP=a;return e}_ps_parser_load_field.__index__=Runtime.getFunctionIndex(_ps_parser_load_field,"_ps_parser_load_field");
function _ps_parser_load_field_table(e,g,d,b){var a=STACKTOP;STACKTOP+=424;Runtime.memset(a,0,424);var c,f=null,h=a+384,i,k,j=a+388;i=0;_llvm_memcpy_p0i8_p0i8_i32(j,g,36,4,0);HEAP[j+8]=2;k=HEAP[g+8]==9;a:do if(k)c=0;else{c=HEAP[g+8]==7?0:1;break a}while(0);if(c==0)HEAP[j+8]=3;_ps_parser_to_token_array(e,a,32,h);if(reSign(HEAP[h],32)<reSign(0,32))i=162;else{c=HEAP[g+24];if(unSign(HEAP[h],32)>unSign(c,32))HEAP[h]=HEAP[g+24];c=HEAP[e];k=HEAP[e+8];var l=HEAP[g+8]!=7;a:do if(l){if(HEAP[g+28]==0)break a;
HEAP[HEAP[d]+HEAP[g+28]]=HEAP[h]&255}while(0);if(reSign(HEAP[h],32)>reSign(0,32)){g=e+8;l=j+16;var m=j+20,o=j+16;for(f=8;;){n=f==8?0:n;f=a+12*n+4;HEAP[e]=HEAP[a+12*n];HEAP[g]=HEAP[f];_ps_parser_load_field(e,j,d,b,0);f=HEAP[l];f=unSign(HEAP[m],8)+f;HEAP[o]=f;f=HEAP[h]-1;HEAP[h]=f;f=reSign(f,32)>reSign(0,32);var n=n+1;if(f)f=9;else break}}HEAP[e]=c;HEAP[e+8]=k}e=i;STACKTOP=a;return e}_ps_parser_load_field_table.__index__=Runtime.getFunctionIndex(_ps_parser_load_field_table,"_ps_parser_load_field_table");
function _ps_parser_to_int(e){_skip_spaces(e,HEAP[e+8]);return _PS_Conv_ToInt(e,HEAP[e+8])}_ps_parser_to_int.__index__=Runtime.getFunctionIndex(_ps_parser_to_int,"_ps_parser_to_int");
function _ps_parser_to_bytes(e,g,d,b,a){var c=STACKTOP;STACKTOP+=4;Runtime.memset(c,0,4);var f,h=null,i,k,j,l,m,o,n,p,r;r=0;_skip_spaces(e,HEAP[e+8]);HEAP[c]=HEAP[e];var q=HEAP[e+8]<=HEAP[c];a:do if(!q){if(a!=0)if(HEAP[HEAP[c]]!=60){r=3;break a}else HEAP[c]+=1;k=HEAP[e+8];j=g;m=d;i=c;k=k;j=j;l=m;n=o=0;p=1;l*=2;m=HEAP[i];var s=l;if(unSign(k-m,32)<unSign(s,32))l=k-m;k=l;l=m;s=j;o=o;p=p;n=n;h=3;b:for(;;){var u=h==3?0:B,t=h==3?n:z,v=h==3?p:C,w=o+u;f=l+w;if(!(unSign(w,32)<unSign(k,32)))break b;var x=unSign(HEAP[f],
8);if(x==0){h=12;f=10}else if(x==9){h=12;f=10}else if(x==10){h=12;f=10}else if(x==12){h=12;f=10}else if(x==13){h=12;f=10}else if(x==32){h=12;f=10}else{h=12;f=5}c:do if(f==5){if(unSign(x,32)>unSign(127,32))break b;h=reSign(HEAP[_ft_char_table+(x&127)],8);if(unSign(h,32)>unSign(15,32))break b;var y=h|v<<4;if((y&256)==0){h=8;break c}HEAP[s+t]=y&255;var A=t+1;h=9}while(0);var z=h==9?A:h==8?t:h==12?t:h==12?t:h==12?t:h==12?t:h==12?t:t,C=h==9?1:h==8?y:h==12?v:h==12?v:h==12?v:h==12?v:h==12?v:v,B=u+1;h=10}n=
t;p=v;o=w;if(v!=1){HEAP[j+n]=(p&255)<<4;n+=1}HEAP[i]=m+o;i=i=n;HEAP[b]=i;if(a!=0){i=HEAP[e+8]>HEAP[c];b:do if(i){if(HEAP[HEAP[c]]==62)break b;r=3;break a}while(0);HEAP[c]+=1}HEAP[e]=HEAP[c]}while(0);e=r;STACKTOP=c;return e}_ps_parser_to_bytes.__index__=Runtime.getFunctionIndex(_ps_parser_to_bytes,"_ps_parser_to_bytes");function _ps_parser_to_fixed(e,g){_skip_spaces(e,HEAP[e+8]);return _PS_Conv_ToFixed(e,HEAP[e+8],g)}_ps_parser_to_fixed.__index__=Runtime.getFunctionIndex(_ps_parser_to_fixed,"_ps_parser_to_fixed");
function _ps_parser_to_coord_array(e,g,d){var b=STACKTOP;STACKTOP+=6;Runtime.memset(b,0,6);var a,c=null,f,h,i,k,j=b+4;_skip_spaces(e,HEAP[e+8]);f=HEAP[e+8];HEAP[b]=HEAP[e];h=0;if(!(HEAP[b]>=f)){i=HEAP[HEAP[b]];k=0;var l=i==91;a:do{if(l){k=93;a=0}else if(i==123){k=125;a=0}else if(k!=0){c=1;a=0}else{c=1;a=2}break a}while(0);if(a==0){HEAP[b]+=1;var m=k;c=0}k=c==0?m:0;l=d!=0;m=k==0;i=h;a:do if(m){var o=i+1;if(l){j=d+2*i;if(!(HEAP[b]<f)){c=4;a=6;break a}_skip_spaces(b,f);if(HEAP[b]>=f){c=5;a=6;break a}var n=
HEAP[b];if(HEAP[HEAP[b]]==k){c=10;a=11;break a}if(reSign(i,32)>=reSign(g,32)){c=9;a=6;break a}g=_PS_Conv_ToFixed(b,f,0);g=reSign(g,32)>>reSign(16,32)&65535;HEAP[j]=g;if(n==HEAP[b]){c=7;a=8}else{c=7;a=6}}else{if(!(HEAP[b]<f)){c=12;a=6;break a}_skip_spaces(b,f);if(HEAP[b]>=f){c=13;a=6;break a}var p=HEAP[b];if(HEAP[HEAP[b]]==k){c=15;a=11;break a}g=_PS_Conv_ToFixed(b,f,0);g=reSign(g,32)>>reSign(16,32)&65535;HEAP[j]=g;if(p==HEAP[b]){c=14;a=8}else{c=14;a=6}}break a}else{if(l){c=16;a=17}else{c=16;a=18}for(;;)if(a==
17){s=c==20?s:0;var r=i+s;c=d+2*r;if(!(HEAP[b]<f)){c=17;a=6;break a}_skip_spaces(b,f);if(HEAP[b]>=f){c=19;a=6;break a}var q=HEAP[b];if(HEAP[HEAP[b]]==k){c=23;a=11;break a}if(reSign(r,32)>=reSign(g,32)){c=22;a=6;break a}a=_PS_Conv_ToFixed(b,f,0);a=reSign(a,32)>>reSign(16,32)&65535;HEAP[c]=a;if(q==HEAP[b]){c=21;a=8;break a}var s=s+1;c=20;a=17}else if(a==18){v=c==28?v:0;var u=i+v;if(!(HEAP[b]<f)){c=18;a=6;break a}_skip_spaces(b,f);if(HEAP[b]>=f){c=24;a=6;break a}var t=HEAP[b];if(HEAP[HEAP[b]]==k){c=
25;a=11;break a}c=_PS_Conv_ToFixed(b,f,0);c=reSign(c,32)>>reSign(16,32)&65535;HEAP[j]=c;if(t==HEAP[b]){c=26;a=8;break a}var v=v+1;c=28;a=18}}while(0);if(a==6)h=c==5?i:c==9?i:c==4?i:c==7?o:c==12?i:c==13?i:c==14?o:c==24?u:c==18?u:c==17?r:c==22?r:r;else if(a==11){o=c==10?n:c==15?p:c==25?t:q;h=c==10?i:c==15?i:c==25?u:r;HEAP[b]=o+1}else if(a==8)h=-1}HEAP[e]=HEAP[b];e=h;STACKTOP=b;return e}_ps_parser_to_coord_array.__index__=Runtime.getFunctionIndex(_ps_parser_to_coord_array,"_ps_parser_to_coord_array");
function _ps_parser_to_fixed_array(e,g,d,b){_skip_spaces(e,HEAP[e+8]);return _ps_tofixedarray(e,HEAP[e+8],g,d,b)}_ps_parser_to_fixed_array.__index__=Runtime.getFunctionIndex(_ps_parser_to_fixed_array,"_ps_parser_to_fixed_array");function _ps_parser_init(e,g,d,b){HEAP[e+12]=0;HEAP[e+4]=g;HEAP[e+8]=d;HEAP[e]=g;HEAP[e+16]=b;_llvm_memcpy_p0i8_p0i8_i32(e+20,_ps_parser_funcs,52,4,0)}_ps_parser_init.__index__=Runtime.getFunctionIndex(_ps_parser_init,"_ps_parser_init");function _ps_parser_done(){}
_ps_parser_done.__index__=Runtime.getFunctionIndex(_ps_parser_done,"_ps_parser_done");
function _t1_builder_init(e,g,d,b,a){var c,f;HEAP[e+64]=0;HEAP[e+68]=1;HEAP[e+4]=g;HEAP[e+8]=b;HEAP[e]=HEAP[g+100];g=b!=0;a:do if(g){f=HEAP[HEAP[b+156]];HEAP[e+12]=f;HEAP[e+16]=f+20;HEAP[e+20]=f+56;c=f;f=c+20;c=c+56;HEAP[f+2]=0;HEAP[f]=0;HEAP[f+28]=0;_llvm_memcpy_p0i8_p0i8_i32(c,f,36,4,0);HEAP[e+76]=HEAP[d+40];HEAP[e+72]=0;if(a==0)break a;HEAP[e+72]=HEAP[HEAP[b+156]+36]}while(0);HEAP[e+24]=0;HEAP[e+28]=0;HEAP[e+32]=0;HEAP[e+32+4]=0;HEAP[e+40]=0;HEAP[e+40+4]=0;e=e+80;HEAP[e]=_t1_builder_init.__index__;
HEAP[e+4]=_t1_builder_done.__index__;HEAP[e+8]=_t1_builder_check_points.__index__;HEAP[e+12]=_t1_builder_add_point.__index__;HEAP[e+16]=_t1_builder_add_point1.__index__;HEAP[e+20]=_t1_builder_add_contour.__index__;HEAP[e+24]=_t1_builder_start_point.__index__;HEAP[e+28]=_t1_builder_close_contour.__index__}_t1_builder_init.__index__=Runtime.getFunctionIndex(_t1_builder_init,"_t1_builder_init");
function _t1_builder_done(e){var g;g=HEAP[e+8];if(g!=0){e=HEAP[e+16];g=g+108;HEAP[g]=HEAP[e];HEAP[g+2]=HEAP[e+2];HEAP[g+4]=HEAP[e+4];HEAP[g+8]=HEAP[e+8];HEAP[g+12]=HEAP[e+12];HEAP[g+16]=HEAP[e+16]}}_t1_builder_done.__index__=Runtime.getFunctionIndex(_t1_builder_done,"_t1_builder_done");
function _t1_builder_check_points(e,g){var d,b,a=g==0;a:do if(a)d=0;else{d=reSign(HEAP[HEAP[e+12]+20+2],16);a=reSign(HEAP[HEAP[e+12]+56+2],16);var c=HEAP[HEAP[e+12]+4];if(unSign(g+d+a,32)<=unSign(c,32)){d=0;break a}b=_FT_GlyphLoader_CheckPoints(HEAP[e+12],g,0);d=2;break a}while(0);if(d==0)b=0;return b}_t1_builder_check_points.__index__=Runtime.getFunctionIndex(_t1_builder_check_points,"_t1_builder_check_points");
function _t1_builder_add_point(e,g,d,b){var a,c;a=HEAP[e+20];if(HEAP[e+68]!=0){e=HEAP[a+4];c=reSign(HEAP[a+2],16);e=e+8*c;c=HEAP[a+8];var f=reSign(HEAP[a+2],16);c=c+f;g=reSign(g,32)>=reSign(0,32)?g+32768&-65536:0-(32768-g&-65536);g=reSign(g,32)>>reSign(16,32);HEAP[e]=g;d=reSign(d,32)>=reSign(0,32)?d+32768&-65536:0-(32768-d&-65536);d=reSign(d,32)>>reSign(16,32);HEAP[e+4]=d;b=b!=0?1:2;HEAP[c]=b}HEAP[a+2]+=1}_t1_builder_add_point.__index__=Runtime.getFunctionIndex(_t1_builder_add_point,"_t1_builder_add_point");
function _t1_builder_add_point1(e,g,d){var b;b=_t1_builder_check_points(e,1);b==0&&_t1_builder_add_point(e,g,d,1);return b}_t1_builder_add_point1.__index__=Runtime.getFunctionIndex(_t1_builder_add_point1,"_t1_builder_add_point1");
function _t1_builder_add_contour(e){var g,d,b;d=HEAP[e+20];if(d==0)d=3;else if(HEAP[e+68]==0){HEAP[d]+=1;d=0}else{b=reSign(HEAP[HEAP[e+12]+20],16);g=reSign(HEAP[HEAP[e+12]+56],16);var a=HEAP[HEAP[e+12]+8];a=unSign(b+1+g,32)>unSign(a,32);a:do{if(a){b=e=_FT_GlyphLoader_CheckPoints(HEAP[e+12],0,1);g=e==0?1:2}else{b=0;g=1}break a}while(0);if(g==1){if(reSign(HEAP[d],16)>reSign(0,16)){e=HEAP[d+12];g=reSign(HEAP[d],16)-1;HEAP[e+2*g]=HEAP[d+2]-1}HEAP[d]+=1}d=b}return d}
_t1_builder_add_contour.__index__=Runtime.getFunctionIndex(_t1_builder_add_contour,"_t1_builder_add_contour");function _t1_builder_start_point(e,g,d){var b,a,c,f,h=HEAP[e+64]==3;a:do if(h)b=0;else{HEAP[e+64]=3;b=_t1_builder_add_contour(e);if(b!=0)break a;a=g;c=d;b=e;a=a;c=c;f=_t1_builder_check_points(b,1);f==0&&_t1_builder_add_point(b,a,c,1);b=b=b=f}while(0);return b}_t1_builder_start_point.__index__=Runtime.getFunctionIndex(_t1_builder_start_point,"_t1_builder_start_point");
function _t1_builder_close_contour(e){var g,d,b,a;e=HEAP[e+20];var c=e==0;a:do if(!c){if(reSign(HEAP[e],16)>reSign(1,16)){g=HEAP[e+12];d=reSign(HEAP[e],16)-2;g=reSign(HEAP[g+2*d],16)+1}else g=0;g=g;var f=reSign(HEAP[e+2],16)>reSign(1,16);b:do if(f){d=HEAP[e+4]+8*g;b=HEAP[e+4];a=reSign(HEAP[e+2],16);b=b+8*a+-8;a=HEAP[e+8];var h=reSign(HEAP[e+2],16);a=a+h+-1;if(HEAP[d]!=HEAP[b])break b;if(HEAP[d+4]!=HEAP[b+4])break b;if(HEAP[a]!=1)break b;HEAP[e+2]-=1}while(0);if(!(reSign(HEAP[e],16)>reSign(0,16)))break a;
d=reSign(HEAP[e+2],16)-1;f=e;if(d==g){HEAP[e]=HEAP[f]-1;HEAP[e+2]-=1}else{g=HEAP[f+12];d=reSign(HEAP[e],16)-1;HEAP[g+2*d]=HEAP[e+2]-1}}while(0)}_t1_builder_close_contour.__index__=Runtime.getFunctionIndex(_t1_builder_close_contour,"_t1_builder_close_contour");
function _t1_decrypt(e,g,d){var b=STACKTOP;STACKTOP+=6;Runtime.memset(b,0,6);var a=null,c,f=b+4;HEAP[b]=e;HEAP[f]=d;e=HEAP[b];a=HEAP[b]+g;g=g;c=unSign(HEAP[f],16);d=HEAP[b];var h=g;if(unSign(a-d,32)<unSign(h,32))g=a-d;a=g;if(unSign(0,32)<unSign(a,32)){a=g;var i=d;c=c;unSign(a,32);unSign(1,32);h=(unSign(a,32)>unSign(1,32)?a:1)-0;for(a=1;;){m=a==1?0:m;l=a==1?c:l;var k=0+m,j=e+k;a=unSign(HEAP[(a==1?d:i)+k],8);k=unSign(l,32)>>>unSign(8,32);var l=(a+l)*52845+22719&65535;HEAP[j]=(a^k)&255;var m=m+1;if(m!=
h)a=2;else break}c=l;a=3}else a=6;HEAP[b]=(a==3?i:d)+g;HEAP[f]=c&65535;STACKTOP=b}_t1_decrypt.__index__=Runtime.getFunctionIndex(_t1_decrypt,"_t1_decrypt");
function _t1_lookup_glyph_by_stdcharcode(e,g){var d,b=null,a,c,f;f=HEAP[e+1348];var h=reSign(g,32)<reSign(0,32),i=reSign(g,32)>reSign(255,32);if(h|i)a=-1;else{h=HEAP[f+20];f=unSign(HEAP[HEAP[f+24]+2*g],16);f=FUNCTION_TABLE[h](f);c=0;h=HEAP[e+1352];i=e+1356;c=c;b=1;a:for(;;){d=b==4?j:0;var k=c+d;if(!(unSign(h,32)>unSign(k,32))){d=8;break a}j=HEAP[HEAP[i]+4*k];b=j!=0;b:do if(b){if(HEAP[j]!=HEAP[f])break b;if(_strcmp(j,f)==0){d=5;break a}}while(0);var j=d+1;b=4;d=2}if(d==8)a=-1;else if(d==5)a=c=k}return a}
_t1_lookup_glyph_by_stdcharcode.__index__=Runtime.getFunctionIndex(_t1_lookup_glyph_by_stdcharcode,"_t1_lookup_glyph_by_stdcharcode");
function _t1_decoder_parse_charstrings(e,g,d){var b=STACKTOP;STACKTOP+=44;Runtime.memset(b,0,44);var a,c=null,f,h,i,k,j,l,m,o,n,p,r;r=b+8;var q,s,u=b+16,t=b+24,v;o=b+32;var w=b+36,x,y,A,z,C,B;q=b+40;var D,E,F,G,H;HEAP[o]=e;HEAP[w]=g;e=HEAP[o];m=B=0;HEAP[q]=w^o^q;g=reSign(HEAP[q],32)>>reSign(10,32);x=HEAP[q];z=reSign(HEAP[q],32)>>reSign(20,32);HEAP[q]=(g^x^z)&65535;if(HEAP[q]==0)HEAP[q]=29572;HEAP[HEAP[o]+1136]=HEAP[o]+112;HEAP[HEAP[o]+1344]=HEAP[o]+1140;x=HEAP[o]+1140;HEAP[e+64]=0;g=HEAP[e+72];HEAP[HEAP[o]+
1492]!=0&&_llvm_memset_p0i8_i32(HEAP[HEAP[o]+1488],0,HEAP[HEAP[o]+1492]*4,1,0);HEAP[x+4]=HEAP[w];HEAP[x+8]=HEAP[w]+d;A=HEAP[x+8];HEAP[x]=HEAP[x+4];y=HEAP[x];d=0;w=C=HEAP[e+24];z=HEAP[e+28];g!=0&&FUNCTION_TABLE[HEAP[g+4]](HEAP[g]);c=3;a:for(;;){J=c==3?0:c==55?J:c==67?J:f;if(y<A)c=4;else{a=61;break a}n=HEAP[HEAP[o]+1136];i=h=0;a=unSign(HEAP[y],8);y+=1;a=a==1?5:a==3?7:a==4?8:a==5?9:a==6?10:a==7?11:a==8?12:a==9?13:a==10?14:a==11?15:a==12?23:a==13?16:a==14?17:a==15?18:a==21?19:a==22?20:a==30?21:a==31?
22:a==255?35:42;b:do if(a==42){if(!(unSign(HEAP[y+-1],8)>unSign(31,8))){a=24;break a}i=unSign(HEAP[y+-1],8)<=unSign(-10,8);c=y;if(i)i=unSign(HEAP[c+-1],8)-139;else{y=c+1;if(y>A){a=24;break a}i=unSign(HEAP[y+-2],8)<=unSign(-6,8);c=unSign(HEAP[y+-2],8);if(i){i=(c-247)*256;c=unSign(HEAP[y+-1],8);i=i+108+c}else{i=(c-251)*256;c=unSign(HEAP[y+-1],8);i=0-i+-108+(0-c)}}if(J!=0){c=47;break b}i<<=16;c=48}else if(a==5){h=16;c=5}else if(a==7){h=18;c=7}else if(a==8){h=14;c=8}else if(a==9)c=h=9;else if(a==10){h=
6;c=10}else if(a==11){h=13;c=11}else if(a==12){h=11;c=12}else if(a==13){h=5;c=13}else if(a==14){h=22;c=14}else if(a==15){h=24;c=15}else if(a==23){if(y>A){a=24;break a}a=unSign(HEAP[y],8);y+=1;if(a==0){c=25;a=26}else if(a==1){c=25;a=27}else if(a==2){c=25;a=28}else if(a==6){c=25;a=29}else if(a==7){c=25;a=30}else if(a==12){c=25;a=31}else if(a==16){c=25;a=32}else if(a==17){c=25;a=33}else if(a==33){c=25;a=34}else{a=24;break a}if(a==26){h=15;c=26}else if(a==27){h=19;c=27}else if(a==28){h=17;c=28}else if(a==
29){h=3;c=29}else if(a==30){h=4;c=30}else if(a==31){h=20;c=31}else if(a==32){h=21;c=32}else if(a==33){h=23;c=33}else if(a==34){h=25;c=34}}else if(a==16){h=2;c=16}else if(a==17){h=1;c=17}else if(a==18){h=26;c=18}else if(a==19){h=10;c=19}else if(a==20){h=7;c=20}else if(a==21){h=12;c=21}else if(a==22){h=8;c=22}else if(a==35){if(y+4>A){a=24;break a}i=unSign(HEAP[y],8)<<24;c=unSign(HEAP[y+1],8)<<16;D=unSign(HEAP[y+2],8)<<8;E=unSign(HEAP[y+3],8);i=c|i|D|E;y+=4;c=reSign(i,32)>reSign(32E3,32);D=reSign(i,
32)<reSign(-32E3,32);E=J==0;if(c|D){if(!E){c=37;break b}c=38}else{if(!E){c=40;break b}i<<=16;c=41}}while(0);J=c==40?J:c==41?0:c==38?1:c==37?J:c==26?J:c==27?J:c==28?J:c==29?J:c==30?J:c==31?J:c==32?J:c==33?J:c==34?J:c==48?0:c==47?J:c==22?J:c==21?J:c==20?J:c==19?J:c==18?J:c==17?J:c==16?J:c==15?J:c==14?J:c==13?J:c==12?J:c==11?J:c==10?J:c==9?J:c==8?J:c==7?J:J;a=reSign(m,32)>reSign(0,32);b:do if(a){D=h;if(D==0)break b;else if(D==22)break b;else if(D==23)break b;else if(D==24)break b;m=0}while(0);D=J!=0;
b:do if(D){s=h;if(h!=0&s!=20){c=50;a=51}else{c=50;a=52}break b}else a=51;while(0);if(a==51){j=h;c=51}var J=c==51?0:J;if((c==51?j:s)==0){if(reSign(n-(HEAP[o]+112),32)>reSign(1023,32)){a=24;break a}HEAP[n]=i;n+=4;HEAP[HEAP[o]+1136]=n;c=55}else if(h==21){if(reSign(n-(HEAP[o]+112),32)<=reSign(7,32)){a=56;break a}n+=-8;h=reSign(HEAP[n+4],32)>>reSign(16,32);i=reSign(HEAP[n],32)>>reSign(16,32);m=Math.floor(reSign(n-(HEAP[o]+112),32)/reSign(4,32));B=i;if(reSign(m,32)<reSign(B,32)){a=56;break a}n+=4*(0-i);
m=B=0;a=h;a=a==0?69:a==1?59:a==2?64:a==3?73:a==12?200:a==13?200:a==14?76:a==15?76:a==16?76:a==17?76:a==18?76:a==19?85:a==20?90:a==21?92:a==22?94:a==23?96:a==24?99:a==25?104:a==27?109:a==28?112:201;b:do if(a==201)m=i;else if(a==69){if(i!=3){a=24;break a}if(HEAP[HEAP[o]+1400]==0){a=24;break a}if(HEAP[HEAP[o]+1404]!=7){a=24;break a}HEAP[n]=w;HEAP[n+4]=z;B=2}else if(a==59){if(i!=0){a=24;break a}HEAP[HEAP[o]+1400]=1;HEAP[HEAP[o]+1404]=0;d=_t1_builder_start_point(e,w,z);if(d!=0){a=61;break a}d=_t1_builder_check_points(e,
6);if(d!=0){a=61;break a}}else if(a==64){if(i!=0){a=24;break a}D=HEAP[o];c=E=HEAP[D+1404];HEAP[D+1404]=E+1;D=reSign(c,32)>reSign(0,32);E=reSign(c,32)<=reSign(6,32);if(!(D&E))break b;c=c==3|c==6?1:0;c=unSign(c&255,8);_t1_builder_add_point(e,w,z,c&255)}else if(a==73){if(i!=1){a=24;break a}B=1;if(g==0)break b;c=HEAP[g+20];D=reSign(HEAP[HEAP[e+20]+2],16);FUNCTION_TABLE[c](HEAP[g],D)}else if(a==200)n=HEAP[o]+112;else if(a==76){D=a=HEAP[HEAP[o]+1464];if(a==0){a=24;break a}a=unSign(h==18,1);E=h+-13+a;if(E*
HEAP[D]!=i){a=24;break a}c=n+4*E;G=n;F=0;a=E;a=unSign(F,32)<unSign(a,32)?79:80;for(;;)if(a==79){H=HEAP[G];if(unSign(HEAP[D],32)>unSign(1,32)){a=HEAP[D+136];var L=HEAP[D],N=c;H=H;L=(unSign(L,32)>unSign(2,32)?L:2)-1;for(c=81;;){l=c==81?0:l;k=c==81?H:k;c=_FT_MulFix(HEAP[N+4*l],HEAP[a+4*(1+l)]);k=k+c;l=l+1;if(l!=L)c=82;else break}a=N+4*L;H=k;c=a}HEAP[G]=H;G+=4;F+=1;a=E;a=unSign(F,32)<unSign(a,32)?79:80}else if(a==80){B=E;break b}}else if(a==85){D=HEAP[HEAP[o]+1464];if(i!=1){a=24;break a}if(D==0){a=24;
break a}c=reSign(HEAP[n],32)>>reSign(16,32);if(reSign(c,32)<reSign(0,32)){a=24;break a}E=HEAP[HEAP[o]+1492];if(unSign(c+HEAP[D],32)>unSign(E,32)){a=24;break a}_llvm_memcpy_p0i8_p0i8_i32(HEAP[HEAP[o]+1488]+4*c,HEAP[D+136],HEAP[D]*4,1,0)}else if(a==90){if(i!=2){a=24;break a}HEAP[n]=HEAP[n+4]+HEAP[n];B=1}else if(a==92){if(i!=2){a=24;break a}HEAP[n]-=HEAP[n+4];B=1}else if(a==94){if(i!=2){a=24;break a}B=_FT_MulFix(HEAP[n],HEAP[n+4]);HEAP[n]=B;B=1}else if(a==96){if(i!=2){a=24;break a}if(HEAP[n+4]==0){a=
24;break a}B=_FT_DivFix(HEAP[n],HEAP[n+4]);HEAP[n]=B;B=1}else if(a==99){c=HEAP[HEAP[o]+1464];if(i!=2){a=24;break a}if(c==0){a=24;break a}c=reSign(HEAP[n+4],32)>>reSign(16,32);if(reSign(c,32)<reSign(0,32)){a=24;break a}D=HEAP[HEAP[o]+1492];if(unSign(c,32)>=unSign(D,32)){a=24;break a}HEAP[HEAP[HEAP[o]+1488]+4*c]=HEAP[n]}else if(a==104){B=HEAP[HEAP[o]+1464];if(i!=1){a=24;break a}if(B==0){a=24;break a}B=reSign(HEAP[n],32)>>reSign(16,32);if(reSign(B,32)<reSign(0,32)){a=24;break a}c=HEAP[HEAP[o]+1492];
if(unSign(B,32)>=unSign(c,32)){a=24;break a}HEAP[n]=HEAP[HEAP[HEAP[o]+1488]+4*B];B=1}else if(a==109){if(i!=4){a=24;break a}B=HEAP[n+12];if(reSign(HEAP[n+8],32)>reSign(B,32))HEAP[n]=HEAP[n+4];B=1}else if(a==112){if(i!=0){a=24;break a}B=HEAP[q];if(reSign(B,32)>reSign(32767,32))B+=1;HEAP[n]=B;B=_FT_MulFix(HEAP[q],65536-HEAP[q]);HEAP[q]=B;if(B==0)HEAP[q]+=10355;B=1}while(0);n+=4*B;HEAP[HEAP[o]+1136]=n;c=67}else{f=HEAP[_t1_args_count+h*4];a=Math.floor(reSign(n-(HEAP[o]+112),32)/reSign(4,32));i=f;if(reSign(a,
32)<reSign(i,32)){a=56;break a}n+=4*(0-f);f=h;if(f==1){a=202;break a}else if(f==2){c=116;a=121}else if(f==3){a=203;break a}else if(f==4){c=116;a=140}else if(f==5){c=116;a=204}else if(f==6){c=116;a=145}else if(f==7){c=116;a=148}else if(f==8){c=116;a=151}else if(f==9){c=116;a=154}else if(f==10){c=116;a=160}else if(f==11){c=116;a=163}else if(f==12){c=116;a=166}else if(f==13){c=116;a=169}else if(f==14){c=116;a=171}else if(f==15){c=116;a=123}else if(f==16){c=116;a=187}else if(f==17){c=116;a=189}else if(f==
18){c=116;a=191}else if(f==19){c=116;a=193}else if(f==20){c=116;a=174}else if(f==22){c=116;a=175}else if(f==23){c=116;a=205}else if(f==24){c=116;a=185}else if(f==25){c=116;a=195}else if(f==26){c=116;a=123}else{a=24;break a}b:do if(a==121){HEAP[e+64]=1;HEAP[e+32]=HEAP[n]+HEAP[e+32];HEAP[e+40]=HEAP[n+4];HEAP[e+40+4]=0;C=w=HEAP[n]+HEAP[e+24];z=HEAP[e+28];if(HEAP[e+70]!=0){a=122;break a}else{c=121;a=123;break b}}else if(a==140){HEAP[e+64]=1;HEAP[e+32]=HEAP[n]+HEAP[e+32];HEAP[e+32+4]=HEAP[n+4]+HEAP[e+
32+4];HEAP[e+40]=HEAP[n+8];HEAP[e+40+4]=HEAP[n+12];w=HEAP[n]+HEAP[e+24];z=HEAP[n+4]+HEAP[e+28];if(HEAP[e+70]!=0){a=141;break a}else{c=140;a=123;break b}}else if(a==204){f=HEAP[e+64]==3;c:do if(f)a=142;else{a=HEAP[e+64]==2?142:143;break c}while(0);a==142&&_t1_builder_close_contour(e);HEAP[e+64]=1;c=143;a=123;break b}else if(a==145){d=_t1_builder_start_point(e,w,z);if(d!=0){a=61;break a}else c=145;w+=HEAP[n];a=147;break b}else if(a==148){w+=HEAP[n];if(HEAP[HEAP[o]+1400]!=0){c=148;a=123;break b}if(HEAP[e+
64]==0){a=24;break a}HEAP[e+64]=2;c=150;a=123;break b}else if(a==151){d=_t1_builder_start_point(e,w,z);if(d!=0){a=61;break a}d=_t1_builder_check_points(e,3);if(d!=0){a=61;break a}w+=HEAP[n];_t1_builder_add_point(e,w,z,0);w+=HEAP[n+4];z+=HEAP[n+8];_t1_builder_add_point(e,w,z,0);z+=HEAP[n+12];_t1_builder_add_point(e,w,z,1);c=153;a=123;break b}else if(a==154){d=_t1_builder_start_point(e,w,z);if(d!=0){a=61;break a}else c=154;w+=HEAP[n];z+=HEAP[n+4];a=147;break b}else if(a==160){w+=HEAP[n];z+=HEAP[n+4];
if(HEAP[HEAP[o]+1400]!=0){c=160;a=123;break b}if(HEAP[e+64]==0){a=24;break a}HEAP[e+64]=2;c=162;a=123;break b}else if(a==163){d=_t1_builder_start_point(e,w,z);if(d!=0){a=61;break a}d=_t1_builder_check_points(e,3);if(d!=0){a=61;break a}w+=HEAP[n];z+=HEAP[n+4];_t1_builder_add_point(e,w,z,0);w+=HEAP[n+8];z+=HEAP[n+12];_t1_builder_add_point(e,w,z,0);w+=HEAP[n+16];z+=HEAP[n+20];_t1_builder_add_point(e,w,z,1);c=165;a=123;break b}else if(a==166){d=_t1_builder_start_point(e,w,z);if(d!=0){a=61;break a}d=_t1_builder_check_points(e,
3);if(d!=0){a=61;break a}z+=HEAP[n];_t1_builder_add_point(e,w,z,0);w+=HEAP[n+4];z+=HEAP[n+8];_t1_builder_add_point(e,w,z,0);w+=HEAP[n+12];_t1_builder_add_point(e,w,z,1);c=168;a=123;break b}else if(a==169){d=_t1_builder_start_point(e,w,z);if(d!=0){a=61;break a}else c=169;z+=HEAP[n];a=147;break b}else if(a==171){z+=HEAP[n];if(HEAP[HEAP[o]+1400]!=0){c=171;a=123;break b}if(HEAP[e+64]==0){a=24;break a}HEAP[e+64]=2;c=173;a=123;break b}else if(a==187){if(g==0){c=187;a=123;break b}FUNCTION_TABLE[HEAP[g+12]](HEAP[g],
1,n);c=188;a=123;break b}else if(a==189){if(g==0){c=189;a=123;break b}FUNCTION_TABLE[HEAP[g+16]](HEAP[g],1,n);c=190;a=123;break b}else if(a==191){if(g==0){c=191;a=123;break b}HEAP[n]=C+HEAP[n];FUNCTION_TABLE[HEAP[g+12]](HEAP[g],0,n);c=192;a=123;break b}else if(a==193){if(g==0){c=193;a=123;break b}f=C;HEAP[n]=f+HEAP[n];HEAP[n+8]=f+HEAP[n+8];HEAP[n+16]=f+HEAP[n+16];FUNCTION_TABLE[HEAP[g+16]](HEAP[g],0,n);c=194;a=123;break b}else if(a==174){f=_FT_DivFix(HEAP[n],HEAP[n+4]);HEAP[n]=f;n+=4;c=174;a=123;
break b}else if(a==175){A=reSign(HEAP[n],32)>>reSign(16,32);if(reSign(A,32)<reSign(0,32)){a=24;break a}f=A;if(reSign(HEAP[HEAP[o]+1364],32)<=reSign(f,32)){a=24;break a}if(reSign(x-(HEAP[o]+1140),32)>reSign(191,32)){a=24;break a}HEAP[x]=y;x+=12;HEAP[x+4]=HEAP[HEAP[HEAP[o]+1368]+4*A];y=HEAP[x+4];f=HEAP[o];if(HEAP[HEAP[o]+1372]!=0)HEAP[x+8]=y+HEAP[HEAP[f+1372]+4*A];else{f=HEAP[f+1360];f=reSign(f,32)>=reSign(0,32)?f:0;HEAP[x+4]=y+f;HEAP[x+8]=HEAP[HEAP[HEAP[o]+1368]+4*(A+1)]}HEAP[x]=HEAP[x+4];if(HEAP[x+
4]==0){a=24;break a}HEAP[HEAP[o]+1344]=x;y=HEAP[x+4];A=HEAP[x+8];c=181;a=123;break b}else if(a==205){if(reSign(B,32)>reSign(0,32)){B-=1;c=182}else{if(m==0){a=24;break a}m-=1;n+=4;c=184}a=123;break b}else if(a==185){if(HEAP[o]+1140>=x){a=24;break a}x+=-12;y=HEAP[x];A=HEAP[x+8];HEAP[HEAP[o]+1344]=x;c=186;a=123;break b}else if(a==195){w=HEAP[n];z=HEAP[n+4];HEAP[HEAP[o]+1400]=0;c=195;a=123;break b}while(0);if(a==147){a=w;v=z;f=e;a=a;h=v;i=v=_t1_builder_check_points(f,1);if(v!=0){a=157;break a}_t1_builder_add_point(f,
a,h,1);d=f=i;if(f!=0){a=61;break a}else c=156}f=c==116?J:c==193?J:c==194?J:c==191?J:c==192?J:c==189?J:c==190?J:c==187?J:c==188?J:c==116?J:c==171?J:c==173?J:c==160?J:c==162?J:c==156?J:c==148?J:c==150?J:c==140?J:c==121?J:c==195?J:c==186?J:c==184?J:c==182?J:c==181?J:c==174?0:c==168?J:c==165?J:c==153?J:J;HEAP[HEAP[o]+1136]=n;c=123}a=4}a:do if(a==24){a=117;break a}else if(a==56){p=161;a=120;break a}else if(a==61){a=158;break a}else if(a==202){_t1_builder_close_contour(e);if(g!=0){r=HEAP[g+8];u=reSign(HEAP[HEAP[e+
20]+2],16);if(FUNCTION_TABLE[r](HEAP[g],u)!=0){a=117;break a}FUNCTION_TABLE[HEAP[g+24]](HEAP[g],HEAP[e+20],HEAP[e+76],HEAP[HEAP[o]+1468])}_FT_GlyphLoader_Add(HEAP[e+12]);p=0;a=120;break a}else if(a==203){q=reSign(HEAP[n+16],32)>>reSign(16,32);s=reSign(HEAP[n+12],32)>>reSign(16,32);e=HEAP[n+8];p=HEAP[n+4];n=HEAP[n];o=HEAP[o];n=n;p=p;e=e;j=s;k=q;v=HEAP[o+4];g=HEAP[o+1496]!=0;b:do{if(!g){p+=HEAP[o+32];q=HEAP[o+1356]==0;c:do if(q){if(HEAP[HEAP[v+128]+52]!=0)break c;q=160;break b}while(0);if(HEAP[HEAP[v+
128]+52]!=0){var I=j;q=I;s=k;c=128}else{q=_t1_lookup_glyph_by_stdcharcode(o,j);s=_t1_lookup_glyph_by_stdcharcode(o,k);var P=q;c=130}l=reSign(c==130?P:I,32)<reSign(0,32);c:do if(!l){if(reSign(s,32)<reSign(0,32))break c;I=HEAP[o+69]!=0;P=o;d:do if(I){k=HEAP[P+8];v=HEAP[HEAP[k+156]];j=_FT_GlyphLoader_CheckSubGlyphs(v,2);if(j!=0)break d;g=HEAP[v+56+32];HEAP[g]=q;HEAP[g+4]=514;HEAP[g+8]=0;HEAP[g+12]=0;g+=32;HEAP[g]=s;HEAP[g+4]=2;m=p-n;l=reSign(m,32)>=reSign(0,32);m=m;l=l=l=l?m+32768&-65536:0-(32768-m&
-65536);l=reSign(l,32)>>reSign(16,32);HEAP[g+8]=l;l=m=e;m=reSign(m,32)>=reSign(0,32);l=l;l=l=l=m?l+32768&-65536:0-(32768-l&-65536);l=reSign(l,32)>>reSign(16,32);HEAP[g+12]=l;HEAP[k+128]=2;HEAP[k+132]=HEAP[v+20+32];HEAP[k+72]=1668246896;HEAP[v+56+28]=2}else{j=HEAP[P+12];k=j+56;HEAP[k+2]=0;HEAP[k]=0;HEAP[k+28]=0;_FT_GlyphLoader_Adjust_Points(j);k=j;j=k+20;k=k+56;HEAP[k+32]=HEAP[j+32]+32*HEAP[j+28];HEAP[o+1496]=1;k=q;j=o;k=k;j=j=j=FUNCTION_TABLE[HEAP[j+1472]](j,k);HEAP[o+1496]=0;if(j!=0)break d;j=o+
32;HEAP[r]=HEAP[j];HEAP[r+4]=HEAP[j+4];HEAP[u]=HEAP[r];HEAP[u+4]=HEAP[r+4];j=o+40;HEAP[b]=HEAP[j];HEAP[b+4]=HEAP[j+4];HEAP[t]=HEAP[b];HEAP[t+4]=HEAP[b+4];HEAP[o+32]=0;HEAP[o+32+4]=0;HEAP[o+24]=p-n;HEAP[o+28]=e;HEAP[o+1496]=1;k=s;j=o;k=k;j=j=j=FUNCTION_TABLE[HEAP[j+1472]](j,k);HEAP[o+1496]=0;if(j!=0)break d;k=o+32;HEAP[k]=HEAP[u];HEAP[k+4]=HEAP[u+4];k=o+40;HEAP[k]=HEAP[t];HEAP[k+4]=HEAP[t+4];HEAP[o+24]=0;HEAP[o+28]=0}while(0);q=j;break b}while(0)}q=160}while(0);p=r=q;a=120;break a}else if(a==122){p=
0;a=120;break a}else if(a==141){p=0;a=120;break a}else if(a==157){d=v;a=158;break a}while(0);if(a==117)p=160;else if(a==158)p=d;r=p;STACKTOP=b;return r}_t1_decoder_parse_charstrings.__index__=Runtime.getFunctionIndex(_t1_decoder_parse_charstrings,"_t1_decoder_parse_charstrings");
function _t1_decoder_init(e,g,d,b,a,c,f,h,i){var k;_llvm_memset_p0i8_i32(e,0,1500,1,0);k=_ft_module_get_service(HEAP[g+96],__str60);if(k==0)e=7;else{HEAP[e+1348]=k;f=unSign(f,8);_t1_builder_init(e,g,d,b,f&255);HEAP[e+1352]=HEAP[g+16];HEAP[e+1356]=a;HEAP[e+1468]=h;HEAP[e+1464]=c;HEAP[e+1472]=i;e=e+1476;HEAP[e]=_t1_decoder_init.__index__;HEAP[e+4]=_t1_decoder_done.__index__;HEAP[e+8]=_t1_decoder_parse_charstrings.__index__;e=0}return e}
_t1_decoder_init.__index__=Runtime.getFunctionIndex(_t1_decoder_init,"_t1_decoder_init");function _t1_decoder_done(e){var g;g=HEAP[e+8];if(g!=0){e=HEAP[e+16];g=g+108;HEAP[g]=HEAP[e];HEAP[g+2]=HEAP[e+2];HEAP[g+4]=HEAP[e+4];HEAP[g+8]=HEAP[e+8];HEAP[g+12]=HEAP[e+12];HEAP[g+16]=HEAP[e+16]}}_t1_decoder_done.__index__=Runtime.getFunctionIndex(_t1_decoder_done,"_t1_decoder_done");function _t1_cmap_std_done(e){HEAP[e+24]=0;HEAP[e+28]=0;HEAP[e+20]=0;HEAP[e+16]=0}
_t1_cmap_std_done.__index__=Runtime.getFunctionIndex(_t1_cmap_std_done,"_t1_cmap_std_done");
function _t1_cmap_std_char_index(e,g){var d,b=null,a,c,f;a=0;if(unSign(g,32)<=unSign(255,32)){c=unSign(HEAP[HEAP[e+16]+2*g],16);c=FUNCTION_TABLE[HEAP[e+20]](c);f=0;var h=HEAP[e+24],i=e+28;f=f;b=0;a:for(;;){d=b==3?j:0;var k=f+d;if(!(unSign(h,32)>unSign(k,32))){d=8;break a}j=HEAP[HEAP[i]+4*k];b=j!=0;b:do if(b){if(HEAP[j]!=HEAP[c])break b;if(_strcmp(j,c)==0){d=4;break a}}while(0);var j=d+1;b=3;d=1}if(d!=8)if(d==4)a=f=k}return a}
_t1_cmap_std_char_index.__index__=Runtime.getFunctionIndex(_t1_cmap_std_char_index,"_t1_cmap_std_char_index");function _t1_cmap_std_char_next(e,g){var d,b=null,a,c;a=0;var f=HEAP[g]+1;var h=c=f,i=a,k=h+1;for(b=-1;;){d=b==2?o:0;var j=b==2?0:i,l=h+d;o=k+d;if(!(unSign(b==2?o:f,32)<=unSign(255,32))){d=4;break}var m=_t1_cmap_std_char_index(e,l);if(m!=0){d=1;break}var o=d+1;b=2;d=0}if(d==1){a=m;c=l}else if(d==4){a=j;c=0}HEAP[g]=c;return a}
_t1_cmap_std_char_next.__index__=Runtime.getFunctionIndex(_t1_cmap_std_char_next,"_t1_cmap_std_char_next");function _t1_cmap_standard_init(e){var g,d;g=HEAP[e];d=HEAP[g+484];HEAP[e+24]=HEAP[g+132+284];HEAP[e+28]=HEAP[g+132+288];HEAP[e+20]=HEAP[d+20];HEAP[e+16]=HEAP[d+24];return 0}_t1_cmap_standard_init.__index__=Runtime.getFunctionIndex(_t1_cmap_standard_init,"_t1_cmap_standard_init");
function _t1_cmap_expert_init(e){var g,d;g=HEAP[e];d=HEAP[g+484];HEAP[e+24]=HEAP[g+132+284];HEAP[e+28]=HEAP[g+132+288];HEAP[e+20]=HEAP[d+20];HEAP[e+16]=HEAP[d+28];return 0}_t1_cmap_expert_init.__index__=Runtime.getFunctionIndex(_t1_cmap_expert_init,"_t1_cmap_expert_init");function _t1_cmap_custom_init(e){var g;g=HEAP[e]+132+240;HEAP[e+16]=HEAP[g+4];HEAP[e+20]=HEAP[g+8]-HEAP[e+16];HEAP[e+24]=HEAP[g+12];return 0}_t1_cmap_custom_init.__index__=Runtime.getFunctionIndex(_t1_cmap_custom_init,"_t1_cmap_custom_init");
function _t1_cmap_custom_done(e){HEAP[e+24]=0;HEAP[e+16]=0;HEAP[e+20]=0}_t1_cmap_custom_done.__index__=Runtime.getFunctionIndex(_t1_cmap_custom_done,"_t1_cmap_custom_done");function _t1_cmap_custom_char_index(e,g){var d;d=0;var b=unSign(HEAP[e+16],32)<=unSign(g,32);a:do if(b){var a=g;if(!(unSign(HEAP[e+20]+HEAP[e+16],32)>unSign(a,32)))break a;d=unSign(HEAP[HEAP[e+24]+2*g],16)}while(0);return d}_t1_cmap_custom_char_index.__index__=Runtime.getFunctionIndex(_t1_cmap_custom_char_index,"_t1_cmap_custom_char_index");
function _t1_cmap_custom_char_next(e,g){var d,b=null,a,c;a=0;c=HEAP[g];c+=1;b=c;if(unSign(HEAP[e+16],32)>unSign(b,32))c=HEAP[e+16];var f=HEAP[e+20]+HEAP[e+16],h=e+24,i=c,k=a;for(b=1;;){d=b==1?0:o;var j=b==1?k:0,l=i+d;if(!(unSign(f,32)>unSign(l,32))){d=6;break}var m=unSign(HEAP[HEAP[h]+2*l],16);if(m!=0){d=3;break}var o=d+1;b=4;d=2}if(d==3){a=m;c=l}else if(d==6){a=j;c=0}HEAP[g]=c;return a}_t1_cmap_custom_char_next.__index__=Runtime.getFunctionIndex(_t1_cmap_custom_char_next,"_t1_cmap_custom_char_next");
function _t1_get_glyph_name418(e,g){return HEAP[HEAP[e+132+288]+4*g]}_t1_get_glyph_name418.__index__=Runtime.getFunctionIndex(_t1_get_glyph_name418,"_t1_get_glyph_name418");function _t1_cmap_unicode_init(e){var g;g=HEAP[e];return FUNCTION_TABLE[HEAP[HEAP[g+484]+4]](HEAP[g+100],e,HEAP[g+132+284],_t1_get_glyph_name418.__index__,0,g)}_t1_cmap_unicode_init.__index__=Runtime.getFunctionIndex(_t1_cmap_unicode_init,"_t1_cmap_unicode_init");
function _t1_cmap_unicode_done(e){var g,d=HEAP[e+20];g=HEAP[HEAP[e]+100];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+20]=0;HEAP[e+16]=0}_t1_cmap_unicode_done.__index__=Runtime.getFunctionIndex(_t1_cmap_unicode_done,"_t1_cmap_unicode_done");function _t1_cmap_unicode_char_index(e,g){return FUNCTION_TABLE[HEAP[HEAP[HEAP[e]+484]+8]](e,g)}_t1_cmap_unicode_char_index.__index__=Runtime.getFunctionIndex(_t1_cmap_unicode_char_index,"_t1_cmap_unicode_char_index");
function _t1_cmap_unicode_char_next(e,g){return FUNCTION_TABLE[HEAP[HEAP[HEAP[e]+484]+12]](e,g)}_t1_cmap_unicode_char_next.__index__=Runtime.getFunctionIndex(_t1_cmap_unicode_char_next,"_t1_cmap_unicode_char_next");
function _afm_stream_skip_spaces(e){var g=null,d;if(!(reSign(HEAP[e+12],32)>reSign(0,32))){d=e+8;a:for(;;){if(HEAP[e]<HEAP[d]){g=HEAP[e];var b=unSign(HEAP[g],8);HEAP[e]=g+1;g=1}else g=0;var a=g==1?b:-1;if(a!=9)if(a!=32)break a}d=a;b=d==13|d==10;a:do if(b)HEAP[e+12]=2;else if(d==59)HEAP[e+12]=1;else{if(!(d==-1|d==26))break a;HEAP[e+12]=3}while(0)}}_afm_stream_skip_spaces.__index__=Runtime.getFunctionIndex(_afm_stream_skip_spaces,"_afm_stream_skip_spaces");
function _afm_stream_read_one(e){var g,d=null,b;_afm_stream_skip_spaces(e);if(reSign(HEAP[e+12],32)>reSign(0,32))e=0;else{b=HEAP[e]+-1;for(var a=e+8;;){if(HEAP[e]<HEAP[a]){g=HEAP[e];var c=unSign(HEAP[g],8);HEAP[e]=g+1;d=2}else d=1;g=d==2?c:-1;if(g==9){g=5;break}else if(g==32){g=5;break}else if(g==10){g=6;break}else if(g==13){g=6;break}else if(g==59){g=7;break}else if(g==26){g=8;break}else if(g==-1){g=8;break}else g=1}if(g!=5)if(g==6)HEAP[e+12]=2;else if(g==7)HEAP[e+12]=1;else if(g==8)HEAP[e+12]=3;
e=b}return e}_afm_stream_read_one.__index__=Runtime.getFunctionIndex(_afm_stream_read_one,"_afm_stream_read_one");
function _afm_stream_read_string(e){var g,d=null,b;_afm_stream_skip_spaces(e);if(reSign(HEAP[e+12],32)>reSign(1,32))e=0;else{b=HEAP[e]+-1;for(var a=e+8;;){if(HEAP[e]<HEAP[a]){g=HEAP[e];var c=unSign(HEAP[g],8);HEAP[e]=g+1;d=2}else d=1;g=d==2?c:-1;if(g==10){g=5;break}else if(g==13){g=5;break}else if(g==26){g=6;break}else if(g==-1){g=6;break}else g=1}if(g==5)HEAP[e+12]=2;else if(g==6)HEAP[e+12]=3;e=b}return e}_afm_stream_read_string.__index__=Runtime.getFunctionIndex(_afm_stream_read_string,"_afm_stream_read_string");
function _afm_parser_read_vals(e,g,d){var b=STACKTOP;STACKTOP+=8;Runtime.memset(b,0,8);var a,c=null,f,h,i=b+4;f=HEAP[e+4];if(unSign(d,32)>unSign(5,32))e=0;else{h=0;var k=e+12,j=e+12,l=e+16;h=h;c=1;a:for(;;){x=c==16?x:0;var m=h+x;a=g+8*m;var o=g+8*m+4,n=o,p=o;if(!(unSign(m,32)<unSign(d,32)))break a;if(HEAP[a]==0){var r=_afm_stream_read_string(f);HEAP[b]=r;c=3}else{var q=_afm_stream_read_one(f);HEAP[b]=q;c=5}if((c==5?q:r)==0)break a;var s=HEAP[f]+-1+(0-HEAP[b]);a=HEAP[a];if(a==0){c=8;a=27}else if(a==
1){c=8;a=27}else if(a==2){c=8;a=18}else if(a==3){c=8;a=19}else if(a==4){c=8;a=28}else if(a==5){c=8;a=29}else{c=8;a=16}b:do if(a==27){var u=HEAP[e],t=s+1,v=reSign(t,32)>reSign(0,32);c:do if(v){var w=FUNCTION_TABLE[HEAP[u+4]](u,t);if(w!=0){c=9;a=11;break c}c=10}else{if(!(reSign(t,32)<reSign(0,32))){c=13;a=11;break c}c=14}while(0);u=c==9?w:c==10?0:c==13?0:0;HEAP[i]=c==9?0:c==10?64:c==13?0:6;HEAP[o]=u;if(HEAP[i]!=0)break b;_llvm_memcpy_p0i8_p0i8_i32(HEAP[o],HEAP[b],s,1,0);HEAP[HEAP[o]+s]=0;c=15}else if(a==
18){c=_PS_Conv_ToFixed(b,HEAP[b]+s,0);HEAP[n]=c;c=18}else if(a==19){c=_PS_Conv_ToInt(b,HEAP[b]+s);HEAP[n]=c;c=19}else if(a==28){u=s!=4;c:do if(u)a=21;else{if(_strncmp(HEAP[b],__str76417,4)!=0){c=20;a=21}else{c=20;a=22}break c}while(0);if(a==21)c=21;HEAP[p]=(c==21?0:1)&255;c=22}else if(a==29)if(HEAP[k]!=0){c=FUNCTION_TABLE[HEAP[j]](HEAP[b],s,HEAP[l]);HEAP[n]=c;c=24}else{HEAP[n]=0;c=25}while(0);var x=x+1;c=16}e=h=m}e=e;STACKTOP=b;return e}
_afm_parser_read_vals.__index__=Runtime.getFunctionIndex(_afm_parser_read_vals,"_afm_parser_read_vals");function _afm_parser_next_key(e,g){var d=null,b;b=HEAP[e+4];for(var a=b+12,c=b+12,f=b+12,h=b+12;;){reSign(HEAP[a],32)<=reSign(1,32)&&_afm_stream_read_string(b);HEAP[c]=0;var i=_afm_stream_read_one(b);if(i!=0){d=3;break}if(!(reSign(HEAP[f],32)<=reSign(2,32))){d=4;break}if(reSign(HEAP[h],32)>reSign(1,32))d=6;else{d=6;break}}d=d==6?0:d==4?0:i;if(g!=0){b=d!=0?HEAP[b]+-1+(0-d):0;HEAP[g]=b}return d}
_afm_parser_next_key.__index__=Runtime.getFunctionIndex(_afm_parser_next_key,"_afm_parser_next_key");
function _afm_tokenize(e,g){var d,b=null,a;b=-1;a:for(;;){var c=b==3?i:0;if(!(reSign(b==3?i:0,32)<=reSign(73,32))){d=10;break a}if(HEAP[HEAP[_afm_key_table+c*4]]==HEAP[e]){b=1;d=2}else{b=1;d=3}for(;;)if(d==2){d=b==8?h:0;var f=c+d;b=_afm_key_table+f*4;if(reSign(f,32)<=reSign(73,32)){if(HEAP[HEAP[b]]!=HEAP[e]){d=4;break a}if(_strncmp(HEAP[b],e,g)==0){d=7;break a}var h=d+1;b=8;d=2}else{b=2;d=3}}else if(d==3){var i=(b==1?c:f)+1;b=3;d=0;continue a}}if(d==4)a=75;else if(d==7)a=f;else if(d==10)a=75;return a}
_afm_tokenize.__index__=Runtime.getFunctionIndex(_afm_tokenize,"_afm_tokenize");function _afm_parser_init(e,g,d,b){var a=STACKTOP;STACKTOP+=4;Runtime.memset(a,0,4);var c;c=_ft_mem_alloc(g,16,a);if(HEAP[a]!=0)e=HEAP[a];else{HEAP[c+4]=d;HEAP[c]=HEAP[c+4];HEAP[c+8]=b;HEAP[c+12]=2;HEAP[e]=g;HEAP[e+4]=c;HEAP[e+8]=0;e=HEAP[e+12]=0}e=e;STACKTOP=a;return e}_afm_parser_init.__index__=Runtime.getFunctionIndex(_afm_parser_init,"_afm_parser_init");
function _afm_parser_done(e){var g,d=HEAP[e+4];g=HEAP[e];d!=0&&FUNCTION_TABLE[HEAP[g+8]](g,d);HEAP[e+4]=0}_afm_parser_done.__index__=Runtime.getFunctionIndex(_afm_parser_done,"_afm_parser_done");function _afm_compare_kern_pairs(e,g){var d,b;d=HEAP[e+4]|HEAP[e]<<16;b=HEAP[g+4]|HEAP[g]<<16;return unSign(d,32)>unSign(b,32)?1:unSign(d,32)<unSign(b,32)?-1:0}_afm_compare_kern_pairs.__index__=Runtime.getFunctionIndex(_afm_compare_kern_pairs,"_afm_compare_kern_pairs");
function _afm_parser_parse(e){var g=STACKTOP;STACKTOP+=172;Runtime.memset(g,0,172);var d,b=null,a,c;c=g+8;var f=g+12,h=g+16,i=g+48,k=g+56,j=g+60,l=g+64,m,o=g+104,n=g+108,p=g+112,r=g+120,q,s,u,t=g+128,v=g+132,w=g+136,x=g+168;a=HEAP[e];s=HEAP[e+8];u=160;HEAP[v]=0;var y=s==0;a:do if(y)q=6;else{q=_afm_parser_next_key(e,t);var A=q==0;b:do if(!A){if(HEAP[t]!=16){d=1;break b}if(_strncmp(q,__str50391,16)!=0){d=1;break b}var z=e,C=w,B=e,D=w,E=w+4,F=s+20,G=w,H=e,J=w,L=w+4,N=s+24,I=w,P=w+8,K=w+16,O=w+24,M=e,
Q=w,R=w+4,T=s+4,V=w+8+4,U=s+4+4,S=w+16+4,X=s+4+8,Y=w+24+4,W=s+4+12,da=w,ba=e,aa=w,ca=w+4,$=s,la=e,ga=r,ea=r+4,Z=e,ha=p,ia=p+4,ja=e;b=3;c:for(;;){var fa=_afm_parser_next_key(z,t);if(fa==0){b=4;d=10;break c}b=_afm_tokenize(fa,HEAP[t]);if(b==0){b=84;d=14}else if(b==14){b=84;d=16}else if(b==20){b=84;d=87;break c}else if(b==26){b=84;d=12}else if(b==30){b=84;d=9}else if(b==40){b=84;d=88}else if(b==45){b=84;d=89}else if(b==49){b=84;d=29;break c}else{b=84;d=4;continue c}if(d==14){HEAP[C]=2;if(_afm_parser_read_vals(B,
D,1)!=1){b=14;d=10;break c}HEAP[F]=HEAP[E];b=15;d=4}else if(d==16){HEAP[G]=2;if(_afm_parser_read_vals(H,J,1)!=1){b=16;d=10;break c}HEAP[N]=HEAP[L];b=17;d=4}else if(d==12){HEAP[I]=2;HEAP[P]=2;HEAP[K]=2;HEAP[O]=2;if(_afm_parser_read_vals(M,Q,4)!=4){b=12;d=10;break c}HEAP[T]=HEAP[R];HEAP[U]=HEAP[V];HEAP[X]=HEAP[S];HEAP[W]=HEAP[Y];b=13;d=4}else if(d==9){HEAP[da]=4;if(_afm_parser_read_vals(ba,aa,1)!=1){b=9;d=10;break c}HEAP[$]=HEAP[ca];b=11;d=4}else if(d==88){HEAP[ga]=3;if(_afm_parser_read_vals(la,r,1)!=
1){d=6;break c}HEAP[v]=HEAP[ea];if(HEAP[v]!=0&HEAP[v]!=2){b=5;d=8;break c}else{b=5;d=4}}else if(d==89){HEAP[x]=0;HEAP[ha]=3;if(_afm_parser_read_vals(Z,p,1)!=1){d=19;break c}HEAP[x]=HEAP[ia];d=HEAP[x]+-1;b=18;d:for(;;){b=b==21?na:0;if(d+b*-1==-1){b=20;break d}var ka=_afm_parser_next_key(ja,0)==0,na=b+1;if(ka){b=21;d=22;break c}else b=21}for(;;){d=_afm_parser_next_key(ja,n);if(d==0){d=25;break c}b=_afm_tokenize(d,HEAP[n]);if(b==17)break;else if(b==20)break;else b=24}u=0;b=27;d=4}}c:do if(d==10){q=b==
9?fa:b==12?fa:b==14?fa:b==16?fa:0;d=7;break c}else if(d==87){q=fa;d=81;break c}else if(d==29){q=fa;z=u=b=e;C=g;B=g+4;D=h;E=h+8;F=h+16;G=h+24;H=h;J=h+4;L=h+8+4;N=h+16+4;I=h+16+4;P=h+24+4;K=b;O=i;M=i+4;Q=l;R=l+8;T=l+16;V=l+24;U=l+32;S=l;X=l+4;Y=l+8+4;W=l+16+4;da=l+24+4;ba=l+32+4;aa=K+8;ca=K;$=z+8;la=z;b=29;d:for(;;){e:for(;;){f:for(;;){b=48;g:for(;;){for(;;){b=_afm_parser_next_key(u,o);if(b==0){b=55;d=83;break d}b=_afm_tokenize(b,HEAP[o]);if(b==20){b=82;d=90;break d}else if(b==21){b=82;d=90;break d}else if(b==
50){b=82;break g}else if(b==51){b=82;break g}else if(b==53){b=82;break}else if(b==75)b=82;else{b=82;d=83;break d}}var sa=HEAP[aa];d=sa+32;HEAP[O]=3;if(_afm_parser_read_vals(K,i,1)!=1){d=33;break d}HEAP[d]=HEAP[M];if(HEAP[sa+32]==0)break f;b=_ft_mem_realloc(HEAP[ca],20,0,HEAP[sa+32],0,j);HEAP[sa+28]=b;if(HEAP[j]==0)break f;m=b=HEAP[j];if(b!=0){b=38;d=53;break d}else b=38}var wa=HEAP[$];d=wa+40;HEAP[C]=3;if(_afm_parser_read_vals(z,g,1)!=1){d=58;break d}HEAP[d]=HEAP[B];if(HEAP[wa+40]==0)break e;b=_ft_mem_realloc(HEAP[la],
16,0,HEAP[wa+40],0,f);HEAP[wa+36]=b;if(HEAP[f]==0)break e;m=b=HEAP[f];if(b!=0){b=64;d=80;break d}}d=sa+32;ga=sa+28;b=36;f:for(;;){b=b==44?Da:0;var Aa=b+-1;g:for(;;){ea=_afm_parser_next_key(K,k);if(ea==0){b=45;d=50;break d}ea=_afm_tokenize(ea,HEAP[k]);if(ea==20)break f;else if(ea==21)break f;else if(ea==23)break f;else if(ea==56)break g;else if(ea!=75){b=49;d=50;break d}}if(reSign(HEAP[d],32)<=reSign(b,32)){b=39;d=40;break d}ea=HEAP[ga];HEAP[Q]=3;HEAP[R]=2;HEAP[T]=2;HEAP[V]=2;HEAP[U]=2;if(_afm_parser_read_vals(K,
S,5)!=5){b=41;d=40;break d}HEAP[ea+20*b]=HEAP[X];HEAP[ea+20*b+4]=HEAP[Y];HEAP[ea+20*b+8]=HEAP[W];HEAP[ea+20*b+12]=HEAP[da];HEAP[ea+20*b+16]=HEAP[ba];Da=reSign(HEAP[ea+20*b],32)<reSign(0,32);g:do if(Da){if(!(reSign(HEAP[ea+20*b+8],32)>reSign(0,32)))break g;HEAP[ea+20*b+8]=0-HEAP[ea+20*b+8]}while(0);var Da=b+1;b=44}HEAP[sa+32]=Aa+1;m=0}d=wa+40;ga=wa+36;b=61;e:for(;;){ea=b==61?-1:pa;Z=ea+1;b=62;f:for(;;){b=b==62?0:ua;for(var pa=Z+b,ta=ea+b;;){ha=_afm_parser_next_key(z,c);if(ha==0){b=71;d=77;break d}var ma=
_afm_tokenize(ha,HEAP[c]);if(ma==20)break e;else if(ma==21)break e;else if(ma==22)break e;else if(ma==34)break;else if(ma==36)break;else if(ma==37)break;else if(ma!=75){b=76;d=77;break d}}if(reSign(HEAP[d],32)<=reSign(pa,32)){b=65;d=66;break d}ha=HEAP[ga];HEAP[D]=5;HEAP[E]=5;HEAP[F]=3;HEAP[G]=3;var ya=_afm_parser_read_vals(z,H,4);if(reSign(ya,32)<=reSign(2,32)){b=67;d=66;break d}HEAP[ha+16*pa]=HEAP[J];HEAP[ha+16*pa+4]=HEAP[L];var qa=ha+16*pa;if(ma!=37)break f;HEAP[ha+16*pa+8]=0;HEAP[ha+16*pa+12]=
HEAP[N];var ua=b+1;b=69}HEAP[qa+8]=HEAP[I];if(ma!=34|ya!=4)b=70;else{var Ba=HEAP[P];b=72}HEAP[qa+12]=b==72?Ba:0;b=74}HEAP[wa+40]=ta+1;_qsort(HEAP[wa+36],HEAP[wa+40],16,_afm_compare_kern_pairs.__index__);m=0;b=75;d=30}d:do if(d==83){u=160;d=7;break c}else if(d==90){u=0;d=81;break c}else if(d==58){d=59;break d}else if(d==80){d=79;break d}else if(d==77){b=77;d=78;break d}else if(d==66){b=66;d=78;break d}else if(d==33){d=34;break d}else if(d==53){d=52;break d}else if(d==50){b=50;d=51;break d}else if(d==
40){b=40;d=51;break d}while(0);d:do if(d==78){d=59;break d}else if(d==51){d=34;break d}while(0);d:do if(d==59){m=160;d=79;break d}else if(d==34){m=160;d=52;break d}while(0);if(d==79){var Na=m;b=79}else if(d==52){var Ea=m;b=52}u=b=b==52?Ea:Na;d=b!=0?7:81;break c}else if(d==6){q=fa;d=7;break c}else if(d==8){q=fa;d=u=7;break c}else if(d==19){q=fa;d=7;break c}else if(d==22){q=fa;d=26;break c}else if(d==25){q=fa;d=26;break c}while(0);if(d==7){f=HEAP[s+28];e=a;c=f;f!=0&&FUNCTION_TABLE[HEAP[e+8]](e,c);HEAP[s+
28]=0;HEAP[s+32]=0;e=HEAP[s+36];a=a;c=e;e!=0&&FUNCTION_TABLE[HEAP[a+8]](a,c);HEAP[s+36]=0;HEAP[s+40]=0;HEAP[s]=0;q=u;break a}else if(d==81){q=0;break a}else if(d==26){q=u=160;break a}}while(0);q=2}while(0);s=q;STACKTOP=g;return s}_afm_parser_parse.__index__=Runtime.getFunctionIndex(_afm_parser_parse,"_afm_parser_parse");
function _PS_Conv_Strtol(e,g,d){var b;b=null;var a,c,f,h;c=HEAP[e];h=f=0;var i=c==g;a:do if(i)b=0;else{b=reSign(d,32)<=reSign(1,32);i=reSign(d,32)>reSign(36,32);if(b|i){b=0;break a}a=HEAP[c]==45;b:do if(a)b=3;else{b=HEAP[c]==43?3:4;break b}while(0);b:do if(b==3){h=unSign(HEAP[c]==45,1);c+=1;if(c!=g)break b;a=0;b=7;break a}while(0);g=g;d=a=d;c=c;f=f;for(b=4;;){m=b==4?0:m;var k=b==4?f:l,j=c+m;if(!(j<g))break;if(HEAP[j]==32)break;if(HEAP[j]==13)break;if(HEAP[j]==10)break;if(HEAP[j]==9)break;if(HEAP[j]==
12)break;if(HEAP[j]==0)break;if(reSign(HEAP[j],8)<reSign(0,8))break;l=unSign(HEAP[j],8)&127;l=HEAP[_ft_char_table+l];b=reSign(l,8)<reSign(0,8);i=reSign(l,8);i=reSign(i,32)>=reSign(a,32);if(b|i)break;b=d*k;var l=reSign(l,8)+b,m=m+1;b=17}f=k;c=j;if(h!=0)f=0-f;HEAP[e]=c;a=f;b=7;break a}while(0);if(b==0)a=0;return a}_PS_Conv_Strtol.__index__=Runtime.getFunctionIndex(_PS_Conv_Strtol,"_PS_Conv_Strtol");
function _PS_Conv_ToInt(e,g){var d,b,a,c;c=_PS_Conv_Strtol(e,g,10);a=HEAP[e];var f=a>=g;a:do if(f)d=0;else{if(HEAP[a]!=35){d=0;break a}HEAP[e]=a+1;b=_PS_Conv_Strtol(e,g,c);d=2;break a}while(0);if(d==0)b=c;return b}_PS_Conv_ToInt.__index__=Runtime.getFunctionIndex(_PS_Conv_ToInt,"_PS_Conv_ToInt");
function _PS_Conv_ToFixed(e,g,d){var b=STACKTOP;STACKTOP+=4;Runtime.memset(b,0,4);var a,c=null,f,h,i,k;f=d;HEAP[b]=HEAP[e];i=0;k=1;d=0;var j=HEAP[b]==g;a:do if(j)h=0;else{h=HEAP[HEAP[b]]==45;b:do if(h)a=1;else{a=HEAP[HEAP[b]]==43?1:2;break b}while(0);b:do if(a==1){d=unSign(HEAP[HEAP[b]]==45,1);HEAP[b]+=1;if(HEAP[b]!=g)break b;h=0;break a}while(0);h=HEAP[HEAP[b]]!=46?_PS_Conv_ToInt(b,g)<<16:0;a=HEAP[b]<g;b:do if(a){if(HEAP[HEAP[b]]!=46)break b;HEAP[b]+=1;var l=g,m=h!=0;f=f;i=i;k=k;c=6;c:for(;;){var o=
c==23?w:k,n=c==23?x:i,p=c==23?y:f;if(!(HEAP[b]<l)){c=8;break c}if(HEAP[HEAP[b]]==32){c=9;break c}if(HEAP[HEAP[b]]==13){c=11;break c}if(HEAP[HEAP[b]]==10){c=12;break c}if(HEAP[HEAP[b]]==9){c=13;break c}if(HEAP[HEAP[b]]==12){c=14;break c}if(HEAP[HEAP[b]]==0){c=15;break c}if(reSign(HEAP[HEAP[b]],8)<reSign(0,8)){c=16;break c}c=unSign(HEAP[HEAP[b]],8)&127;var r=HEAP[_ft_char_table+c];c=reSign(r,8)<reSign(0,8);var q=reSign(r,8)>reSign(9,8);if(c|q){c=17;break c}w=reSign(p,32)<=reSign(0,32);w=m|w;d:do if(w){if(!(reSign(o,
32)<=reSign(9999999,32))){c=21;break d}var s=n*10;s=reSign(r,8)+s;var u=o*10;c=22}else{var t=p-1,v=n*10;v=reSign(r,8)+v;c=19}while(0);var w=c==22?u:c==21?o:o,x=c==22?s:c==21?n:v,y=c==22?p:c==21?p:t;HEAP[b]+=1;c=23}k=o;i=n;f=p}while(0);l=HEAP[b]+1<g;b:do if(l){if(HEAP[HEAP[b]]!=101)if(HEAP[HEAP[b]]!=69){a=26;break b}HEAP[b]+=1;var A=_PS_Conv_ToInt(b,g);f=A=f+A;c=27;a=28;break b}else a=26;while(0);if(a==26){var z=f;c=26}if(reSign(c==26?z:A,32)>reSign(0,32)){var C=h;i=i;c=f;h=0-c;h=reSign(h,32)>reSign(-1,
32)?h:-1;a=c+h+1;for(c=29;;){var B=(c==29?C:B)*10,D=(c==29?i:D)*10,E=(c==29?0:E)+1;if(E!=a)c=30;else break}f=C=-1-h;i=D;h=B;c=31}else{var F=f;c=38}if(reSign(c==38?F:C,32)<reSign(0,32)){h=h;k=k;c=f;a=c+1;a=reSign(a,32)>reSign(0,32)?a:0;l=a-c;for(c=34;;){J=c==34?0:J;H=c==34?k:H;var G=Math.floor(reSign(c==34?h:G,32)/reSign(10,32)),H=H*10,J=J+1;if(J!=l)c=35;else{c=35;break}}f=a;k=H;h=G}if(i!=0){a=_FT_DivFix(i,k);h+=a}if(d!=0)h=0-h;HEAP[e]=HEAP[b];h=h}while(0);e=h;STACKTOP=b;return e}
_PS_Conv_ToFixed.__index__=Runtime.getFunctionIndex(_PS_Conv_ToFixed,"_PS_Conv_ToFixed");
function _ft_get_adobe_glyph_index(e,g){var d,b=null,a,c,f,h,i,k;a=e;k=_ft_adobe_glyph_list;var j=a==0;a:do if(j)d=0;else{if(a>=g){d=0;break a}f=reSign(HEAP[a],8);a+=1;h=unSign(HEAP[k+1],8);k+=2;i=h;h=k;var l=f;f=f;i=i;b=1;b:for(;;){var m=b==1?i:b==6?m:o;d=b==1?0:b==6?p:p;if(!(reSign(d,32)<reSign(m,32))){d=8;break b}var o=reSign(m+d,32)>>reSign(1,32),n=h+o*2;b=unSign(HEAP[n],8)<<8;n=unSign(HEAP[n+1],8)|b;n=_ft_adobe_glyph_list+n;b=unSign(HEAP[n],8)&127;if(b==l){d=3;break b}p=o+1;var p=(b=reSign(b,
32)<reSign(f,32))?p:d;if(!b){b=4;d=2;continue b}b=6;d=2}if(d==8){d=0;break a}else if(d==3){k=k=n;h=g;l=a;b=3;b:for(;;){f=b==17?u:0;i=l+f;if(i>=h){d=9;break b}i=reSign(HEAP[i],8);d=reSign(HEAP[k],8)<reSign(0,8);k+=1;b=HEAP[k];var r=unSign(b,8)&127;if(d){if(r!=i){d=15;break b}}else{if(reSign(HEAP[k],8)<reSign(0,8))k+=2;k+=1;d=b&127;for(b=19;;){b=b==22?s:0;if(!(reSign(d+b*-1,32)>reSign(0,32))){d=24;break b}var q=unSign(HEAP[k],8)<<8;q=unSign(HEAP[k+1],8)|q;q=_ft_adobe_glyph_list+q;if((unSign(HEAP[q],
8)&127)==i)break;k+=2;var s=b+1;b=22}k=q}var u=f+1;b=17;d=5}if(d==9){if(!(reSign(HEAP[k],8)>=reSign(0,8))){d=0;break a}if(!(reSign(HEAP[k+1],8)<reSign(0,8))){d=0;break a}a=unSign(HEAP[k+2],8)<<8;c=unSign(HEAP[k+3],8)|a;d=13;break a}else if(d==15){d=0;break a}else if(d==24){d=0;break a}}}while(0);if(d==0)c=0;return c}_ft_get_adobe_glyph_index.__index__=Runtime.getFunctionIndex(_ft_get_adobe_glyph_index,"_ft_get_adobe_glyph_index");
function _ps_unicode_value(e){var g,d=null,b,a,c,f;d=HEAP[e]==117;a:do if(d){if(HEAP[e+1]!=110){g=1;break a}if(HEAP[e+2]!=105){g=1;break a}a=0;c=e+3;var h=a,i=c;for(d=2;;){g=d==9?o:0;f=d==9?m:h;var k=i+g;m=g*-1;var j=4+m;m=3+m;if(!(reSign(d==9?m:4,32)>reSign(0,32))){g=7;break}d=HEAP[k];m=unSign(d,8)-48;if(unSign(m,32)>unSign(9,32)){d=unSign(d,8)-65;if(unSign(d,32)>unSign(5,32)){g=4;break}var l=d+10;if(unSign(l,32)>unSign(15,32)){g=7;break}else d=5}else d=10;var m=f*16+(d==10?m:l),o=g+1;d=9;g=3}if(g==
7){c=k;a=f}else if(g==4){c=k;a=f}if(j!=0){g=1;break a}if(HEAP[c]==0)b=a;else{if(HEAP[c]!=46){g=1;break a}b=a|-2147483648}g=12;break a}else g=1;while(0);a:do if(g==1){d=HEAP[e]==117;b:do if(d){b=0;f=e+1;k=b;j=f;for(d=14;;){g=d==21?u:0;var n=d==21?s:k,p=j+g;a=g*-1;var r=6+a;a=5+a;if(!(reSign(d==21?a:6,32)>reSign(0,32))){g=19;break}d=HEAP[p];a=unSign(d,8)-48;if(unSign(a,32)>unSign(9,32)){d=unSign(d,8)-65;if(unSign(d,32)>unSign(5,32)){g=16;break}var q=d+10;if(unSign(q,32)>unSign(15,32)){g=19;break}else d=
17}else d=22;var s=n*16+(d==22?a:q),u=g+1;d=21;g=15}if(g==19){f=p;b=n}else if(g==16){f=p;b=n}if(!(reSign(r,32)<=reSign(2,32))){g=24;break b}if(HEAP[f]==0)b=b;else{if(HEAP[f]!=46){g=24;break b}b=b|-2147483648}break a}while(0);b=e;f=0;k=e;j=b;for(d=24;;){g=d==28?v:0;var t=j+g;if(HEAP[t]==0){g=31;break}if(HEAP[t]==46&t>k){g=27;break}var v=g+1;d=28;g=26}if(g==31){b=t;var w=f;d=31}else if(g==27){var x=b=t;f=x;d=27}k=e;b=(d==31?w:x)==0?_ft_get_adobe_glyph_index(k,b):_ft_get_adobe_glyph_index(k,f)|-2147483648}while(0);
return b}_ps_unicode_value.__index__=Runtime.getFunctionIndex(_ps_unicode_value,"_ps_unicode_value");function _compare_uni_maps(e,g){var d,b;d=HEAP[e]&2147483647;b=HEAP[g]&2147483647;if(d==b){d=HEAP[g];if(unSign(HEAP[e],32)>unSign(d,32))d=1;else{d=HEAP[g];d=unSign(HEAP[e],32)<unSign(d,32)?-1:0}}else d=unSign(d,32)>unSign(b,32)?1:unSign(d,32)<unSign(b,32)?-1:0;return d}_compare_uni_maps.__index__=Runtime.getFunctionIndex(_compare_uni_maps,"_compare_uni_maps");
function _ps_unicodes_init(e,g,d,b,a,c){var f=STACKTOP;STACKTOP+=84;Runtime.memset(f,0,84);var h,i=null,k,j,l=f+4,m=f+44,o,n;_llvm_memset_p0i8_i32(l,0,40,4,0);HEAP[g+16]=0;HEAP[g+20]=0;var p=_ft_mem_realloc(e,8,0,d+10,0,f);HEAP[g+20]=p;if(HEAP[f]==0){n=HEAP[g+20];o=0;if(unSign(o,32)<unSign(d,32)){p=a!=0;o=o;n=n;i=o+1;var r=(unSign(d,32)>unSign(i,32)?d:i)-o;i=0;a:for(;;){var q=i==0?0:C,s=i==0?n:z,u=o+q,t=FUNCTION_TABLE[b](c,u);if(t!=0){i=1;h=2}else{i=1;h=3}b:for(;;)if(h==2){i=i==7?w:0;var v=_ft_extra_glyph_name_offsets+
i*4;h=unSign(i,32)<=unSign(9,32);c:do if(h)if(_strcmp(_ft_extra_glyph_names+HEAP[v],t)==0){if(HEAP[l+4*i]!=0)break c;HEAP[l+4*i]=1;HEAP[m+4*i]=u}else{var w=i+1;i=7;h=2;continue b}while(0);v=_ps_unicode_value(t);if((v&2147483647)!=0){i=5;h=8}else{i=5;h=9}for(;;)if(h==8){i=i==12?x:0;h=_ft_extra_glyph_unicodes+i*4;if(unSign(i,32)<=unSign(9,32))if(HEAP[h]==v)HEAP[l+4*i]=2;else{var x=i+1;i=12;h=8;continue}HEAP[s]=v;HEAP[s+4]=u;var y=s+8;i=13;h=9}else if(h==9){var A=i==13?y:s;if(p)break;else{i=9;h=3;continue b}}FUNCTION_TABLE[a](c,
t);i=14;h=3}else if(h==3){var z=i==14?A:i==9?A:s,C=q+1;if(C!=r){i=3;continue a}else break a}}n=z}b=o=0;a=n;c=10-b;i=17;a:for(;;){B=i==17?0:B;j=i==17?a:j;w=b+B;x=_ft_extra_glyph_unicodes+w*4;y=m+w*4;if(HEAP[l+w*4]==1){HEAP[j]=HEAP[x];HEAP[j+4]=HEAP[y];k=j+8;i=19}else i=18;j=i==19?k:j;var B=B+1;if(B!=c)i=21;else break a}n=j;l=Math.floor(reSign(n-HEAP[g+20],32)/reSign(8,32));m=l==0;a:do if(m){j=HEAP[g+20];k=e;j=j;j!=0&&FUNCTION_TABLE[HEAP[k+8]](k,j);HEAP[g+20]=0;if(HEAP[f]!=0)break a;HEAP[f]=163}else{k=
Math.floor(unSign(d,32)/unSign(2,32));j=l;if(unSign(k,32)>unSign(j,32)){k=_ft_mem_realloc(e,8,d,l,HEAP[g+20],f);HEAP[g+20]=k;HEAP[f]=0}_qsort(HEAP[g+20],l,8,_compare_uni_maps.__index__)}while(0);HEAP[g+16]=l}e=HEAP[f];STACKTOP=f;return e}_ps_unicodes_init.__index__=Runtime.getFunctionIndex(_ps_unicodes_init,"_ps_unicodes_init");
function _ps_unicodes_char_index(e,g){var d,b=null,a,c;c=0;a=HEAP[e+20];var f=a+8*HEAP[e+16]+-8;for(b=-1;;){var h=b==-1?f:b==8?h:l,i=b==-1?a:b==8?j:i;if(i<=h)b=0;else{b=0;d=6;break}var k=Math.floor(reSign(h-i,32)/reSign(8,32));k=reSign(k,32)>>reSign(1,32);k=i+8*k;if(HEAP[k]==g){d=1;break}b=HEAP[k]&2147483647;if(b==g)c=k;if(i==h){b=5;d=6;break}if(unSign(b,32)<unSign(g,32)){var j=k+8;b=8}else{var l=k+-8;b=9}d=0}if(d==1){c=k;b=1}else if(d==6){var m=c;b=6}return(b==6?m:k)!=0?HEAP[c+4]:0}
_ps_unicodes_char_index.__index__=Runtime.getFunctionIndex(_ps_unicodes_char_index,"_ps_unicodes_char_index");
function _ps_unicodes_char_next(e,g){var d,b=null,a,c,f;a=0;c=HEAP[g]+1;f=0;var h=e+20,i=c,k=c,j=c;f=f;var l=HEAP[e+16];b=-1;a:for(;;){var m=b==-1?l:b==6?m:n,o=b==-1?f:b==6?r:r;if(!(unSign(o,32)<unSign(m,32))){d=8;break a}var n=(unSign(m-o,32)>>>unSign(1,32))+o,p=HEAP[h]+8*n;if(HEAP[p]==i){d=1;break a}r=HEAP[p]&2147483647;if(r==k)a=HEAP[p+4];d=n+1;var r=(b=unSign(r,32)<unSign(j,32))?d:o;if(!b){b=5;d=0;continue a}b=6;d=0}a:do if(d==1)a=HEAP[p+4];else if(d==8){f=o;if(a!=0)break a;c=0;h=f;if(!(unSign(HEAP[e+
16],32)>unSign(h,32)))break a;c=HEAP[e+20]+8*f;a=HEAP[c+4];c=HEAP[c]&2147483647}while(0);HEAP[g]=c;return a}_ps_unicodes_char_next.__index__=Runtime.getFunctionIndex(_ps_unicodes_char_next,"_ps_unicodes_char_next");function _ps_get_macintosh_name(e){e=e;if(unSign(e,32)>unSign(257,32))e=0;e=reSign(HEAP[_ft_mac_names+e*2],16);return _ft_standard_glyph_names+e}_ps_get_macintosh_name.__index__=Runtime.getFunctionIndex(_ps_get_macintosh_name,"_ps_get_macintosh_name");
function _ps_get_standard_strings(e){if(unSign(e,32)>unSign(390,32))e=0;else{e=reSign(HEAP[_ft_sid_names+e*2],16);e=_ft_standard_glyph_names+e}return e}_ps_get_standard_strings.__index__=Runtime.getFunctionIndex(_ps_get_standard_strings,"_ps_get_standard_strings");function _psnames_get_service(e,g){return _ft_service_list_lookup(_pscmaps_services,g)}_psnames_get_service.__index__=Runtime.getFunctionIndex(_psnames_get_service,"_psnames_get_service");
function run(e){function g(){for(var c=0;c<3;c++)b.push(0)}__initializeRuntime__();_WIDTH=Pointer_make([0],0,ALLOC_STATIC);_HEIGHT=Pointer_make([0],0,ALLOC_STATIC);_image=Pointer_make([0],0,ALLOC_STATIC);__str=Pointer_make([78,111,110,45,48,115,58,32,37,100,10,0],0,ALLOC_STATIC);__str1=Pointer_make([117,115,97,103,101,58,32,37,115,32,102,111,110,116,32,115,97,109,112,108,101,45,116,101,120,116,32,119,105,100,116,104,32,104,101,105,103,104,116,32,97,110,103,108,101,10,0],0,ALLOC_STATIC);__str2=Pointer_make([73,
110,105,116,32,69,114,114,111,114,33,32,37,100,10,0],0,ALLOC_STATIC);__str3=Pointer_make([78,101,119,95,70,97,99,101,32,69,114,114,111,114,33,32,37,100,10,0],0,ALLOC_STATIC);__str4=Pointer_make([83,101,116,95,67,104,97,114,95,83,105,122,101,32,69,114,114,111,114,33,32,37,100,10,0],0,ALLOC_STATIC);_ft_default_modules=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);
__str5=Pointer_make([99,105,100,0],0,ALLOC_STATIC);__str16=Pointer_make([116,121,112,101,49,0],0,ALLOC_STATIC);__str27=Pointer_make([79,84,84,79,0],0,ALLOC_STATIC);__str38=Pointer_make([99,102,102,0],0,ALLOC_STATIC);__str49=Pointer_make([116,114,117,101,116,121,112,101,0],0,ALLOC_STATIC);__str510=Pointer_make([107,101,114,110,105,110,103,0],0,ALLOC_STATIC);__str6=Pointer_make([103,108,121,112,104,45,100,105,99,116,0],0,ALLOC_STATIC);__str7=Pointer_make([112,111,115,116,115,99,114,105,112,116,45,102,
111,110,116,45,110,97,109,101,0],0,ALLOC_STATIC);__str8=Pointer_make([115,102,110,116,45,116,97,98,108,101,0],0,ALLOC_STATIC);__str9=Pointer_make([116,116,45,99,109,97,112,115,0],0,ALLOC_STATIC);__str10=Pointer_make([116,121,112,101,52,50,0],0,ALLOC_STATIC);__str11=Pointer_make([116,114,117,101,116,121,112,101,45,101,110,103,105,110,101,0],0,ALLOC_STATIC);_raccess_guess_table=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,6,0,
0,0,0,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0],0,ALLOC_STATIC);__str12=Pointer_make([46,95,0],0,ALLOC_STATIC);__str13=Pointer_make([47,114,115,114,99,0],0,ALLOC_STATIC);__str14=Pointer_make([47,46,46,110,97,109,101,100,102,111,114,107,47,114,115,114,99,0],0,ALLOC_STATIC);__str15=Pointer_make([114,101,115,111,117,114,99,101,46,102,114,107,47,0],0,ALLOC_STATIC);__str1611=Pointer_make([46,114,101,115,111,117,114,99,101,47,0],0,ALLOC_STATIC);__str17=Pointer_make([37,0],0,ALLOC_STATIC);__str18=Pointer_make([46,
65,112,112,108,101,68,111,117,98,108,101,47,0],0,ALLOC_STATIC);_ft_trig_arctan_table=Pointer_make([4157273,0,0,0,2949120,0,0,0,1740967,0,0,0,919879,0,0,0,466945,0,0,0,234379,0,0,0,117304,0,0,0,58666,0,0,0,29335,0,0,0,14668,0,0,0,7334,0,0,0,3667,0,0,0,1833,0,0,0,917,0,0,0,458,0,0,0,229,0,0,0,115,0,0,0,57,0,0,0,29,0,0,0,14,0,0,0,7,0,0,0,4,0,0,0,2,0,0,0,1,0,0,0],0,ALLOC_STATIC);_bbox_interface=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str19=Pointer_make([98,100,
102,0],0,ALLOC_STATIC);__str20=Pointer_make([67,73,68,0],0,ALLOC_STATIC);__str21=Pointer_make([112,111,115,116,115,99,114,105,112,116,45,105,110,102,111,0],0,ALLOC_STATIC);_ft_bitmap_glyph_class=Pointer_make([52,0,0,0,1651078259,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ft_outline_glyph_class=Pointer_make([40,0,0,0,1869968492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str22=Pointer_make([116,114,117,101,116,121,112,101,103,120,45,118,97,
108,105,100,97,116,101,0],0,ALLOC_STATIC);__str123=Pointer_make([99,108,97,115,115,105,99,107,101,114,110,45,118,97,108,105,100,97,116,101,0],0,ALLOC_STATIC);__str24=Pointer_make([109,117,108,116,105,45,109,97,115,116,101,114,115,0],0,ALLOC_STATIC);__str25=Pointer_make([111,112,101,110,116,121,112,101,45,118,97,108,105,100,97,116,101,0],0,ALLOC_STATIC);__str127=Pointer_make([116,116,45,103,108,121,102,0],0,ALLOC_STATIC);__str28=Pointer_make([112,102,114,45,109,101,116,114,105,99,115,0],0,ALLOC_STATIC);
__str30=Pointer_make([119,105,110,102,111,110,116,115,0],0,ALLOC_STATIC);__str31=Pointer_make([120,102,56,54,45,100,114,105,118,101,114,45,110,97,109,101,0],0,ALLOC_STATIC);_tt_service_gx_multi_masters=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_service_truetype_engine=Pointer_make([2,0,0,0],0,ALLOC_STATIC);_tt_service_truetype_glyf=Pointer_make([0,0,0,0],0,ALLOC_STATIC);_tt_services=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0],0,ALLOC_STATIC);__str133=Pointer_make([84,114,117,101,84,121,112,101,0],0,ALLOC_STATIC);__str537=Pointer_make([115,102,110,116,0],0,ALLOC_STATIC);_tt_driver_class=Pointer_make([1281,0,0,0,84,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,824,0,0,0,304,0,0,0,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_default_graphics_state=Pointer_make([0,0,0,0,0,0,16384,0,0,0,16384,
0,0,0,16384,0,0,0,0,0,1,0,0,0,64,0,0,0,1,0,0,0,1,0,0,0,68,0,0,0,0,0,0,0,0,0,0,0,9,0,3,0,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,0],0,ALLOC_STATIC);_trick_names_6890=Pointer_make([68,70,75,97,105,83,104,111,45,83,66,0,0,0,0,0,0,68,70,75,97,105,83,104,117,0,0,0,0,0,0,0,0,0,68,70,75,97,105,45,83,66,0,0,0,0,0,0,0,0,0,72,117,97,84,105,97,110,75,97,105,84,105,63,0,0,0,0,72,117,97,84,105,97,110,83,111,110,103,84,105,63,0,0,0,77,105,110,103,76,105,85,0,0,0,0,0,0,0,0,0,0,80,77,105,110,103,76,105,85,0,0,0,0,0,0,0,0,
0,77,105,110,103,76,105,52,51,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_sfnt_id_6968=Pointer_make([96268376,0,0,0,740,0,0,0,673397745,0,0,0,34756,0,0,0,-1555783190,0,0,0,481,0,0,0,96268376,0,0,0,740,0,0,0,673397745,0,0,0,34756,0,0,0,-1555783189,0,0,0,481,0,0,0,300280532,0,0,0,848,0,0,0,1513146939,0,0,0,36963,0,0,0,329524738,0,0,0,126,0,0,0,-262148,0,0,0,8,0,0,0,-1667348296,0,0,0,48802,0,0,0,1879179538,0,0,0,8,0,0,0,-262148,0,0,0,8,0,0,0,173671555,0,0,0,97337,0,0,0,1879179538,0,0,0,8,0,0,0],0,ALLOC_STATIC);
_Pop_Push_Count=Pointer_make([0,0,0,0,0,0,32,32,32,32,32,32,2,2,0,80,16,16,16,16,16,16,16,16,0,0,16,0,16,16,16,16,18,16,0,34,1,17,16,32,0,16,32,16,16,0,16,16,0,0,0,0,16,16,16,16,16,0,32,32,0,0,32,32,0,0,32,17,32,17,17,17,32,33,33,1,1,0,0,16,33,33,33,33,33,33,17,17,16,0,33,33,17,16,16,16,33,33,33,33,17,17,17,17,17,17,17,17,17,17,17,17,32,16,16,16,16,16,16,16,32,32,0,0,0,0,16,16,0,32,32,0,0,16,32,32,17,16,51,33,33,16,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,
8,1,2,3,4,5,6,7,8,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32],0,ALLOC_STATIC);_opcode_length=Pointer_make([1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,255,254,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,3,4,5,6,7,8,9,3,5,7,9,11,13,15,17,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],0,ALLOC_STATIC);_gvar_fields_11813=Pointer_make([4,0,20,0,17,4,0,0,12,2,4,0,12,2,6,0,16,4,8,0,12,2,12,0,12,2,14,0,16,4,16,0,0,0,0,0],0,ALLOC_STATIC);_fvar_fields_12035=Pointer_make([4,0,16,0,17,4,0,0,12,2,4,0,12,2,6,0,12,2,8,0,
12,2,10,0,12,2,12,0,12,2,14,0,0,0,0,0],0,ALLOC_STATIC);_fvaraxis_fields_12036=Pointer_make([4,0,20,0,16,4,0,0,16,4,4,0,16,4,8,0,16,4,12,0,12,2,16,0,12,2,18,0,0,0,0,0],0,ALLOC_STATIC);__str740=Pointer_make([87,101,105,103,104,116,0],0,ALLOC_STATIC);__str841=Pointer_make([87,105,100,116,104,0],0,ALLOC_STATIC);__str942=Pointer_make([79,112,116,105,99,97,108,83,105,122,101,0],0,ALLOC_STATIC);__str1043=Pointer_make([83,108,97,110,116,0],0,ALLOC_STATIC);__str44=Pointer_make([37,33,80,83,45,65,100,111,98,
101,70,111,110,116,0],0,ALLOC_STATIC);__str145=Pointer_make([37,33,70,111,110,116,84,121,112,101,0],0,ALLOC_STATIC);__str246=Pointer_make([101,101,120,101,99,0],0,ALLOC_STATIC);__str650=Pointer_make([46,110,111,116,100,101,102,0],0,ALLOC_STATIC);__str751=Pointer_make([83,116,97,110,100,97,114,100,69,110,99,111,100,105,110,103,0],0,ALLOC_STATIC);__str852=Pointer_make([69,120,112,101,114,116,69,110,99,111,100,105,110,103,0],0,ALLOC_STATIC);__str953=Pointer_make([73,83,79,76,97,116,105,110,49,69,110,
99,111,100,105,110,103,0],0,ALLOC_STATIC);__str1054=Pointer_make([100,117,112,0],0,ALLOC_STATIC);__str1155=Pointer_make([112,117,116,0],0,ALLOC_STATIC);_t1_keywords=Pointer_make([0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,4,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,12,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,16,
0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,2,0,0,0,0,0,0,0,20,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,0,0,0,0,24,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,2,0,0,0,0,0,0,0,26,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,2,0,0,0,0,0,0,0,28,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,
0,0,4,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,184,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,188,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,4,0,0,0,0,0,0,0,108,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,112,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,116,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,12,0,0,0,2,0,0,0,14,0,0,0,8,0,0,0,2,0,0,0,0,0,0,0,4,0,0,
0,8,0,0,0,0,0,0,0,40,0,0,0,2,0,0,0,10,0,0,0,9,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,60,0,0,0,2,0,0,0,14,0,0,0,10,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,88,0,0,0,2,0,0,0,10,0,0,0,11,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,120,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,122,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,192,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,128,0,0,0,2,0,0,0,12,0,0,0,124,0,0,0,
2,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,154,0,0,0,2,0,0,0,12,0,0,0,125,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,3,0,0,0,0,0,0,0,180,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,1,0,0,0,0,0,0,0,126,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,1,0,0,0,6,0,0,0,0,0,0,0,232,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,300,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,301,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,348,0,0,0,4,0,
0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,5,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,7,0,0,0,2,0,0,0,0,0,0,0,536,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,7,0,0,0,2,0,0,0,0,0,0,0,540,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,8,0,0,0,0,0,0,0,352,0,0,0,4,0,0,0,16,0,0,0,416,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,10,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0,10,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str1256=Pointer_make([118,101,114,115,105,111,110,0],0,ALLOC_STATIC);__str1357=Pointer_make([78,111,116,105,99,101,0],0,ALLOC_STATIC);__str1458=Pointer_make([70,117,108,108,78,97,109,101,0],0,ALLOC_STATIC);__str1559=Pointer_make([70,97,109,105,108,121,78,97,109,101,0],0,ALLOC_STATIC);__str1660=Pointer_make([73,116,97,108,105,99,65,110,103,108,101,0],0,ALLOC_STATIC);
__str1761=Pointer_make([105,115,70,105,120,101,100,80,105,116,99,104,0],0,ALLOC_STATIC);__str1862=Pointer_make([85,110,100,101,114,108,105,110,101,80,111,115,105,116,105,111,110,0],0,ALLOC_STATIC);__str1963=Pointer_make([85,110,100,101,114,108,105,110,101,84,104,105,99,107,110,101,115,115,0],0,ALLOC_STATIC);__str2064=Pointer_make([70,83,84,121,112,101,0],0,ALLOC_STATIC);__str2165=Pointer_make([85,110,105,113,117,101,73,68,0],0,ALLOC_STATIC);__str2266=Pointer_make([108,101,110,73,86,0],0,ALLOC_STATIC);
__str23=Pointer_make([76,97,110,103,117,97,103,101,71,114,111,117,112,0],0,ALLOC_STATIC);__str2467=Pointer_make([112,97,115,115,119,111,114,100,0],0,ALLOC_STATIC);__str2568=Pointer_make([66,108,117,101,83,99,97,108,101,0],0,ALLOC_STATIC);__str2669=Pointer_make([66,108,117,101,83,104,105,102,116,0],0,ALLOC_STATIC);__str2712=Pointer_make([66,108,117,101,70,117,122,122,0],0,ALLOC_STATIC);__str2870=Pointer_make([66,108,117,101,86,97,108,117,101,115,0],0,ALLOC_STATIC);__str2971=Pointer_make([79,116,104,
101,114,66,108,117,101,115,0],0,ALLOC_STATIC);__str3072=Pointer_make([70,97,109,105,108,121,66,108,117,101,115,0],0,ALLOC_STATIC);__str3173=Pointer_make([70,97,109,105,108,121,79,116,104,101,114,66,108,117,101,115,0],0,ALLOC_STATIC);__str3274=Pointer_make([83,116,100,72,87,0],0,ALLOC_STATIC);__str33=Pointer_make([83,116,100,86,87,0],0,ALLOC_STATIC);__str34=Pointer_make([77,105,110,70,101,97,116,117,114,101,0],0,ALLOC_STATIC);__str35=Pointer_make([83,116,101,109,83,110,97,112,72,0],0,ALLOC_STATIC);
__str36=Pointer_make([83,116,101,109,83,110,97,112,86,0],0,ALLOC_STATIC);__str37=Pointer_make([69,120,112,97,110,115,105,111,110,70,97,99,116,111,114,0],0,ALLOC_STATIC);__str3813=Pointer_make([70,111,114,99,101,66,111,108,100,0],0,ALLOC_STATIC);__str39=Pointer_make([70,111,110,116,78,97,109,101,0],0,ALLOC_STATIC);__str40=Pointer_make([80,97,105,110,116,84,121,112,101,0],0,ALLOC_STATIC);__str41=Pointer_make([70,111,110,116,84,121,112,101,0],0,ALLOC_STATIC);__str42=Pointer_make([83,116,114,111,107,
101,87,105,100,116,104,0],0,ALLOC_STATIC);__str43=Pointer_make([70,111,110,116,66,66,111,120,0],0,ALLOC_STATIC);__str4475=Pointer_make([78,68,86,0],0,ALLOC_STATIC);__str45=Pointer_make([67,68,86,0],0,ALLOC_STATIC);__str46=Pointer_make([68,101,115,105,103,110,86,101,99,116,111,114,0],0,ALLOC_STATIC);__str47=Pointer_make([70,111,110,116,77,97,116,114,105,120,0],0,ALLOC_STATIC);__str48=Pointer_make([69,110,99,111,100,105,110,103,0],0,ALLOC_STATIC);__str4914=Pointer_make([83,117,98,114,115,0],0,ALLOC_STATIC);
__str50=Pointer_make([67,104,97,114,83,116,114,105,110,103,115,0],0,ALLOC_STATIC);__str51=Pointer_make([80,114,105,118,97,116,101,0],0,ALLOC_STATIC);__str52=Pointer_make([66,108,101,110,100,68,101,115,105,103,110,80,111,115,105,116,105,111,110,115,0],0,ALLOC_STATIC);__str53=Pointer_make([66,108,101,110,100,68,101,115,105,103,110,77,97,112,0],0,ALLOC_STATIC);__str54=Pointer_make([66,108,101,110,100,65,120,105,115,84,121,112,101,115,0],0,ALLOC_STATIC);__str55=Pointer_make([87,101,105,103,104,116,86,
101,99,116,111,114,0],0,ALLOC_STATIC);__str56=Pointer_make([66,117,105,108,100,67,104,97,114,65,114,114,97,121,0],0,ALLOC_STATIC);__str57=Pointer_make([99,108,111,115,101,102,105,108,101,0],0,ALLOC_STATIC);__str58=Pointer_make([70,111,110,116,68,105,114,101,99,116,111,114,121,0],0,ALLOC_STATIC);__str59=Pointer_make([112,115,104,105,110,116,101,114,0],0,ALLOC_STATIC);__str60=Pointer_make([112,111,115,116,115,99,114,105,112,116,45,99,109,97,112,115,0],0,ALLOC_STATIC);__str61=Pointer_make([112,115,97,
117,120,0],0,ALLOC_STATIC);__str62=Pointer_make([82,101,103,117,108,97,114,0],0,ALLOC_STATIC);__str63=Pointer_make([66,111,108,100,0],0,ALLOC_STATIC);__str64=Pointer_make([66,108,97,99,107,0],0,ALLOC_STATIC);_t1_service_glyph_dict=Pointer_make([0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t1_service_ps_name=Pointer_make([0,0,0,0],0,ALLOC_STATIC);_t1_service_multi_masters=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t1_service_ps_info=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
0,ALLOC_STATIC);_t1_service_kerning=Pointer_make([0,0,0,0],0,ALLOC_STATIC);_t1_services=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str68=Pointer_make([84,121,112,101,32,49,0],0,ALLOC_STATIC);_t1_driver_class=Pointer_make([1281,0,0,0,40,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,556,0,0,0,44,0,0,0,180,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_cff_service_glyph_dict=Pointer_make([0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_cff_service_ps_info=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_cff_service_ps_name=Pointer_make([0,0,0,0],0,ALLOC_STATIC);_cff_cmap_encoding_class_rec=Pointer_make([20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_cff_cmap_unicode_class_rec=Pointer_make([24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_cff_service_get_cmap_info=Pointer_make([0,0,0,0],0,ALLOC_STATIC);_cff_service_cid_info=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_cff_services=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str481=Pointer_make([67,70,70,0],0,ALLOC_STATIC);_cff_driver_class=Pointer_make([1281,0,0,0,44,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,824,0,0,0,48,0,0,0,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_power_tens=Pointer_make([1,0,0,0,10,0,0,0,100,0,0,0,1E3,0,0,0,1E4,0,0,0,1E5,0,0,0,1E6,0,0,0,1E7,0,0,0,1E8,0,0,0,1E9,0,0,0],0,ALLOC_STATIC);_cff_field_handlers=Pointer_make([4,0,0,0,4096,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,4097,0,0,0,4,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,4352,0,0,0,8,0,0,
0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,4098,0,0,0,12,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,4099,0,0,0,16,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,4100,0,0,0,20,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,4353,0,0,0,24,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,4354,0,0,0,28,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,4355,0,0,0,32,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,4356,0,0,0,36,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4357,0,0,0,40,0,0,0,4,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,1,0,0,0,4358,0,0,0,44,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,4359,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4109,0,0,0,76,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,4101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4360,0,0,0,96,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4111,0,0,0,100,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4112,0,0,0,104,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4113,0,0,0,108,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,
4114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4372,0,0,0,120,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,4373,0,0,0,124,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,4382,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4383,0,0,0,140,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4384,0,0,0,144,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4385,0,0,0,148,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4386,0,0,0,152,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4387,0,0,0,156,0,
0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4388,0,0,0,160,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4389,0,0,0,164,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,4390,0,0,0,168,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,8198,0,0,0,4,0,0,0,4,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,6,0,0,0,8199,0,0,0,60,0,0,0,4,0,0,0,0,0,0,0,10,0,0,0,1,0,0,0,6,0,0,0,8200,0,0,0,100,0,0,0,4,0,0,0,0,0,0,0,14,0,0,0,2,0,0,0,6,0,0,0,8201,0,0,0,156,0,0,0,4,0,0,0,0,0,0,0,10,0,0,0,3,0,0,0,3,0,0,0,8457,0,0,0,196,0,0,0,4,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,8458,0,0,0,200,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,8459,0,0,0,204,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,8202,0,0,0,208,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,8203,0,0,0,212,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,8460,0,0,0,220,0,0,0,4,0,0,0,0,0,0,0,13,0,0,0,216,0,0,0,6,0,0,0,8461,0,0,0,272,0,0,0,4,0,0,0,0,0,0,0,13,0,0,0,217,0,0,0,5,0,0,0,8462,0,0,0,324,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,8463,0,0,0,328,0,0,0,4,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,1,0,0,0,8464,0,0,0,332,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,8465,0,0,0,336,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,8466,0,0,0,340,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,8467,0,0,0,344,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,8211,0,0,0,348,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,8212,0,0,0,352,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,8213,0,0,0,356,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,
ALLOC_STATIC);_cff_isoadobe_charset=Pointer_make([0,0,1,0,2,0,3,0,4,0,5,0,6,0,7,0,8,0,9,0,10,0,11,0,12,0,13,0,14,0,15,0,16,0,17,0,18,0,19,0,20,0,21,0,22,0,23,0,24,0,25,0,26,0,27,0,28,0,29,0,30,0,31,0,32,0,33,0,34,0,35,0,36,0,37,0,38,0,39,0,40,0,41,0,42,0,43,0,44,0,45,0,46,0,47,0,48,0,49,0,50,0,51,0,52,0,53,0,54,0,55,0,56,0,57,0,58,0,59,0,60,0,61,0,62,0,63,0,64,0,65,0,66,0,67,0,68,0,69,0,70,0,71,0,72,0,73,0,74,0,75,0,76,0,77,0,78,0,79,0,80,0,81,0,82,0,83,0,84,0,85,0,86,0,87,0,88,0,89,0,90,0,91,0,92,
0,93,0,94,0,95,0,96,0,97,0,98,0,99,0,100,0,101,0,102,0,103,0,104,0,105,0,106,0,107,0,108,0,109,0,110,0,111,0,112,0,113,0,114,0,115,0,116,0,117,0,118,0,119,0,120,0,121,0,122,0,123,0,124,0,125,0,126,0,127,0,128,0,129,0,130,0,131,0,132,0,133,0,134,0,135,0,136,0,137,0,138,0,139,0,140,0,141,0,142,0,143,0,144,0,145,0,146,0,147,0,148,0,149,0,150,0,151,0,152,0,153,0,154,0,155,0,156,0,157,0,158,0,159,0,160,0,161,0,162,0,163,0,164,0,165,0,166,0,167,0,168,0,169,0,170,0,171,0,172,0,173,0,174,0,175,0,176,0,177,
0,178,0,179,0,180,0,181,0,182,0,183,0,184,0,185,0,186,0,187,0,188,0,189,0,190,0,191,0,192,0,193,0,194,0,195,0,196,0,197,0,198,0,199,0,200,0,201,0,202,0,203,0,204,0,205,0,206,0,207,0,208,0,209,0,210,0,211,0,212,0,213,0,214,0,215,0,216,0,217,0,218,0,219,0,220,0,221,0,222,0,223,0,224,0,225,0,226,0,227,0,228,0],0,ALLOC_STATIC);_cff_expert_charset=Pointer_make([0,0,1,0,229,0,230,0,231,0,232,0,233,0,234,0,235,0,236,0,237,0,238,0,13,0,14,0,15,0,99,0,239,0,240,0,241,0,242,0,243,0,244,0,245,0,246,0,247,0,
248,0,27,0,28,0,249,0,250,0,251,0,252,0,253,0,254,0,255,0,256,0,257,0,258,0,259,0,260,0,261,0,262,0,263,0,264,0,265,0,266,0,109,0,110,0,267,0,268,0,269,0,270,0,271,0,272,0,273,0,274,0,275,0,276,0,277,0,278,0,279,0,280,0,281,0,282,0,283,0,284,0,285,0,286,0,287,0,288,0,289,0,290,0,291,0,292,0,293,0,294,0,295,0,296,0,297,0,298,0,299,0,300,0,301,0,302,0,303,0,304,0,305,0,306,0,307,0,308,0,309,0,310,0,311,0,312,0,313,0,314,0,315,0,316,0,317,0,318,0,158,0,155,0,163,0,319,0,320,0,321,0,322,0,323,0,324,0,
325,0,326,0,150,0,164,0,169,0,327,0,328,0,329,0,330,0,331,0,332,0,333,0,334,0,335,0,336,0,337,0,338,0,339,0,340,0,341,0,342,0,343,0,344,0,345,0,346,0,347,0,348,0,349,0,350,0,351,0,352,0,353,0,354,0,355,0,356,0,357,0,358,0,359,0,360,0,361,0,362,0,363,0,364,0,365,0,366,0,367,0,368,0,369,0,370,0,371,0,372,0,373,0,374,0,375,0,376,0,377,0,378,0],0,ALLOC_STATIC);_cff_expertsubset_charset=Pointer_make([0,0,1,0,231,0,232,0,235,0,236,0,237,0,238,0,13,0,14,0,15,0,99,0,239,0,240,0,241,0,242,0,243,0,244,0,245,
0,246,0,247,0,248,0,27,0,28,0,249,0,250,0,251,0,253,0,254,0,255,0,256,0,257,0,258,0,259,0,260,0,261,0,262,0,263,0,264,0,265,0,266,0,109,0,110,0,267,0,268,0,269,0,270,0,272,0,300,0,301,0,302,0,305,0,314,0,315,0,158,0,155,0,163,0,320,0,321,0,322,0,323,0,324,0,325,0,326,0,150,0,164,0,169,0,327,0,328,0,329,0,330,0,331,0,332,0,333,0,334,0,335,0,336,0,337,0,338,0,339,0,340,0,341,0,342,0,343,0,344,0,345,0,346,0],0,ALLOC_STATIC);_cff_standard_encoding=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,2,0,3,0,4,0,5,0,6,0,7,0,8,0,9,0,10,0,11,0,12,0,13,0,14,0,15,0,16,0,17,0,18,0,19,0,20,0,21,0,22,0,23,0,24,0,25,0,26,0,27,0,28,0,29,0,30,0,31,0,32,0,33,0,34,0,35,0,36,0,37,0,38,0,39,0,40,0,41,0,42,0,43,0,44,0,45,0,46,0,47,0,48,0,49,0,50,0,51,0,52,0,53,0,54,0,55,0,56,0,57,0,58,0,59,0,60,0,61,0,62,0,63,0,64,0,65,0,66,0,67,0,68,0,69,0,70,0,71,0,72,0,73,0,74,0,75,0,76,0,77,0,78,0,79,0,80,0,81,0,82,0,83,0,84,0,85,
0,86,0,87,0,88,0,89,0,90,0,91,0,92,0,93,0,94,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,97,0,98,0,99,0,100,0,101,0,102,0,103,0,104,0,105,0,106,0,107,0,108,0,109,0,110,0,0,0,111,0,112,0,113,0,114,0,0,0,115,0,116,0,117,0,118,0,119,0,120,0,121,0,122,0,0,0,123,0,0,0,124,0,125,0,126,0,127,0,128,0,129,0,130,0,131,0,0,0,132,0,133,0,0,0,134,0,135,0,136,0,137,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,138,0,0,0,139,0,0,0,0,0,0,0,0,0,140,0,141,0,142,0,143,0,0,0,0,0,0,0,0,0,0,0,144,0,0,0,0,0,0,0,145,0,0,0,0,0,146,0,147,0,148,0,149,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_cff_expert_encoding=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,229,0,230,0,0,0,231,0,232,0,233,0,234,0,235,0,236,0,237,0,238,0,13,0,14,0,15,0,99,0,239,0,240,0,241,0,242,0,243,0,244,0,245,0,246,0,247,0,248,0,27,
0,28,0,249,0,250,0,251,0,252,0,0,0,253,0,254,0,255,0,256,0,257,0,0,0,0,0,0,0,258,0,0,0,0,0,259,0,260,0,261,0,262,0,0,0,0,0,263,0,264,0,265,0,0,0,266,0,109,0,110,0,267,0,268,0,269,0,0,0,270,0,271,0,272,0,273,0,274,0,275,0,276,0,277,0,278,0,279,0,280,0,281,0,282,0,283,0,284,0,285,0,286,0,287,0,288,0,289,0,290,0,291,0,292,0,293,0,294,0,295,0,296,0,297,0,298,0,299,0,300,0,301,0,302,0,303,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,304,0,305,0,306,0,0,0,0,0,307,0,308,0,309,0,310,0,311,0,0,0,312,0,0,0,0,0,312,0,0,0,0,0,314,0,315,0,0,0,0,0,316,0,317,0,318,0,0,0,0,0,0,0,158,0,155,0,163,0,319,0,320,0,321,0,322,0,323,0,324,0,325,0,0,0,0,0,326,0,150,0,164,0,169,0,327,0,328,0,329,0,330,0,331,0,332,0,333,0,334,0,335,0,336,0,337,0,338,0,339,0,340,0,341,0,342,0,343,0,344,0,345,0,346,0,347,0,348,0,349,0,350,0,351,0,352,0,353,0,354,0,355,0,356,0,357,0,358,0,359,0,360,0,361,0,362,0,363,0,364,0,365,0,366,0,367,0,368,
0,369,0,370,0,371,0,372,0,373,0,374,0,375,0,376,0,377,0,378,0],0,ALLOC_STATIC);_cff_header_fields_6394=Pointer_make([4,0,4,0,8,1,16,0,8,1,17,0,8,1,18,0,8,1,19,0,0,0,0,0],0,ALLOC_STATIC);_cff_argument_counts=Pointer_make([0,194,193,193,32,32,32,32,32,32,32,32,32,32,13,7,9,11,128,130,130,130,130,128,128,0,1,2,2,2,1,0,2,1,1,1,2,1,2,1,2,1,4,3,2,2,1,2,4,1,1,0,2,0,0,0,5,4,2],0,ALLOC_STATIC);__str93=Pointer_make([37,33,80,83,45,65,100,111,98,101,45,51,46,48,32,82,101,115,111,117,114,99,101,45,67,73,68,70,
111,110,116,0],0,ALLOC_STATIC);__str194=Pointer_make([83,116,97,114,116,68,97,116,97,0],0,ALLOC_STATIC);__str295=Pointer_make([47,115,102,110,116,115,0],0,ALLOC_STATIC);__str396=Pointer_make([40,72,101,120,41,0],0,ALLOC_STATIC);_cid_field_records=Pointer_make([0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,4,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,
0,0,0,0,12,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,16,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,20,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,72,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,144,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,148,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,152,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,2,0,0,0,0,0,0,0,156,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,4,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,12,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,16,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,2,0,0,0,0,0,0,0,20,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,3,0,0,0,1,0,0,0,0,0,0,0,24,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,2,0,0,0,0,0,0,0,26,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,2,0,0,0,0,0,0,0,28,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,212,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,213,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,244,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,248,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,240,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,196,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,200,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,204,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,4,0,0,0,4,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,184,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,188,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,4,0,0,0,0,0,0,0,108,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,112,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,116,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,12,0,0,0,2,0,0,0,14,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,40,0,
0,0,2,0,0,0,10,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,60,0,0,0,2,0,0,0,14,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,88,0,0,0,2,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,120,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,122,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,192,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,8,0,0,0,0,0,0,0,128,0,0,0,2,0,0,0,12,0,0,0,124,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,
8,0,0,0,0,0,0,0,154,0,0,0,2,0,0,0,12,0,0,0,125,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,1,0,0,0,0,0,0,0,126,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,
ALLOC_STATIC);__str497=Pointer_make([67,73,68,70,111,110,116,78,97,109,101,0],0,ALLOC_STATIC);__str598=Pointer_make([67,73,68,70,111,110,116,86,101,114,115,105,111,110,0],0,ALLOC_STATIC);__str699=Pointer_make([67,73,68,70,111,110,116,84,121,112,101,0],0,ALLOC_STATIC);__str7100=Pointer_make([82,101,103,105,115,116,114,121,0],0,ALLOC_STATIC);__str8101=Pointer_make([79,114,100,101,114,105,110,103,0],0,ALLOC_STATIC);__str9102=Pointer_make([83,117,112,112,108,101,109,101,110,116,0],0,ALLOC_STATIC);__str10103=
Pointer_make([85,73,68,66,97,115,101,0],0,ALLOC_STATIC);__str11104=Pointer_make([67,73,68,77,97,112,79,102,102,115,101,116,0],0,ALLOC_STATIC);__str12105=Pointer_make([70,68,66,121,116,101,115,0],0,ALLOC_STATIC);__str13106=Pointer_make([71,68,66,121,116,101,115,0],0,ALLOC_STATIC);__str14107=Pointer_make([67,73,68,67,111,117,110,116,0],0,ALLOC_STATIC);__str27120=Pointer_make([83,117,98,114,77,97,112,79,102,102,115,101,116,0],0,ALLOC_STATIC);__str28121=Pointer_make([83,68,66,121,116,101,115,0],0,ALLOC_STATIC);
__str29122=Pointer_make([83,117,98,114,67,111,117,110,116,0],0,ALLOC_STATIC);__str30123=Pointer_make([108,101,110,66,117,105,108,100,67,104,97,114,65,114,114,97,121,0],0,ALLOC_STATIC);__str31124=Pointer_make([70,111,114,99,101,66,111,108,100,84,104,114,101,115,104,111,108,100,0],0,ALLOC_STATIC);__str51144=Pointer_make([70,68,65,114,114,97,121,0],0,ALLOC_STATIC);__str54147=Pointer_make([37,65,68,79,66,101,103,105,110,70,111,110,116,68,105,99,116,0],0,ALLOC_STATIC);_cid_service_ps_name=Pointer_make([0,
0,0,0],0,ALLOC_STATIC);_cid_service_ps_info=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_cid_service_cid_info=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_cid_services=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str61154=Pointer_make([67,73,68,32,84,121,112,101,32,49,0],0,ALLOC_STATIC);_t1cid_driver_class=Pointer_make([1281,0,0,0,40,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,332,0,0,0,48,0,0,0,172,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str65159=Pointer_make([116,49,99,105,100,0],0,ALLOC_STATIC);_pfr_header_fields=Pointer_make([4,0,58,0,16,4,0,0,12,4,4,0,12,4,8,0,12,4,12,0,12,4,16,0,12,4,20,0,12,4,24,0,20,4,28,0,20,4,32,0,12,4,36,0,20,4,40,0,20,4,44,0,12,4,48,0,20,4,52,0,20,4,56,0,8,4,60,0,8,4,64,0,8,4,68,0,8,4,72,0,8,4,76,0,20,4,80,0,20,4,84,0,20,4,88,0,12,4,92,0,8,4,
96,0,8,4,100,0,12,4,104,0,0,0,0,0],0,ALLOC_STATIC);_pfr_phy_font_extra_items=Pointer_make([1,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_pfr_cmap_class_rec=Pointer_make([24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_pfr_metrics_service_rec=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_pfr_services=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str2166=
Pointer_make([80,70,82,0],0,ALLOC_STATIC);_pfr_driver_class=Pointer_make([257,0,0,0,40,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,440,0,0,0,44,0,0,0,196,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str3168=Pointer_make([112,102,114,0],0,ALLOC_STATIC);_t42_keywords=Pointer_make([0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,
0,4,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,12,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,5,0,0,0,0,0,0,0,16,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,2,0,0,0,0,0,0,0,20,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,0,0,0,0,24,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,2,0,0,0,0,0,0,0,26,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,2,0,0,
0,0,0,0,0,28,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,6,0,0,0,0,0,0,0,232,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,300,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,301,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,348,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str23192=Pointer_make([115,102,110,116,115,0],0,ALLOC_STATIC);__str24193=Pointer_make([37,33,80,83,45,84,114,117,101,84,121,112,
101,70,111,110,116,0],0,ALLOC_STATIC);__str29198=Pointer_make([107,110,111,119,110,0],0,ALLOC_STATIC);_t42_service_glyph_dict=Pointer_make([0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t42_service_ps_font_name=Pointer_make([0,0,0,0],0,ALLOC_STATIC);_t42_service_ps_info=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t42_services=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str34203=Pointer_make([84,121,112,101,32,52,50,0],0,
ALLOC_STATIC);_t42_driver_class=Pointer_make([1281,0,0,0,48,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,560,0,0,0,48,0,0,0,164,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_winmz_header_fields=Pointer_make([4,0,64,0,14,2,0,0,25,58,0,0,18,2,2,0,0,0,0,0],0,ALLOC_STATIC);_winne_header_fields=Pointer_make([4,0,40,0,14,2,0,0,25,34,0,0,14,2,2,0,14,2,4,0,0,0,0,0],0,ALLOC_STATIC);_winpe32_header_fields=
Pointer_make([4,0,248,0,18,4,0,0,14,2,4,0,14,2,6,0,25,12,0,0,14,2,8,0,25,2,0,0,14,2,10,0,25,110,0,0,18,4,12,0,18,4,16,0,25,104,0,0,0,0,0,0],0,ALLOC_STATIC);_winpe32_section_fields=Pointer_make([4,0,40,0,24,8,0,0,25,4,0,0,18,4,8,0,18,4,12,0,18,4,16,0,25,16,0,0,0,0,0,0],0,ALLOC_STATIC);_winpe_rsrc_dir_fields=Pointer_make([4,0,16,0,18,4,0,0,18,4,4,0,14,2,8,0,14,2,10,0,14,2,12,0,14,2,14,0,0,0,0,0],0,ALLOC_STATIC);_winpe_rsrc_dir_entry_fields=Pointer_make([4,0,8,0,18,4,0,0,18,4,4,0,0,0,0,0],0,ALLOC_STATIC);
_winpe_rsrc_data_entry_fields=Pointer_make([4,0,16,0,18,4,0,0,18,4,4,0,18,4,8,0,18,4,12,0,0,0,0,0],0,ALLOC_STATIC);_winfnt_header_fields=Pointer_make([4,0,148,0,14,2,0,0,18,4,4,0,24,60,8,0,14,2,68,0,14,2,70,0,14,2,72,0,14,2,74,0,14,2,76,0,14,2,78,0,14,2,80,0,8,1,82,0,8,1,83,0,8,1,84,0,14,2,86,0,8,1,88,0,14,2,90,0,14,2,92,0,8,1,94,0,14,2,96,0,14,2,98,0,8,1,100,0,8,1,101,0,8,1,102,0,8,1,103,0,14,2,104,0,18,4,108,0,18,4,112,0,18,4,116,0,18,4,120,0,8,1,124,0,18,4,128,0,14,2,132,0,14,2,134,0,14,2,136,
0,18,2,138,0,24,16,140,0,0,0,0,0],0,ALLOC_STATIC);_fnt_cmap_class_rec=Pointer_make([24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str1207=Pointer_make([66,111,108,100,32,73,116,97,108,105,99,0],0,ALLOC_STATIC);__str3209=Pointer_make([73,116,97,108,105,99,0],0,ALLOC_STATIC);_winfnt_service_rec=Pointer_make([0,0,0,0],0,ALLOC_STATIC);_winfnt_services=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str5211=Pointer_make([87,
105,110,100,111,119,115,32,70,78,84,0],0,ALLOC_STATIC);_winfnt_driver_class=Pointer_make([513,0,0,0,40,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,0,0,0,44,0,0,0,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_pcf_metric_header=Pointer_make([4,0,12,0,15,2,0,0,15,2,2,0,15,2,4,0,15,2,6,0,15,2,8,0,15,2,10,0,0,0,0,0],0,ALLOC_STATIC);_pcf_metric_msb_header=Pointer_make([4,0,12,0,13,
2,0,0,13,2,2,0,13,2,4,0,13,2,6,0,13,2,8,0,13,2,10,0,0,0,0,0],0,ALLOC_STATIC);_pcf_compressed_metric_header=Pointer_make([4,0,5,0,8,1,0,0,8,1,1,0,8,1,2,0,8,1,3,0,8,1,4,0,0,0,0,0],0,ALLOC_STATIC);_pcf_property_header=Pointer_make([4,0,9,0,19,4,0,0,8,1,4,0,19,4,8,0,0,0,0,0],0,ALLOC_STATIC);_pcf_property_msb_header=Pointer_make([4,0,9,0,17,4,0,0,8,1,4,0,17,4,8,0,0,0,0,0],0,ALLOC_STATIC);_pcf_accel_header=Pointer_make([4,0,20,0,8,1,0,0,8,1,1,0,8,1,2,0,8,1,3,0,8,1,4,0,8,1,5,0,8,1,6,0,25,1,0,0,19,4,8,0,
19,4,12,0,19,4,16,0,0,0,0,0],0,ALLOC_STATIC);_pcf_accel_msb_header=Pointer_make([4,0,20,0,8,1,0,0,8,1,1,0,8,1,2,0,8,1,3,0,8,1,4,0,8,1,5,0,8,1,6,0,25,1,0,0,17,4,8,0,17,4,12,0,17,4,16,0,0,0,0,0],0,ALLOC_STATIC);__str214=Pointer_make([83,76,65,78,84,0],0,ALLOC_STATIC);__str1215=Pointer_make([79,98,108,105,113,117,101,0],0,ALLOC_STATIC);__str3217=Pointer_make([87,69,73,71,72,84,95,78,65,77,69,0],0,ALLOC_STATIC);__str5219=Pointer_make([83,69,84,87,73,68,84,72,95,78,65,77,69,0],0,ALLOC_STATIC);__str6220=
Pointer_make([65,68,68,95,83,84,89,76,69,95,78,65,77,69,0],0,ALLOC_STATIC);__str8222=Pointer_make([70,65,77,73,76,89,95,78,65,77,69,0],0,ALLOC_STATIC);__str9223=Pointer_make([65,86,69,82,65,71,69,95,87,73,68,84,72,0],0,ALLOC_STATIC);__str10224=Pointer_make([80,79,73,78,84,95,83,73,90,69,0],0,ALLOC_STATIC);__str11225=Pointer_make([80,73,88,69,76,95,83,73,90,69,0],0,ALLOC_STATIC);__str12226=Pointer_make([82,69,83,79,76,85,84,73,79,78,95,88,0],0,ALLOC_STATIC);__str13227=Pointer_make([82,69,83,79,76,
85,84,73,79,78,95,89,0],0,ALLOC_STATIC);__str14228=Pointer_make([67,72,65,82,83,69,84,95,82,69,71,73,83,84,82,89,0],0,ALLOC_STATIC);__str15229=Pointer_make([67,72,65,82,83,69,84,95,69,78,67,79,68,73,78,71,0],0,ALLOC_STATIC);_pcf_cmap_class=Pointer_make([24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str16230=Pointer_make([49,48,54,52,54,0],0,ALLOC_STATIC);__str17231=Pointer_make([56,56,53,57,0],0,ALLOC_STATIC);__str18232=Pointer_make([49,0],0,ALLOC_STATIC);
_pcf_service_bdf=Pointer_make([0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_pcf_services=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str21235=Pointer_make([80,67,70,0],0,ALLOC_STATIC);_pcf_driver_class=Pointer_make([513,0,0,0,40,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,328,0,0,0,44,0,0,0,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str22237=Pointer_make([112,
99,102,0],0,ALLOC_STATIC);__bdf_opts=Pointer_make([1,0,0,0,1,0,0,0,0,0,0,0,8,0,0,0],0,ALLOC_STATIC);__bdf_properties=Pointer_make([0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,
1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,
0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,
0,0,0,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,
0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str2240=Pointer_make([65,86,71,95,67,65,80,73,84,65,76,95,87,73,68,84,72,0],0,ALLOC_STATIC);__str3241=Pointer_make([65,86,71,95,76,79,87,69,82,67,65,83,69,95,87,73,68,84,72,0],0,ALLOC_STATIC);__str4242=Pointer_make([67,
65,80,95,72,69,73,71,72,84,0],0,ALLOC_STATIC);__str5243=Pointer_make([67,72,65,82,83,69,84,95,67,79,76,76,69,67,84,73,79,78,83,0],0,ALLOC_STATIC);__str8246=Pointer_make([67,79,77,77,69,78,84,0],0,ALLOC_STATIC);__str9247=Pointer_make([67,79,80,89,82,73,71,72,84,0],0,ALLOC_STATIC);__str10248=Pointer_make([68,69,70,65,85,76,84,95,67,72,65,82,0],0,ALLOC_STATIC);__str11249=Pointer_make([68,69,83,84,73,78,65,84,73,79,78,0],0,ALLOC_STATIC);__str12250=Pointer_make([68,69,86,73,67,69,95,70,79,78,84,95,78,
65,77,69,0],0,ALLOC_STATIC);__str13251=Pointer_make([69,78,68,95,83,80,65,67,69,0],0,ALLOC_STATIC);__str14252=Pointer_make([70,65,67,69,95,78,65,77,69,0],0,ALLOC_STATIC);__str16254=Pointer_make([70,73,71,85,82,69,95,87,73,68,84,72,0],0,ALLOC_STATIC);__str17255=Pointer_make([70,79,78,84,0],0,ALLOC_STATIC);__str18256=Pointer_make([70,79,78,84,78,65,77,69,95,82,69,71,73,83,84,82,89,0],0,ALLOC_STATIC);__str19257=Pointer_make([70,79,78,84,95,65,83,67,69,78,84,0],0,ALLOC_STATIC);__str20258=Pointer_make([70,
79,78,84,95,68,69,83,67,69,78,84,0],0,ALLOC_STATIC);__str21259=Pointer_make([70,79,85,78,68,82,89,0],0,ALLOC_STATIC);__str22260=Pointer_make([70,85,76,76,95,78,65,77,69,0],0,ALLOC_STATIC);__str23261=Pointer_make([73,84,65,76,73,67,95,65,78,71,76,69,0],0,ALLOC_STATIC);__str24262=Pointer_make([77,65,88,95,83,80,65,67,69,0],0,ALLOC_STATIC);__str25263=Pointer_make([77,73,78,95,83,80,65,67,69,0],0,ALLOC_STATIC);__str26264=Pointer_make([78,79,82,77,95,83,80,65,67,69,0],0,ALLOC_STATIC);__str27265=Pointer_make([78,
79,84,73,67,69,0],0,ALLOC_STATIC);__str30268=Pointer_make([81,85,65,68,95,87,73,68,84,72,0],0,ALLOC_STATIC);__str31269=Pointer_make([82,65,87,95,65,83,67,69,78,84,0],0,ALLOC_STATIC);__str32270=Pointer_make([82,65,87,95,65,86,69,82,65,71,69,95,87,73,68,84,72,0],0,ALLOC_STATIC);__str33271=Pointer_make([82,65,87,95,65,86,71,95,67,65,80,73,84,65,76,95,87,73,68,84,72,0],0,ALLOC_STATIC);__str34272=Pointer_make([82,65,87,95,65,86,71,95,76,79,87,69,82,67,65,83,69,95,87,73,68,84,72,0],0,ALLOC_STATIC);__str35273=
Pointer_make([82,65,87,95,67,65,80,95,72,69,73,71,72,84,0],0,ALLOC_STATIC);__str36274=Pointer_make([82,65,87,95,68,69,83,67,69,78,84,0],0,ALLOC_STATIC);__str37275=Pointer_make([82,65,87,95,69,78,68,95,83,80,65,67,69,0],0,ALLOC_STATIC);__str38276=Pointer_make([82,65,87,95,70,73,71,85,82,69,95,87,73,68,84,72,0],0,ALLOC_STATIC);__str39277=Pointer_make([82,65,87,95,77,65,88,95,83,80,65,67,69,0],0,ALLOC_STATIC);__str40278=Pointer_make([82,65,87,95,77,73,78,95,83,80,65,67,69,0],0,ALLOC_STATIC);__str41279=
Pointer_make([82,65,87,95,78,79,82,77,95,83,80,65,67,69,0],0,ALLOC_STATIC);__str42280=Pointer_make([82,65,87,95,80,73,88,69,76,95,83,73,90,69,0],0,ALLOC_STATIC);__str43281=Pointer_make([82,65,87,95,80,79,73,78,84,95,83,73,90,69,0],0,ALLOC_STATIC);__str44282=Pointer_make([82,65,87,95,80,73,88,69,76,83,73,90,69,0],0,ALLOC_STATIC);__str45283=Pointer_make([82,65,87,95,80,79,73,78,84,83,73,90,69,0],0,ALLOC_STATIC);__str46284=Pointer_make([82,65,87,95,81,85,65,68,95,87,73,68,84,72,0],0,ALLOC_STATIC);__str47285=
Pointer_make([82,65,87,95,83,77,65,76,76,95,67,65,80,95,83,73,90,69,0],0,ALLOC_STATIC);__str48286=Pointer_make([82,65,87,95,83,84,82,73,75,69,79,85,84,95,65,83,67,69,78,84,0],0,ALLOC_STATIC);__str49287=Pointer_make([82,65,87,95,83,84,82,73,75,69,79,85,84,95,68,69,83,67,69,78,84,0],0,ALLOC_STATIC);__str50288=Pointer_make([82,65,87,95,83,85,66,83,67,82,73,80,84,95,83,73,90,69,0],0,ALLOC_STATIC);__str51289=Pointer_make([82,65,87,95,83,85,66,83,67,82,73,80,84,95,88,0],0,ALLOC_STATIC);__str52290=Pointer_make([82,
65,87,95,83,85,66,83,67,82,73,80,84,95,89,0],0,ALLOC_STATIC);__str53291=Pointer_make([82,65,87,95,83,85,80,69,82,83,67,82,73,80,84,95,83,73,90,69,0],0,ALLOC_STATIC);__str54292=Pointer_make([82,65,87,95,83,85,80,69,82,83,67,82,73,80,84,95,88,0],0,ALLOC_STATIC);__str55293=Pointer_make([82,65,87,95,83,85,80,69,82,83,67,82,73,80,84,95,89,0],0,ALLOC_STATIC);__str56294=Pointer_make([82,65,87,95,85,78,68,69,82,76,73,78,69,95,80,79,83,73,84,73,79,78,0],0,ALLOC_STATIC);__str57295=Pointer_make([82,65,87,95,
85,78,68,69,82,76,73,78,69,95,84,72,73,67,75,78,69,83,83,0],0,ALLOC_STATIC);__str58296=Pointer_make([82,65,87,95,88,95,72,69,73,71,72,84,0],0,ALLOC_STATIC);__str59297=Pointer_make([82,69,76,65,84,73,86,69,95,83,69,84,87,73,68,84,72,0],0,ALLOC_STATIC);__str60298=Pointer_make([82,69,76,65,84,73,86,69,95,87,69,73,71,72,84,0],0,ALLOC_STATIC);__str61299=Pointer_make([82,69,83,79,76,85,84,73,79,78,0],0,ALLOC_STATIC);__str66304=Pointer_make([83,77,65,76,76,95,67,65,80,95,83,73,90,69,0],0,ALLOC_STATIC);__str67305=
Pointer_make([83,80,65,67,73,78,71,0],0,ALLOC_STATIC);__str68306=Pointer_make([83,84,82,73,75,69,79,85,84,95,65,83,67,69,78,84,0],0,ALLOC_STATIC);__str69307=Pointer_make([83,84,82,73,75,69,79,85,84,95,68,69,83,67,69,78,84,0],0,ALLOC_STATIC);__str70308=Pointer_make([83,85,66,83,67,82,73,80,84,95,83,73,90,69,0],0,ALLOC_STATIC);__str71309=Pointer_make([83,85,66,83,67,82,73,80,84,95,88,0],0,ALLOC_STATIC);__str72310=Pointer_make([83,85,66,83,67,82,73,80,84,95,89,0],0,ALLOC_STATIC);__str73=Pointer_make([83,
85,80,69,82,83,67,82,73,80,84,95,83,73,90,69,0],0,ALLOC_STATIC);__str74=Pointer_make([83,85,80,69,82,83,67,82,73,80,84,95,88,0],0,ALLOC_STATIC);__str75=Pointer_make([83,85,80,69,82,83,67,82,73,80,84,95,89,0],0,ALLOC_STATIC);__str76=Pointer_make([85,78,68,69,82,76,73,78,69,95,80,79,83,73,84,73,79,78,0],0,ALLOC_STATIC);__str77311=Pointer_make([85,78,68,69,82,76,73,78,69,95,84,72,73,67,75,78,69,83,83,0],0,ALLOC_STATIC);__str78=Pointer_make([87,69,73,71,72,84,0],0,ALLOC_STATIC);__str80=Pointer_make([88,
95,72,69,73,71,72,84,0],0,ALLOC_STATIC);__str81=Pointer_make([95,77,85,76,69,95,66,65,83,69,76,73,78,69,95,79,70,70,83,69,84,0],0,ALLOC_STATIC);__str82=Pointer_make([95,77,85,76,69,95,82,69,76,65,84,73,86,69,95,67,79,77,80,79,83,69,0],0,ALLOC_STATIC);_empty=Pointer_make([0],0,ALLOC_STATIC);_a2i=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,0,0,0,0,0,0,0,10,11,12,13,14,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,10,11,12,13,14,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_odigits=Pointer_make([0,0,0,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ddigits=Pointer_make([0,0,0,0,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_hdigits=Pointer_make([0,0,0,0,0,0,255,3,126,0,0,0,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str83=Pointer_make([45,0],0,ALLOC_STATIC);_nibble_mask=Pointer_make([255,128,192,224,
240,248,252,254],0,ALLOC_STATIC);__str84=Pointer_make([67,72,65,82,83,0],0,ALLOC_STATIC);__str85=Pointer_make([32,43,0],0,ALLOC_STATIC);__str86=Pointer_make([69,78,68,70,79,78,84,0],0,ALLOC_STATIC);__str87=Pointer_make([69,78,68,67,72,65,82,0],0,ALLOC_STATIC);__str88=Pointer_make([83,84,65,82,84,67,72,65,82,0],0,ALLOC_STATIC);__str89=Pointer_make([69,78,67,79,68,73,78,71,0],0,ALLOC_STATIC);__str90=Pointer_make([83,87,73,68,84,72,0],0,ALLOC_STATIC);__str91=Pointer_make([68,87,73,68,84,72,0],0,ALLOC_STATIC);
__str92=Pointer_make([66,66,88,0],0,ALLOC_STATIC);__str93312=Pointer_make([66,73,84,77,65,80,0],0,ALLOC_STATIC);__str94=Pointer_make([69,78,68,80,82,79,80,69,82,84,73,69,83,0],0,ALLOC_STATIC);__str95=Pointer_make([37,104,100,0],0,ALLOC_STATIC);__str96=Pointer_make([95,88,70,82,69,69,56,54,95,71,76,89,80,72,95,82,65,78,71,69,83,0],0,ALLOC_STATIC);__str97=Pointer_make([83,84,65,82,84,70,79,78,84,0],0,ALLOC_STATIC);__str98=Pointer_make([83,84,65,82,84,80,82,79,80,69,82,84,73,69,83,0],0,ALLOC_STATIC);
__str99=Pointer_make([70,79,78,84,66,79,85,78,68,73,78,71,66,79,88,0],0,ALLOC_STATIC);__str100=Pointer_make([83,73,90,69,0],0,ALLOC_STATIC);_bdf_cmap_class=Pointer_make([24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_bdf_service_bdf=Pointer_make([0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_bdf_services=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str110=Pointer_make([66,68,70,0],0,ALLOC_STATIC);_bdf_driver_class=Pointer_make([513,
0,0,0,40,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,0,0,0,44,0,0,0,160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_table_dir_entry_fields_3826=Pointer_make([4,0,16,0,16,4,0,0,16,4,4,0,16,4,8,0,16,4,12,0,0,0,0,0],0,ALLOC_STATIC);_offset_table_fields_3900=Pointer_make([4,0,8,0,12,2,4,0,12,2,6,0,12,2,8,0,12,2,10,0,0,0,0,0],0,ALLOC_STATIC);_header_fields_3996=Pointer_make([4,0,54,
0,16,4,0,0,16,4,4,0,17,4,8,0,17,4,12,0,12,2,16,0,12,2,18,0,17,4,20,0,17,4,24,0,17,4,28,0,17,4,32,0,13,2,36,0,13,2,38,0,13,2,40,0,13,2,42,0,12,2,44,0,12,2,46,0,13,2,48,0,13,2,50,0,13,2,52,0,0,0,0,0],0,ALLOC_STATIC);_maxp_fields_4025=Pointer_make([4,0,6,0,17,4,0,0,12,2,4,0,0,0,0,0],0,ALLOC_STATIC);_maxp_fields_extra_4026=Pointer_make([4,0,26,0,12,2,6,0,12,2,8,0,12,2,10,0,12,2,12,0,12,2,14,0,12,2,16,0,12,2,18,0,12,2,20,0,12,2,22,0,12,2,24,0,12,2,26,0,12,2,28,0,12,2,30,0,0,0,0,0],0,ALLOC_STATIC);_name_table_fields_4061=
Pointer_make([4,0,6,0,12,2,0,0,12,4,4,0,12,4,8,0,0,0,0,0],0,ALLOC_STATIC);_name_record_fields_4062=Pointer_make([12,2,0,0,12,2,2,0,12,2,4,0,12,2,6,0,12,2,8,0,12,4,12,0,0,0,0,0],0,ALLOC_STATIC);_os2_fields_4158=Pointer_make([4,0,78,0,12,2,0,0,13,2,2,0,12,2,4,0,12,2,6,0,13,2,8,0,13,2,10,0,13,2,12,0,13,2,14,0,13,2,16,0,13,2,18,0,13,2,20,0,13,2,22,0,13,2,24,0,13,2,26,0,13,2,28,0,13,2,30,0,8,1,32,0,8,1,33,0,8,1,34,0,8,1,35,0,8,1,36,0,8,1,37,0,8,1,38,0,8,1,39,0,8,1,40,0,8,1,41,0,16,4,44,0,16,4,48,0,16,
4,52,0,16,4,56,0,8,1,60,0,8,1,61,0,8,1,62,0,8,1,63,0,12,2,64,0,12,2,66,0,12,2,68,0,13,2,70,0,13,2,72,0,13,2,74,0,12,2,76,0,12,2,78,0,0,0,0,0],0,ALLOC_STATIC);_os2_fields_extra_4159=Pointer_make([4,0,8,0,16,4,80,0,16,4,84,0,0,0,0,0],0,ALLOC_STATIC);_os2_fields_extra2_4160=Pointer_make([4,0,10,0,13,2,88,0,13,2,90,0,12,2,92,0,12,2,94,0,12,2,96,0,0,0,0,0],0,ALLOC_STATIC);_post_fields_4185=Pointer_make([4,0,32,0,16,4,0,0,16,4,4,0,13,2,8,0,13,2,10,0,16,4,12,0,16,4,16,0,16,4,20,0,16,4,24,0,16,4,28,0,0,0,
0,0],0,ALLOC_STATIC);_pclt_fields_4199=Pointer_make([4,0,54,0,16,4,0,0,16,4,4,0,12,2,8,0,12,2,10,0,12,2,12,0,12,2,14,0,12,2,16,0,24,16,20,0,24,8,36,0,24,6,44,0,9,1,50,0,9,1,51,0,8,1,52,0,8,1,53,0,0,0,0,0],0,ALLOC_STATIC);_metrics_header_fields_4401=Pointer_make([4,0,36,0,16,4,0,0,13,2,4,0,13,2,6,0,13,2,8,0,12,2,10,0,13,2,12,0,13,2,14,0,13,2,16,0,13,2,18,0,13,2,20,0,13,2,22,0,13,2,24,0,13,2,26,0,13,2,28,0,13,2,30,0,13,2,32,0,12,2,34,0,0,0,0,0],0,ALLOC_STATIC);_tt_cmap0_class_rec=Pointer_make([24,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_cmap2_class_rec=Pointer_make([24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_cmap4_class_rec=Pointer_make([56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_cmap6_class_rec=Pointer_make([24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_cmap8_class_rec=Pointer_make([24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_cmap10_class_rec=Pointer_make([24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_cmap12_class_rec=Pointer_make([44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_cmap13_class_rec=Pointer_make([44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_cmap14_class_rec=Pointer_make([40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_cmap_classes=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_tt_encodings_9541=
Pointer_make([2,0,0,0,-1,0,0,0,1970170211,0,0,0,0,0,0,0,-1,0,0,0,1970170211,0,0,0,1,0,0,0,0,0,0,0,1634889070,0,0,0,3,0,0,0,0,0,0,0,1937337698,0,0,0,3,0,0,0,10,0,0,0,1970170211,0,0,0,3,0,0,0,1,0,0,0,1970170211,0,0,0,3,0,0,0,2,0,0,0,1936353651,0,0,0,3,0,0,0,3,0,0,0,1734484E3,0,0,0,3,0,0,0,4,0,0,0,1651074869,0,0,0,3,0,0,0,5,0,0,0,2002873971,0,0,0,3,0,0,0,6,0,0,0,1785686113,0,0,0],0,ALLOC_STATIC);_ttc_header_fields_9565=Pointer_make([4,0,8,0,17,4,4,0,17,4,8,0,0,0,0,0],0,ALLOC_STATIC);_sfnt_service_sfnt_table=
Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_sfnt_service_glyph_dict=Pointer_make([0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_sfnt_service_ps_name=Pointer_make([0,0,0,0],0,ALLOC_STATIC);_tt_service_get_cmap_info=Pointer_make([0,0,0,0],0,ALLOC_STATIC);_sfnt_service_bdf=Pointer_make([0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_sfnt_services=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_sfnt_interface=Pointer_make([0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_sfnt_module_class=Pointer_make([0,0,0,0,20,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_sbit_metrics_fields=Pointer_make([4,0,8,0,8,
1,0,0,8,1,1,0,9,1,2,0,9,1,3,0,8,1,4,0,9,1,5,0,9,1,6,0,8,1,7,0,0,0,0,0],0,ALLOC_STATIC);_strike_start_fields_10745=Pointer_make([16,4,8,0,17,0,0,0,16,4,0,0,16,4,12,0,0,0,0,0],0,ALLOC_STATIC);_sbit_line_metrics_fields_10744=Pointer_make([9,1,0,0,9,1,1,0,8,1,2,0,9,1,3,0,9,1,4,0,9,1,5,0,9,1,6,0,9,1,7,0,9,1,8,0,9,1,9,0,9,1,10,0,9,1,11,0,0,0,0,0],0,ALLOC_STATIC);_strike_end_fields_10746=Pointer_make([12,2,40,0,12,2,42,0,8,1,44,0,8,1,45,0,8,1,46,0,9,1,47,0,0,0,0,0],0,ALLOC_STATIC);_sbit_small_metrics_fields_11020=
Pointer_make([4,0,5,0,8,1,0,0,8,1,1,0,9,1,2,0,9,1,3,0,8,1,4,0,0,0,0,0],0,ALLOC_STATIC);_af_script_classes=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_af_dummy_script_class=Pointer_make([0,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_af_latin_script_class=Pointer_make([1,0,0,0,0,0,0,0,832,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_af_cjk_script_class=Pointer_make([2,0,0,0,0,0,0,0,832,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_af_indic_script_class=Pointer_make([3,0,0,0,0,0,0,0,832,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_af_latin_blue_chars=Pointer_make([84,72,69,90,79,67,81,83,0,0,0,0,0,72,69,90,76,79,67,85,83,0,0,0,0,0,102,105,106,107,100,98,104,0,0,0,0,0,0,120,122,114,111,101,115,99,0,0,0,0,0,0,120,122,114,111,101,115,99,0,0,0,0,0,0,112,113,103,106,121,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_latin_encodings_4600=Pointer_make([1970170211,0,0,0,1634889070,0,0,0,1094995778,
0,0,0,1818326065,0,0,0,0,0,0,0],0,ALLOC_STATIC);_af_latin_uniranges=Pointer_make([32,0,0,0,127,0,0,0,160,0,0,0,255,0,0,0,256,0,0,0,383,0,0,0,384,0,0,0,591,0,0,0,592,0,0,0,687,0,0,0,688,0,0,0,767,0,0,0,768,0,0,0,879,0,0,0,880,0,0,0,1023,0,0,0,1024,0,0,0,1279,0,0,0,1280,0,0,0,1327,0,0,0,7424,0,0,0,7551,0,0,0,7552,0,0,0,7615,0,0,0,7616,0,0,0,7679,0,0,0,7680,0,0,0,7935,0,0,0,7936,0,0,0,8191,0,0,0,8192,0,0,0,8303,0,0,0,8304,0,0,0,8351,0,0,0,8352,0,0,0,8399,0,0,0,8528,0,0,0,8591,0,0,0,9312,0,0,0,9471,0,
0,0,11360,0,0,0,11391,0,0,0,11744,0,0,0,11775,0,0,0,42560,0,0,0,42655,0,0,0,42784,0,0,0,43007,0,0,0,64256,0,0,0,64262,0,0,0,119808,0,0,0,120831,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_af_cjk_uniranges=Pointer_make([11904,0,0,0,12031,0,0,0,12032,0,0,0,12255,0,0,0,12288,0,0,0,12351,0,0,0,12352,0,0,0,12447,0,0,0,12448,0,0,0,12543,0,0,0,12544,0,0,0,12591,0,0,0,12592,0,0,0,12687,0,0,0,12704,0,0,0,12735,0,0,0,12736,0,0,0,12783,0,0,0,12784,0,0,0,12799,0,0,0,12800,0,0,0,13055,0,0,0,13056,0,0,0,13311,0,0,
0,13312,0,0,0,19903,0,0,0,19904,0,0,0,19967,0,0,0,19968,0,0,0,40959,0,0,0,63744,0,0,0,64255,0,0,0,65072,0,0,0,65103,0,0,0,65280,0,0,0,65519,0,0,0,131072,0,0,0,173791,0,0,0,194560,0,0,0,195103,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_af_indic_uniranges=Pointer_make([2304,0,0,0,3583,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_af_autofitter_service=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_autofit_module_class=Pointer_make([4,0,0,0,204,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str325=Pointer_make([97,117,116,111,102,105,116,116,101,114,0],0,ALLOC_STATIC);_pshinter_interface=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_pshinter_module_class=Pointer_make([0,0,0,0,176,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ft_standard_raster=Pointer_make([1869968492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ft_raster1_renderer_class=Pointer_make([2,0,0,0,72,0,0,0,0,
0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1869968492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ft_raster5_renderer_class=Pointer_make([2,0,0,0,72,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1869968492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str329=Pointer_make([114,97,115,116,101,114,49,0],0,ALLOC_STATIC);__str1330=Pointer_make([114,97,115,116,101,114,53,0],0,ALLOC_STATIC);_func_interface=Pointer_make([0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ft_grays_raster=Pointer_make([1869968492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ft_smooth_renderer_class=Pointer_make([2,0,0,0,72,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1869968492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str332=Pointer_make([115,109,111,111,116,104,0],0,ALLOC_STATIC);_ft_smooth_lcd_renderer_class=Pointer_make([2,0,0,0,72,0,0,0,0,0,0,0,65536,
0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1869968492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str1334=Pointer_make([115,109,111,111,116,104,45,108,99,100,0],0,ALLOC_STATIC);_ft_smooth_lcdv_renderer_class=Pointer_make([2,0,0,0,72,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1869968492,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str2336=Pointer_make([115,109,111,111,116,104,45,108,99,100,118,0],0,ALLOC_STATIC);_ftc_size_list_class=
Pointer_make([36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ftc_face_list_class=Pointer_make([16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ftc_cmap_cache_class=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ftc_basic_image_family_class=Pointer_make([48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ftc_basic_image_cache_class=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0],0,ALLOC_STATIC);_ftc_basic_sbit_family_class=Pointer_make([48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ftc_basic_sbit_cache_class=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str337=Pointer_make([49,46,50,46,51,46,52,0],0,ALLOC_STATIC);_ps_table_funcs=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_ps_parser_funcs=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t1_builder_funcs=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t1_decoder_funcs=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_afm_parser_funcs=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t1_cmap_classes=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t1_cmap_standard_class_rec=Pointer_make([32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t1_cmap_expert_class_rec=Pointer_make([32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t1_cmap_custom_class_rec=Pointer_make([28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t1_cmap_unicode_class_rec=Pointer_make([24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_psaux_interface=Pointer_make([0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_psaux_module_class=Pointer_make([0,0,0,0,20,0,0,0,0,0,0,0,131072,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_t1_args_count=Pointer_make([0,0,0,0,0,0,0,0,2,0,0,0,5,0,0,0,4,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,4,0,0,0,2,0,0,0,2,0,0,0,6,0,0,0,4,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,6,0,0,0,2,0,0,0,6,0,0,0,2,0,0,0,-1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0],0,ALLOC_STATIC);_afm_key_table=Pointer_make([0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str2343=Pointer_make([65,115,99,101,110,100,101,114,0],0,ALLOC_STATIC);__str3344=Pointer_make([65,120,105,115,76,97,98,101,108,0],0,ALLOC_STATIC);__str4345=Pointer_make([65,120,105,115,84,121,112,101,0],0,ALLOC_STATIC);__str5346=Pointer_make([66,0],0,ALLOC_STATIC);__str9350=Pointer_make([67,0],0,ALLOC_STATIC);__str10351=Pointer_make([67,67,0],0,ALLOC_STATIC);__str11352=Pointer_make([67,72,0],0,ALLOC_STATIC);
__str12353=Pointer_make([67,97,112,72,101,105,103,104,116,0],0,ALLOC_STATIC);__str13354=Pointer_make([67,104,97,114,87,105,100,116,104,0],0,ALLOC_STATIC);__str14355=Pointer_make([67,104,97,114,97,99,116,101,114,83,101,116,0],0,ALLOC_STATIC);__str15356=Pointer_make([67,104,97,114,97,99,116,101,114,115,0],0,ALLOC_STATIC);__str16357=Pointer_make([68,101,115,99,101,110,100,101,114,0],0,ALLOC_STATIC);__str17358=Pointer_make([69,110,99,111,100,105,110,103,83,99,104,101,109,101,0],0,ALLOC_STATIC);__str18359=
Pointer_make([69,110,100,65,120,105,115,0],0,ALLOC_STATIC);__str19360=Pointer_make([69,110,100,67,104,97,114,77,101,116,114,105,99,115,0],0,ALLOC_STATIC);__str20361=Pointer_make([69,110,100,67,111,109,112,111,115,105,116,101,115,0],0,ALLOC_STATIC);__str21362=Pointer_make([69,110,100,68,105,114,101,99,116,105,111,110,0],0,ALLOC_STATIC);__str22363=Pointer_make([69,110,100,70,111,110,116,77,101,116,114,105,99,115,0],0,ALLOC_STATIC);__str23364=Pointer_make([69,110,100,75,101,114,110,68,97,116,97,0],0,
ALLOC_STATIC);__str24365=Pointer_make([69,110,100,75,101,114,110,80,97,105,114,115,0],0,ALLOC_STATIC);__str25366=Pointer_make([69,110,100,84,114,97,99,107,75,101,114,110,0],0,ALLOC_STATIC);__str26367=Pointer_make([69,115,99,67,104,97,114,0],0,ALLOC_STATIC);__str31372=Pointer_make([73,115,66,97,115,101,70,111,110,116,0],0,ALLOC_STATIC);__str32373=Pointer_make([73,115,67,73,68,70,111,110,116,0],0,ALLOC_STATIC);__str33374=Pointer_make([73,115,70,105,120,101,100,80,105,116,99,104,0],0,ALLOC_STATIC);__str34375=
Pointer_make([73,115,70,105,120,101,100,86,0],0,ALLOC_STATIC);__str36377=Pointer_make([75,80,0],0,ALLOC_STATIC);__str37378=Pointer_make([75,80,72,0],0,ALLOC_STATIC);__str38379=Pointer_make([75,80,88,0],0,ALLOC_STATIC);__str39380=Pointer_make([75,80,89,0],0,ALLOC_STATIC);__str40381=Pointer_make([76,0],0,ALLOC_STATIC);__str41382=Pointer_make([77,97,112,112,105,110,103,83,99,104,101,109,101,0],0,ALLOC_STATIC);__str42383=Pointer_make([77,101,116,114,105,99,115,83,101,116,115,0],0,ALLOC_STATIC);__str43384=
Pointer_make([78,0],0,ALLOC_STATIC);__str45386=Pointer_make([80,67,67,0],0,ALLOC_STATIC);__str46387=Pointer_make([83,116,97,114,116,65,120,105,115,0],0,ALLOC_STATIC);__str47388=Pointer_make([83,116,97,114,116,67,104,97,114,77,101,116,114,105,99,115,0],0,ALLOC_STATIC);__str48389=Pointer_make([83,116,97,114,116,67,111,109,112,111,115,105,116,101,115,0],0,ALLOC_STATIC);__str49390=Pointer_make([83,116,97,114,116,68,105,114,101,99,116,105,111,110,0],0,ALLOC_STATIC);__str50391=Pointer_make([83,116,97,114,
116,70,111,110,116,77,101,116,114,105,99,115,0],0,ALLOC_STATIC);__str51392=Pointer_make([83,116,97,114,116,75,101,114,110,68,97,116,97,0],0,ALLOC_STATIC);__str52393=Pointer_make([83,116,97,114,116,75,101,114,110,80,97,105,114,115,0],0,ALLOC_STATIC);__str53394=Pointer_make([83,116,97,114,116,75,101,114,110,80,97,105,114,115,48,0],0,ALLOC_STATIC);__str54395=Pointer_make([83,116,97,114,116,75,101,114,110,80,97,105,114,115,49,0],0,ALLOC_STATIC);__str55396=Pointer_make([83,116,97,114,116,84,114,97,99,
107,75,101,114,110,0],0,ALLOC_STATIC);__str58399=Pointer_make([84,114,97,99,107,75,101,114,110,0],0,ALLOC_STATIC);__str61402=Pointer_make([86,86,0],0,ALLOC_STATIC);__str62403=Pointer_make([86,86,101,99,116,111,114,0],0,ALLOC_STATIC);__str63404=Pointer_make([86,101,114,115,105,111,110,0],0,ALLOC_STATIC);__str64405=Pointer_make([87,0],0,ALLOC_STATIC);__str65406=Pointer_make([87,48,0],0,ALLOC_STATIC);__str66407=Pointer_make([87,48,88,0],0,ALLOC_STATIC);__str67408=Pointer_make([87,48,89,0],0,ALLOC_STATIC);
__str68409=Pointer_make([87,49,0],0,ALLOC_STATIC);__str69410=Pointer_make([87,49,88,0],0,ALLOC_STATIC);__str70411=Pointer_make([87,49,89,0],0,ALLOC_STATIC);__str71412=Pointer_make([87,88,0],0,ALLOC_STATIC);__str72413=Pointer_make([87,89,0],0,ALLOC_STATIC);__str75416=Pointer_make([88,72,101,105,103,104,116,0],0,ALLOC_STATIC);__str76417=Pointer_make([116,114,117,101,0],0,ALLOC_STATIC);_ft_char_table=Pointer_make([255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255],0,ALLOC_STATIC);_ft_standard_glyph_names=Pointer_make([46,110,117,108,108,0,110,111,110,109,97,114,107,105,110,103,114,101,116,117,114,110,0,110,111,
116,101,113,117,97,108,0,105,110,102,105,110,105,116,121,0,108,101,115,115,101,113,117,97,108,0,103,114,101,97,116,101,114,101,113,117,97,108,0,112,97,114,116,105,97,108,100,105,102,102,0,115,117,109,109,97,116,105,111,110,0,112,114,111,100,117,99,116,0,112,105,0,105,110,116,101,103,114,97,108,0,79,109,101,103,97,0,114,97,100,105,99,97,108,0,97,112,112,114,111,120,101,113,117,97,108,0,68,101,108,116,97,0,110,111,110,98,114,101,97,107,105,110,103,115,112,97,99,101,0,108,111,122,101,110,103,101,0,97,
112,112,108,101,0,102,114,97,110,99,0,71,98,114,101,118,101,0,103,98,114,101,118,101,0,73,100,111,116,97,99,99,101,110,116,0,83,99,101,100,105,108,108,97,0,115,99,101,100,105,108,108,97,0,67,97,99,117,116,101,0,99,97,99,117,116,101,0,67,99,97,114,111,110,0,99,99,97,114,111,110,0,100,99,114,111,97,116,0,46,110,111,116,100,101,102,0,115,112,97,99,101,0,101,120,99,108,97,109,0,113,117,111,116,101,100,98,108,0,110,117,109,98,101,114,115,105,103,110,0,100,111,108,108,97,114,0,112,101,114,99,101,110,116,
0,97,109,112,101,114,115,97,110,100,0,113,117,111,116,101,114,105,103,104,116,0,112,97,114,101,110,108,101,102,116,0,112,97,114,101,110,114,105,103,104,116,0,97,115,116,101,114,105,115,107,0,112,108,117,115,0,99,111,109,109,97,0,104,121,112,104,101,110,0,112,101,114,105,111,100,0,115,108,97,115,104,0,122,101,114,111,0,111,110,101,0,116,119,111,0,116,104,114,101,101,0,102,111,117,114,0,102,105,118,101,0,115,105,120,0,115,101,118,101,110,0,101,105,103,104,116,0,110,105,110,101,0,99,111,108,111,110,
0,115,101,109,105,99,111,108,111,110,0,108,101,115,115,0,101,113,117,97,108,0,103,114,101,97,116,101,114,0,113,117,101,115,116,105,111,110,0,97,116,0,65,0,66,0,67,0,68,0,69,0,70,0,71,0,72,0,73,0,74,0,75,0,76,0,77,0,78,0,79,0,80,0,81,0,82,0,83,0,84,0,85,0,86,0,87,0,88,0,89,0,90,0,98,114,97,99,107,101,116,108,101,102,116,0,98,97,99,107,115,108,97,115,104,0,98,114,97,99,107,101,116,114,105,103,104,116,0,97,115,99,105,105,99,105,114,99,117,109,0,117,110,100,101,114,115,99,111,114,101,0,113,117,111,116,
101,108,101,102,116,0,97,0,98,0,99,0,100,0,101,0,102,0,103,0,104,0,105,0,106,0,107,0,108,0,109,0,110,0,111,0,112,0,113,0,114,0,115,0,116,0,117,0,118,0,119,0,120,0,121,0,122,0,98,114,97,99,101,108,101,102,116,0,98,97,114,0,98,114,97,99,101,114,105,103,104,116,0,97,115,99,105,105,116,105,108,100,101,0,101,120,99,108,97,109,100,111,119,110,0,99,101,110,116,0,115,116,101,114,108,105,110,103,0,102,114,97,99,116,105,111,110,0,121,101,110,0,102,108,111,114,105,110,0,115,101,99,116,105,111,110,0,99,117,114,
114,101,110,99,121,0,113,117,111,116,101,115,105,110,103,108,101,0,113,117,111,116,101,100,98,108,108,101,102,116,0,103,117,105,108,108,101,109,111,116,108,101,102,116,0,103,117,105,108,115,105,110,103,108,108,101,102,116,0,103,117,105,108,115,105,110,103,108,114,105,103,104,116,0,102,105,0,102,108,0,101,110,100,97,115,104,0,100,97,103,103,101,114,0,100,97,103,103,101,114,100,98,108,0,112,101,114,105,111,100,99,101,110,116,101,114,101,100,0,112,97,114,97,103,114,97,112,104,0,98,117,108,108,101,116,
0,113,117,111,116,101,115,105,110,103,108,98,97,115,101,0,113,117,111,116,101,100,98,108,98,97,115,101,0,113,117,111,116,101,100,98,108,114,105,103,104,116,0,103,117,105,108,108,101,109,111,116,114,105,103,104,116,0,101,108,108,105,112,115,105,115,0,112,101,114,116,104,111,117,115,97,110,100,0,113,117,101,115,116,105,111,110,100,111,119,110,0,103,114,97,118,101,0,97,99,117,116,101,0,99,105,114,99,117,109,102,108,101,120,0,116,105,108,100,101,0,109,97,99,114,111,110,0,98,114,101,118,101,0,100,111,
116,97,99,99,101,110,116,0,100,105,101,114,101,115,105,115,0,114,105,110,103,0,99,101,100,105,108,108,97,0,104,117,110,103,97,114,117,109,108,97,117,116,0,111,103,111,110,101,107,0,99,97,114,111,110,0,101,109,100,97,115,104,0,65,69,0,111,114,100,102,101,109,105,110,105,110,101,0,76,115,108,97,115,104,0,79,115,108,97,115,104,0,79,69,0,111,114,100,109,97,115,99,117,108,105,110,101,0,97,101,0,100,111,116,108,101,115,115,105,0,108,115,108,97,115,104,0,111,115,108,97,115,104,0,111,101,0,103,101,114,109,
97,110,100,98,108,115,0,111,110,101,115,117,112,101,114,105,111,114,0,108,111,103,105,99,97,108,110,111,116,0,109,117,0,116,114,97,100,101,109,97,114,107,0,69,116,104,0,111,110,101,104,97,108,102,0,112,108,117,115,109,105,110,117,115,0,84,104,111,114,110,0,111,110,101,113,117,97,114,116,101,114,0,100,105,118,105,100,101,0,98,114,111,107,101,110,98,97,114,0,100,101,103,114,101,101,0,116,104,111,114,110,0,116,104,114,101,101,113,117,97,114,116,101,114,115,0,116,119,111,115,117,112,101,114,105,111,114,
0,114,101,103,105,115,116,101,114,101,100,0,109,105,110,117,115,0,101,116,104,0,109,117,108,116,105,112,108,121,0,116,104,114,101,101,115,117,112,101,114,105,111,114,0,99,111,112,121,114,105,103,104,116,0,65,97,99,117,116,101,0,65,99,105,114,99,117,109,102,108,101,120,0,65,100,105,101,114,101,115,105,115,0,65,103,114,97,118,101,0,65,114,105,110,103,0,65,116,105,108,100,101,0,67,99,101,100,105,108,108,97,0,69,97,99,117,116,101,0,69,99,105,114,99,117,109,102,108,101,120,0,69,100,105,101,114,101,115,
105,115,0,69,103,114,97,118,101,0,73,97,99,117,116,101,0,73,99,105,114,99,117,109,102,108,101,120,0,73,100,105,101,114,101,115,105,115,0,73,103,114,97,118,101,0,78,116,105,108,100,101,0,79,97,99,117,116,101,0,79,99,105,114,99,117,109,102,108,101,120,0,79,100,105,101,114,101,115,105,115,0,79,103,114,97,118,101,0,79,116,105,108,100,101,0,83,99,97,114,111,110,0,85,97,99,117,116,101,0,85,99,105,114,99,117,109,102,108,101,120,0,85,100,105,101,114,101,115,105,115,0,85,103,114,97,118,101,0,89,97,99,117,
116,101,0,89,100,105,101,114,101,115,105,115,0,90,99,97,114,111,110,0,97,97,99,117,116,101,0,97,99,105,114,99,117,109,102,108,101,120,0,97,100,105,101,114,101,115,105,115,0,97,103,114,97,118,101,0,97,114,105,110,103,0,97,116,105,108,100,101,0,99,99,101,100,105,108,108,97,0,101,97,99,117,116,101,0,101,99,105,114,99,117,109,102,108,101,120,0,101,100,105,101,114,101,115,105,115,0,101,103,114,97,118,101,0,105,97,99,117,116,101,0,105,99,105,114,99,117,109,102,108,101,120,0,105,100,105,101,114,101,115,
105,115,0,105,103,114,97,118,101,0,110,116,105,108,100,101,0,111,97,99,117,116,101,0,111,99,105,114,99,117,109,102,108,101,120,0,111,100,105,101,114,101,115,105,115,0,111,103,114,97,118,101,0,111,116,105,108,100,101,0,115,99,97,114,111,110,0,117,97,99,117,116,101,0,117,99,105,114,99,117,109,102,108,101,120,0,117,100,105,101,114,101,115,105,115,0,117,103,114,97,118,101,0,121,97,99,117,116,101,0,121,100,105,101,114,101,115,105,115,0,122,99,97,114,111,110,0,101,120,99,108,97,109,115,109,97,108,108,0,
72,117,110,103,97,114,117,109,108,97,117,116,115,109,97,108,108,0,100,111,108,108,97,114,111,108,100,115,116,121,108,101,0,100,111,108,108,97,114,115,117,112,101,114,105,111,114,0,97,109,112,101,114,115,97,110,100,115,109,97,108,108,0,65,99,117,116,101,115,109,97,108,108,0,112,97,114,101,110,108,101,102,116,115,117,112,101,114,105,111,114,0,112,97,114,101,110,114,105,103,104,116,115,117,112,101,114,105,111,114,0,116,119,111,100,111,116,101,110,108,101,97,100,101,114,0,111,110,101,100,111,116,101,
110,108,101,97,100,101,114,0,122,101,114,111,111,108,100,115,116,121,108,101,0,111,110,101,111,108,100,115,116,121,108,101,0,116,119,111,111,108,100,115,116,121,108,101,0,116,104,114,101,101,111,108,100,115,116,121,108,101,0,102,111,117,114,111,108,100,115,116,121,108,101,0,102,105,118,101,111,108,100,115,116,121,108,101,0,115,105,120,111,108,100,115,116,121,108,101,0,115,101,118,101,110,111,108,100,115,116,121,108,101,0,101,105,103,104,116,111,108,100,115,116,121,108,101,0,110,105,110,101,111,108,
100,115,116,121,108,101,0,99,111,109,109,97,115,117,112,101,114,105,111,114,0,116,104,114,101,101,113,117,97,114,116,101,114,115,101,109,100,97,115,104,0,112,101,114,105,111,100,115,117,112,101,114,105,111,114,0,113,117,101,115,116,105,111,110,115,109,97,108,108,0,97,115,117,112,101,114,105,111,114,0,98,115,117,112,101,114,105,111,114,0,99,101,110,116,115,117,112,101,114,105,111,114,0,100,115,117,112,101,114,105,111,114,0,101,115,117,112,101,114,105,111,114,0,105,115,117,112,101,114,105,111,114,0,
108,115,117,112,101,114,105,111,114,0,109,115,117,112,101,114,105,111,114,0,110,115,117,112,101,114,105,111,114,0,111,115,117,112,101,114,105,111,114,0,114,115,117,112,101,114,105,111,114,0,115,115,117,112,101,114,105,111,114,0,116,115,117,112,101,114,105,111,114,0,102,102,0,102,102,105,0,102,102,108,0,112,97,114,101,110,108,101,102,116,105,110,102,101,114,105,111,114,0,112,97,114,101,110,114,105,103,104,116,105,110,102,101,114,105,111,114,0,67,105,114,99,117,109,102,108,101,120,115,109,97,108,108,
0,104,121,112,104,101,110,115,117,112,101,114,105,111,114,0,71,114,97,118,101,115,109,97,108,108,0,65,115,109,97,108,108,0,66,115,109,97,108,108,0,67,115,109,97,108,108,0,68,115,109,97,108,108,0,69,115,109,97,108,108,0,70,115,109,97,108,108,0,71,115,109,97,108,108,0,72,115,109,97,108,108,0,73,115,109,97,108,108,0,74,115,109,97,108,108,0,75,115,109,97,108,108,0,76,115,109,97,108,108,0,77,115,109,97,108,108,0,78,115,109,97,108,108,0,79,115,109,97,108,108,0,80,115,109,97,108,108,0,81,115,109,97,108,
108,0,82,115,109,97,108,108,0,83,115,109,97,108,108,0,84,115,109,97,108,108,0,85,115,109,97,108,108,0,86,115,109,97,108,108,0,87,115,109,97,108,108,0,88,115,109,97,108,108,0,89,115,109,97,108,108,0,90,115,109,97,108,108,0,99,111,108,111,110,109,111,110,101,116,97,114,121,0,111,110,101,102,105,116,116,101,100,0,114,117,112,105,97,104,0,84,105,108,100,101,115,109,97,108,108,0,101,120,99,108,97,109,100,111,119,110,115,109,97,108,108,0,99,101,110,116,111,108,100,115,116,121,108,101,0,76,115,108,97,115,
104,115,109,97,108,108,0,83,99,97,114,111,110,115,109,97,108,108,0,90,99,97,114,111,110,115,109,97,108,108,0,68,105,101,114,101,115,105,115,115,109,97,108,108,0,66,114,101,118,101,115,109,97,108,108,0,67,97,114,111,110,115,109,97,108,108,0,68,111,116,97,99,99,101,110,116,115,109,97,108,108,0,77,97,99,114,111,110,115,109,97,108,108,0,102,105,103,117,114,101,100,97,115,104,0,104,121,112,104,101,110,105,110,102,101,114,105,111,114,0,79,103,111,110,101,107,115,109,97,108,108,0,82,105,110,103,115,109,
97,108,108,0,67,101,100,105,108,108,97,115,109,97,108,108,0,113,117,101,115,116,105,111,110,100,111,119,110,115,109,97,108,108,0,111,110,101,101,105,103,104,116,104,0,116,104,114,101,101,101,105,103,104,116,104,115,0,102,105,118,101,101,105,103,104,116,104,115,0,115,101,118,101,110,101,105,103,104,116,104,115,0,111,110,101,116,104,105,114,100,0,116,119,111,116,104,105,114,100,115,0,122,101,114,111,115,117,112,101,114,105,111,114,0,102,111,117,114,115,117,112,101,114,105,111,114,0,102,105,118,101,
115,117,112,101,114,105,111,114,0,115,105,120,115,117,112,101,114,105,111,114,0,115,101,118,101,110,115,117,112,101,114,105,111,114,0,101,105,103,104,116,115,117,112,101,114,105,111,114,0,110,105,110,101,115,117,112,101,114,105,111,114,0,122,101,114,111,105,110,102,101,114,105,111,114,0,111,110,101,105,110,102,101,114,105,111,114,0,116,119,111,105,110,102,101,114,105,111,114,0,116,104,114,101,101,105,110,102,101,114,105,111,114,0,102,111,117,114,105,110,102,101,114,105,111,114,0,102,105,118,101,105,
110,102,101,114,105,111,114,0,115,105,120,105,110,102,101,114,105,111,114,0,115,101,118,101,110,105,110,102,101,114,105,111,114,0,101,105,103,104,116,105,110,102,101,114,105,111,114,0,110,105,110,101,105,110,102,101,114,105,111,114,0,99,101,110,116,105,110,102,101,114,105,111,114,0,100,111,108,108,97,114,105,110,102,101,114,105,111,114,0,112,101,114,105,111,100,105,110,102,101,114,105,111,114,0,99,111,109,109,97,105,110,102,101,114,105,111,114,0,65,103,114,97,118,101,115,109,97,108,108,0,65,97,99,
117,116,101,115,109,97,108,108,0,65,99,105,114,99,117,109,102,108,101,120,115,109,97,108,108,0,65,116,105,108,100,101,115,109,97,108,108,0,65,100,105,101,114,101,115,105,115,115,109,97,108,108,0,65,114,105,110,103,115,109,97,108,108,0,65,69,115,109,97,108,108,0,67,99,101,100,105,108,108,97,115,109,97,108,108,0,69,103,114,97,118,101,115,109,97,108,108,0,69,97,99,117,116,101,115,109,97,108,108,0,69,99,105,114,99,117,109,102,108,101,120,115,109,97,108,108,0,69,100,105,101,114,101,115,105,115,115,109,
97,108,108,0,73,103,114,97,118,101,115,109,97,108,108,0,73,97,99,117,116,101,115,109,97,108,108,0,73,99,105,114,99,117,109,102,108,101,120,115,109,97,108,108,0,73,100,105,101,114,101,115,105,115,115,109,97,108,108,0,69,116,104,115,109,97,108,108,0,78,116,105,108,100,101,115,109,97,108,108,0,79,103,114,97,118,101,115,109,97,108,108,0,79,97,99,117,116,101,115,109,97,108,108,0,79,99,105,114,99,117,109,102,108,101,120,115,109,97,108,108,0,79,116,105,108,100,101,115,109,97,108,108,0,79,100,105,101,114,
101,115,105,115,115,109,97,108,108,0,79,69,115,109,97,108,108,0,79,115,108,97,115,104,115,109,97,108,108,0,85,103,114,97,118,101,115,109,97,108,108,0,85,97,99,117,116,101,115,109,97,108,108,0,85,99,105,114,99,117,109,102,108,101,120,115,109,97,108,108,0,85,100,105,101,114,101,115,105,115,115,109,97,108,108,0,89,97,99,117,116,101,115,109,97,108,108,0,84,104,111,114,110,115,109,97,108,108,0,89,100,105,101,114,101,115,105,115,115,109,97,108,108,0,48,48,49,46,48,48,48,0,48,48,49,46,48,48,49,0,48,48,49,
46,48,48,50,0,48,48,49,46,48,48,51,0,66,108,97,99,107,0,66,111,108,100,0,66,111,111,107,0,76,105,103,104,116,0,77,101,100,105,117,109,0,82,101,103,117,108,97,114,0,82,111,109,97,110,0,83,101,109,105,98,111,108,100,0],0,ALLOC_STATIC);_ft_mac_names=Pointer_make([253,0,0,0,6,0,261,0,267,0,274,0,283,0,294,0,301,0,309,0,758,0,330,0,340,0,351,0,360,0,365,0,371,0,378,0,385,0,391,0,396,0,400,0,404,0,410,0,415,0,420,0,424,0,430,0,436,0,441,0,447,0,457,0,462,0,468,0,476,0,485,0,488,0,490,0,492,0,494,0,496,
0,498,0,500,0,502,0,504,0,506,0,508,0,510,0,512,0,514,0,516,0,518,0,520,0,522,0,524,0,526,0,528,0,530,0,532,0,534,0,536,0,538,0,540,0,552,0,562,0,575,0,587,0,979,0,608,0,610,0,612,0,614,0,616,0,618,0,620,0,622,0,624,0,626,0,628,0,630,0,632,0,634,0,636,0,638,0,640,0,642,0,644,0,646,0,648,0,650,0,652,0,654,0,656,0,658,0,660,0,670,0,674,0,685,0,1375,0,1392,0,1405,0,1414,0,1486,0,1512,0,1562,0,1603,0,1632,0,1610,0,1622,0,1645,0,1639,0,1652,0,1661,0,1690,0,1668,0,1680,0,1697,0,1726,0,1704,0,1716,0,1733,
0,1740,0,1769,0,1747,0,1759,0,1776,0,1790,0,1819,0,1797,0,1809,0,839,0,1263,0,707,0,712,0,741,0,881,0,871,0,1160,0,1302,0,1346,0,1197,0,985,0,1031,0,23,0,1086,0,1108,0,32,0,1219,0,41,0,51,0,730,0,1194,0,64,0,76,0,86,0,94,0,97,0,1089,0,1118,0,106,0,1131,0,1150,0,966,0,696,0,1183,0,112,0,734,0,120,0,132,0,783,0,930,0,945,0,138,0,1385,0,1398,0,1529,0,1115,0,1157,0,832,0,1079,0,770,0,916,0,598,0,319,0,1246,0,155,0,1833,0,1586,0,721,0,749,0,797,0,811,0,826,0,829,0,846,0,856,0,888,0,903,0,954,0,1363,0,
1421,0,1356,0,1433,0,1443,0,1450,0,1457,0,1469,0,1479,0,1493,0,1500,0,163,0,1522,0,1543,0,1550,0,1572,0,1134,0,991,0,1002,0,1008,0,1015,0,1021,0,1040,0,1045,0,1053,0,1066,0,1073,0,1101,0,1143,0,1536,0,1783,0,1596,0,1843,0,1253,0,1207,0,1319,0,1579,0,1826,0,1229,0,1270,0,1313,0,1323,0,1171,0,1290,0,1332,0,1211,0,1235,0,1276,0,169,0,175,0,182,0,189,0,200,0,209,0,218,0,225,0,232,0,239,0,246,0],0,ALLOC_STATIC);_ft_sid_names=Pointer_make([253,0,261,0,267,0,274,0,283,0,294,0,301,0,309,0,319,0,330,0,340,
0,351,0,360,0,365,0,371,0,378,0,385,0,391,0,396,0,400,0,404,0,410,0,415,0,420,0,424,0,430,0,436,0,441,0,447,0,457,0,462,0,468,0,476,0,485,0,488,0,490,0,492,0,494,0,496,0,498,0,500,0,502,0,504,0,506,0,508,0,510,0,512,0,514,0,516,0,518,0,520,0,522,0,524,0,526,0,528,0,530,0,532,0,534,0,536,0,538,0,540,0,552,0,562,0,575,0,587,0,598,0,608,0,610,0,612,0,614,0,616,0,618,0,620,0,622,0,624,0,626,0,628,0,630,0,632,0,634,0,636,0,638,0,640,0,642,0,644,0,646,0,648,0,650,0,652,0,654,0,656,0,658,0,660,0,670,0,674,
0,685,0,696,0,707,0,712,0,721,0,730,0,734,0,741,0,749,0,758,0,770,0,783,0,797,0,811,0,826,0,829,0,832,0,839,0,846,0,856,0,871,0,881,0,888,0,903,0,916,0,930,0,945,0,954,0,966,0,979,0,985,0,991,0,1002,0,1008,0,1015,0,1021,0,1031,0,1040,0,1045,0,1053,0,1066,0,1073,0,1079,0,1086,0,1089,0,1101,0,1108,0,1115,0,1118,0,1131,0,1134,0,1143,0,1150,0,1157,0,1160,0,1171,0,1183,0,1194,0,1197,0,1207,0,1211,0,1219,0,1229,0,1235,0,1246,0,1253,0,1263,0,1270,0,1276,0,1290,0,1302,0,1313,0,1319,0,1323,0,1332,0,1346,0,
1356,0,1363,0,1375,0,1385,0,1392,0,1398,0,1405,0,1414,0,1421,0,1433,0,1443,0,1450,0,1457,0,1469,0,1479,0,1486,0,1493,0,1500,0,1512,0,1522,0,1529,0,1536,0,1543,0,1550,0,1562,0,1572,0,1579,0,1586,0,1596,0,1603,0,1610,0,1622,0,1632,0,1639,0,1645,0,1652,0,1661,0,1668,0,1680,0,1690,0,1697,0,1704,0,1716,0,1726,0,1733,0,1740,0,1747,0,1759,0,1769,0,1776,0,1783,0,1790,0,1797,0,1809,0,1819,0,1826,0,1833,0,1843,0,1850,0,1862,0,1880,0,1895,0,1910,0,1925,0,1936,0,1954,0,1973,0,1988,0,2003,0,2016,0,2028,0,2040,
0,2054,0,2067,0,2080,0,2092,0,2106,0,2120,0,2133,0,2147,0,2167,0,2182,0,2196,0,2206,0,2216,0,2229,0,2239,0,2249,0,2259,0,2269,0,2279,0,2289,0,2299,0,2309,0,2319,0,2329,0,2332,0,2336,0,2340,0,2358,0,2377,0,2393,0,2408,0,2419,0,2426,0,2433,0,2440,0,2447,0,2454,0,2461,0,2468,0,2475,0,2482,0,2489,0,2496,0,2503,0,2510,0,2517,0,2524,0,2531,0,2538,0,2545,0,2552,0,2559,0,2566,0,2573,0,2580,0,2587,0,2594,0,2601,0,2615,0,2625,0,2632,0,2643,0,2659,0,2672,0,2684,0,2696,0,2708,0,2722,0,2733,0,2744,0,2759,0,2771,
0,2782,0,2797,0,2809,0,2819,0,2832,0,2850,0,2860,0,2873,0,2885,0,2898,0,2907,0,2917,0,2930,0,2943,0,2956,0,2968,0,2982,0,2996,0,3009,0,3022,0,3034,0,3046,0,3060,0,3073,0,3086,0,3098,0,3112,0,3126,0,3139,0,3152,0,3167,0,3182,0,3196,0,3208,0,3220,0,3237,0,3249,0,3264,0,3275,0,3283,0,3297,0,3309,0,3321,0,3338,0,3353,0,3365,0,3377,0,3394,0,3409,0,3418,0,3430,0,3442,0,3454,0,3471,0,3483,0,3498,0,3506,0,3518,0,3530,0,3542,0,3559,0,3574,0,3586,0,3597,0,3612,0,3620,0,3628,0,3636,0,3644,0,3650,0,3655,0,3660,
0,3666,0,3673,0,3681,0,3687,0],0,ALLOC_STATIC);_t1_expert_encoding=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,229,0,230,0,0,0,231,0,232,0,233,0,234,0,235,0,236,0,237,0,238,0,13,0,14,0,15,0,99,0,239,0,240,0,241,0,242,0,243,0,244,0,245,0,246,0,247,0,248,0,27,0,28,0,249,0,250,0,251,0,252,0,0,0,253,0,254,0,255,0,256,0,257,0,0,0,0,0,0,0,258,0,0,0,0,0,259,0,260,0,261,0,262,0,0,0,0,0,263,0,264,0,265,0,
0,0,266,0,109,0,110,0,267,0,268,0,269,0,0,0,270,0,271,0,272,0,273,0,274,0,275,0,276,0,277,0,278,0,279,0,280,0,281,0,282,0,283,0,284,0,285,0,286,0,287,0,288,0,289,0,290,0,291,0,292,0,293,0,294,0,295,0,296,0,297,0,298,0,299,0,300,0,301,0,302,0,303,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,304,0,305,0,306,0,0,0,0,0,307,0,308,0,309,0,310,0,311,0,0,0,312,0,0,0,0,0,313,0,0,0,0,0,314,0,315,0,0,0,0,0,316,0,317,
0,318,0,0,0,0,0,0,0,158,0,155,0,163,0,319,0,320,0,321,0,322,0,323,0,324,0,325,0,0,0,0,0,326,0,150,0,164,0,169,0,327,0,328,0,329,0,330,0,331,0,332,0,333,0,334,0,335,0,336,0,337,0,338,0,339,0,340,0,341,0,342,0,343,0,344,0,345,0,346,0,347,0,348,0,349,0,350,0,351,0,352,0,353,0,354,0,355,0,356,0,357,0,358,0,359,0,360,0,361,0,362,0,363,0,364,0,365,0,366,0,367,0,368,0,369,0,370,0,371,0,372,0,373,0,374,0,375,0,376,0,377,0,378,0],0,ALLOC_STATIC);_ft_adobe_glyph_list=Pointer_make([0,52,0,106,2,167,3,63,4,220,
6,125,9,143,10,23,11,137,12,199,14,246,15,87,16,233,17,219,18,104,19,88,22,110,23,32,23,71,24,77,27,156,29,73,31,247,32,107,32,222,33,55,34,154,35,218,53,84,59,196,68,6,75,183,83,178,88,135,93,242,101,165,109,185,111,55,117,254,123,73,130,238,138,206,145,31,153,182,156,189,163,249,178,221,193,17,197,99,199,240,204,27,204,155,210,100,65,143,0,65,0,140,0,175,0,193,1,15,1,147,1,233,1,251,2,7,2,40,2,57,2,82,2,91,2,128,2,136,2,154,69,131,0,198,0,150,0,158,0,167,225,227,245,244,101,128,1,252,237,225,227,
242,239,110,128,1,226,243,237,225,236,108,128,247,230,225,227,245,244,101,129,0,193,0,185,243,237,225,236,108,128,247,225,226,242,229,246,101,134,1,2,0,213,0,221,0,232,0,243,0,251,1,7,225,227,245,244,101,128,30,174,227,249,242,233,236,236,233,99,128,4,208,228,239,244,226,229,236,239,119,128,30,182,231,242,225,246,101,128,30,176,232,239,239,235,225,226,239,246,101,128,30,178,244,233,236,228,101,128,30,180,99,4,1,25,1,32,1,121,1,137,225,242,239,110,128,1,205,233,242,99,2,1,40,1,45,236,101,128,36,182,
245,237,230,236,229,120,134,0,194,1,66,1,74,1,85,1,93,1,105,1,113,225,227,245,244,101,128,30,164,228,239,244,226,229,236,239,119,128,30,172,231,242,225,246,101,128,30,166,232,239,239,235,225,226,239,246,101,128,30,168,243,237,225,236,108,128,247,226,244,233,236,228,101,128,30,170,245,244,101,129,246,201,1,129,243,237,225,236,108,128,247,180,249,242,233,236,236,233,99,128,4,16,100,3,1,155,1,165,1,209,226,236,231,242,225,246,101,128,2,0,233,229,242,229,243,233,115,131,0,196,1,181,1,192,1,201,227,249,
242,233,236,236,233,99,128,4,210,237,225,227,242,239,110,128,1,222,243,237,225,236,108,128,247,228,239,116,2,1,216,1,224,226,229,236,239,119,128,30,160,237,225,227,242,239,110,128,1,224,231,242,225,246,101,129,0,192,1,243,243,237,225,236,108,128,247,224,232,239,239,235,225,226,239,246,101,128,30,162,105,2,2,13,2,25,229,227,249,242,233,236,236,233,99,128,4,212,238,246,229,242,244,229,228,226,242,229,246,101,128,2,2,236,240,232,97,129,3,145,2,49,244,239,238,239,115,128,3,134,109,2,2,63,2,71,225,227,
242,239,110,128,1,0,239,238,239,243,240,225,227,101,128,255,33,239,231,239,238,229,107,128,1,4,242,233,238,103,131,0,197,2,104,2,112,2,120,225,227,245,244,101,128,1,250,226,229,236,239,119,128,30,0,243,237,225,236,108,128,247,229,243,237,225,236,108,128,247,97,244,233,236,228,101,129,0,195,2,146,243,237,225,236,108,128,247,227,249,226,225,242,237,229,238,233,225,110,128,5,49,66,137,0,66,2,189,2,198,2,223,3,3,3,10,3,22,3,34,3,46,3,54,227,233,242,227,236,101,128,36,183,228,239,116,2,2,206,2,215,225,
227,227,229,238,116,128,30,2,226,229,236,239,119,128,30,4,101,3,2,231,2,242,2,254,227,249,242,233,236,236,233,99,128,4,17,238,225,242,237,229,238,233,225,110,128,5,50,244,97,128,3,146,232,239,239,107,128,1,129,236,233,238,229,226,229,236,239,119,128,30,6,237,239,238,239,243,240,225,227,101,128,255,34,242,229,246,229,243,237,225,236,108,128,246,244,243,237,225,236,108,128,247,98,244,239,240,226,225,114,128,1,130,67,137,0,67,3,85,3,127,3,193,3,210,3,224,4,171,4,188,4,200,4,212,97,3,3,93,3,104,3,111,
225,242,237,229,238,233,225,110,128,5,62,227,245,244,101,128,1,6,242,239,110,129,246,202,3,119,243,237,225,236,108,128,246,245,99,3,3,135,3,142,3,171,225,242,239,110,128,1,12,229,228,233,236,236,97,130,0,199,3,155,3,163,225,227,245,244,101,128,30,8,243,237,225,236,108,128,247,231,233,242,99,2,3,179,3,184,236,101,128,36,184,245,237,230,236,229,120,128,1,8,228,239,116,129,1,10,3,201,225,227,227,229,238,116,128,1,10,229,228,233,236,236,225,243,237,225,236,108,128,247,184,104,4,3,234,3,246,4,161,4,165,
225,225,242,237,229,238,233,225,110,128,5,73,101,6,4,4,4,24,4,35,4,103,4,115,4,136,225,226,235,232,225,243,233,225,238,227,249,242,233,236,236,233,99,128,4,188,227,249,242,233,236,236,233,99,128,4,39,100,2,4,41,4,85,229,243,227,229,238,228,229,114,2,4,54,4,74,225,226,235,232,225,243,233,225,238,227,249,242,233,236,236,233,99,128,4,190,227,249,242,233,236,236,233,99,128,4,182,233,229,242,229,243,233,243,227,249,242,233,236,236,233,99,128,4,244,232,225,242,237,229,238,233,225,110,128,5,67,235,232,225,
235,225,243,243,233,225,238,227,249,242,233,236,236,233,99,128,4,203,246,229,242,244,233,227,225,236,243,244,242,239,235,229,227,249,242,233,236,236,233,99,128,4,184,105,128,3,167,239,239,107,128,1,135,233,242,227,245,237,230,236,229,248,243,237,225,236,108,128,246,246,237,239,238,239,243,240,225,227,101,128,255,35,239,225,242,237,229,238,233,225,110,128,5,81,243,237,225,236,108,128,247,99,68,142,0,68,4,252,5,10,5,36,5,96,5,121,5,166,5,173,5,231,5,244,6,0,6,12,6,28,6,48,6,57,90,129,1,241,5,2,227,
225,242,239,110,128,1,196,97,2,5,16,5,27,225,242,237,229,238,233,225,110,128,5,52,230,242,233,227,225,110,128,1,137,99,4,5,46,5,53,5,62,5,89,225,242,239,110,128,1,14,229,228,233,236,236,97,128,30,16,233,242,99,2,5,70,5,75,236,101,128,36,185,245,237,230,236,229,248,226,229,236,239,119,128,30,18,242,239,225,116,128,1,16,228,239,116,2,5,104,5,113,225,227,227,229,238,116,128,30,10,226,229,236,239,119,128,30,12,101,3,5,129,5,140,5,150,227,249,242,233,236,236,233,99,128,4,20,233,227,239,240,244,233,99,
128,3,238,236,244,97,129,34,6,5,158,231,242,229,229,107,128,3,148,232,239,239,107,128,1,138,105,2,5,179,5,218,229,242,229,243,233,115,131,246,203,5,194,5,202,5,210,193,227,245,244,101,128,246,204,199,242,225,246,101,128,246,205,243,237,225,236,108,128,247,168,231,225,237,237,225,231,242,229,229,107,128,3,220,234,229,227,249,242,233,236,236,233,99,128,4,2,236,233,238,229,226,229,236,239,119,128,30,14,237,239,238,239,243,240,225,227,101,128,255,36,239,244,225,227,227,229,238,244,243,237,225,236,108,
128,246,247,115,2,6,34,6,41,236,225,243,104,128,1,16,237,225,236,108,128,247,100,244,239,240,226,225,114,128,1,139,122,131,1,242,6,67,6,75,6,112,227,225,242,239,110,128,1,197,101,2,6,81,6,101,225,226,235,232,225,243,233,225,238,227,249,242,233,236,236,233,99,128,4,224,227,249,242,233,236,236,233,99,128,4,5,232,229,227,249,242,233,236,236,233,99,128,4,15,69,146,0,69,6,165,6,183,6,191,7,89,7,153,7,165,7,183,7,211,8,7,8,36,8,94,8,169,8,189,8,208,8,248,9,44,9,109,9,115,225,227,245,244,101,129,0,201,6,
175,243,237,225,236,108,128,247,233,226,242,229,246,101,128,1,20,99,5,6,203,6,210,6,224,6,236,7,79,225,242,239,110,128,1,26,229,228,233,236,236,225,226,242,229,246,101,128,30,28,232,225,242,237,229,238,233,225,110,128,5,53,233,242,99,2,6,244,6,249,236,101,128,36,186,245,237,230,236,229,120,135,0,202,7,16,7,24,7,32,7,43,7,51,7,63,7,71,225,227,245,244,101,128,30,190,226,229,236,239,119,128,30,24,228,239,244,226,229,236,239,119,128,30,198,231,242,225,246,101,128,30,192,232,239,239,235,225,226,239,246,
101,128,30,194,243,237,225,236,108,128,247,234,244,233,236,228,101,128,30,196,249,242,233,236,236,233,99,128,4,4,100,3,7,97,7,107,7,127,226,236,231,242,225,246,101,128,2,4,233,229,242,229,243,233,115,129,0,203,7,119,243,237,225,236,108,128,247,235,239,116,130,1,22,7,136,7,145,225,227,227,229,238,116,128,1,22,226,229,236,239,119,128,30,184,230,227,249,242,233,236,236,233,99,128,4,36,231,242,225,246,101,129,0,200,7,175,243,237,225,236,108,128,247,232,104,2,7,189,7,200,225,242,237,229,238,233,225,110,
128,5,55,239,239,235,225,226,239,246,101,128,30,186,105,3,7,219,7,230,7,245,231,232,244,242,239,237,225,110,128,33,103,238,246,229,242,244,229,228,226,242,229,246,101,128,2,6,239,244,233,230,233,229,228,227,249,242,233,236,236,233,99,128,4,100,108,2,8,13,8,24,227,249,242,233,236,236,233,99,128,4,27,229,246,229,238,242,239,237,225,110,128,33,106,109,3,8,44,8,72,8,83,225,227,242,239,110,130,1,18,8,56,8,64,225,227,245,244,101,128,30,22,231,242,225,246,101,128,30,20,227,249,242,233,236,236,233,99,128,
4,28,239,238,239,243,240,225,227,101,128,255,37,110,4,8,104,8,115,8,135,8,154,227,249,242,233,236,236,233,99,128,4,29,228,229,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,162,103,129,1,74,8,141,232,229,227,249,242,233,236,236,233,99,128,4,164,232,239,239,235,227,249,242,233,236,236,233,99,128,4,199,111,2,8,175,8,183,231,239,238,229,107,128,1,24,240,229,110,128,1,144,240,243,233,236,239,110,129,3,149,8,200,244,239,238,239,115,128,3,136,114,2,8,214,8,225,227,249,242,233,236,236,
233,99,128,4,32,229,246,229,242,243,229,100,129,1,142,8,237,227,249,242,233,236,236,233,99,128,4,45,115,4,9,2,9,13,9,33,9,37,227,249,242,233,236,236,233,99,128,4,33,228,229,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,170,104,128,1,169,237,225,236,108,128,247,101,116,3,9,52,9,78,9,92,97,130,3,151,9,60,9,70,242,237,229,238,233,225,110,128,5,56,244,239,238,239,115,128,3,137,104,129,0,208,9,84,243,237,225,236,108,128,247,240,233,236,228,101,129,30,188,9,101,226,229,236,239,119,128,
30,26,245,242,111,128,32,172,250,104,130,1,183,9,124,9,132,227,225,242,239,110,128,1,238,242,229,246,229,242,243,229,100,128,1,184,70,136,0,70,9,163,9,172,9,184,9,212,9,219,9,248,10,4,10,15,227,233,242,227,236,101,128,36,187,228,239,244,225,227,227,229,238,116,128,30,30,101,2,9,190,9,202,232,225,242,237,229,238,233,225,110,128,5,86,233,227,239,240,244,233,99,128,3,228,232,239,239,107,128,1,145,105,2,9,225,9,238,244,225,227,249,242,233,236,236,233,99,128,4,114,246,229,242,239,237,225,110,128,33,100,
237,239,238,239,243,240,225,227,101,128,255,38,239,245,242,242,239,237,225,110,128,33,99,243,237,225,236,108,128,247,102,71,140,0,71,10,51,10,61,10,107,10,115,10,176,10,193,10,205,11,39,11,52,11,65,11,90,11,107,194,243,241,245,225,242,101,128,51,135,97,3,10,69,10,76,10,94,227,245,244,101,128,1,244,237,237,97,129,3,147,10,84,225,230,242,233,227,225,110,128,1,148,238,231,233,225,227,239,240,244,233,99,128,3,234,226,242,229,246,101,128,1,30,99,4,10,125,10,132,10,141,10,163,225,242,239,110,128,1,230,
229,228,233,236,236,97,128,1,34,233,242,99,2,10,149,10,154,236,101,128,36,188,245,237,230,236,229,120,128,1,28,239,237,237,225,225,227,227,229,238,116,128,1,34,228,239,116,129,1,32,10,184,225,227,227,229,238,116,128,1,32,229,227,249,242,233,236,236,233,99,128,4,19,104,3,10,213,10,226,11,33,225,228,225,242,237,229,238,233,225,110,128,5,66,101,3,10,234,10,255,11,16,237,233,228,228,236,229,232,239,239,235,227,249,242,233,236,236,233,99,128,4,148,243,244,242,239,235,229,227,249,242,233,236,236,233,99,
128,4,146,245,240,244,245,242,238,227,249,242,233,236,236,233,99,128,4,144,239,239,107,128,1,147,233,237,225,242,237,229,238,233,225,110,128,5,51,234,229,227,249,242,233,236,236,233,99,128,4,3,109,2,11,71,11,79,225,227,242,239,110,128,30,32,239,238,239,243,240,225,227,101,128,255,39,242,225,246,101,129,246,206,11,99,243,237,225,236,108,128,247,96,115,2,11,113,11,129,237,225,236,108,129,247,103,11,122,232,239,239,107,128,2,155,244,242,239,235,101,128,1,228,72,140,0,72,11,165,11,190,11,198,11,208,12,
17,12,40,12,77,12,117,12,129,12,157,12,165,12,189,177,184,53,3,11,175,11,180,11,185,179,51,128,37,207,180,51,128,37,170,181,49,128,37,171,178,178,176,183,51,128,37,161,208,243,241,245,225,242,101,128,51,203,97,3,11,216,11,236,12,0,225,226,235,232,225,243,233,225,238,227,249,242,233,236,236,233,99,128,4,168,228,229,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,178,242,228,243,233,231,238,227,249,242,233,236,236,233,99,128,4,42,98,2,12,23,12,28,225,114,128,1,38,242,229,246,229,226,
229,236,239,119,128,30,42,99,2,12,46,12,55,229,228,233,236,236,97,128,30,40,233,242,99,2,12,63,12,68,236,101,128,36,189,245,237,230,236,229,120,128,1,36,100,2,12,83,12,93,233,229,242,229,243,233,115,128,30,38,239,116,2,12,100,12,109,225,227,227,229,238,116,128,30,34,226,229,236,239,119,128,30,36,237,239,238,239,243,240,225,227,101,128,255,40,111,2,12,135,12,146,225,242,237,229,238,233,225,110,128,5,64,242,233,227,239,240,244,233,99,128,3,232,243,237,225,236,108,128,247,104,245,238,231,225,242,245,
237,236,225,245,116,129,246,207,12,181,243,237,225,236,108,128,246,248,250,243,241,245,225,242,101,128,51,144,73,146,0,73,12,239,12,251,12,255,13,11,13,29,13,37,13,94,13,181,13,214,13,224,13,242,13,254,14,48,14,86,14,99,14,166,14,187,14,205,193,227,249,242,233,236,236,233,99,128,4,47,74,128,1,50,213,227,249,242,233,236,236,233,99,128,4,46,225,227,245,244,101,129,0,205,13,21,243,237,225,236,108,128,247,237,226,242,229,246,101,128,1,44,99,3,13,45,13,52,13,84,225,242,239,110,128,1,207,233,242,99,2,13,
60,13,65,236,101,128,36,190,245,237,230,236,229,120,129,0,206,13,76,243,237,225,236,108,128,247,238,249,242,233,236,236,233,99,128,4,6,100,3,13,102,13,112,13,155,226,236,231,242,225,246,101,128,2,8,233,229,242,229,243,233,115,131,0,207,13,128,13,136,13,147,225,227,245,244,101,128,30,46,227,249,242,233,236,236,233,99,128,4,228,243,237,225,236,108,128,247,239,239,116,130,1,48,13,164,13,173,225,227,227,229,238,116,128,1,48,226,229,236,239,119,128,30,202,101,2,13,187,13,203,226,242,229,246,229,227,249,
242,233,236,236,233,99,128,4,214,227,249,242,233,236,236,233,99,128,4,21,230,242,225,235,244,245,114,128,33,17,231,242,225,246,101,129,0,204,13,234,243,237,225,236,108,128,247,236,232,239,239,235,225,226,239,246,101,128,30,200,105,3,14,6,14,17,14,32,227,249,242,233,236,236,233,99,128,4,24,238,246,229,242,244,229,228,226,242,229,246,101,128,2,10,243,232,239,242,244,227,249,242,233,236,236,233,99,128,4,25,109,2,14,54,14,75,225,227,242,239,110,129,1,42,14,64,227,249,242,233,236,236,233,99,128,4,226,
239,238,239,243,240,225,227,101,128,255,41,238,233,225,242,237,229,238,233,225,110,128,5,59,111,3,14,107,14,118,14,126,227,249,242,233,236,236,233,99,128,4,1,231,239,238,229,107,128,1,46,244,97,131,3,153,14,137,14,147,14,158,225,230,242,233,227,225,110,128,1,150,228,233,229,242,229,243,233,115,128,3,170,244,239,238,239,115,128,3,138,115,2,14,172,14,179,237,225,236,108,128,247,105,244,242,239,235,101,128,1,151,244,233,236,228,101,129,1,40,14,197,226,229,236,239,119,128,30,44,250,232,233,244,243,97,
2,14,216,14,227,227,249,242,233,236,236,233,99,128,4,116,228,226,236,231,242,225,246,229,227,249,242,233,236,236,233,99,128,4,118,74,134,0,74,15,6,15,18,15,41,15,53,15,67,15,79,225,225,242,237,229,238,233,225,110,128,5,65,227,233,242,99,2,15,27,15,32,236,101,128,36,191,245,237,230,236,229,120,128,1,52,229,227,249,242,233,236,236,233,99,128,4,8,232,229,232,225,242,237,229,238,233,225,110,128,5,75,237,239,238,239,243,240,225,227,101,128,255,42,243,237,225,236,108,128,247,106,75,140,0,75,15,115,15,125,
15,135,16,18,16,65,16,76,16,106,16,143,16,156,16,168,16,180,16,208,194,243,241,245,225,242,101,128,51,133,203,243,241,245,225,242,101,128,51,205,97,7,15,151,15,169,15,191,15,211,15,226,15,232,15,249,226,225,243,232,235,233,242,227,249,242,233,236,236,233,99,128,4,160,99,2,15,175,15,181,245,244,101,128,30,48,249,242,233,236,236,233,99,128,4,26,228,229,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,154,232,239,239,235,227,249,242,233,236,236,233,99,128,4,195,240,240,97,128,3,154,243,
244,242,239,235,229,227,249,242,233,236,236,233,99,128,4,158,246,229,242,244,233,227,225,236,243,244,242,239,235,229,227,249,242,233,236,236,233,99,128,4,156,99,4,16,28,16,35,16,44,16,52,225,242,239,110,128,1,232,229,228,233,236,236,97,128,1,54,233,242,227,236,101,128,36,192,239,237,237,225,225,227,227,229,238,116,128,1,54,228,239,244,226,229,236,239,119,128,30,50,101,2,16,82,16,94,232,225,242,237,229,238,233,225,110,128,5,84,238,225,242,237,229,238,233,225,110,128,5,63,104,3,16,114,16,126,16,137,
225,227,249,242,233,236,236,233,99,128,4,37,229,233,227,239,240,244,233,99,128,3,230,239,239,107,128,1,152,234,229,227,249,242,233,236,236,233,99,128,4,12,236,233,238,229,226,229,236,239,119,128,30,52,237,239,238,239,243,240,225,227,101,128,255,43,239,240,240,97,2,16,189,16,200,227,249,242,233,236,236,233,99,128,4,128,231,242,229,229,107,128,3,222,115,2,16,214,16,226,233,227,249,242,233,236,236,233,99,128,4,110,237,225,236,108,128,247,107,76,138,0,76,17,1,17,5,17,9,17,29,17,95,17,133,17,147,17,165,
17,177,17,189,74,128,1,199,76,128,246,191,97,2,17,15,17,22,227,245,244,101,128,1,57,237,226,228,97,128,3,155,99,4,17,39,17,46,17,55,17,82,225,242,239,110,128,1,61,229,228,233,236,236,97,128,1,59,233,242,99,2,17,63,17,68,236,101,128,36,193,245,237,230,236,229,248,226,229,236,239,119,128,30,60,239,237,237,225,225,227,227,229,238,116,128,1,59,228,239,116,130,1,63,17,105,17,114,225,227,227,229,238,116,128,1,63,226,229,236,239,119,129,30,54,17,124,237,225,227,242,239,110,128,30,56,233,247,238,225,242,
237,229,238,233,225,110,128,5,60,106,129,1,200,17,153,229,227,249,242,233,236,236,233,99,128,4,9,236,233,238,229,226,229,236,239,119,128,30,58,237,239,238,239,243,240,225,227,101,128,255,44,115,2,17,195,17,212,236,225,243,104,129,1,65,17,204,243,237,225,236,108,128,246,249,237,225,236,108,128,247,108,77,137,0,77,17,241,17,251,18,24,18,33,18,58,18,71,18,83,18,91,18,100,194,243,241,245,225,242,101,128,51,134,225,99,2,18,2,18,18,242,239,110,129,246,208,18,10,243,237,225,236,108,128,247,175,245,244,101,
128,30,62,227,233,242,227,236,101,128,36,194,228,239,116,2,18,41,18,50,225,227,227,229,238,116,128,30,64,226,229,236,239,119,128,30,66,229,238,225,242,237,229,238,233,225,110,128,5,68,237,239,238,239,243,240,225,227,101,128,255,45,243,237,225,236,108,128,247,109,244,245,242,238,229,100,128,1,156,117,128,3,156,78,141,0,78,18,134,18,138,18,146,18,212,18,237,18,248,19,3,19,21,19,33,19,45,19,58,19,66,19,84,74,128,1,202,225,227,245,244,101,128,1,67,99,4,18,156,18,163,18,172,18,199,225,242,239,110,128,
1,71,229,228,233,236,236,97,128,1,69,233,242,99,2,18,180,18,185,236,101,128,36,195,245,237,230,236,229,248,226,229,236,239,119,128,30,74,239,237,237,225,225,227,227,229,238,116,128,1,69,228,239,116,2,18,220,18,229,225,227,227,229,238,116,128,30,68,226,229,236,239,119,128,30,70,232,239,239,235,236,229,230,116,128,1,157,233,238,229,242,239,237,225,110,128,33,104,106,129,1,203,19,9,229,227,249,242,233,236,236,233,99,128,4,10,236,233,238,229,226,229,236,239,119,128,30,72,237,239,238,239,243,240,225,227,
101,128,255,46,239,247,225,242,237,229,238,233,225,110,128,5,70,243,237,225,236,108,128,247,110,244,233,236,228,101,129,0,209,19,76,243,237,225,236,108,128,247,241,117,128,3,157,79,141,0,79,19,118,19,132,19,150,19,203,20,78,20,152,20,187,21,48,21,69,21,213,21,223,21,254,22,53,69,129,1,82,19,124,243,237,225,236,108,128,246,250,225,227,245,244,101,129,0,211,19,142,243,237,225,236,108,128,247,243,98,2,19,156,19,196,225,242,242,229,100,2,19,166,19,177,227,249,242,233,236,236,233,99,128,4,232,228,233,
229,242,229,243,233,243,227,249,242,233,236,236,233,99,128,4,234,242,229,246,101,128,1,78,99,4,19,213,19,220,19,235,20,68,225,242,239,110,128,1,209,229,238,244,229,242,229,228,244,233,236,228,101,128,1,159,233,242,99,2,19,243,19,248,236,101,128,36,196,245,237,230,236,229,120,134,0,212,20,13,20,21,20,32,20,40,20,52,20,60,225,227,245,244,101,128,30,208,228,239,244,226,229,236,239,119,128,30,216,231,242,225,246,101,128,30,210,232,239,239,235,225,226,239,246,101,128,30,212,243,237,225,236,108,128,247,
244,244,233,236,228,101,128,30,214,249,242,233,236,236,233,99,128,4,30,100,3,20,86,20,109,20,142,226,108,2,20,93,20,101,225,227,245,244,101,128,1,80,231,242,225,246,101,128,2,12,233,229,242,229,243,233,115,130,0,214,20,123,20,134,227,249,242,233,236,236,233,99,128,4,230,243,237,225,236,108,128,247,246,239,244,226,229,236,239,119,128,30,204,103,2,20,158,20,170,239,238,229,235,243,237,225,236,108,128,246,251,242,225,246,101,129,0,210,20,179,243,237,225,236,108,128,247,242,104,4,20,197,20,208,20,212,
21,34,225,242,237,229,238,233,225,110,128,5,85,109,128,33,38,111,2,20,218,20,228,239,235,225,226,239,246,101,128,30,206,242,110,133,1,160,20,243,20,251,21,6,21,14,21,26,225,227,245,244,101,128,30,218,228,239,244,226,229,236,239,119,128,30,226,231,242,225,246,101,128,30,220,232,239,239,235,225,226,239,246,101,128,30,222,244,233,236,228,101,128,30,224,245,238,231,225,242,245,237,236,225,245,116,128,1,80,105,129,1,162,21,54,238,246,229,242,244,229,228,226,242,229,246,101,128,2,14,109,4,21,79,21,107,
21,184,21,202,225,227,242,239,110,130,1,76,21,91,21,99,225,227,245,244,101,128,30,82,231,242,225,246,101,128,30,80,229,231,97,132,33,38,21,121,21,132,21,140,21,156,227,249,242,233,236,236,233,99,128,4,96,231,242,229,229,107,128,3,169,242,239,245,238,228,227,249,242,233,236,236,233,99,128,4,122,116,2,21,162,21,177,233,244,236,239,227,249,242,233,236,236,233,99,128,4,124,239,238,239,115,128,3,143,233,227,242,239,110,129,3,159,21,194,244,239,238,239,115,128,3,140,239,238,239,243,240,225,227,101,128,
255,47,238,229,242,239,237,225,110,128,33,96,111,2,21,229,21,248,231,239,238,229,107,129,1,234,21,239,237,225,227,242,239,110,128,1,236,240,229,110,128,1,134,115,3,22,6,22,33,22,40,236,225,243,104,130,0,216,22,17,22,25,225,227,245,244,101,128,1,254,243,237,225,236,108,128,247,248,237,225,236,108,128,247,111,244,242,239,235,229,225,227,245,244,101,128,1,254,116,2,22,59,22,70,227,249,242,233,236,236,233,99,128,4,126,233,236,228,101,131,0,213,22,83,22,91,22,102,225,227,245,244,101,128,30,76,228,233,
229,242,229,243,233,115,128,30,78,243,237,225,236,108,128,247,245,80,136,0,80,22,130,22,138,22,147,22,159,22,211,22,227,22,246,23,2,225,227,245,244,101,128,30,84,227,233,242,227,236,101,128,36,197,228,239,244,225,227,227,229,238,116,128,30,86,101,3,22,167,22,178,22,190,227,249,242,233,236,236,233,99,128,4,31,232,225,242,237,229,238,233,225,110,128,5,74,237,233,228,228,236,229,232,239,239,235,227,249,242,233,236,236,233,99,128,4,166,104,2,22,217,22,221,105,128,3,166,239,239,107,128,1,164,105,129,3,
160,22,233,247,242,225,242,237,229,238,233,225,110,128,5,83,237,239,238,239,243,240,225,227,101,128,255,48,115,2,23,8,23,25,105,129,3,168,23,14,227,249,242,233,236,236,233,99,128,4,112,237,225,236,108,128,247,112,81,131,0,81,23,42,23,51,23,63,227,233,242,227,236,101,128,36,198,237,239,238,239,243,240,225,227,101,128,255,49,243,237,225,236,108,128,247,113,82,138,0,82,23,95,23,119,23,166,23,217,23,230,23,240,23,245,24,19,24,31,24,43,97,2,23,101,23,112,225,242,237,229,238,233,225,110,128,5,76,227,245,
244,101,128,1,84,99,4,23,129,23,136,23,145,23,153,225,242,239,110,128,1,88,229,228,233,236,236,97,128,1,86,233,242,227,236,101,128,36,199,239,237,237,225,225,227,227,229,238,116,128,1,86,100,2,23,172,23,182,226,236,231,242,225,246,101,128,2,16,239,116,2,23,189,23,198,225,227,227,229,238,116,128,30,88,226,229,236,239,119,129,30,90,23,208,237,225,227,242,239,110,128,30,92,229,232,225,242,237,229,238,233,225,110,128,5,80,230,242,225,235,244,245,114,128,33,28,232,111,128,3,161,233,110,2,23,252,24,5,231,
243,237,225,236,108,128,246,252,246,229,242,244,229,228,226,242,229,246,101,128,2,18,236,233,238,229,226,229,236,239,119,128,30,94,237,239,238,239,243,240,225,227,101,128,255,50,243,237,225,236,108,129,247,114,24,53,233,238,246,229,242,244,229,100,129,2,129,24,66,243,245,240,229,242,233,239,114,128,2,182,83,139,0,83,24,103,26,17,26,55,26,182,26,221,26,250,27,84,27,105,27,117,27,135,27,143,70,6,24,117,24,209,24,241,25,77,25,119,25,221,48,9,24,137,24,145,24,153,24,161,24,169,24,177,24,185,24,193,24,
201,177,176,176,176,48,128,37,12,178,176,176,176,48,128,37,20,179,176,176,176,48,128,37,16,180,176,176,176,48,128,37,24,181,176,176,176,48,128,37,60,182,176,176,176,48,128,37,44,183,176,176,176,48,128,37,52,184,176,176,176,48,128,37,28,185,176,176,176,48,128,37,36,49,3,24,217,24,225,24,233,176,176,176,176,48,128,37,0,177,176,176,176,48,128,37,2,185,176,176,176,48,128,37,97,50,9,25,5,25,13,25,21,25,29,25,37,25,45,25,53,25,61,25,69,176,176,176,176,48,128,37,98,177,176,176,176,48,128,37,86,178,176,176,
176,48,128,37,85,179,176,176,176,48,128,37,99,180,176,176,176,48,128,37,81,181,176,176,176,48,128,37,87,182,176,176,176,48,128,37,93,183,176,176,176,48,128,37,92,184,176,176,176,48,128,37,91,51,4,25,87,25,95,25,103,25,111,182,176,176,176,48,128,37,94,183,176,176,176,48,128,37,95,184,176,176,176,48,128,37,90,185,176,176,176,48,128,37,84,52,10,25,141,25,149,25,157,25,165,25,173,25,181,25,189,25,197,25,205,25,213,176,176,176,176,48,128,37,105,177,176,176,176,48,128,37,102,178,176,176,176,48,128,37,96,
179,176,176,176,48,128,37,80,180,176,176,176,48,128,37,108,181,176,176,176,48,128,37,103,182,176,176,176,48,128,37,104,183,176,176,176,48,128,37,100,184,176,176,176,48,128,37,101,185,176,176,176,48,128,37,89,53,5,25,233,25,241,25,249,26,1,26,9,176,176,176,176,48,128,37,88,177,176,176,176,48,128,37,82,178,176,176,176,48,128,37,83,179,176,176,176,48,128,37,107,180,176,176,176,48,128,37,106,97,2,26,23,26,44,227,245,244,101,129,1,90,26,32,228,239,244,225,227,227,229,238,116,128,30,100,237,240,233,231,
242,229,229,107,128,3,224,99,5,26,67,26,98,26,107,26,147,26,169,225,242,239,110,130,1,96,26,78,26,90,228,239,244,225,227,227,229,238,116,128,30,102,243,237,225,236,108,128,246,253,229,228,233,236,236,97,128,1,94,232,247,97,130,1,143,26,117,26,128,227,249,242,233,236,236,233,99,128,4,216,228,233,229,242,229,243,233,243,227,249,242,233,236,236,233,99,128,4,218,233,242,99,2,26,155,26,160,236,101,128,36,200,245,237,230,236,229,120,128,1,92,239,237,237,225,225,227,227,229,238,116,128,2,24,228,239,116,
2,26,190,26,199,225,227,227,229,238,116,128,30,96,226,229,236,239,119,129,30,98,26,209,228,239,244,225,227,227,229,238,116,128,30,104,101,2,26,227,26,239,232,225,242,237,229,238,233,225,110,128,5,77,246,229,238,242,239,237,225,110,128,33,102,104,5,27,6,27,34,27,48,27,59,27,72,97,2,27,12,27,23,225,242,237,229,238,233,225,110,128,5,71,227,249,242,233,236,236,233,99,128,4,40,227,232,225,227,249,242,233,236,236,233,99,128,4,41,229,233,227,239,240,244,233,99,128,3,226,232,225,227,249,242,233,236,236,233,
99,128,4,186,233,237,225,227,239,240,244,233,99,128,3,236,105,2,27,90,27,96,231,237,97,128,3,163,248,242,239,237,225,110,128,33,101,237,239,238,239,243,240,225,227,101,128,255,51,239,230,244,243,233,231,238,227,249,242,233,236,236,233,99,128,4,44,243,237,225,236,108,128,247,115,244,233,231,237,225,231,242,229,229,107,128,3,218,84,141,0,84,27,186,27,191,27,197,28,7,28,32,28,96,28,147,28,177,28,189,28,201,28,246,29,6,29,46,225,117,128,3,164,226,225,114,128,1,102,99,4,27,207,27,214,27,223,27,250,225,
242,239,110,128,1,100,229,228,233,236,236,97,128,1,98,233,242,99,2,27,231,27,236,236,101,128,36,201,245,237,230,236,229,248,226,229,236,239,119,128,30,112,239,237,237,225,225,227,227,229,238,116,128,1,98,228,239,116,2,28,15,28,24,225,227,227,229,238,116,128,30,106,226,229,236,239,119,128,30,108,101,4,28,42,28,53,28,73,28,82,227,249,242,233,236,236,233,99,128,4,34,228,229,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,172,238,242,239,237,225,110,128,33,105,244,243,229,227,249,242,
233,236,236,233,99,128,4,180,104,3,28,104,28,110,28,136,229,244,97,128,3,152,111,2,28,116,28,121,239,107,128,1,172,242,110,129,0,222,28,128,243,237,225,236,108,128,247,254,242,229,229,242,239,237,225,110,128,33,98,105,2,28,153,28,164,236,228,229,243,237,225,236,108,128,246,254,247,238,225,242,237,229,238,233,225,110,128,5,79,236,233,238,229,226,229,236,239,119,128,30,110,237,239,238,239,243,240,225,227,101,128,255,52,111,2,28,207,28,218,225,242,237,229,238,233,225,110,128,5,57,238,101,3,28,227,28,
234,28,240,230,233,246,101,128,1,188,243,233,120,128,1,132,244,247,111,128,1,167,242,229,244,242,239,230,236,229,248,232,239,239,107,128,1,174,115,3,29,14,29,26,29,39,229,227,249,242,233,236,236,233,99,128,4,38,232,229,227,249,242,233,236,236,233,99,128,4,11,237,225,236,108,128,247,116,119,2,29,52,29,64,229,236,246,229,242,239,237,225,110,128,33,107,239,242,239,237,225,110,128,33,97,85,142,0,85,29,105,29,123,29,131,29,198,30,69,30,87,30,198,30,214,30,226,31,21,31,30,31,142,31,149,31,219,225,227,245,
244,101,129,0,218,29,115,243,237,225,236,108,128,247,250,226,242,229,246,101,128,1,108,99,3,29,139,29,146,29,188,225,242,239,110,128,1,211,233,242,99,2,29,154,29,159,236,101,128,36,202,245,237,230,236,229,120,130,0,219,29,172,29,180,226,229,236,239,119,128,30,118,243,237,225,236,108,128,247,251,249,242,233,236,236,233,99,128,4,35,100,3,29,206,29,229,30,59,226,108,2,29,213,29,221,225,227,245,244,101,128,1,112,231,242,225,246,101,128,2,20,233,229,242,229,243,233,115,134,0,220,29,251,30,3,30,11,30,34,
30,42,30,51,225,227,245,244,101,128,1,215,226,229,236,239,119,128,30,114,99,2,30,17,30,24,225,242,239,110,128,1,217,249,242,233,236,236,233,99,128,4,240,231,242,225,246,101,128,1,219,237,225,227,242,239,110,128,1,213,243,237,225,236,108,128,247,252,239,244,226,229,236,239,119,128,30,228,231,242,225,246,101,129,0,217,30,79,243,237,225,236,108,128,247,249,104,2,30,93,30,171,111,2,30,99,30,109,239,235,225,226,239,246,101,128,30,230,242,110,133,1,175,30,124,30,132,30,143,30,151,30,163,225,227,245,244,
101,128,30,232,228,239,244,226,229,236,239,119,128,30,240,231,242,225,246,101,128,30,234,232,239,239,235,225,226,239,246,101,128,30,236,244,233,236,228,101,128,30,238,245,238,231,225,242,245,237,236,225,245,116,129,1,112,30,187,227,249,242,233,236,236,233,99,128,4,242,233,238,246,229,242,244,229,228,226,242,229,246,101,128,2,22,235,227,249,242,233,236,236,233,99,128,4,120,109,2,30,232,31,10,225,227,242,239,110,130,1,106,30,244,30,255,227,249,242,233,236,236,233,99,128,4,238,228,233,229,242,229,243,
233,115,128,30,122,239,238,239,243,240,225,227,101,128,255,53,239,231,239,238,229,107,128,1,114,240,243,233,236,239,110,133,3,165,31,49,31,53,31,90,31,121,31,134,49,128,3,210,97,2,31,59,31,81,227,245,244,229,232,239,239,235,243,249,237,226,239,236,231,242,229,229,107,128,3,211,230,242,233,227,225,110,128,1,177,228,233,229,242,229,243,233,115,129,3,171,31,103,232,239,239,235,243,249,237,226,239,236,231,242,229,229,107,128,3,212,232,239,239,235,243,249,237,226,239,108,128,3,210,244,239,238,239,115,
128,3,142,242,233,238,103,128,1,110,115,3,31,157,31,172,31,179,232,239,242,244,227,249,242,233,236,236,233,99,128,4,14,237,225,236,108,128,247,117,244,242,225,233,231,232,116,2,31,191,31,202,227,249,242,233,236,236,233,99,128,4,174,243,244,242,239,235,229,227,249,242,233,236,236,233,99,128,4,176,244,233,236,228,101,130,1,104,31,231,31,239,225,227,245,244,101,128,30,120,226,229,236,239,119,128,30,116,86,136,0,86,32,11,32,20,32,31,32,60,32,67,32,79,32,91,32,99,227,233,242,227,236,101,128,36,203,228,
239,244,226,229,236,239,119,128,30,126,101,2,32,37,32,48,227,249,242,233,236,236,233,99,128,4,18,247,225,242,237,229,238,233,225,110,128,5,78,232,239,239,107,128,1,178,237,239,238,239,243,240,225,227,101,128,255,54,239,225,242,237,229,238,233,225,110,128,5,72,243,237,225,236,108,128,247,118,244,233,236,228,101,128,30,124,87,134,0,87,32,123,32,131,32,154,32,194,32,202,32,214,225,227,245,244,101,128,30,130,227,233,242,99,2,32,140,32,145,236,101,128,36,204,245,237,230,236,229,120,128,1,116,100,2,32,
160,32,170,233,229,242,229,243,233,115,128,30,132,239,116,2,32,177,32,186,225,227,227,229,238,116,128,30,134,226,229,236,239,119,128,30,136,231,242,225,246,101,128,30,128,237,239,238,239,243,240,225,227,101,128,255,55,243,237,225,236,108,128,247,119,88,134,0,88,32,238,32,247,33,18,33,31,33,35,33,47,227,233,242,227,236,101,128,36,205,100,2,32,253,33,7,233,229,242,229,243,233,115,128,30,140,239,244,225,227,227,229,238,116,128,30,138,229,232,225,242,237,229,238,233,225,110,128,5,61,105,128,3,158,237,
239,238,239,243,240,225,227,101,128,255,56,243,237,225,236,108,128,247,120,89,139,0,89,33,81,33,116,33,139,33,189,33,228,33,236,33,253,34,40,34,52,34,60,34,68,97,2,33,87,33,104,227,245,244,101,129,0,221,33,96,243,237,225,236,108,128,247,253,244,227,249,242,233,236,236,233,99,128,4,98,227,233,242,99,2,33,125,33,130,236,101,128,36,206,245,237,230,236,229,120,128,1,118,100,2,33,145,33,165,233,229,242,229,243,233,115,129,1,120,33,157,243,237,225,236,108,128,247,255,239,116,2,33,172,33,181,225,227,227,
229,238,116,128,30,142,226,229,236,239,119,128,30,244,229,114,2,33,196,33,208,233,227,249,242,233,236,236,233,99,128,4,43,245,228,233,229,242,229,243,233,243,227,249,242,233,236,236,233,99,128,4,248,231,242,225,246,101,128,30,242,232,239,239,107,129,1,179,33,245,225,226,239,246,101,128,30,246,105,3,34,5,34,16,34,27,225,242,237,229,238,233,225,110,128,5,69,227,249,242,233,236,236,233,99,128,4,7,247,238,225,242,237,229,238,233,225,110,128,5,82,237,239,238,239,243,240,225,227,101,128,255,57,243,237,
225,236,108,128,247,121,244,233,236,228,101,128,30,248,245,115,2,34,75,34,113,226,233,103,2,34,83,34,94,227,249,242,233,236,236,233,99,128,4,106,233,239,244,233,230,233,229,228,227,249,242,233,236,236,233,99,128,4,108,236,233,244,244,236,101,2,34,124,34,135,227,249,242,233,236,236,233,99,128,4,102,233,239,244,233,230,233,229,228,227,249,242,233,236,236,233,99,128,4,104,90,136,0,90,34,174,34,198,34,243,35,14,35,81,35,173,35,185,35,197,97,2,34,180,34,191,225,242,237,229,238,233,225,110,128,5,54,227,
245,244,101,128,1,121,99,2,34,204,34,221,225,242,239,110,129,1,125,34,213,243,237,225,236,108,128,246,255,233,242,99,2,34,229,34,234,236,101,128,36,207,245,237,230,236,229,120,128,30,144,228,239,116,130,1,123,34,253,35,6,225,227,227,229,238,116,128,1,123,226,229,236,239,119,128,30,146,101,3,35,22,35,33,35,76,227,249,242,233,236,236,233,99,128,4,23,100,2,35,39,35,58,229,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,152,233,229,242,229,243,233,243,227,249,242,233,236,236,233,99,128,
4,222,244,97,128,3,150,232,101,4,35,92,35,103,35,119,35,130,225,242,237,229,238,233,225,110,128,5,58,226,242,229,246,229,227,249,242,233,236,236,233,99,128,4,193,227,249,242,233,236,236,233,99,128,4,22,100,2,35,136,35,155,229,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,150,233,229,242,229,243,233,243,227,249,242,233,236,236,233,99,128,4,220,236,233,238,229,226,229,236,239,119,128,30,148,237,239,238,239,243,240,225,227,101,128,255,58,115,2,35,203,35,210,237,225,236,108,128,247,
122,244,242,239,235,101,128,1,181,97,149,0,97,36,8,36,144,37,35,37,211,38,55,38,91,45,10,45,47,45,74,46,43,46,81,47,170,47,242,48,197,48,206,49,79,51,87,52,77,52,124,53,19,53,33,97,7,36,24,36,34,36,41,36,48,36,73,36,89,36,100,226,229,238,231,225,236,105,128,9,134,227,245,244,101,128,0,225,228,229,246,97,128,9,6,231,117,2,36,55,36,64,234,225,242,225,244,105,128,10,134,242,237,245,235,232,105,128,10,6,237,225,244,242,225,231,245,242,237,245,235,232,105,128,10,62,242,245,243,241,245,225,242,101,128,
51,3,246,239,247,229,236,243,233,231,110,3,36,116,36,126,36,133,226,229,238,231,225,236,105,128,9,190,228,229,246,97,128,9,62,231,245,234,225,242,225,244,105,128,10,190,98,4,36,154,36,195,36,204,36,214,226,242,229,246,233,225,244,233,239,110,2,36,169,36,184,237,225,242,235,225,242,237,229,238,233,225,110,128,5,95,243,233,231,238,228,229,246,97,128,9,112,229,238,231,225,236,105,128,9,133,239,240,239,237,239,230,111,128,49,26,242,229,246,101,134,1,3,36,233,36,241,36,252,37,7,37,15,37,27,225,227,245,
244,101,128,30,175,227,249,242,233,236,236,233,99,128,4,209,228,239,244,226,229,236,239,119,128,30,183,231,242,225,246,101,128,30,177,232,239,239,235,225,226,239,246,101,128,30,179,244,233,236,228,101,128,30,181,99,4,37,45,37,52,37,131,37,201,225,242,239,110,128,1,206,233,242,99,2,37,60,37,65,236,101,128,36,208,245,237,230,236,229,120,133,0,226,37,84,37,92,37,103,37,111,37,123,225,227,245,244,101,128,30,165,228,239,244,226,229,236,239,119,128,30,173,231,242,225,246,101,128,30,167,232,239,239,235,
225,226,239,246,101,128,30,169,244,233,236,228,101,128,30,171,245,244,101,133,0,180,37,147,37,158,37,175,37,182,37,191,226,229,236,239,247,227,237,98,128,3,23,99,2,37,164,37,169,237,98,128,3,1,239,237,98,128,3,1,228,229,246,97,128,9,84,236,239,247,237,239,100,128,2,207,244,239,238,229,227,237,98,128,3,65,249,242,233,236,236,233,99,128,4,48,100,5,37,223,37,233,37,247,37,253,38,31,226,236,231,242,225,246,101,128,2,1,228,225,235,231,245,242,237,245,235,232,105,128,10,113,229,246,97,128,9,5,233,229,242,
229,243,233,115,130,0,228,38,11,38,22,227,249,242,233,236,236,233,99,128,4,211,237,225,227,242,239,110,128,1,223,239,116,2,38,38,38,46,226,229,236,239,119,128,30,161,237,225,227,242,239,110,128,1,225,101,131,0,230,38,65,38,73,38,82,225,227,245,244,101,128,1,253,235,239,242,229,225,110,128,49,80,237,225,227,242,239,110,128,1,227,230,233,105,6,38,107,38,127,41,64,41,70,41,85,44,185,48,2,38,113,38,120,176,178,176,56,128,32,21,184,185,180,49,128,32,164,177,48,3,38,136,40,160,41,39,48,9,38,156,38,176,
38,238,39,44,39,106,39,168,39,230,40,36,40,98,49,3,38,164,38,168,38,172,55,128,4,16,56,128,4,17,57,128,4,18,50,10,38,198,38,202,38,206,38,210,38,214,38,218,38,222,38,226,38,230,38,234,48,128,4,19,49,128,4,20,50,128,4,21,51,128,4,1,52,128,4,22,53,128,4,23,54,128,4,24,55,128,4,25,56,128,4,26,57,128,4,27,51,10,39,4,39,8,39,12,39,16,39,20,39,24,39,28,39,32,39,36,39,40,48,128,4,28,49,128,4,29,50,128,4,30,51,128,4,31,52,128,4,32,53,128,4,33,54,128,4,34,55,128,4,35,56,128,4,36,57,128,4,37,52,10,39,66,39,
70,39,74,39,78,39,82,39,86,39,90,39,94,39,98,39,102,48,128,4,38,49,128,4,39,50,128,4,40,51,128,4,41,52,128,4,42,53,128,4,43,54,128,4,44,55,128,4,45,56,128,4,46,57,128,4,47,53,10,39,128,39,132,39,136,39,140,39,144,39,148,39,152,39,156,39,160,39,164,48,128,4,144,49,128,4,2,50,128,4,3,51,128,4,4,52,128,4,5,53,128,4,6,54,128,4,7,55,128,4,8,56,128,4,9,57,128,4,10,54,10,39,190,39,194,39,198,39,202,39,206,39,210,39,214,39,218,39,222,39,226,48,128,4,11,49,128,4,12,50,128,4,14,51,128,246,196,52,128,246,197,
53,128,4,48,54,128,4,49,55,128,4,50,56,128,4,51,57,128,4,52,55,10,39,252,40,0,40,4,40,8,40,12,40,16,40,20,40,24,40,28,40,32,48,128,4,53,49,128,4,81,50,128,4,54,51,128,4,55,52,128,4,56,53,128,4,57,54,128,4,58,55,128,4,59,56,128,4,60,57,128,4,61,56,10,40,58,40,62,40,66,40,70,40,74,40,78,40,82,40,86,40,90,40,94,48,128,4,62,49,128,4,63,50,128,4,64,51,128,4,65,52,128,4,66,53,128,4,67,54,128,4,68,55,128,4,69,56,128,4,70,57,128,4,71,57,10,40,120,40,124,40,128,40,132,40,136,40,140,40,144,40,148,40,152,40,
156,48,128,4,72,49,128,4,73,50,128,4,74,51,128,4,75,52,128,4,76,53,128,4,77,54,128,4,78,55,128,4,79,56,128,4,145,57,128,4,82,49,4,40,170,40,232,40,237,41,7,48,10,40,192,40,196,40,200,40,204,40,208,40,212,40,216,40,220,40,224,40,228,48,128,4,83,49,128,4,84,50,128,4,85,51,128,4,86,52,128,4,87,53,128,4,88,54,128,4,89,55,128,4,90,56,128,4,91,57,128,4,92,177,48,128,4,94,52,4,40,247,40,251,40,255,41,3,53,128,4,15,54,128,4,98,55,128,4,114,56,128,4,116,57,5,41,19,41,23,41,27,41,31,41,35,50,128,246,198,51,
128,4,95,52,128,4,99,53,128,4,115,54,128,4,117,56,2,41,45,41,59,51,2,41,51,41,55,49,128,246,199,50,128,246,200,180,54,128,4,217,178,185,57,128,32,14,179,48,2,41,77,41,81,48,128,32,15,49,128,32,13,181,55,7,41,102,41,172,42,237,43,58,44,15,44,108,44,179,51,2,41,108,41,122,56,2,41,114,41,118,49,128,6,106,56,128,6,12,57,8,41,140,41,144,41,148,41,152,41,156,41,160,41,164,41,168,50,128,6,96,51,128,6,97,52,128,6,98,53,128,6,99,54,128,6,100,55,128,6,101,56,128,6,102,57,128,6,103,52,7,41,188,41,220,42,26,
42,88,42,120,42,176,42,232,48,5,41,200,41,204,41,208,41,212,41,216,48,128,6,104,49,128,6,105,51,128,6,27,55,128,6,31,57,128,6,33,49,10,41,242,41,246,41,250,41,254,42,2,42,6,42,10,42,14,42,18,42,22,48,128,6,34,49,128,6,35,50,128,6,36,51,128,6,37,52,128,6,38,53,128,6,39,54,128,6,40,55,128,6,41,56,128,6,42,57,128,6,43,50,10,42,48,42,52,42,56,42,60,42,64,42,68,42,72,42,76,42,80,42,84,48,128,6,44,49,128,6,45,50,128,6,46,51,128,6,47,52,128,6,48,53,128,6,49,54,128,6,50,55,128,6,51,56,128,6,52,57,128,6,53,
51,5,42,100,42,104,42,108,42,112,42,116,48,128,6,54,49,128,6,55,50,128,6,56,51,128,6,57,52,128,6,58,52,9,42,140,42,144,42,148,42,152,42,156,42,160,42,164,42,168,42,172,48,128,6,64,49,128,6,65,50,128,6,66,51,128,6,67,52,128,6,68,53,128,6,69,54,128,6,70,56,128,6,72,57,128,6,73,53,9,42,196,42,200,42,204,42,208,42,212,42,216,42,220,42,224,42,228,48,128,6,74,49,128,6,75,50,128,6,76,51,128,6,77,52,128,6,78,53,128,6,79,54,128,6,80,55,128,6,81,56,128,6,82,183,48,128,6,71,53,3,42,245,43,21,43,53,48,5,43,1,
43,5,43,9,43,13,43,17,53,128,6,164,54,128,6,126,55,128,6,134,56,128,6,152,57,128,6,175,49,5,43,33,43,37,43,41,43,45,43,49,49,128,6,121,50,128,6,136,51,128,6,145,52,128,6,186,57,128,6,210,179,52,128,6,213,54,7,43,74,43,79,43,84,43,89,43,127,43,189,43,251,179,54,128,32,170,180,53,128,5,190,181,56,128,5,195,54,6,43,103,43,107,43,111,43,115,43,119,43,123,52,128,5,208,53,128,5,209,54,128,5,210,55,128,5,211,56,128,5,212,57,128,5,213,55,10,43,149,43,153,43,157,43,161,43,165,43,169,43,173,43,177,43,181,43,
185,48,128,5,214,49,128,5,215,50,128,5,216,51,128,5,217,52,128,5,218,53,128,5,219,54,128,5,220,55,128,5,221,56,128,5,222,57,128,5,223,56,10,43,211,43,215,43,219,43,223,43,227,43,231,43,235,43,239,43,243,43,247,48,128,5,224,49,128,5,225,50,128,5,226,51,128,5,227,52,128,5,228,53,128,5,229,54,128,5,230,55,128,5,231,56,128,5,232,57,128,5,233,57,3,44,3,44,7,44,11,48,128,5,234,52,128,251,42,53,128,251,43,55,4,44,25,44,39,44,59,44,64,48,2,44,31,44,35,48,128,251,75,53,128,251,31,49,3,44,47,44,51,44,55,54,
128,5,240,55,128,5,241,56,128,5,242,178,51,128,251,53,57,7,44,80,44,84,44,88,44,92,44,96,44,100,44,104,51,128,5,180,52,128,5,181,53,128,5,182,54,128,5,187,55,128,5,184,56,128,5,183,57,128,5,176,56,3,44,116,44,160,44,165,48,7,44,132,44,136,44,140,44,144,44,148,44,152,44,156,48,128,5,178,49,128,5,177,50,128,5,179,51,128,5,194,52,128,5,193,54,128,5,185,55,128,5,188,179,57,128,5,189,52,2,44,171,44,175,49,128,5,191,50,128,5,192,185,178,57,128,2,188,54,3,44,193,44,252,45,3,49,4,44,203,44,219,44,225,44,
246,50,2,44,209,44,214,180,56,128,33,5,184,57,128,33,19,179,181,50,128,33,22,181,55,3,44,234,44,238,44,242,51,128,32,44,52,128,32,45,53,128,32,46,182,182,52,128,32,12,179,177,182,55,128,6,109,180,185,179,55,128,2,189,103,2,45,16,45,23,242,225,246,101,128,0,224,117,2,45,29,45,38,234,225,242,225,244,105,128,10,133,242,237,245,235,232,105,128,10,5,104,2,45,53,45,63,233,242,225,231,225,238,97,128,48,66,239,239,235,225,226,239,246,101,128,30,163,105,7,45,90,45,115,45,122,45,134,45,159,45,175,45,255,98,
2,45,96,45,105,229,238,231,225,236,105,128,9,144,239,240,239,237,239,230,111,128,49,30,228,229,246,97,128,9,16,229,227,249,242,233,236,236,233,99,128,4,213,231,117,2,45,141,45,150,234,225,242,225,244,105,128,10,144,242,237,245,235,232,105,128,10,16,237,225,244,242,225,231,245,242,237,245,235,232,105,128,10,72,110,5,45,187,45,196,45,210,45,226,45,241,225,242,225,226,233,99,128,6,57,230,233,238,225,236,225,242,225,226,233,99,128,254,202,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,203,
237,229,228,233,225,236,225,242,225,226,233,99,128,254,204,246,229,242,244,229,228,226,242,229,246,101,128,2,3,246,239,247,229,236,243,233,231,110,3,46,15,46,25,46,32,226,229,238,231,225,236,105,128,9,200,228,229,246,97,128,9,72,231,245,234,225,242,225,244,105,128,10,200,107,2,46,49,46,73,225,244,225,235,225,238,97,129,48,162,46,61,232,225,236,230,247,233,228,244,104,128,255,113,239,242,229,225,110,128,49,79,108,3,46,89,47,145,47,154,101,2,46,95,47,140,102,136,5,208,46,115,46,124,46,139,46,153,46,
242,47,0,47,111,47,125,225,242,225,226,233,99,128,6,39,228,225,231,229,243,232,232,229,226,242,229,119,128,251,48,230,233,238,225,236,225,242,225,226,233,99,128,254,142,104,2,46,159,46,234,225,237,250,97,2,46,168,46,201,225,226,239,246,101,2,46,178,46,187,225,242,225,226,233,99,128,6,35,230,233,238,225,236,225,242,225,226,233,99,128,254,132,226,229,236,239,119,2,46,211,46,220,225,242,225,226,233,99,128,6,37,230,233,238,225,236,225,242,225,226,233,99,128,254,136,229,226,242,229,119,128,5,208,236,225,
237,229,228,232,229,226,242,229,119,128,251,79,237,97,2,47,7,47,43,228,228,225,225,226,239,246,101,2,47,20,47,29,225,242,225,226,233,99,128,6,34,230,233,238,225,236,225,242,225,226,233,99,128,254,130,235,243,245,242,97,4,47,57,47,66,47,80,47,96,225,242,225,226,233,99,128,6,73,230,233,238,225,236,225,242,225,226,233,99,128,254,240,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,243,237,229,228,233,225,236,225,242,225,226,233,99,128,254,244,240,225,244,225,232,232,229,226,242,229,119,128,
251,46,241,225,237,225,244,243,232,229,226,242,229,119,128,251,47,240,104,128,33,53,236,229,241,245,225,108,128,34,76,240,232,97,129,3,177,47,162,244,239,238,239,115,128,3,172,109,4,47,180,47,188,47,199,47,233,225,227,242,239,110,128,1,1,239,238,239,243,240,225,227,101,128,255,65,240,229,242,243,225,238,100,130,0,38,47,213,47,225,237,239,238,239,243,240,225,227,101,128,255,6,243,237,225,236,108,128,247,38,243,241,245,225,242,101,128,51,194,110,4,47,252,48,7,48,129,48,139,226,239,240,239,237,239,230,
111,128,49,34,103,4,48,17,48,28,48,42,48,121,226,239,240,239,237,239,230,111,128,49,36,235,232,225,238,235,232,245,244,232,225,105,128,14,90,236,101,131,34,32,48,53,48,106,48,113,226,242,225,227,235,229,116,2,48,65,48,85,236,229,230,116,129,48,8,48,74,246,229,242,244,233,227,225,108,128,254,63,242,233,231,232,116,129,48,9,48,95,246,229,242,244,233,227,225,108,128,254,64,236,229,230,116,128,35,41,242,233,231,232,116,128,35,42,243,244,242,239,109,128,33,43,239,244,229,236,229,233,97,128,3,135,117,2,
48,145,48,157,228,225,244,244,225,228,229,246,97,128,9,82,243,246,225,242,97,3,48,169,48,179,48,186,226,229,238,231,225,236,105,128,9,130,228,229,246,97,128,9,2,231,245,234,225,242,225,244,105,128,10,130,239,231,239,238,229,107,128,1,5,112,3,48,214,48,238,49,12,97,2,48,220,48,232,225,244,239,243,241,245,225,242,101,128,51,0,242,229,110,128,36,156,239,243,244,242,239,240,232,101,2,48,251,49,6,225,242,237,229,238,233,225,110,128,5,90,237,239,100,128,2,188,112,2,49,18,49,23,236,101,128,248,255,242,111,
2,49,30,49,38,225,227,232,229,115,128,34,80,120,2,49,44,49,64,229,241,245,225,108,129,34,72,49,54,239,242,233,237,225,231,101,128,34,82,233,237,225,244,229,236,249,229,241,245,225,108,128,34,69,114,4,49,89,49,116,49,120,49,165,225,229,97,2,49,97,49,107,229,235,239,242,229,225,110,128,49,142,235,239,242,229,225,110,128,49,141,99,128,35,18,105,2,49,126,49,140,231,232,244,232,225,236,230,242,233,238,103,128,30,154,238,103,130,0,229,49,149,49,157,225,227,245,244,101,128,1,251,226,229,236,239,119,128,
30,1,242,239,119,8,49,185,49,192,50,65,50,131,50,181,50,236,51,3,51,78,226,239,244,104,128,33,148,100,3,49,200,49,239,50,30,225,243,104,4,49,212,49,219,49,226,49,234,228,239,247,110,128,33,227,236,229,230,116,128,33,224,242,233,231,232,116,128,33,226,245,112,128,33,225,226,108,5,49,252,50,3,50,10,50,17,50,25,226,239,244,104,128,33,212,228,239,247,110,128,33,211,236,229,230,116,128,33,208,242,233,231,232,116,128,33,210,245,112,128,33,209,239,247,110,131,33,147,50,42,50,49,50,57,236,229,230,116,128,
33,153,242,233,231,232,116,128,33,152,247,232,233,244,101,128,33,233,104,2,50,71,50,122,229,225,100,4,50,83,50,93,50,103,50,114,228,239,247,238,237,239,100,128,2,197,236,229,230,244,237,239,100,128,2,194,242,233,231,232,244,237,239,100,128,2,195,245,240,237,239,100,128,2,196,239,242,233,250,229,120,128,248,231,236,229,230,116,131,33,144,50,144,50,161,50,173,228,226,108,129,33,208,50,152,243,244,242,239,235,101,128,33,205,239,246,229,242,242,233,231,232,116,128,33,198,247,232,233,244,101,128,33,230,
242,233,231,232,116,132,33,146,50,197,50,209,50,217,50,228,228,226,236,243,244,242,239,235,101,128,33,207,232,229,225,246,121,128,39,158,239,246,229,242,236,229,230,116,128,33,196,247,232,233,244,101,128,33,232,244,225,98,2,50,244,50,251,236,229,230,116,128,33,228,242,233,231,232,116,128,33,229,245,112,132,33,145,51,16,51,44,51,62,51,70,100,2,51,22,51,34,110,129,33,149,51,28,226,243,101,128,33,168,239,247,238,226,225,243,101,128,33,168,236,229,230,116,129,33,150,51,53,239,230,228,239,247,110,128,
33,197,242,233,231,232,116,128,33,151,247,232,233,244,101,128,33,231,246,229,242,244,229,120,128,248,230,115,5,51,99,51,175,51,220,52,47,52,57,99,2,51,105,51,157,233,105,2,51,112,51,135,227,233,242,227,245,109,129,0,94,51,123,237,239,238,239,243,240,225,227,101,128,255,62,244,233,236,228,101,129,0,126,51,145,237,239,238,239,243,240,225,227,101,128,255,94,242,233,240,116,129,2,81,51,166,244,245,242,238,229,100,128,2,82,237,225,236,108,2,51,184,51,195,232,233,242,225,231,225,238,97,128,48,65,235,225,
244,225,235,225,238,97,129,48,161,51,208,232,225,236,230,247,233,228,244,104,128,255,103,244,229,242,233,115,2,51,230,52,43,107,131,0,42,51,240,52,12,52,35,97,2,51,246,52,4,236,244,239,238,229,225,242,225,226,233,99,128,6,109,242,225,226,233,99,128,6,109,109,2,52,18,52,24,225,244,104,128,34,23,239,238,239,243,240,225,227,101,128,255,10,243,237,225,236,108,128,254,97,109,128,32,66,245,240,229,242,233,239,114,128,246,233,249,237,240,244,239,244,233,227,225,236,236,249,229,241,245,225,108,128,34,67,
116,132,0,64,52,89,52,96,52,108,52,116,233,236,228,101,128,0,227,237,239,238,239,243,240,225,227,101,128,255,32,243,237,225,236,108,128,254,107,245,242,238,229,100,128,2,80,117,6,52,138,52,163,52,170,52,195,52,215,52,231,98,2,52,144,52,153,229,238,231,225,236,105,128,9,148,239,240,239,237,239,230,111,128,49,32,228,229,246,97,128,9,20,231,117,2,52,177,52,186,234,225,242,225,244,105,128,10,148,242,237,245,235,232,105,128,10,20,236,229,238,231,244,232,237,225,242,235,226,229,238,231,225,236,105,128,
9,215,237,225,244,242,225,231,245,242,237,245,235,232,105,128,10,76,246,239,247,229,236,243,233,231,110,3,52,247,53,1,53,8,226,229,238,231,225,236,105,128,9,204,228,229,246,97,128,9,76,231,245,234,225,242,225,244,105,128,10,204,246,225,231,242,225,232,225,228,229,246,97,128,9,61,121,2,53,39,53,51,226,225,242,237,229,238,233,225,110,128,5,97,233,110,130,5,226,53,60,53,75,225,236,244,239,238,229,232,229,226,242,229,119,128,251,32,232,229,226,242,229,119,128,5,226,98,144,0,98,53,120,53,255,54,10,54,
19,54,44,55,85,55,147,55,220,57,146,57,158,57,201,57,209,57,219,59,89,59,113,59,122,97,7,53,136,53,146,53,170,53,177,53,202,53,226,53,237,226,229,238,231,225,236,105,128,9,172,227,235,243,236,225,243,104,129,0,92,53,158,237,239,238,239,243,240,225,227,101,128,255,60,228,229,246,97,128,9,44,231,117,2,53,184,53,193,234,225,242,225,244,105,128,10,172,242,237,245,235,232,105,128,10,44,104,2,53,208,53,218,233,242,225,231,225,238,97,128,48,112,244,244,232,225,105,128,14,63,235,225,244,225,235,225,238,97,
128,48,208,114,129,0,124,53,243,237,239,238,239,243,240,225,227,101,128,255,92,226,239,240,239,237,239,230,111,128,49,5,227,233,242,227,236,101,128,36,209,228,239,116,2,54,27,54,36,225,227,227,229,238,116,128,30,3,226,229,236,239,119,128,30,5,101,6,54,58,54,79,54,102,54,244,54,255,55,11,225,237,229,228,243,233,248,244,229,229,238,244,232,238,239,244,229,115,128,38,108,99,2,54,85,54,92,225,245,243,101,128,34,53,249,242,233,236,236,233,99,128,4,49,104,5,54,114,54,123,54,137,54,167,54,226,225,242,225,
226,233,99,128,6,40,230,233,238,225,236,225,242,225,226,233,99,128,254,144,105,2,54,143,54,158,238,233,244,233,225,236,225,242,225,226,233,99,128,254,145,242,225,231,225,238,97,128,48,121,237,101,2,54,174,54,187,228,233,225,236,225,242,225,226,233,99,128,254,146,229,237,105,2,54,195,54,210,238,233,244,233,225,236,225,242,225,226,233,99,128,252,159,243,239,236,225,244,229,228,225,242,225,226,233,99,128,252,8,238,239,239,238,230,233,238,225,236,225,242,225,226,233,99,128,252,109,235,225,244,225,235,
225,238,97,128,48,217,238,225,242,237,229,238,233,225,110,128,5,98,116,132,5,209,55,23,55,43,55,63,55,72,97,129,3,178,55,29,243,249,237,226,239,236,231,242,229,229,107,128,3,208,228,225,231,229,243,104,129,251,49,55,54,232,229,226,242,229,119,128,251,49,232,229,226,242,229,119,128,5,209,242,225,230,229,232,229,226,242,229,119,128,251,76,104,2,55,91,55,141,97,3,55,99,55,109,55,116,226,229,238,231,225,236,105,128,9,173,228,229,246,97,128,9,45,231,117,2,55,123,55,132,234,225,242,225,244,105,128,10,173,
242,237,245,235,232,105,128,10,45,239,239,107,128,2,83,105,5,55,159,55,170,55,181,55,195,55,209,232,233,242,225,231,225,238,97,128,48,115,235,225,244,225,235,225,238,97,128,48,211,236,225,226,233,225,236,227,236,233,227,107,128,2,152,238,228,233,231,245,242,237,245,235,232,105,128,10,2,242,245,243,241,245,225,242,101,128,51,49,108,3,55,228,57,129,57,140,97,2,55,234,57,124,227,107,6,55,249,56,2,56,39,56,188,56,243,57,39,227,233,242,227,236,101,128,37,207,100,2,56,8,56,17,233,225,237,239,238,100,128,
37,198,239,247,238,240,239,233,238,244,233,238,231,244,242,233,225,238,231,236,101,128,37,188,108,2,56,45,56,148,101,2,56,51,56,87,230,244,240,239,233,238,244,233,238,103,2,56,66,56,76,240,239,233,238,244,229,114,128,37,196,244,242,233,225,238,231,236,101,128,37,192,238,244,233,227,245,236,225,242,226,242,225,227,235,229,116,2,56,107,56,127,236,229,230,116,129,48,16,56,116,246,229,242,244,233,227,225,108,128,254,59,242,233,231,232,116,129,48,17,56,137,246,229,242,244,233,227,225,108,128,254,60,239,
247,229,114,2,56,157,56,172,236,229,230,244,244,242,233,225,238,231,236,101,128,37,227,242,233,231,232,244,244,242,233,225,238,231,236,101,128,37,226,114,2,56,194,56,205,229,227,244,225,238,231,236,101,128,37,172,233,231,232,244,240,239,233,238,244,233,238,103,2,56,222,56,232,240,239,233,238,244,229,114,128,37,186,244,242,233,225,238,231,236,101,128,37,182,115,3,56,251,57,25,57,33,109,2,57,1,57,13,225,236,236,243,241,245,225,242,101,128,37,170,233,236,233,238,231,230,225,227,101,128,38,59,241,245,
225,242,101,128,37,160,244,225,114,128,38,5,245,240,112,2,57,47,57,85,229,114,2,57,54,57,69,236,229,230,244,244,242,233,225,238,231,236,101,128,37,228,242,233,231,232,244,244,242,233,225,238,231,236,101,128,37,229,239,233,238,244,233,238,103,2,57,97,57,113,243,237,225,236,236,244,242,233,225,238,231,236,101,128,37,180,244,242,233,225,238,231,236,101,128,37,178,238,107,128,36,35,233,238,229,226,229,236,239,119,128,30,7,239,227,107,128,37,136,237,239,238,239,243,240,225,227,101,128,255,66,111,3,57,
166,57,179,57,190,226,225,233,237,225,233,244,232,225,105,128,14,26,232,233,242,225,231,225,238,97,128,48,124,235,225,244,225,235,225,238,97,128,48,220,240,225,242,229,110,128,36,157,241,243,241,245,225,242,101,128,51,195,114,4,57,229,58,223,59,40,59,79,225,99,2,57,236,58,130,101,3,57,244,57,249,58,61,229,120,128,248,244,236,229,230,116,133,0,123,58,10,58,15,58,37,58,45,58,50,226,116,128,248,243,109,2,58,21,58,26,233,100,128,248,242,239,238,239,243,240,225,227,101,128,255,91,243,237,225,236,108,128,
254,91,244,112,128,248,241,246,229,242,244,233,227,225,108,128,254,55,242,233,231,232,116,133,0,125,58,79,58,84,58,106,58,114,58,119,226,116,128,248,254,109,2,58,90,58,95,233,100,128,248,253,239,238,239,243,240,225,227,101,128,255,93,243,237,225,236,108,128,254,92,244,112,128,248,252,246,229,242,244,233,227,225,108,128,254,56,235,229,116,2,58,138,58,180,236,229,230,116,132,0,91,58,153,58,158,58,163,58,175,226,116,128,248,240,229,120,128,248,239,237,239,238,239,243,240,225,227,101,128,255,59,244,112,
128,248,238,242,233,231,232,116,132,0,93,58,196,58,201,58,206,58,218,226,116,128,248,251,229,120,128,248,250,237,239,238,239,243,240,225,227,101,128,255,61,244,112,128,248,249,229,246,101,131,2,216,58,235,58,246,58,252,226,229,236,239,247,227,237,98,128,3,46,227,237,98,128,3,6,233,238,246,229,242,244,229,100,3,59,11,59,22,59,28,226,229,236,239,247,227,237,98,128,3,47,227,237,98,128,3,17,228,239,245,226,236,229,227,237,98,128,3,97,233,228,231,101,2,59,49,59,60,226,229,236,239,247,227,237,98,128,3,
42,233,238,246,229,242,244,229,228,226,229,236,239,247,227,237,98,128,3,58,239,235,229,238,226,225,114,128,0,166,115,2,59,95,59,103,244,242,239,235,101,128,1,128,245,240,229,242,233,239,114,128,246,234,244,239,240,226,225,114,128,1,131,117,3,59,130,59,141,59,152,232,233,242,225,231,225,238,97,128,48,118,235,225,244,225,235,225,238,97,128,48,214,236,108,2,59,159,59,189,229,116,130,32,34,59,168,59,178,233,238,246,229,242,243,101,128,37,216,239,240,229,242,225,244,239,114,128,34,25,243,229,249,101,128,
37,206,99,143,0,99,59,230,60,179,60,190,60,254,61,29,61,122,63,33,64,17,64,117,64,166,67,158,67,166,67,176,67,188,67,221,97,9,59,250,60,5,60,15,60,22,60,29,60,54,60,64,60,116,60,125,225,242,237,229,238,233,225,110,128,5,110,226,229,238,231,225,236,105,128,9,154,227,245,244,101,128,1,7,228,229,246,97,128,9,26,231,117,2,60,36,60,45,234,225,242,225,244,105,128,10,154,242,237,245,235,232,105,128,10,26,236,243,241,245,225,242,101,128,51,136,238,228,242,225,226,233,238,228,117,4,60,82,60,92,60,98,60,105,
226,229,238,231,225,236,105,128,9,129,227,237,98,128,3,16,228,229,246,97,128,9,1,231,245,234,225,242,225,244,105,128,10,129,240,243,236,239,227,107,128,33,234,114,3,60,133,60,139,60,165,229,239,102,128,33,5,239,110,130,2,199,60,148,60,159,226,229,236,239,247,227,237,98,128,3,44,227,237,98,128,3,12,242,233,225,231,229,242,229,244,245,242,110,128,33,181,226,239,240,239,237,239,230,111,128,49,24,99,4,60,200,60,207,60,226,60,248,225,242,239,110,128,1,13,229,228,233,236,236,97,129,0,231,60,218,225,227,
245,244,101,128,30,9,233,242,99,2,60,234,60,239,236,101,128,36,210,245,237,230,236,229,120,128,1,9,245,242,108,128,2,85,100,2,61,4,61,20,239,116,129,1,11,61,11,225,227,227,229,238,116,128,1,11,243,241,245,225,242,101,128,51,197,101,2,61,35,61,51,228,233,236,236,97,129,0,184,61,45,227,237,98,128,3,39,238,116,132,0,162,61,64,61,88,61,100,61,111,105,2,61,70,61,78,231,242,225,228,101,128,33,3,238,230,229,242,233,239,114,128,246,223,237,239,238,239,243,240,225,227,101,128,255,224,239,236,228,243,244,249,
236,101,128,247,162,243,245,240,229,242,233,239,114,128,246,224,104,5,61,134,61,197,61,208,62,136,62,228,97,4,61,144,61,155,61,165,61,172,225,242,237,229,238,233,225,110,128,5,121,226,229,238,231,225,236,105,128,9,155,228,229,246,97,128,9,27,231,117,2,61,179,61,188,234,225,242,225,244,105,128,10,155,242,237,245,235,232,105,128,10,27,226,239,240,239,237,239,230,111,128,49,20,101,6,61,222,61,242,62,10,62,78,62,90,62,111,225,226,235,232,225,243,233,225,238,227,249,242,233,236,236,233,99,128,4,189,99,
2,61,248,62,0,235,237,225,242,107,128,39,19,249,242,233,236,236,233,99,128,4,71,100,2,62,16,62,60,229,243,227,229,238,228,229,114,2,62,29,62,49,225,226,235,232,225,243,233,225,238,227,249,242,233,236,236,233,99,128,4,191,227,249,242,233,236,236,233,99,128,4,183,233,229,242,229,243,233,243,227,249,242,233,236,236,233,99,128,4,245,232,225,242,237,229,238,233,225,110,128,5,115,235,232,225,235,225,243,243,233,225,238,227,249,242,233,236,236,233,99,128,4,204,246,229,242,244,233,227,225,236,243,244,242,
239,235,229,227,249,242,233,236,236,233,99,128,4,185,105,129,3,199,62,142,229,245,227,104,4,62,155,62,190,62,205,62,214,97,2,62,161,62,176,227,233,242,227,236,229,235,239,242,229,225,110,128,50,119,240,225,242,229,238,235,239,242,229,225,110,128,50,23,227,233,242,227,236,229,235,239,242,229,225,110,128,50,105,235,239,242,229,225,110,128,49,74,240,225,242,229,238,235,239,242,229,225,110,128,50,9,111,2,62,234,63,28,227,104,3,62,243,63,9,63,19,225,110,2,62,250,63,2,231,244,232,225,105,128,14,10,244,
232,225,105,128,14,8,233,238,231,244,232,225,105,128,14,9,239,229,244,232,225,105,128,14,12,239,107,128,1,136,105,2,63,39,63,141,229,245,99,5,63,53,63,88,63,103,63,112,63,126,97,2,63,59,63,74,227,233,242,227,236,229,235,239,242,229,225,110,128,50,118,240,225,242,229,238,235,239,242,229,225,110,128,50,22,227,233,242,227,236,229,235,239,242,229,225,110,128,50,104,235,239,242,229,225,110,128,49,72,240,225,242,229,238,235,239,242,229,225,110,128,50,8,245,240,225,242,229,238,235,239,242,229,225,110,128,
50,28,242,99,2,63,148,63,243,236,101,132,37,203,63,161,63,172,63,177,63,201,237,245,236,244,233,240,236,121,128,34,151,239,116,128,34,153,112,2,63,183,63,189,236,245,115,128,34,149,239,243,244,225,236,237,225,242,107,128,48,54,247,233,244,104,2,63,210,63,226,236,229,230,244,232,225,236,230,226,236,225,227,107,128,37,208,242,233,231,232,244,232,225,236,230,226,236,225,227,107,128,37,209,245,237,230,236,229,120,130,2,198,64,0,64,11,226,229,236,239,247,227,237,98,128,3,45,227,237,98,128,3,2,108,3,64,
25,64,31,64,85,229,225,114,128,35,39,233,227,107,4,64,43,64,54,64,63,64,73,225,236,246,229,239,236,225,114,128,1,194,228,229,238,244,225,108,128,1,192,236,225,244,229,242,225,108,128,1,193,242,229,244,242,239,230,236,229,120,128,1,195,245,98,129,38,99,64,92,243,245,233,116,2,64,101,64,109,226,236,225,227,107,128,38,99,247,232,233,244,101,128,38,103,109,3,64,125,64,139,64,150,227,245,226,229,228,243,241,245,225,242,101,128,51,164,239,238,239,243,240,225,227,101,128,255,67,243,241,245,225,242,229,228,
243,241,245,225,242,101,128,51,160,111,8,64,184,64,195,65,26,65,224,66,253,67,28,67,135,67,144,225,242,237,229,238,233,225,110,128,5,129,236,239,110,131,0,58,64,207,64,232,64,251,237,239,110,2,64,215,64,223,229,244,225,242,121,128,32,161,239,243,240,225,227,101,128,255,26,115,2,64,238,64,244,233,231,110,128,32,161,237,225,236,108,128,254,85,244,242,233,225,238,231,245,236,225,114,2,65,10,65,20,232,225,236,230,237,239,100,128,2,209,237,239,100,128,2,208,109,2,65,32,65,217,237,97,134,0,44,65,49,65,
113,65,124,65,136,65,166,65,189,97,3,65,57,65,83,65,91,226,239,246,101,2,65,66,65,72,227,237,98,128,3,19,242,233,231,232,244,227,237,98,128,3,21,227,227,229,238,116,128,246,195,114,2,65,97,65,104,225,226,233,99,128,6,12,237,229,238,233,225,110,128,5,93,233,238,230,229,242,233,239,114,128,246,225,237,239,238,239,243,240,225,227,101,128,255,12,242,229,246,229,242,243,229,100,2,65,149,65,160,225,226,239,246,229,227,237,98,128,3,20,237,239,100,128,2,189,115,2,65,172,65,179,237,225,236,108,128,254,80,
245,240,229,242,233,239,114,128,246,226,244,245,242,238,229,100,2,65,200,65,211,225,226,239,246,229,227,237,98,128,3,18,237,239,100,128,2,187,240,225,243,115,128,38,60,110,2,65,230,65,239,231,242,245,229,238,116,128,34,69,116,2,65,245,66,3,239,245,242,233,238,244,229,231,242,225,108,128,34,46,242,239,108,142,35,3,66,37,66,43,66,58,66,73,66,117,66,162,66,176,66,181,66,186,66,191,66,197,66,202,66,243,66,248,193,195,75,128,0,6,66,2,66,49,66,54,197,76,128,0,7,83,128,0,8,67,2,66,64,66,69,193,78,128,0,
24,82,128,0,13,68,3,66,81,66,107,66,112,67,4,66,91,66,95,66,99,66,103,49,128,0,17,50,128,0,18,51,128,0,19,52,128,0,20,197,76,128,0,127,204,69,128,0,16,69,5,66,129,66,133,66,138,66,143,66,148,77,128,0,25,206,81,128,0,5,207,84,128,0,4,211,67,128,0,27,84,2,66,154,66,158,66,128,0,23,88,128,0,3,70,2,66,168,66,172,70,128,0,12,83,128,0,28,199,83,128,0,29,200,84,128,0,9,204,70,128,0,10,206,193,75,128,0,21,210,83,128,0,30,83,5,66,214,66,218,66,228,66,233,66,238,73,128,0,15,79,129,0,14,66,224,84,128,0,2,212,
88,128,0,1,213,66,128,0,26,217,78,128,0,22,213,83,128,0,31,214,84,128,0,11,240,249,242,233,231,232,116,129,0,169,67,9,115,2,67,15,67,21,225,238,115,128,248,233,229,242,233,102,128,246,217,114,2,67,34,67,118,238,229,242,226,242,225,227,235,229,116,2,67,49,67,83,236,229,230,116,130,48,12,67,60,67,72,232,225,236,230,247,233,228,244,104,128,255,98,246,229,242,244,233,227,225,108,128,254,65,242,233,231,232,116,130,48,13,67,95,67,107,232,225,236,230,247,233,228,244,104,128,255,99,246,229,242,244,233,227,
225,108,128,254,66,240,239,242,225,244,233,239,238,243,241,245,225,242,101,128,51,127,243,241,245,225,242,101,128,51,199,246,229,242,235,231,243,241,245,225,242,101,128,51,198,240,225,242,229,110,128,36,158,242,245,250,229,233,242,111,128,32,162,243,244,242,229,244,227,232,229,100,128,2,151,245,114,2,67,195,67,213,236,121,2,67,202,67,208,225,238,100,128,34,207,239,114,128,34,206,242,229,238,227,121,128,0,164,249,114,4,67,232,67,240,67,247,67,255,194,242,229,246,101,128,246,209,198,236,229,120,128,
246,210,226,242,229,246,101,128,246,212,230,236,229,120,128,246,213,100,146,0,100,68,46,69,184,70,208,71,12,71,188,72,142,72,204,73,133,73,146,73,155,73,181,73,206,73,215,75,26,75,34,75,45,75,65,75,93,97,11,68,70,68,81,68,91,68,163,68,226,68,237,68,248,69,61,69,123,69,129,69,159,225,242,237,229,238,233,225,110,128,5,100,226,229,238,231,225,236,105,128,9,166,100,5,68,103,68,112,68,118,68,132,68,148,225,242,225,226,233,99,128,6,54,229,246,97,128,9,38,230,233,238,225,236,225,242,225,226,233,99,128,254,
190,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,191,237,229,228,233,225,236,225,242,225,226,233,99,128,254,192,103,3,68,171,68,188,68,202,229,243,104,129,5,188,68,179,232,229,226,242,229,119,128,5,188,231,229,114,129,32,32,68,196,228,226,108,128,32,33,117,2,68,208,68,217,234,225,242,225,244,105,128,10,166,242,237,245,235,232,105,128,10,38,232,233,242,225,231,225,238,97,128,48,96,235,225,244,225,235,225,238,97,128,48,192,108,3,69,0,69,9,69,47,225,242,225,226,233,99,128,6,47,229,116,
130,5,211,69,18,69,38,228,225,231,229,243,104,129,251,51,69,29,232,229,226,242,229,119,128,251,51,232,229,226,242,229,119,128,5,211,230,233,238,225,236,225,242,225,226,233,99,128,254,170,237,237,97,3,69,71,69,80,69,92,225,242,225,226,233,99,128,6,79,236,239,247,225,242,225,226,233,99,128,6,79,244,225,238,97,2,69,101,69,115,236,244,239,238,229,225,242,225,226,233,99,128,6,76,242,225,226,233,99,128,6,76,238,228,97,128,9,100,242,231,97,2,69,137,69,146,232,229,226,242,229,119,128,5,167,236,229,230,244,
232,229,226,242,229,119,128,5,167,243,233,225,240,238,229,245,237,225,244,225,227,249,242,233,236,236,233,227,227,237,98,128,4,133,98,3,69,192,70,189,70,199,108,9,69,212,69,220,70,77,70,85,70,101,70,112,70,130,70,144,70,155,199,242,225,246,101,128,246,211,97,2,69,226,70,27,238,231,236,229,226,242,225,227,235,229,116,2,69,242,70,6,236,229,230,116,129,48,10,69,251,246,229,242,244,233,227,225,108,128,254,61,242,233,231,232,116,129,48,11,70,16,246,229,242,244,233,227,225,108,128,254,62,114,2,70,33,70,
54,227,232,233,238,246,229,242,244,229,228,226,229,236,239,247,227,237,98,128,3,43,242,239,119,2,70,62,70,69,236,229,230,116,128,33,212,242,233,231,232,116,128,33,210,228,225,238,228,97,128,9,101,231,242,225,246,101,129,246,214,70,95,227,237,98,128,3,15,233,238,244,229,231,242,225,108,128,34,44,236,239,247,236,233,238,101,129,32,23,70,124,227,237,98,128,3,51,239,246,229,242,236,233,238,229,227,237,98,128,3,63,240,242,233,237,229,237,239,100,128,2,186,246,229,242,244,233,227,225,108,2,70,168,70,174,
226,225,114,128,32,22,236,233,238,229,225,226,239,246,229,227,237,98,128,3,14,239,240,239,237,239,230,111,128,49,9,243,241,245,225,242,101,128,51,200,99,4,70,218,70,225,70,234,71,5,225,242,239,110,128,1,15,229,228,233,236,236,97,128,30,17,233,242,99,2,70,242,70,247,236,101,128,36,211,245,237,230,236,229,248,226,229,236,239,119,128,30,19,242,239,225,116,128,1,17,100,4,71,22,71,103,71,113,71,164,97,4,71,32,71,42,71,49,71,74,226,229,238,231,225,236,105,128,9,161,228,229,246,97,128,9,33,231,117,2,71,
56,71,65,234,225,242,225,244,105,128,10,161,242,237,245,235,232,105,128,10,33,108,2,71,80,71,89,225,242,225,226,233,99,128,6,136,230,233,238,225,236,225,242,225,226,233,99,128,251,137,228,232,225,228,229,246,97,128,9,92,232,97,3,71,122,71,132,71,139,226,229,238,231,225,236,105,128,9,162,228,229,246,97,128,9,34,231,117,2,71,146,71,155,234,225,242,225,244,105,128,10,162,242,237,245,235,232,105,128,10,34,239,116,2,71,171,71,180,225,227,227,229,238,116,128,30,11,226,229,236,239,119,128,30,13,101,8,71,
206,72,3,72,10,72,35,72,45,72,56,72,101,72,137,99,2,71,212,71,249,233,237,225,236,243,229,240,225,242,225,244,239,114,2,71,230,71,239,225,242,225,226,233,99,128,6,107,240,229,242,243,233,225,110,128,6,107,249,242,233,236,236,233,99,128,4,52,231,242,229,101,128,0,176,232,105,2,72,17,72,26,232,229,226,242,229,119,128,5,173,242,225,231,225,238,97,128,48,103,233,227,239,240,244,233,99,128,3,239,235,225,244,225,235,225,238,97,128,48,199,108,2,72,62,72,85,229,244,101,2,72,70,72,77,236,229,230,116,128,35,
43,242,233,231,232,116,128,35,38,244,97,129,3,180,72,92,244,245,242,238,229,100,128,1,141,238,239,237,233,238,225,244,239,242,237,233,238,245,243,239,238,229,238,245,237,229,242,225,244,239,242,226,229,238,231,225,236,105,128,9,248,250,104,128,2,164,104,2,72,148,72,198,97,3,72,156,72,166,72,173,226,229,238,231,225,236,105,128,9,167,228,229,246,97,128,9,39,231,117,2,72,180,72,189,234,225,242,225,244,105,128,10,167,242,237,245,235,232,105,128,10,39,239,239,107,128,2,87,105,6,72,218,73,11,73,71,73,82,
73,93,73,103,97,2,72,224,72,246,236,249,244,233,235,225,244,239,238,239,115,129,3,133,72,240,227,237,98,128,3,68,237,239,238,100,129,38,102,72,255,243,245,233,244,247,232,233,244,101,128,38,98,229,242,229,243,233,115,133,0,168,73,30,73,38,73,49,73,55,73,63,225,227,245,244,101,128,246,215,226,229,236,239,247,227,237,98,128,3,36,227,237,98,128,3,8,231,242,225,246,101,128,246,216,244,239,238,239,115,128,3,133,232,233,242,225,231,225,238,97,128,48,98,235,225,244,225,235,225,238,97,128,48,194,244,244,
239,237,225,242,107,128,48,3,246,105,2,73,110,73,121,228,101,129,0,247,73,117,115,128,34,35,243,233,239,238,243,236,225,243,104,128,34,21,234,229,227,249,242,233,236,236,233,99,128,4,82,235,243,232,225,228,101,128,37,147,108,2,73,161,73,172,233,238,229,226,229,236,239,119,128,30,15,243,241,245,225,242,101,128,51,151,109,2,73,187,73,195,225,227,242,239,110,128,1,17,239,238,239,243,240,225,227,101,128,255,68,238,226,236,239,227,107,128,37,132,111,10,73,237,73,249,74,3,74,14,74,25,74,97,74,102,74,113,
74,228,74,254,227,232,225,228,225,244,232,225,105,128,14,14,228,229,235,244,232,225,105,128,14,20,232,233,242,225,231,225,238,97,128,48,105,235,225,244,225,235,225,238,97,128,48,201,236,236,225,114,132,0,36,74,40,74,51,74,63,74,74,233,238,230,229,242,233,239,114,128,246,227,237,239,238,239,243,240,225,227,101,128,255,4,239,236,228,243,244,249,236,101,128,247,36,115,2,74,80,74,87,237,225,236,108,128,254,105,245,240,229,242,233,239,114,128,246,228,238,103,128,32,171,242,245,243,241,245,225,242,101,
128,51,38,116,6,74,127,74,144,74,166,74,177,74,209,74,216,225,227,227,229,238,116,129,2,217,74,138,227,237,98,128,3,7,226,229,236,239,247,99,2,74,155,74,160,237,98,128,3,35,239,237,98,128,3,35,235,225,244,225,235,225,238,97,128,48,251,236,229,243,115,2,74,186,74,190,105,128,1,49,106,129,246,190,74,196,243,244,242,239,235,229,232,239,239,107,128,2,132,237,225,244,104,128,34,197,244,229,228,227,233,242,227,236,101,128,37,204,245,226,236,229,249,239,228,240,225,244,225,104,129,251,31,74,245,232,229,
226,242,229,119,128,251,31,247,238,244,225,227,107,2,75,9,75,20,226,229,236,239,247,227,237,98,128,3,30,237,239,100,128,2,213,240,225,242,229,110,128,36,159,243,245,240,229,242,233,239,114,128,246,235,116,2,75,51,75,57,225,233,108,128,2,86,239,240,226,225,114,128,1,140,117,2,75,71,75,82,232,233,242,225,231,225,238,97,128,48,101,235,225,244,225,235,225,238,97,128,48,197,122,132,1,243,75,105,75,114,75,133,75,170,225,236,244,239,238,101,128,2,163,99,2,75,120,75,127,225,242,239,110,128,1,198,245,242,
108,128,2,165,101,2,75,139,75,159,225,226,235,232,225,243,233,225,238,227,249,242,233,236,236,233,99,128,4,225,227,249,242,233,236,236,233,99,128,4,85,232,229,227,249,242,233,236,236,233,99,128,4,95,101,151,0,101,75,233,75,252,76,30,77,4,77,66,77,99,77,111,77,134,77,187,79,43,79,101,79,203,80,63,80,198,81,17,81,48,81,110,81,163,82,98,82,231,82,251,83,39,83,130,97,2,75,239,75,246,227,245,244,101,128,0,233,242,244,104,128,38,65,98,3,76,4,76,13,76,23,229,238,231,225,236,105,128,9,143,239,240,239,237,
239,230,111,128,49,28,242,229,246,101,128,1,21,99,5,76,42,76,115,76,129,76,161,76,250,97,2,76,48,76,109,238,228,242,97,3,76,59,76,66,76,77,228,229,246,97,128,9,13,231,245,234,225,242,225,244,105,128,10,141,246,239,247,229,236,243,233,231,110,2,76,91,76,98,228,229,246,97,128,9,69,231,245,234,225,242,225,244,105,128,10,197,242,239,110,128,1,27,229,228,233,236,236,225,226,242,229,246,101,128,30,29,104,2,76,135,76,146,225,242,237,229,238,233,225,110,128,5,101,249,233,247,238,225,242,237,229,238,233,225,
110,128,5,135,233,242,99,2,76,169,76,174,236,101,128,36,212,245,237,230,236,229,120,134,0,234,76,195,76,203,76,211,76,222,76,230,76,242,225,227,245,244,101,128,30,191,226,229,236,239,119,128,30,25,228,239,244,226,229,236,239,119,128,30,199,231,242,225,246,101,128,30,193,232,239,239,235,225,226,239,246,101,128,30,195,244,233,236,228,101,128,30,197,249,242,233,236,236,233,99,128,4,84,100,4,77,14,77,24,77,30,77,40,226,236,231,242,225,246,101,128,2,5,229,246,97,128,9,15,233,229,242,229,243,233,115,128,
0,235,239,116,130,1,23,77,49,77,58,225,227,227,229,238,116,128,1,23,226,229,236,239,119,128,30,185,101,2,77,72,77,83,231,245,242,237,245,235,232,105,128,10,15,237,225,244,242,225,231,245,242,237,245,235,232,105,128,10,71,230,227,249,242,233,236,236,233,99,128,4,68,103,2,77,117,77,124,242,225,246,101,128,0,232,245,234,225,242,225,244,105,128,10,143,104,4,77,144,77,155,77,166,77,176,225,242,237,229,238,233,225,110,128,5,103,226,239,240,239,237,239,230,111,128,49,29,233,242,225,231,225,238,97,128,48,
72,239,239,235,225,226,239,246,101,128,30,187,105,4,77,197,77,208,79,10,79,25,226,239,240,239,237,239,230,111,128,49,31,231,232,116,142,0,56,77,242,77,251,78,5,78,35,78,42,78,80,78,105,78,150,78,184,78,196,78,207,78,240,78,248,79,3,225,242,225,226,233,99,128,6,104,226,229,238,231,225,236,105,128,9,238,227,233,242,227,236,101,129,36,103,78,16,233,238,246,229,242,243,229,243,225,238,243,243,229,242,233,102,128,39,145,228,229,246,97,128,9,110,229,229,110,2,78,50,78,59,227,233,242,227,236,101,128,36,
113,112,2,78,65,78,72,225,242,229,110,128,36,133,229,242,233,239,100,128,36,153,231,117,2,78,87,78,96,234,225,242,225,244,105,128,10,238,242,237,245,235,232,105,128,10,110,104,2,78,111,78,137,97,2,78,117,78,128,227,235,225,242,225,226,233,99,128,6,104,238,231,250,232,239,117,128,48,40,238,239,244,229,226,229,225,237,229,100,128,38,107,105,2,78,156,78,174,228,229,239,231,242,225,240,232,233,227,240,225,242,229,110,128,50,39,238,230,229,242,233,239,114,128,32,136,237,239,238,239,243,240,225,227,101,
128,255,24,239,236,228,243,244,249,236,101,128,247,56,112,2,78,213,78,220,225,242,229,110,128,36,123,229,114,2,78,227,78,233,233,239,100,128,36,143,243,233,225,110,128,6,248,242,239,237,225,110,128,33,119,243,245,240,229,242,233,239,114,128,32,120,244,232,225,105,128,14,88,238,246,229,242,244,229,228,226,242,229,246,101,128,2,7,239,244,233,230,233,229,228,227,249,242,233,236,236,233,99,128,4,101,107,2,79,49,79,73,225,244,225,235,225,238,97,129,48,168,79,61,232,225,236,230,247,233,228,244,104,128,
255,116,111,2,79,79,79,94,238,235,225,242,231,245,242,237,245,235,232,105,128,10,116,242,229,225,110,128,49,84,108,3,79,109,79,120,79,181,227,249,242,233,236,236,233,99,128,4,59,101,2,79,126,79,133,237,229,238,116,128,34,8,246,229,110,3,79,143,79,152,79,173,227,233,242,227,236,101,128,36,106,112,2,79,158,79,165,225,242,229,110,128,36,126,229,242,233,239,100,128,36,146,242,239,237,225,110,128,33,122,236,233,240,243,233,115,129,32,38,79,192,246,229,242,244,233,227,225,108,128,34,238,109,5,79,215,79,
243,79,254,80,18,80,29,225,227,242,239,110,130,1,19,79,227,79,235,225,227,245,244,101,128,30,23,231,242,225,246,101,128,30,21,227,249,242,233,236,236,233,99,128,4,60,228,225,243,104,129,32,20,80,7,246,229,242,244,233,227,225,108,128,254,49,239,238,239,243,240,225,227,101,128,255,69,112,2,80,35,80,55,232,225,243,233,243,237,225,242,235,225,242,237,229,238,233,225,110,128,5,91,244,249,243,229,116,128,34,5,110,6,80,77,80,88,80,99,80,143,80,175,80,190,226,239,240,239,237,239,230,111,128,49,35,227,249,
242,233,236,236,233,99,128,4,61,100,2,80,105,80,124,225,243,104,129,32,19,80,113,246,229,242,244,233,227,225,108,128,254,50,229,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,163,103,130,1,75,80,151,80,162,226,239,240,239,237,239,230,111,128,49,37,232,229,227,249,242,233,236,236,233,99,128,4,165,232,239,239,235,227,249,242,233,236,236,233,99,128,4,200,243,240,225,227,101,128,32,2,111,3,80,206,80,214,80,223,231,239,238,229,107,128,1,25,235,239,242,229,225,110,128,49,83,240,229,110,
130,2,91,80,233,80,242,227,236,239,243,229,100,128,2,154,242,229,246,229,242,243,229,100,130,2,92,81,1,81,10,227,236,239,243,229,100,128,2,94,232,239,239,107,128,2,93,112,2,81,23,81,30,225,242,229,110,128,36,160,243,233,236,239,110,129,3,181,81,40,244,239,238,239,115,128,3,173,241,117,2,81,55,81,99,225,108,130,0,61,81,64,81,76,237,239,238,239,243,240,225,227,101,128,255,29,115,2,81,82,81,89,237,225,236,108,128,254,102,245,240,229,242,233,239,114,128,32,124,233,246,225,236,229,238,227,101,128,34,97,
114,3,81,118,81,129,81,140,226,239,240,239,237,239,230,111,128,49,38,227,249,242,233,236,236,233,99,128,4,64,229,246,229,242,243,229,100,129,2,88,81,152,227,249,242,233,236,236,233,99,128,4,77,115,6,81,177,81,188,81,208,82,33,82,78,82,88,227,249,242,233,236,236,233,99,128,4,65,228,229,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,171,104,132,2,131,81,220,81,227,82,2,82,17,227,245,242,108,128,2,134,239,242,116,2,81,235,81,242,228,229,246,97,128,9,14,246,239,247,229,236,243,233,231,
238,228,229,246,97,128,9,70,242,229,246,229,242,243,229,228,236,239,239,112,128,1,170,243,241,245,225,244,242,229,246,229,242,243,229,100,128,2,133,237,225,236,108,2,82,42,82,53,232,233,242,225,231,225,238,97,128,48,71,235,225,244,225,235,225,238,97,129,48,167,82,66,232,225,236,230,247,233,228,244,104,128,255,106,244,233,237,225,244,229,100,128,33,46,245,240,229,242,233,239,114,128,246,236,116,5,82,110,82,136,82,140,82,157,82,223,97,130,3,183,82,118,82,128,242,237,229,238,233,225,110,128,5,104,244,
239,238,239,115,128,3,174,104,128,0,240,233,236,228,101,129,30,189,82,149,226,229,236,239,119,128,30,27,238,225,232,244,97,3,82,169,82,201,82,210,230,239,245,235,104,2,82,179,82,188,232,229,226,242,229,119,128,5,145,236,229,230,244,232,229,226,242,229,119,128,5,145,232,229,226,242,229,119,128,5,145,236,229,230,244,232,229,226,242,229,119,128,5,145,245,242,238,229,100,128,1,221,117,2,82,237,82,246,235,239,242,229,225,110,128,49,97,242,111,128,32,172,246,239,247,229,236,243,233,231,110,3,83,11,83,21,
83,28,226,229,238,231,225,236,105,128,9,199,228,229,246,97,128,9,71,231,245,234,225,242,225,244,105,128,10,199,120,2,83,45,83,118,227,236,225,109,132,0,33,83,60,83,71,83,98,83,110,225,242,237,229,238,233,225,110,128,5,92,100,2,83,77,83,82,226,108,128,32,60,239,247,110,129,0,161,83,90,243,237,225,236,108,128,247,161,237,239,238,239,243,240,225,227,101,128,255,1,243,237,225,236,108,128,247,33,233,243,244,229,238,244,233,225,108,128,34,3,250,104,131,2,146,83,141,83,160,83,171,99,2,83,147,83,154,225,
242,239,110,128,1,239,245,242,108,128,2,147,242,229,246,229,242,243,229,100,128,1,185,244,225,233,108,128,1,186,102,140,0,102,83,206,84,32,84,43,84,52,84,64,84,167,84,183,86,191,86,204,86,230,88,107,88,115,97,4,83,216,83,223,83,234,83,245,228,229,246,97,128,9,94,231,245,242,237,245,235,232,105,128,10,94,232,242,229,238,232,229,233,116,128,33,9,244,232,97,3,83,255,84,8,84,20,225,242,225,226,233,99,128,6,78,236,239,247,225,242,225,226,233,99,128,6,78,244,225,238,225,242,225,226,233,99,128,6,75,226,
239,240,239,237,239,230,111,128,49,8,227,233,242,227,236,101,128,36,213,228,239,244,225,227,227,229,238,116,128,30,31,101,3,84,72,84,150,84,160,104,4,84,82,84,105,84,119,84,135,225,114,2,84,89,84,96,225,226,233,99,128,6,65,237,229,238,233,225,110,128,5,134,230,233,238,225,236,225,242,225,226,233,99,128,254,210,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,211,237,229,228,233,225,236,225,242,225,226,233,99,128,254,212,233,227,239,240,244,233,99,128,3,229,237,225,236,101,128,38,64,102,
130,251,0,84,175,84,179,105,128,251,3,108,128,251,4,105,136,251,1,84,203,84,243,84,254,85,20,85,142,85,159,85,167,85,180,230,244,229,229,110,2,84,213,84,222,227,233,242,227,236,101,128,36,110,112,2,84,228,84,235,225,242,229,110,128,36,130,229,242,233,239,100,128,36,150,231,245,242,229,228,225,243,104,128,32,18,236,236,229,100,2,85,7,85,13,226,239,120,128,37,160,242,229,227,116,128,37,172,238,225,108,5,85,34,85,73,85,90,85,107,85,123,235,225,102,130,5,218,85,44,85,64,228,225,231,229,243,104,129,251,
58,85,55,232,229,226,242,229,119,128,251,58,232,229,226,242,229,119,128,5,218,237,229,109,129,5,221,85,81,232,229,226,242,229,119,128,5,221,238,245,110,129,5,223,85,98,232,229,226,242,229,119,128,5,223,240,101,129,5,227,85,114,232,229,226,242,229,119,128,5,227,244,243,225,228,105,129,5,229,85,133,232,229,226,242,229,119,128,5,229,242,243,244,244,239,238,229,227,232,233,238,229,243,101,128,2,201,243,232,229,249,101,128,37,201,244,225,227,249,242,233,236,236,233,99,128,4,115,246,101,142,0,53,85,213,
85,222,85,232,86,6,86,13,86,23,86,48,86,75,86,109,86,121,86,132,86,165,86,173,86,184,225,242,225,226,233,99,128,6,101,226,229,238,231,225,236,105,128,9,235,227,233,242,227,236,101,129,36,100,85,243,233,238,246,229,242,243,229,243,225,238,243,243,229,242,233,102,128,39,142,228,229,246,97,128,9,107,229,233,231,232,244,232,115,128,33,93,231,117,2,86,30,86,39,234,225,242,225,244,105,128,10,235,242,237,245,235,232,105,128,10,107,232,97,2,86,55,86,66,227,235,225,242,225,226,233,99,128,6,101,238,231,250,
232,239,117,128,48,37,105,2,86,81,86,99,228,229,239,231,242,225,240,232,233,227,240,225,242,229,110,128,50,36,238,230,229,242,233,239,114,128,32,133,237,239,238,239,243,240,225,227,101,128,255,21,239,236,228,243,244,249,236,101,128,247,53,112,2,86,138,86,145,225,242,229,110,128,36,120,229,114,2,86,152,86,158,233,239,100,128,36,140,243,233,225,110,128,6,245,242,239,237,225,110,128,33,116,243,245,240,229,242,233,239,114,128,32,117,244,232,225,105,128,14,85,108,129,251,2,86,197,239,242,233,110,128,1,
146,109,2,86,210,86,221,239,238,239,243,240,225,227,101,128,255,70,243,241,245,225,242,101,128,51,153,111,4,86,240,87,6,87,18,87,25,230,97,2,86,247,86,255,238,244,232,225,105,128,14,31,244,232,225,105,128,14,29,238,231,237,225,238,244,232,225,105,128,14,79,242,225,236,108,128,34,0,245,114,142,0,52,87,58,87,67,87,77,87,107,87,114,87,139,87,166,87,200,87,212,87,231,87,242,88,19,88,27,88,38,225,242,225,226,233,99,128,6,100,226,229,238,231,225,236,105,128,9,234,227,233,242,227,236,101,129,36,99,87,88,
233,238,246,229,242,243,229,243,225,238,243,243,229,242,233,102,128,39,141,228,229,246,97,128,9,106,231,117,2,87,121,87,130,234,225,242,225,244,105,128,10,234,242,237,245,235,232,105,128,10,106,232,97,2,87,146,87,157,227,235,225,242,225,226,233,99,128,6,100,238,231,250,232,239,117,128,48,36,105,2,87,172,87,190,228,229,239,231,242,225,240,232,233,227,240,225,242,229,110,128,50,35,238,230,229,242,233,239,114,128,32,132,237,239,238,239,243,240,225,227,101,128,255,20,238,245,237,229,242,225,244,239,242,
226,229,238,231,225,236,105,128,9,247,239,236,228,243,244,249,236,101,128,247,52,112,2,87,248,87,255,225,242,229,110,128,36,119,229,114,2,88,6,88,12,233,239,100,128,36,139,243,233,225,110,128,6,244,242,239,237,225,110,128,33,115,243,245,240,229,242,233,239,114,128,32,116,116,2,88,44,88,82,229,229,110,2,88,52,88,61,227,233,242,227,236,101,128,36,109,112,2,88,67,88,74,225,242,229,110,128,36,129,229,242,233,239,100,128,36,149,104,2,88,88,88,93,225,105,128,14,84,244,239,238,229,227,232,233,238,229,243,
101,128,2,203,240,225,242,229,110,128,36,161,242,97,2,88,122,88,130,227,244,233,239,110,128,32,68,238,99,128,32,163,103,144,0,103,88,171,89,117,89,140,89,201,89,218,90,139,91,132,91,217,91,230,92,88,92,113,92,141,92,163,93,108,93,130,93,232,97,9,88,191,88,201,88,208,88,215,89,23,89,48,89,59,89,70,89,104,226,229,238,231,225,236,105,128,9,151,227,245,244,101,128,1,245,228,229,246,97,128,9,23,102,4,88,225,88,234,88,248,89,8,225,242,225,226,233,99,128,6,175,230,233,238,225,236,225,242,225,226,233,99,
128,251,147,233,238,233,244,233,225,236,225,242,225,226,233,99,128,251,148,237,229,228,233,225,236,225,242,225,226,233,99,128,251,149,231,117,2,89,30,89,39,234,225,242,225,244,105,128,10,151,242,237,245,235,232,105,128,10,23,232,233,242,225,231,225,238,97,128,48,76,235,225,244,225,235,225,238,97,128,48,172,237,237,97,130,3,179,89,80,89,93,236,225,244,233,238,243,237,225,236,108,128,2,99,243,245,240,229,242,233,239,114,128,2,224,238,231,233,225,227,239,240,244,233,99,128,3,235,98,2,89,123,89,133,239,
240,239,237,239,230,111,128,49,13,242,229,246,101,128,1,31,99,4,89,150,89,157,89,166,89,188,225,242,239,110,128,1,231,229,228,233,236,236,97,128,1,35,233,242,99,2,89,174,89,179,236,101,128,36,214,245,237,230,236,229,120,128,1,29,239,237,237,225,225,227,227,229,238,116,128,1,35,228,239,116,129,1,33,89,209,225,227,227,229,238,116,128,1,33,101,6,89,232,89,243,89,254,90,9,90,28,90,130,227,249,242,233,236,236,233,99,128,4,51,232,233,242,225,231,225,238,97,128,48,82,235,225,244,225,235,225,238,97,128,48,
178,239,237,229,244,242,233,227,225,236,236,249,229,241,245,225,108,128,34,81,114,3,90,36,90,85,90,95,229,243,104,3,90,46,90,61,90,70,225,227,227,229,238,244,232,229,226,242,229,119,128,5,156,232,229,226,242,229,119,128,5,243,237,245,241,228,225,237,232,229,226,242,229,119,128,5,157,237,225,238,228,226,236,115,128,0,223,243,232,225,249,233,109,2,90,106,90,121,225,227,227,229,238,244,232,229,226,242,229,119,128,5,158,232,229,226,242,229,119,128,5,244,244,225,237,225,242,107,128,48,19,104,5,90,151,
91,28,91,91,91,116,91,122,97,4,90,161,90,171,90,194,90,219,226,229,238,231,225,236,105,128,9,152,100,2,90,177,90,188,225,242,237,229,238,233,225,110,128,5,114,229,246,97,128,9,24,231,117,2,90,201,90,210,234,225,242,225,244,105,128,10,152,242,237,245,235,232,105,128,10,24,233,110,4,90,230,90,239,90,253,91,13,225,242,225,226,233,99,128,6,58,230,233,238,225,236,225,242,225,226,233,99,128,254,206,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,207,237,229,228,233,225,236,225,242,225,226,233,
99,128,254,208,101,3,91,36,91,57,91,74,237,233,228,228,236,229,232,239,239,235,227,249,242,233,236,236,233,99,128,4,149,243,244,242,239,235,229,227,249,242,233,236,236,233,99,128,4,147,245,240,244,245,242,238,227,249,242,233,236,236,233,99,128,4,145,232,97,2,91,98,91,105,228,229,246,97,128,9,90,231,245,242,237,245,235,232,105,128,10,90,239,239,107,128,2,96,250,243,241,245,225,242,101,128,51,147,105,3,91,140,91,151,91,162,232,233,242,225,231,225,238,97,128,48,78,235,225,244,225,235,225,238,97,128,
48,174,109,2,91,168,91,179,225,242,237,229,238,233,225,110,128,5,99,229,108,130,5,210,91,188,91,208,228,225,231,229,243,104,129,251,50,91,199,232,229,226,242,229,119,128,251,50,232,229,226,242,229,119,128,5,210,234,229,227,249,242,233,236,236,233,99,128,4,83,236,239,244,244,225,108,2,91,241,92,2,233,238,246,229,242,244,229,228,243,244,242,239,235,101,128,1,190,243,244,239,112,132,2,148,92,17,92,28,92,34,92,66,233,238,246,229,242,244,229,100,128,2,150,237,239,100,128,2,192,242,229,246,229,242,243,
229,100,130,2,149,92,49,92,55,237,239,100,128,2,193,243,245,240,229,242,233,239,114,128,2,228,243,244,242,239,235,101,129,2,161,92,77,242,229,246,229,242,243,229,100,128,2,162,109,2,92,94,92,102,225,227,242,239,110,128,30,33,239,238,239,243,240,225,227,101,128,255,71,111,2,92,119,92,130,232,233,242,225,231,225,238,97,128,48,84,235,225,244,225,235,225,238,97,128,48,180,240,97,2,92,148,92,154,242,229,110,128,36,162,243,241,245,225,242,101,128,51,172,114,2,92,169,93,10,97,2,92,175,92,183,228,233,229,
238,116,128,34,7,246,101,134,0,96,92,200,92,211,92,228,92,235,92,244,93,0,226,229,236,239,247,227,237,98,128,3,22,99,2,92,217,92,222,237,98,128,3,0,239,237,98,128,3,0,228,229,246,97,128,9,83,236,239,247,237,239,100,128,2,206,237,239,238,239,243,240,225,227,101,128,255,64,244,239,238,229,227,237,98,128,3,64,229,225,244,229,114,132,0,62,93,26,93,45,93,57,93,100,229,241,245,225,108,129,34,101,93,36,239,242,236,229,243,115,128,34,219,237,239,238,239,243,240,225,227,101,128,255,30,111,2,93,63,93,89,114,
2,93,69,93,82,229,241,245,233,246,225,236,229,238,116,128,34,115,236,229,243,115,128,34,119,246,229,242,229,241,245,225,108,128,34,103,243,237,225,236,108,128,254,101,115,2,93,114,93,122,227,242,233,240,116,128,2,97,244,242,239,235,101,128,1,229,117,4,93,140,93,151,93,208,93,219,232,233,242,225,231,225,238,97,128,48,80,233,108,2,93,158,93,183,236,229,237,239,116,2,93,168,93,175,236,229,230,116,128,0,171,242,233,231,232,116,128,0,187,243,233,238,231,108,2,93,193,93,200,236,229,230,116,128,32,57,242,
233,231,232,116,128,32,58,235,225,244,225,235,225,238,97,128,48,176,242,225,237,245,243,241,245,225,242,101,128,51,24,249,243,241,245,225,242,101,128,51,201,104,144,0,104,94,22,96,164,96,199,96,236,97,20,98,164,98,184,99,149,99,161,99,173,100,241,100,249,101,4,101,13,101,93,101,97,97,13,94,50,94,89,94,99,94,129,94,154,94,232,94,244,95,13,95,28,95,57,95,70,95,128,95,137,97,2,94,56,94,75,226,235,232,225,243,233,225,238,227,249,242,233,236,236,233,99,128,4,169,236,244,239,238,229,225,242,225,226,233,
99,128,6,193,226,229,238,231,225,236,105,128,9,185,228,101,2,94,106,94,124,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,179,246,97,128,9,57,231,117,2,94,136,94,145,234,225,242,225,244,105,128,10,185,242,237,245,235,232,105,128,10,57,104,4,94,164,94,173,94,187,94,217,225,242,225,226,233,99,128,6,45,230,233,238,225,236,225,242,225,226,233,99,128,254,162,105,2,94,193,94,208,238,233,244,233,225,236,225,242,225,226,233,99,128,254,163,242,225,231,225,238,97,128,48,111,237,229,228,233,
225,236,225,242,225,226,233,99,128,254,164,233,244,245,243,241,245,225,242,101,128,51,42,235,225,244,225,235,225,238,97,129,48,207,95,1,232,225,236,230,247,233,228,244,104,128,255,138,236,225,238,244,231,245,242,237,245,235,232,105,128,10,77,237,250,97,2,95,36,95,45,225,242,225,226,233,99,128,6,33,236,239,247,225,242,225,226,233,99,128,6,33,238,231,245,236,230,233,236,236,229,114,128,49,100,114,2,95,76,95,92,228,243,233,231,238,227,249,242,233,236,236,233,99,128,4,74,240,239,239,110,2,95,101,95,114,
236,229,230,244,226,225,242,226,245,112,128,33,188,242,233,231,232,244,226,225,242,226,245,112,128,33,192,243,241,245,225,242,101,128,51,202,244,225,102,3,95,147,95,239,96,74,240,225,244,225,104,134,5,178,95,167,95,172,95,186,95,195,95,210,95,226,177,54,128,5,178,50,2,95,178,95,182,51,128,5,178,102,128,5,178,232,229,226,242,229,119,128,5,178,238,225,242,242,239,247,232,229,226,242,229,119,128,5,178,241,245,225,242,244,229,242,232,229,226,242,229,119,128,5,178,247,233,228,229,232,229,226,242,229,119,
128,5,178,241,225,237,225,244,115,135,5,179,96,6,96,11,96,16,96,21,96,30,96,45,96,61,177,98,128,5,179,178,56,128,5,179,179,52,128,5,179,232,229,226,242,229,119,128,5,179,238,225,242,242,239,247,232,229,226,242,229,119,128,5,179,241,245,225,242,244,229,242,232,229,226,242,229,119,128,5,179,247,233,228,229,232,229,226,242,229,119,128,5,179,243,229,231,239,108,135,5,177,96,96,96,101,96,106,96,111,96,120,96,135,96,151,177,55,128,5,177,178,52,128,5,177,179,48,128,5,177,232,229,226,242,229,119,128,5,177,
238,225,242,242,239,247,232,229,226,242,229,119,128,5,177,241,245,225,242,244,229,242,232,229,226,242,229,119,128,5,177,247,233,228,229,232,229,226,242,229,119,128,5,177,98,3,96,172,96,177,96,187,225,114,128,1,39,239,240,239,237,239,230,111,128,49,15,242,229,246,229,226,229,236,239,119,128,30,43,99,2,96,205,96,214,229,228,233,236,236,97,128,30,41,233,242,99,2,96,222,96,227,236,101,128,36,215,245,237,230,236,229,120,128,1,37,100,2,96,242,96,252,233,229,242,229,243,233,115,128,30,39,239,116,2,97,3,
97,12,225,227,227,229,238,116,128,30,35,226,229,236,239,119,128,30,37,101,136,5,212,97,40,97,73,97,93,98,66,98,82,98,127,98,136,98,149,225,242,116,129,38,101,97,48,243,245,233,116,2,97,57,97,65,226,236,225,227,107,128,38,101,247,232,233,244,101,128,38,97,228,225,231,229,243,104,129,251,52,97,84,232,229,226,242,229,119,128,251,52,104,6,97,107,97,135,97,143,97,193,97,239,98,32,97,2,97,113,97,127,236,244,239,238,229,225,242,225,226,233,99,128,6,193,242,225,226,233,99,128,6,71,229,226,242,229,119,128,
5,212,230,233,238,225,236,97,2,97,154,97,185,236,116,2,97,161,97,173,239,238,229,225,242,225,226,233,99,128,251,167,244,247,239,225,242,225,226,233,99,128,254,234,242,225,226,233,99,128,254,234,232,225,237,250,225,225,226,239,246,101,2,97,208,97,222,230,233,238,225,236,225,242,225,226,233,99,128,251,165,233,243,239,236,225,244,229,228,225,242,225,226,233,99,128,251,164,105,2,97,245,98,23,238,233,244,233,225,236,97,2,98,1,98,15,236,244,239,238,229,225,242,225,226,233,99,128,251,168,242,225,226,233,
99,128,254,235,242,225,231,225,238,97,128,48,120,237,229,228,233,225,236,97,2,98,44,98,58,236,244,239,238,229,225,242,225,226,233,99,128,251,169,242,225,226,233,99,128,254,236,233,243,229,233,229,242,225,243,241,245,225,242,101,128,51,123,107,2,98,88,98,112,225,244,225,235,225,238,97,129,48,216,98,100,232,225,236,230,247,233,228,244,104,128,255,141,245,244,225,225,242,245,243,241,245,225,242,101,128,51,54,238,231,232,239,239,107,128,2,103,242,245,244,245,243,241,245,225,242,101,128,51,57,116,129,
5,215,98,155,232,229,226,242,229,119,128,5,215,232,239,239,107,129,2,102,98,173,243,245,240,229,242,233,239,114,128,2,177,105,4,98,194,99,23,99,34,99,59,229,245,104,4,98,206,98,241,99,0,99,9,97,2,98,212,98,227,227,233,242,227,236,229,235,239,242,229,225,110,128,50,123,240,225,242,229,238,235,239,242,229,225,110,128,50,27,227,233,242,227,236,229,235,239,242,229,225,110,128,50,109,235,239,242,229,225,110,128,49,78,240,225,242,229,238,235,239,242,229,225,110,128,50,13,232,233,242,225,231,225,238,97,
128,48,114,235,225,244,225,235,225,238,97,129,48,210,99,47,232,225,236,230,247,233,228,244,104,128,255,139,242,233,113,134,5,180,99,77,99,82,99,96,99,105,99,120,99,136,177,52,128,5,180,50,2,99,88,99,92,49,128,5,180,100,128,5,180,232,229,226,242,229,119,128,5,180,238,225,242,242,239,247,232,229,226,242,229,119,128,5,180,241,245,225,242,244,229,242,232,229,226,242,229,119,128,5,180,247,233,228,229,232,229,226,242,229,119,128,5,180,236,233,238,229,226,229,236,239,119,128,30,150,237,239,238,239,243,240,
225,227,101,128,255,72,111,9,99,193,99,204,99,228,99,253,100,85,100,98,100,184,100,224,100,235,225,242,237,229,238,233,225,110,128,5,112,232,105,2,99,211,99,219,240,244,232,225,105,128,14,43,242,225,231,225,238,97,128,48,123,235,225,244,225,235,225,238,97,129,48,219,99,241,232,225,236,230,247,233,228,244,104,128,255,142,236,225,109,135,5,185,100,17,100,22,100,27,100,32,100,41,100,56,100,72,177,57,128,5,185,178,54,128,5,185,179,50,128,5,185,232,229,226,242,229,119,128,5,185,238,225,242,242,239,247,
232,229,226,242,229,119,128,5,185,241,245,225,242,244,229,242,232,229,226,242,229,119,128,5,185,247,233,228,229,232,229,226,242,229,119,128,5,185,238,239,235,232,245,235,244,232,225,105,128,14,46,111,2,100,104,100,174,107,4,100,114,100,126,100,132,100,154,225,226,239,246,229,227,239,237,98,128,3,9,227,237,98,128,3,9,240,225,236,225,244,225,236,233,250,229,228,226,229,236,239,247,227,237,98,128,3,33,242,229,244,242,239,230,236,229,248,226,229,236,239,247,227,237,98,128,3,34,238,243,241,245,225,242,
101,128,51,66,114,2,100,190,100,217,105,2,100,196,100,205,227,239,240,244,233,99,128,3,233,250,239,238,244,225,236,226,225,114,128,32,21,238,227,237,98,128,3,27,244,243,240,242,233,238,231,115,128,38,104,245,243,101,128,35,2,240,225,242,229,110,128,36,163,243,245,240,229,242,233,239,114,128,2,176,244,245,242,238,229,100,128,2,101,117,4,101,23,101,34,101,47,101,72,232,233,242,225,231,225,238,97,128,48,117,233,233,244,239,243,241,245,225,242,101,128,51,51,235,225,244,225,235,225,238,97,129,48,213,101,
60,232,225,236,230,247,233,228,244,104,128,255,140,238,231,225,242,245,237,236,225,245,116,129,2,221,101,87,227,237,98,128,3,11,118,128,1,149,249,240,232,229,110,132,0,45,101,113,101,124,101,136,101,159,233,238,230,229,242,233,239,114,128,246,229,237,239,238,239,243,240,225,227,101,128,255,13,115,2,101,142,101,149,237,225,236,108,128,254,99,245,240,229,242,233,239,114,128,246,230,244,247,111,128,32,16,105,149,0,105,101,211,101,234,102,12,102,59,105,197,106,61,106,98,106,125,107,31,107,35,107,73,107,
95,107,179,108,88,108,163,108,171,108,184,109,15,109,72,109,100,109,144,225,99,2,101,218,101,224,245,244,101,128,0,237,249,242,233,236,236,233,99,128,4,79,98,3,101,242,101,251,102,5,229,238,231,225,236,105,128,9,135,239,240,239,237,239,230,111,128,49,39,242,229,246,101,128,1,45,99,3,102,20,102,27,102,49,225,242,239,110,128,1,208,233,242,99,2,102,35,102,40,236,101,128,36,216,245,237,230,236,229,120,128,0,238,249,242,233,236,236,233,99,128,4,86,100,4,102,69,102,79,105,154,105,187,226,236,231,242,225,
246,101,128,2,9,101,2,102,85,105,149,239,231,242,225,240,104,7,102,106,102,120,102,133,105,62,105,93,105,106,105,118,229,225,242,244,232,227,233,242,227,236,101,128,50,143,230,233,242,229,227,233,242,227,236,101,128,50,139,233,99,14,102,164,102,180,103,23,103,77,103,143,103,172,103,188,103,245,104,38,104,50,104,77,104,144,105,26,105,55,225,236,236,233,225,238,227,229,240,225,242,229,110,128,50,63,99,4,102,190,102,201,102,215,102,222,225,236,236,240,225,242,229,110,128,50,58,229,238,244,242,229,227,
233,242,227,236,101,128,50,165,236,239,243,101,128,48,6,111,3,102,230,102,245,103,9,237,237,97,129,48,1,102,238,236,229,230,116,128,255,100,238,231,242,225,244,245,236,225,244,233,239,238,240,225,242,229,110,128,50,55,242,242,229,227,244,227,233,242,227,236,101,128,50,163,101,3,103,31,103,43,103,60,225,242,244,232,240,225,242,229,110,128,50,47,238,244,229,242,240,242,233,243,229,240,225,242,229,110,128,50,61,248,227,229,236,236,229,238,244,227,233,242,227,236,101,128,50,157,102,2,103,83,103,98,229,
243,244,233,246,225,236,240,225,242,229,110,128,50,64,105,2,103,104,103,133,238,225,238,227,233,225,108,2,103,116,103,125,227,233,242,227,236,101,128,50,150,240,225,242,229,110,128,50,54,242,229,240,225,242,229,110,128,50,43,104,2,103,149,103,160,225,246,229,240,225,242,229,110,128,50,50,233,231,232,227,233,242,227,236,101,128,50,164,233,244,229,242,225,244,233,239,238,237,225,242,107,128,48,5,108,3,103,196,103,222,103,234,225,226,239,114,2,103,205,103,214,227,233,242,227,236,101,128,50,152,240,225,
242,229,110,128,50,56,229,230,244,227,233,242,227,236,101,128,50,167,239,247,227,233,242,227,236,101,128,50,166,109,2,103,251,104,27,101,2,104,1,104,16,228,233,227,233,238,229,227,233,242,227,236,101,128,50,169,244,225,236,240,225,242,229,110,128,50,46,239,239,238,240,225,242,229,110,128,50,42,238,225,237,229,240,225,242,229,110,128,50,52,112,2,104,56,104,64,229,242,233,239,100,128,48,2,242,233,238,244,227,233,242,227,236,101,128,50,158,114,2,104,83,104,131,101,3,104,91,104,102,104,117,225,227,232,
240,225,242,229,110,128,50,67,240,242,229,243,229,238,244,240,225,242,229,110,128,50,57,243,239,245,242,227,229,240,225,242,229,110,128,50,62,233,231,232,244,227,233,242,227,236,101,128,50,168,115,5,104,156,104,185,104,199,104,224,104,252,101,2,104,162,104,175,227,242,229,244,227,233,242,227,236,101,128,50,153,236,230,240,225,242,229,110,128,50,66,239,227,233,229,244,249,240,225,242,229,110,128,50,51,112,2,104,205,104,211,225,227,101,128,48,0,229,227,233,225,236,240,225,242,229,110,128,50,53,116,
2,104,230,104,241,239,227,235,240,225,242,229,110,128,50,49,245,228,249,240,225,242,229,110,128,50,59,117,2,105,2,105,11,238,240,225,242,229,110,128,50,48,240,229,242,246,233,243,229,240,225,242,229,110,128,50,60,119,2,105,32,105,44,225,244,229,242,240,225,242,229,110,128,50,44,239,239,228,240,225,242,229,110,128,50,45,250,229,242,111,128,48,7,109,2,105,68,105,81,229,244,225,236,227,233,242,227,236,101,128,50,142,239,239,238,227,233,242,227,236,101,128,50,138,238,225,237,229,227,233,242,227,236,101,
128,50,148,243,245,238,227,233,242,227,236,101,128,50,144,119,2,105,124,105,137,225,244,229,242,227,233,242,227,236,101,128,50,140,239,239,228,227,233,242,227,236,101,128,50,141,246,97,128,9,7,233,229,242,229,243,233,115,130,0,239,105,168,105,176,225,227,245,244,101,128,30,47,227,249,242,233,236,236,233,99,128,4,229,239,244,226,229,236,239,119,128,30,203,101,3,105,205,105,221,105,232,226,242,229,246,229,227,249,242,233,236,236,233,99,128,4,215,227,249,242,233,236,236,233,99,128,4,53,245,238,103,4,
105,244,106,23,106,38,106,47,97,2,105,250,106,9,227,233,242,227,236,229,235,239,242,229,225,110,128,50,117,240,225,242,229,238,235,239,242,229,225,110,128,50,21,227,233,242,227,236,229,235,239,242,229,225,110,128,50,103,235,239,242,229,225,110,128,49,71,240,225,242,229,238,235,239,242,229,225,110,128,50,7,103,2,106,67,106,74,242,225,246,101,128,0,236,117,2,106,80,106,89,234,225,242,225,244,105,128,10,135,242,237,245,235,232,105,128,10,7,104,2,106,104,106,114,233,242,225,231,225,238,97,128,48,68,239,
239,235,225,226,239,246,101,128,30,201,105,8,106,143,106,153,106,164,106,171,106,196,106,212,106,227,106,243,226,229,238,231,225,236,105,128,9,136,227,249,242,233,236,236,233,99,128,4,56,228,229,246,97,128,9,8,231,117,2,106,178,106,187,234,225,242,225,244,105,128,10,136,242,237,245,235,232,105,128,10,8,237,225,244,242,225,231,245,242,237,245,235,232,105,128,10,64,238,246,229,242,244,229,228,226,242,229,246,101,128,2,11,243,232,239,242,244,227,249,242,233,236,236,233,99,128,4,57,246,239,247,229,236,
243,233,231,110,3,107,3,107,13,107,20,226,229,238,231,225,236,105,128,9,192,228,229,246,97,128,9,64,231,245,234,225,242,225,244,105,128,10,192,106,128,1,51,107,2,107,41,107,65,225,244,225,235,225,238,97,129,48,164,107,53,232,225,236,230,247,233,228,244,104,128,255,114,239,242,229,225,110,128,49,99,108,2,107,79,107,84,228,101,128,2,220,245,249,232,229,226,242,229,119,128,5,172,109,2,107,101,107,168,97,3,107,109,107,129,107,154,227,242,239,110,129,1,43,107,118,227,249,242,233,236,236,233,99,128,4,227,
231,229,239,242,225,240,240,242,239,248,233,237,225,244,229,236,249,229,241,245,225,108,128,34,83,244,242,225,231,245,242,237,245,235,232,105,128,10,63,239,238,239,243,240,225,227,101,128,255,73,110,5,107,191,107,201,107,210,107,222,108,50,227,242,229,237,229,238,116,128,34,6,230,233,238,233,244,121,128,34,30,233,225,242,237,229,238,233,225,110,128,5,107,116,2,107,228,108,40,101,2,107,234,108,29,231,242,225,108,131,34,43,107,247,108,9,108,14,98,2,107,253,108,5,239,244,244,239,109,128,35,33,116,128,
35,33,229,120,128,248,245,116,2,108,20,108,25,239,112,128,35,32,112,128,35,32,242,243,229,227,244,233,239,110,128,34,41,233,243,241,245,225,242,101,128,51,5,118,3,108,58,108,67,108,76,226,245,236,236,229,116,128,37,216,227,233,242,227,236,101,128,37,217,243,237,233,236,229,230,225,227,101,128,38,59,111,3,108,96,108,107,108,115,227,249,242,233,236,236,233,99,128,4,81,231,239,238,229,107,128,1,47,244,97,131,3,185,108,126,108,147,108,155,228,233,229,242,229,243,233,115,129,3,202,108,139,244,239,238,
239,115,128,3,144,236,225,244,233,110,128,2,105,244,239,238,239,115,128,3,175,240,225,242,229,110,128,36,164,242,233,231,245,242,237,245,235,232,105,128,10,114,115,4,108,194,108,239,108,253,109,5,237,225,236,108,2,108,203,108,214,232,233,242,225,231,225,238,97,128,48,67,235,225,244,225,235,225,238,97,129,48,163,108,227,232,225,236,230,247,233,228,244,104,128,255,104,243,232,225,242,226,229,238,231,225,236,105,128,9,250,244,242,239,235,101,128,2,104,245,240,229,242,233,239,114,128,246,237,116,2,109,
21,109,55,229,242,225,244,233,239,110,2,109,33,109,44,232,233,242,225,231,225,238,97,128,48,157,235,225,244,225,235,225,238,97,128,48,253,233,236,228,101,129,1,41,109,64,226,229,236,239,119,128,30,45,117,2,109,78,109,89,226,239,240,239,237,239,230,111,128,49,41,227,249,242,233,236,236,233,99,128,4,78,246,239,247,229,236,243,233,231,110,3,109,116,109,126,109,133,226,229,238,231,225,236,105,128,9,191,228,229,246,97,128,9,63,231,245,234,225,242,225,244,105,128,10,191,250,232,233,244,243,97,2,109,155,
109,166,227,249,242,233,236,236,233,99,128,4,117,228,226,236,231,242,225,246,229,227,249,242,233,236,236,233,99,128,4,119,106,138,0,106,109,209,110,16,110,27,110,77,110,93,110,206,111,19,111,24,111,36,111,44,97,4,109,219,109,230,109,240,109,247,225,242,237,229,238,233,225,110,128,5,113,226,229,238,231,225,236,105,128,9,156,228,229,246,97,128,9,28,231,117,2,109,254,110,7,234,225,242,225,244,105,128,10,156,242,237,245,235,232,105,128,10,28,226,239,240,239,237,239,230,111,128,49,16,99,3,110,35,110,42,
110,64,225,242,239,110,128,1,240,233,242,99,2,110,50,110,55,236,101,128,36,217,245,237,230,236,229,120,128,1,53,242,239,243,243,229,228,244,225,233,108,128,2,157,228,239,244,236,229,243,243,243,244,242,239,235,101,128,2,95,101,3,110,101,110,112,110,177,227,249,242,233,236,236,233,99,128,4,88,229,109,4,110,123,110,132,110,146,110,162,225,242,225,226,233,99,128,6,44,230,233,238,225,236,225,242,225,226,233,99,128,254,158,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,159,237,229,228,233,
225,236,225,242,225,226,233,99,128,254,160,104,2,110,183,110,192,225,242,225,226,233,99,128,6,152,230,233,238,225,236,225,242,225,226,233,99,128,251,139,104,2,110,212,111,6,97,3,110,220,110,230,110,237,226,229,238,231,225,236,105,128,9,157,228,229,246,97,128,9,29,231,117,2,110,244,110,253,234,225,242,225,244,105,128,10,157,242,237,245,235,232,105,128,10,29,229,232,225,242,237,229,238,233,225,110,128,5,123,233,115,128,48,4,237,239,238,239,243,240,225,227,101,128,255,74,240,225,242,229,110,128,36,165,
243,245,240,229,242,233,239,114,128,2,178,107,146,0,107,111,95,113,184,113,195,114,1,114,12,114,102,114,116,115,224,116,164,116,177,116,203,116,252,117,134,117,156,117,169,117,192,117,234,117,244,97,12,111,121,111,153,111,175,111,205,112,63,112,88,112,118,112,143,112,249,113,7,113,130,113,159,98,2,111,127,111,144,225,243,232,235,233,242,227,249,242,233,236,236,233,99,128,4,161,229,238,231,225,236,105,128,9,149,99,2,111,159,111,165,245,244,101,128,30,49,249,242,233,236,236,233,99,128,4,58,228,101,
2,111,182,111,200,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,155,246,97,128,9,21,102,135,5,219,111,223,111,232,111,252,112,10,112,19,112,35,112,50,225,242,225,226,233,99,128,6,67,228,225,231,229,243,104,129,251,59,111,243,232,229,226,242,229,119,128,251,59,230,233,238,225,236,225,242,225,226,233,99,128,254,218,232,229,226,242,229,119,128,5,219,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,219,237,229,228,233,225,236,225,242,225,226,233,99,128,254,220,242,225,230,
229,232,229,226,242,229,119,128,251,77,231,117,2,112,70,112,79,234,225,242,225,244,105,128,10,149,242,237,245,235,232,105,128,10,21,104,2,112,94,112,104,233,242,225,231,225,238,97,128,48,75,239,239,235,227,249,242,233,236,236,233,99,128,4,196,235,225,244,225,235,225,238,97,129,48,171,112,131,232,225,236,230,247,233,228,244,104,128,255,118,112,2,112,149,112,170,240,97,129,3,186,112,156,243,249,237,226,239,236,231,242,229,229,107,128,3,240,249,229,239,245,110,3,112,182,112,196,112,230,237,233,229,245,
237,235,239,242,229,225,110,128,49,113,112,2,112,202,112,217,232,233,229,245,240,232,235,239,242,229,225,110,128,49,132,233,229,245,240,235,239,242,229,225,110,128,49,120,243,243,225,238,231,240,233,229,245,240,235,239,242,229,225,110,128,49,121,242,239,242,233,233,243,241,245,225,242,101,128,51,13,115,5,113,19,113,63,113,78,113,86,113,114,232,233,228,225,225,245,244,111,2,113,32,113,41,225,242,225,226,233,99,128,6,64,238,239,243,233,228,229,226,229,225,242,233,238,231,225,242,225,226,233,99,128,
6,64,237,225,236,236,235,225,244,225,235,225,238,97,128,48,245,241,245,225,242,101,128,51,132,242,97,2,113,93,113,102,225,242,225,226,233,99,128,6,80,244,225,238,225,242,225,226,233,99,128,6,77,244,242,239,235,229,227,249,242,233,236,236,233,99,128,4,159,244,225,232,233,242,225,240,242,239,236,239,238,231,237,225,242,235,232,225,236,230,247,233,228,244,104,128,255,112,246,229,242,244,233,227,225,236,243,244,242,239,235,229,227,249,242,233,236,236,233,99,128,4,157,226,239,240,239,237,239,230,111,128,
49,14,99,4,113,205,113,227,113,236,113,244,97,2,113,211,113,221,236,243,241,245,225,242,101,128,51,137,242,239,110,128,1,233,229,228,233,236,236,97,128,1,55,233,242,227,236,101,128,36,218,239,237,237,225,225,227,227,229,238,116,128,1,55,228,239,244,226,229,236,239,119,128,30,51,101,4,114,22,114,49,114,74,114,86,104,2,114,28,114,39,225,242,237,229,238,233,225,110,128,5,132,233,242,225,231,225,238,97,128,48,81,235,225,244,225,235,225,238,97,129,48,177,114,62,232,225,236,230,247,233,228,244,104,128,
255,121,238,225,242,237,229,238,233,225,110,128,5,111,243,237,225,236,236,235,225,244,225,235,225,238,97,128,48,246,231,242,229,229,238,236,225,238,228,233,99,128,1,56,104,6,114,130,115,3,115,14,115,39,115,126,115,214,97,5,114,142,114,152,114,163,114,170,114,195,226,229,238,231,225,236,105,128,9,150,227,249,242,233,236,236,233,99,128,4,69,228,229,246,97,128,9,22,231,117,2,114,177,114,186,234,225,242,225,244,105,128,10,150,242,237,245,235,232,105,128,10,22,104,4,114,205,114,214,114,228,114,244,225,
242,225,226,233,99,128,6,46,230,233,238,225,236,225,242,225,226,233,99,128,254,166,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,167,237,229,228,233,225,236,225,242,225,226,233,99,128,254,168,229,233,227,239,240,244,233,99,128,3,231,232,97,2,115,21,115,28,228,229,246,97,128,9,89,231,245,242,237,245,235,232,105,128,10,89,233,229,245,235,104,4,115,53,115,88,115,103,115,112,97,2,115,59,115,74,227,233,242,227,236,229,235,239,242,229,225,110,128,50,120,240,225,242,229,238,235,239,242,229,
225,110,128,50,24,227,233,242,227,236,229,235,239,242,229,225,110,128,50,106,235,239,242,229,225,110,128,49,75,240,225,242,229,238,235,239,242,229,225,110,128,50,10,111,4,115,136,115,185,115,195,115,200,235,104,4,115,147,115,156,115,165,115,175,225,233,244,232,225,105,128,14,2,239,238,244,232,225,105,128,14,5,245,225,244,244,232,225,105,128,14,3,247,225,233,244,232,225,105,128,14,4,237,245,244,244,232,225,105,128,14,91,239,107,128,1,153,242,225,235,232,225,238,231,244,232,225,105,128,14,6,250,243,
241,245,225,242,101,128,51,145,105,4,115,234,115,245,116,14,116,63,232,233,242,225,231,225,238,97,128,48,77,235,225,244,225,235,225,238,97,129,48,173,116,2,232,225,236,230,247,233,228,244,104,128,255,119,242,111,3,116,23,116,38,116,54,231,245,242,225,237,245,243,241,245,225,242,101,128,51,21,237,229,229,244,239,242,245,243,241,245,225,242,101,128,51,22,243,241,245,225,242,101,128,51,20,249,229,239,107,5,116,78,116,113,116,128,116,137,116,151,97,2,116,84,116,99,227,233,242,227,236,229,235,239,242,
229,225,110,128,50,110,240,225,242,229,238,235,239,242,229,225,110,128,50,14,227,233,242,227,236,229,235,239,242,229,225,110,128,50,96,235,239,242,229,225,110,128,49,49,240,225,242,229,238,235,239,242,229,225,110,128,50,0,243,233,239,243,235,239,242,229,225,110,128,49,51,234,229,227,249,242,233,236,236,233,99,128,4,92,108,2,116,183,116,194,233,238,229,226,229,236,239,119,128,30,53,243,241,245,225,242,101,128,51,152,109,3,116,211,116,225,116,236,227,245,226,229,228,243,241,245,225,242,101,128,51,166,
239,238,239,243,240,225,227,101,128,255,75,243,241,245,225,242,229,228,243,241,245,225,242,101,128,51,162,111,5,117,8,117,34,117,72,117,84,117,98,104,2,117,14,117,24,233,242,225,231,225,238,97,128,48,83,237,243,241,245,225,242,101,128,51,192,235,97,2,117,41,117,49,233,244,232,225,105,128,14,1,244,225,235,225,238,97,129,48,179,117,60,232,225,236,230,247,233,228,244,104,128,255,122,239,240,239,243,241,245,225,242,101,128,51,30,240,240,225,227,249,242,233,236,236,233,99,128,4,129,114,2,117,104,117,124,
229,225,238,243,244,225,238,228,225,242,228,243,249,237,226,239,108,128,50,127,239,238,233,243,227,237,98,128,3,67,240,97,2,117,141,117,147,242,229,110,128,36,166,243,241,245,225,242,101,128,51,170,243,233,227,249,242,233,236,236,233,99,128,4,111,116,2,117,175,117,184,243,241,245,225,242,101,128,51,207,245,242,238,229,100,128,2,158,117,2,117,198,117,209,232,233,242,225,231,225,238,97,128,48,79,235,225,244,225,235,225,238,97,129,48,175,117,222,232,225,236,230,247,233,228,244,104,128,255,120,246,243,
241,245,225,242,101,128,51,184,247,243,241,245,225,242,101,128,51,190,108,146,0,108,118,38,120,65,120,94,120,160,120,198,121,94,121,103,121,119,121,143,121,161,122,23,122,64,122,199,122,207,122,240,122,249,123,1,123,63,97,7,118,54,118,64,118,71,118,78,118,103,118,119,120,53,226,229,238,231,225,236,105,128,9,178,227,245,244,101,128,1,58,228,229,246,97,128,9,50,231,117,2,118,85,118,94,234,225,242,225,244,105,128,10,178,242,237,245,235,232,105,128,10,50,235,235,232,225,238,231,249,225,239,244,232,225,
105,128,14,69,109,10,118,141,119,80,119,97,119,135,119,149,119,168,119,184,119,204,119,224,119,247,97,2,118,147,119,72,236,229,102,4,118,159,118,173,119,9,119,26,230,233,238,225,236,225,242,225,226,233,99,128,254,252,232,225,237,250,97,2,118,183,118,224,225,226,239,246,101,2,118,193,118,207,230,233,238,225,236,225,242,225,226,233,99,128,254,248,233,243,239,236,225,244,229,228,225,242,225,226,233,99,128,254,247,226,229,236,239,119,2,118,234,118,248,230,233,238,225,236,225,242,225,226,233,99,128,254,
250,233,243,239,236,225,244,229,228,225,242,225,226,233,99,128,254,249,233,243,239,236,225,244,229,228,225,242,225,226,233,99,128,254,251,237,225,228,228,225,225,226,239,246,101,2,119,41,119,55,230,233,238,225,236,225,242,225,226,233,99,128,254,246,233,243,239,236,225,244,229,228,225,242,225,226,233,99,128,254,245,242,225,226,233,99,128,6,68,226,228,97,129,3,187,119,88,243,244,242,239,235,101,128,1,155,229,100,130,5,220,119,106,119,126,228,225,231,229,243,104,129,251,60,119,117,232,229,226,242,229,
119,128,251,60,232,229,226,242,229,119,128,5,220,230,233,238,225,236,225,242,225,226,233,99,128,254,222,232,225,232,233,238,233,244,233,225,236,225,242,225,226,233,99,128,252,202,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,223,234,229,229,237,233,238,233,244,233,225,236,225,242,225,226,233,99,128,252,201,235,232,225,232,233,238,233,244,233,225,236,225,242,225,226,233,99,128,252,203,236,225,237,232,229,232,233,243,239,236,225,244,229,228,225,242,225,226,233,99,128,253,242,237,101,2,
119,254,120,11,228,233,225,236,225,242,225,226,233,99,128,254,224,229,109,2,120,18,120,37,232,225,232,233,238,233,244,233,225,236,225,242,225,226,233,99,128,253,136,233,238,233,244,233,225,236,225,242,225,226,233,99,128,252,204,242,231,229,227,233,242,227,236,101,128,37,239,98,3,120,73,120,78,120,84,225,114,128,1,154,229,236,116,128,2,108,239,240,239,237,239,230,111,128,49,12,99,4,120,104,120,111,120,120,120,147,225,242,239,110,128,1,62,229,228,233,236,236,97,128,1,60,233,242,99,2,120,128,120,133,
236,101,128,36,219,245,237,230,236,229,248,226,229,236,239,119,128,30,61,239,237,237,225,225,227,227,229,238,116,128,1,60,228,239,116,130,1,64,120,170,120,179,225,227,227,229,238,116,128,1,64,226,229,236,239,119,129,30,55,120,189,237,225,227,242,239,110,128,30,57,101,3,120,206,120,244,121,89,230,116,2,120,213,120,229,225,238,231,236,229,225,226,239,246,229,227,237,98,128,3,26,244,225,227,235,226,229,236,239,247,227,237,98,128,3,24,243,115,132,0,60,121,1,121,23,121,35,121,81,229,241,245,225,108,129,
34,100,121,11,239,242,231,242,229,225,244,229,114,128,34,218,237,239,238,239,243,240,225,227,101,128,255,28,111,2,121,41,121,70,114,2,121,47,121,60,229,241,245,233,246,225,236,229,238,116,128,34,114,231,242,229,225,244,229,114,128,34,118,246,229,242,229,241,245,225,108,128,34,102,243,237,225,236,108,128,254,100,250,104,128,2,110,230,226,236,239,227,107,128,37,140,232,239,239,235,242,229,244,242,239,230,236,229,120,128,2,109,105,2,121,125,121,130,242,97,128,32,164,247,238,225,242,237,229,238,233,225,
110,128,5,108,106,129,1,201,121,149,229,227,249,242,233,236,236,233,99,128,4,89,108,132,246,192,121,173,121,197,121,208,121,217,97,2,121,179,121,186,228,229,246,97,128,9,51,231,245,234,225,242,225,244,105,128,10,179,233,238,229,226,229,236,239,119,128,30,59,236,225,228,229,246,97,128,9,52,246,239,227,225,236,233,99,3,121,231,121,241,121,248,226,229,238,231,225,236,105,128,9,225,228,229,246,97,128,9,97,246,239,247,229,236,243,233,231,110,2,122,6,122,16,226,229,238,231,225,236,105,128,9,227,228,229,
246,97,128,9,99,109,3,122,31,122,44,122,55,233,228,228,236,229,244,233,236,228,101,128,2,107,239,238,239,243,240,225,227,101,128,255,76,243,241,245,225,242,101,128,51,208,111,6,122,78,122,90,122,132,122,143,122,149,122,191,227,232,245,236,225,244,232,225,105,128,14,44,231,233,227,225,108,3,122,102,122,108,122,127,225,238,100,128,34,39,238,239,116,129,0,172,122,116,242,229,246,229,242,243,229,100,128,35,16,239,114,128,34,40,236,233,238,231,244,232,225,105,128,14,37,238,231,115,128,1,127,247,236,233,
238,101,2,122,159,122,182,99,2,122,165,122,177,229,238,244,229,242,236,233,238,101,128,254,78,237,98,128,3,50,228,225,243,232,229,100,128,254,77,250,229,238,231,101,128,37,202,240,225,242,229,110,128,36,167,115,3,122,215,122,222,122,230,236,225,243,104,128,1,66,241,245,225,242,101,128,33,19,245,240,229,242,233,239,114,128,246,238,244,243,232,225,228,101,128,37,145,245,244,232,225,105,128,14,38,246,239,227,225,236,233,99,3,123,15,123,25,123,32,226,229,238,231,225,236,105,128,9,140,228,229,246,97,128,
9,12,246,239,247,229,236,243,233,231,110,2,123,46,123,56,226,229,238,231,225,236,105,128,9,226,228,229,246,97,128,9,98,248,243,241,245,225,242,101,128,51,211,109,144,0,109,123,109,125,218,125,243,126,14,126,39,127,92,127,114,128,169,128,199,128,248,129,99,129,121,129,146,129,155,130,182,130,210,97,12,123,135,123,145,123,209,123,216,123,241,124,33,125,125,125,150,125,155,125,169,125,181,125,186,226,229,238,231,225,236,105,128,9,174,99,2,123,151,123,203,242,239,110,132,0,175,123,165,123,176,123,182,
123,191,226,229,236,239,247,227,237,98,128,3,49,227,237,98,128,3,4,236,239,247,237,239,100,128,2,205,237,239,238,239,243,240,225,227,101,128,255,227,245,244,101,128,30,63,228,229,246,97,128,9,46,231,117,2,123,223,123,232,234,225,242,225,244,105,128,10,174,242,237,245,235,232,105,128,10,46,104,2,123,247,124,23,225,240,225,235,104,2,124,1,124,10,232,229,226,242,229,119,128,5,164,236,229,230,244,232,229,226,242,229,119,128,5,164,233,242,225,231,225,238,97,128,48,126,105,5,124,45,124,114,124,177,124,
207,125,113,227,232,225,244,244,225,247,97,3,124,60,124,91,124,98,236,239,119,2,124,68,124,79,236,229,230,244,244,232,225,105,128,248,149,242,233,231,232,244,244,232,225,105,128,248,148,244,232,225,105,128,14,75,245,240,240,229,242,236,229,230,244,244,232,225,105,128,248,147,229,107,3,124,123,124,154,124,161,236,239,119,2,124,131,124,142,236,229,230,244,244,232,225,105,128,248,140,242,233,231,232,244,244,232,225,105,128,248,139,244,232,225,105,128,14,72,245,240,240,229,242,236,229,230,244,244,232,
225,105,128,248,138,232,225,238,225,235,225,116,2,124,189,124,200,236,229,230,244,244,232,225,105,128,248,132,244,232,225,105,128,14,49,116,3,124,215,124,243,125,50,225,233,235,232,117,2,124,225,124,236,236,229,230,244,244,232,225,105,128,248,137,244,232,225,105,128,14,71,232,111,3,124,252,125,27,125,34,236,239,119,2,125,4,125,15,236,229,230,244,244,232,225,105,128,248,143,242,233,231,232,244,244,232,225,105,128,248,142,244,232,225,105,128,14,73,245,240,240,229,242,236,229,230,244,244,232,225,105,
128,248,141,242,105,3,125,59,125,90,125,97,236,239,119,2,125,67,125,78,236,229,230,244,244,232,225,105,128,248,146,242,233,231,232,244,244,232,225,105,128,248,145,244,232,225,105,128,14,74,245,240,240,229,242,236,229,230,244,244,232,225,105,128,248,144,249,225,237,239,235,244,232,225,105,128,14,70,235,225,244,225,235,225,238,97,129,48,222,125,138,232,225,236,230,247,233,228,244,104,128,255,143,236,101,128,38,66,238,243,249,239,238,243,241,245,225,242,101,128,51,71,241,225,230,232,229,226,242,229,
119,128,5,190,242,115,128,38,66,115,2,125,192,125,210,239,242,225,227,233,242,227,236,229,232,229,226,242,229,119,128,5,175,241,245,225,242,101,128,51,131,98,2,125,224,125,234,239,240,239,237,239,230,111,128,49,7,243,241,245,225,242,101,128,51,212,99,2,125,249,126,1,233,242,227,236,101,128,36,220,245,226,229,228,243,241,245,225,242,101,128,51,165,228,239,116,2,126,22,126,31,225,227,227,229,238,116,128,30,65,226,229,236,239,119,128,30,67,101,7,126,55,126,182,126,193,126,208,126,233,127,14,127,26,101,
2,126,61,126,169,109,4,126,71,126,80,126,94,126,110,225,242,225,226,233,99,128,6,69,230,233,238,225,236,225,242,225,226,233,99,128,254,226,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,227,237,101,2,126,117,126,130,228,233,225,236,225,242,225,226,233,99,128,254,228,229,237,105,2,126,138,126,153,238,233,244,233,225,236,225,242,225,226,233,99,128,252,209,243,239,236,225,244,229,228,225,242,225,226,233,99,128,252,72,244,239,242,245,243,241,245,225,242,101,128,51,77,232,233,242,225,231,225,
238,97,128,48,129,233,250,233,229,242,225,243,241,245,225,242,101,128,51,126,235,225,244,225,235,225,238,97,129,48,225,126,221,232,225,236,230,247,233,228,244,104,128,255,146,109,130,5,222,126,241,127,5,228,225,231,229,243,104,129,251,62,126,252,232,229,226,242,229,119,128,251,62,232,229,226,242,229,119,128,5,222,238,225,242,237,229,238,233,225,110,128,5,116,242,235,232,97,3,127,37,127,46,127,79,232,229,226,242,229,119,128,5,165,235,229,230,245,236,97,2,127,57,127,66,232,229,226,242,229,119,128,5,
166,236,229,230,244,232,229,226,242,229,119,128,5,166,236,229,230,244,232,229,226,242,229,119,128,5,165,104,2,127,98,127,104,239,239,107,128,2,113,250,243,241,245,225,242,101,128,51,146,105,6,127,128,127,165,128,46,128,57,128,82,128,139,228,100,2,127,135,127,160,236,229,228,239,244,235,225,244,225,235,225,238,225,232,225,236,230,247,233,228,244,104,128,255,101,239,116,128,0,183,229,245,109,5,127,179,127,214,127,229,127,238,128,33,97,2,127,185,127,200,227,233,242,227,236,229,235,239,242,229,225,110,
128,50,114,240,225,242,229,238,235,239,242,229,225,110,128,50,18,227,233,242,227,236,229,235,239,242,229,225,110,128,50,100,235,239,242,229,225,110,128,49,65,112,2,127,244,128,20,97,2,127,250,128,8,238,243,233,239,243,235,239,242,229,225,110,128,49,112,242,229,238,235,239,242,229,225,110,128,50,4,233,229,245,240,235,239,242,229,225,110,128,49,110,243,233,239,243,235,239,242,229,225,110,128,49,111,232,233,242,225,231,225,238,97,128,48,127,235,225,244,225,235,225,238,97,129,48,223,128,70,232,225,236,
230,247,233,228,244,104,128,255,144,238,117,2,128,89,128,134,115,132,34,18,128,101,128,112,128,121,128,127,226,229,236,239,247,227,237,98,128,3,32,227,233,242,227,236,101,128,34,150,237,239,100,128,2,215,240,236,245,115,128,34,19,244,101,128,32,50,242,105,2,128,146,128,160,226,225,225,242,245,243,241,245,225,242,101,128,51,74,243,241,245,225,242,101,128,51,73,108,2,128,175,128,190,239,238,231,236,229,231,244,245,242,238,229,100,128,2,112,243,241,245,225,242,101,128,51,150,109,3,128,207,128,221,128,
232,227,245,226,229,228,243,241,245,225,242,101,128,51,163,239,238,239,243,240,225,227,101,128,255,77,243,241,245,225,242,229,228,243,241,245,225,242,101,128,51,159,111,5,129,4,129,30,129,55,129,65,129,74,104,2,129,10,129,20,233,242,225,231,225,238,97,128,48,130,237,243,241,245,225,242,101,128,51,193,235,225,244,225,235,225,238,97,129,48,226,129,43,232,225,236,230,247,233,228,244,104,128,255,147,236,243,241,245,225,242,101,128,51,214,237,225,244,232,225,105,128,14,33,246,229,242,243,243,241,245,225,
242,101,129,51,167,129,89,228,243,241,245,225,242,101,128,51,168,240,97,2,129,106,129,112,242,229,110,128,36,168,243,241,245,225,242,101,128,51,171,115,2,129,127,129,136,243,241,245,225,242,101,128,51,179,245,240,229,242,233,239,114,128,246,239,244,245,242,238,229,100,128,2,111,117,141,0,181,129,185,129,189,129,199,129,223,129,233,129,255,130,10,130,35,130,58,130,68,130,98,130,162,130,172,49,128,0,181,225,243,241,245,225,242,101,128,51,130,227,104,2,129,206,129,216,231,242,229,225,244,229,114,128,
34,107,236,229,243,115,128,34,106,230,243,241,245,225,242,101,128,51,140,103,2,129,239,129,246,242,229,229,107,128,3,188,243,241,245,225,242,101,128,51,141,232,233,242,225,231,225,238,97,128,48,128,235,225,244,225,235,225,238,97,129,48,224,130,23,232,225,236,230,247,233,228,244,104,128,255,145,108,2,130,41,130,50,243,241,245,225,242,101,128,51,149,244,233,240,236,121,128,0,215,237,243,241,245,225,242,101,128,51,155,238,225,104,2,130,76,130,85,232,229,226,242,229,119,128,5,163,236,229,230,244,232,
229,226,242,229,119,128,5,163,115,2,130,104,130,153,233,99,3,130,113,130,130,130,141,225,236,238,239,244,101,129,38,106,130,124,228,226,108,128,38,107,230,236,225,244,243,233,231,110,128,38,109,243,232,225,242,240,243,233,231,110,128,38,111,243,241,245,225,242,101,128,51,178,246,243,241,245,225,242,101,128,51,182,247,243,241,245,225,242,101,128,51,188,118,2,130,188,130,201,237,229,231,225,243,241,245,225,242,101,128,51,185,243,241,245,225,242,101,128,51,183,119,2,130,216,130,229,237,229,231,225,243,
241,245,225,242,101,128,51,191,243,241,245,225,242,101,128,51,189,110,150,0,110,131,30,131,164,131,188,131,254,132,23,132,81,132,91,132,158,132,201,134,235,134,253,135,22,135,53,135,79,135,144,137,126,137,134,137,159,137,167,138,135,138,145,138,155,97,8,131,48,131,68,131,75,131,82,131,107,131,118,131,143,131,155,98,2,131,54,131,63,229,238,231,225,236,105,128,9,168,236,97,128,34,7,227,245,244,101,128,1,68,228,229,246,97,128,9,40,231,117,2,131,89,131,98,234,225,242,225,244,105,128,10,168,242,237,245,
235,232,105,128,10,40,232,233,242,225,231,225,238,97,128,48,106,235,225,244,225,235,225,238,97,129,48,202,131,131,232,225,236,230,247,233,228,244,104,128,255,133,240,239,243,244,242,239,240,232,101,128,1,73,243,241,245,225,242,101,128,51,129,98,2,131,170,131,180,239,240,239,237,239,230,111,128,49,11,243,240,225,227,101,128,0,160,99,4,131,198,131,205,131,214,131,241,225,242,239,110,128,1,72,229,228,233,236,236,97,128,1,70,233,242,99,2,131,222,131,227,236,101,128,36,221,245,237,230,236,229,248,226,
229,236,239,119,128,30,75,239,237,237,225,225,227,227,229,238,116,128,1,70,228,239,116,2,132,6,132,15,225,227,227,229,238,116,128,30,69,226,229,236,239,119,128,30,71,101,3,132,31,132,42,132,67,232,233,242,225,231,225,238,97,128,48,109,235,225,244,225,235,225,238,97,129,48,205,132,55,232,225,236,230,247,233,228,244,104,128,255,136,247,243,232,229,241,229,236,243,233,231,110,128,32,170,230,243,241,245,225,242,101,128,51,139,103,2,132,97,132,147,97,3,132,105,132,115,132,122,226,229,238,231,225,236,105,
128,9,153,228,229,246,97,128,9,25,231,117,2,132,129,132,138,234,225,242,225,244,105,128,10,153,242,237,245,235,232,105,128,10,25,239,238,231,245,244,232,225,105,128,14,7,104,2,132,164,132,174,233,242,225,231,225,238,97,128,48,147,239,239,107,2,132,182,132,189,236,229,230,116,128,2,114,242,229,244,242,239,230,236,229,120,128,2,115,105,4,132,211,133,124,133,135,133,193,229,245,110,7,132,229,133,8,133,40,133,54,133,63,133,96,133,109,97,2,132,235,132,250,227,233,242,227,236,229,235,239,242,229,225,110,
128,50,111,240,225,242,229,238,235,239,242,229,225,110,128,50,15,227,105,2,133,15,133,27,229,245,227,235,239,242,229,225,110,128,49,53,242,227,236,229,235,239,242,229,225,110,128,50,97,232,233,229,245,232,235,239,242,229,225,110,128,49,54,235,239,242,229,225,110,128,49,52,240,97,2,133,70,133,84,238,243,233,239,243,235,239,242,229,225,110,128,49,104,242,229,238,235,239,242,229,225,110,128,50,1,243,233,239,243,235,239,242,229,225,110,128,49,103,244,233,235,229,245,244,235,239,242,229,225,110,128,49,
102,232,233,242,225,231,225,238,97,128,48,107,107,2,133,141,133,165,225,244,225,235,225,238,97,129,48,203,133,153,232,225,236,230,247,233,228,244,104,128,255,134,232,225,232,233,116,2,133,175,133,186,236,229,230,244,244,232,225,105,128,248,153,244,232,225,105,128,14,77,238,101,141,0,57,133,224,133,233,133,243,134,17,134,24,134,49,134,76,134,110,134,122,134,133,134,166,134,174,134,185,225,242,225,226,233,99,128,6,105,226,229,238,231,225,236,105,128,9,239,227,233,242,227,236,101,129,36,104,133,254,
233,238,246,229,242,243,229,243,225,238,243,243,229,242,233,102,128,39,146,228,229,246,97,128,9,111,231,117,2,134,31,134,40,234,225,242,225,244,105,128,10,239,242,237,245,235,232,105,128,10,111,232,97,2,134,56,134,67,227,235,225,242,225,226,233,99,128,6,105,238,231,250,232,239,117,128,48,41,105,2,134,82,134,100,228,229,239,231,242,225,240,232,233,227,240,225,242,229,110,128,50,40,238,230,229,242,233,239,114,128,32,137,237,239,238,239,243,240,225,227,101,128,255,25,239,236,228,243,244,249,236,101,
128,247,57,112,2,134,139,134,146,225,242,229,110,128,36,124,229,114,2,134,153,134,159,233,239,100,128,36,144,243,233,225,110,128,6,249,242,239,237,225,110,128,33,120,243,245,240,229,242,233,239,114,128,32,121,116,2,134,191,134,229,229,229,110,2,134,199,134,208,227,233,242,227,236,101,128,36,114,112,2,134,214,134,221,225,242,229,110,128,36,134,229,242,233,239,100,128,36,154,232,225,105,128,14,89,106,129,1,204,134,241,229,227,249,242,233,236,236,233,99,128,4,90,235,225,244,225,235,225,238,97,129,48,
243,135,10,232,225,236,230,247,233,228,244,104,128,255,157,108,2,135,28,135,42,229,231,242,233,231,232,244,236,239,238,103,128,1,158,233,238,229,226,229,236,239,119,128,30,73,109,2,135,59,135,70,239,238,239,243,240,225,227,101,128,255,78,243,241,245,225,242,101,128,51,154,110,2,135,85,135,135,97,3,135,93,135,103,135,110,226,229,238,231,225,236,105,128,9,163,228,229,246,97,128,9,35,231,117,2,135,117,135,126,234,225,242,225,244,105,128,10,163,242,237,245,235,232,105,128,10,35,238,225,228,229,246,97,
128,9,41,111,6,135,158,135,169,135,194,135,235,136,187,137,114,232,233,242,225,231,225,238,97,128,48,110,235,225,244,225,235,225,238,97,129,48,206,135,182,232,225,236,230,247,233,228,244,104,128,255,137,110,3,135,202,135,218,135,227,226,242,229,225,235,233,238,231,243,240,225,227,101,128,0,160,229,238,244,232,225,105,128,14,19,245,244,232,225,105,128,14,25,239,110,7,135,252,136,5,136,19,136,53,136,69,136,110,136,169,225,242,225,226,233,99,128,6,70,230,233,238,225,236,225,242,225,226,233,99,128,254,
230,231,232,245,238,238,97,2,136,30,136,39,225,242,225,226,233,99,128,6,186,230,233,238,225,236,225,242,225,226,233,99,128,251,159,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,231,234,229,229,237,105,2,136,79,136,94,238,233,244,233,225,236,225,242,225,226,233,99,128,252,210,243,239,236,225,244,229,228,225,242,225,226,233,99,128,252,75,237,101,2,136,117,136,130,228,233,225,236,225,242,225,226,233,99,128,254,232,229,237,105,2,136,138,136,153,238,233,244,233,225,236,225,242,225,226,233,
99,128,252,213,243,239,236,225,244,229,228,225,242,225,226,233,99,128,252,78,238,239,239,238,230,233,238,225,236,225,242,225,226,233,99,128,252,141,116,7,136,203,136,214,136,243,137,22,137,34,137,54,137,80,227,239,238,244,225,233,238,115,128,34,12,101,2,136,220,136,236,236,229,237,229,238,116,129,34,9,136,231,239,102,128,34,9,241,245,225,108,128,34,96,231,242,229,225,244,229,114,129,34,111,136,255,238,239,114,2,137,7,137,15,229,241,245,225,108,128,34,113,236,229,243,115,128,34,121,233,228,229,238,
244,233,227,225,108,128,34,98,236,229,243,115,129,34,110,137,43,238,239,242,229,241,245,225,108,128,34,112,112,2,137,60,137,70,225,242,225,236,236,229,108,128,34,38,242,229,227,229,228,229,115,128,34,128,243,117,3,137,89,137,96,137,105,226,243,229,116,128,34,132,227,227,229,229,228,115,128,34,129,240,229,242,243,229,116,128,34,133,247,225,242,237,229,238,233,225,110,128,5,118,240,225,242,229,110,128,36,169,115,2,137,140,137,149,243,241,245,225,242,101,128,51,177,245,240,229,242,233,239,114,128,32,
127,244,233,236,228,101,128,0,241,117,132,3,189,137,179,137,190,138,15,138,98,232,233,242,225,231,225,238,97,128,48,108,107,2,137,196,137,220,225,244,225,235,225,238,97,129,48,204,137,208,232,225,236,230,247,233,228,244,104,128,255,135,244,97,3,137,229,137,239,137,246,226,229,238,231,225,236,105,128,9,188,228,229,246,97,128,9,60,231,117,2,137,253,138,6,234,225,242,225,244,105,128,10,188,242,237,245,235,232,105,128,10,60,109,2,138,21,138,55,226,229,242,243,233,231,110,130,0,35,138,35,138,47,237,239,
238,239,243,240,225,227,101,128,255,3,243,237,225,236,108,128,254,95,229,114,2,138,62,138,94,225,236,243,233,231,110,2,138,73,138,81,231,242,229,229,107,128,3,116,236,239,247,229,242,231,242,229,229,107,128,3,117,111,128,33,22,110,130,5,224,138,106,138,126,228,225,231,229,243,104,129,251,64,138,117,232,229,226,242,229,119,128,251,64,232,229,226,242,229,119,128,5,224,246,243,241,245,225,242,101,128,51,181,247,243,241,245,225,242,101,128,51,187,249,97,3,138,164,138,174,138,181,226,229,238,231,225,236,
105,128,9,158,228,229,246,97,128,9,30,231,117,2,138,188,138,197,234,225,242,225,244,105,128,10,158,242,237,245,235,232,105,128,10,30,111,147,0,111,138,248,139,14,139,92,140,6,140,78,140,93,140,133,141,0,141,21,141,59,141,70,141,248,143,82,143,146,143,179,143,225,144,98,144,145,144,157,97,2,138,254,139,5,227,245,244,101,128,0,243,238,231,244,232,225,105,128,14,45,98,4,139,24,139,66,139,75,139,85,225,242,242,229,100,130,2,117,139,36,139,47,227,249,242,233,236,236,233,99,128,4,233,228,233,229,242,229,
243,233,243,227,249,242,233,236,236,233,99,128,4,235,229,238,231,225,236,105,128,9,147,239,240,239,237,239,230,111,128,49,27,242,229,246,101,128,1,79,99,3,139,100,139,173,139,252,97,2,139,106,139,167,238,228,242,97,3,139,117,139,124,139,135,228,229,246,97,128,9,17,231,245,234,225,242,225,244,105,128,10,145,246,239,247,229,236,243,233,231,110,2,139,149,139,156,228,229,246,97,128,9,73,231,245,234,225,242,225,244,105,128,10,201,242,239,110,128,1,210,233,242,99,2,139,181,139,186,236,101,128,36,222,245,
237,230,236,229,120,133,0,244,139,205,139,213,139,224,139,232,139,244,225,227,245,244,101,128,30,209,228,239,244,226,229,236,239,119,128,30,217,231,242,225,246,101,128,30,211,232,239,239,235,225,226,239,246,101,128,30,213,244,233,236,228,101,128,30,215,249,242,233,236,236,233,99,128,4,62,100,4,140,16,140,39,140,45,140,68,226,108,2,140,23,140,31,225,227,245,244,101,128,1,81,231,242,225,246,101,128,2,13,229,246,97,128,9,19,233,229,242,229,243,233,115,129,0,246,140,57,227,249,242,233,236,236,233,99,
128,4,231,239,244,226,229,236,239,119,128,30,205,101,129,1,83,140,84,235,239,242,229,225,110,128,49,90,103,3,140,101,140,116,140,123,239,238,229,107,129,2,219,140,110,227,237,98,128,3,40,242,225,246,101,128,0,242,245,234,225,242,225,244,105,128,10,147,104,4,140,143,140,154,140,164,140,242,225,242,237,229,238,233,225,110,128,5,133,233,242,225,231,225,238,97,128,48,74,111,2,140,170,140,180,239,235,225,226,239,246,101,128,30,207,242,110,133,1,161,140,195,140,203,140,214,140,222,140,234,225,227,245,244,
101,128,30,219,228,239,244,226,229,236,239,119,128,30,227,231,242,225,246,101,128,30,221,232,239,239,235,225,226,239,246,101,128,30,223,244,233,236,228,101,128,30,225,245,238,231,225,242,245,237,236,225,245,116,128,1,81,105,129,1,163,141,6,238,246,229,242,244,229,228,226,242,229,246,101,128,2,15,107,2,141,27,141,51,225,244,225,235,225,238,97,129,48,170,141,39,232,225,236,230,247,233,228,244,104,128,255,117,239,242,229,225,110,128,49,87,236,229,232,229,226,242,229,119,128,5,171,109,6,141,84,141,112,
141,119,141,208,141,219,141,237,225,227,242,239,110,130,1,77,141,96,141,104,225,227,245,244,101,128,30,83,231,242,225,246,101,128,30,81,228,229,246,97,128,9,80,229,231,97,133,3,201,141,135,141,139,141,150,141,164,141,180,49,128,3,214,227,249,242,233,236,236,233,99,128,4,97,236,225,244,233,238,227,236,239,243,229,100,128,2,119,242,239,245,238,228,227,249,242,233,236,236,233,99,128,4,123,116,2,141,186,141,201,233,244,236,239,227,249,242,233,236,236,233,99,128,4,125,239,238,239,115,128,3,206,231,245,
234,225,242,225,244,105,128,10,208,233,227,242,239,110,129,3,191,141,229,244,239,238,239,115,128,3,204,239,238,239,243,240,225,227,101,128,255,79,238,101,145,0,49,142,31,142,40,142,50,142,80,142,105,142,114,142,123,142,148,142,182,142,216,142,228,142,247,143,2,143,35,143,45,143,53,143,64,225,242,225,226,233,99,128,6,97,226,229,238,231,225,236,105,128,9,231,227,233,242,227,236,101,129,36,96,142,61,233,238,246,229,242,243,229,243,225,238,243,243,229,242,233,102,128,39,138,100,2,142,86,142,92,229,246,
97,128,9,103,239,244,229,238,236,229,225,228,229,114,128,32,36,229,233,231,232,244,104,128,33,91,230,233,244,244,229,100,128,246,220,231,117,2,142,130,142,139,234,225,242,225,244,105,128,10,231,242,237,245,235,232,105,128,10,103,232,97,3,142,157,142,168,142,173,227,235,225,242,225,226,233,99,128,6,97,236,102,128,0,189,238,231,250,232,239,117,128,48,33,105,2,142,188,142,206,228,229,239,231,242,225,240,232,233,227,240,225,242,229,110,128,50,32,238,230,229,242,233,239,114,128,32,129,237,239,238,239,
243,240,225,227,101,128,255,17,238,245,237,229,242,225,244,239,242,226,229,238,231,225,236,105,128,9,244,239,236,228,243,244,249,236,101,128,247,49,112,2,143,8,143,15,225,242,229,110,128,36,116,229,114,2,143,22,143,28,233,239,100,128,36,136,243,233,225,110,128,6,241,241,245,225,242,244,229,114,128,0,188,242,239,237,225,110,128,33,112,243,245,240,229,242,233,239,114,128,0,185,244,104,2,143,71,143,76,225,105,128,14,81,233,242,100,128,33,83,111,3,143,90,143,124,143,140,103,2,143,96,143,114,239,238,229,
107,129,1,235,143,105,237,225,227,242,239,110,128,1,237,245,242,237,245,235,232,105,128,10,19,237,225,244,242,225,231,245,242,237,245,235,232,105,128,10,75,240,229,110,128,2,84,112,3,143,154,143,161,143,172,225,242,229,110,128,36,170,229,238,226,245,236,236,229,116,128,37,230,244,233,239,110,128,35,37,114,2,143,185,143,214,100,2,143,191,143,202,230,229,237,233,238,233,238,101,128,0,170,237,225,243,227,245,236,233,238,101,128,0,186,244,232,239,231,239,238,225,108,128,34,31,115,5,143,237,144,13,144,
30,144,75,144,88,232,239,242,116,2,143,246,143,253,228,229,246,97,128,9,18,246,239,247,229,236,243,233,231,238,228,229,246,97,128,9,74,236,225,243,104,129,0,248,144,22,225,227,245,244,101,128,1,255,237,225,236,108,2,144,39,144,50,232,233,242,225,231,225,238,97,128,48,73,235,225,244,225,235,225,238,97,129,48,169,144,63,232,225,236,230,247,233,228,244,104,128,255,107,244,242,239,235,229,225,227,245,244,101,128,1,255,245,240,229,242,233,239,114,128,246,240,116,2,144,104,144,115,227,249,242,233,236,236,
233,99,128,4,127,233,236,228,101,130,0,245,144,126,144,134,225,227,245,244,101,128,30,77,228,233,229,242,229,243,233,115,128,30,79,245,226,239,240,239,237,239,230,111,128,49,33,118,2,144,163,144,244,229,114,2,144,170,144,236,236,233,238,101,131,32,62,144,183,144,206,144,229,99,2,144,189,144,201,229,238,244,229,242,236,233,238,101,128,254,74,237,98,128,3,5,100,2,144,212,144,220,225,243,232,229,100,128,254,73,226,236,247,225,246,121,128,254,76,247,225,246,121,128,254,75,243,227,239,242,101,128,0,175,
239,247,229,236,243,233,231,110,3,145,3,145,13,145,20,226,229,238,231,225,236,105,128,9,203,228,229,246,97,128,9,75,231,245,234,225,242,225,244,105,128,10,203,112,145,0,112,145,69,147,197,147,208,147,217,147,229,149,154,149,164,150,156,151,175,152,9,152,35,152,166,152,174,153,76,153,134,153,162,153,172,97,14,145,99,145,131,145,141,145,148,145,155,145,203,145,214,145,228,145,239,146,30,146,44,147,56,147,95,147,185,97,2,145,105,145,117,237,240,243,243,241,245,225,242,101,128,51,128,243,229,238,244,
239,243,241,245,225,242,101,128,51,43,226,229,238,231,225,236,105,128,9,170,227,245,244,101,128,30,85,228,229,246,97,128,9,42,103,2,145,161,145,179,101,2,145,167,145,174,228,239,247,110,128,33,223,245,112,128,33,222,117,2,145,185,145,194,234,225,242,225,244,105,128,10,170,242,237,245,235,232,105,128,10,42,232,233,242,225,231,225,238,97,128,48,113,233,249,225,238,238,239,233,244,232,225,105,128,14,47,235,225,244,225,235,225,238,97,128,48,209,108,2,145,245,146,14,225,244,225,236,233,250,225,244,233,
239,238,227,249,242,233,236,236,233,227,227,237,98,128,4,132,239,227,232,235,225,227,249,242,233,236,236,233,99,128,4,192,238,243,233,239,243,235,239,242,229,225,110,128,49,127,114,3,146,52,146,73,147,45,97,2,146,58,146,66,231,242,225,240,104,128,0,182,236,236,229,108,128,34,37,229,110,2,146,80,146,190,236,229,230,116,136,0,40,146,103,146,118,146,123,146,128,146,139,146,151,146,174,146,179,225,236,244,239,238,229,225,242,225,226,233,99,128,253,62,226,116,128,248,237,229,120,128,248,236,233,238,230,
229,242,233,239,114,128,32,141,237,239,238,239,243,240,225,227,101,128,255,8,115,2,146,157,146,164,237,225,236,108,128,254,89,245,240,229,242,233,239,114,128,32,125,244,112,128,248,235,246,229,242,244,233,227,225,108,128,254,53,242,233,231,232,116,136,0,41,146,214,146,229,146,234,146,239,146,250,147,6,147,29,147,34,225,236,244,239,238,229,225,242,225,226,233,99,128,253,63,226,116,128,248,248,229,120,128,248,247,233,238,230,229,242,233,239,114,128,32,142,237,239,238,239,243,240,225,227,101,128,255,
9,115,2,147,12,147,19,237,225,236,108,128,254,90,245,240,229,242,233,239,114,128,32,126,244,112,128,248,246,246,229,242,244,233,227,225,108,128,254,54,244,233,225,236,228,233,230,102,128,34,2,115,3,147,64,147,75,147,87,229,241,232,229,226,242,229,119,128,5,192,232,244,225,232,229,226,242,229,119,128,5,153,241,245,225,242,101,128,51,169,244,225,104,134,5,183,147,113,147,127,147,132,147,141,147,156,147,172,49,2,147,119,147,123,49,128,5,183,100,128,5,183,178,97,128,5,183,232,229,226,242,229,119,128,
5,183,238,225,242,242,239,247,232,229,226,242,229,119,128,5,183,241,245,225,242,244,229,242,232,229,226,242,229,119,128,5,183,247,233,228,229,232,229,226,242,229,119,128,5,183,250,229,242,232,229,226,242,229,119,128,5,161,226,239,240,239,237,239,230,111,128,49,6,227,233,242,227,236,101,128,36,223,228,239,244,225,227,227,229,238,116,128,30,87,101,137,5,228,147,251,148,6,148,26,148,38,148,58,148,160,148,171,148,192,149,147,227,249,242,233,236,236,233,99,128,4,63,228,225,231,229,243,104,129,251,68,148,
17,232,229,226,242,229,119,128,251,68,229,250,233,243,241,245,225,242,101,128,51,59,230,233,238,225,236,228,225,231,229,243,232,232,229,226,242,229,119,128,251,67,104,5,148,70,148,93,148,101,148,115,148,145,225,114,2,148,77,148,84,225,226,233,99,128,6,126,237,229,238,233,225,110,128,5,122,229,226,242,229,119,128,5,228,230,233,238,225,236,225,242,225,226,233,99,128,251,87,105,2,148,121,148,136,238,233,244,233,225,236,225,242,225,226,233,99,128,251,88,242,225,231,225,238,97,128,48,122,237,229,228,233,
225,236,225,242,225,226,233,99,128,251,89,235,225,244,225,235,225,238,97,128,48,218,237,233,228,228,236,229,232,239,239,235,227,249,242,233,236,236,233,99,128,4,167,114,5,148,204,148,216,149,2,149,123,149,136,225,230,229,232,229,226,242,229,119,128,251,78,227,229,238,116,131,0,37,148,229,148,238,148,250,225,242,225,226,233,99,128,6,106,237,239,238,239,243,240,225,227,101,128,255,5,243,237,225,236,108,128,254,106,105,2,149,8,149,105,239,100,134,0,46,149,25,149,36,149,47,149,59,149,70,149,82,225,242,
237,229,238,233,225,110,128,5,137,227,229,238,244,229,242,229,100,128,0,183,232,225,236,230,247,233,228,244,104,128,255,97,233,238,230,229,242,233,239,114,128,246,231,237,239,238,239,243,240,225,227,101,128,255,14,115,2,149,88,149,95,237,225,236,108,128,254,82,245,240,229,242,233,239,114,128,246,232,243,240,239,237,229,238,233,231,242,229,229,235,227,237,98,128,3,66,240,229,238,228,233,227,245,236,225,114,128,34,165,244,232,239,245,243,225,238,100,128,32,48,243,229,244,97,128,32,167,230,243,241,245,
225,242,101,128,51,138,104,3,149,172,149,222,150,103,97,3,149,180,149,190,149,197,226,229,238,231,225,236,105,128,9,171,228,229,246,97,128,9,43,231,117,2,149,204,149,213,234,225,242,225,244,105,128,10,171,242,237,245,235,232,105,128,10,43,105,133,3,198,149,236,149,240,150,70,150,78,150,89,49,128,3,213,229,245,240,104,4,149,253,150,32,150,47,150,56,97,2,150,3,150,18,227,233,242,227,236,229,235,239,242,229,225,110,128,50,122,240,225,242,229,238,235,239,242,229,225,110,128,50,26,227,233,242,227,236,
229,235,239,242,229,225,110,128,50,108,235,239,242,229,225,110,128,49,77,240,225,242,229,238,235,239,242,229,225,110,128,50,12,236,225,244,233,110,128,2,120,238,244,232,245,244,232,225,105,128,14,58,243,249,237,226,239,236,231,242,229,229,107,128,3,213,111,3,150,111,150,116,150,142,239,107,128,1,165,240,104,2,150,123,150,132,225,238,244,232,225,105,128,14,30,245,238,231,244,232,225,105,128,14,28,243,225,237,240,232,225,239,244,232,225,105,128,14,32,105,133,3,192,150,170,151,126,151,137,151,148,151,
162,229,245,112,6,150,186,150,221,150,253,151,25,151,39,151,91,97,2,150,192,150,207,227,233,242,227,236,229,235,239,242,229,225,110,128,50,115,240,225,242,229,238,235,239,242,229,225,110,128,50,19,227,105,2,150,228,150,240,229,245,227,235,239,242,229,225,110,128,49,118,242,227,236,229,235,239,242,229,225,110,128,50,101,107,2,151,3,151,17,233,249,229,239,235,235,239,242,229,225,110,128,49,114,239,242,229,225,110,128,49,66,240,225,242,229,238,235,239,242,229,225,110,128,50,5,243,233,239,115,2,151,48,
151,76,107,2,151,54,151,68,233,249,229,239,235,235,239,242,229,225,110,128,49,116,239,242,229,225,110,128,49,68,244,233,235,229,245,244,235,239,242,229,225,110,128,49,117,116,2,151,97,151,112,232,233,229,245,244,232,235,239,242,229,225,110,128,49,119,233,235,229,245,244,235,239,242,229,225,110,128,49,115,232,233,242,225,231,225,238,97,128,48,116,235,225,244,225,235,225,238,97,128,48,212,243,249,237,226,239,236,231,242,229,229,107,128,3,214,247,242,225,242,237,229,238,233,225,110,128,5,131,236,245,
115,132,0,43,151,189,151,200,151,209,151,242,226,229,236,239,247,227,237,98,128,3,31,227,233,242,227,236,101,128,34,149,109,2,151,215,151,222,233,238,245,115,128,0,177,111,2,151,228,151,232,100,128,2,214,238,239,243,240,225,227,101,128,255,11,115,2,151,248,151,255,237,225,236,108,128,254,98,245,240,229,242,233,239,114,128,32,122,109,2,152,15,152,26,239,238,239,243,240,225,227,101,128,255,80,243,241,245,225,242,101,128,51,216,111,5,152,47,152,58,152,125,152,136,152,146,232,233,242,225,231,225,238,
97,128,48,125,233,238,244,233,238,231,233,238,228,229,120,4,152,78,152,90,152,102,152,115,228,239,247,238,247,232,233,244,101,128,38,31,236,229,230,244,247,232,233,244,101,128,38,28,242,233,231,232,244,247,232,233,244,101,128,38,30,245,240,247,232,233,244,101,128,38,29,235,225,244,225,235,225,238,97,128,48,221,240,236,225,244,232,225,105,128,14,27,243,244,225,236,237,225,242,107,129,48,18,152,159,230,225,227,101,128,48,32,240,225,242,229,110,128,36,171,114,3,152,182,152,208,152,233,101,2,152,188,
152,196,227,229,228,229,115,128,34,122,243,227,242,233,240,244,233,239,110,128,33,30,233,237,101,2,152,216,152,222,237,239,100,128,2,185,242,229,246,229,242,243,229,100,128,32,53,111,4,152,243,152,250,153,4,153,17,228,245,227,116,128,34,15,234,229,227,244,233,246,101,128,35,5,236,239,238,231,229,228,235,225,238,97,128,48,252,112,2,153,23,153,60,101,2,153,29,153,36,236,236,239,114,128,35,24,242,243,117,2,153,44,153,51,226,243,229,116,128,34,130,240,229,242,243,229,116,128,34,131,239,242,244,233,239,
110,129,34,55,153,71,225,108,128,34,29,115,2,153,82,153,125,105,130,3,200,153,90,153,101,227,249,242,233,236,236,233,99,128,4,113,236,233,240,238,229,245,237,225,244,225,227,249,242,233,236,236,233,227,227,237,98,128,4,134,243,241,245,225,242,101,128,51,176,117,2,153,140,153,151,232,233,242,225,231,225,238,97,128,48,119,235,225,244,225,235,225,238,97,128,48,215,246,243,241,245,225,242,101,128,51,180,247,243,241,245,225,242,101,128,51,186,113,136,0,113,153,202,154,251,155,6,155,15,155,22,155,34,155,
72,155,80,97,4,153,212,153,235,154,43,154,234,100,2,153,218,153,224,229,246,97,128,9,88,237,225,232,229,226,242,229,119,128,5,168,102,4,153,245,153,254,154,12,154,28,225,242,225,226,233,99,128,6,66,230,233,238,225,236,225,242,225,226,233,99,128,254,214,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,215,237,229,228,233,225,236,225,242,225,226,233,99,128,254,216,237,225,244,115,136,5,184,154,66,154,86,154,100,154,105,154,110,154,119,154,134,154,221,49,3,154,74,154,78,154,82,48,128,5,184,
97,128,5,184,99,128,5,184,50,2,154,92,154,96,55,128,5,184,57,128,5,184,179,51,128,5,184,228,101,128,5,184,232,229,226,242,229,119,128,5,184,238,225,242,242,239,247,232,229,226,242,229,119,128,5,184,113,2,154,140,154,206,225,244,225,110,4,154,153,154,162,154,177,154,193,232,229,226,242,229,119,128,5,184,238,225,242,242,239,247,232,229,226,242,229,119,128,5,184,241,245,225,242,244,229,242,232,229,226,242,229,119,128,5,184,247,233,228,229,232,229,226,242,229,119,128,5,184,245,225,242,244,229,242,232,
229,226,242,229,119,128,5,184,247,233,228,229,232,229,226,242,229,119,128,5,184,242,238,229,249,240,225,242,225,232,229,226,242,229,119,128,5,159,226,239,240,239,237,239,230,111,128,49,17,227,233,242,227,236,101,128,36,224,232,239,239,107,128,2,160,237,239,238,239,243,240,225,227,101,128,255,81,239,102,130,5,231,155,43,155,63,228,225,231,229,243,104,129,251,71,155,54,232,229,226,242,229,119,128,251,71,232,229,226,242,229,119,128,5,231,240,225,242,229,110,128,36,172,117,4,155,90,155,102,155,191,156,
22,225,242,244,229,242,238,239,244,101,128,38,105,226,245,244,115,135,5,187,155,123,155,128,155,133,155,138,155,147,155,162,155,178,177,56,128,5,187,178,53,128,5,187,179,49,128,5,187,232,229,226,242,229,119,128,5,187,238,225,242,242,239,247,232,229,226,242,229,119,128,5,187,241,245,225,242,244,229,242,232,229,226,242,229,119,128,5,187,247,233,228,229,232,229,226,242,229,119,128,5,187,229,243,244,233,239,110,133,0,63,155,210,155,233,155,250,156,2,156,14,225,114,2,155,217,155,224,225,226,233,99,128,
6,31,237,229,238,233,225,110,128,5,94,228,239,247,110,129,0,191,155,242,243,237,225,236,108,128,247,191,231,242,229,229,107,128,3,126,237,239,238,239,243,240,225,227,101,128,255,31,243,237,225,236,108,128,247,63,239,244,101,4,156,34,156,105,156,125,156,154,228,226,108,133,0,34,156,50,156,57,156,64,156,76,156,97,226,225,243,101,128,32,30,236,229,230,116,128,32,28,237,239,238,239,243,240,225,227,101,128,255,2,240,242,233,237,101,129,48,30,156,86,242,229,246,229,242,243,229,100,128,48,29,242,233,231,
232,116,128,32,29,236,229,230,116,129,32,24,156,114,242,229,246,229,242,243,229,100,128,32,27,114,2,156,131,156,141,229,246,229,242,243,229,100,128,32,27,233,231,232,116,129,32,25,156,150,110,128,1,73,243,233,238,231,108,2,156,164,156,171,226,225,243,101,128,32,26,101,129,0,39,156,177,237,239,238,239,243,240,225,227,101,128,255,7,114,145,0,114,156,227,157,231,157,242,158,33,158,84,159,101,159,125,159,220,161,254,162,35,162,47,162,101,162,109,163,15,163,26,163,61,163,161,97,11,156,251,157,6,157,16,
157,23,157,88,157,104,157,129,157,140,157,165,157,188,157,225,225,242,237,229,238,233,225,110,128,5,124,226,229,238,231,225,236,105,128,9,176,227,245,244,101,128,1,85,100,4,157,33,157,39,157,53,157,79,229,246,97,128,9,48,233,227,225,108,129,34,26,157,48,229,120,128,248,229,239,246,229,242,243,243,241,245,225,242,101,129,51,174,157,69,228,243,241,245,225,242,101,128,51,175,243,241,245,225,242,101,128,51,173,230,101,129,5,191,157,95,232,229,226,242,229,119,128,5,191,231,117,2,157,111,157,120,234,225,
242,225,244,105,128,10,176,242,237,245,235,232,105,128,10,48,232,233,242,225,231,225,238,97,128,48,137,235,225,244,225,235,225,238,97,129,48,233,157,153,232,225,236,230,247,233,228,244,104,128,255,151,236,239,247,229,242,228,233,225,231,239,238,225,236,226,229,238,231,225,236,105,128,9,241,109,2,157,194,157,217,233,228,228,236,229,228,233,225,231,239,238,225,236,226,229,238,231,225,236,105,128,9,240,243,232,239,242,110,128,2,100,244,233,111,128,34,54,226,239,240,239,237,239,230,111,128,49,22,99,4,
157,252,158,3,158,12,158,20,225,242,239,110,128,1,89,229,228,233,236,236,97,128,1,87,233,242,227,236,101,128,36,225,239,237,237,225,225,227,227,229,238,116,128,1,87,100,2,158,39,158,49,226,236,231,242,225,246,101,128,2,17,239,116,2,158,56,158,65,225,227,227,229,238,116,128,30,89,226,229,236,239,119,129,30,91,158,75,237,225,227,242,239,110,128,30,93,101,6,158,98,158,143,158,178,158,233,159,2,159,35,102,2,158,104,158,117,229,242,229,238,227,229,237,225,242,107,128,32,59,236,229,248,243,117,2,158,127,
158,134,226,243,229,116,128,34,134,240,229,242,243,229,116,128,34,135,231,233,243,244,229,114,2,158,154,158,159,229,100,128,0,174,115,2,158,165,158,171,225,238,115,128,248,232,229,242,233,102,128,246,218,104,3,158,186,158,209,158,223,225,114,2,158,193,158,200,225,226,233,99,128,6,49,237,229,238,233,225,110,128,5,128,230,233,238,225,236,225,242,225,226,233,99,128,254,174,233,242,225,231,225,238,97,128,48,140,235,225,244,225,235,225,238,97,129,48,236,158,246,232,225,236,230,247,233,228,244,104,128,
255,154,243,104,130,5,232,159,11,159,26,228,225,231,229,243,232,232,229,226,242,229,119,128,251,72,232,229,226,242,229,119,128,5,232,118,3,159,43,159,56,159,88,229,242,243,229,228,244,233,236,228,101,128,34,61,233,97,2,159,63,159,72,232,229,226,242,229,119,128,5,151,237,245,231,242,225,243,232,232,229,226,242,229,119,128,5,151,236,239,231,233,227,225,236,238,239,116,128,35,16,230,233,243,232,232,239,239,107,129,2,126,159,114,242,229,246,229,242,243,229,100,128,2,127,104,2,159,131,159,154,97,2,159,
137,159,147,226,229,238,231,225,236,105,128,9,221,228,229,246,97,128,9,93,111,131,3,193,159,164,159,193,159,207,239,107,129,2,125,159,171,244,245,242,238,229,100,129,2,123,159,182,243,245,240,229,242,233,239,114,128,2,181,243,249,237,226,239,236,231,242,229,229,107,128,3,241,244,233,227,232,239,239,235,237,239,100,128,2,222,105,6,159,234,161,22,161,68,161,79,161,104,161,240,229,245,108,9,160,0,160,35,160,50,160,64,160,110,160,124,160,210,160,223,161,2,97,2,160,6,160,21,227,233,242,227,236,229,235,
239,242,229,225,110,128,50,113,240,225,242,229,238,235,239,242,229,225,110,128,50,17,227,233,242,227,236,229,235,239,242,229,225,110,128,50,99,232,233,229,245,232,235,239,242,229,225,110,128,49,64,107,2,160,70,160,102,233,249,229,239,107,2,160,80,160,89,235,239,242,229,225,110,128,49,58,243,233,239,243,235,239,242,229,225,110,128,49,105,239,242,229,225,110,128,49,57,237,233,229,245,237,235,239,242,229,225,110,128,49,59,112,3,160,132,160,164,160,179,97,2,160,138,160,152,238,243,233,239,243,235,239,
242,229,225,110,128,49,108,242,229,238,235,239,242,229,225,110,128,50,3,232,233,229,245,240,232,235,239,242,229,225,110,128,49,63,233,229,245,112,2,160,188,160,197,235,239,242,229,225,110,128,49,60,243,233,239,243,235,239,242,229,225,110,128,49,107,243,233,239,243,235,239,242,229,225,110,128,49,61,116,2,160,229,160,244,232,233,229,245,244,232,235,239,242,229,225,110,128,49,62,233,235,229,245,244,235,239,242,229,225,110,128,49,106,249,229,239,242,233,238,232,233,229,245,232,235,239,242,229,225,110,
128,49,109,231,232,116,2,161,30,161,38,225,238,231,236,101,128,34,31,116,2,161,44,161,58,225,227,235,226,229,236,239,247,227,237,98,128,3,25,242,233,225,238,231,236,101,128,34,191,232,233,242,225,231,225,238,97,128,48,138,235,225,244,225,235,225,238,97,129,48,234,161,92,232,225,236,230,247,233,228,244,104,128,255,152,110,2,161,110,161,226,103,131,2,218,161,120,161,131,161,137,226,229,236,239,247,227,237,98,128,3,37,227,237,98,128,3,10,232,225,236,102,2,161,146,161,192,236,229,230,116,131,2,191,161,
159,161,170,161,181,225,242,237,229,238,233,225,110,128,5,89,226,229,236,239,247,227,237,98,128,3,28,227,229,238,244,229,242,229,100,128,2,211,242,233,231,232,116,130,2,190,161,204,161,215,226,229,236,239,247,227,237,98,128,3,57,227,229,238,244,229,242,229,100,128,2,210,246,229,242,244,229,228,226,242,229,246,101,128,2,19,244,244,239,242,245,243,241,245,225,242,101,128,51,81,108,2,162,4,162,15,233,238,229,226,229,236,239,119,128,30,95,239,238,231,236,229,103,129,2,124,162,26,244,245,242,238,229,100,
128,2,122,237,239,238,239,243,240,225,227,101,128,255,82,111,3,162,55,162,66,162,91,232,233,242,225,231,225,238,97,128,48,141,235,225,244,225,235,225,238,97,129,48,237,162,79,232,225,236,230,247,233,228,244,104,128,255,155,242,245,225,244,232,225,105,128,14,35,240,225,242,229,110,128,36,173,114,3,162,117,162,153,162,183,97,3,162,125,162,135,162,142,226,229,238,231,225,236,105,128,9,220,228,229,246,97,128,9,49,231,245,242,237,245,235,232,105,128,10,92,229,104,2,162,160,162,169,225,242,225,226,233,
99,128,6,145,230,233,238,225,236,225,242,225,226,233,99,128,251,141,246,239,227,225,236,233,99,4,162,199,162,209,162,216,162,227,226,229,238,231,225,236,105,128,9,224,228,229,246,97,128,9,96,231,245,234,225,242,225,244,105,128,10,224,246,239,247,229,236,243,233,231,110,3,162,243,162,253,163,4,226,229,238,231,225,236,105,128,9,196,228,229,246,97,128,9,68,231,245,234,225,242,225,244,105,128,10,196,243,245,240,229,242,233,239,114,128,246,241,116,2,163,32,163,40,226,236,239,227,107,128,37,144,245,242,
238,229,100,129,2,121,163,50,243,245,240,229,242,233,239,114,128,2,180,117,4,163,71,163,82,163,107,163,154,232,233,242,225,231,225,238,97,128,48,139,235,225,244,225,235,225,238,97,129,48,235,163,95,232,225,236,230,247,233,228,244,104,128,255,153,112,2,163,113,163,148,229,101,2,163,120,163,134,237,225,242,235,226,229,238,231,225,236,105,128,9,242,243,233,231,238,226,229,238,231,225,236,105,128,9,243,233,225,104,128,246,221,244,232,225,105,128,14,36,246,239,227,225,236,233,99,4,163,177,163,187,163,
194,163,205,226,229,238,231,225,236,105,128,9,139,228,229,246,97,128,9,11,231,245,234,225,242,225,244,105,128,10,139,246,239,247,229,236,243,233,231,110,3,163,221,163,231,163,238,226,229,238,231,225,236,105,128,9,195,228,229,246,97,128,9,67,231,245,234,225,242,225,244,105,128,10,195,115,147,0,115,164,35,166,5,166,16,166,142,166,181,169,123,169,134,172,21,174,159,174,205,174,232,175,167,175,234,177,11,177,21,177,207,178,24,178,194,178,204,97,9,164,55,164,65,164,86,164,158,164,183,164,194,164,219,164,
251,165,35,226,229,238,231,225,236,105,128,9,184,227,245,244,101,129,1,91,164,74,228,239,244,225,227,227,229,238,116,128,30,101,100,5,164,98,164,107,164,113,164,127,164,143,225,242,225,226,233,99,128,6,53,229,246,97,128,9,56,230,233,238,225,236,225,242,225,226,233,99,128,254,186,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,187,237,229,228,233,225,236,225,242,225,226,233,99,128,254,188,231,117,2,164,165,164,174,234,225,242,225,244,105,128,10,184,242,237,245,235,232,105,128,10,56,232,
233,242,225,231,225,238,97,128,48,85,235,225,244,225,235,225,238,97,129,48,181,164,207,232,225,236,230,247,233,228,244,104,128,255,123,236,236,225,236,236,225,232,239,245,225,236,225,249,232,229,247,225,243,225,236,236,225,237,225,242,225,226,233,99,128,253,250,237,229,235,104,130,5,225,165,6,165,26,228,225,231,229,243,104,129,251,65,165,17,232,229,226,242,229,119,128,251,65,232,229,226,242,229,119,128,5,225,242,97,5,165,48,165,122,165,130,165,180,165,188,97,5,165,60,165,68,165,76,165,107,165,115,
225,244,232,225,105,128,14,50,229,244,232,225,105,128,14,65,233,237,225,233,109,2,165,86,165,97,225,236,225,233,244,232,225,105,128,14,68,245,225,238,244,232,225,105,128,14,67,237,244,232,225,105,128,14,51,244,232,225,105,128,14,48,229,244,232,225,105,128,14,64,105,3,165,138,165,162,165,173,105,2,165,144,165,155,236,229,230,244,244,232,225,105,128,248,134,244,232,225,105,128,14,53,236,229,230,244,244,232,225,105,128,248,133,244,232,225,105,128,14,52,239,244,232,225,105,128,14,66,117,3,165,196,165,
246,165,253,101,3,165,204,165,228,165,239,101,2,165,210,165,221,236,229,230,244,244,232,225,105,128,248,136,244,232,225,105,128,14,55,236,229,230,244,244,232,225,105,128,248,135,244,232,225,105,128,14,54,244,232,225,105,128,14,56,245,244,232,225,105,128,14,57,226,239,240,239,237,239,230,111,128,49,25,99,5,166,28,166,49,166,58,166,107,166,129,225,242,239,110,129,1,97,166,37,228,239,244,225,227,227,229,238,116,128,30,103,229,228,233,236,236,97,128,1,95,232,247,97,131,2,89,166,70,166,81,166,100,227,
249,242,233,236,236,233,99,128,4,217,228,233,229,242,229,243,233,243,227,249,242,233,236,236,233,99,128,4,219,232,239,239,107,128,2,90,233,242,99,2,166,115,166,120,236,101,128,36,226,245,237,230,236,229,120,128,1,93,239,237,237,225,225,227,227,229,238,116,128,2,25,228,239,116,2,166,150,166,159,225,227,227,229,238,116,128,30,97,226,229,236,239,119,129,30,99,166,169,228,239,244,225,227,227,229,238,116,128,30,105,101,9,166,201,166,217,166,252,167,61,167,164,167,191,167,216,168,41,168,68,225,231,245,
236,236,226,229,236,239,247,227,237,98,128,3,60,99,2,166,223,166,245,239,238,100,129,32,51,166,231,244,239,238,229,227,232,233,238,229,243,101,128,2,202,244,233,239,110,128,0,167,229,110,4,167,7,167,16,167,30,167,46,225,242,225,226,233,99,128,6,51,230,233,238,225,236,225,242,225,226,233,99,128,254,178,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,179,237,229,228,233,225,236,225,242,225,226,233,99,128,254,180,231,239,108,135,5,182,167,81,167,95,167,100,167,109,167,124,167,140,167,151,
49,2,167,87,167,91,51,128,5,182,102,128,5,182,178,99,128,5,182,232,229,226,242,229,119,128,5,182,238,225,242,242,239,247,232,229,226,242,229,119,128,5,182,241,245,225,242,244,229,242,232,229,226,242,229,119,128,5,182,244,225,232,229,226,242,229,119,128,5,146,247,233,228,229,232,229,226,242,229,119,128,5,182,104,2,167,170,167,181,225,242,237,229,238,233,225,110,128,5,125,233,242,225,231,225,238,97,128,48,91,235,225,244,225,235,225,238,97,129,48,187,167,204,232,225,236,230,247,233,228,244,104,128,255,
126,237,105,2,167,223,168,10,227,239,236,239,110,131,0,59,167,237,167,246,168,2,225,242,225,226,233,99,128,6,27,237,239,238,239,243,240,225,227,101,128,255,27,243,237,225,236,108,128,254,84,246,239,233,227,229,228,237,225,242,235,235,225,238,97,129,48,156,168,29,232,225,236,230,247,233,228,244,104,128,255,159,238,116,2,168,48,168,58,233,243,241,245,225,242,101,128,51,34,239,243,241,245,225,242,101,128,51,35,246,229,110,142,0,55,168,102,168,111,168,121,168,151,168,158,168,168,168,193,168,220,168,254,
169,10,169,21,169,54,169,62,169,73,225,242,225,226,233,99,128,6,103,226,229,238,231,225,236,105,128,9,237,227,233,242,227,236,101,129,36,102,168,132,233,238,246,229,242,243,229,243,225,238,243,243,229,242,233,102,128,39,144,228,229,246,97,128,9,109,229,233,231,232,244,232,115,128,33,94,231,117,2,168,175,168,184,234,225,242,225,244,105,128,10,237,242,237,245,235,232,105,128,10,109,232,97,2,168,200,168,211,227,235,225,242,225,226,233,99,128,6,103,238,231,250,232,239,117,128,48,39,105,2,168,226,168,
244,228,229,239,231,242,225,240,232,233,227,240,225,242,229,110,128,50,38,238,230,229,242,233,239,114,128,32,135,237,239,238,239,243,240,225,227,101,128,255,23,239,236,228,243,244,249,236,101,128,247,55,112,2,169,27,169,34,225,242,229,110,128,36,122,229,114,2,169,41,169,47,233,239,100,128,36,142,243,233,225,110,128,6,247,242,239,237,225,110,128,33,118,243,245,240,229,242,233,239,114,128,32,119,116,2,169,79,169,117,229,229,110,2,169,87,169,96,227,233,242,227,236,101,128,36,112,112,2,169,102,169,109,
225,242,229,110,128,36,132,229,242,233,239,100,128,36,152,232,225,105,128,14,87,230,244,232,249,240,232,229,110,128,0,173,104,7,169,150,170,124,170,135,170,149,171,94,171,107,172,15,97,6,169,164,169,175,169,185,169,196,170,83,170,108,225,242,237,229,238,233,225,110,128,5,119,226,229,238,231,225,236,105,128,9,182,227,249,242,233,236,236,233,99,128,4,72,100,2,169,202,170,42,228,97,4,169,213,169,222,169,253,170,11,225,242,225,226,233,99,128,6,81,228,225,237,237,97,2,169,232,169,241,225,242,225,226,233,
99,128,252,97,244,225,238,225,242,225,226,233,99,128,252,94,230,225,244,232,225,225,242,225,226,233,99,128,252,96,235,225,243,242,97,2,170,21,170,30,225,242,225,226,233,99,128,252,98,244,225,238,225,242,225,226,233,99,128,252,95,101,132,37,146,170,54,170,61,170,69,170,78,228,225,242,107,128,37,147,236,233,231,232,116,128,37,145,237,229,228,233,245,109,128,37,146,246,97,128,9,54,231,117,2,170,90,170,99,234,225,242,225,244,105,128,10,182,242,237,245,235,232,105,128,10,54,236,243,232,229,236,229,244,
232,229,226,242,229,119,128,5,147,226,239,240,239,237,239,230,111,128,49,21,227,232,225,227,249,242,233,236,236,233,99,128,4,73,101,4,170,159,170,224,170,234,170,251,229,110,4,170,170,170,179,170,193,170,209,225,242,225,226,233,99,128,6,52,230,233,238,225,236,225,242,225,226,233,99,128,254,182,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,183,237,229,228,233,225,236,225,242,225,226,233,99,128,254,184,233,227,239,240,244,233,99,128,3,227,241,229,108,129,32,170,170,242,232,229,226,242,
229,119,128,32,170,246,97,134,5,176,171,12,171,27,171,41,171,50,171,65,171,81,49,2,171,18,171,23,177,53,128,5,176,53,128,5,176,50,2,171,33,171,37,50,128,5,176,101,128,5,176,232,229,226,242,229,119,128,5,176,238,225,242,242,239,247,232,229,226,242,229,119,128,5,176,241,245,225,242,244,229,242,232,229,226,242,229,119,128,5,176,247,233,228,229,232,229,226,242,229,119,128,5,176,232,225,227,249,242,233,236,236,233,99,128,4,187,105,2,171,113,171,124,237,225,227,239,240,244,233,99,128,3,237,110,131,5,233,
171,134,171,217,171,226,100,2,171,140,171,206,225,231,229,243,104,130,251,73,171,152,171,161,232,229,226,242,229,119,128,251,73,115,2,171,167,171,187,232,233,238,228,239,116,129,251,44,171,178,232,229,226,242,229,119,128,251,44,233,238,228,239,116,129,251,45,171,197,232,229,226,242,229,119,128,251,45,239,244,232,229,226,242,229,119,128,5,193,232,229,226,242,229,119,128,5,233,115,2,171,232,171,252,232,233,238,228,239,116,129,251,42,171,243,232,229,226,242,229,119,128,251,42,233,238,228,239,116,129,
251,43,172,6,232,229,226,242,229,119,128,251,43,239,239,107,128,2,130,105,8,172,39,172,83,172,94,172,119,172,149,172,157,172,170,173,85,231,237,97,131,3,195,172,51,172,55,172,63,49,128,3,194,230,233,238,225,108,128,3,194,236,245,238,225,244,229,243,249,237,226,239,236,231,242,229,229,107,128,3,242,232,233,242,225,231,225,238,97,128,48,87,235,225,244,225,235,225,238,97,129,48,183,172,107,232,225,236,230,247,233,228,244,104,128,255,124,236,245,113,2,172,127,172,136,232,229,226,242,229,119,128,5,189,
236,229,230,244,232,229,226,242,229,119,128,5,189,237,233,236,225,114,128,34,60,238,228,239,244,232,229,226,242,229,119,128,5,194,239,115,6,172,185,172,220,172,252,173,24,173,38,173,70,97,2,172,191,172,206,227,233,242,227,236,229,235,239,242,229,225,110,128,50,116,240,225,242,229,238,235,239,242,229,225,110,128,50,20,227,105,2,172,227,172,239,229,245,227,235,239,242,229,225,110,128,49,126,242,227,236,229,235,239,242,229,225,110,128,50,102,107,2,173,2,173,16,233,249,229,239,235,235,239,242,229,225,
110,128,49,122,239,242,229,225,110,128,49,69,238,233,229,245,238,235,239,242,229,225,110,128,49,123,112,2,173,44,173,57,225,242,229,238,235,239,242,229,225,110,128,50,6,233,229,245,240,235,239,242,229,225,110,128,49,125,244,233,235,229,245,244,235,239,242,229,225,110,128,49,124,120,141,0,54,173,115,173,124,173,134,173,164,173,171,173,196,173,223,174,1,174,13,174,24,174,57,174,65,174,76,225,242,225,226,233,99,128,6,102,226,229,238,231,225,236,105,128,9,236,227,233,242,227,236,101,129,36,101,173,145,
233,238,246,229,242,243,229,243,225,238,243,243,229,242,233,102,128,39,143,228,229,246,97,128,9,108,231,117,2,173,178,173,187,234,225,242,225,244,105,128,10,236,242,237,245,235,232,105,128,10,108,232,97,2,173,203,173,214,227,235,225,242,225,226,233,99,128,6,102,238,231,250,232,239,117,128,48,38,105,2,173,229,173,247,228,229,239,231,242,225,240,232,233,227,240,225,242,229,110,128,50,37,238,230,229,242,233,239,114,128,32,134,237,239,238,239,243,240,225,227,101,128,255,22,239,236,228,243,244,249,236,
101,128,247,54,112,2,174,30,174,37,225,242,229,110,128,36,121,229,114,2,174,44,174,50,233,239,100,128,36,141,243,233,225,110,128,6,246,242,239,237,225,110,128,33,117,243,245,240,229,242,233,239,114,128,32,118,116,2,174,82,174,153,229,229,110,2,174,90,174,132,99,2,174,96,174,104,233,242,227,236,101,128,36,111,245,242,242,229,238,227,249,228,229,238,239,237,233,238,225,244,239,242,226,229,238,231,225,236,105,128,9,249,112,2,174,138,174,145,225,242,229,110,128,36,131,229,242,233,239,100,128,36,151,232,
225,105,128,14,86,108,2,174,165,174,185,225,243,104,129,0,47,174,173,237,239,238,239,243,240,225,227,101,128,255,15,239,238,103,129,1,127,174,193,228,239,244,225,227,227,229,238,116,128,30,155,109,2,174,211,174,221,233,236,229,230,225,227,101,128,38,58,239,238,239,243,240,225,227,101,128,255,83,111,6,174,246,175,40,175,51,175,76,175,121,175,132,102,2,174,252,175,10,240,225,243,245,241,232,229,226,242,229,119,128,5,195,116,2,175,16,175,25,232,249,240,232,229,110,128,0,173,243,233,231,238,227,249,242,
233,236,236,233,99,128,4,76,232,233,242,225,231,225,238,97,128,48,93,235,225,244,225,235,225,238,97,129,48,189,175,64,232,225,236,230,247,233,228,244,104,128,255,127,236,233,228,245,115,2,175,86,175,103,236,239,238,231,239,246,229,242,236,225,249,227,237,98,128,3,56,243,232,239,242,244,239,246,229,242,236,225,249,227,237,98,128,3,55,242,245,243,233,244,232,225,105,128,14,41,115,3,175,140,175,150,175,158,225,236,225,244,232,225,105,128,14,40,239,244,232,225,105,128,14,11,245,225,244,232,225,105,128,
14,42,240,97,3,175,176,175,196,175,228,227,101,129,0,32,175,183,232,225,227,235,225,242,225,226,233,99,128,0,32,228,101,129,38,96,175,203,243,245,233,116,2,175,212,175,220,226,236,225,227,107,128,38,96,247,232,233,244,101,128,38,100,242,229,110,128,36,174,241,245,225,242,101,11,176,6,176,17,176,31,176,56,176,73,176,99,176,114,176,147,176,174,176,230,176,245,226,229,236,239,247,227,237,98,128,3,59,99,2,176,23,176,27,99,128,51,196,109,128,51,157,228,233,225,231,239,238,225,236,227,242,239,243,243,232,
225,244,227,232,230,233,236,108,128,37,169,232,239,242,233,250,239,238,244,225,236,230,233,236,108,128,37,164,107,2,176,79,176,83,103,128,51,143,109,129,51,158,176,89,227,225,240,233,244,225,108,128,51,206,108,2,176,105,176,109,110,128,51,209,239,103,128,51,210,109,4,176,124,176,128,176,133,176,137,103,128,51,142,233,108,128,51,213,109,128,51,156,243,241,245,225,242,229,100,128,51,161,239,242,244,232,239,231,239,238,225,236,227,242,239,243,243,232,225,244,227,232,230,233,236,108,128,37,166,245,240,
240,229,114,2,176,184,176,207,236,229,230,244,244,239,236,239,247,229,242,242,233,231,232,244,230,233,236,108,128,37,167,242,233,231,232,244,244,239,236,239,247,229,242,236,229,230,244,230,233,236,108,128,37,168,246,229,242,244,233,227,225,236,230,233,236,108,128,37,165,247,232,233,244,229,247,233,244,232,243,237,225,236,236,226,236,225,227,107,128,37,163,242,243,241,245,225,242,101,128,51,219,115,2,177,27,177,197,97,4,177,37,177,47,177,54,177,65,226,229,238,231,225,236,105,128,9,183,228,229,246,
97,128,9,55,231,245,234,225,242,225,244,105,128,10,183,238,103,8,177,84,177,98,177,112,177,126,177,141,177,155,177,169,177,182,227,233,229,245,227,235,239,242,229,225,110,128,49,73,232,233,229,245,232,235,239,242,229,225,110,128,49,133,233,229,245,238,231,235,239,242,229,225,110,128,49,128,235,233,249,229,239,235,235,239,242,229,225,110,128,49,50,238,233,229,245,238,235,239,242,229,225,110,128,49,101,240,233,229,245,240,235,239,242,229,225,110,128,49,67,243,233,239,243,235,239,242,229,225,110,128,
49,70,244,233,235,229,245,244,235,239,242,229,225,110,128,49,56,245,240,229,242,233,239,114,128,246,242,116,2,177,213,177,236,229,242,236,233,238,103,129,0,163,177,224,237,239,238,239,243,240,225,227,101,128,255,225,242,239,235,101,2,177,245,178,6,236,239,238,231,239,246,229,242,236,225,249,227,237,98,128,3,54,243,232,239,242,244,239,246,229,242,236,225,249,227,237,98,128,3,53,117,7,178,40,178,72,178,94,178,105,178,146,178,156,178,160,226,243,229,116,130,34,130,178,51,178,62,238,239,244,229,241,245,
225,108,128,34,138,239,242,229,241,245,225,108,128,34,134,99,2,178,78,178,86,227,229,229,228,115,128,34,123,232,244,232,225,116,128,34,11,232,233,242,225,231,225,238,97,128,48,89,107,2,178,111,178,135,225,244,225,235,225,238,97,129,48,185,178,123,232,225,236,230,247,233,228,244,104,128,255,125,245,238,225,242,225,226,233,99,128,6,82,237,237,225,244,233,239,110,128,34,17,110,128,38,60,240,229,242,243,229,116,130,34,131,178,173,178,184,238,239,244,229,241,245,225,108,128,34,139,239,242,229,241,245,
225,108,128,34,135,246,243,241,245,225,242,101,128,51,220,249,239,245,247,225,229,242,225,243,241,245,225,242,101,128,51,124,116,144,0,116,179,1,180,10,180,31,180,174,180,214,183,6,186,144,187,219,187,231,187,243,189,20,189,45,189,131,190,55,190,239,191,73,97,10,179,23,179,33,179,54,179,61,179,86,179,164,179,181,179,206,179,220,179,224,226,229,238,231,225,236,105,128,9,164,227,107,2,179,40,179,47,228,239,247,110,128,34,164,236,229,230,116,128,34,163,228,229,246,97,128,9,36,231,117,2,179,68,179,77,
234,225,242,225,244,105,128,10,164,242,237,245,235,232,105,128,10,36,104,4,179,96,179,105,179,119,179,149,225,242,225,226,233,99,128,6,55,230,233,238,225,236,225,242,225,226,233,99,128,254,194,105,2,179,125,179,140,238,233,244,233,225,236,225,242,225,226,233,99,128,254,195,242,225,231,225,238,97,128,48,95,237,229,228,233,225,236,225,242,225,226,233,99,128,254,196,233,243,249,239,245,229,242,225,243,241,245,225,242,101,128,51,125,235,225,244,225,235,225,238,97,129,48,191,179,194,232,225,236,230,247,
233,228,244,104,128,255,128,244,247,229,229,236,225,242,225,226,233,99,128,6,64,117,128,3,196,118,130,5,234,179,232,180,1,228,225,231,229,115,129,251,74,179,242,104,129,251,74,179,248,232,229,226,242,229,119,128,251,74,232,229,226,242,229,119,128,5,234,98,2,180,16,180,21,225,114,128,1,103,239,240,239,237,239,230,111,128,49,10,99,6,180,45,180,52,180,59,180,68,180,134,180,161,225,242,239,110,128,1,101,227,245,242,108,128,2,168,229,228,233,236,236,97,128,1,99,232,229,104,4,180,80,180,89,180,103,180,
119,225,242,225,226,233,99,128,6,134,230,233,238,225,236,225,242,225,226,233,99,128,251,123,233,238,233,244,233,225,236,225,242,225,226,233,99,128,251,124,237,229,228,233,225,236,225,242,225,226,233,99,128,251,125,233,242,99,2,180,142,180,147,236,101,128,36,227,245,237,230,236,229,248,226,229,236,239,119,128,30,113,239,237,237,225,225,227,227,229,238,116,128,1,99,100,2,180,180,180,190,233,229,242,229,243,233,115,128,30,151,239,116,2,180,197,180,206,225,227,227,229,238,116,128,30,107,226,229,236,239,
119,128,30,109,101,9,180,234,180,245,181,9,182,19,182,44,182,108,182,175,182,180,182,232,227,249,242,233,236,236,233,99,128,4,66,228,229,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,173,104,7,181,25,181,34,181,48,181,88,181,118,181,159,182,1,225,242,225,226,233,99,128,6,42,230,233,238,225,236,225,242,225,226,233,99,128,254,150,232,225,232,105,2,181,57,181,72,238,233,244,233,225,236,225,242,225,226,233,99,128,252,162,243,239,236,225,244,229,228,225,242,225,226,233,99,128,252,12,
105,2,181,94,181,109,238,233,244,233,225,236,225,242,225,226,233,99,128,254,151,242,225,231,225,238,97,128,48,102,234,229,229,237,105,2,181,128,181,143,238,233,244,233,225,236,225,242,225,226,233,99,128,252,161,243,239,236,225,244,229,228,225,242,225,226,233,99,128,252,11,109,2,181,165,181,199,225,242,226,245,244,97,2,181,176,181,185,225,242,225,226,233,99,128,6,41,230,233,238,225,236,225,242,225,226,233,99,128,254,148,101,2,181,205,181,218,228,233,225,236,225,242,225,226,233,99,128,254,152,229,237,
105,2,181,226,181,241,238,233,244,233,225,236,225,242,225,226,233,99,128,252,164,243,239,236,225,244,229,228,225,242,225,226,233,99,128,252,14,238,239,239,238,230,233,238,225,236,225,242,225,226,233,99,128,252,115,235,225,244,225,235,225,238,97,129,48,198,182,32,232,225,236,230,247,233,228,244,104,128,255,131,108,2,182,50,182,69,229,240,232,239,238,101,129,33,33,182,61,226,236,225,227,107,128,38,14,233,243,232,97,2,182,78,182,93,231,229,228,239,236,225,232,229,226,242,229,119,128,5,160,241,229,244,
225,238,225,232,229,226,242,229,119,128,5,169,110,4,182,118,182,127,182,146,182,167,227,233,242,227,236,101,128,36,105,233,228,229,239,231,242,225,240,232,233,227,240,225,242,229,110,128,50,41,112,2,182,152,182,159,225,242,229,110,128,36,125,229,242,233,239,100,128,36,145,242,239,237,225,110,128,33,121,243,104,128,2,167,116,131,5,216,182,190,182,210,182,219,228,225,231,229,243,104,129,251,56,182,201,232,229,226,242,229,119,128,251,56,232,229,226,242,229,119,128,5,216,243,229,227,249,242,233,236,236,
233,99,128,4,181,246,233,114,2,182,240,182,249,232,229,226,242,229,119,128,5,155,236,229,230,244,232,229,226,242,229,119,128,5,155,104,6,183,20,183,172,184,38,184,170,185,77,186,134,97,5,183,32,183,42,183,49,183,74,183,103,226,229,238,231,225,236,105,128,9,165,228,229,246,97,128,9,37,231,117,2,183,56,183,65,234,225,242,225,244,105,128,10,165,242,237,245,235,232,105,128,10,37,108,2,183,80,183,89,225,242,225,226,233,99,128,6,48,230,233,238,225,236,225,242,225,226,233,99,128,254,172,238,244,232,225,
235,232,225,116,3,183,118,183,149,183,156,236,239,119,2,183,126,183,137,236,229,230,244,244,232,225,105,128,248,152,242,233,231,232,244,244,232,225,105,128,248,151,244,232,225,105,128,14,76,245,240,240,229,242,236,229,230,244,244,232,225,105,128,248,150,101,3,183,180,183,244,184,11,104,4,183,190,183,199,183,213,183,229,225,242,225,226,233,99,128,6,43,230,233,238,225,236,225,242,225,226,233,99,128,254,154,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,155,237,229,228,233,225,236,225,242,
225,226,233,99,128,254,156,242,101,2,183,251,184,4,229,248,233,243,244,115,128,34,3,230,239,242,101,128,34,52,244,97,130,3,184,184,20,184,24,49,128,3,209,243,249,237,226,239,236,231,242,229,229,107,128,3,209,105,2,184,44,184,130,229,245,244,104,4,184,57,184,92,184,107,184,116,97,2,184,63,184,78,227,233,242,227,236,229,235,239,242,229,225,110,128,50,121,240,225,242,229,238,235,239,242,229,225,110,128,50,25,227,233,242,227,236,229,235,239,242,229,225,110,128,50,107,235,239,242,229,225,110,128,49,76,
240,225,242,229,238,235,239,242,229,225,110,128,50,11,242,244,229,229,110,2,184,140,184,149,227,233,242,227,236,101,128,36,108,112,2,184,155,184,162,225,242,229,110,128,36,128,229,242,233,239,100,128,36,148,111,6,184,184,184,201,184,206,184,220,184,225,185,22,238,225,238,231,237,239,238,244,232,239,244,232,225,105,128,14,17,239,107,128,1,173,240,232,245,244,232,225,239,244,232,225,105,128,14,18,242,110,128,0,254,244,104,3,184,234,185,2,185,12,97,2,184,240,184,250,232,225,238,244,232,225,105,128,14,
23,238,244,232,225,105,128,14,16,239,238,231,244,232,225,105,128,14,24,245,238,231,244,232,225,105,128,14,22,245,243,225,238,100,2,185,32,185,43,227,249,242,233,236,236,233,99,128,4,130,243,243,229,240,225,242,225,244,239,114,2,185,58,185,67,225,242,225,226,233,99,128,6,108,240,229,242,243,233,225,110,128,6,108,242,229,101,144,0,51,185,115,185,124,185,134,185,164,185,171,185,181,185,206,185,233,186,11,186,23,186,42,186,53,186,86,186,108,186,116,186,127,225,242,225,226,233,99,128,6,99,226,229,238,
231,225,236,105,128,9,233,227,233,242,227,236,101,129,36,98,185,145,233,238,246,229,242,243,229,243,225,238,243,243,229,242,233,102,128,39,140,228,229,246,97,128,9,105,229,233,231,232,244,232,115,128,33,92,231,117,2,185,188,185,197,234,225,242,225,244,105,128,10,233,242,237,245,235,232,105,128,10,105,232,97,2,185,213,185,224,227,235,225,242,225,226,233,99,128,6,99,238,231,250,232,239,117,128,48,35,105,2,185,239,186,1,228,229,239,231,242,225,240,232,233,227,240,225,242,229,110,128,50,34,238,230,229,
242,233,239,114,128,32,131,237,239,238,239,243,240,225,227,101,128,255,19,238,245,237,229,242,225,244,239,242,226,229,238,231,225,236,105,128,9,246,239,236,228,243,244,249,236,101,128,247,51,112,2,186,59,186,66,225,242,229,110,128,36,118,229,114,2,186,73,186,79,233,239,100,128,36,138,243,233,225,110,128,6,243,241,245,225,242,244,229,242,115,129,0,190,186,99,229,237,228,225,243,104,128,246,222,242,239,237,225,110,128,33,114,243,245,240,229,242,233,239,114,128,0,179,244,232,225,105,128,14,83,250,243,
241,245,225,242,101,128,51,148,105,7,186,160,186,171,187,30,187,128,187,140,187,189,187,206,232,233,242,225,231,225,238,97,128,48,97,107,2,186,177,186,201,225,244,225,235,225,238,97,129,48,193,186,189,232,225,236,230,247,233,228,244,104,128,255,129,229,245,116,4,186,213,186,248,187,7,187,16,97,2,186,219,186,234,227,233,242,227,236,229,235,239,242,229,225,110,128,50,112,240,225,242,229,238,235,239,242,229,225,110,128,50,16,227,233,242,227,236,229,235,239,242,229,225,110,128,50,98,235,239,242,229,225,
110,128,49,55,240,225,242,229,238,235,239,242,229,225,110,128,50,2,236,228,101,133,2,220,187,46,187,57,187,74,187,86,187,114,226,229,236,239,247,227,237,98,128,3,48,99,2,187,63,187,68,237,98,128,3,3,239,237,98,128,3,3,228,239,245,226,236,229,227,237,98,128,3,96,111,2,187,92,187,102,240,229,242,225,244,239,114,128,34,60,246,229,242,236,225,249,227,237,98,128,3,52,246,229,242,244,233,227,225,236,227,237,98,128,3,62,237,229,243,227,233,242,227,236,101,128,34,151,112,2,187,146,187,176,229,232,97,2,187,
154,187,163,232,229,226,242,229,119,128,5,150,236,229,230,244,232,229,226,242,229,119,128,5,150,240,233,231,245,242,237,245,235,232,105,128,10,112,244,236,239,227,249,242,233,236,236,233,227,227,237,98,128,4,131,247,238,225,242,237,229,238,233,225,110,128,5,127,236,233,238,229,226,229,236,239,119,128,30,111,237,239,238,239,243,240,225,227,101,128,255,84,111,7,188,3,188,14,188,25,188,50,188,170,188,182,189,10,225,242,237,229,238,233,225,110,128,5,105,232,233,242,225,231,225,238,97,128,48,104,235,225,
244,225,235,225,238,97,129,48,200,188,38,232,225,236,230,247,233,228,244,104,128,255,132,110,3,188,58,188,156,188,161,101,4,188,68,188,137,188,144,188,150,226,225,114,4,188,80,188,109,188,119,188,128,229,248,244,242,97,2,188,90,188,100,232,233,231,232,237,239,100,128,2,229,236,239,247,237,239,100,128,2,233,232,233,231,232,237,239,100,128,2,230,236,239,247,237,239,100,128,2,232,237,233,228,237,239,100,128,2,231,230,233,246,101,128,1,189,243,233,120,128,1,133,244,247,111,128,1,168,239,115,128,3,132,
243,241,245,225,242,101,128,51,39,240,225,244,225,235,244,232,225,105,128,14,15,242,244,239,233,243,229,243,232,229,236,236,226,242,225,227,235,229,116,2,188,205,188,235,236,229,230,116,130,48,20,188,216,188,224,243,237,225,236,108,128,254,93,246,229,242,244,233,227,225,108,128,254,57,242,233,231,232,116,130,48,21,188,247,188,255,243,237,225,236,108,128,254,94,246,229,242,244,233,227,225,108,128,254,58,244,225,239,244,232,225,105,128,14,21,240,97,2,189,27,189,39,236,225,244,225,236,232,239,239,107,
128,1,171,242,229,110,128,36,175,114,3,189,53,189,84,189,99,225,228,229,237,225,242,107,129,33,34,189,65,115,2,189,71,189,77,225,238,115,128,248,234,229,242,233,102,128,246,219,229,244,242,239,230,236,229,248,232,239,239,107,128,2,136,233,225,103,4,189,111,189,116,189,121,189,126,228,110,128,37,188,236,102,128,37,196,242,116,128,37,186,245,112,128,37,178,115,132,2,166,189,143,189,182,190,32,190,45,225,228,105,130,5,230,189,153,189,173,228,225,231,229,243,104,129,251,70,189,164,232,229,226,242,229,
119,128,251,70,232,229,226,242,229,119,128,5,230,101,2,189,188,189,199,227,249,242,233,236,236,233,99,128,4,70,242,101,134,5,181,189,216,189,230,189,235,189,244,190,3,190,19,49,2,189,222,189,226,50,128,5,181,101,128,5,181,178,98,128,5,181,232,229,226,242,229,119,128,5,181,238,225,242,242,239,247,232,229,226,242,229,119,128,5,181,241,245,225,242,244,229,242,232,229,226,242,229,119,128,5,181,247,233,228,229,232,229,226,242,229,119,128,5,181,232,229,227,249,242,233,236,236,233,99,128,4,91,245,240,229,
242,233,239,114,128,246,243,116,4,190,65,190,115,190,180,190,231,97,3,190,73,190,83,190,90,226,229,238,231,225,236,105,128,9,159,228,229,246,97,128,9,31,231,117,2,190,97,190,106,234,225,242,225,244,105,128,10,159,242,237,245,235,232,105,128,10,31,229,104,4,190,126,190,135,190,149,190,165,225,242,225,226,233,99,128,6,121,230,233,238,225,236,225,242,225,226,233,99,128,251,103,233,238,233,244,233,225,236,225,242,225,226,233,99,128,251,104,237,229,228,233,225,236,225,242,225,226,233,99,128,251,105,232,
97,3,190,189,190,199,190,206,226,229,238,231,225,236,105,128,9,160,228,229,246,97,128,9,32,231,117,2,190,213,190,222,234,225,242,225,244,105,128,10,160,242,237,245,235,232,105,128,10,32,245,242,238,229,100,128,2,135,117,3,190,247,191,2,191,27,232,233,242,225,231,225,238,97,128,48,100,235,225,244,225,235,225,238,97,129,48,196,191,15,232,225,236,230,247,233,228,244,104,128,255,130,243,237,225,236,108,2,191,37,191,48,232,233,242,225,231,225,238,97,128,48,99,235,225,244,225,235,225,238,97,129,48,195,
191,61,232,225,236,230,247,233,228,244,104,128,255,111,119,2,191,79,191,184,101,2,191,85,191,133,236,246,101,3,191,95,191,104,191,125,227,233,242,227,236,101,128,36,107,112,2,191,110,191,117,225,242,229,110,128,36,127,229,242,233,239,100,128,36,147,242,239,237,225,110,128,33,123,238,244,121,3,191,143,191,152,191,163,227,233,242,227,236,101,128,36,115,232,225,238,231,250,232,239,117,128,83,68,112,2,191,169,191,176,225,242,229,110,128,36,135,229,242,233,239,100,128,36,155,111,142,0,50,191,216,191,225,
191,235,192,9,192,61,192,86,192,113,192,147,192,159,192,178,192,189,192,222,192,230,192,254,225,242,225,226,233,99,128,6,98,226,229,238,231,225,236,105,128,9,232,227,233,242,227,236,101,129,36,97,191,246,233,238,246,229,242,243,229,243,225,238,243,243,229,242,233,102,128,39,139,100,2,192,15,192,21,229,246,97,128,9,104,239,116,2,192,28,192,39,229,238,236,229,225,228,229,114,128,32,37,236,229,225,228,229,114,129,32,37,192,50,246,229,242,244,233,227,225,108,128,254,48,231,117,2,192,68,192,77,234,225,
242,225,244,105,128,10,232,242,237,245,235,232,105,128,10,104,232,97,2,192,93,192,104,227,235,225,242,225,226,233,99,128,6,98,238,231,250,232,239,117,128,48,34,105,2,192,119,192,137,228,229,239,231,242,225,240,232,233,227,240,225,242,229,110,128,50,33,238,230,229,242,233,239,114,128,32,130,237,239,238,239,243,240,225,227,101,128,255,18,238,245,237,229,242,225,244,239,242,226,229,238,231,225,236,105,128,9,245,239,236,228,243,244,249,236,101,128,247,50,112,2,192,195,192,202,225,242,229,110,128,36,117,
229,114,2,192,209,192,215,233,239,100,128,36,137,243,233,225,110,128,6,242,242,239,237,225,110,128,33,113,115,2,192,236,192,244,244,242,239,235,101,128,1,187,245,240,229,242,233,239,114,128,0,178,244,104,2,193,5,193,10,225,105,128,14,82,233,242,228,115,128,33,84,117,145,0,117,193,55,193,63,193,104,193,161,194,43,194,80,194,203,194,219,195,14,195,84,195,165,195,174,196,37,196,61,196,169,196,197,197,55,225,227,245,244,101,128,0,250,98,4,193,73,193,78,193,87,193,97,225,114,128,2,137,229,238,231,225,
236,105,128,9,137,239,240,239,237,239,230,111,128,49,40,242,229,246,101,128,1,109,99,3,193,112,193,119,193,151,225,242,239,110,128,1,212,233,242,99,2,193,127,193,132,236,101,128,36,228,245,237,230,236,229,120,129,0,251,193,143,226,229,236,239,119,128,30,119,249,242,233,236,236,233,99,128,4,67,100,5,193,173,193,184,193,207,193,213,194,33,225,244,244,225,228,229,246,97,128,9,81,226,108,2,193,191,193,199,225,227,245,244,101,128,1,113,231,242,225,246,101,128,2,21,229,246,97,128,9,9,233,229,242,229,243,
233,115,133,0,252,193,233,193,241,193,249,194,16,194,24,225,227,245,244,101,128,1,216,226,229,236,239,119,128,30,115,99,2,193,255,194,6,225,242,239,110,128,1,218,249,242,233,236,236,233,99,128,4,241,231,242,225,246,101,128,1,220,237,225,227,242,239,110,128,1,214,239,244,226,229,236,239,119,128,30,229,103,2,194,49,194,56,242,225,246,101,128,0,249,117,2,194,62,194,71,234,225,242,225,244,105,128,10,137,242,237,245,235,232,105,128,10,9,104,3,194,88,194,98,194,176,233,242,225,231,225,238,97,128,48,70,
111,2,194,104,194,114,239,235,225,226,239,246,101,128,30,231,242,110,133,1,176,194,129,194,137,194,148,194,156,194,168,225,227,245,244,101,128,30,233,228,239,244,226,229,236,239,119,128,30,241,231,242,225,246,101,128,30,235,232,239,239,235,225,226,239,246,101,128,30,237,244,233,236,228,101,128,30,239,245,238,231,225,242,245,237,236,225,245,116,129,1,113,194,192,227,249,242,233,236,236,233,99,128,4,243,233,238,246,229,242,244,229,228,226,242,229,246,101,128,2,23,107,3,194,227,194,251,195,6,225,244,
225,235,225,238,97,129,48,166,194,239,232,225,236,230,247,233,228,244,104,128,255,115,227,249,242,233,236,236,233,99,128,4,121,239,242,229,225,110,128,49,92,109,2,195,20,195,73,97,2,195,26,195,59,227,242,239,110,130,1,107,195,37,195,48,227,249,242,233,236,236,233,99,128,4,239,228,233,229,242,229,243,233,115,128,30,123,244,242,225,231,245,242,237,245,235,232,105,128,10,65,239,238,239,243,240,225,227,101,128,255,85,110,2,195,90,195,145,228,229,242,243,227,239,242,101,132,0,95,195,109,195,115,195,127,
195,138,228,226,108,128,32,23,237,239,238,239,243,240,225,227,101,128,255,63,246,229,242,244,233,227,225,108,128,254,51,247,225,246,121,128,254,79,105,2,195,151,195,156,239,110,128,34,42,246,229,242,243,225,108,128,34,0,239,231,239,238,229,107,128,1,115,112,5,195,186,195,193,195,201,195,216,196,11,225,242,229,110,128,36,176,226,236,239,227,107,128,37,128,240,229,242,228,239,244,232,229,226,242,229,119,128,5,196,243,233,236,239,110,131,3,197,195,230,195,251,196,3,228,233,229,242,229,243,233,115,129,
3,203,195,243,244,239,238,239,115,128,3,176,236,225,244,233,110,128,2,138,244,239,238,239,115,128,3,205,244,225,227,107,2,196,20,196,31,226,229,236,239,247,227,237,98,128,3,29,237,239,100,128,2,212,114,2,196,43,196,55,225,231,245,242,237,245,235,232,105,128,10,115,233,238,103,128,1,111,115,3,196,69,196,84,196,129,232,239,242,244,227,249,242,233,236,236,233,99,128,4,94,237,225,236,108,2,196,93,196,104,232,233,242,225,231,225,238,97,128,48,69,235,225,244,225,235,225,238,97,129,48,165,196,117,232,225,
236,230,247,233,228,244,104,128,255,105,244,242,225,233,231,232,116,2,196,141,196,152,227,249,242,233,236,236,233,99,128,4,175,243,244,242,239,235,229,227,249,242,233,236,236,233,99,128,4,177,244,233,236,228,101,130,1,105,196,181,196,189,225,227,245,244,101,128,30,121,226,229,236,239,119,128,30,117,117,5,196,209,196,219,196,226,196,251,197,11,226,229,238,231,225,236,105,128,9,138,228,229,246,97,128,9,10,231,117,2,196,233,196,242,234,225,242,225,244,105,128,10,138,242,237,245,235,232,105,128,10,10,
237,225,244,242,225,231,245,242,237,245,235,232,105,128,10,66,246,239,247,229,236,243,233,231,110,3,197,27,197,37,197,44,226,229,238,231,225,236,105,128,9,194,228,229,246,97,128,9,66,231,245,234,225,242,225,244,105,128,10,194,246,239,247,229,236,243,233,231,110,3,197,71,197,81,197,88,226,229,238,231,225,236,105,128,9,193,228,229,246,97,128,9,65,231,245,234,225,242,225,244,105,128,10,193,118,139,0,118,197,125,198,17,198,26,198,37,198,222,198,229,199,71,199,83,199,183,199,191,199,212,97,4,197,135,197,
142,197,167,197,178,228,229,246,97,128,9,53,231,117,2,197,149,197,158,234,225,242,225,244,105,128,10,181,242,237,245,235,232,105,128,10,53,235,225,244,225,235,225,238,97,128,48,247,118,132,5,213,197,190,197,217,197,249,198,5,228,225,231,229,243,104,130,251,53,197,203,197,208,182,53,128,251,53,232,229,226,242,229,119,128,251,53,104,2,197,223,197,231,229,226,242,229,119,128,5,213,239,236,225,109,129,251,75,197,240,232,229,226,242,229,119,128,251,75,246,225,246,232,229,226,242,229,119,128,5,240,249,
239,228,232,229,226,242,229,119,128,5,241,227,233,242,227,236,101,128,36,229,228,239,244,226,229,236,239,119,128,30,127,101,6,198,51,198,62,198,126,198,137,198,143,198,210,227,249,242,233,236,236,233,99,128,4,50,104,4,198,72,198,81,198,95,198,111,225,242,225,226,233,99,128,6,164,230,233,238,225,236,225,242,225,226,233,99,128,251,107,233,238,233,244,233,225,236,225,242,225,226,233,99,128,251,108,237,229,228,233,225,236,225,242,225,226,233,99,128,251,109,235,225,244,225,235,225,238,97,128,48,249,238,
245,115,128,38,64,242,244,233,227,225,108,2,198,154,198,160,226,225,114,128,0,124,236,233,238,101,4,198,173,198,184,198,195,198,204,225,226,239,246,229,227,237,98,128,3,13,226,229,236,239,247,227,237,98,128,3,41,236,239,247,237,239,100,128,2,204,237,239,100,128,2,200,247,225,242,237,229,238,233,225,110,128,5,126,232,239,239,107,128,2,139,105,3,198,237,198,248,199,31,235,225,244,225,235,225,238,97,128,48,248,242,225,237,97,3,199,3,199,13,199,20,226,229,238,231,225,236,105,128,9,205,228,229,246,97,
128,9,77,231,245,234,225,242,225,244,105,128,10,205,243,225,242,231,97,3,199,43,199,53,199,60,226,229,238,231,225,236,105,128,9,131,228,229,246,97,128,9,3,231,245,234,225,242,225,244,105,128,10,131,237,239,238,239,243,240,225,227,101,128,255,86,111,3,199,91,199,102,199,172,225,242,237,229,238,233,225,110,128,5,120,233,227,229,100,2,199,111,199,147,233,244,229,242,225,244,233,239,110,2,199,125,199,136,232,233,242,225,231,225,238,97,128,48,158,235,225,244,225,235,225,238,97,128,48,254,237,225,242,235,
235,225,238,97,129,48,155,199,160,232,225,236,230,247,233,228,244,104,128,255,158,235,225,244,225,235,225,238,97,128,48,250,240,225,242,229,110,128,36,177,116,2,199,197,199,204,233,236,228,101,128,30,125,245,242,238,229,100,128,2,140,117,2,199,218,199,229,232,233,242,225,231,225,238,97,128,48,148,235,225,244,225,235,225,238,97,128,48,244,119,143,0,119,200,18,200,251,201,5,201,28,201,68,201,135,201,143,203,114,203,155,203,167,203,242,203,250,204,1,204,12,204,21,97,8,200,36,200,43,200,53,200,64,200,
102,200,134,200,146,200,182,227,245,244,101,128,30,131,229,235,239,242,229,225,110,128,49,89,232,233,242,225,231,225,238,97,128,48,143,107,2,200,70,200,94,225,244,225,235,225,238,97,129,48,239,200,82,232,225,236,230,247,233,228,244,104,128,255,156,239,242,229,225,110,128,49,88,243,237,225,236,108,2,200,112,200,123,232,233,242,225,231,225,238,97,128,48,142,235,225,244,225,235,225,238,97,128,48,238,244,244,239,243,241,245,225,242,101,128,51,87,118,2,200,152,200,160,229,228,225,243,104,128,48,28,249,
245,238,228,229,242,243,227,239,242,229,246,229,242,244,233,227,225,108,128,254,52,119,3,200,190,200,199,200,213,225,242,225,226,233,99,128,6,72,230,233,238,225,236,225,242,225,226,233,99,128,254,238,232,225,237,250,225,225,226,239,246,101,2,200,228,200,237,225,242,225,226,233,99,128,6,36,230,233,238,225,236,225,242,225,226,233,99,128,254,134,226,243,241,245,225,242,101,128,51,221,227,233,242,99,2,201,14,201,19,236,101,128,36,230,245,237,230,236,229,120,128,1,117,100,2,201,34,201,44,233,229,242,229,
243,233,115,128,30,133,239,116,2,201,51,201,60,225,227,227,229,238,116,128,30,135,226,229,236,239,119,128,30,137,101,4,201,78,201,89,201,101,201,125,232,233,242,225,231,225,238,97,128,48,145,233,229,242,243,244,242,225,243,115,128,33,24,107,2,201,107,201,117,225,244,225,235,225,238,97,128,48,241,239,242,229,225,110,128,49,94,239,235,239,242,229,225,110,128,49,93,231,242,225,246,101,128,30,129,232,233,244,101,8,201,164,201,173,202,1,202,91,202,175,202,220,203,16,203,72,226,245,236,236,229,116,128,
37,230,99,2,201,179,201,199,233,242,227,236,101,129,37,203,201,189,233,238,246,229,242,243,101,128,37,217,239,242,238,229,242,226,242,225,227,235,229,116,2,201,216,201,236,236,229,230,116,129,48,14,201,225,246,229,242,244,233,227,225,108,128,254,67,242,233,231,232,116,129,48,15,201,246,246,229,242,244,233,227,225,108,128,254,68,100,2,202,7,202,48,233,225,237,239,238,100,129,37,199,202,18,227,239,238,244,225,233,238,233,238,231,226,236,225,227,235,243,237,225,236,236,228,233,225,237,239,238,100,128,
37,200,239,247,238,240,239,233,238,244,233,238,103,2,202,64,202,80,243,237,225,236,236,244,242,233,225,238,231,236,101,128,37,191,244,242,233,225,238,231,236,101,128,37,189,236,101,2,202,98,202,140,230,244,240,239,233,238,244,233,238,103,2,202,113,202,129,243,237,225,236,236,244,242,233,225,238,231,236,101,128,37,195,244,242,233,225,238,231,236,101,128,37,193,238,244,233,227,245,236,225,242,226,242,225,227,235,229,116,2,202,160,202,167,236,229,230,116,128,48,22,242,233,231,232,116,128,48,23,242,233,
231,232,244,240,239,233,238,244,233,238,103,2,202,193,202,209,243,237,225,236,236,244,242,233,225,238,231,236,101,128,37,185,244,242,233,225,238,231,236,101,128,37,183,115,3,202,228,203,2,203,10,109,2,202,234,202,246,225,236,236,243,241,245,225,242,101,128,37,171,233,236,233,238,231,230,225,227,101,128,38,58,241,245,225,242,101,128,37,161,244,225,114,128,38,6,116,2,203,22,203,33,229,236,229,240,232,239,238,101,128,38,15,239,242,244,239,233,243,229,243,232,229,236,236,226,242,225,227,235,229,116,2,
203,57,203,64,236,229,230,116,128,48,24,242,233,231,232,116,128,48,25,245,240,240,239,233,238,244,233,238,103,2,203,87,203,103,243,237,225,236,236,244,242,233,225,238,231,236,101,128,37,181,244,242,233,225,238,231,236,101,128,37,179,105,2,203,120,203,131,232,233,242,225,231,225,238,97,128,48,144,107,2,203,137,203,147,225,244,225,235,225,238,97,128,48,240,239,242,229,225,110,128,49,95,237,239,238,239,243,240,225,227,101,128,255,87,111,4,203,177,203,188,203,213,203,231,232,233,242,225,231,225,238,97,
128,48,146,235,225,244,225,235,225,238,97,129,48,242,203,201,232,225,236,230,247,233,228,244,104,128,255,102,110,129,32,169,203,219,237,239,238,239,243,240,225,227,101,128,255,230,247,225,229,238,244,232,225,105,128,14,39,240,225,242,229,110,128,36,178,242,233,238,103,128,30,152,243,245,240,229,242,233,239,114,128,2,183,244,245,242,238,229,100,128,2,141,249,238,110,128,1,191,120,137,0,120,204,49,204,60,204,71,204,80,204,107,204,120,204,124,204,136,204,144,225,226,239,246,229,227,237,98,128,3,61,226,
239,240,239,237,239,230,111,128,49,18,227,233,242,227,236,101,128,36,231,100,2,204,86,204,96,233,229,242,229,243,233,115,128,30,141,239,244,225,227,227,229,238,116,128,30,139,229,232,225,242,237,229,238,233,225,110,128,5,109,105,128,3,190,237,239,238,239,243,240,225,227,101,128,255,88,240,225,242,229,110,128,36,179,243,245,240,229,242,233,239,114,128,2,227,121,143,0,121,204,189,205,148,205,171,205,211,207,177,207,185,207,202,208,10,208,22,209,19,209,59,209,71,209,82,209,103,210,76,97,11,204,213,204,
225,204,235,204,242,204,249,205,3,205,28,205,39,205,77,205,90,205,136,225,228,239,243,241,245,225,242,101,128,51,78,226,229,238,231,225,236,105,128,9,175,227,245,244,101,128,0,253,228,229,246,97,128,9,47,229,235,239,242,229,225,110,128,49,82,231,117,2,205,10,205,19,234,225,242,225,244,105,128,10,175,242,237,245,235,232,105,128,10,47,232,233,242,225,231,225,238,97,128,48,132,107,2,205,45,205,69,225,244,225,235,225,238,97,129,48,228,205,57,232,225,236,230,247,233,228,244,104,128,255,148,239,242,229,
225,110,128,49,81,237,225,235,235,225,238,244,232,225,105,128,14,78,243,237,225,236,108,2,205,100,205,111,232,233,242,225,231,225,238,97,128,48,131,235,225,244,225,235,225,238,97,129,48,227,205,124,232,225,236,230,247,233,228,244,104,128,255,108,244,227,249,242,233,236,236,233,99,128,4,99,227,233,242,99,2,205,157,205,162,236,101,128,36,232,245,237,230,236,229,120,128,1,119,100,2,205,177,205,187,233,229,242,229,243,233,115,128,0,255,239,116,2,205,194,205,203,225,227,227,229,238,116,128,30,143,226,
229,236,239,119,128,30,245,101,7,205,227,206,235,206,244,207,6,207,38,207,114,207,165,104,8,205,245,205,254,206,32,206,46,206,119,206,135,206,194,206,212,225,242,225,226,233,99,128,6,74,226,225,242,242,229,101,2,206,9,206,18,225,242,225,226,233,99,128,6,210,230,233,238,225,236,225,242,225,226,233,99,128,251,175,230,233,238,225,236,225,242,225,226,233,99,128,254,242,232,225,237,250,225,225,226,239,246,101,4,206,65,206,74,206,88,206,104,225,242,225,226,233,99,128,6,38,230,233,238,225,236,225,242,225,
226,233,99,128,254,138,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,139,237,229,228,233,225,236,225,242,225,226,233,99,128,254,140,233,238,233,244,233,225,236,225,242,225,226,233,99,128,254,243,237,101,2,206,142,206,155,228,233,225,236,225,242,225,226,233,99,128,254,244,229,237,105,2,206,163,206,178,238,233,244,233,225,236,225,242,225,226,233,99,128,252,221,243,239,236,225,244,229,228,225,242,225,226,233,99,128,252,88,238,239,239,238,230,233,238,225,236,225,242,225,226,233,99,128,252,
148,244,232,242,229,229,228,239,244,243,226,229,236,239,247,225,242,225,226,233,99,128,6,209,235,239,242,229,225,110,128,49,86,110,129,0,165,206,250,237,239,238,239,243,240,225,227,101,128,255,229,111,2,207,12,207,21,235,239,242,229,225,110,128,49,85,242,233,238,232,233,229,245,232,235,239,242,229,225,110,128,49,134,114,3,207,46,207,82,207,94,225,232,226,229,238,249,239,237,111,2,207,60,207,69,232,229,226,242,229,119,128,5,170,236,229,230,244,232,229,226,242,229,119,128,5,170,233,227,249,242,233,
236,236,233,99,128,4,75,245,228,233,229,242,229,243,233,243,227,249,242,233,236,236,233,99,128,4,249,243,233,229,245,238,103,3,207,127,207,136,207,152,235,239,242,229,225,110,128,49,129,240,225,238,243,233,239,243,235,239,242,229,225,110,128,49,131,243,233,239,243,235,239,242,229,225,110,128,49,130,244,233,246,232,229,226,242,229,119,128,5,154,231,242,225,246,101,128,30,243,232,239,239,107,129,1,180,207,194,225,226,239,246,101,128,30,247,105,5,207,214,207,225,207,236,207,245,207,253,225,242,237,229,
238,233,225,110,128,5,117,227,249,242,233,236,236,233,99,128,4,87,235,239,242,229,225,110,128,49,98,238,249,225,238,103,128,38,47,247,238,225,242,237,229,238,233,225,110,128,5,130,237,239,238,239,243,240,225,227,101,128,255,89,111,7,208,38,208,108,208,119,208,129,208,167,208,213,208,222,100,131,5,217,208,48,208,68,208,77,228,225,231,229,243,104,129,251,57,208,59,232,229,226,242,229,119,128,251,57,232,229,226,242,229,119,128,5,217,249,239,100,2,208,85,208,94,232,229,226,242,229,119,128,5,242,240,225,
244,225,232,232,229,226,242,229,119,128,251,31,232,233,242,225,231,225,238,97,128,48,136,233,235,239,242,229,225,110,128,49,137,107,2,208,135,208,159,225,244,225,235,225,238,97,129,48,232,208,147,232,225,236,230,247,233,228,244,104,128,255,150,239,242,229,225,110,128,49,91,243,237,225,236,108,2,208,177,208,188,232,233,242,225,231,225,238,97,128,48,135,235,225,244,225,235,225,238,97,129,48,231,208,201,232,225,236,230,247,233,228,244,104,128,255,110,244,231,242,229,229,107,128,3,243,121,2,208,228,209,
9,97,2,208,234,208,244,229,235,239,242,229,225,110,128,49,136,107,2,208,250,209,2,239,242,229,225,110,128,49,135,244,232,225,105,128,14,34,233,238,231,244,232,225,105,128,14,13,112,2,209,25,209,32,225,242,229,110,128,36,180,239,231,229,231,242,225,237,237,229,238,105,129,3,122,209,48,231,242,229,229,235,227,237,98,128,3,69,114,129,1,166,209,65,233,238,103,128,30,153,243,245,240,229,242,233,239,114,128,2,184,116,2,209,88,209,95,233,236,228,101,128,30,249,245,242,238,229,100,128,2,142,117,5,209,115,
209,126,209,136,209,174,210,50,232,233,242,225,231,225,238,97,128,48,134,233,235,239,242,229,225,110,128,49,140,107,2,209,142,209,166,225,244,225,235,225,238,97,129,48,230,209,154,232,225,236,230,247,233,228,244,104,128,255,149,239,242,229,225,110,128,49,96,115,3,209,182,209,220,210,5,226,233,103,2,209,190,209,201,227,249,242,233,236,236,233,99,128,4,107,233,239,244,233,230,233,229,228,227,249,242,233,236,236,233,99,128,4,109,236,233,244,244,236,101,2,209,231,209,242,227,249,242,233,236,236,233,99,
128,4,103,233,239,244,233,230,233,229,228,227,249,242,233,236,236,233,99,128,4,105,237,225,236,108,2,210,14,210,25,232,233,242,225,231,225,238,97,128,48,133,235,225,244,225,235,225,238,97,129,48,229,210,38,232,225,236,230,247,233,228,244,104,128,255,109,249,101,2,210,57,210,66,235,239,242,229,225,110,128,49,139,239,235,239,242,229,225,110,128,49,138,249,97,2,210,83,210,93,226,229,238,231,225,236,105,128,9,223,228,229,246,97,128,9,95,122,142,0,122,210,132,211,140,211,151,211,194,211,221,213,0,213,
108,213,150,213,162,213,174,213,202,213,210,213,226,213,235,97,10,210,154,210,165,210,172,210,179,210,190,211,12,211,42,211,53,211,89,211,101,225,242,237,229,238,233,225,110,128,5,102,227,245,244,101,128,1,122,228,229,246,97,128,9,91,231,245,242,237,245,235,232,105,128,10,91,104,4,210,200,210,209,210,223,210,253,225,242,225,226,233,99,128,6,56,230,233,238,225,236,225,242,225,226,233,99,128,254,198,105,2,210,229,210,244,238,233,244,233,225,236,225,242,225,226,233,99,128,254,199,242,225,231,225,238,
97,128,48,86,237,229,228,233,225,236,225,242,225,226,233,99,128,254,200,233,110,2,211,19,211,28,225,242,225,226,233,99,128,6,50,230,233,238,225,236,225,242,225,226,233,99,128,254,176,235,225,244,225,235,225,238,97,128,48,182,241,229,102,2,211,61,211,75,231,225,228,239,236,232,229,226,242,229,119,128,5,149,241,225,244,225,238,232,229,226,242,229,119,128,5,148,242,241,225,232,229,226,242,229,119,128,5,152,249,233,110,130,5,214,211,111,211,131,228,225,231,229,243,104,129,251,54,211,122,232,229,226,242,
229,119,128,251,54,232,229,226,242,229,119,128,5,214,226,239,240,239,237,239,230,111,128,49,23,99,3,211,159,211,166,211,188,225,242,239,110,128,1,126,233,242,99,2,211,174,211,179,236,101,128,36,233,245,237,230,236,229,120,128,30,145,245,242,108,128,2,145,228,239,116,130,1,124,211,204,211,213,225,227,227,229,238,116,128,1,124,226,229,236,239,119,128,30,147,101,6,211,235,211,246,212,33,212,44,212,55,212,251,227,249,242,233,236,236,233,99,128,4,55,100,2,211,252,212,15,229,243,227,229,238,228,229,242,
227,249,242,233,236,236,233,99,128,4,153,233,229,242,229,243,233,243,227,249,242,233,236,236,233,99,128,4,223,232,233,242,225,231,225,238,97,128,48,92,235,225,244,225,235,225,238,97,128,48,188,242,111,140,0,48,212,84,212,93,212,103,212,110,212,135,212,148,212,159,212,171,212,182,212,192,212,203,212,210,225,242,225,226,233,99,128,6,96,226,229,238,231,225,236,105,128,9,230,228,229,246,97,128,9,102,231,117,2,212,117,212,126,234,225,242,225,244,105,128,10,230,242,237,245,235,232,105,128,10,102,232,225,
227,235,225,242,225,226,233,99,128,6,96,233,238,230,229,242,233,239,114,128,32,128,237,239,238,239,243,240,225,227,101,128,255,16,239,236,228,243,244,249,236,101,128,247,48,240,229,242,243,233,225,110,128,6,240,243,245,240,229,242,233,239,114,128,32,112,244,232,225,105,128,14,80,247,233,228,244,104,3,212,222,212,231,212,243,234,239,233,238,229,114,128,254,255,238,239,238,234,239,233,238,229,114,128,32,12,243,240,225,227,101,128,32,11,244,97,128,3,182,104,2,213,6,213,17,226,239,240,239,237,239,230,
111,128,49,19,101,4,213,27,213,38,213,54,213,65,225,242,237,229,238,233,225,110,128,5,106,226,242,229,246,229,227,249,242,233,236,236,233,99,128,4,194,227,249,242,233,236,236,233,99,128,4,54,100,2,213,71,213,90,229,243,227,229,238,228,229,242,227,249,242,233,236,236,233,99,128,4,151,233,229,242,229,243,233,243,227,249,242,233,236,236,233,99,128,4,221,105,3,213,116,213,127,213,138,232,233,242,225,231,225,238,97,128,48,88,235,225,244,225,235,225,238,97,128,48,184,238,239,242,232,229,226,242,229,119,
128,5,174,236,233,238,229,226,229,236,239,119,128,30,149,237,239,238,239,243,240,225,227,101,128,255,90,111,2,213,180,213,191,232,233,242,225,231,225,238,97,128,48,94,235,225,244,225,235,225,238,97,128,48,190,240,225,242,229,110,128,36,181,242,229,244,242,239,230,236,229,248,232,239,239,107,128,2,144,243,244,242,239,235,101,128,1,182,117,2,213,241,213,252,232,233,242,225,231,225,238,97,128,48,90,235,225,244,225,235,225,238,97,128,48,186],0,ALLOC_STATIC);_ft_extra_glyph_unicodes=Pointer_make([916,
0,0,0,937,0,0,0,8725,0,0,0,173,0,0,0,713,0,0,0,956,0,0,0,8729,0,0,0,160,0,0,0,538,0,0,0,539,0,0,0],0,ALLOC_STATIC);_ft_extra_glyph_names=Pointer_make([68,101,108,116,97,0,79,109,101,103,97,0,102,114,97,99,116,105,111,110,0,104,121,112,104,101,110,0,109,97,99,114,111,110,0,109,117,0,112,101,114,105,111,100,99,101,110,116,101,114,101,100,0,115,112,97,99,101,0,84,99,111,109,109,97,97,99,99,101,110,116,0,116,99,111,109,109,97,97,99,99,101,110,116,0],0,ALLOC_STATIC);_ft_extra_glyph_name_offsets=Pointer_make([0,
0,0,0,6,0,0,0,12,0,0,0,21,0,0,0,28,0,0,0,35,0,0,0,38,0,0,0,53,0,0,0,59,0,0,0,72,0,0,0],0,ALLOC_STATIC);_pscmaps_interface=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_pscmaps_services=Pointer_make([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);_psnames_module_class=Pointer_make([0,0,0,0,20,0,0,0,0,0,0,0,65536,0,0,0,131072,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],0,ALLOC_STATIC);__str1421=Pointer_make([112,115,110,97,109,101,115,0],0,ALLOC_STATIC);
IHEAP[_ft_default_modules+0]=_tt_driver_class;IHEAP[_ft_default_modules+4]=_t1_driver_class;IHEAP[_ft_default_modules+8]=_cff_driver_class;IHEAP[_ft_default_modules+12]=_t1cid_driver_class;IHEAP[_ft_default_modules+16]=_pfr_driver_class;IHEAP[_ft_default_modules+20]=_t42_driver_class;IHEAP[_ft_default_modules+24]=_winfnt_driver_class;IHEAP[_ft_default_modules+28]=_pcf_driver_class;IHEAP[_ft_default_modules+32]=_bdf_driver_class;IHEAP[_ft_default_modules+36]=_sfnt_module_class;IHEAP[_ft_default_modules+
40]=_autofit_module_class;IHEAP[_ft_default_modules+44]=_pshinter_module_class;IHEAP[_ft_default_modules+48]=_ft_raster1_renderer_class;IHEAP[_ft_default_modules+52]=_ft_smooth_renderer_class;IHEAP[_ft_default_modules+56]=_ft_smooth_lcd_renderer_class;IHEAP[_ft_default_modules+60]=_ft_smooth_lcdv_renderer_class;IHEAP[_ft_default_modules+64]=_psaux_module_class;IHEAP[_ft_default_modules+68]=_psnames_module_class;IHEAP[_raccess_guess_table+0]=_raccess_guess_apple_double.__index__;IHEAP[_raccess_guess_table+
8]=_raccess_guess_apple_single.__index__;IHEAP[_raccess_guess_table+16]=_raccess_guess_darwin_ufs_export.__index__;IHEAP[_raccess_guess_table+24]=_raccess_guess_darwin_newvfs.__index__;IHEAP[_raccess_guess_table+32]=_raccess_guess_darwin_hfsplus.__index__;IHEAP[_raccess_guess_table+40]=_raccess_guess_vfat.__index__;IHEAP[_raccess_guess_table+48]=_raccess_guess_linux_cap.__index__;IHEAP[_raccess_guess_table+56]=_raccess_guess_linux_double.__index__;IHEAP[_raccess_guess_table+64]=_raccess_guess_linux_netatalk.__index__;
IHEAP[_bbox_interface+0]=_BBox_Move_To.__index__;IHEAP[_bbox_interface+4]=_BBox_Move_To.__index__;IHEAP[_bbox_interface+8]=_BBox_Conic_To.__index__;IHEAP[_bbox_interface+12]=_BBox_Cubic_To.__index__;IHEAP[_ft_bitmap_glyph_class+8]=_ft_bitmap_glyph_init.__index__;IHEAP[_ft_bitmap_glyph_class+12]=_ft_bitmap_glyph_done.__index__;IHEAP[_ft_bitmap_glyph_class+16]=_ft_bitmap_glyph_copy.__index__;IHEAP[_ft_bitmap_glyph_class+24]=_ft_bitmap_glyph_bbox.__index__;IHEAP[_ft_outline_glyph_class+8]=_ft_outline_glyph_init.__index__;
IHEAP[_ft_outline_glyph_class+12]=_ft_outline_glyph_done.__index__;IHEAP[_ft_outline_glyph_class+16]=_ft_outline_glyph_copy.__index__;IHEAP[_ft_outline_glyph_class+20]=_ft_outline_glyph_transform.__index__;IHEAP[_ft_outline_glyph_class+24]=_ft_outline_glyph_bbox.__index__;IHEAP[_ft_outline_glyph_class+28]=_ft_outline_glyph_prepare.__index__;IHEAP[_tt_service_gx_multi_masters+8]=_TT_Set_MM_Blend.__index__;IHEAP[_tt_service_gx_multi_masters+12]=_TT_Get_MM_Var.__index__;IHEAP[_tt_service_gx_multi_masters+
16]=_TT_Set_Var_Design.__index__;IHEAP[_tt_service_truetype_glyf+0]=_tt_face_get_location.__index__;IHEAP[_tt_services+0]=__str31;IHEAP[_tt_services+4]=__str133;IHEAP[_tt_services+8]=__str24;IHEAP[_tt_services+12]=_tt_service_gx_multi_masters;IHEAP[_tt_services+16]=__str11;IHEAP[_tt_services+20]=_tt_service_truetype_engine;IHEAP[_tt_services+24]=__str127;IHEAP[_tt_services+28]=_tt_service_truetype_glyf;IHEAP[_tt_driver_class+8]=__str49;IHEAP[_tt_driver_class+24]=_tt_driver_init.__index__;IHEAP[_tt_driver_class+
28]=_tt_driver_done.__index__;IHEAP[_tt_driver_class+32]=_tt_get_interface.__index__;IHEAP[_tt_driver_class+48]=_tt_face_init.__index__;IHEAP[_tt_driver_class+52]=_tt_face_done.__index__;IHEAP[_tt_driver_class+56]=_tt_size_init.__index__;IHEAP[_tt_driver_class+60]=_tt_size_done.__index__;IHEAP[_tt_driver_class+64]=_tt_slot_init.__index__;IHEAP[_tt_driver_class+72]=_ft_stub_set_char_sizes.__index__;IHEAP[_tt_driver_class+76]=_ft_stub_set_pixel_sizes.__index__;IHEAP[_tt_driver_class+80]=_Load_Glyph.__index__;
IHEAP[_tt_driver_class+84]=_tt_get_kerning.__index__;IHEAP[_tt_driver_class+92]=_tt_get_advances.__index__;IHEAP[_tt_driver_class+96]=_tt_size_request.__index__;IHEAP[_tt_driver_class+100]=_tt_size_select.__index__;IHEAP[_t1_keywords+0]=__str1256;IHEAP[_t1_keywords+36]=__str1357;IHEAP[_t1_keywords+72]=__str1458;IHEAP[_t1_keywords+108]=__str1559;IHEAP[_t1_keywords+144]=__str740;IHEAP[_t1_keywords+180]=__str1660;IHEAP[_t1_keywords+216]=__str1761;IHEAP[_t1_keywords+252]=__str1862;IHEAP[_t1_keywords+
288]=__str1963;IHEAP[_t1_keywords+324]=__str2064;IHEAP[_t1_keywords+360]=__str2165;IHEAP[_t1_keywords+396]=__str2266;IHEAP[_t1_keywords+432]=__str23;IHEAP[_t1_keywords+468]=__str2467;IHEAP[_t1_keywords+504]=__str2568;IHEAP[_t1_keywords+540]=__str2669;IHEAP[_t1_keywords+576]=__str2712;IHEAP[_t1_keywords+612]=__str2870;IHEAP[_t1_keywords+648]=__str2971;IHEAP[_t1_keywords+684]=__str3072;IHEAP[_t1_keywords+720]=__str3173;IHEAP[_t1_keywords+756]=__str3274;IHEAP[_t1_keywords+792]=__str33;IHEAP[_t1_keywords+
828]=__str34;IHEAP[_t1_keywords+864]=__str35;IHEAP[_t1_keywords+900]=__str36;IHEAP[_t1_keywords+936]=__str37;IHEAP[_t1_keywords+972]=__str3813;IHEAP[_t1_keywords+1008]=__str39;IHEAP[_t1_keywords+1044]=__str40;IHEAP[_t1_keywords+1080]=__str41;IHEAP[_t1_keywords+1116]=__str42;IHEAP[_t1_keywords+1152]=__str43;IHEAP[_t1_keywords+1188]=__str4475;IHEAP[_t1_keywords+1224]=__str45;IHEAP[_t1_keywords+1260]=__str46;IHEAP[_t1_keywords+1296]=__str47;IHEAP[_t1_keywords+1308]=_parse_font_matrix.__index__;IHEAP[_t1_keywords+
1332]=__str48;IHEAP[_t1_keywords+1344]=_parse_encoding.__index__;IHEAP[_t1_keywords+1368]=__str4914;IHEAP[_t1_keywords+1380]=_parse_subrs.__index__;IHEAP[_t1_keywords+1404]=__str50;IHEAP[_t1_keywords+1416]=_parse_charstrings.__index__;IHEAP[_t1_keywords+1440]=__str51;IHEAP[_t1_keywords+1452]=_parse_private.__index__;IHEAP[_t1_keywords+1476]=__str52;IHEAP[_t1_keywords+1488]=_parse_blend_design_positions.__index__;IHEAP[_t1_keywords+1512]=__str53;IHEAP[_t1_keywords+1524]=_parse_blend_design_map.__index__;
IHEAP[_t1_keywords+1548]=__str54;IHEAP[_t1_keywords+1560]=_parse_blend_axis_types.__index__;IHEAP[_t1_keywords+1584]=__str55;IHEAP[_t1_keywords+1596]=_parse_weight_vector.__index__;IHEAP[_t1_keywords+1620]=__str56;IHEAP[_t1_keywords+1632]=_parse_buildchar.__index__;IHEAP[_t1_service_glyph_dict+0]=_t1_get_glyph_name.__index__;IHEAP[_t1_service_glyph_dict+4]=_t1_get_name_index.__index__;IHEAP[_t1_service_ps_name+0]=_t1_get_ps_name.__index__;IHEAP[_t1_service_multi_masters+0]=_T1_Get_Multi_Master.__index__;
IHEAP[_t1_service_multi_masters+4]=_T1_Set_MM_Design.__index__;IHEAP[_t1_service_multi_masters+8]=_T1_Set_MM_Blend.__index__;IHEAP[_t1_service_multi_masters+12]=_T1_Get_MM_Var.__index__;IHEAP[_t1_service_multi_masters+16]=_T1_Set_Var_Design.__index__;IHEAP[_t1_service_ps_info+0]=_t1_ps_get_font_info.__index__;IHEAP[_t1_service_ps_info+4]=_t1_ps_get_font_extra.__index__;IHEAP[_t1_service_ps_info+8]=_t1_ps_has_glyph_names.__index__;IHEAP[_t1_service_ps_info+12]=_t1_ps_get_font_private.__index__;IHEAP[_t1_service_kerning+
0]=_T1_Get_Track_Kerning.__index__;IHEAP[_t1_services+0]=__str7;IHEAP[_t1_services+4]=_t1_service_ps_name;IHEAP[_t1_services+8]=__str6;IHEAP[_t1_services+12]=_t1_service_glyph_dict;IHEAP[_t1_services+16]=__str31;IHEAP[_t1_services+20]=__str68;IHEAP[_t1_services+24]=__str21;IHEAP[_t1_services+28]=_t1_service_ps_info;IHEAP[_t1_services+32]=__str510;IHEAP[_t1_services+36]=_t1_service_kerning;IHEAP[_t1_services+40]=__str24;IHEAP[_t1_services+44]=_t1_service_multi_masters;IHEAP[_t1_driver_class+8]=__str16;
IHEAP[_t1_driver_class+24]=_T1_Driver_Init.__index__;IHEAP[_t1_driver_class+28]=_T1_Driver_Done.__index__;IHEAP[_t1_driver_class+32]=_Get_Interface.__index__;IHEAP[_t1_driver_class+48]=_T1_Face_Init.__index__;IHEAP[_t1_driver_class+52]=_T1_Face_Done.__index__;IHEAP[_t1_driver_class+56]=_T1_Size_Init.__index__;IHEAP[_t1_driver_class+60]=_T1_Size_Done.__index__;IHEAP[_t1_driver_class+64]=_T1_GlyphSlot_Init.__index__;IHEAP[_t1_driver_class+68]=_T1_GlyphSlot_Done.__index__;IHEAP[_t1_driver_class+72]=
_ft_stub_set_char_sizes.__index__;IHEAP[_t1_driver_class+76]=_ft_stub_set_pixel_sizes.__index__;IHEAP[_t1_driver_class+80]=_T1_Load_Glyph.__index__;IHEAP[_t1_driver_class+84]=_Get_Kerning.__index__;IHEAP[_t1_driver_class+88]=_T1_Read_Metrics.__index__;IHEAP[_t1_driver_class+92]=_T1_Get_Advances.__index__;IHEAP[_t1_driver_class+96]=_T1_Size_Request.__index__;IHEAP[_cff_service_glyph_dict+0]=_cff_get_glyph_name.__index__;IHEAP[_cff_service_glyph_dict+4]=_cff_get_name_index.__index__;IHEAP[_cff_service_ps_info+
0]=_cff_ps_get_font_info.__index__;IHEAP[_cff_service_ps_info+8]=_cff_ps_has_glyph_names.__index__;IHEAP[_cff_service_ps_name+0]=_cff_get_ps_name.__index__;IHEAP[_cff_cmap_encoding_class_rec+4]=_cff_cmap_encoding_init.__index__;IHEAP[_cff_cmap_encoding_class_rec+8]=_cff_cmap_encoding_done.__index__;IHEAP[_cff_cmap_encoding_class_rec+12]=_cff_cmap_encoding_char_index.__index__;IHEAP[_cff_cmap_encoding_class_rec+16]=_cff_cmap_encoding_char_next.__index__;IHEAP[_cff_cmap_unicode_class_rec+4]=_cff_cmap_unicode_init.__index__;
IHEAP[_cff_cmap_unicode_class_rec+8]=_cff_cmap_unicode_done.__index__;IHEAP[_cff_cmap_unicode_class_rec+12]=_cff_cmap_unicode_char_index.__index__;IHEAP[_cff_cmap_unicode_class_rec+16]=_cff_cmap_unicode_char_next.__index__;IHEAP[_cff_service_get_cmap_info+0]=_cff_get_cmap_info.__index__;IHEAP[_cff_service_cid_info+0]=_cff_get_ros.__index__;IHEAP[_cff_service_cid_info+4]=_cff_get_is_cid.__index__;IHEAP[_cff_service_cid_info+8]=_cff_get_cid_from_glyph_index.__index__;IHEAP[_cff_services+0]=__str31;
IHEAP[_cff_services+4]=__str481;IHEAP[_cff_services+8]=__str21;IHEAP[_cff_services+12]=_cff_service_ps_info;IHEAP[_cff_services+16]=__str7;IHEAP[_cff_services+20]=_cff_service_ps_name;IHEAP[_cff_services+24]=__str6;IHEAP[_cff_services+28]=_cff_service_glyph_dict;IHEAP[_cff_services+32]=__str9;IHEAP[_cff_services+36]=_cff_service_get_cmap_info;IHEAP[_cff_services+40]=__str20;IHEAP[_cff_services+44]=_cff_service_cid_info;IHEAP[_cff_driver_class+8]=__str38;IHEAP[_cff_driver_class+24]=_cff_driver_init.__index__;
IHEAP[_cff_driver_class+28]=_cff_driver_done.__index__;IHEAP[_cff_driver_class+32]=_cff_get_interface.__index__;IHEAP[_cff_driver_class+48]=_cff_face_init.__index__;IHEAP[_cff_driver_class+52]=_cff_face_done.__index__;IHEAP[_cff_driver_class+56]=_cff_size_init.__index__;IHEAP[_cff_driver_class+60]=_cff_size_done.__index__;IHEAP[_cff_driver_class+64]=_cff_slot_init.__index__;IHEAP[_cff_driver_class+68]=_cff_slot_done.__index__;IHEAP[_cff_driver_class+72]=_ft_stub_set_char_sizes.__index__;IHEAP[_cff_driver_class+
76]=_ft_stub_set_pixel_sizes.__index__;IHEAP[_cff_driver_class+80]=_Load_Glyph92.__index__;IHEAP[_cff_driver_class+84]=_cff_get_kerning.__index__;IHEAP[_cff_driver_class+92]=_cff_get_advances.__index__;IHEAP[_cff_driver_class+96]=_cff_size_request.__index__;IHEAP[_cff_driver_class+100]=_cff_size_select.__index__;IHEAP[_cff_field_handlers+352]=_cff_parse_font_matrix.__index__;IHEAP[_cff_field_handlers+408]=_cff_parse_font_bbox.__index__;IHEAP[_cff_field_handlers+548]=_cff_parse_private_dict.__index__;
IHEAP[_cff_field_handlers+632]=_cff_parse_cid_ros.__index__;IHEAP[_cid_field_records+0]=__str497;IHEAP[_cid_field_records+36]=__str598;IHEAP[_cid_field_records+72]=__str699;IHEAP[_cid_field_records+108]=__str7100;IHEAP[_cid_field_records+144]=__str8101;IHEAP[_cid_field_records+180]=__str9102;IHEAP[_cid_field_records+216]=__str10103;IHEAP[_cid_field_records+252]=__str11104;IHEAP[_cid_field_records+288]=__str12105;IHEAP[_cid_field_records+324]=__str13106;IHEAP[_cid_field_records+360]=__str14107;IHEAP[_cid_field_records+
396]=__str1256;IHEAP[_cid_field_records+432]=__str1357;IHEAP[_cid_field_records+468]=__str1458;IHEAP[_cid_field_records+504]=__str1559;IHEAP[_cid_field_records+540]=__str740;IHEAP[_cid_field_records+576]=__str1660;IHEAP[_cid_field_records+612]=__str1761;IHEAP[_cid_field_records+648]=__str1862;IHEAP[_cid_field_records+684]=__str1963;IHEAP[_cid_field_records+720]=__str2064;IHEAP[_cid_field_records+756]=__str40;IHEAP[_cid_field_records+792]=__str41;IHEAP[_cid_field_records+828]=__str27120;IHEAP[_cid_field_records+
864]=__str28121;IHEAP[_cid_field_records+900]=__str29122;IHEAP[_cid_field_records+936]=__str30123;IHEAP[_cid_field_records+972]=__str31124;IHEAP[_cid_field_records+1008]=__str42;IHEAP[_cid_field_records+1044]=__str2165;IHEAP[_cid_field_records+1080]=__str2266;IHEAP[_cid_field_records+1116]=__str23;IHEAP[_cid_field_records+1152]=__str2467;IHEAP[_cid_field_records+1188]=__str2568;IHEAP[_cid_field_records+1224]=__str2669;IHEAP[_cid_field_records+1260]=__str2712;IHEAP[_cid_field_records+1296]=__str2870;
IHEAP[_cid_field_records+1332]=__str2971;IHEAP[_cid_field_records+1368]=__str3072;IHEAP[_cid_field_records+1404]=__str3173;IHEAP[_cid_field_records+1440]=__str3274;IHEAP[_cid_field_records+1476]=__str33;IHEAP[_cid_field_records+1512]=__str34;IHEAP[_cid_field_records+1548]=__str35;IHEAP[_cid_field_records+1584]=__str36;IHEAP[_cid_field_records+1620]=__str3813;IHEAP[_cid_field_records+1656]=__str43;IHEAP[_cid_field_records+1692]=__str51144;IHEAP[_cid_field_records+1704]=_parse_fd_array.__index__;IHEAP[_cid_field_records+
1728]=__str47;IHEAP[_cid_field_records+1740]=_parse_font_matrix160.__index__;IHEAP[_cid_field_records+1764]=__str37;IHEAP[_cid_field_records+1776]=_parse_expansion_factor.__index__;IHEAP[_cid_service_ps_name+0]=_cid_get_postscript_name.__index__;IHEAP[_cid_service_ps_info+0]=_cid_ps_get_font_info.__index__;IHEAP[_cid_service_ps_info+4]=_cid_ps_get_font_extra.__index__;IHEAP[_cid_service_cid_info+0]=_cid_get_ros.__index__;IHEAP[_cid_service_cid_info+4]=_cid_get_is_cid.__index__;IHEAP[_cid_service_cid_info+
8]=_cid_get_cid_from_glyph_index.__index__;IHEAP[_cid_services+0]=__str31;IHEAP[_cid_services+4]=__str61154;IHEAP[_cid_services+8]=__str7;IHEAP[_cid_services+12]=_cid_service_ps_name;IHEAP[_cid_services+16]=__str21;IHEAP[_cid_services+20]=_cid_service_ps_info;IHEAP[_cid_services+24]=__str20;IHEAP[_cid_services+28]=_cid_service_cid_info;IHEAP[_t1cid_driver_class+8]=__str65159;IHEAP[_t1cid_driver_class+24]=_cid_driver_init.__index__;IHEAP[_t1cid_driver_class+28]=_cid_driver_done.__index__;IHEAP[_t1cid_driver_class+
32]=_cid_get_interface.__index__;IHEAP[_t1cid_driver_class+48]=_cid_face_init.__index__;IHEAP[_t1cid_driver_class+52]=_cid_face_done.__index__;IHEAP[_t1cid_driver_class+56]=_cid_size_init.__index__;IHEAP[_t1cid_driver_class+60]=_cid_size_done.__index__;IHEAP[_t1cid_driver_class+64]=_cid_slot_init.__index__;IHEAP[_t1cid_driver_class+68]=_cid_slot_done.__index__;IHEAP[_t1cid_driver_class+72]=_ft_stub_set_char_sizes.__index__;IHEAP[_t1cid_driver_class+76]=_ft_stub_set_pixel_sizes.__index__;IHEAP[_t1cid_driver_class+
80]=_cid_slot_load_glyph.__index__;IHEAP[_t1cid_driver_class+96]=_cid_size_request.__index__;IHEAP[_pfr_phy_font_extra_items+4]=_pfr_extra_item_load_bitmap_info.__index__;IHEAP[_pfr_phy_font_extra_items+12]=_pfr_extra_item_load_font_id.__index__;IHEAP[_pfr_phy_font_extra_items+20]=_pfr_extra_item_load_stem_snaps.__index__;IHEAP[_pfr_phy_font_extra_items+28]=_pfr_extra_item_load_kerning_pairs.__index__;IHEAP[_pfr_cmap_class_rec+4]=_pfr_cmap_init.__index__;IHEAP[_pfr_cmap_class_rec+8]=_pfr_cmap_done.__index__;
IHEAP[_pfr_cmap_class_rec+12]=_pfr_cmap_char_index.__index__;IHEAP[_pfr_cmap_class_rec+16]=_pfr_cmap_char_next.__index__;IHEAP[_pfr_metrics_service_rec+0]=_pfr_get_metrics.__index__;IHEAP[_pfr_metrics_service_rec+4]=_pfr_face_get_kerning.__index__;IHEAP[_pfr_metrics_service_rec+8]=_pfr_get_advance.__index__;IHEAP[_pfr_services+0]=__str28;IHEAP[_pfr_services+4]=_pfr_metrics_service_rec;IHEAP[_pfr_services+8]=__str31;IHEAP[_pfr_services+12]=__str2166;IHEAP[_pfr_driver_class+8]=__str3168;IHEAP[_pfr_driver_class+
32]=_pfr_get_service.__index__;IHEAP[_pfr_driver_class+48]=_pfr_face_init.__index__;IHEAP[_pfr_driver_class+52]=_pfr_face_done.__index__;IHEAP[_pfr_driver_class+64]=_pfr_slot_init.__index__;IHEAP[_pfr_driver_class+68]=_pfr_slot_done.__index__;IHEAP[_pfr_driver_class+72]=_ft_stub_set_char_sizes.__index__;IHEAP[_pfr_driver_class+76]=_ft_stub_set_pixel_sizes.__index__;IHEAP[_pfr_driver_class+80]=_pfr_slot_load.__index__;IHEAP[_pfr_driver_class+84]=_pfr_get_kerning.__index__;IHEAP[_t42_keywords+0]=__str1256;
IHEAP[_t42_keywords+36]=__str1357;IHEAP[_t42_keywords+72]=__str1458;IHEAP[_t42_keywords+108]=__str1559;IHEAP[_t42_keywords+144]=__str740;IHEAP[_t42_keywords+180]=__str1660;IHEAP[_t42_keywords+216]=__str1761;IHEAP[_t42_keywords+252]=__str1862;IHEAP[_t42_keywords+288]=__str1963;IHEAP[_t42_keywords+324]=__str2064;IHEAP[_t42_keywords+360]=__str39;IHEAP[_t42_keywords+396]=__str40;IHEAP[_t42_keywords+432]=__str41;IHEAP[_t42_keywords+468]=__str42;IHEAP[_t42_keywords+504]=__str43;IHEAP[_t42_keywords+540]=
__str47;IHEAP[_t42_keywords+552]=_t42_parse_font_matrix.__index__;IHEAP[_t42_keywords+576]=__str48;IHEAP[_t42_keywords+588]=_t42_parse_encoding.__index__;IHEAP[_t42_keywords+612]=__str50;IHEAP[_t42_keywords+624]=_t42_parse_charstrings.__index__;IHEAP[_t42_keywords+648]=__str23192;IHEAP[_t42_keywords+660]=_t42_parse_sfnts.__index__;IHEAP[_t42_service_glyph_dict+0]=_t42_get_glyph_name.__index__;IHEAP[_t42_service_glyph_dict+4]=_t42_get_name_index.__index__;IHEAP[_t42_service_ps_font_name+0]=_t42_get_ps_font_name.__index__;
IHEAP[_t42_service_ps_info+0]=_t42_ps_get_font_info.__index__;IHEAP[_t42_service_ps_info+4]=_t42_ps_get_font_extra.__index__;IHEAP[_t42_service_ps_info+8]=_t42_ps_has_glyph_names.__index__;IHEAP[_t42_service_ps_info+12]=_t42_ps_get_font_private.__index__;IHEAP[_t42_services+0]=__str6;IHEAP[_t42_services+4]=_t42_service_glyph_dict;IHEAP[_t42_services+8]=__str7;IHEAP[_t42_services+12]=_t42_service_ps_font_name;IHEAP[_t42_services+16]=__str21;IHEAP[_t42_services+20]=_t42_service_ps_info;IHEAP[_t42_services+
24]=__str31;IHEAP[_t42_services+28]=__str34203;IHEAP[_t42_driver_class+8]=__str10;IHEAP[_t42_driver_class+24]=_T42_Driver_Init.__index__;IHEAP[_t42_driver_class+28]=_T42_Driver_Done.__index__;IHEAP[_t42_driver_class+32]=_T42_Get_Interface.__index__;IHEAP[_t42_driver_class+48]=_T42_Face_Init.__index__;IHEAP[_t42_driver_class+52]=_T42_Face_Done.__index__;IHEAP[_t42_driver_class+56]=_T42_Size_Init.__index__;IHEAP[_t42_driver_class+60]=_T42_Size_Done.__index__;IHEAP[_t42_driver_class+64]=_T42_GlyphSlot_Init.__index__;
IHEAP[_t42_driver_class+68]=_T42_GlyphSlot_Done.__index__;IHEAP[_t42_driver_class+72]=_ft_stub_set_char_sizes.__index__;IHEAP[_t42_driver_class+76]=_ft_stub_set_pixel_sizes.__index__;IHEAP[_t42_driver_class+80]=_T42_GlyphSlot_Load.__index__;IHEAP[_t42_driver_class+96]=_T42_Size_Request.__index__;IHEAP[_t42_driver_class+100]=_T42_Size_Select.__index__;IHEAP[_fnt_cmap_class_rec+4]=_fnt_cmap_init.__index__;IHEAP[_fnt_cmap_class_rec+12]=_fnt_cmap_char_index.__index__;IHEAP[_fnt_cmap_class_rec+16]=_fnt_cmap_char_next.__index__;
IHEAP[_winfnt_service_rec+0]=_winfnt_get_header.__index__;IHEAP[_winfnt_services+0]=__str31;IHEAP[_winfnt_services+4]=__str5211;IHEAP[_winfnt_services+8]=__str30;IHEAP[_winfnt_services+12]=_winfnt_service_rec;IHEAP[_winfnt_driver_class+8]=__str30;IHEAP[_winfnt_driver_class+32]=_winfnt_get_service.__index__;IHEAP[_winfnt_driver_class+48]=_FNT_Face_Init.__index__;IHEAP[_winfnt_driver_class+52]=_FNT_Face_Done.__index__;IHEAP[_winfnt_driver_class+72]=_ft_stub_set_char_sizes.__index__;IHEAP[_winfnt_driver_class+
76]=_ft_stub_set_pixel_sizes.__index__;IHEAP[_winfnt_driver_class+80]=_FNT_Load_Glyph.__index__;IHEAP[_winfnt_driver_class+96]=_FNT_Size_Request.__index__;IHEAP[_winfnt_driver_class+100]=_FNT_Size_Select.__index__;IHEAP[_pcf_cmap_class+4]=_pcf_cmap_init.__index__;IHEAP[_pcf_cmap_class+8]=_pcf_cmap_done.__index__;IHEAP[_pcf_cmap_class+12]=_pcf_cmap_char_index.__index__;IHEAP[_pcf_cmap_class+16]=_pcf_cmap_char_next.__index__;IHEAP[_pcf_service_bdf+0]=_pcf_get_charset_id.__index__;IHEAP[_pcf_service_bdf+
4]=_pcf_get_bdf_property.__index__;IHEAP[_pcf_services+0]=__str19;IHEAP[_pcf_services+4]=_pcf_service_bdf;IHEAP[_pcf_services+8]=__str31;IHEAP[_pcf_services+12]=__str21235;IHEAP[_pcf_driver_class+8]=__str22237;IHEAP[_pcf_driver_class+32]=_pcf_driver_requester.__index__;IHEAP[_pcf_driver_class+48]=_PCF_Face_Init.__index__;IHEAP[_pcf_driver_class+52]=_PCF_Face_Done.__index__;IHEAP[_pcf_driver_class+72]=_ft_stub_set_char_sizes.__index__;IHEAP[_pcf_driver_class+76]=_ft_stub_set_pixel_sizes.__index__;
IHEAP[_pcf_driver_class+80]=_PCF_Glyph_Load.__index__;IHEAP[_pcf_driver_class+96]=_PCF_Size_Request.__index__;IHEAP[_pcf_driver_class+100]=_PCF_Size_Select.__index__;IHEAP[__bdf_properties+0]=__str6220;IHEAP[__bdf_properties+16]=__str9223;IHEAP[__bdf_properties+32]=__str2240;IHEAP[__bdf_properties+48]=__str3241;IHEAP[__bdf_properties+64]=__str4242;IHEAP[__bdf_properties+80]=__str5243;IHEAP[__bdf_properties+96]=__str15229;IHEAP[__bdf_properties+112]=__str14228;IHEAP[__bdf_properties+128]=__str8246;
IHEAP[__bdf_properties+144]=__str9247;IHEAP[__bdf_properties+160]=__str10248;IHEAP[__bdf_properties+176]=__str11249;IHEAP[__bdf_properties+192]=__str12250;IHEAP[__bdf_properties+208]=__str13251;IHEAP[__bdf_properties+224]=__str14252;IHEAP[__bdf_properties+240]=__str8222;IHEAP[__bdf_properties+256]=__str16254;IHEAP[__bdf_properties+272]=__str17255;IHEAP[__bdf_properties+288]=__str18256;IHEAP[__bdf_properties+304]=__str19257;IHEAP[__bdf_properties+320]=__str20258;IHEAP[__bdf_properties+336]=__str21259;
IHEAP[__bdf_properties+352]=__str22260;IHEAP[__bdf_properties+368]=__str23261;IHEAP[__bdf_properties+384]=__str24262;IHEAP[__bdf_properties+400]=__str25263;IHEAP[__bdf_properties+416]=__str26264;IHEAP[__bdf_properties+432]=__str27265;IHEAP[__bdf_properties+448]=__str11225;IHEAP[__bdf_properties+464]=__str10224;IHEAP[__bdf_properties+480]=__str30268;IHEAP[__bdf_properties+496]=__str31269;IHEAP[__bdf_properties+512]=__str32270;IHEAP[__bdf_properties+528]=__str33271;IHEAP[__bdf_properties+544]=__str34272;
IHEAP[__bdf_properties+560]=__str35273;IHEAP[__bdf_properties+576]=__str36274;IHEAP[__bdf_properties+592]=__str37275;IHEAP[__bdf_properties+608]=__str38276;IHEAP[__bdf_properties+624]=__str39277;IHEAP[__bdf_properties+640]=__str40278;IHEAP[__bdf_properties+656]=__str41279;IHEAP[__bdf_properties+672]=__str42280;IHEAP[__bdf_properties+688]=__str43281;IHEAP[__bdf_properties+704]=__str44282;IHEAP[__bdf_properties+720]=__str45283;IHEAP[__bdf_properties+736]=__str46284;IHEAP[__bdf_properties+752]=__str47285;
IHEAP[__bdf_properties+768]=__str48286;IHEAP[__bdf_properties+784]=__str49287;IHEAP[__bdf_properties+800]=__str50288;IHEAP[__bdf_properties+816]=__str51289;IHEAP[__bdf_properties+832]=__str52290;IHEAP[__bdf_properties+848]=__str53291;IHEAP[__bdf_properties+864]=__str54292;IHEAP[__bdf_properties+880]=__str55293;IHEAP[__bdf_properties+896]=__str56294;IHEAP[__bdf_properties+912]=__str57295;IHEAP[__bdf_properties+928]=__str58296;IHEAP[__bdf_properties+944]=__str59297;IHEAP[__bdf_properties+960]=__str60298;
IHEAP[__bdf_properties+976]=__str61299;IHEAP[__bdf_properties+992]=__str12226;IHEAP[__bdf_properties+1008]=__str13227;IHEAP[__bdf_properties+1024]=__str5219;IHEAP[__bdf_properties+1040]=__str214;IHEAP[__bdf_properties+1056]=__str66304;IHEAP[__bdf_properties+1072]=__str67305;IHEAP[__bdf_properties+1088]=__str68306;IHEAP[__bdf_properties+1104]=__str69307;IHEAP[__bdf_properties+1120]=__str70308;IHEAP[__bdf_properties+1136]=__str71309;IHEAP[__bdf_properties+1152]=__str72310;IHEAP[__bdf_properties+1168]=
__str73;IHEAP[__bdf_properties+1184]=__str74;IHEAP[__bdf_properties+1200]=__str75;IHEAP[__bdf_properties+1216]=__str76;IHEAP[__bdf_properties+1232]=__str77311;IHEAP[__bdf_properties+1248]=__str78;IHEAP[__bdf_properties+1264]=__str3217;IHEAP[__bdf_properties+1280]=__str80;IHEAP[__bdf_properties+1296]=__str81;IHEAP[__bdf_properties+1312]=__str82;IHEAP[_bdf_cmap_class+4]=_bdf_cmap_init.__index__;IHEAP[_bdf_cmap_class+8]=_bdf_cmap_done.__index__;IHEAP[_bdf_cmap_class+12]=_bdf_cmap_char_index.__index__;
IHEAP[_bdf_cmap_class+16]=_bdf_cmap_char_next.__index__;IHEAP[_bdf_service_bdf+0]=_bdf_get_charset_id.__index__;IHEAP[_bdf_service_bdf+4]=_bdf_get_bdf_property.__index__;IHEAP[_bdf_services+0]=__str19;IHEAP[_bdf_services+4]=_bdf_service_bdf;IHEAP[_bdf_services+8]=__str31;IHEAP[_bdf_services+12]=__str110;IHEAP[_bdf_driver_class+8]=__str19;IHEAP[_bdf_driver_class+32]=_bdf_driver_requester.__index__;IHEAP[_bdf_driver_class+48]=_BDF_Face_Init.__index__;IHEAP[_bdf_driver_class+52]=_BDF_Face_Done.__index__;
IHEAP[_bdf_driver_class+72]=_ft_stub_set_char_sizes.__index__;IHEAP[_bdf_driver_class+76]=_ft_stub_set_pixel_sizes.__index__;IHEAP[_bdf_driver_class+80]=_BDF_Glyph_Load.__index__;IHEAP[_bdf_driver_class+96]=_BDF_Size_Request.__index__;IHEAP[_bdf_driver_class+100]=_BDF_Size_Select.__index__;IHEAP[_tt_cmap0_class_rec+4]=_tt_cmap_init.__index__;IHEAP[_tt_cmap0_class_rec+12]=_tt_cmap0_char_index.__index__;IHEAP[_tt_cmap0_class_rec+16]=_tt_cmap0_char_next.__index__;IHEAP[_tt_cmap0_class_rec+44]=_tt_cmap0_validate.__index__;
IHEAP[_tt_cmap0_class_rec+48]=_tt_cmap0_get_info.__index__;IHEAP[_tt_cmap2_class_rec+4]=_tt_cmap_init.__index__;IHEAP[_tt_cmap2_class_rec+12]=_tt_cmap2_char_index.__index__;IHEAP[_tt_cmap2_class_rec+16]=_tt_cmap2_char_next.__index__;IHEAP[_tt_cmap2_class_rec+44]=_tt_cmap2_validate.__index__;IHEAP[_tt_cmap2_class_rec+48]=_tt_cmap2_get_info.__index__;IHEAP[_tt_cmap4_class_rec+4]=_tt_cmap4_init.__index__;IHEAP[_tt_cmap4_class_rec+12]=_tt_cmap4_char_index.__index__;IHEAP[_tt_cmap4_class_rec+16]=_tt_cmap4_char_next.__index__;
IHEAP[_tt_cmap4_class_rec+44]=_tt_cmap4_validate.__index__;IHEAP[_tt_cmap4_class_rec+48]=_tt_cmap4_get_info.__index__;IHEAP[_tt_cmap6_class_rec+4]=_tt_cmap_init.__index__;IHEAP[_tt_cmap6_class_rec+12]=_tt_cmap6_char_index.__index__;IHEAP[_tt_cmap6_class_rec+16]=_tt_cmap6_char_next.__index__;IHEAP[_tt_cmap6_class_rec+44]=_tt_cmap6_validate.__index__;IHEAP[_tt_cmap6_class_rec+48]=_tt_cmap6_get_info.__index__;IHEAP[_tt_cmap8_class_rec+4]=_tt_cmap_init.__index__;IHEAP[_tt_cmap8_class_rec+12]=_tt_cmap8_char_index.__index__;
IHEAP[_tt_cmap8_class_rec+16]=_tt_cmap8_char_next.__index__;IHEAP[_tt_cmap8_class_rec+44]=_tt_cmap8_validate.__index__;IHEAP[_tt_cmap8_class_rec+48]=_tt_cmap8_get_info.__index__;IHEAP[_tt_cmap10_class_rec+4]=_tt_cmap_init.__index__;IHEAP[_tt_cmap10_class_rec+12]=_tt_cmap10_char_index.__index__;IHEAP[_tt_cmap10_class_rec+16]=_tt_cmap10_char_next.__index__;IHEAP[_tt_cmap10_class_rec+44]=_tt_cmap10_validate.__index__;IHEAP[_tt_cmap10_class_rec+48]=_tt_cmap10_get_info.__index__;IHEAP[_tt_cmap12_class_rec+
4]=_tt_cmap12_init.__index__;IHEAP[_tt_cmap12_class_rec+12]=_tt_cmap12_char_index.__index__;IHEAP[_tt_cmap12_class_rec+16]=_tt_cmap12_char_next.__index__;IHEAP[_tt_cmap12_class_rec+44]=_tt_cmap12_validate.__index__;IHEAP[_tt_cmap12_class_rec+48]=_tt_cmap12_get_info.__index__;IHEAP[_tt_cmap13_class_rec+4]=_tt_cmap13_init.__index__;IHEAP[_tt_cmap13_class_rec+12]=_tt_cmap13_char_index.__index__;IHEAP[_tt_cmap13_class_rec+16]=_tt_cmap13_char_next.__index__;IHEAP[_tt_cmap13_class_rec+44]=_tt_cmap13_validate.__index__;
IHEAP[_tt_cmap13_class_rec+48]=_tt_cmap13_get_info.__index__;IHEAP[_tt_cmap14_class_rec+4]=_tt_cmap14_init.__index__;IHEAP[_tt_cmap14_class_rec+8]=_tt_cmap14_done.__index__;IHEAP[_tt_cmap14_class_rec+12]=_tt_cmap14_char_index.__index__;IHEAP[_tt_cmap14_class_rec+16]=_tt_cmap14_char_next.__index__;IHEAP[_tt_cmap14_class_rec+20]=_tt_cmap14_char_var_index.__index__;IHEAP[_tt_cmap14_class_rec+24]=_tt_cmap14_char_var_isdefault.__index__;IHEAP[_tt_cmap14_class_rec+28]=_tt_cmap14_variants.__index__;IHEAP[_tt_cmap14_class_rec+
32]=_tt_cmap14_char_variants.__index__;IHEAP[_tt_cmap14_class_rec+36]=_tt_cmap14_variant_chars.__index__;IHEAP[_tt_cmap14_class_rec+44]=_tt_cmap14_validate.__index__;IHEAP[_tt_cmap14_class_rec+48]=_tt_cmap14_get_info.__index__;IHEAP[_tt_cmap_classes+0]=_tt_cmap0_class_rec;IHEAP[_tt_cmap_classes+4]=_tt_cmap2_class_rec;IHEAP[_tt_cmap_classes+8]=_tt_cmap4_class_rec;IHEAP[_tt_cmap_classes+12]=_tt_cmap6_class_rec;IHEAP[_tt_cmap_classes+16]=_tt_cmap8_class_rec;IHEAP[_tt_cmap_classes+20]=_tt_cmap10_class_rec;
IHEAP[_tt_cmap_classes+24]=_tt_cmap12_class_rec;IHEAP[_tt_cmap_classes+28]=_tt_cmap13_class_rec;IHEAP[_tt_cmap_classes+32]=_tt_cmap14_class_rec;IHEAP[_sfnt_service_sfnt_table+0]=_tt_face_load_any.__index__;IHEAP[_sfnt_service_sfnt_table+4]=_get_sfnt_table.__index__;IHEAP[_sfnt_service_sfnt_table+8]=_sfnt_table_info.__index__;IHEAP[_sfnt_service_glyph_dict+0]=_sfnt_get_glyph_name.__index__;IHEAP[_sfnt_service_glyph_dict+4]=_sfnt_get_name_index.__index__;IHEAP[_sfnt_service_ps_name+0]=_sfnt_get_ps_name.__index__;
IHEAP[_tt_service_get_cmap_info+0]=_tt_get_cmap_info.__index__;IHEAP[_sfnt_service_bdf+0]=_sfnt_get_charset_id.__index__;IHEAP[_sfnt_service_bdf+4]=_tt_face_find_bdf_prop.__index__;IHEAP[_sfnt_services+0]=__str8;IHEAP[_sfnt_services+4]=_sfnt_service_sfnt_table;IHEAP[_sfnt_services+8]=__str7;IHEAP[_sfnt_services+12]=_sfnt_service_ps_name;IHEAP[_sfnt_services+16]=__str6;IHEAP[_sfnt_services+20]=_sfnt_service_glyph_dict;IHEAP[_sfnt_services+24]=__str19;IHEAP[_sfnt_services+28]=_sfnt_service_bdf;IHEAP[_sfnt_services+
32]=__str9;IHEAP[_sfnt_services+36]=_tt_service_get_cmap_info;IHEAP[_sfnt_interface+0]=_tt_face_goto_table.__index__;IHEAP[_sfnt_interface+4]=_sfnt_init_face.__index__;IHEAP[_sfnt_interface+8]=_sfnt_load_face.__index__;IHEAP[_sfnt_interface+12]=_sfnt_done_face.__index__;IHEAP[_sfnt_interface+16]=_sfnt_get_interface.__index__;IHEAP[_sfnt_interface+20]=_tt_face_load_any.__index__;IHEAP[_sfnt_interface+24]=_tt_face_load_sfnt_header_stub.__index__;IHEAP[_sfnt_interface+28]=_tt_face_load_directory_stub.__index__;
IHEAP[_sfnt_interface+32]=_tt_face_load_head.__index__;IHEAP[_sfnt_interface+36]=_tt_face_load_hhea.__index__;IHEAP[_sfnt_interface+40]=_tt_face_load_cmap.__index__;IHEAP[_sfnt_interface+44]=_tt_face_load_maxp.__index__;IHEAP[_sfnt_interface+48]=_tt_face_load_os2.__index__;IHEAP[_sfnt_interface+52]=_tt_face_load_post.__index__;IHEAP[_sfnt_interface+56]=_tt_face_load_name.__index__;IHEAP[_sfnt_interface+60]=_tt_face_free_name.__index__;IHEAP[_sfnt_interface+64]=_tt_face_load_hdmx_stub.__index__;IHEAP[_sfnt_interface+
68]=_tt_face_free_hdmx_stub.__index__;IHEAP[_sfnt_interface+72]=_tt_face_load_kern.__index__;IHEAP[_sfnt_interface+76]=_tt_face_load_gasp.__index__;IHEAP[_sfnt_interface+80]=_tt_face_load_pclt.__index__;IHEAP[_sfnt_interface+84]=_tt_face_load_bhed.__index__;IHEAP[_sfnt_interface+88]=_tt_face_set_sbit_strike_stub.__index__;IHEAP[_sfnt_interface+92]=_tt_face_load_sbit_stub.__index__;IHEAP[_sfnt_interface+96]=_tt_find_sbit_image.__index__;IHEAP[_sfnt_interface+100]=_tt_load_sbit_metrics.__index__;IHEAP[_sfnt_interface+
104]=_tt_face_load_sbit_image.__index__;IHEAP[_sfnt_interface+108]=_tt_face_free_sbit_stub.__index__;IHEAP[_sfnt_interface+112]=_tt_face_get_ps_name.__index__;IHEAP[_sfnt_interface+116]=_tt_face_free_ps_names.__index__;IHEAP[_sfnt_interface+120]=_tt_face_load_charmap_stub.__index__;IHEAP[_sfnt_interface+124]=_tt_face_free_charmap_stub.__index__;IHEAP[_sfnt_interface+128]=_tt_face_get_kerning.__index__;IHEAP[_sfnt_interface+132]=_tt_face_load_font_dir.__index__;IHEAP[_sfnt_interface+136]=_tt_face_load_hmtx.__index__;
IHEAP[_sfnt_interface+140]=_tt_face_load_eblc.__index__;IHEAP[_sfnt_interface+144]=_tt_face_free_eblc.__index__;IHEAP[_sfnt_interface+148]=_tt_face_set_sbit_strike.__index__;IHEAP[_sfnt_interface+152]=_tt_face_load_strike_metrics.__index__;IHEAP[_sfnt_interface+156]=_tt_face_get_metrics.__index__;IHEAP[_sfnt_module_class+8]=__str537;IHEAP[_sfnt_module_class+20]=_sfnt_interface;IHEAP[_sfnt_module_class+32]=_sfnt_get_interface.__index__;IHEAP[_af_script_classes+0]=_af_dummy_script_class;IHEAP[_af_script_classes+
4]=_af_latin_script_class;IHEAP[_af_script_classes+8]=_af_cjk_script_class;IHEAP[_af_script_classes+12]=_af_indic_script_class;IHEAP[_af_dummy_script_class+24]=_af_dummy_hints_init.__index__;IHEAP[_af_dummy_script_class+28]=_af_dummy_hints_apply.__index__;IHEAP[_af_latin_script_class+4]=_af_latin_uniranges;IHEAP[_af_latin_script_class+12]=_af_latin_metrics_init.__index__;IHEAP[_af_latin_script_class+16]=_af_latin_metrics_scale.__index__;IHEAP[_af_latin_script_class+24]=_af_latin_hints_init.__index__;
IHEAP[_af_latin_script_class+28]=_af_latin_hints_apply.__index__;IHEAP[_af_cjk_script_class+4]=_af_cjk_uniranges;IHEAP[_af_cjk_script_class+12]=_af_cjk_metrics_init.__index__;IHEAP[_af_cjk_script_class+16]=_af_cjk_metrics_scale.__index__;IHEAP[_af_cjk_script_class+24]=_af_cjk_hints_init.__index__;IHEAP[_af_cjk_script_class+28]=_af_cjk_hints_apply.__index__;IHEAP[_af_indic_script_class+4]=_af_indic_uniranges;IHEAP[_af_indic_script_class+12]=_af_indic_metrics_init.__index__;IHEAP[_af_indic_script_class+
16]=_af_indic_metrics_scale.__index__;IHEAP[_af_indic_script_class+24]=_af_indic_hints_init.__index__;IHEAP[_af_indic_script_class+28]=_af_indic_hints_apply.__index__;IHEAP[_af_autofitter_service+12]=_af_autofitter_load_glyph.__index__;IHEAP[_autofit_module_class+8]=__str325;IHEAP[_autofit_module_class+20]=_af_autofitter_service;IHEAP[_autofit_module_class+24]=_af_autofitter_init.__index__;IHEAP[_autofit_module_class+28]=_af_autofitter_done.__index__;IHEAP[_pshinter_interface+0]=_pshinter_get_globals_funcs.__index__;
IHEAP[_pshinter_interface+4]=_pshinter_get_t1_funcs.__index__;IHEAP[_pshinter_interface+8]=_pshinter_get_t2_funcs.__index__;IHEAP[_pshinter_module_class+8]=__str59;IHEAP[_pshinter_module_class+20]=_pshinter_interface;IHEAP[_pshinter_module_class+24]=_ps_hinter_init.__index__;IHEAP[_pshinter_module_class+28]=_ps_hinter_done.__index__;IHEAP[_ft_standard_raster+4]=_ft_black_new.__index__;IHEAP[_ft_standard_raster+8]=_ft_black_reset.__index__;IHEAP[_ft_standard_raster+12]=_ft_black_set_mode.__index__;
IHEAP[_ft_standard_raster+16]=_ft_black_render.__index__;IHEAP[_ft_standard_raster+20]=_ft_black_done.__index__;IHEAP[_ft_raster1_renderer_class+8]=__str329;IHEAP[_ft_raster1_renderer_class+24]=_ft_raster1_init.__index__;IHEAP[_ft_raster1_renderer_class+40]=_ft_raster1_render.__index__;IHEAP[_ft_raster1_renderer_class+44]=_ft_raster1_transform.__index__;IHEAP[_ft_raster1_renderer_class+48]=_ft_raster1_get_cbox.__index__;IHEAP[_ft_raster1_renderer_class+52]=_ft_raster1_set_mode.__index__;IHEAP[_ft_raster1_renderer_class+
56]=_ft_standard_raster;IHEAP[_ft_raster5_renderer_class+8]=__str1330;IHEAP[_ft_raster5_renderer_class+24]=_ft_raster1_init.__index__;IHEAP[_ft_raster5_renderer_class+40]=_ft_raster1_render.__index__;IHEAP[_ft_raster5_renderer_class+44]=_ft_raster1_transform.__index__;IHEAP[_ft_raster5_renderer_class+48]=_ft_raster1_get_cbox.__index__;IHEAP[_ft_raster5_renderer_class+52]=_ft_raster1_set_mode.__index__;IHEAP[_ft_raster5_renderer_class+56]=_ft_standard_raster;IHEAP[_func_interface+0]=_gray_move_to.__index__;
IHEAP[_func_interface+4]=_gray_line_to.__index__;IHEAP[_func_interface+8]=_gray_conic_to.__index__;IHEAP[_func_interface+12]=_gray_cubic_to.__index__;IHEAP[_ft_grays_raster+4]=_gray_raster_new.__index__;IHEAP[_ft_grays_raster+8]=_gray_raster_reset.__index__;IHEAP[_ft_grays_raster+16]=_gray_raster_render.__index__;IHEAP[_ft_grays_raster+20]=_gray_raster_done.__index__;IHEAP[_ft_smooth_renderer_class+8]=__str332;IHEAP[_ft_smooth_renderer_class+24]=_ft_smooth_init.__index__;IHEAP[_ft_smooth_renderer_class+
40]=_ft_smooth_render.__index__;IHEAP[_ft_smooth_renderer_class+44]=_ft_smooth_transform.__index__;IHEAP[_ft_smooth_renderer_class+48]=_ft_smooth_get_cbox.__index__;IHEAP[_ft_smooth_renderer_class+52]=_ft_smooth_set_mode.__index__;IHEAP[_ft_smooth_renderer_class+56]=_ft_grays_raster;IHEAP[_ft_smooth_lcd_renderer_class+8]=__str1334;IHEAP[_ft_smooth_lcd_renderer_class+24]=_ft_smooth_init.__index__;IHEAP[_ft_smooth_lcd_renderer_class+40]=_ft_smooth_render_lcd.__index__;IHEAP[_ft_smooth_lcd_renderer_class+
44]=_ft_smooth_transform.__index__;IHEAP[_ft_smooth_lcd_renderer_class+48]=_ft_smooth_get_cbox.__index__;IHEAP[_ft_smooth_lcd_renderer_class+52]=_ft_smooth_set_mode.__index__;IHEAP[_ft_smooth_lcd_renderer_class+56]=_ft_grays_raster;IHEAP[_ft_smooth_lcdv_renderer_class+8]=__str2336;IHEAP[_ft_smooth_lcdv_renderer_class+24]=_ft_smooth_init.__index__;IHEAP[_ft_smooth_lcdv_renderer_class+40]=_ft_smooth_render_lcd_v.__index__;IHEAP[_ft_smooth_lcdv_renderer_class+44]=_ft_smooth_transform.__index__;IHEAP[_ft_smooth_lcdv_renderer_class+
48]=_ft_smooth_get_cbox.__index__;IHEAP[_ft_smooth_lcdv_renderer_class+52]=_ft_smooth_set_mode.__index__;IHEAP[_ft_smooth_lcdv_renderer_class+56]=_ft_grays_raster;IHEAP[_ftc_size_list_class+4]=_ftc_size_node_compare.__index__;IHEAP[_ftc_size_list_class+8]=_ftc_size_node_init.__index__;IHEAP[_ftc_size_list_class+12]=_ftc_size_node_reset.__index__;IHEAP[_ftc_size_list_class+16]=_ftc_size_node_done.__index__;IHEAP[_ftc_face_list_class+4]=_ftc_face_node_compare.__index__;IHEAP[_ftc_face_list_class+8]=
_ftc_face_node_init.__index__;IHEAP[_ftc_face_list_class+16]=_ftc_face_node_done.__index__;IHEAP[_ftc_cmap_cache_class+0]=_ftc_cmap_node_new.__index__;IHEAP[_ftc_cmap_cache_class+4]=_ftc_cmap_node_weight.__index__;IHEAP[_ftc_cmap_cache_class+8]=_ftc_cmap_node_compare.__index__;IHEAP[_ftc_cmap_cache_class+12]=_ftc_cmap_node_remove_faceid.__index__;IHEAP[_ftc_cmap_cache_class+16]=_ftc_cmap_node_free.__index__;IHEAP[_ftc_cmap_cache_class+24]=_ftc_cache_init.__index__;IHEAP[_ftc_cmap_cache_class+28]=
_ftc_cache_done.__index__;IHEAP[_ftc_basic_image_family_class+4]=_ftc_basic_family_compare.__index__;IHEAP[_ftc_basic_image_family_class+8]=_ftc_basic_family_init.__index__;IHEAP[_ftc_basic_image_family_class+20]=_ftc_basic_family_load_glyph.__index__;IHEAP[_ftc_basic_image_cache_class+0]=_ftc_inode_new.__index__;IHEAP[_ftc_basic_image_cache_class+4]=_ftc_inode_weight.__index__;IHEAP[_ftc_basic_image_cache_class+8]=_ftc_gnode_compare.__index__;IHEAP[_ftc_basic_image_cache_class+12]=_ftc_basic_gnode_compare_faceid.__index__;
IHEAP[_ftc_basic_image_cache_class+16]=_ftc_inode_free.__index__;IHEAP[_ftc_basic_image_cache_class+24]=_ftc_gcache_init.__index__;IHEAP[_ftc_basic_image_cache_class+28]=_ftc_gcache_done.__index__;IHEAP[_ftc_basic_image_cache_class+32]=_ftc_basic_image_family_class;IHEAP[_ftc_basic_sbit_family_class+4]=_ftc_basic_family_compare.__index__;IHEAP[_ftc_basic_sbit_family_class+8]=_ftc_basic_family_init.__index__;IHEAP[_ftc_basic_sbit_family_class+20]=_ftc_basic_family_get_count.__index__;IHEAP[_ftc_basic_sbit_family_class+
24]=_ftc_basic_family_load_bitmap.__index__;IHEAP[_ftc_basic_sbit_cache_class+0]=_ftc_snode_new.__index__;IHEAP[_ftc_basic_sbit_cache_class+4]=_ftc_snode_weight.__index__;IHEAP[_ftc_basic_sbit_cache_class+8]=_ftc_snode_compare.__index__;IHEAP[_ftc_basic_sbit_cache_class+12]=_ftc_basic_gnode_compare_faceid.__index__;IHEAP[_ftc_basic_sbit_cache_class+16]=_ftc_snode_free.__index__;IHEAP[_ftc_basic_sbit_cache_class+24]=_ftc_gcache_init.__index__;IHEAP[_ftc_basic_sbit_cache_class+28]=_ftc_gcache_done.__index__;
IHEAP[_ftc_basic_sbit_cache_class+32]=_ftc_basic_sbit_family_class;IHEAP[_ps_table_funcs+0]=_ps_table_new.__index__;IHEAP[_ps_table_funcs+4]=_ps_table_done.__index__;IHEAP[_ps_table_funcs+8]=_ps_table_add.__index__;IHEAP[_ps_table_funcs+12]=_ps_table_release.__index__;IHEAP[_ps_parser_funcs+0]=_ps_parser_init.__index__;IHEAP[_ps_parser_funcs+4]=_ps_parser_done.__index__;IHEAP[_ps_parser_funcs+8]=_ps_parser_skip_spaces.__index__;IHEAP[_ps_parser_funcs+12]=_ps_parser_skip_PS_token.__index__;IHEAP[_ps_parser_funcs+
16]=_ps_parser_to_int.__index__;IHEAP[_ps_parser_funcs+20]=_ps_parser_to_fixed.__index__;IHEAP[_ps_parser_funcs+24]=_ps_parser_to_bytes.__index__;IHEAP[_ps_parser_funcs+28]=_ps_parser_to_coord_array.__index__;IHEAP[_ps_parser_funcs+32]=_ps_parser_to_fixed_array.__index__;IHEAP[_ps_parser_funcs+36]=_ps_parser_to_token.__index__;IHEAP[_ps_parser_funcs+40]=_ps_parser_to_token_array.__index__;IHEAP[_ps_parser_funcs+44]=_ps_parser_load_field.__index__;IHEAP[_ps_parser_funcs+48]=_ps_parser_load_field_table.__index__;
IHEAP[_t1_builder_funcs+0]=_t1_builder_init.__index__;IHEAP[_t1_builder_funcs+4]=_t1_builder_done.__index__;IHEAP[_t1_builder_funcs+8]=_t1_builder_check_points.__index__;IHEAP[_t1_builder_funcs+12]=_t1_builder_add_point.__index__;IHEAP[_t1_builder_funcs+16]=_t1_builder_add_point1.__index__;IHEAP[_t1_builder_funcs+20]=_t1_builder_add_contour.__index__;IHEAP[_t1_builder_funcs+24]=_t1_builder_start_point.__index__;IHEAP[_t1_builder_funcs+28]=_t1_builder_close_contour.__index__;IHEAP[_t1_decoder_funcs+
0]=_t1_decoder_init.__index__;IHEAP[_t1_decoder_funcs+4]=_t1_decoder_done.__index__;IHEAP[_t1_decoder_funcs+8]=_t1_decoder_parse_charstrings.__index__;IHEAP[_afm_parser_funcs+0]=_afm_parser_init.__index__;IHEAP[_afm_parser_funcs+4]=_afm_parser_done.__index__;IHEAP[_afm_parser_funcs+8]=_afm_parser_parse.__index__;IHEAP[_t1_cmap_classes+0]=_t1_cmap_standard_class_rec;IHEAP[_t1_cmap_classes+4]=_t1_cmap_expert_class_rec;IHEAP[_t1_cmap_classes+8]=_t1_cmap_custom_class_rec;IHEAP[_t1_cmap_classes+12]=_t1_cmap_unicode_class_rec;
IHEAP[_t1_cmap_standard_class_rec+4]=_t1_cmap_standard_init.__index__;IHEAP[_t1_cmap_standard_class_rec+8]=_t1_cmap_std_done.__index__;IHEAP[_t1_cmap_standard_class_rec+12]=_t1_cmap_std_char_index.__index__;IHEAP[_t1_cmap_standard_class_rec+16]=_t1_cmap_std_char_next.__index__;IHEAP[_t1_cmap_expert_class_rec+4]=_t1_cmap_expert_init.__index__;IHEAP[_t1_cmap_expert_class_rec+8]=_t1_cmap_std_done.__index__;IHEAP[_t1_cmap_expert_class_rec+12]=_t1_cmap_std_char_index.__index__;IHEAP[_t1_cmap_expert_class_rec+
16]=_t1_cmap_std_char_next.__index__;IHEAP[_t1_cmap_custom_class_rec+4]=_t1_cmap_custom_init.__index__;IHEAP[_t1_cmap_custom_class_rec+8]=_t1_cmap_custom_done.__index__;IHEAP[_t1_cmap_custom_class_rec+12]=_t1_cmap_custom_char_index.__index__;IHEAP[_t1_cmap_custom_class_rec+16]=_t1_cmap_custom_char_next.__index__;IHEAP[_t1_cmap_unicode_class_rec+4]=_t1_cmap_unicode_init.__index__;IHEAP[_t1_cmap_unicode_class_rec+8]=_t1_cmap_unicode_done.__index__;IHEAP[_t1_cmap_unicode_class_rec+12]=_t1_cmap_unicode_char_index.__index__;
IHEAP[_t1_cmap_unicode_class_rec+16]=_t1_cmap_unicode_char_next.__index__;IHEAP[_psaux_interface+0]=_ps_table_funcs;IHEAP[_psaux_interface+4]=_ps_parser_funcs;IHEAP[_psaux_interface+8]=_t1_builder_funcs;IHEAP[_psaux_interface+12]=_t1_decoder_funcs;IHEAP[_psaux_interface+16]=_t1_decrypt.__index__;IHEAP[_psaux_interface+20]=_t1_cmap_classes;IHEAP[_psaux_interface+24]=_afm_parser_funcs;IHEAP[_psaux_module_class+8]=__str61;IHEAP[_psaux_module_class+20]=_psaux_interface;IHEAP[_afm_key_table+0]=__str2343;
IHEAP[_afm_key_table+4]=__str3344;IHEAP[_afm_key_table+8]=__str4345;IHEAP[_afm_key_table+12]=__str5346;IHEAP[_afm_key_table+16]=__str54;IHEAP[_afm_key_table+20]=__str53;IHEAP[_afm_key_table+24]=__str52;IHEAP[_afm_key_table+28]=__str9350;IHEAP[_afm_key_table+32]=__str10351;IHEAP[_afm_key_table+36]=__str11352;IHEAP[_afm_key_table+40]=__str12353;IHEAP[_afm_key_table+44]=__str13354;IHEAP[_afm_key_table+48]=__str14355;IHEAP[_afm_key_table+52]=__str15356;IHEAP[_afm_key_table+56]=__str16357;IHEAP[_afm_key_table+
60]=__str17358;IHEAP[_afm_key_table+64]=__str18359;IHEAP[_afm_key_table+68]=__str19360;IHEAP[_afm_key_table+72]=__str20361;IHEAP[_afm_key_table+76]=__str21362;IHEAP[_afm_key_table+80]=__str22363;IHEAP[_afm_key_table+84]=__str23364;IHEAP[_afm_key_table+88]=__str24365;IHEAP[_afm_key_table+92]=__str25366;IHEAP[_afm_key_table+96]=__str26367;IHEAP[_afm_key_table+100]=__str1559;IHEAP[_afm_key_table+104]=__str43;IHEAP[_afm_key_table+108]=__str39;IHEAP[_afm_key_table+112]=__str1458;IHEAP[_afm_key_table+116]=
__str31372;IHEAP[_afm_key_table+120]=__str32373;IHEAP[_afm_key_table+124]=__str33374;IHEAP[_afm_key_table+128]=__str34375;IHEAP[_afm_key_table+132]=__str1660;IHEAP[_afm_key_table+136]=__str36377;IHEAP[_afm_key_table+140]=__str37378;IHEAP[_afm_key_table+144]=__str38379;IHEAP[_afm_key_table+148]=__str39380;IHEAP[_afm_key_table+152]=__str40381;IHEAP[_afm_key_table+156]=__str41382;IHEAP[_afm_key_table+160]=__str42383;IHEAP[_afm_key_table+164]=__str43384;IHEAP[_afm_key_table+168]=__str1357;IHEAP[_afm_key_table+
172]=__str45386;IHEAP[_afm_key_table+176]=__str46387;IHEAP[_afm_key_table+180]=__str47388;IHEAP[_afm_key_table+184]=__str48389;IHEAP[_afm_key_table+188]=__str49390;IHEAP[_afm_key_table+192]=__str50391;IHEAP[_afm_key_table+196]=__str51392;IHEAP[_afm_key_table+200]=__str52393;IHEAP[_afm_key_table+204]=__str53394;IHEAP[_afm_key_table+208]=__str54395;IHEAP[_afm_key_table+212]=__str55396;IHEAP[_afm_key_table+216]=__str3274;IHEAP[_afm_key_table+220]=__str33;IHEAP[_afm_key_table+224]=__str58399;IHEAP[_afm_key_table+
228]=__str1862;IHEAP[_afm_key_table+232]=__str1963;IHEAP[_afm_key_table+236]=__str61402;IHEAP[_afm_key_table+240]=__str62403;IHEAP[_afm_key_table+244]=__str63404;IHEAP[_afm_key_table+248]=__str64405;IHEAP[_afm_key_table+252]=__str65406;IHEAP[_afm_key_table+256]=__str66407;IHEAP[_afm_key_table+260]=__str67408;IHEAP[_afm_key_table+264]=__str68409;IHEAP[_afm_key_table+268]=__str69410;IHEAP[_afm_key_table+272]=__str70411;IHEAP[_afm_key_table+276]=__str71412;IHEAP[_afm_key_table+280]=__str72413;IHEAP[_afm_key_table+
284]=__str740;IHEAP[_afm_key_table+288]=__str55;IHEAP[_afm_key_table+292]=__str75416;IHEAP[_pscmaps_interface+0]=_ps_unicode_value.__index__;IHEAP[_pscmaps_interface+4]=_ps_unicodes_init.__index__;IHEAP[_pscmaps_interface+8]=_ps_unicodes_char_index.__index__;IHEAP[_pscmaps_interface+12]=_ps_unicodes_char_next.__index__;IHEAP[_pscmaps_interface+16]=_ps_get_macintosh_name.__index__;IHEAP[_pscmaps_interface+20]=_ps_get_standard_strings.__index__;IHEAP[_pscmaps_interface+24]=_cff_standard_encoding;IHEAP[_pscmaps_interface+
28]=_t1_expert_encoding;IHEAP[_pscmaps_services+0]=__str60;IHEAP[_pscmaps_services+4]=_pscmaps_interface;IHEAP[_psnames_module_class+8]=__str1421;IHEAP[_psnames_module_class+20]=_pscmaps_interface;IHEAP[_psnames_module_class+32]=_psnames_get_service.__index__;_STDIO.init();var d=e.length+1,b=[Pointer_make(intArrayFromString("/bin/this.program"),null)];g();for(var a=0;a<d-1;a+=1){b.push(Pointer_make(intArrayFromString(e[a]),null));g()}b.push(0);b=Pointer_make(b,null);__globalConstructor__();if(Module._main){_main(d,
b,0);__shutdownRuntime__()}}Module.run=run;
this._STDIO.prepare("font.ttf",[0,1,0,0,0,19,1,0,0,4,0,48,70,70,84,77,77,252,131,182,0,2,21,60,0,0,0,28,71,68,69,70,2,207,0,4,0,2,4,132,0,0,0,32,71,80,79,83,50,107,108,237,0,2,4,244,0,0,16,72,71,83,85,66,147,60,130,75,0,2,4,164,0,0,0,80,79,83,47,50,248,70,135,149,0,0,1,184,0,0,0,96,99,109,97,112,9,102,162,14,0,0,12,148,0,0,7,2,99,118,116,32,95,226,95,128,0,0,30,140,0,0,2,74,102,112,103,109,115,211,35,176,0,0,19,152,0,0,7,5,103,97,115,112,0,17,0,9,0,2,4,116,0,0,0,16,103,108,121,102,84,38,251,98,0,
0,38,32,0,1,171,220,104,101,97,100,247,19,195,240,0,0,1,60,0,0,0,54,104,104,101,97,14,138,8,92,0,0,1,116,0,0,0,36,104,109,116,120,163,114,242,117,0,0,2,24,0,0,10,122,107,101,114,110,198,26,210,123,0,1,209,252,0,0,21,90,108,111,99,97,188,142,93,148,0,0,32,216,0,0,5,70,109,97,120,112,7,227,8,167,0,0,1,152,0,0,0,32,110,97,109,101,210,9,166,107,0,1,231,88,0,0,8,121,112,111,115,116,0,162,37,184,0,1,239,212,0,0,20,158,112,114,101,112,59,235,12,109,0,0,26,160,0,0,3,233,0,1,0,0,0,1,15,92,119,169,227,201,
95,15,60,245,0,31,8,0,0,0,0,0,200,108,180,224,0,0,0,0,200,108,180,224,254,135,253,147,8,127,8,68,0,1,0,8,0,2,0,0,0,0,0,0,0,1,0,0,7,62,254,78,0,67,8,235,254,135,254,135,8,127,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,155,0,1,0,0,2,162,1,82,0,84,0,130,0,5,0,2,0,16,0,47,0,90,0,0,4,122,6,161,0,3,0,1,0,3,4,230,2,188,0,5,0,8,5,154,5,51,0,0,1,27,5,154,5,51,0,0,3,209,0,102,2,18,8,5,2,11,7,4,2,2,2,2,2,4,160,0,2,175,80,0,120,251,0,0,0,0,0,0,0,0,49,65,83,67,0,32,0,33,251,2,5,211,254,81,1,51,7,62,1,178,96,0,0,159,223,
215,0,0,4,58,5,129,0,0,0,32,0,2,2,236,0,68,0,0,0,0,2,170,0,0,2,57,0,0,2,170,0,193,3,203,0,135,4,115,0,35,4,115,0,27,7,29,0,51,5,199,0,90,1,231,0,109,2,170,0,102,2,170,0,2,3,29,0,6,4,172,0,86,2,57,0,139,2,170,0,80,2,57,0,139,2,57,0,20,4,115,0,81,4,115,0,129,4,115,0,71,4,115,0,47,4,115,0,31,4,115,0,63,4,115,0,75,4,115,0,88,4,115,0,65,4,115,0,71,2,170,0,197,2,170,0,195,4,172,0,86,4,172,0,85,4,172,0,86,4,227,0,94,7,205,0,117,5,199,0,51,5,199,0,137,5,199,0,84,5,199,0,137,5,86,0,137,4,227,0,137,6,57,0,
84,5,199,0,137,2,57,0,137,4,115,0,31,5,199,0,137,4,227,0,137,6,170,0,137,5,199,0,137,6,57,0,84,5,86,0,137,6,57,0,84,5,199,0,137,5,86,0,59,4,227,0,23,5,199,0,123,5,86,0,14,7,141,0,2,5,86,0,18,5,86,0,35,4,227,0,61,2,170,0,115,2,57,0,21,2,170,0,25,4,172,0,45,4,115,255,236,2,170,0,66,4,115,0,60,4,227,0,135,4,115,0,80,4,227,0,84,4,115,0,80,2,170,0,35,4,227,0,84,4,227,0,143,2,57,0,143,2,57,255,224,4,115,0,143,2,57,0,143,7,29,0,135,4,227,0,135,4,227,0,80,4,227,0,135,4,227,0,84,3,29,0,135,4,115,0,72,2,170,
0,25,4,227,0,127,4,115,0,8,6,57,255,250,4,115,0,14,4,115,0,16,4,0,0,68,3,29,0,33,2,61,0,156,3,29,0,43,4,172,0,81,2,170,0,194,4,115,0,51,4,115,0,21,4,115,0,57,4,115,0,8,2,61,0,156,4,115,0,53,2,170,0,16,5,229,0,32,2,246,0,45,4,115,0,92,4,172,0,84,5,229,0,32,4,107,255,239,3,51,0,90,4,100,0,49,2,170,0,51,2,170,0,44,2,170,0,87,4,156,0,134,4,115,0,71,2,57,0,141,2,170,0,96,2,170,0,82,2,236,0,45,4,115,0,93,6,172,0,94,6,172,0,94,6,172,0,103,4,227,0,114,5,199,0,51,5,199,0,51,5,199,0,51,5,199,0,51,5,199,0,51,
5,199,0,51,8,0,0,4,5,199,0,84,5,86,0,137,5,86,0,137,5,86,0,137,5,86,0,137,2,57,255,216,2,57,0,104,2,57,255,171,2,57,255,215,5,199,0,8,5,199,0,137,6,57,0,84,6,57,0,84,6,57,0,84,6,57,0,84,6,57,0,84,4,172,0,86,6,57,0,84,5,199,0,123,5,199,0,123,5,199,0,123,5,199,0,123,5,86,0,35,5,86,0,137,4,227,0,143,4,115,0,52,4,115,0,52,4,115,0,52,4,115,0,52,4,115,0,52,4,115,0,52,7,29,0,66,4,115,0,80,4,115,0,80,4,115,0,80,4,115,0,80,4,115,0,80,2,57,255,192,2,57,0,114,2,57,255,173,2,57,255,216,4,227,0,80,4,227,0,135,
4,227,0,80,4,227,0,80,4,227,0,80,4,227,0,80,4,227,0,80,4,100,0,49,4,227,0,1,4,227,0,127,4,227,0,127,4,227,0,127,4,227,0,127,4,115,0,16,4,227,0,143,4,115,0,16,5,199,0,51,4,115,0,60,5,199,0,51,4,115,0,60,5,199,0,51,4,115,0,60,5,199,0,84,4,115,0,80,5,199,0,84,4,115,0,80,5,199,0,84,4,115,0,80,5,199,0,84,4,115,0,80,5,199,0,137,5,192,0,84,5,199,0,8,4,227,0,84,5,86,0,137,4,115,0,80,5,86,0,137,4,115,0,80,5,86,0,137,4,115,0,80,5,86,0,137,4,115,0,80,5,86,0,137,4,115,0,80,6,57,0,84,4,227,0,84,6,57,0,84,4,227,
0,84,6,57,0,84,4,227,0,84,6,57,0,84,4,227,0,84,5,199,0,137,4,227,0,143,5,199,0,14,4,227,0,10,2,57,255,153,2,57,255,153,2,57,255,236,2,57,255,236,2,57,255,188,2,57,255,189,2,57,0,88,2,57,0,69,2,57,0,137,2,57,0,145,6,71,0,137,4,115,0,143,4,115,0,31,2,57,255,166,5,199,0,137,4,115,0,143,4,115,0,143,4,227,0,137,2,57,0,106,4,227,0,137,2,57,0,143,4,227,0,137,3,21,0,143,4,227,0,137,3,213,0,143,4,227,0,0,2,57,0,18,5,199,0,137,4,227,0,135,5,199,0,137,4,227,0,135,5,199,0,137,4,227,0,135,5,171,255,234,5,201,
0,133,4,227,0,135,6,57,0,84,4,227,0,80,6,57,0,84,4,227,0,80,6,57,0,84,4,227,0,80,8,0,0,84,7,141,0,80,5,199,0,137,3,29,0,135,5,199,0,137,3,29,0,135,5,199,0,137,3,29,0,56,5,86,0,59,4,115,0,72,5,86,0,59,4,115,0,72,5,86,0,59,4,115,0,72,5,86,0,59,4,115,0,72,4,227,0,23,2,170,0,25,4,227,0,23,3,213,0,25,4,227,0,23,2,170,0,25,5,199,0,123,4,227,0,127,5,199,0,123,4,227,0,127,5,199,0,123,4,227,0,127,5,199,0,123,4,227,0,127,5,199,0,123,4,227,0,127,5,199,0,123,4,227,0,127,7,141,0,2,6,57,255,250,5,86,0,35,4,115,
0,16,5,86,0,35,4,227,0,61,4,0,0,68,4,227,0,61,4,0,0,68,4,227,0,61,4,0,0,68,2,57,0,142,4,115,0,168,5,199,0,51,4,115,0,60,8,0,0,4,7,29,0,66,6,57,0,84,4,227,0,1,5,86,0,59,4,115,0,72,4,227,0,23,2,170,0,25,2,170,0,0,2,170,0,0,2,170,0,36,2,170,255,199,2,170,0,200,2,170,0,39,2,170,0,76,2,170,255,242,2,170,255,164,2,170,0,185,3,184,0,110,5,199,0,36,2,170,0,197,6,211,0,46,7,63,0,36,3,202,0,36,6,153,255,230,7,107,0,128,6,180,255,208,2,57,255,169,5,199,0,51,5,199,0,137,4,207,0,137,5,192,0,83,5,86,0,137,4,227,
0,61,5,199,0,137,6,57,0,84,2,57,0,137,5,199,0,137,5,86,0,14,6,170,0,137,5,199,0,137,5,38,0,84,6,57,0,84,5,199,0,137,5,86,0,137,4,205,0,90,4,227,0,23,5,86,0,35,6,145,0,63,5,86,0,18,6,121,0,96,6,106,0,83,2,57,255,215,5,86,0,35,4,235,0,80,3,156,0,77,4,227,0,107,2,57,0,137,4,168,0,127,4,235,0,80,4,226,0,142,4,115,0,8,4,218,0,86,3,204,0,77,3,175,0,66,4,227,0,107,4,83,0,90,2,57,0,137,4,118,0,143,4,115,0,9,4,229,0,144,4,115,0,0,3,144,0,66,4,227,0,80,6,32,0,42,4,243,0,121,4,41,0,79,5,121,0,80,3,146,0,18,
4,168,0,127,5,185,0,80,4,155,0,13,6,7,0,129,6,194,0,81,2,57,255,217,4,168,0,127,4,227,0,80,4,168,0,127,6,194,0,81,5,90,0,137,7,21,0,23,4,137,0,137,5,177,0,84,5,86,0,59,2,57,0,137,2,53,255,213,4,115,0,31,8,192,0,8,8,128,0,137,7,0,0,23,4,226,0,137,4,250,255,249,5,192,0,137,5,199,0,51,5,192,0,137,5,199,0,137,4,137,0,137,5,179,0,18,5,86,0,137,7,59,255,250,5,3,0,46,5,192,0,136,5,192,0,136,4,226,0,137,5,157,0,8,6,170,0,137,5,199,0,137,6,57,0,84,5,192,0,137,5,86,0,137,5,199,0,84,4,227,0,23,4,250,0,1,6,212,
0,71,5,86,0,18,5,216,0,137,5,159,0,110,8,10,0,137,8,39,0,137,6,245,0,22,7,213,0,137,5,192,0,137,5,177,0,54,8,64,0,137,5,192,0,35,4,115,0,60,4,241,0,94,4,235,0,143,3,85,0,143,5,20,0,14,4,115,0,80,5,172,255,239,3,250,0,53,4,235,0,142,4,235,0,142,4,1,0,142,5,21,0,21,5,235,0,143,4,213,0,143,4,227,0,80,4,213,0,143,4,227,0,135,4,115,0,80,3,235,0,58,4,115,0,16,7,0,0,82,4,115,0,14,4,235,0,143,4,165,0,83,6,171,0,143,6,192,0,143,5,213,0,38,6,213,0,143,4,235,0,143,4,107,0,52,6,213,0,143,4,171,255,255,4,115,
0,80,4,227,0,10,3,85,0,143,4,107,0,80,4,115,0,72,2,57,0,143,2,64,255,218,2,57,255,224,7,192,0,21,7,64,0,143,4,227,0,10,4,1,0,142,4,115,0,16,4,213,0,143,3,229,0,137,3,147,0,143,7,141,0,2,6,57,255,250,7,141,0,2,6,57,255,250,7,141,0,2,6,57,255,250,5,86,0,35,4,115,0,16,2,170,0,80,2,170,0,80,4,115,0,62,8,0,0,0,8,0,0,0,4,107,255,236,2,57,0,139,2,57,0,139,2,57,0,138,2,57,0,139,4,0,0,151,4,0,0,151,4,0,0,151,4,115,0,138,4,115,0,136,2,205,0,65,8,0,0,225,8,0,0,41,1,235,0,85,3,213,0,85,2,170,0,92,2,170,0,93,
4,213,0,193,2,170,255,126,1,86,254,135,3,43,0,108,4,115,0,7,4,115,0,21,8,192,0,158,4,115,0,10,7,21,0,54,3,233,0,41,8,235,0,137,8,0,0,125,6,37,0,85,4,205,0,88,6,172,0,114,6,172,0,84,6,172,0,103,6,172,0,163,8,0,1,162,4,0,1,16,8,0,1,162,4,0,1,16,8,0,1,162,4,0,1,16,4,0,1,16,3,244,0,53,4,229,0,43,6,150,0,204,5,180,0,134,4,172,0,85,4,100,0,2,5,180,0,72,7,213,1,152,5,199,1,25,2,49,255,127,4,100,0,43,4,100,0,29,4,171,0,100,4,100,0,49,4,100,0,49,4,213,0,157,4,172,0,100,4,213,2,34,4,213,1,5,5,171,255,246,5,
0,1,216,5,171,2,141,5,171,255,246,5,171,2,141,5,171,255,246,5,171,2,141,5,171,255,246,5,171,255,246,5,171,255,246,5,171,255,246,5,171,255,246,5,171,1,217,5,171,2,141,5,171,1,217,5,171,1,217,5,171,255,246,5,171,255,246,5,171,255,246,5,171,2,141,5,171,1,217,5,171,1,217,5,171,255,246,5,171,255,246,5,171,255,246,5,171,2,141,5,171,1,217,5,171,1,217,5,171,255,246,5,171,255,246,5,171,255,246,5,171,255,246,5,171,255,246,5,171,255,246,5,171,255,246,5,171,255,246,5,171,255,246,5,171,255,246,5,171,255,246,5,
171,255,246,5,171,0,0,5,171,0,0,5,171,0,0,5,171,0,0,5,171,2,213,5,171,0,103,5,171,0,0,5,213,0,0,4,213,0,123,4,213,0,6,2,214,0,109,2,214,0,109,8,0,0,0,7,235,1,158,7,235,1,145,7,235,1,158,7,235,1,145,3,244,0,3,4,213,0,167,4,213,0,178,4,213,0,41,4,213,0,41,2,214,0,115,8,43,1,177,8,107,1,209,7,85,1,70,6,0,1,218,6,0,1,81,4,64,0,59,5,64,0,60,4,192,0,102,4,21,0,66,4,0,0,196,6,0,1,16,4,227,0,35,4,227,0,35,2,170,0,140,2,170,0,141,2,170,0,103,2,170,0,35,2,170,0,53,2,170,0,43,2,170,0,45,2,170,255,189,1,199,
0,113,1,199,0,103,2,170,0,87,0,87,255,229,255,229,0,15,255,207,255,174,255,251,0,0,0,0,0,3,0,0,0,3,0,0,0,28,0,1,0,0,0,0,4,248,0,3,0,1,0,0,0,28,0,4,4,220,0,0,0,194,0,128,0,6,0,66,0,126,1,127,1,146,1,255,2,27,2,199,2,201,2,221,3,126,3,138,3,140,3,161,3,206,4,12,4,79,4,92,4,95,4,145,30,133,30,243,32,17,32,21,32,30,32,34,32,38,32,48,32,51,32,58,32,60,32,62,32,68,32,127,32,164,32,167,32,172,33,5,33,19,33,22,33,34,33,38,33,46,33,94,33,149,33,168,34,2,34,6,34,15,34,18,34,21,34,26,34,31,34,41,34,43,34,72,
34,97,34,101,35,2,35,16,35,33,37,0,37,2,37,12,37,16,37,20,37,24,37,28,37,36,37,44,37,52,37,60,37,108,37,128,37,132,37,136,37,140,37,147,37,161,37,172,37,178,37,186,37,188,37,196,37,203,37,207,37,217,37,230,38,60,38,64,38,66,38,96,38,99,38,102,38,107,240,2,240,5,251,2,255,255,0,0,0,32,0,160,1,146,1,250,2,24,2,198,2,201,2,216,3,126,3,132,3,140,3,142,3,163,4,1,4,14,4,81,4,94,4,144,30,128,30,242,32,16,32,19,32,23,32,32,32,38,32,48,32,50,32,57,32,60,32,62,32,68,32,127,32,163,32,167,32,172,33,5,33,19,33,
22,33,34,33,38,33,46,33,91,33,144,33,168,34,2,34,6,34,15,34,17,34,21,34,25,34,30,34,41,34,43,34,72,34,96,34,100,35,2,35,16,35,32,37,0,37,2,37,12,37,16,37,20,37,24,37,28,37,36,37,44,37,52,37,60,37,80,37,128,37,132,37,136,37,140,37,144,37,160,37,170,37,178,37,186,37,188,37,196,37,202,37,207,37,216,37,230,38,58,38,64,38,66,38,96,38,99,38,101,38,106,240,1,240,5,251,1,255,255,255,227,0,0,255,174,255,71,255,47,254,133,254,132,254,118,252,160,253,208,253,207,253,206,253,205,253,155,253,154,253,153,253,152,
253,104,227,122,227,14,225,242,225,241,225,240,225,239,225,236,225,227,225,226,225,221,225,220,225,219,225,214,225,156,225,121,225,119,225,115,225,27,225,14,225,12,225,1,224,254,224,247,224,203,224,154,224,136,224,47,224,44,224,36,224,35,224,5,0,0,224,25,224,16,224,15,223,243,223,220,223,218,223,62,223,49,223,34,221,68,221,67,221,58,221,55,221,52,221,49,221,46,221,39,221,32,221,25,221,18,220,255,220,236,220,233,220,230,220,227,220,224,220,212,220,204,220,199,220,192,220,191,220,184,220,179,220,176,
220,168,220,156,220,73,220,70,220,69,220,40,220,38,220,37,220,34,18,141,18,139,7,141,0,1,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,98,0,99,0,100,0,
101,0,102,0,103,0,104,0,105,0,106,0,107,0,108,0,109,0,16,0,110,0,111,0,112,0,113,0,114,0,115,0,116,0,117,0,118,0,119,0,120,0,121,0,122,0,123,0,124,0,125,0,126,0,127,0,128,0,129,0,130,0,131,0,132,0,133,0,134,0,135,0,136,0,137,0,138,0,139,0,140,0,141,0,142,0,143,0,144,0,145,0,146,0,147,0,148,0,149,0,150,0,151,0,152,0,153,0,154,0,155,0,156,0,157,0,158,0,159,0,160,0,161,0,162,0,163,0,164,0,165,0,166,0,167,0,168,0,169,0,170,0,171,0,172,0,173,0,174,0,175,0,176,0,177,0,178,0,179,0,180,0,181,0,182,0,183,
0,184,0,185,0,186,0,187,0,188,0,189,0,190,0,191,0,192,0,193,0,194,0,195,0,196,0,197,0,198,0,199,0,200,0,201,0,202,0,203,0,204,0,205,0,206,0,207,0,208,0,209,0,210,0,211,0,212,0,213,0,214,0,215,0,216,0,217,0,218,0,219,0,220,0,221,0,222,0,223,0,224,0,225,0,226,0,227,0,228,0,229,0,230,0,231,0,232,0,233,0,234,0,235,0,236,0,237,0,238,0,239,0,240,0,241,0,242,0,243,0,244,0,245,0,246,0,247,0,248,0,249,0,250,0,251,0,252,0,253,0,254,0,255,1,0,1,1,1,2,1,3,1,4,1,5,1,6,1,7,1,8,1,9,1,10,1,11,1,12,1,13,1,14,1,15,
1,16,1,17,1,18,1,19,1,20,1,21,1,22,1,23,1,24,1,25,1,26,1,27,1,28,1,29,1,30,1,31,1,32,1,33,1,34,1,35,1,36,1,37,1,38,1,39,1,40,1,41,1,42,1,43,1,44,1,45,1,46,1,47,1,48,1,49,1,50,1,51,1,52,1,53,1,54,1,55,1,56,1,57,1,58,1,59,1,60,1,61,1,62,1,63,0,119,2,54,0,6,2,10,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,3,0,4,0,5,0,6,0,7,0,8,0,9,0,10,0,11,0,12,0,13,0,14,0,15,0,16,0,17,0,18,0,19,0,20,0,21,0,22,0,23,0,24,
0,25,0,26,0,27,0,28,0,29,0,30,0,31,0,32,0,33,0,34,0,35,0,36,0,37,0,38,0,39,0,40,0,41,0,42,0,43,0,44,0,45,0,46,0,47,0,48,0,49,0,50,0,51,0,52,0,53,0,54,0,55,0,56,0,57,0,58,0,59,0,60,0,61,0,62,0,63,0,64,0,65,0,66,0,67,0,68,0,69,0,70,0,71,0,72,0,73,0,74,0,75,0,76,0,77,0,78,0,79,0,80,0,81,0,82,0,83,0,84,0,85,0,86,0,87,0,88,0,89,0,90,0,91,0,92,0,93,0,94,0,95,0,96,0,97,0,0,0,132,0,133,0,135,0,137,0,145,0,150,0,156,0,161,0,160,0,162,0,164,0,163,0,165,0,167,0,169,0,168,0,170,0,171,0,173,0,172,0,174,0,175,
0,177,0,179,0,178,0,180,0,182,0,181,0,186,0,185,0,187,0,188,2,15,0,112,0,99,0,100,0,104,2,17,0,118,0,159,0,110,0,106,2,35,0,116,0,105,2,60,0,134,0,152,2,55,0,113,2,62,2,63,0,102,0,117,2,49,2,52,2,51,1,141,2,58,0,107,0,122,1,118,0,166,0,184,0,127,0,98,0,109,2,54,1,64,2,59,2,50,0,108,0,123,2,18,0,3,0,128,0,131,0,149,1,18,1,19,2,4,2,5,2,12,2,13,2,8,2,9,0,183,2,125,0,191,1,56,2,26,2,31,2,22,2,23,2,142,2,143,2,16,0,119,2,10,2,14,2,19,0,130,0,138,0,129,0,139,0,136,0,141,0,142,0,143,0,140,0,147,0,148,0,
0,0,146,0,154,0,155,0,153,0,241,1,75,1,82,0,111,1,78,1,79,1,80,0,120,1,83,1,81,1,76,0,0,64,69,89,88,85,84,83,82,81,80,79,78,77,76,75,74,73,72,71,70,69,68,67,66,65,64,63,62,61,60,59,58,57,56,55,54,53,49,48,47,46,45,44,40,39,38,37,36,35,34,33,31,24,20,17,16,15,14,13,11,10,9,8,7,6,5,4,3,2,1,0,44,69,35,70,96,32,176,38,96,176,4,38,35,72,72,45,44,69,35,70,35,97,32,176,38,97,176,4,38,35,72,72,45,44,69,35,70,96,176,32,97,32,176,70,96,176,4,38,35,72,72,45,44,69,35,70,35,97,176,32,96,32,176,38,97,176,32,97,
176,4,38,35,72,72,45,44,69,35,70,96,176,64,97,32,176,102,96,176,4,38,35,72,72,45,44,69,35,70,35,97,176,64,96,32,176,38,97,176,64,97,176,4,38,35,72,72,45,44,1,16,32,60,0,60,45,44,32,69,35,32,176,205,68,35,32,184,1,90,81,88,35,32,176,141,68,35,89,32,176,237,81,88,35,32,176,77,68,35,89,32,176,4,38,81,88,35,32,176,13,68,35,89,33,33,45,44,32,32,69,24,104,68,32,176,1,96,32,69,176,70,118,104,138,69,96,68,45,44,1,177,11,10,67,35,67,101,10,45,44,0,177,10,11,67,35,67,11,45,44,0,176,40,35,112,177,1,40,62,1,
176,40,35,112,177,2,40,69,58,177,2,0,8,13,45,44,32,69,176,3,37,69,97,100,176,80,81,88,69,68,27,33,33,89,45,44,73,176,14,35,68,45,44,32,69,176,0,67,96,68,45,44,1,176,6,67,176,7,67,101,10,45,44,32,105,176,64,97,176,0,139,32,177,44,192,138,140,184,16,0,98,96,43,12,100,35,100,97,92,88,176,3,97,89,45,44,138,3,69,138,138,135,176,17,43,176,41,35,68,176,41,122,228,24,45,44,69,101,176,44,35,68,69,176,43,35,68,45,44,75,82,88,69,68,27,33,33,89,45,44,75,81,88,69,68,27,33,33,89,45,44,1,176,5,37,16,35,32,138,245,
0,176,1,96,35,237,236,45,44,1,176,5,37,16,35,32,138,245,0,176,1,97,35,237,236,45,44,1,176,6,37,16,245,0,237,236,45,44,70,35,70,96,138,138,70,35,32,70,138,96,138,97,184,255,128,98,35,32,16,35,138,177,12,12,138,112,69,96,32,176,0,80,88,176,1,97,184,255,186,139,27,176,70,140,89,176,16,96,104,1,58,45,44,32,69,176,3,37,70,82,75,176,19,81,91,88,176,2,37,70,32,104,97,176,3,37,176,3,37,63,35,33,56,27,33,17,89,45,44,32,69,176,3,37,70,80,88,176,2,37,70,32,104,97,176,3,37,176,3,37,63,35,33,56,27,33,17,89,45,
44,0,176,7,67,176,6,67,11,45,44,33,33,12,100,35,100,139,184,64,0,98,45,44,33,176,128,81,88,12,100,35,100,139,184,32,0,98,27,178,0,64,47,43,89,176,2,96,45,44,33,176,192,81,88,12,100,35,100,139,184,21,85,98,27,178,0,128,47,43,89,176,2,96,45,44,12,100,35,100,139,184,64,0,98,96,35,33,45,44,75,83,88,138,176,4,37,73,100,35,69,105,176,64,139,97,176,128,98,176,32,97,106,176,14,35,68,35,16,176,14,246,27,33,35,138,18,17,32,57,47,89,45,44,75,83,88,32,176,3,37,73,100,105,32,176,5,38,176,6,37,73,100,35,97,176,
128,98,176,32,97,106,176,14,35,68,176,4,38,16,176,14,246,138,16,176,14,35,68,176,14,246,176,14,35,68,176,14,237,27,138,176,4,38,17,18,32,57,35,32,57,47,47,89,45,44,69,35,69,96,35,69,96,35,69,96,35,118,104,24,176,128,98,32,45,44,176,72,43,45,44,32,69,176,0,84,88,176,64,68,32,69,176,64,97,68,27,33,33,89,45,44,69,177,48,47,69,35,69,97,96,176,1,96,105,68,45,44,75,81,88,176,47,35,112,176,20,35,66,27,33,33,89,45,44,75,81,88,32,176,3,37,69,105,83,88,68,27,33,33,89,27,33,33,89,45,44,69,176,20,67,176,0,96,
99,176,1,96,105,68,45,44,176,47,69,68,45,44,69,35,32,69,138,96,68,45,44,69,35,69,96,68,45,44,75,35,81,88,185,0,51,255,224,177,52,32,27,179,51,0,52,0,89,68,68,45,44,176,22,67,88,176,3,38,69,138,88,100,102,176,31,96,27,100,176,32,96,102,32,88,27,33,176,64,89,176,1,97,89,35,88,101,89,176,41,35,68,35,16,176,41,224,27,33,33,33,33,33,89,45,44,176,2,67,84,88,75,83,35,75,81,90,88,56,27,33,33,89,27,33,33,33,33,89,45,44,176,22,67,88,176,4,37,69,100,176,32,96,102,32,88,27,33,176,64,89,176,1,97,35,88,27,101,
89,176,41,35,68,176,5,37,176,8,37,8,32,88,2,27,3,89,176,4,37,16,176,5,37,32,70,176,4,37,35,66,60,176,4,37,176,7,37,8,176,7,37,16,176,6,37,32,70,176,4,37,176,1,96,35,66,60,32,88,1,27,0,89,176,4,37,16,176,5,37,176,41,224,176,41,32,69,101,68,176,7,37,16,176,6,37,176,41,224,176,5,37,176,8,37,8,32,88,2,27,3,89,176,5,37,176,3,37,67,72,176,4,37,176,7,37,8,176,6,37,176,3,37,176,1,96,67,72,27,33,89,33,33,33,33,33,33,33,45,44,2,176,4,37,32,32,70,176,4,37,35,66,176,5,37,8,176,3,37,69,72,33,33,33,33,45,44,2,
176,3,37,32,176,4,37,8,176,2,37,67,72,33,33,33,45,44,69,35,32,69,24,32,176,0,80,32,88,35,101,35,89,35,104,32,176,64,80,88,33,176,64,89,35,88,101,89,138,96,68,45,44,75,83,35,75,81,90,88,32,69,138,96,68,27,33,33,89,45,44,75,84,88,32,69,138,96,68,27,33,33,89,45,44,75,83,35,75,81,90,88,56,27,33,33,89,45,44,176,0,33,75,84,88,56,27,33,33,89,45,44,176,2,67,84,88,176,70,43,27,33,33,33,33,89,45,44,176,2,67,84,88,176,71,43,27,33,33,33,89,45,44,176,2,67,84,88,176,72,43,27,33,33,33,33,89,45,44,176,2,67,84,88,
176,73,43,27,33,33,33,89,45,44,32,138,8,35,75,83,138,75,81,90,88,35,56,27,33,33,89,45,44,0,176,2,37,73,176,0,83,88,32,176,64,56,17,27,33,89,45,44,1,70,35,70,96,35,70,97,35,32,16,32,70,138,97,184,255,128,98,138,177,64,64,138,112,69,96,104,58,45,44,32,138,35,73,100,138,35,83,88,60,27,33,89,45,44,75,82,88,125,27,122,89,45,44,176,18,0,75,1,75,84,66,45,44,177,2,0,66,177,35,1,136,81,177,64,1,136,83,90,88,185,16,0,0,32,136,84,88,178,2,1,2,67,96,66,89,177,36,1,136,81,88,185,32,0,0,64,136,84,88,178,2,2,2,
67,96,66,177,36,1,136,84,88,178,2,32,2,67,96,66,0,75,1,75,82,88,178,2,8,2,67,96,66,89,27,185,64,0,0,128,136,84,88,178,2,4,2,67,96,66,89,185,64,0,0,128,99,184,1,0,136,84,88,178,2,8,2,67,96,66,89,185,64,0,1,0,99,184,2,0,136,84,88,178,2,16,2,67,96,66,89,185,64,0,2,0,99,184,4,0,136,84,88,178,2,64,2,67,96,66,89,89,89,89,89,45,44,69,24,104,35,75,81,88,35,32,69,32,100,176,64,80,88,124,89,104,138,96,89,68,45,44,176,0,22,176,2,37,176,2,37,1,176,1,35,62,0,176,2,35,62,177,1,2,6,12,176,10,35,101,66,176,11,35,
66,1,176,1,35,63,0,176,2,35,63,177,1,2,6,12,176,6,35,101,66,176,7,35,66,176,1,22,1,45,44,122,138,16,69,35,245,24,45,0,0,0,191,0,80,1,7,0,1,0,47,1,7,0,1,0,175,1,4,64,71,1,208,253,1,191,253,1,16,253,1,111,251,1,64,251,1,128,245,144,245,160,245,3,241,240,53,31,47,240,159,240,2,95,239,1,47,239,95,239,111,239,159,239,223,239,5,230,228,32,31,229,228,61,31,226,224,39,31,225,224,61,31,223,61,221,85,222,61,3,85,221,184,1,30,178,60,31,47,65,11,1,30,0,1,0,16,1,30,0,32,1,30,0,64,1,30,0,3,255,192,1,30,64,40,25,
28,70,220,3,255,31,0,219,1,218,4,60,31,212,210,28,31,211,210,38,31,96,209,144,209,192,209,3,96,209,144,209,176,209,192,209,224,209,5,184,255,192,179,209,25,29,70,184,255,192,180,209,10,13,70,15,184,1,22,64,15,1,191,190,38,31,64,187,41,65,70,64,187,34,39,70,184,1,33,64,35,182,61,31,0,184,1,184,183,10,31,0,183,1,0,183,32,183,64,183,96,183,112,183,5,64,183,96,183,144,183,208,183,240,183,5,184,1,32,64,13,72,61,31,0,181,96,181,2,160,181,208,181,2,184,255,192,64,14,181,11,14,70,15,178,95,178,2,177,3,60,
31,47,65,11,1,25,0,63,1,25,0,79,1,25,0,3,0,143,1,25,0,1,0,64,1,25,64,40,38,41,70,31,175,47,175,63,175,159,175,4,15,175,1,64,175,14,22,70,0,173,112,173,128,173,3,224,173,240,173,2,171,170,53,31,170,80,38,31,185,1,27,1,26,178,60,31,0,184,1,26,182,1,15,169,1,15,168,1,188,1,23,1,19,0,60,0,31,1,21,64,135,80,60,31,158,155,39,31,157,155,39,31,156,155,39,31,128,155,1,152,70,40,31,159,151,175,151,2,150,70,53,31,15,148,31,148,2,147,144,38,31,146,145,38,31,143,140,11,31,142,140,38,31,15,141,31,141,2,95,141,
111,141,127,141,255,141,4,64,141,19,23,70,15,140,1,64,140,11,15,70,15,137,31,137,2,134,133,15,31,95,133,1,54,130,70,130,2,118,80,38,31,117,80,38,31,116,80,38,31,115,80,38,31,41,112,1,27,112,1,3,112,1,244,112,1,214,112,230,112,2,104,112,1,89,112,1,184,255,240,64,116,112,10,13,70,111,110,72,31,110,70,50,31,26,1,24,85,25,51,24,85,7,51,3,85,6,3,255,31,97,80,38,31,96,95,50,31,95,80,38,31,94,90,72,31,92,70,39,31,91,90,120,31,90,70,49,31,19,50,18,85,5,1,3,85,4,50,3,85,111,3,1,15,3,63,3,2,95,83,1,64,83,40,
44,70,64,83,30,34,70,64,83,19,24,70,82,81,40,31,81,79,28,31,80,79,28,31,25,79,41,79,2,89,79,105,79,2,184,1,18,64,41,70,37,31,73,70,25,31,72,70,33,31,71,70,53,31,248,70,1,152,70,1,22,50,21,85,17,1,15,85,16,50,15,85,2,1,0,85,1,0,255,31,184,1,17,178,27,9,31,184,1,16,64,61,27,9,31,16,27,64,27,2,16,27,32,27,48,27,112,27,4,31,15,63,15,95,15,127,15,4,15,15,47,15,79,15,111,15,143,15,223,15,255,15,7,63,15,95,15,127,15,239,15,4,111,0,1,95,0,1,128,22,1,5,1,184,1,144,177,84,83,43,43,75,184,7,255,82,75,176,7,
80,91,176,1,136,176,37,83,176,1,136,176,64,81,90,176,6,136,176,0,85,90,91,88,177,1,1,142,89,133,141,141,0,66,29,75,176,50,83,88,176,96,29,89,75,176,100,83,88,176,64,29,89,75,176,128,83,88,176,16,29,177,22,0,66,89,115,116,115,116,117,115,116,43,43,43,43,43,43,43,1,115,116,43,43,43,43,0,115,116,43,43,43,43,43,43,115,115,117,43,43,43,1,43,43,43,0,43,43,43,43,43,43,43,43,1,43,43,43,115,115,115,115,116,116,116,0,43,43,43,43,1,115,115,43,115,0,43,115,43,116,117,43,43,43,43,115,1,43,115,43,0,115,43,43,43,
43,43,115,115,115,43,1,43,43,0,115,116,43,115,116,43,115,116,43,115,1,43,115,116,43,0,115,116,117,43,116,43,43,43,1,43,0,115,43,43,115,116,1,43,43,0,43,115,43,43,115,117,43,43,43,1,43,43,0,43,43,115,116,1,115,43,0,115,115,115,115,115,115,1,115,115,115,24,0,0,0,5,204,5,204,0,125,5,129,0,21,0,121,5,129,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,58,0,20,0,119,0,0,255,236,0,0,0,0,255,236,0,0,0,0,255,236,0,0,254,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,1,25,1,37,0,245,0,235,0,0,0,0,0,0,0,0,0,0,0,193,0,211,0,186,0,176,0,207,0,0,0,0,0,0,0,0,0,0,0,0,1,39,1,41,1,6,0,0,1,18,0,228,0,244,0,198,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,25,1,31,1,76,0,0,0,0,0,223,0,209,0,197,0,181,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,0,169,1,253,0,216,1,25,0,128,0,183,1,253,0,0,0,0,1,63,0,219,1,93,1,37,0,170,0,128,0,117,0,141,1,252,1,121,1,33,0,160,1,16,0,0,0,0,1,49,1,25,1,14,1,4,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,61,1,255,0,224,1,6,0,148,0,224,0,148,1,68,0,224,5,115,3,25,0,0,0,216,2,197,0,156,3,129,2,205,0,203,0,244,0,78,2,141,0,0,0,255,0,215,0,204,1,48,1,69,0,115,0,180,0,166,0,0,0,0,0,115,0,128,0,141,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,162,0,152,0,131,0,141,0,0,0,0,0,0,0,0,5,174,254,188,5,129,2,182,0,17,255,246,0,182,0,188,0,198,0,0,0,127,0,138,0,96,0,0,0,0,0,0,0,0,0,240,1,238,1,144,0,0,2,25,1,8,1,21,0,0,0,0,0,0,0,190,0,0,0,0,0,0,0,0,7,72,3,106,2,182,2,2,253,147,0,0,0,145,
0,103,0,145,0,97,1,217,0,0,2,141,3,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,170,254,111,254,104,1,5,0,147,0,152,0,226,1,81,0,143,0,190,0,174,254,185,254,164,0,94,0,175,2,213,0,85,0,242,0,166,0,68,5,17,1,169,0,0,0,0,0,44,0,44,0,44,0,44,1,70,1,120,2,42,3,50,5,148,6,112,6,154,6,214,7,26,7,94,7,160,7,204,7,224,7,252,8,36,8,118,8,182,9,4,9,146,9,250,10,122,10,250,11,48,11,212,12,90,13,48,14,26,14,98,14,154,14,226,15,64,16,72,17,228,18,88,18,202,19,36,19,100,19,154,20,24,20,88,20,154,20,218,21,74,21,106,22,230,
23,68,23,192,24,20,24,168,25,18,25,160,26,204,27,28,27,146,29,56,29,160,30,140,30,220,31,4,31,42,31,82,31,138,31,160,31,202,32,110,32,226,33,48,33,160,34,4,34,90,34,230,35,74,35,134,36,6,36,106,36,154,37,64,37,166,37,238,38,108,38,218,39,54,39,214,40,38,40,126,40,162,40,248,41,116,41,172,41,234,42,86,42,124,42,232,43,60,44,12,44,104,44,250,45,118,46,28,46,80,47,54,47,122,48,52,48,214,49,54,49,100,50,20,50,42,50,140,50,230,51,62,51,192,51,230,52,70,52,144,52,170,53,56,53,120,53,220,54,58,54,88,54,
110,54,140,54,244,55,12,55,36,55,60,55,84,55,110,55,134,55,254,56,18,56,42,56,66,56,90,56,116,56,140,56,162,56,186,56,210,57,68,57,92,57,116,57,140,57,164,57,188,57,214,58,54,58,254,59,22,59,46,59,70,59,96,59,120,59,200,60,96,60,120,60,144,60,168,60,192,60,218,60,244,61,198,61,218,61,242,62,10,62,34,62,60,62,84,62,106,62,128,62,152,63,60,63,84,63,108,63,132,63,156,63,180,63,206,64,16,64,156,64,168,64,180,64,192,64,204,64,216,65,74,65,86,65,110,65,134,65,158,65,182,65,202,65,224,65,248,66,16,66,40,
66,64,66,88,66,108,66,132,66,156,66,180,66,202,66,210,67,102,67,126,67,150,67,174,67,198,67,222,67,242,68,8,68,34,68,58,68,82,68,106,68,130,68,154,68,178,68,202,68,222,68,242,69,12,69,36,69,60,69,152,70,24,70,46,70,68,70,92,70,114,70,136,70,158,70,178,70,198,70,222,71,10,71,36,71,70,71,94,72,34,72,58,72,78,72,172,72,196,72,218,72,238,73,0,73,22,73,44,73,64,73,88,73,150,73,236,74,4,74,28,74,48,74,68,74,92,74,116,74,164,75,30,75,156,75,180,75,204,75,228,75,252,76,22,76,48,76,182,77,72,77,96,77,120,
77,140,77,160,77,184,77,208,77,232,78,0,78,24,78,48,78,68,78,88,78,112,78,136,78,148,78,160,78,184,78,208,80,20,80,120,80,144,80,156,80,180,80,192,80,216,80,228,80,254,81,10,81,36,81,48,81,72,81,84,81,108,81,120,81,144,81,156,81,182,81,206,81,230,81,254,82,18,82,42,82,66,82,146,82,232,83,20,83,66,83,90,83,114,83,138,83,162,83,174,83,186,83,198,83,210,84,36,84,118,84,172,85,42,85,66,85,162,86,18,86,180,86,236,87,24,87,104,90,166,90,174,90,210,90,246,91,34,91,82,91,134,91,182,91,204,91,212,91,220,92,
0,92,86,92,94,92,102,92,110,92,250,93,2,93,10,93,128,93,136,93,144,93,210,93,218,94,2,94,10,94,76,94,84,94,92,96,34,96,42,97,250,98,132,98,156,98,182,98,206,101,214,101,238,102,4,102,30,102,162,103,48,104,42,104,182,105,56,105,204,106,52,106,150,106,236,107,74,108,90,108,216,110,42,110,230,110,238,111,102,111,202,112,70,112,180,113,32,113,116,114,216,115,110,116,228,118,122,118,148,118,174,118,198,118,222,118,246,120,34,120,166,124,4,124,132,124,140,124,148,125,172,125,180,126,58,126,150,126,232,
127,0,127,24,128,40,128,48,128,136,128,144,128,178,129,6,129,14,130,216,131,110,131,202,131,226,132,62,132,148,132,156,132,164,132,172,132,210,132,218,132,226,132,234,133,94,134,216,134,224,135,36,135,106,136,188,138,80,138,154,138,240,139,66,139,192,140,64,140,168,140,176,141,38,141,154,141,200,142,50,142,58,143,128,144,12,144,100,144,124,144,216,145,50,146,80,146,148,146,156,146,208,146,216,146,224,148,114,148,122,150,108,150,116,150,174,150,248,152,112,153,236,154,62,154,170,155,0,155,104,155,
214,156,56,156,82,156,246,157,14,157,116,157,124,157,188,159,138,159,146,160,40,160,146,161,24,161,48,161,60,162,178,162,224,163,24,163,48,163,60,163,84,163,96,163,122,163,134,163,158,163,170,163,198,163,226,163,246,164,10,164,30,164,42,164,102,164,152,164,212,165,4,165,98,165,186,166,40,166,96,166,184,166,246,167,54,169,200,169,232,169,252,170,48,170,100,170,122,170,144,170,178,171,0,171,88,172,8,174,84,175,8,175,234,176,116,177,44,177,186,178,70,178,174,178,208,178,240,179,16,179,56,179,102,179,
148,179,194,179,240,180,56,180,128,180,208,181,94,181,218,182,0,182,98,182,122,182,228,183,130,183,154,183,208,184,48,184,208,185,82,185,142,185,236,186,72,186,118,186,156,186,210,187,16,187,40,187,66,187,100,187,134,187,168,187,202,187,240,188,22,188,60,188,98,188,148,188,186,188,228,189,18,189,66,189,124,189,170,189,218,190,20,190,66,190,114,190,172,190,218,191,10,191,68,191,120,191,174,191,242,192,38,192,94,192,164,192,218,193,14,193,84,193,138,193,190,194,6,194,78,194,152,194,244,195,12,195,36,
195,60,195,84,195,108,197,132,199,96,201,32,201,46,201,78,201,106,201,146,201,160,201,174,201,188,201,202,201,216,202,34,202,116,202,166,202,216,203,42,203,108,204,28,204,156,205,76,205,198,206,94,206,190,207,68,207,152,207,210,208,30,208,148,209,6,209,108,209,182,209,214,210,2,210,86,210,202,210,252,211,144,211,228,212,14,212,50,212,84,212,116,212,186,212,240,213,24,213,116,213,164,213,238,0,0,0,2,0,68,0,0,2,100,5,85,0,3,0,7,0,46,177,1,0,47,60,178,7,4,34,237,50,177,6,5,220,60,178,3,2,34,237,50,0,
177,3,0,47,60,178,5,4,34,237,50,178,7,6,35,252,60,178,1,2,34,237,50,51,17,33,17,37,33,17,33,68,2,32,254,36,1,152,254,104,5,85,250,171,68,4,205,0,0,0,2,0,193,0,0,1,231,5,129,0,3,0,7,2,6,64,91,3,2,7,150,6,4,22,4,2,11,4,4,9,8,153,9,169,9,2,86,9,102,9,2,25,9,1,134,9,150,9,198,9,214,9,246,9,5,57,9,73,9,89,9,3,6,9,1,203,153,9,201,9,2,70,9,118,9,134,9,3,198,9,214,9,230,9,3,25,9,73,9,153,9,169,9,4,4,9,1,244,9,1,182,9,214,9,230,9,3,9,184,255,128,64,19,161,165,72,70,9,86,9,2,52,9,1,38,9,1,2,9,1,155,9,184,255,
192,64,11,151,154,72,196,9,212,9,228,9,3,9,184,255,64,182,143,147,72,100,9,1,9,184,255,64,64,46,137,141,72,4,9,1,244,9,1,224,9,1,194,9,210,9,2,176,9,1,130,9,146,9,162,9,3,84,9,100,9,116,9,3,70,9,1,34,9,50,9,2,22,9,1,9,184,255,128,64,73,112,120,72,114,9,1,68,9,84,9,100,9,3,50,9,1,20,9,36,9,2,2,9,1,104,228,9,244,9,2,210,9,1,166,9,182,9,198,9,3,114,9,130,9,146,9,3,68,9,84,9,100,9,3,54,9,1,32,9,1,20,9,1,6,9,1,246,9,1,226,9,1,9,184,255,128,64,40,80,85,72,54,9,86,9,102,9,118,9,4,34,9,1,1,0,9,16,9,2,240,
9,1,212,9,228,9,2,192,9,1,148,9,164,9,180,9,3,9,184,255,128,64,24,59,63,72,4,9,20,9,36,9,3,56,228,9,244,9,2,176,9,192,9,208,9,3,9,184,255,192,64,45,44,49,72,32,9,1,20,9,1,0,9,1,240,9,1,148,9,196,9,212,9,228,9,4,96,9,112,9,2,68,9,84,9,116,9,132,9,148,9,180,9,196,9,7,9,184,255,192,64,18,23,28,72,16,9,1,2,0,9,1,7,1,1,2,3,5,157,4,0,47,237,63,57,47,1,94,93,95,93,43,93,113,113,113,114,114,114,43,114,114,94,93,43,93,93,93,93,113,95,113,113,43,113,113,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,
43,113,113,113,113,113,113,113,113,113,114,43,114,43,114,43,94,93,93,93,93,43,93,93,113,113,113,114,114,94,93,93,93,113,113,113,17,18,57,47,94,93,237,51,50,49,48,1,35,3,33,1,17,33,17,1,199,230,32,1,38,254,218,1,32,1,170,3,215,250,127,1,14,254,242,0,0,0,2,0,135,3,130,3,68,5,129,0,3,0,7,0,54,64,35,2,152,143,3,1,47,3,159,3,2,0,3,1,3,7,152,207,6,1,0,6,32,6,48,6,64,6,4,6,4,0,169,6,2,3,0,63,51,237,50,1,47,93,113,237,47,93,93,113,237,49,48,1,35,3,33,1,35,3,33,3,39,219,27,1,19,254,57,219,27,1,17,3,130,1,
255,254,1,1,255,0,0,0,2,0,35,0,0,4,82,5,115,0,27,0,31,0,242,181,26,32,9,0,77,16,184,255,192,179,10,0,77,12,184,255,224,64,38,9,10,0,76,4,1,0,25,24,5,24,22,31,30,7,6,23,6,8,29,28,21,20,9,20,18,15,14,11,10,19,10,5,1,82,23,6,23,184,1,20,64,12,24,5,20,24,24,5,19,1,82,9,20,9,184,1,20,64,19,10,19,20,10,19,9,10,20,6,20,6,10,27,3,24,33,16,12,10,184,255,192,64,50,10,13,72,10,8,4,12,174,13,29,1,13,28,0,16,174,17,25,21,17,15,13,175,13,2,207,13,255,13,2,15,17,79,17,175,17,3,207,17,1,13,17,13,17,5,23,19,177,10,
5,0,47,51,63,51,18,57,57,47,47,93,113,93,113,17,51,51,16,237,50,50,17,51,51,16,237,50,50,1,47,43,51,51,16,204,50,50,17,57,57,47,47,16,0,193,135,5,43,135,43,196,135,24,16,43,135,43,196,49,48,16,135,192,192,192,192,16,135,192,192,192,192,16,135,192,192,192,192,16,135,192,192,192,192,1,43,43,43,1,3,51,21,35,3,35,19,33,3,35,19,35,53,51,19,35,53,51,19,51,3,33,19,51,3,51,21,33,3,33,19,3,141,69,215,246,82,156,80,254,205,80,153,79,155,188,70,207,238,84,153,82,1,51,84,156,84,164,253,111,72,1,53,70,3,94,254,
180,149,254,131,1,125,254,131,1,125,149,1,76,148,1,129,254,127,1,129,254,127,148,254,180,1,76,0,0,0,0,3,0,27,255,104,4,86,5,240,0,53,0,64,0,73,1,53,185,0,45,255,192,179,11,15,72,46,184,255,192,64,14,11,15,72,20,64,11,15,72,19,64,11,15,72,52,184,255,208,64,9,10,0,77,26,32,10,0,77,39,184,255,232,64,9,9,0,77,20,64,9,0,77,50,184,255,248,180,9,10,0,76,2,184,255,232,64,26,9,10,0,76,30,8,9,10,0,76,45,35,54,34,34,13,0,71,6,7,19,7,42,110,41,59,184,255,248,181,12,15,72,59,110,28,184,255,192,64,17,25,28,72,
0,7,1,28,7,41,41,7,28,3,13,65,110,0,184,255,192,64,91,38,53,72,0,75,14,110,175,13,191,13,2,13,64,22,28,72,13,64,14,17,72,13,71,19,116,8,0,14,16,14,48,14,64,14,128,14,144,14,6,14,14,5,8,20,70,46,64,45,54,8,12,15,72,54,117,33,29,42,1,11,42,1,42,42,36,70,64,33,192,33,1,96,8,112,8,128,8,3,160,8,176,8,2,8,33,8,33,6,34,6,0,47,47,18,57,57,47,47,93,113,93,18,57,57,50,50,47,93,93,16,237,43,50,17,51,17,51,17,51,51,47,93,16,237,50,1,47,43,43,93,237,16,222,43,237,18,23,57,47,47,47,93,43,237,43,16,237,17,51,16,
205,50,17,18,57,47,51,205,50,49,48,43,43,0,43,1,43,43,43,43,43,43,43,43,1,20,14,2,7,21,35,53,46,3,39,37,30,3,23,17,46,1,35,46,3,53,52,62,2,55,53,51,21,30,3,23,5,46,1,39,17,22,50,23,30,3,1,14,3,21,20,30,2,23,1,52,46,2,39,17,62,1,4,86,56,117,182,126,109,114,169,119,73,18,1,0,8,31,54,83,61,3,24,4,78,150,117,72,66,119,165,98,109,107,150,104,64,21,254,248,15,87,80,5,11,6,86,165,129,79,253,178,53,71,44,18,28,50,68,40,1,74,34,60,81,46,106,115,1,156,85,139,101,59,5,175,172,4,54,98,141,91,47,48,79,58,37,6,
1,135,2,5,18,53,91,139,104,91,131,86,44,4,134,134,4,48,87,127,84,39,87,95,11,254,160,2,2,20,54,92,145,2,159,4,28,43,55,30,43,55,36,25,13,254,58,49,61,38,25,13,254,145,7,86,0,0,5,0,51,255,240,6,231,5,145,0,19,0,23,0,43,0,63,0,83,3,213,185,0,27,255,232,64,17,9,10,0,76,41,24,9,10,0,76,37,24,9,10,0,76,31,184,255,232,180,9,10,0,76,18,184,255,232,64,17,9,10,0,76,12,24,9,10,0,76,8,24,9,10,0,76,2,184,255,232,64,16,9,10,0,76,9,22,1,22,23,6,20,1,3,20,21,21,184,255,240,64,52,23,16,231,23,247,23,2,7,23,1,8,21,
1,10,23,21,23,21,39,0,54,180,8,10,1,10,181,44,180,24,0,40,0,2,0,64,20,25,72,0,85,64,180,7,29,1,13,29,181,74,180,39,184,255,192,64,255,20,25,72,39,64,16,19,72,39,226,85,1,209,85,1,194,85,1,179,85,1,164,85,1,149,85,1,114,85,130,85,2,97,85,1,80,85,1,65,85,1,50,85,1,19,85,35,85,2,4,85,1,241,85,1,210,85,226,85,2,179,85,195,85,2,162,85,1,147,85,1,132,85,1,117,85,1,102,85,1,65,85,81,85,2,50,85,1,35,85,1,20,85,1,3,85,1,199,227,85,243,85,2,212,85,1,177,85,193,85,2,162,85,1,131,85,147,85,2,116,85,1,99,85,1,
84,85,1,69,85,1,54,85,1,33,85,1,18,85,1,3,85,1,244,85,1,213,85,229,85,2,195,85,1,180,85,1,165,85,1,145,85,1,130,85,1,115,85,1,98,85,1,83,85,1,68,85,1,53,85,1,38,85,1,5,85,21,85,2,241,85,1,226,85,1,211,85,1,196,85,1,181,85,1,164,85,1,149,85,1,134,85,1,117,85,1,97,85,1,66,85,82,85,2,51,85,1,36,85,1,21,85,1,6,85,1,151,247,85,1,230,85,1,212,85,1,193,85,1,178,85,1,163,85,1,64,255,132,85,148,85,2,117,85,1,102,85,1,71,85,87,85,2,50,85,1,33,85,1,18,85,1,3,85,1,244,85,1,229,85,1,214,85,1,199,85,1,182,85,1,
167,85,1,148,85,1,131,85,1,84,85,100,85,116,85,3,69,85,1,38,85,54,85,2,23,85,1,244,85,1,227,85,1,0,208,85,1,194,85,1,164,85,180,85,2,146,85,1,132,85,1,118,85,1,96,85,1,82,85,1,48,85,64,85,2,34,85,1,4,85,20,85,2,103,214,85,230,85,246,85,3,192,85,1,178,85,1,160,85,1,146,85,1,132,85,1,114,85,1,100,85,1,86,85,1,18,85,34,85,50,85,3,4,85,1,226,85,242,85,2,212,85,1,182,85,198,85,2,146,85,1,132,85,1,102,85,118,85,2,80,85,1,66,85,1,52,85,1,38,85,1,2,85,1,242,85,1,228,85,1,198,85,214,85,2,164,85,180,85,2,134,
85,150,85,2,98,85,1,84,85,1,38,85,54,85,70,85,3,20,85,1,6,85,1,55,194,85,210,85,2,164,85,180,85,2,150,85,1,121,85,1,102,181,85,1,73,85,1,85,184,255,128,64,91,39,42,72,246,85,1,185,85,217,85,2,162,85,1,132,85,148,85,2,102,85,118,85,2,57,85,1,32,85,1,18,85,1,1,0,85,1,224,85,240,85,2,212,85,1,171,85,187,85,2,159,85,1,80,85,96,85,112,85,3,68,85,1,27,85,1,15,85,1,7,2,79,182,34,183,69,182,24,7,22,6,49,182,15,183,59,182,5,25,21,24,0,63,63,237,244,237,63,63,237,244,237,1,95,94,93,93,93,93,93,93,93,93,113,
95,113,113,113,113,113,113,113,113,43,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,95,93,93,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,
93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,47,43,43,237,244,94,93,237,16,222,43,93,237,244,93,237,17,18,57,57,47,47,94,93,93,113,56,56,17,51,95,93,17,51,93,49,48,43,43,43,43,43,43,43,43,1,20,14,2,35,34,46,2,53,52,62,2,51,50,30,2,1,35,1,51,37,50,30,2,21,20,14,2,35,34,46,2,53,52,62,2,1,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,1,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,6,231,56,96,129,73,75,129,95,55,55,96,131,76,72,128,95,55,251,65,206,3,152,209,251,213,72,128,96,
56,56,97,130,74,73,129,95,55,54,96,131,4,196,17,34,50,34,37,53,34,17,16,35,52,36,33,51,35,18,252,15,17,34,50,34,37,54,34,17,17,35,52,36,34,51,35,17,1,176,125,172,105,46,46,105,172,125,132,173,103,41,41,103,173,253,204,5,129,16,41,102,173,132,125,172,106,46,46,105,172,126,132,173,102,41,252,31,87,114,67,27,27,68,114,86,84,111,68,28,28,67,112,2,117,86,113,67,27,28,67,113,85,84,112,68,29,28,68,113,0,3,0,90,255,236,5,135,5,137,0,56,0,70,0,84,0,197,64,31,46,24,9,10,0,76,71,40,9,10,0,76,73,24,9,10,0,76,
27,24,9,10,0,76,6,40,9,10,0,76,16,184,255,232,64,45,9,10,0,76,10,24,9,10,0,76,63,73,8,57,73,18,29,73,30,47,26,71,23,66,74,5,7,8,33,18,30,30,64,11,14,72,47,18,79,18,2,48,8,1,8,184,255,192,64,14,14,24,72,8,18,30,30,18,8,3,0,39,86,77,184,1,18,64,35,48,0,1,0,74,23,5,66,4,13,36,82,79,52,47,71,33,26,4,52,95,29,111,29,2,29,29,13,42,52,22,60,82,13,4,0,63,237,63,51,18,57,47,93,18,23,57,16,237,50,17,23,57,1,47,93,237,16,206,17,23,57,47,47,47,43,93,93,43,17,18,57,17,23,57,16,237,16,237,16,237,49,48,43,43,43,
43,43,43,43,19,52,62,2,55,46,1,53,52,62,2,51,50,30,2,21,20,14,2,7,30,1,23,62,1,55,23,14,1,7,30,1,51,50,54,55,21,6,35,34,46,2,39,14,3,35,34,46,2,1,52,38,35,34,6,21,20,22,23,62,3,3,46,1,39,14,1,21,20,30,2,51,50,54,90,51,90,124,73,32,42,40,90,144,103,81,133,96,53,66,109,142,75,51,122,71,56,76,26,209,34,94,65,45,90,43,32,59,26,55,76,51,94,84,72,29,33,81,95,109,61,126,184,118,57,3,12,76,65,77,81,31,23,51,90,66,38,82,77,138,57,83,89,31,60,91,60,65,105,1,129,79,128,104,83,34,65,148,66,66,118,89,52,39,76,
110,72,73,113,91,75,35,90,167,79,85,179,99,70,117,206,97,38,35,8,8,203,22,20,33,44,24,25,47,36,21,62,108,148,3,52,57,72,86,71,48,100,45,22,45,53,62,252,191,86,188,103,39,114,81,46,80,59,34,48,0,1,0,109,3,130,1,125,5,129,0,3,0,54,64,13,3,152,128,2,144,2,160,2,3,144,2,1,2,184,255,192,179,28,31,72,2,184,255,192,64,11,11,14,72,2,2,4,5,0,169,2,3,0,63,237,17,18,1,57,47,43,43,93,113,237,49,48,1,35,3,33,1,98,219,26,1,16,3,130,1,255,0,0,0,1,0,102,254,87,2,168,5,204,0,21,0,46,64,16,0,241,21,10,241,96,11,1,
112,11,1,11,11,16,241,5,184,255,192,183,10,13,72,5,10,0,0,27,0,63,63,1,47,43,237,51,47,93,113,237,212,237,49,48,1,46,3,53,52,62,2,55,33,14,3,21,20,30,2,23,1,143,77,112,73,35,35,73,112,77,1,25,80,114,73,34,34,73,114,80,254,87,111,220,232,251,142,143,249,231,219,111,116,226,232,245,135,136,245,232,225,117,0,0,0,1,0,2,254,87,2,68,5,204,0,21,0,63,64,41,21,241,0,11,241,111,10,1,127,10,1,10,10,16,241,96,5,144,5,2,79,5,1,239,5,1,48,5,160,5,2,15,5,31,5,2,5,10,0,0,27,0,63,63,1,47,93,93,93,113,113,237,50,47,
93,113,237,212,237,49,48,19,62,3,53,52,46,2,39,33,30,3,21,20,14,2,7,2,80,114,73,34,34,73,114,80,1,25,77,112,73,35,35,73,112,77,254,87,117,225,232,245,136,135,245,232,226,116,111,219,231,249,143,142,251,232,220,111,0,0,0,1,0,6,2,135,3,27,5,129,0,14,0,75,64,43,8,11,4,1,1,3,14,6,13,9,11,7,2,10,0,2,16,2,2,2,4,8,3,9,2,10,1,11,11,10,9,6,8,5,13,7,0,5,1,5,5,13,3,0,63,51,47,93,51,18,23,57,17,51,17,51,17,51,17,51,1,47,93,47,18,23,57,17,51,17,51,49,48,1,55,23,7,23,7,39,7,39,55,39,55,23,3,51,1,236,235,68,250,
186,184,146,149,186,190,250,68,239,18,215,4,111,104,197,61,213,121,252,252,123,211,61,197,104,1,18,0,1,0,86,0,161,4,89,4,177,0,11,0,81,64,44,11,14,1,4,2,14,15,4,31,4,2,18,3,4,9,1,170,64,6,2,2,12,13,2,14,4,7,5,14,48,7,1,144,7,160,7,2,7,0,4,173,9,5,178,0,63,51,237,50,198,93,113,43,0,24,16,77,230,17,18,1,57,47,51,26,237,50,198,95,94,93,43,1,24,16,77,230,49,48,1,17,35,17,33,53,33,17,51,17,33,21,2,199,226,254,113,1,143,226,1,146,2,57,254,104,1,152,224,1,152,254,104,224,0,0,0,0,1,0,139,254,195,1,176,1,
49,0,14,0,34,64,18,5,6,12,11,151,0,150,32,12,48,12,2,12,13,155,6,168,12,0,47,230,237,1,47,93,253,237,16,198,50,49,48,37,20,14,2,7,35,62,3,53,35,17,33,1,176,15,28,40,25,185,29,48,36,20,129,1,33,66,67,110,93,78,35,35,78,82,82,40,1,49,0,0,1,0,80,1,153,2,88,2,141,0,3,0,15,181,2,0,0,186,1,188,0,63,237,1,47,47,49,48,19,53,33,21,80,2,8,1,153,244,244,0,1,0,139,0,0,1,172,1,49,0,3,0,28,64,14,3,150,32,0,48,0,2,0,0,5,4,1,155,0,0,47,237,17,18,1,57,47,93,237,49,48,51,17,33,17,139,1,33,1,49,254,207,0,0,0,0,1,0,
20,255,215,2,37,5,204,0,3,0,48,185,0,3,255,240,64,18,10,0,77,1,8,9,10,0,76,1,2,16,16,2,1,2,3,0,184,255,240,179,0,1,0,0,0,47,63,1,47,56,50,47,93,56,51,49,48,43,43,23,1,51,1,20,1,35,238,254,226,41,5,245,250,11,0,0,0,0,2,0,81,255,236,4,31,5,150,0,19,0,39,0,38,64,21,20,110,207,0,1,0,41,30,110,64,10,1,10,25,115,15,7,35,115,5,25,0,63,237,63,237,1,47,93,237,16,222,113,237,49,48,1,20,2,14,1,35,34,46,1,2,53,52,18,62,1,51,50,30,1,18,5,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,4,31,74,131,179,106,106,178,128,
72,71,130,181,110,103,177,129,73,254,230,22,48,77,55,59,80,49,21,22,48,78,57,55,78,50,23,2,193,202,254,235,171,75,74,171,1,21,203,213,1,23,166,67,67,166,254,233,213,149,195,115,46,47,116,195,147,145,194,117,48,48,117,194,0,0,1,0,129,0,0,4,58,5,129,0,10,0,83,64,31,36,5,52,5,68,5,3,43,3,59,3,75,3,3,9,9,8,110,2,4,15,1,111,1,207,1,3,1,1,6,2,184,255,192,64,17,10,13,72,2,2,11,12,5,4,3,6,6,8,1,116,0,24,0,63,237,50,63,51,205,50,17,18,1,57,47,43,51,51,47,93,51,16,237,50,47,49,48,0,93,93,51,53,33,17,5,53,37,
33,17,33,21,129,1,93,254,174,1,97,1,10,1,67,209,3,193,211,221,229,251,80,209,0,1,0,71,0,0,4,33,5,150,0,34,0,55,64,29,8,111,25,25,33,36,14,110,15,15,32,112,95,0,1,0,8,0,20,14,14,11,115,20,7,32,115,0,24,0,63,237,63,237,51,47,17,18,57,1,47,93,237,51,47,237,16,206,50,47,237,49,48,51,53,62,5,53,52,38,35,34,6,7,37,62,3,51,50,30,2,21,20,14,4,7,33,21,71,48,138,151,149,119,74,94,91,90,95,14,254,229,10,62,115,173,120,114,176,120,62,78,122,149,140,115,28,2,142,195,105,169,141,121,113,114,64,94,90,97,97,16,83,
146,110,63,53,102,147,94,99,160,135,118,112,114,65,231,0,0,0,1,0,47,255,233,4,41,5,150,0,59,0,117,64,75,38,110,39,55,26,32,111,49,39,26,49,49,26,39,3,10,19,111,0,61,11,111,10,64,14,21,72,10,54,25,115,26,26,16,44,79,38,159,38,2,38,38,35,115,44,7,16,115,5,32,11,96,11,112,11,176,11,192,11,5,48,11,64,11,128,11,144,11,208,11,5,11,11,5,25,0,63,51,47,93,113,16,237,63,237,51,47,93,17,18,57,47,237,57,1,47,43,237,16,222,237,18,23,57,47,47,47,16,237,18,57,16,237,49,48,1,20,14,2,35,34,46,2,39,37,30,3,51,50,54,
53,52,46,2,43,1,53,51,50,62,2,53,52,38,35,34,6,7,37,62,3,51,50,30,2,21,20,14,2,7,21,30,3,4,41,63,126,187,124,138,189,121,61,9,1,30,6,33,56,81,55,101,112,53,81,94,42,98,92,42,87,70,44,97,93,87,107,8,254,231,12,85,129,168,94,124,178,114,54,36,73,114,78,87,128,82,40,1,135,96,153,108,57,70,115,146,75,25,45,75,54,29,100,103,63,76,41,14,227,16,42,75,58,87,99,96,88,20,99,146,96,47,60,102,136,77,62,107,85,61,15,4,10,59,88,111,0,0,0,2,0,31,0,0,4,104,5,129,0,10,0,23,0,118,64,58,22,63,5,111,5,2,15,5,31,5,63,
5,79,5,111,5,143,5,159,5,175,5,207,5,223,5,255,5,11,63,5,79,5,111,5,255,5,4,5,64,18,22,72,5,5,10,8,1,110,23,6,128,2,1,144,2,1,2,184,255,192,64,20,10,15,72,2,2,24,25,0,4,116,8,5,22,22,1,16,6,6,1,24,0,63,63,51,18,57,47,51,51,237,50,17,18,1,57,47,43,93,113,51,51,237,50,50,51,47,43,93,113,114,51,49,48,1,17,33,17,33,53,1,33,17,51,21,1,52,62,2,55,14,3,7,1,33,3,172,254,244,253,127,2,83,1,58,188,254,56,1,3,3,2,5,22,27,29,11,254,185,1,156,1,31,254,225,1,31,211,3,143,252,111,209,2,158,17,55,58,53,15,11,41,
47,46,17,254,15,0,0,1,0,63,255,236,4,58,5,129,0,40,0,130,185,0,33,255,224,181,10,0,77,32,33,33,184,255,224,64,15,16,25,72,29,27,33,3,28,31,28,31,10,19,111,0,184,255,192,64,52,38,53,72,0,42,11,110,95,10,111,10,2,10,28,28,24,115,143,36,223,36,2,239,36,1,36,36,16,32,116,29,6,16,115,5,63,11,143,11,223,11,3,239,11,1,64,11,1,11,11,5,25,0,63,51,47,93,93,113,16,237,63,237,18,57,47,93,113,237,51,47,1,47,93,237,16,222,43,237,18,57,57,47,47,23,51,43,17,51,49,48,0,43,1,20,14,2,35,34,46,2,39,37,30,3,51,50,54,
53,52,46,2,35,34,6,7,33,19,33,21,33,3,62,1,51,50,30,2,4,58,67,132,195,128,118,176,121,69,13,1,25,8,29,52,76,54,105,125,31,57,83,53,70,90,31,254,238,49,3,79,253,176,23,42,128,85,104,164,114,60,1,213,106,179,131,73,57,101,136,78,23,33,62,48,29,134,126,56,90,64,34,53,38,3,25,209,254,156,37,53,68,122,171,0,0,0,2,0,75,255,236,4,41,5,150,0,30,0,48,0,105,185,0,21,255,248,64,11,10,0,77,17,110,16,16,8,31,110,0,184,255,192,64,49,38,41,72,0,50,23,41,111,223,8,239,8,255,8,3,8,36,116,23,16,26,1,223,26,239,26,
2,80,26,96,26,2,26,26,46,20,115,11,80,17,1,17,17,11,7,46,115,5,25,0,63,237,63,51,47,93,16,237,18,57,47,93,93,113,51,237,1,47,113,237,50,16,222,43,237,18,57,47,237,49,48,43,1,20,14,2,35,34,0,17,16,0,51,50,30,2,23,5,46,1,35,34,6,21,62,1,51,50,30,2,5,52,46,2,35,34,14,2,21,20,30,2,51,50,54,4,41,60,119,178,117,249,254,245,1,15,252,84,138,108,76,23,254,247,20,90,60,113,129,45,160,101,93,151,107,58,254,230,26,53,78,51,37,74,58,36,30,55,78,49,95,106,1,205,106,177,127,71,1,93,1,87,1,121,1,125,35,78,123,88,
37,74,65,226,230,75,80,61,115,166,112,57,91,64,35,24,53,82,58,60,104,77,43,135,0,0,0,0,1,0,88,0,0,4,25,5,129,0,14,0,46,64,26,10,24,10,0,77,5,111,6,6,12,11,0,16,48,12,64,12,2,12,0,12,115,13,6,5,24,0,63,63,237,50,1,47,93,16,206,50,17,57,47,237,49,48,43,1,6,10,2,21,33,52,26,2,55,33,53,33,4,25,95,169,126,73,254,219,79,136,180,100,253,68,3,193,4,162,150,254,230,254,227,254,211,168,167,1,45,1,30,1,23,145,231,0,3,0,65,255,236,4,52,5,150,0,41,0,61,0,81,0,101,64,24,15,21,62,111,0,52,111,21,36,72,42,111,31,
95,31,111,31,2,21,31,21,31,10,0,184,255,192,64,33,38,47,72,0,83,72,111,95,10,111,10,2,10,64,38,47,72,10,36,15,67,117,57,57,77,47,117,26,7,77,117,5,25,0,63,237,63,237,18,57,47,237,57,57,1,47,43,93,237,16,206,43,17,57,57,47,47,113,16,237,18,57,16,237,16,237,17,57,49,48,1,20,14,2,35,34,46,2,53,52,62,2,55,53,46,3,53,52,62,2,51,50,30,2,21,20,14,2,7,21,30,3,1,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,19,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,4,52,60,124,190,131,130,191,125,60,48,80,104,55,59,94,66,35,
61,118,175,115,123,179,116,56,35,66,95,60,62,107,78,44,254,188,18,42,71,54,52,70,42,18,15,40,72,57,60,73,38,12,33,19,49,86,66,60,81,49,21,21,51,84,63,63,82,48,19,1,141,91,153,111,62,62,111,152,90,77,119,86,51,9,4,13,60,84,103,56,84,138,98,53,55,99,138,83,55,103,84,58,12,4,10,53,85,119,2,56,42,71,51,29,29,51,71,42,37,72,57,36,36,58,72,253,184,43,80,61,37,37,62,81,45,53,88,63,34,35,64,89,0,0,0,0,2,0,71,255,236,4,39,5,150,0,36,0,56,0,98,64,62,14,8,10,0,77,17,37,111,0,9,110,8,8,27,208,0,224,0,240,0,3,
0,58,47,111,95,27,1,27,64,38,41,72,27,52,116,17,111,22,1,15,22,31,22,2,22,22,12,42,115,32,7,12,115,3,0,9,1,9,9,3,25,0,63,51,47,113,16,237,63,237,18,57,47,93,113,51,237,1,47,43,93,237,16,206,113,17,57,47,237,16,237,50,49,48,43,1,16,0,35,34,46,2,39,37,30,1,51,50,62,2,55,14,3,35,34,46,2,53,52,62,2,51,50,30,1,18,37,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,4,39,254,238,252,91,145,108,75,22,1,8,20,91,69,57,90,64,35,1,20,66,83,94,48,92,150,106,57,67,126,183,116,122,187,126,65,254,215,27,54,78,51,47,74,52,
27,26,50,76,49,39,75,59,36,2,215,254,137,254,140,38,80,126,87,37,75,72,54,110,169,115,39,60,40,21,65,122,173,109,112,176,121,63,83,173,254,247,15,60,105,77,44,35,66,94,59,55,95,69,39,28,56,85,0,0,0,0,2,0,197,0,0,1,229,4,10,0,3,0,7,1,127,64,255,3,7,150,0,0,4,16,4,2,11,4,80,9,96,9,2,15,9,31,9,2,192,9,208,9,224,9,3,79,9,95,9,2,0,9,48,9,2,206,223,9,239,9,255,9,3,160,9,176,9,192,9,3,63,9,111,9,2,16,9,32,9,2,224,9,1,159,9,175,9,2,80,9,96,9,128,9,3,15,9,31,9,2,239,9,1,192,9,208,9,2,79,9,95,9,2,0,9,16,9,
48,9,3,155,223,9,239,9,255,9,3,160,9,176,9,192,9,3,63,9,111,9,2,16,9,32,9,2,224,9,1,143,9,159,9,175,9,3,80,9,96,9,2,9,64,118,121,72,192,9,208,9,2,79,9,95,9,143,9,3,0,9,48,9,2,104,175,9,191,9,207,9,3,112,9,128,9,144,9,3,15,9,63,9,2,255,9,1,224,9,1,95,9,111,9,127,9,3,32,9,48,9,2,191,9,223,9,239,9,3,144,9,160,9,2,31,9,47,9,2,0,9,1,56,224,9,240,9,2,9,64,46,49,72,80,9,96,9,2,31,9,1,223,9,239,9,2,144,9,192,9,2,63,9,79,64,53,9,95,9,3,0,9,16,9,32,9,3,159,9,191,9,207,9,3,64,9,80,9,112,9,128,9,4,15,9,1,7,0,
156,63,1,95,1,127,1,159,1,191,1,5,1,64,22,34,72,1,5,156,4,0,47,237,47,43,93,237,1,94,93,93,93,113,113,113,113,114,114,43,114,94,93,93,93,93,113,113,113,113,114,114,114,94,93,93,93,43,113,113,113,114,114,114,114,94,93,93,93,93,113,113,113,113,114,114,114,114,94,93,93,93,113,113,47,94,93,196,253,196,49,48,19,17,33,17,1,17,33,17,197,1,32,254,224,1,32,2,240,1,26,254,230,253,16,1,25,254,231,0,0,0,2,0,195,254,195,1,231,4,10,0,3,0,18,1,142,64,255,2,150,1,9,10,16,15,151,4,150,1,0,16,16,16,2,11,16,80,20,96,
20,2,15,20,31,20,2,192,20,208,20,224,20,3,79,20,95,20,2,0,20,48,20,2,206,223,20,239,20,255,20,3,160,20,176,20,192,20,3,63,20,111,20,2,16,20,32,20,2,224,20,1,159,20,175,20,2,80,20,96,20,128,20,3,15,20,31,20,2,239,20,1,192,20,208,20,2,79,20,95,20,2,0,20,16,20,48,20,3,155,223,20,239,20,255,20,3,160,20,176,20,192,20,3,63,20,111,20,2,16,20,32,20,2,224,20,1,143,20,159,20,175,20,3,80,20,96,20,2,20,64,118,121,72,192,20,208,20,2,79,20,95,20,143,20,3,0,20,48,20,2,104,175,20,191,20,207,20,3,112,20,128,20,144,
20,3,15,20,63,20,2,255,20,1,224,20,1,95,20,111,20,127,20,3,32,20,48,20,2,191,20,223,20,239,20,3,144,20,160,20,2,31,20,47,20,2,0,20,1,56,224,20,240,20,2,20,64,46,49,72,80,20,96,20,2,31,20,1,223,20,239,20,2,144,64,62,20,192,20,2,63,20,79,20,95,20,3,0,20,16,20,32,20,3,159,20,191,20,207,20,3,64,20,80,20,112,20,128,20,4,15,20,1,7,0,156,63,1,95,1,127,1,159,1,191,1,5,1,64,22,34,72,1,17,156,10,168,16,0,47,230,237,47,43,93,237,1,94,93,93,93,113,113,113,113,114,114,43,114,94,93,93,93,93,113,113,113,113,114,
114,114,94,93,93,93,43,113,113,113,114,114,114,114,94,93,93,93,93,113,113,113,113,114,114,114,114,94,93,93,93,113,113,47,94,93,196,253,237,16,198,50,16,237,49,48,19,17,33,25,1,20,14,2,7,35,62,3,53,35,17,33,199,1,32,15,28,40,25,184,28,49,36,20,129,1,32,2,240,1,26,254,230,253,82,67,110,93,78,35,35,78,82,82,40,1,25,0,0,0,0,1,0,86,0,125,4,89,4,205,0,6,0,104,64,56,0,1,82,5,4,5,176,6,0,20,6,0,5,6,1,2,1,82,3,4,1,4,3,176,2,1,20,2,1,3,2,6,8,4,0,1,0,4,4,2,5,63,6,1,6,3,95,2,1,32,2,1,15,2,1,2,0,47,93,93,93,51,
47,93,51,18,57,61,47,51,51,1,24,47,51,16,222,212,193,135,4,43,16,1,193,135,4,43,16,196,16,1,193,135,4,24,43,135,43,196,49,48,19,17,1,21,9,1,21,86,4,3,252,191,3,65,2,4,1,66,1,135,228,254,187,254,188,227,0,2,0,85,1,35,4,88,4,41,0,3,0,7,0,72,64,51,7,2,9,4,64,1,1,1,5,173,223,4,1,15,4,31,4,63,4,79,4,143,4,5,4,64,20,25,72,4,0,173,48,1,112,1,2,32,1,64,1,96,1,112,1,160,1,192,1,6,1,0,47,93,113,237,47,43,93,113,237,1,47,93,51,16,206,50,49,48,19,53,33,21,1,53,33,21,85,4,3,251,253,4,3,3,74,223,223,253,217,221,
221,0,0,1,0,86,0,125,4,89,4,205,0,6,0,104,64,56,6,1,82,1,2,1,176,0,6,20,0,6,1,0,5,4,1,82,3,2,5,2,3,176,4,5,20,4,5,3,4,2,6,8,4,0,6,5,2,2,3,95,4,1,32,4,1,15,4,1,4,1,63,0,1,0,0,47,93,50,47,93,93,93,51,57,61,47,51,51,1,24,47,196,16,206,50,16,193,135,4,43,16,1,193,135,4,43,16,196,16,1,193,135,4,24,43,135,43,196,49,48,55,53,9,1,53,1,17,86,3,64,252,192,4,3,125,227,1,68,1,69,228,254,121,254,190,0,0,2,0,94,0,0,4,109,5,150,0,35,0,39,0,66,64,31,9,39,150,10,36,36,26,17,150,0,41,25,150,32,26,48,26,2,26,17,31,
10,10,31,37,157,36,21,25,25,20,184,1,21,177,31,4,0,63,237,51,47,63,237,17,57,47,18,57,1,47,93,237,16,222,237,17,57,47,51,237,50,49,48,1,20,14,6,7,33,62,5,53,52,38,35,34,14,2,7,37,62,3,51,50,30,2,1,17,33,17,4,109,35,58,74,78,75,60,38,2,254,245,5,63,90,102,87,57,115,106,51,86,65,42,6,254,227,12,75,130,189,125,120,188,131,69,253,73,1,33,4,2,66,100,79,63,56,54,61,73,48,85,121,90,71,74,87,60,88,102,31,56,80,48,12,89,156,116,68,56,105,150,251,161,1,14,254,242,0,0,2,0,117,254,188,7,86,5,174,0,95,0,120,0,
208,64,23,44,24,10,0,77,7,24,9,0,77,8,40,9,10,0,76,8,40,9,10,0,76,35,184,255,232,179,9,0,77,114,184,255,232,64,33,9,0,77,21,24,9,10,0,76,72,72,10,0,108,210,24,35,39,212,10,96,34,10,24,10,24,10,84,47,210,0,122,59,184,255,232,182,9,10,0,76,59,210,84,184,255,192,64,56,9,12,72,84,71,71,77,42,111,213,19,5,19,101,213,34,29,33,29,175,19,191,19,207,19,3,0,29,1,48,29,64,29,224,29,240,29,4,19,29,19,29,66,52,16,10,0,77,52,213,91,218,66,213,77,219,0,63,237,63,237,43,18,57,57,47,47,93,113,93,17,51,16,196,237,
17,51,16,237,50,18,57,47,1,47,43,237,43,16,214,237,17,57,57,47,47,17,51,51,16,237,50,16,237,17,18,57,47,49,48,0,43,43,1,43,43,0,43,1,43,43,1,20,14,2,35,34,46,2,53,52,54,55,35,14,3,35,34,46,2,53,52,62,2,51,50,22,23,51,55,51,3,14,1,21,20,22,51,50,62,2,53,52,46,2,35,34,14,4,21,20,30,4,51,50,62,2,55,23,14,3,35,34,46,4,53,52,18,62,2,36,51,50,4,22,18,5,52,46,2,35,34,14,4,21,20,22,51,50,62,2,55,62,3,7,86,76,131,175,99,42,71,50,28,3,3,6,21,70,91,109,59,95,127,76,32,68,128,186,118,102,130,32,6,39,156,117,
17,20,47,31,59,111,88,53,82,160,236,154,133,224,181,137,93,47,34,69,105,142,181,110,86,160,147,135,61,62,60,138,162,188,110,130,220,177,134,90,45,63,119,171,217,1,3,146,203,1,41,193,93,253,121,31,56,78,48,55,92,72,54,35,18,97,100,48,95,84,69,21,5,9,7,4,2,213,144,239,172,96,21,43,65,43,14,38,15,44,86,67,42,68,110,138,69,115,220,172,105,93,81,152,254,6,79,124,37,50,42,76,136,188,112,126,216,158,90,63,114,158,189,214,114,87,163,142,118,84,47,24,42,57,32,122,34,64,49,30,57,103,144,174,200,107,139,1,0,
220,180,128,70,118,200,254,248,151,47,79,57,32,41,70,93,106,112,53,114,132,46,89,131,84,18,43,42,38,0,2,0,51,0,0,5,145,5,129,0,7,0,20,2,226,64,79,19,2,3,5,1,82,3,13,3,94,4,5,20,4,5,3,4,20,1,0,6,1,82,0,13,0,94,7,6,20,7,6,13,4,7,64,19,22,72,7,7,23,7,2,11,7,22,199,22,215,22,2,152,22,1,134,22,1,7,22,23,22,39,22,87,22,119,22,5,151,22,167,22,183,22,231,22,4,22,184,255,192,64,255,202,205,72,8,22,1,200,199,22,215,22,231,22,3,152,22,1,134,22,1,119,22,1,40,22,1,7,22,23,22,2,247,22,1,200,22,1,183,22,1,166,22,
1,151,22,1,120,22,1,71,22,1,183,22,231,22,2,136,22,152,22,2,103,22,119,22,2,56,22,1,23,22,1,6,22,1,152,246,22,1,212,22,228,22,2,197,22,1,182,22,1,147,22,163,22,2,132,22,1,101,22,117,22,2,84,22,1,67,22,1,36,22,52,22,2,21,22,1,6,22,1,244,22,1,229,22,1,212,22,1,181,22,197,22,2,164,22,1,149,22,1,134,22,1,100,22,116,22,2,67,22,83,22,2,52,22,1,37,22,1,22,22,1,2,22,1,243,22,1,212,22,228,22,2,197,22,1,182,22,1,147,22,163,22,2,132,22,1,117,22,1,102,22,1,84,22,1,69,22,1,36,22,52,22,2,21,22,1,4,22,1,104,229,
22,245,22,2,212,22,1,197,22,1,179,22,1,0,160,22,1,146,22,1,116,22,132,22,2,98,22,1,80,22,1,50,22,66,22,2,36,22,1,22,22,1,64,215,2,22,1,240,22,1,226,22,1,196,22,212,22,2,178,22,1,164,22,1,144,22,1,130,22,1,116,22,1,82,22,98,22,2,68,22,1,54,22,1,36,22,1,16,22,1,2,22,1,228,22,244,22,2,214,22,1,196,22,1,162,22,178,22,2,148,22,1,118,22,134,22,2,100,22,1,82,22,1,52,22,68,22,2,38,22,1,20,22,1,6,22,1,56,242,22,1,228,22,1,214,22,1,194,22,1,180,22,1,166,22,1,132,22,1,118,22,1,84,22,100,22,2,38,22,70,22,2,18,
22,1,1,0,22,1,196,22,244,22,2,160,22,176,22,2,100,22,116,22,148,22,3,80,22,1,20,22,52,22,68,22,3,132,22,148,22,180,22,196,22,228,22,5,112,22,1,68,22,100,22,2,16,22,1,2,0,22,1,8,176,4,192,4,208,4,3,4,7,1,2,95,20,25,13,1,13,5,19,19,6,5,3,4,0,18,0,63,50,63,51,57,47,18,57,93,51,237,50,47,1,47,93,94,93,95,93,93,93,93,113,113,113,113,113,114,95,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,
114,114,114,95,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,113,113,113,113,113,113,113,114,114,114,114,114,114,94,93,43,93,113,113,113,113,16,214,94,93,43,17,57,135,43,135,43,196,16,192,192,16,0,193,135,5,24,43,135,43,196,16,192,192,49,48,33,3,33,3,33,1,33,9,1,46,3,39,14,3,7,3,33,4,109,125,253,231,125,254,217,2,2,1,92,2,0,253,146,12,23,17,11,1,1,10,17,23,12,139,1,
149,1,104,254,152,5,129,250,127,3,219,35,71,59,38,2,3,38,58,71,35,254,107,0,0,0,3,0,137,0,0,5,106,5,129,0,18,0,27,0,40,0,100,64,22,16,35,19,91,95,13,111,13,2,13,13,35,28,90,0,42,32,42,48,42,2,42,184,255,192,64,39,28,35,72,24,35,90,32,6,48,6,2,6,16,34,95,16,24,1,95,24,111,24,143,24,3,239,24,1,24,24,35,23,95,7,3,35,95,6,18,0,63,237,63,237,18,57,47,93,113,114,237,57,1,47,93,237,50,43,93,16,222,237,18,57,47,93,237,18,57,49,48,1,20,14,2,35,33,17,33,50,30,2,21,20,6,7,30,1,1,52,38,35,33,17,33,50,54,19,52,
46,2,35,33,17,33,50,62,2,5,106,86,149,198,111,253,63,2,133,125,195,134,69,133,136,171,179,254,134,121,119,254,176,1,82,125,113,82,44,77,103,60,254,138,1,129,58,100,73,42,1,146,107,153,97,45,5,129,43,88,133,90,120,165,29,20,175,1,213,95,80,254,163,87,254,9,56,76,46,20,254,108,19,47,80,0,0,1,0,84,255,236,5,143,5,150,0,41,0,99,185,0,40,255,248,180,9,10,0,76,34,184,255,248,64,55,9,10,0,76,27,92,26,26,5,92,6,43,48,43,1,37,91,48,16,1,15,16,31,16,2,16,32,95,21,27,27,21,4,32,5,48,5,2,32,5,96,5,160,5,224,
5,240,5,5,5,5,0,95,11,19,0,63,237,51,47,93,113,63,51,47,16,237,1,47,93,93,237,93,16,222,237,51,47,237,49,48,43,43,37,50,62,2,55,5,14,3,35,34,36,38,2,53,52,18,54,36,51,50,30,2,23,5,46,3,35,34,14,2,21,20,30,2,3,27,83,121,89,59,19,1,1,31,100,150,207,140,183,254,244,175,85,85,172,1,7,178,138,207,151,99,28,254,252,14,58,89,120,76,107,154,99,47,47,100,157,212,47,76,96,49,97,76,146,112,69,109,195,1,12,159,165,1,10,187,101,58,105,143,86,71,45,83,64,39,69,128,179,111,110,183,132,74,0,0,2,0,137,0,0,5,113,5,
129,0,12,0,25,0,88,185,0,24,255,224,180,9,10,0,76,24,184,255,232,64,49,8,0,77,15,32,10,0,77,15,56,9,0,77,15,24,8,0,77,13,91,0,27,144,27,1,48,27,64,27,2,20,90,0,6,48,6,64,6,3,8,6,19,95,7,3,20,95,6,18,0,63,237,63,237,1,47,94,93,237,93,113,16,222,237,49,48,0,43,43,43,43,43,1,20,2,14,1,35,33,17,33,50,4,22,18,5,52,46,2,43,1,17,51,50,62,2,5,113,106,184,251,145,253,198,1,254,164,1,18,198,110,254,215,67,120,167,101,209,250,89,151,111,63,2,203,176,254,245,180,92,5,129,82,170,254,250,180,123,176,113,54,252,
71,62,123,182,0,0,0,1,0,137,0,0,5,6,5,129,0,11,0,82,64,53,15,3,1,7,3,7,3,9,10,13,32,13,48,13,64,13,3,5,9,90,32,0,48,0,2,0,8,95,95,5,111,5,143,5,223,5,255,5,5,239,5,1,5,5,9,4,95,1,3,9,95,0,18,0,63,237,63,237,18,57,47,93,113,237,1,47,93,237,50,93,16,206,17,57,57,47,47,113,49,48,51,17,33,21,33,17,33,21,33,17,33,21,137,4,84,252,211,2,240,253,16,3,86,5,129,228,254,158,228,254,141,228,0,1,0,137,0,0,4,152,5,129,0,9,0,63,64,38,3,3,5,8,11,32,11,48,11,2,1,5,90,32,6,48,6,2,6,4,95,47,1,1,1,64,14,49,72,1,1,5,
0,95,7,3,5,18,0,63,63,237,18,57,47,43,93,237,1,47,93,237,50,93,16,206,17,57,47,49,48,1,17,33,21,33,17,33,17,33,21,1,176,2,209,253,47,254,217,4,15,4,157,254,76,228,253,251,5,129,228,0,0,1,0,84,255,236,5,186,5,150,0,45,0,112,185,0,44,255,232,179,10,0,77,44,184,255,248,179,9,0,77,38,184,255,232,179,10,0,77,38,184,255,248,64,47,9,0,77,31,92,30,7,30,7,30,41,6,92,9,47,32,47,48,47,2,41,91,48,20,1,15,20,31,20,2,20,7,95,8,8,0,36,95,25,31,31,25,4,0,95,15,19,0,63,237,63,51,47,16,237,18,57,47,237,1,47,93,93,
237,93,16,222,237,18,57,57,47,47,16,237,49,48,43,43,43,43,37,50,62,2,55,53,33,53,33,17,14,3,35,34,36,38,2,53,52,18,54,36,51,50,30,2,23,5,46,3,35,34,14,2,21,20,30,2,3,38,64,118,101,81,26,254,168,2,102,48,136,170,201,113,187,254,242,174,83,88,179,1,15,183,133,207,155,105,31,254,240,18,60,89,117,75,110,160,104,50,51,105,160,211,20,33,43,23,195,218,253,250,49,89,67,40,109,195,1,12,159,165,1,10,187,101,52,96,135,84,82,44,79,59,35,69,128,179,111,110,184,132,74,0,0,0,0,1,0,137,0,0,5,61,5,129,0,11,0,77,64,
51,8,0,90,223,11,1,11,13,80,13,96,13,112,13,3,128,13,144,13,2,48,13,64,13,176,13,208,13,4,7,3,90,0,4,48,4,64,4,3,8,4,2,96,7,7,9,5,3,4,0,18,0,63,50,63,51,57,47,237,1,47,94,93,237,50,93,113,114,16,222,113,237,50,49,48,33,17,33,17,33,17,33,17,33,17,33,17,4,22,253,154,254,217,1,39,2,102,1,39,2,92,253,164,5,129,253,207,2,49,250,127,0,0,1,0,137,0,0,1,176,5,129,0,3,0,105,64,24,96,5,1,32,5,48,5,64,5,112,5,128,5,192,5,208,5,7,224,5,240,5,2,5,184,255,192,64,11,49,52,72,159,5,1,0,5,1,17,5,184,255,192,64,37,
20,23,72,3,90,0,0,16,0,32,0,3,68,0,0,192,0,208,0,224,0,4,240,0,1,32,0,48,0,224,0,3,0,1,3,0,18,0,63,63,1,47,93,113,114,94,93,237,43,94,93,93,43,93,113,114,49,48,51,17,33,17,137,1,39,5,129,250,127,0,0,0,1,0,31,255,236,3,231,5,129,0,23,0,48,64,26,16,16,5,15,90,18,25,48,25,112,25,2,6,90,5,16,95,17,3,11,95,0,6,6,0,19,0,63,50,47,16,237,63,237,1,47,237,113,16,222,237,17,57,47,49,48,5,34,46,2,39,37,30,3,51,50,54,53,17,33,53,33,17,20,14,2,2,12,106,166,122,79,20,1,37,10,36,51,66,39,88,91,254,231,2,63,62,121,
177,20,44,96,153,109,43,59,81,51,23,118,110,2,227,231,252,61,107,173,121,65,0,0,0,1,0,137,0,0,5,180,5,129,0,11,0,166,64,21,1,0,1,82,1,2,0,94,11,10,20,11,11,10,68,7,1,73,1,1,10,184,255,224,179,10,0,77,10,184,255,224,179,10,0,77,10,184,255,248,64,27,9,0,77,8,32,9,10,0,76,0,24,9,10,0,76,10,1,11,8,9,16,9,9,0,11,16,11,184,255,192,64,23,9,12,72,11,11,13,32,13,48,13,2,7,3,90,32,4,48,4,2,4,2,7,10,184,255,224,64,13,9,0,77,10,1,7,1,8,5,3,4,0,18,0,63,50,63,51,57,57,17,51,43,17,51,1,47,93,237,50,93,17,51,47,
43,56,51,51,47,56,51,17,57,57,49,48,43,43,43,43,0,43,93,93,135,5,16,43,8,43,16,196,33,1,7,17,33,17,33,17,1,33,9,1,4,88,254,6,174,254,217,1,39,2,123,1,88,253,166,2,139,2,135,133,253,254,5,129,253,129,2,127,253,172,252,211,0,1,0,137,0,0,4,164,5,129,0,5,0,34,64,19,4,7,80,7,1,3,90,32,0,48,0,2,0,1,3,3,95,0,18,0,63,237,63,1,47,93,237,93,16,206,49,48,51,17,33,17,33,21,137,1,39,2,244,5,129,251,99,228,0,1,0,137,0,0,6,33,5,129,0,48,2,91,182,46,32,9,10,0,76,32,184,255,224,64,11,9,10,0,76,15,8,9,10,0,76,14,184,
255,248,64,255,9,10,0,76,15,14,38,38,30,46,6,0,92,48,50,203,50,1,189,50,1,1,139,50,1,127,50,1,59,50,75,50,107,50,3,47,50,1,27,50,1,251,50,1,239,50,1,171,50,203,50,2,159,50,1,91,50,123,50,139,50,3,79,50,1,59,50,1,47,50,1,11,50,1,199,235,50,1,223,50,1,155,50,187,50,203,50,3,143,50,1,75,50,123,50,2,63,50,1,11,50,43,50,2,251,50,1,239,50,1,187,50,219,50,2,159,50,175,50,2,132,50,1,107,50,1,95,50,1,75,50,1,52,50,1,27,50,1,15,50,1,244,50,1,203,50,1,191,50,1,164,50,1,123,50,139,50,2,111,50,1,84,50,1,59,50,
1,47,50,1,4,50,1,151,235,50,1,223,50,1,203,50,1,180,50,1,155,50,1,143,50,1,11,50,43,50,75,50,123,50,4,27,50,59,50,75,50,107,50,139,50,187,50,219,50,251,50,8,251,50,1,239,50,1,196,50,1,171,50,1,159,50,1,139,50,1,116,50,1,91,50,1,79,50,1,52,50,1,11,50,1,103,255,50,1,64,175,228,50,1,187,50,203,50,2,175,50,1,148,50,1,123,50,1,111,50,1,68,50,1,43,50,1,31,50,1,11,50,1,244,50,1,219,50,1,207,50,1,27,50,59,50,75,50,107,50,139,50,187,50,6,59,50,91,50,123,50,139,50,171,50,203,50,251,50,7,47,50,1,4,50,1,55,203,
50,235,50,2,180,50,1,155,50,1,116,50,1,75,50,1,36,50,1,11,50,1,251,50,1,212,50,1,187,50,1,175,50,1,132,50,1,107,50,1,95,50,1,2,64,50,1,31,50,63,50,2,224,50,240,50,2,207,50,1,160,50,1,63,50,79,50,127,50,3,0,50,32,50,2,7,32,23,29,92,32,30,48,30,2,30,6,23,38,23,38,46,31,3,30,15,0,18,0,63,50,50,63,51,57,57,47,47,51,1,47,93,237,50,50,94,93,93,93,93,93,113,113,95,113,113,113,113,113,113,113,114,114,114,114,114,114,114,94,93,93,93,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,
93,93,93,93,93,93,93,113,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,113,113,113,95,113,113,16,222,237,50,50,18,57,17,51,51,49,48,43,43,43,43,33,17,52,54,55,54,55,6,7,14,3,7,3,35,3,46,3,39,38,39,22,23,30,1,21,17,33,17,33,19,30,1,23,22,23,54,55,62,3,55,19,33,17,5,27,3,2,3,2,21,19,8,18,17,16,6,254,210,254,6,15,17,18,9,20,22,3,3,2,4,254,250,1,139,252,10,23,11,12,14,14,13,6,12,
12,12,5,248,1,137,3,86,51,108,45,53,50,79,71,30,64,60,52,19,252,238,3,18,19,52,60,64,30,71,79,58,56,48,106,39,252,170,5,129,252,236,31,90,42,49,53,52,48,21,44,42,38,15,3,25,250,127,0,0,1,0,137,0,0,5,61,5,129,0,19,0,112,64,36,0,24,9,17,72,0,11,17,92,207,18,1,18,21,64,21,80,21,96,21,3,112,21,128,21,2,32,21,48,21,160,21,192,21,4,10,184,255,232,64,14,9,17,72,10,1,7,92,32,8,48,8,2,8,11,184,255,224,64,20,9,10,0,76,1,32,9,10,0,76,1,11,1,11,17,9,3,8,0,18,0,63,50,63,51,57,57,47,47,43,43,1,47,93,237,50,50,
43,93,113,114,16,222,113,237,50,50,43,49,48,33,1,22,23,30,1,21,17,33,17,33,1,38,39,46,1,53,17,33,17,3,227,253,154,5,4,4,5,254,250,1,81,2,111,5,4,4,5,1,6,4,61,44,44,38,88,40,252,193,5,129,251,186,42,46,39,98,50,3,51,250,127,0,2,0,84,255,236,5,227,5,150,0,19,0,39,0,119,185,0,38,255,200,179,10,0,77,38,184,255,224,179,9,0,77,32,184,255,224,179,10,0,77,32,184,255,216,64,62,9,0,77,28,24,10,0,77,22,24,10,0,77,20,91,191,0,207,0,2,0,41,48,41,64,41,96,41,112,41,128,41,160,41,6,32,41,240,41,2,30,91,192,10,1,
48,10,1,15,10,31,10,2,10,25,95,15,4,35,95,5,19,0,63,237,63,237,1,47,93,93,113,237,93,113,16,222,113,237,49,48,0,43,43,43,43,43,43,1,20,2,6,4,35,34,36,38,2,53,52,18,54,36,51,50,4,22,18,5,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,5,227,98,184,254,247,167,177,254,247,178,89,93,181,1,9,172,172,1,9,181,94,254,211,53,104,153,101,103,155,104,52,53,104,154,101,108,156,101,48,2,199,165,254,242,192,104,109,195,1,12,159,165,1,10,187,101,102,188,254,247,164,111,179,128,69,69,128,179,111,110,183,132,74,75,133,
183,0,2,0,137,0,0,5,16,5,129,0,14,0,25,0,78,185,0,12,255,248,64,47,9,0,77,15,91,0,27,48,27,96,27,112,27,128,27,4,31,27,1,20,7,90,32,8,48,8,2,8,6,95,47,20,1,20,64,14,33,72,20,20,7,19,95,9,3,7,18,0,63,63,237,18,57,47,43,93,237,1,47,93,237,50,113,113,16,222,237,49,48,0,43,1,20,14,2,35,33,17,33,17,33,50,30,2,5,52,38,35,33,17,33,50,62,2,5,16,61,126,194,133,254,162,254,217,2,121,135,198,130,63,254,215,131,131,254,207,1,57,66,95,63,30,3,195,91,169,130,77,254,16,5,129,65,118,164,104,109,113,254,55,34,62,
87,0,0,0,2,0,84,254,109,5,227,5,150,0,36,0,56,0,128,64,9,54,8,9,0,77,25,54,1,50,184,255,248,64,74,9,0,77,21,50,1,22,44,1,25,40,1,24,19,1,31,14,1,5,91,22,14,22,14,27,37,91,191,0,1,0,58,48,58,64,58,96,58,112,58,128,58,5,32,58,240,58,2,47,91,48,27,1,15,27,31,27,2,27,42,95,32,4,10,95,17,17,52,95,22,5,5,22,19,0,63,51,47,16,237,51,47,237,63,237,1,47,93,93,237,93,113,16,222,113,237,18,57,57,47,47,237,49,48,93,93,93,93,93,43,93,43,1,20,14,2,7,30,3,51,50,54,55,7,14,1,35,34,46,2,39,46,3,53,52,18,54,36,51,50,
4,22,18,5,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,5,227,71,135,194,124,20,54,68,80,46,29,60,30,2,54,118,70,95,142,105,73,27,150,225,150,75,93,181,1,9,172,172,1,9,181,94,254,211,53,104,153,101,103,155,104,52,53,104,154,101,108,156,101,48,2,199,141,237,183,121,25,58,73,41,15,5,5,202,12,16,57,103,145,88,14,118,190,252,147,165,1,10,187,101,102,188,254,247,164,111,179,128,69,69,128,179,111,110,184,132,74,75,133,184,0,2,0,137,0,0,5,157,5,129,0,17,0,28,0,112,64,75,0,40,9,10,0,76,1,16,3,18,91,11,0,17,16,
15,17,31,17,2,17,17,63,11,79,11,2,11,30,112,30,1,32,30,48,30,160,30,3,23,3,90,32,4,48,4,2,4,16,2,95,95,23,111,23,127,23,175,23,4,23,64,22,33,72,23,23,0,22,95,5,3,4,0,18,0,63,50,63,237,18,57,47,43,93,237,57,1,47,93,237,50,93,113,16,206,113,50,47,93,56,51,16,237,18,57,57,49,48,43,33,1,33,17,33,17,33,50,30,2,21,20,14,2,7,9,1,52,38,35,33,17,33,50,62,2,4,81,254,185,254,166,254,217,2,192,132,197,132,65,47,83,114,67,1,125,254,145,135,125,254,134,1,130,66,95,61,30,2,23,253,233,5,129,59,109,155,97,79,131,
102,69,16,253,176,3,209,103,100,254,96,31,57,78,0,1,0,59,255,236,5,6,5,150,0,61,0,109,185,0,59,255,232,64,66,9,0,77,33,16,9,0,77,42,90,41,50,90,31,41,31,41,31,10,19,90,0,63,11,90,15,10,31,10,79,10,95,10,111,10,5,10,19,50,5,45,95,36,42,42,36,4,16,95,5,16,11,32,11,48,11,3,48,11,64,11,2,11,11,5,19,0,63,51,47,93,113,16,237,63,51,47,16,237,18,57,57,1,47,93,237,16,222,237,18,57,57,47,47,16,237,16,237,49,48,43,43,1,20,14,2,35,34,46,2,39,37,30,3,51,50,54,53,52,46,2,39,46,5,53,52,62,2,51,50,30,2,23,5,46,1,
35,34,14,2,21,20,30,2,23,30,5,5,6,70,147,229,158,140,214,153,95,21,1,29,12,46,81,121,86,150,159,64,106,138,75,60,120,109,94,69,39,84,149,206,122,138,197,133,77,18,254,226,22,135,126,78,103,61,26,50,90,125,75,66,130,118,102,75,43,1,150,96,157,112,61,50,98,145,94,47,47,78,57,31,91,97,58,74,48,32,15,14,30,42,58,85,114,77,105,150,95,44,43,88,133,89,39,91,92,27,46,61,34,52,67,45,31,16,14,31,42,60,87,120,0,0,0,0,1,0,23,0,0,4,205,5,129,0,7,2,48,64,127,7,14,1,2,4,14,11,4,1,111,107,4,1,11,4,43,4,123,4,139,
4,155,4,5,59,11,4,27,4,91,4,107,4,171,4,187,4,6,59,4,123,4,139,4,203,4,219,4,5,27,4,43,4,59,4,91,4,107,4,123,4,171,4,235,4,251,4,9,4,1,90,203,2,219,2,235,2,3,180,2,1,11,2,75,2,91,2,155,2,4,139,2,187,2,203,2,3,2,64,42,52,72,4,2,20,2,2,11,2,144,9,1,4,9,116,9,132,9,3,164,9,180,9,244,9,3,9,184,255,192,64,255,222,225,72,107,9,123,9,2,84,9,1,59,9,1,4,9,36,9,2,204,240,9,1,212,9,228,9,2,187,9,1,132,9,148,9,164,9,3,107,9,1,84,9,1,59,9,1,4,9,20,9,2,219,9,235,9,2,176,9,192,9,2,36,9,84,9,100,9,116,9,164,9,5,
251,9,1,224,9,1,212,9,1,171,9,1,148,9,1,91,9,1,68,9,1,27,9,43,9,2,4,9,1,154,251,9,1,132,9,180,9,212,9,3,91,9,1,52,9,1,11,9,1,187,9,1,64,9,80,9,2,4,9,36,9,52,9,3,228,9,244,9,2,192,9,1,164,9,180,9,2,139,9,1,112,9,1,84,9,100,9,2,59,9,1,4,9,36,9,2,104,251,9,1,228,9,1,203,9,1,144,9,160,9,2,4,9,52,9,68,9,84,9,132,9,5,244,9,1,203,9,219,9,2,180,9,1,139,9,1,116,9,1,59,9,91,9,2,36,9,1,11,9,1,235,9,251,9,2,208,9,1,196,9,1,155,9,1,68,9,1,11,9,27,9,2,55,244,9,1,123,9,139,9,155,9,64,59,187,9,203,9,5,111,9,1,43,
9,59,9,75,9,3,4,9,1,11,9,75,9,91,9,139,9,171,9,219,9,6,255,9,1,2,143,9,207,9,223,9,3,0,9,32,9,48,9,112,9,4,7,0,4,95,5,3,1,18,0,63,63,237,50,1,94,93,93,95,93,113,114,114,114,114,114,94,93,93,93,93,93,93,113,113,113,113,113,113,113,113,114,114,114,114,114,94,93,93,93,93,93,93,93,93,113,113,113,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,113,114,114,114,114,114,114,114,114,94,93,93,93,93,43,93,113,113,47,94,93,43,93,113,114,114,237,198,93,113,114,94,93,114,94,93,43,1,24,16,77,230,49,48,
1,17,33,17,33,53,33,21,3,5,254,217,254,57,4,182,4,157,251,99,4,157,228,228,0,0,0,1,0,123,255,236,5,74,5,129,0,25,0,75,64,53,19,90,224,20,240,20,2,20,27,64,27,80,27,96,27,3,112,27,128,27,2,32,27,48,27,160,27,192,27,4,7,90,15,6,1,239,6,255,6,2,32,6,48,6,2,6,19,6,3,13,95,0,19,0,63,237,63,51,1,47,93,93,114,237,93,113,114,16,222,93,237,49,48,5,34,46,2,53,17,33,17,20,30,2,51,50,62,2,53,17,33,17,20,14,2,2,211,132,220,159,89,1,39,44,82,116,71,72,121,87,48,1,39,94,168,231,20,63,133,208,144,3,113,252,166,89,
129,83,39,41,86,132,91,3,80,252,158,145,212,139,67,0,0,0,0,1,0,14,0,0,5,72,5,129,0,16,0,163,181,15,16,10,0,77,3,184,255,240,64,15,9,10,0,76,1,32,10,0,77,1,24,9,0,77,0,184,255,240,179,10,0,77,0,184,255,232,64,49,9,0,77,192,18,1,159,18,1,96,18,1,47,18,1,1,0,9,9,2,15,16,16,47,16,95,16,2,112,16,160,16,176,16,224,16,4,16,16,48,16,96,16,192,16,4,16,3,2,184,255,240,64,33,63,2,111,2,127,2,159,2,175,2,191,2,239,2,255,2,8,15,2,31,2,159,2,3,2,9,9,1,15,2,3,1,18,0,63,63,51,18,57,47,1,47,93,113,56,51,47,93,113,
114,56,51,18,57,17,51,51,93,93,93,93,49,48,43,43,43,43,43,43,41,1,1,33,1,30,1,23,22,23,54,55,62,1,55,1,33,3,66,254,213,253,247,1,52,1,34,14,26,11,12,11,10,11,10,27,14,1,33,1,49,5,129,252,119,45,94,39,46,42,41,45,38,95,47,3,137,0,0,0,1,0,2,0,0,7,139,5,129,0,48,2,166,185,0,33,255,232,64,17,9,10,0,76,32,24,9,10,0,76,47,24,9,10,0,76,18,184,255,232,180,9,10,0,76,15,184,255,240,64,17,9,10,0,76,16,40,9,10,0,76,1,16,9,10,0,76,0,184,255,216,64,32,9,10,0,76,1,0,41,33,32,7,16,15,24,24,7,41,3,17,47,48,16,6,48,
22,48,2,11,48,48,50,18,17,184,255,240,64,255,121,17,185,17,2,153,17,217,17,2,139,17,1,9,17,73,17,2,36,17,107,50,1,57,50,89,50,2,43,50,1,25,50,1,233,50,1,198,50,1,73,50,105,50,137,50,169,50,4,59,50,1,9,50,41,50,2,207,9,50,1,87,139,50,1,121,50,1,102,50,1,73,50,1,59,50,1,38,50,1,9,50,1,198,251,50,1,201,50,233,50,2,187,50,1,137,50,169,50,2,123,50,1,25,50,57,50,89,50,105,50,4,217,50,249,50,2,203,50,1,153,50,185,50,2,139,50,1,125,50,1,1,91,50,1,63,50,79,50,2,36,50,1,11,50,1,107,50,139,50,171,50,203,50,
235,50,5,95,50,1,27,50,43,50,75,50,3,15,50,1,150,4,50,1,87,180,50,1,155,50,1,143,50,1,116,50,1,91,50,1,79,50,1,27,50,59,50,2,15,50,1,219,50,251,50,2,207,50,1,107,50,139,50,171,50,3,95,50,1,52,50,1,27,50,1,244,50,1,219,50,1,207,50,1,180,50,1,139,50,1,4,50,36,50,68,50,100,50,4,106,251,50,1,212,50,64,164,1,187,50,1,144,50,1,132,50,1,107,50,1,80,50,1,68,50,1,43,50,1,4,50,1,235,50,1,196,50,1,139,50,171,50,2,20,50,52,50,84,50,116,50,4,251,50,1,212,50,1,187,50,1,175,50,1,148,50,1,123,50,1,111,50,1,80,50,
1,68,50,1,43,50,1,4,50,1,57,180,50,212,50,244,50,3,155,50,1,116,50,1,75,50,91,50,2,48,50,1,36,50,1,11,50,1,240,50,1,2,224,50,1,207,50,1,160,50,1,79,50,111,50,143,50,3,16,50,1,240,50,1,223,50,1,176,50,1,159,50,1,112,50,1,15,50,79,50,95,50,3,8,41,24,7,24,7,47,32,17,3,16,0,18,0,63,50,63,51,51,57,57,47,47,51,1,94,93,93,93,93,93,93,113,113,113,113,113,95,113,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,113,
113,113,113,113,113,114,114,114,114,114,114,114,114,94,93,94,93,93,93,93,113,113,113,113,95,113,113,113,113,113,114,114,114,114,114,114,94,93,93,93,93,93,93,93,94,93,94,93,93,93,93,93,113,113,113,113,47,94,93,93,93,113,56,51,17,51,47,94,93,56,51,18,23,57,17,51,51,17,51,51,17,51,51,49,48,43,43,43,43,43,43,43,43,41,1,3,46,1,39,38,39,6,7,14,3,7,3,33,1,33,19,30,1,23,22,23,54,55,62,3,55,19,33,19,30,3,23,22,23,54,55,62,1,55,19,33,6,31,254,162,191,9,21,9,11,9,11,11,5,10,11,9,5,190,254,162,254,149,1,43,176,
15,26,11,12,10,15,14,6,14,13,13,5,174,1,74,178,6,12,12,12,5,12,12,12,13,11,28,14,170,1,43,3,47,37,102,48,55,59,59,56,24,51,49,44,18,252,209,5,129,252,240,64,124,49,57,52,74,70,30,64,62,57,23,2,238,253,18,24,59,63,63,30,70,71,56,60,51,122,57,3,16,0,0,0,0,1,0,18,0,0,5,68,5,129,0,11,0,142,64,23,23,6,1,23,2,1,24,0,1,7,4,10,3,1,1,11,8,9,9,16,6,5,5,184,255,240,64,43,176,9,1,9,5,9,5,0,11,16,47,11,95,11,143,11,3,15,11,63,11,111,11,159,11,207,11,255,11,6,223,11,1,16,11,32,11,48,11,3,11,2,3,184,255,240,64,
18,15,3,31,3,2,3,10,7,1,4,4,3,8,5,3,3,0,18,0,63,50,63,51,18,57,25,47,51,51,51,1,24,47,93,56,50,47,93,93,113,114,56,51,57,57,47,47,113,56,17,51,56,17,51,17,57,17,23,51,49,48,93,93,93,33,9,1,33,9,1,33,9,1,33,9,1,4,14,254,158,254,158,254,200,1,232,254,65,1,56,1,57,1,57,1,54,254,84,1,213,2,49,253,207,2,229,2,156,254,14,1,242,253,100,253,27,0,1,0,35,0,0,5,53,5,129,0,8,1,167,64,13,6,2,7,8,16,8,14,1,2,4,14,5,4,184,255,240,64,255,11,4,27,4,75,4,91,4,139,4,155,4,203,4,219,4,8,11,4,27,4,43,4,75,4,91,4,107,
4,139,4,155,4,171,4,203,4,219,4,11,4,1,90,4,2,20,2,164,2,3,11,2,43,10,59,10,91,10,3,20,10,1,11,10,59,10,75,10,107,10,123,10,187,10,203,10,251,10,8,206,27,10,43,10,59,10,107,10,155,10,171,10,251,10,7,187,10,219,10,235,10,3,148,10,1,75,10,123,10,2,11,10,123,10,139,10,187,10,235,10,251,10,6,156,251,10,1,228,10,1,11,10,27,10,59,10,75,10,139,10,155,10,203,10,7,244,10,1,91,10,171,10,219,10,3,4,10,36,10,52,10,3,4,10,20,10,52,10,68,10,116,10,132,10,164,10,196,10,244,10,9,108,164,10,180,10,212,10,228,10,4,
139,10,1,112,10,1,2,0,10,48,10,96,10,3,176,10,224,10,240,10,3,159,10,1,0,10,64,10,112,10,128,10,4,240,10,1,223,10,1,0,10,16,10,48,10,128,10,144,10,192,10,6,58,255,10,1,160,10,208,10,224,10,3,127,64,68,10,1,32,10,80,10,2,15,10,1,176,10,224,10,240,10,3,143,10,1,96,10,112,10,2,79,10,1,48,10,1,31,10,1,192,10,240,10,2,159,10,1,112,10,128,10,2,95,10,1,0,10,48,10,64,10,3,6,6,0,3,3,1,8,4,7,1,18,0,63,63,51,18,57,47,51,51,47,1,93,93,93,93,93,113,113,113,113,113,113,114,114,114,114,114,94,93,93,93,113,113,113,
114,95,114,114,114,94,93,113,113,113,114,114,114,94,93,113,113,113,114,94,93,113,113,47,94,93,237,198,93,113,56,50,43,1,24,16,77,230,56,50,18,57,49,48,1,17,33,17,1,33,9,1,33,3,63,254,218,254,10,1,53,1,82,1,86,1,53,2,66,253,190,2,66,3,63,253,172,2,84,0,1,0,61,0,0,4,168,5,129,0,9,0,112,185,0,8,255,224,179,10,0,77,8,184,255,240,64,16,9,0,77,3,40,10,0,77,3,32,9,0,77,3,7,4,184,255,192,64,15,18,26,72,4,7,4,7,1,0,11,143,11,1,2,11,184,255,192,64,25,13,25,72,8,15,1,31,1,2,1,64,13,16,72,1,7,4,95,5,3,2,8,95,
1,18,0,63,237,50,63,237,50,1,47,43,93,51,43,95,113,16,206,17,57,57,47,47,43,17,51,49,48,43,43,43,43,41,1,53,1,33,53,33,21,1,33,4,168,251,149,2,250,253,82,3,246,253,6,3,35,209,3,201,231,205,252,51,0,0,0,0,1,0,115,254,87,2,145,5,204,0,7,0,43,64,25,6,16,2,1,2,2,5,240,31,0,1,32,0,48,0,2,0,4,245,1,0,5,245,0,27,0,63,237,63,237,1,47,93,113,237,51,47,93,196,49,48,19,17,33,21,33,17,33,21,115,2,30,254,236,1,20,254,87,7,117,190,250,8,191,0,1,0,21,255,215,2,38,5,205,0,3,0,44,64,19,0,16,10,0,77,0,8,9,0,77,0,3,
16,16,3,1,3,2,1,184,255,240,179,1,1,0,0,0,47,63,1,47,56,51,47,93,56,51,49,48,43,43,5,1,51,1,1,51,254,226,238,1,35,41,5,246,250,10,0,0,0,1,0,25,254,87,2,55,5,204,0,7,0,41,64,24,4,31,0,1,0,0,7,240,32,2,48,2,64,2,3,2,4,245,5,0,1,245,0,27,0,63,237,63,237,1,47,93,237,50,47,93,196,49,48,19,53,33,17,33,53,33,17,25,1,22,254,234,2,30,254,87,191,5,248,190,248,139,0,0,0,1,0,45,2,2,4,127,5,129,0,6,0,69,185,0,5,255,232,64,20,10,0,77,4,24,10,0,77,5,4,1,1,3,0,6,16,6,8,2,3,184,255,240,64,12,3,64,14,22,72,3,3,0,0,
1,4,3,0,63,51,51,47,50,1,47,43,56,51,16,206,56,50,17,57,61,47,51,51,49,48,43,43,9,2,35,1,33,1,3,154,254,186,254,188,227,1,135,1,66,1,137,2,2,2,240,253,16,3,127,252,129,0,1,255,236,255,6,4,133,255,84,0,3,0,18,183,2,0,0,187,0,1,1,1,0,47,114,237,1,47,47,49,48,7,53,33,21,20,4,153,250,78,78,0,0,0,1,0,66,4,159,2,63,5,222,0,5,0,48,64,33,0,131,5,132,3,130,112,2,160,2,2,2,3,140,15,0,1,15,0,47,0,63,0,95,0,127,0,159,0,239,0,7,0,0,47,93,113,237,1,47,93,237,253,237,49,48,9,1,53,33,19,21,1,150,254,172,1,2,251,
4,159,1,20,43,254,224,31,0,0,2,0,60,255,236,4,128,4,78,0,53,0,68,0,137,182,49,24,9,12,0,76,31,184,255,240,64,37,9,0,77,7,16,9,0,77,3,24,9,11,0,76,54,50,11,70,34,192,41,208,41,2,41,41,34,70,191,70,1,79,70,1,22,71,23,184,255,192,64,41,21,24,72,23,23,60,71,5,64,13,16,72,5,55,82,10,10,28,63,31,22,47,22,127,22,143,22,4,22,22,17,81,28,16,39,63,79,50,47,0,22,0,63,50,50,237,50,63,237,51,47,93,17,18,57,47,237,1,47,43,237,51,47,43,237,93,113,16,204,50,47,93,16,237,50,50,49,48,43,43,43,43,5,34,46,2,53,52,62,
2,63,1,53,52,46,2,35,34,14,2,7,37,62,3,51,50,30,2,21,17,20,30,2,51,50,55,21,14,3,35,34,38,39,35,14,1,19,7,14,3,21,20,22,51,50,62,2,53,1,137,78,123,86,46,67,116,156,88,233,21,40,59,38,35,55,40,25,5,254,219,12,64,113,165,111,101,158,110,58,7,19,35,28,32,30,25,40,40,45,30,106,101,10,6,56,175,202,144,45,81,61,36,71,59,54,88,61,34,20,43,83,122,78,96,131,81,37,1,4,55,59,79,50,21,14,35,59,45,14,71,117,86,47,50,99,144,95,254,118,38,60,41,21,6,152,6,10,6,4,104,101,101,112,2,9,2,2,11,35,66,57,77,75,46,75,98,
51,0,2,0,135,255,236,4,143,5,204,0,36,0,52,0,77,64,20,37,71,207,0,223,0,2,0,54,112,54,1,22,10,45,70,208,20,1,20,184,255,192,179,36,40,72,20,184,255,192,64,18,9,12,72,20,40,79,28,32,16,21,0,17,21,50,79,10,5,22,0,63,51,237,63,63,63,51,237,1,47,43,43,93,237,50,50,113,16,222,113,237,49,48,1,20,14,2,35,34,46,2,39,35,20,14,2,7,33,62,1,53,17,33,17,20,6,7,6,7,51,62,1,51,50,30,2,5,52,38,35,34,14,2,21,20,30,2,51,50,54,4,143,49,102,157,107,48,96,86,72,26,2,3,4,5,2,254,239,3,5,1,25,1,1,1,1,4,51,178,117,104,150,
97,46,254,219,108,113,43,84,66,40,40,64,84,43,107,116,2,33,123,207,151,84,20,46,74,54,21,54,51,40,8,35,129,83,4,213,254,98,32,61,26,30,27,112,96,83,149,204,121,184,178,34,85,143,109,106,140,84,34,177,0,1,0,80,255,236,4,55,4,78,0,32,0,55,64,30,16,70,15,15,27,70,79,28,1,28,34,22,71,5,19,79,10,16,16,10,16,64,27,1,27,27,24,79,0,22,0,63,237,51,47,93,63,51,47,16,237,1,47,237,16,222,93,237,51,47,237,49,48,5,34,46,2,53,52,62,2,51,50,30,2,23,5,46,1,35,34,6,21,16,51,50,54,55,5,14,3,2,82,129,193,128,64,70,132,
193,123,105,163,118,73,14,254,229,12,96,88,113,104,221,80,108,13,1,26,10,71,121,172,20,80,146,205,124,135,211,145,76,56,97,132,76,14,83,99,186,177,254,138,101,100,13,75,137,105,63,0,2,0,84,255,236,4,92,5,204,0,36,0,53,0,68,64,42,31,5,37,70,223,33,1,33,64,36,40,72,33,55,112,55,1,47,71,192,14,208,14,2,48,14,1,14,31,0,42,79,24,19,16,49,79,5,9,22,0,21,0,63,63,51,237,63,51,237,63,1,47,93,113,237,113,16,222,43,93,237,50,50,49,48,33,46,3,53,35,14,1,35,34,46,2,53,52,62,2,51,50,30,2,23,51,52,38,52,38,53,17,
33,17,20,22,23,1,52,46,2,35,34,14,2,21,16,51,50,62,2,3,76,2,5,5,3,4,49,175,122,102,149,97,47,49,102,157,108,53,98,84,68,24,2,1,1,1,25,6,2,254,227,40,65,83,43,54,83,57,29,221,42,84,66,41,8,41,52,54,21,105,91,84,150,205,121,123,206,149,84,22,46,72,51,10,39,50,54,25,1,139,251,32,79,123,34,2,35,107,141,83,33,42,90,140,99,254,144,36,86,145,0,0,0,0,2,0,80,255,236,4,45,4,78,0,30,0,39,0,79,182,25,70,26,26,37,70,16,184,255,192,64,39,39,43,72,16,41,47,41,79,41,95,41,111,41,159,41,5,36,17,71,5,17,82,36,36,22,
31,82,10,16,22,81,0,16,25,1,25,25,0,22,0,63,50,47,93,16,237,63,237,18,57,47,237,1,47,237,50,93,16,222,43,237,51,47,237,49,48,5,34,46,2,53,52,62,2,51,50,30,2,29,1,33,20,30,2,51,50,54,55,5,14,3,3,34,14,2,7,33,46,1,2,74,117,187,132,70,83,141,184,102,128,181,116,54,253,74,24,54,86,61,74,94,20,1,9,18,65,108,161,115,43,75,55,34,2,1,164,8,110,20,69,141,213,143,155,212,131,58,89,160,223,135,8,68,117,85,49,63,66,23,46,104,87,57,3,177,29,63,100,70,131,131,0,1,0,35,0,0,2,174,5,204,0,27,0,87,185,0,10,255,224,
64,29,9,10,0,76,191,29,1,128,29,1,27,27,95,15,1,15,15,25,1,70,2,6,2,4,4,48,2,1,2,184,255,192,64,16,16,19,72,2,19,81,12,0,0,4,79,25,5,15,1,21,0,63,63,51,237,50,63,237,1,47,43,113,51,47,17,51,16,237,50,50,47,93,51,47,93,113,49,48,0,43,1,17,33,17,35,53,51,53,52,62,2,51,50,22,23,21,46,1,35,34,14,2,29,1,51,21,1,217,254,232,158,158,30,72,122,91,48,93,37,18,45,19,39,51,29,12,213,3,124,252,132,3,124,190,113,62,105,78,44,10,6,181,4,5,16,32,49,32,85,190,0,0,2,0,84,254,78,4,90,4,79,0,51,0,69,0,84,64,51,36,14,
52,70,223,47,1,47,64,36,40,72,47,71,112,71,1,6,70,5,5,62,71,192,28,208,28,2,48,28,1,28,42,15,57,79,36,33,16,65,79,19,23,21,9,81,0,6,6,0,27,0,63,50,47,16,237,63,51,237,63,51,237,63,1,47,93,113,237,51,47,237,113,16,222,43,93,237,50,50,49,48,1,34,46,2,39,37,30,1,51,50,62,2,53,60,1,55,54,53,35,14,1,35,34,46,2,53,52,62,2,51,50,22,23,51,52,62,2,55,33,14,1,21,17,20,14,2,19,52,46,2,35,34,14,2,21,20,22,51,50,62,2,2,84,107,163,115,69,13,1,25,15,99,80,50,83,59,33,1,1,2,49,177,122,103,149,98,47,50,103,157,108,
108,171,48,5,3,4,5,2,1,10,2,4,68,131,191,113,40,64,83,42,54,83,58,30,112,111,42,83,66,40,254,78,43,77,107,64,33,65,74,28,67,110,81,28,58,24,28,26,105,94,81,145,201,121,125,203,146,79,92,103,21,55,51,40,7,36,130,84,252,225,118,175,116,58,3,222,102,136,82,34,42,88,136,94,175,178,33,83,138,0,1,0,143,0,0,4,100,5,204,0,31,0,97,185,0,5,255,224,64,38,8,0,77,10,70,224,9,240,9,2,9,33,144,33,160,33,2,112,33,144,33,160,33,176,33,240,33,5,239,33,1,26,22,70,208,23,1,23,184,255,192,179,36,40,72,23,184,255,192,
64,14,8,12,72,23,24,0,23,9,21,31,16,80,3,16,0,63,237,51,63,51,63,1,47,43,43,93,237,50,93,113,114,16,222,93,237,49,48,0,43,1,62,1,51,50,30,2,21,17,33,17,52,46,2,35,34,14,2,21,17,33,17,33,17,20,14,2,7,1,164,57,172,119,98,135,85,38,254,232,20,46,74,53,51,83,60,33,254,231,1,25,2,3,2,1,3,98,124,112,64,112,152,88,253,82,2,94,63,105,75,42,45,83,115,69,253,189,5,204,254,107,32,65,57,46,13,0,0,0,0,2,0,143,0,0,1,168,5,204,0,3,0,7,0,79,64,54,1,5,70,2,191,6,1,112,6,1,223,6,1,6,9,64,9,80,9,2,160,9,176,9,2,127,
9,1,96,9,1,31,9,1,239,9,1,128,9,176,9,192,9,208,9,4,5,15,4,21,0,83,1,0,0,63,237,63,63,1,93,93,113,113,113,113,114,16,222,93,113,113,50,237,50,49,48,19,53,33,21,1,17,33,17,143,1,25,254,231,1,25,4,253,207,207,251,3,4,58,251,198,0,2,255,224,254,87,1,169,5,204,0,3,0,23,0,172,64,133,22,32,9,10,0,76,8,8,1,17,70,2,143,18,1,175,18,191,18,239,18,255,18,4,96,18,1,207,18,1,0,18,1,10,18,25,176,25,192,25,2,175,25,1,16,25,64,25,80,25,128,25,4,80,25,96,25,144,25,208,25,4,239,25,1,0,25,16,25,64,25,80,25,112,25,128,
25,144,25,176,25,192,25,9,56,207,25,223,25,255,25,3,96,25,160,25,2,15,25,63,25,127,25,159,25,191,25,5,160,25,208,25,224,25,3,15,25,31,25,63,25,3,7,17,15,11,80,4,27,0,83,1,0,0,63,237,63,237,63,1,94,93,93,113,114,114,94,93,93,113,114,114,114,16,222,94,93,93,113,113,114,50,237,50,50,47,49,48,0,43,19,53,33,21,1,34,38,39,53,30,1,51,50,62,2,53,17,33,17,20,14,2,144,1,25,254,225,56,83,31,13,26,12,39,48,28,10,1,25,32,69,109,4,253,207,207,249,90,5,4,198,2,2,16,38,62,46,4,118,251,70,65,108,80,44,0,0,0,0,1,0,
143,0,0,4,117,5,204,0,11,0,142,64,36,28,0,1,26,1,1,87,10,103,10,2,5,10,1,10,8,1,10,1,11,8,9,38,0,54,0,70,0,150,0,4,9,0,11,16,11,184,255,192,64,16,9,12,72,11,11,13,47,13,1,7,3,70,208,4,1,4,184,255,192,179,36,40,72,4,184,255,192,64,28,9,12,72,4,123,1,139,1,2,1,32,19,25,72,2,7,10,1,1,7,7,8,15,5,0,4,0,21,0,63,50,63,63,57,47,57,17,51,17,51,43,93,1,47,43,43,93,237,50,93,17,51,47,43,56,51,51,93,17,51,17,57,57,49,48,93,93,93,93,93,33,1,7,17,33,17,33,17,1,33,9,1,3,66,254,223,121,254,231,1,25,1,130,1,46,254,
132,1,153,1,234,84,254,106,5,204,252,174,1,192,254,90,253,108,0,1,0,143,0,0,1,168,5,204,0,3,0,69,64,48,1,70,191,2,1,112,2,1,223,2,1,2,5,64,5,80,5,2,160,5,176,5,2,127,5,1,96,5,1,31,5,1,239,5,1,128,5,176,5,192,5,208,5,4,1,0,0,21,0,63,63,1,93,93,113,113,113,113,114,16,222,93,113,113,237,49,48,51,17,33,17,143,1,25,5,204,250,52,0,0,0,1,0,135,0,0,6,158,4,79,0,57,0,168,185,0,40,255,240,180,9,10,0,76,31,184,255,224,64,85,9,10,0,76,32,57,70,0,0,13,45,70,228,44,244,44,2,44,59,84,59,132,59,212,59,228,59,4,59,
59,1,155,59,187,59,219,59,3,84,59,1,59,59,1,47,59,1,2,31,59,1,0,59,1,176,59,208,59,224,59,3,159,59,1,96,59,128,59,2,47,59,1,25,12,70,0,13,32,13,48,13,208,13,4,13,184,255,192,64,19,36,40,72,13,51,6,80,25,33,38,3,29,16,19,15,45,13,0,21,0,63,50,50,63,63,23,51,237,50,1,47,43,93,237,50,93,93,93,93,113,113,95,113,113,113,113,114,114,16,222,93,237,17,57,47,237,50,49,48,0,43,43,33,17,52,46,2,35,34,14,2,21,17,33,17,52,46,2,39,33,30,3,21,51,62,1,51,50,22,23,51,62,3,51,50,30,2,21,17,33,17,52,46,2,35,34,14,2,
7,17,3,12,17,39,63,45,43,70,51,28,254,231,1,3,2,2,1,12,2,4,4,3,4,52,155,108,124,151,26,6,29,67,81,95,56,89,123,77,35,254,233,17,39,63,45,42,69,51,28,2,2,95,63,105,75,42,45,83,115,69,253,188,3,72,35,74,67,53,13,12,53,64,64,22,124,112,121,115,67,90,55,24,64,112,152,88,253,81,2,95,63,105,75,42,43,79,110,67,253,175,0,0,0,1,0,135,0,0,4,100,4,79,0,35,0,97,185,0,31,255,224,64,38,8,0,77,0,70,224,35,240,35,2,35,37,144,37,160,37,2,112,37,144,37,160,37,176,37,240,37,5,239,37,1,25,12,70,208,13,1,13,184,255,192,
179,36,40,72,13,184,255,192,64,14,8,12,72,13,25,6,80,29,16,19,15,13,0,21,0,63,50,63,63,237,51,1,47,43,43,93,237,50,93,113,114,16,222,93,237,49,48,0,43,33,17,52,46,2,35,34,14,2,21,17,33,17,52,46,2,39,33,30,3,21,51,62,1,51,50,30,2,21,17,3,76,20,46,74,53,51,83,60,33,254,231,1,3,2,2,1,12,2,4,4,3,4,57,172,119,98,135,85,38,2,95,63,105,75,42,45,83,115,69,253,188,3,72,35,74,67,53,13,12,53,64,64,22,124,112,64,112,152,88,253,81,0,0,2,0,80,255,236,4,147,4,78,0,19,0,35,0,36,64,20,20,71,0,37,96,37,112,37,2,26,
71,10,23,79,15,16,31,79,5,22,0,63,237,63,237,1,47,237,113,16,222,237,49,48,1,20,14,2,35,34,46,2,53,52,62,2,51,50,30,2,5,52,38,35,34,6,21,20,30,2,51,50,62,2,4,147,69,138,206,137,132,202,137,70,67,136,206,138,146,206,131,61,254,218,126,120,124,132,35,64,90,54,62,97,66,34,2,30,124,206,149,83,82,148,207,125,121,205,150,84,84,149,205,122,193,174,176,191,97,140,90,43,43,90,140,0,0,2,0,135,254,87,4,143,4,81,0,36,0,54,0,93,185,0,34,255,224,64,28,8,0,77,3,32,8,0,77,37,71,207,0,223,0,2,0,56,112,56,1,45,28,
17,70,208,18,1,18,184,255,192,179,36,40,72,18,184,255,192,64,18,8,12,72,18,40,79,28,32,16,22,15,17,27,50,79,10,5,22,0,63,51,237,63,63,63,51,237,1,47,43,43,93,237,50,50,113,16,222,113,237,49,48,0,43,43,1,20,14,2,35,34,46,2,39,35,30,3,21,17,33,17,52,38,39,33,30,3,21,51,62,1,51,50,30,2,5,52,38,35,34,14,2,21,20,30,2,51,50,62,2,4,143,49,102,157,107,48,95,86,73,26,6,1,2,2,1,254,231,5,3,1,17,2,5,3,2,4,51,178,117,103,150,97,47,254,219,112,111,42,83,65,41,40,65,82,42,54,84,57,30,2,34,123,208,150,85,20,45,
73,54,5,40,53,59,25,254,97,4,234,83,130,36,7,40,52,56,21,107,92,84,148,205,122,185,179,35,85,143,109,106,141,84,35,43,91,142,0,0,0,2,0,84,254,87,4,90,4,79,0,33,0,50,0,68,64,42,34,12,19,70,223,18,1,18,64,36,40,72,18,52,112,52,1,44,71,192,0,208,0,2,48,0,1,0,46,79,25,29,22,19,27,14,15,39,79,8,5,16,0,63,51,237,63,63,63,51,237,1,47,93,113,237,113,16,222,43,93,237,50,50,49,48,19,52,62,2,51,50,22,23,52,62,2,55,33,14,1,21,17,33,17,52,54,55,54,55,35,14,1,35,34,46,2,37,52,46,2,35,34,14,2,21,16,51,50,62,2,84,
50,103,157,108,108,171,48,3,5,5,2,1,14,2,4,254,233,2,1,1,1,2,49,182,122,102,149,97,47,2,235,40,64,83,42,54,83,58,30,223,42,83,66,40,2,28,123,207,149,84,92,103,21,55,51,40,7,36,130,83,251,22,1,194,28,54,23,26,24,105,95,84,150,205,127,108,140,83,33,42,90,140,98,254,144,36,86,144,0,0,0,1,0,135,0,0,2,254,4,79,0,29,0,94,185,0,15,255,232,180,9,10,0,76,21,184,255,192,64,28,9,12,72,21,21,31,127,31,159,31,2,208,31,1,47,31,95,31,175,31,3,12,29,70,208,0,1,0,184,255,192,179,36,40,72,0,184,255,192,64,13,9,12,
72,0,25,80,12,18,16,7,15,0,21,0,63,63,63,51,237,1,47,43,43,93,237,50,93,93,113,17,51,47,43,49,48,0,43,51,17,52,46,2,39,33,30,3,21,51,62,3,51,50,22,23,21,46,1,35,34,6,21,17,143,1,3,2,2,1,12,2,4,4,3,4,21,42,57,80,59,25,49,13,27,55,38,105,117,3,60,35,78,71,57,13,12,59,70,69,21,59,93,65,35,9,6,235,6,9,170,167,253,237,0,0,1,0,72,255,236,4,31,4,79,0,59,0,152,185,0,58,255,232,64,10,9,0,77,33,16,9,10,0,76,2,184,255,240,64,10,9,0,77,50,70,31,42,70,41,31,184,255,192,64,70,25,32,72,31,41,31,41,10,21,70,207,
0,223,0,2,79,0,1,0,61,80,61,1,48,61,176,61,2,64,61,1,47,61,1,11,70,10,50,21,5,47,81,36,210,42,1,112,42,1,31,42,47,42,2,42,42,36,16,16,81,5,16,11,32,11,2,11,11,5,22,0,63,51,47,93,16,237,63,51,47,93,93,93,16,237,18,57,57,1,47,237,93,93,113,114,16,222,93,113,237,18,57,57,47,47,43,16,237,16,237,49,48,43,43,43,1,20,14,2,35,34,46,2,39,55,30,3,51,50,62,2,53,52,46,2,39,46,3,53,52,62,2,51,50,30,2,23,7,46,3,35,34,6,21,20,30,2,23,30,3,4,31,65,124,180,115,103,166,125,84,21,247,12,42,62,83,53,48,83,61,34,49,85,
115,65,68,132,104,64,60,116,171,111,88,152,120,81,16,249,7,36,53,70,42,100,100,41,75,103,61,75,145,113,69,1,60,78,124,87,47,30,69,110,81,37,45,56,30,10,11,27,49,37,42,49,31,23,15,15,42,72,111,85,77,121,85,45,33,71,110,78,26,39,51,30,11,51,60,37,44,29,21,15,16,43,75,118,0,0,0,1,0,25,255,238,2,145,5,56,0,23,0,84,64,51,2,40,9,10,0,76,12,12,95,20,1,20,20,10,14,70,3,7,3,5,5,79,3,95,3,111,3,3,3,64,38,44,72,160,3,1,3,13,5,79,6,10,6,8,8,6,15,17,79,0,22,0,63,237,63,51,47,17,51,16,237,50,1,47,93,43,113,51,
47,17,51,16,237,50,50,47,93,51,47,49,48,43,5,34,38,53,17,35,53,51,55,51,21,51,21,35,17,20,22,51,50,54,55,21,14,1,1,164,124,134,137,151,88,176,205,205,60,63,26,42,26,52,116,18,135,137,2,126,190,254,254,190,253,206,79,75,8,6,174,17,17,0,0,0,0,1,0,127,255,236,4,92,4,58,0,27,0,85,0,177,21,8,63,177,2,8,63,176,11,205,177,7,15,63,176,16,51,1,176,28,47,176,6,214,176,9,205,176,9,16,176,15,220,177,24,27,50,50,176,18,205,176,18,16,176,23,205,176,23,47,176,18,16,176,29,214,177,23,15,17,18,176,0,57,0,177,11,21,
17,18,176,23,57,176,7,17,177,0,27,57,57,48,49,37,6,35,34,39,38,53,17,33,17,16,51,50,55,54,53,17,33,17,20,23,33,46,1,47,1,38,53,3,63,107,241,184,91,81,1,25,192,101,63,63,1,25,8,254,244,1,5,2,2,2,215,235,120,105,190,2,175,253,161,254,227,86,88,138,2,68,252,184,138,104,12,53,32,64,32,22,0,1,0,8,0,0,4,106,4,58,0,6,0,30,0,177,4,8,63,177,5,15,63,176,1,51,1,176,7,47,176,8,214,0,177,5,4,17,18,176,0,57,48,49,37,1,33,1,33,1,33,2,53,1,15,1,38,254,113,254,176,254,125,1,41,227,3,87,251,198,4,58,0,1,255,250,0,
0,6,61,4,58,0,12,0,108,0,177,10,8,63,177,7,9,51,51,177,11,15,63,178,1,2,4,51,51,51,1,176,13,47,176,14,214,176,54,26,185,62,13,240,82,10,176,1,46,14,176,0,192,177,8,79,249,5,176,9,192,185,193,234,240,118,10,176,7,46,177,9,8,8,176,8,192,14,177,3,79,249,5,176,2,192,3,0,178,0,3,8,46,46,46,1,182,0,1,2,3,7,8,9,46,46,46,46,46,46,46,176,64,26,0,48,49,1,19,33,27,1,33,1,33,11,1,33,1,33,1,180,209,1,45,207,184,1,4,254,228,254,215,219,226,254,215,254,232,1,8,0,255,3,59,252,197,3,59,251,198,3,114,252,142,4,58,
0,1,0,14,0,0,4,100,4,58,0,11,0,186,182,8,24,9,10,0,76,6,184,255,232,180,9,10,0,76,2,184,255,232,64,51,9,10,0,76,0,24,9,10,0,76,7,3,8,10,11,6,11,1,9,2,4,3,8,1,10,9,2,9,7,4,3,8,3,7,4,10,3,1,1,11,3,8,9,0,9,11,16,144,11,1,11,184,255,192,64,11,10,13,72,11,11,13,6,5,5,2,3,184,255,240,64,29,79,3,159,3,2,3,240,13,1,224,13,1,79,13,159,13,2,1,7,10,3,4,4,8,5,15,3,0,21,0,63,50,63,51,57,25,47,23,51,1,93,93,113,24,47,93,56,51,51,17,51,17,51,47,43,93,56,51,51,17,51,17,18,57,17,23,51,16,135,192,192,16,135,192,192,
2,8,192,8,192,16,135,192,8,192,49,48,1,43,43,43,43,33,11,1,33,9,1,33,27,1,33,9,1,3,51,252,254,254,213,1,140,254,135,1,47,231,230,1,49,254,135,1,143,1,136,254,120,2,47,2,11,254,158,1,98,253,248,253,206,0,1,0,16,254,87,4,104,4,58,0,19,0,35,0,185,0,7,1,36,63,176,12,205,177,18,15,63,176,1,51,1,176,20,47,176,21,214,0,177,18,12,17,18,176,0,57,48,49,37,19,33,1,6,7,6,35,34,39,53,22,50,54,55,54,63,1,1,33,2,72,250,1,38,254,84,81,87,95,154,101,76,53,85,64,26,51,41,18,254,84,1,41,241,3,73,251,141,197,82,89,13,
200,8,18,21,42,102,48,4,47,0,0,1,0,68,0,0,3,199,4,58,0,9,0,80,64,50,2,71,6,7,71,1,239,6,255,6,2,3,6,3,6,1,8,8,11,64,11,1,192,11,208,11,2,127,11,1,15,1,31,1,79,1,95,1,4,1,6,3,80,4,15,1,7,80,0,21,0,63,237,50,63,237,50,1,47,93,93,113,114,16,206,47,17,57,57,47,47,93,16,237,16,237,49,48,51,53,1,33,53,33,21,1,33,21,68,2,28,254,13,3,41,253,231,2,74,199,2,168,203,201,253,92,205,0,0,1,0,33,254,87,2,242,5,204,0,45,0,87,64,54,2,40,9,10,0,76,19,40,9,10,0,76,33,11,22,44,44,28,40,240,5,95,11,1,11,11,17,143,5,159,
5,175,5,3,48,5,80,5,2,5,34,11,245,12,12,43,24,245,21,0,43,245,0,27,0,63,237,63,237,18,57,47,237,57,1,47,93,93,51,51,47,93,16,237,50,50,47,51,17,57,49,48,43,0,43,1,34,46,2,53,17,52,46,2,39,53,62,3,53,17,52,54,59,1,21,35,34,6,21,17,20,14,2,7,21,30,3,21,17,20,22,59,1,21,2,45,69,109,77,40,32,60,85,52,53,85,59,32,157,138,197,58,91,81,33,56,76,42,43,76,56,32,81,91,58,254,87,42,77,111,69,1,72,63,87,54,24,1,195,2,25,54,87,63,1,72,146,153,190,104,105,254,211,51,85,64,43,9,4,10,43,65,83,51,254,211,106,103,
191,0,0,1,0,156,254,57,1,162,5,204,0,3,0,46,178,3,171,0,184,255,192,64,16,9,14,72,0,64,5,80,5,128,5,144,5,160,5,5,5,184,255,192,181,27,30,72,1,0,0,0,47,63,1,43,93,47,43,237,49,48,19,17,33,17,156,1,6,254,57,7,147,248,109,0,0,0,0,1,0,43,254,87,2,254,5,204,0,45,0,90,185,0,41,255,216,180,9,10,0,76,25,184,255,216,64,44,9,10,0,76,10,4,80,32,1,32,32,27,39,240,4,21,0,0,16,48,4,64,4,2,15,4,31,4,2,4,10,33,245,32,32,22,0,245,45,27,21,245,22,0,0,63,237,63,237,17,57,47,237,57,1,47,93,93,51,51,47,51,16,237,50,
50,47,93,18,57,49,48,43,43,23,51,50,54,53,17,52,62,2,55,53,46,3,53,17,52,38,43,1,53,51,50,22,21,17,20,30,2,23,21,14,3,21,17,20,14,2,43,1,43,57,93,79,33,56,75,43,42,75,57,33,79,93,57,197,138,157,33,60,85,53,53,85,60,33,40,77,109,69,197,234,103,106,1,45,51,83,65,43,10,4,9,43,64,85,51,1,45,105,104,190,153,146,254,184,63,87,54,25,2,195,1,24,54,87,63,254,184,69,111,77,42,0,1,0,81,2,4,4,95,3,72,0,31,0,66,64,18,2,16,10,0,77,30,48,9,10,0,76,29,48,9,10,0,76,12,184,255,192,64,22,9,10,0,76,13,48,9,10,0,76,26,
33,11,26,6,173,15,175,23,173,11,0,0,47,50,237,253,237,51,1,47,16,206,49,48,43,0,43,43,43,43,1,34,38,39,46,1,35,34,14,2,7,53,62,1,51,50,30,2,23,30,1,51,50,54,55,21,14,3,3,84,75,145,75,66,109,46,39,67,61,58,30,51,136,84,41,82,80,78,38,45,107,48,68,128,52,32,61,63,70,2,4,42,26,23,24,12,23,32,21,213,38,46,13,21,27,13,16,27,50,42,219,22,31,19,8,0,0,0,0,2,0,194,254,185,1,232,4,58,0,3,0,7,1,115,64,255,7,4,2,150,4,1,20,1,2,11,1,1,9,8,59,9,75,9,91,9,123,9,139,9,187,9,6,11,9,43,9,59,9,107,9,251,9,5,202,27,
9,171,9,235,9,251,9,4,91,9,155,9,171,9,187,9,219,9,235,9,6,11,9,91,9,107,9,139,9,155,9,203,9,6,154,27,9,43,9,75,9,91,9,139,9,5,203,9,1,9,64,210,214,72,9,64,190,193,72,9,64,169,172,72,9,64,148,151,72,180,9,1,59,9,1,9,64,127,130,72,9,64,118,121,72,127,9,1,100,9,1,11,9,43,9,59,9,75,9,4,105,251,9,1,212,9,1,9,64,97,100,72,116,9,132,9,2,59,9,1,32,9,1,11,9,1,251,9,1,228,9,1,128,9,1,91,9,107,9,123,9,3,36,9,52,9,2,235,9,1,212,9,1,187,9,1,148,9,164,9,2,48,9,1,36,9,1,11,9,27,9,2,56,148,9,164,9,228,9,244,9,4,
123,9,139,9,2,84,9,100,9,2,27,9,1,240,9,1,2,224,9,1,223,9,1,64,9,80,9,144,9,192,9,4,63,64,31,9,1,0,9,16,9,32,9,3,207,9,1,0,9,64,9,80,9,112,9,128,9,144,9,176,9,7,7,5,5,4,184,1,26,179,0,157,1,15,0,63,237,63,57,47,1,94,93,93,113,113,113,113,113,95,113,114,114,114,114,94,93,93,93,93,93,93,93,113,113,113,113,113,114,114,114,114,43,114,114,94,93,93,93,43,43,113,113,43,43,43,43,113,114,94,93,113,114,94,93,113,17,18,57,47,94,93,237,51,50,49,48,19,17,33,17,1,19,51,19,200,1,32,254,218,32,230,32,3,44,1,14,254,
242,251,141,3,213,252,43,0,0,2,0,51,255,225,4,68,5,129,0,7,0,36,0,58,0,177,27,3,63,1,176,37,47,176,22,214,176,5,205,176,5,16,176,17,220,177,0,26,50,50,176,16,205,177,8,28,50,50,176,16,16,176,10,220,176,34,50,176,11,205,176,33,50,176,11,16,176,38,214,0,48,49,1,17,6,7,6,16,23,22,23,54,55,5,6,7,6,7,21,35,53,38,39,38,53,52,55,54,55,53,51,21,22,23,22,23,5,38,39,1,250,67,41,64,66,42,226,120,21,1,27,21,105,113,185,162,222,120,113,119,117,219,162,175,110,103,27,254,230,23,110,1,96,2,169,21,60,92,254,174,
91,57,21,44,152,12,146,101,109,21,191,189,21,145,135,227,233,142,140,24,184,184,19,100,93,145,14,136,41,0,0,0,0,1,0,21,0,0,4,94,5,150,0,48,0,155,64,31,3,16,9,0,77,20,40,9,10,0,76,37,0,35,39,110,16,12,28,110,41,27,1,27,12,27,12,6,48,110,0,184,255,192,64,55,38,53,72,41,0,1,0,50,14,14,6,64,38,60,72,6,64,14,31,72,6,38,14,117,35,47,15,127,15,175,15,3,15,64,22,25,72,15,15,44,31,117,22,28,28,22,7,7,44,116,6,64,48,1,48,184,255,192,182,18,21,72,48,48,6,24,0,63,51,47,43,93,16,237,50,63,51,47,16,237,18,57,47,
43,93,51,237,50,1,47,43,43,51,47,16,222,93,43,237,18,57,57,47,47,93,237,16,196,253,196,18,57,49,48,43,0,43,1,14,3,35,33,53,62,3,61,1,35,53,51,53,52,62,2,51,50,30,2,23,7,46,1,35,34,6,29,1,33,21,33,21,20,14,2,7,33,50,54,55,4,94,13,60,98,134,87,253,74,39,66,46,26,188,178,48,103,161,114,96,136,95,61,19,233,21,82,66,91,80,1,30,254,226,25,46,68,43,1,124,104,107,17,1,107,73,132,99,59,205,22,52,71,96,66,92,170,248,92,151,107,58,41,76,107,67,47,77,70,115,125,225,170,90,59,93,73,56,24,99,94,0,2,0,57,0,170,
4,57,4,172,0,34,0,54,0,84,64,52,14,22,45,170,31,18,1,192,18,208,18,2,18,56,4,31,35,170,16,0,1,207,0,223,0,2,0,0,32,0,2,0,23,79,30,1,30,40,173,79,26,1,26,26,13,5,50,173,207,9,1,9,0,47,93,237,198,50,51,47,93,237,198,93,50,1,47,93,113,114,237,198,50,16,220,113,114,237,198,50,49,48,19,52,54,55,39,55,23,62,1,51,50,22,23,55,23,7,30,1,21,20,6,7,23,7,39,6,35,34,38,39,7,39,55,46,1,55,20,30,2,51,50,62,2,53,52,46,2,35,34,14,2,134,31,29,133,157,131,48,112,60,60,111,48,135,158,136,29,31,30,28,134,158,133,100,
121,60,112,48,135,157,135,28,30,226,33,57,76,43,43,75,57,33,33,57,75,43,43,76,57,33,2,172,60,112,49,133,156,133,28,31,30,29,135,158,135,48,111,60,60,109,48,133,160,135,59,29,28,137,158,137,48,111,62,43,76,57,33,33,57,76,43,43,76,57,33,33,57,76,0,1,0,8,0,0,4,106,5,129,0,22,0,246,179,0,20,1,0,184,255,232,64,21,10,0,77,17,24,10,0,77,12,16,5,1,16,1,22,4,19,1,9,19,18,184,255,240,64,101,15,18,1,59,15,18,31,18,175,18,3,47,18,143,18,2,79,18,143,18,159,18,223,18,4,18,18,9,11,21,1,9,21,22,16,112,22,240,22,
2,80,22,208,22,224,22,3,0,22,16,22,80,22,96,22,160,22,240,22,6,12,22,22,20,4,0,8,92,17,13,0,9,1,59,0,9,16,9,160,9,3,32,9,128,9,2,48,9,64,9,144,9,208,9,4,9,9,23,24,7,11,184,1,19,180,12,4,12,3,15,184,1,19,64,22,16,20,0,16,79,12,1,15,12,31,12,2,12,16,12,16,8,21,18,3,8,18,0,63,63,51,18,57,57,47,47,93,113,17,51,51,16,237,50,17,51,16,237,50,17,18,1,57,47,93,113,114,94,93,51,51,237,50,50,57,50,47,94,93,113,114,56,51,94,93,17,51,47,93,113,114,94,93,56,51,94,93,18,57,57,17,51,17,51,49,48,43,43,0,93,1,33,21,
33,21,33,21,33,21,33,53,33,53,33,55,33,53,33,1,33,9,1,33,2,254,1,20,254,174,1,82,254,174,254,240,254,176,1,80,2,254,174,1,20,254,148,1,33,1,14,1,18,1,33,2,179,146,162,147,236,236,147,162,146,2,206,253,172,2,84,0,0,0,2,0,156,254,57,1,162,5,174,0,3,0,7,0,61,180,7,2,171,4,1,184,255,192,64,16,9,14,72,1,64,9,80,9,128,9,144,9,160,9,5,9,184,255,192,64,11,27,30,72,5,0,5,0,1,4,1,0,0,63,47,18,57,57,47,47,1,43,93,47,43,50,237,50,49,48,19,17,33,17,1,17,33,17,156,1,6,254,250,1,6,2,164,3,10,252,246,251,149,3,11,
252,245,0,2,0,53,255,27,4,32,5,147,0,75,0,93,0,202,185,0,86,255,224,179,10,0,77,87,184,255,224,180,9,10,0,76,31,184,255,224,64,11,9,10,0,76,70,24,9,10,0,76,36,184,255,232,64,32,9,10,0,76,74,40,9,10,0,76,68,81,73,76,72,24,53,72,34,6,72,5,14,72,73,89,29,34,84,72,63,73,184,255,192,64,31,18,26,72,34,5,73,63,63,73,5,34,4,44,24,95,45,72,44,64,14,19,72,44,81,68,89,29,68,29,0,50,184,1,15,64,17,39,16,45,224,45,2,45,45,32,39,48,39,64,39,3,39,11,184,1,15,183,0,240,6,1,6,6,0,4,0,63,50,47,93,16,237,47,93,51,47,
93,16,237,18,57,57,17,51,17,51,1,47,43,237,16,206,17,23,57,47,47,47,47,43,16,237,17,57,57,16,237,16,237,16,237,16,237,17,57,57,49,48,43,43,43,43,0,43,43,1,50,30,2,23,7,46,3,35,34,6,21,20,30,2,23,30,3,21,20,14,2,7,30,3,21,20,14,2,35,34,46,2,39,55,30,3,51,50,54,53,52,46,2,39,46,3,53,52,62,2,55,46,3,53,52,54,1,52,46,2,39,14,1,21,20,30,2,23,62,3,2,63,87,153,120,81,15,239,7,39,57,73,41,112,105,46,78,103,57,85,151,112,66,26,51,73,47,41,67,47,26,58,120,182,124,103,167,127,85,21,237,11,46,68,88,53,122,126,
42,84,126,84,63,134,109,71,30,56,79,48,38,69,51,30,235,1,211,32,71,111,78,93,100,48,81,105,56,41,72,52,30,5,147,31,66,104,73,25,34,49,31,15,59,65,39,53,38,27,13,19,48,74,108,80,44,81,69,54,15,18,48,61,79,50,78,127,90,49,30,68,110,80,37,45,60,36,14,65,80,45,58,41,33,20,15,45,72,107,78,49,80,63,48,16,16,49,65,80,48,149,164,252,197,39,54,41,31,15,11,73,69,39,53,37,27,13,2,17,34,52,0,0,2,0,16,4,175,2,155,5,138,0,3,0,7,0,99,64,74,16,9,1,32,9,80,9,128,9,176,9,224,9,5,0,9,48,9,96,9,144,9,192,9,240,9,6,65,
0,133,95,3,1,3,3,7,133,4,5,1,141,4,111,0,1,15,0,47,0,63,0,95,0,127,0,239,0,6,0,64,43,60,72,0,64,33,41,72,0,64,26,29,72,0,0,47,43,43,43,93,113,50,237,50,1,47,237,51,47,93,237,94,93,113,114,49,48,1,53,51,21,33,53,51,21,1,194,217,253,117,214,4,175,219,219,219,219,0,0,3,0,32,255,240,5,198,5,150,0,25,0,47,0,89,0,129,64,83,71,24,9,10,0,76,67,24,9,10,0,76,48,196,69,59,59,79,79,69,95,69,111,69,3,69,79,69,79,14,26,195,15,0,31,0,2,0,91,38,195,14,58,53,202,64,85,202,74,80,80,74,64,64,80,64,96,64,3,64,74,1,15,
74,31,74,2,255,74,1,64,74,64,74,43,31,200,21,4,43,200,7,19,0,63,237,63,237,18,57,57,47,47,93,113,114,113,17,51,47,16,237,16,237,51,1,47,237,16,222,93,237,17,57,57,47,47,93,17,51,47,16,237,49,48,43,43,1,20,14,4,35,34,46,4,53,52,62,4,51,50,4,22,18,7,52,46,2,35,34,14,4,21,20,30,2,51,50,62,2,37,20,30,2,51,50,62,2,55,23,14,3,35,34,46,2,53,52,62,2,51,50,30,2,23,7,46,3,35,34,14,2,5,198,52,94,131,161,185,100,99,185,160,133,94,52,52,94,132,161,184,100,150,1,7,197,113,112,96,166,222,127,84,155,136,110,80,43,
96,165,221,126,127,222,166,96,252,202,27,56,84,57,41,64,48,33,10,160,20,57,84,116,79,104,152,100,48,48,98,149,100,78,116,83,57,19,156,10,32,47,62,41,58,84,53,25,2,195,100,185,161,131,94,52,52,94,131,161,185,100,100,184,161,132,94,52,114,196,254,249,150,126,221,165,96,44,79,111,135,155,84,127,222,166,96,96,166,222,129,62,104,75,42,26,42,51,24,47,43,85,68,41,63,113,156,92,96,154,107,58,37,63,83,46,41,24,46,37,22,39,72,101,0,2,0,45,2,213,2,246,5,139,0,50,0,65,0,138,185,0,29,255,224,64,31,9,10,0,76,5,
24,9,10,0,76,2,40,9,10,0,76,20,225,21,21,3,9,56,224,40,224,32,240,32,2,32,184,255,192,64,52,26,30,72,15,32,1,32,67,63,225,111,3,127,3,2,3,64,18,22,72,3,57,230,9,9,51,26,63,20,1,15,20,159,20,2,20,64,15,19,72,20,20,15,228,26,222,47,35,51,228,44,0,184,1,30,0,63,50,237,50,51,63,237,51,47,43,113,114,17,18,57,47,237,1,47,43,93,237,16,220,93,43,93,50,237,50,17,57,47,237,49,48,43,43,43,1,34,38,53,52,62,2,63,1,53,52,46,2,35,34,14,2,7,39,62,3,51,50,30,2,29,1,20,22,51,50,62,2,55,21,14,1,35,34,38,39,35,14,1,
39,50,62,2,61,1,7,14,3,21,20,22,1,1,97,115,46,78,103,57,147,16,28,38,22,21,37,30,21,3,190,8,43,75,106,69,65,105,76,41,18,33,4,14,14,13,4,29,63,27,71,81,5,3,34,111,6,35,55,38,20,92,31,54,41,24,46,2,213,105,97,60,80,49,21,1,2,42,35,46,27,11,8,21,36,29,9,43,74,55,31,28,59,88,60,237,48,49,1,2,1,1,109,8,10,73,61,65,72,131,30,46,57,28,27,2,1,7,21,39,33,41,44,0,0,0,0,2,0,92,0,141,4,23,3,172,0,8,0,17,0,113,64,72,3,235,4,0,235,8,236,6,235,31,2,1,95,2,127,2,2,2,64,29,32,72,32,2,1,2,12,235,13,9,235,17,236,15,
235,64,31,11,1,11,64,29,32,72,32,11,48,11,64,11,96,11,4,31,11,1,11,12,3,237,10,11,15,2,1,9,0,237,32,15,6,239,0,25,63,51,26,237,50,51,51,17,51,51,237,50,1,24,47,93,93,43,113,26,237,253,237,212,237,47,93,43,93,113,237,253,237,212,237,49,48,37,1,53,1,51,21,3,1,21,33,1,53,1,51,21,3,1,21,3,39,255,0,1,0,238,254,1,0,253,71,254,254,1,2,236,254,1,0,141,1,105,71,1,111,37,254,146,254,151,35,1,105,71,1,111,37,254,146,254,151,35,0,0,0,1,0,84,0,141,4,87,3,25,0,5,0,59,64,43,1,170,4,7,2,15,0,31,0,95,0,111,0,175,
0,191,0,6,47,0,127,0,191,0,207,0,4,63,0,143,0,159,0,175,0,223,0,5,0,2,173,3,178,0,63,253,198,93,113,114,1,47,16,222,237,49,48,37,17,33,53,33,17,3,119,252,221,4,3,141,1,172,224,253,116,0,0,4,0,32,255,240,5,198,5,150,0,25,0,47,0,61,0,70,0,148,185,0,56,255,216,64,65,9,10,0,76,59,24,9,10,0,76,49,60,57,67,51,196,52,48,61,16,61,61,57,196,62,52,62,52,62,14,26,195,15,0,31,0,2,0,72,38,195,14,48,52,60,50,201,67,66,201,53,95,53,111,53,2,53,64,23,26,72,112,52,1,52,184,255,192,64,19,26,31,72,52,67,53,53,67,52,
3,43,31,200,21,4,43,200,7,19,0,63,237,63,237,18,23,57,47,47,47,43,93,43,113,16,237,16,237,57,17,51,1,47,237,16,222,93,237,17,57,57,47,47,16,237,50,47,56,51,16,237,50,17,57,57,49,48,0,43,1,43,1,20,14,4,35,34,46,4,53,52,62,4,51,50,4,22,18,7,52,46,2,35,34,14,4,21,20,30,2,51,50,62,2,1,3,35,17,35,17,33,50,22,21,20,6,7,19,3,52,38,43,1,21,51,50,54,5,198,52,94,131,161,185,100,99,185,160,133,94,52,52,94,132,161,184,100,150,1,7,197,113,112,96,166,222,127,84,155,136,110,80,43,96,165,221,126,127,222,166,96,254,
69,178,117,178,1,74,153,152,96,78,213,219,75,69,133,144,66,67,2,195,100,185,161,131,94,52,52,94,131,161,185,100,100,184,161,132,94,52,114,196,254,249,150,126,221,165,96,44,79,111,135,155,84,127,222,166,96,96,166,222,254,229,1,57,254,199,3,47,129,113,94,118,25,254,176,2,59,57,60,246,71,0,0,0,1,255,239,5,172,4,124,6,10,0,3,0,17,178,1,0,2,185,1,28,0,1,0,47,237,1,47,47,49,48,1,33,53,33,4,124,251,115,4,141,5,172,94,0,2,0,90,3,27,2,219,5,145,0,19,0,39,0,79,185,0,18,255,232,180,9,10,0,76,2,184,255,232,64,
44,9,10,0,76,12,24,9,10,0,76,8,24,9,10,0,76,20,172,0,0,30,172,48,10,64,10,96,10,112,10,144,10,192,10,6,10,35,174,5,5,25,174,15,4,0,63,237,51,47,237,1,47,93,237,51,47,237,49,48,43,43,43,43,1,20,14,2,35,34,46,2,53,52,62,2,51,50,30,2,7,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,2,219,51,87,117,66,66,117,87,50,50,87,117,66,66,117,87,51,158,25,44,59,35,35,60,45,26,26,45,60,35,35,59,44,25,4,86,66,115,85,49,49,85,115,66,67,115,85,48,48,85,115,67,35,61,45,25,25,45,61,35,34,61,46,27,27,46,61,0,0,2,0,49,0,0,
4,52,4,246,0,11,0,15,0,117,64,69,15,10,14,10,9,1,170,2,64,12,5,5,2,14,15,5,31,5,47,5,95,5,111,5,127,5,6,13,3,5,6,2,2,17,16,13,173,12,2,14,0,4,173,5,64,9,5,7,5,14,207,7,1,7,64,29,33,72,7,192,5,1,95,5,1,64,5,1,5,0,47,93,93,93,198,43,93,43,17,0,51,26,24,16,77,253,50,230,47,237,17,18,1,57,47,51,196,95,94,93,43,1,16,24,196,26,16,77,253,50,50,244,196,49,48,1,17,35,17,33,53,33,17,51,17,33,21,1,53,33,21,2,162,224,254,111,1,145,224,1,146,251,253,4,3,2,195,254,171,1,85,223,1,84,254,172,223,253,61,223,223,0,
0,1,0,51,2,182,2,127,5,146,0,33,0,75,185,0,22,255,216,64,42,9,10,0,76,8,226,24,24,15,32,31,32,2,32,35,13,226,14,14,31,226,0,8,0,19,95,13,111,13,127,13,3,13,13,11,228,19,222,31,229,0,221,0,63,237,63,237,51,47,93,17,18,57,1,47,237,51,47,237,16,206,93,50,47,237,49,48,43,19,39,62,5,53,52,38,35,34,7,39,62,3,51,50,30,2,21,20,14,4,7,33,21,53,2,25,75,84,84,67,42,39,42,85,10,194,6,43,72,102,66,71,105,69,34,44,68,83,77,63,14,1,106,2,182,121,53,81,64,54,51,56,34,42,49,98,5,46,80,60,34,32,56,77,45,53,80,64,53,
51,52,31,138,0,0,0,0,1,0,44,2,172,2,126,5,146,0,53,0,109,64,66,34,225,35,48,22,28,225,45,35,22,45,45,22,35,3,8,15,225,0,55,9,225,8,48,21,228,22,22,12,40,15,34,159,34,2,255,34,1,34,64,15,19,72,34,34,31,228,40,222,12,228,3,128,9,1,80,9,96,9,112,9,3,9,9,3,223,0,63,51,47,93,113,16,237,63,237,51,47,43,93,113,17,18,57,47,237,57,1,47,237,16,222,237,18,23,57,47,47,47,16,237,18,57,16,237,49,48,1,20,6,35,34,46,2,39,55,30,1,51,50,54,53,52,46,2,43,1,53,51,50,62,2,53,52,38,35,34,6,7,39,62,3,51,50,30,2,21,20,6,
7,21,30,3,2,126,150,138,84,113,71,33,5,189,5,55,54,49,53,27,41,49,22,56,51,23,45,36,23,46,43,42,51,5,186,6,50,77,99,57,68,102,67,34,73,79,45,65,41,20,3,127,99,112,36,59,74,39,12,45,48,47,49,31,37,19,6,126,8,20,35,27,39,44,44,45,12,51,77,51,25,29,51,69,39,64,91,16,2,5,31,46,57,0,0,0,1,0,87,4,159,2,85,5,222,0,5,0,42,64,28,2,130,3,132,5,131,0,2,140,15,5,1,15,5,47,5,63,5,95,5,127,5,159,5,239,5,7,5,0,47,93,113,237,1,47,237,253,237,49,48,19,53,19,33,21,1,87,252,1,2,254,172,4,159,31,1,32,43,254,236,0,1,
0,134,254,86,4,33,4,58,0,39,0,71,64,23,3,31,70,239,34,255,34,2,34,41,21,9,17,70,224,18,240,18,2,224,18,1,18,184,255,192,64,17,9,12,72,18,32,19,15,18,27,26,80,12,3,9,22,0,21,0,63,63,51,51,237,63,63,51,1,47,43,93,113,237,50,50,16,222,113,237,50,49,48,33,46,1,53,35,14,3,35,34,38,39,35,30,1,21,17,33,17,33,17,20,30,2,51,50,62,2,53,17,33,17,20,30,2,23,3,21,3,10,3,19,43,49,58,33,52,81,23,4,3,1,254,231,1,25,16,40,67,52,50,68,42,18,1,25,1,3,3,1,23,78,43,49,64,37,14,48,42,32,55,28,254,131,5,228,253,163,64,
104,75,41,45,81,115,70,2,66,252,184,34,73,67,54,14,0,0,0,0,1,0,71,254,248,4,47,5,129,0,19,0,79,64,43,14,8,9,0,77,5,151,0,6,1,6,6,1,79,12,95,12,2,12,19,2,151,159,1,1,48,1,96,1,128,1,3,1,0,7,16,7,2,7,7,1,0,4,184,1,23,179,17,3,6,1,0,47,51,63,237,50,18,57,47,93,1,47,93,93,237,51,47,93,18,57,47,93,237,49,48,43,1,17,35,17,35,17,35,17,34,46,2,53,52,62,2,51,33,21,3,172,156,195,155,81,133,96,53,50,95,138,88,2,117,4,242,250,6,5,250,250,6,3,190,45,88,134,88,84,133,93,50,143,0,0,0,0,1,0,141,2,19,1,173,3,68,0,
3,0,22,64,11,3,150,32,0,48,0,2,0,1,155,0,0,47,237,1,47,93,237,49,48,19,17,33,17,141,1,32,2,19,1,49,254,207,0,0,0,0,1,0,96,254,87,1,244,0,0,0,25,0,204,185,0,25,255,216,179,10,0,77,2,184,255,232,64,37,10,0,77,20,64,9,0,77,22,23,23,21,20,20,7,14,136,11,0,75,0,2,0,52,7,1,11,7,1,10,7,20,27,36,27,2,27,184,255,192,64,47,95,100,72,224,27,1,2,32,27,48,27,80,27,96,27,4,0,27,48,27,96,27,112,27,4,59,0,27,112,27,160,27,176,27,4,128,27,176,27,192,27,224,27,240,27,5,27,184,255,192,179,83,88,72,27,184,255,192,179,
68,74,72,27,184,255,192,64,33,53,56,72,31,27,1,0,27,1,144,27,192,27,240,27,3,47,27,1,0,27,1,8,23,17,17,5,21,21,11,146,5,27,0,63,237,63,18,57,47,205,1,94,93,93,93,113,113,43,43,43,113,114,94,93,113,95,113,43,114,47,94,93,93,47,93,237,18,57,47,51,51,17,51,49,48,43,43,43,5,20,14,2,35,34,39,53,30,1,51,50,54,53,52,38,35,42,1,7,55,51,7,30,1,1,244,31,71,116,85,45,56,25,42,17,75,62,56,66,13,25,14,62,143,33,94,91,235,39,70,51,30,6,118,5,2,37,32,35,34,2,172,82,5,82,0,1,0,82,2,182,2,106,5,134,0,10,0,84,185,
0,5,255,224,64,32,17,21,72,3,32,17,21,72,143,9,1,9,9,8,224,2,4,1,1,6,2,2,11,12,5,32,4,48,4,2,4,3,184,255,224,64,11,11,16,72,3,6,220,8,1,228,0,221,0,63,237,50,63,51,43,205,93,50,17,18,1,57,47,51,51,47,51,16,237,50,47,93,49,48,0,43,43,19,53,51,17,7,53,55,51,17,51,21,82,184,173,180,175,170,2,182,121,1,212,108,122,117,253,169,121,0,0,0,2,0,45,2,213,2,201,5,139,0,19,0,39,0,81,185,0,17,255,232,180,9,10,0,76,13,184,255,232,64,41,9,10,0,76,7,24,9,10,0,76,3,24,9,10,0,76,20,226,15,0,1,0,41,30,226,127,10,1,
10,64,18,22,72,10,25,229,15,222,35,229,5,184,1,30,0,63,237,63,237,1,47,43,93,237,16,222,93,237,49,48,0,43,43,43,43,1,20,14,2,35,34,46,2,53,52,62,2,51,50,30,2,7,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,2,201,43,85,126,84,80,123,84,43,41,83,126,84,88,127,81,38,200,17,33,49,33,33,51,35,19,19,35,48,29,33,52,35,19,4,49,77,128,92,51,51,91,128,78,75,127,92,52,52,92,127,75,59,78,47,19,20,47,78,58,60,80,48,20,20,48,80,0,0,0,0,2,0,93,0,141,4,24,3,172,0,8,0,17,0,113,64,36,11,235,15,236,9,14,235,13,17,235,176,
9,1,32,9,128,9,2,9,2,235,6,236,0,5,235,4,8,235,64,128,0,176,0,2,0,184,255,192,64,28,11,17,72,31,0,1,0,17,8,237,16,15,11,6,7,11,3,14,5,237,32,16,15,11,11,6,2,239,0,25,63,17,51,17,51,51,26,237,50,23,51,17,51,51,237,50,1,24,47,93,43,113,26,237,212,237,16,253,237,47,93,113,237,212,237,16,253,237,49,48,55,53,1,3,53,51,1,21,1,51,53,1,3,53,51,1,21,1,93,1,0,254,238,1,0,255,0,219,1,0,254,236,1,2,254,254,141,35,1,105,1,110,37,254,145,71,254,151,35,1,105,1,110,37,254,145,71,254,151,255,255,0,94,0,0,6,75,5,134,
16,38,0,121,12,0,16,39,2,26,2,208,0,0,17,7,2,147,3,178,253,75,0,26,64,15,3,2,17,24,1,112,12,1,64,12,1,16,12,1,12,17,93,93,93,53,0,63,53,53,255,255,0,94,255,255,6,76,5,134,16,38,0,121,12,0,16,39,2,26,2,188,0,0,17,7,0,114,3,205,253,73,0,7,178,2,15,24,0,63,53,0,0,0,255,255,0,103,0,0,6,75,5,146,16,39,2,26,2,208,0,0,16,39,2,147,3,178,253,75,17,6,0,115,59,0,0,26,64,15,1,2,6,24,0,112,1,1,64,1,1,16,1,1,1,17,93,93,93,53,0,63,53,53,0,2,0,114,254,164,4,129,4,58,0,35,0,39,0,87,181,34,24,9,0,77,3,184,255,240,
64,31,9,0,77,10,36,150,9,39,39,0,25,150,26,41,17,150,32,0,48,0,2,0,17,31,10,10,38,31,25,25,20,186,1,21,0,31,1,27,179,38,157,39,15,0,63,237,63,237,51,47,17,18,57,47,18,57,1,47,93,237,16,222,237,17,57,47,51,237,50,49,48,0,43,1,43,55,52,62,6,55,33,14,5,21,20,22,51,50,62,2,55,5,14,3,35,34,46,2,1,17,33,17,114,35,58,74,78,75,60,38,2,1,11,5,63,90,102,87,57,115,106,51,86,65,42,6,1,29,12,75,130,189,125,120,188,131,69,2,183,254,223,56,66,100,79,63,56,54,61,73,48,85,120,91,71,74,86,61,88,102,31,56,80,48,12,
89,156,116,68,56,105,150,4,95,254,242,1,14,0,0,255,255,0,51,0,0,5,145,7,23,18,38,0,36,0,0,17,7,2,154,1,86,0,0,0,21,180,2,21,5,38,2,184,255,202,180,22,25,4,7,37,1,43,53,0,43,53,0,255,255,0,51,0,0,5,145,7,23,18,38,0,36,0,0,17,7,2,155,1,230,0,0,0,19,64,11,2,21,5,38,2,90,21,24,4,7,37,1,43,53,0,43,53,0,0,0,255,255,0,51,0,0,5,145,7,43,18,38,0,36,0,0,17,7,2,156,1,141,0,0,0,19,64,11,2,22,5,38,2,0,27,21,4,7,37,1,43,53,0,43,53,0,0,0,255,255,0,51,0,0,5,145,7,31,18,38,0,36,0,0,17,7,2,159,1,141,0,0,0,19,64,11,
2,21,5,38,2,0,32,48,4,7,37,1,43,53,0,43,53,0,0,0,255,255,0,51,0,0,5,145,6,213,18,38,0,36,0,0,17,7,2,158,1,143,0,0,0,23,64,13,3,2,21,5,38,3,2,1,25,23,4,7,37,1,43,53,53,0,43,53,53,0,0,0,255,255,0,51,0,0,5,145,7,14,18,38,0,36,0,0,17,7,1,80,1,190,0,162,0,22,64,12,3,2,56,3,3,2,1,31,21,4,7,37,1,43,53,53,0,63,53,53,0,2,0,4,0,0,7,176,5,129,0,15,0,24,0,146,64,91,9,13,90,0,24,0,23,2,3,5,1,82,3,17,3,94,4,5,20,4,4,5,17,4,27,7,1,43,11,59,11,75,11,3,0,11,7,7,11,0,3,4,14,26,143,26,1,2,63,26,95,26,111,26,3,4,2,95,
23,12,95,9,95,9,111,9,143,9,223,9,255,9,5,239,9,1,23,9,23,9,13,8,17,95,5,3,13,95,3,0,18,0,63,50,237,63,237,50,18,57,57,47,47,93,113,16,237,16,237,1,47,93,95,113,16,206,17,23,57,47,47,47,93,113,18,57,135,16,43,135,43,196,16,192,192,17,1,51,24,16,237,50,49,48,33,17,33,3,33,1,33,21,33,17,33,21,33,17,33,21,1,35,14,3,7,3,33,3,163,254,62,172,254,207,2,188,4,199,253,67,2,127,253,129,2,230,251,243,61,4,26,30,29,7,191,1,92,1,104,254,152,5,129,227,254,157,221,254,133,227,4,168,9,56,67,62,15,254,111,0,0,0,255,
255,0,84,254,87,5,143,5,150,18,38,0,38,0,0,17,7,0,120,1,233,0,0,0,11,182,1,33,49,42,16,6,37,1,43,53,0,0,0,255,255,0,137,0,0,5,6,7,23,18,38,0,40,0,0,17,7,2,154,1,53,0,0,0,21,180,1,12,5,38,1,184,255,195,180,13,16,0,10,37,1,43,53,0,43,53,0,255,255,0,137,0,0,5,6,7,23,18,38,0,40,0,0,17,7,2,155,1,174,0,0,0,19,64,11,1,12,5,38,1,60,12,15,0,10,37,1,43,53,0,43,53,0,0,0,255,255,0,137,0,0,5,6,7,43,18,38,0,40,0,0,17,7,2,156,1,115,0,0,0,19,64,11,1,13,5,38,1,1,18,12,0,10,37,1,43,53,0,43,53,0,0,0,255,255,0,137,0,
0,5,6,6,213,18,38,0,40,0,0,17,7,2,158,1,115,0,0,0,23,64,13,2,1,12,5,38,2,1,0,16,14,0,10,37,1,43,53,53,0,43,53,53,0,0,0,255,255,255,216,0,0,1,213,7,23,18,38,0,44,0,0,17,6,2,154,129,0,0,21,180,1,4,5,38,1,184,255,186,180,5,8,0,2,37,1,43,53,0,43,53,0,0,0,255,255,0,104,0,0,2,102,7,23,18,38,0,44,0,0,17,6,2,155,17,0,0,19,64,11,1,4,5,38,1,74,4,7,0,2,37,1,43,53,0,43,53,0,255,255,255,171,0,0,2,140,7,43,18,38,0,44,0,0,17,6,2,156,198,0,0,21,180,1,5,5,38,1,184,255,255,180,10,4,0,2,37,1,43,53,0,43,53,0,0,0,255,
255,255,215,0,0,2,98,6,213,18,38,0,44,0,0,17,6,2,158,200,0,0,23,64,13,2,1,4,5,38,2,1,0,8,6,0,2,37,1,43,53,53,0,43,53,53,0,0,2,0,8,0,0,5,113,5,129,0,16,0,33,0,117,64,78,31,16,9,10,0,76,20,16,9,10,0,76,26,26,28,17,91,0,35,128,35,1,24,28,90,6,10,6,8,8,6,27,8,95,24,47,9,127,9,175,9,3,9,64,51,54,72,9,64,43,49,72,9,64,36,41,72,9,64,29,34,72,9,64,22,26,72,9,9,28,23,95,11,3,28,95,6,18,0,63,237,63,237,18,57,47,43,43,43,43,43,93,51,237,50,1,47,51,47,17,51,16,237,50,113,16,222,237,18,57,47,49,48,43,43,1,20,
2,14,1,35,33,17,35,53,51,17,33,50,4,22,18,5,52,46,2,43,1,17,33,21,33,17,51,50,62,2,5,113,106,184,251,145,253,198,129,129,1,254,164,1,18,198,110,254,215,67,120,167,101,209,1,100,254,156,250,89,151,111,63,2,203,176,254,245,180,92,2,82,219,2,84,82,170,254,250,180,123,175,112,53,254,147,219,254,149,61,122,181,0,255,255,0,137,0,0,5,61,7,31,18,38,0,49,0,0,17,7,2,159,1,142,0,0,0,19,64,11,1,20,5,38,1,0,31,47,8,18,37,1,43,53,0,43,53,0,0,0,255,255,0,84,255,236,5,227,7,23,18,38,0,50,0,0,17,7,2,154,1,204,0,0,
0,19,64,11,2,40,5,38,2,6,41,44,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,84,255,236,5,227,7,23,18,38,0,50,0,0,17,7,2,155,2,26,0,0,0,19,64,11,2,40,5,38,2,84,40,43,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,84,255,236,5,227,7,43,18,38,0,50,0,0,17,7,2,156,1,197,0,0,0,21,180,2,41,5,38,2,184,255,255,180,46,40,10,0,37,1,43,53,0,43,53,0,255,255,0,84,255,236,5,227,7,31,18,38,0,50,0,0,17,7,2,159,1,190,0,0,0,21,180,2,40,5,38,2,184,255,248,180,51,67,10,0,37,1,43,53,0,43,53,0,255,255,0,84,255,236,5,227,6,213,18,38,
0,50,0,0,17,7,2,158,1,198,0,0,0,25,182,3,2,40,5,38,3,2,184,255,255,180,44,42,10,0,37,1,43,53,53,0,43,53,53,0,0,1,0,86,0,168,4,86,4,170,0,11,0,125,185,0,4,255,232,64,23,20,33,72,35,4,51,4,67,4,3,10,24,20,33,72,44,10,60,10,76,10,3,7,184,255,232,64,59,20,33,72,35,7,51,7,67,7,3,1,24,20,33,72,44,1,60,1,76,1,3,4,32,10,48,10,80,10,3,10,7,16,1,32,1,64,1,96,1,112,1,144,1,192,1,7,0,1,32,1,160,1,192,1,240,1,5,1,184,255,192,180,13,16,72,1,178,0,25,63,43,93,113,51,1,47,93,51,49,48,93,43,93,43,0,93,43,93,43,19,
9,1,55,9,1,23,9,1,7,9,1,86,1,100,254,160,158,1,96,1,96,158,254,160,1,96,158,254,160,254,156,1,70,1,102,1,96,156,254,162,1,96,158,254,158,254,162,160,1,98,254,154,0,3,0,84,255,183,5,228,5,193,0,26,0,38,0,50,0,232,185,0,48,255,240,64,19,10,0,77,42,16,9,0,77,36,16,10,0,77,36,8,9,0,77,30,184,255,248,64,9,9,0,77,25,24,9,0,77,16,184,255,240,179,10,0,77,16,184,255,232,64,10,9,0,77,15,32,9,10,0,76,12,184,255,240,64,14,9,0,77,2,16,10,0,77,2,32,9,0,77,1,184,255,232,179,10,0,77,1,184,255,240,64,10,9,0,77,25,
16,9,10,0,76,12,184,255,232,179,10,0,77,12,184,255,240,64,59,9,0,77,30,43,31,42,4,39,27,91,15,12,25,1,4,4,14,18,52,39,91,0,48,4,1,15,4,31,4,2,4,31,42,30,43,4,46,34,95,23,12,15,1,25,4,23,9,26,26,23,19,46,95,9,13,13,9,4,0,63,51,47,16,237,63,51,47,17,18,23,57,16,237,17,23,57,1,47,93,93,51,237,16,222,50,17,23,57,237,17,23,57,49,48,0,43,43,43,1,43,43,43,43,43,43,43,43,43,43,43,43,43,43,23,55,38,2,53,52,18,54,36,51,50,22,23,55,51,7,22,18,21,20,2,6,4,35,34,39,7,1,52,38,39,1,30,1,51,50,62,2,37,20,22,23,1,
46,1,35,34,14,2,147,154,109,108,93,181,1,9,172,103,177,74,82,193,142,112,114,98,184,254,246,167,212,148,91,3,97,43,43,253,227,43,107,63,108,157,101,48,252,198,41,43,2,27,45,102,62,103,155,104,52,73,218,99,1,33,178,165,1,10,187,101,39,35,117,203,94,254,227,180,165,254,242,192,104,77,129,3,15,100,165,62,252,252,26,29,75,133,184,108,99,168,65,3,0,25,26,69,128,179,0,255,255,0,123,255,236,5,74,7,23,18,38,0,56,0,0,17,7,2,154,1,73,0,0,0,21,180,1,26,5,38,1,184,255,188,180,27,30,5,20,37,1,43,53,0,43,53,0,
255,255,0,123,255,236,5,74,7,23,18,38,0,56,0,0,17,7,2,155,1,249,0,0,0,19,64,11,1,26,5,38,1,108,26,29,5,20,37,1,43,53,0,43,53,0,0,0,255,255,0,123,255,236,5,74,7,43,18,38,0,56,0,0,17,7,2,156,1,139,0,0,0,21,180,1,27,5,38,1,184,255,254,180,32,26,5,20,37,1,43,53,0,43,53,0,255,255,0,123,255,236,5,74,6,213,18,38,0,56,0,0,17,7,2,158,1,142,0,0,0,23,64,13,2,1,26,5,38,2,1,0,30,28,5,20,37,1,43,53,53,0,43,53,53,0,0,0,255,255,0,35,0,0,5,53,7,23,18,38,0,60,0,0,17,7,2,155,1,181,0,0,0,19,64,11,1,9,5,38,1,95,9,12,
4,8,37,1,43,53,0,43,53,0,0,0,0,2,0,137,0,0,5,16,5,129,0,16,0,27,0,66,64,39,17,91,0,29,22,11,7,90,32,8,48,8,2,8,6,95,22,21,95,11,95,22,111,22,2,95,11,111,11,2,22,11,22,11,7,9,3,7,18,0,63,63,18,57,57,47,47,93,93,16,237,16,237,1,47,93,237,50,50,16,222,237,49,48,1,20,14,2,35,33,17,33,17,33,21,33,50,30,2,5,52,38,35,33,17,33,50,62,2,5,16,61,126,194,133,254,162,254,217,1,39,1,82,135,198,130,63,254,215,131,131,254,207,1,57,66,95,63,30,2,225,91,165,124,74,254,229,5,129,233,63,115,162,103,110,124,254,37,36,
65,88,0,0,1,0,143,255,236,4,169,5,204,0,63,0,135,185,0,62,255,240,64,11,9,10,0,76,27,16,9,10,0,76,2,184,255,240,64,44,9,10,0,76,57,70,24,31,70,50,8,64,11,14,72,50,64,9,15,72,8,24,50,50,24,8,3,39,17,70,0,65,159,65,1,80,65,1,38,70,208,39,1,39,184,255,192,179,36,40,72,39,184,255,192,64,18,9,12,72,39,17,57,31,3,5,34,80,45,0,39,14,79,5,22,0,63,237,196,63,237,18,23,57,1,47,43,43,93,237,93,93,16,222,237,18,23,57,47,47,47,43,43,16,237,16,237,49,48,43,43,43,1,20,14,2,35,34,38,39,53,30,3,51,50,54,53,52,46,
4,53,52,62,4,53,52,38,35,34,6,21,17,33,17,52,62,2,51,50,30,2,21,20,14,4,21,20,30,4,4,169,44,95,146,102,71,129,62,24,60,62,61,25,81,74,50,75,88,75,50,33,50,57,50,33,93,88,103,108,254,231,60,123,186,126,114,168,109,53,33,50,59,50,33,50,74,88,74,50,1,56,73,122,88,49,20,23,206,11,21,17,10,69,57,46,68,59,57,73,95,66,46,69,58,50,53,62,40,65,78,127,141,252,11,3,239,111,177,123,66,54,91,122,68,54,85,68,54,45,41,20,28,49,55,65,85,113,255,255,0,52,255,236,4,120,5,222,18,38,0,68,248,0,17,7,0,67,0,174,0,0,0,
21,180,2,69,17,38,2,184,255,153,180,70,73,5,41,37,1,43,53,0,43,53,0,255,255,0,52,255,236,4,120,5,222,18,38,0,68,248,0,17,7,0,116,1,32,0,0,0,19,64,11,2,69,17,38,2,32,69,72,5,41,37,1,43,53,0,43,53,0,0,0,255,255,0,52,255,236,4,120,5,249,18,38,0,68,248,0,17,7,1,75,0,199,0,0,0,21,180,2,70,17,38,2,184,255,226,180,75,69,5,41,37,1,43,53,0,43,53,0,255,255,0,52,255,236,4,120,5,196,18,38,0,68,248,0,17,7,1,82,0,176,0,0,0,21,180,2,69,17,38,2,184,255,210,180,80,96,5,41,37,1,43,53,0,43,53,0,255,255,0,52,255,236,
4,120,5,138,18,38,0,68,248,0,17,7,0,105,0,215,0,0,0,25,182,3,2,69,17,38,3,2,184,255,215,180,73,71,5,41,37,1,43,53,53,0,43,53,53,0,255,255,0,52,255,236,4,120,6,149,18,38,0,68,248,0,17,7,1,80,1,10,0,41,0,25,182,3,2,74,17,38,3,2,184,255,217,180,79,69,5,41,37,1,43,53,53,0,43,53,53,0,0,3,0,66,255,236,6,200,4,78,0,61,0,76,0,85,0,175,64,13,15,24,9,10,0,76,11,24,9,10,0,76,38,184,255,224,64,38,9,10,0,76,3,38,82,48,71,19,68,68,13,47,56,70,57,57,83,70,191,47,207,47,223,47,3,47,87,95,87,1,32,87,1,30,71,31,184,
255,192,64,55,21,24,72,31,31,74,71,79,13,95,13,111,13,3,13,68,48,81,19,82,82,62,77,25,81,36,41,36,31,30,47,30,127,30,143,30,4,30,30,36,16,53,62,79,8,16,56,32,56,2,56,56,0,8,22,0,63,51,51,47,93,16,237,50,63,51,47,93,17,51,16,237,50,18,57,47,51,237,50,1,47,93,237,51,47,43,237,93,93,16,222,113,237,51,47,237,17,18,57,47,51,237,50,57,57,49,48,0,43,1,43,43,5,34,38,39,14,3,35,34,46,2,53,52,62,2,63,1,53,52,46,2,35,34,14,2,7,37,62,3,51,50,23,62,1,51,50,30,2,29,1,33,20,30,2,51,50,54,55,5,14,3,37,50,62,2,61,
1,7,14,3,21,20,22,1,34,14,2,7,33,46,1,4,229,151,220,63,29,77,101,127,79,79,126,88,47,69,120,160,91,240,22,43,63,40,37,59,42,27,5,254,219,12,65,114,166,114,217,116,69,173,96,128,181,116,54,253,74,26,55,85,59,74,94,20,1,9,18,65,108,161,252,152,57,92,66,35,152,48,85,64,38,75,3,51,43,75,55,34,2,1,164,8,110,20,113,116,50,84,61,34,43,83,122,78,96,130,81,37,2,4,55,59,79,50,21,14,35,59,45,14,71,117,86,47,107,57,50,89,160,223,135,19,65,113,83,47,63,66,23,46,104,87,57,196,49,79,101,51,45,2,2,11,35,66,57,77,
75,2,237,29,63,100,70,131,131,0,0,0,255,255,0,80,254,87,4,55,4,78,18,38,0,70,0,0,17,7,0,120,1,35,0,0,0,11,182,1,9,40,33,5,28,37,1,43,53,0,0,0,255,255,0,80,255,236,4,45,5,222,18,38,0,72,0,0,17,7,0,67,0,221,0,0,0,21,180,2,40,17,38,2,184,255,223,180,41,44,5,15,37,1,43,53,0,43,53,0,255,255,0,80,255,236,4,45,5,222,18,38,0,72,0,0,17,7,0,116,1,75,0,0,0,19,64,11,2,40,17,38,2,98,40,43,5,15,37,1,43,53,0,43,53,0,0,0,255,255,0,80,255,236,4,45,5,249,18,38,0,72,0,0,17,7,1,75,0,223,0,0,0,19,64,11,2,41,17,38,2,17,
46,40,5,15,37,1,43,53,0,43,53,0,0,0,255,255,0,80,255,236,4,45,5,138,18,38,0,72,0,0,17,7,0,105,0,244,0,0,0,23,64,13,3,2,40,17,38,3,2,11,44,42,5,15,37,1,43,53,53,0,43,53,53,0,0,0,255,255,255,192,0,0,1,189,5,222,18,38,0,241,0,0,17,7,0,67,255,126,0,0,0,21,180,1,4,17,38,1,184,255,161,180,5,8,0,2,37,1,43,53,0,43,53,0,255,255,0,114,0,0,2,112,5,222,18,38,0,241,0,0,17,6,0,116,27,0,0,19,64,11,1,4,17,38,1,83,4,7,0,2,37,1,43,53,0,43,53,0,255,255,255,173,0,0,2,142,5,249,18,38,0,241,0,0,17,6,1,75,173,0,0,19,64,
11,1,5,17,38,1,0,10,4,0,2,37,1,43,53,0,43,53,0,255,255,255,216,0,0,2,99,5,138,18,38,0,241,0,0,17,6,0,105,200,0,0,23,64,13,2,1,4,17,38,2,1,0,8,6,0,2,37,1,43,53,53,0,43,53,53,0,0,2,0,80,255,238,4,147,5,223,0,39,0,53,0,167,185,0,2,255,248,64,11,9,10,0,76,28,64,9,10,0,76,1,184,255,216,180,9,10,0,76,37,184,255,240,180,9,10,0,76,31,184,255,208,64,24,9,10,0,76,24,46,40,71,6,0,37,27,30,4,33,39,15,28,31,28,2,28,28,33,184,255,192,64,44,9,15,72,33,39,33,39,16,6,55,46,71,16,37,30,0,27,4,28,39,38,38,33,29,28,
24,43,79,21,80,21,96,21,2,28,21,28,21,33,0,51,79,11,22,0,63,237,63,57,57,47,47,93,16,237,57,17,51,17,51,47,51,18,23,57,1,47,237,16,206,17,57,57,47,47,43,51,47,93,17,18,23,57,16,237,17,57,49,48,43,0,43,1,43,0,43,43,1,30,3,29,1,20,14,2,35,34,46,2,53,52,62,2,51,50,22,23,46,1,39,5,53,55,46,1,39,33,30,1,23,37,21,3,52,38,35,34,6,21,20,30,2,51,50,54,3,88,69,116,84,46,68,137,206,137,132,202,138,71,67,136,206,138,46,90,27,34,70,46,254,220,166,57,133,68,1,37,40,81,39,1,12,100,126,120,124,132,35,64,90,54,125,
134,4,242,70,161,181,202,111,4,122,204,147,82,73,131,183,110,107,181,132,74,17,15,72,110,53,122,184,70,46,88,42,20,46,28,113,188,252,186,160,143,146,157,80,115,75,35,144,0,0,255,255,0,135,0,0,4,100,5,196,18,38,0,81,0,0,17,7,1,82,1,10,0,0,0,19,64,11,1,36,17,38,1,12,47,63,19,34,37,1,43,53,0,43,53,0,0,0,255,255,0,80,255,236,4,147,5,222,18,38,0,82,0,0,17,7,0,67,1,6,0,0,0,21,180,2,36,17,38,2,184,255,213,180,37,40,10,0,37,1,43,53,0,43,53,0,255,255,0,80,255,236,4,147,5,222,18,38,0,82,0,0,17,7,0,116,1,122,
0,0,0,19,64,11,2,36,17,38,2,94,36,39,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,80,255,236,4,147,5,249,18,38,0,82,0,0,17,7,1,75,1,0,0,0,0,21,180,2,37,17,38,2,184,255,255,180,42,36,10,0,37,1,43,53,0,43,53,0,255,255,0,80,255,236,4,147,5,196,18,38,0,82,0,0,17,7,1,82,0,248,0,0,0,21,180,2,36,17,38,2,184,255,255,180,47,63,10,0,37,1,43,53,0,43,53,0,255,255,0,80,255,236,4,147,5,138,18,38,0,82,0,0,17,7,0,105,1,28,0,0,0,23,64,13,3,2,36,17,38,3,2,0,40,38,10,0,37,1,43,53,53,0,43,53,53,0,0,0,0,3,0,49,0,170,4,52,
4,170,0,3,0,7,0,11,0,77,64,40,6,14,2,5,1,14,15,5,1,19,3,5,1,10,2,170,9,1,1,12,13,9,173,64,8,14,4,1,5,14,0,173,160,1,1,1,4,173,5,178,0,63,237,214,93,237,43,0,24,16,77,246,26,237,17,18,1,57,47,196,253,196,16,198,95,94,93,43,1,24,16,77,230,49,48,1,53,51,21,1,53,33,21,1,53,51,21,1,186,238,253,137,4,3,253,134,238,3,193,233,233,254,120,224,224,254,113,233,233,0,0,0,0,3,0,1,255,201,4,218,4,109,0,27,0,35,0,47,0,128,185,0,26,255,208,64,17,9,10,0,76,12,48,9,10,0,76,7,32,9,10,0,76,21,184,255,208,64,11,9,10,
0,76,8,32,9,10,0,76,22,184,255,232,179,10,0,77,22,184,255,224,64,40,9,0,77,39,31,40,30,4,28,36,71,25,22,8,11,4,14,24,0,49,28,71,10,14,40,30,39,31,4,43,33,79,23,19,16,43,79,9,5,22,0,63,51,237,63,51,237,17,23,57,1,47,51,237,16,222,50,17,23,57,237,17,23,57,49,48,0,43,43,43,43,43,1,43,43,1,20,14,2,35,34,38,39,7,35,55,46,1,53,52,62,2,51,50,22,23,55,51,7,30,1,5,20,23,1,38,35,34,6,5,52,38,39,1,30,1,51,50,62,2,4,147,69,138,206,137,99,161,64,113,183,197,59,59,67,136,206,138,104,163,63,101,184,184,59,54,252,
228,17,1,151,60,108,124,132,1,246,8,8,254,105,32,82,50,62,97,66,34,2,30,124,206,149,83,46,43,124,215,73,193,116,121,205,150,84,43,40,114,206,74,196,115,92,71,1,205,69,176,191,47,81,34,254,52,37,35,43,90,140,255,255,0,127,255,236,4,92,5,222,18,38,0,88,0,0,16,7,0,67,0,217,0,0,255,255,0,127,255,236,4,92,5,222,18,38,0,88,0,0,16,7,0,116,1,120,0,0,255,255,0,127,255,236,4,92,5,249,18,38,0,88,0,0,16,7,1,75,0,252,0,0,255,255,0,127,255,236,4,92,5,138,18,38,0,88,0,0,16,7,0,105,1,26,0,0,255,255,0,16,254,87,4,
104,5,222,18,38,0,92,0,0,16,7,0,116,1,70,0,0,0,2,0,143,254,87,4,143,5,204,0,34,0,50,0,79,64,17,35,71,207,16,223,16,2,16,52,43,1,33,70,208,34,1,34,184,255,192,179,36,40,72,34,184,255,192,64,23,9,12,72,34,48,79,26,21,22,38,79,7,11,64,53,59,72,11,16,33,27,0,0,0,63,63,63,43,51,237,63,51,237,1,47,43,43,93,237,50,50,16,222,113,237,49,48,19,33,17,20,6,7,6,7,51,62,1,51,50,30,2,21,20,14,2,35,34,46,2,39,35,30,3,21,17,33,1,52,38,35,34,14,2,21,20,30,2,51,50,54,143,1,25,1,1,1,1,4,51,178,117,103,150,97,47,49,102,
157,107,48,95,86,73,26,6,1,2,2,1,254,231,2,219,111,112,42,83,65,41,40,65,82,42,108,117,5,204,254,50,30,60,24,28,26,107,92,80,142,195,116,117,198,144,81,20,45,73,54,5,40,53,59,25,254,97,3,177,172,166,32,79,134,101,99,131,78,32,165,0,255,255,0,16,254,87,4,104,5,138,18,38,0,92,0,0,16,7,0,105,0,241,0,0,255,255,0,51,0,0,5,145,6,169,18,38,0,36,0,0,17,7,1,77,1,140,1,78,0,19,64,11,2,23,5,38,2,0,21,22,4,7,37,1,43,53,0,43,53,0,0,0,255,255,0,60,255,236,4,128,5,91,18,38,0,68,0,0,17,7,1,77,0,243,0,0,0,21,180,
2,71,17,38,2,184,255,235,180,69,70,5,41,37,1,43,53,0,43,53,0,255,255,0,51,0,0,5,145,7,16,18,38,0,36,0,0,17,7,2,161,1,134,0,0,0,19,64,11,2,21,5,38,2,1,26,38,4,7,37,1,43,53,0,43,53,0,0,0,255,255,0,60,255,236,4,128,5,226,18,38,0,68,0,0,17,7,1,78,1,27,0,0,0,21,180,2,69,17,38,2,184,255,230,180,74,86,5,41,37,1,43,53,0,43,53,0,255,255,0,51,254,98,5,145,5,129,18,38,0,36,0,0,17,7,1,81,3,181,0,11,0,14,185,0,2,255,167,180,32,32,7,7,37,1,43,53,255,255,0,60,254,87,4,128,4,78,18,38,0,68,0,0,17,7,1,81,2,97,0,0,
0,18,179,2,15,80,1,184,255,100,180,80,80,41,41,37,1,43,93,53,255,255,0,84,255,236,5,143,7,23,18,38,0,38,0,0,17,7,2,155,2,53,0,0,0,19,64,11,1,42,5,38,1,153,42,45,16,6,37,1,43,53,0,43,53,0,0,0,255,255,0,80,255,236,4,55,5,222,18,38,0,70,0,0,17,7,0,116,1,103,0,0,0,19,64,11,1,33,17,38,1,121,33,36,5,28,37,1,43,53,0,43,53,0,0,0,255,255,0,84,255,236,5,143,7,43,18,38,0,38,0,0,17,7,2,156,1,204,0,0,0,19,64,11,1,43,5,38,1,48,48,42,16,6,37,1,43,53,0,43,53,0,0,0,255,255,0,80,255,236,4,55,5,249,18,38,0,70,0,0,17,
7,1,75,0,230,0,0,0,19,64,11,1,34,17,38,1,19,39,33,5,28,37,1,43,53,0,43,53,0,0,0,255,255,0,84,255,236,5,143,6,218,18,38,0,38,0,0,17,7,1,79,1,190,1,14,0,19,64,11,1,42,5,38,1,33,42,44,16,6,37,1,43,53,0,43,53,0,0,0,255,255,0,80,255,236,4,55,5,204,18,38,0,70,0,0,17,7,1,79,1,4,0,0,0,11,182,1,21,33,35,5,28,37,1,43,53,0,0,0,255,255,0,84,255,236,5,143,7,43,18,38,0,38,0,0,17,7,2,157,1,184,0,0,0,19,64,11,1,42,5,38,1,28,44,50,16,6,37,1,43,53,0,43,53,0,0,0,255,255,0,80,255,236,4,55,5,249,18,38,0,70,0,0,17,7,1,
76,0,214,0,0,0,19,64,11,1,33,17,38,1,3,35,41,5,28,37,1,43,53,0,43,53,0,0,0,255,255,0,137,0,0,5,113,7,43,18,38,0,39,0,0,17,7,2,157,1,102,0,0,0,21,180,2,26,5,38,2,184,255,191,180,28,34,6,0,37,1,43,53,0,43,53,0,255,255,0,84,255,236,5,193,5,204,16,38,0,71,0,0,17,7,2,152,4,91,0,75,0,18,64,10,2,65,0,2,120,64,64,32,32,37,1,43,53,0,63,53,255,255,0,8,0,0,5,113,5,129,16,6,0,144,0,0,0,2,0,84,255,236,4,217,5,204,0,44,0,61,0,124,64,55,44,44,25,41,16,0,45,70,7,4,4,3,223,7,1,7,64,36,40,72,7,63,143,63,1,55,71,192,
25,208,25,2,48,25,1,25,6,43,82,44,3,44,50,81,30,35,30,0,30,16,30,32,30,3,30,184,255,192,64,17,14,17,72,44,30,44,30,1,57,79,16,20,22,11,21,1,0,0,63,63,63,51,237,17,57,57,47,47,43,93,17,51,16,237,17,51,16,237,50,1,47,93,113,237,113,16,206,43,93,50,50,47,16,237,50,50,50,17,57,47,49,48,1,53,33,21,51,21,35,17,20,22,23,33,46,3,53,35,14,1,35,34,46,2,53,52,62,2,51,50,30,2,23,51,52,38,52,38,61,1,33,53,1,52,46,2,35,34,14,2,21,16,51,50,62,2,3,59,1,26,132,132,6,2,254,240,2,5,5,3,4,49,176,122,102,149,97,47,49,
102,157,108,53,98,84,68,24,2,1,1,254,226,1,34,40,65,83,43,54,83,57,29,221,42,84,66,41,5,65,139,139,170,252,85,79,123,34,8,41,52,54,21,105,91,81,144,198,118,119,199,143,80,22,46,72,51,10,39,50,54,25,126,170,252,208,104,133,78,30,39,84,134,95,254,162,33,82,137,255,255,0,137,0,0,5,6,6,169,18,38,0,40,0,0,17,7,1,77,1,94,1,78,0,21,180,1,14,5,38,1,184,255,237,180,12,13,0,10,37,1,43,53,0,43,53,0,255,255,0,80,255,236,4,45,5,91,18,38,0,72,0,0,17,7,1,77,0,245,0,0,0,19,64,11,2,42,17,38,2,12,40,41,5,15,37,1,43,
53,0,43,53,0,0,0,255,255,0,137,0,0,5,6,7,16,18,38,0,40,0,0,17,7,2,161,1,97,0,0,0,21,180,1,12,5,38,1,184,255,247,180,17,29,0,10,37,1,43,53,0,43,53,0,255,255,0,80,255,236,4,45,5,226,18,38,0,72,0,0,17,7,1,78,1,16,0,0,0,21,180,2,40,17,38,2,184,255,251,180,45,57,5,15,37,1,43,53,0,43,53,0,255,255,0,137,0,0,5,6,6,218,18,38,0,40,0,0,17,7,1,79,1,109,1,14,0,21,180,1,12,5,38,1,184,255,250,180,12,14,0,10,37,1,43,53,0,43,53,0,255,255,0,80,255,236,4,45,5,204,18,38,0,72,0,0,17,7,1,79,0,241,0,0,0,11,182,2,7,40,42,
5,15,37,1,43,53,0,0,0,255,255,0,137,254,87,5,6,5,129,18,38,0,40,0,0,17,7,1,81,2,237,0,0,0,18,179,1,15,23,1,184,255,106,180,23,23,10,10,37,1,43,93,53,255,255,0,80,254,104,4,45,4,78,18,38,0,72,0,0,17,7,1,81,1,207,0,17,0,23,180,2,51,51,29,2,184,255,244,180,51,51,29,29,37,1,43,53,0,16,60,47,53,0,0,0,255,255,0,137,0,0,5,6,7,43,18,38,0,40,0,0,17,7,2,157,1,111,0,0,0,21,180,1,12,5,38,1,184,255,253,180,14,20,0,10,37,1,43,53,0,43,53,0,255,255,0,80,255,236,4,45,5,249,18,38,0,72,0,0,17,7,1,76,0,216,0,0,0,19,
64,11,2,40,17,38,2,10,42,48,5,15,37,1,43,53,0,43,53,0,0,0,255,255,0,84,255,236,5,186,7,43,18,38,0,42,0,0,17,7,2,156,1,199,0,0,0,19,64,11,1,47,5,38,1,21,52,46,20,9,37,1,43,53,0,43,53,0,0,0,255,255,0,84,254,78,4,90,5,249,18,38,0,74,0,0,17,7,1,75,0,233,0,0,0,19,64,11,2,71,17,38,2,2,76,70,28,43,37,1,43,53,0,43,53,0,0,0,255,255,0,84,255,236,5,186,7,16,18,38,0,42,0,0,17,7,2,161,1,205,0,0,0,19,64,11,1,46,5,38,1,35,51,63,20,9,37,1,43,53,0,43,53,0,0,0,255,255,0,84,254,78,4,90,5,226,18,38,0,74,0,0,17,7,1,78,
1,54,0,0,0,19,64,11,2,70,17,38,2,8,75,87,28,43,37,1,43,53,0,43,53,0,0,0,255,255,0,84,255,236,5,186,6,218,18,38,0,42,0,0,17,7,1,79,1,211,1,14,0,19,64,11,1,46,5,38,1,32,46,48,20,9,37,1,43,53,0,43,53,0,0,0,255,255,0,84,254,78,4,90,5,204,18,38,0,74,0,0,17,7,1,79,1,29,0,0,0,11,182,2,26,70,72,28,43,37,1,43,53,0,0,0,255,255,0,84,254,57,5,186,5,150,18,38,0,42,0,0,17,7,2,146,2,78,0,0,0,11,182,1,40,56,46,20,9,37,1,43,53,0,0,0,255,255,0,84,254,78,4,90,6,73,16,38,0,74,0,0,17,7,2,153,1,137,0,0,0,25,64,16,2,79,
17,38,2,19,70,78,28,43,37,82,64,33,33,72,43,1,43,53,0,43,53,0,255,255,0,137,0,0,5,61,7,43,18,38,0,43,0,0,17,7,2,156,1,147,0,0,0,19,64,11,1,13,5,38,1,5,18,12,4,10,37,1,43,53,0,43,53,0,0,0,255,255,0,143,0,0,4,100,7,122,18,38,0,75,0,0,17,7,2,156,1,46,0,79,0,19,64,11,1,33,2,38,1,10,38,32,23,8,37,1,43,53,0,43,53,0,0,0,0,2,0,14,0,0,5,185,5,129,0,19,0,23,0,106,64,65,20,12,0,90,17,15,19,25,64,25,80,25,96,25,3,112,25,128,25,2,32,25,48,25,160,25,192,25,4,23,11,3,90,6,8,32,4,48,4,2,4,22,18,6,95,7,15,11,7,2,
96,23,127,7,1,7,23,7,23,13,9,3,4,0,18,0,63,50,63,51,57,57,47,47,93,16,237,17,51,51,16,237,50,50,1,47,93,51,51,237,50,50,93,113,114,16,222,50,50,237,50,50,49,48,33,17,33,17,33,17,35,53,51,53,33,21,33,53,33,21,51,21,35,17,1,53,33,21,4,33,253,143,254,217,123,123,1,39,2,113,1,28,124,124,254,228,253,143,2,92,253,164,4,21,170,194,194,194,194,170,251,235,3,80,197,197,0,1,0,10,0,0,4,100,5,204,0,39,0,136,185,0,5,255,224,182,8,0,77,144,31,1,31,184,255,192,64,40,9,13,72,31,31,22,10,70,224,9,240,9,2,9,41,144,
41,160,41,2,112,41,240,41,2,239,41,1,33,30,22,70,23,25,25,27,208,23,1,23,184,255,192,179,36,40,72,23,184,255,192,181,8,12,72,23,33,25,184,1,15,64,14,30,26,26,3,28,0,23,9,21,16,80,0,3,15,0,63,51,237,63,51,63,18,57,47,51,237,50,1,47,43,43,93,51,51,47,16,237,50,50,93,113,114,16,222,93,237,18,57,47,43,93,49,48,0,43,1,62,1,51,50,30,2,21,17,33,17,52,46,2,35,34,14,2,21,17,33,17,35,53,51,53,33,21,33,21,33,21,20,14,2,7,1,164,57,172,119,98,135,85,38,254,232,20,46,74,53,51,83,60,33,254,231,133,133,1,25,1,50,
254,206,2,3,2,1,3,58,124,112,64,112,152,88,253,122,2,54,63,105,75,42,45,83,115,69,253,229,4,151,170,139,139,170,136,32,65,57,46,13,0,0,0,255,255,255,153,0,0,2,165,7,31,18,38,0,44,0,0,17,6,2,159,202,0,0,19,64,11,1,4,5,38,1,2,15,31,0,2,37,1,43,53,0,43,53,0,255,255,255,153,0,0,2,165,5,196,18,38,0,241,0,0,17,6,1,82,167,0,0,19,64,11,1,4,17,38,1,1,15,31,0,2,37,1,43,53,0,43,53,0,255,255,255,236,0,0,2,80,6,169,18,38,0,44,0,0,17,7,1,77,255,200,1,78,0,19,64,11,1,6,5,38,1,1,4,5,0,2,37,1,43,53,0,43,53,0,0,0,
255,255,255,236,0,0,2,80,5,91,18,38,0,241,0,0,17,6,1,77,200,0,0,19,64,11,1,6,17,38,1,0,4,5,0,2,37,1,43,53,0,43,53,0,255,255,255,188,0,0,2,128,7,16,18,38,0,44,0,0,17,6,2,161,193,0,0,19,64,11,1,4,5,38,1,1,9,21,0,2,37,1,43,53,0,43,53,0,255,255,255,189,0,0,2,129,5,226,18,38,0,241,0,0,17,6,1,78,246,0,0,19,64,11,1,4,17,38,1,1,9,21,0,2,37,1,43,53,0,43,53,0,255,255,0,88,254,87,1,220,5,129,18,38,0,44,0,0,17,6,1,81,12,0,0,14,185,0,1,255,223,180,15,15,2,2,37,1,43,53,0,0,255,255,0,69,254,87,1,201,5,204,18,38,
0,76,0,0,17,6,1,81,249,0,0,14,185,0,2,255,212,180,19,19,7,7,37,1,43,53,0,0,255,255,0,137,0,0,1,176,6,218,18,38,0,44,0,0,17,7,1,79,255,202,1,14,0,19,64,11,1,4,5,38,1,2,4,6,0,2,37,1,43,53,0,43,53,0,0,0,0,1,0,145,0,0,1,170,4,58,0,3,0,63,64,43,1,70,191,2,1,112,2,1,223,2,1,2,5,160,5,176,5,2,127,5,1,96,5,1,31,5,1,239,5,1,128,5,176,5,192,5,208,5,4,1,15,0,21,0,63,63,1,93,93,113,113,113,113,16,222,93,113,113,237,49,48,51,17,33,17,145,1,25,4,58,251,198,255,255,0,137,255,236,5,187,5,129,16,38,0,44,0,0,17,7,
0,45,1,212,0,0,0,26,64,17,1,255,22,1,239,22,1,192,22,1,111,22,1,48,22,1,22,17,93,93,93,93,93,53,255,255,0,143,254,87,3,226,5,204,16,38,0,76,0,0,17,7,0,77,2,57,0,0,0,41,185,0,33,255,192,64,24,12,12,72,3,2,207,22,1,175,22,1,127,22,1,64,22,1,16,22,1,0,22,1,22,17,93,93,93,93,93,93,53,53,43,0,255,255,0,31,255,236,4,34,7,43,18,38,0,45,0,0,17,7,2,156,1,92,0,0,0,19,64,11,1,25,5,38,1,174,30,24,5,18,37,1,43,53,0,43,53,0,0,0,0,2,255,166,254,87,2,135,5,249,0,9,0,29,1,37,64,232,28,32,9,10,0,76,22,9,38,9,54,9,
3,9,25,8,41,8,57,8,3,8,3,3,1,22,5,38,5,54,5,3,5,131,95,6,111,6,2,63,6,207,6,2,6,64,34,37,72,16,6,1,6,6,14,14,23,70,143,24,1,175,24,191,24,239,24,255,24,4,96,24,1,207,24,1,0,24,1,10,24,31,176,31,192,31,2,175,31,1,16,31,64,31,80,31,128,31,4,80,31,96,31,144,31,208,31,4,239,31,1,0,31,16,31,64,31,80,31,112,31,128,31,144,31,176,31,192,31,9,56,207,31,223,31,255,31,3,96,31,160,31,2,15,31,63,31,127,31,159,31,191,31,5,160,31,208,31,224,31,3,15,31,31,31,63,31,3,7,41,2,57,2,73,2,3,2,131,0,1,32,1,48,1,128,1,4,
48,1,96,1,112,1,144,1,160,1,192,1,240,1,7,1,23,15,17,80,10,27,3,8,142,6,15,1,1,15,1,47,1,63,1,95,1,127,1,159,1,239,1,7,1,0,47,93,113,51,237,50,63,237,63,1,47,93,113,237,93,94,93,93,113,114,114,94,93,93,113,114,114,114,16,222,94,93,93,113,113,114,237,50,47,50,47,93,43,93,113,237,93,18,57,17,51,93,51,93,49,48,0,43,1,21,35,39,35,7,35,53,1,51,1,34,38,39,53,30,1,51,50,62,2,53,17,33,17,20,14,2,2,135,159,203,4,211,160,1,2,229,254,253,56,83,31,13,26,12,39,48,28,10,1,25,32,69,109,4,187,28,192,192,28,1,62,
248,94,5,4,198,2,2,16,38,62,46,4,118,251,70,65,108,80,44,0,255,255,0,137,254,57,5,180,5,129,18,38,0,46,0,0,17,7,2,146,2,15,0,0,0,21,180,1,23,20,39,1,184,255,210,180,22,12,4,11,37,1,43,53,0,43,53,0,255,255,0,143,254,57,4,117,5,204,18,38,0,78,0,0,17,7,2,146,1,121,0,0,0,14,185,0,1,255,217,180,22,12,4,11,37,1,43,53,0,1,0,143,0,0,4,117,4,58,0,11,0,128,185,0,9,255,248,64,14,10,0,77,0,40,10,0,77,1,24,10,0,77,10,184,255,232,64,16,9,0,77,8,24,9,0,77,1,10,11,8,9,9,0,11,184,255,192,64,15,9,12,72,11,16,11,11,
13,7,3,70,208,4,1,4,184,255,192,179,36,40,72,4,184,255,192,64,16,9,12,72,4,2,7,10,1,7,1,8,5,15,4,0,21,0,63,50,63,51,57,57,17,51,17,51,1,47,43,43,93,237,50,17,51,47,56,43,51,51,17,51,17,57,57,49,48,43,43,43,43,43,33,1,7,17,33,17,33,17,1,33,9,1,3,66,254,223,121,254,231,1,25,1,130,1,46,254,132,1,153,1,234,84,254,106,4,58,254,64,1,192,254,90,253,108,0,0,255,255,0,137,0,0,4,164,7,23,18,38,0,47,0,0,17,7,2,155,0,173,0,0,0,21,180,1,6,5,38,1,184,255,109,180,6,9,0,4,37,1,43,53,0,43,53,0,255,255,0,106,0,0,2,
104,7,102,18,38,0,79,0,0,17,6,2,155,19,79,0,19,64,11,1,4,2,38,1,77,4,7,0,2,37,1,43,53,0,43,53,0,255,255,0,137,254,57,4,164,5,129,18,38,0,47,0,0,17,7,2,146,1,153,0,0,0,14,185,0,1,255,228,180,16,6,0,4,37,1,43,53,255,255,0,143,254,57,1,168,5,204,18,38,0,79,0,0,17,6,2,146,58,0,0,11,182,1,0,14,4,0,2,37,1,43,53,0,255,255,0,137,0,0,4,164,5,129,16,38,0,47,0,0,17,7,2,152,2,114,0,0,0,18,64,10,1,17,3,1,199,16,6,0,4,37,1,43,53,0,63,53,255,255,0,143,0,0,3,22,5,204,16,38,0,79,0,0,17,7,2,152,1,176,0,75,0,18,64,
10,1,15,0,1,121,14,14,2,2,37,1,43,53,0,63,53,255,255,0,137,0,0,4,164,5,129,18,38,0,47,0,0,17,7,1,79,1,213,253,142,0,11,182,1,147,6,8,0,4,37,1,43,53,0,0,0,255,255,0,143,0,0,3,113,5,204,16,38,0,79,0,0,17,7,1,79,1,144,253,142,0,19,185,0,9,255,192,179,17,17,72,9,184,255,192,178,16,16,72,43,43,0,0,0,0,1,0,0,0,0,4,164,5,129,0,13,0,69,64,38,31,8,47,8,63,8,3,8,8,11,12,15,7,11,90,0,2,2,4,0,9,3,1,10,4,7,4,2,8,2,8,2,5,3,11,95,0,18,0,63,237,63,57,57,47,47,18,23,57,50,51,1,47,51,51,47,16,237,50,16,206,17,57,47,
93,49,48,51,17,7,53,55,17,33,17,37,21,5,17,33,21,137,137,137,1,39,1,51,254,205,2,244,1,227,65,225,66,2,188,253,209,147,223,147,254,116,231,0,0,1,0,18,0,0,2,41,5,204,0,11,0,122,64,80,15,4,1,224,4,240,4,2,4,4,6,2,70,1,239,10,1,10,10,9,191,1,1,112,1,1,223,1,1,1,13,160,13,176,13,2,127,13,1,96,13,1,31,13,1,239,13,1,128,13,176,13,192,13,208,13,4,58,11,1,11,53,5,1,5,3,0,6,9,4,4,10,4,10,4,1,7,0,1,21,0,63,63,18,57,57,47,47,18,23,57,50,93,51,93,1,93,93,113,113,113,113,16,206,93,113,113,50,50,47,93,16,237,50,
50,47,93,114,49,48,1,17,33,17,7,53,55,17,33,17,55,21,1,168,254,231,125,125,1,25,129,2,205,253,51,2,49,69,215,69,2,196,253,216,74,213,255,255,0,137,0,0,5,61,7,23,18,38,0,49,0,0,17,7,2,155,1,231,0,0,0,19,64,11,1,20,5,38,1,90,20,23,8,18,37,1,43,53,0,43,53,0,0,0,255,255,0,135,0,0,4,100,5,222,18,38,0,81,0,0,17,7,0,116,1,132,0,0,0,19,64,11,1,36,17,38,1,100,36,39,19,34,37,1,43,53,0,43,53,0,0,0,255,255,0,137,254,57,5,61,5,129,18,38,0,49,0,0,17,7,2,146,1,252,0,0,0,14,185,0,1,255,251,180,30,20,8,18,37,1,43,
53,255,255,0,135,254,57,4,100,4,79,18,38,0,81,0,0,17,7,2,146,1,155,0,0,0,11,182,1,7,46,36,19,34,37,1,43,53,0,0,0,255,255,0,137,0,0,5,61,7,43,18,38,0,49,0,0,17,7,2,157,1,136,0,0,0,21,180,1,20,5,38,1,184,255,251,180,22,28,8,18,37,1,43,53,0,43,53,0,255,255,0,135,0,0,4,100,5,249,18,38,0,81,0,0,17,7,1,76,0,242,0,0,0,21,180,1,36,17,38,1,184,255,237,180,38,44,19,34,37,1,43,53,0,43,53,0,255,255,255,234,0,0,5,44,5,129,16,39,0,81,0,200,0,0,17,7,2,9,255,95,0,0,0,66,185,0,1,255,182,64,43,36,36,14,14,37,0,192,
0,1,175,0,1,127,0,1,32,0,1,16,0,1,15,0,1,224,0,1,160,0,1,112,0,1,111,0,1,63,0,1,0,0,1,0,17,93,93,93,93,93,93,113,113,113,113,113,113,53,43,53,0,0,0,1,0,133,255,236,5,75,5,149,0,57,0,80,185,0,56,255,248,64,46,9,10,0,76,15,5,31,5,2,5,5,28,16,90,53,59,41,28,90,32,29,48,29,2,29,41,22,95,47,4,36,3,29,18,11,95,0,0,6,16,6,2,6,6,0,19,0,63,50,47,93,16,237,63,63,63,237,50,1,47,93,237,50,16,222,237,17,57,47,93,49,48,43,5,34,46,2,39,55,30,3,51,50,62,2,53,17,52,46,2,35,34,14,2,21,17,33,17,52,46,2,39,33,30,3,21,
51,62,3,51,50,30,2,21,17,20,14,2,3,136,74,115,92,72,32,202,17,37,44,52,31,54,67,36,12,32,67,103,71,76,134,99,57,254,217,1,1,1,1,1,32,2,4,3,2,4,32,97,123,145,81,117,168,106,50,42,103,174,20,23,45,67,43,171,22,42,33,20,45,86,128,82,1,39,94,134,85,39,59,99,131,72,252,185,4,68,37,92,90,76,22,22,63,69,69,28,62,100,70,39,64,133,204,139,254,165,130,208,146,78,0,0,0,0,1,0,135,254,87,4,100,4,79,0,51,0,103,64,43,50,32,9,10,0,76,3,25,13,70,224,46,240,46,2,46,53,144,53,160,53,2,112,53,144,53,160,53,176,53,240,
53,5,239,53,1,37,24,70,208,25,1,25,184,255,192,179,36,40,72,25,184,255,192,64,17,9,12,72,25,37,18,80,41,16,32,15,25,21,7,80,0,27,0,63,237,63,63,63,237,51,1,47,43,43,93,237,50,93,113,114,16,222,93,237,17,57,49,48,0,43,1,34,38,39,53,30,1,51,50,62,2,53,17,52,46,2,35,34,14,2,21,17,33,17,52,46,2,39,33,30,3,21,51,62,1,51,50,30,2,21,17,20,14,2,3,69,56,83,31,13,26,12,39,49,28,10,20,46,74,53,51,83,60,33,254,231,1,3,2,2,1,12,2,4,4,3,4,57,172,119,98,135,85,38,32,69,109,254,87,5,4,198,2,2,16,38,62,46,2,155,63,
105,75,42,45,83,115,69,253,188,3,72,35,74,67,53,13,12,53,64,64,22,124,112,64,112,152,88,252,209,65,108,80,44,0,255,255,0,84,255,236,5,227,6,169,18,38,0,50,0,0,17,7,1,77,1,198,1,78,0,19,64,11,2,42,5,38,2,0,40,41,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,80,255,236,4,147,5,91,18,38,0,82,0,0,17,7,1,77,1,32,0,0,0,19,64,11,2,38,17,38,2,4,36,37,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,84,255,236,5,227,7,16,18,38,0,50,0,0,17,7,2,161,1,181,0,0,0,21,180,2,40,5,38,2,184,255,247,180,45,57,10,0,37,1,43,53,0,43,
53,0,255,255,0,80,255,236,4,147,5,226,18,38,0,82,0,0,17,7,1,78,1,80,0,0,0,19,64,11,2,36,17,38,2,7,41,53,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,84,255,236,5,227,7,24,18,38,0,50,0,0,17,7,2,160,2,49,0,0,0,23,64,13,3,2,40,5,38,3,2,111,41,50,10,0,37,1,43,53,53,0,43,53,53,0,0,0,255,255,0,80,255,236,4,147,5,204,18,38,0,82,0,0,17,7,1,83,1,129,0,0,0,23,64,13,3,2,36,17,38,3,2,100,37,46,10,0,37,1,43,53,53,0,43,53,53,0,0,0,0,2,0,84,255,246,7,176,5,140,0,26,0,43,0,129,185,0,38,255,232,179,10,0,77,32,184,255,
232,64,75,10,0,77,20,24,91,43,22,59,22,75,22,3,43,22,18,18,22,43,3,8,25,45,143,45,1,2,45,64,12,15,72,35,91,48,8,1,15,8,31,8,2,8,23,95,95,20,111,20,143,20,223,20,255,20,5,239,20,1,20,20,40,13,30,19,95,13,16,3,40,24,95,3,0,18,0,63,50,237,50,63,51,237,50,17,18,57,47,93,113,237,1,47,93,93,237,43,95,113,16,206,17,23,57,47,47,47,93,237,50,49,48,43,43,33,14,1,35,34,36,38,2,53,52,18,54,36,51,50,22,23,33,21,33,17,33,21,33,17,33,21,1,46,1,35,34,14,2,21,20,30,2,51,50,54,55,3,224,38,107,54,177,254,247,178,89,
93,181,1,9,172,56,99,48,3,161,253,101,2,94,253,162,2,196,252,19,30,94,44,103,155,104,52,53,105,154,100,46,86,38,2,8,106,191,1,9,159,165,1,7,183,98,7,4,227,254,157,221,254,133,227,4,145,8,11,66,124,176,111,110,180,129,70,6,14,0,0,0,3,0,80,255,236,7,75,4,78,0,42,0,58,0,67,0,95,64,16,3,19,64,29,71,43,43,11,28,37,70,38,38,65,70,28,184,255,192,64,34,39,46,72,28,69,128,69,1,49,71,11,29,81,64,64,54,59,46,79,22,16,16,34,54,79,6,16,37,1,37,37,0,6,22,0,63,51,51,47,93,16,237,50,63,51,237,50,18,57,47,237,1,47,
237,93,16,222,43,237,51,47,237,17,18,57,47,237,50,57,57,49,48,5,34,38,39,14,1,35,34,46,2,53,52,62,2,51,50,22,23,62,1,51,50,30,2,29,1,33,20,30,2,51,50,54,55,5,14,3,1,52,38,35,34,6,21,20,30,2,51,50,62,2,1,34,14,2,7,33,46,1,5,104,118,185,66,69,196,129,132,202,137,70,67,136,206,138,134,194,66,71,190,106,128,181,116,54,253,74,26,55,85,59,74,94,20,1,9,18,65,108,161,253,146,126,120,124,132,35,64,90,54,62,97,66,34,1,251,43,75,55,34,2,1,164,8,110,20,79,80,76,83,82,148,207,125,121,205,150,84,80,73,81,72,89,
160,223,135,19,65,113,83,47,63,66,23,46,104,87,57,2,50,193,174,176,191,97,140,90,43,43,90,140,1,224,29,63,100,70,131,131,255,255,0,137,0,0,5,157,7,23,18,38,0,53,0,0,17,7,2,155,1,205,0,0,0,19,64,11,2,29,5,38,2,16,29,32,4,17,37,1,43,53,0,43,53,0,0,0,255,255,0,135,0,0,3,11,5,222,18,38,0,85,0,0,17,7,0,116,0,182,0,0,0,19,64,11,1,30,17,38,1,73,30,33,6,21,37,1,43,53,0,43,53,0,0,0,255,255,0,137,254,57,5,157,5,129,18,38,0,53,0,0,17,7,2,146,2,5,0,0,0,14,185,0,2,255,212,180,39,29,4,17,37,1,43,53,255,255,0,135,
254,57,2,254,4,79,18,38,0,85,0,0,17,6,2,146,57,0,0,14,185,0,1,255,88,180,40,30,6,21,37,1,43,53,0,0,255,255,0,137,0,0,5,157,7,43,18,38,0,53,0,0,17,7,2,157,1,102,0,0,0,21,180,2,29,5,38,2,184,255,169,180,31,37,4,17,37,1,43,53,0,43,53,0,255,255,0,56,0,0,3,25,5,249,18,38,0,85,0,0,17,6,1,76,56,0,0,21,180,1,30,17,38,1,184,255,230,180,32,38,6,21,37,1,43,53,0,43,53,0,0,0,255,255,0,59,255,236,5,6,7,23,18,38,0,54,0,0,17,7,2,155,1,212,0,0,0,19,64,11,1,62,5,38,1,137,62,65,10,0,37,1,43,53,0,43,53,0,0,0,255,255,
0,72,255,236,4,31,5,222,18,38,0,86,0,0,17,7,0,116,1,57,0,0,0,19,64,11,1,60,17,38,1,91,60,63,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,59,255,236,5,6,7,43,18,38,0,54,0,0,17,7,2,156,1,113,0,0,0,19,64,11,1,63,5,38,1,38,68,62,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,72,255,236,4,31,5,249,18,38,0,86,0,0,17,7,1,75,0,198,0,0,0,19,64,11,1,61,17,38,1,3,66,60,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,59,254,87,5,6,5,150,18,38,0,54,0,0,17,7,0,120,1,166,0,0,0,11,182,1,47,69,62,10,0,37,1,43,53,0,0,0,255,255,0,72,254,
87,4,31,4,79,18,38,0,86,0,0,17,7,0,120,1,30,0,0,0,11,182,1,20,67,60,10,0,37,1,43,53,0,0,0,255,255,0,59,255,236,5,6,7,43,18,38,0,54,0,0,17,7,2,157,1,90,0,0,0,19,64,11,1,62,5,38,1,15,64,70,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,72,255,236,4,31,5,249,18,38,0,86,0,0,17,7,1,76,0,205,0,0,0,19,64,11,1,60,17,38,1,10,62,68,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,23,254,87,4,205,5,129,16,39,0,120,1,67,0,0,18,6,0,55,0,0,255,255,0,25,254,87,2,145,5,56,16,39,0,120,0,156,0,0,18,6,0,87,0,0,255,255,0,23,0,0,4,205,
7,43,18,38,0,55,0,0,17,7,2,157,1,33,0,0,0,19,64,11,1,8,5,38,1,4,10,16,4,6,37,1,43,53,0,43,53,0,0,0,255,255,0,25,255,238,3,213,5,204,16,38,0,87,0,0,17,7,2,152,2,111,0,75,0,20,64,13,1,32,34,1,0,34,1,91,34,34,11,11,37,1,43,93,93,53,0,0,0,1,0,23,0,0,4,205,5,129,0,15,2,79,64,135,2,15,5,9,6,12,15,14,5,6,12,14,11,12,1,111,107,12,1,11,12,43,12,123,12,139,12,155,12,5,59,11,12,27,12,91,12,107,12,171,12,187,12,6,59,12,123,12,139,12,203,12,219,12,5,27,12,43,12,59,12,91,12,107,12,123,12,171,12,235,12,251,12,9,
12,1,5,90,10,203,6,219,6,235,6,3,180,6,1,11,6,75,6,91,6,155,6,4,139,6,187,6,203,6,3,6,64,42,52,72,4,6,20,6,2,11,6,144,17,1,4,17,116,17,132,17,3,164,17,180,17,244,17,3,17,184,255,192,64,255,222,225,72,107,17,123,17,2,84,17,1,59,17,1,4,17,36,17,2,204,240,17,1,212,17,228,17,2,187,17,1,132,17,148,17,164,17,3,107,17,1,84,17,1,59,17,1,4,17,20,17,2,219,17,235,17,2,176,17,192,17,2,36,17,84,17,100,17,116,17,164,17,5,251,17,1,224,17,1,212,17,1,171,17,1,148,17,1,91,17,1,68,17,1,27,17,43,17,2,4,17,1,154,251,
17,1,132,17,180,17,212,17,3,91,17,1,52,17,1,11,17,1,187,17,1,64,17,80,17,2,4,17,36,17,52,17,3,228,17,244,17,2,192,17,1,164,17,180,17,2,139,17,1,112,17,1,84,17,100,17,2,59,17,1,4,17,36,17,2,104,251,17,1,228,17,1,203,17,1,144,17,160,17,2,4,17,52,17,68,17,84,17,132,17,5,244,17,1,203,17,219,17,2,180,17,1,139,17,1,116,17,1,59,17,91,17,2,36,17,1,11,17,1,235,17,251,17,2,208,17,1,196,17,1,155,17,1,68,17,1,11,17,27,17,2,55,244,17,1,123,17,139,17,155,17,64,67,187,17,203,17,5,111,17,1,43,17,59,17,75,17,3,4,
17,1,11,17,75,17,91,17,139,17,171,17,219,17,6,255,17,1,2,143,17,207,17,223,17,3,0,17,32,17,48,17,112,17,4,7,0,12,95,13,4,8,95,1,9,9,5,13,3,5,18,0,63,63,18,57,47,51,237,50,16,237,50,1,94,93,93,95,93,113,114,114,114,114,114,94,93,93,93,93,93,93,113,113,113,113,113,113,113,113,114,114,114,114,114,94,93,93,93,93,93,93,93,93,113,113,113,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,113,114,114,114,114,114,114,114,114,94,93,93,93,93,43,93,113,113,47,94,93,43,93,113,114,114,51,237,50,198,93,
113,114,94,93,114,94,93,43,1,24,16,77,230,17,18,57,17,18,57,49,48,1,17,51,21,35,17,33,17,35,53,51,17,33,53,33,21,3,5,228,228,254,217,227,227,254,57,4,182,4,157,254,147,190,253,142,2,114,190,1,109,228,228,0,0,1,0,25,255,238,2,145,5,56,0,31,0,113,64,72,2,40,9,10,0,76,19,19,16,16,95,28,1,28,14,18,28,3,22,70,3,6,9,7,11,9,3,79,3,95,3,111,3,3,3,64,38,44,72,160,3,1,3,17,9,79,10,14,10,12,12,10,15,21,5,79,18,223,6,1,127,6,191,6,239,6,3,6,25,79,0,22,0,63,237,47,93,113,51,237,50,63,51,47,17,51,16,237,50,1,47,
93,43,113,23,51,47,50,16,237,23,50,47,93,51,47,51,47,49,48,43,5,34,38,61,1,35,53,51,53,35,53,51,55,51,21,51,21,35,21,51,21,35,21,20,22,51,50,54,55,21,14,1,1,164,124,134,127,127,137,151,88,176,205,205,185,185,60,63,26,42,26,52,116,18,135,137,219,190,229,190,254,254,190,229,190,143,79,75,8,6,174,17,17,255,255,0,123,255,236,5,74,7,31,18,38,0,56,0,0,17,7,2,159,1,141,0,0,0,19,64,11,1,26,5,38,1,0,37,53,5,20,37,1,43,53,0,43,53,0,0,0,255,255,0,127,255,236,4,92,5,196,18,38,0,88,0,0,16,7,1,82,0,243,0,0,255,
255,0,123,255,236,5,74,6,164,18,38,0,56,0,0,17,7,1,77,1,141,1,73,0,19,64,11,1,28,5,38,1,0,26,27,5,20,37,1,43,53,0,43,53,0,0,0,255,255,0,127,255,236,4,92,5,91,18,38,0,88,0,0,16,7,1,77,1,20,0,0,255,255,0,123,255,236,5,74,7,16,18,38,0,56,0,0,17,7,2,161,1,134,0,0,0,19,64,11,1,26,5,38,1,0,31,43,5,20,37,1,43,53,0,43,53,0,0,0,255,255,0,127,255,236,4,92,5,226,18,38,0,88,0,0,16,7,1,78,1,71,0,0,255,255,0,123,255,236,5,74,7,186,18,38,0,56,0,0,17,7,1,80,1,191,1,78,0,23,64,13,2,1,31,5,38,2,1,1,36,26,5,20,37,1,
43,53,53,0,43,53,53,0,0,0,255,255,0,127,255,236,4,92,6,108,18,38,0,88,0,0,16,7,1,80,1,72,0,0,255,255,0,123,255,236,5,74,7,24,18,38,0,56,0,0,17,7,2,160,1,219,0,0,0,23,64,13,2,1,26,5,38,2,1,82,27,36,5,20,37,1,43,53,53,0,43,53,53,0,0,0,255,255,0,127,255,236,4,99,5,204,18,38,0,88,0,0,16,7,1,83,1,93,0,0,255,255,0,123,254,87,5,74,5,129,18,38,0,56,0,0,17,7,1,81,2,32,0,0,0,21,64,13,1,37,64,41,49,72,1,70,37,37,25,25,37,1,43,53,0,43,53,0,255,255,0,127,254,87,4,92,4,58,18,38,0,88,0,0,16,7,1,81,2,133,0,0,255,
255,0,2,0,0,7,139,7,43,18,38,0,58,0,0,17,7,2,156,2,115,0,0,0,19,64,11,1,50,5,38,1,2,55,49,17,48,37,1,43,53,0,43,53,0,0,0,255,255,255,250,0,0,6,61,5,249,18,38,0,90,0,0,16,7,1,75,1,173,0,0,255,255,0,35,0,0,5,53,7,43,18,38,0,60,0,0,17,7,2,156,1,87,0,0,0,19,64,11,1,10,5,38,1,0,15,9,4,8,37,1,43,53,0,43,53,0,0,0,255,255,0,16,254,87,4,104,5,249,18,38,0,92,0,0,16,7,1,75,0,212,0,0,255,255,0,35,0,0,5,53,6,213,18,38,0,60,0,0,17,7,2,158,1,82,0,0,0,25,182,2,1,9,5,38,2,1,184,255,251,180,13,11,4,8,37,1,43,53,53,
0,43,53,53,0,255,255,0,61,0,0,4,168,7,23,18,38,0,61,0,0,17,7,2,155,1,130,0,0,0,19,64,11,1,10,5,38,1,101,10,13,1,0,37,1,43,53,0,43,53,0,0,0,255,255,0,68,0,0,3,199,5,222,18,38,0,93,0,0,17,7,0,116,0,249,0,0,0,19,64,11,1,10,17,38,1,73,10,13,0,8,37,1,43,53,0,43,53,0,0,0,255,255,0,61,0,0,4,168,6,218,18,38,0,61,0,0,17,7,1,79,1,40,1,14,0,19,64,11,1,10,5,38,1,10,10,12,1,0,37,1,43,53,0,43,53,0,0,0,255,255,0,68,0,0,3,199,5,204,18,38,0,93,0,0,17,7,1,79,0,189,0,0,0,11,182,1,12,10,12,0,8,37,1,43,53,0,0,0,255,255,
0,61,0,0,4,168,7,43,18,38,0,61,0,0,17,7,2,157,1,45,0,0,0,19,64,11,1,10,5,38,1,16,12,18,1,0,37,1,43,53,0,43,53,0,0,0,255,255,0,68,0,0,3,199,5,249,18,38,0,93,0,0,17,7,1,76,0,143,0,0,0,21,180,1,10,17,38,1,184,255,250,180,12,18,0,8,37,1,43,53,0,43,53,0,0,1,0,142,0,0,2,123,5,204,0,19,0,91,185,0,3,255,224,64,61,9,10,0,76,8,8,18,70,176,19,192,19,2,127,19,1,32,19,48,19,208,19,3,19,64,21,80,21,2,160,21,176,21,2,127,21,1,96,21,1,31,21,1,239,21,1,128,21,176,21,192,21,208,21,4,18,21,12,81,5,1,0,63,237,63,1,93,
93,113,113,113,113,114,47,93,113,113,237,50,47,49,48,0,43,19,52,62,2,51,50,22,23,21,46,1,35,34,14,2,21,17,33,142,30,72,122,91,48,93,37,18,45,19,39,51,29,12,254,232,4,171,62,105,78,44,10,6,181,4,5,16,32,49,32,251,113,0,0,0,0,1,0,168,254,87,4,9,5,174,0,29,0,75,185,0,13,255,224,64,40,9,10,0,76,10,29,9,12,110,18,16,15,15,14,29,31,13,14,12,16,117,9,32,17,80,17,96,17,112,17,4,17,17,13,5,117,24,7,13,27,0,63,63,237,18,57,47,93,51,237,50,1,47,51,16,206,17,57,47,51,51,237,50,17,57,49,48,43,1,46,3,35,34,6,15,
1,51,7,35,3,33,19,35,55,51,55,62,3,51,50,30,2,23,3,225,9,27,28,27,11,65,57,12,20,212,36,213,251,254,231,251,158,37,158,27,11,49,86,130,92,23,51,49,44,15,4,223,3,6,5,3,66,61,107,190,251,15,4,241,190,135,62,105,78,44,5,8,11,6,0,0,255,255,0,51,0,0,5,145,8,68,18,38,0,36,0,0,16,39,1,80,1,190,0,147,17,7,2,155,1,243,1,45,0,51,64,33,4,80,66,1,64,66,1,48,66,1,32,66,1,66,3,2,56,3,4,103,61,64,4,7,37,3,2,1,31,21,4,7,37,1,43,53,53,43,53,0,63,53,53,17,93,93,93,93,53,0,0,0,255,255,0,60,255,236,4,128,7,220,18,38,
0,68,0,0,16,39,1,80,1,20,0,0,17,7,0,116,1,99,1,254,0,55,64,28,4,80,114,1,64,114,1,48,114,1,32,114,1,114,3,2,74,17,38,4,91,109,112,5,41,37,3,2,184,255,219,180,79,69,5,41,37,1,43,53,53,43,53,0,43,53,53,17,93,93,93,93,53,0,0,0,255,255,0,4,0,0,7,176,7,23,18,38,0,134,0,0,17,7,2,155,3,228,0,0,0,21,180,2,25,5,38,2,184,1,96,180,25,28,4,14,37,1,43,53,0,43,53,0,255,255,0,66,255,236,6,200,5,222,18,38,0,166,0,0,17,7,0,116,2,175,0,0,0,19,64,11,3,86,17,38,3,128,86,89,13,46,37,1,43,53,0,43,53,0,0,0,255,255,0,84,
255,183,5,228,7,23,18,38,0,152,0,0,17,7,2,155,2,26,0,0,0,19,64,11,3,51,5,38,3,84,51,54,4,18,37,1,43,53,0,43,53,0,0,0,255,255,0,1,255,201,4,218,5,222,18,38,0,184,0,0,17,7,0,116,1,122,0,0,0,19,64,11,3,48,17,38,3,98,48,51,10,24,37,1,43,53,0,43,53,0,0,0,255,255,0,59,254,57,5,6,5,150,16,39,2,146,1,223,0,0,18,6,0,54,0,0,255,255,0,72,254,57,4,31,4,79,16,39,2,146,1,107,0,0,18,6,0,86,0,0,255,255,0,23,254,57,4,205,5,129,16,39,2,146,1,150,0,0,18,6,0,55,0,0,255,255,0,25,254,57,2,145,5,56,16,39,2,146,0,138,0,
0,18,6,0,87,0,0,0,1,0,0,4,159,2,225,5,249,0,9,0,121,64,61,38,9,54,9,70,9,3,41,8,57,8,73,8,3,9,8,3,3,1,38,5,54,5,70,5,3,5,131,6,41,2,57,2,73,2,3,2,131,0,1,32,1,48,1,3,16,1,64,1,112,1,160,1,192,1,208,1,240,1,7,1,184,255,192,64,27,30,37,72,1,3,8,142,6,15,1,1,15,1,47,1,63,1,95,1,127,1,159,1,239,1,7,1,0,47,93,113,51,237,50,1,47,43,93,113,237,93,47,237,93,18,57,17,51,51,93,93,49,48,1,21,35,39,35,7,35,53,1,51,2,225,159,203,4,211,160,1,2,229,4,187,28,192,192,28,1,62,0,0,1,0,0,4,159,2,225,5,249,0,9,0,121,
64,51,41,1,57,1,73,1,3,38,0,54,0,70,0,3,1,0,5,5,3,41,7,57,7,73,7,3,7,131,0,8,32,8,48,8,3,16,8,64,8,112,8,160,8,192,8,208,8,240,8,7,8,184,255,192,64,37,30,60,72,8,38,4,54,4,70,4,3,4,131,3,7,4,142,5,15,0,1,15,0,47,0,63,0,95,0,127,0,159,0,239,0,7,0,0,47,93,113,50,237,50,1,47,237,93,47,43,93,113,237,93,18,57,17,51,51,93,93,49,48,1,35,1,53,51,23,51,55,51,21,1,231,229,254,254,160,211,4,203,159,4,159,1,61,29,193,193,29,0,0,1,0,36,4,179,2,136,5,91,0,3,0,81,64,64,32,1,80,1,128,1,3,48,1,80,1,96,1,144,1,192,
1,240,1,6,47,1,95,1,143,1,191,1,239,1,5,1,0,1,144,111,2,143,2,159,2,3,15,2,47,2,63,2,95,2,127,2,5,2,64,36,39,72,2,64,26,29,72,2,0,47,43,43,93,113,237,1,47,47,93,113,114,49,48,19,33,21,33,36,2,100,253,156,5,91,168,0,0,1,255,199,4,159,2,139,5,226,0,21,0,180,64,148,16,23,32,23,64,23,80,23,112,23,128,23,160,23,7,80,23,128,23,176,23,224,23,4,95,23,143,23,2,0,23,16,23,2,56,64,23,112,23,160,23,208,23,224,23,5,31,23,79,23,2,239,23,1,0,23,48,23,96,23,144,23,160,23,5,8,16,131,15,17,31,17,79,17,127,17,175,17,
5,15,17,31,17,63,17,79,17,127,17,143,17,175,17,191,17,223,17,239,17,10,191,17,223,17,239,17,3,144,17,1,15,17,31,17,2,17,6,131,5,64,18,53,72,5,16,5,140,11,144,15,0,1,15,0,47,0,63,0,95,0,127,0,159,0,239,0,7,0,0,47,93,113,237,237,50,1,47,43,237,47,93,93,93,113,114,237,94,93,93,113,114,94,93,93,113,114,49,48,1,34,46,2,39,51,30,3,51,50,62,2,55,51,14,3,1,39,80,126,89,52,5,163,8,36,50,63,34,36,63,50,34,7,164,8,51,87,126,4,159,51,89,117,66,39,62,42,23,23,42,62,39,66,117,89,51,0,0,1,0,200,4,253,1,225,5,204,
0,3,0,23,64,10,3,70,0,0,4,5,0,83,1,0,0,63,237,17,18,1,57,47,237,49,48,19,53,33,21,200,1,25,4,253,207,207,0,2,0,39,4,112,2,35,6,108,0,19,0,39,0,76,185,0,18,255,232,180,9,10,0,76,2,184,255,232,64,42,9,10,0,76,12,24,9,10,0,76,8,24,9,10,0,76,20,135,0,137,30,135,95,10,143,10,159,10,3,10,64,20,25,72,10,25,148,15,148,35,145,5,0,47,237,244,237,1,47,43,93,237,244,237,49,48,43,43,43,43,1,20,14,2,35,34,46,2,53,52,62,2,51,50,30,2,7,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,2,35,40,69,93,52,52,93,69,40,40,69,93,
52,52,93,69,40,127,20,34,47,26,26,46,34,19,19,34,46,26,26,47,34,20,5,110,53,93,69,39,39,69,93,53,52,93,69,40,40,69,93,52,26,45,34,20,20,34,45,26,27,47,34,20,20,34,47,0,1,0,76,254,87,1,208,0,21,0,22,0,149,64,109,7,24,10,0,77,3,24,10,0,77,11,16,11,11,11,20,75,20,91,20,3,20,14,136,11,5,1,10,5,219,24,1,180,24,1,27,24,75,24,2,244,24,1,91,24,139,24,2,52,24,1,203,24,1,116,24,1,11,24,1,55,203,24,1,24,64,44,49,72,79,24,1,2,15,24,31,24,2,143,24,1,15,24,63,24,143,24,159,24,207,24,5,7,24,64,34,37,72,24,64,24,
28,72,10,21,17,145,0,27,0,63,237,63,1,43,43,94,93,113,114,95,114,43,114,94,93,93,93,113,113,113,114,114,114,47,94,93,237,47,93,57,47,56,49,48,43,43,1,34,46,2,53,52,62,2,55,51,14,1,21,20,22,51,50,54,55,21,6,1,57,51,87,63,36,32,48,55,23,153,63,66,49,45,31,53,28,63,254,87,25,51,74,50,48,81,62,43,12,42,115,53,42,51,14,13,137,33,0,0,1,255,242,4,159,2,254,5,196,0,31,0,226,185,0,30,255,216,64,22,9,10,0,76,14,24,9,10,0,76,68,27,100,27,116,27,148,27,164,27,5,27,184,255,192,64,109,21,31,72,11,27,1,9,27,11,
36,33,52,33,2,16,33,1,4,33,1,244,33,1,224,33,1,196,33,212,33,2,176,33,1,148,33,164,33,2,128,33,1,100,33,116,33,2,80,33,1,52,33,68,33,2,32,33,1,4,33,20,33,2,240,33,1,212,33,228,33,2,192,33,1,164,33,180,33,2,144,33,1,116,33,132,33,2,96,33,1,68,33,84,33,2,48,33,1,20,33,36,33,2,0,33,1,65,2,33,184,255,192,64,30,54,64,72,26,5,144,16,143,21,144,10,15,0,1,15,0,47,0,63,0,95,0,127,0,159,0,239,0,7,0,0,47,93,113,50,237,253,237,51,1,43,95,94,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,
113,113,114,114,114,47,47,94,93,43,93,49,48,43,43,1,34,46,2,35,34,14,2,7,35,62,3,51,50,30,2,51,50,62,2,55,51,14,3,2,31,44,89,84,75,30,26,34,21,12,5,137,3,16,47,86,73,45,90,84,73,29,25,33,23,13,5,135,2,16,46,86,4,159,38,47,38,17,32,45,29,45,102,88,58,38,47,38,17,32,46,28,45,102,88,58,0,0,0,0,2,255,164,4,160,3,6,5,204,0,5,0,11,0,61,64,40,9,130,10,132,6,131,15,7,1,7,3,130,4,132,0,131,1,9,3,140,6,15,0,1,15,0,47,0,63,0,95,0,127,0,159,0,239,0,7,0,0,47,93,113,50,237,50,1,47,237,253,237,47,93,237,253,237,
49,48,19,35,53,19,51,21,19,35,53,19,51,21,50,142,225,235,88,142,225,235,4,160,34,1,10,43,254,255,34,1,10,43,0,0,0,0,1,0,185,4,159,1,255,5,228,0,5,0,52,64,35,2,130,15,3,1,3,3,5,0,0,16,0,2,0,2,140,15,5,1,15,5,47,5,63,5,95,5,127,5,159,5,239,5,7,5,0,47,93,113,237,1,47,93,205,51,47,93,237,49,48,19,53,19,33,21,3,185,69,1,1,221,4,159,33,1,36,37,254,224,0,0,0,0,3,0,110,4,166,3,74,6,85,0,5,0,9,0,13,0,104,177,6,9,184,255,192,64,32,9,20,72,9,9,0,13,10,10,2,130,15,3,31,3,2,3,3,5,0,0,16,0,32,0,3,0,11,7,141,10,
6,184,255,192,64,30,25,35,72,6,2,64,19,22,72,2,140,15,5,1,15,5,47,5,63,5,95,5,127,5,159,5,239,5,7,5,0,47,93,113,237,43,212,43,50,237,50,1,47,93,205,51,47,93,237,51,47,205,17,51,47,43,205,49,48,1,53,19,51,21,3,37,53,51,21,33,53,51,21,1,105,59,237,181,254,146,200,1,76,200,4,166,33,1,142,37,254,118,41,222,222,222,222,255,255,0,36,0,0,5,145,5,130,16,38,0,36,0,0,17,7,1,84,255,107,255,158,6,96,179,2,23,3,2,184,255,53,181,24,24,5,5,37,28,184,255,192,179,229,229,72,28,184,255,192,179,228,228,72,28,184,255,
128,179,224,224,72,28,184,255,192,179,223,223,72,28,184,255,192,179,221,221,72,28,184,255,192,179,220,220,72,28,184,255,192,179,218,218,72,28,184,255,192,179,217,217,72,28,184,255,192,179,216,216,72,28,184,255,192,179,215,215,72,28,184,255,192,64,9,214,214,72,28,64,212,212,72,28,184,255,192,179,211,211,72,28,184,255,128,179,210,210,72,28,184,255,192,179,209,209,72,28,184,255,128,179,205,205,72,28,184,255,192,179,204,204,72,28,184,255,192,179,203,203,72,28,184,255,192,179,202,202,72,28,184,255,192,
179,198,198,72,28,184,255,192,179,197,197,72,28,184,255,192,179,196,196,72,28,184,255,192,64,9,195,195,72,28,64,193,193,72,28,184,255,128,179,192,192,72,28,184,255,192,179,191,191,72,28,184,255,192,64,9,190,190,72,28,64,186,186,72,28,184,255,128,179,185,185,72,28,184,255,192,179,184,184,72,28,184,255,192,179,183,183,72,28,184,255,192,179,179,179,72,28,184,255,128,179,178,178,72,28,184,255,192,179,177,177,72,28,184,255,192,179,172,172,72,28,184,255,192,179,170,170,72,28,184,255,192,179,166,166,72,
28,184,255,192,179,165,165,72,28,184,255,192,64,9,163,163,72,28,64,161,161,72,28,184,255,192,179,160,160,72,28,184,255,128,179,159,159,72,28,184,255,128,179,158,158,72,28,184,255,192,179,157,157,72,28,184,255,128,179,156,156,72,28,184,255,192,179,155,155,72,28,184,255,192,179,154,154,72,28,184,255,128,179,153,153,72,28,184,255,128,179,152,152,72,28,184,255,128,179,151,151,72,28,184,255,0,179,150,150,72,28,184,255,0,179,149,149,72,28,184,255,64,179,148,148,72,28,184,255,128,179,147,147,72,28,184,254,
192,179,146,146,72,28,184,254,192,179,145,145,72,28,184,255,0,179,144,144,72,28,184,255,64,179,143,143,72,28,184,255,64,179,142,142,72,28,184,255,0,179,141,141,72,28,184,254,192,179,140,140,72,28,184,255,0,179,139,139,72,28,184,255,0,179,138,138,72,28,184,255,64,179,137,137,72,28,184,255,128,179,136,136,72,28,184,255,0,179,135,135,72,28,184,255,64,179,134,134,72,28,184,255,0,179,133,133,72,28,184,255,64,179,132,132,72,28,184,255,64,179,131,131,72,28,184,255,0,179,130,130,72,28,184,255,64,179,129,
129,72,28,184,255,128,179,128,128,72,28,184,255,0,179,127,127,72,28,184,255,0,179,126,126,72,28,184,254,192,179,125,125,72,28,184,254,192,179,124,124,72,28,184,255,0,179,123,123,72,28,184,255,64,179,122,122,72,28,184,255,128,179,121,121,72,28,184,254,128,179,120,120,72,28,184,254,192,179,119,119,72,28,184,255,0,179,118,118,72,28,184,255,0,179,117,117,72,28,184,255,64,179,116,116,72,28,184,255,128,179,115,115,72,28,184,254,192,179,114,114,72,28,184,254,192,179,113,113,72,28,184,255,0,179,112,112,72,
28,184,255,64,179,111,111,72,28,184,255,128,179,110,110,72,28,184,255,0,179,109,109,72,28,184,255,64,179,108,108,72,28,184,255,0,179,107,107,72,28,184,255,0,179,106,106,72,28,184,255,64,179,105,105,72,28,184,255,0,179,104,104,72,28,184,255,64,179,103,103,72,28,184,255,64,179,102,102,72,28,184,255,0,179,101,101,72,28,184,255,64,179,100,100,72,28,184,254,192,179,99,99,72,28,184,255,0,179,98,98,72,28,184,255,64,179,97,97,72,28,184,255,128,179,96,96,72,28,184,255,128,179,95,95,72,28,184,255,64,179,94,
94,72,28,184,255,0,179,93,93,72,28,184,255,64,179,92,92,72,28,184,255,64,179,91,91,72,28,184,255,128,179,90,90,72,28,184,255,192,179,89,89,72,28,184,255,64,179,88,88,72,28,184,255,0,179,87,87,72,28,184,255,64,179,86,86,72,28,184,255,128,179,85,85,72,28,184,255,128,179,84,84,72,28,184,255,64,179,83,83,72,28,184,255,128,179,82,82,72,28,184,255,0,179,81,81,72,28,184,255,64,179,80,80,72,28,184,255,128,179,79,79,72,28,184,255,64,179,78,78,72,28,184,255,64,179,77,77,72,28,184,255,128,179,76,76,72,28,184,
255,192,179,75,75,72,28,184,255,128,179,74,74,72,28,184,255,0,179,73,73,72,28,184,255,64,179,72,72,72,28,184,255,128,179,71,71,72,28,184,255,128,179,70,70,72,28,184,255,192,179,69,69,72,28,184,255,128,179,68,68,72,28,184,255,64,179,67,67,72,28,184,255,64,179,66,66,72,28,184,255,128,179,65,65,72,28,184,255,192,179,64,64,72,28,184,255,192,179,63,63,72,28,184,255,128,179,62,62,72,28,184,255,64,179,61,61,72,28,184,255,128,179,60,60,72,28,184,255,128,179,59,59,72,28,184,255,192,179,58,58,72,28,184,255,
128,179,57,57,72,28,184,255,192,179,56,56,72,28,184,255,64,179,55,55,72,28,184,255,128,179,54,54,72,28,184,255,192,179,53,53,72,28,184,255,64,179,52,52,72,28,184,255,128,179,51,51,72,28,184,255,192,179,50,50,72,28,184,255,128,179,48,48,72,28,184,255,192,179,47,47,72,28,184,255,128,179,46,46,72,28,184,255,128,179,45,45,72,28,184,255,192,179,44,44,72,28,184,255,192,179,42,42,72,28,184,255,64,179,41,41,72,28,184,255,128,179,40,40,72,28,184,255,192,179,39,39,72,28,184,255,192,179,36,36,72,28,184,255,
128,179,35,35,72,28,184,255,128,179,34,34,72,28,184,255,192,179,33,33,72,28,184,255,192,179,31,31,72,28,184,255,192,179,30,30,72,28,184,255,128,179,29,29,72,28,184,255,192,179,28,28,72,28,184,255,192,179,27,27,72,28,184,255,192,179,25,25,72,28,184,255,192,179,22,22,72,28,184,255,192,179,20,20,72,28,184,255,192,179,19,19,72,28,184,255,192,179,17,17,72,28,184,255,192,179,16,16,72,28,184,255,128,179,15,15,72,28,184,255,192,179,14,14,72,28,184,255,192,179,12,12,72,28,184,255,128,179,9,9,72,28,184,255,
192,178,8,8,72,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,
43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,1,43,53,0,63,53,0,0,255,255,0,197,2,19,1,229,3,68,18,6,2,145,56,0,255,255,0,46,0,0,6,131,5,130,16,39,0,40,1,125,0,0,17,7,1,84,255,117,255,158,0,44,179,1,14,3,1,184,255,110,64,22,15,15,1,1,37,0,160,0,1,143,0,1,79,0,1,63,0,1,47,0,1,0,17,93,93,93,93,93,53,43,53,0,63,53,255,255,0,36,0,0,6,181,5,130,16,39,0,43,1,120,0,0,17,7,1,84,255,107,255,158,0,44,179,1,14,3,1,184,255,105,64,22,15,15,4,4,37,0,207,0,1,175,0,1,79,0,1,63,0,1,47,0,1,0,17,93,93,93,93,
93,53,43,53,0,63,53,255,255,0,36,0,0,3,65,5,130,16,39,0,44,1,145,0,0,17,7,1,84,255,107,255,158,0,60,179,1,6,3,1,184,255,80,64,34,7,7,0,0,37,0,240,0,1,239,0,1,207,0,1,223,0,1,143,0,1,127,0,1,64,0,1,63,0,1,0,0,1,0,17,93,93,93,93,93,93,93,93,93,53,43,53,0,63,53,255,255,255,230,255,236,6,67,5,150,16,38,0,50,96,0,17,7,1,84,255,45,255,158,0,67,180,2,42,3,2,40,184,255,192,178,9,17,72,184,255,50,64,32,40,40,10,10,37,1,0,111,0,1,111,0,1,95,0,1,79,0,1,63,0,1,15,0,1,255,0,1,96,0,1,0,17,93,93,113,113,113,113,
113,113,53,53,43,43,53,0,63,53,0,0,0,255,255,0,128,0,0,7,73,5,130,16,39,0,60,2,20,0,0,17,6,1,84,199,158,0,76,182,1,11,3,1,0,12,1,184,255,143,64,43,12,12,4,4,37,0,255,0,1,208,0,1,207,0,1,191,0,1,144,0,1,143,0,1,127,0,1,80,0,1,79,0,1,63,0,1,16,0,1,15,0,1,0,17,93,93,93,93,93,93,93,93,93,93,93,93,53,43,93,53,0,63,53,0,0,255,255,255,208,0,0,6,97,5,150,16,38,1,118,74,0,17,7,1,84,255,23,255,158,0,69,64,16,1,56,3,1,64,54,1,48,54,1,32,54,1,16,54,1,184,255,23,64,28,54,54,49,49,37,0,223,0,1,143,0,1,208,0,1,
128,0,1,112,0,1,79,0,1,15,0,1,0,17,93,93,93,93,93,113,113,53,43,93,93,93,93,53,0,63,53,0,255,255,255,169,0,0,2,133,6,85,18,38,1,134,0,0,17,7,1,85,255,59,0,0,0,18,178,3,2,1,184,255,217,180,20,26,5,13,37,1,43,53,53,53,255,255,0,51,0,0,5,145,5,129,18,6,0,36,0,0,255,255,0,137,0,0,5,106,5,129,18,6,0,37,0,0,0,1,0,137,0,1,4,174,5,129,0,5,0,36,64,21,32,0,48,0,2,0,7,3,90,32,4,48,4,2,4,2,95,5,3,3,18,0,63,63,237,1,47,93,237,16,198,93,49,48,1,21,33,17,33,17,4,174,253,2,254,217,5,129,228,251,100,5,128,0,0,0,0,
2,0,83,0,0,5,108,5,129,0,5,0,18,0,91,64,52,8,1,1,2,1,82,6,12,6,94,3,2,20,3,3,2,1,1,82,18,12,18,94,0,1,20,0,0,1,2,1,12,12,0,6,3,20,18,31,0,1,0,12,1,3,0,6,96,4,18,1,3,0,63,63,237,50,50,17,57,1,47,93,51,16,206,50,17,57,17,51,51,49,48,135,16,43,135,43,196,135,24,16,43,135,43,196,1,93,55,1,5,1,21,33,37,1,46,3,39,14,3,7,1,84,1,227,1,89,1,220,250,231,3,235,254,246,15,29,23,14,2,1,16,22,29,15,254,249,226,4,159,1,251,98,226,244,2,186,41,81,69,49,7,7,50,70,82,40,253,72,0,0,0,255,255,0,137,0,0,5,6,5,129,18,
6,0,40,0,0,255,255,0,61,0,0,4,168,5,129,18,6,0,61,0,0,255,255,0,137,0,0,5,61,5,129,18,6,0,43,0,0,0,3,0,84,255,236,5,227,5,150,0,3,0,23,0,43,0,137,181,27,40,10,0,77,31,184,255,232,64,14,10,0,77,41,16,10,0,77,41,8,9,0,77,37,184,255,232,179,10,0,77,37,184,255,248,64,66,9,0,77,0,1,34,24,91,4,45,48,45,64,45,96,45,112,45,128,45,160,45,6,32,45,240,45,2,34,91,48,14,1,15,14,31,14,2,14,3,95,95,0,111,0,143,0,223,0,255,0,5,239,0,1,0,0,39,29,95,19,4,39,95,9,19,0,63,237,63,237,18,57,47,93,113,237,1,47,93,93,237,
93,113,16,222,237,17,57,57,49,48,43,43,43,43,43,43,1,33,21,33,37,20,2,6,4,35,34,36,38,2,53,52,18,54,36,51,50,4,22,18,5,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,1,246,2,75,253,181,3,237,98,184,254,247,167,177,254,247,178,89,93,181,1,9,172,172,1,9,181,94,254,211,53,104,153,101,103,155,104,52,53,104,154,101,108,156,101,48,3,59,228,112,165,254,242,192,104,109,195,1,12,159,165,1,10,187,101,102,188,254,247,164,111,179,128,69,69,128,179,111,110,183,132,74,75,133,183,255,255,0,137,0,0,1,176,5,129,18,6,0,
44,0,0,255,255,0,137,0,0,5,180,5,129,18,6,0,46,0,0,0,1,0,14,0,1,5,72,5,130,0,16,0,164,64,49,15,1,82,13,7,13,94,14,15,20,14,15,13,14,16,0,1,82,1,7,16,7,1,94,0,16,20,0,16,1,16,15,7,7,14,1,0,16,0,0,1,0,0,32,0,48,0,3,0,184,255,192,179,37,41,72,0,184,255,192,64,20,28,35,72,0,0,18,192,18,1,159,18,1,96,18,1,47,18,1,13,14,184,255,240,64,20,15,14,1,14,64,37,41,72,14,64,28,35,72,14,7,15,3,14,0,18,0,63,50,63,57,1,47,43,43,113,56,51,93,93,93,93,17,51,47,43,43,93,113,56,50,18,57,17,51,51,0,193,135,5,43,16,0,193,
135,5,43,16,196,16,0,193,135,5,24,43,135,43,196,49,48,37,33,1,46,1,39,38,39,6,7,14,1,7,1,33,1,33,5,72,254,207,254,223,14,27,10,11,10,11,12,11,26,14,254,222,254,204,2,9,1,43,1,3,117,48,94,38,45,41,42,46,39,94,45,252,139,5,129,255,255,0,137,0,0,6,33,5,129,18,6,0,48,0,0,255,255,0,137,0,0,5,61,5,129,18,6,0,49,0,0,0,3,0,84,0,0,4,211,5,129,0,3,0,7,0,11,0,76,64,11,3,11,8,2,2,8,11,3,4,7,4,184,255,192,64,32,23,28,72,4,13,7,64,23,28,72,48,7,1,15,7,31,7,2,7,10,95,11,11,0,7,95,6,18,3,95,0,3,0,63,237,63,237,17,
57,47,237,1,47,93,93,43,16,206,43,17,23,57,47,47,47,47,49,48,19,33,21,33,1,21,33,53,1,21,33,53,119,4,57,251,199,4,92,251,129,3,228,252,183,5,129,228,252,71,228,228,2,87,228,228,0,0,255,255,0,84,255,236,5,227,5,150,18,6,0,50,0,0,0,1,0,137,0,0,5,61,5,129,0,7,0,39,64,22,0,90,207,7,1,7,9,3,90,32,4,48,4,2,4,2,96,5,3,4,0,18,0,63,50,63,237,1,47,93,237,16,222,113,237,49,48,33,17,33,17,33,17,33,17,4,32,253,143,254,218,4,180,4,141,251,115,5,129,250,127,0,0,0,255,255,0,137,0,0,5,16,5,129,18,6,0,51,0,0,0,1,0,
90,0,0,4,143,5,129,0,12,0,77,64,43,2,92,15,8,31,8,2,8,6,8,6,1,11,14,7,91,3,10,90,48,1,1,15,1,31,1,2,1,3,7,95,4,9,8,2,2,4,3,1,10,95,0,18,0,63,237,50,63,57,25,47,51,51,24,16,237,50,1,47,93,93,237,214,237,16,206,17,57,57,47,47,93,237,49,48,51,53,9,1,53,33,21,33,1,21,1,33,21,90,1,192,254,81,3,231,253,71,1,115,254,118,3,13,234,1,251,1,179,233,228,254,139,134,254,66,228,255,255,0,23,0,0,4,205,5,129,18,6,0,55,0,0,255,255,0,35,0,0,5,53,5,129,18,6,0,60,0,0,0,3,0,63,255,245,6,83,5,139,0,10,0,40,0,51,2,245,
64,255,27,5,40,92,47,24,11,11,18,0,91,33,53,167,53,183,53,215,53,3,136,53,1,119,53,1,102,53,1,39,53,71,53,87,53,3,6,53,1,229,53,245,53,2,214,53,1,199,53,1,168,53,1,150,53,1,133,53,1,118,53,1,103,53,1,56,53,72,53,2,37,53,1,22,53,1,7,53,1,200,216,53,1,201,53,1,180,53,1,165,53,1,134,53,150,53,2,119,53,1,88,53,1,69,53,1,38,53,54,53,2,23,53,1,248,53,1,231,53,1,213,53,1,198,53,1,183,53,1,152,53,1,137,53,1,119,53,1,102,53,1,87,53,1,70,53,1,39,53,55,53,2,6,53,1,245,53,1,230,53,1,199,53,215,53,2,168,53,1,
151,53,1,118,53,134,53,2,103,53,1,72,53,1,57,53,1,22,53,38,53,2,7,53,1,152,216,53,248,53,2,196,53,1,181,53,1,166,53,1,151,53,1,104,53,1,85,53,1,70,53,1,55,53,1,8,53,1,249,53,1,230,53,1,199,53,215,53,2,168,53,1,151,53,1,98,53,114,53,2,83,53,1,68,53,1,64,255,53,53,1,22,53,38,53,2,5,53,1,243,53,1,228,53,1,213,53,1,182,53,198,53,2,167,53,1,150,53,1,132,53,1,117,53,1,86,53,102,53,2,71,53,1,54,53,1,39,53,1,21,53,1,3,53,1,103,244,53,1,229,53,1,214,53,1,197,53,1,182,53,1,163,53,1,0,144,53,1,130,53,1,116,
53,1,102,53,1,82,53,1,68,53,1,48,53,1,34,53,1,20,53,1,6,53,1,246,53,1,228,53,1,214,53,1,180,53,1,166,53,1,146,53,1,132,53,1,114,53,1,100,53,1,86,53,1,64,53,1,50,53,1,36,53,1,22,53,1,4,53,1,230,53,246,53,2,210,53,1,196,53,1,182,53,1,148,53,164,53,2,134,53,1,100,53,1,86,53,1,52,53,1,34,53,1,20,53,1,6,53,1,55,226,53,242,53,2,212,53,1,194,53,1,1,176,53,1,164,53,1,112,53,1,100,53,1,80,53,1,68,53,1,27,53,1,4,53,1,84,53,116,53,132,53,180,53,212,53,228,53,6,59,53,1,32,53,1,20,53,1,244,53,1,219,64,53,53,1,
148,53,196,53,2,91,53,107,53,123,53,3,52,53,1,16,53,1,2,0,53,1,7,41,91,15,18,31,18,79,18,95,18,111,18,5,18,4,48,95,27,24,25,4,5,47,95,39,12,11,19,0,63,221,50,237,50,63,221,50,253,196,1,47,93,237,94,93,95,93,93,93,93,93,93,113,113,113,113,114,114,114,114,114,114,114,114,95,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,95,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,93,93,113,113,
113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,16,222,237,18,57,47,51,51,237,50,50,49,48,1,52,38,43,1,17,51,50,62,2,1,53,35,34,46,2,53,52,62,2,59,1,53,33,21,51,50,30,2,21,20,14,2,43,1,21,1,20,30,2,59,1,17,35,34,6,5,42,158,165,19,26,84,119,77,36,253,148,54,148,220,146,71,74,149,224,
150,42,1,22,42,150,224,149,74,71,146,219,149,54,253,148,36,77,119,84,26,19,165,158,2,218,152,170,253,113,50,89,122,253,99,199,88,150,198,110,119,195,138,75,158,158,75,138,195,119,110,198,150,88,199,2,229,72,122,89,50,2,143,170,0,0,0,255,255,0,18,0,0,5,68,5,129,18,6,0,59,0,0,0,1,0,96,0,0,6,25,5,129,0,35,3,50,64,255,200,37,216,37,232,37,3,185,37,1,170,37,1,155,37,1,137,37,1,104,37,120,37,2,89,37,1,74,37,1,41,37,57,37,2,7,37,1,216,37,232,37,2,201,37,1,186,37,1,120,37,136,37,168,37,3,105,37,1,90,37,1,
75,37,1,57,37,1,24,37,1,9,37,1,199,250,37,1,219,37,235,37,2,183,37,199,37,2,136,37,152,37,2,121,37,1,106,37,1,40,37,56,37,2,25,37,1,10,37,1,200,37,232,37,248,37,3,185,37,1,170,37,1,155,37,1,56,37,72,37,104,37,136,37,4,41,37,1,7,37,1,216,37,1,201,37,1,186,37,1,120,37,168,37,2,105,37,1,90,37,1,75,37,1,24,37,1,9,37,1,151,250,37,1,232,37,1,217,37,1,183,37,199,37,2,136,37,1,121,37,1,106,37,1,40,37,1,25,37,1,10,37,1,251,37,1,231,37,1,200,37,1,185,37,1,170,37,1,136,37,1,115,37,1,0,96,37,1,66,37,82,37,2,
52,37,1,6,37,38,37,2,226,37,242,37,2,212,37,1,198,37,1,169,37,1,64,255,150,37,1,130,37,1,116,37,1,102,37,1,20,37,1,2,37,1,103,242,37,1,228,37,1,182,37,198,37,214,37,3,146,37,162,37,2,132,37,1,70,37,86,37,118,37,3,50,37,1,36,37,1,22,37,1,230,37,1,201,37,1,166,37,182,37,2,148,37,1,134,37,1,116,37,1,102,37,1,66,37,1,52,37,1,6,37,38,37,2,246,37,1,212,37,1,150,37,166,37,198,37,3,121,37,1,86,37,102,37,2,36,37,1,6,37,22,37,2,55,242,37,1,1,224,37,1,212,37,1,192,37,1,164,37,180,37,2,139,37,1,116,37,1,80,37,
1,68,37,1,43,37,1,31,37,1,4,37,1,228,37,1,203,37,1,180,37,1,144,37,1,84,37,100,37,132,37,3,59,37,1,36,37,1,0,37,1,244,37,1,219,37,1,148,37,1,123,37,1,4,37,20,37,52,37,84,37,100,37,5,7,21,1,90,18,2,2,9,27,90,4,30,1,196,30,212,30,2,139,30,1,100,30,1,11,30,27,30,75,30,3,58,240,30,1,212,30,228,30,2,192,30,1,164,30,64,109,180,30,2,144,30,1,68,30,116,30,132,30,3,32,30,1,20,30,1,251,30,1,239,30,1,180,30,212,30,2,155,30,1,36,30,52,30,84,30,100,30,132,30,5,11,30,1,244,30,1,208,30,1,2,192,30,1,175,30,1,96,
30,1,79,30,1,0,30,32,30,48,30,3,10,30,37,12,90,0,9,1,68,112,9,1,32,9,48,9,2,15,9,31,9,2,9,21,18,95,0,3,3,1,28,19,10,3,1,18,0,63,63,51,51,18,57,47,51,237,50,1,47,93,93,113,94,93,237,16,222,94,93,93,93,93,93,95,93,93,113,113,113,113,113,113,114,114,114,114,114,114,114,114,94,93,93,93,93,113,237,17,57,47,51,237,50,94,93,93,93,93,93,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,95,114,94,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,
114,114,114,94,93,93,93,93,93,93,93,93,93,93,113,113,113,113,95,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,49,48,1,17,33,17,35,34,46,2,53,17,33,17,20,30,2,59,1,17,33,17,51,50,62,2,53,17,33,17,20,14,2,35,3,200,254,233,40,144,209,135,65,1,23,35,74,115,81,9,1,23,9,81,115,74,35,1,23,65,135,209,144,1,171,254,85,1,
171,67,131,194,127,1,207,254,45,80,112,70,32,2,249,253,7,32,70,112,80,1,211,254,49,127,194,131,67,0,0,1,0,83,0,0,6,23,5,150,0,53,0,113,185,0,29,255,240,64,66,10,0,77,25,16,10,0,77,44,36,10,18,64,36,96,36,2,79,18,111,18,2,36,18,36,18,49,22,91,5,5,207,16,1,16,55,32,90,176,49,1,49,49,192,38,1,15,38,31,38,2,38,19,19,35,35,15,38,95,18,37,18,27,95,0,4,0,63,237,63,51,237,50,50,47,51,47,1,47,93,113,50,47,113,237,16,206,113,50,47,237,18,57,57,47,47,93,93,17,51,17,51,49,48,43,43,1,50,4,30,1,21,20,14,2,7,54,
55,62,1,51,33,21,33,17,62,1,53,52,46,2,35,34,14,2,21,20,22,23,17,33,53,33,50,22,23,22,23,46,3,53,52,62,1,36,3,53,165,1,7,184,98,48,104,161,113,31,32,27,62,26,1,20,253,97,181,162,55,105,154,98,99,153,106,55,163,181,253,101,1,18,26,62,27,32,30,112,161,102,48,98,184,1,7,5,150,82,156,223,141,102,177,153,128,51,3,3,2,3,228,1,53,86,231,148,101,158,108,57,57,108,158,101,148,231,86,254,203,228,3,2,3,3,51,128,153,178,102,141,223,155,82,0,0,0,255,255,255,215,0,0,2,98,6,213,18,38,0,44,0,0,17,6,2,158,200,0,0,
23,64,13,2,1,4,5,38,2,1,0,8,6,0,2,37,1,43,53,53,0,43,53,53,0,255,255,0,35,0,0,5,53,6,213,18,38,0,60,0,0,17,7,2,158,1,82,0,0,0,25,182,2,1,9,5,38,2,1,184,255,251,180,13,11,4,8,37,1,43,53,53,0,43,53,53,0,255,255,0,80,255,236,4,214,5,228,18,38,1,126,0,0,17,7,1,84,1,78,0,0,0,19,64,11,2,58,17,38,2,23,58,61,8,21,37,1,43,53,0,43,53,0,0,0,255,255,0,77,255,236,3,171,5,228,16,38,1,130,0,0,17,7,1,84,0,238,0,0,5,245,64,12,1,56,17,38,1,78,56,59,14,4,37,63,184,1,128,179,229,229,72,63,184,1,64,179,228,228,72,63,
184,1,128,179,227,227,72,63,184,1,64,179,226,226,72,63,184,1,64,179,225,225,72,63,184,1,64,179,224,224,72,63,184,1,64,179,223,223,72,63,184,1,64,179,222,222,72,63,184,1,64,179,221,221,72,63,184,1,64,179,220,220,72,63,184,1,64,179,219,219,72,63,184,1,64,179,218,218,72,63,184,1,64,179,217,217,72,63,184,1,128,179,216,216,72,63,184,1,64,179,215,215,72,63,184,1,64,179,214,214,72,63,184,1,64,179,213,213,72,63,184,1,64,179,212,212,72,63,184,1,64,179,211,211,72,63,184,1,64,179,210,210,72,63,184,1,64,179,
209,209,72,63,184,1,64,179,208,208,72,63,184,1,64,179,207,207,72,63,184,1,64,179,206,206,72,63,184,1,64,179,205,205,72,63,184,1,64,179,204,204,72,63,184,1,0,179,203,203,72,63,184,1,64,179,202,202,72,63,184,1,0,179,201,201,72,63,184,1,64,179,200,200,72,63,184,1,0,179,199,199,72,63,184,1,64,179,198,198,72,63,184,1,64,179,197,197,72,63,184,1,64,179,196,196,72,63,184,1,64,179,195,195,72,63,184,1,0,179,194,194,72,63,184,1,64,179,193,193,72,63,184,1,0,179,192,192,72,63,184,1,64,179,191,191,72,63,184,1,
0,179,190,190,72,63,184,1,64,179,189,189,72,63,184,1,0,179,188,188,72,63,184,1,64,179,187,187,72,63,184,1,0,179,186,186,72,63,184,1,64,179,185,185,72,63,184,1,0,179,184,184,72,63,184,1,0,179,183,183,72,63,184,1,0,179,182,182,72,63,184,1,0,179,181,181,72,63,184,1,0,179,180,180,72,63,184,1,0,179,179,179,72,63,184,1,0,179,178,178,72,63,184,1,0,179,177,177,72,63,184,1,64,179,176,176,72,63,184,1,0,179,175,175,72,63,184,1,0,179,174,174,72,63,184,1,0,179,173,173,72,63,184,1,0,179,172,172,72,63,184,1,0,179,
171,171,72,63,184,1,0,179,170,170,72,63,184,1,0,179,169,169,72,63,184,1,0,179,168,168,72,63,184,1,0,179,167,167,72,63,184,1,0,179,166,166,72,63,184,1,0,179,165,165,72,63,184,1,0,64,9,164,164,72,63,192,163,163,72,63,184,1,0,64,9,162,162,72,63,192,161,161,72,63,184,1,0,64,9,160,160,72,63,192,159,159,72,63,184,1,0,179,158,158,72,63,184,1,0,179,157,157,72,63,184,1,0,179,156,156,72,63,184,1,0,179,155,155,72,63,184,1,0,179,154,154,72,63,184,1,0,64,9,153,153,72,63,192,152,152,72,63,184,1,0,64,9,151,151,
72,63,192,150,150,72,63,184,1,0,64,9,149,149,72,63,192,148,148,72,63,184,1,0,64,9,147,147,72,63,192,146,146,72,63,184,1,0,64,34,145,145,72,63,192,144,144,72,63,192,143,143,72,63,192,142,142,72,63,192,141,141,72,63,192,140,140,72,63,192,139,139,72,63,184,1,0,64,9,138,138,72,63,192,137,137,72,63,184,1,0,64,9,136,136,72,63,192,135,135,72,63,184,1,0,64,255,134,134,72,63,192,133,133,72,63,192,132,132,72,63,192,131,131,72,63,192,130,130,72,63,192,129,129,72,63,192,128,128,72,63,192,127,127,72,63,192,126,
126,72,63,192,125,125,72,63,192,124,124,72,63,128,123,123,72,63,192,122,122,72,63,128,121,121,72,63,192,120,120,72,63,128,119,119,72,63,192,118,118,72,63,192,117,117,72,63,192,116,116,72,63,192,115,115,72,63,192,114,114,72,63,192,113,113,72,63,128,112,112,72,63,192,111,111,72,63,128,110,110,72,63,192,109,109,72,63,128,108,108,72,63,192,107,107,72,63,128,106,106,72,63,192,105,105,72,63,128,104,104,72,63,192,103,103,72,63,128,102,102,72,63,128,101,101,72,63,128,100,100,72,63,128,99,99,72,63,192,98,
98,72,63,128,97,97,72,63,192,96,96,72,63,128,95,95,72,63,192,94,94,72,63,128,93,93,72,63,128,92,92,72,63,128,91,91,72,63,128,90,90,72,63,128,89,89,72,63,128,88,88,72,63,128,87,87,72,63,128,86,86,72,63,128,85,85,72,63,128,84,84,72,63,128,64,255,83,83,72,63,128,82,82,72,63,64,81,81,72,63,128,80,80,72,63,128,79,79,72,63,128,78,78,72,63,128,77,77,72,63,128,76,76,72,63,128,75,75,72,63,128,74,74,72,63,128,73,73,72,63,128,72,72,72,63,128,71,71,72,63,64,70,70,72,63,128,69,69,72,63,64,68,68,72,63,128,67,67,
72,63,64,66,66,72,63,128,65,65,72,63,64,64,64,72,63,128,63,63,72,63,64,62,62,72,63,64,61,61,72,63,64,60,60,72,63,64,59,59,72,63,128,58,58,72,63,64,57,57,72,63,128,56,56,72,63,64,55,55,72,63,128,54,54,72,63,64,53,53,72,63,128,52,52,72,63,64,51,51,72,63,64,50,50,72,63,64,49,49,72,63,64,48,48,72,63,64,47,47,72,63,64,46,46,72,63,64,45,45,72,63,64,44,44,72,63,64,43,43,72,63,64,42,42,72,63,64,40,40,72,63,64,39,39,72,63,64,38,38,72,63,64,37,37,72,63,64,36,36,72,63,64,35,35,72,63,64,34,34,72,63,64,33,33,
72,63,64,32,32,72,63,64,64,53,31,31,72,63,64,29,29,72,63,64,27,27,72,63,64,25,25,72,63,64,23,23,72,63,64,21,21,72,63,64,20,20,72,63,64,18,18,72,63,64,16,16,72,63,64,14,14,72,63,64,12,12,72,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,
43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,1,43,53,0,43,53,0,255,255,0,107,254,88,4,100,5,228,18,38,1,132,0,0,17,7,1,84,1,127,0,0,0,19,64,11,1,36,17,38,1,115,36,39,17,34,37,1,43,53,0,43,53,0,0,0,255,255,0,137,0,0,1,246,5,228,18,38,1,
134,0,0,17,6,1,84,247,0,0,19,64,11,1,14,17,38,1,21,14,17,5,13,37,1,43,53,0,43,53,0,255,255,0,127,255,236,4,84,6,85,18,38,1,146,0,0,17,7,1,85,0,128,0,0,0,25,181,3,2,1,3,2,1,184,255,243,180,36,42,8,0,37,1,43,53,53,53,0,53,53,53,0,0,2,0,80,255,236,4,214,4,78,0,37,0,57,0,90,64,28,34,40,10,0,77,34,16,9,0,77,0,16,26,70,32,48,48,48,2,48,48,8,21,32,31,31,20,21,184,255,192,64,23,9,12,72,21,21,59,38,71,8,32,21,20,15,53,79,16,11,16,43,79,0,5,22,0,63,51,237,63,51,237,63,63,1,47,237,17,51,47,43,51,51,17,51,17,
18,57,47,93,237,57,57,49,48,43,43,37,14,3,35,34,2,17,16,18,51,50,30,2,23,51,62,1,55,33,14,3,7,30,3,23,33,46,3,39,1,20,30,2,51,50,62,2,55,46,3,35,34,14,2,3,92,26,65,85,111,72,212,209,227,220,73,117,91,66,21,3,11,40,24,1,9,26,54,48,35,6,8,26,36,42,24,254,242,13,23,18,13,4,254,23,20,44,69,48,39,76,63,47,10,9,35,55,77,51,48,72,46,23,237,56,94,69,38,1,19,1,25,1,28,1,26,39,69,93,54,55,127,53,47,133,144,144,58,77,151,141,130,57,32,66,63,55,21,1,46,97,138,89,42,45,92,139,93,74,133,100,59,40,88,140,0,0,0,
0,2,0,142,254,87,4,157,5,204,0,32,0,62,0,108,185,0,21,255,240,180,9,10,0,76,2,184,255,240,64,27,9,10,0,76,49,13,52,70,23,64,9,15,72,23,23,13,43,70,0,64,33,13,70,208,14,1,14,184,255,192,179,36,40,72,14,184,255,192,64,20,9,12,72,14,28,48,79,49,49,38,57,80,18,0,13,27,38,79,5,22,0,63,237,63,63,237,18,57,47,237,57,1,47,43,43,93,237,50,16,222,237,18,57,47,43,237,18,57,49,48,43,43,1,20,14,2,35,34,38,39,35,30,1,21,17,33,17,52,54,51,50,30,2,21,20,14,2,7,30,3,5,30,3,51,50,62,2,53,52,46,2,35,53,62,1,53,52,46,
2,35,34,14,2,21,4,157,52,111,171,119,101,147,55,9,5,3,254,230,249,247,108,166,113,57,35,61,81,46,57,115,92,58,253,11,22,57,65,70,34,58,88,59,30,36,80,126,89,127,113,21,44,67,47,54,80,53,26,1,149,88,155,116,66,55,39,57,92,53,254,215,5,172,237,220,47,90,130,82,73,111,82,56,18,11,55,93,137,244,17,30,23,13,35,65,91,56,56,94,68,39,198,22,114,99,36,63,47,26,31,69,111,79,0,1,0,8,254,88,4,107,4,58,0,24,1,154,181,13,24,10,0,77,1,184,255,216,64,24,10,0,77,24,15,7,20,7,7,23,7,2,9,3,7,14,9,21,1,10,21,21,13,14,
184,255,192,64,255,9,13,72,14,16,14,14,26,107,26,1,84,26,1,11,26,43,26,75,26,155,26,251,26,5,207,20,26,52,26,132,26,148,26,164,26,228,26,6,244,26,1,219,26,1,164,26,196,26,2,235,26,1,212,26,1,123,26,155,26,2,100,26,1,11,26,43,26,2,157,27,26,43,26,75,26,107,26,155,26,171,26,187,26,7,91,26,107,26,139,26,155,26,187,26,219,26,251,26,7,79,26,1,11,26,59,26,2,255,26,1,187,26,1,132,26,1,75,26,91,26,107,26,3,52,26,1,11,26,1,108,43,26,59,26,75,26,139,26,155,26,219,26,251,26,7,155,26,171,26,187,26,219,26,235,
26,5,100,26,116,26,132,26,3,75,26,1,20,26,1,187,26,1,132,26,1,75,26,91,26,2,52,26,1,11,26,1,58,139,26,155,26,171,26,235,26,4,116,26,1,75,26,91,26,2,4,26,1,224,26,1,2,208,26,1,175,26,1,32,26,64,26,112,26,128,26,4,224,26,240,26,2,191,26,1,144,26,160,26,2,79,26,111,26,2,32,26,1,31,26,1,0,26,1,7,177,1,0,184,255,240,64,17,79,0,1,0,15,64,9,0,77,15,7,24,20,27,13,0,15,0,63,50,63,47,51,51,43,1,47,93,56,50,94,93,93,93,93,93,93,93,113,113,113,95,113,114,114,114,114,94,93,93,93,93,93,113,113,113,113,114,94,93,
93,93,93,93,93,113,113,113,114,94,93,93,93,93,93,113,113,113,114,94,93,113,113,17,51,47,56,43,51,57,47,94,93,18,57,95,94,93,51,17,51,51,49,48,43,43,19,33,19,30,3,23,62,3,55,19,33,1,14,3,7,33,62,1,55,8,1,42,212,3,17,18,15,1,4,16,18,18,7,201,1,39,254,117,21,37,31,25,9,254,222,20,53,28,4,58,253,128,9,62,77,79,27,31,73,71,63,21,2,123,251,252,55,110,117,126,70,134,213,88,0,0,0,2,0,86,255,236,4,132,5,204,0,19,0,50,0,127,185,0,25,255,224,183,9,10,0,76,46,5,0,25,184,255,208,64,32,9,10,0,76,25,0,47,16,47,
2,47,50,47,50,41,0,71,31,52,10,71,48,41,1,41,46,64,14,17,72,46,5,184,255,192,64,16,14,17,72,79,5,1,5,24,9,10,0,76,5,5,15,47,184,255,192,64,13,9,10,0,76,47,20,79,48,0,15,79,36,22,0,63,237,63,237,50,43,18,57,47,43,93,43,51,43,1,47,93,237,16,222,237,18,57,57,47,47,93,51,43,18,57,57,49,48,0,43,1,52,46,2,39,14,3,21,20,30,2,51,50,62,2,3,34,46,2,39,1,30,3,21,20,14,2,35,34,46,2,53,52,62,2,55,1,53,33,21,3,98,32,55,72,40,67,107,76,41,28,58,89,61,70,97,60,27,132,13,39,43,39,13,1,67,58,92,63,33,71,138,201,129,
127,198,135,71,73,127,169,96,254,200,3,85,1,231,69,117,102,88,40,24,76,105,134,83,66,112,81,46,47,82,115,3,106,2,2,2,1,254,219,53,114,128,146,84,108,185,134,76,69,129,186,117,110,172,132,95,33,1,58,147,190,0,0,0,1,0,77,255,236,3,171,4,78,0,55,0,104,64,63,27,24,9,10,0,76,12,24,9,10,0,76,42,70,19,48,25,48,35,35,48,25,3,14,0,4,16,4,2,4,4,57,53,71,79,14,1,14,19,48,47,47,0,39,82,30,43,36,1,36,36,30,16,0,81,9,16,3,1,3,3,9,22,0,63,51,47,93,16,237,63,51,47,93,16,237,18,57,47,205,57,1,47,93,237,17,51,47,93,
18,23,57,47,47,47,18,57,237,49,48,43,43,37,50,54,55,23,14,3,35,34,46,2,53,52,62,2,55,53,46,3,53,52,62,2,51,50,30,2,23,7,46,1,35,34,6,21,20,30,2,51,21,34,14,2,21,20,22,2,14,75,137,58,143,33,77,103,137,92,107,158,104,51,42,77,106,63,61,95,65,34,56,108,157,102,70,114,94,78,34,162,42,101,69,84,88,51,88,120,69,66,123,94,56,85,168,77,60,140,34,66,52,33,47,84,116,70,57,93,66,40,5,2,6,42,66,87,51,63,106,77,44,19,40,65,45,123,57,56,65,57,48,59,32,10,177,7,31,65,58,72,74,0,0,0,1,0,66,254,111,3,143,5,204,0,
54,0,141,185,0,3,255,248,64,15,10,0,77,37,24,10,0,77,29,32,9,10,0,76,8,184,255,232,179,10,0,77,7,184,255,232,64,18,9,0,77,38,48,64,30,60,72,48,48,10,16,45,48,45,2,45,184,255,192,64,41,15,18,72,45,45,31,16,16,21,70,10,64,13,18,72,10,56,0,70,79,31,95,31,111,31,3,31,64,39,60,72,31,48,45,81,0,21,15,46,0,15,184,1,16,0,63,63,18,57,57,237,50,1,47,43,93,237,16,222,43,237,50,47,17,57,47,43,93,17,51,47,43,51,49,48,0,43,1,43,43,43,0,43,1,20,30,2,23,30,3,21,20,14,2,7,39,62,3,53,52,46,2,39,46,3,53,52,62,4,55,
53,14,3,35,33,53,33,21,14,5,1,68,40,71,97,56,54,115,94,60,20,29,32,13,183,9,19,16,11,35,65,92,58,64,133,108,68,46,80,107,123,131,64,12,34,36,34,11,254,197,2,189,62,131,123,108,81,47,1,166,56,69,43,29,16,15,38,67,107,84,42,87,81,68,21,74,15,37,40,42,21,37,51,36,27,15,14,39,74,122,96,80,167,169,167,160,148,65,4,1,1,1,1,189,190,61,140,149,155,152,148,0,0,0,0,1,0,107,254,88,4,100,4,78,0,35,0,98,185,0,32,255,232,64,39,9,10,0,76,0,70,224,35,240,35,2,35,37,144,37,160,37,2,112,37,144,37,160,37,176,37,240,
37,5,239,37,1,23,12,70,208,13,1,13,184,255,192,179,36,40,72,13,184,255,192,64,15,9,12,72,13,23,6,80,29,16,17,15,13,21,0,27,0,63,63,63,63,237,51,1,47,43,43,93,237,50,93,113,114,16,222,93,237,49,48,43,1,17,52,46,2,35,34,14,2,21,17,33,17,52,38,39,33,30,3,21,51,62,3,51,50,30,2,21,17,3,77,19,44,71,52,53,87,61,33,254,230,22,14,1,13,9,14,10,5,3,27,64,84,108,72,93,133,85,41,254,88,4,29,75,101,61,26,41,80,115,75,253,187,3,83,68,121,42,21,48,49,47,20,47,76,53,29,44,92,144,101,251,135,0,0,0,0,3,0,90,255,236,
3,249,5,203,0,15,0,26,0,37,0,67,64,17,33,21,70,0,64,34,38,72,0,39,32,22,70,48,8,1,8,184,255,192,64,20,34,38,72,8,22,79,47,32,1,32,32,16,27,81,11,0,16,81,3,22,0,63,237,63,237,18,57,47,113,237,1,47,43,93,237,50,16,222,43,237,50,49,48,1,16,2,35,34,46,1,2,53,16,18,51,50,30,1,18,1,50,62,2,55,33,30,3,19,34,14,2,7,33,46,3,3,249,240,228,108,171,118,62,233,232,121,175,112,54,254,45,39,68,52,32,2,254,135,2,32,51,65,41,39,68,51,32,2,1,122,2,31,49,66,2,221,254,131,254,140,92,186,1,27,192,1,118,1,120,93,188,254,
231,253,9,47,111,186,138,138,185,112,47,4,114,45,108,179,134,134,179,108,45,0,0,1,0,137,0,0,1,243,4,58,0,13,0,119,64,90,10,48,9,10,0,76,3,48,9,10,0,76,13,64,9,12,72,13,13,6,70,15,7,63,7,79,7,3,62,127,7,191,7,239,7,3,175,7,191,7,207,7,255,7,4,112,7,1,207,7,223,7,2,0,7,16,7,2,7,15,160,15,176,15,2,127,15,1,96,15,1,31,15,1,239,15,1,128,15,176,15,192,15,208,15,4,6,15,0,21,0,63,63,1,93,93,113,113,113,113,16,222,93,93,113,113,114,94,93,237,51,47,43,49,48,43,43,51,46,3,53,17,33,17,20,30,2,23,199,15,24,15,
8,1,26,12,21,29,18,16,53,64,70,33,3,78,252,169,32,64,60,51,20,0,0,0,0,1,0,143,0,0,4,117,4,58,0,11,0,128,185,0,9,255,248,64,14,10,0,77,0,40,10,0,77,1,24,10,0,77,10,184,255,232,64,16,9,0,77,8,24,9,0,77,1,10,11,8,9,9,0,11,184,255,192,64,15,9,12,72,11,16,11,11,13,7,3,70,208,4,1,4,184,255,192,179,36,40,72,4,184,255,192,64,16,9,12,72,4,2,7,10,1,7,1,8,5,15,4,0,21,0,63,50,63,51,57,57,17,51,17,51,1,47,43,43,93,237,50,17,51,47,56,43,51,51,17,51,17,57,57,49,48,43,43,43,43,43,33,1,7,17,33,17,33,17,1,33,9,1,3,
74,254,221,127,254,231,1,25,1,141,1,35,254,132,1,153,1,199,106,254,163,4,58,254,18,1,238,254,50,253,148,0,0,0,1,0,9,0,0,4,84,6,1,0,35,1,173,185,0,35,255,240,64,9,10,0,77,20,16,10,0,77,14,184,255,224,64,9,10,0,77,2,32,10,0,77,33,184,255,240,64,17,9,0,77,35,17,9,7,9,1,10,3,9,16,27,27,15,16,184,255,240,64,9,11,16,1,13,16,1,0,16,0,184,255,192,64,255,9,13,72,0,0,37,107,37,1,84,37,1,11,37,43,37,75,37,155,37,251,37,5,207,20,37,52,37,132,37,148,37,164,37,228,37,6,244,37,1,219,37,1,164,37,196,37,2,235,37,
1,212,37,1,123,37,155,37,2,100,37,1,11,37,43,37,2,157,27,37,43,37,75,37,107,37,155,37,171,37,187,37,7,91,37,107,37,139,37,155,37,187,37,203,37,219,37,251,37,8,79,37,1,11,37,59,37,2,255,37,1,187,37,1,132,37,1,75,37,91,37,107,37,3,52,37,1,11,37,1,108,43,37,59,37,75,37,139,37,155,37,219,37,251,37,7,155,37,171,37,187,37,219,37,235,37,5,100,37,116,37,132,37,3,75,37,1,20,37,1,187,37,1,132,37,1,75,37,91,37,2,52,37,1,11,37,1,58,139,37,155,37,171,37,235,37,4,116,37,1,75,37,91,37,2,4,37,1,224,37,1,2,208,37,
1,175,37,1,32,37,64,37,112,37,128,37,4,224,37,240,37,2,191,37,1,144,37,160,37,2,79,37,111,37,2,32,37,1,31,37,1,0,37,1,7,64,10,9,17,17,0,23,80,30,16,0,21,0,63,50,47,237,18,57,47,51,1,94,93,93,93,93,93,93,93,113,113,113,95,113,114,114,114,114,94,93,93,93,93,93,113,113,113,113,114,94,93,93,93,93,93,93,113,113,113,114,94,93,93,93,93,93,113,113,113,114,94,93,113,113,17,51,47,43,56,50,47,94,93,56,51,57,47,17,57,95,94,93,17,51,51,49,48,43,43,43,43,43,41,1,3,46,5,39,14,3,7,3,33,1,39,46,3,35,34,6,7,39,62,
1,51,50,30,2,23,4,84,254,218,136,4,13,16,18,14,11,2,7,27,32,33,13,182,254,215,1,218,26,27,44,43,48,32,20,54,19,48,31,99,57,81,116,89,71,34,1,206,13,45,57,62,58,48,14,27,87,95,91,30,254,83,3,238,73,69,96,61,27,11,8,194,11,19,43,92,142,98,0,0,0,1,0,144,254,96,4,93,4,58,0,39,0,134,64,35,3,31,70,223,34,239,34,2,34,64,64,68,72,34,64,50,53,72,34,64,36,40,72,34,41,21,9,17,70,208,18,224,18,2,18,184,255,192,179,64,68,72,18,184,255,192,179,50,53,72,18,184,255,192,179,36,40,72,18,184,255,192,64,36,9,12,72,18,
144,41,160,41,2,112,41,144,41,160,41,176,41,240,41,5,239,41,1,32,19,15,18,27,26,80,12,3,9,22,0,21,0,63,63,51,51,237,63,63,51,1,93,113,114,47,43,43,43,43,93,237,50,50,16,222,43,43,43,93,237,50,49,48,33,46,3,53,35,14,1,35,34,38,39,35,30,1,21,17,33,17,33,17,20,30,2,51,50,62,2,53,17,33,17,20,30,2,23,3,81,1,5,4,3,3,38,122,86,52,87,23,4,3,1,254,231,1,25,19,43,70,52,50,80,58,31,1,25,1,3,3,1,12,44,53,54,21,99,105,48,42,32,55,28,254,141,5,218,253,163,64,104,75,41,45,81,115,70,2,66,252,184,34,73,67,54,14,0,
1,0,0,0,0,4,23,4,58,0,20,2,86,185,0,9,255,208,179,10,0,77,8,184,255,192,179,10,0,77,7,184,255,240,64,26,10,0,77,10,24,9,10,0,76,3,24,9,0,77,6,32,9,0,77,6,5,9,9,0,8,7,184,255,240,64,26,7,14,70,0,0,22,185,22,1,102,22,1,9,22,73,22,2,185,22,1,150,22,166,22,2,22,184,255,192,64,113,205,209,72,9,22,1,202,201,22,1,6,22,86,22,118,22,150,22,4,54,22,70,22,86,22,198,22,230,22,5,34,22,1,4,22,20,22,2,246,22,1,226,22,1,212,22,1,194,22,1,160,22,176,22,2,146,22,1,132,22,1,112,22,1,82,22,98,22,2,68,22,1,48,22,1,18,
22,34,22,2,4,22,1,151,226,22,242,22,2,196,22,212,22,2,162,22,178,22,2,132,22,148,22,2,114,22,1,84,22,100,22,2,22,184,255,64,64,255,136,139,72,0,22,1,240,22,1,226,22,1,212,22,1,192,22,1,162,22,178,22,2,148,22,1,128,22,1,98,22,114,22,2,84,22,1,66,22,1,52,22,1,38,22,1,18,22,1,4,22,1,244,22,1,230,22,1,210,22,1,1,192,22,1,164,22,180,22,2,128,22,144,22,2,100,22,116,22,2,64,22,80,22,2,52,22,1,16,22,1,4,22,1,103,244,22,1,208,22,224,22,2,180,22,196,22,2,160,22,1,132,22,148,22,2,96,22,1,68,22,84,22,2,32,22,
1,20,22,1,212,22,228,22,2,203,22,1,144,22,160,22,2,132,22,1,96,22,112,22,2,68,22,84,22,2,32,22,48,22,2,20,22,1,240,22,1,212,22,228,22,2,176,22,1,100,22,116,22,148,22,164,22,4,64,22,1,36,22,52,22,2,0,22,1,55,2,112,22,128,22,176,22,192,22,240,22,5,95,22,1,0,22,16,22,64,22,3,208,22,1,175,22,1,144,22,1,111,22,1,80,22,1,47,22,63,22,2,127,22,143,22,191,22,239,22,255,22,5,80,22,1,15,22,31,64,11,22,63,22,3,7,17,7,15,9,6,21,0,63,51,63,51,1,94,93,93,93,113,113,113,113,113,113,114,114,114,95,94,93,93,93,93,
93,93,93,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,95,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,113,114,43,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,114,114,94,93,43,93,93,113,113,113,16,206,47,237,47,56,51,18,57,17,51,51,49,48,43,43,43,43,43,43,1,20,14,2,7,33,1,33,1,62,3,53,52,38,39,33,30,1,4,23,63,108,141,78,254,245,254,122,1,41,1,5,56,79,50,23,29,20,1,24,23,27,3,78,99,218,221,214,94,4,58,
252,181,80,148,145,147,78,81,119,45,45,113,0,0,1,0,66,254,111,3,143,5,204,0,72,0,176,185,0,8,255,224,64,22,10,0,77,60,32,9,10,0,76,44,32,9,10,0,76,29,32,9,10,0,76,7,184,255,248,64,22,9,0,77,62,70,42,47,57,36,42,67,57,64,11,60,72,128,54,144,54,2,42,184,255,192,64,59,9,14,72,54,42,67,57,57,67,42,54,4,31,10,16,16,21,70,0,10,16,10,32,10,3,10,74,0,70,79,31,95,31,111,31,3,31,64,39,60,72,31,57,54,79,55,36,68,79,62,55,0,21,67,67,15,55,0,15,184,1,16,0,63,63,18,57,47,57,57,18,57,237,57,16,237,50,1,47,43,93,
237,16,214,93,237,50,47,17,18,23,57,47,47,47,47,43,93,43,17,18,57,17,51,16,237,49,48,0,43,1,43,43,43,43,1,20,30,2,23,30,3,21,20,14,2,7,39,62,3,53,52,46,2,39,46,3,53,52,62,2,55,53,46,3,53,52,62,2,55,53,14,3,43,1,53,33,21,14,3,21,20,30,2,23,21,14,3,1,68,40,71,97,56,54,115,94,60,20,29,32,13,183,9,19,16,11,35,65,92,58,64,133,108,68,52,111,176,124,67,119,87,51,50,79,97,47,12,68,80,76,18,76,2,142,69,130,101,61,53,89,115,61,100,161,113,61,1,164,53,68,45,30,15,15,38,67,107,84,42,87,81,68,21,74,15,37,40,42,
21,37,51,36,27,15,14,39,74,122,96,76,152,129,95,19,2,5,34,60,86,55,57,82,58,35,9,8,1,2,3,2,191,185,7,28,48,74,54,51,65,40,20,5,191,12,36,65,103,0,0,0,255,255,0,80,255,236,4,147,4,78,18,6,0,82,0,0,0,1,0,42,255,236,5,233,4,58,0,40,0,117,182,13,40,9,10,0,76,21,184,255,232,64,68,9,10,0,76,8,8,1,48,39,1,39,39,1,16,70,29,29,23,14,70,223,1,1,0,1,1,1,42,15,32,31,32,63,32,3,32,64,18,22,72,32,32,22,70,0,23,16,23,48,23,80,23,96,23,5,23,16,0,29,79,38,15,23,21,4,79,11,22,0,63,237,63,63,237,50,50,1,47,93,237,51,
47,43,93,16,220,93,93,237,17,57,47,237,17,51,47,93,18,57,47,49,48,43,43,1,17,20,22,51,50,54,55,23,14,1,35,34,38,53,17,33,21,20,14,2,7,33,62,3,61,1,34,6,7,53,62,3,51,33,21,4,216,56,48,26,52,20,20,44,115,64,141,137,254,149,13,24,32,19,254,225,19,36,29,17,97,149,36,15,44,49,51,23,5,9,3,124,253,179,72,55,8,4,184,10,14,149,136,2,115,124,130,218,186,160,74,76,163,184,212,125,132,17,20,198,7,11,7,4,190,0,0,0,0,2,0,121,254,87,4,163,4,79,0,26,0,45,0,61,64,21,27,71,0,47,38,15,71,15,16,1,239,16,255,16,2,16,
64,36,42,72,16,184,255,192,64,14,9,12,72,16,32,79,22,16,15,27,41,79,5,22,0,63,237,63,63,237,1,47,43,43,93,113,237,50,16,222,237,49,48,1,20,14,2,35,34,46,2,39,35,30,1,21,17,33,17,52,62,2,51,50,30,2,5,52,46,2,35,34,14,2,21,17,30,1,51,50,62,2,4,163,64,119,170,107,55,91,77,62,26,4,2,2,254,217,69,132,191,121,114,201,150,88,254,218,37,68,95,57,59,83,53,25,52,132,77,53,81,54,28,2,4,118,197,142,79,21,37,50,29,30,55,32,254,87,3,238,119,193,136,74,79,150,218,130,90,142,99,52,46,87,125,79,254,240,57,69,50,91,
130,0,0,0,0,1,0,79,254,111,3,216,4,79,0,57,0,87,182,32,16,9,10,0,76,9,184,255,232,64,9,10,0,77,54,16,10,0,77,3,184,255,240,64,27,10,0,77,45,45,35,12,18,18,23,70,12,59,0,70,35,0,23,17,51,79,42,46,46,42,16,17,184,1,16,0,63,63,51,47,16,237,18,57,57,1,47,237,16,222,237,50,47,17,18,57,47,49,48,0,43,43,1,43,43,1,20,30,2,23,30,5,21,20,14,2,7,39,62,3,53,52,46,2,39,46,5,53,52,62,4,51,50,22,23,7,46,3,35,34,14,4,1,84,44,77,106,62,40,83,79,70,52,31,22,33,37,14,178,9,19,16,11,42,76,103,62,45,93,88,76,58,33,22,
50,82,121,162,105,115,177,59,139,18,42,50,58,34,55,85,65,45,28,13,1,189,58,74,51,37,21,12,24,32,43,64,88,61,39,82,76,64,20,74,15,36,40,42,21,37,50,36,27,15,12,28,43,61,89,122,81,59,145,150,143,111,67,75,66,149,19,36,28,17,48,77,100,104,100,0,0,0,0,2,0,80,255,236,5,81,4,58,0,28,0,47,0,82,64,14,34,23,40,29,71,0,16,16,0,64,23,60,72,0,184,255,192,64,36,10,13,72,0,49,40,71,15,10,31,10,2,143,10,191,10,223,10,239,10,4,10,64,28,60,72,10,17,35,79,15,15,43,79,5,22,0,63,237,63,237,50,1,47,43,93,113,237,16,206,
43,43,50,47,16,237,18,57,57,49,48,1,20,14,2,35,34,46,2,53,52,62,2,51,33,21,35,34,46,2,39,21,30,3,5,52,46,2,39,35,34,14,2,21,20,22,51,50,62,2,4,146,68,135,203,136,136,205,138,69,95,169,235,140,2,130,195,10,39,47,49,19,31,60,48,29,254,218,17,28,37,20,74,68,118,88,51,125,121,65,95,64,31,1,202,105,176,126,71,74,139,202,129,144,210,138,66,190,1,2,2,1,4,40,94,108,124,36,63,114,101,86,36,45,91,138,94,177,175,44,83,118,0,0,1,0,18,255,235,3,112,4,58,0,33,0,114,64,85,31,40,9,10,0,76,47,5,63,5,175,5,3,5,5,32,
70,15,24,24,32,13,48,13,128,13,144,13,160,13,5,13,13,15,15,111,15,127,15,143,15,4,159,15,255,15,2,127,15,159,15,175,15,223,15,239,15,5,0,15,1,15,35,96,35,112,35,144,35,160,35,208,35,224,35,6,20,79,29,22,14,0,79,11,15,0,63,237,50,63,237,1,93,16,204,93,93,113,114,50,47,93,57,47,16,237,50,47,93,49,48,43,1,34,14,2,7,53,62,3,51,33,21,33,17,20,30,2,51,50,54,55,23,14,3,35,34,38,53,17,1,14,39,79,69,53,12,12,43,51,54,23,2,167,254,207,16,29,43,27,17,48,16,24,17,50,55,55,22,155,144,3,124,6,11,13,7,198,6,11,
8,4,190,253,188,40,52,31,12,5,3,178,5,10,8,5,140,132,2,129,0,1,0,127,255,236,4,84,4,58,0,29,0,75,64,37,7,16,9,0,77,24,19,70,0,31,144,31,160,31,2,112,31,144,31,160,31,176,31,240,31,5,239,31,1,11,70,239,8,255,8,2,8,184,255,192,64,11,9,12,72,8,24,9,15,14,80,5,22,0,63,237,63,51,1,47,43,93,237,93,113,114,16,222,237,50,49,48,43,1,20,14,2,35,34,38,53,17,33,17,20,22,51,50,62,2,53,52,46,2,39,33,30,3,4,84,59,125,194,136,240,227,1,25,95,108,59,82,52,23,23,36,44,21,1,30,20,42,35,22,2,59,136,219,154,82,221,232,
2,137,253,146,136,137,46,101,158,111,63,138,129,112,37,40,113,134,149,0,0,2,0,80,254,87,5,106,4,82,0,37,0,47,2,56,64,199,19,24,45,5,70,29,8,8,0,24,70,13,38,70,0,49,217,49,1,164,49,180,49,196,49,3,118,49,150,49,2,84,49,1,70,49,1,36,49,52,49,2,6,49,22,49,2,226,49,1,196,49,212,49,2,150,49,166,49,182,49,3,121,49,1,102,49,1,84,49,1,70,49,1,9,49,1,200,228,49,244,49,2,198,49,214,49,2,153,49,1,100,49,116,49,132,49,3,54,49,86,49,2,20,49,1,2,49,1,244,49,1,230,49,1,169,49,185,49,2,148,49,1,118,49,134,49,2,73,
49,1,18,49,34,49,2,4,49,1,246,49,1,228,49,1,214,49,1,178,49,1,164,49,1,118,49,150,49,2,66,49,1,52,49,1,6,49,38,49,2,152,210,49,1,196,49,1,166,49,182,49,2,98,49,1,52,49,68,49,84,49,3,38,49,1,244,49,1,49,184,255,192,64,55,130,133,72,137,49,1,38,49,70,49,86,49,118,49,4,9,49,1,182,49,230,49,246,49,3,116,49,132,49,2,102,49,1,41,49,57,49,2,22,49,1,4,49,1,103,246,49,1,201,49,1,187,49,1,49,184,255,192,64,174,93,96,72,73,49,1,38,49,54,49,2,230,49,246,49,2,201,49,1,180,49,1,166,49,1,89,49,105,49,121,49,3,68,
49,1,54,49,1,9,49,1,251,49,1,237,49,1,1,192,49,208,49,2,164,49,180,49,2,139,49,1,127,49,1,36,49,52,49,68,49,100,49,4,11,49,1,55,240,49,1,228,49,1,139,49,155,49,203,49,3,116,49,1,75,49,91,49,2,47,49,63,49,2,2,0,49,16,49,2,208,49,224,49,2,175,49,191,49,2,96,49,112,49,144,49,3,63,49,79,49,2,32,49,1,15,49,1,240,49,1,79,49,111,49,143,49,159,49,207,49,223,49,6,48,49,1,15,49,1,7,19,41,82,18,33,16,45,29,81,5,8,22,6,27,0,63,63,51,237,50,63,51,237,50,1,94,93,93,93,93,113,113,113,113,113,113,114,95,114,114,
114,114,114,114,94,93,93,93,93,93,93,95,93,93,113,113,113,113,113,113,113,113,114,114,43,114,114,114,94,93,93,93,93,93,93,113,113,113,43,113,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,16,222,237,47,237,18,57,47,51,237,50,18,57,49,48,1,20,14,2,7,17,35,17,46,3,53,52,62,2,55,23,14,3,21,20,30,2,23,17,52,54,51,50,30,2,5,52,38,35,34,6,21,17,62,1,5,106,81,145,198,117,238,121,195,
137,74,60,114,167,108,21,51,74,48,22,35,65,94,58,174,186,95,155,110,59,254,237,75,68,57,66,128,138,2,53,151,215,140,71,6,254,105,1,149,5,72,138,208,141,133,196,135,80,18,179,13,70,103,127,70,93,138,93,49,4,2,23,198,204,76,141,199,121,191,172,109,122,253,235,6,200,0,0,0,1,0,13,254,88,4,145,4,80,0,44,0,150,181,20,40,10,0,77,30,184,255,216,179,10,0,77,2,184,255,216,179,10,0,77,2,184,255,232,64,44,9,0,77,23,9,1,9,17,33,3,25,7,25,1,25,18,32,15,16,16,16,16,19,18,16,16,18,32,18,48,18,3,18,18,46,79,46,159,
46,2,42,42,31,32,184,255,240,64,25,32,23,9,1,9,25,25,25,2,9,17,25,3,33,33,15,32,18,27,15,15,39,80,0,16,0,63,237,63,63,51,18,57,25,47,23,51,93,93,1,24,47,56,51,51,47,93,17,51,47,93,56,51,51,56,17,51,17,18,57,93,17,23,51,93,49,48,0,43,43,1,43,43,19,50,30,2,31,1,30,1,23,62,3,55,19,33,9,1,33,3,46,3,39,14,3,7,3,33,1,39,46,3,35,34,7,39,62,1,233,60,90,79,77,47,20,2,9,3,5,16,17,16,5,155,1,41,254,137,1,157,254,212,195,7,21,21,18,5,5,20,22,21,7,214,254,212,1,196,119,37,55,46,43,27,41,40,40,31,109,4,80,42,94,
150,108,46,5,29,12,14,39,40,36,10,1,69,253,78,252,208,1,176,15,50,55,52,18,17,52,53,49,14,254,75,3,61,243,76,98,56,21,16,191,11,19,0,0,0,0,1,0,129,254,87,5,135,5,60,0,31,2,134,64,21,11,24,9,0,77,0,13,70,29,22,16,1,16,16,7,23,70,9,22,1,22,184,255,192,64,255,9,12,72,22,6,70,6,7,1,23,7,33,166,33,1,146,33,1,132,33,1,102,33,118,33,2,73,33,1,59,33,1,34,33,1,20,33,1,6,33,1,244,33,1,214,33,230,33,2,180,33,1,166,33,1,146,33,1,132,33,1,118,33,1,73,33,1,6,33,54,33,2,203,230,33,246,33,2,210,33,1,196,33,1,134,
33,166,33,182,33,3,98,33,1,84,33,1,70,33,1,25,33,1,11,33,1,228,33,244,33,2,210,33,1,196,33,1,166,33,182,33,2,137,33,1,118,33,1,98,33,1,84,33,1,70,33,1,25,33,1,6,33,1,214,33,1,196,33,1,166,33,182,33,2,146,33,1,132,33,1,70,33,102,33,118,33,3,34,33,1,20,33,1,6,33,1,154,233,33,1,219,33,1,201,33,1,176,33,1,162,33,1,148,33,1,118,33,134,33,2,89,33,1,70,33,1,36,33,52,33,2,22,33,1,233,33,249,33,2,214,33,1,185,33,1,162,33,1,148,33,1,134,33,1,84,33,1,22,33,70,33,2,233,33,249,33,2,214,33,1,169,33,185,33,2,64,
203,155,33,1,134,33,1,98,33,1,84,33,1,70,33,1,25,33,1,11,33,1,105,228,33,244,33,2,214,33,1,169,33,185,33,2,155,33,1,118,33,1,98,33,1,84,33,1,70,33,1,20,33,1,6,33,1,214,33,1,169,33,185,33,2,150,33,1,73,33,105,33,121,33,3,34,33,1,1,16,33,1,4,33,1,219,33,1,207,33,1,148,33,164,33,2,123,33,1,95,33,111,33,2,64,33,1,52,33,1,16,33,1,4,33,1,57,251,33,1,224,33,1,212,33,1,139,33,171,33,187,33,3,127,33,1,100,33,1,27,33,75,33,2,212,33,1,171,33,187,33,2,100,33,116,33,2,75,33,1,63,33,1,2,0,33,1,208,33,1,175,33,
191,33,2,144,33,1,63,33,111,33,127,33,3,0,33,16,33,2,8,0,29,79,13,16,22,30,30,6,22,15,14,27,0,63,63,51,51,47,63,51,237,50,1,94,93,93,93,93,93,113,95,113,113,113,113,113,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,95,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,
114,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,16,222,94,93,237,47,43,93,237,18,57,47,113,51,237,50,49,48,0,43,37,62,3,53,17,33,17,20,14,2,7,17,33,17,46,3,53,17,33,17,20,30,2,23,17,33,3,133,66,91,57,25,1,19,55,123,194,140,254,253,136,195,125,59,1,19,29,59,91,61,1,1,176,1,29,69,114,85,2,96,253,144,122,179,117,59,1,254,107,1,149,1,59,117,179,122,2,112,253,161,85,113,69,29,2,4,139,0,0,1,0,81,255,236,6,113,4,79,0,61,2,129,64,255,13,13,19,61,46,46,40,30,61,70,60,60,19,
51,70,6,40,1,40,8,70,9,19,1,38,19,63,185,63,1,148,63,164,63,2,134,63,1,116,63,1,102,63,1,52,63,1,38,63,1,4,63,20,63,2,246,63,1,196,63,1,178,63,1,164,63,1,102,63,150,63,2,68,63,1,54,63,1,25,63,1,6,63,1,202,233,63,1,212,63,1,198,63,1,164,63,1,150,63,1,121,63,1,102,63,1,84,63,1,66,63,1,52,63,1,38,63,1,9,63,1,242,63,1,212,63,228,63,2,198,63,1,137,63,169,63,2,116,63,1,102,63,1,41,63,73,63,2,2,63,1,244,63,1,226,63,1,212,63,1,198,63,1,148,63,1,130,63,1,116,63,1,102,63,1,57,63,73,63,2,34,63,1,20,63,1,6,63,
1,154,244,63,1,230,63,1,196,63,1,118,63,134,63,150,63,182,63,4,84,63,1,70,63,1,36,63,52,63,2,22,63,1,249,63,1,226,63,1,196,63,212,63,2,182,63,1,121,63,153,63,2,38,63,70,63,86,63,102,63,4,9,63,1,249,63,64,222,1,182,63,198,63,230,63,3,137,63,153,63,2,114,63,1,100,63,1,86,63,1,41,63,57,63,2,4,63,1,104,246,63,1,217,63,1,203,63,1,169,63,1,86,63,102,63,134,63,150,63,4,57,63,1,6,63,38,63,2,230,63,246,63,2,201,63,1,187,63,1,164,63,1,134,63,150,63,2,105,63,1,91,63,1,73,63,1,38,63,54,63,2,9,63,1,233,63,1,219,
63,1,150,63,182,63,198,63,3,121,63,1,107,63,1,86,63,1,52,63,1,38,63,1,9,63,1,56,251,63,1,226,63,1,1,208,63,1,196,63,1,171,63,1,159,63,1,123,63,1,100,63,1,75,63,1,63,63,1,27,63,43,63,2,240,63,1,2,176,63,192,63,224,63,3,159,63,1,80,63,96,63,128,63,3,63,63,1,0,63,1,79,63,95,63,127,63,191,63,223,63,5,0,63,1,8,60,60,14,3,56,79,30,24,35,22,46,13,81,45,14,16,0,63,51,237,50,63,51,51,237,50,17,57,47,1,94,93,93,113,113,113,113,113,95,113,114,114,114,114,114,114,114,114,114,95,114,114,94,93,93,93,93,93,93,93,
93,93,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,16,222,94,93,237,47,93,237,18,57,47,237,57,18,57,47,17,18,57,47,49,48,1,20,22,51,50,62,2,53,52,46,2,39,55,30,3,21,20,14,2,35,34,46,2,39,35,14,3,35,34,46,2,53,52,
62,2,55,23,14,3,21,20,30,2,51,50,54,61,1,33,3,227,94,85,54,73,44,18,29,61,96,68,23,121,192,133,71,58,111,162,104,74,114,84,58,17,4,17,58,84,114,74,104,162,111,58,71,133,192,120,23,68,96,62,28,18,44,72,54,86,97,1,2,1,218,142,156,48,90,127,78,72,131,106,73,13,189,18,93,147,201,127,128,200,137,72,32,60,89,57,57,89,60,32,72,137,200,128,127,201,147,93,18,187,13,74,105,131,72,78,127,90,49,156,141,187,0,0,255,255,255,217,0,0,2,100,5,138,18,38,1,134,0,0,17,6,0,105,201,0,0,25,182,2,1,14,17,38,2,1,184,255,
225,180,18,16,5,13,37,1,43,53,53,0,43,53,53,0,0,0,255,255,0,127,255,236,4,84,5,138,18,38,1,146,0,0,17,7,0,105,0,242,0,0,0,25,182,2,1,30,17,38,2,1,184,255,222,180,34,32,8,0,37,1,43,53,53,0,43,53,53,0,255,255,0,80,255,236,4,147,5,228,18,38,0,82,0,0,17,7,1,84,1,86,0,0,0,19,64,11,2,36,17,38,2,64,36,39,10,0,37,1,43,53,0,43,53,0,0,0,255,255,0,127,255,236,4,84,5,228,18,38,1,146,0,0,17,7,1,84,1,24,0,0,0,19,64,11,1,30,17,38,1,10,30,33,8,0,37,1,43,53,0,43,53,0,0,0,255,255,0,81,255,236,6,113,5,228,18,38,1,150,
0,0,17,7,1,84,2,91,0,0,0,19,64,11,1,62,17,38,1,86,62,65,40,19,37,1,43,53,0,43,53,0,0,0,255,255,0,137,0,0,5,6,6,213,16,38,0,40,0,0,17,7,2,158,1,121,0,0,2,60,64,14,2,1,12,5,38,2,1,6,16,14,0,10,37,21,184,255,192,179,228,228,72,21,184,255,192,179,227,227,72,21,184,255,192,179,225,225,72,21,184,255,192,179,224,224,72,21,184,255,192,179,222,222,72,21,184,255,192,179,221,221,72,21,184,255,192,179,219,219,72,21,184,255,192,179,218,218,72,21,184,255,192,179,216,216,72,21,184,255,192,179,215,215,72,21,184,
255,192,179,212,212,72,21,184,255,192,179,209,209,72,21,184,255,192,179,206,206,72,21,184,255,192,179,203,203,72,21,184,255,192,179,200,200,72,21,184,255,192,179,197,197,72,21,184,255,192,179,194,194,72,21,184,255,192,179,191,191,72,21,184,255,192,179,188,188,72,21,184,255,192,179,185,185,72,21,184,255,192,179,182,182,72,21,184,255,192,179,179,179,72,21,184,255,192,179,176,176,72,21,184,255,192,179,173,173,72,21,184,255,192,179,170,170,72,21,184,255,192,179,167,167,72,21,184,255,192,179,164,164,72,
21,184,255,192,179,161,161,72,21,184,255,192,179,158,158,72,21,184,255,192,179,155,155,72,21,184,255,192,179,152,152,72,21,184,255,192,179,149,149,72,21,184,255,192,179,146,146,72,21,184,255,192,179,143,143,72,21,184,255,192,179,140,140,72,21,184,255,192,179,137,137,72,21,184,255,192,179,134,134,72,21,184,255,192,179,131,131,72,21,184,255,192,179,128,128,72,21,184,255,192,179,125,125,72,21,184,255,192,179,122,122,72,21,184,255,192,179,119,119,72,21,184,255,192,179,116,116,72,21,184,255,192,179,113,
113,72,21,184,255,192,179,110,110,72,21,184,255,192,179,107,107,72,21,184,255,192,179,104,104,72,21,184,255,192,179,101,101,72,21,184,255,192,179,98,98,72,21,184,255,192,179,95,95,72,21,184,255,192,179,92,92,72,21,184,255,192,179,89,89,72,21,184,255,192,179,86,86,72,21,184,255,192,179,83,83,72,21,184,255,192,179,80,80,72,21,184,255,192,179,77,77,72,21,184,255,192,179,74,74,72,21,184,255,192,179,71,71,72,21,184,255,192,179,13,13,72,21,184,255,192,179,12,12,72,21,184,255,192,178,11,11,72,43,43,43,43,
43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,1,43,53,53,0,43,53,53,0,0,0,1,0,23,255,236,6,172,5,129,0,51,0,116,64,72,15,16,9,10,0,76,22,16,9,0,77,22,45,33,90,11,53,64,51,14,45,46,48,14,1,45,90,63,48,1,48,32,46,48,46,2,46,1,39,95,16,6,1,144,6,208,6,2,112,6,1,6,6,28,0,48,95,49,3,46,18,0,23,16,23,2,23,23,28,95,17,19,0,63,237,51,47,93,63,63,237,50,18,57,47,93,113,114,237,51,1,
47,93,198,93,237,50,43,1,24,16,77,228,26,16,222,237,17,57,49,48,43,0,43,1,17,62,3,51,50,30,2,29,1,20,14,2,35,34,46,2,39,55,30,3,51,50,62,2,61,1,52,46,2,35,34,14,2,7,17,33,17,33,53,33,21,3,5,36,103,126,143,75,117,171,111,53,42,102,169,128,74,118,95,76,32,202,17,37,44,52,31,54,67,36,12,24,60,101,78,54,110,102,89,33,254,217,254,57,4,182,4,157,254,176,15,36,31,21,54,110,169,115,54,108,172,121,65,23,45,67,43,171,22,42,33,20,33,63,93,60,9,67,97,63,30,12,20,23,11,253,107,4,157,228,228,0,0,255,255,0,137,
0,1,4,97,7,23,16,39,2,155,1,113,0,0,17,6,1,173,0,0,6,161,180,1,6,20,39,1,184,255,174,181,10,6,0,3,37,13,184,2,0,179,229,229,72,13,184,2,0,179,228,228,72,13,184,1,192,179,227,227,72,13,184,2,0,179,226,226,72,13,184,1,192,179,225,225,72,13,184,2,0,179,224,224,72,13,184,2,0,179,223,223,72,13,184,1,192,179,222,222,72,13,184,2,0,179,221,221,72,13,184,1,192,179,220,220,72,13,184,2,0,179,219,219,72,13,184,1,192,179,218,218,72,13,184,1,192,179,217,217,72,13,184,2,0,179,216,216,72,13,184,1,192,179,215,215,
72,13,184,2,0,179,214,214,72,13,184,1,192,179,213,213,72,13,184,1,192,179,212,212,72,13,184,1,192,179,211,211,72,13,184,1,192,179,210,210,72,13,184,2,0,179,209,209,72,13,184,1,192,179,208,208,72,13,184,1,192,179,207,207,72,13,184,1,192,179,206,206,72,13,184,1,192,179,205,205,72,13,184,1,192,179,204,204,72,13,184,1,192,179,203,203,72,13,184,1,128,179,202,202,72,13,184,1,192,179,201,201,72,13,184,1,192,179,200,200,72,13,184,1,192,179,199,199,72,13,184,1,192,179,198,198,72,13,184,1,128,179,197,197,72,
13,184,1,192,179,196,196,72,13,184,1,128,179,195,195,72,13,184,1,192,179,194,194,72,13,184,1,192,179,193,193,72,13,184,1,128,179,192,192,72,13,184,1,192,179,191,191,72,13,184,1,128,179,190,190,72,13,184,1,192,179,189,189,72,13,184,1,128,179,188,188,72,13,184,1,128,179,187,187,72,13,184,1,192,179,186,186,72,13,184,1,128,179,185,185,72,13,184,1,192,179,184,184,72,13,184,1,128,179,183,183,72,13,184,1,128,179,182,182,72,13,184,1,128,179,181,181,72,13,184,1,128,179,180,180,72,13,184,1,192,179,179,179,
72,13,184,1,128,179,178,178,72,13,184,1,128,179,177,177,72,13,184,1,128,179,176,176,72,13,184,1,128,179,175,175,72,13,184,1,128,179,174,174,72,13,184,1,128,179,173,173,72,13,184,1,64,179,172,172,72,13,184,1,128,179,171,171,72,13,184,1,128,179,170,170,72,13,184,1,128,179,169,169,72,13,184,1,128,179,168,168,72,13,184,1,64,179,167,167,72,13,184,1,128,179,166,166,72,13,184,1,64,179,165,165,72,13,184,1,128,179,164,164,72,13,184,1,128,179,163,163,72,13,184,1,64,179,162,162,72,13,184,1,128,179,161,161,72,
13,184,1,64,179,160,160,72,13,184,1,128,179,159,159,72,13,184,1,64,179,158,158,72,13,184,1,64,179,157,157,72,13,184,1,128,179,156,156,72,13,184,1,64,179,155,155,72,13,184,1,128,179,154,154,72,13,184,1,64,179,153,153,72,13,184,1,64,179,152,152,72,13,184,1,64,179,151,151,72,13,184,1,64,179,150,150,72,13,184,1,128,179,149,149,72,13,184,1,64,179,148,148,72,13,184,1,64,179,147,147,72,13,184,1,64,179,146,146,72,13,184,1,64,179,145,145,72,13,184,1,64,179,144,144,72,13,184,1,64,179,143,143,72,13,184,1,0,
179,142,142,72,13,184,1,64,179,141,141,72,13,184,1,64,179,140,140,72,13,184,1,64,179,139,139,72,13,184,1,64,179,138,138,72,13,184,1,0,179,137,137,72,13,184,1,64,179,136,136,72,13,184,1,0,179,135,135,72,13,184,1,64,179,134,134,72,13,184,1,64,179,133,133,72,13,184,1,0,179,132,132,72,13,184,1,64,179,131,131,72,13,184,1,0,179,130,130,72,13,184,1,64,179,129,129,72,13,184,1,0,179,128,128,72,13,184,1,0,179,127,127,72,13,184,1,64,179,126,126,72,13,184,1,0,179,125,125,72,13,184,1,64,179,124,124,72,13,184,
1,0,179,123,123,72,13,184,1,0,179,122,122,72,13,184,1,0,179,121,121,72,13,184,1,0,179,120,120,72,13,184,1,64,179,119,119,72,13,184,1,0,179,118,118,72,13,184,1,0,179,117,117,72,13,184,1,0,179,116,116,72,13,184,1,0,179,115,115,72,13,184,1,0,179,114,114,72,13,184,1,0,64,9,113,113,72,13,192,112,112,72,13,184,1,0,179,111,111,72,13,184,1,0,179,110,110,72,13,184,1,0,179,109,109,72,13,184,1,0,64,9,108,108,72,13,192,107,107,72,13,184,1,0,64,9,106,106,72,13,192,105,105,72,13,184,1,0,179,104,104,72,13,184,1,
0,64,9,103,103,72,13,192,102,102,72,13,184,1,0,64,9,101,101,72,13,192,100,100,72,13,184,1,0,64,14,99,99,72,13,192,98,98,72,13,192,97,97,72,13,184,1,0,64,9,96,96,72,13,192,95,95,72,13,184,1,0,64,24,94,94,72,13,192,93,93,72,13,192,92,92,72,13,192,91,91,72,13,192,90,90,72,13,184,1,0,64,255,89,89,72,13,192,88,88,72,13,192,87,87,72,13,192,86,86,72,13,192,85,85,72,13,128,84,84,72,13,192,83,83,72,13,192,82,82,72,13,192,81,81,72,13,192,80,80,72,13,128,79,79,72,13,192,78,78,72,13,128,77,77,72,13,192,76,76,
72,13,128,75,75,72,13,128,74,74,72,13,192,73,73,72,13,128,72,72,72,13,192,71,71,72,13,128,70,70,72,13,128,69,69,72,13,128,68,68,72,13,128,67,67,72,13,192,66,66,72,13,128,65,65,72,13,128,64,64,72,13,128,63,63,72,13,128,62,62,72,13,128,61,61,72,13,128,60,60,72,13,128,59,59,72,13,128,58,58,72,13,128,57,57,72,13,128,56,56,72,13,128,55,55,72,13,64,54,54,72,13,128,53,53,72,13,128,52,52,72,13,128,51,51,72,13,128,50,50,72,13,64,49,49,72,13,128,48,48,72,13,64,47,47,72,13,128,46,46,72,13,64,45,45,72,13,64,
44,44,72,13,128,43,43,72,13,64,42,42,72,13,128,41,41,72,13,64,40,40,72,13,64,39,39,72,13,64,64,108,38,38,72,13,64,37,37,72,13,128,36,36,72,13,64,35,35,72,13,64,34,34,72,13,64,33,33,72,13,64,32,32,72,13,64,31,31,72,13,64,30,30,72,13,64,29,29,72,13,64,28,28,72,13,64,27,27,72,13,64,26,26,72,13,64,25,25,72,13,64,23,23,72,13,64,22,22,72,13,64,21,21,72,13,64,20,20,72,13,64,18,18,72,13,64,16,16,72,13,64,13,13,72,13,64,11,11,72,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,
43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,
43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,1,43,53,0,43,53,0,0,1,0,84,255,236,5,123,5,150,0,44,0,120,64,80,27,92,26,38,26,38,6,37,40,91,48,16,1,15,16,31,16,2,16,5,92,15,6,1,6,46,40,95,95,37,111,37,143,37,223,37,255,37,5,239,37,1,37,37,0,32,95,21,127,27,1,27,27,21,4,0,95,11,32,5,48,5,2,32,5,96,5,112,5,160,5,224,5,240,5,6,5,5,11,19,0,63,51,47,93,113,16,237,63,51,47,93,16,237,18,57,47,93,113,237,1,16,222,93,237,47,93,93,237,50,17,57,57,47,47,237,49,48,37,50,62,2,55,23,14,3,35,34,36,
38,2,53,52,18,54,36,51,50,30,2,23,7,46,3,35,34,14,2,7,33,21,33,30,3,3,19,81,120,86,58,19,252,31,98,148,204,138,180,254,248,172,84,83,170,1,3,175,136,204,149,97,28,255,14,57,87,117,75,91,142,99,56,5,2,34,253,221,6,56,100,145,212,47,76,96,49,97,76,146,112,69,109,195,1,12,159,165,1,10,187,101,58,105,143,86,71,45,83,64,39,50,95,137,87,228,89,144,101,55,0,255,255,0,59,255,236,5,6,5,150,18,6,0,54,0,0,255,255,0,137,0,0,1,176,5,129,18,6,0,44,0,0,255,255,255,213,0,0,2,96,6,213,16,38,0,44,0,0,17,6,2,158,198,
0,2,22,182,2,1,4,5,38,2,1,184,255,254,64,255,8,6,0,2,37,13,64,229,229,72,13,64,226,226,72,13,64,225,225,72,13,64,222,222,72,13,64,219,219,72,13,64,218,218,72,13,64,215,215,72,13,64,212,212,72,13,64,211,211,72,13,64,208,208,72,13,64,207,207,72,13,64,204,204,72,13,64,201,201,72,13,64,200,200,72,13,64,197,197,72,13,64,193,193,72,13,64,190,190,72,13,64,189,189,72,13,64,186,186,72,13,64,183,183,72,13,64,182,182,72,13,64,179,179,72,13,64,175,175,72,13,64,172,172,72,13,64,171,171,72,13,64,168,168,72,13,
64,164,164,72,13,64,161,161,72,13,64,157,157,72,13,64,154,154,72,13,64,153,153,72,13,64,150,150,72,13,64,146,146,72,13,64,143,143,72,13,64,139,139,72,13,64,135,135,72,13,64,132,132,72,13,64,128,128,72,13,64,125,125,72,13,64,121,121,72,13,64,117,117,72,13,64,114,114,72,13,64,110,110,72,13,64,103,103,72,13,64,99,99,72,13,64,96,96,72,13,64,92,92,72,13,64,85,85,72,13,64,81,81,72,13,64,74,74,72,64,16,13,64,67,67,72,13,64,63,63,72,13,64,56,56,72,13,184,255,192,179,55,55,72,13,184,255,192,179,52,52,72,13,
184,255,192,179,51,51,72,13,184,255,192,179,50,50,72,13,184,255,192,179,49,49,72,13,184,255,192,179,46,46,72,13,184,255,192,179,41,41,72,13,184,255,192,64,9,40,40,72,13,64,38,38,72,13,184,255,192,179,37,37,72,13,184,255,192,179,36,36,72,13,184,255,192,179,35,35,72,13,184,255,192,179,32,32,72,13,184,255,192,64,14,31,31,72,13,64,27,27,72,13,64,26,26,72,13,184,255,192,179,23,23,72,13,184,255,192,179,22,22,72,13,184,255,192,179,21,21,72,13,184,255,192,179,20,20,72,13,184,255,192,183,17,17,72,13,64,9,
9,72,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,1,43,53,53,0,43,53,53,0,0,255,255,0,31,255,236,3,231,5,129,18,6,0,45,0,0,0,2,0,8,255,240,8,120,5,129,0,38,0,47,0,120,185,0,8,255,232,179,26,39,72,8,184,255,224,64,11,22,25,72,165,8,181,8,197,8,3,8,184,255,240,64,53,11,18,72,8,92,31,33,44,90,6,31,6,31,6,19,39,91,0,49,31,19,
1,19,43,95,16,33,1,95,33,111,33,143,33,3,239,33,1,33,33,44,8,96,31,3,23,96,16,19,44,95,6,18,0,63,237,63,237,63,237,18,57,47,93,113,114,237,1,47,93,16,222,237,17,57,57,47,47,16,237,50,16,237,43,93,43,43,49,48,1,20,14,2,35,33,17,33,3,14,5,35,34,38,39,53,30,1,51,50,62,4,55,19,33,17,33,50,30,2,5,52,38,35,33,17,33,50,54,8,120,65,131,195,130,253,77,254,165,49,23,45,53,65,85,110,72,27,58,14,8,27,8,23,40,37,36,35,38,21,67,3,135,1,172,123,184,121,61,254,214,139,138,254,170,1,92,140,131,1,175,90,158,116,67,
4,141,254,164,161,249,185,126,78,34,9,8,247,4,3,21,56,98,155,218,147,1,217,253,207,60,109,154,98,93,101,254,121,101,0,0,0,0,2,0,137,0,0,8,54,5,129,0,22,0,31,0,75,64,43,17,28,90,14,6,6,10,23,91,0,33,13,9,90,10,27,27,8,96,17,16,13,1,95,13,111,13,143,13,3,239,13,1,13,13,15,11,3,28,95,10,6,18,0,63,51,237,63,51,57,47,93,113,114,51,237,50,47,1,47,237,50,16,222,237,17,57,47,51,237,50,49,48,1,20,14,2,35,33,17,33,17,33,17,33,17,33,17,33,17,33,50,30,2,5,52,38,43,1,17,33,50,54,8,54,65,131,195,130,253,166,253,
221,254,217,1,39,2,35,1,39,1,83,123,184,121,61,254,214,139,138,253,1,3,140,131,1,175,90,158,116,67,2,92,253,164,5,129,253,207,2,49,253,207,60,109,154,98,93,101,254,121,101,0,0,0,0,1,0,23,0,0,6,123,5,129,0,27,0,72,64,39,11,90,10,29,64,27,14,21,22,24,14,1,21,90,63,24,1,24,32,22,48,22,2,22,0,24,95,25,17,95,1,6,6,10,25,3,22,10,18,0,63,51,63,18,57,47,51,237,16,237,50,1,47,93,198,93,237,50,43,1,24,16,77,228,26,16,222,237,49,48,1,17,62,3,51,50,22,21,17,33,17,52,46,2,35,34,6,7,17,33,17,33,53,33,21,3,5,37,
91,104,118,64,235,237,254,228,30,68,107,78,88,165,66,254,217,254,57,4,182,4,157,254,193,14,30,24,15,226,239,254,32,1,193,72,105,67,33,32,21,253,95,4,157,228,228,0,0,0,255,255,0,137,0,0,4,229,7,23,18,38,1,180,0,0,17,7,2,155,1,172,0,0,0,19,64,11,1,26,5,38,1,75,26,29,0,16,37,1,43,53,0,43,53,0,0,0,255,255,255,249,255,236,5,5,7,62,18,38,1,189,248,0,17,7,2,151,1,31,1,74,0,21,180,1,26,5,38,1,184,255,244,180,33,41,21,25,37,1,43,53,0,43,53,0,0,1,0,137,254,104,5,54,5,129,0,11,1,236,64,255,11,92,0,0,2,6,90,
9,13,5,90,4,2,20,2,2,11,2,180,13,1,139,13,1,116,13,1,96,13,1,4,13,36,13,68,13,84,13,4,235,13,1,212,13,1,187,13,1,175,13,1,128,13,144,13,2,100,13,116,13,2,80,13,1,68,13,1,27,13,1,4,13,1,202,235,13,1,192,13,1,180,13,1,155,13,1,128,13,1,68,13,116,13,2,11,13,27,13,43,13,3,224,13,240,13,2,100,13,164,13,180,13,212,13,4,59,13,75,13,2,4,13,20,13,2,196,13,212,13,244,13,3,91,13,107,13,171,13,3,4,13,52,13,2,153,196,13,228,13,244,13,3,155,13,1,143,13,1,116,13,1,96,13,1,84,13,1,48,13,1,36,13,1,11,13,1,228,13,
1,155,13,187,13,2,132,13,1,80,13,1,68,13,1,43,13,1,20,13,1,187,13,219,13,251,13,3,52,13,68,13,100,13,116,13,132,13,164,13,6,27,13,1,15,13,1,105,228,13,244,13,2,208,13,1,196,13,1,155,13,1,116,13,1,43,13,91,13,2,240,13,1,180,13,228,13,64,117,2,75,13,123,13,139,13,3,20,13,36,13,2,212,13,1,123,13,139,13,171,13,187,13,4,100,13,1,80,13,1,52,13,68,13,2,27,13,1,4,13,1,55,219,13,1,196,13,1,155,13,171,13,2,112,13,1,52,13,84,13,100,13,3,251,13,1,228,13,1,203,13,1,191,13,1,148,13,1,43,13,59,13,75,13,107,13,4,
251,13,1,84,13,132,13,196,13,212,13,4,27,13,43,13,2,15,13,1,7,2,5,96,1,10,2,18,0,184,1,17,178,7,3,3,0,63,51,63,63,196,16,237,1,95,94,93,93,93,93,113,113,113,113,113,113,114,114,114,114,114,94,93,93,93,93,93,93,93,113,113,113,113,114,114,114,114,114,114,94,93,93,93,93,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,94,93,93,93,113,113,113,113,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,47,94,93,237,16,222,237,17,57,47,237,49,48,1,17,33,17,33,17,
33,17,33,17,33,17,2,99,254,38,1,39,2,105,1,29,254,39,254,104,1,152,5,129,251,115,4,141,250,127,254,104,255,255,0,51,0,0,5,145,5,129,18,6,0,36,0,0,0,2,0,137,0,0,5,119,5,129,0,16,0,25,0,85,181,3,24,9,0,77,14,184,255,232,64,44,9,0,77,9,9,16,22,17,91,0,27,48,27,1,11,22,90,6,21,95,16,11,1,95,11,111,11,143,11,3,239,11,1,11,11,22,10,95,7,3,22,95,6,18,0,63,237,63,237,18,57,47,93,113,114,237,1,47,237,50,93,16,222,237,17,18,57,47,49,48,0,43,43,1,20,14,2,35,33,17,33,21,33,17,33,50,30,2,5,52,38,35,33,17,33,50,
54,5,119,65,131,195,130,253,27,4,37,253,2,1,222,123,184,121,61,254,214,139,138,254,120,1,142,140,131,1,175,90,158,116,67,5,129,227,254,178,60,109,154,98,93,101,254,121,101,0,0,0,255,255,0,137,0,0,5,106,5,129,18,6,0,37,0,0,0,1,0,137,0,1,4,97,5,129,0,5,0,34,64,19,15,1,1,1,7,3,90,32,4,48,4,2,4,2,95,5,3,3,18,0,63,63,237,1,47,93,237,16,206,93,49,48,1,21,33,17,33,17,4,97,253,79,254,217,5,129,228,251,100,5,128,0,0,2,0,18,254,104,5,142,5,129,0,16,0,25,0,78,64,43,41,15,57,15,2,15,16,18,24,72,25,91,9,19,92,
15,9,15,9,7,3,92,2,2,17,90,0,27,6,92,7,19,96,15,3,25,0,8,96,5,18,7,2,184,1,17,0,63,51,63,237,50,50,63,237,1,47,237,16,220,237,51,47,237,17,57,57,47,47,237,16,237,43,93,49,48,37,51,17,35,17,33,17,35,17,51,62,3,55,19,33,1,17,33,7,14,3,7,4,213,185,250,252,120,250,156,34,64,55,45,15,61,3,21,254,227,254,250,31,12,36,45,54,29,244,253,116,1,152,254,104,2,140,62,160,186,205,107,1,189,251,115,3,153,234,85,191,184,166,61,255,255,0,137,0,0,5,6,5,129,18,6,0,40,0,0,0,1,255,250,0,0,7,69,5,129,0,45,2,251,64,35,
38,41,39,45,6,9,8,25,45,90,22,0,0,8,39,31,32,16,32,32,40,39,16,6,39,22,39,38,39,3,39,39,47,16,15,184,255,240,179,15,15,7,8,184,255,240,64,255,9,8,1,10,8,235,47,1,217,47,1,203,47,1,189,47,1,171,47,1,157,47,1,139,47,1,86,47,1,9,47,57,47,2,214,47,1,185,47,1,166,47,1,105,47,137,47,2,91,47,1,73,47,1,38,47,1,9,47,1,199,233,47,1,219,47,1,9,47,25,47,57,47,89,47,105,47,137,47,185,47,7,198,47,230,47,246,47,3,169,47,1,118,47,1,89,47,1,70,47,1,41,47,1,22,47,1,246,47,1,185,47,217,47,2,118,47,150,47,2,9,47,41,
47,89,47,3,151,246,47,1,228,47,1,214,47,1,194,47,1,180,47,1,166,47,1,148,47,1,102,47,134,47,2,84,47,1,66,47,1,52,47,1,38,47,1,20,47,1,6,47,1,228,47,1,214,47,1,180,47,196,47,2,166,47,1,146,47,1,132,47,1,114,47,1,96,47,1,82,47,1,68,47,1,50,47,1,36,47,1,2,47,18,47,2,242,47,1,224,47,1,210,47,1,196,47,1,178,47,1,164,47,1,130,47,146,47,2,116,47,1,96,47,1,82,47,1,68,47,1,50,47,1,36,47,64,232,1,16,47,1,2,47,1,103,244,47,1,226,47,1,212,47,1,198,47,1,162,47,178,47,2,148,47,1,130,47,1,116,47,1,98,47,1,84,47,
1,70,47,1,50,47,1,20,47,36,47,2,2,47,1,244,47,1,226,47,1,212,47,1,198,47,1,178,47,1,164,47,1,150,47,1,116,47,132,47,2,102,47,1,68,47,84,47,2,50,47,1,36,47,1,22,47,1,4,47,1,246,47,1,196,47,212,47,2,178,47,1,1,160,47,1,148,47,1,128,47,1,100,47,116,47,2,80,47,1,68,47,1,32,47,48,47,2,20,47,1,0,47,1,55,240,47,1,228,47,1,208,47,1,132,47,164,47,196,47,3,112,47,1,100,47,1,80,47,1,36,47,68,47,2,0,47,1,244,47,1,208,47,1,148,47,164,47,196,47,3,128,47,1,84,47,116,47,2,32,47,1,2,16,47,1,208,47,240,47,2,191,47,
1,112,47,160,47,2,79,47,1,32,47,1,15,47,1,7,41,38,9,9,184,255,240,64,21,9,10,0,76,9,6,22,44,1,25,1,22,22,31,23,15,3,40,8,0,18,0,63,50,50,63,51,51,57,47,51,51,17,51,17,18,57,43,17,51,50,1,94,93,93,93,93,93,93,113,95,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,95,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,
113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,113,113,113,113,113,113,113,114,114,114,94,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,47,94,93,56,51,51,47,56,51,17,51,47,93,56,51,51,47,56,51,17,18,57,47,51,237,50,18,57,57,17,18,57,57,49,48,33,17,34,46,2,39,1,33,1,46,3,39,3,33,19,30,3,51,17,33,17,50,62,2,55,19,33,3,14,3,7,1,33,1,14,1,35,17,3,18,15,35,34,32,11,254,163,254,196,1,199,12,37,43,46,22,251,1,44,198,48,70,56,48,27,1,28,27,
48,57,70,48,198,1,44,251,22,46,43,37,12,1,199,254,196,254,163,26,71,30,2,100,4,7,10,7,253,128,3,12,9,45,61,71,36,1,151,254,188,78,106,64,27,2,87,253,169,27,64,106,78,1,68,254,105,36,71,61,45,9,252,244,2,128,13,15,253,156,0,0,1,0,46,255,236,4,165,5,149,0,56,0,141,185,0,40,255,248,64,88,9,10,0,76,31,92,32,47,42,19,19,32,23,90,42,32,42,32,42,5,14,90,52,58,6,92,15,5,31,5,2,5,64,13,21,72,5,47,18,95,95,19,111,19,143,19,223,19,255,19,5,239,19,1,19,19,11,37,127,31,1,31,31,26,95,37,4,11,95,0,48,6,1,32,6,96,
6,112,6,160,6,240,6,5,6,6,0,19,0,63,50,47,93,113,16,237,63,237,51,47,93,17,18,57,47,93,113,237,57,1,47,43,93,237,16,222,237,18,57,57,47,47,16,237,17,57,47,18,57,16,237,49,48,43,5,34,46,2,39,37,30,3,51,50,54,53,52,38,43,1,53,51,50,54,53,52,38,35,34,14,2,7,37,62,3,51,50,30,2,21,20,14,2,7,30,3,21,20,14,2,2,126,126,193,142,99,32,1,8,20,58,79,104,67,129,134,159,169,59,59,151,144,123,108,63,94,69,47,15,254,244,31,94,136,182,118,116,188,134,73,40,73,104,63,67,115,85,49,74,141,205,20,52,99,144,93,93,55,92,
68,38,107,97,101,89,227,96,100,91,96,40,68,90,49,61,92,148,106,57,52,95,136,84,69,111,83,57,16,10,49,81,113,73,93,154,111,62,0,0,0,1,0,136,0,0,5,55,5,129,0,19,0,109,64,41,9,32,10,0,77,9,24,9,0,77,18,9,12,92,11,21,64,21,80,21,96,21,3,112,21,128,21,2,32,21,48,21,160,21,192,21,4,15,21,1,19,184,255,224,179,10,0,77,19,184,255,232,64,23,9,0,77,19,8,2,92,32,1,48,1,2,1,18,8,18,8,9,1,3,12,0,18,0,63,50,63,51,57,57,47,47,1,47,93,237,50,50,43,43,93,93,113,114,16,222,237,50,50,43,43,49,48,51,17,33,17,20,6,7,6,
7,1,33,17,33,17,52,54,55,54,55,1,136,1,6,2,2,2,2,2,101,1,76,254,250,2,2,2,2,253,159,5,129,252,205,50,98,39,46,42,4,70,250,127,3,63,40,88,38,44,44,251,195,255,255,0,136,0,0,5,55,7,62,18,38,1,178,0,0,17,7,2,151,1,146,1,74,0,19,64,11,1,20,5,38,1,6,27,35,0,10,37,1,43,53,0,43,53,0,0,0,0,1,0,137,0,0,4,229,5,129,0,25,0,90,181,17,8,10,0,77,15,184,255,240,64,44,9,10,0,76,18,15,16,8,9,16,9,9,17,16,16,0,16,16,16,2,16,16,27,2,24,90,32,25,48,25,2,25,15,18,23,97,2,2,25,16,18,8,0,3,0,63,50,63,51,57,47,237,57,57,
1,47,93,237,50,17,51,47,93,56,51,51,47,56,51,17,57,57,49,48,0,43,1,43,19,33,17,50,62,2,55,19,33,1,14,3,7,1,33,1,14,3,35,17,33,137,1,39,27,52,62,76,49,206,1,44,254,247,23,50,46,40,12,1,229,254,191,254,138,11,31,35,35,15,254,218,5,129,253,169,28,64,105,78,1,68,254,107,35,72,62,46,9,252,244,2,128,7,12,10,6,253,163,0,0,1,0,8,255,240,5,20,5,129,0,27,0,79,185,0,1,255,232,179,26,39,72,1,184,255,224,64,11,22,25,72,165,1,181,1,197,1,3,1,184,255,240,64,26,11,18,72,1,92,24,24,12,27,90,26,29,31,12,1,12,27,18,
1,96,24,3,15,96,9,19,0,63,237,63,237,63,1,47,93,16,222,237,17,57,47,237,43,93,43,43,49,48,1,33,3,14,5,35,34,38,39,53,30,1,51,50,62,4,55,19,33,17,33,3,248,254,105,49,23,45,53,65,85,110,72,27,58,14,8,27,8,23,40,37,36,35,38,21,67,3,184,254,228,4,141,254,164,161,249,185,126,78,34,9,8,247,4,3,21,56,98,155,218,147,1,217,250,127,0,0,0,255,255,0,137,0,0,6,33,5,129,18,6,0,48,0,0,255,255,0,137,0,0,5,61,5,129,18,6,0,43,0,0,255,255,0,84,255,236,5,227,5,150,18,6,0,50,0,0,0,1,0,137,0,0,5,55,5,129,0,7,0,35,64,19,
0,90,7,9,3,90,32,4,48,4,2,4,2,96,5,3,4,0,18,0,63,50,63,237,1,47,93,237,16,222,237,49,48,33,17,33,17,33,17,33,17,4,26,253,149,254,218,4,174,4,141,251,115,5,129,250,127,0,0,0,255,255,0,137,0,0,5,16,5,129,18,6,0,51,0,0,255,255,0,84,255,236,5,143,5,150,18,6,0,38,0,0,255,255,0,23,0,0,4,205,5,129,18,6,0,55,0,0,0,1,0,1,255,236,5,13,5,129,0,25,0,140,182,24,32,9,10,0,76,22,184,255,224,64,67,9,10,0,76,10,10,25,0,20,23,7,23,23,23,2,9,3,23,21,24,25,16,4,25,20,25,2,57,20,25,52,25,100,25,132,25,148,25,180,25,228,
25,7,52,25,100,25,180,25,228,25,4,180,25,228,25,2,48,25,1,2,32,25,1,25,22,21,184,255,240,64,16,15,21,31,21,2,21,23,20,20,24,21,3,14,96,5,19,0,63,237,63,51,57,47,51,1,47,93,56,51,47,93,95,93,93,113,114,94,93,56,51,18,57,95,94,93,17,51,51,17,57,47,49,48,43,43,1,14,3,35,34,46,2,39,55,30,1,51,50,62,2,63,1,1,33,9,1,33,3,0,40,79,97,125,86,31,71,67,61,23,82,38,78,44,35,55,49,46,25,17,253,212,1,51,1,132,1,42,1,43,1,62,83,126,86,43,8,16,22,14,246,18,24,20,46,75,55,37,3,164,253,88,2,168,0,3,0,71,255,245,6,
141,5,139,0,10,0,40,0,51,2,93,64,30,27,5,40,92,47,24,11,11,0,41,91,9,18,25,18,73,18,89,18,4,9,18,64,38,43,72,18,0,91,33,184,255,192,64,255,38,43,72,33,53,235,53,1,201,53,1,187,53,1,169,53,1,139,53,155,53,2,105,53,121,53,2,91,53,1,25,53,41,53,73,53,3,6,53,1,201,53,233,53,2,187,53,1,105,53,137,53,2,91,53,1,41,53,57,53,73,53,3,27,53,1,9,53,1,199,251,53,1,237,53,1,219,53,1,166,53,1,89,53,105,53,137,53,3,70,53,1,41,53,1,27,53,1,9,53,1,249,53,1,235,53,1,201,53,1,187,53,1,169,53,1,139,53,155,53,2,105,53,
1,70,53,1,25,53,41,53,2,6,53,1,201,53,233,53,2,187,53,1,105,53,137,53,2,91,53,1,41,53,57,53,73,53,3,27,53,1,9,53,1,151,251,53,1,233,53,1,166,53,1,105,53,137,53,2,70,53,1,41,53,1,27,53,1,9,53,1,251,53,1,201,53,233,53,2,187,53,1,153,53,169,53,2,139,53,1,114,53,1,1,96,53,1,84,53,1,64,53,1,52,53,1,27,53,1,4,53,1,212,53,244,53,2,187,53,1,116,53,1,27,53,43,53,59,53,91,53,4,0,53,1,64,169,103,196,53,212,53,244,53,3,160,53,1,52,53,68,53,116,53,148,53,4,27,53,1,187,53,203,53,235,53,251,53,4,148,53,1,112,53,
1,100,53,1,64,53,1,52,53,1,27,53,1,4,53,1,235,53,1,212,53,1,91,53,139,53,187,53,3,4,53,36,53,2,55,164,53,196,53,212,53,244,53,4,139,53,1,68,53,116,53,2,43,53,1,31,53,1,203,53,235,53,251,53,3,148,53,164,53,2,112,53,1,2,64,53,96,53,2,31,53,1,0,53,1,207,53,239,53,2,160,53,1,95,53,111,53,143,53,3,0,53,32,53,2,7,4,48,95,24,27,24,5,47,95,39,128,24,144,24,160,24,3,12,24,12,24,11,25,4,11,19,0,63,63,18,57,57,47,47,93,51,237,50,17,51,16,237,50,1,94,93,93,93,93,113,113,113,95,113,113,113,114,114,114,114,114,
94,93,93,93,93,113,113,113,113,113,113,113,113,114,114,114,114,94,93,93,93,93,93,113,113,113,113,113,113,95,113,113,113,113,113,113,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,16,222,43,237,47,43,94,93,237,18,57,47,51,51,237,50,50,49,48,1,52,38,43,1,17,51,50,62,2,1,53,35,34,46,2,53,52,62,2,59,1,53,33,21,51,50,30,2,21,20,14,2,43,1,21,1,20,30,2,59,1,17,
35,34,6,5,100,158,165,44,51,84,119,77,36,253,123,79,148,220,146,71,74,149,224,150,67,1,22,67,150,224,149,74,71,146,219,149,79,253,123,36,77,119,84,51,44,165,158,2,218,152,170,253,113,50,89,122,253,99,199,88,150,198,110,119,195,138,75,158,158,75,138,195,119,110,198,150,88,199,2,229,72,122,89,50,2,143,170,0,0,0,255,255,0,18,0,0,5,68,5,129,18,6,0,59,0,0,0,1,0,137,254,104,5,201,5,129,0,11,0,83,181,0,92,192,11,1,11,184,255,192,179,27,34,72,11,184,255,192,64,36,16,22,72,11,11,6,90,9,64,25,37,72,9,64,15,
22,72,9,13,5,90,32,2,48,2,2,2,7,3,3,9,5,96,2,18,0,184,1,17,0,63,63,237,50,63,51,1,47,93,237,16,220,43,43,237,51,47,43,43,113,237,49,48,1,17,33,17,33,17,33,17,33,17,51,17,4,207,251,186,1,39,2,57,1,29,195,254,104,1,152,5,129,251,115,4,141,251,115,253,116,0,0,0,1,0,110,0,0,5,21,5,129,0,23,0,60,64,36,7,8,9,0,77,20,0,90,23,25,11,90,10,64,23,27,72,32,10,48,10,2,15,10,1,10,17,95,1,6,6,21,10,3,0,18,0,63,63,51,57,47,51,237,1,47,93,93,43,237,16,222,237,50,49,48,0,43,33,17,14,3,35,34,38,53,17,33,17,20,30,2,
51,50,54,55,17,33,17,3,238,39,95,110,124,67,240,221,1,28,25,63,107,82,92,173,70,1,39,2,35,14,30,24,15,226,239,1,224,254,63,72,105,67,33,32,21,2,161,250,127,0,0,0,0,1,0,137,0,0,7,129,5,129,0,11,2,115,64,48,7,90,4,4,0,8,90,11,13,54,13,1,39,13,1,22,13,1,7,13,1,244,13,1,213,13,229,13,2,198,13,1,181,13,1,166,13,1,149,13,1,134,13,1,117,13,1,13,184,255,192,64,10,212,216,72,5,13,21,13,2,210,13,184,255,128,179,203,209,72,13,184,255,192,64,9,198,202,72,149,13,165,13,2,13,184,255,128,179,189,195,72,13,184,255,
192,64,9,185,188,72,197,13,213,13,2,13,184,255,128,179,176,182,72,13,184,255,192,64,28,171,175,72,213,13,229,13,245,13,3,198,13,1,181,13,1,166,13,1,149,13,1,118,13,134,13,2,13,184,255,192,64,10,157,161,72,5,13,21,13,2,155,13,184,255,128,64,255,151,154,72,229,13,1,212,13,1,181,13,197,13,2,166,13,1,149,13,1,134,13,1,115,13,1,100,13,1,83,13,1,69,13,1,52,13,1,37,13,1,20,13,1,5,13,1,244,13,1,213,13,229,13,2,198,13,1,181,13,1,166,13,1,147,13,1,0,130,13,1,112,13,1,100,13,1,82,13,1,68,13,1,50,13,1,36,13,
1,18,13,1,4,13,1,242,13,1,230,13,1,212,13,1,198,13,1,176,13,1,162,13,1,144,13,1,114,13,130,13,2,100,13,1,82,13,1,68,13,1,54,13,1,36,13,1,6,13,22,13,2,104,226,13,1,1,192,13,208,13,2,180,13,1,160,13,1,68,13,100,13,132,13,3,27,13,1,0,13,1,244,13,1,224,13,1,212,13,1,192,13,1,68,13,100,13,132,13,164,13,180,13,5,59,13,1,32,13,1,20,13,1,0,13,1,244,13,1,224,13,1,84,13,100,13,132,13,164,13,196,13,212,13,6,64,13,1,52,13,1,32,13,1,20,13,1,0,13,1,56,244,13,1,139,13,171,13,203,13,235,13,4,112,13,1,64,64,2,16,
13,48,13,80,13,3,175,13,207,13,239,13,3,48,13,80,13,112,13,3,15,13,1,239,13,1,64,13,80,13,112,13,144,13,160,13,192,13,6,15,13,47,13,2,8,3,90,32,0,48,0,2,0,9,5,1,3,7,3,96,0,18,0,63,237,50,63,51,51,1,47,93,237,94,93,93,93,113,113,113,114,95,114,114,114,94,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,95,114,94,93,93,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,95,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,
114,114,43,94,93,43,93,93,93,93,93,93,43,43,113,43,43,114,43,43,94,93,43,93,93,93,93,93,93,93,93,113,113,113,113,16,222,237,17,57,47,237,49,48,51,17,33,17,33,17,33,17,33,17,33,17,137,1,29,1,208,1,29,1,209,1,29,5,129,251,115,4,141,251,115,4,141,250,127,0,1,0,137,254,104,8,24,5,129,0,15,2,237,183,14,92,150,13,214,13,2,13,184,255,192,64,29,16,22,72,13,13,11,7,90,4,4,0,8,90,9,11,153,11,217,11,3,25,11,64,15,22,72,11,17,17,184,255,192,64,10,226,229,72,100,17,1,82,17,1,17,184,255,128,64,169,219,223,72,226,
17,242,17,2,212,17,1,198,17,1,180,17,1,166,17,1,132,17,148,17,2,114,17,1,100,17,1,82,17,1,68,17,1,50,17,1,36,17,1,18,17,1,4,17,1,203,244,17,1,230,17,1,212,17,1,198,17,1,164,17,180,17,2,146,17,1,134,17,1,100,17,116,17,2,82,17,1,68,17,1,50,17,1,20,17,36,17,2,6,17,1,244,17,1,230,17,1,210,17,1,180,17,196,17,2,166,17,1,148,17,1,134,17,1,114,17,1,100,17,1,82,17,1,70,17,1,52,17,1,38,17,1,20,17,1,6,17,1,242,17,1,212,17,228,17,2,198,17,1,180,17,1,166,17,1,148,17,1,134,17,1,116,17,1,17,184,255,192,64,10,157,
161,72,4,17,20,17,2,155,17,184,255,192,64,255,151,154,72,244,17,1,226,17,1,212,17,1,194,17,1,180,17,1,162,17,1,148,17,1,128,17,1,114,17,1,96,17,1,84,17,1,66,17,1,52,17,1,34,17,1,20,17,1,2,17,1,228,17,244,17,2,214,17,1,194,17,1,180,17,1,160,17,1,148,17,1,130,17,1,118,17,1,100,17,1,86,17,1,68,17,1,54,17,1,36,17,1,22,17,1,4,17,1,214,17,230,17,2,194,17,1,180,17,1,162,17,1,1,128,17,144,17,2,116,17,1,96,17,1,52,17,84,17,2,11,17,1,103,244,17,1,208,17,1,196,17,1,176,17,1,84,17,116,17,148,17,3,43,17,1,20,
17,1,228,17,244,17,2,208,17,1,84,17,116,17,148,17,180,17,196,17,5,75,17,1,52,17,1,16,17,1,4,17,1,208,17,224,17,240,17,3,196,17,1,176,17,1,164,17,1,144,17,1,132,17,1,112,17,1,100,17,1,80,17,1,68,17,1,48,17,1,36,17,1,16,17,1,4,17,1,55,164,17,196,17,228,17,3,128,17,1,2,32,17,64,17,96,17,3,64,64,52,17,96,17,128,17,192,17,224,17,5,31,17,1,255,17,1,80,17,96,17,128,17,160,17,176,17,208,17,6,31,17,63,17,2,0,17,1,7,3,90,79,0,95,0,2,32,0,48,0,2,0,14,184,1,17,64,10,9,5,1,3,11,7,3,96,0,18,0,63,237,50,50,63,51,
51,63,1,47,93,114,237,94,93,93,93,93,113,113,114,95,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,114,114,114,114,114,114,114,94,93,93,93,93,93,95,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,114,114,114,43,94,93,43,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,
93,93,93,43,113,113,43,16,220,43,94,93,237,17,57,47,237,17,51,47,43,93,237,49,48,51,17,33,17,33,17,33,17,33,17,33,17,51,17,35,17,137,1,29,1,187,1,29,1,186,1,29,195,250,5,129,251,115,4,141,251,115,4,141,251,115,253,116,1,152,0,2,0,22,0,0,6,172,5,129,0,16,0,25,0,59,64,35,17,91,5,27,16,22,90,13,11,21,95,16,16,1,95,16,111,16,143,16,3,239,16,1,16,16,22,13,95,14,3,22,95,11,18,0,63,237,63,237,18,57,47,93,113,114,237,1,47,198,237,50,16,222,237,49,48,1,50,30,2,21,20,14,2,35,33,17,33,53,33,17,1,52,38,35,33,
17,33,50,54,4,195,123,184,121,61,65,131,195,130,253,59,254,56,2,239,2,125,139,138,254,152,1,110,140,131,3,80,60,109,154,94,90,158,116,67,4,157,228,253,207,254,91,93,101,254,121,101,0,0,3,0,137,0,0,7,76,5,129,0,14,0,23,0,27,0,73,64,45,15,91,0,0,20,24,90,27,29,112,29,224,29,240,29,3,9,20,90,6,19,95,16,9,1,95,9,111,9,143,9,3,239,9,1,9,9,25,7,3,20,95,24,6,18,0,63,51,237,63,51,57,47,93,113,114,237,1,47,237,50,93,16,222,237,17,57,47,237,49,48,1,20,14,2,35,33,17,33,17,33,50,30,2,5,52,38,35,33,17,33,50,54,
1,17,33,17,5,79,65,131,195,130,253,67,1,39,1,182,123,184,121,61,254,214,139,138,254,160,1,102,140,131,2,0,1,39,1,175,90,158,116,67,5,129,253,207,60,109,154,98,93,101,254,121,101,254,181,5,129,250,127,0,2,0,137,0,0,5,119,5,129,0,14,0,23,0,80,181,3,24,9,0,77,12,184,255,232,64,44,9,0,77,15,91,0,25,64,25,1,48,25,112,25,224,25,3,9,20,90,6,19,95,16,9,1,95,9,111,9,143,9,3,239,9,1,9,9,7,3,20,95,6,18,0,63,237,63,57,47,93,113,114,237,1,47,237,50,93,113,16,222,237,49,48,0,43,43,1,20,14,2,35,33,17,33,17,33,50,
30,2,5,52,38,35,33,17,33,50,54,5,119,65,131,195,130,253,27,1,39,1,222,123,184,121,61,254,214,139,138,254,120,1,142,140,131,1,175,90,158,116,67,5,129,253,207,60,109,154,98,93,101,254,121,101,0,0,1,0,54,255,236,5,93,5,150,0,44,0,114,64,76,18,92,19,6,19,6,39,8,5,91,29,46,40,92,31,39,1,39,64,13,18,72,39,6,95,95,7,111,7,143,7,223,7,255,7,5,239,7,1,7,7,24,0,95,34,32,40,48,40,2,32,40,96,40,112,40,160,40,224,40,240,40,6,40,40,34,19,127,18,1,18,18,13,95,24,4,0,63,237,51,47,93,63,51,47,93,113,16,237,17,57,
47,93,113,237,1,47,43,93,237,16,222,237,50,17,57,57,47,47,237,49,48,37,50,62,2,55,33,53,33,46,3,35,34,14,2,7,39,62,3,51,50,4,22,18,21,20,2,6,4,35,34,46,2,39,55,30,3,2,158,95,144,100,56,6,253,221,2,34,5,56,99,142,91,75,117,87,57,14,255,28,97,149,204,136,175,1,3,170,83,84,172,254,248,180,138,204,148,98,31,252,19,58,86,120,212,55,101,144,89,228,87,137,95,50,39,64,83,45,71,86,143,105,58,101,187,254,246,165,159,254,244,195,109,69,112,146,76,97,49,96,76,47,0,0,0,0,2,0,137,255,236,7,234,5,150,0,26,0,46,
0,110,64,11,44,24,10,0,77,30,24,10,0,77,40,184,255,232,179,10,0,77,40,184,255,248,179,9,0,77,34,184,255,232,64,44,10,0,77,37,90,10,17,17,12,27,91,191,0,207,0,2,0,48,16,12,90,32,13,48,13,2,13,32,95,22,4,11,96,16,16,13,14,3,13,18,42,95,5,19,0,63,237,63,63,18,57,47,237,63,237,1,47,93,237,50,16,222,113,237,17,57,47,51,237,49,48,43,43,43,43,43,1,20,2,14,1,35,34,46,2,39,33,17,33,17,33,17,33,62,3,51,50,30,1,18,5,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,7,234,90,171,246,155,150,231,163,95,13,254,232,254,
217,1,39,1,27,17,101,165,226,142,159,246,168,87,254,211,44,90,135,90,92,136,89,44,44,90,135,91,97,136,87,40,2,199,165,254,242,192,104,92,165,229,138,253,164,5,129,253,207,135,216,150,81,102,188,254,247,164,111,179,128,69,69,128,179,111,110,183,132,74,75,133,183,0,0,0,0,2,0,35,0,0,5,55,5,129,0,17,0,28,0,111,185,0,17,255,232,179,10,0,77,17,184,255,248,64,26,9,0,77,1,16,6,24,14,90,13,30,112,30,1,32,30,48,30,160,30,3,15,30,1,17,0,184,255,240,64,31,0,0,16,0,2,0,0,18,91,32,6,48,6,2,15,6,1,6,1,16,95,23,
23,0,26,95,11,3,14,0,18,0,63,50,63,237,18,57,47,237,57,1,47,93,93,237,51,47,93,56,51,93,93,113,16,222,237,50,17,57,57,49,48,43,43,51,1,46,3,53,52,62,2,51,33,17,33,17,33,1,19,20,30,2,51,33,17,33,34,6,35,1,125,67,114,83,47,65,132,197,132,2,192,254,217,254,166,254,185,35,30,61,95,66,1,130,254,134,125,135,2,80,16,69,102,131,79,97,155,109,59,250,127,2,23,253,233,3,209,47,78,57,31,1,160,100,255,255,0,60,255,236,4,128,4,78,18,6,0,68,0,0,0,2,0,94,255,236,4,160,5,222,0,19,0,56,0,64,64,38,42,42,23,52,10,71,
208,31,1,32,31,48,31,2,31,0,71,223,23,1,23,58,96,58,112,58,2,52,5,79,20,20,41,0,15,79,26,22,0,63,237,63,57,47,237,51,1,113,16,222,113,237,47,93,113,237,57,18,57,47,49,48,1,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,3,50,18,17,16,0,33,34,46,2,53,52,18,62,1,55,62,3,55,21,14,1,7,14,5,7,62,3,3,122,33,62,89,55,59,96,69,37,37,66,89,52,59,95,66,36,193,251,236,254,230,254,244,127,201,139,73,65,145,232,166,65,112,103,96,49,97,182,102,88,140,106,76,49,25,3,22,72,106,144,1,245,97,128,77,31,33,77,128,95,96,127,
75,31,30,75,127,2,111,254,251,254,250,254,247,254,253,70,156,250,180,192,1,22,193,115,28,11,17,14,12,6,235,10,23,16,13,32,48,69,104,142,97,67,115,84,48,0,0,0,0,3,0,143,0,0,4,155,4,58,0,21,0,34,0,45,0,97,185,0,17,255,232,180,9,10,0,76,3,184,255,232,64,21,9,10,0,76,42,71,10,5,5,22,28,70,16,47,36,22,70,208,20,1,20,184,255,192,179,36,40,72,20,184,255,192,64,18,9,12,72,20,10,34,82,36,36,22,35,82,21,15,22,82,20,21,0,63,237,63,237,18,57,47,237,57,1,47,43,43,93,237,50,16,222,237,18,57,47,57,237,49,48,43,
43,1,50,30,2,21,20,14,2,7,21,30,3,21,20,6,35,33,17,1,51,50,62,2,53,52,46,2,43,1,25,1,51,50,62,2,53,52,38,35,2,167,93,171,129,77,39,67,88,49,59,99,74,41,239,219,253,190,1,26,227,66,92,57,25,27,60,96,68,216,208,64,86,51,22,96,114,4,58,24,62,104,81,52,82,58,37,9,7,7,35,62,89,61,157,155,4,58,252,117,16,36,56,39,42,59,36,16,1,176,254,252,15,31,50,35,67,62,0,1,0,143,0,0,3,30,4,58,0,5,0,58,185,0,1,255,192,64,12,9,12,72,1,1,7,3,70,208,4,1,4,184,255,192,179,36,40,72,4,184,255,192,64,10,9,12,72,4,2,79,5,15,
3,21,0,63,63,237,1,47,43,43,93,237,17,51,47,43,49,48,1,21,33,17,33,17,3,30,254,139,254,230,4,58,190,252,132,4,58,0,0,2,0,14,254,104,4,238,4,58,0,7,0,23,0,127,64,75,22,72,21,21,19,6,6,1,6,6,22,6,134,6,230,6,246,6,5,6,12,6,1,1,247,1,1,153,1,1,118,1,134,1,2,57,1,73,1,2,1,17,144,17,1,12,17,12,17,11,7,70,159,19,1,0,19,16,19,96,19,112,19,4,19,25,8,72,11,1,79,17,15,22,9,184,1,17,181,19,6,11,79,8,21,0,63,237,50,50,63,51,63,237,1,47,237,16,220,93,93,237,17,57,57,47,47,93,17,51,93,93,93,93,113,17,51,93,113,
17,51,47,237,49,48,1,35,14,3,7,33,5,17,35,17,51,62,2,18,55,33,17,51,17,35,17,3,66,236,18,40,43,44,23,1,148,253,193,245,125,30,56,55,54,28,2,242,146,245,3,124,138,222,173,126,43,190,254,104,2,86,47,134,207,1,39,209,252,132,253,170,1,152,0,255,255,0,80,255,236,4,45,4,78,18,6,0,72,0,0,0,1,255,239,0,0,5,189,4,58,0,41,1,251,181,34,16,10,0,77,3,184,255,240,64,10,10,0,77,24,24,9,10,0,76,13,184,255,232,64,28,9,10,0,76,31,34,32,40,3,6,5,20,40,72,17,4,41,1,33,41,41,5,32,11,10,10,4,5,184,255,240,183,5,26,27,
27,33,32,16,32,184,255,192,64,255,9,12,72,32,32,43,159,43,1,132,43,1,59,43,91,43,107,43,3,47,43,1,20,43,1,203,43,235,43,251,43,3,191,43,1,164,43,1,91,43,123,43,139,43,3,79,43,1,2,15,43,31,43,2,204,15,43,31,43,63,43,79,43,127,43,143,43,175,43,191,43,239,43,255,43,10,15,43,47,43,63,43,95,43,111,43,127,43,159,43,175,43,207,43,223,43,10,15,43,47,43,79,43,95,43,127,43,159,43,191,43,207,43,239,43,9,155,63,43,79,43,111,43,159,43,175,43,191,43,223,43,239,43,8,32,43,1,207,43,223,43,255,43,3,176,43,1,31,43,
95,43,111,43,143,43,4,15,43,63,43,95,43,127,43,175,43,207,43,239,43,7,107,63,43,111,43,143,43,175,43,223,43,255,43,6,31,43,47,43,95,43,143,43,159,43,207,43,255,43,7,175,43,191,43,239,43,3,144,43,1,63,43,79,43,127,43,3,32,43,1,15,43,1,58,239,43,255,43,2,208,43,1,127,43,143,43,191,43,3,96,43,1,31,43,79,43,2,240,43,1,223,43,1,192,43,64,66,1,175,43,1,128,43,1,111,43,1,80,43,1,63,43,1,16,43,1,255,43,1,224,43,1,143,43,207,43,2,112,43,1,63,43,95,43,2,0,43,32,43,2,8,34,3,31,6,3,6,17,3,0,0,20,17,17,4,26,18,
11,15,41,33,4,21,0,63,51,51,63,51,51,18,57,17,51,51,17,51,18,57,57,17,51,17,51,1,94,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,114,114,114,114,114,94,93,93,93,93,93,113,114,94,93,113,113,113,114,114,94,93,113,114,94,93,95,93,93,93,93,93,113,113,113,113,113,17,51,47,43,56,51,51,17,51,47,56,51,51,17,51,17,18,57,47,94,93,51,237,50,18,57,57,17,18,57,57,49,48,43,43,43,43,1,34,38,39,3,33,1,46,1,39,3,33,19,30,3,23,17,51,17,62,3,55,19,33,3,14,1,7,1,33,3,14,3,35,17,35,2,88,25,58,14,223,254,215,
1,62,17,44,31,216,1,18,136,39,56,43,38,21,252,21,38,43,56,39,136,1,18,216,30,45,17,1,62,254,215,223,7,23,26,28,13,252,1,201,6,5,254,44,2,59,14,61,55,1,125,254,255,75,86,43,12,1,1,218,254,38,1,12,43,86,75,1,1,254,131,56,60,14,253,197,1,212,3,4,3,1,254,55,0,0,0,0,1,0,53,255,236,3,181,4,78,0,57,0,121,185,0,55,255,232,180,9,10,0,76,40,184,255,232,64,61,9,10,0,76,31,72,32,47,42,18,18,3,23,70,42,32,42,32,42,3,12,71,53,59,79,59,1,4,72,3,47,17,82,18,18,37,9,43,31,1,31,31,1,31,31,26,82,37,16,9,81,0,0,4,16,
4,2,4,4,0,22,0,63,50,47,93,16,237,63,237,51,47,93,93,17,18,57,47,237,57,1,47,237,93,16,222,237,18,57,57,47,47,16,237,17,57,47,18,57,16,237,49,48,43,43,5,34,38,39,55,30,3,51,50,54,53,52,46,2,35,53,50,62,2,53,52,38,35,34,14,2,7,39,62,3,51,50,30,2,21,20,14,2,7,21,30,3,21,20,14,2,1,237,179,220,41,241,9,38,52,64,34,80,89,43,78,109,65,63,104,75,41,78,72,30,61,51,37,5,237,13,73,114,150,88,91,148,105,57,38,67,91,52,56,102,77,46,56,113,171,20,160,148,44,39,61,42,22,79,64,50,62,35,13,177,13,33,57,45,60,67,
13,33,56,42,22,75,113,75,38,41,74,103,63,56,85,62,40,11,2,6,39,66,92,58,69,119,87,49,0,0,1,0,142,0,0,4,93,4,58,0,19,0,97,185,0,17,255,240,64,12,9,10,0,76,7,16,9,10,0,76,7,10,184,1,18,64,15,223,9,1,9,64,36,40,72,9,21,208,21,1,17,0,184,1,18,179,208,19,1,19,184,255,192,179,36,40,72,19,184,255,192,64,12,9,12,72,19,16,6,18,9,21,7,0,15,0,63,50,63,51,57,57,1,47,43,43,93,237,50,93,16,222,43,93,237,50,49,48,43,43,1,17,20,14,2,7,1,33,17,33,17,52,62,2,55,1,33,17,1,148,4,6,7,3,1,192,1,29,254,252,3,6,7,4,254,
77,254,212,4,58,254,26,23,80,86,77,21,3,5,251,198,2,38,19,60,64,60,20,252,251,4,58,0,0,0,255,255,0,142,0,0,4,93,5,244,18,38,1,210,0,0,17,7,2,151,1,42,0,0,0,19,64,11,1,20,17,38,1,8,27,35,18,8,37,1,43,53,0,43,53,0,0,0,0,1,0,142,0,0,4,2,4,58,0,21,0,101,185,0,13,255,232,64,14,9,10,0,76,13,16,14,2,20,70,208,21,1,21,184,255,192,179,36,40,72,21,184,255,192,64,11,9,12,72,21,8,9,9,15,14,16,14,184,255,208,64,18,9,12,72,14,14,23,16,13,19,19,2,2,21,14,21,8,0,15,0,63,50,63,51,57,17,51,18,57,57,17,1,51,47,43,56,
51,51,17,51,47,43,43,93,237,50,17,57,57,49,48,43,19,33,17,62,3,55,19,33,3,14,1,7,1,33,3,14,1,35,17,33,142,1,26,23,36,41,53,39,126,1,18,206,32,53,17,1,62,254,225,233,14,50,18,254,230,4,58,254,48,1,9,40,82,75,1,1,254,131,60,56,14,253,197,1,202,5,6,254,65,0,1,0,21,255,236,4,134,4,58,0,27,0,90,64,61,25,2,41,2,2,7,2,1,247,2,1,184,2,1,153,2,169,2,2,132,2,1,118,2,1,103,2,1,43,2,59,2,75,2,3,2,191,25,207,25,223,25,3,25,25,15,0,70,27,29,15,2,79,25,15,18,79,9,22,0,21,0,63,63,237,63,237,1,47,16,222,237,17,57,
47,93,51,93,93,93,93,93,93,93,113,113,49,48,33,17,33,6,2,14,3,35,34,46,2,39,53,30,1,51,50,62,3,18,55,33,17,3,108,254,202,25,42,44,51,70,94,65,14,45,47,39,9,11,38,19,29,43,36,31,35,41,27,3,59,3,124,184,254,234,203,134,80,33,2,4,5,2,191,4,5,25,70,126,201,1,32,197,251,198,0,1,0,143,0,0,5,92,4,58,0,28,1,218,182,19,24,9,10,0,76,11,184,255,232,64,16,9,10,0,76,0,1,15,15,21,11,8,72,4,9,1,9,184,255,192,179,36,40,72,9,184,255,192,64,255,9,12,72,9,19,22,72,11,21,1,22,21,64,36,40,72,21,30,96,30,1,36,30,52,30,
84,30,3,11,30,1,244,30,1,223,30,1,132,30,196,30,2,11,30,27,30,59,30,107,30,4,205,212,30,228,30,2,176,30,1,116,30,132,30,164,30,3,91,30,1,4,30,20,30,52,30,68,30,4,155,30,187,30,2,4,30,52,30,100,30,116,30,4,235,30,1,212,30,1,187,30,1,175,30,1,84,30,100,30,132,30,3,11,30,1,154,212,30,1,123,30,139,30,187,30,3,100,30,1,75,30,1,52,30,1,11,30,27,30,2,235,30,1,148,30,180,30,196,30,3,75,30,1,36,30,1,244,30,1,155,30,219,30,2,132,30,1,43,30,59,30,107,30,3,4,30,20,30,2,105,68,30,116,30,180,30,228,30,4,43,30,
1,20,30,1,235,30,251,30,2,212,30,1,107,30,139,30,187,30,3,4,30,52,30,84,30,3,148,30,212,30,2,123,30,1,100,30,1,75,30,1,36,30,1,11,30,1,57,203,30,219,30,251,30,3,176,30,1,68,30,116,30,148,30,164,64,71,30,4,43,30,1,20,30,1,251,30,1,239,30,1,203,30,1,191,30,1,2,175,30,1,112,30,144,30,2,31,30,79,30,2,144,30,192,30,224,30,240,30,4,127,30,1,32,30,48,30,80,30,96,30,4,15,30,1,7,28,2,15,2,9,19,10,15,22,1,9,21,0,63,51,51,63,51,18,57,57,17,51,1,94,93,93,93,93,113,113,113,95,113,113,113,113,114,114,114,114,114,
94,93,93,93,93,93,93,113,113,113,113,114,114,114,94,93,93,93,93,93,113,113,113,113,114,114,114,114,114,114,94,93,93,93,93,93,93,113,113,114,114,114,114,114,94,93,93,93,93,113,113,113,16,222,43,94,93,237,50,47,43,43,93,237,50,18,57,17,51,51,49,48,43,43,33,35,1,30,3,21,17,35,17,33,19,30,1,23,62,1,55,19,33,17,35,17,52,62,2,55,3,102,213,254,228,3,6,5,2,246,1,116,180,20,40,8,10,38,20,175,1,110,246,3,6,6,3,3,117,29,71,70,64,23,253,140,4,58,253,207,65,149,72,72,149,65,2,49,251,198,2,116,22,67,73,71,26,0,
0,1,0,143,0,0,4,70,4,58,0,11,0,82,64,20,2,6,70,223,5,1,5,64,36,40,72,5,13,1,9,70,208,10,1,10,184,255,192,179,36,40,72,10,184,255,192,64,22,9,12,72,10,8,79,31,1,1,127,1,143,1,2,1,1,10,5,21,3,0,15,0,63,50,63,51,57,47,93,113,237,1,47,43,43,93,237,50,16,222,43,93,237,50,49,48,1,17,33,17,33,17,33,17,33,17,33,17,1,169,1,131,1,26,254,230,254,125,254,230,4,58,254,84,1,172,251,198,1,207,254,49,4,58,0,0,255,255,0,80,255,236,4,147,4,78,18,6,0,82,0,0,0,1,0,143,0,0,4,70,4,58,0,7,0,62,64,18,2,70,223,1,1,1,64,36,
40,72,1,9,5,70,208,6,1,6,184,255,192,179,36,40,72,6,184,255,192,64,11,9,12,72,6,4,79,7,15,6,1,21,0,63,51,63,237,1,47,43,43,93,237,16,222,43,93,237,49,48,1,17,33,17,33,17,33,17,4,70,254,230,254,125,254,230,4,58,251,198,3,124,252,132,4,58,0,0,255,255,0,135,254,87,4,143,4,81,18,6,0,83,0,0,255,255,0,80,255,236,4,55,4,78,18,6,0,70,0,0,0,1,0,58,0,0,3,178,4,58,0,7,2,252,64,79,2,14,4,5,7,14,24,7,40,7,56,7,136,7,152,7,5,72,7,88,7,104,7,184,7,200,7,5,8,7,24,7,2,11,7,64,24,27,72,7,64,17,21,72,7,4,70,7,5,23,
5,39,5,3,66,23,5,39,5,103,5,119,5,135,5,5,7,5,87,5,103,5,183,5,199,5,5,15,5,184,255,192,179,70,82,72,5,184,255,192,179,54,57,72,5,184,255,192,179,49,52,72,5,184,255,192,179,43,46,72,5,184,255,192,64,22,9,12,72,5,180,9,1,163,9,1,132,9,148,9,2,117,9,1,99,9,1,9,184,255,0,64,190,220,223,72,21,9,1,3,9,1,228,9,244,9,2,213,9,1,196,9,1,181,9,1,163,9,1,0,128,9,144,9,2,98,9,114,9,2,84,9,1,66,9,1,32,9,48,9,2,2,9,18,9,2,202,228,9,244,9,2,192,9,208,9,2,146,9,162,9,178,9,3,132,9,1,80,9,96,9,112,9,3,50,9,66,9,2,
36,9,1,16,9,1,2,9,1,240,9,1,210,9,226,9,2,196,9,1,176,9,1,146,9,162,9,2,132,9,1,114,9,1,100,9,1,80,9,1,50,9,66,9,2,4,9,20,9,36,9,3,240,9,1,210,9,226,9,2,180,9,196,9,2,166,9,1,148,9,1,114,9,130,9,2,84,9,100,9,2,54,9,70,9,2,18,9,34,9,2,4,9,1,154,244,9,1,214,9,230,9,2,9,184,255,128,64,10,146,150,72,118,9,1,98,9,1,9,184,255,128,64,75,140,143,72,22,9,1,2,9,1,228,9,244,9,2,214,9,1,196,9,1,182,9,1,162,9,1,132,9,148,9,2,102,9,118,9,2,66,9,1,36,9,52,9,2,6,9,22,9,2,214,9,1,196,9,1,6,9,22,9,166,9,182,9,4,106,
134,9,182,9,198,9,246,9,4,9,184,255,192,64,62,110,113,72,100,9,1,22,9,38,9,70,9,86,9,4,2,9,1,228,9,244,9,2,166,9,198,9,214,9,3,130,9,146,9,2,100,9,116,9,2,70,9,86,9,2,52,9,1,34,9,1,4,9,20,9,2,230,9,246,9,2,9,184,255,128,64,31,67,70,72,134,9,150,9,2,100,9,116,9,2,86,9,1,68,9,1,38,9,54,9,2,4,9,20,9,2,57,9,184,255,192,64,67,53,56,72,180,9,196,9,2,134,9,150,9,166,9,3,98,9,1,1,64,9,80,9,2,36,9,52,9,2,224,9,240,9,2,148,9,196,9,212,9,3,128,9,1,2,96,9,112,9,2,0,9,32,9,64,9,96,9,112,9,192,9,208,9,7,8,9,184,
255,192,64,10,24,27,72,4,21,3,7,79,0,15,0,63,237,50,63,1,43,94,93,113,95,113,113,113,114,114,95,114,114,114,43,94,93,93,93,93,93,93,43,93,113,113,113,113,113,113,113,113,114,114,114,43,114,94,93,93,93,113,113,113,113,113,113,113,113,113,113,114,114,43,114,114,43,114,114,94,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,95,93,93,93,93,93,113,113,43,113,113,113,113,113,47,43,43,43,43,43,94,93,113,94,93,237,198,43,43,
94,93,113,114,43,1,24,16,77,230,49,48,19,33,21,33,17,33,17,33,58,3,120,254,209,254,230,254,209,4,58,190,252,132,3,124,0,0,255,255,0,16,254,87,4,104,4,58,18,6,0,92,0,0,0,3,0,82,254,87,6,173,5,204,0,54,0,71,0,87,2,242,178,46,80,17,184,1,18,64,255,45,55,182,18,198,18,214,18,3,6,18,246,18,2,33,18,18,0,65,71,22,28,1,28,72,71,9,0,25,0,2,37,0,89,212,89,1,198,89,1,178,89,1,164,89,1,146,89,1,132,89,1,114,89,1,68,89,84,89,100,89,3,34,89,50,89,2,16,89,1,2,89,1,228,89,244,89,2,214,89,1,194,89,1,180,89,1,162,
89,1,148,89,1,130,89,1,100,89,116,89,2,86,89,1,66,89,1,52,89,1,38,89,1,20,89,1,6,89,1,200,244,89,1,230,89,1,196,89,212,89,2,178,89,1,164,89,1,146,89,1,134,89,1,100,89,116,89,2,66,89,82,89,2,52,89,1,34,89,1,22,89,1,4,89,1,246,89,1,228,89,1,214,89,1,194,89,1,180,89,1,162,89,1,150,89,1,132,89,1,70,89,86,89,118,89,3,48,89,1,36,89,1,18,89,1,4,89,1,242,89,1,228,89,1,178,89,194,89,210,89,3,164,89,1,150,89,1,132,89,1,118,89,1,100,89,1,86,89,1,68,89,1,54,89,1,36,89,1,22,89,1,2,89,1,152,64,255,244,89,1,226,
89,1,212,89,1,198,89,1,180,89,1,166,89,1,148,89,1,134,89,1,114,89,1,68,89,84,89,100,89,3,50,89,1,36,89,1,18,89,1,4,89,1,242,89,1,230,89,1,196,89,1,182,89,1,164,89,1,150,89,1,132,89,1,102,89,118,89,2,66,89,1,52,89,1,34,89,1,20,89,1,6,89,1,244,89,1,198,89,214,89,2,178,89,1,164,89,1,146,89,1,116,89,132,89,2,102,89,1,68,89,84,89,2,54,89,1,36,89,1,6,89,22,89,2,104,230,89,1,196,89,1,182,89,1,132,89,164,89,2,70,89,86,89,118,89,3,52,89,1,22,89,1,244,89,1,230,89,1,196,89,212,89,2,178,89,1,1,100,89,132,89,
164,89,3,64,89,1,4,89,36,89,2,228,89,1,192,89,1,116,89,148,89,180,89,3,48,89,1,36,89,1,16,89,1,4,89,1,56,240,89,1,219,89,1,132,89,164,89,196,89,3,91,89,1,4,89,36,89,68,89,3,196,89,212,89,244,89,3,176,89,1,164,89,1,144,89,1,2,32,89,64,64,51,89,80,89,112,89,4,31,89,1,223,89,255,89,2,160,89,192,89,2,95,89,127,89,159,89,3,32,89,48,89,2,15,89,1,8,67,85,79,23,5,22,75,60,79,50,33,16,45,0,17,27,0,63,63,63,51,237,50,63,51,237,50,1,94,93,93,93,93,93,113,113,95,113,113,113,113,114,114,114,114,114,94,93,93,93,
93,93,93,93,113,113,113,95,113,113,113,113,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,16,222,94,93,237,47,93,237,18,57,47,94,93,113,51,
51,237,50,50,49,48,1,20,14,2,35,34,46,2,39,35,30,3,21,17,33,17,35,14,1,35,34,46,2,53,52,62,2,51,50,30,2,23,51,52,38,52,38,53,17,33,17,62,1,51,50,30,2,5,52,46,2,35,34,14,2,21,16,51,50,62,2,37,52,38,35,34,14,2,21,20,30,2,51,50,54,6,173,45,94,144,98,44,87,80,67,24,6,1,2,2,1,254,251,2,45,161,112,94,137,89,43,45,94,144,99,49,90,77,63,22,2,1,1,1,5,47,164,107,95,137,90,43,252,84,35,56,72,37,47,72,50,25,192,37,72,57,36,2,135,97,97,36,72,57,35,35,56,72,36,94,101,2,34,123,208,150,85,20,45,73,54,5,40,53,59,
25,254,97,2,89,105,91,84,150,205,121,123,206,149,84,22,46,72,51,10,39,50,54,25,1,139,253,190,107,92,84,148,205,121,107,141,83,33,42,90,140,99,254,144,36,86,145,107,185,179,35,85,143,109,106,141,84,35,178,255,255,0,14,0,0,4,100,4,58,18,6,0,91,0,0,0,1,0,143,254,104,4,216,4,58,0,11,0,66,64,14,10,72,9,9,4,70,7,13,3,70,208,0,1,0,184,255,192,179,36,40,72,0,184,255,192,180,9,12,72,0,10,184,1,17,183,5,1,15,7,3,79,0,21,0,63,237,50,63,51,63,1,47,43,43,93,237,16,220,237,51,47,237,49,48,51,17,33,17,33,17,33,
17,51,17,35,17,143,1,26,1,131,1,26,146,245,4,58,252,132,3,124,252,132,253,170,1,152,0,0,0,0,1,0,83,0,0,4,23,4,58,0,27,0,58,64,35,24,40,9,10,0,76,11,15,70,223,14,1,14,64,36,40,72,14,29,1,70,191,26,1,26,11,6,80,21,21,14,21,12,0,15,0,63,50,63,57,47,237,51,1,47,113,237,16,222,43,93,237,50,49,48,43,1,17,20,30,2,51,50,62,2,55,17,33,17,33,17,14,3,35,34,46,2,53,17,1,107,16,36,61,45,33,59,58,60,35,1,25,254,231,43,85,92,100,57,74,114,78,40,4,58,254,126,33,57,42,24,6,12,17,10,1,241,251,198,1,159,15,31,24,16,
43,82,117,73,1,182,0,0,1,0,143,0,0,6,24,4,58,0,11,2,190,185,0,8,1,18,179,5,5,1,9,184,1,18,181,198,0,214,0,2,0,184,255,192,64,255,40,43,72,9,0,25,0,2,21,0,13,196,13,1,166,13,182,13,2,148,13,1,134,13,1,116,13,1,70,13,102,13,2,4,13,20,13,36,13,3,198,13,214,13,246,13,3,180,13,1,118,13,166,13,2,98,13,1,84,13,1,70,13,1,52,13,1,38,13,1,20,13,1,6,13,1,201,244,13,1,230,13,1,212,13,1,182,13,198,13,2,164,13,1,134,13,1,84,13,100,13,2,70,13,1,52,13,1,22,13,38,13,2,230,13,1,194,13,1,180,13,1,166,13,1,148,13,1,
134,13,1,116,13,1,54,13,70,13,102,13,3,36,13,1,9,13,1,233,13,1,118,13,134,13,166,13,182,13,214,13,5,100,13,1,54,13,86,13,2,41,13,1,6,13,22,13,2,152,226,13,1,180,13,196,13,212,13,3,166,13,1,148,13,1,134,13,1,114,13,1,100,13,1,82,13,1,68,13,1,54,13,1,36,13,1,22,13,1,4,13,1,228,13,244,13,2,210,13,1,196,13,1,178,13,1,148,13,164,13,2,130,13,1,100,13,116,13,2,70,13,86,13,2,50,13,64,237,1,36,13,1,18,13,1,4,13,1,214,13,230,13,246,13,3,180,13,196,13,2,162,13,1,148,13,1,134,13,1,116,13,1,102,13,1,84,13,1,70,
13,1,2,13,18,13,34,13,3,104,244,13,1,230,13,1,212,13,1,198,13,1,178,13,1,132,13,164,13,2,118,13,1,84,13,100,13,2,70,13,1,52,13,1,22,13,1,242,13,1,228,13,1,214,13,1,196,13,1,118,13,150,13,166,13,182,13,4,100,13,1,82,13,1,68,13,1,54,13,1,36,13,1,22,13,1,4,13,1,246,13,1,212,13,1,198,13,1,180,13,1,118,13,134,13,166,13,3,100,13,1,54,13,70,13,2,20,13,1,6,13,1,56,244,13,1,217,13,1,162,13,1,1,144,13,1,132,13,1,80,13,112,13,2,2,0,13,32,13,64,13,3,175,13,207,13,239,13,3,144,13,1,143,13,1,48,13,64,13,96,13,
3,15,13,1,176,13,208,13,224,13,3,143,13,1,0,13,64,13,80,13,112,13,4,8,4,184,1,18,179,208,1,1,1,184,255,192,64,13,9,12,72,1,10,6,2,15,8,4,79,1,21,0,63,237,50,63,51,51,1,47,43,93,237,94,93,93,93,113,113,113,113,113,114,95,114,114,114,95,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,
94,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,16,222,94,93,43,93,237,17,57,47,237,49,48,41,1,17,33,17,33,17,33,17,33,17,33,6,24,250,119,1,6,1,60,1,6,1,59,1,6,4,58,252,132,3,124,252,132,3,124,0,1,0,143,254,104,6,172,4,58,0,15,2,188,185,0,7,1,18,64,9,4,4,8,0,14,72,13,13,8,184,1,18,181,150,11,166,11,2,11,184,255,192,64,15,40,43,72,121,11,137,11,2,6,11,22,11,2,9,11,184,255,192,64,255,27,
30,72,11,17,180,17,1,150,17,166,17,2,132,17,1,38,17,54,17,102,17,3,4,17,20,17,2,244,17,1,230,17,1,196,17,1,182,17,1,164,17,1,102,17,150,17,2,84,17,1,70,17,1,36,17,1,22,17,1,4,17,1,202,150,17,182,17,214,17,246,17,4,132,17,1,102,17,1,68,17,1,38,17,54,17,2,4,17,20,17,2,244,17,1,230,17,1,196,17,1,182,17,1,162,17,1,148,17,1,102,17,118,17,134,17,3,84,17,1,6,17,38,17,70,17,3,182,17,214,17,246,17,3,148,17,1,22,17,70,17,102,17,134,17,4,9,17,1,154,240,17,1,210,17,226,17,2,196,17,1,182,17,1,148,17,164,17,2,
128,17,1,98,17,114,17,2,84,17,1,70,17,1,36,17,52,17,2,18,17,1,4,17,1,246,17,1,226,17,1,212,17,1,192,17,1,178,17,1,164,17,1,146,17,1,116,17,132,17,2,86,17,102,17,2,68,17,1,54,17,1,36,17,1,22,17,1,214,17,246,17,2,196,17,1,178,17,1,132,17,148,17,164,17,3,64,205,118,17,1,84,17,100,17,2,70,17,1,18,17,34,17,50,17,3,4,17,1,103,246,17,1,228,17,1,214,17,1,194,17,1,180,17,1,166,17,1,148,17,1,134,17,1,116,17,1,86,17,102,17,2,68,17,1,38,17,1,4,17,1,244,17,1,230,17,1,212,17,1,182,17,198,17,2,116,17,132,17,2,98,
17,1,1,80,17,1,36,17,52,17,2,16,17,1,4,17,1,228,17,1,219,17,1,148,17,196,17,2,64,17,80,17,112,17,3,52,17,1,32,17,1,20,17,1,0,17,1,55,212,17,244,17,2,176,17,1,148,17,164,17,2,128,17,1,36,17,52,17,84,17,100,17,4,16,17,1,107,17,139,17,155,17,187,17,219,17,251,17,6,84,17,1,27,17,1,244,17,1,219,17,1,84,17,100,17,132,17,3,43,17,59,17,2,16,17,1,2,0,17,1,7,3,184,1,18,179,208,0,1,0,184,255,192,180,9,12,72,0,14,184,1,17,64,10,11,7,3,79,0,21,9,5,1,15,0,63,51,51,63,237,50,50,63,1,47,43,93,237,94,93,95,93,93,
93,93,93,113,113,113,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,113,113,113,113,95,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,16,220,43,94,93,113,43,113,237,51,47,237,17,18,57,47,237,49,48,51,17,33,17,
33,17,33,17,33,17,33,17,51,17,35,17,143,1,6,1,61,1,6,1,60,1,6,146,245,4,58,252,132,3,124,252,132,3,124,252,132,253,170,1,152,0,0,2,0,38,0,0,5,128,4,58,0,14,0,27,0,75,185,0,5,255,232,180,9,10,0,76,2,184,255,232,64,35,9,10,0,76,14,15,70,9,9,11,21,70,191,3,207,3,223,3,3,3,29,11,27,82,14,14,15,11,79,12,15,15,82,9,21,0,63,237,63,237,18,57,47,237,1,47,16,222,113,237,18,57,47,237,50,49,48,43,43,1,50,22,21,20,14,2,35,33,17,33,53,33,25,1,51,50,62,2,53,52,46,2,43,1,3,173,235,232,57,116,175,118,253,237,254,
139,2,143,188,69,93,55,23,25,56,92,66,189,2,135,154,164,77,122,85,45,3,124,190,254,77,254,40,20,39,58,37,38,55,36,17,0,0,3,0,143,0,0,6,70,4,58,0,12,0,23,0,27,0,120,185,0,5,255,232,180,9,10,0,76,2,184,255,232,64,42,9,10,0,76,19,70,96,3,1,36,3,1,3,3,9,24,70,223,27,1,27,64,36,40,72,16,27,1,27,29,128,29,208,29,2,12,13,70,208,9,1,9,184,255,192,179,36,40,72,9,184,255,192,64,16,9,12,72,9,23,82,12,12,25,10,15,13,82,24,9,21,0,63,51,237,63,51,57,47,237,1,47,43,43,93,237,50,93,16,222,93,43,93,237,18,57,47,93,
93,237,49,48,43,43,1,50,22,21,20,14,2,35,33,17,33,25,1,51,50,62,2,53,52,38,43,1,1,17,33,17,2,185,235,242,60,120,178,118,253,213,1,26,212,69,96,59,26,116,133,213,3,132,1,25,2,135,154,164,77,122,85,45,4,58,254,77,254,40,20,39,58,37,76,70,254,37,4,58,251,198,0,0,0,2,0,143,0,0,4,150,4,58,0,12,0,23,0,93,185,0,5,255,232,180,9,10,0,76,2,184,255,232,64,27,9,10,0,76,19,70,191,3,207,3,223,3,3,3,25,32,25,208,25,2,12,13,70,208,9,1,9,184,255,192,179,36,40,72,9,184,255,192,64,14,9,12,72,9,23,82,12,12,10,15,13,
82,9,21,0,63,237,63,57,47,237,1,47,43,43,93,237,50,93,16,222,113,237,49,48,43,43,1,50,22,21,20,14,2,35,33,17,33,25,1,51,50,62,2,53,52,38,43,1,2,185,235,242,60,120,178,118,253,213,1,26,212,69,96,59,26,116,133,213,2,135,154,164,77,122,85,45,4,58,254,77,254,40,20,39,58,37,76,70,0,0,1,0,52,255,236,4,27,4,78,0,40,0,84,64,49,144,10,1,10,10,0,12,9,71,31,42,20,70,21,21,1,70,0,10,79,11,11,26,4,79,36,64,1,160,1,2,1,1,36,22,121,20,137,20,2,45,20,1,20,20,17,79,26,16,0,63,237,51,47,93,93,63,51,47,93,16,237,17,
57,47,237,1,47,237,51,47,237,16,222,237,50,18,57,47,93,49,48,19,37,30,1,51,50,62,2,55,33,53,33,46,3,35,34,6,7,37,62,3,51,50,30,2,21,20,14,2,35,34,46,2,52,1,26,13,108,80,58,80,51,25,3,254,203,1,53,3,24,50,79,57,88,96,12,254,229,14,73,118,163,105,123,193,132,70,64,128,193,129,111,172,121,71,1,104,13,100,101,37,71,105,68,190,61,99,69,37,99,83,14,76,132,97,56,76,145,211,135,124,205,146,80,63,105,137,0,0,0,0,2,0,143,255,236,6,133,4,78,0,26,0,40,0,97,64,26,33,71,17,47,10,111,10,143,10,223,10,4,10,10,13,
27,71,0,42,16,12,70,208,13,1,13,184,255,192,179,36,40,72,13,184,255,192,64,26,9,12,72,13,11,79,63,16,79,16,2,16,16,38,30,79,22,16,14,15,13,21,38,79,5,22,0,63,237,63,63,63,237,18,57,47,114,237,1,47,43,43,93,237,50,16,222,237,17,57,47,93,51,237,49,48,1,20,14,2,35,34,46,2,39,35,17,33,17,33,17,51,62,3,51,50,30,2,5,52,38,35,34,6,21,20,30,2,51,50,54,6,133,66,133,199,132,117,183,131,77,10,196,254,230,1,26,200,14,77,129,182,118,141,199,126,58,254,218,116,110,115,121,32,59,83,50,114,124,2,30,124,206,149,83,
69,127,178,109,254,49,4,58,254,84,99,165,118,66,84,149,205,122,193,174,176,191,97,140,90,43,175,0,0,2,255,255,0,0,4,28,4,58,0,17,0,26,0,101,185,0,1,255,232,64,24,10,0,77,5,16,9,0,77,10,16,9,10,0,76,0,3,8,26,16,70,15,28,1,2,184,255,240,64,32,63,2,1,2,2,22,70,48,8,1,8,139,3,1,3,0,82,25,64,14,17,72,25,25,1,19,82,13,15,16,1,21,0,63,51,63,237,18,57,47,43,237,57,1,93,47,93,237,51,47,93,56,51,16,222,237,50,17,57,57,49,48,43,43,43,9,1,33,1,46,3,53,52,62,2,51,33,17,33,17,19,35,34,6,21,20,22,59,1,2,66,254,
240,254,205,1,66,50,85,63,35,64,122,178,113,1,231,254,230,2,192,102,103,92,97,208,1,179,254,77,1,215,12,47,75,101,66,79,117,76,38,251,198,1,179,1,216,73,78,72,77,0,0,0,255,255,0,80,255,236,4,45,5,138,18,38,0,72,0,0,17,7,0,105,0,244,0,0,0,23,64,13,3,2,40,17,38,3,2,11,44,42,5,15,37,1,43,53,53,0,43,53,53,0,0,0,0,1,0,10,254,87,4,100,5,204,0,55,0,172,185,0,53,255,232,180,9,10,0,76,48,184,255,232,64,46,9,0,77,3,33,3,33,24,12,70,224,51,240,51,2,51,57,144,57,160,57,2,112,57,240,57,2,239,57,1,35,32,24,70,
25,29,25,224,28,1,28,28,208,25,1,25,184,255,192,179,36,40,72,25,184,255,192,64,25,9,12,72,25,35,27,82,28,32,28,40,18,80,45,16,45,1,0,45,16,45,32,45,3,45,184,255,192,64,16,14,17,72,28,45,28,45,25,30,0,25,21,7,80,0,27,0,63,237,63,63,18,57,57,47,47,43,93,113,16,237,51,17,51,16,237,50,1,47,43,43,93,51,47,93,17,51,16,237,50,50,93,113,114,16,222,93,237,18,57,57,47,47,49,48,43,43,1,34,38,39,53,30,1,51,50,62,2,53,17,52,46,2,35,34,14,2,21,17,33,17,35,53,51,53,33,21,33,21,33,21,20,14,2,7,51,62,1,51,50,30,2,
21,17,20,14,2,3,69,56,83,31,13,26,12,39,49,28,10,20,46,74,53,51,83,60,33,254,231,133,133,1,25,1,54,254,202,2,3,2,1,4,57,172,119,98,135,85,38,32,69,109,254,87,5,4,198,2,2,16,38,62,46,2,114,63,105,75,42,45,83,115,69,253,229,4,151,170,139,139,170,136,32,65,57,46,13,124,112,64,112,152,88,252,250,65,108,80,44,255,255,0,143,0,0,3,45,5,222,18,38,1,205,0,0,17,7,0,116,0,216,0,0,0,19,64,11,1,6,17,38,1,87,6,9,4,0,37,1,43,53,0,43,53,0,0,0,0,1,0,80,255,236,4,55,4,78,0,36,0,90,64,53,24,24,5,32,16,70,15,15,31,70,
32,64,13,19,72,32,38,22,25,71,5,25,79,22,22,28,19,79,10,121,16,137,16,2,45,16,1,16,16,10,16,28,79,0,64,31,160,31,2,31,31,0,22,0,63,50,47,93,16,237,63,51,47,93,93,16,237,18,57,47,237,1,47,237,50,16,222,43,237,51,47,237,17,18,57,47,49,48,5,34,46,2,53,52,62,2,51,50,30,2,23,5,46,1,35,34,6,7,33,21,33,30,1,51,50,54,55,5,14,3,2,82,129,193,128,64,70,132,193,123,105,163,118,73,14,254,229,12,96,88,101,107,5,1,53,254,203,5,110,102,80,108,13,1,26,10,71,121,172,20,80,146,205,124,135,211,145,76,56,97,132,76,14,
83,99,135,131,190,141,140,101,100,13,75,137,105,63,0,255,255,0,72,255,236,4,31,4,79,18,6,0,86,0,0,255,255,0,143,0,0,1,170,5,204,16,38,0,241,254,0,17,6,1,79,201,0,0,102,185,0,9,255,192,179,45,46,72,9,184,255,192,64,9,35,36,72,9,64,32,32,72,9,184,255,192,64,14,31,31,72,9,64,26,26,72,9,64,23,23,72,9,184,255,192,179,20,22,72,9,184,255,192,181,17,17,72,1,0,0,184,255,192,179,50,50,72,0,184,255,192,64,11,45,46,72,0,1,0,4,7,1,3,37,1,43,53,17,43,43,53,53,1,43,43,43,43,43,43,43,43,0,0,255,255,255,218,0,0,2,
101,5,138,16,38,0,241,0,0,17,6,0,105,202,0,3,130,64,14,2,1,4,17,38,2,1,2,8,6,0,2,37,13,184,255,192,179,228,228,72,13,184,255,192,179,227,227,72,13,184,255,192,179,226,226,72,13,184,255,192,179,224,224,72,13,184,255,192,179,223,223,72,13,184,255,192,179,221,221,72,13,184,255,192,179,220,220,72,13,184,255,192,179,219,219,72,13,184,255,192,179,217,217,72,13,184,255,192,179,216,216,72,13,184,255,192,179,214,214,72,13,184,255,192,179,213,213,72,13,184,255,192,179,212,212,72,13,184,255,192,179,210,210,
72,13,184,255,192,179,209,209,72,13,184,255,192,179,208,208,72,13,184,255,192,179,206,206,72,13,184,255,192,179,205,205,72,13,184,255,192,179,203,203,72,13,184,255,192,179,202,202,72,13,184,255,192,179,201,201,72,13,184,255,192,179,199,199,72,13,184,255,192,179,198,198,72,13,184,255,192,179,196,196,72,13,184,255,192,179,195,195,72,13,184,255,192,179,194,194,72,13,184,255,192,179,192,192,72,13,184,255,192,179,191,191,72,13,184,255,192,179,188,188,72,13,184,255,192,179,187,187,72,13,184,255,192,179,
185,185,72,13,184,255,192,179,184,184,72,13,184,255,192,179,181,181,72,13,184,255,192,179,180,180,72,13,184,255,192,179,178,178,72,13,184,255,192,179,177,177,72,13,184,255,192,179,176,176,72,13,184,255,192,179,174,174,72,13,184,255,192,179,173,173,72,13,184,255,192,179,170,170,72,13,184,255,192,179,169,169,72,13,184,255,192,179,167,167,72,13,184,255,192,179,166,166,72,13,184,255,192,179,163,163,72,13,184,255,192,179,162,162,72,13,184,255,192,179,160,160,72,13,184,255,192,179,159,159,72,13,184,255,
192,179,156,156,72,13,184,255,192,179,155,155,72,13,184,255,192,179,152,152,72,13,184,255,192,179,149,149,72,13,184,255,192,179,148,148,72,13,184,255,192,179,145,145,72,13,184,255,192,179,144,144,72,13,184,255,192,179,142,142,72,13,184,255,192,179,141,141,72,13,184,255,192,179,138,138,72,13,184,255,192,179,137,137,72,13,184,255,192,179,134,134,72,13,184,255,192,179,131,131,72,13,184,255,192,179,130,130,72,13,184,255,192,179,127,127,72,13,184,255,192,179,124,124,72,13,184,255,192,179,123,123,72,13,
184,255,192,179,120,120,72,13,184,255,192,179,116,116,72,13,184,255,192,179,113,113,72,13,184,255,192,179,112,112,72,13,184,255,192,179,109,109,72,13,184,255,192,179,106,106,72,13,184,255,192,179,105,105,72,13,184,255,192,179,102,102,72,13,184,255,192,179,98,98,72,13,184,255,192,179,95,95,72,13,184,255,192,179,91,91,72,13,184,255,192,179,88,88,72,13,184,255,192,179,84,84,72,13,184,255,192,179,80,80,72,13,184,255,192,179,77,77,72,13,184,255,192,179,73,73,72,13,184,255,192,179,70,70,72,13,184,255,192,
179,66,66,72,13,184,255,192,179,59,59,72,13,184,255,192,179,52,52,72,13,184,255,192,179,48,48,72,13,184,255,192,179,41,41,72,13,184,255,192,179,36,36,72,13,184,255,192,179,35,35,72,13,184,255,192,64,9,34,34,72,13,64,32,32,72,13,184,255,192,64,14,31,31,72,13,64,26,26,72,13,64,23,23,72,13,184,255,192,179,22,22,72,13,184,255,192,179,21,21,72,13,184,255,192,179,20,20,72,13,184,255,192,179,17,17,72,13,184,255,192,178,16,16,72,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,
43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,43,1,43,53,53,0,43,53,53,0,0,255,255,255,224,254,87,1,169,5,204,18,6,0,77,0,0,0,2,0,21,255,236,7,107,4,58,0,36,0,47,0,159,185,0,33,255,232,180,9,10,0,76,30,184,255,232,64,99,9,10,0,76,25,2,41,2,2,7,2,1,247,2,1,184,2,1,153,2,169,2,2,132,2,1,118,2,1,103,2,1,43,2,59,2,75,2,3,2,25,27,37,70,0,
111,0,1,111,25,191,25,207,25,223,25,4,16,25,32,25,2,25,0,25,0,14,43,70,191,31,207,31,223,31,3,31,49,64,49,1,14,47,82,27,27,37,1,79,26,15,18,79,9,22,37,82,0,21,0,63,237,63,237,63,237,18,57,47,237,1,47,93,16,222,113,237,17,57,57,47,47,93,93,93,16,237,50,17,51,93,93,93,93,93,93,93,113,113,49,48,43,43,33,17,33,6,2,14,3,35,34,46,2,39,53,30,1,51,50,62,3,18,55,33,17,33,50,22,21,20,14,2,35,37,51,50,62,2,53,52,38,43,1,3,100,254,210,25,42,44,51,70,94,65,14,45,47,39,9,11,38,19,29,43,36,31,35,41,27,3,51,1,16,
235,242,60,120,178,118,254,239,212,69,96,59,26,116,133,213,3,124,184,254,234,203,134,80,33,2,4,5,2,191,4,5,25,70,126,201,1,32,197,254,77,154,164,77,122,85,45,175,20,39,58,37,76,70,0,2,0,143,0,0,6,235,4,58,0,20,0,31,0,108,185,0,5,255,240,180,9,10,0,76,2,184,255,232,64,29,9,10,0,76,20,21,70,17,9,9,13,27,70,191,3,207,3,223,3,3,3,33,16,12,70,208,13,1,13,184,255,192,179,36,40,72,13,184,255,192,64,18,9,12,72,13,10,31,82,17,20,20,14,19,15,21,82,13,9,21,0,63,51,237,63,51,57,47,197,253,197,1,47,43,43,93,237,
50,16,222,113,237,17,57,47,51,237,50,49,48,43,43,1,50,22,21,20,14,2,35,33,17,33,17,33,17,33,17,33,17,33,25,1,51,50,62,2,53,52,38,43,1,5,14,235,242,60,120,178,118,253,249,254,161,254,230,1,26,1,95,1,26,176,69,96,59,26,116,133,177,2,135,154,164,77,122,85,45,1,207,254,49,4,58,254,84,1,172,254,77,254,40,20,39,58,37,76,70,0,0,0,1,0,10,0,0,4,100,5,204,0,39,0,153,185,0,36,255,232,64,45,9,10,0,76,21,21,12,0,70,224,39,240,39,2,39,41,144,41,160,41,2,112,41,240,41,2,239,41,1,23,20,12,70,13,17,13,224,16,1,16,
16,208,13,1,13,184,255,192,179,36,40,72,13,184,255,192,64,25,9,12,72,13,23,15,82,16,20,16,29,6,80,33,16,33,1,0,33,16,33,32,33,3,33,184,255,192,64,12,14,17,72,16,33,16,33,18,0,13,0,21,0,63,50,63,57,57,47,47,43,93,113,16,237,51,17,51,16,237,50,1,47,43,43,93,51,47,93,17,51,16,237,50,50,93,113,114,16,222,93,237,18,57,47,49,48,43,33,17,52,46,2,35,34,14,2,21,17,33,17,35,53,51,53,33,21,33,21,33,21,20,14,2,7,51,62,1,51,50,30,2,21,17,3,76,20,46,74,53,51,83,60,33,254,231,133,133,1,25,1,54,254,202,2,3,2,1,4,
57,172,119,98,135,85,38,2,54,63,105,75,42,45,83,115,69,253,229,4,151,170,139,139,170,136,32,65,57,46,13,124,112,64,112,152,88,253,122,0,255,255,0,142,0,0,4,2,5,222,18,38,1,212,0,0,17,7,0,116,1,63,0,0,0,19,64,11,1,22,17,38,1,77,22,25,0,14,37,1,43,53,0,43,53,0,0,0,255,255,0,16,254,87,4,104,5,244,18,38,0,92,0,0,16,7,2,151,0,228,0,0,0,1,0,143,254,104,4,70,4,58,0,11,2,187,64,24,10,72,11,11,1,5,70,9,8,1,8,64,36,40,72,8,13,4,70,6,1,1,22,1,184,255,192,179,36,40,72,1,184,255,192,64,255,9,12,72,1,191,13,1,
139,13,155,13,171,13,3,121,13,1,107,13,1,93,13,1,79,13,1,61,13,1,43,13,1,29,13,1,9,13,1,251,13,1,237,13,1,217,13,1,189,13,205,13,2,175,13,1,141,13,157,13,2,127,13,1,89,13,1,13,128,203,206,72,13,13,1,202,13,128,198,201,72,201,13,1,187,13,1,173,13,1,139,13,155,13,2,125,13,1,107,13,1,89,13,1,59,13,75,13,2,41,13,1,27,13,1,13,13,1,235,13,251,13,2,221,13,1,207,13,1,153,13,169,13,2,107,13,123,13,2,93,13,1,73,13,1,59,13,1,45,13,1,25,13,1,11,13,1,13,192,165,168,72,191,13,1,173,13,1,153,13,1,139,13,1,105,13,
1,91,13,1,77,13,1,43,13,59,13,2,29,13,1,11,13,1,153,249,13,1,219,13,235,13,2,201,13,1,187,13,1,173,13,1,139,13,155,13,2,109,13,125,13,2,89,13,1,59,13,75,13,2,41,13,1,13,13,29,13,2,255,13,1,235,13,1,217,13,1,203,13,1,153,13,169,13,2,107,64,234,13,123,13,2,93,13,1,57,13,73,13,2,43,13,1,9,13,1,13,128,117,120,72,189,13,1,153,13,169,13,2,123,13,139,13,2,105,13,1,91,13,1,77,13,1,43,13,59,13,2,25,13,1,11,13,1,105,185,13,217,13,233,13,3,171,13,1,121,13,137,13,153,13,3,107,13,1,57,13,73,13,2,11,13,27,13,2,
253,13,1,1,219,13,1,207,13,1,155,13,171,13,2,111,13,127,13,143,13,3,91,13,1,68,13,1,27,13,43,13,2,251,13,1,239,13,1,91,13,123,13,139,13,187,13,203,13,219,13,6,79,13,1,27,13,59,13,2,15,13,1,57,219,13,235,13,251,13,3,207,13,1,171,13,1,148,13,1,123,13,1,100,13,1,27,13,43,13,59,13,3,235,13,1,223,13,1,2,160,13,176,13,2,111,13,159,13,2,80,13,1,47,13,63,13,2,208,13,224,13,2,191,13,1,112,13,160,13,2,79,13,95,13,2,48,13,1,31,13,1,0,13,1,8,11,184,1,17,183,9,4,79,1,21,6,2,15,0,63,51,63,237,51,63,1,94,93,93,
93,93,93,93,93,113,113,113,113,95,113,113,114,114,114,114,114,114,114,94,93,93,93,93,93,93,113,113,113,113,113,113,113,95,113,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,43,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,43,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,43,94,93,43,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,47,43,43,94,93,237,16,222,43,93,237,
17,57,47,237,49,48,41,1,17,33,17,33,17,33,17,33,17,35,1,240,254,159,1,26,1,131,1,26,254,159,245,4,58,252,133,3,123,251,198,254,104,0,1,0,137,0,1,3,185,7,28,0,7,0,51,64,30,0,92,3,64,24,36,72,48,3,1,3,3,9,5,90,32,6,48,6,2,6,4,95,7,1,1,7,3,5,18,0,63,63,51,47,16,237,1,47,93,237,17,51,47,93,43,237,49,48,1,17,51,17,33,17,33,17,2,191,250,253,247,254,217,5,129,1,155,253,129,251,100,5,128,0,0,0,1,0,143,0,0,3,61,5,210,0,7,0,70,183,0,72,3,64,13,66,72,3,184,255,192,64,12,9,12,72,3,3,9,5,70,208,6,1,6,184,255,
192,179,36,40,72,6,184,255,192,64,12,9,12,72,6,4,79,7,15,5,21,1,0,0,63,63,63,237,1,47,43,43,93,237,17,51,47,43,43,237,49,48,1,17,51,17,33,17,33,17,2,72,245,254,108,254,230,4,58,1,152,253,170,252,132,4,58,0,0,0,255,255,0,2,0,0,7,139,7,23,18,38,0,58,0,0,17,7,2,154,2,65,0,0,0,21,180,1,49,5,38,1,184,255,208,180,50,53,17,48,37,1,43,53,0,43,53,0,255,255,255,250,0,0,6,61,5,222,18,38,0,90,0,0,16,7,0,67,1,123,0,0,255,255,0,2,0,0,7,139,7,23,18,38,0,58,0,0,17,7,2,155,2,224,0,0,0,19,64,11,1,49,5,38,1,111,49,
52,17,48,37,1,43,53,0,43,53,0,0,0,255,255,255,250,0,0,6,61,5,222,18,38,0,90,0,0,16,7,0,116,2,38,0,0,255,255,0,2,0,0,7,139,6,213,18,38,0,58,0,0,17,7,2,158,2,117,0,0,0,23,64,13,2,1,49,5,38,2,1,3,53,51,17,48,37,1,43,53,53,0,43,53,53,0,0,0,255,255,255,250,0,0,6,61,5,138,18,38,0,90,0,0,16,7,0,105,1,200,0,0,255,255,0,35,0,0,5,53,7,23,18,38,0,60,0,0,17,7,2,154,1,34,0,0,0,21,180,1,9,5,38,1,184,255,204,180,10,13,4,8,37,1,43,53,0,43,53,0,255,255,0,16,254,87,4,104,5,222,18,38,0,92,0,0,16,7,0,67,0,139,0,0,0,
1,0,80,1,153,2,88,2,141,0,3,0,29,0,176,0,47,176,1,205,176,1,205,1,176,4,47,176,0,220,176,3,205,176,3,16,176,5,214,0,48,49,19,53,33,21,80,2,8,1,153,244,244,0,0,0,1,0,80,1,153,2,88,2,141,0,3,0,29,0,176,0,47,176,1,205,176,1,205,1,176,4,47,176,0,220,176,3,205,176,3,16,176,5,214,0,48,49,19,53,33,21,80,2,8,1,153,244,244,0,0,0,1,0,62,1,192,4,52,2,139,0,3,0,15,181,2,0,0,185,1,188,0,63,237,1,47,47,49,48,19,53,33,21,62,3,246,1,192,203,203,0,1,0,0,1,192,8,0,2,139,0,3,0,15,181,2,0,0,185,1,188,0,63,237,1,47,47,
49,48,17,53,33,21,8,0,1,192,203,203,0,0,1,0,0,1,192,8,0,2,139,0,3,0,15,181,2,0,0,185,1,188,0,63,237,1,47,47,49,48,17,53,33,21,8,0,1,192,203,203,0,255,255,255,236,254,0,4,133,255,84,16,39,0,66,0,0,254,250,16,6,0,66,0,0,0,1,0,139,3,63,1,174,5,129,0,14,0,65,64,45,6,7,14,12,151,15,14,31,14,2,14,150,79,0,95,0,2,111,0,127,0,175,0,191,0,4,143,0,191,0,207,0,3,32,0,48,0,2,0,14,158,12,168,6,3,0,63,253,237,1,47,93,93,113,114,237,93,237,16,198,50,49,48,19,53,52,62,2,55,51,14,3,21,51,17,139,15,28,40,25,183,28,
48,35,20,127,3,63,195,67,110,92,79,35,35,78,82,82,40,254,251,0,0,0,0,1,0,139,3,63,1,174,5,129,0,14,0,43,64,26,5,6,12,11,151,0,12,16,12,2,0,150,32,12,48,12,208,12,3,12,6,168,12,158,13,3,0,63,253,230,1,47,93,253,93,237,16,198,50,49,48,1,20,14,2,7,35,62,3,53,35,17,33,1,174,14,28,41,26,182,28,48,35,20,127,1,31,4,190,67,109,93,78,36,36,78,81,83,40,1,4,0,0,0,0,1,0,138,254,195,1,175,1,4,0,14,0,66,64,45,5,6,12,11,151,0,12,16,12,2,0,150,79,12,1,111,12,127,12,175,12,3,143,12,191,12,207,12,3,32,12,48,12,2,15,
12,31,12,2,12,13,158,6,168,12,0,47,230,237,1,47,93,93,93,113,114,253,93,237,16,198,50,49,48,37,20,14,2,7,35,62,3,53,35,17,33,1,175,15,28,40,25,185,29,49,36,20,129,1,32,66,67,110,93,78,35,35,78,82,82,40,1,4,0,0,1,0,139,3,63,1,174,5,129,0,14,0,41,64,24,8,7,1,2,151,15,1,31,1,2,1,150,32,13,48,13,2,13,8,168,2,158,14,3,0,63,253,237,1,47,93,237,93,237,16,198,50,49,48,1,17,35,20,30,2,23,35,46,3,61,1,1,170,127,20,35,48,28,182,26,41,28,14,5,129,254,252,40,83,81,78,36,36,78,93,109,67,195,0,0,0,2,0,151,3,63,
3,104,5,129,0,14,0,29,0,93,64,43,6,7,14,12,151,15,14,31,14,2,14,150,175,0,1,95,0,207,0,2,112,0,1,0,21,22,29,27,151,15,29,31,29,2,29,150,95,15,1,191,15,1,15,184,255,192,64,13,9,12,72,15,29,14,158,27,12,168,21,6,3,0,63,196,253,196,253,196,1,47,43,93,113,237,93,237,16,198,50,47,93,113,114,237,93,237,16,198,50,49,48,1,53,52,62,2,55,51,14,3,21,51,17,33,53,52,62,2,55,51,14,3,21,51,17,2,67,15,29,41,26,182,28,48,35,20,127,253,51,15,28,40,25,183,28,48,35,20,127,3,63,195,67,110,92,79,35,35,78,82,82,40,254,
251,195,67,110,92,79,35,35,78,82,82,40,254,251,0,0,0,0,2,0,151,3,63,3,104,5,129,0,12,0,27,0,85,64,54,5,6,11,9,151,0,11,16,11,2,12,150,80,11,1,15,11,31,11,2,11,18,19,26,24,151,0,26,16,26,2,27,150,63,26,1,127,26,1,32,26,48,26,2,26,19,6,168,25,10,158,26,11,3,0,63,196,253,196,246,196,1,47,93,93,114,253,93,237,16,198,50,47,93,113,253,93,237,16,198,50,49,48,1,20,14,2,7,35,62,1,53,35,17,33,5,20,14,2,7,35,62,3,53,35,17,33,3,104,15,28,40,26,184,57,76,127,1,31,254,82,14,28,41,26,182,28,48,35,20,127,1,31,4,
193,68,111,93,78,36,72,165,81,1,4,192,68,111,93,78,36,36,78,81,83,40,1,4,0,2,0,151,254,195,3,104,1,4,0,14,0,29,0,124,64,89,5,6,12,11,151,0,12,16,12,2,0,150,47,12,79,12,2,15,12,79,12,111,12,127,12,143,12,5,15,12,31,12,111,12,143,12,175,12,5,12,20,21,27,26,151,0,27,16,27,2,15,150,15,27,1,111,27,127,27,143,27,175,27,4,27,64,43,46,72,27,64,29,32,72,32,27,48,27,2,27,28,13,158,12,21,6,168,27,12,0,47,196,246,196,16,253,196,1,47,93,43,43,93,113,253,93,237,16,198,50,47,93,113,114,253,93,237,16,198,50,49,48,
37,20,14,2,7,35,62,3,53,35,17,33,5,20,14,2,7,35,62,3,53,35,17,33,3,104,15,28,40,26,184,29,48,36,20,127,1,31,254,82,14,28,41,26,182,28,48,35,20,127,1,31,66,67,110,93,78,35,35,78,82,82,40,1,4,194,67,110,93,78,35,35,78,82,82,40,1,4,0,0,0,1,0,138,255,118,3,234,5,204,0,11,0,56,64,26,6,3,9,0,4,7,10,193,8,190,5,193,48,7,64,7,2,7,7,13,12,11,4,192,10,5,184,1,22,178,7,0,1,0,47,63,246,50,237,50,17,18,1,57,47,93,230,253,230,18,23,57,49,48,1,3,35,3,5,53,5,3,33,3,37,21,2,157,22,155,22,254,180,1,76,28,0,255,28,
1,77,3,192,251,182,4,74,27,204,29,1,120,254,136,29,204,0,1,0,136,255,115,3,234,5,204,0,21,0,85,64,36,3,0,20,17,6,9,11,14,8,5,4,12,7,193,15,5,191,4,19,2,193,16,48,4,64,4,2,4,4,23,22,12,19,192,13,18,184,1,22,181,16,8,1,192,7,2,184,1,22,177,4,0,0,63,246,50,237,50,47,246,50,237,50,17,18,1,57,47,93,51,246,198,16,253,50,246,196,17,18,23,57,49,48,1,5,53,5,3,51,3,37,21,37,3,19,37,21,37,19,35,19,5,53,5,19,1,222,254,171,1,85,16,215,16,1,85,254,171,26,26,1,84,254,172,16,215,16,254,170,1,86,26,3,212,27,204,29,
1,100,254,156,29,204,27,254,202,254,205,27,204,29,254,156,1,100,29,204,27,1,51,0,1,0,65,1,125,2,139,3,201,0,19,0,58,185,0,18,255,232,180,9,10,0,76,2,184,255,232,64,26,9,10,0,76,12,24,9,10,0,76,8,24,9,10,0,76,10,10,15,0,1,0,21,15,15,5,0,47,51,47,1,16,206,93,50,47,49,48,43,43,43,43,1,20,14,2,35,34,46,2,53,52,62,2,51,50,30,2,2,139,47,80,107,61,60,106,79,46,46,79,106,60,61,107,80,47,2,164,61,107,80,47,47,80,107,61,61,107,79,46,46,79,107,0,0,3,0,225,0,0,7,24,1,49,0,3,0,7,0,11,0,72,64,42,3,150,64,0,14,
4,8,4,14,11,150,8,7,150,0,4,1,32,4,1,32,4,48,4,64,4,144,4,176,4,5,4,4,12,13,9,1,5,155,8,0,4,0,47,51,51,237,50,50,17,18,1,57,47,93,113,114,237,212,237,43,1,24,16,77,244,26,237,49,48,33,17,33,17,33,17,33,17,33,17,33,17,5,248,1,32,252,88,1,30,252,83,1,32,1,49,254,207,1,49,254,207,1,49,254,207,0,0,0,7,0,41,255,253,7,215,5,139,0,3,0,23,0,43,0,63,0,83,0,103,0,123,3,205,185,0,87,255,232,64,17,9,10,0,76,101,24,9,10,0,76,97,24,9,10,0,76,91,184,255,232,180,9,10,0,76,47,184,255,232,64,17,9,10,0,76,61,24,9,10,
0,76,57,24,9,10,0,76,51,184,255,232,180,9,10,0,76,11,184,255,232,64,17,9,10,0,76,21,24,9,10,0,76,17,24,9,10,0,76,7,184,255,232,64,27,9,10,0,76,74,180,80,59,96,59,2,59,64,180,9,2,1,2,3,6,0,1,10,3,0,1,1,184,255,240,64,255,3,16,49,3,1,1,3,49,3,89,19,114,180,6,99,22,99,2,99,104,180,89,64,14,25,72,89,125,24,180,9,9,1,15,9,34,180,19,217,125,1,187,125,203,125,2,153,125,1,139,125,1,114,125,1,100,125,1,86,125,1,41,125,57,125,2,27,125,1,13,125,1,249,125,1,235,125,1,210,125,1,196,125,1,150,125,182,125,2,121,
125,1,107,125,1,93,125,1,73,125,1,59,125,1,34,125,1,4,125,20,125,2,200,246,125,1,217,125,1,203,125,1,189,125,1,175,125,1,155,125,1,130,125,1,100,125,116,125,2,86,125,1,41,125,1,27,125,1,13,125,1,255,125,1,235,125,1,208,125,1,194,125,1,180,125,1,166,125,1,137,125,1,123,125,1,109,125,1,79,125,95,125,2,48,125,1,34,125,1,20,125,1,6,125,1,233,125,1,203,125,219,125,2,173,125,189,125,2,148,125,1,128,125,1,114,125,1,100,125,1,86,125,1,57,125,1,27,125,43,125,2,13,125,1,152,255,125,1,230,125,1,210,125,1,196,
125,1,182,125,1,137,125,153,125,2,64,255,107,125,123,125,2,93,125,1,68,125,1,54,125,1,34,125,1,20,125,1,6,125,1,217,125,1,203,125,1,189,125,1,175,125,1,150,125,1,116,125,1,86,125,102,125,2,57,125,1,43,125,1,13,125,29,125,2,244,125,1,230,125,1,194,125,1,180,125,1,166,125,1,137,125,1,123,125,1,109,125,1,84,125,1,70,125,1,20,125,1,6,125,1,104,249,125,1,235,125,1,221,125,1,207,125,1,164,125,180,125,2,150,125,1,116,125,1,102,125,1,73,125,1,59,125,1,45,125,1,18,125,1,4,125,1,246,125,1,217,125,1,203,125,
1,169,125,1,139,125,155,125,2,125,125,1,84,125,100,125,2,70,125,1,41,125,1,27,125,1,233,125,249,125,2,219,125,1,194,125,1,180,125,1,166,125,1,137,125,1,123,125,1,109,125,1,73,125,1,59,125,1,34,125,1,20,125,1,6,125,1,55,246,125,1,201,125,217,125,2,187,125,1,153,125,1,139,125,1,114,125,1,100,125,1,86,125,1,41,125,57,125,2,27,125,1,13,125,1,249,125,1,235,125,1,210,64,98,125,1,196,125,1,150,125,182,125,2,121,125,1,107,125,1,93,125,1,73,125,1,59,125,1,36,125,1,6,125,22,125,2,246,125,1,217,125,1,203,125,
1,169,125,1,155,125,1,141,125,1,116,125,1,86,125,102,125,2,41,125,1,27,125,1,13,125,1,7,1,69,109,44,84,79,119,54,94,39,182,14,184,29,182,4,7,2,6,109,182,84,184,119,182,94,25,1,24,0,63,63,237,244,237,63,63,237,244,237,17,51,17,51,17,51,17,51,1,95,94,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,
114,94,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,47,237,212,94,93,237,16,222,43,237,212,93,237,17,18,23,57,47,47,47,56,56,17,51,95,94,93,17,51,93,237,212,93,237,49,48,43,43,43,43,43,43,43,43,43,43,
43,43,33,35,1,51,37,50,30,2,21,20,14,2,35,34,46,2,53,52,62,2,19,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,1,50,30,2,21,20,14,2,35,34,46,2,53,52,62,2,19,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,1,50,30,2,21,20,14,2,35,34,46,2,53,52,62,2,19,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,1,126,197,3,44,199,252,159,58,104,78,45,46,78,105,60,60,104,77,45,44,78,106,171,14,27,41,27,30,43,29,13,14,28,42,29,27,42,28,14,2,105,58,104,78,45,46,78,105,60,60,104,77,45,44,78,106,171,14,27,41,27,30,44,28,14,14,28,43,29,
27,42,28,14,2,44,59,103,78,45,45,79,105,60,60,104,77,45,44,78,106,171,14,27,41,27,30,43,29,13,14,28,42,29,27,42,28,14,5,129,10,33,81,138,106,100,137,85,37,37,84,137,101,106,138,81,33,254,154,69,90,53,22,22,54,90,68,67,90,54,23,23,54,90,254,232,33,81,138,106,100,137,85,37,37,84,137,101,106,138,81,33,254,154,69,90,53,22,22,54,90,68,67,90,54,23,23,54,90,1,169,33,81,138,106,100,137,85,37,37,84,137,101,106,138,81,33,254,154,69,90,53,22,22,54,90,68,67,90,54,23,23,54,90,0,0,0,0,1,0,85,3,122,1,199,5,129,
0,3,0,35,64,18,3,0,3,2,150,0,1,16,1,2,1,1,4,5,0,169,1,3,0,63,237,17,18,1,57,47,93,237,51,17,51,49,48,27,1,33,3,85,64,1,50,158,3,122,2,7,253,249,255,255,0,85,3,122,3,176,5,129,16,38,2,20,0,0,17,7,2,20,1,233,0,0,0,14,185,0,1,1,233,180,4,6,0,2,37,1,43,53,0,1,0,92,0,141,2,76,3,172,0,8,0,59,64,35,3,235,4,0,235,8,236,6,235,64,31,2,1,2,64,29,32,72,32,2,48,2,160,2,3,2,3,237,2,1,0,237,32,6,239,0,25,63,26,237,51,51,237,1,24,47,93,43,113,26,237,253,237,212,237,49,48,37,1,53,1,51,21,3,1,21,1,94,254,254,1,2,236,
254,1,0,141,1,105,71,1,111,37,254,146,254,151,35,0,1,0,93,0,141,2,77,3,172,0,8,0,59,64,35,2,235,6,236,0,5,235,4,8,235,64,176,0,1,32,0,48,0,64,0,96,0,112,0,5,0,8,237,7,6,5,237,32,2,239,0,25,63,26,237,51,51,237,1,24,47,93,113,26,237,212,237,16,253,237,49,48,55,53,1,3,53,51,1,21,1,93,1,0,254,238,1,0,255,0,141,35,1,105,1,110,37,254,145,71,254,151,0,255,255,0,193,0,0,4,20,5,129,16,38,0,4,0,0,17,7,0,4,2,45,0,0,0,16,177,3,2,184,2,45,180,10,11,2,3,37,1,43,53,53,0,0,0,1,255,126,5,174,3,44,6,84,0,3,0,14,180,
1,0,1,185,2,0,47,237,1,47,47,49,48,1,33,53,33,3,44,252,82,3,174,5,174,166,0,0,0,0,1,254,135,0,0,2,207,5,129,0,3,0,40,64,9,2,3,16,16,3,1,3,0,1,184,255,240,64,10,15,1,31,1,2,1,2,6,0,24,0,63,63,1,47,93,56,51,47,93,56,51,49,48,43,1,1,51,176,201,3,127,201,5,129,0,0,0,0,1,0,108,2,7,2,198,4,157,0,33,0,55,185,0,31,255,208,64,12,9,10,0,76,0,224,33,35,23,10,224,11,184,255,192,64,12,9,13,72,11,17,23,17,6,228,29,11,0,0,47,50,47,237,51,51,47,1,47,43,237,50,16,222,237,49,48,43,1,17,52,46,2,35,34,6,21,17,35,17,
52,46,2,53,51,30,3,21,51,62,3,51,50,22,21,17,2,19,11,25,40,30,62,73,178,1,1,2,166,1,2,3,2,3,15,38,49,64,42,110,107,2,7,1,128,44,59,36,15,96,91,254,161,1,255,20,46,40,29,4,3,27,34,35,12,28,46,32,17,108,121,254,79,0,0,0,1,0,7,0,0,4,68,5,129,0,17,0,112,64,71,3,7,3,7,9,16,19,5,1,9,90,10,12,14,12,10,8,12,95,13,5,13,4,95,1,16,1,64,1,96,1,112,1,144,1,5,31,1,79,1,2,127,1,175,1,2,31,13,47,13,63,13,127,13,4,47,13,127,13,2,13,1,13,1,9,0,95,15,3,9,18,0,63,63,237,18,57,57,47,47,93,113,93,113,114,16,237,17,51,
16,237,50,1,47,51,51,47,16,237,50,50,16,206,17,57,57,47,47,49,48,1,17,33,21,33,21,33,21,33,17,33,17,35,53,51,17,33,21,1,166,2,125,253,131,1,58,254,198,254,227,130,130,3,187,4,177,254,116,208,190,149,254,254,1,2,149,3,234,208,0,0,1,0,21,0,0,4,94,5,150,0,56,0,195,64,39,3,16,9,0,77,41,23,1,23,40,9,10,0,76,45,40,40,31,46,39,43,110,20,13,16,32,110,31,41,31,1,16,31,16,31,6,56,110,0,184,255,192,64,23,38,53,72,41,0,1,0,58,19,14,6,64,38,60,72,6,64,14,31,72,6,46,14,184,1,19,180,15,43,15,42,18,184,1,19,64,35,
19,39,19,143,15,175,15,2,15,19,31,19,47,19,3,15,19,15,19,52,35,117,26,32,32,26,7,7,52,116,6,64,56,1,56,184,255,192,182,18,21,72,56,56,6,24,0,63,51,47,43,93,16,237,50,63,51,47,16,237,18,57,57,47,47,93,113,17,51,16,237,50,17,51,16,237,50,1,47,43,43,214,196,16,222,93,43,237,18,57,57,47,47,93,16,237,16,197,196,253,196,196,18,57,17,51,49,48,43,93,0,43,1,14,3,35,33,53,62,3,61,1,35,53,51,53,35,53,51,53,52,62,2,51,50,30,2,23,7,46,1,35,34,6,29,1,33,21,33,21,33,21,33,21,20,14,2,7,33,50,54,55,4,94,13,60,98,
134,87,253,74,39,66,46,26,188,178,178,178,48,103,161,114,96,136,95,61,19,233,21,82,66,91,80,1,30,254,226,1,30,254,226,25,46,68,43,1,124,104,107,17,1,107,73,132,99,59,205,22,49,67,93,66,6,149,112,149,104,92,151,107,58,41,76,107,67,47,77,70,115,125,81,149,112,149,4,59,90,69,53,24,99,94,0,0,0,3,0,158,255,236,8,123,5,129,0,43,0,95,0,108,3,113,182,72,40,9,10,0,76,45,184,255,216,64,82,9,10,0,76,5,40,9,10,0,76,96,72,24,33,0,0,31,35,73,6,28,6,86,73,52,71,23,24,1,40,71,1,71,64,40,45,72,71,64,18,35,72,152,
6,1,6,64,21,31,72,87,6,1,40,6,56,6,2,6,24,71,77,77,71,24,6,4,17,61,73,8,44,24,44,2,9,44,110,103,16,72,17,184,255,192,64,31,9,13,72,17,182,110,198,110,2,167,110,1,150,110,1,103,110,119,110,135,110,3,84,110,1,53,110,69,110,2,110,184,255,128,64,127,212,218,72,183,110,1,166,110,1,149,110,1,134,110,1,119,110,1,70,110,86,110,102,110,3,55,110,1,37,110,1,22,110,1,5,110,1,200,244,110,1,229,110,1,214,110,1,183,110,199,110,2,166,110,1,151,110,1,133,110,1,102,110,118,110,2,55,110,71,110,87,110,3,22,110,1,7,110,
1,197,110,213,110,229,110,3,180,110,1,165,110,1,147,110,1,100,110,116,110,132,110,3,85,110,1,54,110,70,110,2,21,110,37,110,2,4,110,1,229,110,245,110,2,103,110,1,110,184,255,192,64,255,162,165,72,70,110,1,23,110,39,110,55,110,3,6,110,1,152,252,110,1,237,110,1,219,110,1,202,110,1,187,110,1,170,110,1,155,110,1,141,110,1,126,110,1,108,110,1,91,110,1,76,110,1,43,110,59,110,2,28,110,1,13,110,1,235,110,251,110,2,218,110,1,201,110,1,186,110,1,171,110,1,154,110,1,139,110,1,87,110,1,57,110,1,42,110,1,27,110,
1,12,110,1,200,110,216,110,248,110,3,185,110,1,170,110,1,155,110,1,88,110,104,110,136,110,3,73,110,1,58,110,1,43,110,1,7,110,1,103,233,110,1,218,110,1,203,110,1,188,110,1,104,110,152,110,2,89,110,1,74,110,1,8,110,40,110,2,249,110,1,218,110,234,110,2,203,110,1,167,110,1,137,110,1,122,110,1,107,110,1,92,110,1,0,25,110,73,110,2,11,110,1,253,110,1,239,110,1,198,110,1,169,110,1,155,110,1,141,110,1,127,110,1,84,110,1,70,110,1,57,110,1,43,110,1,29,110,1,15,110,1,55,212,110,228,110,2,198,110,1,169,110,1,
155,110,1,64,103,143,110,1,116,110,1,102,110,1,41,110,57,110,2,27,110,1,0,110,1,242,110,1,230,110,1,185,110,1,171,110,1,150,110,1,130,110,1,116,110,1,102,110,1,73,110,1,61,110,1,38,110,1,20,110,1,6,110,1,185,110,201,110,233,110,3,150,110,166,110,2,137,110,1,48,110,1,34,110,1,1,16,110,1,2,0,110,1,7,15,79,103,34,7,82,28,29,29,31,28,78,78,83,184,1,15,64,15,74,103,74,28,28,74,103,3,56,102,79,18,3,40,56,184,1,15,183,47,53,53,3,47,19,17,18,0,63,63,51,51,47,16,237,50,63,237,18,23,57,47,47,47,16,237,51,47,
17,51,51,47,16,237,50,16,237,1,94,93,95,93,95,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,93,93,93,93,113,113,95,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,94,93,93,93,93,93,93,93,93,93,113,113,113,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,114,114,114,114,114,114,94,93,93,93,43,93,93,113,113,113,113,113,113,113,113,113,114,114,114,114,114,114,114,114,114,
114,114,94,93,93,93,93,93,93,93,93,93,93,43,113,113,113,113,113,113,47,43,237,50,16,222,94,93,237,18,23,57,47,47,47,47,93,93,43,93,43,43,93,113,16,198,237,17,51,16,237,50,50,47,51,16,237,49,48,43,43,43,37,14,1,35,34,38,53,17,35,53,14,3,43,1,17,35,17,33,50,30,2,21,20,6,7,51,55,51,21,51,21,35,17,20,30,2,51,50,54,55,37,20,6,35,34,46,2,39,55,30,1,51,50,62,2,53,52,46,2,39,46,3,53,52,54,51,50,22,23,7,46,3,35,34,6,21,20,30,2,23,30,3,1,52,46,2,43,1,17,51,50,62,2,5,147,34,65,48,125,113,104,27,81,108,133,80,
110,241,1,58,131,196,130,65,16,15,86,88,125,147,147,11,22,34,24,23,32,19,2,232,194,179,83,129,94,62,16,199,15,89,79,36,61,44,24,35,62,86,52,49,97,76,47,178,171,149,176,23,201,5,27,39,48,26,69,67,32,58,79,48,48,101,81,52,250,117,37,71,104,66,75,83,67,101,68,34,8,11,13,122,123,1,162,113,48,77,56,30,253,219,5,129,61,111,157,95,47,86,39,242,242,166,254,143,37,49,28,12,7,7,75,127,134,27,60,95,68,26,61,48,6,18,32,25,27,33,22,17,11,11,33,57,86,63,115,121,127,124,17,28,38,24,10,27,36,21,27,19,16,11,10,34,
59,89,2,164,67,89,54,23,254,36,25,57,93,0,0,0,1,0,10,255,236,4,79,5,150,0,61,0,179,185,0,15,255,224,64,32,10,0,77,55,46,46,51,37,110,36,36,3,110,4,63,57,45,51,111,24,14,26,15,3,0,20,32,20,2,20,57,15,184,1,19,180,16,54,16,48,24,184,1,19,64,71,25,45,25,47,25,1,15,25,31,25,47,25,207,25,239,25,5,79,16,143,16,2,207,16,239,16,2,16,25,16,25,0,40,115,31,15,37,31,37,47,37,3,37,37,31,7,0,115,9,64,3,80,3,2,0,3,16,3,32,3,64,3,160,3,240,3,6,3,3,9,25,0,63,51,47,93,113,16,237,63,51,47,93,16,237,18,57,57,47,47,93,
113,93,113,17,51,16,237,50,17,51,16,237,50,1,47,93,23,51,50,237,50,50,16,222,237,51,47,237,18,57,17,51,49,48,43,37,50,54,55,5,14,3,35,34,46,2,39,35,55,51,46,1,53,52,54,55,35,55,51,62,3,51,50,30,2,23,5,46,1,35,34,14,2,7,33,7,33,14,1,21,20,22,23,33,7,33,30,3,2,146,72,86,10,1,21,13,62,108,158,108,125,183,124,70,13,129,40,77,1,1,1,1,117,40,87,15,76,127,180,119,101,152,108,65,13,254,232,10,84,74,47,74,55,35,8,1,71,29,254,209,1,1,2,1,1,84,30,254,208,6,30,55,82,199,92,82,16,80,138,101,58,78,141,195,116,
149,5,30,16,17,35,4,149,123,192,132,68,55,97,131,76,16,74,82,32,71,112,81,149,11,31,14,14,25,12,149,67,114,83,47,0,0,0,4,0,54,255,240,6,223,5,145,0,33,0,53,0,57,0,77,0,230,64,13,3,24,9,10,0,76,7,24,9,10,0,76,52,184,255,232,64,17,9,10,0,76,46,24,9,10,0,76,42,24,9,10,0,76,36,184,255,232,64,14,9,10,0,76,25,56,1,56,57,22,54,1,54,55,184,255,240,64,53,57,16,0,57,1,240,57,1,16,57,1,31,55,1,55,57,55,57,5,34,68,180,44,181,58,180,95,34,111,34,127,34,3,34,79,16,28,180,15,29,181,22,180,143,5,159,5,2,5,144,28,
1,28,184,255,192,64,48,36,39,72,143,28,1,96,28,1,112,28,192,28,2,79,28,1,28,28,8,25,182,0,183,10,47,16,63,16,2,16,16,19,182,10,7,56,6,63,182,49,183,73,182,39,25,54,24,0,63,63,237,244,237,63,63,237,51,47,93,16,244,237,17,51,47,93,93,113,113,43,113,1,47,93,237,244,50,237,50,16,222,93,237,244,237,17,18,57,57,47,47,93,93,113,114,56,56,51,93,17,51,93,49,48,43,43,43,43,43,43,1,34,46,2,53,52,62,2,51,50,30,2,23,7,46,1,35,34,6,21,20,22,51,50,54,55,23,14,3,5,20,14,2,35,34,46,2,53,52,62,2,51,50,30,2,1,35,1,
51,19,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,1,163,99,139,87,40,63,102,130,67,75,113,80,47,10,188,8,66,59,85,69,70,84,60,68,8,188,7,46,81,116,4,241,56,96,129,73,75,129,95,55,55,96,131,76,72,128,95,55,251,69,206,3,152,209,73,17,34,50,34,37,53,34,17,16,35,52,36,33,51,35,18,2,13,69,121,165,96,131,173,103,42,43,74,101,58,12,63,75,143,146,151,145,77,67,10,58,109,82,50,93,125,172,105,46,46,105,172,125,132,173,103,41,41,103,173,253,204,5,129,252,47,87,114,67,27,27,68,114,86,84,111,68,28,28,67,112,0,2,
0,41,255,236,3,160,5,149,0,40,0,54,0,120,64,12,17,40,9,0,77,12,40,9,10,0,76,29,184,255,232,180,9,10,0,76,25,184,255,232,64,54,9,10,0,76,3,73,4,4,38,41,73,47,32,1,32,56,50,38,70,21,17,0,14,32,14,48,14,64,14,144,14,160,14,6,14,15,37,79,50,21,50,3,50,3,50,11,44,82,27,4,0,80,11,22,0,63,237,63,237,18,57,57,47,47,17,51,16,237,50,1,47,93,51,51,237,50,16,222,93,237,18,57,47,237,49,48,0,43,43,43,1,43,37,50,54,55,51,14,5,35,34,38,61,1,6,7,53,62,1,55,3,52,62,2,51,50,30,2,21,20,14,2,7,21,20,22,19,52,38,35,34,
14,2,21,17,62,3,2,70,80,85,23,146,10,31,46,63,85,110,70,169,159,64,68,33,69,31,1,37,92,155,117,83,131,92,48,65,123,176,111,68,168,54,57,34,46,26,11,54,85,58,31,195,106,107,51,103,95,83,61,35,167,163,166,25,23,195,11,25,12,1,134,68,132,104,64,39,76,110,72,98,169,139,110,38,201,96,86,3,144,69,84,24,40,54,30,254,176,22,69,86,100,0,4,0,137,0,0,8,127,5,129,0,3,0,23,0,43,0,63,0,178,185,0,42,255,232,64,17,9,10,0,76,36,24,9,10,0,76,32,24,9,10,0,76,26,184,255,232,64,11,9,10,0,76,4,24,9,17,72,4,21,184,1,32,
64,20,22,54,180,34,1,34,22,34,22,34,12,44,180,2,24,65,47,65,1,14,184,255,232,180,9,17,72,14,11,184,1,32,64,37,0,12,32,12,48,12,64,12,4,12,59,182,29,49,182,39,29,39,29,39,1,13,20,15,1,27,5,1,5,15,5,15,12,21,13,3,1,184,1,33,179,4,0,12,18,0,63,51,51,228,63,51,18,57,57,47,47,93,93,17,18,57,57,47,47,16,237,16,237,1,47,93,237,50,43,93,16,222,50,237,17,57,57,47,47,17,51,16,237,16,237,50,43,49,48,43,43,43,43,33,53,33,21,33,1,22,23,30,1,21,17,35,17,33,1,38,39,46,1,53,17,51,17,1,20,14,2,35,34,46,2,53,52,62,
2,51,50,30,2,7,52,46,2,35,34,14,2,21,20,30,2,51,50,62,2,5,244,2,123,251,160,253,90,5,4,4,5,242,1,41,2,171,5,4,4,5,242,3,66,43,85,126,84,80,123,84,43,41,83,126,84,88,127,81,38,214,15,30,44,29,29,46,32,17,17,31,43,26,30,46,32,17,166,166,4,71,46,47,40,91,40,252,193,5,129,251,176,49,50,43,99,44,3,51,250,127,2,111,77,128,92,51,51,91,128,78,75,127,92,52,52,92,127,75,56,74,45,18,19,45,74,55,57,76,46,19,19,46,76,0,2,0,125,3,0,7,4,5,129,0,42,0,50,0,118,182,15,24,9,10,0,76,3,184,255,232,64,65,9,10,0,76,9,17,
3,0,197,64,1,1,18,45,50,14,44,47,45,14,47,44,196,0,45,16,45,2,45,15,18,197,111,17,1,15,17,79,17,95,17,223,17,4,17,52,1,18,31,9,4,45,209,24,37,43,3,47,202,2,15,45,3,48,3,0,63,23,51,237,23,50,63,23,51,1,16,222,93,113,237,50,47,93,237,198,43,1,24,16,77,230,17,18,57,47,26,237,50,18,57,49,48,43,43,1,35,17,51,19,30,1,23,22,23,54,55,62,1,55,19,51,17,35,17,52,54,55,54,55,6,7,14,1,7,3,35,3,46,1,39,38,39,22,23,30,1,21,37,17,35,17,35,53,33,21,4,35,166,248,139,9,23,10,11,12,12,11,10,22,9,144,243,165,2,2,2,2,
16,14,12,26,8,154,131,149,8,26,13,15,15,2,2,2,1,254,1,180,243,2,162,3,0,2,129,254,211,20,55,25,29,31,31,29,25,55,20,1,45,253,127,1,84,14,56,29,34,39,39,36,31,61,17,254,184,1,72,19,61,30,35,39,41,35,30,55,11,162,254,10,1,246,139,139,0,0,1,0,85,0,0,5,208,5,150,0,57,0,113,185,0,31,255,240,64,67,10,0,77,27,16,10,0,77,48,40,10,18,32,40,1,48,40,64,40,96,40,112,40,4,63,18,79,18,2,40,18,40,18,53,24,90,5,5,16,59,34,90,53,53,48,42,1,15,42,31,42,2,42,19,19,39,39,15,42,95,18,41,18,29,95,0,4,0,63,237,63,51,237,
50,50,47,51,47,1,47,93,93,50,47,237,16,206,50,47,237,18,57,57,47,47,93,93,113,17,51,17,51,49,48,43,43,1,50,30,2,21,20,14,2,7,54,55,62,1,51,33,21,33,17,62,3,53,52,46,2,35,34,14,2,21,20,30,2,23,17,33,53,33,50,22,23,22,23,46,3,53,52,62,2,3,19,156,250,174,93,47,100,155,109,30,31,26,59,25,1,12,253,139,87,118,72,32,51,97,141,91,91,141,97,51,32,74,119,88,253,132,1,14,26,61,26,31,30,111,157,101,47,93,174,250,5,150,82,156,223,141,102,177,153,128,51,3,3,2,3,228,1,53,43,101,115,132,74,101,158,108,57,57,108,
158,101,74,132,115,101,43,254,203,228,3,2,3,3,51,128,153,178,102,141,223,155,82,0,0,0,2,0,88,255,222,4,124,4,72,0,34,0,47,0,66,64,18,30,30,5,35,73,17,49,47,19,73,48,5,1,5,29,29,24,18,184,1,31,179,47,47,24,41,184,1,31,178,12,16,24,184,1,31,177,0,22,0,63,237,63,237,18,57,47,237,17,57,47,1,47,93,237,50,16,222,237,18,57,47,49,48,5,34,46,2,53,52,62,4,51,50,30,2,21,33,17,30,3,51,50,62,2,55,23,14,3,19,17,46,3,35,34,14,2,7,17,2,107,130,198,134,69,44,76,102,118,128,63,113,193,142,81,252,197,22,64,78,88,46,
75,116,93,77,34,72,36,83,110,143,203,19,59,76,93,53,51,87,74,60,24,34,93,157,204,111,98,160,125,93,60,29,79,146,209,131,254,156,24,45,35,20,32,60,87,55,42,57,100,76,44,2,138,1,21,20,42,34,22,19,32,42,24,254,234,0,0,0,255,255,0,114,255,248,6,72,5,134,16,38,0,121,32,0,16,39,2,26,2,188,0,0,17,7,2,150,3,207,253,76,0,32,64,18,4,3,2,20,25,1,128,12,1,32,12,1,12,0,32,0,1,0,17,93,53,17,93,93,53,0,63,53,53,53,0,0,255,255,0,84,255,248,6,72,5,146,16,39,2,26,2,168,0,0,16,39,2,150,3,207,253,76,17,6,0,115,40,0,
0,28,64,16,1,3,2,9,25,0,128,0,1,64,0,1,32,0,1,0,17,93,93,93,53,0,63,53,53,53,0,0,255,255,0,103,255,248,6,72,5,129,16,39,2,26,2,168,0,0,16,39,2,150,3,207,253,76,17,6,2,148,50,0,0,28,64,16,1,3,2,9,25,0,128,0,1,64,0,1,32,0,1,0,17,93,93,93,53,0,63,53,53,53,0,0,255,255,0,163,255,248,6,72,5,129,16,39,2,26,2,148,0,0,16,39,2,150,3,207,253,76,17,6,2,149,120,0,0,44,64,27,3,2,1,9,25,0,64,0,1,32,0,1,0,4,64,82,1,32,82,1,16,82,1,0,82,1,82,17,93,93,93,93,53,17,93,93,53,0,63,53,53,53,0,0,0,1,1,162,0,100,6,94,2,68,
0,17,0,24,64,9,0,15,12,3,128,16,7,17,16,0,47,205,1,47,205,26,204,50,57,57,49,48,1,30,1,23,35,46,1,39,53,62,1,55,51,14,1,7,33,21,2,129,29,59,31,72,58,130,82,82,130,58,72,31,59,29,3,221,1,41,34,98,65,68,112,42,36,42,112,68,65,98,34,86,0,0,0,1,1,16,255,195,2,240,4,127,0,17,0,26,64,10,15,64,0,0,15,12,3,17,128,7,0,47,26,205,204,50,57,57,1,47,26,205,49,48,1,14,1,7,53,62,1,55,51,30,1,23,21,46,1,39,17,35,1,213,34,98,65,68,112,42,36,42,112,68,65,98,34,86,3,160,29,59,31,72,58,130,82,82,130,58,72,31,59,29,252,
35,0,1,1,162,0,100,6,94,2,68,0,17,0,24,64,9,0,15,12,3,128,7,17,16,17,0,47,205,1,47,221,26,204,50,57,57,49,48,1,46,1,39,51,30,1,23,21,14,1,7,35,62,1,55,33,53,5,127,29,59,31,72,58,130,82,82,130,58,72,31,59,29,252,35,1,127,34,98,65,68,112,42,36,42,112,68,65,98,34,86,0,0,0,1,1,16,255,195,2,240,4,127,0,17,0,26,64,10,17,64,16,15,0,3,12,128,8,16,0,47,221,26,204,50,57,57,1,47,26,205,49,48,37,62,1,55,21,14,1,7,35,46,1,39,53,30,1,23,17,51,2,43,34,98,65,68,112,42,36,42,112,68,65,98,34,86,162,29,59,31,72,58,
130,82,82,130,58,72,31,59,29,3,221,0,0,1,1,162,0,100,6,94,2,68,0,31,0,36,64,15,16,31,28,19,128,23,64,15,0,3,12,128,8,0,15,0,47,205,1,47,26,204,50,57,57,26,221,26,204,50,57,57,49,48,1,30,1,23,35,46,1,39,53,62,1,55,51,14,1,7,33,46,1,39,51,30,1,23,21,14,1,7,35,62,1,55,2,129,29,59,31,72,58,130,82,82,130,58,72,31,59,29,2,254,29,59,31,72,58,130,82,82,130,58,72,31,59,29,1,41,34,98,65,68,112,42,36,42,112,68,65,98,34,34,98,65,68,112,42,36,42,112,68,65,98,34,0,0,0,1,1,16,255,195,2,240,4,127,0,31,0,38,64,16,
15,64,0,31,16,19,28,128,24,64,0,15,12,3,128,7,0,47,26,204,50,57,57,26,221,26,204,50,57,57,1,47,26,205,49,48,1,14,1,7,53,62,1,55,51,30,1,23,21,46,1,39,17,62,1,55,21,14,1,7,35,46,1,39,53,30,1,23,1,213,34,98,65,68,112,42,36,42,112,68,65,98,34,34,98,65,68,112,42,36,42,112,68,65,98,34,3,160,29,59,31,72,58,130,82,82,130,58,72,31,59,29,253,2,29,59,31,72,58,130,82,82,130,58,72,31,59,29,0,2,1,16,255,72,2,240,4,127,0,3,0,35,0,40,64,17,1,19,0,4,35,20,23,32,28,3,0,28,4,19,16,7,11,0,47,204,50,57,57,221,222,205,
16,204,50,57,57,1,47,51,205,50,49,48,5,33,21,33,19,14,1,7,53,62,1,55,51,30,1,23,21,46,1,39,17,62,1,55,21,14,1,7,35,46,1,39,53,30,1,23,1,16,1,224,254,32,197,34,98,65,68,112,42,36,42,112,68,65,98,34,34,98,65,68,112,42,36,42,112,68,65,98,34,104,80,4,88,29,59,31,72,58,130,82,82,130,58,72,31,59,29,253,2,29,59,31,72,58,130,82,82,130,58,72,31,59,29,0,0,2,0,53,255,231,3,177,5,188,0,45,0,67,0,97,64,14,7,43,1,12,16,10,0,77,12,24,9,0,77,8,184,255,224,64,19,10,0,77,37,37,15,46,29,70,0,64,9,25,72,0,69,58,70,15,
184,255,192,64,21,20,25,72,15,51,82,25,22,22,63,41,37,37,32,79,41,0,63,79,10,22,0,63,237,63,237,51,47,17,18,57,47,51,237,1,47,43,237,16,222,43,237,50,17,57,47,49,48,43,43,43,93,1,20,14,2,7,14,3,35,34,46,2,53,52,62,4,51,50,22,23,51,54,52,53,52,38,35,34,14,2,7,55,62,1,51,50,30,2,1,46,3,35,34,14,4,21,20,30,2,51,50,62,2,3,177,6,12,17,12,28,90,125,161,101,94,130,81,35,20,44,68,96,125,78,76,122,31,4,1,106,111,25,57,55,52,20,45,39,107,66,110,151,94,41,254,252,7,29,41,50,29,41,67,53,40,25,13,17,34,50,32,
51,87,67,47,3,139,49,105,106,105,48,117,191,137,74,64,109,144,79,59,136,136,126,97,58,86,76,20,44,26,173,190,10,18,25,15,205,23,34,92,154,204,254,139,36,62,45,25,43,70,92,97,96,40,46,76,54,29,81,134,170,0,2,0,43,0,0,4,185,5,129,0,5,0,18,0,173,64,11,18,16,10,0,77,18,24,9,0,77,17,184,255,240,179,10,0,77,17,184,255,232,179,9,0,77,16,184,255,240,64,43,10,0,77,6,16,10,0,77,3,2,11,11,1,18,0,4,16,4,2,11,4,20,16,20,32,20,144,20,3,48,20,80,20,128,20,160,20,208,20,240,20,6,20,184,255,192,64,55,93,96,72,79,
20,1,0,20,1,57,16,20,64,20,96,20,144,20,176,20,208,20,224,20,7,15,20,1,191,20,223,20,2,0,20,32,20,80,20,112,20,144,20,160,20,6,17,1,11,2,3,17,95,0,18,0,63,237,63,57,1,47,51,93,93,113,114,94,93,93,43,113,114,16,198,94,93,50,17,57,17,51,51,49,48,43,43,43,43,43,43,51,53,1,33,1,21,1,46,3,39,14,3,7,3,33,43,1,141,1,112,1,145,254,12,14,29,24,17,1,1,16,23,27,14,207,2,68,215,4,170,251,86,215,3,152,47,97,82,57,5,5,58,83,97,45,253,79,0,0,0,1,0,204,254,57,5,202,5,129,0,7,0,36,64,19,0,90,7,9,3,90,32,4,48,4,2,
4,2,96,5,3,4,4,0,0,47,50,47,63,237,1,47,93,237,16,222,237,49,48,1,17,33,17,33,17,33,17,4,176,253,67,254,217,4,254,254,57,6,84,249,172,7,72,248,184,0,1,0,134,254,57,5,68,5,129,0,11,0,138,64,41,80,2,96,2,2,2,64,26,45,72,2,91,79,8,1,8,6,8,6,0,10,13,143,7,1,7,91,3,143,9,1,9,91,3,32,0,48,0,2,0,3,184,255,232,64,50,10,17,72,3,7,95,4,8,79,2,95,2,111,2,239,2,4,47,2,63,2,79,2,191,2,223,2,255,2,6,2,2,4,3,26,1,42,1,58,1,3,1,24,14,17,72,1,9,95,0,0,47,237,57,43,93,63,57,25,47,93,113,51,24,16,237,57,43,1,47,93,
196,237,114,16,237,114,16,206,17,57,57,47,47,93,237,43,114,49,48,19,53,9,1,53,33,21,33,9,1,33,21,134,2,94,253,182,4,113,253,2,2,16,253,220,3,75,254,57,160,3,8,3,8,152,227,253,71,253,56,228,0,0,0,0,1,0,85,2,57,4,88,3,25,0,3,0,22,64,10,2,5,64,1,1,1,0,173,1,178,0,63,237,1,47,93,16,206,49,48,19,53,33,21,85,4,3,2,57,224,224,0,0,1,0,2,255,231,4,106,6,84,0,8,0,169,182,1,2,5,6,1,6,5,184,1,29,64,10,2,1,20,2,2,1,0,7,6,7,184,1,29,64,20,8,0,20,8,8,0,5,2,1,0,6,6,8,2,2,3,7,8,16,8,184,255,192,64,67,10,0,77,8,3,
111,10,127,10,159,10,191,10,223,10,255,10,6,15,10,47,10,95,10,127,10,159,10,191,10,6,59,176,10,208,10,240,10,3,175,10,207,10,239,10,3,112,10,144,10,2,79,10,111,10,143,10,175,10,4,2,173,5,5,7,0,25,0,63,47,57,47,237,1,93,113,113,114,94,93,113,47,47,43,56,51,18,57,47,18,57,17,51,51,17,51,135,16,43,135,125,196,135,24,16,43,16,0,193,135,5,125,16,196,49,48,5,35,1,35,53,33,19,1,51,2,112,168,254,242,184,1,55,219,1,156,186,25,2,242,166,253,133,5,80,0,3,0,72,0,216,5,109,3,196,0,35,0,51,0,69,0,117,185,0,34,
255,232,64,17,9,10,0,76,20,24,9,10,0,76,16,24,9,10,0,76,2,184,255,232,183,9,10,0,76,52,39,18,47,184,1,24,178,0,71,62,184,1,24,181,31,18,1,18,36,57,184,1,25,180,31,26,23,42,67,184,1,25,64,21,8,5,47,13,63,13,79,13,3,63,13,79,13,127,13,207,13,223,13,5,13,0,47,93,113,51,51,237,50,47,51,51,237,50,1,47,93,237,16,222,237,18,57,57,49,48,43,43,43,43,1,20,14,2,35,34,38,39,14,3,35,34,46,2,53,52,62,2,51,50,22,23,62,3,51,50,30,2,37,34,6,7,30,1,51,50,62,2,53,52,46,2,5,46,3,35,34,14,2,21,20,30,2,51,50,54,5,109,
47,86,118,72,103,168,65,28,69,83,97,56,70,120,86,49,47,86,120,72,103,165,65,27,67,80,95,55,75,124,88,48,254,165,60,106,48,44,99,70,36,59,41,22,21,40,58,254,63,22,43,48,55,35,37,61,44,24,22,42,62,41,59,96,2,71,74,133,101,59,112,127,49,84,62,34,52,96,138,85,77,134,99,57,111,128,49,84,62,35,52,97,137,113,96,101,94,102,31,53,71,41,41,72,53,31,187,47,74,51,26,31,53,72,42,39,71,54,31,95,0,0,0,0,1,1,152,0,0,6,96,4,199,0,5,0,13,179,2,5,2,5,0,47,205,1,47,205,49,48,1,51,17,33,21,33,1,152,94,4,106,251,56,4,
199,251,151,94,0,0,0,0,1,1,25,255,254,4,173,4,8,0,25,0,25,64,11,25,172,0,12,172,13,13,0,19,174,6,0,47,237,47,51,1,47,237,47,237,49,48,5,17,52,62,2,51,50,30,2,21,17,35,17,52,46,2,35,34,14,2,21,17,1,25,68,122,167,98,99,169,123,70,103,53,95,130,78,78,130,94,52,2,2,0,116,192,138,76,76,138,192,116,254,0,2,2,98,155,108,57,56,108,156,100,254,0,0,0,0,0,1,255,127,254,57,2,190,5,207,0,37,0,81,185,0,35,255,232,64,33,9,10,0,76,17,24,9,10,0,76,24,24,6,6,33,70,16,14,32,14,2,0,14,32,14,48,14,192,14,208,14,5,14,
184,255,192,64,14,35,38,72,14,14,39,38,27,80,20,0,9,80,0,0,47,237,63,237,17,18,1,57,47,43,93,113,237,51,47,50,47,49,48,43,43,19,34,46,2,39,53,30,1,51,50,62,2,53,17,52,62,2,51,50,22,23,21,46,1,35,34,14,2,21,17,20,14,2,26,19,43,42,37,14,21,62,36,44,60,36,15,52,101,150,99,40,87,28,20,63,36,44,60,37,16,51,101,149,254,57,3,6,7,5,217,8,17,30,53,72,42,4,127,87,141,99,54,11,8,219,10,15,31,54,71,39,251,127,87,141,99,54,0,2,0,43,1,18,4,57,4,55,0,30,0,62,0,136,64,18,33,16,10,0,77,61,48,9,10,0,76,60,48,9,10,
0,76,43,184,255,192,64,34,9,10,0,76,44,48,9,10,0,76,2,16,10,0,77,27,48,9,10,0,76,28,48,9,10,0,76,29,48,9,10,0,76,11,184,255,192,64,36,9,10,0,76,12,48,9,10,0,76,58,26,64,43,11,57,37,173,46,175,54,173,42,31,25,6,173,14,175,23,173,11,63,0,1,0,0,47,93,50,237,253,237,51,47,51,237,253,237,51,1,47,196,16,222,196,49,48,43,0,43,43,43,43,43,1,43,0,43,43,43,43,1,34,38,39,38,35,34,14,2,7,53,62,1,51,50,30,2,23,30,1,51,50,54,55,21,14,3,3,34,38,39,46,1,35,34,14,2,7,53,62,1,51,50,22,23,30,3,51,50,54,55,21,14,3,3,
46,75,145,75,132,89,39,67,61,58,30,51,136,84,41,82,80,78,38,45,107,48,68,128,52,32,61,63,70,41,75,145,75,66,109,46,39,67,61,58,30,51,136,84,83,160,76,22,50,52,52,24,68,128,52,32,61,63,70,2,244,41,26,47,12,22,33,21,213,39,45,13,21,26,13,16,27,50,42,219,23,31,18,8,254,30,44,26,23,22,12,23,32,21,213,38,46,46,26,7,16,14,8,50,42,219,22,31,19,8,0,0,0,0,1,0,29,0,37,4,72,5,43,0,19,0,185,185,0,16,255,248,64,46,10,0,77,13,16,17,0,4,1,12,37,1,53,1,69,1,3,1,10,7,6,3,4,2,11,42,11,58,11,74,11,3,11,12,47,2,63,2,
2,2,12,2,12,4,19,14,184,255,192,64,77,37,40,72,14,21,8,63,4,1,4,64,36,40,72,4,64,14,34,72,4,16,8,173,13,48,11,1,48,11,176,11,2,11,48,9,112,9,2,32,9,64,9,96,9,112,9,160,9,192,9,6,9,17,5,173,2,0,223,4,1,15,4,31,4,63,4,79,4,143,4,5,4,64,20,25,72,4,0,47,43,93,113,51,198,237,50,47,93,113,198,93,113,51,237,50,1,47,43,43,93,51,16,206,43,50,17,57,57,47,47,93,17,51,93,17,18,23,57,50,93,17,18,23,57,49,48,43,1,7,35,55,35,53,33,19,33,53,33,19,51,3,51,21,33,3,33,21,1,205,129,213,129,219,1,71,166,254,19,2,90,133,
211,131,252,254,151,166,2,15,1,35,254,254,221,1,74,223,1,2,254,254,223,254,182,221,0,0,0,0,3,0,100,0,244,4,71,4,80,0,3,0,7,0,11,0,66,64,13,11,7,2,13,8,4,32,0,64,0,2,0,8,184,1,0,179,9,9,1,5,184,1,0,180,63,4,1,4,0,184,1,0,183,15,1,31,1,63,1,3,1,0,47,93,237,47,93,237,17,57,47,237,1,47,93,51,51,16,206,50,50,49,48,19,53,33,21,1,53,33,21,1,53,33,21,100,3,227,252,29,3,227,252,29,3,227,3,188,148,148,253,56,148,148,1,100,148,148,0,0,2,0,49,0,0,4,51,5,18,0,6,0,10,0,131,64,35,0,1,82,5,4,5,176,6,0,20,6,0,5,6,
1,2,1,82,3,4,1,4,3,176,2,1,20,2,1,3,2,10,10,2,6,184,255,192,64,36,37,40,72,6,12,7,7,4,0,64,36,40,72,0,64,12,20,72,0,8,173,7,1,0,4,4,2,5,6,3,48,2,64,2,2,2,0,47,93,51,47,51,18,57,61,47,51,51,24,47,237,1,47,43,43,51,51,47,16,222,43,196,51,47,16,193,135,4,43,16,1,193,135,4,43,16,196,16,1,193,135,4,24,43,135,43,196,49,48,19,17,1,21,9,1,21,1,53,33,21,49,4,2,252,192,3,64,251,254,4,0,2,119,1,65,1,90,227,254,232,254,233,227,254,227,223,223,0,0,0,0,2,0,49,0,0,4,51,5,18,0,6,0,10,0,129,64,35,6,1,82,1,2,1,176,
0,6,20,0,6,1,0,5,4,1,82,3,2,5,2,3,176,4,5,20,4,5,3,4,10,10,2,6,184,255,192,64,35,37,40,72,6,12,7,7,4,0,64,36,40,72,0,64,12,20,72,0,8,173,7,6,5,2,2,3,48,4,64,4,2,4,1,0,0,47,50,47,93,51,57,61,47,51,51,24,47,237,1,47,43,43,196,51,47,16,206,43,50,50,47,16,193,135,4,43,16,1,193,135,4,43,16,196,16,1,193,135,4,24,43,135,43,196,49,48,19,53,9,1,53,1,17,1,53,33,21,49,3,63,252,193,4,2,251,254,4,2,1,29,227,1,23,1,24,227,254,166,254,191,253,137,223,223,0,0,2,0,157,0,0,4,55,4,129,0,4,0,9,0,35,64,18,105,9,121,9,
2,105,7,121,7,2,6,4,5,0,2,8,5,0,0,47,205,47,205,1,47,205,221,205,49,48,0,93,93,51,17,9,1,17,37,33,17,9,1,157,1,205,1,205,252,182,2,250,254,131,254,131,2,123,2,6,253,250,253,133,82,2,6,1,170,254,86,0,0,0,0,1,0,100,0,180,4,71,2,242,0,5,0,44,64,28,32,2,1,2,5,170,32,0,80,0,2,0,4,173,15,1,63,1,95,1,143,1,4,1,63,0,1,0,0,47,93,47,93,237,1,47,93,237,47,93,49,48,55,17,33,21,33,17,100,3,227,252,174,180,2,62,146,254,84,0,0,1,2,34,253,154,3,210,6,170,0,23,0,29,182,4,32,8,11,72,9,0,184,1,0,180,1,19,12,6,1,0,47,
47,205,205,1,47,237,204,49,48,43,1,35,17,52,55,54,51,50,22,21,20,6,35,34,39,46,1,39,38,35,34,7,6,21,2,181,147,84,82,128,63,75,51,37,30,13,8,26,20,33,16,36,9,6,253,154,7,86,196,123,123,63,48,40,52,10,4,24,22,39,39,35,105,0,0,0,1,1,5,253,154,2,181,6,170,0,28,0,32,185,0,4,255,224,180,8,11,72,12,2,184,1,0,180,28,24,17,7,0,0,47,47,205,205,1,47,253,204,49,48,43,1,51,17,20,7,14,1,35,34,46,2,53,52,62,2,51,50,23,30,1,23,22,51,50,55,54,53,2,34,147,90,40,103,62,30,50,37,20,14,23,31,18,33,26,5,21,15,31,16,37,
8,7,6,170,248,168,205,125,56,54,16,29,39,24,20,34,24,14,16,2,23,20,37,41,31,106,0,0,0,1,255,246,2,37,5,181,2,182,0,3,0,22,180,3,5,0,4,0,184,1,2,177,1,252,0,63,237,17,1,51,17,51,49,48,3,53,33,21,10,5,191,2,37,145,145,0,0,1,1,216,253,147,2,105,7,72,0,3,0,24,187,0,2,1,0,0,3,1,6,180,4,3,254,0,250,0,63,63,1,16,246,237,49,48,1,51,17,35,1,216,145,145,7,72,246,75,0,0,0,1,2,141,253,147,5,181,2,182,0,5,0,34,178,2,7,3,186,1,0,0,0,1,6,179,6,5,254,3,184,1,2,177,0,252,0,63,237,63,1,16,246,237,17,51,49,48,1,33,
21,33,17,35,2,141,3,40,253,105,145,2,182,145,251,110,0,0,0,1,255,246,253,147,3,30,2,182,0,5,0,34,187,0,2,1,0,0,5,1,6,181,6,0,6,4,254,5,184,1,2,177,2,252,0,63,237,63,17,1,51,16,246,237,49,48,3,53,33,17,35,17,10,3,40,145,2,37,145,250,221,4,146,0,0,0,0,1,2,141,2,37,5,181,7,72,0,5,0,34,178,4,7,2,189,1,0,0,5,1,6,0,6,0,5,1,2,179,2,252,0,250,0,63,63,237,1,16,246,237,17,51,49,48,1,51,17,33,21,33,2,141,145,2,151,252,216,7,72,251,110,145,0,0,0,1,255,246,2,37,3,30,7,72,0,5,0,34,187,0,5,1,0,0,2,1,6,181,6,0,6,
3,250,5,184,1,2,177,2,252,0,63,237,63,17,1,51,16,244,237,49,48,3,53,33,17,51,17,10,2,151,145,2,37,145,4,146,250,221,0,0,0,0,1,2,141,253,147,5,181,7,72,0,7,0,39,179,4,9,5,1,186,1,0,0,0,1,6,179,8,7,254,5,184,1,2,179,2,252,0,250,0,63,63,237,63,1,16,246,237,50,17,51,49,48,1,51,17,33,21,33,17,35,2,141,145,2,151,253,105,145,7,72,251,110,145,251,110,0,1,255,246,253,147,3,30,7,72,0,7,0,39,177,7,4,186,1,0,0,2,1,6,183,8,0,8,6,254,3,250,7,184,1,2,177,2,252,0,63,237,63,63,17,1,51,16,244,237,51,49,48,3,53,33,
17,51,17,35,17,10,2,151,145,145,2,37,145,4,146,246,75,4,146,0,0,1,255,246,253,147,5,181,2,182,0,7,0,40,178,3,9,4,186,1,0,0,7,1,6,182,8,0,8,6,254,4,0,184,1,2,177,1,252,0,63,237,50,63,17,1,51,16,246,237,17,51,49,48,3,53,33,21,33,17,35,17,10,5,191,253,105,145,2,37,145,145,251,110,4,146,0,1,255,246,2,37,5,181,7,72,0,7,0,40,178,7,9,5,186,1,0,0,2,1,6,182,8,0,8,3,250,5,0,184,1,2,177,1,252,0,63,237,51,63,17,1,51,16,244,237,17,51,49,48,3,53,33,17,51,17,33,21,10,2,151,145,2,151,2,37,145,4,146,251,110,145,0,
1,255,246,253,147,5,181,7,72,0,11,0,51,179,7,13,5,8,187,1,0,0,2,0,11,1,6,64,9,12,0,12,10,254,3,250,8,11,184,1,2,178,5,2,252,0,63,51,237,50,63,63,17,1,51,16,246,50,237,50,17,51,49,48,3,53,33,17,51,17,33,21,33,17,35,17,10,2,151,145,2,151,253,105,145,2,37,145,4,146,251,110,145,251,110,4,146,0,0,0,2,255,246,1,113,5,181,3,106,0,3,0,7,0,37,183,3,7,7,9,0,4,8,4,184,1,2,178,5,253,0,184,1,2,177,1,251,0,63,237,63,237,17,1,51,50,17,51,17,51,49,48,3,53,33,21,1,53,33,21,10,5,191,250,65,5,191,2,217,145,145,254,
152,145,145,0,2,1,217,253,147,3,210,7,72,0,3,0,7,0,42,65,9,0,5,1,0,0,4,1,7,0,8,0,1,1,0,0,0,1,4,182,8,7,3,254,4,0,250,0,63,50,63,51,1,16,246,237,16,244,237,49,48,1,51,17,35,1,51,17,35,1,217,145,145,1,104,145,145,7,72,246,75,9,181,246,75,0,0,0,1,2,141,253,147,5,181,3,106,0,9,0,49,181,2,6,6,11,7,3,186,1,0,0,0,1,6,179,10,9,254,7,184,1,2,178,4,253,3,184,1,2,177,0,251,0,63,237,63,237,63,1,16,246,237,50,17,51,17,51,49,48,1,33,21,33,21,33,21,33,17,35,2,141,3,40,253,105,2,151,253,105,145,3,106,145,215,145,
252,34,0,0,1,1,217,253,147,5,181,2,182,0,9,0,51,178,1,11,6,191,1,0,0,9,1,4,0,10,0,2,1,0,0,5,1,7,178,10,2,6,184,1,2,180,9,252,4,8,254,0,63,51,63,237,50,1,16,244,237,16,246,237,17,51,49,48,1,21,33,17,35,17,35,17,35,17,5,181,254,29,145,215,145,2,182,145,251,110,4,146,251,110,5,35,0,0,0,0,2,1,217,253,147,5,181,3,106,0,5,0,11,0,63,180,2,8,8,13,9,65,11,1,0,0,6,1,7,0,12,0,3,1,0,0,0,1,4,0,12,0,9,1,2,181,6,253,11,5,254,3,184,1,2,177,0,251,0,63,237,63,51,63,237,1,16,246,237,16,244,237,17,51,17,51,49,48,1,33,
21,33,17,35,1,33,21,33,17,35,1,217,3,220,252,181,145,1,104,2,116,254,29,145,3,106,145,250,186,4,111,145,252,34,0,0,1,255,246,253,147,3,30,3,106,0,9,0,49,177,9,6,186,1,0,0,3,1,6,183,10,4,0,0,10,8,254,3,184,1,2,178,6,251,9,184,1,2,177,2,253,0,63,237,63,237,63,17,1,51,17,51,16,244,237,51,49,48,3,53,33,53,33,53,33,17,35,17,10,2,151,253,105,3,40,145,1,113,145,215,145,250,41,3,222,0,0,0,1,255,246,253,147,3,210,2,182,0,9,0,52,65,9,0,6,1,0,0,9,1,4,0,10,0,2,1,0,0,5,1,7,183,10,0,10,4,8,254,6,0,184,1,2,177,
1,252,0,63,237,50,63,51,17,1,51,16,244,237,16,246,237,49,48,3,53,33,17,35,17,35,17,35,17,10,3,220,145,215,145,2,37,145,250,221,4,146,251,110,4,146,0,0,0,0,2,255,246,253,147,3,210,3,106,0,5,0,11,0,63,180,4,9,9,12,11,65,11,1,0,0,8,1,4,0,12,0,0,1,0,0,3,1,7,0,12,0,9,1,2,181,10,253,2,7,254,4,184,1,2,177,5,251,0,63,237,63,51,63,237,1,16,244,237,16,246,237,17,51,17,51,49,48,1,17,35,17,33,53,1,35,17,33,53,33,3,210,145,252,181,2,116,145,254,29,2,116,3,106,250,41,5,70,145,250,41,3,222,145,0,0,1,2,141,1,113,
5,181,7,72,0,9,0,49,181,4,8,8,11,2,6,189,1,0,0,9,1,6,0,10,0,9,1,2,178,6,253,5,184,1,2,179,2,251,0,250,0,63,63,237,63,237,1,16,246,237,50,17,51,17,51,49,48,1,51,17,33,21,33,21,33,21,33,2,141,145,2,151,253,105,2,151,252,216,7,72,252,34,145,215,145,0,0,1,1,217,2,37,5,181,7,72,0,9,0,52,178,4,11,2,65,11,1,0,0,9,1,7,0,10,0,8,1,0,0,5,1,4,0,10,0,5,1,2,181,2,8,252,0,6,250,0,63,51,63,51,237,1,16,246,237,16,244,237,17,51,49,48,1,51,17,33,21,33,17,51,17,51,3,65,145,1,227,252,36,145,215,7,72,251,110,145,5,35,
251,110,0,0,0,2,1,217,1,113,5,181,7,72,0,5,0,11,0,63,180,10,4,4,13,8,65,11,1,0,0,11,1,7,0,12,0,2,1,0,0,5,1,4,0,12,0,11,1,2,178,8,251,5,184,1,2,180,2,253,6,0,250,0,63,50,63,237,63,237,1,16,246,237,16,244,237,17,51,17,51,49,48,1,51,17,33,21,33,1,51,17,33,21,33,1,217,145,3,75,252,36,1,104,145,1,227,253,140,7,72,250,186,145,5,215,252,34,145,0,0,1,255,246,1,113,3,30,7,72,0,9,0,50,188,0,9,1,0,0,6,0,2,1,6,183,10,4,0,0,10,7,250,3,184,1,2,178,6,251,9,184,1,2,177,2,253,0,63,237,63,237,63,17,1,51,17,51,16,244,
50,237,49,48,3,53,33,53,33,53,33,17,51,17,10,2,151,253,105,2,151,145,1,113,145,215,145,3,222,250,41,0,0,1,255,246,2,37,3,210,7,72,0,9,0,52,65,9,0,0,1,0,0,7,1,7,0,10,0,6,1,0,0,3,1,4,183,10,1,10,8,4,250,6,1,184,1,2,177,2,252,0,63,237,51,63,51,17,1,51,16,244,237,16,244,237,49,48,1,33,53,33,17,51,17,51,17,51,3,210,252,36,1,227,145,215,145,2,37,145,4,146,251,110,4,146,0,0,0,2,255,246,1,113,3,210,7,72,0,5,0,11,0,63,65,9,0,8,1,0,0,11,1,4,0,12,0,0,1,0,0,3,1,7,181,12,9,1,1,12,9,184,1,2,181,10,251,4,6,250,
1,184,1,2,177,2,253,0,63,237,63,51,63,237,17,1,51,17,51,16,244,237,16,244,237,49,48,1,33,53,33,17,51,33,51,17,33,53,33,3,210,252,36,3,75,145,254,7,145,253,140,1,227,1,113,145,5,70,251,145,145,0,0,0,0,1,2,141,253,147,5,181,7,72,0,11,0,54,182,4,8,8,13,6,2,10,186,1,0,0,11,1,6,179,12,11,254,9,184,1,2,178,6,253,5,184,1,2,179,2,251,0,250,0,63,63,237,63,237,63,1,16,246,237,50,50,17,51,17,51,49,48,1,51,17,33,21,33,21,33,21,33,17,35,2,141,145,2,151,253,105,2,151,253,105,145,7,72,252,34,145,215,145,252,34,
0,0,0,0,2,1,217,253,147,5,181,7,72,0,7,0,11,0,56,178,4,13,10,186,1,0,0,11,1,4,178,12,2,6,186,1,0,0,7,1,7,183,12,7,11,254,0,8,250,5,184,1,2,177,2,252,0,63,237,63,51,63,51,1,16,244,237,50,16,246,237,17,51,49,48,1,51,17,33,21,33,17,35,1,51,17,35,3,65,145,1,227,254,29,145,254,152,145,145,7,72,251,110,145,251,110,9,181,246,75,0,0,3,1,217,253,147,5,181,7,72,0,3,0,9,0,15,0,73,181,14,6,6,17,12,8,65,12,1,0,0,15,0,9,1,7,0,16,0,0,1,0,0,1,1,4,0,16,0,15,1,2,178,12,251,7,184,1,2,183,4,253,10,2,250,9,1,254,0,63,
51,63,51,63,237,63,237,1,16,246,237,16,244,50,237,50,17,51,17,51,49,48,1,35,17,51,19,33,21,33,17,35,17,51,17,33,21,33,2,106,145,145,215,2,116,254,29,145,145,1,227,253,140,253,147,9,181,250,186,145,252,34,9,181,252,34,145,0,1,255,246,253,147,3,30,7,72,0,11,0,56,185,0,9,1,0,178,6,2,10,184,1,6,64,10,12,4,0,0,12,10,254,7,250,3,184,1,2,178,6,251,11,184,1,2,177,2,253,0,63,237,63,237,63,63,17,1,51,17,51,16,246,50,50,237,49,48,3,53,33,53,33,53,33,17,51,17,35,17,10,2,151,253,105,2,151,145,145,1,113,145,215,
145,3,222,246,75,3,222,0,0,0,2,255,246,253,147,3,210,7,72,0,7,0,11,0,59,65,10,0,10,1,0,0,11,1,7,0,12,0,5,1,0,0,2,0,6,1,4,64,10,12,0,12,11,6,254,8,3,250,7,184,1,2,177,2,252,0,63,237,63,51,63,51,17,1,51,16,246,50,237,16,244,237,49,48,3,53,33,17,51,17,35,17,1,51,17,35,10,1,227,145,145,1,104,145,145,2,37,145,4,146,246,75,4,146,5,35,246,75,0,0,0,0,3,255,246,253,147,3,210,7,72,0,3,0,9,0,15,0,73,181,7,13,13,16,6,10,65,12,1,0,0,9,0,11,1,4,0,16,0,2,1,0,0,3,1,7,0,16,0,12,1,2,181,15,253,3,11,254,6,184,1,2,180,
9,251,0,4,250,0,63,51,63,237,63,51,63,237,1,16,244,237,16,246,50,237,50,17,51,17,51,49,48,1,51,17,35,1,51,17,33,53,33,19,35,17,33,53,33,3,65,145,145,254,152,145,253,140,1,227,145,145,254,29,2,116,7,72,246,75,9,181,251,145,145,250,41,3,222,145,0,0,0,2,255,246,253,147,5,181,3,106,0,7,0,11,0,57,180,11,3,3,13,4,186,1,0,0,7,1,6,181,12,8,0,0,12,8,184,1,2,181,9,251,6,254,4,0,184,1,2,177,1,253,0,63,237,50,63,63,237,17,1,51,17,51,16,246,237,17,51,17,51,49,48,3,53,33,21,33,17,35,17,1,53,33,21,10,5,191,253,
105,145,253,105,5,191,1,113,145,145,252,34,3,222,1,104,145,145,0,0,1,255,246,253,147,5,181,2,182,0,11,0,58,178,3,13,8,191,1,0,0,11,1,4,0,12,0,4,1,0,0,7,1,7,64,9,12,0,12,6,10,254,8,4,0,184,1,2,177,1,252,0,63,237,50,50,63,51,17,1,51,16,244,237,16,246,237,17,51,49,48,3,53,33,21,33,17,35,17,35,17,35,17,10,5,191,254,29,145,215,145,2,37,145,145,251,110,4,146,251,110,4,146,0,3,255,246,253,147,5,181,3,106,0,5,0,11,0,15,0,74,180,13,8,8,17,9,186,1,0,0,6,1,7,181,16,14,3,3,16,5,189,1,0,0,2,1,4,0,16,0,14,1,2,
179,15,251,9,3,184,1,2,181,6,4,253,11,1,254,0,63,51,63,51,237,50,63,237,1,16,246,237,17,51,17,51,16,244,237,17,51,17,51,49,48,1,35,17,33,53,33,51,33,21,33,17,35,1,21,33,53,2,106,145,254,29,2,116,215,2,116,254,29,145,2,116,250,65,253,147,3,222,145,145,252,34,5,215,145,145,0,0,0,0,2,255,246,1,113,5,181,7,72,0,7,0,11,0,58,64,9,7,11,11,13,0,8,8,12,5,189,1,0,0,2,1,6,0,12,0,8,1,2,181,9,253,3,250,5,0,184,1,2,177,1,251,0,63,237,51,63,63,237,1,16,244,237,17,51,17,51,17,51,17,51,49,48,3,53,33,17,51,17,33,21,
1,53,33,21,10,2,151,145,2,151,250,65,5,191,2,217,145,3,222,252,34,145,254,152,145,145,0,1,255,246,2,37,5,181,7,72,0,11,0,58,178,11,13,9,191,1,0,0,6,1,7,0,12,0,5,1,0,0,2,1,4,64,9,12,0,12,7,3,250,9,5,0,184,1,2,177,1,252,0,63,237,51,51,63,51,17,1,51,16,244,237,16,244,237,17,51,49,48,3,53,33,17,51,17,51,17,51,17,33,21,10,1,227,145,215,145,1,227,2,37,145,4,146,251,110,4,146,251,110,145,0,3,255,246,1,113,5,181,7,72,0,5,0,11,0,15,0,76,64,9,4,15,15,17,9,12,12,16,8,65,11,1,0,0,11,1,4,0,16,0,2,1,0,0,5,1,7,
0,16,0,12,1,2,179,13,253,5,9,184,1,2,181,2,10,251,0,6,250,0,63,51,63,51,237,50,63,237,1,16,244,237,16,244,237,17,51,17,51,17,51,17,51,49,48,1,51,17,33,21,33,1,51,17,33,53,33,1,53,33,21,3,65,145,1,227,253,140,254,152,145,253,140,1,227,254,29,5,191,7,72,252,34,145,4,111,251,145,145,254,7,145,145,0,0,0,1,255,246,253,147,5,181,7,72,0,19,0,76,182,11,15,15,21,13,9,16,184,1,0,178,6,2,19,184,1,6,64,11,20,4,0,0,20,18,254,7,250,12,4,184,1,2,180,9,5,251,16,0,184,1,2,178,13,1,253,0,63,51,237,50,63,51,237,50,
63,63,17,1,51,17,51,16,246,50,50,237,50,50,17,51,17,51,49,48,3,53,33,53,33,53,33,17,51,17,33,21,33,21,33,21,33,17,35,17,10,2,151,253,105,2,151,145,2,151,253,105,2,151,253,105,145,1,113,145,215,145,3,222,252,34,145,215,145,252,34,3,222,0,0,1,255,246,253,147,5,181,7,72,0,19,0,77,179,4,21,18,9,187,1,0,0,15,0,12,1,4,178,20,2,5,187,1,0,0,19,0,8,1,7,64,9,20,13,20,0,16,250,9,5,13,184,1,2,182,18,2,14,252,7,11,254,0,63,51,63,51,51,237,50,50,63,51,17,1,51,16,244,50,237,50,16,246,50,237,50,17,51,49,48,1,51,
17,33,21,33,17,35,17,35,17,35,17,33,53,33,17,51,17,51,3,65,145,1,227,254,29,145,215,145,254,29,1,227,145,215,7,72,251,110,145,251,110,4,146,251,110,4,146,145,4,146,251,110,0,0,0,0,4,255,246,253,147,5,181,7,72,0,5,0,11,0,17,0,23,0,93,181,4,14,14,25,2,15,187,1,0,0,5,0,12,1,7,182,24,21,9,9,24,20,11,187,1,0,0,23,0,8,1,4,178,24,5,21,184,1,2,183,2,22,251,0,18,250,15,9,184,1,2,181,12,10,253,17,7,254,0,63,51,63,51,237,50,63,51,63,51,237,50,1,16,246,50,237,50,17,51,17,51,16,244,50,237,50,17,51,17,51,49,48,
1,51,17,33,21,33,3,35,17,33,53,33,51,33,21,33,17,35,1,51,17,33,53,33,3,65,145,1,227,253,140,215,145,254,29,2,116,215,2,116,254,29,145,254,152,145,253,140,1,227,7,72,252,34,145,250,186,3,222,145,145,252,34,9,181,251,145,145,0,0,0,0,1,0,0,2,109,5,171,7,72,0,3,0,18,182,0,5,1,4,2,250,1,0,47,63,17,1,51,17,51,49,48,1,33,17,33,5,171,250,85,5,171,2,109,4,219,0,0,0,1,0,0,253,147,5,171,2,109,0,3,0,18,182,0,5,1,4,2,1,254,0,63,47,17,1,51,17,51,49,48,1,33,17,33,5,171,250,85,5,171,253,147,4,218,0,0,0,1,0,0,253,
147,5,171,7,72,0,3,0,19,183,0,5,1,4,2,250,1,254,0,63,63,17,1,51,17,51,49,48,1,33,17,33,5,171,250,85,5,171,253,147,9,181,0,0,1,0,0,253,147,2,214,7,72,0,3,0,17,182,1,4,0,2,250,1,254,0,63,63,1,47,17,51,49,48,1,33,17,33,2,214,253,42,2,214,253,147,9,181,0,0,0,0,1,2,213,253,147,5,171,7,72,0,3,0,17,182,0,5,1,2,250,1,254,0,63,63,1,47,17,51,49,48,1,33,17,33,5,171,253,42,2,214,253,147,9,181,0,0,0,0,42,0,103,253,245,5,171,6,163,0,3,0,7,0,11,0,15,0,19,0,23,0,27,0,31,0,35,0,39,0,43,0,47,0,51,0,55,0,59,0,63,0,
67,0,71,0,75,0,79,0,83,0,87,0,91,0,95,0,99,0,103,0,107,0,111,0,115,0,119,0,123,0,127,0,131,0,135,0,139,0,143,0,147,0,151,0,155,0,159,0,163,0,167,2,49,181,161,157,153,149,145,165,184,1,1,182,164,109,85,69,45,13,121,184,1,1,64,13,120,108,84,68,44,12,120,101,77,53,29,5,137,184,1,1,64,13,136,100,76,52,28,4,136,113,89,65,41,17,125,184,1,1,64,13,124,112,88,64,40,16,124,97,81,57,25,9,141,184,1,1,64,13,140,96,80,56,24,8,140,117,93,61,37,21,129,184,1,1,64,33,128,116,92,60,36,20,128,120,136,124,140,128,128,
140,124,136,120,5,132,160,156,152,148,144,164,164,169,105,73,49,33,1,133,184,1,1,64,15,104,72,48,32,0,10,132,1,8,3,132,167,143,139,135,184,1,3,180,132,163,103,99,107,184,1,3,183,104,160,100,96,104,95,91,87,184,1,3,183,84,92,88,84,159,83,79,75,184,1,3,183,72,156,80,76,72,67,63,71,184,1,3,183,68,64,60,68,155,59,55,51,184,1,3,183,48,152,56,52,48,43,39,47,184,1,3,183,44,40,36,44,151,31,27,35,184,1,3,183,32,148,28,24,32,23,19,15,184,1,3,183,12,20,16,12,147,11,7,3,184,1,3,183,0,144,8,4,0,131,127,123,184,
1,3,64,60,120,128,124,120,22,84,1,27,72,1,25,68,1,27,48,1,27,44,1,20,32,1,104,84,72,68,48,44,32,12,0,120,120,0,12,32,44,48,68,72,84,104,10,108,164,140,136,27,132,59,132,2,15,132,1,2,132,119,115,111,184,1,3,178,116,112,108,0,47,51,51,237,50,50,47,95,93,93,51,51,51,18,23,57,47,47,47,47,47,47,47,47,47,47,93,93,93,93,93,93,17,51,51,16,237,50,50,17,51,51,51,16,237,50,50,50,17,51,51,16,237,50,50,17,51,51,51,16,237,50,50,50,17,51,51,16,237,50,50,17,51,51,51,16,237,50,50,50,17,51,51,16,237,50,50,17,51,51,
51,16,237,50,50,50,17,51,51,16,237,50,50,17,51,51,51,16,237,50,50,50,16,237,50,50,50,1,47,95,94,93,51,51,51,51,51,237,50,50,50,50,50,17,51,47,51,51,51,51,51,18,23,57,47,47,47,47,47,17,51,51,51,51,51,16,237,50,50,50,50,50,17,51,51,51,51,51,16,237,50,50,50,50,50,17,51,51,51,51,51,16,237,50,50,50,50,50,17,51,51,51,51,51,16,237,50,50,50,50,50,17,51,51,51,51,51,16,237,50,50,50,50,50,16,237,50,50,50,50,50,49,48,19,51,21,35,37,51,21,35,37,51,21,35,5,51,21,35,37,51,21,35,37,51,21,35,7,51,21,35,37,51,21,35,
37,51,21,35,5,51,21,35,37,51,21,35,37,51,21,35,7,51,21,35,37,51,21,35,37,51,21,35,23,51,21,35,37,51,21,35,37,51,21,35,7,51,21,35,37,51,21,35,37,51,21,35,5,51,21,35,37,51,21,35,37,51,21,35,7,51,21,35,37,51,21,35,37,51,21,35,23,51,21,35,37,51,21,35,37,51,21,35,1,51,21,35,37,51,21,35,37,51,21,35,1,51,21,35,37,51,21,35,37,51,21,35,1,51,21,35,17,51,21,35,17,51,21,35,17,51,21,35,17,51,21,35,17,51,21,35,103,104,104,1,158,104,104,1,160,103,103,253,145,104,104,1,159,104,104,1,159,104,104,207,103,103,254,96,
104,104,254,98,104,104,4,13,104,104,254,97,104,104,254,97,104,104,207,104,104,1,158,104,104,1,160,103,103,207,104,104,254,97,104,104,254,97,104,104,207,104,104,1,158,104,104,1,160,103,103,253,145,104,104,1,159,104,104,1,159,104,104,207,103,103,254,96,104,104,254,98,104,104,207,104,104,1,159,104,104,1,159,104,104,252,194,104,104,1,159,104,104,1,159,104,104,251,243,104,104,1,158,104,104,1,160,103,103,1,158,104,104,104,104,104,104,104,104,104,104,104,104,5,34,98,98,98,98,98,97,96,96,96,96,96,96,96,96,
96,96,96,99,96,96,96,96,96,96,96,96,96,96,96,99,96,96,96,96,96,96,97,97,97,97,97,98,94,94,94,94,94,98,97,97,97,97,97,96,96,96,96,96,96,7,237,98,98,98,98,98,1,35,96,96,96,96,96,254,223,98,254,223,96,254,221,96,254,221,97,254,222,97,7,238,96,0,0,0,0,84,0,0,253,245,5,171,6,163,0,3,0,7,0,11,0,15,0,19,0,23,0,27,0,31,0,35,0,39,0,43,0,47,0,51,0,55,0,59,0,63,0,67,0,71,0,75,0,79,0,83,0,87,0,91,0,95,0,99,0,103,0,107,0,111,0,115,0,119,0,123,0,127,0,131,0,135,0,139,0,143,0,147,0,151,0,155,0,159,0,163,0,167,0,
171,0,175,0,179,0,183,0,187,0,191,0,195,0,199,0,203,0,207,0,211,0,215,0,219,0,223,0,227,0,231,0,235,0,239,0,243,0,247,0,251,0,255,1,3,1,7,1,11,1,15,1,19,1,23,1,27,1,31,1,35,1,39,1,43,1,47,1,51,1,55,1,59,1,63,1,67,1,71,1,75,1,79,0,0,19,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,5,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,5,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,5,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,
35,55,51,21,35,5,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,5,51,21,35,37,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,37,51,21,35,5,51,21,35,39,51,21,35,39,51,21,35,39,51,21,35,39,51,21,35,39,51,21,35,7,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,23,51,21,35,39,51,21,35,39,51,21,35,39,51,21,35,39,51,21,35,39,51,21,35,7,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,1,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,
55,51,21,35,1,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,55,51,21,35,19,51,21,35,7,51,21,35,23,51,21,35,7,51,21,35,23,51,21,35,7,51,21,35,23,51,21,35,7,51,21,35,23,51,21,35,7,51,21,35,17,51,21,35,19,51,21,35,103,104,104,207,104,104,207,104,104,208,104,104,208,104,104,207,104,104,251,140,103,103,207,103,103,207,103,103,207,104,104,208,104,104,208,103,103,252,90,104,104,207,104,104,207,104,104,208,104,104,208,104,104,207,104,104,251,140,103,103,207,103,103,207,103,103,207,104,104,208,
104,104,208,103,103,252,90,104,104,207,104,104,207,104,104,208,104,104,208,104,104,207,104,104,251,140,103,103,1,158,103,103,207,104,104,208,104,104,208,103,103,252,194,103,103,3,165,104,104,207,104,104,208,104,104,208,104,104,207,104,104,207,104,104,103,103,103,207,103,103,207,103,103,207,104,104,208,104,104,208,103,103,103,104,104,207,104,104,208,104,104,208,104,104,207,104,104,207,104,104,103,103,103,207,103,103,207,103,103,207,104,104,208,104,104,208,103,103,251,243,103,103,207,103,103,207,103,
103,207,104,104,208,104,104,208,103,103,252,90,104,104,207,104,104,207,104,104,208,104,104,208,104,104,207,104,104,207,104,104,103,103,103,103,104,104,103,103,103,103,104,104,103,103,103,103,104,104,103,103,103,103,104,104,103,103,103,103,103,103,104,104,5,34,98,98,98,98,98,98,98,98,98,98,98,97,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,99,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,96,99,96,96,96,96,96,96,96,96,96,96,96,96,97,97,97,97,97,97,97,97,97,
97,97,98,94,94,94,94,94,94,94,94,94,94,94,98,97,97,97,97,97,97,97,97,97,97,97,96,96,96,96,96,96,96,96,96,96,96,96,7,237,98,98,98,98,98,98,98,98,98,98,98,1,35,96,96,96,96,96,96,96,96,96,96,96,254,223,98,97,96,96,96,99,96,96,96,99,96,96,97,98,94,98,97,96,96,7,237,98,1,35,96,0,0,67,0,0,253,147,5,213,6,163,0,73,0,77,0,81,0,85,0,89,0,93,0,97,0,101,0,105,0,109,0,113,0,117,0,121,0,125,0,129,0,133,0,137,0,141,0,145,0,149,0,153,0,157,0,161,0,165,0,169,0,173,0,177,0,181,0,185,0,189,0,193,0,197,0,201,0,205,
0,209,0,213,0,217,0,221,0,225,0,229,0,233,0,237,0,241,0,245,0,249,0,253,1,1,1,5,1,9,1,13,1,17,1,21,1,25,1,29,1,33,1,37,1,41,1,45,1,49,1,53,1,57,1,61,1,65,1,69,1,73,1,77,1,81,0,0,1,33,17,51,53,35,17,51,53,35,17,51,53,35,17,51,53,35,17,51,53,35,17,51,53,51,21,51,53,51,21,51,53,51,21,51,53,51,21,51,53,51,21,51,53,51,21,51,53,51,21,35,21,51,17,35,21,51,17,35,21,51,17,35,21,51,17,35,21,51,17,35,21,51,1,21,51,53,51,21,51,53,51,21,51,53,51,21,51,53,23,35,21,51,39,35,21,51,39,35,21,51,39,35,21,51,7,21,51,
53,51,21,51,53,51,21,51,53,51,21,51,53,5,35,21,51,55,21,51,53,51,21,51,53,51,21,51,53,5,21,51,53,33,21,51,53,7,53,35,21,37,21,51,53,19,53,35,21,35,53,35,21,35,53,35,21,35,53,35,21,7,21,51,53,51,21,51,53,51,21,51,53,51,21,51,53,19,53,35,21,35,53,35,21,35,53,35,21,35,53,35,21,7,21,51,53,51,21,51,53,51,21,51,53,51,21,51,53,19,35,21,51,39,35,21,51,39,35,21,51,39,35,21,51,1,35,21,51,39,35,21,51,39,35,21,51,39,35,21,51,1,21,51,53,51,21,51,53,23,35,21,51,39,35,21,51,7,21,51,53,51,21,51,53,7,35,21,51,55,
21,51,53,5,21,51,53,23,53,35,21,23,53,35,21,35,53,35,21,7,21,51,53,51,21,51,53,19,53,35,21,35,53,35,21,7,21,51,53,51,21,51,53,19,35,21,51,39,35,21,51,19,35,21,51,39,35,21,51,5,213,250,43,106,106,106,106,106,106,106,106,106,106,106,107,106,107,106,107,107,107,107,107,106,107,106,107,107,107,107,107,107,107,107,107,107,107,107,107,250,149,107,106,107,106,107,107,107,107,107,107,214,107,107,214,106,106,213,106,106,213,107,106,107,106,107,107,107,253,234,106,106,107,106,107,107,107,107,252,170,107,1,
63,107,213,107,1,171,107,107,107,107,107,107,106,107,106,107,107,106,107,106,107,107,107,107,107,107,107,107,106,107,106,107,107,106,107,106,107,107,107,107,107,107,214,107,107,214,106,106,213,106,106,2,22,107,107,214,107,107,213,107,107,213,107,107,2,235,107,106,107,106,106,106,213,106,106,213,107,106,107,107,106,106,107,106,254,86,107,213,107,213,106,107,106,107,107,106,107,106,106,107,106,107,107,106,107,106,106,106,213,106,106,107,107,107,213,107,107,253,147,1,34,97,1,34,97,1,35,96,1,33,98,1,
33,98,1,33,96,96,96,96,96,96,96,96,96,96,96,96,96,193,98,254,223,96,254,221,96,254,221,96,254,221,94,254,221,96,6,106,96,96,96,96,96,96,96,96,192,98,98,98,98,98,98,98,97,96,96,96,96,96,96,96,96,192,96,96,96,96,96,96,96,96,195,96,96,96,96,96,96,96,96,96,96,254,223,97,97,97,97,97,97,97,97,98,94,94,94,94,94,94,94,94,254,223,97,97,97,97,97,97,97,97,96,96,96,96,96,96,96,96,96,6,205,98,98,98,98,98,98,98,1,34,98,98,98,98,98,98,98,254,223,96,96,96,96,192,98,98,98,97,96,96,96,96,192,96,96,96,96,195,96,96,
96,96,96,193,97,97,97,97,98,94,94,94,94,254,223,97,97,97,97,96,96,96,96,96,6,205,98,98,98,1,34,98,98,98,0,0,0,0,1,0,123,0,117,4,90,4,84,0,3,0,0,19,33,17,33,123,3,223,252,33,4,84,252,33,0,0,2,0,6,0,0,4,207,4,201,0,3,0,7,0,21,183,7,1,4,0,4,0,5,3,0,47,205,221,205,1,47,205,221,205,49,48,19,33,17,33,19,17,33,17,6,4,201,251,55,76,4,49,4,201,251,55,4,125,251,207,4,49,0,0,1,0,109,1,127,2,105,3,123,0,3,0,26,64,13,3,48,2,1,15,2,31,2,2,8,2,1,2,0,47,205,1,47,94,93,93,205,49,48,1,33,17,33,2,105,254,4,1,252,1,
127,1,252,0,0,0,2,0,109,1,127,2,105,3,123,0,3,0,7,0,34,64,17,5,3,6,48,2,1,15,2,31,2,2,8,2,7,1,6,2,0,47,205,221,205,1,47,94,93,93,205,221,205,49,48,1,33,17,33,3,17,33,17,2,105,254,4,1,252,76,254,156,1,127,1,252,254,80,1,98,254,158,0,0,0,0,1,0,0,0,0,8,0,2,104,0,3,0,0,17,33,17,33,8,0,248,0,2,104,253,152,0,0,0,1,1,158,0,0,6,76,4,174,0,2,0,0,33,9,1,1,158,2,88,2,86,4,174,251,82,0,0,1,1,145,255,229,6,90,4,172,0,2,0,0,9,2,1,145,4,201,251,55,4,172,253,158,253,155,0,1,1,158,255,229,6,76,4,147,0,2,0,0,9,2,6,
76,253,170,253,168,4,147,251,82,4,174,0,1,1,145,255,229,6,90,4,172,0,2,0,0,1,17,1,6,90,251,55,4,172,251,57,2,101,0,0,2,0,3,0,0,3,244,5,166,0,5,0,9,0,92,181,8,32,9,0,77,6,184,255,224,64,16,9,0,77,1,0,8,4,3,6,8,6,8,6,2,9,5,184,255,192,64,22,9,13,72,5,11,7,31,2,1,2,2,5,9,3,7,7,1,6,3,7,8,1,0,47,51,63,51,18,57,61,47,23,51,1,24,47,93,51,16,196,43,50,17,57,57,61,47,47,17,51,51,17,51,51,49,48,0,43,43,33,35,9,1,51,9,4,2,46,104,254,61,1,195,104,1,198,254,7,254,223,1,33,1,33,2,209,2,213,253,45,1,225,254,31,
254,18,1,238,0,0,2,0,167,0,162,4,46,4,41,0,19,0,39,0,46,64,28,68,37,84,37,2,75,33,91,33,2,75,27,91,27,2,68,23,84,23,2,30,10,20,0,25,15,35,5,0,47,205,220,205,1,47,205,220,205,49,48,93,93,93,93,19,52,62,2,51,50,30,2,21,20,14,2,35,34,46,2,55,20,30,2,51,50,62,2,53,52,46,2,35,34,14,2,167,70,122,164,94,94,165,123,71,71,123,165,94,94,164,122,70,86,57,98,133,76,76,134,99,58,58,99,134,76,76,133,98,57,2,100,94,165,123,71,71,123,165,94,94,164,122,70,70,122,164,94,76,132,99,57,57,99,132,76,76,134,99,58,58,99,
134,0,0,0,0,1,0,178,0,137,4,35,3,250,0,23,0,17,182,8,16,12,15,0,1,0,0,47,93,205,1,47,205,49,48,1,50,23,30,1,23,30,1,21,20,7,6,35,34,39,38,53,52,54,55,62,1,55,54,2,106,110,107,53,82,29,29,31,129,129,183,182,129,129,30,29,29,83,52,108,3,250,57,28,82,52,54,110,57,183,129,129,129,129,183,58,109,54,52,82,28,57,0,0,0,2,0,41,0,0,4,172,4,131,0,3,0,23,0,21,183,14,2,4,1,19,1,9,0,0,47,205,221,205,1,47,205,221,205,49,48,51,17,33,17,1,20,30,2,51,50,62,2,53,52,46,2,35,34,14,2,41,4,131,252,4,69,120,160,91,91,161,
120,69,69,120,161,91,91,160,120,69,4,131,251,125,2,65,91,160,120,69,69,120,160,91,91,161,120,69,69,120,161,0,0,3,0,41,0,0,4,172,4,131,0,3,0,23,0,43,0,34,64,14,4,24,1,14,34,2,1,19,29,0,9,39,1,0,0,47,221,221,206,16,221,206,1,47,221,221,206,16,221,206,49,48,51,17,33,17,1,52,62,2,51,50,30,2,21,20,14,2,35,34,46,2,39,20,30,2,51,50,62,2,53,52,46,2,35,34,14,2,41,4,131,252,81,58,99,133,75,75,133,99,58,58,99,133,75,75,133,99,58,77,69,120,160,91,91,161,120,69,69,120,161,91,91,160,120,69,4,131,251,125,2,65,75,
133,99,58,58,99,133,75,75,133,99,58,58,99,133,75,91,160,120,69,69,120,160,91,91,161,120,69,69,120,161,0,0,2,0,115,1,133,2,99,3,117,0,18,0,34,0,21,183,19,0,27,11,31,6,23,15,0,47,205,220,205,1,47,205,220,205,49,48,1,20,6,7,14,1,35,34,39,46,1,53,52,55,54,51,50,23,22,7,52,39,38,35,34,7,6,21,20,23,22,51,50,55,54,2,99,37,37,37,86,51,101,75,35,37,72,74,102,103,71,74,76,51,51,70,70,51,51,51,49,72,72,49,51,2,125,53,86,37,35,37,72,37,86,53,102,72,74,74,71,103,70,51,51,51,51,70,69,54,49,49,54,0,0,0,5,1,177,
255,229,6,121,4,172,0,17,0,33,0,45,0,57,0,68,0,147,64,93,20,32,36,32,116,32,3,20,28,36,28,116,28,3,27,24,43,24,123,24,3,27,20,43,20,123,20,3,68,34,40,63,52,46,40,46,40,46,8,18,31,0,1,0,26,8,49,37,43,55,43,62,58,104,58,1,89,58,1,71,58,1,25,58,1,58,60,65,15,43,95,43,111,43,3,8,65,64,9,14,72,43,65,43,65,4,22,15,13,1,13,30,4,0,47,205,220,93,205,18,57,57,47,47,43,94,93,16,205,51,93,93,93,93,17,51,17,51,16,205,50,1,47,205,220,93,205,18,57,57,47,47,16,205,51,16,205,51,49,48,0,93,93,93,93,1,20,7,6,35,34,
39,38,53,52,54,55,54,51,50,23,30,1,7,52,39,38,35,34,7,6,21,20,23,22,51,50,55,54,1,20,6,35,34,38,53,52,54,51,50,22,5,20,6,35,34,38,53,52,54,51,50,22,1,22,51,50,55,23,6,35,34,38,39,6,121,180,179,253,253,179,180,90,90,178,254,254,178,90,90,90,153,151,218,218,151,153,153,152,217,217,152,153,253,90,46,32,32,45,45,32,32,46,1,211,44,32,32,47,47,32,32,44,253,234,76,147,145,76,62,98,185,94,141,48,2,72,254,178,179,179,178,254,128,215,91,178,178,91,215,128,217,153,154,154,153,217,216,153,154,154,153,1,87,32,
46,46,32,32,45,45,32,32,46,46,32,32,45,45,254,191,137,137,35,186,95,91,0,0,4,1,209,255,229,6,153,4,172,0,17,0,29,0,41,0,52,0,96,64,55,42,18,24,47,36,30,24,30,24,30,0,8,39,27,21,33,21,48,52,104,52,1,89,52,1,75,52,1,61,52,1,52,50,45,15,21,31,21,95,21,111,21,4,8,79,45,95,45,2,21,45,21,45,13,4,0,47,204,57,57,47,47,93,94,93,16,206,51,93,93,93,93,17,51,17,51,16,206,50,1,47,205,57,57,47,47,16,206,51,16,206,51,49,48,1,20,7,6,35,34,39,38,53,52,54,55,54,51,50,23,30,1,5,52,38,35,34,6,21,20,22,51,50,54,37,52,
38,35,34,6,21,20,22,51,50,54,1,30,1,51,50,55,39,6,35,34,39,6,153,180,179,253,253,179,180,90,90,178,254,254,178,90,90,253,0,46,32,32,45,45,32,32,46,1,211,44,32,32,47,47,32,32,44,253,174,48,141,94,185,98,62,76,145,147,76,2,72,254,178,179,179,178,254,128,215,91,178,178,91,215,1,32,45,45,32,32,46,46,32,32,45,45,32,32,46,46,254,220,91,95,186,35,137,137,0,2,1,70,255,115,6,14,4,59,0,51,0,70,0,139,185,0,47,255,240,64,13,11,14,72,52,46,1,52,36,1,119,35,1,35,184,255,240,64,77,11,14,72,21,16,11,14,72,59,20,
1,59,9,1,8,16,11,14,72,59,47,1,52,35,1,52,21,1,59,8,1,66,143,13,223,13,2,112,13,1,63,13,1,32,13,1,13,57,43,62,128,31,208,31,224,31,3,127,31,1,48,31,1,47,31,1,31,52,15,51,63,51,79,51,3,8,51,0,47,94,93,205,220,93,93,93,93,205,1,47,205,220,93,93,93,93,205,49,48,0,93,93,93,93,1,43,93,93,43,43,93,93,93,43,1,51,21,30,3,23,55,23,7,30,1,23,51,21,35,14,1,7,23,7,39,14,1,7,14,1,7,21,35,53,46,1,39,7,39,55,46,1,39,35,53,51,54,55,39,55,23,62,1,55,23,34,6,7,6,21,20,23,30,1,51,50,55,54,53,52,39,46,1,3,137,66,32,
57,54,53,29,186,45,184,45,44,3,215,215,8,44,40,184,49,182,31,55,23,24,58,34,66,63,110,48,188,43,182,40,46,8,215,215,12,80,180,40,189,57,112,54,31,69,117,48,98,98,48,117,69,139,96,99,99,49,117,4,59,217,3,12,21,32,22,182,45,184,59,113,57,62,60,110,51,188,43,182,23,32,11,9,12,5,217,217,9,46,35,180,45,184,51,111,63,62,128,95,184,49,182,40,44,6,61,50,48,100,136,137,98,50,47,97,97,138,137,99,48,50,0,0,0,2,1,218,0,80,4,38,4,129,0,28,0,47,0,98,64,62,22,18,25,0,0,5,15,43,1,239,43,255,43,2,43,15,14,1,14,0,
34,1,224,34,240,34,2,34,5,22,25,19,0,28,16,28,80,28,3,28,0,39,1,240,39,1,39,18,0,0,128,0,2,8,0,29,64,37,40,72,29,10,0,47,205,43,220,94,93,50,205,113,114,47,93,51,205,50,1,47,205,113,114,220,93,205,113,114,17,57,47,51,205,50,49,48,1,46,1,39,38,53,52,55,62,1,51,50,23,22,21,20,7,6,7,21,33,21,33,17,35,17,33,53,33,19,34,7,14,1,21,20,22,23,22,51,50,55,54,53,52,38,39,38,2,220,55,90,35,71,83,44,101,60,118,83,86,72,72,106,1,0,255,0,74,254,254,1,2,35,83,62,29,31,31,29,62,83,87,59,61,30,29,62,2,66,8,46,42,80,
108,122,83,43,43,86,83,122,109,81,82,12,166,70,254,250,1,6,70,2,145,59,31,71,44,43,71,31,62,62,61,84,44,71,31,59,0,2,1,81,0,250,4,175,4,129,0,65,0,81,0,70,64,40,49,65,59,15,78,1,78,63,32,1,32,15,51,1,51,0,70,1,70,59,65,49,63,74,0,55,128,55,2,55,66,144,20,1,20,15,63,1,8,63,0,47,94,93,204,93,205,220,93,205,18,57,57,1,47,205,114,220,93,204,93,205,114,18,57,57,49,48,1,46,1,39,46,1,39,46,1,53,52,55,62,1,51,50,22,23,30,1,51,50,54,55,54,51,50,21,20,7,14,1,21,20,22,23,30,1,21,20,6,7,6,35,34,39,46,1,39,7,
22,21,20,7,6,35,34,39,38,53,52,55,54,51,50,23,7,34,7,6,21,20,23,22,51,50,55,54,53,52,39,38,3,255,17,54,37,28,40,14,5,3,6,3,6,5,5,15,13,32,63,32,46,64,19,36,13,16,6,9,7,4,8,2,2,2,2,9,5,21,20,22,31,11,237,84,86,87,118,118,87,84,84,85,122,71,83,154,90,62,61,61,64,88,89,60,62,62,60,4,0,5,18,14,11,24,14,3,10,5,8,9,2,2,2,2,8,9,7,6,12,14,9,18,34,79,45,31,64,34,11,16,5,5,7,3,6,39,42,82,42,238,81,109,125,86,88,84,84,117,117,87,86,43,32,62,61,88,91,61,61,61,62,90,87,62,62,0,0,1,0,59,0,0,4,5,4,207,0,47,0,40,
64,25,38,32,10,48,10,96,10,112,10,4,10,14,34,64,8,11,72,34,23,79,0,95,0,2,0,0,47,93,47,47,43,51,1,47,93,47,49,48,1,30,1,23,30,1,23,22,23,22,21,20,7,6,35,34,39,22,23,30,1,31,1,33,55,50,55,62,3,39,14,1,35,34,39,38,53,52,55,62,1,55,62,1,55,54,2,32,14,40,26,28,95,69,141,35,37,63,66,88,157,99,3,36,38,163,137,8,252,232,6,125,86,43,66,44,20,1,45,132,83,90,66,63,30,23,78,57,69,110,38,56,4,207,54,95,44,43,105,63,126,66,67,70,95,63,66,191,147,87,86,99,9,37,37,49,25,69,91,119,75,96,95,66,63,91,74,59,42,85,47,
59,113,57,83,0,0,0,0,1,0,60,0,0,5,4,4,199,0,75,0,47,64,24,57,77,63,23,1,23,52,61,67,13,47,30,4,18,31,18,1,27,18,27,18,1,41,1,0,47,47,18,57,57,47,47,93,18,23,57,50,51,1,47,93,16,206,49,48,41,1,55,62,1,55,62,1,55,54,53,52,38,53,6,7,14,1,35,34,38,39,38,53,52,55,54,51,50,22,23,46,1,39,46,1,53,52,55,62,1,51,50,23,22,21,20,7,54,55,62,1,51,50,22,23,22,21,20,7,6,35,34,38,39,46,1,39,30,1,23,30,1,23,22,23,4,70,252,182,8,84,108,27,41,64,26,52,2,58,90,43,88,45,59,97,41,79,73,73,93,31,80,51,20,27,8,5,6,78,40,
97,60,116,80,80,69,84,16,14,30,17,51,86,36,73,80,80,112,62,132,50,17,43,26,3,23,23,22,67,46,61,159,35,17,33,17,25,75,50,100,109,8,22,17,121,59,28,30,42,38,83,116,115,79,80,25,26,34,52,19,17,38,20,115,78,38,40,80,78,109,86,98,40,3,5,3,37,41,76,116,118,83,80,60,51,19,61,45,81,125,46,45,76,31,39,30,0,1,0,102,255,233,4,90,4,121,0,39,0,38,64,23,18,2,1,4,2,1,8,29,41,16,12,64,12,80,12,112,12,128,12,5,12,16,0,0,47,47,1,47,93,16,206,49,48,94,93,93,5,46,1,39,46,1,39,46,1,39,46,1,53,52,55,54,51,50,23,30,1,23,
62,1,51,50,22,23,22,21,20,7,14,1,7,14,1,7,14,1,2,98,14,42,26,28,103,76,56,69,14,43,37,68,70,102,98,78,28,47,17,34,142,88,50,85,35,70,41,20,78,60,75,108,32,31,44,23,56,101,48,50,147,102,76,93,22,65,106,56,103,71,70,72,28,80,54,119,117,36,34,70,94,86,88,45,119,75,96,152,55,54,110,0,0,0,0,1,0,66,255,231,3,210,4,199,0,26,0,18,183,48,12,1,12,75,21,1,21,0,25,47,93,1,47,93,49,48,1,30,1,23,30,1,23,14,1,7,14,1,7,46,1,39,46,1,39,46,1,39,62,1,55,62,1,2,7,45,113,69,69,116,47,39,120,83,69,106,40,13,35,22,38,98,
60,14,94,81,50,128,80,59,96,4,199,78,165,93,93,141,53,40,150,111,93,159,72,25,58,32,57,135,80,20,119,99,59,160,107,77,148,0,0,1,0,196,0,29,3,59,4,129,0,33,0,48,64,25,2,19,33,13,64,79,6,95,6,111,6,3,6,128,27,33,18,10,10,47,0,1,0,31,24,0,47,205,204,93,57,47,57,1,47,205,26,220,93,26,205,16,205,50,49,48,1,51,21,23,30,1,21,20,6,7,35,62,1,53,52,38,39,38,39,17,20,6,7,6,35,34,38,53,52,55,54,51,50,23,1,233,76,153,51,58,48,46,47,29,28,28,29,57,64,37,37,72,108,57,58,60,63,80,44,46,4,129,100,193,69,163,85,78,
134,59,65,124,59,60,99,40,81,9,254,6,63,98,38,75,54,46,73,60,60,19,0,2,1,16,255,213,4,239,4,135,0,34,0,38,0,108,64,61,35,32,64,18,26,128,36,15,64,111,0,1,0,128,15,9,1,9,9,0,26,1,26,17,35,86,35,1,67,35,1,35,16,36,54,36,1,37,36,1,20,36,1,3,36,1,8,36,34,38,33,88,33,1,33,37,34,30,23,13,6,0,47,205,47,205,47,51,51,93,17,51,17,51,94,93,93,93,93,17,51,51,93,93,17,51,1,47,93,51,47,93,26,221,93,26,205,50,26,16,221,26,205,51,49,48,1,20,6,7,14,1,35,34,38,53,52,55,54,51,50,23,17,5,17,20,6,7,6,35,34,38,53,52,55,
54,51,50,23,17,37,1,37,53,5,4,239,36,38,37,88,51,57,57,57,62,81,48,42,253,218,37,35,74,106,57,58,59,60,84,45,45,2,186,253,144,2,38,253,218,1,68,63,101,35,37,39,54,47,76,57,59,18,1,192,149,254,118,62,98,38,74,53,45,76,57,60,19,2,240,178,254,103,149,117,152,0,0,0,3,0,35,0,0,4,82,5,204,0,3,0,7,0,35,0,112,185,0,18,255,224,64,39,9,10,0,76,0,4,70,3,223,7,1,7,37,240,37,1,47,37,63,37,2,35,35,95,23,1,23,23,33,9,70,10,12,14,12,48,10,1,10,184,255,192,64,22,16,19,72,10,27,81,20,0,8,12,79,33,5,13,15,10,4,21,0,
83,1,0,0,63,237,63,51,63,51,51,237,50,63,237,1,47,43,113,51,51,47,16,237,50,50,47,93,51,47,93,93,16,222,93,50,237,50,49,48,0,43,1,53,33,21,1,17,33,17,1,17,33,17,35,53,51,53,52,62,2,51,50,22,23,21,46,1,35,34,14,2,29,1,51,21,3,57,1,25,254,231,1,25,253,135,254,232,158,158,30,72,122,91,48,93,37,18,45,19,39,51,29,12,213,4,253,207,207,251,3,4,58,251,198,3,124,252,132,3,124,190,113,62,105,78,44,10,6,181,4,5,16,32,49,32,85,190,0,0,0,2,0,35,0,0,4,82,5,204,0,3,0,31,0,103,185,0,14,255,224,64,37,9,10,0,76,0,
70,223,3,1,3,33,240,33,1,47,33,63,33,2,31,31,95,19,1,19,19,29,5,70,6,8,10,8,48,6,1,6,184,255,192,64,19,16,19,72,6,23,81,16,0,4,8,79,29,9,15,1,0,6,0,21,0,63,50,63,63,51,237,50,63,237,1,47,43,113,51,51,47,16,237,50,50,47,93,51,47,93,93,16,222,93,237,49,48,0,43,33,17,33,17,1,17,33,17,35,53,51,53,52,62,2,51,50,22,23,21,46,1,35,34,14,2,29,1,51,21,3,58,1,24,253,135,254,232,158,158,30,72,122,91,48,93,37,18,45,19,39,51,29,12,213,5,204,250,52,3,124,252,132,3,124,190,113,62,105,78,44,10,6,181,4,5,16,32,49,
32,85,190,0,0,0,0,1,0,140,254,87,2,32,255,198,0,25,0,68,185,0,25,255,216,179,10,0,77,2,184,255,232,64,34,10,0,77,14,136,16,0,1,0,19,64,9,0,77,19,0,7,16,7,2,7,16,146,15,23,1,255,23,1,23,11,146,5,27,0,63,237,47,93,113,237,1,47,93,196,43,47,93,237,49,48,43,43,5,20,14,2,35,34,39,53,30,1,51,50,54,53,52,35,42,1,7,55,62,1,51,50,22,2,32,31,71,116,85,45,56,25,42,17,75,62,113,13,24,14,38,20,57,35,91,106,231,44,71,51,28,6,118,5,2,37,32,69,2,109,2,3,92,0,0,1,0,141,2,19,1,173,3,68,0,3,0,34,64,21,3,150,95,0,127,
0,2,143,0,191,0,207,0,3,0,1,155,15,0,1,0,0,47,93,237,1,47,93,113,237,49,48,19,17,33,17,141,1,32,2,19,1,49,254,207,0,0,0,0,1,0,103,254,57,1,92,255,178,0,12,0,39,64,14,9,9,47,12,63,12,2,12,6,11,10,10,6,11,184,255,192,179,9,12,72,11,0,47,43,196,57,47,1,47,196,205,93,57,47,49,48,5,20,14,2,7,35,62,1,53,35,53,51,1,92,14,26,34,20,137,45,49,108,245,204,44,71,61,51,24,48,84,38,207,0,0,0,2,0,35,2,182,2,153,5,134,0,10,0,23,0,84,64,51,17,47,5,63,5,2,111,5,127,5,2,5,64,21,24,72,5,5,19,10,1,10,8,1,224,18,6,64,
2,80,2,96,2,3,2,2,24,25,0,4,229,8,5,17,17,1,11,6,220,1,221,0,63,63,51,18,57,47,51,51,237,50,17,18,1,57,47,113,51,51,237,50,50,93,51,47,43,93,113,51,49,48,1,21,35,53,33,53,1,51,17,51,21,1,14,3,15,1,51,53,52,62,2,2,50,183,254,168,1,60,211,103,254,230,3,17,21,20,4,141,202,1,1,2,3,66,140,140,148,1,176,254,72,140,1,186,4,31,36,31,6,194,194,8,28,32,30,0,0,0,0,1,0,53,2,172,2,128,5,129,0,38,0,113,185,0,2,255,216,180,9,10,0,76,37,184,255,216,64,60,9,10,0,76,30,31,27,25,31,3,26,29,26,29,10,19,225,15,0,31,0,
2,0,40,11,225,10,159,26,175,26,2,26,26,22,228,239,34,255,34,2,34,34,16,30,229,27,220,16,228,5,96,11,112,11,2,11,11,5,223,0,63,51,47,93,16,237,63,237,18,57,47,93,237,51,47,93,1,47,237,16,222,93,237,18,57,57,47,47,23,51,17,51,49,48,43,43,1,20,14,2,35,34,46,2,39,55,30,3,51,50,54,53,52,38,35,34,6,7,35,19,33,21,33,7,62,1,51,50,30,2,2,128,39,76,112,74,68,101,70,40,7,190,3,14,24,36,25,49,58,52,52,34,51,14,178,29,1,239,254,175,10,23,79,46,57,91,63,33,3,171,55,94,68,38,32,56,73,42,12,17,32,24,15,64,60,53,
62,27,19,1,149,138,136,19,27,35,64,89,0,0,0,0,1,0,43,2,182,2,112,5,129,0,14,0,44,64,24,5,225,6,6,12,11,15,0,31,0,2,0,16,239,12,1,12,0,12,229,13,220,5,221,0,63,63,237,50,1,47,93,16,206,93,50,17,57,47,237,49,48,1,14,3,21,35,52,62,2,55,33,53,33,2,112,64,95,62,31,193,40,73,101,60,254,102,2,67,5,1,79,137,136,146,89,83,147,139,136,72,138,0,0,0,3,0,45,2,172,2,121,5,144,0,37,0,53,0,71,0,94,182,8,24,9,10,0,76,2,184,255,232,64,46,9,10,0,76,16,19,54,32,64,38,225,27,44,225,19,27,19,27,10,54,225,15,0,31,0,2,0,
73,64,224,10,32,16,59,228,49,49,67,41,228,22,222,67,228,5,223,0,63,237,63,237,18,57,47,237,57,57,1,47,237,16,222,93,237,18,57,57,47,47,237,16,237,18,57,17,18,57,49,48,43,43,1,20,14,2,35,34,46,2,53,52,62,2,55,53,46,1,53,52,54,51,50,30,2,21,20,14,2,7,21,30,3,3,52,38,35,34,6,21,20,30,2,51,50,62,2,19,52,46,2,35,34,14,2,21,20,22,51,50,62,2,2,121,35,72,111,76,76,111,72,35,25,42,53,28,60,69,139,134,72,104,68,33,18,34,48,31,32,55,40,23,206,37,51,50,38,7,19,35,27,29,35,18,6,17,9,25,42,33,30,40,25,10,47,62,
31,41,24,9,3,129,46,79,56,32,32,57,77,46,39,61,43,27,4,2,14,90,58,86,104,28,50,71,42,28,53,43,30,6,2,5,27,43,61,1,25,36,47,47,36,16,31,25,15,16,25,31,254,223,18,33,26,15,15,26,34,18,45,55,15,26,38,0,0,0,0,1,255,189,4,160,2,235,5,244,0,21,0,98,185,0,19,255,232,64,32,9,10,0,76,3,24,9,10,0,76,14,0,15,1,16,15,64,15,112,15,144,15,160,15,192,15,208,15,240,15,8,15,184,255,192,64,34,27,60,72,15,8,7,64,16,60,72,7,14,7,11,147,15,0,1,15,0,47,0,63,0,95,0,127,0,159,0,239,0,7,0,0,47,93,113,237,205,50,1,47,43,205,
47,43,93,113,205,49,48,43,43,1,34,46,4,39,51,30,1,51,50,54,55,51,14,5,1,84,82,124,89,59,35,16,2,224,5,94,84,84,94,5,224,2,16,35,59,89,124,4,160,26,47,65,75,84,43,103,96,96,103,43,84,75,65,47,26,0,1,0,113,3,244,1,102,5,129,0,12,0,35,64,19,9,9,12,6,11,111,10,127,10,143,10,3,10,144,6,1,6,11,3,0,63,196,93,205,93,1,47,196,205,57,47,49,48,1,20,14,2,7,35,62,1,53,35,53,51,1,102,14,26,34,20,137,45,49,108,245,4,239,43,72,61,51,24,48,96,46,207,0,0,1,0,103,4,188,1,92,6,73,0,10,0,30,64,14,7,4,64,9,1,9,10,8,8,
64,4,1,4,9,0,47,204,93,57,47,1,47,205,93,50,57,49,48,19,52,54,55,51,14,1,21,51,21,35,103,44,40,147,45,49,108,245,5,78,87,117,47,48,96,46,207,0,1,0,87,5,250,2,84,7,23,0,5,0,32,64,18,0,131,5,132,3,130,2,3,143,95,0,1,0,64,9,12,72,0,0,47,43,93,237,1,47,237,253,237,49,48,1,37,53,33,23,21,1,171,254,172,1,2,251,5,250,242,43,254,31,0,0,0,0,1,0,87,5,250,2,85,7,23,0,5,0,32,64,18,2,130,3,132,5,131,0,2,143,95,5,1,5,64,9,12,72,5,0,47,43,93,237,1,47,237,253,237,49,48,19,53,55,33,21,5,87,252,1,2,254,172,5,250,31,
254,43,242,0,1,255,229,5,250,2,198,7,43,0,9,0,95,64,68,38,9,54,9,70,9,3,41,8,57,8,73,8,3,9,8,3,3,1,38,5,54,5,70,5,3,5,131,6,41,2,57,2,73,2,3,2,131,0,1,48,1,96,1,3,64,1,112,1,160,1,208,1,4,1,3,8,143,6,95,2,1,2,64,9,12,72,2,0,47,43,93,51,237,50,1,47,93,113,237,93,47,237,93,18,57,17,51,51,93,93,49,48,1,21,35,39,35,7,35,53,1,51,2,198,159,203,4,211,160,1,2,229,6,23,29,151,151,29,1,20,0,0,0,0,1,255,229,5,250,2,198,7,43,0,9,0,63,64,40,1,0,5,5,3,7,131,0,8,48,8,96,8,3,64,8,112,8,160,8,208,8,4,8,4,131,3,7,
4,143,5,95,0,1,0,64,9,12,72,0,0,47,43,93,50,237,50,1,47,237,47,93,113,237,18,57,17,51,51,49,48,1,35,1,53,51,23,51,55,51,21,1,204,229,254,254,160,211,4,203,159,5,250,1,20,29,152,152,29,0,0,0,0,2,0,15,5,250,2,154,6,213,0,3,0,7,0,41,64,23,0,133,95,3,1,3,3,7,133,4,5,1,141,4,95,0,1,0,64,9,12,72,0,0,47,43,93,50,237,50,1,47,237,51,47,93,237,49,48,1,53,51,21,33,53,51,21,1,213,197,253,117,194,5,250,219,219,219,219,0,0,0,0,1,255,207,5,250,2,219,7,31,0,31,0,88,185,0,30,255,216,64,61,9,10,0,76,14,24,9,10,0,76,
0,27,32,27,48,27,80,27,96,27,5,64,27,112,27,160,27,192,27,208,27,240,27,6,15,27,1,27,11,64,21,31,72,11,26,5,144,16,143,21,144,10,95,0,1,0,64,9,12,72,0,0,47,43,93,50,237,253,237,51,1,47,43,47,93,93,113,49,48,43,43,1,34,46,2,35,34,14,2,7,35,62,3,51,50,30,2,51,50,62,2,55,51,14,3,1,252,44,89,84,75,30,26,34,21,12,5,137,3,16,47,86,73,45,90,84,73,29,25,33,23,13,5,135,2,16,46,86,5,250,38,47,38,17,32,45,29,45,102,88,58,38,47,38,17,32,46,28,45,102,88,58,0,0,2,255,174,5,250,3,6,7,24,0,5,0,11,0,49,64,30,112,
10,128,10,2,10,63,7,1,7,112,4,128,4,2,4,1,9,3,143,6,95,0,1,0,64,9,12,72,0,0,47,43,93,50,237,50,1,47,205,93,212,93,205,93,49,48,19,35,53,55,51,21,23,35,53,55,51,21,50,132,215,235,88,132,215,235,5,250,34,252,43,243,34,252,43,0,0,0,1,255,251,5,240,2,191,7,16,0,21,0,76,64,56,16,131,32,17,80,17,128,17,160,17,176,17,5,0,17,48,17,96,17,144,17,192,17,240,17,6,112,17,160,17,208,17,3,15,17,31,17,2,17,6,131,5,16,5,143,11,144,95,0,1,0,64,9,12,72,0,0,47,43,93,237,237,50,1,47,237,47,93,93,113,114,237,49,48,1,34,
46,2,39,51,30,3,51,50,62,2,55,51,14,3,1,91,80,126,89,52,5,163,8,36,50,63,34,36,63,50,34,7,164,8,51,87,126,5,240,48,79,104,57,32,50,35,19,19,35,50,32,57,104,79,48,0,0,0,0,1,0,0,21,86,0,1,3,140,12,0,0,9,9,72,0,3,0,36,255,180,0,3,0,60,255,219,0,3,1,86,255,180,0,3,1,95,255,180,0,3,1,98,255,180,0,3,1,105,255,180,0,3,1,114,255,219,0,3,1,120,255,219,0,20,0,20,255,143,0,36,0,3,255,180,0,36,0,55,255,104,0,36,0,57,255,104,0,36,0,58,255,143,0,36,0,60,255,68,0,36,0,89,255,180,0,36,0,90,255,219,0,36,0,92,255,
180,0,36,2,9,255,143,0,41,0,15,255,29,0,41,0,17,255,29,0,41,0,36,255,143,0,47,0,3,255,219,0,47,0,55,255,104,0,47,0,57,255,104,0,47,0,58,255,143,0,47,0,60,255,68,0,47,0,92,255,180,0,47,2,9,255,143,0,51,0,3,255,219,0,51,0,15,254,248,0,51,0,17,254,248,0,51,0,36,255,104,0,53,0,57,255,219,0,53,0,58,255,219,0,53,0,60,255,180,0,55,0,15,255,29,0,55,0,16,255,143,0,55,0,17,255,29,0,55,0,29,255,29,0,55,0,30,255,29,0,55,0,36,255,104,0,55,0,50,255,219,0,55,0,68,255,104,0,55,0,70,255,104,0,55,0,72,255,104,0,55,
0,76,255,219,0,55,0,82,255,104,0,55,0,85,255,143,0,55,0,86,255,104,0,55,0,88,255,104,0,55,0,90,255,104,0,55,0,92,255,104,0,57,0,15,255,68,0,57,0,16,255,143,0,57,0,17,255,68,0,57,0,29,255,143,0,57,0,30,255,143,0,57,0,36,255,104,0,57,0,68,255,143,0,57,0,72,255,143,0,57,0,76,255,219,0,57,0,82,255,104,0,57,0,85,255,143,0,57,0,88,255,180,0,57,0,92,255,180,0,58,0,15,255,143,0,58,0,16,255,215,0,58,0,17,255,143,0,58,0,29,255,219,0,58,0,30,255,219,0,58,0,36,255,143,0,58,0,68,255,180,0,58,0,72,255,219,0,58,
0,76,255,238,0,58,0,82,255,219,0,58,0,85,255,219,0,58,0,88,255,219,0,58,0,92,255,219,0,60,0,3,255,219,0,60,0,15,255,29,0,60,0,16,255,143,0,60,0,17,255,29,0,60,0,29,255,104,0,60,0,30,255,104,0,60,0,36,255,68,0,60,0,68,255,143,0,60,0,72,255,143,0,60,0,76,255,180,0,60,0,82,255,104,0,60,0,83,255,143,0,60,0,84,255,104,0,60,0,88,255,143,0,60,0,89,255,143,0,73,2,9,0,37,0,85,0,15,255,143,0,85,0,17,255,143,0,85,2,9,0,76,0,89,0,15,255,104,0,89,0,17,255,104,0,90,0,15,255,180,0,90,0,17,255,180,0,92,0,15,255,
104,0,92,0,17,255,104,1,86,1,102,255,201,1,86,1,109,255,201,1,86,1,113,255,86,1,86,1,114,255,70,1,86,1,115,255,201,1,86,1,120,255,70,1,86,1,128,255,180,1,86,1,138,255,180,1,86,1,148,255,180,1,91,1,114,255,199,1,91,1,120,255,199,1,92,1,94,1,0,1,92,1,95,255,70,1,92,1,98,255,70,1,92,1,102,255,178,1,92,1,105,255,70,1,92,1,109,255,178,1,92,1,115,255,178,1,92,1,118,255,178,1,92,1,121,255,104,1,92,1,123,255,180,1,92,1,124,255,180,1,92,1,126,255,104,1,92,1,129,255,180,1,92,1,132,255,180,1,92,1,134,255,180,
1,92,1,135,255,180,1,92,1,137,255,180,1,92,1,140,255,104,1,92,1,144,255,104,1,92,1,147,255,104,1,92,1,151,0,92,1,92,1,153,255,104,1,93,1,114,255,199,1,93,1,120,255,199,1,95,1,102,255,201,1,95,1,109,255,201,1,95,1,113,255,86,1,95,1,114,255,70,1,95,1,115,255,201,1,95,1,120,255,70,1,95,1,128,255,180,1,95,1,138,255,180,1,95,1,148,255,180,1,95,2,9,255,143,1,97,0,15,255,31,1,97,0,17,255,31,1,97,1,95,255,33,1,97,1,98,255,33,1,97,1,105,255,33,1,97,1,124,255,190,1,97,1,134,255,190,1,97,1,151,0,94,1,98,1,102,
255,201,1,98,1,109,255,201,1,98,1,113,255,86,1,98,1,114,255,70,1,98,1,120,255,70,1,102,1,95,255,201,1,102,1,98,255,201,1,102,1,105,255,201,1,102,1,114,255,199,1,102,1,120,255,199,1,104,1,102,255,162,1,104,1,109,255,162,1,104,1,115,255,162,1,104,1,121,255,209,1,104,1,126,255,209,1,104,1,129,255,209,1,104,1,131,255,209,1,104,1,133,255,209,1,104,1,139,255,209,1,104,1,140,255,209,1,104,1,144,255,209,1,104,1,147,255,209,1,104,1,150,255,209,1,104,1,153,255,209,1,104,1,155,255,209,1,105,1,102,255,201,1,
105,1,109,255,201,1,105,1,113,255,86,1,105,1,114,255,70,1,105,1,120,255,70,1,109,1,95,255,201,1,109,1,98,255,201,1,109,1,105,255,201,1,109,1,114,255,199,1,109,1,120,255,199,1,111,0,15,254,250,1,111,0,17,254,250,1,111,1,95,255,104,1,111,1,98,255,104,1,111,1,105,255,104,1,112,1,141,255,221,1,112,1,145,255,221,1,113,0,15,255,31,1,113,0,16,255,143,1,113,0,17,255,31,1,113,0,29,255,31,1,113,0,30,255,31,1,113,1,94,0,242,1,113,1,95,255,104,1,113,1,98,255,92,1,113,1,102,255,219,1,113,1,105,255,104,1,113,1,
109,255,219,1,113,1,115,255,201,1,113,1,118,255,219,1,113,1,121,255,104,1,113,1,122,255,104,1,113,1,126,255,104,1,113,1,128,255,104,1,113,1,129,255,172,1,113,1,130,255,104,1,113,1,132,255,104,1,113,1,134,255,219,1,113,1,137,255,104,1,113,1,138,255,104,1,113,1,140,255,104,1,113,1,144,255,104,1,113,1,146,255,104,1,113,1,147,255,104,1,113,1,148,255,133,1,113,1,149,255,104,1,113,1,151,0,92,1,113,1,152,255,104,1,113,1,153,255,104,1,113,1,154,255,104,1,114,0,15,255,31,1,114,0,16,255,143,1,114,0,17,255,
31,1,114,0,29,255,104,1,114,0,30,255,104,1,114,1,94,1,0,1,114,1,95,255,70,1,114,1,98,255,70,1,114,1,102,255,178,1,114,1,105,255,70,1,114,1,109,255,178,1,114,1,115,255,178,1,114,1,118,255,178,1,114,1,121,255,104,1,114,1,123,255,180,1,114,1,124,255,180,1,114,1,126,255,104,1,114,1,128,255,172,1,114,1,129,255,180,1,114,1,132,255,180,1,114,1,134,255,180,1,114,1,135,255,180,1,114,1,137,255,180,1,114,1,140,255,104,1,114,1,144,255,104,1,114,1,147,255,104,1,114,1,151,0,92,1,114,1,153,255,104,1,115,1,95,255,
201,1,115,1,113,255,201,1,115,1,114,255,199,1,115,1,120,255,199,1,116,1,150,255,229,1,116,1,155,255,229,1,117,1,121,255,219,1,117,1,126,255,219,1,117,1,129,255,219,1,117,1,140,255,219,1,117,1,144,255,219,1,117,1,147,255,219,1,117,1,150,255,219,1,117,1,153,255,219,1,117,1,155,255,219,1,118,1,114,255,199,1,118,1,120,255,199,1,120,1,94,1,0,1,120,1,95,255,70,1,120,1,98,255,70,1,120,1,102,255,178,1,120,1,105,255,70,1,120,1,109,255,178,1,120,1,115,255,178,1,120,1,118,255,178,1,120,1,121,255,104,1,120,1,
123,255,180,1,120,1,124,255,180,1,120,1,126,255,104,1,120,1,129,255,180,1,120,1,132,255,180,1,120,1,134,255,180,1,120,1,135,255,180,1,120,1,137,255,180,1,120,1,140,255,104,1,120,1,144,255,104,1,120,1,147,255,104,1,120,1,151,0,92,1,120,1,153,255,104,1,129,1,141,255,199,1,129,1,145,255,199,1,129,1,148,255,182,1,131,1,121,255,141,1,131,1,123,255,207,1,131,1,126,255,141,1,131,1,128,255,190,1,131,1,129,255,180,1,131,1,132,255,207,1,131,1,133,255,180,1,131,1,134,255,207,1,131,1,135,255,207,1,131,1,138,
255,190,1,131,1,140,255,141,1,131,1,141,255,180,1,131,1,144,255,141,1,131,1,145,255,180,1,131,1,147,255,141,1,131,1,150,255,141,1,131,1,153,255,141,1,131,1,155,255,141,1,135,1,121,255,188,1,135,1,126,255,188,1,135,1,129,255,188,1,135,1,131,255,188,1,135,1,133,255,227,1,135,1,139,255,188,1,135,1,140,255,188,1,135,1,143,255,188,1,135,1,144,255,188,1,135,1,147,255,188,1,135,1,150,255,188,1,135,1,153,255,188,1,135,1,155,255,188,1,136,1,121,255,231,1,136,1,125,255,225,1,136,1,126,255,231,1,136,1,129,255,
231,1,136,1,131,255,231,1,136,1,139,255,231,1,136,1,140,255,231,1,136,1,143,255,231,1,136,1,144,255,231,1,136,1,146,255,225,1,136,1,147,255,231,1,136,1,150,255,231,1,136,1,152,255,225,1,136,1,153,255,231,1,136,1,154,255,225,1,136,1,155,255,231,1,139,1,121,255,231,1,139,1,126,255,231,1,139,1,129,255,231,1,139,1,131,255,231,1,139,1,139,255,231,1,139,1,140,255,231,1,139,1,143,255,231,1,139,1,144,255,231,1,139,1,147,255,231,1,139,1,153,255,231,1,140,1,141,255,199,1,140,1,145,255,199,1,140,1,148,255,182,
1,141,1,121,255,199,1,141,1,126,255,199,1,141,1,129,255,199,1,141,1,131,255,199,1,141,1,136,255,180,1,141,1,140,255,199,1,141,1,143,255,199,1,141,1,144,255,199,1,141,1,147,255,199,1,141,1,150,255,199,1,141,1,155,255,199,1,142,1,141,255,199,1,142,1,145,255,199,1,145,1,121,255,199,1,145,1,126,255,199,1,145,1,129,255,199,1,145,1,131,255,199,1,145,1,140,255,199,1,145,1,143,255,199,1,145,1,144,255,199,1,145,1,147,255,199,1,145,1,150,255,199,1,145,1,155,255,199,1,147,1,136,255,231,1,147,1,141,255,199,1,
147,1,145,255,199,1,147,1,148,255,182,1,148,1,121,255,182,1,148,1,126,255,182,1,148,1,129,255,182,1,148,1,131,255,182,1,148,1,140,255,182,1,148,1,143,255,182,1,148,1,144,255,182,1,148,1,147,255,182,1,148,1,150,255,213,1,148,1,153,255,182,1,148,1,155,255,213,1,150,1,141,255,199,1,150,1,145,255,199,1,150,1,148,255,213,1,153,1,141,255,199,1,153,1,145,255,199,1,153,1,148,255,182,1,155,1,141,255,199,1,155,1,145,255,199,1,155,1,148,255,213,1,158,0,15,255,25,1,158,0,17,255,0,1,158,0,29,255,229,1,158,0,30,
255,229,1,158,0,108,255,178,1,158,0,123,255,178,1,164,2,9,255,51,1,165,2,9,255,51,1,170,1,174,0,76,1,170,1,181,0,25,1,170,1,184,255,229,1,170,1,185,255,229,1,170,1,187,255,205,1,170,1,188,255,154,1,170,1,189,255,178,1,170,1,190,255,205,1,170,1,193,255,100,1,170,1,199,255,205,1,170,1,202,0,25,1,170,1,203,255,229,1,170,1,219,255,229,1,170,1,220,255,229,1,170,1,231,0,25,1,170,2,9,255,152,1,171,1,170,255,178,1,171,1,176,255,205,1,171,1,177,255,229,1,171,1,181,255,205,1,171,1,187,255,229,1,171,1,188,255,
205,1,171,1,189,255,205,1,171,1,190,255,229,1,171,1,191,255,205,1,171,1,193,255,178,1,171,1,196,255,178,1,171,1,199,255,205,1,171,1,201,255,205,1,171,1,221,255,229,1,172,1,170,255,154,1,172,1,174,255,229,1,172,1,176,255,178,1,172,1,177,255,229,1,172,1,181,255,205,1,172,1,184,255,205,1,172,1,187,255,178,1,172,1,188,255,178,1,172,1,189,255,178,1,172,1,190,255,205,1,172,1,191,255,178,1,172,1,193,255,178,1,172,1,196,255,154,1,172,1,201,255,205,1,172,1,220,255,229,1,172,1,223,255,229,1,172,1,225,255,178,
1,173,0,15,255,25,1,173,0,17,255,0,1,173,0,29,255,229,1,173,0,30,255,229,1,173,0,108,255,178,1,173,0,123,255,178,1,173,1,170,255,127,1,173,1,174,255,205,1,173,1,181,255,205,1,173,1,184,255,229,1,173,1,187,255,229,1,173,1,202,255,229,1,173,1,204,255,205,1,173,1,206,255,178,1,173,1,207,255,152,1,173,1,210,255,205,1,173,1,213,255,154,1,173,1,214,255,178,1,173,1,215,255,205,1,173,1,216,255,154,1,173,1,218,255,178,1,173,1,221,255,178,1,173,1,229,255,178,1,173,1,230,255,178,1,173,1,232,255,178,1,173,1,
233,255,178,1,174,1,177,0,25,1,174,1,189,0,25,1,174,1,190,255,229,1,174,1,193,255,229,1,174,1,207,0,25,1,174,1,209,0,51,1,174,1,216,0,25,1,174,1,221,0,25,1,176,1,177,0,25,1,176,1,184,255,229,1,176,1,187,255,205,1,176,1,188,0,51,1,176,1,189,0,51,1,176,1,193,0,25,1,176,1,196,0,76,1,176,1,202,0,25,1,176,1,216,255,229,1,177,1,176,255,205,1,177,1,181,255,205,1,177,1,184,255,229,1,177,1,187,255,205,1,177,1,188,255,178,1,177,1,189,255,178,1,177,1,190,255,205,1,177,1,193,255,178,1,177,1,201,255,205,1,180,
1,177,0,76,1,180,1,187,255,229,1,180,1,188,0,51,1,180,1,189,0,51,1,180,1,190,255,229,1,180,1,193,0,51,1,180,1,199,0,25,1,180,1,202,0,25,1,180,1,209,0,25,1,180,1,219,255,229,1,181,1,202,0,51,1,182,1,202,0,25,1,182,1,219,255,229,1,182,1,225,255,229,1,184,1,170,255,205,1,184,1,174,255,229,1,184,1,176,255,229,1,184,1,181,255,205,1,184,1,189,255,205,1,184,1,191,255,178,1,184,1,201,255,229,1,184,1,206,255,205,1,184,1,213,255,229,1,186,0,15,254,229,1,186,0,17,254,205,1,186,0,29,255,229,1,186,0,30,255,229,
1,186,1,170,255,76,1,186,1,174,255,127,1,186,1,176,255,229,1,186,1,177,255,229,1,186,1,181,255,127,1,186,1,182,255,229,1,186,1,184,255,229,1,186,1,187,255,205,1,186,1,188,255,229,1,186,1,189,255,229,1,186,1,190,255,229,1,186,1,191,255,178,1,186,1,201,255,205,1,186,1,202,255,229,1,186,1,206,255,127,1,186,1,207,255,205,1,186,1,216,255,205,1,186,1,233,255,229,1,187,1,170,255,205,1,187,1,174,255,229,1,187,1,177,255,229,1,187,1,181,255,205,1,187,1,182,255,229,1,187,1,184,255,205,1,187,1,188,255,205,1,
187,1,189,255,229,1,187,1,191,255,178,1,187,1,193,255,205,1,187,1,196,255,229,1,187,1,199,255,229,1,187,1,202,0,25,1,187,1,203,255,229,1,187,1,208,0,25,1,187,1,219,255,229,1,187,1,222,255,229,1,187,1,225,255,229,1,188,0,15,255,51,1,188,0,17,255,25,1,188,0,29,255,229,1,188,0,30,255,229,1,188,0,108,255,205,1,188,1,170,255,127,1,188,1,174,255,205,1,188,1,176,0,51,1,188,1,181,255,205,1,188,1,184,255,205,1,188,1,190,255,178,1,188,1,201,255,229,1,188,1,202,255,205,1,188,1,204,255,178,1,188,1,207,255,154,
1,188,1,210,255,178,1,188,1,212,255,178,1,188,1,213,255,127,1,188,1,214,255,152,1,188,1,216,255,127,1,188,1,217,255,229,1,188,1,218,255,178,1,188,1,219,255,127,1,188,1,221,255,178,1,188,1,223,255,178,1,188,1,227,255,229,1,188,1,229,255,229,1,188,1,230,255,229,1,188,1,232,255,229,1,188,1,233,255,205,1,189,0,15,255,25,1,189,0,17,255,0,1,189,0,29,255,205,1,189,0,30,255,205,1,189,0,108,255,178,1,189,0,123,255,178,1,189,1,170,255,102,1,189,1,174,255,152,1,189,1,181,255,178,1,189,1,184,255,205,1,189,1,
190,255,178,1,189,1,199,255,229,1,189,1,201,255,205,1,189,1,203,255,205,1,189,1,204,255,178,1,189,1,205,255,178,1,189,1,206,255,127,1,189,1,207,255,127,1,189,1,208,255,229,1,189,1,209,255,154,1,189,1,210,255,178,1,189,1,211,255,178,1,189,1,212,255,178,1,189,1,213,255,127,1,189,1,214,255,154,1,189,1,215,255,178,1,189,1,216,255,127,1,189,1,217,255,178,1,189,1,218,255,178,1,189,1,219,255,127,1,189,1,223,255,205,1,189,1,224,255,178,1,189,1,226,255,178,1,189,1,227,255,178,1,189,1,232,255,178,1,189,1,233,
255,154,1,190,1,170,255,205,1,190,1,174,255,152,1,190,1,181,255,178,1,190,1,188,255,178,1,190,1,189,255,178,1,190,1,190,255,229,1,190,1,193,255,229,1,190,1,201,255,203,1,190,1,213,255,205,1,191,1,177,255,229,1,191,1,184,255,203,1,191,1,187,255,178,1,191,1,190,255,178,1,191,1,199,255,205,1,191,1,216,255,229,1,191,1,221,255,229,1,192,1,202,0,76,1,192,1,207,0,25,1,192,1,216,0,25,1,195,1,202,0,25,1,196,1,201,255,178,1,196,2,9,255,51,1,198,1,170,255,205,1,198,1,174,255,229,1,198,1,176,255,178,1,198,1,
177,255,205,1,198,1,181,255,178,1,198,1,182,255,205,1,198,1,184,255,229,1,198,1,187,255,205,1,198,1,188,255,49,1,198,1,191,255,152,1,198,1,193,255,102,1,198,1,199,255,178,1,198,1,201,255,178,1,198,2,9,255,102,1,199,1,174,255,205,1,199,1,176,255,205,1,199,1,177,255,229,1,199,1,181,255,178,1,199,1,190,255,229,1,199,1,191,255,205,1,199,1,201,255,205,1,199,1,206,255,229,1,199,1,208,0,25,1,199,1,213,255,205,1,200,1,170,255,205,1,200,1,174,255,205,1,200,1,176,255,205,1,200,1,181,255,178,1,200,1,187,255,
229,1,200,1,188,255,205,1,200,1,191,255,178,1,200,1,193,255,229,1,200,1,206,255,205,1,200,1,208,0,25,1,200,1,213,255,205,1,202,1,209,0,25,1,202,1,225,255,205,1,203,1,206,255,205,1,203,1,208,255,229,1,203,1,209,255,229,1,203,1,213,255,205,1,203,1,214,255,229,1,203,1,219,255,229,1,203,1,221,255,229,1,203,1,223,255,205,1,203,1,225,255,205,1,203,1,228,255,229,1,203,1,231,255,229,1,203,1,233,255,229,1,204,1,202,255,229,1,204,1,203,255,229,1,204,1,207,255,229,1,204,1,208,255,229,1,204,1,213,255,229,1,204,
1,214,255,229,1,204,1,216,255,229,1,204,1,219,255,205,1,204,1,220,255,229,1,204,1,221,255,205,1,204,1,222,255,229,1,204,1,225,255,178,1,204,1,228,255,205,1,204,1,233,255,229,1,205,0,15,255,76,1,205,0,17,255,51,1,205,1,206,255,178,1,205,1,213,255,205,1,205,1,216,255,229,1,205,1,219,255,229,1,206,1,209,0,25,1,206,1,219,255,229,1,206,1,221,0,25,1,206,1,228,255,229,1,207,1,203,255,229,1,207,1,208,255,229,1,207,1,214,255,229,1,207,1,219,255,229,1,207,1,220,255,229,1,207,1,221,255,229,1,207,1,223,255,229,
1,207,1,225,255,205,1,208,1,202,0,25,1,208,1,207,255,229,1,208,1,209,0,25,1,208,1,216,255,205,1,208,1,219,255,229,1,208,1,225,255,205,1,209,1,202,255,229,1,209,1,203,255,205,1,209,1,207,255,229,1,209,1,208,255,229,1,209,1,209,255,229,1,209,1,213,255,229,1,209,1,214,255,205,1,209,1,216,255,205,1,209,1,219,255,205,1,209,1,221,255,205,1,209,1,222,255,229,1,209,1,225,255,178,1,209,1,228,255,205,1,212,1,213,0,25,1,212,1,216,255,229,1,212,1,219,255,229,1,212,1,222,255,229,1,212,1,225,255,229,1,212,1,231,
255,229,1,213,1,203,255,229,1,213,1,207,255,229,1,213,1,216,255,229,1,213,1,219,255,229,1,213,1,221,255,229,1,213,1,225,255,205,1,214,1,202,255,229,1,214,1,203,255,229,1,214,1,209,255,229,1,214,1,216,255,229,1,214,1,219,255,229,1,214,1,221,255,229,1,214,1,222,255,229,1,214,1,231,255,229,1,216,1,206,255,229,1,216,1,208,255,229,1,216,1,209,255,229,1,216,1,213,255,205,1,216,1,214,255,229,1,216,1,219,255,229,1,216,1,220,255,205,1,216,1,221,255,229,1,216,1,223,255,205,1,216,1,225,255,205,1,216,1,231,255,
229,1,216,1,233,255,229,1,218,1,206,255,205,1,218,1,208,255,229,1,218,1,209,255,229,1,218,1,213,255,205,1,218,1,214,255,229,1,218,1,220,255,229,1,218,1,221,255,229,1,218,1,223,255,229,1,218,1,225,255,205,1,218,1,231,255,229,1,218,1,233,255,229,1,219,1,202,0,25,1,219,1,203,255,229,1,219,1,223,255,229,1,219,1,225,255,203,1,219,1,228,255,229,1,220,0,15,255,102,1,220,0,17,255,76,1,220,1,206,255,229,1,220,1,208,0,25,1,220,1,213,255,229,1,220,1,216,255,229,1,220,1,219,255,229,1,220,1,221,0,51,1,221,0,15,
255,102,1,221,0,17,255,76,1,221,0,29,255,229,1,221,0,30,255,229,1,221,0,123,0,51,1,221,1,202,255,229,1,221,1,206,255,205,1,221,1,207,255,229,1,221,1,208,0,25,1,221,1,209,255,229,1,221,1,213,255,229,1,221,1,214,255,229,1,221,1,216,255,205,1,221,1,218,255,229,1,221,1,219,255,205,1,221,1,220,0,25,1,221,1,222,255,229,1,221,1,223,0,25,1,221,1,231,255,229,1,221,1,233,255,229,1,222,1,203,255,229,1,222,1,206,255,229,1,222,1,207,255,229,1,222,1,213,255,205,1,222,1,214,255,229,1,222,1,216,255,229,1,222,1,220,
255,229,1,222,1,221,255,229,1,222,1,225,255,205,1,222,1,233,255,229,1,223,1,203,255,229,1,223,1,207,255,205,1,223,1,209,255,229,1,223,1,216,255,205,1,223,1,219,255,205,1,223,1,221,0,25,1,223,1,222,255,229,1,223,1,225,255,205,1,223,1,231,255,229,1,224,1,202,0,25,1,224,1,209,0,25,1,224,1,219,255,229,1,227,1,202,0,25,1,227,1,216,255,229,1,230,1,220,255,76,1,230,1,225,255,76,1,231,1,203,255,229,1,231,1,206,255,229,1,231,1,208,255,229,1,231,1,209,255,229,1,231,1,213,255,205,1,231,1,214,255,229,1,231,1,
219,255,229,1,231,1,220,255,229,1,231,1,223,255,229,1,231,1,233,255,229,1,232,1,203,255,229,1,232,1,206,255,229,1,232,1,208,255,229,1,232,1,213,255,205,1,232,1,214,255,229,1,232,1,219,255,229,1,232,1,220,255,205,1,232,1,223,255,205,1,232,1,225,255,178,1,232,1,231,255,229,1,246,0,15,255,102,1,246,0,17,255,76,1,246,0,29,255,229,1,246,0,30,255,229,1,246,0,108,255,205,1,248,0,15,255,127,1,248,0,17,255,102,1,248,0,29,255,229,1,248,0,30,255,229,1,248,0,108,255,205,1,248,0,123,255,205,2,8,2,8,255,180,2,
9,0,3,255,143,2,9,0,86,255,180,2,9,2,9,255,180,2,14,1,157,255,51,2,14,1,166,255,51,2,14,1,188,255,76,2,14,1,193,255,49,2,14,1,196,255,76,0,0,0,0,0,28,1,86,0,1,0,0,0,0,0,0,0,94,0,190,0,1,0,0,0,0,0,1,0,15,1,61,0,1,0,0,0,0,0,2,0,4,1,87,0,1,0,0,0,0,0,3,0,31,1,156,0,1,0,0,0,0,0,4,0,20,1,230,0,1,0,0,0,0,0,5,0,12,2,21,0,1,0,0,0,0,0,6,0,19,2,74,0,1,0,0,0,0,0,7,0,122,3,84,0,1,0,0,0,0,0,8,0,20,3,249,0,1,0,0,0,0,0,9,0,14,4,44,0,1,0,0,0,0,0,11,0,28,4,117,0,1,0,0,0,0,0,12,0,46,4,240,0,1,0,0,0,0,0,13,0,127,6,31,
0,1,0,0,0,0,0,14,0,43,6,247,0,3,0,1,4,9,0,0,0,188,0,0,0,3,0,1,4,9,0,1,0,30,1,29,0,3,0,1,4,9,0,2,0,8,1,77,0,3,0,1,4,9,0,3,0,62,1,92,0,3,0,1,4,9,0,4,0,40,1,188,0,3,0,1,4,9,0,5,0,24,1,251,0,3,0,1,4,9,0,6,0,38,2,34,0,3,0,1,4,9,0,7,0,244,2,94,0,3,0,1,4,9,0,8,0,40,3,207,0,3,0,1,4,9,0,9,0,28,4,14,0,3,0,1,4,9,0,11,0,56,4,59,0,3,0,1,4,9,0,12,0,92,4,146,0,3,0,1,4,9,0,13,0,254,5,31,0,3,0,1,4,9,0,14,0,86,6,159,0,67,0,111,0,112,0,121,0,114,0,105,0,103,0,104,0,116,0,32,0,169,0,32,0,50,0,48,0,48,0,55,0,32,0,82,
0,101,0,100,0,32,0,72,0,97,0,116,0,44,0,32,0,73,0,110,0,99,0,46,0,32,0,65,0,108,0,108,0,32,0,114,0,105,0,103,0,104,0,116,0,115,0,32,0,114,0,101,0,115,0,101,0,114,0,118,0,101,0,100,0,46,0,32,0,76,0,73,0,66,0,69,0,82,0,65,0,84,0,73,0,79,0,78,0,32,0,105,0,115,0,32,0,97,0,32,0,116,0,114,0,97,0,100,0,101,0,109,0,97,0,114,0,107,0,32,0,111,0,102,0,32,0,82,0,101,0,100,0,32,0,72,0,97,0,116,0,44,0,32,0,73,0,110,0,99,0,46,0,0,67,111,112,121,114,105,103,104,116,32,169,32,50,48,48,55,32,82,101,100,32,72,97,116,
44,32,73,110,99,46,32,65,108,108,32,114,105,103,104,116,115,32,114,101,115,101,114,118,101,100,46,32,76,73,66,69,82,65,84,73,79,78,32,105,115,32,97,32,116,114,97,100,101,109,97,114,107,32,111,102,32,82,101,100,32,72,97,116,44,32,73,110,99,46,0,0,76,0,105,0,98,0,101,0,114,0,97,0,116,0,105,0,111,0,110,0,32,0,83,0,97,0,110,0,115,0,0,76,105,98,101,114,97,116,105,111,110,32,83,97,110,115,0,0,66,0,111,0,108,0,100,0,0,66,111,108,100,0,0,65,0,115,0,99,0,101,0,110,0,100,0,101,0,114,0,32,0,45,0,32,0,76,0,105,
0,98,0,101,0,114,0,97,0,116,0,105,0,111,0,110,0,32,0,83,0,97,0,110,0,115,0,32,0,66,0,111,0,108,0,100,0,0,65,115,99,101,110,100,101,114,32,45,32,76,105,98,101,114,97,116,105,111,110,32,83,97,110,115,32,66,111,108,100,0,0,76,0,105,0,98,0,101,0,114,0,97,0,116,0,105,0,111,0,110,0,32,0,83,0,97,0,110,0,115,0,32,0,66,0,111,0,108,0,100,0,0,76,105,98,101,114,97,116,105,111,110,32,83,97,110,115,32,66,111,108,100,0,0,86,0,101,0,114,0,115,0,105,0,111,0,110,0,32,0,49,0,46,0,48,0,54,0,0,86,101,114,115,105,111,
110,32,49,46,48,54,0,0,76,0,105,0,98,0,101,0,114,0,97,0,116,0,105,0,111,0,110,0,83,0,97,0,110,0,115,0,45,0,66,0,111,0,108,0,100,0,0,76,105,98,101,114,97,116,105,111,110,83,97,110,115,45,66,111,108,100,0,0,76,0,105,0,98,0,101,0,114,0,97,0,116,0,105,0,111,0,110,0,32,0,105,0,115,0,32,0,97,0,32,0,116,0,114,0,97,0,100,0,101,0,109,0,97,0,114,0,107,0,32,0,111,0,102,0,32,0,82,0,101,0,100,0,32,0,72,0,97,0,116,0,44,0,32,0,73,0,110,0,99,0,46,0,32,0,114,0,101,0,103,0,105,0,115,0,116,0,101,0,114,0,101,0,100,0,
32,0,105,0,110,0,32,0,85,0,46,0,83,0,46,0,32,0,80,0,97,0,116,0,101,0,110,0,116,0,32,0,97,0,110,0,100,0,32,0,84,0,114,0,97,0,100,0,101,0,109,0,97,0,114,0,107,0,32,0,79,0,102,0,102,0,105,0,99,0,101,0,32,0,97,0,110,0,100,0,32,0,99,0,101,0,114,0,116,0,97,0,105,0,110,0,32,0,111,0,116,0,104,0,101,0,114,0,32,0,106,0,117,0,114,0,105,0,115,0,100,0,105,0,99,0,116,0,105,0,111,0,110,0,115,0,46,0,0,76,105,98,101,114,97,116,105,111,110,32,105,115,32,97,32,116,114,97,100,101,109,97,114,107,32,111,102,32,82,101,
100,32,72,97,116,44,32,73,110,99,46,32,114,101,103,105,115,116,101,114,101,100,32,105,110,32,85,46,83,46,32,80,97,116,101,110,116,32,97,110,100,32,84,114,97,100,101,109,97,114,107,32,79,102,102,105,99,101,32,97,110,100,32,99,101,114,116,97,105,110,32,111,116,104,101,114,32,106,117,114,105,115,100,105,99,116,105,111,110,115,46,0,0,65,0,115,0,99,0,101,0,110,0,100,0,101,0,114,0,32,0,67,0,111,0,114,0,112,0,111,0,114,0,97,0,116,0,105,0,111,0,110,0,0,65,115,99,101,110,100,101,114,32,67,111,114,112,111,
114,97,116,105,111,110,0,0,83,0,116,0,101,0,118,0,101,0,32,0,77,0,97,0,116,0,116,0,101,0,115,0,111,0,110,0,0,83,116,101,118,101,32,77,97,116,116,101,115,111,110,0,0,104,0,116,0,116,0,112,0,58,0,47,0,47,0,119,0,119,0,119,0,46,0,97,0,115,0,99,0,101,0,110,0,100,0,101,0,114,0,99,0,111,0,114,0,112,0,46,0,99,0,111,0,109,0,47,0,0,104,116,116,112,58,47,47,119,119,119,46,97,115,99,101,110,100,101,114,99,111,114,112,46,99,111,109,47,0,0,104,0,116,0,116,0,112,0,58,0,47,0,47,0,119,0,119,0,119,0,46,0,97,0,115,
0,99,0,101,0,110,0,100,0,101,0,114,0,99,0,111,0,114,0,112,0,46,0,99,0,111,0,109,0,47,0,116,0,121,0,112,0,101,0,100,0,101,0,115,0,105,0,103,0,110,0,101,0,114,0,115,0,46,0,104,0,116,0,109,0,108,0,0,104,116,116,112,58,47,47,119,119,119,46,97,115,99,101,110,100,101,114,99,111,114,112,46,99,111,109,47,116,121,112,101,100,101,115,105,103,110,101,114,115,46,104,116,109,108,0,0,85,0,115,0,101,0,32,0,111,0,102,0,32,0,116,0,104,0,105,0,115,0,32,0,76,0,105,0,98,0,101,0,114,0,97,0,116,0,105,0,111,0,110,0,32,
0,102,0,111,0,110,0,116,0,32,0,115,0,111,0,102,0,116,0,119,0,97,0,114,0,101,0,32,0,105,0,115,0,32,0,115,0,117,0,98,0,106,0,101,0,99,0,116,0,32,0,116,0,111,0,32,0,116,0,104,0,101,0,32,0,108,0,105,0,99,0,101,0,110,0,115,0,101,0,32,0,97,0,103,0,114,0,101,0,101,0,109,0,101,0,110,0,116,0,32,0,117,0,110,0,100,0,101,0,114,0,32,0,119,0,104,0,105,0,99,0,104,0,32,0,121,0,111,0,117,0,32,0,97,0,99,0,99,0,101,0,112,0,116,0,101,0,100,0,32,0,116,0,104,0,101,0,32,0,76,0,105,0,98,0,101,0,114,0,97,0,116,0,105,0,111,
0,110,0,32,0,102,0,111,0,110,0,116,0,32,0,115,0,111,0,102,0,116,0,119,0,97,0,114,0,101,0,46,0,0,85,115,101,32,111,102,32,116,104,105,115,32,76,105,98,101,114,97,116,105,111,110,32,102,111,110,116,32,115,111,102,116,119,97,114,101,32,105,115,32,115,117,98,106,101,99,116,32,116,111,32,116,104,101,32,108,105,99,101,110,115,101,32,97,103,114,101,101,109,101,110,116,32,117,110,100,101,114,32,119,104,105,99,104,32,121,111,117,32,97,99,99,101,112,116,101,100,32,116,104,101,32,76,105,98,101,114,97,116,105,
111,110,32,102,111,110,116,32,115,111,102,116,119,97,114,101,46,0,0,104,0,116,0,116,0,112,0,58,0,47,0,47,0,119,0,119,0,119,0,46,0,97,0,115,0,99,0,101,0,110,0,100,0,101,0,114,0,99,0,111,0,114,0,112,0,46,0,99,0,111,0,109,0,47,0,108,0,105,0,98,0,101,0,114,0,97,0,116,0,105,0,111,0,110,0,46,0,104,0,116,0,109,0,108,0,0,104,116,116,112,58,47,47,119,119,119,46,97,115,99,101,110,100,101,114,99,111,114,112,46,99,111,109,47,108,105,98,101,114,97,116,105,111,110,46,104,116,109,108,0,0,0,0,0,2,0,0,0,0,0,0,255,
39,0,215,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,162,0,0,0,1,0,2,1,2,0,4,0,5,0,6,0,7,0,8,0,9,0,10,0,11,0,12,0,13,0,14,0,15,1,3,0,17,0,18,0,19,0,20,0,21,0,22,0,23,0,24,0,25,0,26,0,27,0,28,0,29,1,4,0,31,0,32,0,33,0,34,0,35,0,36,0,37,0,38,0,39,0,40,0,41,0,42,0,43,0,44,0,45,0,46,0,47,0,48,0,49,0,50,0,51,0,52,0,53,0,54,0,55,0,56,0,57,0,58,0,59,0,60,0,61,0,62,0,63,0,64,0,65,0,66,0,67,0,68,0,69,0,70,0,71,0,72,0,73,0,74,0,75,0,76,0,77,0,78,0,79,0,80,0,81,0,82,0,83,0,84,0,85,0,86,0,87,0,88,0,89,0,90,0,91,
0,92,0,93,0,94,0,95,0,96,0,97,0,163,0,132,0,133,0,189,0,150,0,232,0,134,0,142,0,139,0,157,0,169,0,164,0,138,0,218,0,131,0,147,1,5,1,6,0,141,1,7,0,136,1,8,0,222,1,9,0,158,0,170,0,245,0,244,0,246,0,162,0,173,0,201,0,199,0,174,0,98,0,99,0,144,0,100,0,203,0,101,0,200,0,202,0,207,0,204,0,205,0,206,0,233,0,102,0,211,0,208,0,209,0,175,0,103,0,240,0,145,0,214,0,212,0,213,0,104,0,235,0,237,0,137,0,106,0,105,0,107,0,109,0,108,0,110,0,160,0,111,0,113,0,112,0,114,0,115,0,117,0,116,0,118,0,119,0,234,0,120,0,122,
0,121,0,123,0,125,0,124,0,184,0,161,0,127,0,126,0,128,0,129,0,236,0,238,0,186,1,10,1,11,1,12,1,13,1,14,1,15,0,253,0,254,1,16,1,17,1,18,1,19,0,255,1,0,1,20,1,21,1,22,1,1,1,23,1,24,1,25,1,26,1,27,1,28,1,29,1,30,1,31,1,32,1,33,1,34,0,248,0,249,1,35,1,36,1,37,1,38,1,39,1,40,1,41,1,42,1,43,1,44,1,45,1,46,1,47,1,48,1,49,1,50,0,250,0,215,1,51,1,52,1,53,1,54,1,55,1,56,1,57,1,58,1,59,1,60,1,61,1,62,1,63,1,64,1,65,0,226,0,227,1,66,1,67,1,68,1,69,1,70,1,71,1,72,1,73,1,74,1,75,1,76,1,77,1,78,1,79,1,80,0,176,
0,177,1,81,1,82,1,83,1,84,1,85,1,86,1,87,1,88,1,89,1,90,0,251,0,252,0,228,0,229,1,91,1,92,1,93,1,94,1,95,1,96,1,97,1,98,1,99,1,100,1,101,1,102,1,103,1,104,1,105,1,106,1,107,1,108,1,109,1,110,1,111,1,112,0,187,1,113,1,114,1,115,1,116,0,230,0,231,1,117,0,166,1,118,1,119,1,120,1,121,1,122,1,123,1,124,1,125,1,126,1,127,0,216,0,225,1,128,0,219,0,220,0,221,0,224,0,217,0,223,1,129,1,130,1,131,1,132,1,133,1,134,1,135,1,136,1,137,1,138,1,139,1,140,1,141,1,142,0,168,1,143,1,144,1,145,1,146,1,147,1,148,1,149,
1,150,1,151,1,152,1,153,1,154,1,155,1,156,1,157,1,158,1,159,1,160,1,161,0,159,1,162,1,163,1,164,1,165,1,166,1,167,1,168,1,169,1,170,1,171,1,172,1,173,1,174,1,175,1,176,1,177,1,178,1,179,0,151,1,180,1,181,1,182,0,155,1,183,1,184,1,185,1,186,1,187,1,188,1,189,1,190,1,191,1,192,1,193,1,194,1,195,1,196,1,197,1,198,1,199,1,200,1,201,1,202,1,203,1,204,1,205,1,206,1,207,1,208,1,209,1,210,1,211,1,212,1,213,1,214,1,215,1,216,1,217,1,218,1,219,1,220,1,221,1,222,1,223,1,224,1,225,1,226,1,227,1,228,1,229,1,230,
1,231,1,232,1,233,1,234,1,235,1,236,1,237,1,238,1,239,1,240,1,241,1,242,1,243,1,244,1,245,1,246,1,247,1,248,1,249,1,250,1,251,1,252,1,253,1,254,1,255,2,0,2,1,2,2,2,3,2,4,2,5,2,6,2,7,2,8,2,9,2,10,2,11,2,12,2,13,2,14,2,15,2,16,2,17,2,18,2,19,2,20,2,21,2,22,2,23,2,24,2,25,2,26,2,27,2,28,2,29,2,30,2,31,2,32,2,33,2,34,2,35,2,36,2,37,2,38,2,39,2,40,2,41,2,42,2,43,2,44,0,178,0,179,2,45,2,46,0,182,0,183,0,196,2,47,0,180,0,181,0,197,0,130,0,194,0,135,0,171,0,198,2,48,2,49,0,190,0,191,2,50,2,51,2,52,2,53,0,
247,2,54,2,55,2,56,2,57,2,58,2,59,0,140,2,60,2,61,2,62,2,63,2,64,2,65,2,66,2,67,2,68,2,69,2,70,2,71,2,72,0,152,2,73,0,154,0,153,0,239,0,165,0,146,2,74,2,75,0,156,0,167,0,143,2,76,0,148,0,149,2,77,2,78,2,79,2,80,2,81,2,82,2,83,2,84,2,85,2,86,2,87,2,88,2,89,2,90,2,91,2,92,2,93,2,94,2,95,2,96,2,97,2,98,2,99,2,100,2,101,2,102,2,103,2,104,2,105,2,106,2,107,2,108,2,109,2,110,2,111,2,112,2,113,2,114,2,115,2,116,2,117,2,118,2,119,2,120,2,121,2,122,2,123,2,124,2,125,2,126,2,127,2,128,2,129,2,130,2,131,2,132,
2,133,2,134,2,135,2,136,2,137,0,185,2,138,2,139,2,140,2,141,2,142,2,143,2,144,2,145,2,146,2,147,2,148,2,149,2,150,2,151,2,152,2,153,2,154,2,155,2,156,2,157,2,158,2,159,2,160,2,161,2,162,2,163,2,164,2,165,2,166,2,167,2,168,2,169,2,170,2,171,2,172,2,173,7,117,110,105,48,48,65,48,7,117,110,105,48,48,65,68,7,117,110,105,48,51,55,69,7,117,110,105,48,48,66,50,7,117,110,105,48,48,66,51,7,117,110,105,48,48,66,53,7,117,110,105,50,50,49,57,7,117,110,105,48,48,66,57,7,65,109,97,99,114,111,110,7,97,109,97,99,
114,111,110,6,65,98,114,101,118,101,6,97,98,114,101,118,101,7,65,111,103,111,110,101,107,7,97,111,103,111,110,101,107,11,67,99,105,114,99,117,109,102,108,101,120,11,99,99,105,114,99,117,109,102,108,101,120,10,67,100,111,116,97,99,99,101,110,116,10,99,100,111,116,97,99,99,101,110,116,6,68,99,97,114,111,110,6,100,99,97,114,111,110,6,68,99,114,111,97,116,7,69,109,97,99,114,111,110,7,101,109,97,99,114,111,110,6,69,98,114,101,118,101,6,101,98,114,101,118,101,10,69,100,111,116,97,99,99,101,110,116,10,101,
100,111,116,97,99,99,101,110,116,7,69,111,103,111,110,101,107,7,101,111,103,111,110,101,107,6,69,99,97,114,111,110,6,101,99,97,114,111,110,11,71,99,105,114,99,117,109,102,108,101,120,11,103,99,105,114,99,117,109,102,108,101,120,10,71,100,111,116,97,99,99,101,110,116,10,103,100,111,116,97,99,99,101,110,116,12,71,99,111,109,109,97,97,99,99,101,110,116,12,103,99,111,109,109,97,97,99,99,101,110,116,11,72,99,105,114,99,117,109,102,108,101,120,11,104,99,105,114,99,117,109,102,108,101,120,4,72,98,97,114,
4,104,98,97,114,6,73,116,105,108,100,101,6,105,116,105,108,100,101,7,73,109,97,99,114,111,110,7,105,109,97,99,114,111,110,6,73,98,114,101,118,101,6,105,98,114,101,118,101,7,73,111,103,111,110,101,107,7,105,111,103,111,110,101,107,2,73,74,2,105,106,11,74,99,105,114,99,117,109,102,108,101,120,11,106,99,105,114,99,117,109,102,108,101,120,12,75,99,111,109,109,97,97,99,99,101,110,116,12,107,99,111,109,109,97,97,99,99,101,110,116,12,107,103,114,101,101,110,108,97,110,100,105,99,6,76,97,99,117,116,101,6,
108,97,99,117,116,101,12,76,99,111,109,109,97,97,99,99,101,110,116,12,108,99,111,109,109,97,97,99,99,101,110,116,6,76,99,97,114,111,110,6,108,99,97,114,111,110,4,76,100,111,116,4,108,100,111,116,6,78,97,99,117,116,101,6,110,97,99,117,116,101,12,78,99,111,109,109,97,97,99,99,101,110,116,12,110,99,111,109,109,97,97,99,99,101,110,116,6,78,99,97,114,111,110,6,110,99,97,114,111,110,11,110,97,112,111,115,116,114,111,112,104,101,3,69,110,103,3,101,110,103,7,79,109,97,99,114,111,110,7,111,109,97,99,114,111,
110,6,79,98,114,101,118,101,6,111,98,114,101,118,101,13,79,104,117,110,103,97,114,117,109,108,97,117,116,13,111,104,117,110,103,97,114,117,109,108,97,117,116,6,82,97,99,117,116,101,6,114,97,99,117,116,101,12,82,99,111,109,109,97,97,99,99,101,110,116,12,114,99,111,109,109,97,97,99,99,101,110,116,6,82,99,97,114,111,110,6,114,99,97,114,111,110,6,83,97,99,117,116,101,6,115,97,99,117,116,101,11,83,99,105,114,99,117,109,102,108,101,120,11,115,99,105,114,99,117,109,102,108,101,120,12,84,99,111,109,109,97,
97,99,99,101,110,116,12,116,99,111,109,109,97,97,99,99,101,110,116,6,84,99,97,114,111,110,6,116,99,97,114,111,110,4,84,98,97,114,4,116,98,97,114,6,85,116,105,108,100,101,6,117,116,105,108,100,101,7,85,109,97,99,114,111,110,7,117,109,97,99,114,111,110,6,85,98,114,101,118,101,6,117,98,114,101,118,101,5,85,114,105,110,103,5,117,114,105,110,103,13,85,104,117,110,103,97,114,117,109,108,97,117,116,13,117,104,117,110,103,97,114,117,109,108,97,117,116,7,85,111,103,111,110,101,107,7,117,111,103,111,110,101,
107,11,87,99,105,114,99,117,109,102,108,101,120,11,119,99,105,114,99,117,109,102,108,101,120,11,89,99,105,114,99,117,109,102,108,101,120,11,121,99,105,114,99,117,109,102,108,101,120,6,90,97,99,117,116,101,6,122,97,99,117,116,101,10,90,100,111,116,97,99,99,101,110,116,10,122,100,111,116,97,99,99,101,110,116,5,108,111,110,103,115,10,65,114,105,110,103,97,99,117,116,101,10,97,114,105,110,103,97,99,117,116,101,7,65,69,97,99,117,116,101,7,97,101,97,99,117,116,101,11,79,115,108,97,115,104,97,99,117,116,
101,11,111,115,108,97,115,104,97,99,117,116,101,12,83,99,111,109,109,97,97,99,99,101,110,116,12,115,99,111,109,109,97,97,99,99,101,110,116,7,117,110,105,48,50,49,65,7,117,110,105,48,50,49,66,7,117,110,105,48,50,67,57,5,116,111,110,111,115,13,100,105,101,114,101,115,105,115,116,111,110,111,115,10,65,108,112,104,97,116,111,110,111,115,9,97,110,111,116,101,108,101,105,97,12,69,112,115,105,108,111,110,116,111,110,111,115,8,69,116,97,116,111,110,111,115,9,73,111,116,97,116,111,110,111,115,12,79,109,105,
99,114,111,110,116,111,110,111,115,12,85,112,115,105,108,111,110,116,111,110,111,115,10,79,109,101,103,97,116,111,110,111,115,17,105,111,116,97,100,105,101,114,101,115,105,115,116,111,110,111,115,5,65,108,112,104,97,4,66,101,116,97,5,71,97,109,109,97,7,69,112,115,105,108,111,110,4,90,101,116,97,3,69,116,97,5,84,104,101,116,97,4,73,111,116,97,5,75,97,112,112,97,6,76,97,109,98,100,97,2,77,117,2,78,117,2,88,105,7,79,109,105,99,114,111,110,2,80,105,3,82,104,111,5,83,105,103,109,97,3,84,97,117,7,85,112,
115,105,108,111,110,3,80,104,105,3,67,104,105,3,80,115,105,12,73,111,116,97,100,105,101,114,101,115,105,115,15,85,112,115,105,108,111,110,100,105,101,114,101,115,105,115,10,97,108,112,104,97,116,111,110,111,115,12,101,112,115,105,108,111,110,116,111,110,111,115,8,101,116,97,116,111,110,111,115,9,105,111,116,97,116,111,110,111,115,20,117,112,115,105,108,111,110,100,105,101,114,101,115,105,115,116,111,110,111,115,5,97,108,112,104,97,4,98,101,116,97,5,103,97,109,109,97,5,100,101,108,116,97,7,101,112,
115,105,108,111,110,4,122,101,116,97,3,101,116,97,5,116,104,101,116,97,4,105,111,116,97,5,107,97,112,112,97,6,108,97,109,98,100,97,2,110,117,2,120,105,7,111,109,105,99,114,111,110,3,114,104,111,6,115,105,103,109,97,49,5,115,105,103,109,97,3,116,97,117,7,117,112,115,105,108,111,110,3,112,104,105,3,99,104,105,3,112,115,105,5,111,109,101,103,97,12,105,111,116,97,100,105,101,114,101,115,105,115,15,117,112,115,105,108,111,110,100,105,101,114,101,115,105,115,12,111,109,105,99,114,111,110,116,111,110,111,
115,12,117,112,115,105,108,111,110,116,111,110,111,115,10,111,109,101,103,97,116,111,110,111,115,9,97,102,105,105,49,48,48,50,51,9,97,102,105,105,49,48,48,53,49,9,97,102,105,105,49,48,48,53,50,9,97,102,105,105,49,48,48,53,51,9,97,102,105,105,49,48,48,53,52,9,97,102,105,105,49,48,48,53,53,9,97,102,105,105,49,48,48,53,54,9,97,102,105,105,49,48,48,53,55,9,97,102,105,105,49,48,48,53,56,9,97,102,105,105,49,48,48,53,57,9,97,102,105,105,49,48,48,54,48,9,97,102,105,105,49,48,48,54,49,9,97,102,105,105,49,
48,48,54,50,9,97,102,105,105,49,48,49,52,53,9,97,102,105,105,49,48,48,49,55,9,97,102,105,105,49,48,48,49,56,9,97,102,105,105,49,48,48,49,57,9,97,102,105,105,49,48,48,50,48,9,97,102,105,105,49,48,48,50,49,9,97,102,105,105,49,48,48,50,50,9,97,102,105,105,49,48,48,50,52,9,97,102,105,105,49,48,48,50,53,9,97,102,105,105,49,48,48,50,54,9,97,102,105,105,49,48,48,50,55,9,97,102,105,105,49,48,48,50,56,9,97,102,105,105,49,48,48,50,57,9,97,102,105,105,49,48,48,51,48,9,97,102,105,105,49,48,48,51,49,9,97,102,
105,105,49,48,48,51,50,9,97,102,105,105,49,48,48,51,51,9,97,102,105,105,49,48,48,51,52,9,97,102,105,105,49,48,48,51,53,9,97,102,105,105,49,48,48,51,54,9,97,102,105,105,49,48,48,51,55,9,97,102,105,105,49,48,48,51,56,9,97,102,105,105,49,48,48,51,57,9,97,102,105,105,49,48,48,52,48,9,97,102,105,105,49,48,48,52,49,9,97,102,105,105,49,48,48,52,50,9,97,102,105,105,49,48,48,52,51,9,97,102,105,105,49,48,48,52,52,9,97,102,105,105,49,48,48,52,53,9,97,102,105,105,49,48,48,52,54,9,97,102,105,105,49,48,48,52,55,
9,97,102,105,105,49,48,48,52,56,9,97,102,105,105,49,48,48,52,57,9,97,102,105,105,49,48,48,54,53,9,97,102,105,105,49,48,48,54,54,9,97,102,105,105,49,48,48,54,55,9,97,102,105,105,49,48,48,54,56,9,97,102,105,105,49,48,48,54,57,9,97,102,105,105,49,48,48,55,48,9,97,102,105,105,49,48,48,55,50,9,97,102,105,105,49,48,48,55,51,9,97,102,105,105,49,48,48,55,52,9,97,102,105,105,49,48,48,55,53,9,97,102,105,105,49,48,48,55,54,9,97,102,105,105,49,48,48,55,55,9,97,102,105,105,49,48,48,55,56,9,97,102,105,105,49,48,
48,55,57,9,97,102,105,105,49,48,48,56,48,9,97,102,105,105,49,48,48,56,49,9,97,102,105,105,49,48,48,56,50,9,97,102,105,105,49,48,48,56,51,9,97,102,105,105,49,48,48,56,52,9,97,102,105,105,49,48,48,56,53,9,97,102,105,105,49,48,48,56,54,9,97,102,105,105,49,48,48,56,55,9,97,102,105,105,49,48,48,56,56,9,97,102,105,105,49,48,48,56,57,9,97,102,105,105,49,48,48,57,48,9,97,102,105,105,49,48,48,57,49,9,97,102,105,105,49,48,48,57,50,9,97,102,105,105,49,48,48,57,51,9,97,102,105,105,49,48,48,57,52,9,97,102,105,
105,49,48,48,57,53,9,97,102,105,105,49,48,48,57,54,9,97,102,105,105,49,48,48,57,55,9,97,102,105,105,49,48,48,55,49,9,97,102,105,105,49,48,48,57,57,9,97,102,105,105,49,48,49,48,48,9,97,102,105,105,49,48,49,48,49,9,97,102,105,105,49,48,49,48,50,9,97,102,105,105,49,48,49,48,51,9,97,102,105,105,49,48,49,48,52,9,97,102,105,105,49,48,49,48,53,9,97,102,105,105,49,48,49,48,54,9,97,102,105,105,49,48,49,48,55,9,97,102,105,105,49,48,49,48,56,9,97,102,105,105,49,48,49,48,57,9,97,102,105,105,49,48,49,49,48,9,
97,102,105,105,49,48,49,57,51,9,97,102,105,105,49,48,48,53,48,9,97,102,105,105,49,48,48,57,56,6,87,103,114,97,118,101,6,119,103,114,97,118,101,6,87,97,99,117,116,101,6,119,97,99,117,116,101,9,87,100,105,101,114,101,115,105,115,9,119,100,105,101,114,101,115,105,115,6,89,103,114,97,118,101,6,121,103,114,97,118,101,7,117,110,105,50,48,49,48,7,117,110,105,50,48,49,49,9,97,102,105,105,48,48,50,48,56,13,117,110,100,101,114,115,99,111,114,101,100,98,108,13,113,117,111,116,101,114,101,118,101,114,115,101,
100,6,109,105,110,117,116,101,6,115,101,99,111,110,100,9,101,120,99,108,97,109,100,98,108,7,117,110,105,50,48,51,69,7,117,110,105,50,50,49,53,7,117,110,105,50,48,55,70,4,108,105,114,97,6,112,101,115,101,116,97,4,69,117,114,111,9,97,102,105,105,54,49,50,52,56,9,97,102,105,105,54,49,50,56,57,9,97,102,105,105,54,49,51,53,50,7,117,110,105,50,49,50,54,9,101,115,116,105,109,97,116,101,100,9,111,110,101,101,105,103,104,116,104,12,116,104,114,101,101,101,105,103,104,116,104,115,11,102,105,118,101,101,105,
103,104,116,104,115,12,115,101,118,101,110,101,105,103,104,116,104,115,9,97,114,114,111,119,108,101,102,116,7,97,114,114,111,119,117,112,10,97,114,114,111,119,114,105,103,104,116,9,97,114,114,111,119,100,111,119,110,9,97,114,114,111,119,98,111,116,104,9,97,114,114,111,119,117,112,100,110,12,97,114,114,111,119,117,112,100,110,98,115,101,7,117,110,105,50,50,48,54,10,111,114,116,104,111,103,111,110,97,108,12,105,110,116,101,114,115,101,99,116,105,111,110,11,101,113,117,105,118,97,108,101,110,99,101,
5,104,111,117,115,101,13,114,101,118,108,111,103,105,99,97,108,110,111,116,10,105,110,116,101,103,114,97,108,116,112,10,105,110,116,101,103,114,97,108,98,116,8,83,70,49,48,48,48,48,48,8,83,70,49,49,48,48,48,48,8,83,70,48,49,48,48,48,48,8,83,70,48,51,48,48,48,48,8,83,70,48,50,48,48,48,48,8,83,70,48,52,48,48,48,48,8,83,70,48,56,48,48,48,48,8,83,70,48,57,48,48,48,48,8,83,70,48,54,48,48,48,48,8,83,70,48,55,48,48,48,48,8,83,70,48,53,48,48,48,48,8,83,70,52,51,48,48,48,48,8,83,70,50,52,48,48,48,48,8,83,
70,53,49,48,48,48,48,8,83,70,53,50,48,48,48,48,8,83,70,51,57,48,48,48,48,8,83,70,50,50,48,48,48,48,8,83,70,50,49,48,48,48,48,8,83,70,50,53,48,48,48,48,8,83,70,53,48,48,48,48,48,8,83,70,52,57,48,48,48,48,8,83,70,51,56,48,48,48,48,8,83,70,50,56,48,48,48,48,8,83,70,50,55,48,48,48,48,8,83,70,50,54,48,48,48,48,8,83,70,51,54,48,48,48,48,8,83,70,51,55,48,48,48,48,8,83,70,52,50,48,48,48,48,8,83,70,49,57,48,48,48,48,8,83,70,50,48,48,48,48,48,8,83,70,50,51,48,48,48,48,8,83,70,52,55,48,48,48,48,8,83,70,52,56,
48,48,48,48,8,83,70,52,49,48,48,48,48,8,83,70,52,53,48,48,48,48,8,83,70,52,54,48,48,48,48,8,83,70,52,48,48,48,48,48,8,83,70,53,52,48,48,48,48,8,83,70,53,51,48,48,48,48,8,83,70,52,52,48,48,48,48,7,117,112,98,108,111,99,107,7,100,110,98,108,111,99,107,5,98,108,111,99,107,7,108,102,98,108,111,99,107,7,114,116,98,108,111,99,107,7,108,116,115,104,97,100,101,5,115,104,97,100,101,7,100,107,115,104,97,100,101,9,102,105,108,108,101,100,98,111,120,6,72,50,50,48,55,51,6,72,49,56,53,52,51,6,72,49,56,53,53,49,
10,102,105,108,108,101,100,114,101,99,116,7,116,114,105,97,103,117,112,7,116,114,105,97,103,114,116,7,116,114,105,97,103,100,110,7,116,114,105,97,103,108,102,6,99,105,114,99,108,101,6,72,49,56,53,51,51,9,105,110,118,98,117,108,108,101,116,9,105,110,118,99,105,114,99,108,101,10,111,112,101,110,98,117,108,108,101,116,9,115,109,105,108,101,102,97,99,101,12,105,110,118,115,109,105,108,101,102,97,99,101,3,115,117,110,6,102,101,109,97,108,101,4,109,97,108,101,5,115,112,97,100,101,4,99,108,117,98,5,104,
101,97,114,116,7,100,105,97,109,111,110,100,11,109,117,115,105,99,97,108,110,111,116,101,14,109,117,115,105,99,97,108,110,111,116,101,100,98,108,7,117,110,105,70,66,48,49,7,117,110,105,70,66,48,50,7,117,110,105,70,48,48,53,6,109,105,100,100,111,116,11,99,111,109,109,97,97,99,99,101,110,116,12,102,111,117,114,115,117,112,101,114,105,111,114,12,102,105,118,101,115,117,112,101,114,105,111,114,13,115,101,118,101,110,115,117,112,101,114,105,111,114,13,101,105,103,104,116,115,117,112,101,114,105,111,114,
13,99,121,114,105,108,108,105,99,98,114,101,118,101,16,99,97,114,111,110,99,111,109,109,97,97,99,99,101,110,116,17,99,111,109,109,97,97,99,99,101,110,116,114,111,116,97,116,101,8,103,114,97,118,101,46,117,99,8,97,99,117,116,101,46,117,99,13,99,105,114,99,117,109,102,108,101,120,46,117,99,8,99,97,114,111,110,46,117,99,11,100,105,101,114,101,115,105,115,46,117,99,8,116,105,108,100,101,46,117,99,15,104,117,110,103,97,114,117,109,108,97,117,116,46,117,99,8,98,114,101,118,101,46,117,99,0,0,0,0,0,3,0,8,
0,2,0,10,0,1,255,255,0,3,0,1,0,0,0,14,0,0,0,24,0,0,0,0,0,2,0,1,0,1,2,161,0,1,0,4,0,0,0,2,0,0,0,1,0,0,0,10,0,76,0,78,0,4,68,70,76,84,0,26,99,121,114,108,0,36,103,114,101,107,0,46,108,97,116,110,0,56,0,4,0,0,0,0,255,255,0,0,0,4,0,0,0,0,255,255,0,0,0,4,0,0,0,0,255,255,0,0,0,4,0,0,0,0,255,255,0,0,0,0,0,0,0,1,0,0,0,10,0,84,0,98,0,4,68,70,76,84,0,26,99,121,114,108,0,38,103,114,101,107,0,50,108,97,116,110,0,62,0,4,0,0,0,0,255,255,0,1,0,0,0,4,0,0,0,0,255,255,0,1,0,0,0,4,0,0,0,0,255,255,0,1,0,0,0,4,0,0,0,
0,255,255,0,1,0,0,0,1,107,101,114,110,0,8,0,0,0,1,0,0,0,1,0,4,0,2,0,0,0,1,0,8,0,1,15,6,0,4,0,0,0,104,0,218,0,252,1,2,1,40,1,54,1,84,1,102,1,116,1,186,1,240,2,38,2,100,2,106,2,120,2,130,2,120,2,140,2,178,2,188,2,178,3,22,3,64,3,98,3,120,3,142,3,98,3,120,3,204,3,226,3,236,4,114,4,228,4,246,5,0,2,178,2,188,5,38,5,52,5,126,5,180,5,246,5,38,6,32,6,78,6,88,6,130,6,148,6,194,5,38,6,194,6,208,6,234,6,234,6,240,7,50,7,108,7,178,8,28,8,62,8,100,8,138,8,180,8,186,8,200,8,238,9,72,9,146,10,12,10,158,10,196,10,
226,10,240,10,246,11,0,11,58,11,100,11,146,11,156,11,206,12,8,12,34,12,52,12,86,12,112,12,166,12,192,12,218,12,252,13,46,13,92,13,114,13,148,13,230,14,16,14,54,14,68,14,78,14,88,14,130,14,172,14,194,14,220,14,226,14,240,0,8,0,36,255,180,0,60,255,219,1,86,255,180,1,95,255,180,1,98,255,180,1,105,255,180,1,114,255,219,1,120,255,219,0,1,0,20,255,143,0,9,0,3,255,180,0,55,255,104,0,57,255,104,0,58,255,143,0,60,255,68,0,89,255,180,0,90,255,219,0,92,255,180,2,9,255,143,0,3,0,15,255,29,0,17,255,29,0,36,255,
143,0,7,0,3,255,219,0,55,255,104,0,57,255,104,0,58,255,143,0,60,255,68,0,92,255,180,2,9,255,143,0,4,0,3,255,219,0,15,254,248,0,17,254,248,0,36,255,104,0,3,0,57,255,219,0,58,255,219,0,60,255,180,0,17,0,15,255,29,0,16,255,143,0,17,255,29,0,29,255,29,0,30,255,29,0,36,255,104,0,50,255,219,0,68,255,104,0,70,255,104,0,72,255,104,0,76,255,219,0,82,255,104,0,85,255,143,0,86,255,104,0,88,255,104,0,90,255,104,0,92,255,104,0,13,0,15,255,68,0,16,255,143,0,17,255,68,0,29,255,143,0,30,255,143,0,36,255,104,0,68,
255,143,0,72,255,143,0,76,255,219,0,82,255,104,0,85,255,143,0,88,255,180,0,92,255,180,0,13,0,15,255,143,0,16,255,215,0,17,255,143,0,29,255,219,0,30,255,219,0,36,255,143,0,68,255,180,0,72,255,219,0,76,255,238,0,82,255,219,0,85,255,219,0,88,255,219,0,92,255,219,0,15,0,3,255,219,0,15,255,29,0,16,255,143,0,17,255,29,0,29,255,104,0,30,255,104,0,36,255,68,0,68,255,143,0,72,255,143,0,76,255,180,0,82,255,104,0,83,255,143,0,84,255,104,0,88,255,143,0,89,255,143,0,1,2,9,0,37,0,3,0,15,255,143,0,17,255,143,2,
9,0,76,0,2,0,15,255,104,0,17,255,104,0,2,0,15,255,180,0,17,255,180,0,9,1,102,255,201,1,109,255,201,1,113,255,86,1,114,255,70,1,115,255,201,1,120,255,70,1,128,255,180,1,138,255,180,1,148,255,180,0,2,1,114,255,199,1,120,255,199,0,22,1,94,1,0,1,95,255,70,1,98,255,70,1,102,255,178,1,105,255,70,1,109,255,178,1,115,255,178,1,118,255,178,1,121,255,104,1,123,255,180,1,124,255,180,1,126,255,104,1,129,255,180,1,132,255,180,1,134,255,180,1,135,255,180,1,137,255,180,1,140,255,104,1,144,255,104,1,147,255,104,
1,151,0,92,1,153,255,104,0,10,1,102,255,201,1,109,255,201,1,113,255,86,1,114,255,70,1,115,255,201,1,120,255,70,1,128,255,180,1,138,255,180,1,148,255,180,2,9,255,143,0,8,0,15,255,31,0,17,255,31,1,95,255,33,1,98,255,33,1,105,255,33,1,124,255,190,1,134,255,190,1,151,0,94,0,5,1,102,255,201,1,109,255,201,1,113,255,86,1,114,255,70,1,120,255,70,0,5,1,95,255,201,1,98,255,201,1,105,255,201,1,114,255,199,1,120,255,199,0,15,1,102,255,162,1,109,255,162,1,115,255,162,1,121,255,209,1,126,255,209,1,129,255,209,
1,131,255,209,1,133,255,209,1,139,255,209,1,140,255,209,1,144,255,209,1,147,255,209,1,150,255,209,1,153,255,209,1,155,255,209,0,5,0,15,254,250,0,17,254,250,1,95,255,104,1,98,255,104,1,105,255,104,0,2,1,141,255,221,1,145,255,221,0,33,0,15,255,31,0,16,255,143,0,17,255,31,0,29,255,31,0,30,255,31,1,94,0,242,1,95,255,104,1,98,255,92,1,102,255,219,1,105,255,104,1,109,255,219,1,115,255,201,1,118,255,219,1,121,255,104,1,122,255,104,1,126,255,104,1,128,255,104,1,129,255,172,1,130,255,104,1,132,255,104,1,134,
255,219,1,137,255,104,1,138,255,104,1,140,255,104,1,144,255,104,1,146,255,104,1,147,255,104,1,148,255,133,1,149,255,104,1,151,0,92,1,152,255,104,1,153,255,104,1,154,255,104,0,28,0,15,255,31,0,16,255,143,0,17,255,31,0,29,255,104,0,30,255,104,1,94,1,0,1,95,255,70,1,98,255,70,1,102,255,178,1,105,255,70,1,109,255,178,1,115,255,178,1,118,255,178,1,121,255,104,1,123,255,180,1,124,255,180,1,126,255,104,1,128,255,172,1,129,255,180,1,132,255,180,1,134,255,180,1,135,255,180,1,137,255,180,1,140,255,104,1,144,
255,104,1,147,255,104,1,151,0,92,1,153,255,104,0,4,1,95,255,201,1,113,255,201,1,114,255,199,1,120,255,199,0,2,1,150,255,229,1,155,255,229,0,9,1,121,255,219,1,126,255,219,1,129,255,219,1,140,255,219,1,144,255,219,1,147,255,219,1,150,255,219,1,153,255,219,1,155,255,219,0,3,1,141,255,199,1,145,255,199,1,148,255,182,0,18,1,121,255,141,1,123,255,207,1,126,255,141,1,128,255,190,1,129,255,180,1,132,255,207,1,133,255,180,1,134,255,207,1,135,255,207,1,138,255,190,1,140,255,141,1,141,255,180,1,144,255,141,
1,145,255,180,1,147,255,141,1,150,255,141,1,153,255,141,1,155,255,141,0,13,1,121,255,188,1,126,255,188,1,129,255,188,1,131,255,188,1,133,255,227,1,139,255,188,1,140,255,188,1,143,255,188,1,144,255,188,1,147,255,188,1,150,255,188,1,153,255,188,1,155,255,188,0,16,1,121,255,231,1,125,255,225,1,126,255,231,1,129,255,231,1,131,255,231,1,139,255,231,1,140,255,231,1,143,255,231,1,144,255,231,1,146,255,225,1,147,255,231,1,150,255,231,1,152,255,225,1,153,255,231,1,154,255,225,1,155,255,231,0,10,1,121,255,
231,1,126,255,231,1,129,255,231,1,131,255,231,1,139,255,231,1,140,255,231,1,143,255,231,1,144,255,231,1,147,255,231,1,153,255,231,0,11,1,121,255,199,1,126,255,199,1,129,255,199,1,131,255,199,1,136,255,180,1,140,255,199,1,143,255,199,1,144,255,199,1,147,255,199,1,150,255,199,1,155,255,199,0,2,1,141,255,199,1,145,255,199,0,10,1,121,255,199,1,126,255,199,1,129,255,199,1,131,255,199,1,140,255,199,1,143,255,199,1,144,255,199,1,147,255,199,1,150,255,199,1,155,255,199,0,4,1,136,255,231,1,141,255,199,1,145,
255,199,1,148,255,182,0,11,1,121,255,182,1,126,255,182,1,129,255,182,1,131,255,182,1,140,255,182,1,143,255,182,1,144,255,182,1,147,255,182,1,150,255,213,1,153,255,182,1,155,255,213,0,3,1,141,255,199,1,145,255,199,1,148,255,213,0,6,0,15,255,25,0,17,255,0,0,29,255,229,0,30,255,229,0,108,255,178,0,123,255,178,0,1,2,9,255,51,0,16,1,174,0,76,1,181,0,25,1,184,255,229,1,185,255,229,1,187,255,205,1,188,255,154,1,189,255,178,1,190,255,205,1,193,255,100,1,199,255,205,1,202,0,25,1,203,255,229,1,219,255,229,
1,220,255,229,1,231,0,25,2,9,255,152,0,14,1,170,255,178,1,176,255,205,1,177,255,229,1,181,255,205,1,187,255,229,1,188,255,205,1,189,255,205,1,190,255,229,1,191,255,205,1,193,255,178,1,196,255,178,1,199,255,205,1,201,255,205,1,221,255,229,0,17,1,170,255,154,1,174,255,229,1,176,255,178,1,177,255,229,1,181,255,205,1,184,255,205,1,187,255,178,1,188,255,178,1,189,255,178,1,190,255,205,1,191,255,178,1,193,255,178,1,196,255,154,1,201,255,205,1,220,255,229,1,223,255,229,1,225,255,178,0,26,0,15,255,25,0,17,
255,0,0,29,255,229,0,30,255,229,0,108,255,178,0,123,255,178,1,170,255,127,1,174,255,205,1,181,255,205,1,184,255,229,1,187,255,229,1,202,255,229,1,204,255,205,1,206,255,178,1,207,255,152,1,210,255,205,1,213,255,154,1,214,255,178,1,215,255,205,1,216,255,154,1,218,255,178,1,221,255,178,1,229,255,178,1,230,255,178,1,232,255,178,1,233,255,178,0,8,1,177,0,25,1,189,0,25,1,190,255,229,1,193,255,229,1,207,0,25,1,209,0,51,1,216,0,25,1,221,0,25,0,9,1,177,0,25,1,184,255,229,1,187,255,205,1,188,0,51,1,189,0,51,
1,193,0,25,1,196,0,76,1,202,0,25,1,216,255,229,0,9,1,176,255,205,1,181,255,205,1,184,255,229,1,187,255,205,1,188,255,178,1,189,255,178,1,190,255,205,1,193,255,178,1,201,255,205,0,10,1,177,0,76,1,187,255,229,1,188,0,51,1,189,0,51,1,190,255,229,1,193,0,51,1,199,0,25,1,202,0,25,1,209,0,25,1,219,255,229,0,1,1,202,0,51,0,3,1,202,0,25,1,219,255,229,1,225,255,229,0,9,1,170,255,205,1,174,255,229,1,176,255,229,1,181,255,205,1,189,255,205,1,191,255,178,1,201,255,229,1,206,255,205,1,213,255,229,0,22,0,15,254,
229,0,17,254,205,0,29,255,229,0,30,255,229,1,170,255,76,1,174,255,127,1,176,255,229,1,177,255,229,1,181,255,127,1,182,255,229,1,184,255,229,1,187,255,205,1,188,255,229,1,189,255,229,1,190,255,229,1,191,255,178,1,201,255,205,1,202,255,229,1,206,255,127,1,207,255,205,1,216,255,205,1,233,255,229,0,18,1,170,255,205,1,174,255,229,1,177,255,229,1,181,255,205,1,182,255,229,1,184,255,205,1,188,255,205,1,189,255,229,1,191,255,178,1,193,255,205,1,196,255,229,1,199,255,229,1,202,0,25,1,203,255,229,1,208,0,25,
1,219,255,229,1,222,255,229,1,225,255,229,0,30,0,15,255,51,0,17,255,25,0,29,255,229,0,30,255,229,0,108,255,205,1,170,255,127,1,174,255,205,1,176,0,51,1,181,255,205,1,184,255,205,1,190,255,178,1,201,255,229,1,202,255,205,1,204,255,178,1,207,255,154,1,210,255,178,1,212,255,178,1,213,255,127,1,214,255,152,1,216,255,127,1,217,255,229,1,218,255,178,1,219,255,127,1,221,255,178,1,223,255,178,1,227,255,229,1,229,255,229,1,230,255,229,1,232,255,229,1,233,255,205,0,36,0,15,255,25,0,17,255,0,0,29,255,205,0,
30,255,205,0,108,255,178,0,123,255,178,1,170,255,102,1,174,255,152,1,181,255,178,1,184,255,205,1,190,255,178,1,199,255,229,1,201,255,205,1,203,255,205,1,204,255,178,1,205,255,178,1,206,255,127,1,207,255,127,1,208,255,229,1,209,255,154,1,210,255,178,1,211,255,178,1,212,255,178,1,213,255,127,1,214,255,154,1,215,255,178,1,216,255,127,1,217,255,178,1,218,255,178,1,219,255,127,1,223,255,205,1,224,255,178,1,226,255,178,1,227,255,178,1,232,255,178,1,233,255,154,0,9,1,170,255,205,1,174,255,152,1,181,255,
178,1,188,255,178,1,189,255,178,1,190,255,229,1,193,255,229,1,201,255,203,1,213,255,205,0,7,1,177,255,229,1,184,255,203,1,187,255,178,1,190,255,178,1,199,255,205,1,216,255,229,1,221,255,229,0,3,1,202,0,76,1,207,0,25,1,216,0,25,0,1,1,202,0,25,0,2,1,201,255,178,2,9,255,51,0,14,1,170,255,205,1,174,255,229,1,176,255,178,1,177,255,205,1,181,255,178,1,182,255,205,1,184,255,229,1,187,255,205,1,188,255,49,1,191,255,152,1,193,255,102,1,199,255,178,1,201,255,178,2,9,255,102,0,10,1,174,255,205,1,176,255,205,
1,177,255,229,1,181,255,178,1,190,255,229,1,191,255,205,1,201,255,205,1,206,255,229,1,208,0,25,1,213,255,205,0,11,1,170,255,205,1,174,255,205,1,176,255,205,1,181,255,178,1,187,255,229,1,188,255,205,1,191,255,178,1,193,255,229,1,206,255,205,1,208,0,25,1,213,255,205,0,2,1,209,0,25,1,225,255,205,0,12,1,206,255,205,1,208,255,229,1,209,255,229,1,213,255,205,1,214,255,229,1,219,255,229,1,221,255,229,1,223,255,205,1,225,255,205,1,228,255,229,1,231,255,229,1,233,255,229,0,14,1,202,255,229,1,203,255,229,1,
207,255,229,1,208,255,229,1,213,255,229,1,214,255,229,1,216,255,229,1,219,255,205,1,220,255,229,1,221,255,205,1,222,255,229,1,225,255,178,1,228,255,205,1,233,255,229,0,6,0,15,255,76,0,17,255,51,1,206,255,178,1,213,255,205,1,216,255,229,1,219,255,229,0,4,1,209,0,25,1,219,255,229,1,221,0,25,1,228,255,229,0,8,1,203,255,229,1,208,255,229,1,214,255,229,1,219,255,229,1,220,255,229,1,221,255,229,1,223,255,229,1,225,255,205,0,6,1,202,0,25,1,207,255,229,1,209,0,25,1,216,255,205,1,219,255,229,1,225,255,205,
0,13,1,202,255,229,1,203,255,205,1,207,255,229,1,208,255,229,1,209,255,229,1,213,255,229,1,214,255,205,1,216,255,205,1,219,255,205,1,221,255,205,1,222,255,229,1,225,255,178,1,228,255,205,0,6,1,213,0,25,1,216,255,229,1,219,255,229,1,222,255,229,1,225,255,229,1,231,255,229,0,6,1,203,255,229,1,207,255,229,1,216,255,229,1,219,255,229,1,221,255,229,1,225,255,205,0,8,1,202,255,229,1,203,255,229,1,209,255,229,1,216,255,229,1,219,255,229,1,221,255,229,1,222,255,229,1,231,255,229,0,12,1,206,255,229,1,208,
255,229,1,209,255,229,1,213,255,205,1,214,255,229,1,219,255,229,1,220,255,205,1,221,255,229,1,223,255,205,1,225,255,205,1,231,255,229,1,233,255,229,0,11,1,206,255,205,1,208,255,229,1,209,255,229,1,213,255,205,1,214,255,229,1,220,255,229,1,221,255,229,1,223,255,229,1,225,255,205,1,231,255,229,1,233,255,229,0,5,1,202,0,25,1,203,255,229,1,223,255,229,1,225,255,203,1,228,255,229,0,8,0,15,255,102,0,17,255,76,1,206,255,229,1,208,0,25,1,213,255,229,1,216,255,229,1,219,255,229,1,221,0,51,0,20,0,15,255,102,
0,17,255,76,0,29,255,229,0,30,255,229,0,123,0,51,1,202,255,229,1,206,255,205,1,207,255,229,1,208,0,25,1,209,255,229,1,213,255,229,1,214,255,229,1,216,255,205,1,218,255,229,1,219,255,205,1,220,0,25,1,222,255,229,1,223,0,25,1,231,255,229,1,233,255,229,0,10,1,203,255,229,1,206,255,229,1,207,255,229,1,213,255,205,1,214,255,229,1,216,255,229,1,220,255,229,1,221,255,229,1,225,255,205,1,233,255,229,0,9,1,203,255,229,1,207,255,205,1,209,255,229,1,216,255,205,1,219,255,205,1,221,0,25,1,222,255,229,1,225,255,
205,1,231,255,229,0,3,1,202,0,25,1,209,0,25,1,219,255,229,0,2,1,202,0,25,1,216,255,229,0,2,1,220,255,76,1,225,255,76,0,10,1,203,255,229,1,206,255,229,1,208,255,229,1,209,255,229,1,213,255,205,1,214,255,229,1,219,255,229,1,220,255,229,1,223,255,229,1,233,255,229,0,10,1,203,255,229,1,206,255,229,1,208,255,229,1,213,255,205,1,214,255,229,1,219,255,229,1,220,255,205,1,223,255,205,1,225,255,178,1,231,255,229,0,5,0,15,255,102,0,17,255,76,0,29,255,229,0,30,255,229,0,108,255,205,0,6,0,15,255,127,0,17,255,
102,0,29,255,229,0,30,255,229,0,108,255,205,0,123,255,205,0,1,2,8,255,180,0,3,0,3,255,143,0,86,255,180,2,9,255,180,0,5,1,157,255,51,1,166,255,51,1,188,255,76,1,193,255,49,1,196,255,76,0,1,0,104,0,3,0,20,0,36,0,41,0,47,0,51,0,53,0,55,0,57,0,58,0,60,0,73,0,85,0,89,0,90,0,92,1,86,1,91,1,92,1,93,1,95,1,97,1,98,1,102,1,104,1,105,1,109,1,111,1,112,1,113,1,114,1,115,1,116,1,117,1,118,1,120,1,129,1,131,1,135,1,136,1,139,1,140,1,141,1,142,1,145,1,147,1,148,1,150,1,153,1,155,1,158,1,164,1,165,1,170,1,171,1,
172,1,173,1,174,1,176,1,177,1,180,1,181,1,182,1,184,1,186,1,187,1,188,1,189,1,190,1,191,1,192,1,195,1,196,1,198,1,199,1,200,1,202,1,203,1,204,1,205,1,206,1,207,1,208,1,209,1,212,1,213,1,214,1,216,1,218,1,219,1,220,1,221,1,222,1,223,1,224,1,227,1,230,1,231,1,232,1,246,1,248,2,8,2,9,2,14,0,0,0,1,0,0,0,0,198,212,46,153,0,0,0,0,191,26,255,128,0,0,0,0,200,13,85,156]);this.NO_RUN||run(args);
